/* DO NOT EDIT THIS FILE
 * Automatically generated by toolchain/trunk/proc-defs/sh/create-debug-mmrs.sh
 * DO NOT EDIT THIS FILE
 */

#include <linux/debugfs.h>
#include <linux/fs.h>
#include <linux/kernel.h>
#include <linux/module.h>
#include <asm/blackfin.h>

/* Some MMRs are stupid and have different read/write addresses.
 * So let's account for that here by interjecting ourselves into
 * the normal debugfs process.
 */
struct bfin_rw_ptr_pair {
	void *read, *write;
};
static void bfin_rw_x16_set(void *data, u64 val)
{
	*(u16 *) ((struct bfin_rw_ptr_pair *)data)->write = val;
}
static u64 bfin_rw_x16_get(void *data)
{
	return *(u16 *) ((struct bfin_rw_ptr_pair *)data)->read;
}
DEFINE_SIMPLE_ATTRIBUTE(bfin_rw_x16_fops, bfin_rw_x16_get, bfin_rw_x16_set, "%llx\n");
static __init
struct dentry *debugfs_create_rw_x16(const char *name, mode_t mode, struct dentry *parent, u16 *rvalue, u16 *wvalue)
{
	struct dentry *ret;
	struct bfin_rw_ptr_pair *pair = kmalloc(sizeof(*pair), GFP_KERNEL);
	pair->read = rvalue;
	pair->write = wvalue;
	ret = debugfs_create_file(name, mode, parent, rvalue, &bfin_rw_x16_fops);
	if (ret)
		ret->d_inode->i_private = pair;
	return ret;
}

static int __init bfin_init_mmr_debugfs(void)
{
	struct dentry *top, *parent;

	printk(KERN_DEBUG "Setting up Blackfin MMR debugfs\n");

	top = debugfs_create_dir("blackfin", NULL);
	if (top == NULL)
		return -1;

#ifdef __ADSPBF522__
# define USE_BF522 1
#else
# define USE_BF522 0
#endif
	if (USE_BF522) {

		parent = debugfs_create_dir("Core Timer Register File", top);
		debugfs_create_x32("TCNTL", 0600, parent, (u32 *)0xFFE03000);
		debugfs_create_x32("TCOUNT", 0600, parent, (u32 *)0xFFE0300C);
		debugfs_create_x32("TPERIOD", 0600, parent, (u32 *)0xFFE03004);
		debugfs_create_x32("TSCALE", 0600, parent, (u32 *)0xFFE03008);

		parent = debugfs_create_dir("Counter", top);
		debugfs_create_x16("CNT_COMMAND", 0600, parent, (u16 *)0xFFC0350C);
		debugfs_create_x16("CNT_CONFIG", 0600, parent, (u16 *)0xFFC03500);
		debugfs_create_x32("CNT_COUNTER", 0600, parent, (u32 *)0xFFC03514);
		debugfs_create_x16("CNT_DEBOUNCE", 0600, parent, (u16 *)0xFFC03510);
		debugfs_create_x16("CNT_IMASK", 0600, parent, (u16 *)0xFFC03504);
		debugfs_create_x32("CNT_MAX", 0600, parent, (u32 *)0xFFC03518);
		debugfs_create_x32("CNT_MIN", 0600, parent, (u32 *)0xFFC0351C);
		debugfs_create_x16("CNT_STATUS", 0600, parent, (u16 *)0xFFC03508);

		parent = debugfs_create_dir("DMA Controller", top);
		debugfs_create_x16("DMA0_CONFIG", 0600, parent, (u16 *)0xFFC00C08);
		debugfs_create_x32("DMA0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C24);
		debugfs_create_x32("DMA0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C20);
		debugfs_create_x16("DMA0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C30);
		debugfs_create_x16("DMA0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C38);
		debugfs_create_x16("DMA0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C28);
		debugfs_create_x32("DMA0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C00);
		debugfs_create_x16("DMA0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C2C);
		debugfs_create_x32("DMA0_START_ADDR", 0600, parent, (u32 *)0xFFC00C04);
		debugfs_create_x16("DMA0_X_COUNT", 0600, parent, (u16 *)0xFFC00C10);
		debugfs_create_x16("DMA0_X_MODIFY", 0600, parent, (u16 *)0xFFC00C14);
		debugfs_create_x16("DMA0_Y_COUNT", 0600, parent, (u16 *)0xFFC00C18);
		debugfs_create_x16("DMA0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C1C);
		debugfs_create_x16("DMA10_CONFIG", 0600, parent, (u16 *)0xFFC00E88);
		debugfs_create_x32("DMA10_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EA4);
		debugfs_create_x32("DMA10_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EA0);
		debugfs_create_x16("DMA10_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EB0);
		debugfs_create_x16("DMA10_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EB8);
		debugfs_create_x16("DMA10_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EA8);
		debugfs_create_x32("DMA10_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E80);
		debugfs_create_x16("DMA10_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EAC);
		debugfs_create_x32("DMA10_START_ADDR", 0600, parent, (u32 *)0xFFC00E84);
		debugfs_create_x16("DMA10_X_COUNT", 0600, parent, (u16 *)0xFFC00E90);
		debugfs_create_x16("DMA10_X_MODIFY", 0600, parent, (u16 *)0xFFC00E94);
		debugfs_create_x16("DMA10_Y_COUNT", 0600, parent, (u16 *)0xFFC00E98);
		debugfs_create_x16("DMA10_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E9C);
		debugfs_create_x16("DMA11_CONFIG", 0600, parent, (u16 *)0xFFC00EC8);
		debugfs_create_x32("DMA11_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EE4);
		debugfs_create_x32("DMA11_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EE0);
		debugfs_create_x16("DMA11_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EF0);
		debugfs_create_x16("DMA11_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EF8);
		debugfs_create_x16("DMA11_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EE8);
		debugfs_create_x32("DMA11_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00EC0);
		debugfs_create_x16("DMA11_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EEC);
		debugfs_create_x32("DMA11_START_ADDR", 0600, parent, (u32 *)0xFFC00EC4);
		debugfs_create_x16("DMA11_X_COUNT", 0600, parent, (u16 *)0xFFC00ED0);
		debugfs_create_x16("DMA11_X_MODIFY", 0600, parent, (u16 *)0xFFC00ED4);
		debugfs_create_x16("DMA11_Y_COUNT", 0600, parent, (u16 *)0xFFC00ED8);
		debugfs_create_x16("DMA11_Y_MODIFY", 0600, parent, (u16 *)0xFFC00EDC);
		debugfs_create_x16("DMA1_CONFIG", 0600, parent, (u16 *)0xFFC00C48);
		debugfs_create_x32("DMA1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C64);
		debugfs_create_x32("DMA1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C60);
		debugfs_create_x16("DMA1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C70);
		debugfs_create_x16("DMA1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C78);
		debugfs_create_x16("DMA1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C68);
		debugfs_create_x32("DMA1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C40);
		debugfs_create_x16("DMA1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C6C);
		debugfs_create_x32("DMA1_START_ADDR", 0600, parent, (u32 *)0xFFC00C44);
		debugfs_create_x16("DMA1_X_COUNT", 0600, parent, (u16 *)0xFFC00C50);
		debugfs_create_x16("DMA1_X_MODIFY", 0600, parent, (u16 *)0xFFC00C54);
		debugfs_create_x16("DMA1_Y_COUNT", 0600, parent, (u16 *)0xFFC00C58);
		debugfs_create_x16("DMA1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C5C);
		debugfs_create_x16("DMA2_CONFIG", 0600, parent, (u16 *)0xFFC00C88);
		debugfs_create_x32("DMA2_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CA4);
		debugfs_create_x32("DMA2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CA0);
		debugfs_create_x16("DMA2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CB0);
		debugfs_create_x16("DMA2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CB8);
		debugfs_create_x16("DMA2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CA8);
		debugfs_create_x32("DMA2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C80);
		debugfs_create_x16("DMA2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CAC);
		debugfs_create_x32("DMA2_START_ADDR", 0600, parent, (u32 *)0xFFC00C84);
		debugfs_create_x16("DMA2_X_COUNT", 0600, parent, (u16 *)0xFFC00C90);
		debugfs_create_x16("DMA2_X_MODIFY", 0600, parent, (u16 *)0xFFC00C94);
		debugfs_create_x16("DMA2_Y_COUNT", 0600, parent, (u16 *)0xFFC00C98);
		debugfs_create_x16("DMA2_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C9C);
		debugfs_create_x16("DMA3_CONFIG", 0600, parent, (u16 *)0xFFC00CC8);
		debugfs_create_x32("DMA3_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CE4);
		debugfs_create_x32("DMA3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CE0);
		debugfs_create_x16("DMA3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CF0);
		debugfs_create_x16("DMA3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CF8);
		debugfs_create_x16("DMA3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CE8);
		debugfs_create_x32("DMA3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00CC0);
		debugfs_create_x16("DMA3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CEC);
		debugfs_create_x32("DMA3_START_ADDR", 0600, parent, (u32 *)0xFFC00CC4);
		debugfs_create_x16("DMA3_X_COUNT", 0600, parent, (u16 *)0xFFC00CD0);
		debugfs_create_x16("DMA3_X_MODIFY", 0600, parent, (u16 *)0xFFC00CD4);
		debugfs_create_x16("DMA3_Y_COUNT", 0600, parent, (u16 *)0xFFC00CD8);
		debugfs_create_x16("DMA3_Y_MODIFY", 0600, parent, (u16 *)0xFFC00CDC);
		debugfs_create_x16("DMA4_CONFIG", 0600, parent, (u16 *)0xFFC00D08);
		debugfs_create_x32("DMA4_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D24);
		debugfs_create_x32("DMA4_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D20);
		debugfs_create_x16("DMA4_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D30);
		debugfs_create_x16("DMA4_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D38);
		debugfs_create_x16("DMA4_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D28);
		debugfs_create_x32("DMA4_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D00);
		debugfs_create_x16("DMA4_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D2C);
		debugfs_create_x32("DMA4_START_ADDR", 0600, parent, (u32 *)0xFFC00D04);
		debugfs_create_x16("DMA4_X_COUNT", 0600, parent, (u16 *)0xFFC00D10);
		debugfs_create_x16("DMA4_X_MODIFY", 0600, parent, (u16 *)0xFFC00D14);
		debugfs_create_x16("DMA4_Y_COUNT", 0600, parent, (u16 *)0xFFC00D18);
		debugfs_create_x16("DMA4_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D1C);
		debugfs_create_x16("DMA5_CONFIG", 0600, parent, (u16 *)0xFFC00D48);
		debugfs_create_x32("DMA5_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D64);
		debugfs_create_x32("DMA5_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D60);
		debugfs_create_x16("DMA5_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D70);
		debugfs_create_x16("DMA5_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D78);
		debugfs_create_x16("DMA5_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D68);
		debugfs_create_x32("DMA5_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D40);
		debugfs_create_x16("DMA5_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D6C);
		debugfs_create_x32("DMA5_START_ADDR", 0600, parent, (u32 *)0xFFC00D44);
		debugfs_create_x16("DMA5_X_COUNT", 0600, parent, (u16 *)0xFFC00D50);
		debugfs_create_x16("DMA5_X_MODIFY", 0600, parent, (u16 *)0xFFC00D54);
		debugfs_create_x16("DMA5_Y_COUNT", 0600, parent, (u16 *)0xFFC00D58);
		debugfs_create_x16("DMA5_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D5C);
		debugfs_create_x16("DMA6_CONFIG", 0600, parent, (u16 *)0xFFC00D88);
		debugfs_create_x32("DMA6_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DA4);
		debugfs_create_x32("DMA6_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DA0);
		debugfs_create_x16("DMA6_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DB0);
		debugfs_create_x16("DMA6_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DB8);
		debugfs_create_x16("DMA6_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DA8);
		debugfs_create_x32("DMA6_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D80);
		debugfs_create_x16("DMA6_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DAC);
		debugfs_create_x32("DMA6_START_ADDR", 0600, parent, (u32 *)0xFFC00D84);
		debugfs_create_x16("DMA6_X_COUNT", 0600, parent, (u16 *)0xFFC00D90);
		debugfs_create_x16("DMA6_X_MODIFY", 0600, parent, (u16 *)0xFFC00D94);
		debugfs_create_x16("DMA6_Y_COUNT", 0600, parent, (u16 *)0xFFC00D98);
		debugfs_create_x16("DMA6_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D9C);
		debugfs_create_x16("DMA7_CONFIG", 0600, parent, (u16 *)0xFFC00DC8);
		debugfs_create_x32("DMA7_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DE4);
		debugfs_create_x32("DMA7_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DE0);
		debugfs_create_x16("DMA7_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DF0);
		debugfs_create_x16("DMA7_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DF8);
		debugfs_create_x16("DMA7_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DE8);
		debugfs_create_x32("DMA7_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00DC0);
		debugfs_create_x16("DMA7_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DEC);
		debugfs_create_x32("DMA7_START_ADDR", 0600, parent, (u32 *)0xFFC00DC4);
		debugfs_create_x16("DMA7_X_COUNT", 0600, parent, (u16 *)0xFFC00DD0);
		debugfs_create_x16("DMA7_X_MODIFY", 0600, parent, (u16 *)0xFFC00DD4);
		debugfs_create_x16("DMA7_Y_COUNT", 0600, parent, (u16 *)0xFFC00DD8);
		debugfs_create_x16("DMA7_Y_MODIFY", 0600, parent, (u16 *)0xFFC00DDC);
		debugfs_create_x16("DMA8_CONFIG", 0600, parent, (u16 *)0xFFC00E08);
		debugfs_create_x32("DMA8_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E24);
		debugfs_create_x32("DMA8_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E20);
		debugfs_create_x16("DMA8_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E30);
		debugfs_create_x16("DMA8_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E38);
		debugfs_create_x16("DMA8_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E28);
		debugfs_create_x32("DMA8_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E00);
		debugfs_create_x16("DMA8_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E2C);
		debugfs_create_x32("DMA8_START_ADDR", 0600, parent, (u32 *)0xFFC00E04);
		debugfs_create_x16("DMA8_X_COUNT", 0600, parent, (u16 *)0xFFC00E10);
		debugfs_create_x16("DMA8_X_MODIFY", 0600, parent, (u16 *)0xFFC00E14);
		debugfs_create_x16("DMA8_Y_COUNT", 0600, parent, (u16 *)0xFFC00E18);
		debugfs_create_x16("DMA8_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E1C);
		debugfs_create_x16("DMA9_CONFIG", 0600, parent, (u16 *)0xFFC00E48);
		debugfs_create_x32("DMA9_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E64);
		debugfs_create_x32("DMA9_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E60);
		debugfs_create_x16("DMA9_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E70);
		debugfs_create_x16("DMA9_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E78);
		debugfs_create_x16("DMA9_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E68);
		debugfs_create_x32("DMA9_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E40);
		debugfs_create_x16("DMA9_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E6C);
		debugfs_create_x32("DMA9_START_ADDR", 0600, parent, (u32 *)0xFFC00E44);
		debugfs_create_x16("DMA9_X_COUNT", 0600, parent, (u16 *)0xFFC00E50);
		debugfs_create_x16("DMA9_X_MODIFY", 0600, parent, (u16 *)0xFFC00E54);
		debugfs_create_x16("DMA9_Y_COUNT", 0600, parent, (u16 *)0xFFC00E58);
		debugfs_create_x16("DMA9_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E5C);

		parent = debugfs_create_dir("DMA Traffic Control", top);
		debugfs_create_x16("DMA_TC_CNT", 0600, parent, (u16 *)0xFFC00B0C);
		debugfs_create_x16("DMA_TC_PER", 0600, parent, (u16 *)0xFFC00B10);

		parent = debugfs_create_dir("EBIU", top);
		debugfs_create_x32("EBIU_AMBCTL0", 0600, parent, (u32 *)0xFFC00A04);
		debugfs_create_x32("EBIU_AMBCTL1", 0600, parent, (u32 *)0xFFC00A08);
		debugfs_create_x16("EBIU_AMGCTL", 0600, parent, (u16 *)0xFFC00A00);
		debugfs_create_x16("EBIU_SDBCTL", 0600, parent, (u16 *)0xFFC00A14);
		debugfs_create_x32("EBIU_SDGCTL", 0600, parent, (u32 *)0xFFC00A10);
		debugfs_create_x16("EBIU_SDRRC", 0600, parent, (u16 *)0xFFC00A18);
		debugfs_create_x16("EBIU_SDSTAT", 0600, parent, (u16 *)0xFFC00A1C);

		parent = debugfs_create_dir("Event Vectors", top);
		debugfs_create_x32("EVT0", 0600, parent, (u32 *)0xFFE02000);
		debugfs_create_x32("EVT10", 0600, parent, (u32 *)0xFFE02028);
		debugfs_create_x32("EVT11", 0600, parent, (u32 *)0xFFE0202C);
		debugfs_create_x32("EVT12", 0600, parent, (u32 *)0xFFE02030);
		debugfs_create_x32("EVT13", 0600, parent, (u32 *)0xFFE02034);
		debugfs_create_x32("EVT14", 0600, parent, (u32 *)0xFFE02038);
		debugfs_create_x32("EVT15", 0600, parent, (u32 *)0xFFE0203C);
		debugfs_create_x32("EVT1", 0600, parent, (u32 *)0xFFE02004);
		debugfs_create_x32("EVT2", 0600, parent, (u32 *)0xFFE02008);
		debugfs_create_x32("EVT3", 0600, parent, (u32 *)0xFFE0200C);
		debugfs_create_x32("EVT4", 0600, parent, (u32 *)0xFFE02010);
		debugfs_create_x32("EVT5", 0600, parent, (u32 *)0xFFE02014);
		debugfs_create_x32("EVT6", 0600, parent, (u32 *)0xFFE02018);
		debugfs_create_x32("EVT7", 0600, parent, (u32 *)0xFFE0201C);
		debugfs_create_x32("EVT8", 0600, parent, (u32 *)0xFFE02020);
		debugfs_create_x32("EVT9", 0600, parent, (u32 *)0xFFE02024);

		parent = debugfs_create_dir("Extended Registers", top);
		debugfs_create_x32("CHIPID", 0600, parent, (u32 *)0xFFC00014);
		debugfs_create_x32("DSPID", 0600, parent, (u32 *)0xFFE05000);

		parent = debugfs_create_dir("GPIO PIN", top);
		debugfs_create_x16("PORTF_DRIVE", 0600, parent, (u16 *)0xFFC03220);
		debugfs_create_x16("PORTF_HYSTERESIS", 0600, parent, (u16 *)0xFFC03240);
		debugfs_create_x16("PORTF_MUX", 0600, parent, (u16 *)0xFFC03210);
		debugfs_create_x16("PORTF_SLEW", 0600, parent, (u16 *)0xFFC03230);
		debugfs_create_x16("PORTG_DRIVE", 0600, parent, (u16 *)0xFFC03224);
		debugfs_create_x16("PORTG_HYSTERESIS", 0600, parent, (u16 *)0xFFC03244);
		debugfs_create_x16("PORTG_MUX", 0600, parent, (u16 *)0xFFC03214);
		debugfs_create_x16("PORTG_SLEW", 0600, parent, (u16 *)0xFFC03234);
		debugfs_create_x16("PORTH_DRIVE", 0600, parent, (u16 *)0xFFC03228);
		debugfs_create_x16("PORTH_HYSTERESIS", 0600, parent, (u16 *)0xFFC03248);
		debugfs_create_x16("PORTH_MUX", 0600, parent, (u16 *)0xFFC03218);
		debugfs_create_x16("PORTH_SLEW", 0600, parent, (u16 *)0xFFC03238);

		parent = debugfs_create_dir("HOST", top);
		debugfs_create_x16("HOST_CONTROL", 0600, parent, (u16 *)0xFFC03400);
		debugfs_create_x16("HOST_STATUS", 0600, parent, (u16 *)0xFFC03404);
		debugfs_create_x16("HOST_TIMEOUT", 0600, parent, (u16 *)0xFFC03408);

		parent = debugfs_create_dir("Handshake MDMA", top);
		debugfs_create_x16("HMDMA0_BCINIT", 0600, parent, (u16 *)0xFFC03308);
		debugfs_create_x16("HMDMA0_BCOUNT", 0600, parent, (u16 *)0xFFC03318);
		debugfs_create_x16("HMDMA0_CONTROL", 0600, parent, (u16 *)0xFFC03300);
		debugfs_create_x16("HMDMA0_ECINIT", 0600, parent, (u16 *)0xFFC03304);
		debugfs_create_x16("HMDMA0_ECOUNT", 0600, parent, (u16 *)0xFFC03314);
		debugfs_create_x16("HMDMA0_ECOVERFLOW", 0600, parent, (u16 *)0xFFC03310);
		debugfs_create_x16("HMDMA0_ECURGENT", 0600, parent, (u16 *)0xFFC0330C);
		debugfs_create_x16("HMDMA1_BCINIT", 0600, parent, (u16 *)0xFFC03348);
		debugfs_create_x16("HMDMA1_BCOUNT", 0600, parent, (u16 *)0xFFC03358);
		debugfs_create_x16("HMDMA1_CONTROL", 0600, parent, (u16 *)0xFFC03340);
		debugfs_create_x16("HMDMA1_ECINIT", 0600, parent, (u16 *)0xFFC03344);
		debugfs_create_x16("HMDMA1_ECOUNT", 0600, parent, (u16 *)0xFFC03354);
		debugfs_create_x16("HMDMA1_ECOVERFLOW", 0600, parent, (u16 *)0xFFC03350);
		debugfs_create_x16("HMDMA1_ECURGENT", 0600, parent, (u16 *)0xFFC0334C);

		parent = debugfs_create_dir("Interrupt Controller", top);
		debugfs_create_x32("ILAT", 0600, parent, (u32 *)0xFFE0210C);
		debugfs_create_x32("IMASK", 0600, parent, (u32 *)0xFFE02104);
		debugfs_create_x32("IPEND", 0600, parent, (u32 *)0xFFE02108);
		debugfs_create_x32("IPRIO", 0600, parent, (u32 *)0xFFE02110);

		parent = debugfs_create_dir("L1 Code Memory Registers", top);
		debugfs_create_x32("ICPLB_ADDR0", 0600, parent, (u32 *)0xFFE01100);
		debugfs_create_x32("ICPLB_ADDR10", 0600, parent, (u32 *)0xFFE01128);
		debugfs_create_x32("ICPLB_ADDR11", 0600, parent, (u32 *)0xFFE0112C);
		debugfs_create_x32("ICPLB_ADDR12", 0600, parent, (u32 *)0xFFE01130);
		debugfs_create_x32("ICPLB_ADDR13", 0600, parent, (u32 *)0xFFE01134);
		debugfs_create_x32("ICPLB_ADDR14", 0600, parent, (u32 *)0xFFE01138);
		debugfs_create_x32("ICPLB_ADDR15", 0600, parent, (u32 *)0xFFE0113C);
		debugfs_create_x32("ICPLB_ADDR1", 0600, parent, (u32 *)0xFFE01104);
		debugfs_create_x32("ICPLB_ADDR2", 0600, parent, (u32 *)0xFFE01108);
		debugfs_create_x32("ICPLB_ADDR3", 0600, parent, (u32 *)0xFFE0110C);
		debugfs_create_x32("ICPLB_ADDR4", 0600, parent, (u32 *)0xFFE01110);
		debugfs_create_x32("ICPLB_ADDR5", 0600, parent, (u32 *)0xFFE01114);
		debugfs_create_x32("ICPLB_ADDR6", 0600, parent, (u32 *)0xFFE01118);
		debugfs_create_x32("ICPLB_ADDR7", 0600, parent, (u32 *)0xFFE0111C);
		debugfs_create_x32("ICPLB_ADDR8", 0600, parent, (u32 *)0xFFE01120);
		debugfs_create_x32("ICPLB_ADDR9", 0600, parent, (u32 *)0xFFE01124);
		debugfs_create_x32("ICPLB_DATA0", 0600, parent, (u32 *)0xFFE01200);
		debugfs_create_x32("ICPLB_DATA10", 0600, parent, (u32 *)0xFFE01228);
		debugfs_create_x32("ICPLB_DATA11", 0600, parent, (u32 *)0xFFE0122C);
		debugfs_create_x32("ICPLB_DATA12", 0600, parent, (u32 *)0xFFE01230);
		debugfs_create_x32("ICPLB_DATA13", 0600, parent, (u32 *)0xFFE01234);
		debugfs_create_x32("ICPLB_DATA14", 0600, parent, (u32 *)0xFFE01238);
		debugfs_create_x32("ICPLB_DATA15", 0600, parent, (u32 *)0xFFE0123C);
		debugfs_create_x32("ICPLB_DATA1", 0600, parent, (u32 *)0xFFE01204);
		debugfs_create_x32("ICPLB_DATA2", 0600, parent, (u32 *)0xFFE01208);
		debugfs_create_x32("ICPLB_DATA3", 0600, parent, (u32 *)0xFFE0120C);
		debugfs_create_x32("ICPLB_DATA4", 0600, parent, (u32 *)0xFFE01210);
		debugfs_create_x32("ICPLB_DATA5", 0600, parent, (u32 *)0xFFE01214);
		debugfs_create_x32("ICPLB_DATA6", 0600, parent, (u32 *)0xFFE01218);
		debugfs_create_x32("ICPLB_DATA7", 0600, parent, (u32 *)0xFFE0121C);
		debugfs_create_x32("ICPLB_DATA8", 0600, parent, (u32 *)0xFFE01220);
		debugfs_create_x32("ICPLB_DATA9", 0600, parent, (u32 *)0xFFE01224);
		debugfs_create_x32("ICPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0100C);
		debugfs_create_x32("ICPLB_STATUS", 0600, parent, (u32 *)0xFFE01008);
		debugfs_create_x32("IMEM_CONTROL", 0600, parent, (u32 *)0xFFE01004);
		debugfs_create_x32("ITEST_COMMAND", 0600, parent, (u32 *)0xFFE01300);
		debugfs_create_x32("ITEST_DATA0", 0600, parent, (u32 *)0xFFE01400);
		debugfs_create_x32("ITEST_DATA1", 0600, parent, (u32 *)0xFFE01404);

		parent = debugfs_create_dir("L1 Data Memory Registers", top);
		debugfs_create_x32("DCPLB_ADDR0", 0600, parent, (u32 *)0xFFE00100);
		debugfs_create_x32("DCPLB_ADDR10", 0600, parent, (u32 *)0xFFE00128);
		debugfs_create_x32("DCPLB_ADDR11", 0600, parent, (u32 *)0xFFE0012C);
		debugfs_create_x32("DCPLB_ADDR12", 0600, parent, (u32 *)0xFFE00130);
		debugfs_create_x32("DCPLB_ADDR13", 0600, parent, (u32 *)0xFFE00134);
		debugfs_create_x32("DCPLB_ADDR14", 0600, parent, (u32 *)0xFFE00138);
		debugfs_create_x32("DCPLB_ADDR15", 0600, parent, (u32 *)0xFFE0013C);
		debugfs_create_x32("DCPLB_ADDR1", 0600, parent, (u32 *)0xFFE00104);
		debugfs_create_x32("DCPLB_ADDR2", 0600, parent, (u32 *)0xFFE00108);
		debugfs_create_x32("DCPLB_ADDR3", 0600, parent, (u32 *)0xFFE0010C);
		debugfs_create_x32("DCPLB_ADDR4", 0600, parent, (u32 *)0xFFE00110);
		debugfs_create_x32("DCPLB_ADDR5", 0600, parent, (u32 *)0xFFE00114);
		debugfs_create_x32("DCPLB_ADDR6", 0600, parent, (u32 *)0xFFE00118);
		debugfs_create_x32("DCPLB_ADDR7", 0600, parent, (u32 *)0xFFE0011C);
		debugfs_create_x32("DCPLB_ADDR8", 0600, parent, (u32 *)0xFFE00120);
		debugfs_create_x32("DCPLB_ADDR9", 0600, parent, (u32 *)0xFFE00124);
		debugfs_create_x32("DCPLB_DATA0", 0600, parent, (u32 *)0xFFE00200);
		debugfs_create_x32("DCPLB_DATA10", 0600, parent, (u32 *)0xFFE00228);
		debugfs_create_x32("DCPLB_DATA11", 0600, parent, (u32 *)0xFFE0022C);
		debugfs_create_x32("DCPLB_DATA12", 0600, parent, (u32 *)0xFFE00230);
		debugfs_create_x32("DCPLB_DATA13", 0600, parent, (u32 *)0xFFE00234);
		debugfs_create_x32("DCPLB_DATA14", 0600, parent, (u32 *)0xFFE00238);
		debugfs_create_x32("DCPLB_DATA15", 0600, parent, (u32 *)0xFFE0023C);
		debugfs_create_x32("DCPLB_DATA1", 0600, parent, (u32 *)0xFFE00204);
		debugfs_create_x32("DCPLB_DATA2", 0600, parent, (u32 *)0xFFE00208);
		debugfs_create_x32("DCPLB_DATA3", 0600, parent, (u32 *)0xFFE0020C);
		debugfs_create_x32("DCPLB_DATA4", 0600, parent, (u32 *)0xFFE00210);
		debugfs_create_x32("DCPLB_DATA5", 0600, parent, (u32 *)0xFFE00214);
		debugfs_create_x32("DCPLB_DATA6", 0600, parent, (u32 *)0xFFE00218);
		debugfs_create_x32("DCPLB_DATA7", 0600, parent, (u32 *)0xFFE0021C);
		debugfs_create_x32("DCPLB_DATA8", 0600, parent, (u32 *)0xFFE00220);
		debugfs_create_x32("DCPLB_DATA9", 0600, parent, (u32 *)0xFFE00224);
		debugfs_create_x32("DCPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0000C);
		debugfs_create_x32("DCPLB_STATUS", 0600, parent, (u32 *)0xFFE00008);
		debugfs_create_x32("DMEM_CONTROL", 0600, parent, (u32 *)0xFFE00004);
		debugfs_create_x32("DTEST_COMMAND", 0600, parent, (u32 *)0xFFE00300);
		debugfs_create_x32("DTEST_DATA0", 0600, parent, (u32 *)0xFFE00400);
		debugfs_create_x32("DTEST_DATA1", 0600, parent, (u32 *)0xFFE00404);
		debugfs_create_x32("SRAM_BASE_ADDR", 0600, parent, (u32 *)0xFFE00000);

		parent = debugfs_create_dir("MDMA Destination 0", top);
		debugfs_create_x16("MDMA_D0_CONFIG", 0600, parent, (u16 *)0xFFC00F08);
		debugfs_create_x32("MDMA_D0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F24);
		debugfs_create_x32("MDMA_D0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F20);
		debugfs_create_x16("MDMA_D0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F30);
		debugfs_create_x16("MDMA_D0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F38);
		debugfs_create_x16("MDMA_D0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F28);
		debugfs_create_x32("MDMA_D0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F00);
		debugfs_create_x16("MDMA_D0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F2C);
		debugfs_create_x32("MDMA_D0_START_ADDR", 0600, parent, (u32 *)0xFFC00F04);
		debugfs_create_x16("MDMA_D0_X_COUNT", 0600, parent, (u16 *)0xFFC00F10);
		debugfs_create_x16("MDMA_D0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F14);
		debugfs_create_x16("MDMA_D0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F18);
		debugfs_create_x16("MDMA_D0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F1C);

		parent = debugfs_create_dir("MDMA Destination 1", top);
		debugfs_create_x16("MDMA_D1_CONFIG", 0600, parent, (u16 *)0xFFC00F88);
		debugfs_create_x32("MDMA_D1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FA4);
		debugfs_create_x32("MDMA_D1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FA0);
		debugfs_create_x16("MDMA_D1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FB0);
		debugfs_create_x16("MDMA_D1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FB8);
		debugfs_create_x16("MDMA_D1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FA8);
		debugfs_create_x32("MDMA_D1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F80);
		debugfs_create_x16("MDMA_D1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FAC);
		debugfs_create_x32("MDMA_D1_START_ADDR", 0600, parent, (u32 *)0xFFC00F84);
		debugfs_create_x16("MDMA_D1_X_COUNT", 0600, parent, (u16 *)0xFFC00F90);
		debugfs_create_x16("MDMA_D1_X_MODIFY", 0600, parent, (u16 *)0xFFC00F94);
		debugfs_create_x16("MDMA_D1_Y_COUNT", 0600, parent, (u16 *)0xFFC00F98);
		debugfs_create_x16("MDMA_D1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F9C);

		parent = debugfs_create_dir("MDMA Source 0", top);
		debugfs_create_x16("MDMA_S0_CONFIG", 0600, parent, (u16 *)0xFFC00F48);
		debugfs_create_x32("MDMA_S0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F64);
		debugfs_create_x32("MDMA_S0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F60);
		debugfs_create_x16("MDMA_S0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F70);
		debugfs_create_x16("MDMA_S0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F78);
		debugfs_create_x16("MDMA_S0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F68);
		debugfs_create_x32("MDMA_S0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F40);
		debugfs_create_x16("MDMA_S0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F6C);
		debugfs_create_x32("MDMA_S0_START_ADDR", 0600, parent, (u32 *)0xFFC00F44);
		debugfs_create_x16("MDMA_S0_X_COUNT", 0600, parent, (u16 *)0xFFC00F50);
		debugfs_create_x16("MDMA_S0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F54);
		debugfs_create_x16("MDMA_S0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F58);
		debugfs_create_x16("MDMA_S0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F5C);

		parent = debugfs_create_dir("MDMA Source 1", top);
		debugfs_create_x16("MDMA_S1_CONFIG", 0600, parent, (u16 *)0xFFC00FC8);
		debugfs_create_x32("MDMA_S1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FE4);
		debugfs_create_x32("MDMA_S1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FE0);
		debugfs_create_x16("MDMA_S1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FF0);
		debugfs_create_x16("MDMA_S1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FF8);
		debugfs_create_x16("MDMA_S1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FE8);
		debugfs_create_x32("MDMA_S1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00FC0);
		debugfs_create_x16("MDMA_S1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FEC);
		debugfs_create_x32("MDMA_S1_START_ADDR", 0600, parent, (u32 *)0xFFC00FC4);
		debugfs_create_x16("MDMA_S1_X_COUNT", 0600, parent, (u16 *)0xFFC00FD0);
		debugfs_create_x16("MDMA_S1_X_MODIFY", 0600, parent, (u16 *)0xFFC00FD4);
		debugfs_create_x16("MDMA_S1_Y_COUNT", 0600, parent, (u16 *)0xFFC00FD8);
		debugfs_create_x16("MDMA_S1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00FDC);

		parent = debugfs_create_dir("NFC", top);
		debugfs_create_x16("NFC_ADDR", 0600, parent, (u16 *)0xFFC03740);
		debugfs_create_x16("NFC_CMD", 0600, parent, (u16 *)0xFFC03744);
		debugfs_create_x16("NFC_COUNT", 0600, parent, (u16 *)0xFFC03720);
		debugfs_create_x16("NFC_CTL", 0600, parent, (u16 *)0xFFC03700);
		debugfs_create_x16("NFC_DATA_RD", 0600, parent, (u16 *)0xFFC0374C);
		debugfs_create_x16("NFC_DATA_WR", 0600, parent, (u16 *)0xFFC03748);
		debugfs_create_x16("NFC_ECC0", 0600, parent, (u16 *)0xFFC03710);
		debugfs_create_x16("NFC_ECC1", 0600, parent, (u16 *)0xFFC03714);
		debugfs_create_x16("NFC_ECC2", 0600, parent, (u16 *)0xFFC03718);
		debugfs_create_x16("NFC_ECC3", 0600, parent, (u16 *)0xFFC0371C);
		debugfs_create_x16("NFC_IRQMASK", 0600, parent, (u16 *)0xFFC0370C);
		debugfs_create_x16("NFC_IRQSTAT", 0600, parent, (u16 *)0xFFC03708);
		debugfs_create_x16("NFC_PGCTL", 0600, parent, (u16 *)0xFFC03728);
		debugfs_create_x16("NFC_READ", 0600, parent, (u16 *)0xFFC0372C);
		debugfs_create_x16("NFC_RST", 0600, parent, (u16 *)0xFFC03724);
		debugfs_create_x16("NFC_STAT", 0600, parent, (u16 *)0xFFC03704);

		parent = debugfs_create_dir("NON-GPIO", top);
		debugfs_create_x16("NONGPIO_DRIVE", 0600, parent, (u16 *)0xFFC03280);
		debugfs_create_x16("NONGPIO_HYSTERESIS", 0600, parent, (u16 *)0xFFC03288);
		debugfs_create_x16("NONGPIO_SLEW", 0600, parent, (u16 *)0xFFC03284);

		parent = debugfs_create_dir("OTP", top);
		debugfs_create_x16("OTP_BEN", 0600, parent, (u16 *)0xFFC03604);
		debugfs_create_x16("OTP_CONTROL", 0600, parent, (u16 *)0xFFC03600);
		debugfs_create_x32("OTP_DATA0", 0600, parent, (u32 *)0xFFC03680);
		debugfs_create_x32("OTP_DATA1", 0600, parent, (u32 *)0xFFC03684);
		debugfs_create_x32("OTP_DATA2", 0600, parent, (u32 *)0xFFC03688);
		debugfs_create_x32("OTP_DATA3", 0600, parent, (u32 *)0xFFC0368C);
		debugfs_create_x16("OTP_STATUS", 0600, parent, (u16 *)0xFFC03608);
		debugfs_create_x32("OTP_TIMING", 0600, parent, (u32 *)0xFFC0360C);

		parent = debugfs_create_dir("PLL", top);
		debugfs_create_x16("PLL_CTL", 0600, parent, (u16 *)0xFFC00000);
		debugfs_create_x16("PLL_DIV", 0600, parent, (u16 *)0xFFC00004);
		debugfs_create_x16("PLL_LOCKCNT", 0600, parent, (u16 *)0xFFC00010);
		debugfs_create_x16("PLL_STAT", 0600, parent, (u16 *)0xFFC0000C);
		debugfs_create_x16("VR_CTL", 0600, parent, (u16 *)0xFFC00008);

		parent = debugfs_create_dir("PPI", top);
		debugfs_create_x16("PPI_CONTROL", 0600, parent, (u16 *)0xFFC01000);
		debugfs_create_x16("PPI_COUNT", 0600, parent, (u16 *)0xFFC01008);
		debugfs_create_x16("PPI_DELAY", 0600, parent, (u16 *)0xFFC0100C);
		debugfs_create_x16("PPI_FRAME", 0600, parent, (u16 *)0xFFC01010);
		debugfs_create_x16("PPI_STATUS", 0600, parent, (u16 *)0xFFC01004);

		parent = debugfs_create_dir("Performance Monitor", top);
		debugfs_create_x32("PFCNTR0", 0600, parent, (u32 *)0xFFE08100);
		debugfs_create_x32("PFCNTR1", 0600, parent, (u32 *)0xFFE08104);
		debugfs_create_x32("PFCTL", 0600, parent, (u32 *)0xFFE08000);

		parent = debugfs_create_dir("Pin Control", top);
		debugfs_create_x16("PORTF_FER", 0600, parent, (u16 *)0xFFC03200);
		debugfs_create_x16("PORTG_FER", 0600, parent, (u16 *)0xFFC03204);
		debugfs_create_x16("PORTH_FER", 0600, parent, (u16 *)0xFFC03208);

		parent = debugfs_create_dir("Port I-O", top);
		debugfs_create_x16("PORTFIO", 0600, parent, (u16 *)0xFFC00700);
		debugfs_create_x16("PORTFIO_BOTH", 0600, parent, (u16 *)0xFFC0073C);
		debugfs_create_x16("PORTFIO_CLEAR", 0600, parent, (u16 *)0xFFC00704);
		debugfs_create_x16("PORTFIO_DIR", 0600, parent, (u16 *)0xFFC00730);
		debugfs_create_x16("PORTFIO_EDGE", 0600, parent, (u16 *)0xFFC00738);
		debugfs_create_x16("PORTFIO_INEN", 0600, parent, (u16 *)0xFFC00740);
		debugfs_create_x16("PORTFIO_MASKA", 0600, parent, (u16 *)0xFFC00710);
		debugfs_create_x16("PORTFIO_MASKA_CLEAR", 0600, parent, (u16 *)0xFFC00714);
		debugfs_create_x16("PORTFIO_MASKA_SET", 0600, parent, (u16 *)0xFFC00718);
		debugfs_create_x16("PORTFIO_MASKA_TOGGLE", 0600, parent, (u16 *)0xFFC0071C);
		debugfs_create_x16("PORTFIO_MASKB", 0600, parent, (u16 *)0xFFC00720);
		debugfs_create_x16("PORTFIO_MASKB_CLEAR", 0600, parent, (u16 *)0xFFC00724);
		debugfs_create_x16("PORTFIO_MASKB_SET", 0600, parent, (u16 *)0xFFC00728);
		debugfs_create_x16("PORTFIO_MASKB_TOGGLE", 0600, parent, (u16 *)0xFFC0072C);
		debugfs_create_x16("PORTFIO_POLAR", 0600, parent, (u16 *)0xFFC00734);
		debugfs_create_x16("PORTFIO_SET", 0600, parent, (u16 *)0xFFC00708);
		debugfs_create_x16("PORTFIO_TOGGLE", 0600, parent, (u16 *)0xFFC0070C);
		debugfs_create_x16("PORTGIO", 0600, parent, (u16 *)0xFFC01500);
		debugfs_create_x16("PORTGIO_BOTH", 0600, parent, (u16 *)0xFFC0153C);
		debugfs_create_x16("PORTGIO_CLEAR", 0600, parent, (u16 *)0xFFC01504);
		debugfs_create_x16("PORTGIO_DIR", 0600, parent, (u16 *)0xFFC01530);
		debugfs_create_x16("PORTGIO_EDGE", 0600, parent, (u16 *)0xFFC01538);
		debugfs_create_x16("PORTGIO_INEN", 0600, parent, (u16 *)0xFFC01540);
		debugfs_create_x16("PORTGIO_MASKA", 0600, parent, (u16 *)0xFFC01510);
		debugfs_create_x16("PORTGIO_MASKA_CLEAR", 0600, parent, (u16 *)0xFFC01514);
		debugfs_create_x16("PORTGIO_MASKA_SET", 0600, parent, (u16 *)0xFFC01518);
		debugfs_create_x16("PORTGIO_MASKA_TOGGLE", 0600, parent, (u16 *)0xFFC0151C);
		debugfs_create_x16("PORTGIO_MASKB", 0600, parent, (u16 *)0xFFC01520);
		debugfs_create_x16("PORTGIO_MASKB_CLEAR", 0600, parent, (u16 *)0xFFC01524);
		debugfs_create_x16("PORTGIO_MASKB_SET", 0600, parent, (u16 *)0xFFC01528);
		debugfs_create_x16("PORTGIO_MASKB_TOGGLE", 0600, parent, (u16 *)0xFFC0152C);
		debugfs_create_x16("PORTGIO_POLAR", 0600, parent, (u16 *)0xFFC01534);
		debugfs_create_x16("PORTGIO_SET", 0600, parent, (u16 *)0xFFC01508);
		debugfs_create_x16("PORTGIO_TOGGLE", 0600, parent, (u16 *)0xFFC0150C);
		debugfs_create_x16("PORTHIO", 0600, parent, (u16 *)0xFFC01700);
		debugfs_create_x16("PORTHIO_BOTH", 0600, parent, (u16 *)0xFFC0173C);
		debugfs_create_x16("PORTHIO_CLEAR", 0600, parent, (u16 *)0xFFC01704);
		debugfs_create_x16("PORTHIO_DIR", 0600, parent, (u16 *)0xFFC01730);
		debugfs_create_x16("PORTHIO_EDGE", 0600, parent, (u16 *)0xFFC01738);
		debugfs_create_x16("PORTHIO_INEN", 0600, parent, (u16 *)0xFFC01740);
		debugfs_create_x16("PORTHIO_MASKA", 0600, parent, (u16 *)0xFFC01710);
		debugfs_create_x16("PORTHIO_MASKA_CLEAR", 0600, parent, (u16 *)0xFFC01714);
		debugfs_create_x16("PORTHIO_MASKA_SET", 0600, parent, (u16 *)0xFFC01718);
		debugfs_create_x16("PORTHIO_MASKA_TOGGLE", 0600, parent, (u16 *)0xFFC0171C);
		debugfs_create_x16("PORTHIO_MASKB", 0600, parent, (u16 *)0xFFC01720);
		debugfs_create_x16("PORTHIO_MASKB_CLEAR", 0600, parent, (u16 *)0xFFC01724);
		debugfs_create_x16("PORTHIO_MASKB_SET", 0600, parent, (u16 *)0xFFC01728);
		debugfs_create_x16("PORTHIO_MASKB_TOGGLE", 0600, parent, (u16 *)0xFFC0172C);
		debugfs_create_x16("PORTHIO_POLAR", 0600, parent, (u16 *)0xFFC01734);
		debugfs_create_x16("PORTHIO_SET", 0600, parent, (u16 *)0xFFC01708);
		debugfs_create_x16("PORTHIO_TOGGLE", 0600, parent, (u16 *)0xFFC0170C);

		parent = debugfs_create_dir("RTC", top);
		debugfs_create_x32("RTC_ALARM", 0600, parent, (u32 *)0xFFC00310);
		debugfs_create_x16("RTC_ICTL", 0600, parent, (u16 *)0xFFC00304);
		debugfs_create_x16("RTC_ISTAT", 0600, parent, (u16 *)0xFFC00308);
		debugfs_create_x16("RTC_PREN", 0600, parent, (u16 *)0xFFC00314);
		debugfs_create_x32("RTC_STAT", 0600, parent, (u32 *)0xFFC00300);
		debugfs_create_x16("RTC_SWCNT", 0600, parent, (u16 *)0xFFC0030C);

		parent = debugfs_create_dir("SPI", top);
		debugfs_create_x16("SPI_BAUD", 0600, parent, (u16 *)0xFFC00514);
		debugfs_create_x16("SPI_CTL", 0600, parent, (u16 *)0xFFC00500);
		debugfs_create_x16("SPI_FLG", 0600, parent, (u16 *)0xFFC00504);
		debugfs_create_x16("SPI_RDBR", 0600, parent, (u16 *)0xFFC00510);
		debugfs_create_x16("SPI_SHADOW", 0600, parent, (u16 *)0xFFC00518);
		debugfs_create_x16("SPI_STAT", 0600, parent, (u16 *)0xFFC00508);
		debugfs_create_x16("SPI_TDBR", 0600, parent, (u16 *)0xFFC0050C);

		parent = debugfs_create_dir("SPORT", top);
		debugfs_create_x16("SPORT0_CHNL", 0600, parent, (u16 *)0xFFC00834);
		debugfs_create_x16("SPORT0_MCMC1", 0600, parent, (u16 *)0xFFC00838);
		debugfs_create_x16("SPORT0_MCMC2", 0600, parent, (u16 *)0xFFC0083C);
		debugfs_create_x32("SPORT0_MRCS0", 0600, parent, (u32 *)0xFFC00850);
		debugfs_create_x32("SPORT0_MRCS1", 0600, parent, (u32 *)0xFFC00854);
		debugfs_create_x32("SPORT0_MRCS2", 0600, parent, (u32 *)0xFFC00858);
		debugfs_create_x32("SPORT0_MRCS3", 0600, parent, (u32 *)0xFFC0085C);
		debugfs_create_x32("SPORT0_MTCS0", 0600, parent, (u32 *)0xFFC00840);
		debugfs_create_x32("SPORT0_MTCS1", 0600, parent, (u32 *)0xFFC00844);
		debugfs_create_x32("SPORT0_MTCS2", 0600, parent, (u32 *)0xFFC00848);
		debugfs_create_x32("SPORT0_MTCS3", 0600, parent, (u32 *)0xFFC0084C);
		debugfs_create_x16("SPORT0_RCLKDIV", 0600, parent, (u16 *)0xFFC00828);
		debugfs_create_x16("SPORT0_RCR1", 0600, parent, (u16 *)0xFFC00820);
		debugfs_create_x16("SPORT0_RCR2", 0600, parent, (u16 *)0xFFC00824);
		debugfs_create_x16("SPORT0_RFSDIV", 0600, parent, (u16 *)0xFFC0082C);
		debugfs_create_x32("SPORT0_RX", 0600, parent, (u32 *)0xFFC00818);
		debugfs_create_x16("SPORT0_STAT", 0600, parent, (u16 *)0xFFC00830);
		debugfs_create_x16("SPORT0_TCLKDIV", 0600, parent, (u16 *)0xFFC00808);
		debugfs_create_x16("SPORT0_TCR1", 0600, parent, (u16 *)0xFFC00800);
		debugfs_create_x16("SPORT0_TCR2", 0600, parent, (u16 *)0xFFC00804);
		debugfs_create_x16("SPORT0_TFSDIV", 0600, parent, (u16 *)0xFFC0080C);
		debugfs_create_x32("SPORT0_TX", 0600, parent, (u32 *)0xFFC00810);
		debugfs_create_x16("SPORT1_CHNL", 0600, parent, (u16 *)0xFFC00934);
		debugfs_create_x16("SPORT1_MCMC1", 0600, parent, (u16 *)0xFFC00938);
		debugfs_create_x16("SPORT1_MCMC2", 0600, parent, (u16 *)0xFFC0093C);
		debugfs_create_x32("SPORT1_MRCS0", 0600, parent, (u32 *)0xFFC00950);
		debugfs_create_x32("SPORT1_MRCS1", 0600, parent, (u32 *)0xFFC00954);
		debugfs_create_x32("SPORT1_MRCS2", 0600, parent, (u32 *)0xFFC00958);
		debugfs_create_x32("SPORT1_MRCS3", 0600, parent, (u32 *)0xFFC0095C);
		debugfs_create_x32("SPORT1_MTCS0", 0600, parent, (u32 *)0xFFC00940);
		debugfs_create_x32("SPORT1_MTCS1", 0600, parent, (u32 *)0xFFC00944);
		debugfs_create_x32("SPORT1_MTCS2", 0600, parent, (u32 *)0xFFC00948);
		debugfs_create_x32("SPORT1_MTCS3", 0600, parent, (u32 *)0xFFC0094C);
		debugfs_create_x16("SPORT1_RCLKDIV", 0600, parent, (u16 *)0xFFC00928);
		debugfs_create_x16("SPORT1_RCR1", 0600, parent, (u16 *)0xFFC00920);
		debugfs_create_x16("SPORT1_RCR2", 0600, parent, (u16 *)0xFFC00924);
		debugfs_create_x16("SPORT1_RFSDIV", 0600, parent, (u16 *)0xFFC0092C);
		debugfs_create_x32("SPORT1_RX", 0600, parent, (u32 *)0xFFC00918);
		debugfs_create_x16("SPORT1_STAT", 0600, parent, (u16 *)0xFFC00930);
		debugfs_create_x16("SPORT1_TCLKDIV", 0600, parent, (u16 *)0xFFC00908);
		debugfs_create_x16("SPORT1_TCR1", 0600, parent, (u16 *)0xFFC00900);
		debugfs_create_x16("SPORT1_TCR2", 0600, parent, (u16 *)0xFFC00904);
		debugfs_create_x16("SPORT1_TFSDIV", 0600, parent, (u16 *)0xFFC0090C);
		debugfs_create_x32("SPORT1_TX", 0600, parent, (u32 *)0xFFC00910);

		parent = debugfs_create_dir("Security", top);
		debugfs_create_x16("SECURE_CONTROL", 0600, parent, (u16 *)0xFFC03624);
		debugfs_create_x16("SECURE_STATUS", 0600, parent, (u16 *)0xFFC03628);
		debugfs_create_x32("SECURE_SYSSWT", 0600, parent, (u32 *)0xFFC03620);

		parent = debugfs_create_dir("System Interrupt Controller Register File", top);
		debugfs_create_x32("SIC_IAR0", 0600, parent, (u32 *)0xFFC00110);
		debugfs_create_x32("SIC_IAR1", 0600, parent, (u32 *)0xFFC00114);
		debugfs_create_x32("SIC_IAR2", 0600, parent, (u32 *)0xFFC00118);
		debugfs_create_x32("SIC_IAR3", 0600, parent, (u32 *)0xFFC0011C);
		debugfs_create_x32("SIC_IAR4", 0600, parent, (u32 *)0xFFC00150);
		debugfs_create_x32("SIC_IAR5", 0600, parent, (u32 *)0xFFC00154);
		debugfs_create_x32("SIC_IAR6", 0600, parent, (u32 *)0xFFC00158);
		debugfs_create_x32("SIC_IAR7", 0600, parent, (u32 *)0xFFC0015C);
		debugfs_create_x32("SIC_IMASK0", 0600, parent, (u32 *)0xFFC0010C);
		debugfs_create_x32("SIC_IMASK1", 0600, parent, (u32 *)0xFFC0014C);
		debugfs_create_x32("SIC_ISR0", 0600, parent, (u32 *)0xFFC00120);
		debugfs_create_x32("SIC_ISR1", 0600, parent, (u32 *)0xFFC00160);
		debugfs_create_x32("SIC_IWR0", 0600, parent, (u32 *)0xFFC00124);
		debugfs_create_x32("SIC_IWR1", 0600, parent, (u32 *)0xFFC00164);
		debugfs_create_x32("SIC_RVECT", 0600, parent, (u32 *)0xFFC00108);

		parent = debugfs_create_dir("System Reset and Interrupt Control Registers", top);
		debugfs_create_x16("SWRST", 0600, parent, (u16 *)0xFFC00100);
		debugfs_create_x16("SYSCR", 0600, parent, (u16 *)0xFFC00104);

		parent = debugfs_create_dir("TWI", top);
		debugfs_create_x16("TWI_CLKDIV", 0600, parent, (u16 *)0xFFC01400);
		debugfs_create_x16("TWI_CONTROL", 0600, parent, (u16 *)0xFFC01404);
		debugfs_create_x16("TWI_FIFO_CTL", 0600, parent, (u16 *)0xFFC01428);
		debugfs_create_x16("TWI_FIFO_STAT", 0600, parent, (u16 *)0xFFC0142C);
		debugfs_create_x16("TWI_INT_MASK", 0600, parent, (u16 *)0xFFC01424);
		debugfs_create_x16("TWI_INT_STAT", 0600, parent, (u16 *)0xFFC01420);
		debugfs_create_x16("TWI_MASTER_ADDR", 0600, parent, (u16 *)0xFFC0141C);
		debugfs_create_x16("TWI_MASTER_CTL", 0600, parent, (u16 *)0xFFC01414);
		debugfs_create_x16("TWI_MASTER_STAT", 0600, parent, (u16 *)0xFFC01418);
		debugfs_create_x16("TWI_RCV_DATA16", 0600, parent, (u16 *)0xFFC0148C);
		debugfs_create_x16("TWI_RCV_DATA8", 0600, parent, (u16 *)0xFFC01488);
		debugfs_create_x16("TWI_SLAVE_ADDR", 0600, parent, (u16 *)0xFFC01410);
		debugfs_create_x16("TWI_SLAVE_CTL", 0600, parent, (u16 *)0xFFC01408);
		debugfs_create_x16("TWI_SLAVE_STAT", 0600, parent, (u16 *)0xFFC0140C);
		debugfs_create_x16("TWI_XMT_DATA16", 0600, parent, (u16 *)0xFFC01484);
		debugfs_create_x16("TWI_XMT_DATA8", 0600, parent, (u16 *)0xFFC01480);

		parent = debugfs_create_dir("Timer Registers", top);
		debugfs_create_x16("TIMER0_CONFIG", 0600, parent, (u16 *)0xFFC00600);
		debugfs_create_x32("TIMER0_COUNTER", 0600, parent, (u32 *)0xFFC00604);
		debugfs_create_x32("TIMER0_PERIOD", 0600, parent, (u32 *)0xFFC00608);
		debugfs_create_x32("TIMER0_WIDTH", 0600, parent, (u32 *)0xFFC0060C);
		debugfs_create_x16("TIMER1_CONFIG", 0600, parent, (u16 *)0xFFC00610);
		debugfs_create_x32("TIMER1_COUNTER", 0600, parent, (u32 *)0xFFC00614);
		debugfs_create_x32("TIMER1_PERIOD", 0600, parent, (u32 *)0xFFC00618);
		debugfs_create_x32("TIMER1_WIDTH", 0600, parent, (u32 *)0xFFC0061C);
		debugfs_create_x16("TIMER2_CONFIG", 0600, parent, (u16 *)0xFFC00620);
		debugfs_create_x32("TIMER2_COUNTER", 0600, parent, (u32 *)0xFFC00624);
		debugfs_create_x32("TIMER2_PERIOD", 0600, parent, (u32 *)0xFFC00628);
		debugfs_create_x32("TIMER2_WIDTH", 0600, parent, (u32 *)0xFFC0062C);
		debugfs_create_x16("TIMER3_CONFIG", 0600, parent, (u16 *)0xFFC00630);
		debugfs_create_x32("TIMER3_COUNTER", 0600, parent, (u32 *)0xFFC00634);
		debugfs_create_x32("TIMER3_PERIOD", 0600, parent, (u32 *)0xFFC00638);
		debugfs_create_x32("TIMER3_WIDTH", 0600, parent, (u32 *)0xFFC0063C);
		debugfs_create_x16("TIMER4_CONFIG", 0600, parent, (u16 *)0xFFC00640);
		debugfs_create_x32("TIMER4_COUNTER", 0600, parent, (u32 *)0xFFC00644);
		debugfs_create_x32("TIMER4_PERIOD", 0600, parent, (u32 *)0xFFC00648);
		debugfs_create_x32("TIMER4_WIDTH", 0600, parent, (u32 *)0xFFC0064C);
		debugfs_create_x16("TIMER5_CONFIG", 0600, parent, (u16 *)0xFFC00650);
		debugfs_create_x32("TIMER5_COUNTER", 0600, parent, (u32 *)0xFFC00654);
		debugfs_create_x32("TIMER5_PERIOD", 0600, parent, (u32 *)0xFFC00658);
		debugfs_create_x32("TIMER5_WIDTH", 0600, parent, (u32 *)0xFFC0065C);
		debugfs_create_x16("TIMER6_CONFIG", 0600, parent, (u16 *)0xFFC00660);
		debugfs_create_x32("TIMER6_COUNTER", 0600, parent, (u32 *)0xFFC00664);
		debugfs_create_x32("TIMER6_PERIOD", 0600, parent, (u32 *)0xFFC00668);
		debugfs_create_x32("TIMER6_WIDTH", 0600, parent, (u32 *)0xFFC0066C);
		debugfs_create_x16("TIMER7_CONFIG", 0600, parent, (u16 *)0xFFC00670);
		debugfs_create_x32("TIMER7_COUNTER", 0600, parent, (u32 *)0xFFC00674);
		debugfs_create_x32("TIMER7_PERIOD", 0600, parent, (u32 *)0xFFC00678);
		debugfs_create_x32("TIMER7_WIDTH", 0600, parent, (u32 *)0xFFC0067C);
		debugfs_create_x16("TIMER_DISABLE", 0600, parent, (u16 *)0xFFC00684);
		debugfs_create_x16("TIMER_ENABLE", 0600, parent, (u16 *)0xFFC00680);
		debugfs_create_x32("TIMER_STATUS", 0600, parent, (u32 *)0xFFC00688);

		parent = debugfs_create_dir("Trace Unit", top);
		debugfs_create_x32("TBUF", 0600, parent, (u32 *)0xFFE06100);
		debugfs_create_x32("TBUFCTL", 0600, parent, (u32 *)0xFFE06000);
		debugfs_create_x32("TBUFSTAT", 0600, parent, (u32 *)0xFFE06004);

		parent = debugfs_create_dir("UART", top);
		debugfs_create_x16("UART0_DLH", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART0_DLL", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART0_GCTL", 0600, parent, (u16 *)0xFFC00424);
		debugfs_create_x16("UART0_IER", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART0_IIR", 0600, parent, (u16 *)0xFFC00408);
		debugfs_create_x16("UART0_LCR", 0600, parent, (u16 *)0xFFC0040C);
		debugfs_create_x16("UART0_LSR", 0600, parent, (u16 *)0xFFC00414);
		debugfs_create_x16("UART0_MCR", 0600, parent, (u16 *)0xFFC00410);
		debugfs_create_x16("UART0_MSR", 0600, parent, (u16 *)0xFFC00418);
		debugfs_create_x16("UART0_RBR", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART0_SCR", 0600, parent, (u16 *)0xFFC0041C);
		debugfs_create_x16("UART0_THR", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART1_DLH", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("UART1_DLL", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART1_GCTL", 0600, parent, (u16 *)0xFFC02024);
		debugfs_create_x16("UART1_IER", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("UART1_IIR", 0600, parent, (u16 *)0xFFC02008);
		debugfs_create_x16("UART1_LCR", 0600, parent, (u16 *)0xFFC0200C);
		debugfs_create_x16("UART1_LSR", 0600, parent, (u16 *)0xFFC02014);
		debugfs_create_x16("UART1_MCR", 0600, parent, (u16 *)0xFFC02010);
		debugfs_create_x16("UART1_MSR", 0600, parent, (u16 *)0xFFC02018);
		debugfs_create_x16("UART1_RBR", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART1_SCR", 0600, parent, (u16 *)0xFFC0201C);
		debugfs_create_x16("UART1_THR", 0600, parent, (u16 *)0xFFC02000);

		parent = debugfs_create_dir("Watchdog", top);
		debugfs_create_x32("WDOG_CNT", 0600, parent, (u32 *)0xFFC00204);
		debugfs_create_x16("WDOG_CTL", 0600, parent, (u16 *)0xFFC00200);
		debugfs_create_x32("WDOG_STAT", 0600, parent, (u32 *)0xFFC00208);

		parent = debugfs_create_dir("Watchpoint and Patch Unit", top);
		debugfs_create_x32("WPDA0", 0600, parent, (u32 *)0xFFE07140);
		debugfs_create_x32("WPDA1", 0600, parent, (u32 *)0xFFE07144);
		debugfs_create_x32("WPDACNT0", 0600, parent, (u32 *)0xFFE07180);
		debugfs_create_x32("WPDACNT1", 0600, parent, (u32 *)0xFFE07184);
		debugfs_create_x32("WPDACTL", 0600, parent, (u32 *)0xFFE07100);
		debugfs_create_x32("WPIA0", 0600, parent, (u32 *)0xFFE07040);
		debugfs_create_x32("WPIA1", 0600, parent, (u32 *)0xFFE07044);
		debugfs_create_x32("WPIA2", 0600, parent, (u32 *)0xFFE07048);
		debugfs_create_x32("WPIA3", 0600, parent, (u32 *)0xFFE0704C);
		debugfs_create_x32("WPIA4", 0600, parent, (u32 *)0xFFE07050);
		debugfs_create_x32("WPIA5", 0600, parent, (u32 *)0xFFE07054);
		debugfs_create_x32("WPIACNT0", 0600, parent, (u32 *)0xFFE07080);
		debugfs_create_x32("WPIACNT1", 0600, parent, (u32 *)0xFFE07084);
		debugfs_create_x32("WPIACNT2", 0600, parent, (u32 *)0xFFE07088);
		debugfs_create_x32("WPIACNT3", 0600, parent, (u32 *)0xFFE0708C);
		debugfs_create_x32("WPIACNT4", 0600, parent, (u32 *)0xFFE07090);
		debugfs_create_x32("WPIACNT5", 0600, parent, (u32 *)0xFFE07094);
		debugfs_create_x32("WPIACTL", 0600, parent, (u32 *)0xFFE07000);
		debugfs_create_x32("WPSTAT", 0600, parent, (u32 *)0xFFE07200);

	}	/* BF522 */

#ifdef __ADSPBF523__
# define USE_BF523 1
#else
# define USE_BF523 0
#endif
	if (USE_BF523) {

		parent = debugfs_create_dir("Core Timer Register File", top);
		debugfs_create_x32("TCNTL", 0600, parent, (u32 *)0xFFE03000);
		debugfs_create_x32("TCOUNT", 0600, parent, (u32 *)0xFFE0300C);
		debugfs_create_x32("TPERIOD", 0600, parent, (u32 *)0xFFE03004);
		debugfs_create_x32("TSCALE", 0600, parent, (u32 *)0xFFE03008);

		parent = debugfs_create_dir("Counter", top);
		debugfs_create_x16("CNT_COMMAND", 0600, parent, (u16 *)0xFFC0350C);
		debugfs_create_x16("CNT_CONFIG", 0600, parent, (u16 *)0xFFC03500);
		debugfs_create_x32("CNT_COUNTER", 0600, parent, (u32 *)0xFFC03514);
		debugfs_create_x16("CNT_DEBOUNCE", 0600, parent, (u16 *)0xFFC03510);
		debugfs_create_x16("CNT_IMASK", 0600, parent, (u16 *)0xFFC03504);
		debugfs_create_x32("CNT_MAX", 0600, parent, (u32 *)0xFFC03518);
		debugfs_create_x32("CNT_MIN", 0600, parent, (u32 *)0xFFC0351C);
		debugfs_create_x16("CNT_STATUS", 0600, parent, (u16 *)0xFFC03508);

		parent = debugfs_create_dir("DMA Controller", top);
		debugfs_create_x16("DMA0_CONFIG", 0600, parent, (u16 *)0xFFC00C08);
		debugfs_create_x32("DMA0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C24);
		debugfs_create_x32("DMA0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C20);
		debugfs_create_x16("DMA0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C30);
		debugfs_create_x16("DMA0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C38);
		debugfs_create_x16("DMA0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C28);
		debugfs_create_x32("DMA0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C00);
		debugfs_create_x16("DMA0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C2C);
		debugfs_create_x32("DMA0_START_ADDR", 0600, parent, (u32 *)0xFFC00C04);
		debugfs_create_x16("DMA0_X_COUNT", 0600, parent, (u16 *)0xFFC00C10);
		debugfs_create_x16("DMA0_X_MODIFY", 0600, parent, (u16 *)0xFFC00C14);
		debugfs_create_x16("DMA0_Y_COUNT", 0600, parent, (u16 *)0xFFC00C18);
		debugfs_create_x16("DMA0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C1C);
		debugfs_create_x16("DMA10_CONFIG", 0600, parent, (u16 *)0xFFC00E88);
		debugfs_create_x32("DMA10_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EA4);
		debugfs_create_x32("DMA10_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EA0);
		debugfs_create_x16("DMA10_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EB0);
		debugfs_create_x16("DMA10_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EB8);
		debugfs_create_x16("DMA10_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EA8);
		debugfs_create_x32("DMA10_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E80);
		debugfs_create_x16("DMA10_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EAC);
		debugfs_create_x32("DMA10_START_ADDR", 0600, parent, (u32 *)0xFFC00E84);
		debugfs_create_x16("DMA10_X_COUNT", 0600, parent, (u16 *)0xFFC00E90);
		debugfs_create_x16("DMA10_X_MODIFY", 0600, parent, (u16 *)0xFFC00E94);
		debugfs_create_x16("DMA10_Y_COUNT", 0600, parent, (u16 *)0xFFC00E98);
		debugfs_create_x16("DMA10_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E9C);
		debugfs_create_x16("DMA11_CONFIG", 0600, parent, (u16 *)0xFFC00EC8);
		debugfs_create_x32("DMA11_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EE4);
		debugfs_create_x32("DMA11_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EE0);
		debugfs_create_x16("DMA11_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EF0);
		debugfs_create_x16("DMA11_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EF8);
		debugfs_create_x16("DMA11_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EE8);
		debugfs_create_x32("DMA11_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00EC0);
		debugfs_create_x16("DMA11_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EEC);
		debugfs_create_x32("DMA11_START_ADDR", 0600, parent, (u32 *)0xFFC00EC4);
		debugfs_create_x16("DMA11_X_COUNT", 0600, parent, (u16 *)0xFFC00ED0);
		debugfs_create_x16("DMA11_X_MODIFY", 0600, parent, (u16 *)0xFFC00ED4);
		debugfs_create_x16("DMA11_Y_COUNT", 0600, parent, (u16 *)0xFFC00ED8);
		debugfs_create_x16("DMA11_Y_MODIFY", 0600, parent, (u16 *)0xFFC00EDC);
		debugfs_create_x16("DMA1_CONFIG", 0600, parent, (u16 *)0xFFC00C48);
		debugfs_create_x32("DMA1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C64);
		debugfs_create_x32("DMA1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C60);
		debugfs_create_x16("DMA1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C70);
		debugfs_create_x16("DMA1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C78);
		debugfs_create_x16("DMA1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C68);
		debugfs_create_x32("DMA1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C40);
		debugfs_create_x16("DMA1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C6C);
		debugfs_create_x32("DMA1_START_ADDR", 0600, parent, (u32 *)0xFFC00C44);
		debugfs_create_x16("DMA1_X_COUNT", 0600, parent, (u16 *)0xFFC00C50);
		debugfs_create_x16("DMA1_X_MODIFY", 0600, parent, (u16 *)0xFFC00C54);
		debugfs_create_x16("DMA1_Y_COUNT", 0600, parent, (u16 *)0xFFC00C58);
		debugfs_create_x16("DMA1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C5C);
		debugfs_create_x16("DMA2_CONFIG", 0600, parent, (u16 *)0xFFC00C88);
		debugfs_create_x32("DMA2_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CA4);
		debugfs_create_x32("DMA2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CA0);
		debugfs_create_x16("DMA2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CB0);
		debugfs_create_x16("DMA2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CB8);
		debugfs_create_x16("DMA2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CA8);
		debugfs_create_x32("DMA2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C80);
		debugfs_create_x16("DMA2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CAC);
		debugfs_create_x32("DMA2_START_ADDR", 0600, parent, (u32 *)0xFFC00C84);
		debugfs_create_x16("DMA2_X_COUNT", 0600, parent, (u16 *)0xFFC00C90);
		debugfs_create_x16("DMA2_X_MODIFY", 0600, parent, (u16 *)0xFFC00C94);
		debugfs_create_x16("DMA2_Y_COUNT", 0600, parent, (u16 *)0xFFC00C98);
		debugfs_create_x16("DMA2_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C9C);
		debugfs_create_x16("DMA3_CONFIG", 0600, parent, (u16 *)0xFFC00CC8);
		debugfs_create_x32("DMA3_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CE4);
		debugfs_create_x32("DMA3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CE0);
		debugfs_create_x16("DMA3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CF0);
		debugfs_create_x16("DMA3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CF8);
		debugfs_create_x16("DMA3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CE8);
		debugfs_create_x32("DMA3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00CC0);
		debugfs_create_x16("DMA3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CEC);
		debugfs_create_x32("DMA3_START_ADDR", 0600, parent, (u32 *)0xFFC00CC4);
		debugfs_create_x16("DMA3_X_COUNT", 0600, parent, (u16 *)0xFFC00CD0);
		debugfs_create_x16("DMA3_X_MODIFY", 0600, parent, (u16 *)0xFFC00CD4);
		debugfs_create_x16("DMA3_Y_COUNT", 0600, parent, (u16 *)0xFFC00CD8);
		debugfs_create_x16("DMA3_Y_MODIFY", 0600, parent, (u16 *)0xFFC00CDC);
		debugfs_create_x16("DMA4_CONFIG", 0600, parent, (u16 *)0xFFC00D08);
		debugfs_create_x32("DMA4_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D24);
		debugfs_create_x32("DMA4_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D20);
		debugfs_create_x16("DMA4_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D30);
		debugfs_create_x16("DMA4_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D38);
		debugfs_create_x16("DMA4_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D28);
		debugfs_create_x32("DMA4_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D00);
		debugfs_create_x16("DMA4_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D2C);
		debugfs_create_x32("DMA4_START_ADDR", 0600, parent, (u32 *)0xFFC00D04);
		debugfs_create_x16("DMA4_X_COUNT", 0600, parent, (u16 *)0xFFC00D10);
		debugfs_create_x16("DMA4_X_MODIFY", 0600, parent, (u16 *)0xFFC00D14);
		debugfs_create_x16("DMA4_Y_COUNT", 0600, parent, (u16 *)0xFFC00D18);
		debugfs_create_x16("DMA4_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D1C);
		debugfs_create_x16("DMA5_CONFIG", 0600, parent, (u16 *)0xFFC00D48);
		debugfs_create_x32("DMA5_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D64);
		debugfs_create_x32("DMA5_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D60);
		debugfs_create_x16("DMA5_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D70);
		debugfs_create_x16("DMA5_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D78);
		debugfs_create_x16("DMA5_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D68);
		debugfs_create_x32("DMA5_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D40);
		debugfs_create_x16("DMA5_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D6C);
		debugfs_create_x32("DMA5_START_ADDR", 0600, parent, (u32 *)0xFFC00D44);
		debugfs_create_x16("DMA5_X_COUNT", 0600, parent, (u16 *)0xFFC00D50);
		debugfs_create_x16("DMA5_X_MODIFY", 0600, parent, (u16 *)0xFFC00D54);
		debugfs_create_x16("DMA5_Y_COUNT", 0600, parent, (u16 *)0xFFC00D58);
		debugfs_create_x16("DMA5_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D5C);
		debugfs_create_x16("DMA6_CONFIG", 0600, parent, (u16 *)0xFFC00D88);
		debugfs_create_x32("DMA6_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DA4);
		debugfs_create_x32("DMA6_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DA0);
		debugfs_create_x16("DMA6_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DB0);
		debugfs_create_x16("DMA6_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DB8);
		debugfs_create_x16("DMA6_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DA8);
		debugfs_create_x32("DMA6_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D80);
		debugfs_create_x16("DMA6_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DAC);
		debugfs_create_x32("DMA6_START_ADDR", 0600, parent, (u32 *)0xFFC00D84);
		debugfs_create_x16("DMA6_X_COUNT", 0600, parent, (u16 *)0xFFC00D90);
		debugfs_create_x16("DMA6_X_MODIFY", 0600, parent, (u16 *)0xFFC00D94);
		debugfs_create_x16("DMA6_Y_COUNT", 0600, parent, (u16 *)0xFFC00D98);
		debugfs_create_x16("DMA6_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D9C);
		debugfs_create_x16("DMA7_CONFIG", 0600, parent, (u16 *)0xFFC00DC8);
		debugfs_create_x32("DMA7_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DE4);
		debugfs_create_x32("DMA7_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DE0);
		debugfs_create_x16("DMA7_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DF0);
		debugfs_create_x16("DMA7_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DF8);
		debugfs_create_x16("DMA7_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DE8);
		debugfs_create_x32("DMA7_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00DC0);
		debugfs_create_x16("DMA7_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DEC);
		debugfs_create_x32("DMA7_START_ADDR", 0600, parent, (u32 *)0xFFC00DC4);
		debugfs_create_x16("DMA7_X_COUNT", 0600, parent, (u16 *)0xFFC00DD0);
		debugfs_create_x16("DMA7_X_MODIFY", 0600, parent, (u16 *)0xFFC00DD4);
		debugfs_create_x16("DMA7_Y_COUNT", 0600, parent, (u16 *)0xFFC00DD8);
		debugfs_create_x16("DMA7_Y_MODIFY", 0600, parent, (u16 *)0xFFC00DDC);
		debugfs_create_x16("DMA8_CONFIG", 0600, parent, (u16 *)0xFFC00E08);
		debugfs_create_x32("DMA8_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E24);
		debugfs_create_x32("DMA8_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E20);
		debugfs_create_x16("DMA8_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E30);
		debugfs_create_x16("DMA8_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E38);
		debugfs_create_x16("DMA8_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E28);
		debugfs_create_x32("DMA8_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E00);
		debugfs_create_x16("DMA8_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E2C);
		debugfs_create_x32("DMA8_START_ADDR", 0600, parent, (u32 *)0xFFC00E04);
		debugfs_create_x16("DMA8_X_COUNT", 0600, parent, (u16 *)0xFFC00E10);
		debugfs_create_x16("DMA8_X_MODIFY", 0600, parent, (u16 *)0xFFC00E14);
		debugfs_create_x16("DMA8_Y_COUNT", 0600, parent, (u16 *)0xFFC00E18);
		debugfs_create_x16("DMA8_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E1C);
		debugfs_create_x16("DMA9_CONFIG", 0600, parent, (u16 *)0xFFC00E48);
		debugfs_create_x32("DMA9_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E64);
		debugfs_create_x32("DMA9_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E60);
		debugfs_create_x16("DMA9_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E70);
		debugfs_create_x16("DMA9_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E78);
		debugfs_create_x16("DMA9_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E68);
		debugfs_create_x32("DMA9_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E40);
		debugfs_create_x16("DMA9_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E6C);
		debugfs_create_x32("DMA9_START_ADDR", 0600, parent, (u32 *)0xFFC00E44);
		debugfs_create_x16("DMA9_X_COUNT", 0600, parent, (u16 *)0xFFC00E50);
		debugfs_create_x16("DMA9_X_MODIFY", 0600, parent, (u16 *)0xFFC00E54);
		debugfs_create_x16("DMA9_Y_COUNT", 0600, parent, (u16 *)0xFFC00E58);
		debugfs_create_x16("DMA9_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E5C);

		parent = debugfs_create_dir("DMA Traffic Control", top);
		debugfs_create_x16("DMA_TC_CNT", 0600, parent, (u16 *)0xFFC00B0C);
		debugfs_create_x16("DMA_TC_PER", 0600, parent, (u16 *)0xFFC00B10);

		parent = debugfs_create_dir("EBIU", top);
		debugfs_create_x32("EBIU_AMBCTL0", 0600, parent, (u32 *)0xFFC00A04);
		debugfs_create_x32("EBIU_AMBCTL1", 0600, parent, (u32 *)0xFFC00A08);
		debugfs_create_x16("EBIU_AMGCTL", 0600, parent, (u16 *)0xFFC00A00);
		debugfs_create_x16("EBIU_SDBCTL", 0600, parent, (u16 *)0xFFC00A14);
		debugfs_create_x32("EBIU_SDGCTL", 0600, parent, (u32 *)0xFFC00A10);
		debugfs_create_x16("EBIU_SDRRC", 0600, parent, (u16 *)0xFFC00A18);
		debugfs_create_x16("EBIU_SDSTAT", 0600, parent, (u16 *)0xFFC00A1C);

		parent = debugfs_create_dir("Event Vectors", top);
		debugfs_create_x32("EVT0", 0600, parent, (u32 *)0xFFE02000);
		debugfs_create_x32("EVT10", 0600, parent, (u32 *)0xFFE02028);
		debugfs_create_x32("EVT11", 0600, parent, (u32 *)0xFFE0202C);
		debugfs_create_x32("EVT12", 0600, parent, (u32 *)0xFFE02030);
		debugfs_create_x32("EVT13", 0600, parent, (u32 *)0xFFE02034);
		debugfs_create_x32("EVT14", 0600, parent, (u32 *)0xFFE02038);
		debugfs_create_x32("EVT15", 0600, parent, (u32 *)0xFFE0203C);
		debugfs_create_x32("EVT1", 0600, parent, (u32 *)0xFFE02004);
		debugfs_create_x32("EVT2", 0600, parent, (u32 *)0xFFE02008);
		debugfs_create_x32("EVT3", 0600, parent, (u32 *)0xFFE0200C);
		debugfs_create_x32("EVT4", 0600, parent, (u32 *)0xFFE02010);
		debugfs_create_x32("EVT5", 0600, parent, (u32 *)0xFFE02014);
		debugfs_create_x32("EVT6", 0600, parent, (u32 *)0xFFE02018);
		debugfs_create_x32("EVT7", 0600, parent, (u32 *)0xFFE0201C);
		debugfs_create_x32("EVT8", 0600, parent, (u32 *)0xFFE02020);
		debugfs_create_x32("EVT9", 0600, parent, (u32 *)0xFFE02024);

		parent = debugfs_create_dir("Extended Registers", top);
		debugfs_create_x32("CHIPID", 0600, parent, (u32 *)0xFFC00014);
		debugfs_create_x32("DSPID", 0600, parent, (u32 *)0xFFE05000);

		parent = debugfs_create_dir("GPIO PIN", top);
		debugfs_create_x16("PORTF_DRIVE", 0600, parent, (u16 *)0xFFC03220);
		debugfs_create_x16("PORTF_HYSTERESIS", 0600, parent, (u16 *)0xFFC03240);
		debugfs_create_x16("PORTF_MUX", 0600, parent, (u16 *)0xFFC03210);
		debugfs_create_x16("PORTF_SLEW", 0600, parent, (u16 *)0xFFC03230);
		debugfs_create_x16("PORTG_DRIVE", 0600, parent, (u16 *)0xFFC03224);
		debugfs_create_x16("PORTG_HYSTERESIS", 0600, parent, (u16 *)0xFFC03244);
		debugfs_create_x16("PORTG_MUX", 0600, parent, (u16 *)0xFFC03214);
		debugfs_create_x16("PORTG_SLEW", 0600, parent, (u16 *)0xFFC03234);
		debugfs_create_x16("PORTH_DRIVE", 0600, parent, (u16 *)0xFFC03228);
		debugfs_create_x16("PORTH_HYSTERESIS", 0600, parent, (u16 *)0xFFC03248);
		debugfs_create_x16("PORTH_MUX", 0600, parent, (u16 *)0xFFC03218);
		debugfs_create_x16("PORTH_SLEW", 0600, parent, (u16 *)0xFFC03238);

		parent = debugfs_create_dir("HOST", top);
		debugfs_create_x16("HOST_CONTROL", 0600, parent, (u16 *)0xFFC03400);
		debugfs_create_x16("HOST_STATUS", 0600, parent, (u16 *)0xFFC03404);
		debugfs_create_x16("HOST_TIMEOUT", 0600, parent, (u16 *)0xFFC03408);

		parent = debugfs_create_dir("Handshake MDMA", top);
		debugfs_create_x16("HMDMA0_BCINIT", 0600, parent, (u16 *)0xFFC03308);
		debugfs_create_x16("HMDMA0_BCOUNT", 0600, parent, (u16 *)0xFFC03318);
		debugfs_create_x16("HMDMA0_CONTROL", 0600, parent, (u16 *)0xFFC03300);
		debugfs_create_x16("HMDMA0_ECINIT", 0600, parent, (u16 *)0xFFC03304);
		debugfs_create_x16("HMDMA0_ECOUNT", 0600, parent, (u16 *)0xFFC03314);
		debugfs_create_x16("HMDMA0_ECOVERFLOW", 0600, parent, (u16 *)0xFFC03310);
		debugfs_create_x16("HMDMA0_ECURGENT", 0600, parent, (u16 *)0xFFC0330C);
		debugfs_create_x16("HMDMA1_BCINIT", 0600, parent, (u16 *)0xFFC03348);
		debugfs_create_x16("HMDMA1_BCOUNT", 0600, parent, (u16 *)0xFFC03358);
		debugfs_create_x16("HMDMA1_CONTROL", 0600, parent, (u16 *)0xFFC03340);
		debugfs_create_x16("HMDMA1_ECINIT", 0600, parent, (u16 *)0xFFC03344);
		debugfs_create_x16("HMDMA1_ECOUNT", 0600, parent, (u16 *)0xFFC03354);
		debugfs_create_x16("HMDMA1_ECOVERFLOW", 0600, parent, (u16 *)0xFFC03350);
		debugfs_create_x16("HMDMA1_ECURGENT", 0600, parent, (u16 *)0xFFC0334C);

		parent = debugfs_create_dir("Interrupt Controller", top);
		debugfs_create_x32("ILAT", 0600, parent, (u32 *)0xFFE0210C);
		debugfs_create_x32("IMASK", 0600, parent, (u32 *)0xFFE02104);
		debugfs_create_x32("IPEND", 0600, parent, (u32 *)0xFFE02108);
		debugfs_create_x32("IPRIO", 0600, parent, (u32 *)0xFFE02110);

		parent = debugfs_create_dir("L1 Code Memory Registers", top);
		debugfs_create_x32("ICPLB_ADDR0", 0600, parent, (u32 *)0xFFE01100);
		debugfs_create_x32("ICPLB_ADDR10", 0600, parent, (u32 *)0xFFE01128);
		debugfs_create_x32("ICPLB_ADDR11", 0600, parent, (u32 *)0xFFE0112C);
		debugfs_create_x32("ICPLB_ADDR12", 0600, parent, (u32 *)0xFFE01130);
		debugfs_create_x32("ICPLB_ADDR13", 0600, parent, (u32 *)0xFFE01134);
		debugfs_create_x32("ICPLB_ADDR14", 0600, parent, (u32 *)0xFFE01138);
		debugfs_create_x32("ICPLB_ADDR15", 0600, parent, (u32 *)0xFFE0113C);
		debugfs_create_x32("ICPLB_ADDR1", 0600, parent, (u32 *)0xFFE01104);
		debugfs_create_x32("ICPLB_ADDR2", 0600, parent, (u32 *)0xFFE01108);
		debugfs_create_x32("ICPLB_ADDR3", 0600, parent, (u32 *)0xFFE0110C);
		debugfs_create_x32("ICPLB_ADDR4", 0600, parent, (u32 *)0xFFE01110);
		debugfs_create_x32("ICPLB_ADDR5", 0600, parent, (u32 *)0xFFE01114);
		debugfs_create_x32("ICPLB_ADDR6", 0600, parent, (u32 *)0xFFE01118);
		debugfs_create_x32("ICPLB_ADDR7", 0600, parent, (u32 *)0xFFE0111C);
		debugfs_create_x32("ICPLB_ADDR8", 0600, parent, (u32 *)0xFFE01120);
		debugfs_create_x32("ICPLB_ADDR9", 0600, parent, (u32 *)0xFFE01124);
		debugfs_create_x32("ICPLB_DATA0", 0600, parent, (u32 *)0xFFE01200);
		debugfs_create_x32("ICPLB_DATA10", 0600, parent, (u32 *)0xFFE01228);
		debugfs_create_x32("ICPLB_DATA11", 0600, parent, (u32 *)0xFFE0122C);
		debugfs_create_x32("ICPLB_DATA12", 0600, parent, (u32 *)0xFFE01230);
		debugfs_create_x32("ICPLB_DATA13", 0600, parent, (u32 *)0xFFE01234);
		debugfs_create_x32("ICPLB_DATA14", 0600, parent, (u32 *)0xFFE01238);
		debugfs_create_x32("ICPLB_DATA15", 0600, parent, (u32 *)0xFFE0123C);
		debugfs_create_x32("ICPLB_DATA1", 0600, parent, (u32 *)0xFFE01204);
		debugfs_create_x32("ICPLB_DATA2", 0600, parent, (u32 *)0xFFE01208);
		debugfs_create_x32("ICPLB_DATA3", 0600, parent, (u32 *)0xFFE0120C);
		debugfs_create_x32("ICPLB_DATA4", 0600, parent, (u32 *)0xFFE01210);
		debugfs_create_x32("ICPLB_DATA5", 0600, parent, (u32 *)0xFFE01214);
		debugfs_create_x32("ICPLB_DATA6", 0600, parent, (u32 *)0xFFE01218);
		debugfs_create_x32("ICPLB_DATA7", 0600, parent, (u32 *)0xFFE0121C);
		debugfs_create_x32("ICPLB_DATA8", 0600, parent, (u32 *)0xFFE01220);
		debugfs_create_x32("ICPLB_DATA9", 0600, parent, (u32 *)0xFFE01224);
		debugfs_create_x32("ICPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0100C);
		debugfs_create_x32("ICPLB_STATUS", 0600, parent, (u32 *)0xFFE01008);
		debugfs_create_x32("IMEM_CONTROL", 0600, parent, (u32 *)0xFFE01004);
		debugfs_create_x32("ITEST_COMMAND", 0600, parent, (u32 *)0xFFE01300);
		debugfs_create_x32("ITEST_DATA0", 0600, parent, (u32 *)0xFFE01400);
		debugfs_create_x32("ITEST_DATA1", 0600, parent, (u32 *)0xFFE01404);

		parent = debugfs_create_dir("L1 Data Memory Registers", top);
		debugfs_create_x32("DCPLB_ADDR0", 0600, parent, (u32 *)0xFFE00100);
		debugfs_create_x32("DCPLB_ADDR10", 0600, parent, (u32 *)0xFFE00128);
		debugfs_create_x32("DCPLB_ADDR11", 0600, parent, (u32 *)0xFFE0012C);
		debugfs_create_x32("DCPLB_ADDR12", 0600, parent, (u32 *)0xFFE00130);
		debugfs_create_x32("DCPLB_ADDR13", 0600, parent, (u32 *)0xFFE00134);
		debugfs_create_x32("DCPLB_ADDR14", 0600, parent, (u32 *)0xFFE00138);
		debugfs_create_x32("DCPLB_ADDR15", 0600, parent, (u32 *)0xFFE0013C);
		debugfs_create_x32("DCPLB_ADDR1", 0600, parent, (u32 *)0xFFE00104);
		debugfs_create_x32("DCPLB_ADDR2", 0600, parent, (u32 *)0xFFE00108);
		debugfs_create_x32("DCPLB_ADDR3", 0600, parent, (u32 *)0xFFE0010C);
		debugfs_create_x32("DCPLB_ADDR4", 0600, parent, (u32 *)0xFFE00110);
		debugfs_create_x32("DCPLB_ADDR5", 0600, parent, (u32 *)0xFFE00114);
		debugfs_create_x32("DCPLB_ADDR6", 0600, parent, (u32 *)0xFFE00118);
		debugfs_create_x32("DCPLB_ADDR7", 0600, parent, (u32 *)0xFFE0011C);
		debugfs_create_x32("DCPLB_ADDR8", 0600, parent, (u32 *)0xFFE00120);
		debugfs_create_x32("DCPLB_ADDR9", 0600, parent, (u32 *)0xFFE00124);
		debugfs_create_x32("DCPLB_DATA0", 0600, parent, (u32 *)0xFFE00200);
		debugfs_create_x32("DCPLB_DATA10", 0600, parent, (u32 *)0xFFE00228);
		debugfs_create_x32("DCPLB_DATA11", 0600, parent, (u32 *)0xFFE0022C);
		debugfs_create_x32("DCPLB_DATA12", 0600, parent, (u32 *)0xFFE00230);
		debugfs_create_x32("DCPLB_DATA13", 0600, parent, (u32 *)0xFFE00234);
		debugfs_create_x32("DCPLB_DATA14", 0600, parent, (u32 *)0xFFE00238);
		debugfs_create_x32("DCPLB_DATA15", 0600, parent, (u32 *)0xFFE0023C);
		debugfs_create_x32("DCPLB_DATA1", 0600, parent, (u32 *)0xFFE00204);
		debugfs_create_x32("DCPLB_DATA2", 0600, parent, (u32 *)0xFFE00208);
		debugfs_create_x32("DCPLB_DATA3", 0600, parent, (u32 *)0xFFE0020C);
		debugfs_create_x32("DCPLB_DATA4", 0600, parent, (u32 *)0xFFE00210);
		debugfs_create_x32("DCPLB_DATA5", 0600, parent, (u32 *)0xFFE00214);
		debugfs_create_x32("DCPLB_DATA6", 0600, parent, (u32 *)0xFFE00218);
		debugfs_create_x32("DCPLB_DATA7", 0600, parent, (u32 *)0xFFE0021C);
		debugfs_create_x32("DCPLB_DATA8", 0600, parent, (u32 *)0xFFE00220);
		debugfs_create_x32("DCPLB_DATA9", 0600, parent, (u32 *)0xFFE00224);
		debugfs_create_x32("DCPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0000C);
		debugfs_create_x32("DCPLB_STATUS", 0600, parent, (u32 *)0xFFE00008);
		debugfs_create_x32("DMEM_CONTROL", 0600, parent, (u32 *)0xFFE00004);
		debugfs_create_x32("DTEST_COMMAND", 0600, parent, (u32 *)0xFFE00300);
		debugfs_create_x32("DTEST_DATA0", 0600, parent, (u32 *)0xFFE00400);
		debugfs_create_x32("DTEST_DATA1", 0600, parent, (u32 *)0xFFE00404);
		debugfs_create_x32("SRAM_BASE_ADDR", 0600, parent, (u32 *)0xFFE00000);

		parent = debugfs_create_dir("MDMA Destination 0", top);
		debugfs_create_x16("MDMA_D0_CONFIG", 0600, parent, (u16 *)0xFFC00F08);
		debugfs_create_x32("MDMA_D0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F24);
		debugfs_create_x32("MDMA_D0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F20);
		debugfs_create_x16("MDMA_D0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F30);
		debugfs_create_x16("MDMA_D0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F38);
		debugfs_create_x16("MDMA_D0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F28);
		debugfs_create_x32("MDMA_D0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F00);
		debugfs_create_x16("MDMA_D0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F2C);
		debugfs_create_x32("MDMA_D0_START_ADDR", 0600, parent, (u32 *)0xFFC00F04);
		debugfs_create_x16("MDMA_D0_X_COUNT", 0600, parent, (u16 *)0xFFC00F10);
		debugfs_create_x16("MDMA_D0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F14);
		debugfs_create_x16("MDMA_D0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F18);
		debugfs_create_x16("MDMA_D0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F1C);

		parent = debugfs_create_dir("MDMA Destination 1", top);
		debugfs_create_x16("MDMA_D1_CONFIG", 0600, parent, (u16 *)0xFFC00F88);
		debugfs_create_x32("MDMA_D1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FA4);
		debugfs_create_x32("MDMA_D1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FA0);
		debugfs_create_x16("MDMA_D1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FB0);
		debugfs_create_x16("MDMA_D1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FB8);
		debugfs_create_x16("MDMA_D1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FA8);
		debugfs_create_x32("MDMA_D1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F80);
		debugfs_create_x16("MDMA_D1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FAC);
		debugfs_create_x32("MDMA_D1_START_ADDR", 0600, parent, (u32 *)0xFFC00F84);
		debugfs_create_x16("MDMA_D1_X_COUNT", 0600, parent, (u16 *)0xFFC00F90);
		debugfs_create_x16("MDMA_D1_X_MODIFY", 0600, parent, (u16 *)0xFFC00F94);
		debugfs_create_x16("MDMA_D1_Y_COUNT", 0600, parent, (u16 *)0xFFC00F98);
		debugfs_create_x16("MDMA_D1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F9C);

		parent = debugfs_create_dir("MDMA Source 0", top);
		debugfs_create_x16("MDMA_S0_CONFIG", 0600, parent, (u16 *)0xFFC00F48);
		debugfs_create_x32("MDMA_S0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F64);
		debugfs_create_x32("MDMA_S0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F60);
		debugfs_create_x16("MDMA_S0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F70);
		debugfs_create_x16("MDMA_S0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F78);
		debugfs_create_x16("MDMA_S0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F68);
		debugfs_create_x32("MDMA_S0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F40);
		debugfs_create_x16("MDMA_S0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F6C);
		debugfs_create_x32("MDMA_S0_START_ADDR", 0600, parent, (u32 *)0xFFC00F44);
		debugfs_create_x16("MDMA_S0_X_COUNT", 0600, parent, (u16 *)0xFFC00F50);
		debugfs_create_x16("MDMA_S0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F54);
		debugfs_create_x16("MDMA_S0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F58);
		debugfs_create_x16("MDMA_S0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F5C);

		parent = debugfs_create_dir("MDMA Source 1", top);
		debugfs_create_x16("MDMA_S1_CONFIG", 0600, parent, (u16 *)0xFFC00FC8);
		debugfs_create_x32("MDMA_S1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FE4);
		debugfs_create_x32("MDMA_S1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FE0);
		debugfs_create_x16("MDMA_S1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FF0);
		debugfs_create_x16("MDMA_S1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FF8);
		debugfs_create_x16("MDMA_S1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FE8);
		debugfs_create_x32("MDMA_S1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00FC0);
		debugfs_create_x16("MDMA_S1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FEC);
		debugfs_create_x32("MDMA_S1_START_ADDR", 0600, parent, (u32 *)0xFFC00FC4);
		debugfs_create_x16("MDMA_S1_X_COUNT", 0600, parent, (u16 *)0xFFC00FD0);
		debugfs_create_x16("MDMA_S1_X_MODIFY", 0600, parent, (u16 *)0xFFC00FD4);
		debugfs_create_x16("MDMA_S1_Y_COUNT", 0600, parent, (u16 *)0xFFC00FD8);
		debugfs_create_x16("MDMA_S1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00FDC);

		parent = debugfs_create_dir("NFC", top);
		debugfs_create_x16("NFC_ADDR", 0600, parent, (u16 *)0xFFC03740);
		debugfs_create_x16("NFC_CMD", 0600, parent, (u16 *)0xFFC03744);
		debugfs_create_x16("NFC_COUNT", 0600, parent, (u16 *)0xFFC03720);
		debugfs_create_x16("NFC_CTL", 0600, parent, (u16 *)0xFFC03700);
		debugfs_create_x16("NFC_DATA_RD", 0600, parent, (u16 *)0xFFC0374C);
		debugfs_create_x16("NFC_DATA_WR", 0600, parent, (u16 *)0xFFC03748);
		debugfs_create_x16("NFC_ECC0", 0600, parent, (u16 *)0xFFC03710);
		debugfs_create_x16("NFC_ECC1", 0600, parent, (u16 *)0xFFC03714);
		debugfs_create_x16("NFC_ECC2", 0600, parent, (u16 *)0xFFC03718);
		debugfs_create_x16("NFC_ECC3", 0600, parent, (u16 *)0xFFC0371C);
		debugfs_create_x16("NFC_IRQMASK", 0600, parent, (u16 *)0xFFC0370C);
		debugfs_create_x16("NFC_IRQSTAT", 0600, parent, (u16 *)0xFFC03708);
		debugfs_create_x16("NFC_PGCTL", 0600, parent, (u16 *)0xFFC03728);
		debugfs_create_x16("NFC_READ", 0600, parent, (u16 *)0xFFC0372C);
		debugfs_create_x16("NFC_RST", 0600, parent, (u16 *)0xFFC03724);
		debugfs_create_x16("NFC_STAT", 0600, parent, (u16 *)0xFFC03704);

		parent = debugfs_create_dir("NON-GPIO", top);
		debugfs_create_x16("NONGPIO_DRIVE", 0600, parent, (u16 *)0xFFC03280);
		debugfs_create_x16("NONGPIO_HYSTERESIS", 0600, parent, (u16 *)0xFFC03288);
		debugfs_create_x16("NONGPIO_SLEW", 0600, parent, (u16 *)0xFFC03284);

		parent = debugfs_create_dir("OTP", top);
		debugfs_create_x16("OTP_BEN", 0600, parent, (u16 *)0xFFC03604);
		debugfs_create_x16("OTP_CONTROL", 0600, parent, (u16 *)0xFFC03600);
		debugfs_create_x32("OTP_DATA0", 0600, parent, (u32 *)0xFFC03680);
		debugfs_create_x32("OTP_DATA1", 0600, parent, (u32 *)0xFFC03684);
		debugfs_create_x32("OTP_DATA2", 0600, parent, (u32 *)0xFFC03688);
		debugfs_create_x32("OTP_DATA3", 0600, parent, (u32 *)0xFFC0368C);
		debugfs_create_x16("OTP_STATUS", 0600, parent, (u16 *)0xFFC03608);
		debugfs_create_x32("OTP_TIMING", 0600, parent, (u32 *)0xFFC0360C);

		parent = debugfs_create_dir("PLL", top);
		debugfs_create_x16("PLL_CTL", 0600, parent, (u16 *)0xFFC00000);
		debugfs_create_x16("PLL_DIV", 0600, parent, (u16 *)0xFFC00004);
		debugfs_create_x16("PLL_LOCKCNT", 0600, parent, (u16 *)0xFFC00010);
		debugfs_create_x16("PLL_STAT", 0600, parent, (u16 *)0xFFC0000C);
		debugfs_create_x16("VR_CTL", 0600, parent, (u16 *)0xFFC00008);

		parent = debugfs_create_dir("PPI", top);
		debugfs_create_x16("PPI_CONTROL", 0600, parent, (u16 *)0xFFC01000);
		debugfs_create_x16("PPI_COUNT", 0600, parent, (u16 *)0xFFC01008);
		debugfs_create_x16("PPI_DELAY", 0600, parent, (u16 *)0xFFC0100C);
		debugfs_create_x16("PPI_FRAME", 0600, parent, (u16 *)0xFFC01010);
		debugfs_create_x16("PPI_STATUS", 0600, parent, (u16 *)0xFFC01004);

		parent = debugfs_create_dir("Performance Monitor", top);
		debugfs_create_x32("PFCNTR0", 0600, parent, (u32 *)0xFFE08100);
		debugfs_create_x32("PFCNTR1", 0600, parent, (u32 *)0xFFE08104);
		debugfs_create_x32("PFCTL", 0600, parent, (u32 *)0xFFE08000);

		parent = debugfs_create_dir("Pin Control", top);
		debugfs_create_x16("PORTF_FER", 0600, parent, (u16 *)0xFFC03200);
		debugfs_create_x16("PORTG_FER", 0600, parent, (u16 *)0xFFC03204);
		debugfs_create_x16("PORTH_FER", 0600, parent, (u16 *)0xFFC03208);

		parent = debugfs_create_dir("Port I-O", top);
		debugfs_create_x16("PORTFIO", 0600, parent, (u16 *)0xFFC00700);
		debugfs_create_x16("PORTFIO_BOTH", 0600, parent, (u16 *)0xFFC0073C);
		debugfs_create_x16("PORTFIO_CLEAR", 0600, parent, (u16 *)0xFFC00704);
		debugfs_create_x16("PORTFIO_DIR", 0600, parent, (u16 *)0xFFC00730);
		debugfs_create_x16("PORTFIO_EDGE", 0600, parent, (u16 *)0xFFC00738);
		debugfs_create_x16("PORTFIO_INEN", 0600, parent, (u16 *)0xFFC00740);
		debugfs_create_x16("PORTFIO_MASKA", 0600, parent, (u16 *)0xFFC00710);
		debugfs_create_x16("PORTFIO_MASKA_CLEAR", 0600, parent, (u16 *)0xFFC00714);
		debugfs_create_x16("PORTFIO_MASKA_SET", 0600, parent, (u16 *)0xFFC00718);
		debugfs_create_x16("PORTFIO_MASKA_TOGGLE", 0600, parent, (u16 *)0xFFC0071C);
		debugfs_create_x16("PORTFIO_MASKB", 0600, parent, (u16 *)0xFFC00720);
		debugfs_create_x16("PORTFIO_MASKB_CLEAR", 0600, parent, (u16 *)0xFFC00724);
		debugfs_create_x16("PORTFIO_MASKB_SET", 0600, parent, (u16 *)0xFFC00728);
		debugfs_create_x16("PORTFIO_MASKB_TOGGLE", 0600, parent, (u16 *)0xFFC0072C);
		debugfs_create_x16("PORTFIO_POLAR", 0600, parent, (u16 *)0xFFC00734);
		debugfs_create_x16("PORTFIO_SET", 0600, parent, (u16 *)0xFFC00708);
		debugfs_create_x16("PORTFIO_TOGGLE", 0600, parent, (u16 *)0xFFC0070C);
		debugfs_create_x16("PORTGIO", 0600, parent, (u16 *)0xFFC01500);
		debugfs_create_x16("PORTGIO_BOTH", 0600, parent, (u16 *)0xFFC0153C);
		debugfs_create_x16("PORTGIO_CLEAR", 0600, parent, (u16 *)0xFFC01504);
		debugfs_create_x16("PORTGIO_DIR", 0600, parent, (u16 *)0xFFC01530);
		debugfs_create_x16("PORTGIO_EDGE", 0600, parent, (u16 *)0xFFC01538);
		debugfs_create_x16("PORTGIO_INEN", 0600, parent, (u16 *)0xFFC01540);
		debugfs_create_x16("PORTGIO_MASKA", 0600, parent, (u16 *)0xFFC01510);
		debugfs_create_x16("PORTGIO_MASKA_CLEAR", 0600, parent, (u16 *)0xFFC01514);
		debugfs_create_x16("PORTGIO_MASKA_SET", 0600, parent, (u16 *)0xFFC01518);
		debugfs_create_x16("PORTGIO_MASKA_TOGGLE", 0600, parent, (u16 *)0xFFC0151C);
		debugfs_create_x16("PORTGIO_MASKB", 0600, parent, (u16 *)0xFFC01520);
		debugfs_create_x16("PORTGIO_MASKB_CLEAR", 0600, parent, (u16 *)0xFFC01524);
		debugfs_create_x16("PORTGIO_MASKB_SET", 0600, parent, (u16 *)0xFFC01528);
		debugfs_create_x16("PORTGIO_MASKB_TOGGLE", 0600, parent, (u16 *)0xFFC0152C);
		debugfs_create_x16("PORTGIO_POLAR", 0600, parent, (u16 *)0xFFC01534);
		debugfs_create_x16("PORTGIO_SET", 0600, parent, (u16 *)0xFFC01508);
		debugfs_create_x16("PORTGIO_TOGGLE", 0600, parent, (u16 *)0xFFC0150C);
		debugfs_create_x16("PORTHIO", 0600, parent, (u16 *)0xFFC01700);
		debugfs_create_x16("PORTHIO_BOTH", 0600, parent, (u16 *)0xFFC0173C);
		debugfs_create_x16("PORTHIO_CLEAR", 0600, parent, (u16 *)0xFFC01704);
		debugfs_create_x16("PORTHIO_DIR", 0600, parent, (u16 *)0xFFC01730);
		debugfs_create_x16("PORTHIO_EDGE", 0600, parent, (u16 *)0xFFC01738);
		debugfs_create_x16("PORTHIO_INEN", 0600, parent, (u16 *)0xFFC01740);
		debugfs_create_x16("PORTHIO_MASKA", 0600, parent, (u16 *)0xFFC01710);
		debugfs_create_x16("PORTHIO_MASKA_CLEAR", 0600, parent, (u16 *)0xFFC01714);
		debugfs_create_x16("PORTHIO_MASKA_SET", 0600, parent, (u16 *)0xFFC01718);
		debugfs_create_x16("PORTHIO_MASKA_TOGGLE", 0600, parent, (u16 *)0xFFC0171C);
		debugfs_create_x16("PORTHIO_MASKB", 0600, parent, (u16 *)0xFFC01720);
		debugfs_create_x16("PORTHIO_MASKB_CLEAR", 0600, parent, (u16 *)0xFFC01724);
		debugfs_create_x16("PORTHIO_MASKB_SET", 0600, parent, (u16 *)0xFFC01728);
		debugfs_create_x16("PORTHIO_MASKB_TOGGLE", 0600, parent, (u16 *)0xFFC0172C);
		debugfs_create_x16("PORTHIO_POLAR", 0600, parent, (u16 *)0xFFC01734);
		debugfs_create_x16("PORTHIO_SET", 0600, parent, (u16 *)0xFFC01708);
		debugfs_create_x16("PORTHIO_TOGGLE", 0600, parent, (u16 *)0xFFC0170C);

		parent = debugfs_create_dir("RTC", top);
		debugfs_create_x32("RTC_ALARM", 0600, parent, (u32 *)0xFFC00310);
		debugfs_create_x16("RTC_ICTL", 0600, parent, (u16 *)0xFFC00304);
		debugfs_create_x16("RTC_ISTAT", 0600, parent, (u16 *)0xFFC00308);
		debugfs_create_x16("RTC_PREN", 0600, parent, (u16 *)0xFFC00314);
		debugfs_create_x32("RTC_STAT", 0600, parent, (u32 *)0xFFC00300);
		debugfs_create_x16("RTC_SWCNT", 0600, parent, (u16 *)0xFFC0030C);

		parent = debugfs_create_dir("SPI", top);
		debugfs_create_x16("SPI_BAUD", 0600, parent, (u16 *)0xFFC00514);
		debugfs_create_x16("SPI_CTL", 0600, parent, (u16 *)0xFFC00500);
		debugfs_create_x16("SPI_FLG", 0600, parent, (u16 *)0xFFC00504);
		debugfs_create_x16("SPI_RDBR", 0600, parent, (u16 *)0xFFC00510);
		debugfs_create_x16("SPI_SHADOW", 0600, parent, (u16 *)0xFFC00518);
		debugfs_create_x16("SPI_STAT", 0600, parent, (u16 *)0xFFC00508);
		debugfs_create_x16("SPI_TDBR", 0600, parent, (u16 *)0xFFC0050C);

		parent = debugfs_create_dir("SPORT", top);
		debugfs_create_x16("SPORT0_CHNL", 0600, parent, (u16 *)0xFFC00834);
		debugfs_create_x16("SPORT0_MCMC1", 0600, parent, (u16 *)0xFFC00838);
		debugfs_create_x16("SPORT0_MCMC2", 0600, parent, (u16 *)0xFFC0083C);
		debugfs_create_x32("SPORT0_MRCS0", 0600, parent, (u32 *)0xFFC00850);
		debugfs_create_x32("SPORT0_MRCS1", 0600, parent, (u32 *)0xFFC00854);
		debugfs_create_x32("SPORT0_MRCS2", 0600, parent, (u32 *)0xFFC00858);
		debugfs_create_x32("SPORT0_MRCS3", 0600, parent, (u32 *)0xFFC0085C);
		debugfs_create_x32("SPORT0_MTCS0", 0600, parent, (u32 *)0xFFC00840);
		debugfs_create_x32("SPORT0_MTCS1", 0600, parent, (u32 *)0xFFC00844);
		debugfs_create_x32("SPORT0_MTCS2", 0600, parent, (u32 *)0xFFC00848);
		debugfs_create_x32("SPORT0_MTCS3", 0600, parent, (u32 *)0xFFC0084C);
		debugfs_create_x16("SPORT0_RCLKDIV", 0600, parent, (u16 *)0xFFC00828);
		debugfs_create_x16("SPORT0_RCR1", 0600, parent, (u16 *)0xFFC00820);
		debugfs_create_x16("SPORT0_RCR2", 0600, parent, (u16 *)0xFFC00824);
		debugfs_create_x16("SPORT0_RFSDIV", 0600, parent, (u16 *)0xFFC0082C);
		debugfs_create_x32("SPORT0_RX", 0600, parent, (u32 *)0xFFC00818);
		debugfs_create_x16("SPORT0_STAT", 0600, parent, (u16 *)0xFFC00830);
		debugfs_create_x16("SPORT0_TCLKDIV", 0600, parent, (u16 *)0xFFC00808);
		debugfs_create_x16("SPORT0_TCR1", 0600, parent, (u16 *)0xFFC00800);
		debugfs_create_x16("SPORT0_TCR2", 0600, parent, (u16 *)0xFFC00804);
		debugfs_create_x16("SPORT0_TFSDIV", 0600, parent, (u16 *)0xFFC0080C);
		debugfs_create_x32("SPORT0_TX", 0600, parent, (u32 *)0xFFC00810);
		debugfs_create_x16("SPORT1_CHNL", 0600, parent, (u16 *)0xFFC00934);
		debugfs_create_x16("SPORT1_MCMC1", 0600, parent, (u16 *)0xFFC00938);
		debugfs_create_x16("SPORT1_MCMC2", 0600, parent, (u16 *)0xFFC0093C);
		debugfs_create_x32("SPORT1_MRCS0", 0600, parent, (u32 *)0xFFC00950);
		debugfs_create_x32("SPORT1_MRCS1", 0600, parent, (u32 *)0xFFC00954);
		debugfs_create_x32("SPORT1_MRCS2", 0600, parent, (u32 *)0xFFC00958);
		debugfs_create_x32("SPORT1_MRCS3", 0600, parent, (u32 *)0xFFC0095C);
		debugfs_create_x32("SPORT1_MTCS0", 0600, parent, (u32 *)0xFFC00940);
		debugfs_create_x32("SPORT1_MTCS1", 0600, parent, (u32 *)0xFFC00944);
		debugfs_create_x32("SPORT1_MTCS2", 0600, parent, (u32 *)0xFFC00948);
		debugfs_create_x32("SPORT1_MTCS3", 0600, parent, (u32 *)0xFFC0094C);
		debugfs_create_x16("SPORT1_RCLKDIV", 0600, parent, (u16 *)0xFFC00928);
		debugfs_create_x16("SPORT1_RCR1", 0600, parent, (u16 *)0xFFC00920);
		debugfs_create_x16("SPORT1_RCR2", 0600, parent, (u16 *)0xFFC00924);
		debugfs_create_x16("SPORT1_RFSDIV", 0600, parent, (u16 *)0xFFC0092C);
		debugfs_create_x32("SPORT1_RX", 0600, parent, (u32 *)0xFFC00918);
		debugfs_create_x16("SPORT1_STAT", 0600, parent, (u16 *)0xFFC00930);
		debugfs_create_x16("SPORT1_TCLKDIV", 0600, parent, (u16 *)0xFFC00908);
		debugfs_create_x16("SPORT1_TCR1", 0600, parent, (u16 *)0xFFC00900);
		debugfs_create_x16("SPORT1_TCR2", 0600, parent, (u16 *)0xFFC00904);
		debugfs_create_x16("SPORT1_TFSDIV", 0600, parent, (u16 *)0xFFC0090C);
		debugfs_create_x32("SPORT1_TX", 0600, parent, (u32 *)0xFFC00910);

		parent = debugfs_create_dir("Security", top);
		debugfs_create_x16("SECURE_CONTROL", 0600, parent, (u16 *)0xFFC03624);
		debugfs_create_x16("SECURE_STATUS", 0600, parent, (u16 *)0xFFC03628);
		debugfs_create_x32("SECURE_SYSSWT", 0600, parent, (u32 *)0xFFC03620);

		parent = debugfs_create_dir("System Interrupt Controller Register File", top);
		debugfs_create_x32("SIC_IAR0", 0600, parent, (u32 *)0xFFC00110);
		debugfs_create_x32("SIC_IAR1", 0600, parent, (u32 *)0xFFC00114);
		debugfs_create_x32("SIC_IAR2", 0600, parent, (u32 *)0xFFC00118);
		debugfs_create_x32("SIC_IAR3", 0600, parent, (u32 *)0xFFC0011C);
		debugfs_create_x32("SIC_IAR4", 0600, parent, (u32 *)0xFFC00150);
		debugfs_create_x32("SIC_IAR5", 0600, parent, (u32 *)0xFFC00154);
		debugfs_create_x32("SIC_IAR6", 0600, parent, (u32 *)0xFFC00158);
		debugfs_create_x32("SIC_IAR7", 0600, parent, (u32 *)0xFFC0015C);
		debugfs_create_x32("SIC_IMASK0", 0600, parent, (u32 *)0xFFC0010C);
		debugfs_create_x32("SIC_IMASK1", 0600, parent, (u32 *)0xFFC0014C);
		debugfs_create_x32("SIC_ISR0", 0600, parent, (u32 *)0xFFC00120);
		debugfs_create_x32("SIC_ISR1", 0600, parent, (u32 *)0xFFC00160);
		debugfs_create_x32("SIC_IWR0", 0600, parent, (u32 *)0xFFC00124);
		debugfs_create_x32("SIC_IWR1", 0600, parent, (u32 *)0xFFC00164);
		debugfs_create_x32("SIC_RVECT", 0600, parent, (u32 *)0xFFC00108);

		parent = debugfs_create_dir("System Reset and Interrupt Control Registers", top);
		debugfs_create_x16("SWRST", 0600, parent, (u16 *)0xFFC00100);
		debugfs_create_x16("SYSCR", 0600, parent, (u16 *)0xFFC00104);

		parent = debugfs_create_dir("TWI", top);
		debugfs_create_x16("TWI_CLKDIV", 0600, parent, (u16 *)0xFFC01400);
		debugfs_create_x16("TWI_CONTROL", 0600, parent, (u16 *)0xFFC01404);
		debugfs_create_x16("TWI_FIFO_CTL", 0600, parent, (u16 *)0xFFC01428);
		debugfs_create_x16("TWI_FIFO_STAT", 0600, parent, (u16 *)0xFFC0142C);
		debugfs_create_x16("TWI_INT_MASK", 0600, parent, (u16 *)0xFFC01424);
		debugfs_create_x16("TWI_INT_STAT", 0600, parent, (u16 *)0xFFC01420);
		debugfs_create_x16("TWI_MASTER_ADDR", 0600, parent, (u16 *)0xFFC0141C);
		debugfs_create_x16("TWI_MASTER_CTL", 0600, parent, (u16 *)0xFFC01414);
		debugfs_create_x16("TWI_MASTER_STAT", 0600, parent, (u16 *)0xFFC01418);
		debugfs_create_x16("TWI_RCV_DATA16", 0600, parent, (u16 *)0xFFC0148C);
		debugfs_create_x16("TWI_RCV_DATA8", 0600, parent, (u16 *)0xFFC01488);
		debugfs_create_x16("TWI_SLAVE_ADDR", 0600, parent, (u16 *)0xFFC01410);
		debugfs_create_x16("TWI_SLAVE_CTL", 0600, parent, (u16 *)0xFFC01408);
		debugfs_create_x16("TWI_SLAVE_STAT", 0600, parent, (u16 *)0xFFC0140C);
		debugfs_create_x16("TWI_XMT_DATA16", 0600, parent, (u16 *)0xFFC01484);
		debugfs_create_x16("TWI_XMT_DATA8", 0600, parent, (u16 *)0xFFC01480);

		parent = debugfs_create_dir("Timer Registers", top);
		debugfs_create_x16("TIMER0_CONFIG", 0600, parent, (u16 *)0xFFC00600);
		debugfs_create_x32("TIMER0_COUNTER", 0600, parent, (u32 *)0xFFC00604);
		debugfs_create_x32("TIMER0_PERIOD", 0600, parent, (u32 *)0xFFC00608);
		debugfs_create_x32("TIMER0_WIDTH", 0600, parent, (u32 *)0xFFC0060C);
		debugfs_create_x16("TIMER1_CONFIG", 0600, parent, (u16 *)0xFFC00610);
		debugfs_create_x32("TIMER1_COUNTER", 0600, parent, (u32 *)0xFFC00614);
		debugfs_create_x32("TIMER1_PERIOD", 0600, parent, (u32 *)0xFFC00618);
		debugfs_create_x32("TIMER1_WIDTH", 0600, parent, (u32 *)0xFFC0061C);
		debugfs_create_x16("TIMER2_CONFIG", 0600, parent, (u16 *)0xFFC00620);
		debugfs_create_x32("TIMER2_COUNTER", 0600, parent, (u32 *)0xFFC00624);
		debugfs_create_x32("TIMER2_PERIOD", 0600, parent, (u32 *)0xFFC00628);
		debugfs_create_x32("TIMER2_WIDTH", 0600, parent, (u32 *)0xFFC0062C);
		debugfs_create_x16("TIMER3_CONFIG", 0600, parent, (u16 *)0xFFC00630);
		debugfs_create_x32("TIMER3_COUNTER", 0600, parent, (u32 *)0xFFC00634);
		debugfs_create_x32("TIMER3_PERIOD", 0600, parent, (u32 *)0xFFC00638);
		debugfs_create_x32("TIMER3_WIDTH", 0600, parent, (u32 *)0xFFC0063C);
		debugfs_create_x16("TIMER4_CONFIG", 0600, parent, (u16 *)0xFFC00640);
		debugfs_create_x32("TIMER4_COUNTER", 0600, parent, (u32 *)0xFFC00644);
		debugfs_create_x32("TIMER4_PERIOD", 0600, parent, (u32 *)0xFFC00648);
		debugfs_create_x32("TIMER4_WIDTH", 0600, parent, (u32 *)0xFFC0064C);
		debugfs_create_x16("TIMER5_CONFIG", 0600, parent, (u16 *)0xFFC00650);
		debugfs_create_x32("TIMER5_COUNTER", 0600, parent, (u32 *)0xFFC00654);
		debugfs_create_x32("TIMER5_PERIOD", 0600, parent, (u32 *)0xFFC00658);
		debugfs_create_x32("TIMER5_WIDTH", 0600, parent, (u32 *)0xFFC0065C);
		debugfs_create_x16("TIMER6_CONFIG", 0600, parent, (u16 *)0xFFC00660);
		debugfs_create_x32("TIMER6_COUNTER", 0600, parent, (u32 *)0xFFC00664);
		debugfs_create_x32("TIMER6_PERIOD", 0600, parent, (u32 *)0xFFC00668);
		debugfs_create_x32("TIMER6_WIDTH", 0600, parent, (u32 *)0xFFC0066C);
		debugfs_create_x16("TIMER7_CONFIG", 0600, parent, (u16 *)0xFFC00670);
		debugfs_create_x32("TIMER7_COUNTER", 0600, parent, (u32 *)0xFFC00674);
		debugfs_create_x32("TIMER7_PERIOD", 0600, parent, (u32 *)0xFFC00678);
		debugfs_create_x32("TIMER7_WIDTH", 0600, parent, (u32 *)0xFFC0067C);
		debugfs_create_x16("TIMER_DISABLE", 0600, parent, (u16 *)0xFFC00684);
		debugfs_create_x16("TIMER_ENABLE", 0600, parent, (u16 *)0xFFC00680);
		debugfs_create_x32("TIMER_STATUS", 0600, parent, (u32 *)0xFFC00688);

		parent = debugfs_create_dir("Trace Unit", top);
		debugfs_create_x32("TBUF", 0600, parent, (u32 *)0xFFE06100);
		debugfs_create_x32("TBUFCTL", 0600, parent, (u32 *)0xFFE06000);
		debugfs_create_x32("TBUFSTAT", 0600, parent, (u32 *)0xFFE06004);

		parent = debugfs_create_dir("UART", top);
		debugfs_create_x16("UART0_DLH", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART0_DLL", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART0_GCTL", 0600, parent, (u16 *)0xFFC00424);
		debugfs_create_x16("UART0_IER", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART0_IIR", 0600, parent, (u16 *)0xFFC00408);
		debugfs_create_x16("UART0_LCR", 0600, parent, (u16 *)0xFFC0040C);
		debugfs_create_x16("UART0_LSR", 0600, parent, (u16 *)0xFFC00414);
		debugfs_create_x16("UART0_MCR", 0600, parent, (u16 *)0xFFC00410);
		debugfs_create_x16("UART0_MSR", 0600, parent, (u16 *)0xFFC00418);
		debugfs_create_x16("UART0_RBR", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART0_SCR", 0600, parent, (u16 *)0xFFC0041C);
		debugfs_create_x16("UART0_THR", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART1_DLH", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("UART1_DLL", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART1_GCTL", 0600, parent, (u16 *)0xFFC02024);
		debugfs_create_x16("UART1_IER", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("UART1_IIR", 0600, parent, (u16 *)0xFFC02008);
		debugfs_create_x16("UART1_LCR", 0600, parent, (u16 *)0xFFC0200C);
		debugfs_create_x16("UART1_LSR", 0600, parent, (u16 *)0xFFC02014);
		debugfs_create_x16("UART1_MCR", 0600, parent, (u16 *)0xFFC02010);
		debugfs_create_x16("UART1_MSR", 0600, parent, (u16 *)0xFFC02018);
		debugfs_create_x16("UART1_RBR", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART1_SCR", 0600, parent, (u16 *)0xFFC0201C);
		debugfs_create_x16("UART1_THR", 0600, parent, (u16 *)0xFFC02000);

		parent = debugfs_create_dir("Watchdog", top);
		debugfs_create_x32("WDOG_CNT", 0600, parent, (u32 *)0xFFC00204);
		debugfs_create_x16("WDOG_CTL", 0600, parent, (u16 *)0xFFC00200);
		debugfs_create_x32("WDOG_STAT", 0600, parent, (u32 *)0xFFC00208);

		parent = debugfs_create_dir("Watchpoint and Patch Unit", top);
		debugfs_create_x32("WPDA0", 0600, parent, (u32 *)0xFFE07140);
		debugfs_create_x32("WPDA1", 0600, parent, (u32 *)0xFFE07144);
		debugfs_create_x32("WPDACNT0", 0600, parent, (u32 *)0xFFE07180);
		debugfs_create_x32("WPDACNT1", 0600, parent, (u32 *)0xFFE07184);
		debugfs_create_x32("WPDACTL", 0600, parent, (u32 *)0xFFE07100);
		debugfs_create_x32("WPIA0", 0600, parent, (u32 *)0xFFE07040);
		debugfs_create_x32("WPIA1", 0600, parent, (u32 *)0xFFE07044);
		debugfs_create_x32("WPIA2", 0600, parent, (u32 *)0xFFE07048);
		debugfs_create_x32("WPIA3", 0600, parent, (u32 *)0xFFE0704C);
		debugfs_create_x32("WPIA4", 0600, parent, (u32 *)0xFFE07050);
		debugfs_create_x32("WPIA5", 0600, parent, (u32 *)0xFFE07054);
		debugfs_create_x32("WPIACNT0", 0600, parent, (u32 *)0xFFE07080);
		debugfs_create_x32("WPIACNT1", 0600, parent, (u32 *)0xFFE07084);
		debugfs_create_x32("WPIACNT2", 0600, parent, (u32 *)0xFFE07088);
		debugfs_create_x32("WPIACNT3", 0600, parent, (u32 *)0xFFE0708C);
		debugfs_create_x32("WPIACNT4", 0600, parent, (u32 *)0xFFE07090);
		debugfs_create_x32("WPIACNT5", 0600, parent, (u32 *)0xFFE07094);
		debugfs_create_x32("WPIACTL", 0600, parent, (u32 *)0xFFE07000);
		debugfs_create_x32("WPSTAT", 0600, parent, (u32 *)0xFFE07200);

	}	/* BF523 */

#ifdef __ADSPBF524__
# define USE_BF524 1
#else
# define USE_BF524 0
#endif
	if (USE_BF524) {

		parent = debugfs_create_dir("Core Timer Register File", top);
		debugfs_create_x32("TCNTL", 0600, parent, (u32 *)0xFFE03000);
		debugfs_create_x32("TCOUNT", 0600, parent, (u32 *)0xFFE0300C);
		debugfs_create_x32("TPERIOD", 0600, parent, (u32 *)0xFFE03004);
		debugfs_create_x32("TSCALE", 0600, parent, (u32 *)0xFFE03008);

		parent = debugfs_create_dir("Counter", top);
		debugfs_create_x16("CNT_COMMAND", 0600, parent, (u16 *)0xFFC0350C);
		debugfs_create_x16("CNT_CONFIG", 0600, parent, (u16 *)0xFFC03500);
		debugfs_create_x32("CNT_COUNTER", 0600, parent, (u32 *)0xFFC03514);
		debugfs_create_x16("CNT_DEBOUNCE", 0600, parent, (u16 *)0xFFC03510);
		debugfs_create_x16("CNT_IMASK", 0600, parent, (u16 *)0xFFC03504);
		debugfs_create_x32("CNT_MAX", 0600, parent, (u32 *)0xFFC03518);
		debugfs_create_x32("CNT_MIN", 0600, parent, (u32 *)0xFFC0351C);
		debugfs_create_x16("CNT_STATUS", 0600, parent, (u16 *)0xFFC03508);

		parent = debugfs_create_dir("DMA Controller", top);
		debugfs_create_x16("DMA0_CONFIG", 0600, parent, (u16 *)0xFFC00C08);
		debugfs_create_x32("DMA0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C24);
		debugfs_create_x32("DMA0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C20);
		debugfs_create_x16("DMA0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C30);
		debugfs_create_x16("DMA0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C38);
		debugfs_create_x16("DMA0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C28);
		debugfs_create_x32("DMA0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C00);
		debugfs_create_x16("DMA0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C2C);
		debugfs_create_x32("DMA0_START_ADDR", 0600, parent, (u32 *)0xFFC00C04);
		debugfs_create_x16("DMA0_X_COUNT", 0600, parent, (u16 *)0xFFC00C10);
		debugfs_create_x16("DMA0_X_MODIFY", 0600, parent, (u16 *)0xFFC00C14);
		debugfs_create_x16("DMA0_Y_COUNT", 0600, parent, (u16 *)0xFFC00C18);
		debugfs_create_x16("DMA0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C1C);
		debugfs_create_x16("DMA10_CONFIG", 0600, parent, (u16 *)0xFFC00E88);
		debugfs_create_x32("DMA10_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EA4);
		debugfs_create_x32("DMA10_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EA0);
		debugfs_create_x16("DMA10_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EB0);
		debugfs_create_x16("DMA10_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EB8);
		debugfs_create_x16("DMA10_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EA8);
		debugfs_create_x32("DMA10_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E80);
		debugfs_create_x16("DMA10_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EAC);
		debugfs_create_x32("DMA10_START_ADDR", 0600, parent, (u32 *)0xFFC00E84);
		debugfs_create_x16("DMA10_X_COUNT", 0600, parent, (u16 *)0xFFC00E90);
		debugfs_create_x16("DMA10_X_MODIFY", 0600, parent, (u16 *)0xFFC00E94);
		debugfs_create_x16("DMA10_Y_COUNT", 0600, parent, (u16 *)0xFFC00E98);
		debugfs_create_x16("DMA10_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E9C);
		debugfs_create_x16("DMA11_CONFIG", 0600, parent, (u16 *)0xFFC00EC8);
		debugfs_create_x32("DMA11_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EE4);
		debugfs_create_x32("DMA11_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EE0);
		debugfs_create_x16("DMA11_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EF0);
		debugfs_create_x16("DMA11_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EF8);
		debugfs_create_x16("DMA11_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EE8);
		debugfs_create_x32("DMA11_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00EC0);
		debugfs_create_x16("DMA11_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EEC);
		debugfs_create_x32("DMA11_START_ADDR", 0600, parent, (u32 *)0xFFC00EC4);
		debugfs_create_x16("DMA11_X_COUNT", 0600, parent, (u16 *)0xFFC00ED0);
		debugfs_create_x16("DMA11_X_MODIFY", 0600, parent, (u16 *)0xFFC00ED4);
		debugfs_create_x16("DMA11_Y_COUNT", 0600, parent, (u16 *)0xFFC00ED8);
		debugfs_create_x16("DMA11_Y_MODIFY", 0600, parent, (u16 *)0xFFC00EDC);
		debugfs_create_x16("DMA1_CONFIG", 0600, parent, (u16 *)0xFFC00C48);
		debugfs_create_x32("DMA1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C64);
		debugfs_create_x32("DMA1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C60);
		debugfs_create_x16("DMA1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C70);
		debugfs_create_x16("DMA1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C78);
		debugfs_create_x16("DMA1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C68);
		debugfs_create_x32("DMA1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C40);
		debugfs_create_x16("DMA1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C6C);
		debugfs_create_x32("DMA1_START_ADDR", 0600, parent, (u32 *)0xFFC00C44);
		debugfs_create_x16("DMA1_X_COUNT", 0600, parent, (u16 *)0xFFC00C50);
		debugfs_create_x16("DMA1_X_MODIFY", 0600, parent, (u16 *)0xFFC00C54);
		debugfs_create_x16("DMA1_Y_COUNT", 0600, parent, (u16 *)0xFFC00C58);
		debugfs_create_x16("DMA1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C5C);
		debugfs_create_x16("DMA2_CONFIG", 0600, parent, (u16 *)0xFFC00C88);
		debugfs_create_x32("DMA2_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CA4);
		debugfs_create_x32("DMA2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CA0);
		debugfs_create_x16("DMA2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CB0);
		debugfs_create_x16("DMA2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CB8);
		debugfs_create_x16("DMA2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CA8);
		debugfs_create_x32("DMA2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C80);
		debugfs_create_x16("DMA2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CAC);
		debugfs_create_x32("DMA2_START_ADDR", 0600, parent, (u32 *)0xFFC00C84);
		debugfs_create_x16("DMA2_X_COUNT", 0600, parent, (u16 *)0xFFC00C90);
		debugfs_create_x16("DMA2_X_MODIFY", 0600, parent, (u16 *)0xFFC00C94);
		debugfs_create_x16("DMA2_Y_COUNT", 0600, parent, (u16 *)0xFFC00C98);
		debugfs_create_x16("DMA2_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C9C);
		debugfs_create_x16("DMA3_CONFIG", 0600, parent, (u16 *)0xFFC00CC8);
		debugfs_create_x32("DMA3_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CE4);
		debugfs_create_x32("DMA3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CE0);
		debugfs_create_x16("DMA3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CF0);
		debugfs_create_x16("DMA3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CF8);
		debugfs_create_x16("DMA3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CE8);
		debugfs_create_x32("DMA3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00CC0);
		debugfs_create_x16("DMA3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CEC);
		debugfs_create_x32("DMA3_START_ADDR", 0600, parent, (u32 *)0xFFC00CC4);
		debugfs_create_x16("DMA3_X_COUNT", 0600, parent, (u16 *)0xFFC00CD0);
		debugfs_create_x16("DMA3_X_MODIFY", 0600, parent, (u16 *)0xFFC00CD4);
		debugfs_create_x16("DMA3_Y_COUNT", 0600, parent, (u16 *)0xFFC00CD8);
		debugfs_create_x16("DMA3_Y_MODIFY", 0600, parent, (u16 *)0xFFC00CDC);
		debugfs_create_x16("DMA4_CONFIG", 0600, parent, (u16 *)0xFFC00D08);
		debugfs_create_x32("DMA4_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D24);
		debugfs_create_x32("DMA4_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D20);
		debugfs_create_x16("DMA4_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D30);
		debugfs_create_x16("DMA4_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D38);
		debugfs_create_x16("DMA4_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D28);
		debugfs_create_x32("DMA4_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D00);
		debugfs_create_x16("DMA4_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D2C);
		debugfs_create_x32("DMA4_START_ADDR", 0600, parent, (u32 *)0xFFC00D04);
		debugfs_create_x16("DMA4_X_COUNT", 0600, parent, (u16 *)0xFFC00D10);
		debugfs_create_x16("DMA4_X_MODIFY", 0600, parent, (u16 *)0xFFC00D14);
		debugfs_create_x16("DMA4_Y_COUNT", 0600, parent, (u16 *)0xFFC00D18);
		debugfs_create_x16("DMA4_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D1C);
		debugfs_create_x16("DMA5_CONFIG", 0600, parent, (u16 *)0xFFC00D48);
		debugfs_create_x32("DMA5_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D64);
		debugfs_create_x32("DMA5_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D60);
		debugfs_create_x16("DMA5_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D70);
		debugfs_create_x16("DMA5_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D78);
		debugfs_create_x16("DMA5_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D68);
		debugfs_create_x32("DMA5_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D40);
		debugfs_create_x16("DMA5_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D6C);
		debugfs_create_x32("DMA5_START_ADDR", 0600, parent, (u32 *)0xFFC00D44);
		debugfs_create_x16("DMA5_X_COUNT", 0600, parent, (u16 *)0xFFC00D50);
		debugfs_create_x16("DMA5_X_MODIFY", 0600, parent, (u16 *)0xFFC00D54);
		debugfs_create_x16("DMA5_Y_COUNT", 0600, parent, (u16 *)0xFFC00D58);
		debugfs_create_x16("DMA5_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D5C);
		debugfs_create_x16("DMA6_CONFIG", 0600, parent, (u16 *)0xFFC00D88);
		debugfs_create_x32("DMA6_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DA4);
		debugfs_create_x32("DMA6_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DA0);
		debugfs_create_x16("DMA6_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DB0);
		debugfs_create_x16("DMA6_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DB8);
		debugfs_create_x16("DMA6_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DA8);
		debugfs_create_x32("DMA6_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D80);
		debugfs_create_x16("DMA6_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DAC);
		debugfs_create_x32("DMA6_START_ADDR", 0600, parent, (u32 *)0xFFC00D84);
		debugfs_create_x16("DMA6_X_COUNT", 0600, parent, (u16 *)0xFFC00D90);
		debugfs_create_x16("DMA6_X_MODIFY", 0600, parent, (u16 *)0xFFC00D94);
		debugfs_create_x16("DMA6_Y_COUNT", 0600, parent, (u16 *)0xFFC00D98);
		debugfs_create_x16("DMA6_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D9C);
		debugfs_create_x16("DMA7_CONFIG", 0600, parent, (u16 *)0xFFC00DC8);
		debugfs_create_x32("DMA7_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DE4);
		debugfs_create_x32("DMA7_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DE0);
		debugfs_create_x16("DMA7_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DF0);
		debugfs_create_x16("DMA7_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DF8);
		debugfs_create_x16("DMA7_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DE8);
		debugfs_create_x32("DMA7_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00DC0);
		debugfs_create_x16("DMA7_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DEC);
		debugfs_create_x32("DMA7_START_ADDR", 0600, parent, (u32 *)0xFFC00DC4);
		debugfs_create_x16("DMA7_X_COUNT", 0600, parent, (u16 *)0xFFC00DD0);
		debugfs_create_x16("DMA7_X_MODIFY", 0600, parent, (u16 *)0xFFC00DD4);
		debugfs_create_x16("DMA7_Y_COUNT", 0600, parent, (u16 *)0xFFC00DD8);
		debugfs_create_x16("DMA7_Y_MODIFY", 0600, parent, (u16 *)0xFFC00DDC);
		debugfs_create_x16("DMA8_CONFIG", 0600, parent, (u16 *)0xFFC00E08);
		debugfs_create_x32("DMA8_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E24);
		debugfs_create_x32("DMA8_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E20);
		debugfs_create_x16("DMA8_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E30);
		debugfs_create_x16("DMA8_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E38);
		debugfs_create_x16("DMA8_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E28);
		debugfs_create_x32("DMA8_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E00);
		debugfs_create_x16("DMA8_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E2C);
		debugfs_create_x32("DMA8_START_ADDR", 0600, parent, (u32 *)0xFFC00E04);
		debugfs_create_x16("DMA8_X_COUNT", 0600, parent, (u16 *)0xFFC00E10);
		debugfs_create_x16("DMA8_X_MODIFY", 0600, parent, (u16 *)0xFFC00E14);
		debugfs_create_x16("DMA8_Y_COUNT", 0600, parent, (u16 *)0xFFC00E18);
		debugfs_create_x16("DMA8_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E1C);
		debugfs_create_x16("DMA9_CONFIG", 0600, parent, (u16 *)0xFFC00E48);
		debugfs_create_x32("DMA9_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E64);
		debugfs_create_x32("DMA9_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E60);
		debugfs_create_x16("DMA9_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E70);
		debugfs_create_x16("DMA9_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E78);
		debugfs_create_x16("DMA9_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E68);
		debugfs_create_x32("DMA9_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E40);
		debugfs_create_x16("DMA9_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E6C);
		debugfs_create_x32("DMA9_START_ADDR", 0600, parent, (u32 *)0xFFC00E44);
		debugfs_create_x16("DMA9_X_COUNT", 0600, parent, (u16 *)0xFFC00E50);
		debugfs_create_x16("DMA9_X_MODIFY", 0600, parent, (u16 *)0xFFC00E54);
		debugfs_create_x16("DMA9_Y_COUNT", 0600, parent, (u16 *)0xFFC00E58);
		debugfs_create_x16("DMA9_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E5C);

		parent = debugfs_create_dir("DMA Traffic Control", top);
		debugfs_create_x16("DMA_TC_CNT", 0600, parent, (u16 *)0xFFC00B0C);
		debugfs_create_x16("DMA_TC_PER", 0600, parent, (u16 *)0xFFC00B10);

		parent = debugfs_create_dir("EBIU", top);
		debugfs_create_x32("EBIU_AMBCTL0", 0600, parent, (u32 *)0xFFC00A04);
		debugfs_create_x32("EBIU_AMBCTL1", 0600, parent, (u32 *)0xFFC00A08);
		debugfs_create_x16("EBIU_AMGCTL", 0600, parent, (u16 *)0xFFC00A00);
		debugfs_create_x16("EBIU_SDBCTL", 0600, parent, (u16 *)0xFFC00A14);
		debugfs_create_x32("EBIU_SDGCTL", 0600, parent, (u32 *)0xFFC00A10);
		debugfs_create_x16("EBIU_SDRRC", 0600, parent, (u16 *)0xFFC00A18);
		debugfs_create_x16("EBIU_SDSTAT", 0600, parent, (u16 *)0xFFC00A1C);

		parent = debugfs_create_dir("Event Vectors", top);
		debugfs_create_x32("EVT0", 0600, parent, (u32 *)0xFFE02000);
		debugfs_create_x32("EVT10", 0600, parent, (u32 *)0xFFE02028);
		debugfs_create_x32("EVT11", 0600, parent, (u32 *)0xFFE0202C);
		debugfs_create_x32("EVT12", 0600, parent, (u32 *)0xFFE02030);
		debugfs_create_x32("EVT13", 0600, parent, (u32 *)0xFFE02034);
		debugfs_create_x32("EVT14", 0600, parent, (u32 *)0xFFE02038);
		debugfs_create_x32("EVT15", 0600, parent, (u32 *)0xFFE0203C);
		debugfs_create_x32("EVT1", 0600, parent, (u32 *)0xFFE02004);
		debugfs_create_x32("EVT2", 0600, parent, (u32 *)0xFFE02008);
		debugfs_create_x32("EVT3", 0600, parent, (u32 *)0xFFE0200C);
		debugfs_create_x32("EVT4", 0600, parent, (u32 *)0xFFE02010);
		debugfs_create_x32("EVT5", 0600, parent, (u32 *)0xFFE02014);
		debugfs_create_x32("EVT6", 0600, parent, (u32 *)0xFFE02018);
		debugfs_create_x32("EVT7", 0600, parent, (u32 *)0xFFE0201C);
		debugfs_create_x32("EVT8", 0600, parent, (u32 *)0xFFE02020);
		debugfs_create_x32("EVT9", 0600, parent, (u32 *)0xFFE02024);

		parent = debugfs_create_dir("Extended Registers", top);
		debugfs_create_x32("CHIPID", 0600, parent, (u32 *)0xFFC00014);
		debugfs_create_x32("DSPID", 0600, parent, (u32 *)0xFFE05000);

		parent = debugfs_create_dir("GPIO PIN", top);
		debugfs_create_x16("PORTF_DRIVE", 0600, parent, (u16 *)0xFFC03220);
		debugfs_create_x16("PORTF_HYSTERESIS", 0600, parent, (u16 *)0xFFC03240);
		debugfs_create_x16("PORTF_MUX", 0600, parent, (u16 *)0xFFC03210);
		debugfs_create_x16("PORTF_SLEW", 0600, parent, (u16 *)0xFFC03230);
		debugfs_create_x16("PORTG_DRIVE", 0600, parent, (u16 *)0xFFC03224);
		debugfs_create_x16("PORTG_HYSTERESIS", 0600, parent, (u16 *)0xFFC03244);
		debugfs_create_x16("PORTG_MUX", 0600, parent, (u16 *)0xFFC03214);
		debugfs_create_x16("PORTG_SLEW", 0600, parent, (u16 *)0xFFC03234);
		debugfs_create_x16("PORTH_DRIVE", 0600, parent, (u16 *)0xFFC03228);
		debugfs_create_x16("PORTH_HYSTERESIS", 0600, parent, (u16 *)0xFFC03248);
		debugfs_create_x16("PORTH_MUX", 0600, parent, (u16 *)0xFFC03218);
		debugfs_create_x16("PORTH_SLEW", 0600, parent, (u16 *)0xFFC03238);

		parent = debugfs_create_dir("HOST", top);
		debugfs_create_x16("HOST_CONTROL", 0600, parent, (u16 *)0xFFC03400);
		debugfs_create_x16("HOST_STATUS", 0600, parent, (u16 *)0xFFC03404);
		debugfs_create_x16("HOST_TIMEOUT", 0600, parent, (u16 *)0xFFC03408);

		parent = debugfs_create_dir("Handshake MDMA", top);
		debugfs_create_x16("HMDMA0_BCINIT", 0600, parent, (u16 *)0xFFC03308);
		debugfs_create_x16("HMDMA0_BCOUNT", 0600, parent, (u16 *)0xFFC03318);
		debugfs_create_x16("HMDMA0_CONTROL", 0600, parent, (u16 *)0xFFC03300);
		debugfs_create_x16("HMDMA0_ECINIT", 0600, parent, (u16 *)0xFFC03304);
		debugfs_create_x16("HMDMA0_ECOUNT", 0600, parent, (u16 *)0xFFC03314);
		debugfs_create_x16("HMDMA0_ECOVERFLOW", 0600, parent, (u16 *)0xFFC03310);
		debugfs_create_x16("HMDMA0_ECURGENT", 0600, parent, (u16 *)0xFFC0330C);
		debugfs_create_x16("HMDMA1_BCINIT", 0600, parent, (u16 *)0xFFC03348);
		debugfs_create_x16("HMDMA1_BCOUNT", 0600, parent, (u16 *)0xFFC03358);
		debugfs_create_x16("HMDMA1_CONTROL", 0600, parent, (u16 *)0xFFC03340);
		debugfs_create_x16("HMDMA1_ECINIT", 0600, parent, (u16 *)0xFFC03344);
		debugfs_create_x16("HMDMA1_ECOUNT", 0600, parent, (u16 *)0xFFC03354);
		debugfs_create_x16("HMDMA1_ECOVERFLOW", 0600, parent, (u16 *)0xFFC03350);
		debugfs_create_x16("HMDMA1_ECURGENT", 0600, parent, (u16 *)0xFFC0334C);

		parent = debugfs_create_dir("Interrupt Controller", top);
		debugfs_create_x32("ILAT", 0600, parent, (u32 *)0xFFE0210C);
		debugfs_create_x32("IMASK", 0600, parent, (u32 *)0xFFE02104);
		debugfs_create_x32("IPEND", 0600, parent, (u32 *)0xFFE02108);
		debugfs_create_x32("IPRIO", 0600, parent, (u32 *)0xFFE02110);

		parent = debugfs_create_dir("L1 Code Memory Registers", top);
		debugfs_create_x32("ICPLB_ADDR0", 0600, parent, (u32 *)0xFFE01100);
		debugfs_create_x32("ICPLB_ADDR10", 0600, parent, (u32 *)0xFFE01128);
		debugfs_create_x32("ICPLB_ADDR11", 0600, parent, (u32 *)0xFFE0112C);
		debugfs_create_x32("ICPLB_ADDR12", 0600, parent, (u32 *)0xFFE01130);
		debugfs_create_x32("ICPLB_ADDR13", 0600, parent, (u32 *)0xFFE01134);
		debugfs_create_x32("ICPLB_ADDR14", 0600, parent, (u32 *)0xFFE01138);
		debugfs_create_x32("ICPLB_ADDR15", 0600, parent, (u32 *)0xFFE0113C);
		debugfs_create_x32("ICPLB_ADDR1", 0600, parent, (u32 *)0xFFE01104);
		debugfs_create_x32("ICPLB_ADDR2", 0600, parent, (u32 *)0xFFE01108);
		debugfs_create_x32("ICPLB_ADDR3", 0600, parent, (u32 *)0xFFE0110C);
		debugfs_create_x32("ICPLB_ADDR4", 0600, parent, (u32 *)0xFFE01110);
		debugfs_create_x32("ICPLB_ADDR5", 0600, parent, (u32 *)0xFFE01114);
		debugfs_create_x32("ICPLB_ADDR6", 0600, parent, (u32 *)0xFFE01118);
		debugfs_create_x32("ICPLB_ADDR7", 0600, parent, (u32 *)0xFFE0111C);
		debugfs_create_x32("ICPLB_ADDR8", 0600, parent, (u32 *)0xFFE01120);
		debugfs_create_x32("ICPLB_ADDR9", 0600, parent, (u32 *)0xFFE01124);
		debugfs_create_x32("ICPLB_DATA0", 0600, parent, (u32 *)0xFFE01200);
		debugfs_create_x32("ICPLB_DATA10", 0600, parent, (u32 *)0xFFE01228);
		debugfs_create_x32("ICPLB_DATA11", 0600, parent, (u32 *)0xFFE0122C);
		debugfs_create_x32("ICPLB_DATA12", 0600, parent, (u32 *)0xFFE01230);
		debugfs_create_x32("ICPLB_DATA13", 0600, parent, (u32 *)0xFFE01234);
		debugfs_create_x32("ICPLB_DATA14", 0600, parent, (u32 *)0xFFE01238);
		debugfs_create_x32("ICPLB_DATA15", 0600, parent, (u32 *)0xFFE0123C);
		debugfs_create_x32("ICPLB_DATA1", 0600, parent, (u32 *)0xFFE01204);
		debugfs_create_x32("ICPLB_DATA2", 0600, parent, (u32 *)0xFFE01208);
		debugfs_create_x32("ICPLB_DATA3", 0600, parent, (u32 *)0xFFE0120C);
		debugfs_create_x32("ICPLB_DATA4", 0600, parent, (u32 *)0xFFE01210);
		debugfs_create_x32("ICPLB_DATA5", 0600, parent, (u32 *)0xFFE01214);
		debugfs_create_x32("ICPLB_DATA6", 0600, parent, (u32 *)0xFFE01218);
		debugfs_create_x32("ICPLB_DATA7", 0600, parent, (u32 *)0xFFE0121C);
		debugfs_create_x32("ICPLB_DATA8", 0600, parent, (u32 *)0xFFE01220);
		debugfs_create_x32("ICPLB_DATA9", 0600, parent, (u32 *)0xFFE01224);
		debugfs_create_x32("ICPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0100C);
		debugfs_create_x32("ICPLB_STATUS", 0600, parent, (u32 *)0xFFE01008);
		debugfs_create_x32("IMEM_CONTROL", 0600, parent, (u32 *)0xFFE01004);
		debugfs_create_x32("ITEST_COMMAND", 0600, parent, (u32 *)0xFFE01300);
		debugfs_create_x32("ITEST_DATA0", 0600, parent, (u32 *)0xFFE01400);
		debugfs_create_x32("ITEST_DATA1", 0600, parent, (u32 *)0xFFE01404);

		parent = debugfs_create_dir("L1 Data Memory Registers", top);
		debugfs_create_x32("DCPLB_ADDR0", 0600, parent, (u32 *)0xFFE00100);
		debugfs_create_x32("DCPLB_ADDR10", 0600, parent, (u32 *)0xFFE00128);
		debugfs_create_x32("DCPLB_ADDR11", 0600, parent, (u32 *)0xFFE0012C);
		debugfs_create_x32("DCPLB_ADDR12", 0600, parent, (u32 *)0xFFE00130);
		debugfs_create_x32("DCPLB_ADDR13", 0600, parent, (u32 *)0xFFE00134);
		debugfs_create_x32("DCPLB_ADDR14", 0600, parent, (u32 *)0xFFE00138);
		debugfs_create_x32("DCPLB_ADDR15", 0600, parent, (u32 *)0xFFE0013C);
		debugfs_create_x32("DCPLB_ADDR1", 0600, parent, (u32 *)0xFFE00104);
		debugfs_create_x32("DCPLB_ADDR2", 0600, parent, (u32 *)0xFFE00108);
		debugfs_create_x32("DCPLB_ADDR3", 0600, parent, (u32 *)0xFFE0010C);
		debugfs_create_x32("DCPLB_ADDR4", 0600, parent, (u32 *)0xFFE00110);
		debugfs_create_x32("DCPLB_ADDR5", 0600, parent, (u32 *)0xFFE00114);
		debugfs_create_x32("DCPLB_ADDR6", 0600, parent, (u32 *)0xFFE00118);
		debugfs_create_x32("DCPLB_ADDR7", 0600, parent, (u32 *)0xFFE0011C);
		debugfs_create_x32("DCPLB_ADDR8", 0600, parent, (u32 *)0xFFE00120);
		debugfs_create_x32("DCPLB_ADDR9", 0600, parent, (u32 *)0xFFE00124);
		debugfs_create_x32("DCPLB_DATA0", 0600, parent, (u32 *)0xFFE00200);
		debugfs_create_x32("DCPLB_DATA10", 0600, parent, (u32 *)0xFFE00228);
		debugfs_create_x32("DCPLB_DATA11", 0600, parent, (u32 *)0xFFE0022C);
		debugfs_create_x32("DCPLB_DATA12", 0600, parent, (u32 *)0xFFE00230);
		debugfs_create_x32("DCPLB_DATA13", 0600, parent, (u32 *)0xFFE00234);
		debugfs_create_x32("DCPLB_DATA14", 0600, parent, (u32 *)0xFFE00238);
		debugfs_create_x32("DCPLB_DATA15", 0600, parent, (u32 *)0xFFE0023C);
		debugfs_create_x32("DCPLB_DATA1", 0600, parent, (u32 *)0xFFE00204);
		debugfs_create_x32("DCPLB_DATA2", 0600, parent, (u32 *)0xFFE00208);
		debugfs_create_x32("DCPLB_DATA3", 0600, parent, (u32 *)0xFFE0020C);
		debugfs_create_x32("DCPLB_DATA4", 0600, parent, (u32 *)0xFFE00210);
		debugfs_create_x32("DCPLB_DATA5", 0600, parent, (u32 *)0xFFE00214);
		debugfs_create_x32("DCPLB_DATA6", 0600, parent, (u32 *)0xFFE00218);
		debugfs_create_x32("DCPLB_DATA7", 0600, parent, (u32 *)0xFFE0021C);
		debugfs_create_x32("DCPLB_DATA8", 0600, parent, (u32 *)0xFFE00220);
		debugfs_create_x32("DCPLB_DATA9", 0600, parent, (u32 *)0xFFE00224);
		debugfs_create_x32("DCPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0000C);
		debugfs_create_x32("DCPLB_STATUS", 0600, parent, (u32 *)0xFFE00008);
		debugfs_create_x32("DMEM_CONTROL", 0600, parent, (u32 *)0xFFE00004);
		debugfs_create_x32("DTEST_COMMAND", 0600, parent, (u32 *)0xFFE00300);
		debugfs_create_x32("DTEST_DATA0", 0600, parent, (u32 *)0xFFE00400);
		debugfs_create_x32("DTEST_DATA1", 0600, parent, (u32 *)0xFFE00404);
		debugfs_create_x32("SRAM_BASE_ADDR", 0600, parent, (u32 *)0xFFE00000);

		parent = debugfs_create_dir("MDMA Destination 0", top);
		debugfs_create_x16("MDMA_D0_CONFIG", 0600, parent, (u16 *)0xFFC00F08);
		debugfs_create_x32("MDMA_D0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F24);
		debugfs_create_x32("MDMA_D0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F20);
		debugfs_create_x16("MDMA_D0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F30);
		debugfs_create_x16("MDMA_D0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F38);
		debugfs_create_x16("MDMA_D0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F28);
		debugfs_create_x32("MDMA_D0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F00);
		debugfs_create_x16("MDMA_D0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F2C);
		debugfs_create_x32("MDMA_D0_START_ADDR", 0600, parent, (u32 *)0xFFC00F04);
		debugfs_create_x16("MDMA_D0_X_COUNT", 0600, parent, (u16 *)0xFFC00F10);
		debugfs_create_x16("MDMA_D0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F14);
		debugfs_create_x16("MDMA_D0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F18);
		debugfs_create_x16("MDMA_D0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F1C);

		parent = debugfs_create_dir("MDMA Destination 1", top);
		debugfs_create_x16("MDMA_D1_CONFIG", 0600, parent, (u16 *)0xFFC00F88);
		debugfs_create_x32("MDMA_D1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FA4);
		debugfs_create_x32("MDMA_D1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FA0);
		debugfs_create_x16("MDMA_D1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FB0);
		debugfs_create_x16("MDMA_D1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FB8);
		debugfs_create_x16("MDMA_D1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FA8);
		debugfs_create_x32("MDMA_D1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F80);
		debugfs_create_x16("MDMA_D1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FAC);
		debugfs_create_x32("MDMA_D1_START_ADDR", 0600, parent, (u32 *)0xFFC00F84);
		debugfs_create_x16("MDMA_D1_X_COUNT", 0600, parent, (u16 *)0xFFC00F90);
		debugfs_create_x16("MDMA_D1_X_MODIFY", 0600, parent, (u16 *)0xFFC00F94);
		debugfs_create_x16("MDMA_D1_Y_COUNT", 0600, parent, (u16 *)0xFFC00F98);
		debugfs_create_x16("MDMA_D1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F9C);

		parent = debugfs_create_dir("MDMA Source 0", top);
		debugfs_create_x16("MDMA_S0_CONFIG", 0600, parent, (u16 *)0xFFC00F48);
		debugfs_create_x32("MDMA_S0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F64);
		debugfs_create_x32("MDMA_S0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F60);
		debugfs_create_x16("MDMA_S0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F70);
		debugfs_create_x16("MDMA_S0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F78);
		debugfs_create_x16("MDMA_S0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F68);
		debugfs_create_x32("MDMA_S0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F40);
		debugfs_create_x16("MDMA_S0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F6C);
		debugfs_create_x32("MDMA_S0_START_ADDR", 0600, parent, (u32 *)0xFFC00F44);
		debugfs_create_x16("MDMA_S0_X_COUNT", 0600, parent, (u16 *)0xFFC00F50);
		debugfs_create_x16("MDMA_S0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F54);
		debugfs_create_x16("MDMA_S0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F58);
		debugfs_create_x16("MDMA_S0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F5C);

		parent = debugfs_create_dir("MDMA Source 1", top);
		debugfs_create_x16("MDMA_S1_CONFIG", 0600, parent, (u16 *)0xFFC00FC8);
		debugfs_create_x32("MDMA_S1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FE4);
		debugfs_create_x32("MDMA_S1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FE0);
		debugfs_create_x16("MDMA_S1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FF0);
		debugfs_create_x16("MDMA_S1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FF8);
		debugfs_create_x16("MDMA_S1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FE8);
		debugfs_create_x32("MDMA_S1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00FC0);
		debugfs_create_x16("MDMA_S1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FEC);
		debugfs_create_x32("MDMA_S1_START_ADDR", 0600, parent, (u32 *)0xFFC00FC4);
		debugfs_create_x16("MDMA_S1_X_COUNT", 0600, parent, (u16 *)0xFFC00FD0);
		debugfs_create_x16("MDMA_S1_X_MODIFY", 0600, parent, (u16 *)0xFFC00FD4);
		debugfs_create_x16("MDMA_S1_Y_COUNT", 0600, parent, (u16 *)0xFFC00FD8);
		debugfs_create_x16("MDMA_S1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00FDC);

		parent = debugfs_create_dir("NFC", top);
		debugfs_create_x16("NFC_ADDR", 0600, parent, (u16 *)0xFFC03740);
		debugfs_create_x16("NFC_CMD", 0600, parent, (u16 *)0xFFC03744);
		debugfs_create_x16("NFC_COUNT", 0600, parent, (u16 *)0xFFC03720);
		debugfs_create_x16("NFC_CTL", 0600, parent, (u16 *)0xFFC03700);
		debugfs_create_x16("NFC_DATA_RD", 0600, parent, (u16 *)0xFFC0374C);
		debugfs_create_x16("NFC_DATA_WR", 0600, parent, (u16 *)0xFFC03748);
		debugfs_create_x16("NFC_ECC0", 0600, parent, (u16 *)0xFFC03710);
		debugfs_create_x16("NFC_ECC1", 0600, parent, (u16 *)0xFFC03714);
		debugfs_create_x16("NFC_ECC2", 0600, parent, (u16 *)0xFFC03718);
		debugfs_create_x16("NFC_ECC3", 0600, parent, (u16 *)0xFFC0371C);
		debugfs_create_x16("NFC_IRQMASK", 0600, parent, (u16 *)0xFFC0370C);
		debugfs_create_x16("NFC_IRQSTAT", 0600, parent, (u16 *)0xFFC03708);
		debugfs_create_x16("NFC_PGCTL", 0600, parent, (u16 *)0xFFC03728);
		debugfs_create_x16("NFC_READ", 0600, parent, (u16 *)0xFFC0372C);
		debugfs_create_x16("NFC_RST", 0600, parent, (u16 *)0xFFC03724);
		debugfs_create_x16("NFC_STAT", 0600, parent, (u16 *)0xFFC03704);

		parent = debugfs_create_dir("NON-GPIO", top);
		debugfs_create_x16("NONGPIO_DRIVE", 0600, parent, (u16 *)0xFFC03280);
		debugfs_create_x16("NONGPIO_HYSTERESIS", 0600, parent, (u16 *)0xFFC03288);
		debugfs_create_x16("NONGPIO_SLEW", 0600, parent, (u16 *)0xFFC03284);

		parent = debugfs_create_dir("OTP", top);
		debugfs_create_x16("OTP_BEN", 0600, parent, (u16 *)0xFFC03604);
		debugfs_create_x16("OTP_CONTROL", 0600, parent, (u16 *)0xFFC03600);
		debugfs_create_x32("OTP_DATA0", 0600, parent, (u32 *)0xFFC03680);
		debugfs_create_x32("OTP_DATA1", 0600, parent, (u32 *)0xFFC03684);
		debugfs_create_x32("OTP_DATA2", 0600, parent, (u32 *)0xFFC03688);
		debugfs_create_x32("OTP_DATA3", 0600, parent, (u32 *)0xFFC0368C);
		debugfs_create_x16("OTP_STATUS", 0600, parent, (u16 *)0xFFC03608);
		debugfs_create_x32("OTP_TIMING", 0600, parent, (u32 *)0xFFC0360C);

		parent = debugfs_create_dir("PLL", top);
		debugfs_create_x16("PLL_CTL", 0600, parent, (u16 *)0xFFC00000);
		debugfs_create_x16("PLL_DIV", 0600, parent, (u16 *)0xFFC00004);
		debugfs_create_x16("PLL_LOCKCNT", 0600, parent, (u16 *)0xFFC00010);
		debugfs_create_x16("PLL_STAT", 0600, parent, (u16 *)0xFFC0000C);
		debugfs_create_x16("VR_CTL", 0600, parent, (u16 *)0xFFC00008);

		parent = debugfs_create_dir("PPI", top);
		debugfs_create_x16("PPI_CONTROL", 0600, parent, (u16 *)0xFFC01000);
		debugfs_create_x16("PPI_COUNT", 0600, parent, (u16 *)0xFFC01008);
		debugfs_create_x16("PPI_DELAY", 0600, parent, (u16 *)0xFFC0100C);
		debugfs_create_x16("PPI_FRAME", 0600, parent, (u16 *)0xFFC01010);
		debugfs_create_x16("PPI_STATUS", 0600, parent, (u16 *)0xFFC01004);

		parent = debugfs_create_dir("Performance Monitor", top);
		debugfs_create_x32("PFCNTR0", 0600, parent, (u32 *)0xFFE08100);
		debugfs_create_x32("PFCNTR1", 0600, parent, (u32 *)0xFFE08104);
		debugfs_create_x32("PFCTL", 0600, parent, (u32 *)0xFFE08000);

		parent = debugfs_create_dir("Pin Control", top);
		debugfs_create_x16("PORTF_FER", 0600, parent, (u16 *)0xFFC03200);
		debugfs_create_x16("PORTG_FER", 0600, parent, (u16 *)0xFFC03204);
		debugfs_create_x16("PORTH_FER", 0600, parent, (u16 *)0xFFC03208);

		parent = debugfs_create_dir("Port I-O", top);
		debugfs_create_x16("PORTFIO", 0600, parent, (u16 *)0xFFC00700);
		debugfs_create_x16("PORTFIO_BOTH", 0600, parent, (u16 *)0xFFC0073C);
		debugfs_create_x16("PORTFIO_CLEAR", 0600, parent, (u16 *)0xFFC00704);
		debugfs_create_x16("PORTFIO_DIR", 0600, parent, (u16 *)0xFFC00730);
		debugfs_create_x16("PORTFIO_EDGE", 0600, parent, (u16 *)0xFFC00738);
		debugfs_create_x16("PORTFIO_INEN", 0600, parent, (u16 *)0xFFC00740);
		debugfs_create_x16("PORTFIO_MASKA", 0600, parent, (u16 *)0xFFC00710);
		debugfs_create_x16("PORTFIO_MASKA_CLEAR", 0600, parent, (u16 *)0xFFC00714);
		debugfs_create_x16("PORTFIO_MASKA_SET", 0600, parent, (u16 *)0xFFC00718);
		debugfs_create_x16("PORTFIO_MASKA_TOGGLE", 0600, parent, (u16 *)0xFFC0071C);
		debugfs_create_x16("PORTFIO_MASKB", 0600, parent, (u16 *)0xFFC00720);
		debugfs_create_x16("PORTFIO_MASKB_CLEAR", 0600, parent, (u16 *)0xFFC00724);
		debugfs_create_x16("PORTFIO_MASKB_SET", 0600, parent, (u16 *)0xFFC00728);
		debugfs_create_x16("PORTFIO_MASKB_TOGGLE", 0600, parent, (u16 *)0xFFC0072C);
		debugfs_create_x16("PORTFIO_POLAR", 0600, parent, (u16 *)0xFFC00734);
		debugfs_create_x16("PORTFIO_SET", 0600, parent, (u16 *)0xFFC00708);
		debugfs_create_x16("PORTFIO_TOGGLE", 0600, parent, (u16 *)0xFFC0070C);
		debugfs_create_x16("PORTGIO", 0600, parent, (u16 *)0xFFC01500);
		debugfs_create_x16("PORTGIO_BOTH", 0600, parent, (u16 *)0xFFC0153C);
		debugfs_create_x16("PORTGIO_CLEAR", 0600, parent, (u16 *)0xFFC01504);
		debugfs_create_x16("PORTGIO_DIR", 0600, parent, (u16 *)0xFFC01530);
		debugfs_create_x16("PORTGIO_EDGE", 0600, parent, (u16 *)0xFFC01538);
		debugfs_create_x16("PORTGIO_INEN", 0600, parent, (u16 *)0xFFC01540);
		debugfs_create_x16("PORTGIO_MASKA", 0600, parent, (u16 *)0xFFC01510);
		debugfs_create_x16("PORTGIO_MASKA_CLEAR", 0600, parent, (u16 *)0xFFC01514);
		debugfs_create_x16("PORTGIO_MASKA_SET", 0600, parent, (u16 *)0xFFC01518);
		debugfs_create_x16("PORTGIO_MASKA_TOGGLE", 0600, parent, (u16 *)0xFFC0151C);
		debugfs_create_x16("PORTGIO_MASKB", 0600, parent, (u16 *)0xFFC01520);
		debugfs_create_x16("PORTGIO_MASKB_CLEAR", 0600, parent, (u16 *)0xFFC01524);
		debugfs_create_x16("PORTGIO_MASKB_SET", 0600, parent, (u16 *)0xFFC01528);
		debugfs_create_x16("PORTGIO_MASKB_TOGGLE", 0600, parent, (u16 *)0xFFC0152C);
		debugfs_create_x16("PORTGIO_POLAR", 0600, parent, (u16 *)0xFFC01534);
		debugfs_create_x16("PORTGIO_SET", 0600, parent, (u16 *)0xFFC01508);
		debugfs_create_x16("PORTGIO_TOGGLE", 0600, parent, (u16 *)0xFFC0150C);
		debugfs_create_x16("PORTHIO", 0600, parent, (u16 *)0xFFC01700);
		debugfs_create_x16("PORTHIO_BOTH", 0600, parent, (u16 *)0xFFC0173C);
		debugfs_create_x16("PORTHIO_CLEAR", 0600, parent, (u16 *)0xFFC01704);
		debugfs_create_x16("PORTHIO_DIR", 0600, parent, (u16 *)0xFFC01730);
		debugfs_create_x16("PORTHIO_EDGE", 0600, parent, (u16 *)0xFFC01738);
		debugfs_create_x16("PORTHIO_INEN", 0600, parent, (u16 *)0xFFC01740);
		debugfs_create_x16("PORTHIO_MASKA", 0600, parent, (u16 *)0xFFC01710);
		debugfs_create_x16("PORTHIO_MASKA_CLEAR", 0600, parent, (u16 *)0xFFC01714);
		debugfs_create_x16("PORTHIO_MASKA_SET", 0600, parent, (u16 *)0xFFC01718);
		debugfs_create_x16("PORTHIO_MASKA_TOGGLE", 0600, parent, (u16 *)0xFFC0171C);
		debugfs_create_x16("PORTHIO_MASKB", 0600, parent, (u16 *)0xFFC01720);
		debugfs_create_x16("PORTHIO_MASKB_CLEAR", 0600, parent, (u16 *)0xFFC01724);
		debugfs_create_x16("PORTHIO_MASKB_SET", 0600, parent, (u16 *)0xFFC01728);
		debugfs_create_x16("PORTHIO_MASKB_TOGGLE", 0600, parent, (u16 *)0xFFC0172C);
		debugfs_create_x16("PORTHIO_POLAR", 0600, parent, (u16 *)0xFFC01734);
		debugfs_create_x16("PORTHIO_SET", 0600, parent, (u16 *)0xFFC01708);
		debugfs_create_x16("PORTHIO_TOGGLE", 0600, parent, (u16 *)0xFFC0170C);

		parent = debugfs_create_dir("RTC", top);
		debugfs_create_x32("RTC_ALARM", 0600, parent, (u32 *)0xFFC00310);
		debugfs_create_x16("RTC_ICTL", 0600, parent, (u16 *)0xFFC00304);
		debugfs_create_x16("RTC_ISTAT", 0600, parent, (u16 *)0xFFC00308);
		debugfs_create_x16("RTC_PREN", 0600, parent, (u16 *)0xFFC00314);
		debugfs_create_x32("RTC_STAT", 0600, parent, (u32 *)0xFFC00300);
		debugfs_create_x16("RTC_SWCNT", 0600, parent, (u16 *)0xFFC0030C);

		parent = debugfs_create_dir("SPI", top);
		debugfs_create_x16("SPI_BAUD", 0600, parent, (u16 *)0xFFC00514);
		debugfs_create_x16("SPI_CTL", 0600, parent, (u16 *)0xFFC00500);
		debugfs_create_x16("SPI_FLG", 0600, parent, (u16 *)0xFFC00504);
		debugfs_create_x16("SPI_RDBR", 0600, parent, (u16 *)0xFFC00510);
		debugfs_create_x16("SPI_SHADOW", 0600, parent, (u16 *)0xFFC00518);
		debugfs_create_x16("SPI_STAT", 0600, parent, (u16 *)0xFFC00508);
		debugfs_create_x16("SPI_TDBR", 0600, parent, (u16 *)0xFFC0050C);

		parent = debugfs_create_dir("SPORT", top);
		debugfs_create_x16("SPORT0_CHNL", 0600, parent, (u16 *)0xFFC00834);
		debugfs_create_x16("SPORT0_MCMC1", 0600, parent, (u16 *)0xFFC00838);
		debugfs_create_x16("SPORT0_MCMC2", 0600, parent, (u16 *)0xFFC0083C);
		debugfs_create_x32("SPORT0_MRCS0", 0600, parent, (u32 *)0xFFC00850);
		debugfs_create_x32("SPORT0_MRCS1", 0600, parent, (u32 *)0xFFC00854);
		debugfs_create_x32("SPORT0_MRCS2", 0600, parent, (u32 *)0xFFC00858);
		debugfs_create_x32("SPORT0_MRCS3", 0600, parent, (u32 *)0xFFC0085C);
		debugfs_create_x32("SPORT0_MTCS0", 0600, parent, (u32 *)0xFFC00840);
		debugfs_create_x32("SPORT0_MTCS1", 0600, parent, (u32 *)0xFFC00844);
		debugfs_create_x32("SPORT0_MTCS2", 0600, parent, (u32 *)0xFFC00848);
		debugfs_create_x32("SPORT0_MTCS3", 0600, parent, (u32 *)0xFFC0084C);
		debugfs_create_x16("SPORT0_RCLKDIV", 0600, parent, (u16 *)0xFFC00828);
		debugfs_create_x16("SPORT0_RCR1", 0600, parent, (u16 *)0xFFC00820);
		debugfs_create_x16("SPORT0_RCR2", 0600, parent, (u16 *)0xFFC00824);
		debugfs_create_x16("SPORT0_RFSDIV", 0600, parent, (u16 *)0xFFC0082C);
		debugfs_create_x32("SPORT0_RX", 0600, parent, (u32 *)0xFFC00818);
		debugfs_create_x16("SPORT0_STAT", 0600, parent, (u16 *)0xFFC00830);
		debugfs_create_x16("SPORT0_TCLKDIV", 0600, parent, (u16 *)0xFFC00808);
		debugfs_create_x16("SPORT0_TCR1", 0600, parent, (u16 *)0xFFC00800);
		debugfs_create_x16("SPORT0_TCR2", 0600, parent, (u16 *)0xFFC00804);
		debugfs_create_x16("SPORT0_TFSDIV", 0600, parent, (u16 *)0xFFC0080C);
		debugfs_create_x32("SPORT0_TX", 0600, parent, (u32 *)0xFFC00810);
		debugfs_create_x16("SPORT1_CHNL", 0600, parent, (u16 *)0xFFC00934);
		debugfs_create_x16("SPORT1_MCMC1", 0600, parent, (u16 *)0xFFC00938);
		debugfs_create_x16("SPORT1_MCMC2", 0600, parent, (u16 *)0xFFC0093C);
		debugfs_create_x32("SPORT1_MRCS0", 0600, parent, (u32 *)0xFFC00950);
		debugfs_create_x32("SPORT1_MRCS1", 0600, parent, (u32 *)0xFFC00954);
		debugfs_create_x32("SPORT1_MRCS2", 0600, parent, (u32 *)0xFFC00958);
		debugfs_create_x32("SPORT1_MRCS3", 0600, parent, (u32 *)0xFFC0095C);
		debugfs_create_x32("SPORT1_MTCS0", 0600, parent, (u32 *)0xFFC00940);
		debugfs_create_x32("SPORT1_MTCS1", 0600, parent, (u32 *)0xFFC00944);
		debugfs_create_x32("SPORT1_MTCS2", 0600, parent, (u32 *)0xFFC00948);
		debugfs_create_x32("SPORT1_MTCS3", 0600, parent, (u32 *)0xFFC0094C);
		debugfs_create_x16("SPORT1_RCLKDIV", 0600, parent, (u16 *)0xFFC00928);
		debugfs_create_x16("SPORT1_RCR1", 0600, parent, (u16 *)0xFFC00920);
		debugfs_create_x16("SPORT1_RCR2", 0600, parent, (u16 *)0xFFC00924);
		debugfs_create_x16("SPORT1_RFSDIV", 0600, parent, (u16 *)0xFFC0092C);
		debugfs_create_x32("SPORT1_RX", 0600, parent, (u32 *)0xFFC00918);
		debugfs_create_x16("SPORT1_STAT", 0600, parent, (u16 *)0xFFC00930);
		debugfs_create_x16("SPORT1_TCLKDIV", 0600, parent, (u16 *)0xFFC00908);
		debugfs_create_x16("SPORT1_TCR1", 0600, parent, (u16 *)0xFFC00900);
		debugfs_create_x16("SPORT1_TCR2", 0600, parent, (u16 *)0xFFC00904);
		debugfs_create_x16("SPORT1_TFSDIV", 0600, parent, (u16 *)0xFFC0090C);
		debugfs_create_x32("SPORT1_TX", 0600, parent, (u32 *)0xFFC00910);

		parent = debugfs_create_dir("Security", top);
		debugfs_create_x16("SECURE_CONTROL", 0600, parent, (u16 *)0xFFC03624);
		debugfs_create_x16("SECURE_STATUS", 0600, parent, (u16 *)0xFFC03628);
		debugfs_create_x32("SECURE_SYSSWT", 0600, parent, (u32 *)0xFFC03620);

		parent = debugfs_create_dir("System Interrupt Controller Register File", top);
		debugfs_create_x32("SIC_IAR0", 0600, parent, (u32 *)0xFFC00110);
		debugfs_create_x32("SIC_IAR1", 0600, parent, (u32 *)0xFFC00114);
		debugfs_create_x32("SIC_IAR2", 0600, parent, (u32 *)0xFFC00118);
		debugfs_create_x32("SIC_IAR3", 0600, parent, (u32 *)0xFFC0011C);
		debugfs_create_x32("SIC_IAR4", 0600, parent, (u32 *)0xFFC00150);
		debugfs_create_x32("SIC_IAR5", 0600, parent, (u32 *)0xFFC00154);
		debugfs_create_x32("SIC_IAR6", 0600, parent, (u32 *)0xFFC00158);
		debugfs_create_x32("SIC_IAR7", 0600, parent, (u32 *)0xFFC0015C);
		debugfs_create_x32("SIC_IMASK0", 0600, parent, (u32 *)0xFFC0010C);
		debugfs_create_x32("SIC_IMASK1", 0600, parent, (u32 *)0xFFC0014C);
		debugfs_create_x32("SIC_ISR0", 0600, parent, (u32 *)0xFFC00120);
		debugfs_create_x32("SIC_ISR1", 0600, parent, (u32 *)0xFFC00160);
		debugfs_create_x32("SIC_IWR0", 0600, parent, (u32 *)0xFFC00124);
		debugfs_create_x32("SIC_IWR1", 0600, parent, (u32 *)0xFFC00164);
		debugfs_create_x32("SIC_RVECT", 0600, parent, (u32 *)0xFFC00108);

		parent = debugfs_create_dir("System Reset and Interrupt Control Registers", top);
		debugfs_create_x16("SWRST", 0600, parent, (u16 *)0xFFC00100);
		debugfs_create_x16("SYSCR", 0600, parent, (u16 *)0xFFC00104);

		parent = debugfs_create_dir("TWI", top);
		debugfs_create_x16("TWI_CLKDIV", 0600, parent, (u16 *)0xFFC01400);
		debugfs_create_x16("TWI_CONTROL", 0600, parent, (u16 *)0xFFC01404);
		debugfs_create_x16("TWI_FIFO_CTL", 0600, parent, (u16 *)0xFFC01428);
		debugfs_create_x16("TWI_FIFO_STAT", 0600, parent, (u16 *)0xFFC0142C);
		debugfs_create_x16("TWI_INT_MASK", 0600, parent, (u16 *)0xFFC01424);
		debugfs_create_x16("TWI_INT_STAT", 0600, parent, (u16 *)0xFFC01420);
		debugfs_create_x16("TWI_MASTER_ADDR", 0600, parent, (u16 *)0xFFC0141C);
		debugfs_create_x16("TWI_MASTER_CTL", 0600, parent, (u16 *)0xFFC01414);
		debugfs_create_x16("TWI_MASTER_STAT", 0600, parent, (u16 *)0xFFC01418);
		debugfs_create_x16("TWI_RCV_DATA16", 0600, parent, (u16 *)0xFFC0148C);
		debugfs_create_x16("TWI_RCV_DATA8", 0600, parent, (u16 *)0xFFC01488);
		debugfs_create_x16("TWI_SLAVE_ADDR", 0600, parent, (u16 *)0xFFC01410);
		debugfs_create_x16("TWI_SLAVE_CTL", 0600, parent, (u16 *)0xFFC01408);
		debugfs_create_x16("TWI_SLAVE_STAT", 0600, parent, (u16 *)0xFFC0140C);
		debugfs_create_x16("TWI_XMT_DATA16", 0600, parent, (u16 *)0xFFC01484);
		debugfs_create_x16("TWI_XMT_DATA8", 0600, parent, (u16 *)0xFFC01480);

		parent = debugfs_create_dir("Timer Registers", top);
		debugfs_create_x16("TIMER0_CONFIG", 0600, parent, (u16 *)0xFFC00600);
		debugfs_create_x32("TIMER0_COUNTER", 0600, parent, (u32 *)0xFFC00604);
		debugfs_create_x32("TIMER0_PERIOD", 0600, parent, (u32 *)0xFFC00608);
		debugfs_create_x32("TIMER0_WIDTH", 0600, parent, (u32 *)0xFFC0060C);
		debugfs_create_x16("TIMER1_CONFIG", 0600, parent, (u16 *)0xFFC00610);
		debugfs_create_x32("TIMER1_COUNTER", 0600, parent, (u32 *)0xFFC00614);
		debugfs_create_x32("TIMER1_PERIOD", 0600, parent, (u32 *)0xFFC00618);
		debugfs_create_x32("TIMER1_WIDTH", 0600, parent, (u32 *)0xFFC0061C);
		debugfs_create_x16("TIMER2_CONFIG", 0600, parent, (u16 *)0xFFC00620);
		debugfs_create_x32("TIMER2_COUNTER", 0600, parent, (u32 *)0xFFC00624);
		debugfs_create_x32("TIMER2_PERIOD", 0600, parent, (u32 *)0xFFC00628);
		debugfs_create_x32("TIMER2_WIDTH", 0600, parent, (u32 *)0xFFC0062C);
		debugfs_create_x16("TIMER3_CONFIG", 0600, parent, (u16 *)0xFFC00630);
		debugfs_create_x32("TIMER3_COUNTER", 0600, parent, (u32 *)0xFFC00634);
		debugfs_create_x32("TIMER3_PERIOD", 0600, parent, (u32 *)0xFFC00638);
		debugfs_create_x32("TIMER3_WIDTH", 0600, parent, (u32 *)0xFFC0063C);
		debugfs_create_x16("TIMER4_CONFIG", 0600, parent, (u16 *)0xFFC00640);
		debugfs_create_x32("TIMER4_COUNTER", 0600, parent, (u32 *)0xFFC00644);
		debugfs_create_x32("TIMER4_PERIOD", 0600, parent, (u32 *)0xFFC00648);
		debugfs_create_x32("TIMER4_WIDTH", 0600, parent, (u32 *)0xFFC0064C);
		debugfs_create_x16("TIMER5_CONFIG", 0600, parent, (u16 *)0xFFC00650);
		debugfs_create_x32("TIMER5_COUNTER", 0600, parent, (u32 *)0xFFC00654);
		debugfs_create_x32("TIMER5_PERIOD", 0600, parent, (u32 *)0xFFC00658);
		debugfs_create_x32("TIMER5_WIDTH", 0600, parent, (u32 *)0xFFC0065C);
		debugfs_create_x16("TIMER6_CONFIG", 0600, parent, (u16 *)0xFFC00660);
		debugfs_create_x32("TIMER6_COUNTER", 0600, parent, (u32 *)0xFFC00664);
		debugfs_create_x32("TIMER6_PERIOD", 0600, parent, (u32 *)0xFFC00668);
		debugfs_create_x32("TIMER6_WIDTH", 0600, parent, (u32 *)0xFFC0066C);
		debugfs_create_x16("TIMER7_CONFIG", 0600, parent, (u16 *)0xFFC00670);
		debugfs_create_x32("TIMER7_COUNTER", 0600, parent, (u32 *)0xFFC00674);
		debugfs_create_x32("TIMER7_PERIOD", 0600, parent, (u32 *)0xFFC00678);
		debugfs_create_x32("TIMER7_WIDTH", 0600, parent, (u32 *)0xFFC0067C);
		debugfs_create_x16("TIMER_DISABLE", 0600, parent, (u16 *)0xFFC00684);
		debugfs_create_x16("TIMER_ENABLE", 0600, parent, (u16 *)0xFFC00680);
		debugfs_create_x32("TIMER_STATUS", 0600, parent, (u32 *)0xFFC00688);

		parent = debugfs_create_dir("Trace Unit", top);
		debugfs_create_x32("TBUF", 0600, parent, (u32 *)0xFFE06100);
		debugfs_create_x32("TBUFCTL", 0600, parent, (u32 *)0xFFE06000);
		debugfs_create_x32("TBUFSTAT", 0600, parent, (u32 *)0xFFE06004);

		parent = debugfs_create_dir("UART", top);
		debugfs_create_x16("UART0_DLH", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART0_DLL", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART0_GCTL", 0600, parent, (u16 *)0xFFC00424);
		debugfs_create_x16("UART0_IER", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART0_IIR", 0600, parent, (u16 *)0xFFC00408);
		debugfs_create_x16("UART0_LCR", 0600, parent, (u16 *)0xFFC0040C);
		debugfs_create_x16("UART0_LSR", 0600, parent, (u16 *)0xFFC00414);
		debugfs_create_x16("UART0_MCR", 0600, parent, (u16 *)0xFFC00410);
		debugfs_create_x16("UART0_MSR", 0600, parent, (u16 *)0xFFC00418);
		debugfs_create_x16("UART0_RBR", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART0_SCR", 0600, parent, (u16 *)0xFFC0041C);
		debugfs_create_x16("UART0_THR", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART1_DLH", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("UART1_DLL", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART1_GCTL", 0600, parent, (u16 *)0xFFC02024);
		debugfs_create_x16("UART1_IER", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("UART1_IIR", 0600, parent, (u16 *)0xFFC02008);
		debugfs_create_x16("UART1_LCR", 0600, parent, (u16 *)0xFFC0200C);
		debugfs_create_x16("UART1_LSR", 0600, parent, (u16 *)0xFFC02014);
		debugfs_create_x16("UART1_MCR", 0600, parent, (u16 *)0xFFC02010);
		debugfs_create_x16("UART1_MSR", 0600, parent, (u16 *)0xFFC02018);
		debugfs_create_x16("UART1_RBR", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART1_SCR", 0600, parent, (u16 *)0xFFC0201C);
		debugfs_create_x16("UART1_THR", 0600, parent, (u16 *)0xFFC02000);

		parent = debugfs_create_dir("USB", top);
		debugfs_create_x16("USB_APHY_CALIB", 0600, parent, (u16 *)0xFFC039E4);
		debugfs_create_x16("USB_APHY_CNTRL2", 0600, parent, (u16 *)0xFFC039E8);
		debugfs_create_x16("USB_APHY_CNTRL", 0600, parent, (u16 *)0xFFC039E0);
		debugfs_create_x16("USB_COUNT0", 0600, parent, (u16 *)0xFFC03850);
		debugfs_create_x16("USB_CSR0", 0600, parent, (u16 *)0xFFC03844);
		debugfs_create_x16("USB_DMA0_ADDRHIGH", 0600, parent, (u16 *)0xFFC03C0C);
		debugfs_create_x16("USB_DMA0_ADDRLOW", 0600, parent, (u16 *)0xFFC03C08);
		debugfs_create_x16("USB_DMA0_CONTROL", 0600, parent, (u16 *)0xFFC03C04);
		debugfs_create_x16("USB_DMA0_COUNTHIGH", 0600, parent, (u16 *)0xFFC03C14);
		debugfs_create_x16("USB_DMA0_COUNTLOW", 0600, parent, (u16 *)0xFFC03C10);
		debugfs_create_x16("USB_DMA1_ADDRHIGH", 0600, parent, (u16 *)0xFFC03C2C);
		debugfs_create_x16("USB_DMA1_ADDRLOW", 0600, parent, (u16 *)0xFFC03C28);
		debugfs_create_x16("USB_DMA1_CONTROL", 0600, parent, (u16 *)0xFFC03C24);
		debugfs_create_x16("USB_DMA1_COUNTHIGH", 0600, parent, (u16 *)0xFFC03C34);
		debugfs_create_x16("USB_DMA1_COUNTLOW", 0600, parent, (u16 *)0xFFC03C30);
		debugfs_create_x16("USB_DMA2_ADDRHIGH", 0600, parent, (u16 *)0xFFC03C4C);
		debugfs_create_x16("USB_DMA2_ADDRLOW", 0600, parent, (u16 *)0xFFC03C48);
		debugfs_create_x16("USB_DMA2_CONTROL", 0600, parent, (u16 *)0xFFC03C44);
		debugfs_create_x16("USB_DMA2_COUNTHIGH", 0600, parent, (u16 *)0xFFC03C54);
		debugfs_create_x16("USB_DMA2_COUNTLOW", 0600, parent, (u16 *)0xFFC03C50);
		debugfs_create_x16("USB_DMA3_ADDRHIGH", 0600, parent, (u16 *)0xFFC03C6C);
		debugfs_create_x16("USB_DMA3_ADDRLOW", 0600, parent, (u16 *)0xFFC03C68);
		debugfs_create_x16("USB_DMA3_CONTROL", 0600, parent, (u16 *)0xFFC03C64);
		debugfs_create_x16("USB_DMA3_COUNTHIGH", 0600, parent, (u16 *)0xFFC03C74);
		debugfs_create_x16("USB_DMA3_COUNTLOW", 0600, parent, (u16 *)0xFFC03C70);
		debugfs_create_x16("USB_DMA4_ADDRHIGH", 0600, parent, (u16 *)0xFFC03C8C);
		debugfs_create_x16("USB_DMA4_ADDRLOW", 0600, parent, (u16 *)0xFFC03C88);
		debugfs_create_x16("USB_DMA4_CONTROL", 0600, parent, (u16 *)0xFFC03C84);
		debugfs_create_x16("USB_DMA4_COUNTHIGH", 0600, parent, (u16 *)0xFFC03C94);
		debugfs_create_x16("USB_DMA4_COUNTLOW", 0600, parent, (u16 *)0xFFC03C90);
		debugfs_create_x16("USB_DMA5_ADDRHIGH", 0600, parent, (u16 *)0xFFC03CAC);
		debugfs_create_x16("USB_DMA5_ADDRLOW", 0600, parent, (u16 *)0xFFC03CA8);
		debugfs_create_x16("USB_DMA5_CONTROL", 0600, parent, (u16 *)0xFFC03CA4);
		debugfs_create_x16("USB_DMA5_COUNTHIGH", 0600, parent, (u16 *)0xFFC03CB4);
		debugfs_create_x16("USB_DMA5_COUNTLOW", 0600, parent, (u16 *)0xFFC03CB0);
		debugfs_create_x16("USB_DMA6_ADDRHIGH", 0600, parent, (u16 *)0xFFC03CCC);
		debugfs_create_x16("USB_DMA6_ADDRLOW", 0600, parent, (u16 *)0xFFC03CC8);
		debugfs_create_x16("USB_DMA6_CONTROL", 0600, parent, (u16 *)0xFFC03CC4);
		debugfs_create_x16("USB_DMA6_COUNTHIGH", 0600, parent, (u16 *)0xFFC03CD4);
		debugfs_create_x16("USB_DMA6_COUNTLOW", 0600, parent, (u16 *)0xFFC03CD0);
		debugfs_create_x16("USB_DMA7_ADDRHIGH", 0600, parent, (u16 *)0xFFC03CEC);
		debugfs_create_x16("USB_DMA7_ADDRLOW", 0600, parent, (u16 *)0xFFC03CE8);
		debugfs_create_x16("USB_DMA7_CONTROL", 0600, parent, (u16 *)0xFFC03CE4);
		debugfs_create_x16("USB_DMA7_COUNTHIGH", 0600, parent, (u16 *)0xFFC03CF4);
		debugfs_create_x16("USB_DMA7_COUNTLOW", 0600, parent, (u16 *)0xFFC03CF0);
		debugfs_create_x16("USB_DMA_INTERRUPT", 0600, parent, (u16 *)0xFFC03C00);
		debugfs_create_x16("USB_EP0_FIFO", 0600, parent, (u16 *)0xFFC03880);
		debugfs_create_x16("USB_EP1_FIFO", 0600, parent, (u16 *)0xFFC03888);
		debugfs_create_x16("USB_EP2_FIFO", 0600, parent, (u16 *)0xFFC03890);
		debugfs_create_x16("USB_EP3_FIFO", 0600, parent, (u16 *)0xFFC03898);
		debugfs_create_x16("USB_EP4_FIFO", 0600, parent, (u16 *)0xFFC038A0);
		debugfs_create_x16("USB_EP5_FIFO", 0600, parent, (u16 *)0xFFC038A8);
		debugfs_create_x16("USB_EP6_FIFO", 0600, parent, (u16 *)0xFFC038B0);
		debugfs_create_x16("USB_EP7_FIFO", 0600, parent, (u16 *)0xFFC038B8);
		debugfs_create_x16("USB_EP_NI0_RXCOUNT", 0600, parent, (u16 *)0xFFC03A10);
		debugfs_create_x16("USB_EP_NI0_RXCSR", 0600, parent, (u16 *)0xFFC03A0C);
		debugfs_create_x16("USB_EP_NI0_RXINTERVAL", 0600, parent, (u16 *)0xFFC03A20);
		debugfs_create_x16("USB_EP_NI0_RXMAXP", 0600, parent, (u16 *)0xFFC03A08);
		debugfs_create_x16("USB_EP_NI0_RXTYPE", 0600, parent, (u16 *)0xFFC03A1C);
		debugfs_create_x16("USB_EP_NI0_TXCOUNT", 0600, parent, (u16 *)0xFFC03A28);
		debugfs_create_x16("USB_EP_NI0_TXCSR", 0600, parent, (u16 *)0xFFC03A04);
		debugfs_create_x16("USB_EP_NI0_TXINTERVAL", 0600, parent, (u16 *)0xFFC03A18);
		debugfs_create_x16("USB_EP_NI0_TXMAXP", 0600, parent, (u16 *)0xFFC03A00);
		debugfs_create_x16("USB_EP_NI0_TXTYPE", 0600, parent, (u16 *)0xFFC03A14);
		debugfs_create_x16("USB_EP_NI1_RXCOUNT", 0600, parent, (u16 *)0xFFC03A50);
		debugfs_create_x16("USB_EP_NI1_RXCSR", 0600, parent, (u16 *)0xFFC03A4C);
		debugfs_create_x16("USB_EP_NI1_RXINTERVAL", 0600, parent, (u16 *)0xFFC03A60);
		debugfs_create_x16("USB_EP_NI1_RXMAXP", 0600, parent, (u16 *)0xFFC03A48);
		debugfs_create_x16("USB_EP_NI1_RXTYPE", 0600, parent, (u16 *)0xFFC03A5C);
		debugfs_create_x16("USB_EP_NI1_TXCOUNT", 0600, parent, (u16 *)0xFFC03A68);
		debugfs_create_x16("USB_EP_NI1_TXCSR", 0600, parent, (u16 *)0xFFC03A44);
		debugfs_create_x16("USB_EP_NI1_TXINTERVAL", 0600, parent, (u16 *)0xFFC03A58);
		debugfs_create_x16("USB_EP_NI1_TXMAXP", 0600, parent, (u16 *)0xFFC03A40);
		debugfs_create_x16("USB_EP_NI1_TXTYPE", 0600, parent, (u16 *)0xFFC03A54);
		debugfs_create_x16("USB_EP_NI2_RXCOUNT", 0600, parent, (u16 *)0xFFC03A90);
		debugfs_create_x16("USB_EP_NI2_RXCSR", 0600, parent, (u16 *)0xFFC03A8C);
		debugfs_create_x16("USB_EP_NI2_RXINTERVAL", 0600, parent, (u16 *)0xFFC03AA0);
		debugfs_create_x16("USB_EP_NI2_RXMAXP", 0600, parent, (u16 *)0xFFC03A88);
		debugfs_create_x16("USB_EP_NI2_RXTYPE", 0600, parent, (u16 *)0xFFC03A9C);
		debugfs_create_x16("USB_EP_NI2_TXCOUNT", 0600, parent, (u16 *)0xFFC03AA8);
		debugfs_create_x16("USB_EP_NI2_TXCSR", 0600, parent, (u16 *)0xFFC03A84);
		debugfs_create_x16("USB_EP_NI2_TXINTERVAL", 0600, parent, (u16 *)0xFFC03A98);
		debugfs_create_x16("USB_EP_NI2_TXMAXP", 0600, parent, (u16 *)0xFFC03A80);
		debugfs_create_x16("USB_EP_NI2_TXTYPE", 0600, parent, (u16 *)0xFFC03A94);
		debugfs_create_x16("USB_EP_NI3_RXCOUNT", 0600, parent, (u16 *)0xFFC03AD0);
		debugfs_create_x16("USB_EP_NI3_RXCSR", 0600, parent, (u16 *)0xFFC03ACC);
		debugfs_create_x16("USB_EP_NI3_RXINTERVAL", 0600, parent, (u16 *)0xFFC03AE0);
		debugfs_create_x16("USB_EP_NI3_RXMAXP", 0600, parent, (u16 *)0xFFC03AC8);
		debugfs_create_x16("USB_EP_NI3_RXTYPE", 0600, parent, (u16 *)0xFFC03ADC);
		debugfs_create_x16("USB_EP_NI3_TXCOUNT", 0600, parent, (u16 *)0xFFC03AE8);
		debugfs_create_x16("USB_EP_NI3_TXCSR", 0600, parent, (u16 *)0xFFC03AC4);
		debugfs_create_x16("USB_EP_NI3_TXINTERVAL", 0600, parent, (u16 *)0xFFC03AD8);
		debugfs_create_x16("USB_EP_NI3_TXMAXP", 0600, parent, (u16 *)0xFFC03AC0);
		debugfs_create_x16("USB_EP_NI3_TXTYPE", 0600, parent, (u16 *)0xFFC03AD4);
		debugfs_create_x16("USB_EP_NI4_RXCOUNT", 0600, parent, (u16 *)0xFFC03B10);
		debugfs_create_x16("USB_EP_NI4_RXCSR", 0600, parent, (u16 *)0xFFC03B0C);
		debugfs_create_x16("USB_EP_NI4_RXINTERVAL", 0600, parent, (u16 *)0xFFC03B20);
		debugfs_create_x16("USB_EP_NI4_RXMAXP", 0600, parent, (u16 *)0xFFC03B08);
		debugfs_create_x16("USB_EP_NI4_RXTYPE", 0600, parent, (u16 *)0xFFC03B1C);
		debugfs_create_x16("USB_EP_NI4_TXCOUNT", 0600, parent, (u16 *)0xFFC03B28);
		debugfs_create_x16("USB_EP_NI4_TXCSR", 0600, parent, (u16 *)0xFFC03B04);
		debugfs_create_x16("USB_EP_NI4_TXINTERVAL", 0600, parent, (u16 *)0xFFC03B18);
		debugfs_create_x16("USB_EP_NI4_TXMAXP", 0600, parent, (u16 *)0xFFC03B00);
		debugfs_create_x16("USB_EP_NI4_TXTYPE", 0600, parent, (u16 *)0xFFC03B14);
		debugfs_create_x16("USB_EP_NI5_RXCOUNT", 0600, parent, (u16 *)0xFFC03B50);
		debugfs_create_x16("USB_EP_NI5_RXCSR", 0600, parent, (u16 *)0xFFC03B4C);
		debugfs_create_x16("USB_EP_NI5_RXINTERVAL", 0600, parent, (u16 *)0xFFC03B60);
		debugfs_create_x16("USB_EP_NI5_RXMAXP", 0600, parent, (u16 *)0xFFC03B48);
		debugfs_create_x16("USB_EP_NI5_RXTYPE", 0600, parent, (u16 *)0xFFC03B5C);
		debugfs_create_x16("USB_EP_NI5_TXCOUNT", 0600, parent, (u16 *)0xFFC03B68);
		debugfs_create_x16("USB_EP_NI5_TXCSR", 0600, parent, (u16 *)0xFFC03B44);
		debugfs_create_x16("USB_EP_NI5_TXINTERVAL", 0600, parent, (u16 *)0xFFC03B58);
		debugfs_create_x16("USB_EP_NI5_TXMAXP", 0600, parent, (u16 *)0xFFC03B40);
		debugfs_create_x16("USB_EP_NI5_TXTYPE", 0600, parent, (u16 *)0xFFC03B54);
		debugfs_create_x16("USB_EP_NI6_RXCOUNT", 0600, parent, (u16 *)0xFFC03B90);
		debugfs_create_x16("USB_EP_NI6_RXCSR", 0600, parent, (u16 *)0xFFC03B8C);
		debugfs_create_x16("USB_EP_NI6_RXINTERVAL", 0600, parent, (u16 *)0xFFC03BA0);
		debugfs_create_x16("USB_EP_NI6_RXMAXP", 0600, parent, (u16 *)0xFFC03B88);
		debugfs_create_x16("USB_EP_NI6_RXTYPE", 0600, parent, (u16 *)0xFFC03B9C);
		debugfs_create_x16("USB_EP_NI6_TXCOUNT", 0600, parent, (u16 *)0xFFC03BA8);
		debugfs_create_x16("USB_EP_NI6_TXCSR", 0600, parent, (u16 *)0xFFC03B84);
		debugfs_create_x16("USB_EP_NI6_TXINTERVAL", 0600, parent, (u16 *)0xFFC03B98);
		debugfs_create_x16("USB_EP_NI6_TXMAXP", 0600, parent, (u16 *)0xFFC03B80);
		debugfs_create_x16("USB_EP_NI6_TXTYPE", 0600, parent, (u16 *)0xFFC03B94);
		debugfs_create_x16("USB_EP_NI7_RXCOUNT", 0600, parent, (u16 *)0xFFC03BD0);
		debugfs_create_x16("USB_EP_NI7_RXCSR", 0600, parent, (u16 *)0xFFC03BCC);
		debugfs_create_x16("USB_EP_NI7_RXINTERVAL", 0600, parent, (u16 *)0xFFC03BF0);
		debugfs_create_x16("USB_EP_NI7_RXMAXP", 0600, parent, (u16 *)0xFFC03BC8);
		debugfs_create_x16("USB_EP_NI7_RXTYPE", 0600, parent, (u16 *)0xFFC03BDC);
		debugfs_create_x16("USB_EP_NI7_TXCOUNT", 0600, parent, (u16 *)0xFFC03BF8);
		debugfs_create_x16("USB_EP_NI7_TXCSR", 0600, parent, (u16 *)0xFFC03BC4);
		debugfs_create_x16("USB_EP_NI7_TXINTERVAL", 0600, parent, (u16 *)0xFFC03BD8);
		debugfs_create_x16("USB_EP_NI7_TXMAXP", 0600, parent, (u16 *)0xFFC03BC0);
		debugfs_create_x16("USB_EP_NI7_TXTYPE", 0600, parent, (u16 *)0xFFC03BD4);
		debugfs_create_x16("USB_FADDR", 0600, parent, (u16 *)0xFFC03800);
		debugfs_create_x16("USB_FRAME", 0600, parent, (u16 *)0xFFC03820);
		debugfs_create_x16("USB_FS_EOF1", 0600, parent, (u16 *)0xFFC03954);
		debugfs_create_x16("USB_GLOBAL_CTL", 0600, parent, (u16 *)0xFFC03830);
		debugfs_create_x16("USB_GLOBINTR", 0600, parent, (u16 *)0xFFC0382C);
		debugfs_create_x16("USB_HS_EOF1", 0600, parent, (u16 *)0xFFC03950);
		debugfs_create_x16("USB_INDEX", 0600, parent, (u16 *)0xFFC03824);
		debugfs_create_x16("USB_INTRRX", 0600, parent, (u16 *)0xFFC0380C);
		debugfs_create_x16("USB_INTRRXE", 0600, parent, (u16 *)0xFFC03814);
		debugfs_create_x16("USB_INTRTX", 0600, parent, (u16 *)0xFFC03808);
		debugfs_create_x16("USB_INTRTXE", 0600, parent, (u16 *)0xFFC03810);
		debugfs_create_x16("USB_INTRUSB", 0600, parent, (u16 *)0xFFC03818);
		debugfs_create_x16("USB_INTRUSBE", 0600, parent, (u16 *)0xFFC0381C);
		debugfs_create_x16("USB_LINKINFO", 0600, parent, (u16 *)0xFFC03948);
		debugfs_create_x16("USB_LS_EOF1", 0600, parent, (u16 *)0xFFC03958);
		debugfs_create_x16("USB_NAKLIMIT0", 0600, parent, (u16 *)0xFFC03858);
		debugfs_create_x16("USB_OTG_DEV_CTL", 0600, parent, (u16 *)0xFFC03900);
		debugfs_create_x16("USB_OTG_VBUS_IRQ", 0600, parent, (u16 *)0xFFC03904);
		debugfs_create_x16("USB_OTG_VBUS_MASK", 0600, parent, (u16 *)0xFFC03908);
		debugfs_create_x16("USB_PHY_TEST", 0600, parent, (u16 *)0xFFC039EC);
		debugfs_create_x16("USB_PLLOSC_CTRL", 0600, parent, (u16 *)0xFFC039F0);
		debugfs_create_x16("USB_POWER", 0600, parent, (u16 *)0xFFC03804);
		debugfs_create_x16("USB_RXCOUNT", 0600, parent, (u16 *)0xFFC03850);
		debugfs_create_x16("USB_RXCSR", 0600, parent, (u16 *)0xFFC0384C);
		debugfs_create_x16("USB_RXINTERVAL", 0600, parent, (u16 *)0xFFC03860);
		debugfs_create_x16("USB_RXTYPE", 0600, parent, (u16 *)0xFFC0385C);
		debugfs_create_x16("USB_RX_MAX_PACKET", 0600, parent, (u16 *)0xFFC03848);
		debugfs_create_x16("USB_SRP_CLKDIV", 0600, parent, (u16 *)0xFFC039F4);
		debugfs_create_x16("USB_TESTMODE", 0600, parent, (u16 *)0xFFC03828);
		debugfs_create_x16("USB_TXCOUNT", 0600, parent, (u16 *)0xFFC03868);
		debugfs_create_x16("USB_TXCSR", 0600, parent, (u16 *)0xFFC03844);
		debugfs_create_x16("USB_TXINTERVAL", 0600, parent, (u16 *)0xFFC03858);
		debugfs_create_x16("USB_TXTYPE", 0600, parent, (u16 *)0xFFC03854);
		debugfs_create_x16("USB_TX_MAX_PACKET", 0600, parent, (u16 *)0xFFC03840);
		debugfs_create_x16("USB_VPLEN", 0600, parent, (u16 *)0xFFC0394C);

		parent = debugfs_create_dir("Watchdog", top);
		debugfs_create_x32("WDOG_CNT", 0600, parent, (u32 *)0xFFC00204);
		debugfs_create_x16("WDOG_CTL", 0600, parent, (u16 *)0xFFC00200);
		debugfs_create_x32("WDOG_STAT", 0600, parent, (u32 *)0xFFC00208);

		parent = debugfs_create_dir("Watchpoint and Patch Unit", top);
		debugfs_create_x32("WPDA0", 0600, parent, (u32 *)0xFFE07140);
		debugfs_create_x32("WPDA1", 0600, parent, (u32 *)0xFFE07144);
		debugfs_create_x32("WPDACNT0", 0600, parent, (u32 *)0xFFE07180);
		debugfs_create_x32("WPDACNT1", 0600, parent, (u32 *)0xFFE07184);
		debugfs_create_x32("WPDACTL", 0600, parent, (u32 *)0xFFE07100);
		debugfs_create_x32("WPIA0", 0600, parent, (u32 *)0xFFE07040);
		debugfs_create_x32("WPIA1", 0600, parent, (u32 *)0xFFE07044);
		debugfs_create_x32("WPIA2", 0600, parent, (u32 *)0xFFE07048);
		debugfs_create_x32("WPIA3", 0600, parent, (u32 *)0xFFE0704C);
		debugfs_create_x32("WPIA4", 0600, parent, (u32 *)0xFFE07050);
		debugfs_create_x32("WPIA5", 0600, parent, (u32 *)0xFFE07054);
		debugfs_create_x32("WPIACNT0", 0600, parent, (u32 *)0xFFE07080);
		debugfs_create_x32("WPIACNT1", 0600, parent, (u32 *)0xFFE07084);
		debugfs_create_x32("WPIACNT2", 0600, parent, (u32 *)0xFFE07088);
		debugfs_create_x32("WPIACNT3", 0600, parent, (u32 *)0xFFE0708C);
		debugfs_create_x32("WPIACNT4", 0600, parent, (u32 *)0xFFE07090);
		debugfs_create_x32("WPIACNT5", 0600, parent, (u32 *)0xFFE07094);
		debugfs_create_x32("WPIACTL", 0600, parent, (u32 *)0xFFE07000);
		debugfs_create_x32("WPSTAT", 0600, parent, (u32 *)0xFFE07200);

	}	/* BF524 */

#ifdef __ADSPBF525__
# define USE_BF525 1
#else
# define USE_BF525 0
#endif
	if (USE_BF525) {

		parent = debugfs_create_dir("Core Timer Register File", top);
		debugfs_create_x32("TCNTL", 0600, parent, (u32 *)0xFFE03000);
		debugfs_create_x32("TCOUNT", 0600, parent, (u32 *)0xFFE0300C);
		debugfs_create_x32("TPERIOD", 0600, parent, (u32 *)0xFFE03004);
		debugfs_create_x32("TSCALE", 0600, parent, (u32 *)0xFFE03008);

		parent = debugfs_create_dir("Counter", top);
		debugfs_create_x16("CNT_COMMAND", 0600, parent, (u16 *)0xFFC0350C);
		debugfs_create_x16("CNT_CONFIG", 0600, parent, (u16 *)0xFFC03500);
		debugfs_create_x32("CNT_COUNTER", 0600, parent, (u32 *)0xFFC03514);
		debugfs_create_x16("CNT_DEBOUNCE", 0600, parent, (u16 *)0xFFC03510);
		debugfs_create_x16("CNT_IMASK", 0600, parent, (u16 *)0xFFC03504);
		debugfs_create_x32("CNT_MAX", 0600, parent, (u32 *)0xFFC03518);
		debugfs_create_x32("CNT_MIN", 0600, parent, (u32 *)0xFFC0351C);
		debugfs_create_x16("CNT_STATUS", 0600, parent, (u16 *)0xFFC03508);

		parent = debugfs_create_dir("DMA Controller", top);
		debugfs_create_x16("DMA0_CONFIG", 0600, parent, (u16 *)0xFFC00C08);
		debugfs_create_x32("DMA0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C24);
		debugfs_create_x32("DMA0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C20);
		debugfs_create_x16("DMA0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C30);
		debugfs_create_x16("DMA0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C38);
		debugfs_create_x16("DMA0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C28);
		debugfs_create_x32("DMA0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C00);
		debugfs_create_x16("DMA0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C2C);
		debugfs_create_x32("DMA0_START_ADDR", 0600, parent, (u32 *)0xFFC00C04);
		debugfs_create_x16("DMA0_X_COUNT", 0600, parent, (u16 *)0xFFC00C10);
		debugfs_create_x16("DMA0_X_MODIFY", 0600, parent, (u16 *)0xFFC00C14);
		debugfs_create_x16("DMA0_Y_COUNT", 0600, parent, (u16 *)0xFFC00C18);
		debugfs_create_x16("DMA0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C1C);
		debugfs_create_x16("DMA10_CONFIG", 0600, parent, (u16 *)0xFFC00E88);
		debugfs_create_x32("DMA10_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EA4);
		debugfs_create_x32("DMA10_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EA0);
		debugfs_create_x16("DMA10_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EB0);
		debugfs_create_x16("DMA10_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EB8);
		debugfs_create_x16("DMA10_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EA8);
		debugfs_create_x32("DMA10_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E80);
		debugfs_create_x16("DMA10_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EAC);
		debugfs_create_x32("DMA10_START_ADDR", 0600, parent, (u32 *)0xFFC00E84);
		debugfs_create_x16("DMA10_X_COUNT", 0600, parent, (u16 *)0xFFC00E90);
		debugfs_create_x16("DMA10_X_MODIFY", 0600, parent, (u16 *)0xFFC00E94);
		debugfs_create_x16("DMA10_Y_COUNT", 0600, parent, (u16 *)0xFFC00E98);
		debugfs_create_x16("DMA10_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E9C);
		debugfs_create_x16("DMA11_CONFIG", 0600, parent, (u16 *)0xFFC00EC8);
		debugfs_create_x32("DMA11_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EE4);
		debugfs_create_x32("DMA11_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EE0);
		debugfs_create_x16("DMA11_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EF0);
		debugfs_create_x16("DMA11_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EF8);
		debugfs_create_x16("DMA11_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EE8);
		debugfs_create_x32("DMA11_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00EC0);
		debugfs_create_x16("DMA11_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EEC);
		debugfs_create_x32("DMA11_START_ADDR", 0600, parent, (u32 *)0xFFC00EC4);
		debugfs_create_x16("DMA11_X_COUNT", 0600, parent, (u16 *)0xFFC00ED0);
		debugfs_create_x16("DMA11_X_MODIFY", 0600, parent, (u16 *)0xFFC00ED4);
		debugfs_create_x16("DMA11_Y_COUNT", 0600, parent, (u16 *)0xFFC00ED8);
		debugfs_create_x16("DMA11_Y_MODIFY", 0600, parent, (u16 *)0xFFC00EDC);
		debugfs_create_x16("DMA1_CONFIG", 0600, parent, (u16 *)0xFFC00C48);
		debugfs_create_x32("DMA1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C64);
		debugfs_create_x32("DMA1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C60);
		debugfs_create_x16("DMA1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C70);
		debugfs_create_x16("DMA1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C78);
		debugfs_create_x16("DMA1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C68);
		debugfs_create_x32("DMA1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C40);
		debugfs_create_x16("DMA1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C6C);
		debugfs_create_x32("DMA1_START_ADDR", 0600, parent, (u32 *)0xFFC00C44);
		debugfs_create_x16("DMA1_X_COUNT", 0600, parent, (u16 *)0xFFC00C50);
		debugfs_create_x16("DMA1_X_MODIFY", 0600, parent, (u16 *)0xFFC00C54);
		debugfs_create_x16("DMA1_Y_COUNT", 0600, parent, (u16 *)0xFFC00C58);
		debugfs_create_x16("DMA1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C5C);
		debugfs_create_x16("DMA2_CONFIG", 0600, parent, (u16 *)0xFFC00C88);
		debugfs_create_x32("DMA2_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CA4);
		debugfs_create_x32("DMA2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CA0);
		debugfs_create_x16("DMA2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CB0);
		debugfs_create_x16("DMA2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CB8);
		debugfs_create_x16("DMA2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CA8);
		debugfs_create_x32("DMA2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C80);
		debugfs_create_x16("DMA2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CAC);
		debugfs_create_x32("DMA2_START_ADDR", 0600, parent, (u32 *)0xFFC00C84);
		debugfs_create_x16("DMA2_X_COUNT", 0600, parent, (u16 *)0xFFC00C90);
		debugfs_create_x16("DMA2_X_MODIFY", 0600, parent, (u16 *)0xFFC00C94);
		debugfs_create_x16("DMA2_Y_COUNT", 0600, parent, (u16 *)0xFFC00C98);
		debugfs_create_x16("DMA2_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C9C);
		debugfs_create_x16("DMA3_CONFIG", 0600, parent, (u16 *)0xFFC00CC8);
		debugfs_create_x32("DMA3_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CE4);
		debugfs_create_x32("DMA3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CE0);
		debugfs_create_x16("DMA3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CF0);
		debugfs_create_x16("DMA3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CF8);
		debugfs_create_x16("DMA3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CE8);
		debugfs_create_x32("DMA3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00CC0);
		debugfs_create_x16("DMA3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CEC);
		debugfs_create_x32("DMA3_START_ADDR", 0600, parent, (u32 *)0xFFC00CC4);
		debugfs_create_x16("DMA3_X_COUNT", 0600, parent, (u16 *)0xFFC00CD0);
		debugfs_create_x16("DMA3_X_MODIFY", 0600, parent, (u16 *)0xFFC00CD4);
		debugfs_create_x16("DMA3_Y_COUNT", 0600, parent, (u16 *)0xFFC00CD8);
		debugfs_create_x16("DMA3_Y_MODIFY", 0600, parent, (u16 *)0xFFC00CDC);
		debugfs_create_x16("DMA4_CONFIG", 0600, parent, (u16 *)0xFFC00D08);
		debugfs_create_x32("DMA4_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D24);
		debugfs_create_x32("DMA4_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D20);
		debugfs_create_x16("DMA4_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D30);
		debugfs_create_x16("DMA4_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D38);
		debugfs_create_x16("DMA4_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D28);
		debugfs_create_x32("DMA4_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D00);
		debugfs_create_x16("DMA4_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D2C);
		debugfs_create_x32("DMA4_START_ADDR", 0600, parent, (u32 *)0xFFC00D04);
		debugfs_create_x16("DMA4_X_COUNT", 0600, parent, (u16 *)0xFFC00D10);
		debugfs_create_x16("DMA4_X_MODIFY", 0600, parent, (u16 *)0xFFC00D14);
		debugfs_create_x16("DMA4_Y_COUNT", 0600, parent, (u16 *)0xFFC00D18);
		debugfs_create_x16("DMA4_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D1C);
		debugfs_create_x16("DMA5_CONFIG", 0600, parent, (u16 *)0xFFC00D48);
		debugfs_create_x32("DMA5_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D64);
		debugfs_create_x32("DMA5_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D60);
		debugfs_create_x16("DMA5_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D70);
		debugfs_create_x16("DMA5_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D78);
		debugfs_create_x16("DMA5_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D68);
		debugfs_create_x32("DMA5_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D40);
		debugfs_create_x16("DMA5_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D6C);
		debugfs_create_x32("DMA5_START_ADDR", 0600, parent, (u32 *)0xFFC00D44);
		debugfs_create_x16("DMA5_X_COUNT", 0600, parent, (u16 *)0xFFC00D50);
		debugfs_create_x16("DMA5_X_MODIFY", 0600, parent, (u16 *)0xFFC00D54);
		debugfs_create_x16("DMA5_Y_COUNT", 0600, parent, (u16 *)0xFFC00D58);
		debugfs_create_x16("DMA5_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D5C);
		debugfs_create_x16("DMA6_CONFIG", 0600, parent, (u16 *)0xFFC00D88);
		debugfs_create_x32("DMA6_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DA4);
		debugfs_create_x32("DMA6_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DA0);
		debugfs_create_x16("DMA6_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DB0);
		debugfs_create_x16("DMA6_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DB8);
		debugfs_create_x16("DMA6_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DA8);
		debugfs_create_x32("DMA6_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D80);
		debugfs_create_x16("DMA6_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DAC);
		debugfs_create_x32("DMA6_START_ADDR", 0600, parent, (u32 *)0xFFC00D84);
		debugfs_create_x16("DMA6_X_COUNT", 0600, parent, (u16 *)0xFFC00D90);
		debugfs_create_x16("DMA6_X_MODIFY", 0600, parent, (u16 *)0xFFC00D94);
		debugfs_create_x16("DMA6_Y_COUNT", 0600, parent, (u16 *)0xFFC00D98);
		debugfs_create_x16("DMA6_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D9C);
		debugfs_create_x16("DMA7_CONFIG", 0600, parent, (u16 *)0xFFC00DC8);
		debugfs_create_x32("DMA7_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DE4);
		debugfs_create_x32("DMA7_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DE0);
		debugfs_create_x16("DMA7_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DF0);
		debugfs_create_x16("DMA7_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DF8);
		debugfs_create_x16("DMA7_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DE8);
		debugfs_create_x32("DMA7_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00DC0);
		debugfs_create_x16("DMA7_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DEC);
		debugfs_create_x32("DMA7_START_ADDR", 0600, parent, (u32 *)0xFFC00DC4);
		debugfs_create_x16("DMA7_X_COUNT", 0600, parent, (u16 *)0xFFC00DD0);
		debugfs_create_x16("DMA7_X_MODIFY", 0600, parent, (u16 *)0xFFC00DD4);
		debugfs_create_x16("DMA7_Y_COUNT", 0600, parent, (u16 *)0xFFC00DD8);
		debugfs_create_x16("DMA7_Y_MODIFY", 0600, parent, (u16 *)0xFFC00DDC);
		debugfs_create_x16("DMA8_CONFIG", 0600, parent, (u16 *)0xFFC00E08);
		debugfs_create_x32("DMA8_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E24);
		debugfs_create_x32("DMA8_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E20);
		debugfs_create_x16("DMA8_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E30);
		debugfs_create_x16("DMA8_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E38);
		debugfs_create_x16("DMA8_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E28);
		debugfs_create_x32("DMA8_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E00);
		debugfs_create_x16("DMA8_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E2C);
		debugfs_create_x32("DMA8_START_ADDR", 0600, parent, (u32 *)0xFFC00E04);
		debugfs_create_x16("DMA8_X_COUNT", 0600, parent, (u16 *)0xFFC00E10);
		debugfs_create_x16("DMA8_X_MODIFY", 0600, parent, (u16 *)0xFFC00E14);
		debugfs_create_x16("DMA8_Y_COUNT", 0600, parent, (u16 *)0xFFC00E18);
		debugfs_create_x16("DMA8_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E1C);
		debugfs_create_x16("DMA9_CONFIG", 0600, parent, (u16 *)0xFFC00E48);
		debugfs_create_x32("DMA9_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E64);
		debugfs_create_x32("DMA9_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E60);
		debugfs_create_x16("DMA9_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E70);
		debugfs_create_x16("DMA9_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E78);
		debugfs_create_x16("DMA9_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E68);
		debugfs_create_x32("DMA9_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E40);
		debugfs_create_x16("DMA9_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E6C);
		debugfs_create_x32("DMA9_START_ADDR", 0600, parent, (u32 *)0xFFC00E44);
		debugfs_create_x16("DMA9_X_COUNT", 0600, parent, (u16 *)0xFFC00E50);
		debugfs_create_x16("DMA9_X_MODIFY", 0600, parent, (u16 *)0xFFC00E54);
		debugfs_create_x16("DMA9_Y_COUNT", 0600, parent, (u16 *)0xFFC00E58);
		debugfs_create_x16("DMA9_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E5C);

		parent = debugfs_create_dir("DMA Traffic Control", top);
		debugfs_create_x16("DMA_TC_CNT", 0600, parent, (u16 *)0xFFC00B0C);
		debugfs_create_x16("DMA_TC_PER", 0600, parent, (u16 *)0xFFC00B10);

		parent = debugfs_create_dir("EBIU", top);
		debugfs_create_x32("EBIU_AMBCTL0", 0600, parent, (u32 *)0xFFC00A04);
		debugfs_create_x32("EBIU_AMBCTL1", 0600, parent, (u32 *)0xFFC00A08);
		debugfs_create_x16("EBIU_AMGCTL", 0600, parent, (u16 *)0xFFC00A00);
		debugfs_create_x16("EBIU_SDBCTL", 0600, parent, (u16 *)0xFFC00A14);
		debugfs_create_x32("EBIU_SDGCTL", 0600, parent, (u32 *)0xFFC00A10);
		debugfs_create_x16("EBIU_SDRRC", 0600, parent, (u16 *)0xFFC00A18);
		debugfs_create_x16("EBIU_SDSTAT", 0600, parent, (u16 *)0xFFC00A1C);

		parent = debugfs_create_dir("Event Vectors", top);
		debugfs_create_x32("EVT0", 0600, parent, (u32 *)0xFFE02000);
		debugfs_create_x32("EVT10", 0600, parent, (u32 *)0xFFE02028);
		debugfs_create_x32("EVT11", 0600, parent, (u32 *)0xFFE0202C);
		debugfs_create_x32("EVT12", 0600, parent, (u32 *)0xFFE02030);
		debugfs_create_x32("EVT13", 0600, parent, (u32 *)0xFFE02034);
		debugfs_create_x32("EVT14", 0600, parent, (u32 *)0xFFE02038);
		debugfs_create_x32("EVT15", 0600, parent, (u32 *)0xFFE0203C);
		debugfs_create_x32("EVT1", 0600, parent, (u32 *)0xFFE02004);
		debugfs_create_x32("EVT2", 0600, parent, (u32 *)0xFFE02008);
		debugfs_create_x32("EVT3", 0600, parent, (u32 *)0xFFE0200C);
		debugfs_create_x32("EVT4", 0600, parent, (u32 *)0xFFE02010);
		debugfs_create_x32("EVT5", 0600, parent, (u32 *)0xFFE02014);
		debugfs_create_x32("EVT6", 0600, parent, (u32 *)0xFFE02018);
		debugfs_create_x32("EVT7", 0600, parent, (u32 *)0xFFE0201C);
		debugfs_create_x32("EVT8", 0600, parent, (u32 *)0xFFE02020);
		debugfs_create_x32("EVT9", 0600, parent, (u32 *)0xFFE02024);

		parent = debugfs_create_dir("Extended Registers", top);
		debugfs_create_x32("CHIPID", 0600, parent, (u32 *)0xFFC00014);
		debugfs_create_x32("DSPID", 0600, parent, (u32 *)0xFFE05000);

		parent = debugfs_create_dir("GPIO PIN", top);
		debugfs_create_x16("PORTF_DRIVE", 0600, parent, (u16 *)0xFFC03220);
		debugfs_create_x16("PORTF_HYSTERESIS", 0600, parent, (u16 *)0xFFC03240);
		debugfs_create_x16("PORTF_MUX", 0600, parent, (u16 *)0xFFC03210);
		debugfs_create_x16("PORTF_SLEW", 0600, parent, (u16 *)0xFFC03230);
		debugfs_create_x16("PORTG_DRIVE", 0600, parent, (u16 *)0xFFC03224);
		debugfs_create_x16("PORTG_HYSTERESIS", 0600, parent, (u16 *)0xFFC03244);
		debugfs_create_x16("PORTG_MUX", 0600, parent, (u16 *)0xFFC03214);
		debugfs_create_x16("PORTG_SLEW", 0600, parent, (u16 *)0xFFC03234);
		debugfs_create_x16("PORTH_DRIVE", 0600, parent, (u16 *)0xFFC03228);
		debugfs_create_x16("PORTH_HYSTERESIS", 0600, parent, (u16 *)0xFFC03248);
		debugfs_create_x16("PORTH_MUX", 0600, parent, (u16 *)0xFFC03218);
		debugfs_create_x16("PORTH_SLEW", 0600, parent, (u16 *)0xFFC03238);

		parent = debugfs_create_dir("HOST", top);
		debugfs_create_x16("HOST_CONTROL", 0600, parent, (u16 *)0xFFC03400);
		debugfs_create_x16("HOST_STATUS", 0600, parent, (u16 *)0xFFC03404);
		debugfs_create_x16("HOST_TIMEOUT", 0600, parent, (u16 *)0xFFC03408);

		parent = debugfs_create_dir("Handshake MDMA", top);
		debugfs_create_x16("HMDMA0_BCINIT", 0600, parent, (u16 *)0xFFC03308);
		debugfs_create_x16("HMDMA0_BCOUNT", 0600, parent, (u16 *)0xFFC03318);
		debugfs_create_x16("HMDMA0_CONTROL", 0600, parent, (u16 *)0xFFC03300);
		debugfs_create_x16("HMDMA0_ECINIT", 0600, parent, (u16 *)0xFFC03304);
		debugfs_create_x16("HMDMA0_ECOUNT", 0600, parent, (u16 *)0xFFC03314);
		debugfs_create_x16("HMDMA0_ECOVERFLOW", 0600, parent, (u16 *)0xFFC03310);
		debugfs_create_x16("HMDMA0_ECURGENT", 0600, parent, (u16 *)0xFFC0330C);
		debugfs_create_x16("HMDMA1_BCINIT", 0600, parent, (u16 *)0xFFC03348);
		debugfs_create_x16("HMDMA1_BCOUNT", 0600, parent, (u16 *)0xFFC03358);
		debugfs_create_x16("HMDMA1_CONTROL", 0600, parent, (u16 *)0xFFC03340);
		debugfs_create_x16("HMDMA1_ECINIT", 0600, parent, (u16 *)0xFFC03344);
		debugfs_create_x16("HMDMA1_ECOUNT", 0600, parent, (u16 *)0xFFC03354);
		debugfs_create_x16("HMDMA1_ECOVERFLOW", 0600, parent, (u16 *)0xFFC03350);
		debugfs_create_x16("HMDMA1_ECURGENT", 0600, parent, (u16 *)0xFFC0334C);

		parent = debugfs_create_dir("Interrupt Controller", top);
		debugfs_create_x32("ILAT", 0600, parent, (u32 *)0xFFE0210C);
		debugfs_create_x32("IMASK", 0600, parent, (u32 *)0xFFE02104);
		debugfs_create_x32("IPEND", 0600, parent, (u32 *)0xFFE02108);
		debugfs_create_x32("IPRIO", 0600, parent, (u32 *)0xFFE02110);

		parent = debugfs_create_dir("L1 Code Memory Registers", top);
		debugfs_create_x32("ICPLB_ADDR0", 0600, parent, (u32 *)0xFFE01100);
		debugfs_create_x32("ICPLB_ADDR10", 0600, parent, (u32 *)0xFFE01128);
		debugfs_create_x32("ICPLB_ADDR11", 0600, parent, (u32 *)0xFFE0112C);
		debugfs_create_x32("ICPLB_ADDR12", 0600, parent, (u32 *)0xFFE01130);
		debugfs_create_x32("ICPLB_ADDR13", 0600, parent, (u32 *)0xFFE01134);
		debugfs_create_x32("ICPLB_ADDR14", 0600, parent, (u32 *)0xFFE01138);
		debugfs_create_x32("ICPLB_ADDR15", 0600, parent, (u32 *)0xFFE0113C);
		debugfs_create_x32("ICPLB_ADDR1", 0600, parent, (u32 *)0xFFE01104);
		debugfs_create_x32("ICPLB_ADDR2", 0600, parent, (u32 *)0xFFE01108);
		debugfs_create_x32("ICPLB_ADDR3", 0600, parent, (u32 *)0xFFE0110C);
		debugfs_create_x32("ICPLB_ADDR4", 0600, parent, (u32 *)0xFFE01110);
		debugfs_create_x32("ICPLB_ADDR5", 0600, parent, (u32 *)0xFFE01114);
		debugfs_create_x32("ICPLB_ADDR6", 0600, parent, (u32 *)0xFFE01118);
		debugfs_create_x32("ICPLB_ADDR7", 0600, parent, (u32 *)0xFFE0111C);
		debugfs_create_x32("ICPLB_ADDR8", 0600, parent, (u32 *)0xFFE01120);
		debugfs_create_x32("ICPLB_ADDR9", 0600, parent, (u32 *)0xFFE01124);
		debugfs_create_x32("ICPLB_DATA0", 0600, parent, (u32 *)0xFFE01200);
		debugfs_create_x32("ICPLB_DATA10", 0600, parent, (u32 *)0xFFE01228);
		debugfs_create_x32("ICPLB_DATA11", 0600, parent, (u32 *)0xFFE0122C);
		debugfs_create_x32("ICPLB_DATA12", 0600, parent, (u32 *)0xFFE01230);
		debugfs_create_x32("ICPLB_DATA13", 0600, parent, (u32 *)0xFFE01234);
		debugfs_create_x32("ICPLB_DATA14", 0600, parent, (u32 *)0xFFE01238);
		debugfs_create_x32("ICPLB_DATA15", 0600, parent, (u32 *)0xFFE0123C);
		debugfs_create_x32("ICPLB_DATA1", 0600, parent, (u32 *)0xFFE01204);
		debugfs_create_x32("ICPLB_DATA2", 0600, parent, (u32 *)0xFFE01208);
		debugfs_create_x32("ICPLB_DATA3", 0600, parent, (u32 *)0xFFE0120C);
		debugfs_create_x32("ICPLB_DATA4", 0600, parent, (u32 *)0xFFE01210);
		debugfs_create_x32("ICPLB_DATA5", 0600, parent, (u32 *)0xFFE01214);
		debugfs_create_x32("ICPLB_DATA6", 0600, parent, (u32 *)0xFFE01218);
		debugfs_create_x32("ICPLB_DATA7", 0600, parent, (u32 *)0xFFE0121C);
		debugfs_create_x32("ICPLB_DATA8", 0600, parent, (u32 *)0xFFE01220);
		debugfs_create_x32("ICPLB_DATA9", 0600, parent, (u32 *)0xFFE01224);
		debugfs_create_x32("ICPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0100C);
		debugfs_create_x32("ICPLB_STATUS", 0600, parent, (u32 *)0xFFE01008);
		debugfs_create_x32("IMEM_CONTROL", 0600, parent, (u32 *)0xFFE01004);
		debugfs_create_x32("ITEST_COMMAND", 0600, parent, (u32 *)0xFFE01300);
		debugfs_create_x32("ITEST_DATA0", 0600, parent, (u32 *)0xFFE01400);
		debugfs_create_x32("ITEST_DATA1", 0600, parent, (u32 *)0xFFE01404);

		parent = debugfs_create_dir("L1 Data Memory Registers", top);
		debugfs_create_x32("DCPLB_ADDR0", 0600, parent, (u32 *)0xFFE00100);
		debugfs_create_x32("DCPLB_ADDR10", 0600, parent, (u32 *)0xFFE00128);
		debugfs_create_x32("DCPLB_ADDR11", 0600, parent, (u32 *)0xFFE0012C);
		debugfs_create_x32("DCPLB_ADDR12", 0600, parent, (u32 *)0xFFE00130);
		debugfs_create_x32("DCPLB_ADDR13", 0600, parent, (u32 *)0xFFE00134);
		debugfs_create_x32("DCPLB_ADDR14", 0600, parent, (u32 *)0xFFE00138);
		debugfs_create_x32("DCPLB_ADDR15", 0600, parent, (u32 *)0xFFE0013C);
		debugfs_create_x32("DCPLB_ADDR1", 0600, parent, (u32 *)0xFFE00104);
		debugfs_create_x32("DCPLB_ADDR2", 0600, parent, (u32 *)0xFFE00108);
		debugfs_create_x32("DCPLB_ADDR3", 0600, parent, (u32 *)0xFFE0010C);
		debugfs_create_x32("DCPLB_ADDR4", 0600, parent, (u32 *)0xFFE00110);
		debugfs_create_x32("DCPLB_ADDR5", 0600, parent, (u32 *)0xFFE00114);
		debugfs_create_x32("DCPLB_ADDR6", 0600, parent, (u32 *)0xFFE00118);
		debugfs_create_x32("DCPLB_ADDR7", 0600, parent, (u32 *)0xFFE0011C);
		debugfs_create_x32("DCPLB_ADDR8", 0600, parent, (u32 *)0xFFE00120);
		debugfs_create_x32("DCPLB_ADDR9", 0600, parent, (u32 *)0xFFE00124);
		debugfs_create_x32("DCPLB_DATA0", 0600, parent, (u32 *)0xFFE00200);
		debugfs_create_x32("DCPLB_DATA10", 0600, parent, (u32 *)0xFFE00228);
		debugfs_create_x32("DCPLB_DATA11", 0600, parent, (u32 *)0xFFE0022C);
		debugfs_create_x32("DCPLB_DATA12", 0600, parent, (u32 *)0xFFE00230);
		debugfs_create_x32("DCPLB_DATA13", 0600, parent, (u32 *)0xFFE00234);
		debugfs_create_x32("DCPLB_DATA14", 0600, parent, (u32 *)0xFFE00238);
		debugfs_create_x32("DCPLB_DATA15", 0600, parent, (u32 *)0xFFE0023C);
		debugfs_create_x32("DCPLB_DATA1", 0600, parent, (u32 *)0xFFE00204);
		debugfs_create_x32("DCPLB_DATA2", 0600, parent, (u32 *)0xFFE00208);
		debugfs_create_x32("DCPLB_DATA3", 0600, parent, (u32 *)0xFFE0020C);
		debugfs_create_x32("DCPLB_DATA4", 0600, parent, (u32 *)0xFFE00210);
		debugfs_create_x32("DCPLB_DATA5", 0600, parent, (u32 *)0xFFE00214);
		debugfs_create_x32("DCPLB_DATA6", 0600, parent, (u32 *)0xFFE00218);
		debugfs_create_x32("DCPLB_DATA7", 0600, parent, (u32 *)0xFFE0021C);
		debugfs_create_x32("DCPLB_DATA8", 0600, parent, (u32 *)0xFFE00220);
		debugfs_create_x32("DCPLB_DATA9", 0600, parent, (u32 *)0xFFE00224);
		debugfs_create_x32("DCPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0000C);
		debugfs_create_x32("DCPLB_STATUS", 0600, parent, (u32 *)0xFFE00008);
		debugfs_create_x32("DMEM_CONTROL", 0600, parent, (u32 *)0xFFE00004);
		debugfs_create_x32("DTEST_COMMAND", 0600, parent, (u32 *)0xFFE00300);
		debugfs_create_x32("DTEST_DATA0", 0600, parent, (u32 *)0xFFE00400);
		debugfs_create_x32("DTEST_DATA1", 0600, parent, (u32 *)0xFFE00404);
		debugfs_create_x32("SRAM_BASE_ADDR", 0600, parent, (u32 *)0xFFE00000);

		parent = debugfs_create_dir("MDMA Destination 0", top);
		debugfs_create_x16("MDMA_D0_CONFIG", 0600, parent, (u16 *)0xFFC00F08);
		debugfs_create_x32("MDMA_D0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F24);
		debugfs_create_x32("MDMA_D0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F20);
		debugfs_create_x16("MDMA_D0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F30);
		debugfs_create_x16("MDMA_D0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F38);
		debugfs_create_x16("MDMA_D0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F28);
		debugfs_create_x32("MDMA_D0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F00);
		debugfs_create_x16("MDMA_D0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F2C);
		debugfs_create_x32("MDMA_D0_START_ADDR", 0600, parent, (u32 *)0xFFC00F04);
		debugfs_create_x16("MDMA_D0_X_COUNT", 0600, parent, (u16 *)0xFFC00F10);
		debugfs_create_x16("MDMA_D0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F14);
		debugfs_create_x16("MDMA_D0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F18);
		debugfs_create_x16("MDMA_D0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F1C);

		parent = debugfs_create_dir("MDMA Destination 1", top);
		debugfs_create_x16("MDMA_D1_CONFIG", 0600, parent, (u16 *)0xFFC00F88);
		debugfs_create_x32("MDMA_D1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FA4);
		debugfs_create_x32("MDMA_D1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FA0);
		debugfs_create_x16("MDMA_D1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FB0);
		debugfs_create_x16("MDMA_D1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FB8);
		debugfs_create_x16("MDMA_D1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FA8);
		debugfs_create_x32("MDMA_D1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F80);
		debugfs_create_x16("MDMA_D1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FAC);
		debugfs_create_x32("MDMA_D1_START_ADDR", 0600, parent, (u32 *)0xFFC00F84);
		debugfs_create_x16("MDMA_D1_X_COUNT", 0600, parent, (u16 *)0xFFC00F90);
		debugfs_create_x16("MDMA_D1_X_MODIFY", 0600, parent, (u16 *)0xFFC00F94);
		debugfs_create_x16("MDMA_D1_Y_COUNT", 0600, parent, (u16 *)0xFFC00F98);
		debugfs_create_x16("MDMA_D1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F9C);

		parent = debugfs_create_dir("MDMA Source 0", top);
		debugfs_create_x16("MDMA_S0_CONFIG", 0600, parent, (u16 *)0xFFC00F48);
		debugfs_create_x32("MDMA_S0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F64);
		debugfs_create_x32("MDMA_S0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F60);
		debugfs_create_x16("MDMA_S0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F70);
		debugfs_create_x16("MDMA_S0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F78);
		debugfs_create_x16("MDMA_S0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F68);
		debugfs_create_x32("MDMA_S0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F40);
		debugfs_create_x16("MDMA_S0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F6C);
		debugfs_create_x32("MDMA_S0_START_ADDR", 0600, parent, (u32 *)0xFFC00F44);
		debugfs_create_x16("MDMA_S0_X_COUNT", 0600, parent, (u16 *)0xFFC00F50);
		debugfs_create_x16("MDMA_S0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F54);
		debugfs_create_x16("MDMA_S0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F58);
		debugfs_create_x16("MDMA_S0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F5C);

		parent = debugfs_create_dir("MDMA Source 1", top);
		debugfs_create_x16("MDMA_S1_CONFIG", 0600, parent, (u16 *)0xFFC00FC8);
		debugfs_create_x32("MDMA_S1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FE4);
		debugfs_create_x32("MDMA_S1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FE0);
		debugfs_create_x16("MDMA_S1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FF0);
		debugfs_create_x16("MDMA_S1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FF8);
		debugfs_create_x16("MDMA_S1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FE8);
		debugfs_create_x32("MDMA_S1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00FC0);
		debugfs_create_x16("MDMA_S1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FEC);
		debugfs_create_x32("MDMA_S1_START_ADDR", 0600, parent, (u32 *)0xFFC00FC4);
		debugfs_create_x16("MDMA_S1_X_COUNT", 0600, parent, (u16 *)0xFFC00FD0);
		debugfs_create_x16("MDMA_S1_X_MODIFY", 0600, parent, (u16 *)0xFFC00FD4);
		debugfs_create_x16("MDMA_S1_Y_COUNT", 0600, parent, (u16 *)0xFFC00FD8);
		debugfs_create_x16("MDMA_S1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00FDC);

		parent = debugfs_create_dir("NFC", top);
		debugfs_create_x16("NFC_ADDR", 0600, parent, (u16 *)0xFFC03740);
		debugfs_create_x16("NFC_CMD", 0600, parent, (u16 *)0xFFC03744);
		debugfs_create_x16("NFC_COUNT", 0600, parent, (u16 *)0xFFC03720);
		debugfs_create_x16("NFC_CTL", 0600, parent, (u16 *)0xFFC03700);
		debugfs_create_x16("NFC_DATA_RD", 0600, parent, (u16 *)0xFFC0374C);
		debugfs_create_x16("NFC_DATA_WR", 0600, parent, (u16 *)0xFFC03748);
		debugfs_create_x16("NFC_ECC0", 0600, parent, (u16 *)0xFFC03710);
		debugfs_create_x16("NFC_ECC1", 0600, parent, (u16 *)0xFFC03714);
		debugfs_create_x16("NFC_ECC2", 0600, parent, (u16 *)0xFFC03718);
		debugfs_create_x16("NFC_ECC3", 0600, parent, (u16 *)0xFFC0371C);
		debugfs_create_x16("NFC_IRQMASK", 0600, parent, (u16 *)0xFFC0370C);
		debugfs_create_x16("NFC_IRQSTAT", 0600, parent, (u16 *)0xFFC03708);
		debugfs_create_x16("NFC_PGCTL", 0600, parent, (u16 *)0xFFC03728);
		debugfs_create_x16("NFC_READ", 0600, parent, (u16 *)0xFFC0372C);
		debugfs_create_x16("NFC_RST", 0600, parent, (u16 *)0xFFC03724);
		debugfs_create_x16("NFC_STAT", 0600, parent, (u16 *)0xFFC03704);

		parent = debugfs_create_dir("NON-GPIO", top);
		debugfs_create_x16("NONGPIO_DRIVE", 0600, parent, (u16 *)0xFFC03280);
		debugfs_create_x16("NONGPIO_HYSTERESIS", 0600, parent, (u16 *)0xFFC03288);
		debugfs_create_x16("NONGPIO_SLEW", 0600, parent, (u16 *)0xFFC03284);

		parent = debugfs_create_dir("OTP", top);
		debugfs_create_x16("OTP_BEN", 0600, parent, (u16 *)0xFFC03604);
		debugfs_create_x16("OTP_CONTROL", 0600, parent, (u16 *)0xFFC03600);
		debugfs_create_x32("OTP_DATA0", 0600, parent, (u32 *)0xFFC03680);
		debugfs_create_x32("OTP_DATA1", 0600, parent, (u32 *)0xFFC03684);
		debugfs_create_x32("OTP_DATA2", 0600, parent, (u32 *)0xFFC03688);
		debugfs_create_x32("OTP_DATA3", 0600, parent, (u32 *)0xFFC0368C);
		debugfs_create_x16("OTP_STATUS", 0600, parent, (u16 *)0xFFC03608);
		debugfs_create_x32("OTP_TIMING", 0600, parent, (u32 *)0xFFC0360C);

		parent = debugfs_create_dir("PLL", top);
		debugfs_create_x16("PLL_CTL", 0600, parent, (u16 *)0xFFC00000);
		debugfs_create_x16("PLL_DIV", 0600, parent, (u16 *)0xFFC00004);
		debugfs_create_x16("PLL_LOCKCNT", 0600, parent, (u16 *)0xFFC00010);
		debugfs_create_x16("PLL_STAT", 0600, parent, (u16 *)0xFFC0000C);
		debugfs_create_x16("VR_CTL", 0600, parent, (u16 *)0xFFC00008);

		parent = debugfs_create_dir("PPI", top);
		debugfs_create_x16("PPI_CONTROL", 0600, parent, (u16 *)0xFFC01000);
		debugfs_create_x16("PPI_COUNT", 0600, parent, (u16 *)0xFFC01008);
		debugfs_create_x16("PPI_DELAY", 0600, parent, (u16 *)0xFFC0100C);
		debugfs_create_x16("PPI_FRAME", 0600, parent, (u16 *)0xFFC01010);
		debugfs_create_x16("PPI_STATUS", 0600, parent, (u16 *)0xFFC01004);

		parent = debugfs_create_dir("Performance Monitor", top);
		debugfs_create_x32("PFCNTR0", 0600, parent, (u32 *)0xFFE08100);
		debugfs_create_x32("PFCNTR1", 0600, parent, (u32 *)0xFFE08104);
		debugfs_create_x32("PFCTL", 0600, parent, (u32 *)0xFFE08000);

		parent = debugfs_create_dir("Pin Control", top);
		debugfs_create_x16("PORTF_FER", 0600, parent, (u16 *)0xFFC03200);
		debugfs_create_x16("PORTG_FER", 0600, parent, (u16 *)0xFFC03204);
		debugfs_create_x16("PORTH_FER", 0600, parent, (u16 *)0xFFC03208);

		parent = debugfs_create_dir("Port I-O", top);
		debugfs_create_x16("PORTFIO", 0600, parent, (u16 *)0xFFC00700);
		debugfs_create_x16("PORTFIO_BOTH", 0600, parent, (u16 *)0xFFC0073C);
		debugfs_create_x16("PORTFIO_CLEAR", 0600, parent, (u16 *)0xFFC00704);
		debugfs_create_x16("PORTFIO_DIR", 0600, parent, (u16 *)0xFFC00730);
		debugfs_create_x16("PORTFIO_EDGE", 0600, parent, (u16 *)0xFFC00738);
		debugfs_create_x16("PORTFIO_INEN", 0600, parent, (u16 *)0xFFC00740);
		debugfs_create_x16("PORTFIO_MASKA", 0600, parent, (u16 *)0xFFC00710);
		debugfs_create_x16("PORTFIO_MASKA_CLEAR", 0600, parent, (u16 *)0xFFC00714);
		debugfs_create_x16("PORTFIO_MASKA_SET", 0600, parent, (u16 *)0xFFC00718);
		debugfs_create_x16("PORTFIO_MASKA_TOGGLE", 0600, parent, (u16 *)0xFFC0071C);
		debugfs_create_x16("PORTFIO_MASKB", 0600, parent, (u16 *)0xFFC00720);
		debugfs_create_x16("PORTFIO_MASKB_CLEAR", 0600, parent, (u16 *)0xFFC00724);
		debugfs_create_x16("PORTFIO_MASKB_SET", 0600, parent, (u16 *)0xFFC00728);
		debugfs_create_x16("PORTFIO_MASKB_TOGGLE", 0600, parent, (u16 *)0xFFC0072C);
		debugfs_create_x16("PORTFIO_POLAR", 0600, parent, (u16 *)0xFFC00734);
		debugfs_create_x16("PORTFIO_SET", 0600, parent, (u16 *)0xFFC00708);
		debugfs_create_x16("PORTFIO_TOGGLE", 0600, parent, (u16 *)0xFFC0070C);
		debugfs_create_x16("PORTGIO", 0600, parent, (u16 *)0xFFC01500);
		debugfs_create_x16("PORTGIO_BOTH", 0600, parent, (u16 *)0xFFC0153C);
		debugfs_create_x16("PORTGIO_CLEAR", 0600, parent, (u16 *)0xFFC01504);
		debugfs_create_x16("PORTGIO_DIR", 0600, parent, (u16 *)0xFFC01530);
		debugfs_create_x16("PORTGIO_EDGE", 0600, parent, (u16 *)0xFFC01538);
		debugfs_create_x16("PORTGIO_INEN", 0600, parent, (u16 *)0xFFC01540);
		debugfs_create_x16("PORTGIO_MASKA", 0600, parent, (u16 *)0xFFC01510);
		debugfs_create_x16("PORTGIO_MASKA_CLEAR", 0600, parent, (u16 *)0xFFC01514);
		debugfs_create_x16("PORTGIO_MASKA_SET", 0600, parent, (u16 *)0xFFC01518);
		debugfs_create_x16("PORTGIO_MASKA_TOGGLE", 0600, parent, (u16 *)0xFFC0151C);
		debugfs_create_x16("PORTGIO_MASKB", 0600, parent, (u16 *)0xFFC01520);
		debugfs_create_x16("PORTGIO_MASKB_CLEAR", 0600, parent, (u16 *)0xFFC01524);
		debugfs_create_x16("PORTGIO_MASKB_SET", 0600, parent, (u16 *)0xFFC01528);
		debugfs_create_x16("PORTGIO_MASKB_TOGGLE", 0600, parent, (u16 *)0xFFC0152C);
		debugfs_create_x16("PORTGIO_POLAR", 0600, parent, (u16 *)0xFFC01534);
		debugfs_create_x16("PORTGIO_SET", 0600, parent, (u16 *)0xFFC01508);
		debugfs_create_x16("PORTGIO_TOGGLE", 0600, parent, (u16 *)0xFFC0150C);
		debugfs_create_x16("PORTHIO", 0600, parent, (u16 *)0xFFC01700);
		debugfs_create_x16("PORTHIO_BOTH", 0600, parent, (u16 *)0xFFC0173C);
		debugfs_create_x16("PORTHIO_CLEAR", 0600, parent, (u16 *)0xFFC01704);
		debugfs_create_x16("PORTHIO_DIR", 0600, parent, (u16 *)0xFFC01730);
		debugfs_create_x16("PORTHIO_EDGE", 0600, parent, (u16 *)0xFFC01738);
		debugfs_create_x16("PORTHIO_INEN", 0600, parent, (u16 *)0xFFC01740);
		debugfs_create_x16("PORTHIO_MASKA", 0600, parent, (u16 *)0xFFC01710);
		debugfs_create_x16("PORTHIO_MASKA_CLEAR", 0600, parent, (u16 *)0xFFC01714);
		debugfs_create_x16("PORTHIO_MASKA_SET", 0600, parent, (u16 *)0xFFC01718);
		debugfs_create_x16("PORTHIO_MASKA_TOGGLE", 0600, parent, (u16 *)0xFFC0171C);
		debugfs_create_x16("PORTHIO_MASKB", 0600, parent, (u16 *)0xFFC01720);
		debugfs_create_x16("PORTHIO_MASKB_CLEAR", 0600, parent, (u16 *)0xFFC01724);
		debugfs_create_x16("PORTHIO_MASKB_SET", 0600, parent, (u16 *)0xFFC01728);
		debugfs_create_x16("PORTHIO_MASKB_TOGGLE", 0600, parent, (u16 *)0xFFC0172C);
		debugfs_create_x16("PORTHIO_POLAR", 0600, parent, (u16 *)0xFFC01734);
		debugfs_create_x16("PORTHIO_SET", 0600, parent, (u16 *)0xFFC01708);
		debugfs_create_x16("PORTHIO_TOGGLE", 0600, parent, (u16 *)0xFFC0170C);

		parent = debugfs_create_dir("RTC", top);
		debugfs_create_x32("RTC_ALARM", 0600, parent, (u32 *)0xFFC00310);
		debugfs_create_x16("RTC_ICTL", 0600, parent, (u16 *)0xFFC00304);
		debugfs_create_x16("RTC_ISTAT", 0600, parent, (u16 *)0xFFC00308);
		debugfs_create_x16("RTC_PREN", 0600, parent, (u16 *)0xFFC00314);
		debugfs_create_x32("RTC_STAT", 0600, parent, (u32 *)0xFFC00300);
		debugfs_create_x16("RTC_SWCNT", 0600, parent, (u16 *)0xFFC0030C);

		parent = debugfs_create_dir("SPI", top);
		debugfs_create_x16("SPI_BAUD", 0600, parent, (u16 *)0xFFC00514);
		debugfs_create_x16("SPI_CTL", 0600, parent, (u16 *)0xFFC00500);
		debugfs_create_x16("SPI_FLG", 0600, parent, (u16 *)0xFFC00504);
		debugfs_create_x16("SPI_RDBR", 0600, parent, (u16 *)0xFFC00510);
		debugfs_create_x16("SPI_SHADOW", 0600, parent, (u16 *)0xFFC00518);
		debugfs_create_x16("SPI_STAT", 0600, parent, (u16 *)0xFFC00508);
		debugfs_create_x16("SPI_TDBR", 0600, parent, (u16 *)0xFFC0050C);

		parent = debugfs_create_dir("SPORT", top);
		debugfs_create_x16("SPORT0_CHNL", 0600, parent, (u16 *)0xFFC00834);
		debugfs_create_x16("SPORT0_MCMC1", 0600, parent, (u16 *)0xFFC00838);
		debugfs_create_x16("SPORT0_MCMC2", 0600, parent, (u16 *)0xFFC0083C);
		debugfs_create_x32("SPORT0_MRCS0", 0600, parent, (u32 *)0xFFC00850);
		debugfs_create_x32("SPORT0_MRCS1", 0600, parent, (u32 *)0xFFC00854);
		debugfs_create_x32("SPORT0_MRCS2", 0600, parent, (u32 *)0xFFC00858);
		debugfs_create_x32("SPORT0_MRCS3", 0600, parent, (u32 *)0xFFC0085C);
		debugfs_create_x32("SPORT0_MTCS0", 0600, parent, (u32 *)0xFFC00840);
		debugfs_create_x32("SPORT0_MTCS1", 0600, parent, (u32 *)0xFFC00844);
		debugfs_create_x32("SPORT0_MTCS2", 0600, parent, (u32 *)0xFFC00848);
		debugfs_create_x32("SPORT0_MTCS3", 0600, parent, (u32 *)0xFFC0084C);
		debugfs_create_x16("SPORT0_RCLKDIV", 0600, parent, (u16 *)0xFFC00828);
		debugfs_create_x16("SPORT0_RCR1", 0600, parent, (u16 *)0xFFC00820);
		debugfs_create_x16("SPORT0_RCR2", 0600, parent, (u16 *)0xFFC00824);
		debugfs_create_x16("SPORT0_RFSDIV", 0600, parent, (u16 *)0xFFC0082C);
		debugfs_create_x32("SPORT0_RX", 0600, parent, (u32 *)0xFFC00818);
		debugfs_create_x16("SPORT0_STAT", 0600, parent, (u16 *)0xFFC00830);
		debugfs_create_x16("SPORT0_TCLKDIV", 0600, parent, (u16 *)0xFFC00808);
		debugfs_create_x16("SPORT0_TCR1", 0600, parent, (u16 *)0xFFC00800);
		debugfs_create_x16("SPORT0_TCR2", 0600, parent, (u16 *)0xFFC00804);
		debugfs_create_x16("SPORT0_TFSDIV", 0600, parent, (u16 *)0xFFC0080C);
		debugfs_create_x32("SPORT0_TX", 0600, parent, (u32 *)0xFFC00810);
		debugfs_create_x16("SPORT1_CHNL", 0600, parent, (u16 *)0xFFC00934);
		debugfs_create_x16("SPORT1_MCMC1", 0600, parent, (u16 *)0xFFC00938);
		debugfs_create_x16("SPORT1_MCMC2", 0600, parent, (u16 *)0xFFC0093C);
		debugfs_create_x32("SPORT1_MRCS0", 0600, parent, (u32 *)0xFFC00950);
		debugfs_create_x32("SPORT1_MRCS1", 0600, parent, (u32 *)0xFFC00954);
		debugfs_create_x32("SPORT1_MRCS2", 0600, parent, (u32 *)0xFFC00958);
		debugfs_create_x32("SPORT1_MRCS3", 0600, parent, (u32 *)0xFFC0095C);
		debugfs_create_x32("SPORT1_MTCS0", 0600, parent, (u32 *)0xFFC00940);
		debugfs_create_x32("SPORT1_MTCS1", 0600, parent, (u32 *)0xFFC00944);
		debugfs_create_x32("SPORT1_MTCS2", 0600, parent, (u32 *)0xFFC00948);
		debugfs_create_x32("SPORT1_MTCS3", 0600, parent, (u32 *)0xFFC0094C);
		debugfs_create_x16("SPORT1_RCLKDIV", 0600, parent, (u16 *)0xFFC00928);
		debugfs_create_x16("SPORT1_RCR1", 0600, parent, (u16 *)0xFFC00920);
		debugfs_create_x16("SPORT1_RCR2", 0600, parent, (u16 *)0xFFC00924);
		debugfs_create_x16("SPORT1_RFSDIV", 0600, parent, (u16 *)0xFFC0092C);
		debugfs_create_x32("SPORT1_RX", 0600, parent, (u32 *)0xFFC00918);
		debugfs_create_x16("SPORT1_STAT", 0600, parent, (u16 *)0xFFC00930);
		debugfs_create_x16("SPORT1_TCLKDIV", 0600, parent, (u16 *)0xFFC00908);
		debugfs_create_x16("SPORT1_TCR1", 0600, parent, (u16 *)0xFFC00900);
		debugfs_create_x16("SPORT1_TCR2", 0600, parent, (u16 *)0xFFC00904);
		debugfs_create_x16("SPORT1_TFSDIV", 0600, parent, (u16 *)0xFFC0090C);
		debugfs_create_x32("SPORT1_TX", 0600, parent, (u32 *)0xFFC00910);

		parent = debugfs_create_dir("Security", top);
		debugfs_create_x16("SECURE_CONTROL", 0600, parent, (u16 *)0xFFC03624);
		debugfs_create_x16("SECURE_STATUS", 0600, parent, (u16 *)0xFFC03628);
		debugfs_create_x32("SECURE_SYSSWT", 0600, parent, (u32 *)0xFFC03620);

		parent = debugfs_create_dir("System Interrupt Controller Register File", top);
		debugfs_create_x32("SIC_IAR0", 0600, parent, (u32 *)0xFFC00110);
		debugfs_create_x32("SIC_IAR1", 0600, parent, (u32 *)0xFFC00114);
		debugfs_create_x32("SIC_IAR2", 0600, parent, (u32 *)0xFFC00118);
		debugfs_create_x32("SIC_IAR3", 0600, parent, (u32 *)0xFFC0011C);
		debugfs_create_x32("SIC_IAR4", 0600, parent, (u32 *)0xFFC00150);
		debugfs_create_x32("SIC_IAR5", 0600, parent, (u32 *)0xFFC00154);
		debugfs_create_x32("SIC_IAR6", 0600, parent, (u32 *)0xFFC00158);
		debugfs_create_x32("SIC_IAR7", 0600, parent, (u32 *)0xFFC0015C);
		debugfs_create_x32("SIC_IMASK0", 0600, parent, (u32 *)0xFFC0010C);
		debugfs_create_x32("SIC_IMASK1", 0600, parent, (u32 *)0xFFC0014C);
		debugfs_create_x32("SIC_ISR0", 0600, parent, (u32 *)0xFFC00120);
		debugfs_create_x32("SIC_ISR1", 0600, parent, (u32 *)0xFFC00160);
		debugfs_create_x32("SIC_IWR0", 0600, parent, (u32 *)0xFFC00124);
		debugfs_create_x32("SIC_IWR1", 0600, parent, (u32 *)0xFFC00164);
		debugfs_create_x32("SIC_RVECT", 0600, parent, (u32 *)0xFFC00108);

		parent = debugfs_create_dir("System Reset and Interrupt Control Registers", top);
		debugfs_create_x16("SWRST", 0600, parent, (u16 *)0xFFC00100);
		debugfs_create_x16("SYSCR", 0600, parent, (u16 *)0xFFC00104);

		parent = debugfs_create_dir("TWI", top);
		debugfs_create_x16("TWI_CLKDIV", 0600, parent, (u16 *)0xFFC01400);
		debugfs_create_x16("TWI_CONTROL", 0600, parent, (u16 *)0xFFC01404);
		debugfs_create_x16("TWI_FIFO_CTL", 0600, parent, (u16 *)0xFFC01428);
		debugfs_create_x16("TWI_FIFO_STAT", 0600, parent, (u16 *)0xFFC0142C);
		debugfs_create_x16("TWI_INT_MASK", 0600, parent, (u16 *)0xFFC01424);
		debugfs_create_x16("TWI_INT_STAT", 0600, parent, (u16 *)0xFFC01420);
		debugfs_create_x16("TWI_MASTER_ADDR", 0600, parent, (u16 *)0xFFC0141C);
		debugfs_create_x16("TWI_MASTER_CTL", 0600, parent, (u16 *)0xFFC01414);
		debugfs_create_x16("TWI_MASTER_STAT", 0600, parent, (u16 *)0xFFC01418);
		debugfs_create_x16("TWI_RCV_DATA16", 0600, parent, (u16 *)0xFFC0148C);
		debugfs_create_x16("TWI_RCV_DATA8", 0600, parent, (u16 *)0xFFC01488);
		debugfs_create_x16("TWI_SLAVE_ADDR", 0600, parent, (u16 *)0xFFC01410);
		debugfs_create_x16("TWI_SLAVE_CTL", 0600, parent, (u16 *)0xFFC01408);
		debugfs_create_x16("TWI_SLAVE_STAT", 0600, parent, (u16 *)0xFFC0140C);
		debugfs_create_x16("TWI_XMT_DATA16", 0600, parent, (u16 *)0xFFC01484);
		debugfs_create_x16("TWI_XMT_DATA8", 0600, parent, (u16 *)0xFFC01480);

		parent = debugfs_create_dir("Timer Registers", top);
		debugfs_create_x16("TIMER0_CONFIG", 0600, parent, (u16 *)0xFFC00600);
		debugfs_create_x32("TIMER0_COUNTER", 0600, parent, (u32 *)0xFFC00604);
		debugfs_create_x32("TIMER0_PERIOD", 0600, parent, (u32 *)0xFFC00608);
		debugfs_create_x32("TIMER0_WIDTH", 0600, parent, (u32 *)0xFFC0060C);
		debugfs_create_x16("TIMER1_CONFIG", 0600, parent, (u16 *)0xFFC00610);
		debugfs_create_x32("TIMER1_COUNTER", 0600, parent, (u32 *)0xFFC00614);
		debugfs_create_x32("TIMER1_PERIOD", 0600, parent, (u32 *)0xFFC00618);
		debugfs_create_x32("TIMER1_WIDTH", 0600, parent, (u32 *)0xFFC0061C);
		debugfs_create_x16("TIMER2_CONFIG", 0600, parent, (u16 *)0xFFC00620);
		debugfs_create_x32("TIMER2_COUNTER", 0600, parent, (u32 *)0xFFC00624);
		debugfs_create_x32("TIMER2_PERIOD", 0600, parent, (u32 *)0xFFC00628);
		debugfs_create_x32("TIMER2_WIDTH", 0600, parent, (u32 *)0xFFC0062C);
		debugfs_create_x16("TIMER3_CONFIG", 0600, parent, (u16 *)0xFFC00630);
		debugfs_create_x32("TIMER3_COUNTER", 0600, parent, (u32 *)0xFFC00634);
		debugfs_create_x32("TIMER3_PERIOD", 0600, parent, (u32 *)0xFFC00638);
		debugfs_create_x32("TIMER3_WIDTH", 0600, parent, (u32 *)0xFFC0063C);
		debugfs_create_x16("TIMER4_CONFIG", 0600, parent, (u16 *)0xFFC00640);
		debugfs_create_x32("TIMER4_COUNTER", 0600, parent, (u32 *)0xFFC00644);
		debugfs_create_x32("TIMER4_PERIOD", 0600, parent, (u32 *)0xFFC00648);
		debugfs_create_x32("TIMER4_WIDTH", 0600, parent, (u32 *)0xFFC0064C);
		debugfs_create_x16("TIMER5_CONFIG", 0600, parent, (u16 *)0xFFC00650);
		debugfs_create_x32("TIMER5_COUNTER", 0600, parent, (u32 *)0xFFC00654);
		debugfs_create_x32("TIMER5_PERIOD", 0600, parent, (u32 *)0xFFC00658);
		debugfs_create_x32("TIMER5_WIDTH", 0600, parent, (u32 *)0xFFC0065C);
		debugfs_create_x16("TIMER6_CONFIG", 0600, parent, (u16 *)0xFFC00660);
		debugfs_create_x32("TIMER6_COUNTER", 0600, parent, (u32 *)0xFFC00664);
		debugfs_create_x32("TIMER6_PERIOD", 0600, parent, (u32 *)0xFFC00668);
		debugfs_create_x32("TIMER6_WIDTH", 0600, parent, (u32 *)0xFFC0066C);
		debugfs_create_x16("TIMER7_CONFIG", 0600, parent, (u16 *)0xFFC00670);
		debugfs_create_x32("TIMER7_COUNTER", 0600, parent, (u32 *)0xFFC00674);
		debugfs_create_x32("TIMER7_PERIOD", 0600, parent, (u32 *)0xFFC00678);
		debugfs_create_x32("TIMER7_WIDTH", 0600, parent, (u32 *)0xFFC0067C);
		debugfs_create_x16("TIMER_DISABLE", 0600, parent, (u16 *)0xFFC00684);
		debugfs_create_x16("TIMER_ENABLE", 0600, parent, (u16 *)0xFFC00680);
		debugfs_create_x32("TIMER_STATUS", 0600, parent, (u32 *)0xFFC00688);

		parent = debugfs_create_dir("Trace Unit", top);
		debugfs_create_x32("TBUF", 0600, parent, (u32 *)0xFFE06100);
		debugfs_create_x32("TBUFCTL", 0600, parent, (u32 *)0xFFE06000);
		debugfs_create_x32("TBUFSTAT", 0600, parent, (u32 *)0xFFE06004);

		parent = debugfs_create_dir("UART", top);
		debugfs_create_x16("UART0_DLH", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART0_DLL", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART0_GCTL", 0600, parent, (u16 *)0xFFC00424);
		debugfs_create_x16("UART0_IER", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART0_IIR", 0600, parent, (u16 *)0xFFC00408);
		debugfs_create_x16("UART0_LCR", 0600, parent, (u16 *)0xFFC0040C);
		debugfs_create_x16("UART0_LSR", 0600, parent, (u16 *)0xFFC00414);
		debugfs_create_x16("UART0_MCR", 0600, parent, (u16 *)0xFFC00410);
		debugfs_create_x16("UART0_MSR", 0600, parent, (u16 *)0xFFC00418);
		debugfs_create_x16("UART0_RBR", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART0_SCR", 0600, parent, (u16 *)0xFFC0041C);
		debugfs_create_x16("UART0_THR", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART1_DLH", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("UART1_DLL", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART1_GCTL", 0600, parent, (u16 *)0xFFC02024);
		debugfs_create_x16("UART1_IER", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("UART1_IIR", 0600, parent, (u16 *)0xFFC02008);
		debugfs_create_x16("UART1_LCR", 0600, parent, (u16 *)0xFFC0200C);
		debugfs_create_x16("UART1_LSR", 0600, parent, (u16 *)0xFFC02014);
		debugfs_create_x16("UART1_MCR", 0600, parent, (u16 *)0xFFC02010);
		debugfs_create_x16("UART1_MSR", 0600, parent, (u16 *)0xFFC02018);
		debugfs_create_x16("UART1_RBR", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART1_SCR", 0600, parent, (u16 *)0xFFC0201C);
		debugfs_create_x16("UART1_THR", 0600, parent, (u16 *)0xFFC02000);

		parent = debugfs_create_dir("USB", top);
		debugfs_create_x16("USB_APHY_CALIB", 0600, parent, (u16 *)0xFFC039E4);
		debugfs_create_x16("USB_APHY_CNTRL2", 0600, parent, (u16 *)0xFFC039E8);
		debugfs_create_x16("USB_APHY_CNTRL", 0600, parent, (u16 *)0xFFC039E0);
		debugfs_create_x16("USB_COUNT0", 0600, parent, (u16 *)0xFFC03850);
		debugfs_create_x16("USB_CSR0", 0600, parent, (u16 *)0xFFC03844);
		debugfs_create_x16("USB_DMA0_ADDRHIGH", 0600, parent, (u16 *)0xFFC03C0C);
		debugfs_create_x16("USB_DMA0_ADDRLOW", 0600, parent, (u16 *)0xFFC03C08);
		debugfs_create_x16("USB_DMA0_CONTROL", 0600, parent, (u16 *)0xFFC03C04);
		debugfs_create_x16("USB_DMA0_COUNTHIGH", 0600, parent, (u16 *)0xFFC03C14);
		debugfs_create_x16("USB_DMA0_COUNTLOW", 0600, parent, (u16 *)0xFFC03C10);
		debugfs_create_x16("USB_DMA1_ADDRHIGH", 0600, parent, (u16 *)0xFFC03C2C);
		debugfs_create_x16("USB_DMA1_ADDRLOW", 0600, parent, (u16 *)0xFFC03C28);
		debugfs_create_x16("USB_DMA1_CONTROL", 0600, parent, (u16 *)0xFFC03C24);
		debugfs_create_x16("USB_DMA1_COUNTHIGH", 0600, parent, (u16 *)0xFFC03C34);
		debugfs_create_x16("USB_DMA1_COUNTLOW", 0600, parent, (u16 *)0xFFC03C30);
		debugfs_create_x16("USB_DMA2_ADDRHIGH", 0600, parent, (u16 *)0xFFC03C4C);
		debugfs_create_x16("USB_DMA2_ADDRLOW", 0600, parent, (u16 *)0xFFC03C48);
		debugfs_create_x16("USB_DMA2_CONTROL", 0600, parent, (u16 *)0xFFC03C44);
		debugfs_create_x16("USB_DMA2_COUNTHIGH", 0600, parent, (u16 *)0xFFC03C54);
		debugfs_create_x16("USB_DMA2_COUNTLOW", 0600, parent, (u16 *)0xFFC03C50);
		debugfs_create_x16("USB_DMA3_ADDRHIGH", 0600, parent, (u16 *)0xFFC03C6C);
		debugfs_create_x16("USB_DMA3_ADDRLOW", 0600, parent, (u16 *)0xFFC03C68);
		debugfs_create_x16("USB_DMA3_CONTROL", 0600, parent, (u16 *)0xFFC03C64);
		debugfs_create_x16("USB_DMA3_COUNTHIGH", 0600, parent, (u16 *)0xFFC03C74);
		debugfs_create_x16("USB_DMA3_COUNTLOW", 0600, parent, (u16 *)0xFFC03C70);
		debugfs_create_x16("USB_DMA4_ADDRHIGH", 0600, parent, (u16 *)0xFFC03C8C);
		debugfs_create_x16("USB_DMA4_ADDRLOW", 0600, parent, (u16 *)0xFFC03C88);
		debugfs_create_x16("USB_DMA4_CONTROL", 0600, parent, (u16 *)0xFFC03C84);
		debugfs_create_x16("USB_DMA4_COUNTHIGH", 0600, parent, (u16 *)0xFFC03C94);
		debugfs_create_x16("USB_DMA4_COUNTLOW", 0600, parent, (u16 *)0xFFC03C90);
		debugfs_create_x16("USB_DMA5_ADDRHIGH", 0600, parent, (u16 *)0xFFC03CAC);
		debugfs_create_x16("USB_DMA5_ADDRLOW", 0600, parent, (u16 *)0xFFC03CA8);
		debugfs_create_x16("USB_DMA5_CONTROL", 0600, parent, (u16 *)0xFFC03CA4);
		debugfs_create_x16("USB_DMA5_COUNTHIGH", 0600, parent, (u16 *)0xFFC03CB4);
		debugfs_create_x16("USB_DMA5_COUNTLOW", 0600, parent, (u16 *)0xFFC03CB0);
		debugfs_create_x16("USB_DMA6_ADDRHIGH", 0600, parent, (u16 *)0xFFC03CCC);
		debugfs_create_x16("USB_DMA6_ADDRLOW", 0600, parent, (u16 *)0xFFC03CC8);
		debugfs_create_x16("USB_DMA6_CONTROL", 0600, parent, (u16 *)0xFFC03CC4);
		debugfs_create_x16("USB_DMA6_COUNTHIGH", 0600, parent, (u16 *)0xFFC03CD4);
		debugfs_create_x16("USB_DMA6_COUNTLOW", 0600, parent, (u16 *)0xFFC03CD0);
		debugfs_create_x16("USB_DMA7_ADDRHIGH", 0600, parent, (u16 *)0xFFC03CEC);
		debugfs_create_x16("USB_DMA7_ADDRLOW", 0600, parent, (u16 *)0xFFC03CE8);
		debugfs_create_x16("USB_DMA7_CONTROL", 0600, parent, (u16 *)0xFFC03CE4);
		debugfs_create_x16("USB_DMA7_COUNTHIGH", 0600, parent, (u16 *)0xFFC03CF4);
		debugfs_create_x16("USB_DMA7_COUNTLOW", 0600, parent, (u16 *)0xFFC03CF0);
		debugfs_create_x16("USB_DMA_INTERRUPT", 0600, parent, (u16 *)0xFFC03C00);
		debugfs_create_x16("USB_EP0_FIFO", 0600, parent, (u16 *)0xFFC03880);
		debugfs_create_x16("USB_EP1_FIFO", 0600, parent, (u16 *)0xFFC03888);
		debugfs_create_x16("USB_EP2_FIFO", 0600, parent, (u16 *)0xFFC03890);
		debugfs_create_x16("USB_EP3_FIFO", 0600, parent, (u16 *)0xFFC03898);
		debugfs_create_x16("USB_EP4_FIFO", 0600, parent, (u16 *)0xFFC038A0);
		debugfs_create_x16("USB_EP5_FIFO", 0600, parent, (u16 *)0xFFC038A8);
		debugfs_create_x16("USB_EP6_FIFO", 0600, parent, (u16 *)0xFFC038B0);
		debugfs_create_x16("USB_EP7_FIFO", 0600, parent, (u16 *)0xFFC038B8);
		debugfs_create_x16("USB_EP_NI0_RXCOUNT", 0600, parent, (u16 *)0xFFC03A10);
		debugfs_create_x16("USB_EP_NI0_RXCSR", 0600, parent, (u16 *)0xFFC03A0C);
		debugfs_create_x16("USB_EP_NI0_RXINTERVAL", 0600, parent, (u16 *)0xFFC03A20);
		debugfs_create_x16("USB_EP_NI0_RXMAXP", 0600, parent, (u16 *)0xFFC03A08);
		debugfs_create_x16("USB_EP_NI0_RXTYPE", 0600, parent, (u16 *)0xFFC03A1C);
		debugfs_create_x16("USB_EP_NI0_TXCOUNT", 0600, parent, (u16 *)0xFFC03A28);
		debugfs_create_x16("USB_EP_NI0_TXCSR", 0600, parent, (u16 *)0xFFC03A04);
		debugfs_create_x16("USB_EP_NI0_TXINTERVAL", 0600, parent, (u16 *)0xFFC03A18);
		debugfs_create_x16("USB_EP_NI0_TXMAXP", 0600, parent, (u16 *)0xFFC03A00);
		debugfs_create_x16("USB_EP_NI0_TXTYPE", 0600, parent, (u16 *)0xFFC03A14);
		debugfs_create_x16("USB_EP_NI1_RXCOUNT", 0600, parent, (u16 *)0xFFC03A50);
		debugfs_create_x16("USB_EP_NI1_RXCSR", 0600, parent, (u16 *)0xFFC03A4C);
		debugfs_create_x16("USB_EP_NI1_RXINTERVAL", 0600, parent, (u16 *)0xFFC03A60);
		debugfs_create_x16("USB_EP_NI1_RXMAXP", 0600, parent, (u16 *)0xFFC03A48);
		debugfs_create_x16("USB_EP_NI1_RXTYPE", 0600, parent, (u16 *)0xFFC03A5C);
		debugfs_create_x16("USB_EP_NI1_TXCOUNT", 0600, parent, (u16 *)0xFFC03A68);
		debugfs_create_x16("USB_EP_NI1_TXCSR", 0600, parent, (u16 *)0xFFC03A44);
		debugfs_create_x16("USB_EP_NI1_TXINTERVAL", 0600, parent, (u16 *)0xFFC03A58);
		debugfs_create_x16("USB_EP_NI1_TXMAXP", 0600, parent, (u16 *)0xFFC03A40);
		debugfs_create_x16("USB_EP_NI1_TXTYPE", 0600, parent, (u16 *)0xFFC03A54);
		debugfs_create_x16("USB_EP_NI2_RXCOUNT", 0600, parent, (u16 *)0xFFC03A90);
		debugfs_create_x16("USB_EP_NI2_RXCSR", 0600, parent, (u16 *)0xFFC03A8C);
		debugfs_create_x16("USB_EP_NI2_RXINTERVAL", 0600, parent, (u16 *)0xFFC03AA0);
		debugfs_create_x16("USB_EP_NI2_RXMAXP", 0600, parent, (u16 *)0xFFC03A88);
		debugfs_create_x16("USB_EP_NI2_RXTYPE", 0600, parent, (u16 *)0xFFC03A9C);
		debugfs_create_x16("USB_EP_NI2_TXCOUNT", 0600, parent, (u16 *)0xFFC03AA8);
		debugfs_create_x16("USB_EP_NI2_TXCSR", 0600, parent, (u16 *)0xFFC03A84);
		debugfs_create_x16("USB_EP_NI2_TXINTERVAL", 0600, parent, (u16 *)0xFFC03A98);
		debugfs_create_x16("USB_EP_NI2_TXMAXP", 0600, parent, (u16 *)0xFFC03A80);
		debugfs_create_x16("USB_EP_NI2_TXTYPE", 0600, parent, (u16 *)0xFFC03A94);
		debugfs_create_x16("USB_EP_NI3_RXCOUNT", 0600, parent, (u16 *)0xFFC03AD0);
		debugfs_create_x16("USB_EP_NI3_RXCSR", 0600, parent, (u16 *)0xFFC03ACC);
		debugfs_create_x16("USB_EP_NI3_RXINTERVAL", 0600, parent, (u16 *)0xFFC03AE0);
		debugfs_create_x16("USB_EP_NI3_RXMAXP", 0600, parent, (u16 *)0xFFC03AC8);
		debugfs_create_x16("USB_EP_NI3_RXTYPE", 0600, parent, (u16 *)0xFFC03ADC);
		debugfs_create_x16("USB_EP_NI3_TXCOUNT", 0600, parent, (u16 *)0xFFC03AE8);
		debugfs_create_x16("USB_EP_NI3_TXCSR", 0600, parent, (u16 *)0xFFC03AC4);
		debugfs_create_x16("USB_EP_NI3_TXINTERVAL", 0600, parent, (u16 *)0xFFC03AD8);
		debugfs_create_x16("USB_EP_NI3_TXMAXP", 0600, parent, (u16 *)0xFFC03AC0);
		debugfs_create_x16("USB_EP_NI3_TXTYPE", 0600, parent, (u16 *)0xFFC03AD4);
		debugfs_create_x16("USB_EP_NI4_RXCOUNT", 0600, parent, (u16 *)0xFFC03B10);
		debugfs_create_x16("USB_EP_NI4_RXCSR", 0600, parent, (u16 *)0xFFC03B0C);
		debugfs_create_x16("USB_EP_NI4_RXINTERVAL", 0600, parent, (u16 *)0xFFC03B20);
		debugfs_create_x16("USB_EP_NI4_RXMAXP", 0600, parent, (u16 *)0xFFC03B08);
		debugfs_create_x16("USB_EP_NI4_RXTYPE", 0600, parent, (u16 *)0xFFC03B1C);
		debugfs_create_x16("USB_EP_NI4_TXCOUNT", 0600, parent, (u16 *)0xFFC03B28);
		debugfs_create_x16("USB_EP_NI4_TXCSR", 0600, parent, (u16 *)0xFFC03B04);
		debugfs_create_x16("USB_EP_NI4_TXINTERVAL", 0600, parent, (u16 *)0xFFC03B18);
		debugfs_create_x16("USB_EP_NI4_TXMAXP", 0600, parent, (u16 *)0xFFC03B00);
		debugfs_create_x16("USB_EP_NI4_TXTYPE", 0600, parent, (u16 *)0xFFC03B14);
		debugfs_create_x16("USB_EP_NI5_RXCOUNT", 0600, parent, (u16 *)0xFFC03B50);
		debugfs_create_x16("USB_EP_NI5_RXCSR", 0600, parent, (u16 *)0xFFC03B4C);
		debugfs_create_x16("USB_EP_NI5_RXINTERVAL", 0600, parent, (u16 *)0xFFC03B60);
		debugfs_create_x16("USB_EP_NI5_RXMAXP", 0600, parent, (u16 *)0xFFC03B48);
		debugfs_create_x16("USB_EP_NI5_RXTYPE", 0600, parent, (u16 *)0xFFC03B5C);
		debugfs_create_x16("USB_EP_NI5_TXCOUNT", 0600, parent, (u16 *)0xFFC03B68);
		debugfs_create_x16("USB_EP_NI5_TXCSR", 0600, parent, (u16 *)0xFFC03B44);
		debugfs_create_x16("USB_EP_NI5_TXINTERVAL", 0600, parent, (u16 *)0xFFC03B58);
		debugfs_create_x16("USB_EP_NI5_TXMAXP", 0600, parent, (u16 *)0xFFC03B40);
		debugfs_create_x16("USB_EP_NI5_TXTYPE", 0600, parent, (u16 *)0xFFC03B54);
		debugfs_create_x16("USB_EP_NI6_RXCOUNT", 0600, parent, (u16 *)0xFFC03B90);
		debugfs_create_x16("USB_EP_NI6_RXCSR", 0600, parent, (u16 *)0xFFC03B8C);
		debugfs_create_x16("USB_EP_NI6_RXINTERVAL", 0600, parent, (u16 *)0xFFC03BA0);
		debugfs_create_x16("USB_EP_NI6_RXMAXP", 0600, parent, (u16 *)0xFFC03B88);
		debugfs_create_x16("USB_EP_NI6_RXTYPE", 0600, parent, (u16 *)0xFFC03B9C);
		debugfs_create_x16("USB_EP_NI6_TXCOUNT", 0600, parent, (u16 *)0xFFC03BA8);
		debugfs_create_x16("USB_EP_NI6_TXCSR", 0600, parent, (u16 *)0xFFC03B84);
		debugfs_create_x16("USB_EP_NI6_TXINTERVAL", 0600, parent, (u16 *)0xFFC03B98);
		debugfs_create_x16("USB_EP_NI6_TXMAXP", 0600, parent, (u16 *)0xFFC03B80);
		debugfs_create_x16("USB_EP_NI6_TXTYPE", 0600, parent, (u16 *)0xFFC03B94);
		debugfs_create_x16("USB_EP_NI7_RXCOUNT", 0600, parent, (u16 *)0xFFC03BD0);
		debugfs_create_x16("USB_EP_NI7_RXCSR", 0600, parent, (u16 *)0xFFC03BCC);
		debugfs_create_x16("USB_EP_NI7_RXINTERVAL", 0600, parent, (u16 *)0xFFC03BF0);
		debugfs_create_x16("USB_EP_NI7_RXMAXP", 0600, parent, (u16 *)0xFFC03BC8);
		debugfs_create_x16("USB_EP_NI7_RXTYPE", 0600, parent, (u16 *)0xFFC03BDC);
		debugfs_create_x16("USB_EP_NI7_TXCOUNT", 0600, parent, (u16 *)0xFFC03BF8);
		debugfs_create_x16("USB_EP_NI7_TXCSR", 0600, parent, (u16 *)0xFFC03BC4);
		debugfs_create_x16("USB_EP_NI7_TXINTERVAL", 0600, parent, (u16 *)0xFFC03BD8);
		debugfs_create_x16("USB_EP_NI7_TXMAXP", 0600, parent, (u16 *)0xFFC03BC0);
		debugfs_create_x16("USB_EP_NI7_TXTYPE", 0600, parent, (u16 *)0xFFC03BD4);
		debugfs_create_x16("USB_FADDR", 0600, parent, (u16 *)0xFFC03800);
		debugfs_create_x16("USB_FRAME", 0600, parent, (u16 *)0xFFC03820);
		debugfs_create_x16("USB_FS_EOF1", 0600, parent, (u16 *)0xFFC03954);
		debugfs_create_x16("USB_GLOBAL_CTL", 0600, parent, (u16 *)0xFFC03830);
		debugfs_create_x16("USB_GLOBINTR", 0600, parent, (u16 *)0xFFC0382C);
		debugfs_create_x16("USB_HS_EOF1", 0600, parent, (u16 *)0xFFC03950);
		debugfs_create_x16("USB_INDEX", 0600, parent, (u16 *)0xFFC03824);
		debugfs_create_x16("USB_INTRRX", 0600, parent, (u16 *)0xFFC0380C);
		debugfs_create_x16("USB_INTRRXE", 0600, parent, (u16 *)0xFFC03814);
		debugfs_create_x16("USB_INTRTX", 0600, parent, (u16 *)0xFFC03808);
		debugfs_create_x16("USB_INTRTXE", 0600, parent, (u16 *)0xFFC03810);
		debugfs_create_x16("USB_INTRUSB", 0600, parent, (u16 *)0xFFC03818);
		debugfs_create_x16("USB_INTRUSBE", 0600, parent, (u16 *)0xFFC0381C);
		debugfs_create_x16("USB_LINKINFO", 0600, parent, (u16 *)0xFFC03948);
		debugfs_create_x16("USB_LS_EOF1", 0600, parent, (u16 *)0xFFC03958);
		debugfs_create_x16("USB_NAKLIMIT0", 0600, parent, (u16 *)0xFFC03858);
		debugfs_create_x16("USB_OTG_DEV_CTL", 0600, parent, (u16 *)0xFFC03900);
		debugfs_create_x16("USB_OTG_VBUS_IRQ", 0600, parent, (u16 *)0xFFC03904);
		debugfs_create_x16("USB_OTG_VBUS_MASK", 0600, parent, (u16 *)0xFFC03908);
		debugfs_create_x16("USB_PHY_TEST", 0600, parent, (u16 *)0xFFC039EC);
		debugfs_create_x16("USB_PLLOSC_CTRL", 0600, parent, (u16 *)0xFFC039F0);
		debugfs_create_x16("USB_POWER", 0600, parent, (u16 *)0xFFC03804);
		debugfs_create_x16("USB_RXCOUNT", 0600, parent, (u16 *)0xFFC03850);
		debugfs_create_x16("USB_RXCSR", 0600, parent, (u16 *)0xFFC0384C);
		debugfs_create_x16("USB_RXINTERVAL", 0600, parent, (u16 *)0xFFC03860);
		debugfs_create_x16("USB_RXTYPE", 0600, parent, (u16 *)0xFFC0385C);
		debugfs_create_x16("USB_RX_MAX_PACKET", 0600, parent, (u16 *)0xFFC03848);
		debugfs_create_x16("USB_SRP_CLKDIV", 0600, parent, (u16 *)0xFFC039F4);
		debugfs_create_x16("USB_TESTMODE", 0600, parent, (u16 *)0xFFC03828);
		debugfs_create_x16("USB_TXCOUNT", 0600, parent, (u16 *)0xFFC03868);
		debugfs_create_x16("USB_TXCSR", 0600, parent, (u16 *)0xFFC03844);
		debugfs_create_x16("USB_TXINTERVAL", 0600, parent, (u16 *)0xFFC03858);
		debugfs_create_x16("USB_TXTYPE", 0600, parent, (u16 *)0xFFC03854);
		debugfs_create_x16("USB_TX_MAX_PACKET", 0600, parent, (u16 *)0xFFC03840);
		debugfs_create_x16("USB_VPLEN", 0600, parent, (u16 *)0xFFC0394C);

		parent = debugfs_create_dir("Watchdog", top);
		debugfs_create_x32("WDOG_CNT", 0600, parent, (u32 *)0xFFC00204);
		debugfs_create_x16("WDOG_CTL", 0600, parent, (u16 *)0xFFC00200);
		debugfs_create_x32("WDOG_STAT", 0600, parent, (u32 *)0xFFC00208);

		parent = debugfs_create_dir("Watchpoint and Patch Unit", top);
		debugfs_create_x32("WPDA0", 0600, parent, (u32 *)0xFFE07140);
		debugfs_create_x32("WPDA1", 0600, parent, (u32 *)0xFFE07144);
		debugfs_create_x32("WPDACNT0", 0600, parent, (u32 *)0xFFE07180);
		debugfs_create_x32("WPDACNT1", 0600, parent, (u32 *)0xFFE07184);
		debugfs_create_x32("WPDACTL", 0600, parent, (u32 *)0xFFE07100);
		debugfs_create_x32("WPIA0", 0600, parent, (u32 *)0xFFE07040);
		debugfs_create_x32("WPIA1", 0600, parent, (u32 *)0xFFE07044);
		debugfs_create_x32("WPIA2", 0600, parent, (u32 *)0xFFE07048);
		debugfs_create_x32("WPIA3", 0600, parent, (u32 *)0xFFE0704C);
		debugfs_create_x32("WPIA4", 0600, parent, (u32 *)0xFFE07050);
		debugfs_create_x32("WPIA5", 0600, parent, (u32 *)0xFFE07054);
		debugfs_create_x32("WPIACNT0", 0600, parent, (u32 *)0xFFE07080);
		debugfs_create_x32("WPIACNT1", 0600, parent, (u32 *)0xFFE07084);
		debugfs_create_x32("WPIACNT2", 0600, parent, (u32 *)0xFFE07088);
		debugfs_create_x32("WPIACNT3", 0600, parent, (u32 *)0xFFE0708C);
		debugfs_create_x32("WPIACNT4", 0600, parent, (u32 *)0xFFE07090);
		debugfs_create_x32("WPIACNT5", 0600, parent, (u32 *)0xFFE07094);
		debugfs_create_x32("WPIACTL", 0600, parent, (u32 *)0xFFE07000);
		debugfs_create_x32("WPSTAT", 0600, parent, (u32 *)0xFFE07200);

	}	/* BF525 */

#ifdef __ADSPBF526__
# define USE_BF526 1
#else
# define USE_BF526 0
#endif
	if (USE_BF526) {

		parent = debugfs_create_dir("Core Timer Register File", top);
		debugfs_create_x32("TCNTL", 0600, parent, (u32 *)0xFFE03000);
		debugfs_create_x32("TCOUNT", 0600, parent, (u32 *)0xFFE0300C);
		debugfs_create_x32("TPERIOD", 0600, parent, (u32 *)0xFFE03004);
		debugfs_create_x32("TSCALE", 0600, parent, (u32 *)0xFFE03008);

		parent = debugfs_create_dir("Counter", top);
		debugfs_create_x16("CNT_COMMAND", 0600, parent, (u16 *)0xFFC0350C);
		debugfs_create_x16("CNT_CONFIG", 0600, parent, (u16 *)0xFFC03500);
		debugfs_create_x32("CNT_COUNTER", 0600, parent, (u32 *)0xFFC03514);
		debugfs_create_x16("CNT_DEBOUNCE", 0600, parent, (u16 *)0xFFC03510);
		debugfs_create_x16("CNT_IMASK", 0600, parent, (u16 *)0xFFC03504);
		debugfs_create_x32("CNT_MAX", 0600, parent, (u32 *)0xFFC03518);
		debugfs_create_x32("CNT_MIN", 0600, parent, (u32 *)0xFFC0351C);
		debugfs_create_x16("CNT_STATUS", 0600, parent, (u16 *)0xFFC03508);

		parent = debugfs_create_dir("DMA Controller", top);
		debugfs_create_x16("DMA0_CONFIG", 0600, parent, (u16 *)0xFFC00C08);
		debugfs_create_x32("DMA0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C24);
		debugfs_create_x32("DMA0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C20);
		debugfs_create_x16("DMA0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C30);
		debugfs_create_x16("DMA0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C38);
		debugfs_create_x16("DMA0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C28);
		debugfs_create_x32("DMA0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C00);
		debugfs_create_x16("DMA0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C2C);
		debugfs_create_x32("DMA0_START_ADDR", 0600, parent, (u32 *)0xFFC00C04);
		debugfs_create_x16("DMA0_X_COUNT", 0600, parent, (u16 *)0xFFC00C10);
		debugfs_create_x16("DMA0_X_MODIFY", 0600, parent, (u16 *)0xFFC00C14);
		debugfs_create_x16("DMA0_Y_COUNT", 0600, parent, (u16 *)0xFFC00C18);
		debugfs_create_x16("DMA0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C1C);
		debugfs_create_x16("DMA10_CONFIG", 0600, parent, (u16 *)0xFFC00E88);
		debugfs_create_x32("DMA10_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EA4);
		debugfs_create_x32("DMA10_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EA0);
		debugfs_create_x16("DMA10_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EB0);
		debugfs_create_x16("DMA10_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EB8);
		debugfs_create_x16("DMA10_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EA8);
		debugfs_create_x32("DMA10_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E80);
		debugfs_create_x16("DMA10_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EAC);
		debugfs_create_x32("DMA10_START_ADDR", 0600, parent, (u32 *)0xFFC00E84);
		debugfs_create_x16("DMA10_X_COUNT", 0600, parent, (u16 *)0xFFC00E90);
		debugfs_create_x16("DMA10_X_MODIFY", 0600, parent, (u16 *)0xFFC00E94);
		debugfs_create_x16("DMA10_Y_COUNT", 0600, parent, (u16 *)0xFFC00E98);
		debugfs_create_x16("DMA10_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E9C);
		debugfs_create_x16("DMA11_CONFIG", 0600, parent, (u16 *)0xFFC00EC8);
		debugfs_create_x32("DMA11_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EE4);
		debugfs_create_x32("DMA11_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EE0);
		debugfs_create_x16("DMA11_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EF0);
		debugfs_create_x16("DMA11_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EF8);
		debugfs_create_x16("DMA11_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EE8);
		debugfs_create_x32("DMA11_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00EC0);
		debugfs_create_x16("DMA11_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EEC);
		debugfs_create_x32("DMA11_START_ADDR", 0600, parent, (u32 *)0xFFC00EC4);
		debugfs_create_x16("DMA11_X_COUNT", 0600, parent, (u16 *)0xFFC00ED0);
		debugfs_create_x16("DMA11_X_MODIFY", 0600, parent, (u16 *)0xFFC00ED4);
		debugfs_create_x16("DMA11_Y_COUNT", 0600, parent, (u16 *)0xFFC00ED8);
		debugfs_create_x16("DMA11_Y_MODIFY", 0600, parent, (u16 *)0xFFC00EDC);
		debugfs_create_x16("DMA1_CONFIG", 0600, parent, (u16 *)0xFFC00C48);
		debugfs_create_x32("DMA1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C64);
		debugfs_create_x32("DMA1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C60);
		debugfs_create_x16("DMA1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C70);
		debugfs_create_x16("DMA1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C78);
		debugfs_create_x16("DMA1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C68);
		debugfs_create_x32("DMA1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C40);
		debugfs_create_x16("DMA1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C6C);
		debugfs_create_x32("DMA1_START_ADDR", 0600, parent, (u32 *)0xFFC00C44);
		debugfs_create_x16("DMA1_X_COUNT", 0600, parent, (u16 *)0xFFC00C50);
		debugfs_create_x16("DMA1_X_MODIFY", 0600, parent, (u16 *)0xFFC00C54);
		debugfs_create_x16("DMA1_Y_COUNT", 0600, parent, (u16 *)0xFFC00C58);
		debugfs_create_x16("DMA1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C5C);
		debugfs_create_x16("DMA2_CONFIG", 0600, parent, (u16 *)0xFFC00C88);
		debugfs_create_x32("DMA2_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CA4);
		debugfs_create_x32("DMA2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CA0);
		debugfs_create_x16("DMA2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CB0);
		debugfs_create_x16("DMA2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CB8);
		debugfs_create_x16("DMA2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CA8);
		debugfs_create_x32("DMA2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C80);
		debugfs_create_x16("DMA2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CAC);
		debugfs_create_x32("DMA2_START_ADDR", 0600, parent, (u32 *)0xFFC00C84);
		debugfs_create_x16("DMA2_X_COUNT", 0600, parent, (u16 *)0xFFC00C90);
		debugfs_create_x16("DMA2_X_MODIFY", 0600, parent, (u16 *)0xFFC00C94);
		debugfs_create_x16("DMA2_Y_COUNT", 0600, parent, (u16 *)0xFFC00C98);
		debugfs_create_x16("DMA2_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C9C);
		debugfs_create_x16("DMA3_CONFIG", 0600, parent, (u16 *)0xFFC00CC8);
		debugfs_create_x32("DMA3_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CE4);
		debugfs_create_x32("DMA3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CE0);
		debugfs_create_x16("DMA3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CF0);
		debugfs_create_x16("DMA3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CF8);
		debugfs_create_x16("DMA3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CE8);
		debugfs_create_x32("DMA3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00CC0);
		debugfs_create_x16("DMA3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CEC);
		debugfs_create_x32("DMA3_START_ADDR", 0600, parent, (u32 *)0xFFC00CC4);
		debugfs_create_x16("DMA3_X_COUNT", 0600, parent, (u16 *)0xFFC00CD0);
		debugfs_create_x16("DMA3_X_MODIFY", 0600, parent, (u16 *)0xFFC00CD4);
		debugfs_create_x16("DMA3_Y_COUNT", 0600, parent, (u16 *)0xFFC00CD8);
		debugfs_create_x16("DMA3_Y_MODIFY", 0600, parent, (u16 *)0xFFC00CDC);
		debugfs_create_x16("DMA4_CONFIG", 0600, parent, (u16 *)0xFFC00D08);
		debugfs_create_x32("DMA4_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D24);
		debugfs_create_x32("DMA4_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D20);
		debugfs_create_x16("DMA4_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D30);
		debugfs_create_x16("DMA4_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D38);
		debugfs_create_x16("DMA4_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D28);
		debugfs_create_x32("DMA4_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D00);
		debugfs_create_x16("DMA4_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D2C);
		debugfs_create_x32("DMA4_START_ADDR", 0600, parent, (u32 *)0xFFC00D04);
		debugfs_create_x16("DMA4_X_COUNT", 0600, parent, (u16 *)0xFFC00D10);
		debugfs_create_x16("DMA4_X_MODIFY", 0600, parent, (u16 *)0xFFC00D14);
		debugfs_create_x16("DMA4_Y_COUNT", 0600, parent, (u16 *)0xFFC00D18);
		debugfs_create_x16("DMA4_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D1C);
		debugfs_create_x16("DMA5_CONFIG", 0600, parent, (u16 *)0xFFC00D48);
		debugfs_create_x32("DMA5_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D64);
		debugfs_create_x32("DMA5_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D60);
		debugfs_create_x16("DMA5_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D70);
		debugfs_create_x16("DMA5_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D78);
		debugfs_create_x16("DMA5_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D68);
		debugfs_create_x32("DMA5_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D40);
		debugfs_create_x16("DMA5_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D6C);
		debugfs_create_x32("DMA5_START_ADDR", 0600, parent, (u32 *)0xFFC00D44);
		debugfs_create_x16("DMA5_X_COUNT", 0600, parent, (u16 *)0xFFC00D50);
		debugfs_create_x16("DMA5_X_MODIFY", 0600, parent, (u16 *)0xFFC00D54);
		debugfs_create_x16("DMA5_Y_COUNT", 0600, parent, (u16 *)0xFFC00D58);
		debugfs_create_x16("DMA5_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D5C);
		debugfs_create_x16("DMA6_CONFIG", 0600, parent, (u16 *)0xFFC00D88);
		debugfs_create_x32("DMA6_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DA4);
		debugfs_create_x32("DMA6_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DA0);
		debugfs_create_x16("DMA6_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DB0);
		debugfs_create_x16("DMA6_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DB8);
		debugfs_create_x16("DMA6_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DA8);
		debugfs_create_x32("DMA6_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D80);
		debugfs_create_x16("DMA6_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DAC);
		debugfs_create_x32("DMA6_START_ADDR", 0600, parent, (u32 *)0xFFC00D84);
		debugfs_create_x16("DMA6_X_COUNT", 0600, parent, (u16 *)0xFFC00D90);
		debugfs_create_x16("DMA6_X_MODIFY", 0600, parent, (u16 *)0xFFC00D94);
		debugfs_create_x16("DMA6_Y_COUNT", 0600, parent, (u16 *)0xFFC00D98);
		debugfs_create_x16("DMA6_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D9C);
		debugfs_create_x16("DMA7_CONFIG", 0600, parent, (u16 *)0xFFC00DC8);
		debugfs_create_x32("DMA7_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DE4);
		debugfs_create_x32("DMA7_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DE0);
		debugfs_create_x16("DMA7_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DF0);
		debugfs_create_x16("DMA7_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DF8);
		debugfs_create_x16("DMA7_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DE8);
		debugfs_create_x32("DMA7_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00DC0);
		debugfs_create_x16("DMA7_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DEC);
		debugfs_create_x32("DMA7_START_ADDR", 0600, parent, (u32 *)0xFFC00DC4);
		debugfs_create_x16("DMA7_X_COUNT", 0600, parent, (u16 *)0xFFC00DD0);
		debugfs_create_x16("DMA7_X_MODIFY", 0600, parent, (u16 *)0xFFC00DD4);
		debugfs_create_x16("DMA7_Y_COUNT", 0600, parent, (u16 *)0xFFC00DD8);
		debugfs_create_x16("DMA7_Y_MODIFY", 0600, parent, (u16 *)0xFFC00DDC);
		debugfs_create_x16("DMA8_CONFIG", 0600, parent, (u16 *)0xFFC00E08);
		debugfs_create_x32("DMA8_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E24);
		debugfs_create_x32("DMA8_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E20);
		debugfs_create_x16("DMA8_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E30);
		debugfs_create_x16("DMA8_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E38);
		debugfs_create_x16("DMA8_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E28);
		debugfs_create_x32("DMA8_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E00);
		debugfs_create_x16("DMA8_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E2C);
		debugfs_create_x32("DMA8_START_ADDR", 0600, parent, (u32 *)0xFFC00E04);
		debugfs_create_x16("DMA8_X_COUNT", 0600, parent, (u16 *)0xFFC00E10);
		debugfs_create_x16("DMA8_X_MODIFY", 0600, parent, (u16 *)0xFFC00E14);
		debugfs_create_x16("DMA8_Y_COUNT", 0600, parent, (u16 *)0xFFC00E18);
		debugfs_create_x16("DMA8_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E1C);
		debugfs_create_x16("DMA9_CONFIG", 0600, parent, (u16 *)0xFFC00E48);
		debugfs_create_x32("DMA9_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E64);
		debugfs_create_x32("DMA9_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E60);
		debugfs_create_x16("DMA9_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E70);
		debugfs_create_x16("DMA9_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E78);
		debugfs_create_x16("DMA9_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E68);
		debugfs_create_x32("DMA9_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E40);
		debugfs_create_x16("DMA9_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E6C);
		debugfs_create_x32("DMA9_START_ADDR", 0600, parent, (u32 *)0xFFC00E44);
		debugfs_create_x16("DMA9_X_COUNT", 0600, parent, (u16 *)0xFFC00E50);
		debugfs_create_x16("DMA9_X_MODIFY", 0600, parent, (u16 *)0xFFC00E54);
		debugfs_create_x16("DMA9_Y_COUNT", 0600, parent, (u16 *)0xFFC00E58);
		debugfs_create_x16("DMA9_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E5C);

		parent = debugfs_create_dir("DMA Traffic Control", top);
		debugfs_create_x16("DMA_TC_CNT", 0600, parent, (u16 *)0xFFC00B0C);
		debugfs_create_x16("DMA_TC_PER", 0600, parent, (u16 *)0xFFC00B10);

		parent = debugfs_create_dir("EBIU", top);
		debugfs_create_x32("EBIU_AMBCTL0", 0600, parent, (u32 *)0xFFC00A04);
		debugfs_create_x32("EBIU_AMBCTL1", 0600, parent, (u32 *)0xFFC00A08);
		debugfs_create_x16("EBIU_AMGCTL", 0600, parent, (u16 *)0xFFC00A00);
		debugfs_create_x16("EBIU_SDBCTL", 0600, parent, (u16 *)0xFFC00A14);
		debugfs_create_x32("EBIU_SDGCTL", 0600, parent, (u32 *)0xFFC00A10);
		debugfs_create_x16("EBIU_SDRRC", 0600, parent, (u16 *)0xFFC00A18);
		debugfs_create_x16("EBIU_SDSTAT", 0600, parent, (u16 *)0xFFC00A1C);

		parent = debugfs_create_dir("Ethernet Controller", top);
		debugfs_create_x32("EMAC_ADDRHI", 0600, parent, (u32 *)0xFFC03008);
		debugfs_create_x32("EMAC_ADDRLO", 0600, parent, (u32 *)0xFFC03004);
		debugfs_create_x32("EMAC_FLC", 0600, parent, (u32 *)0xFFC0301C);
		debugfs_create_x32("EMAC_HASHHI", 0600, parent, (u32 *)0xFFC03010);
		debugfs_create_x32("EMAC_HASHLO", 0600, parent, (u32 *)0xFFC0300C);
		debugfs_create_x32("EMAC_MMC_CTL", 0600, parent, (u32 *)0xFFC03080);
		debugfs_create_x32("EMAC_MMC_RIRQE", 0600, parent, (u32 *)0xFFC03088);
		debugfs_create_x32("EMAC_MMC_RIRQS", 0600, parent, (u32 *)0xFFC03084);
		debugfs_create_x32("EMAC_MMC_TIRQE", 0600, parent, (u32 *)0xFFC03090);
		debugfs_create_x32("EMAC_MMC_TIRQS", 0600, parent, (u32 *)0xFFC0308C);
		debugfs_create_x32("EMAC_OPMODE", 0600, parent, (u32 *)0xFFC03000);
		debugfs_create_x32("EMAC_RXC_ALIGN", 0600, parent, (u32 *)0xFFC03108);
		debugfs_create_x32("EMAC_RXC_ALLFRM", 0600, parent, (u32 *)0xFFC03138);
		debugfs_create_x32("EMAC_RXC_ALLOCT", 0600, parent, (u32 *)0xFFC0313C);
		debugfs_create_x32("EMAC_RXC_BROAD", 0600, parent, (u32 *)0xFFC0311C);
		debugfs_create_x32("EMAC_RXC_DMAOVF", 0600, parent, (u32 *)0xFFC03110);
		debugfs_create_x32("EMAC_RXC_EQ64", 0600, parent, (u32 *)0xFFC03148);
		debugfs_create_x32("EMAC_RXC_FCS", 0600, parent, (u32 *)0xFFC03104);
		debugfs_create_x32("EMAC_RXC_GE1024", 0600, parent, (u32 *)0xFFC0315C);
		debugfs_create_x32("EMAC_RXC_LNERRI", 0600, parent, (u32 *)0xFFC03120);
		debugfs_create_x32("EMAC_RXC_LNERRO", 0600, parent, (u32 *)0xFFC03124);
		debugfs_create_x32("EMAC_RXC_LONG", 0600, parent, (u32 *)0xFFC03128);
		debugfs_create_x32("EMAC_RXC_LT1024", 0600, parent, (u32 *)0xFFC03158);
		debugfs_create_x32("EMAC_RXC_LT128", 0600, parent, (u32 *)0xFFC0314C);
		debugfs_create_x32("EMAC_RXC_LT256", 0600, parent, (u32 *)0xFFC03150);
		debugfs_create_x32("EMAC_RXC_LT512", 0600, parent, (u32 *)0xFFC03154);
		debugfs_create_x32("EMAC_RXC_MACCTL", 0600, parent, (u32 *)0xFFC0312C);
		debugfs_create_x32("EMAC_RXC_MULTI", 0600, parent, (u32 *)0xFFC03118);
		debugfs_create_x32("EMAC_RXC_OCTET", 0600, parent, (u32 *)0xFFC0310C);
		debugfs_create_x32("EMAC_RXC_OK", 0600, parent, (u32 *)0xFFC03100);
		debugfs_create_x32("EMAC_RXC_OPCODE", 0600, parent, (u32 *)0xFFC03130);
		debugfs_create_x32("EMAC_RXC_PAUSE", 0600, parent, (u32 *)0xFFC03134);
		debugfs_create_x32("EMAC_RXC_SHORT", 0600, parent, (u32 *)0xFFC03144);
		debugfs_create_x32("EMAC_RXC_TYPED", 0600, parent, (u32 *)0xFFC03140);
		debugfs_create_x32("EMAC_RXC_UNICST", 0600, parent, (u32 *)0xFFC03114);
		debugfs_create_x32("EMAC_RX_IRQE", 0600, parent, (u32 *)0xFFC03070);
		debugfs_create_x32("EMAC_RX_STAT", 0600, parent, (u32 *)0xFFC03068);
		debugfs_create_x32("EMAC_RX_STKY", 0600, parent, (u32 *)0xFFC0306C);
		debugfs_create_x32("EMAC_STAADD", 0600, parent, (u32 *)0xFFC03014);
		debugfs_create_x32("EMAC_STADAT", 0600, parent, (u32 *)0xFFC03018);
		debugfs_create_x32("EMAC_SYSCTL", 0600, parent, (u32 *)0xFFC03060);
		debugfs_create_x32("EMAC_SYSTAT", 0600, parent, (u32 *)0xFFC03064);
		debugfs_create_x32("EMAC_TXC_1COL", 0600, parent, (u32 *)0xFFC03184);
		debugfs_create_x32("EMAC_TXC_ABORT", 0600, parent, (u32 *)0xFFC031D8);
		debugfs_create_x32("EMAC_TXC_ALLFRM", 0600, parent, (u32 *)0xFFC031B8);
		debugfs_create_x32("EMAC_TXC_ALLOCT", 0600, parent, (u32 *)0xFFC031BC);
		debugfs_create_x32("EMAC_TXC_BROAD", 0600, parent, (u32 *)0xFFC031AC);
		debugfs_create_x32("EMAC_TXC_CRSERR", 0600, parent, (u32 *)0xFFC031A0);
		debugfs_create_x32("EMAC_TXC_DEFER", 0600, parent, (u32 *)0xFFC03190);
		debugfs_create_x32("EMAC_TXC_DMAUND", 0600, parent, (u32 *)0xFFC0319C);
		debugfs_create_x32("EMAC_TXC_EQ64", 0600, parent, (u32 *)0xFFC031C0);
		debugfs_create_x32("EMAC_TXC_GE1024", 0600, parent, (u32 *)0xFFC031D4);
		debugfs_create_x32("EMAC_TXC_GT1COL", 0600, parent, (u32 *)0xFFC03188);
		debugfs_create_x32("EMAC_TXC_LATECL", 0600, parent, (u32 *)0xFFC03194);
		debugfs_create_x32("EMAC_TXC_LT1024", 0600, parent, (u32 *)0xFFC031D0);
		debugfs_create_x32("EMAC_TXC_LT128", 0600, parent, (u32 *)0xFFC031C4);
		debugfs_create_x32("EMAC_TXC_LT256", 0600, parent, (u32 *)0xFFC031C8);
		debugfs_create_x32("EMAC_TXC_LT512", 0600, parent, (u32 *)0xFFC031CC);
		debugfs_create_x32("EMAC_TXC_MACCTL", 0600, parent, (u32 *)0xFFC031B4);
		debugfs_create_x32("EMAC_TXC_MULTI", 0600, parent, (u32 *)0xFFC031A8);
		debugfs_create_x32("EMAC_TXC_OCTET", 0600, parent, (u32 *)0xFFC0318C);
		debugfs_create_x32("EMAC_TXC_OK", 0600, parent, (u32 *)0xFFC03180);
		debugfs_create_x32("EMAC_TXC_UNICST", 0600, parent, (u32 *)0xFFC031A4);
		debugfs_create_x32("EMAC_TXC_XS_COL", 0600, parent, (u32 *)0xFFC03198);
		debugfs_create_x32("EMAC_TXC_XS_DFR", 0600, parent, (u32 *)0xFFC031B0);
		debugfs_create_x32("EMAC_TX_IRQE", 0600, parent, (u32 *)0xFFC0307C);
		debugfs_create_x32("EMAC_TX_STAT", 0600, parent, (u32 *)0xFFC03074);
		debugfs_create_x32("EMAC_TX_STKY", 0600, parent, (u32 *)0xFFC03078);
		debugfs_create_x32("EMAC_VLAN1", 0600, parent, (u32 *)0xFFC03020);
		debugfs_create_x32("EMAC_VLAN2", 0600, parent, (u32 *)0xFFC03024);
		debugfs_create_x32("EMAC_WKUP_CTL", 0600, parent, (u32 *)0xFFC0302C);
		debugfs_create_x32("EMAC_WKUP_FFCMD", 0600, parent, (u32 *)0xFFC03040);
		debugfs_create_x32("EMAC_WKUP_FFCRC0", 0600, parent, (u32 *)0xFFC03048);
		debugfs_create_x32("EMAC_WKUP_FFCRC1", 0600, parent, (u32 *)0xFFC0304C);
		debugfs_create_x32("EMAC_WKUP_FFMSK0", 0600, parent, (u32 *)0xFFC03030);
		debugfs_create_x32("EMAC_WKUP_FFMSK1", 0600, parent, (u32 *)0xFFC03034);
		debugfs_create_x32("EMAC_WKUP_FFMSK2", 0600, parent, (u32 *)0xFFC03038);
		debugfs_create_x32("EMAC_WKUP_FFMSK3", 0600, parent, (u32 *)0xFFC0303C);
		debugfs_create_x32("EMAC_WKUP_FFOFF", 0600, parent, (u32 *)0xFFC03044);

		parent = debugfs_create_dir("Event Vectors", top);
		debugfs_create_x32("EVT0", 0600, parent, (u32 *)0xFFE02000);
		debugfs_create_x32("EVT10", 0600, parent, (u32 *)0xFFE02028);
		debugfs_create_x32("EVT11", 0600, parent, (u32 *)0xFFE0202C);
		debugfs_create_x32("EVT12", 0600, parent, (u32 *)0xFFE02030);
		debugfs_create_x32("EVT13", 0600, parent, (u32 *)0xFFE02034);
		debugfs_create_x32("EVT14", 0600, parent, (u32 *)0xFFE02038);
		debugfs_create_x32("EVT15", 0600, parent, (u32 *)0xFFE0203C);
		debugfs_create_x32("EVT1", 0600, parent, (u32 *)0xFFE02004);
		debugfs_create_x32("EVT2", 0600, parent, (u32 *)0xFFE02008);
		debugfs_create_x32("EVT3", 0600, parent, (u32 *)0xFFE0200C);
		debugfs_create_x32("EVT4", 0600, parent, (u32 *)0xFFE02010);
		debugfs_create_x32("EVT5", 0600, parent, (u32 *)0xFFE02014);
		debugfs_create_x32("EVT6", 0600, parent, (u32 *)0xFFE02018);
		debugfs_create_x32("EVT7", 0600, parent, (u32 *)0xFFE0201C);
		debugfs_create_x32("EVT8", 0600, parent, (u32 *)0xFFE02020);
		debugfs_create_x32("EVT9", 0600, parent, (u32 *)0xFFE02024);

		parent = debugfs_create_dir("Extended Registers", top);
		debugfs_create_x32("CHIPID", 0600, parent, (u32 *)0xFFC00014);
		debugfs_create_x32("DSPID", 0600, parent, (u32 *)0xFFE05000);

		parent = debugfs_create_dir("GPIO PIN", top);
		debugfs_create_x16("PORTF_DRIVE", 0600, parent, (u16 *)0xFFC03220);
		debugfs_create_x16("PORTF_HYSTERESIS", 0600, parent, (u16 *)0xFFC03240);
		debugfs_create_x16("PORTF_MUX", 0600, parent, (u16 *)0xFFC03210);
		debugfs_create_x16("PORTF_SLEW", 0600, parent, (u16 *)0xFFC03230);
		debugfs_create_x16("PORTG_DRIVE", 0600, parent, (u16 *)0xFFC03224);
		debugfs_create_x16("PORTG_HYSTERESIS", 0600, parent, (u16 *)0xFFC03244);
		debugfs_create_x16("PORTG_MUX", 0600, parent, (u16 *)0xFFC03214);
		debugfs_create_x16("PORTG_SLEW", 0600, parent, (u16 *)0xFFC03234);
		debugfs_create_x16("PORTH_DRIVE", 0600, parent, (u16 *)0xFFC03228);
		debugfs_create_x16("PORTH_HYSTERESIS", 0600, parent, (u16 *)0xFFC03248);
		debugfs_create_x16("PORTH_MUX", 0600, parent, (u16 *)0xFFC03218);
		debugfs_create_x16("PORTH_SLEW", 0600, parent, (u16 *)0xFFC03238);

		parent = debugfs_create_dir("HOST", top);
		debugfs_create_x16("HOST_CONTROL", 0600, parent, (u16 *)0xFFC03400);
		debugfs_create_x16("HOST_STATUS", 0600, parent, (u16 *)0xFFC03404);
		debugfs_create_x16("HOST_TIMEOUT", 0600, parent, (u16 *)0xFFC03408);

		parent = debugfs_create_dir("Handshake MDMA", top);
		debugfs_create_x16("HMDMA0_BCINIT", 0600, parent, (u16 *)0xFFC03308);
		debugfs_create_x16("HMDMA0_BCOUNT", 0600, parent, (u16 *)0xFFC03318);
		debugfs_create_x16("HMDMA0_CONTROL", 0600, parent, (u16 *)0xFFC03300);
		debugfs_create_x16("HMDMA0_ECINIT", 0600, parent, (u16 *)0xFFC03304);
		debugfs_create_x16("HMDMA0_ECOUNT", 0600, parent, (u16 *)0xFFC03314);
		debugfs_create_x16("HMDMA0_ECOVERFLOW", 0600, parent, (u16 *)0xFFC03310);
		debugfs_create_x16("HMDMA0_ECURGENT", 0600, parent, (u16 *)0xFFC0330C);
		debugfs_create_x16("HMDMA1_BCINIT", 0600, parent, (u16 *)0xFFC03348);
		debugfs_create_x16("HMDMA1_BCOUNT", 0600, parent, (u16 *)0xFFC03358);
		debugfs_create_x16("HMDMA1_CONTROL", 0600, parent, (u16 *)0xFFC03340);
		debugfs_create_x16("HMDMA1_ECINIT", 0600, parent, (u16 *)0xFFC03344);
		debugfs_create_x16("HMDMA1_ECOUNT", 0600, parent, (u16 *)0xFFC03354);
		debugfs_create_x16("HMDMA1_ECOVERFLOW", 0600, parent, (u16 *)0xFFC03350);
		debugfs_create_x16("HMDMA1_ECURGENT", 0600, parent, (u16 *)0xFFC0334C);

		parent = debugfs_create_dir("Interrupt Controller", top);
		debugfs_create_x32("ILAT", 0600, parent, (u32 *)0xFFE0210C);
		debugfs_create_x32("IMASK", 0600, parent, (u32 *)0xFFE02104);
		debugfs_create_x32("IPEND", 0600, parent, (u32 *)0xFFE02108);
		debugfs_create_x32("IPRIO", 0600, parent, (u32 *)0xFFE02110);

		parent = debugfs_create_dir("L1 Code Memory Registers", top);
		debugfs_create_x32("ICPLB_ADDR0", 0600, parent, (u32 *)0xFFE01100);
		debugfs_create_x32("ICPLB_ADDR10", 0600, parent, (u32 *)0xFFE01128);
		debugfs_create_x32("ICPLB_ADDR11", 0600, parent, (u32 *)0xFFE0112C);
		debugfs_create_x32("ICPLB_ADDR12", 0600, parent, (u32 *)0xFFE01130);
		debugfs_create_x32("ICPLB_ADDR13", 0600, parent, (u32 *)0xFFE01134);
		debugfs_create_x32("ICPLB_ADDR14", 0600, parent, (u32 *)0xFFE01138);
		debugfs_create_x32("ICPLB_ADDR15", 0600, parent, (u32 *)0xFFE0113C);
		debugfs_create_x32("ICPLB_ADDR1", 0600, parent, (u32 *)0xFFE01104);
		debugfs_create_x32("ICPLB_ADDR2", 0600, parent, (u32 *)0xFFE01108);
		debugfs_create_x32("ICPLB_ADDR3", 0600, parent, (u32 *)0xFFE0110C);
		debugfs_create_x32("ICPLB_ADDR4", 0600, parent, (u32 *)0xFFE01110);
		debugfs_create_x32("ICPLB_ADDR5", 0600, parent, (u32 *)0xFFE01114);
		debugfs_create_x32("ICPLB_ADDR6", 0600, parent, (u32 *)0xFFE01118);
		debugfs_create_x32("ICPLB_ADDR7", 0600, parent, (u32 *)0xFFE0111C);
		debugfs_create_x32("ICPLB_ADDR8", 0600, parent, (u32 *)0xFFE01120);
		debugfs_create_x32("ICPLB_ADDR9", 0600, parent, (u32 *)0xFFE01124);
		debugfs_create_x32("ICPLB_DATA0", 0600, parent, (u32 *)0xFFE01200);
		debugfs_create_x32("ICPLB_DATA10", 0600, parent, (u32 *)0xFFE01228);
		debugfs_create_x32("ICPLB_DATA11", 0600, parent, (u32 *)0xFFE0122C);
		debugfs_create_x32("ICPLB_DATA12", 0600, parent, (u32 *)0xFFE01230);
		debugfs_create_x32("ICPLB_DATA13", 0600, parent, (u32 *)0xFFE01234);
		debugfs_create_x32("ICPLB_DATA14", 0600, parent, (u32 *)0xFFE01238);
		debugfs_create_x32("ICPLB_DATA15", 0600, parent, (u32 *)0xFFE0123C);
		debugfs_create_x32("ICPLB_DATA1", 0600, parent, (u32 *)0xFFE01204);
		debugfs_create_x32("ICPLB_DATA2", 0600, parent, (u32 *)0xFFE01208);
		debugfs_create_x32("ICPLB_DATA3", 0600, parent, (u32 *)0xFFE0120C);
		debugfs_create_x32("ICPLB_DATA4", 0600, parent, (u32 *)0xFFE01210);
		debugfs_create_x32("ICPLB_DATA5", 0600, parent, (u32 *)0xFFE01214);
		debugfs_create_x32("ICPLB_DATA6", 0600, parent, (u32 *)0xFFE01218);
		debugfs_create_x32("ICPLB_DATA7", 0600, parent, (u32 *)0xFFE0121C);
		debugfs_create_x32("ICPLB_DATA8", 0600, parent, (u32 *)0xFFE01220);
		debugfs_create_x32("ICPLB_DATA9", 0600, parent, (u32 *)0xFFE01224);
		debugfs_create_x32("ICPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0100C);
		debugfs_create_x32("ICPLB_STATUS", 0600, parent, (u32 *)0xFFE01008);
		debugfs_create_x32("IMEM_CONTROL", 0600, parent, (u32 *)0xFFE01004);
		debugfs_create_x32("ITEST_COMMAND", 0600, parent, (u32 *)0xFFE01300);
		debugfs_create_x32("ITEST_DATA0", 0600, parent, (u32 *)0xFFE01400);
		debugfs_create_x32("ITEST_DATA1", 0600, parent, (u32 *)0xFFE01404);

		parent = debugfs_create_dir("L1 Data Memory Registers", top);
		debugfs_create_x32("DCPLB_ADDR0", 0600, parent, (u32 *)0xFFE00100);
		debugfs_create_x32("DCPLB_ADDR10", 0600, parent, (u32 *)0xFFE00128);
		debugfs_create_x32("DCPLB_ADDR11", 0600, parent, (u32 *)0xFFE0012C);
		debugfs_create_x32("DCPLB_ADDR12", 0600, parent, (u32 *)0xFFE00130);
		debugfs_create_x32("DCPLB_ADDR13", 0600, parent, (u32 *)0xFFE00134);
		debugfs_create_x32("DCPLB_ADDR14", 0600, parent, (u32 *)0xFFE00138);
		debugfs_create_x32("DCPLB_ADDR15", 0600, parent, (u32 *)0xFFE0013C);
		debugfs_create_x32("DCPLB_ADDR1", 0600, parent, (u32 *)0xFFE00104);
		debugfs_create_x32("DCPLB_ADDR2", 0600, parent, (u32 *)0xFFE00108);
		debugfs_create_x32("DCPLB_ADDR3", 0600, parent, (u32 *)0xFFE0010C);
		debugfs_create_x32("DCPLB_ADDR4", 0600, parent, (u32 *)0xFFE00110);
		debugfs_create_x32("DCPLB_ADDR5", 0600, parent, (u32 *)0xFFE00114);
		debugfs_create_x32("DCPLB_ADDR6", 0600, parent, (u32 *)0xFFE00118);
		debugfs_create_x32("DCPLB_ADDR7", 0600, parent, (u32 *)0xFFE0011C);
		debugfs_create_x32("DCPLB_ADDR8", 0600, parent, (u32 *)0xFFE00120);
		debugfs_create_x32("DCPLB_ADDR9", 0600, parent, (u32 *)0xFFE00124);
		debugfs_create_x32("DCPLB_DATA0", 0600, parent, (u32 *)0xFFE00200);
		debugfs_create_x32("DCPLB_DATA10", 0600, parent, (u32 *)0xFFE00228);
		debugfs_create_x32("DCPLB_DATA11", 0600, parent, (u32 *)0xFFE0022C);
		debugfs_create_x32("DCPLB_DATA12", 0600, parent, (u32 *)0xFFE00230);
		debugfs_create_x32("DCPLB_DATA13", 0600, parent, (u32 *)0xFFE00234);
		debugfs_create_x32("DCPLB_DATA14", 0600, parent, (u32 *)0xFFE00238);
		debugfs_create_x32("DCPLB_DATA15", 0600, parent, (u32 *)0xFFE0023C);
		debugfs_create_x32("DCPLB_DATA1", 0600, parent, (u32 *)0xFFE00204);
		debugfs_create_x32("DCPLB_DATA2", 0600, parent, (u32 *)0xFFE00208);
		debugfs_create_x32("DCPLB_DATA3", 0600, parent, (u32 *)0xFFE0020C);
		debugfs_create_x32("DCPLB_DATA4", 0600, parent, (u32 *)0xFFE00210);
		debugfs_create_x32("DCPLB_DATA5", 0600, parent, (u32 *)0xFFE00214);
		debugfs_create_x32("DCPLB_DATA6", 0600, parent, (u32 *)0xFFE00218);
		debugfs_create_x32("DCPLB_DATA7", 0600, parent, (u32 *)0xFFE0021C);
		debugfs_create_x32("DCPLB_DATA8", 0600, parent, (u32 *)0xFFE00220);
		debugfs_create_x32("DCPLB_DATA9", 0600, parent, (u32 *)0xFFE00224);
		debugfs_create_x32("DCPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0000C);
		debugfs_create_x32("DCPLB_STATUS", 0600, parent, (u32 *)0xFFE00008);
		debugfs_create_x32("DMEM_CONTROL", 0600, parent, (u32 *)0xFFE00004);
		debugfs_create_x32("DTEST_COMMAND", 0600, parent, (u32 *)0xFFE00300);
		debugfs_create_x32("DTEST_DATA0", 0600, parent, (u32 *)0xFFE00400);
		debugfs_create_x32("DTEST_DATA1", 0600, parent, (u32 *)0xFFE00404);
		debugfs_create_x32("SRAM_BASE_ADDR", 0600, parent, (u32 *)0xFFE00000);

		parent = debugfs_create_dir("MDMA Destination 0", top);
		debugfs_create_x16("MDMA_D0_CONFIG", 0600, parent, (u16 *)0xFFC00F08);
		debugfs_create_x32("MDMA_D0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F24);
		debugfs_create_x32("MDMA_D0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F20);
		debugfs_create_x16("MDMA_D0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F30);
		debugfs_create_x16("MDMA_D0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F38);
		debugfs_create_x16("MDMA_D0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F28);
		debugfs_create_x32("MDMA_D0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F00);
		debugfs_create_x16("MDMA_D0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F2C);
		debugfs_create_x32("MDMA_D0_START_ADDR", 0600, parent, (u32 *)0xFFC00F04);
		debugfs_create_x16("MDMA_D0_X_COUNT", 0600, parent, (u16 *)0xFFC00F10);
		debugfs_create_x16("MDMA_D0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F14);
		debugfs_create_x16("MDMA_D0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F18);
		debugfs_create_x16("MDMA_D0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F1C);

		parent = debugfs_create_dir("MDMA Destination 1", top);
		debugfs_create_x16("MDMA_D1_CONFIG", 0600, parent, (u16 *)0xFFC00F88);
		debugfs_create_x32("MDMA_D1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FA4);
		debugfs_create_x32("MDMA_D1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FA0);
		debugfs_create_x16("MDMA_D1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FB0);
		debugfs_create_x16("MDMA_D1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FB8);
		debugfs_create_x16("MDMA_D1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FA8);
		debugfs_create_x32("MDMA_D1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F80);
		debugfs_create_x16("MDMA_D1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FAC);
		debugfs_create_x32("MDMA_D1_START_ADDR", 0600, parent, (u32 *)0xFFC00F84);
		debugfs_create_x16("MDMA_D1_X_COUNT", 0600, parent, (u16 *)0xFFC00F90);
		debugfs_create_x16("MDMA_D1_X_MODIFY", 0600, parent, (u16 *)0xFFC00F94);
		debugfs_create_x16("MDMA_D1_Y_COUNT", 0600, parent, (u16 *)0xFFC00F98);
		debugfs_create_x16("MDMA_D1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F9C);

		parent = debugfs_create_dir("MDMA Source 0", top);
		debugfs_create_x16("MDMA_S0_CONFIG", 0600, parent, (u16 *)0xFFC00F48);
		debugfs_create_x32("MDMA_S0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F64);
		debugfs_create_x32("MDMA_S0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F60);
		debugfs_create_x16("MDMA_S0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F70);
		debugfs_create_x16("MDMA_S0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F78);
		debugfs_create_x16("MDMA_S0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F68);
		debugfs_create_x32("MDMA_S0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F40);
		debugfs_create_x16("MDMA_S0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F6C);
		debugfs_create_x32("MDMA_S0_START_ADDR", 0600, parent, (u32 *)0xFFC00F44);
		debugfs_create_x16("MDMA_S0_X_COUNT", 0600, parent, (u16 *)0xFFC00F50);
		debugfs_create_x16("MDMA_S0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F54);
		debugfs_create_x16("MDMA_S0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F58);
		debugfs_create_x16("MDMA_S0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F5C);

		parent = debugfs_create_dir("MDMA Source 1", top);
		debugfs_create_x16("MDMA_S1_CONFIG", 0600, parent, (u16 *)0xFFC00FC8);
		debugfs_create_x32("MDMA_S1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FE4);
		debugfs_create_x32("MDMA_S1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FE0);
		debugfs_create_x16("MDMA_S1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FF0);
		debugfs_create_x16("MDMA_S1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FF8);
		debugfs_create_x16("MDMA_S1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FE8);
		debugfs_create_x32("MDMA_S1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00FC0);
		debugfs_create_x16("MDMA_S1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FEC);
		debugfs_create_x32("MDMA_S1_START_ADDR", 0600, parent, (u32 *)0xFFC00FC4);
		debugfs_create_x16("MDMA_S1_X_COUNT", 0600, parent, (u16 *)0xFFC00FD0);
		debugfs_create_x16("MDMA_S1_X_MODIFY", 0600, parent, (u16 *)0xFFC00FD4);
		debugfs_create_x16("MDMA_S1_Y_COUNT", 0600, parent, (u16 *)0xFFC00FD8);
		debugfs_create_x16("MDMA_S1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00FDC);

		parent = debugfs_create_dir("NFC", top);
		debugfs_create_x16("NFC_ADDR", 0600, parent, (u16 *)0xFFC03740);
		debugfs_create_x16("NFC_CMD", 0600, parent, (u16 *)0xFFC03744);
		debugfs_create_x16("NFC_COUNT", 0600, parent, (u16 *)0xFFC03720);
		debugfs_create_x16("NFC_CTL", 0600, parent, (u16 *)0xFFC03700);
		debugfs_create_x16("NFC_DATA_RD", 0600, parent, (u16 *)0xFFC0374C);
		debugfs_create_x16("NFC_DATA_WR", 0600, parent, (u16 *)0xFFC03748);
		debugfs_create_x16("NFC_ECC0", 0600, parent, (u16 *)0xFFC03710);
		debugfs_create_x16("NFC_ECC1", 0600, parent, (u16 *)0xFFC03714);
		debugfs_create_x16("NFC_ECC2", 0600, parent, (u16 *)0xFFC03718);
		debugfs_create_x16("NFC_ECC3", 0600, parent, (u16 *)0xFFC0371C);
		debugfs_create_x16("NFC_IRQMASK", 0600, parent, (u16 *)0xFFC0370C);
		debugfs_create_x16("NFC_IRQSTAT", 0600, parent, (u16 *)0xFFC03708);
		debugfs_create_x16("NFC_PGCTL", 0600, parent, (u16 *)0xFFC03728);
		debugfs_create_x16("NFC_READ", 0600, parent, (u16 *)0xFFC0372C);
		debugfs_create_x16("NFC_RST", 0600, parent, (u16 *)0xFFC03724);
		debugfs_create_x16("NFC_STAT", 0600, parent, (u16 *)0xFFC03704);

		parent = debugfs_create_dir("NON-GPIO", top);
		debugfs_create_x16("NONGPIO_DRIVE", 0600, parent, (u16 *)0xFFC03280);
		debugfs_create_x16("NONGPIO_HYSTERESIS", 0600, parent, (u16 *)0xFFC03288);
		debugfs_create_x16("NONGPIO_SLEW", 0600, parent, (u16 *)0xFFC03284);

		parent = debugfs_create_dir("OTP", top);
		debugfs_create_x16("OTP_BEN", 0600, parent, (u16 *)0xFFC03604);
		debugfs_create_x16("OTP_CONTROL", 0600, parent, (u16 *)0xFFC03600);
		debugfs_create_x32("OTP_DATA0", 0600, parent, (u32 *)0xFFC03680);
		debugfs_create_x32("OTP_DATA1", 0600, parent, (u32 *)0xFFC03684);
		debugfs_create_x32("OTP_DATA2", 0600, parent, (u32 *)0xFFC03688);
		debugfs_create_x32("OTP_DATA3", 0600, parent, (u32 *)0xFFC0368C);
		debugfs_create_x16("OTP_STATUS", 0600, parent, (u16 *)0xFFC03608);
		debugfs_create_x32("OTP_TIMING", 0600, parent, (u32 *)0xFFC0360C);

		parent = debugfs_create_dir("PLL", top);
		debugfs_create_x16("PLL_CTL", 0600, parent, (u16 *)0xFFC00000);
		debugfs_create_x16("PLL_DIV", 0600, parent, (u16 *)0xFFC00004);
		debugfs_create_x16("PLL_LOCKCNT", 0600, parent, (u16 *)0xFFC00010);
		debugfs_create_x16("PLL_STAT", 0600, parent, (u16 *)0xFFC0000C);
		debugfs_create_x16("VR_CTL", 0600, parent, (u16 *)0xFFC00008);

		parent = debugfs_create_dir("PPI", top);
		debugfs_create_x16("PPI_CONTROL", 0600, parent, (u16 *)0xFFC01000);
		debugfs_create_x16("PPI_COUNT", 0600, parent, (u16 *)0xFFC01008);
		debugfs_create_x16("PPI_DELAY", 0600, parent, (u16 *)0xFFC0100C);
		debugfs_create_x16("PPI_FRAME", 0600, parent, (u16 *)0xFFC01010);
		debugfs_create_x16("PPI_STATUS", 0600, parent, (u16 *)0xFFC01004);

		parent = debugfs_create_dir("Performance Monitor", top);
		debugfs_create_x32("PFCNTR0", 0600, parent, (u32 *)0xFFE08100);
		debugfs_create_x32("PFCNTR1", 0600, parent, (u32 *)0xFFE08104);
		debugfs_create_x32("PFCTL", 0600, parent, (u32 *)0xFFE08000);

		parent = debugfs_create_dir("Pin Control", top);
		debugfs_create_x16("PORTF_FER", 0600, parent, (u16 *)0xFFC03200);
		debugfs_create_x16("PORTG_FER", 0600, parent, (u16 *)0xFFC03204);
		debugfs_create_x16("PORTH_FER", 0600, parent, (u16 *)0xFFC03208);

		parent = debugfs_create_dir("Port I-O", top);
		debugfs_create_x16("PORTFIO", 0600, parent, (u16 *)0xFFC00700);
		debugfs_create_x16("PORTFIO_BOTH", 0600, parent, (u16 *)0xFFC0073C);
		debugfs_create_x16("PORTFIO_CLEAR", 0600, parent, (u16 *)0xFFC00704);
		debugfs_create_x16("PORTFIO_DIR", 0600, parent, (u16 *)0xFFC00730);
		debugfs_create_x16("PORTFIO_EDGE", 0600, parent, (u16 *)0xFFC00738);
		debugfs_create_x16("PORTFIO_INEN", 0600, parent, (u16 *)0xFFC00740);
		debugfs_create_x16("PORTFIO_MASKA", 0600, parent, (u16 *)0xFFC00710);
		debugfs_create_x16("PORTFIO_MASKA_CLEAR", 0600, parent, (u16 *)0xFFC00714);
		debugfs_create_x16("PORTFIO_MASKA_SET", 0600, parent, (u16 *)0xFFC00718);
		debugfs_create_x16("PORTFIO_MASKA_TOGGLE", 0600, parent, (u16 *)0xFFC0071C);
		debugfs_create_x16("PORTFIO_MASKB", 0600, parent, (u16 *)0xFFC00720);
		debugfs_create_x16("PORTFIO_MASKB_CLEAR", 0600, parent, (u16 *)0xFFC00724);
		debugfs_create_x16("PORTFIO_MASKB_SET", 0600, parent, (u16 *)0xFFC00728);
		debugfs_create_x16("PORTFIO_MASKB_TOGGLE", 0600, parent, (u16 *)0xFFC0072C);
		debugfs_create_x16("PORTFIO_POLAR", 0600, parent, (u16 *)0xFFC00734);
		debugfs_create_x16("PORTFIO_SET", 0600, parent, (u16 *)0xFFC00708);
		debugfs_create_x16("PORTFIO_TOGGLE", 0600, parent, (u16 *)0xFFC0070C);
		debugfs_create_x16("PORTGIO", 0600, parent, (u16 *)0xFFC01500);
		debugfs_create_x16("PORTGIO_BOTH", 0600, parent, (u16 *)0xFFC0153C);
		debugfs_create_x16("PORTGIO_CLEAR", 0600, parent, (u16 *)0xFFC01504);
		debugfs_create_x16("PORTGIO_DIR", 0600, parent, (u16 *)0xFFC01530);
		debugfs_create_x16("PORTGIO_EDGE", 0600, parent, (u16 *)0xFFC01538);
		debugfs_create_x16("PORTGIO_INEN", 0600, parent, (u16 *)0xFFC01540);
		debugfs_create_x16("PORTGIO_MASKA", 0600, parent, (u16 *)0xFFC01510);
		debugfs_create_x16("PORTGIO_MASKA_CLEAR", 0600, parent, (u16 *)0xFFC01514);
		debugfs_create_x16("PORTGIO_MASKA_SET", 0600, parent, (u16 *)0xFFC01518);
		debugfs_create_x16("PORTGIO_MASKA_TOGGLE", 0600, parent, (u16 *)0xFFC0151C);
		debugfs_create_x16("PORTGIO_MASKB", 0600, parent, (u16 *)0xFFC01520);
		debugfs_create_x16("PORTGIO_MASKB_CLEAR", 0600, parent, (u16 *)0xFFC01524);
		debugfs_create_x16("PORTGIO_MASKB_SET", 0600, parent, (u16 *)0xFFC01528);
		debugfs_create_x16("PORTGIO_MASKB_TOGGLE", 0600, parent, (u16 *)0xFFC0152C);
		debugfs_create_x16("PORTGIO_POLAR", 0600, parent, (u16 *)0xFFC01534);
		debugfs_create_x16("PORTGIO_SET", 0600, parent, (u16 *)0xFFC01508);
		debugfs_create_x16("PORTGIO_TOGGLE", 0600, parent, (u16 *)0xFFC0150C);
		debugfs_create_x16("PORTHIO", 0600, parent, (u16 *)0xFFC01700);
		debugfs_create_x16("PORTHIO_BOTH", 0600, parent, (u16 *)0xFFC0173C);
		debugfs_create_x16("PORTHIO_CLEAR", 0600, parent, (u16 *)0xFFC01704);
		debugfs_create_x16("PORTHIO_DIR", 0600, parent, (u16 *)0xFFC01730);
		debugfs_create_x16("PORTHIO_EDGE", 0600, parent, (u16 *)0xFFC01738);
		debugfs_create_x16("PORTHIO_INEN", 0600, parent, (u16 *)0xFFC01740);
		debugfs_create_x16("PORTHIO_MASKA", 0600, parent, (u16 *)0xFFC01710);
		debugfs_create_x16("PORTHIO_MASKA_CLEAR", 0600, parent, (u16 *)0xFFC01714);
		debugfs_create_x16("PORTHIO_MASKA_SET", 0600, parent, (u16 *)0xFFC01718);
		debugfs_create_x16("PORTHIO_MASKA_TOGGLE", 0600, parent, (u16 *)0xFFC0171C);
		debugfs_create_x16("PORTHIO_MASKB", 0600, parent, (u16 *)0xFFC01720);
		debugfs_create_x16("PORTHIO_MASKB_CLEAR", 0600, parent, (u16 *)0xFFC01724);
		debugfs_create_x16("PORTHIO_MASKB_SET", 0600, parent, (u16 *)0xFFC01728);
		debugfs_create_x16("PORTHIO_MASKB_TOGGLE", 0600, parent, (u16 *)0xFFC0172C);
		debugfs_create_x16("PORTHIO_POLAR", 0600, parent, (u16 *)0xFFC01734);
		debugfs_create_x16("PORTHIO_SET", 0600, parent, (u16 *)0xFFC01708);
		debugfs_create_x16("PORTHIO_TOGGLE", 0600, parent, (u16 *)0xFFC0170C);

		parent = debugfs_create_dir("RTC", top);
		debugfs_create_x32("RTC_ALARM", 0600, parent, (u32 *)0xFFC00310);
		debugfs_create_x16("RTC_ICTL", 0600, parent, (u16 *)0xFFC00304);
		debugfs_create_x16("RTC_ISTAT", 0600, parent, (u16 *)0xFFC00308);
		debugfs_create_x16("RTC_PREN", 0600, parent, (u16 *)0xFFC00314);
		debugfs_create_x32("RTC_STAT", 0600, parent, (u32 *)0xFFC00300);
		debugfs_create_x16("RTC_SWCNT", 0600, parent, (u16 *)0xFFC0030C);

		parent = debugfs_create_dir("SPI", top);
		debugfs_create_x16("SPI_BAUD", 0600, parent, (u16 *)0xFFC00514);
		debugfs_create_x16("SPI_CTL", 0600, parent, (u16 *)0xFFC00500);
		debugfs_create_x16("SPI_FLG", 0600, parent, (u16 *)0xFFC00504);
		debugfs_create_x16("SPI_RDBR", 0600, parent, (u16 *)0xFFC00510);
		debugfs_create_x16("SPI_SHADOW", 0600, parent, (u16 *)0xFFC00518);
		debugfs_create_x16("SPI_STAT", 0600, parent, (u16 *)0xFFC00508);
		debugfs_create_x16("SPI_TDBR", 0600, parent, (u16 *)0xFFC0050C);

		parent = debugfs_create_dir("SPORT", top);
		debugfs_create_x16("SPORT0_CHNL", 0600, parent, (u16 *)0xFFC00834);
		debugfs_create_x16("SPORT0_MCMC1", 0600, parent, (u16 *)0xFFC00838);
		debugfs_create_x16("SPORT0_MCMC2", 0600, parent, (u16 *)0xFFC0083C);
		debugfs_create_x32("SPORT0_MRCS0", 0600, parent, (u32 *)0xFFC00850);
		debugfs_create_x32("SPORT0_MRCS1", 0600, parent, (u32 *)0xFFC00854);
		debugfs_create_x32("SPORT0_MRCS2", 0600, parent, (u32 *)0xFFC00858);
		debugfs_create_x32("SPORT0_MRCS3", 0600, parent, (u32 *)0xFFC0085C);
		debugfs_create_x32("SPORT0_MTCS0", 0600, parent, (u32 *)0xFFC00840);
		debugfs_create_x32("SPORT0_MTCS1", 0600, parent, (u32 *)0xFFC00844);
		debugfs_create_x32("SPORT0_MTCS2", 0600, parent, (u32 *)0xFFC00848);
		debugfs_create_x32("SPORT0_MTCS3", 0600, parent, (u32 *)0xFFC0084C);
		debugfs_create_x16("SPORT0_RCLKDIV", 0600, parent, (u16 *)0xFFC00828);
		debugfs_create_x16("SPORT0_RCR1", 0600, parent, (u16 *)0xFFC00820);
		debugfs_create_x16("SPORT0_RCR2", 0600, parent, (u16 *)0xFFC00824);
		debugfs_create_x16("SPORT0_RFSDIV", 0600, parent, (u16 *)0xFFC0082C);
		debugfs_create_x32("SPORT0_RX", 0600, parent, (u32 *)0xFFC00818);
		debugfs_create_x16("SPORT0_STAT", 0600, parent, (u16 *)0xFFC00830);
		debugfs_create_x16("SPORT0_TCLKDIV", 0600, parent, (u16 *)0xFFC00808);
		debugfs_create_x16("SPORT0_TCR1", 0600, parent, (u16 *)0xFFC00800);
		debugfs_create_x16("SPORT0_TCR2", 0600, parent, (u16 *)0xFFC00804);
		debugfs_create_x16("SPORT0_TFSDIV", 0600, parent, (u16 *)0xFFC0080C);
		debugfs_create_x32("SPORT0_TX", 0600, parent, (u32 *)0xFFC00810);
		debugfs_create_x16("SPORT1_CHNL", 0600, parent, (u16 *)0xFFC00934);
		debugfs_create_x16("SPORT1_MCMC1", 0600, parent, (u16 *)0xFFC00938);
		debugfs_create_x16("SPORT1_MCMC2", 0600, parent, (u16 *)0xFFC0093C);
		debugfs_create_x32("SPORT1_MRCS0", 0600, parent, (u32 *)0xFFC00950);
		debugfs_create_x32("SPORT1_MRCS1", 0600, parent, (u32 *)0xFFC00954);
		debugfs_create_x32("SPORT1_MRCS2", 0600, parent, (u32 *)0xFFC00958);
		debugfs_create_x32("SPORT1_MRCS3", 0600, parent, (u32 *)0xFFC0095C);
		debugfs_create_x32("SPORT1_MTCS0", 0600, parent, (u32 *)0xFFC00940);
		debugfs_create_x32("SPORT1_MTCS1", 0600, parent, (u32 *)0xFFC00944);
		debugfs_create_x32("SPORT1_MTCS2", 0600, parent, (u32 *)0xFFC00948);
		debugfs_create_x32("SPORT1_MTCS3", 0600, parent, (u32 *)0xFFC0094C);
		debugfs_create_x16("SPORT1_RCLKDIV", 0600, parent, (u16 *)0xFFC00928);
		debugfs_create_x16("SPORT1_RCR1", 0600, parent, (u16 *)0xFFC00920);
		debugfs_create_x16("SPORT1_RCR2", 0600, parent, (u16 *)0xFFC00924);
		debugfs_create_x16("SPORT1_RFSDIV", 0600, parent, (u16 *)0xFFC0092C);
		debugfs_create_x32("SPORT1_RX", 0600, parent, (u32 *)0xFFC00918);
		debugfs_create_x16("SPORT1_STAT", 0600, parent, (u16 *)0xFFC00930);
		debugfs_create_x16("SPORT1_TCLKDIV", 0600, parent, (u16 *)0xFFC00908);
		debugfs_create_x16("SPORT1_TCR1", 0600, parent, (u16 *)0xFFC00900);
		debugfs_create_x16("SPORT1_TCR2", 0600, parent, (u16 *)0xFFC00904);
		debugfs_create_x16("SPORT1_TFSDIV", 0600, parent, (u16 *)0xFFC0090C);
		debugfs_create_x32("SPORT1_TX", 0600, parent, (u32 *)0xFFC00910);

		parent = debugfs_create_dir("Security", top);
		debugfs_create_x16("SECURE_CONTROL", 0600, parent, (u16 *)0xFFC03624);
		debugfs_create_x16("SECURE_STATUS", 0600, parent, (u16 *)0xFFC03628);
		debugfs_create_x32("SECURE_SYSSWT", 0600, parent, (u32 *)0xFFC03620);

		parent = debugfs_create_dir("System Interrupt Controller Register File", top);
		debugfs_create_x32("SIC_IAR0", 0600, parent, (u32 *)0xFFC00110);
		debugfs_create_x32("SIC_IAR1", 0600, parent, (u32 *)0xFFC00114);
		debugfs_create_x32("SIC_IAR2", 0600, parent, (u32 *)0xFFC00118);
		debugfs_create_x32("SIC_IAR3", 0600, parent, (u32 *)0xFFC0011C);
		debugfs_create_x32("SIC_IAR4", 0600, parent, (u32 *)0xFFC00150);
		debugfs_create_x32("SIC_IAR5", 0600, parent, (u32 *)0xFFC00154);
		debugfs_create_x32("SIC_IAR6", 0600, parent, (u32 *)0xFFC00158);
		debugfs_create_x32("SIC_IAR7", 0600, parent, (u32 *)0xFFC0015C);
		debugfs_create_x32("SIC_IMASK0", 0600, parent, (u32 *)0xFFC0010C);
		debugfs_create_x32("SIC_IMASK1", 0600, parent, (u32 *)0xFFC0014C);
		debugfs_create_x32("SIC_ISR0", 0600, parent, (u32 *)0xFFC00120);
		debugfs_create_x32("SIC_ISR1", 0600, parent, (u32 *)0xFFC00160);
		debugfs_create_x32("SIC_IWR0", 0600, parent, (u32 *)0xFFC00124);
		debugfs_create_x32("SIC_IWR1", 0600, parent, (u32 *)0xFFC00164);
		debugfs_create_x32("SIC_RVECT", 0600, parent, (u32 *)0xFFC00108);

		parent = debugfs_create_dir("System Reset and Interrupt Control Registers", top);
		debugfs_create_x16("SWRST", 0600, parent, (u16 *)0xFFC00100);
		debugfs_create_x16("SYSCR", 0600, parent, (u16 *)0xFFC00104);

		parent = debugfs_create_dir("TWI", top);
		debugfs_create_x16("TWI_CLKDIV", 0600, parent, (u16 *)0xFFC01400);
		debugfs_create_x16("TWI_CONTROL", 0600, parent, (u16 *)0xFFC01404);
		debugfs_create_x16("TWI_FIFO_CTL", 0600, parent, (u16 *)0xFFC01428);
		debugfs_create_x16("TWI_FIFO_STAT", 0600, parent, (u16 *)0xFFC0142C);
		debugfs_create_x16("TWI_INT_MASK", 0600, parent, (u16 *)0xFFC01424);
		debugfs_create_x16("TWI_INT_STAT", 0600, parent, (u16 *)0xFFC01420);
		debugfs_create_x16("TWI_MASTER_ADDR", 0600, parent, (u16 *)0xFFC0141C);
		debugfs_create_x16("TWI_MASTER_CTL", 0600, parent, (u16 *)0xFFC01414);
		debugfs_create_x16("TWI_MASTER_STAT", 0600, parent, (u16 *)0xFFC01418);
		debugfs_create_x16("TWI_RCV_DATA16", 0600, parent, (u16 *)0xFFC0148C);
		debugfs_create_x16("TWI_RCV_DATA8", 0600, parent, (u16 *)0xFFC01488);
		debugfs_create_x16("TWI_SLAVE_ADDR", 0600, parent, (u16 *)0xFFC01410);
		debugfs_create_x16("TWI_SLAVE_CTL", 0600, parent, (u16 *)0xFFC01408);
		debugfs_create_x16("TWI_SLAVE_STAT", 0600, parent, (u16 *)0xFFC0140C);
		debugfs_create_x16("TWI_XMT_DATA16", 0600, parent, (u16 *)0xFFC01484);
		debugfs_create_x16("TWI_XMT_DATA8", 0600, parent, (u16 *)0xFFC01480);

		parent = debugfs_create_dir("Timer Registers", top);
		debugfs_create_x16("TIMER0_CONFIG", 0600, parent, (u16 *)0xFFC00600);
		debugfs_create_x32("TIMER0_COUNTER", 0600, parent, (u32 *)0xFFC00604);
		debugfs_create_x32("TIMER0_PERIOD", 0600, parent, (u32 *)0xFFC00608);
		debugfs_create_x32("TIMER0_WIDTH", 0600, parent, (u32 *)0xFFC0060C);
		debugfs_create_x16("TIMER1_CONFIG", 0600, parent, (u16 *)0xFFC00610);
		debugfs_create_x32("TIMER1_COUNTER", 0600, parent, (u32 *)0xFFC00614);
		debugfs_create_x32("TIMER1_PERIOD", 0600, parent, (u32 *)0xFFC00618);
		debugfs_create_x32("TIMER1_WIDTH", 0600, parent, (u32 *)0xFFC0061C);
		debugfs_create_x16("TIMER2_CONFIG", 0600, parent, (u16 *)0xFFC00620);
		debugfs_create_x32("TIMER2_COUNTER", 0600, parent, (u32 *)0xFFC00624);
		debugfs_create_x32("TIMER2_PERIOD", 0600, parent, (u32 *)0xFFC00628);
		debugfs_create_x32("TIMER2_WIDTH", 0600, parent, (u32 *)0xFFC0062C);
		debugfs_create_x16("TIMER3_CONFIG", 0600, parent, (u16 *)0xFFC00630);
		debugfs_create_x32("TIMER3_COUNTER", 0600, parent, (u32 *)0xFFC00634);
		debugfs_create_x32("TIMER3_PERIOD", 0600, parent, (u32 *)0xFFC00638);
		debugfs_create_x32("TIMER3_WIDTH", 0600, parent, (u32 *)0xFFC0063C);
		debugfs_create_x16("TIMER4_CONFIG", 0600, parent, (u16 *)0xFFC00640);
		debugfs_create_x32("TIMER4_COUNTER", 0600, parent, (u32 *)0xFFC00644);
		debugfs_create_x32("TIMER4_PERIOD", 0600, parent, (u32 *)0xFFC00648);
		debugfs_create_x32("TIMER4_WIDTH", 0600, parent, (u32 *)0xFFC0064C);
		debugfs_create_x16("TIMER5_CONFIG", 0600, parent, (u16 *)0xFFC00650);
		debugfs_create_x32("TIMER5_COUNTER", 0600, parent, (u32 *)0xFFC00654);
		debugfs_create_x32("TIMER5_PERIOD", 0600, parent, (u32 *)0xFFC00658);
		debugfs_create_x32("TIMER5_WIDTH", 0600, parent, (u32 *)0xFFC0065C);
		debugfs_create_x16("TIMER6_CONFIG", 0600, parent, (u16 *)0xFFC00660);
		debugfs_create_x32("TIMER6_COUNTER", 0600, parent, (u32 *)0xFFC00664);
		debugfs_create_x32("TIMER6_PERIOD", 0600, parent, (u32 *)0xFFC00668);
		debugfs_create_x32("TIMER6_WIDTH", 0600, parent, (u32 *)0xFFC0066C);
		debugfs_create_x16("TIMER7_CONFIG", 0600, parent, (u16 *)0xFFC00670);
		debugfs_create_x32("TIMER7_COUNTER", 0600, parent, (u32 *)0xFFC00674);
		debugfs_create_x32("TIMER7_PERIOD", 0600, parent, (u32 *)0xFFC00678);
		debugfs_create_x32("TIMER7_WIDTH", 0600, parent, (u32 *)0xFFC0067C);
		debugfs_create_x16("TIMER_DISABLE", 0600, parent, (u16 *)0xFFC00684);
		debugfs_create_x16("TIMER_ENABLE", 0600, parent, (u16 *)0xFFC00680);
		debugfs_create_x32("TIMER_STATUS", 0600, parent, (u32 *)0xFFC00688);

		parent = debugfs_create_dir("Trace Unit", top);
		debugfs_create_x32("TBUF", 0600, parent, (u32 *)0xFFE06100);
		debugfs_create_x32("TBUFCTL", 0600, parent, (u32 *)0xFFE06000);
		debugfs_create_x32("TBUFSTAT", 0600, parent, (u32 *)0xFFE06004);

		parent = debugfs_create_dir("UART", top);
		debugfs_create_x16("UART0_DLH", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART0_DLL", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART0_GCTL", 0600, parent, (u16 *)0xFFC00424);
		debugfs_create_x16("UART0_IER", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART0_IIR", 0600, parent, (u16 *)0xFFC00408);
		debugfs_create_x16("UART0_LCR", 0600, parent, (u16 *)0xFFC0040C);
		debugfs_create_x16("UART0_LSR", 0600, parent, (u16 *)0xFFC00414);
		debugfs_create_x16("UART0_MCR", 0600, parent, (u16 *)0xFFC00410);
		debugfs_create_x16("UART0_MSR", 0600, parent, (u16 *)0xFFC00418);
		debugfs_create_x16("UART0_RBR", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART0_SCR", 0600, parent, (u16 *)0xFFC0041C);
		debugfs_create_x16("UART0_THR", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART1_DLH", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("UART1_DLL", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART1_GCTL", 0600, parent, (u16 *)0xFFC02024);
		debugfs_create_x16("UART1_IER", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("UART1_IIR", 0600, parent, (u16 *)0xFFC02008);
		debugfs_create_x16("UART1_LCR", 0600, parent, (u16 *)0xFFC0200C);
		debugfs_create_x16("UART1_LSR", 0600, parent, (u16 *)0xFFC02014);
		debugfs_create_x16("UART1_MCR", 0600, parent, (u16 *)0xFFC02010);
		debugfs_create_x16("UART1_MSR", 0600, parent, (u16 *)0xFFC02018);
		debugfs_create_x16("UART1_RBR", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART1_SCR", 0600, parent, (u16 *)0xFFC0201C);
		debugfs_create_x16("UART1_THR", 0600, parent, (u16 *)0xFFC02000);

		parent = debugfs_create_dir("USB", top);
		debugfs_create_x16("USB_APHY_CALIB", 0600, parent, (u16 *)0xFFC039E4);
		debugfs_create_x16("USB_APHY_CNTRL2", 0600, parent, (u16 *)0xFFC039E8);
		debugfs_create_x16("USB_APHY_CNTRL", 0600, parent, (u16 *)0xFFC039E0);
		debugfs_create_x16("USB_COUNT0", 0600, parent, (u16 *)0xFFC03850);
		debugfs_create_x16("USB_CSR0", 0600, parent, (u16 *)0xFFC03844);
		debugfs_create_x16("USB_DMA0_ADDRHIGH", 0600, parent, (u16 *)0xFFC03C0C);
		debugfs_create_x16("USB_DMA0_ADDRLOW", 0600, parent, (u16 *)0xFFC03C08);
		debugfs_create_x16("USB_DMA0_CONTROL", 0600, parent, (u16 *)0xFFC03C04);
		debugfs_create_x16("USB_DMA0_COUNTHIGH", 0600, parent, (u16 *)0xFFC03C14);
		debugfs_create_x16("USB_DMA0_COUNTLOW", 0600, parent, (u16 *)0xFFC03C10);
		debugfs_create_x16("USB_DMA1_ADDRHIGH", 0600, parent, (u16 *)0xFFC03C2C);
		debugfs_create_x16("USB_DMA1_ADDRLOW", 0600, parent, (u16 *)0xFFC03C28);
		debugfs_create_x16("USB_DMA1_CONTROL", 0600, parent, (u16 *)0xFFC03C24);
		debugfs_create_x16("USB_DMA1_COUNTHIGH", 0600, parent, (u16 *)0xFFC03C34);
		debugfs_create_x16("USB_DMA1_COUNTLOW", 0600, parent, (u16 *)0xFFC03C30);
		debugfs_create_x16("USB_DMA2_ADDRHIGH", 0600, parent, (u16 *)0xFFC03C4C);
		debugfs_create_x16("USB_DMA2_ADDRLOW", 0600, parent, (u16 *)0xFFC03C48);
		debugfs_create_x16("USB_DMA2_CONTROL", 0600, parent, (u16 *)0xFFC03C44);
		debugfs_create_x16("USB_DMA2_COUNTHIGH", 0600, parent, (u16 *)0xFFC03C54);
		debugfs_create_x16("USB_DMA2_COUNTLOW", 0600, parent, (u16 *)0xFFC03C50);
		debugfs_create_x16("USB_DMA3_ADDRHIGH", 0600, parent, (u16 *)0xFFC03C6C);
		debugfs_create_x16("USB_DMA3_ADDRLOW", 0600, parent, (u16 *)0xFFC03C68);
		debugfs_create_x16("USB_DMA3_CONTROL", 0600, parent, (u16 *)0xFFC03C64);
		debugfs_create_x16("USB_DMA3_COUNTHIGH", 0600, parent, (u16 *)0xFFC03C74);
		debugfs_create_x16("USB_DMA3_COUNTLOW", 0600, parent, (u16 *)0xFFC03C70);
		debugfs_create_x16("USB_DMA4_ADDRHIGH", 0600, parent, (u16 *)0xFFC03C8C);
		debugfs_create_x16("USB_DMA4_ADDRLOW", 0600, parent, (u16 *)0xFFC03C88);
		debugfs_create_x16("USB_DMA4_CONTROL", 0600, parent, (u16 *)0xFFC03C84);
		debugfs_create_x16("USB_DMA4_COUNTHIGH", 0600, parent, (u16 *)0xFFC03C94);
		debugfs_create_x16("USB_DMA4_COUNTLOW", 0600, parent, (u16 *)0xFFC03C90);
		debugfs_create_x16("USB_DMA5_ADDRHIGH", 0600, parent, (u16 *)0xFFC03CAC);
		debugfs_create_x16("USB_DMA5_ADDRLOW", 0600, parent, (u16 *)0xFFC03CA8);
		debugfs_create_x16("USB_DMA5_CONTROL", 0600, parent, (u16 *)0xFFC03CA4);
		debugfs_create_x16("USB_DMA5_COUNTHIGH", 0600, parent, (u16 *)0xFFC03CB4);
		debugfs_create_x16("USB_DMA5_COUNTLOW", 0600, parent, (u16 *)0xFFC03CB0);
		debugfs_create_x16("USB_DMA6_ADDRHIGH", 0600, parent, (u16 *)0xFFC03CCC);
		debugfs_create_x16("USB_DMA6_ADDRLOW", 0600, parent, (u16 *)0xFFC03CC8);
		debugfs_create_x16("USB_DMA6_CONTROL", 0600, parent, (u16 *)0xFFC03CC4);
		debugfs_create_x16("USB_DMA6_COUNTHIGH", 0600, parent, (u16 *)0xFFC03CD4);
		debugfs_create_x16("USB_DMA6_COUNTLOW", 0600, parent, (u16 *)0xFFC03CD0);
		debugfs_create_x16("USB_DMA7_ADDRHIGH", 0600, parent, (u16 *)0xFFC03CEC);
		debugfs_create_x16("USB_DMA7_ADDRLOW", 0600, parent, (u16 *)0xFFC03CE8);
		debugfs_create_x16("USB_DMA7_CONTROL", 0600, parent, (u16 *)0xFFC03CE4);
		debugfs_create_x16("USB_DMA7_COUNTHIGH", 0600, parent, (u16 *)0xFFC03CF4);
		debugfs_create_x16("USB_DMA7_COUNTLOW", 0600, parent, (u16 *)0xFFC03CF0);
		debugfs_create_x16("USB_DMA_INTERRUPT", 0600, parent, (u16 *)0xFFC03C00);
		debugfs_create_x16("USB_EP0_FIFO", 0600, parent, (u16 *)0xFFC03880);
		debugfs_create_x16("USB_EP1_FIFO", 0600, parent, (u16 *)0xFFC03888);
		debugfs_create_x16("USB_EP2_FIFO", 0600, parent, (u16 *)0xFFC03890);
		debugfs_create_x16("USB_EP3_FIFO", 0600, parent, (u16 *)0xFFC03898);
		debugfs_create_x16("USB_EP4_FIFO", 0600, parent, (u16 *)0xFFC038A0);
		debugfs_create_x16("USB_EP5_FIFO", 0600, parent, (u16 *)0xFFC038A8);
		debugfs_create_x16("USB_EP6_FIFO", 0600, parent, (u16 *)0xFFC038B0);
		debugfs_create_x16("USB_EP7_FIFO", 0600, parent, (u16 *)0xFFC038B8);
		debugfs_create_x16("USB_EP_NI0_RXCOUNT", 0600, parent, (u16 *)0xFFC03A10);
		debugfs_create_x16("USB_EP_NI0_RXCSR", 0600, parent, (u16 *)0xFFC03A0C);
		debugfs_create_x16("USB_EP_NI0_RXINTERVAL", 0600, parent, (u16 *)0xFFC03A20);
		debugfs_create_x16("USB_EP_NI0_RXMAXP", 0600, parent, (u16 *)0xFFC03A08);
		debugfs_create_x16("USB_EP_NI0_RXTYPE", 0600, parent, (u16 *)0xFFC03A1C);
		debugfs_create_x16("USB_EP_NI0_TXCOUNT", 0600, parent, (u16 *)0xFFC03A28);
		debugfs_create_x16("USB_EP_NI0_TXCSR", 0600, parent, (u16 *)0xFFC03A04);
		debugfs_create_x16("USB_EP_NI0_TXINTERVAL", 0600, parent, (u16 *)0xFFC03A18);
		debugfs_create_x16("USB_EP_NI0_TXMAXP", 0600, parent, (u16 *)0xFFC03A00);
		debugfs_create_x16("USB_EP_NI0_TXTYPE", 0600, parent, (u16 *)0xFFC03A14);
		debugfs_create_x16("USB_EP_NI1_RXCOUNT", 0600, parent, (u16 *)0xFFC03A50);
		debugfs_create_x16("USB_EP_NI1_RXCSR", 0600, parent, (u16 *)0xFFC03A4C);
		debugfs_create_x16("USB_EP_NI1_RXINTERVAL", 0600, parent, (u16 *)0xFFC03A60);
		debugfs_create_x16("USB_EP_NI1_RXMAXP", 0600, parent, (u16 *)0xFFC03A48);
		debugfs_create_x16("USB_EP_NI1_RXTYPE", 0600, parent, (u16 *)0xFFC03A5C);
		debugfs_create_x16("USB_EP_NI1_TXCOUNT", 0600, parent, (u16 *)0xFFC03A68);
		debugfs_create_x16("USB_EP_NI1_TXCSR", 0600, parent, (u16 *)0xFFC03A44);
		debugfs_create_x16("USB_EP_NI1_TXINTERVAL", 0600, parent, (u16 *)0xFFC03A58);
		debugfs_create_x16("USB_EP_NI1_TXMAXP", 0600, parent, (u16 *)0xFFC03A40);
		debugfs_create_x16("USB_EP_NI1_TXTYPE", 0600, parent, (u16 *)0xFFC03A54);
		debugfs_create_x16("USB_EP_NI2_RXCOUNT", 0600, parent, (u16 *)0xFFC03A90);
		debugfs_create_x16("USB_EP_NI2_RXCSR", 0600, parent, (u16 *)0xFFC03A8C);
		debugfs_create_x16("USB_EP_NI2_RXINTERVAL", 0600, parent, (u16 *)0xFFC03AA0);
		debugfs_create_x16("USB_EP_NI2_RXMAXP", 0600, parent, (u16 *)0xFFC03A88);
		debugfs_create_x16("USB_EP_NI2_RXTYPE", 0600, parent, (u16 *)0xFFC03A9C);
		debugfs_create_x16("USB_EP_NI2_TXCOUNT", 0600, parent, (u16 *)0xFFC03AA8);
		debugfs_create_x16("USB_EP_NI2_TXCSR", 0600, parent, (u16 *)0xFFC03A84);
		debugfs_create_x16("USB_EP_NI2_TXINTERVAL", 0600, parent, (u16 *)0xFFC03A98);
		debugfs_create_x16("USB_EP_NI2_TXMAXP", 0600, parent, (u16 *)0xFFC03A80);
		debugfs_create_x16("USB_EP_NI2_TXTYPE", 0600, parent, (u16 *)0xFFC03A94);
		debugfs_create_x16("USB_EP_NI3_RXCOUNT", 0600, parent, (u16 *)0xFFC03AD0);
		debugfs_create_x16("USB_EP_NI3_RXCSR", 0600, parent, (u16 *)0xFFC03ACC);
		debugfs_create_x16("USB_EP_NI3_RXINTERVAL", 0600, parent, (u16 *)0xFFC03AE0);
		debugfs_create_x16("USB_EP_NI3_RXMAXP", 0600, parent, (u16 *)0xFFC03AC8);
		debugfs_create_x16("USB_EP_NI3_RXTYPE", 0600, parent, (u16 *)0xFFC03ADC);
		debugfs_create_x16("USB_EP_NI3_TXCOUNT", 0600, parent, (u16 *)0xFFC03AE8);
		debugfs_create_x16("USB_EP_NI3_TXCSR", 0600, parent, (u16 *)0xFFC03AC4);
		debugfs_create_x16("USB_EP_NI3_TXINTERVAL", 0600, parent, (u16 *)0xFFC03AD8);
		debugfs_create_x16("USB_EP_NI3_TXMAXP", 0600, parent, (u16 *)0xFFC03AC0);
		debugfs_create_x16("USB_EP_NI3_TXTYPE", 0600, parent, (u16 *)0xFFC03AD4);
		debugfs_create_x16("USB_EP_NI4_RXCOUNT", 0600, parent, (u16 *)0xFFC03B10);
		debugfs_create_x16("USB_EP_NI4_RXCSR", 0600, parent, (u16 *)0xFFC03B0C);
		debugfs_create_x16("USB_EP_NI4_RXINTERVAL", 0600, parent, (u16 *)0xFFC03B20);
		debugfs_create_x16("USB_EP_NI4_RXMAXP", 0600, parent, (u16 *)0xFFC03B08);
		debugfs_create_x16("USB_EP_NI4_RXTYPE", 0600, parent, (u16 *)0xFFC03B1C);
		debugfs_create_x16("USB_EP_NI4_TXCOUNT", 0600, parent, (u16 *)0xFFC03B28);
		debugfs_create_x16("USB_EP_NI4_TXCSR", 0600, parent, (u16 *)0xFFC03B04);
		debugfs_create_x16("USB_EP_NI4_TXINTERVAL", 0600, parent, (u16 *)0xFFC03B18);
		debugfs_create_x16("USB_EP_NI4_TXMAXP", 0600, parent, (u16 *)0xFFC03B00);
		debugfs_create_x16("USB_EP_NI4_TXTYPE", 0600, parent, (u16 *)0xFFC03B14);
		debugfs_create_x16("USB_EP_NI5_RXCOUNT", 0600, parent, (u16 *)0xFFC03B50);
		debugfs_create_x16("USB_EP_NI5_RXCSR", 0600, parent, (u16 *)0xFFC03B4C);
		debugfs_create_x16("USB_EP_NI5_RXINTERVAL", 0600, parent, (u16 *)0xFFC03B60);
		debugfs_create_x16("USB_EP_NI5_RXMAXP", 0600, parent, (u16 *)0xFFC03B48);
		debugfs_create_x16("USB_EP_NI5_RXTYPE", 0600, parent, (u16 *)0xFFC03B5C);
		debugfs_create_x16("USB_EP_NI5_TXCOUNT", 0600, parent, (u16 *)0xFFC03B68);
		debugfs_create_x16("USB_EP_NI5_TXCSR", 0600, parent, (u16 *)0xFFC03B44);
		debugfs_create_x16("USB_EP_NI5_TXINTERVAL", 0600, parent, (u16 *)0xFFC03B58);
		debugfs_create_x16("USB_EP_NI5_TXMAXP", 0600, parent, (u16 *)0xFFC03B40);
		debugfs_create_x16("USB_EP_NI5_TXTYPE", 0600, parent, (u16 *)0xFFC03B54);
		debugfs_create_x16("USB_EP_NI6_RXCOUNT", 0600, parent, (u16 *)0xFFC03B90);
		debugfs_create_x16("USB_EP_NI6_RXCSR", 0600, parent, (u16 *)0xFFC03B8C);
		debugfs_create_x16("USB_EP_NI6_RXINTERVAL", 0600, parent, (u16 *)0xFFC03BA0);
		debugfs_create_x16("USB_EP_NI6_RXMAXP", 0600, parent, (u16 *)0xFFC03B88);
		debugfs_create_x16("USB_EP_NI6_RXTYPE", 0600, parent, (u16 *)0xFFC03B9C);
		debugfs_create_x16("USB_EP_NI6_TXCOUNT", 0600, parent, (u16 *)0xFFC03BA8);
		debugfs_create_x16("USB_EP_NI6_TXCSR", 0600, parent, (u16 *)0xFFC03B84);
		debugfs_create_x16("USB_EP_NI6_TXINTERVAL", 0600, parent, (u16 *)0xFFC03B98);
		debugfs_create_x16("USB_EP_NI6_TXMAXP", 0600, parent, (u16 *)0xFFC03B80);
		debugfs_create_x16("USB_EP_NI6_TXTYPE", 0600, parent, (u16 *)0xFFC03B94);
		debugfs_create_x16("USB_EP_NI7_RXCOUNT", 0600, parent, (u16 *)0xFFC03BD0);
		debugfs_create_x16("USB_EP_NI7_RXCSR", 0600, parent, (u16 *)0xFFC03BCC);
		debugfs_create_x16("USB_EP_NI7_RXINTERVAL", 0600, parent, (u16 *)0xFFC03BF0);
		debugfs_create_x16("USB_EP_NI7_RXMAXP", 0600, parent, (u16 *)0xFFC03BC8);
		debugfs_create_x16("USB_EP_NI7_RXTYPE", 0600, parent, (u16 *)0xFFC03BDC);
		debugfs_create_x16("USB_EP_NI7_TXCOUNT", 0600, parent, (u16 *)0xFFC03BF8);
		debugfs_create_x16("USB_EP_NI7_TXCSR", 0600, parent, (u16 *)0xFFC03BC4);
		debugfs_create_x16("USB_EP_NI7_TXINTERVAL", 0600, parent, (u16 *)0xFFC03BD8);
		debugfs_create_x16("USB_EP_NI7_TXMAXP", 0600, parent, (u16 *)0xFFC03BC0);
		debugfs_create_x16("USB_EP_NI7_TXTYPE", 0600, parent, (u16 *)0xFFC03BD4);
		debugfs_create_x16("USB_FADDR", 0600, parent, (u16 *)0xFFC03800);
		debugfs_create_x16("USB_FRAME", 0600, parent, (u16 *)0xFFC03820);
		debugfs_create_x16("USB_FS_EOF1", 0600, parent, (u16 *)0xFFC03954);
		debugfs_create_x16("USB_GLOBAL_CTL", 0600, parent, (u16 *)0xFFC03830);
		debugfs_create_x16("USB_GLOBINTR", 0600, parent, (u16 *)0xFFC0382C);
		debugfs_create_x16("USB_HS_EOF1", 0600, parent, (u16 *)0xFFC03950);
		debugfs_create_x16("USB_INDEX", 0600, parent, (u16 *)0xFFC03824);
		debugfs_create_x16("USB_INTRRX", 0600, parent, (u16 *)0xFFC0380C);
		debugfs_create_x16("USB_INTRRXE", 0600, parent, (u16 *)0xFFC03814);
		debugfs_create_x16("USB_INTRTX", 0600, parent, (u16 *)0xFFC03808);
		debugfs_create_x16("USB_INTRTXE", 0600, parent, (u16 *)0xFFC03810);
		debugfs_create_x16("USB_INTRUSB", 0600, parent, (u16 *)0xFFC03818);
		debugfs_create_x16("USB_INTRUSBE", 0600, parent, (u16 *)0xFFC0381C);
		debugfs_create_x16("USB_LINKINFO", 0600, parent, (u16 *)0xFFC03948);
		debugfs_create_x16("USB_LS_EOF1", 0600, parent, (u16 *)0xFFC03958);
		debugfs_create_x16("USB_NAKLIMIT0", 0600, parent, (u16 *)0xFFC03858);
		debugfs_create_x16("USB_OTG_DEV_CTL", 0600, parent, (u16 *)0xFFC03900);
		debugfs_create_x16("USB_OTG_VBUS_IRQ", 0600, parent, (u16 *)0xFFC03904);
		debugfs_create_x16("USB_OTG_VBUS_MASK", 0600, parent, (u16 *)0xFFC03908);
		debugfs_create_x16("USB_PHY_TEST", 0600, parent, (u16 *)0xFFC039EC);
		debugfs_create_x16("USB_PLLOSC_CTRL", 0600, parent, (u16 *)0xFFC039F0);
		debugfs_create_x16("USB_POWER", 0600, parent, (u16 *)0xFFC03804);
		debugfs_create_x16("USB_RXCOUNT", 0600, parent, (u16 *)0xFFC03850);
		debugfs_create_x16("USB_RXCSR", 0600, parent, (u16 *)0xFFC0384C);
		debugfs_create_x16("USB_RXINTERVAL", 0600, parent, (u16 *)0xFFC03860);
		debugfs_create_x16("USB_RXTYPE", 0600, parent, (u16 *)0xFFC0385C);
		debugfs_create_x16("USB_RX_MAX_PACKET", 0600, parent, (u16 *)0xFFC03848);
		debugfs_create_x16("USB_SRP_CLKDIV", 0600, parent, (u16 *)0xFFC039F4);
		debugfs_create_x16("USB_TESTMODE", 0600, parent, (u16 *)0xFFC03828);
		debugfs_create_x16("USB_TXCOUNT", 0600, parent, (u16 *)0xFFC03868);
		debugfs_create_x16("USB_TXCSR", 0600, parent, (u16 *)0xFFC03844);
		debugfs_create_x16("USB_TXINTERVAL", 0600, parent, (u16 *)0xFFC03858);
		debugfs_create_x16("USB_TXTYPE", 0600, parent, (u16 *)0xFFC03854);
		debugfs_create_x16("USB_TX_MAX_PACKET", 0600, parent, (u16 *)0xFFC03840);
		debugfs_create_x16("USB_VPLEN", 0600, parent, (u16 *)0xFFC0394C);

		parent = debugfs_create_dir("Watchdog", top);
		debugfs_create_x32("WDOG_CNT", 0600, parent, (u32 *)0xFFC00204);
		debugfs_create_x16("WDOG_CTL", 0600, parent, (u16 *)0xFFC00200);
		debugfs_create_x32("WDOG_STAT", 0600, parent, (u32 *)0xFFC00208);

		parent = debugfs_create_dir("Watchpoint and Patch Unit", top);
		debugfs_create_x32("WPDA0", 0600, parent, (u32 *)0xFFE07140);
		debugfs_create_x32("WPDA1", 0600, parent, (u32 *)0xFFE07144);
		debugfs_create_x32("WPDACNT0", 0600, parent, (u32 *)0xFFE07180);
		debugfs_create_x32("WPDACNT1", 0600, parent, (u32 *)0xFFE07184);
		debugfs_create_x32("WPDACTL", 0600, parent, (u32 *)0xFFE07100);
		debugfs_create_x32("WPIA0", 0600, parent, (u32 *)0xFFE07040);
		debugfs_create_x32("WPIA1", 0600, parent, (u32 *)0xFFE07044);
		debugfs_create_x32("WPIA2", 0600, parent, (u32 *)0xFFE07048);
		debugfs_create_x32("WPIA3", 0600, parent, (u32 *)0xFFE0704C);
		debugfs_create_x32("WPIA4", 0600, parent, (u32 *)0xFFE07050);
		debugfs_create_x32("WPIA5", 0600, parent, (u32 *)0xFFE07054);
		debugfs_create_x32("WPIACNT0", 0600, parent, (u32 *)0xFFE07080);
		debugfs_create_x32("WPIACNT1", 0600, parent, (u32 *)0xFFE07084);
		debugfs_create_x32("WPIACNT2", 0600, parent, (u32 *)0xFFE07088);
		debugfs_create_x32("WPIACNT3", 0600, parent, (u32 *)0xFFE0708C);
		debugfs_create_x32("WPIACNT4", 0600, parent, (u32 *)0xFFE07090);
		debugfs_create_x32("WPIACNT5", 0600, parent, (u32 *)0xFFE07094);
		debugfs_create_x32("WPIACTL", 0600, parent, (u32 *)0xFFE07000);
		debugfs_create_x32("WPSTAT", 0600, parent, (u32 *)0xFFE07200);

	}	/* BF526 */

#ifdef __ADSPBF527__
# define USE_BF527 1
#else
# define USE_BF527 0
#endif
	if (USE_BF527) {

		parent = debugfs_create_dir("Core Timer Register File", top);
		debugfs_create_x32("TCNTL", 0600, parent, (u32 *)0xFFE03000);
		debugfs_create_x32("TCOUNT", 0600, parent, (u32 *)0xFFE0300C);
		debugfs_create_x32("TPERIOD", 0600, parent, (u32 *)0xFFE03004);
		debugfs_create_x32("TSCALE", 0600, parent, (u32 *)0xFFE03008);

		parent = debugfs_create_dir("Counter", top);
		debugfs_create_x16("CNT_COMMAND", 0600, parent, (u16 *)0xFFC0350C);
		debugfs_create_x16("CNT_CONFIG", 0600, parent, (u16 *)0xFFC03500);
		debugfs_create_x32("CNT_COUNTER", 0600, parent, (u32 *)0xFFC03514);
		debugfs_create_x16("CNT_DEBOUNCE", 0600, parent, (u16 *)0xFFC03510);
		debugfs_create_x16("CNT_IMASK", 0600, parent, (u16 *)0xFFC03504);
		debugfs_create_x32("CNT_MAX", 0600, parent, (u32 *)0xFFC03518);
		debugfs_create_x32("CNT_MIN", 0600, parent, (u32 *)0xFFC0351C);
		debugfs_create_x16("CNT_STATUS", 0600, parent, (u16 *)0xFFC03508);

		parent = debugfs_create_dir("DMA Controller", top);
		debugfs_create_x16("DMA0_CONFIG", 0600, parent, (u16 *)0xFFC00C08);
		debugfs_create_x32("DMA0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C24);
		debugfs_create_x32("DMA0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C20);
		debugfs_create_x16("DMA0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C30);
		debugfs_create_x16("DMA0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C38);
		debugfs_create_x16("DMA0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C28);
		debugfs_create_x32("DMA0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C00);
		debugfs_create_x16("DMA0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C2C);
		debugfs_create_x32("DMA0_START_ADDR", 0600, parent, (u32 *)0xFFC00C04);
		debugfs_create_x16("DMA0_X_COUNT", 0600, parent, (u16 *)0xFFC00C10);
		debugfs_create_x16("DMA0_X_MODIFY", 0600, parent, (u16 *)0xFFC00C14);
		debugfs_create_x16("DMA0_Y_COUNT", 0600, parent, (u16 *)0xFFC00C18);
		debugfs_create_x16("DMA0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C1C);
		debugfs_create_x16("DMA10_CONFIG", 0600, parent, (u16 *)0xFFC00E88);
		debugfs_create_x32("DMA10_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EA4);
		debugfs_create_x32("DMA10_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EA0);
		debugfs_create_x16("DMA10_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EB0);
		debugfs_create_x16("DMA10_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EB8);
		debugfs_create_x16("DMA10_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EA8);
		debugfs_create_x32("DMA10_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E80);
		debugfs_create_x16("DMA10_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EAC);
		debugfs_create_x32("DMA10_START_ADDR", 0600, parent, (u32 *)0xFFC00E84);
		debugfs_create_x16("DMA10_X_COUNT", 0600, parent, (u16 *)0xFFC00E90);
		debugfs_create_x16("DMA10_X_MODIFY", 0600, parent, (u16 *)0xFFC00E94);
		debugfs_create_x16("DMA10_Y_COUNT", 0600, parent, (u16 *)0xFFC00E98);
		debugfs_create_x16("DMA10_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E9C);
		debugfs_create_x16("DMA11_CONFIG", 0600, parent, (u16 *)0xFFC00EC8);
		debugfs_create_x32("DMA11_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EE4);
		debugfs_create_x32("DMA11_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EE0);
		debugfs_create_x16("DMA11_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EF0);
		debugfs_create_x16("DMA11_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EF8);
		debugfs_create_x16("DMA11_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EE8);
		debugfs_create_x32("DMA11_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00EC0);
		debugfs_create_x16("DMA11_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EEC);
		debugfs_create_x32("DMA11_START_ADDR", 0600, parent, (u32 *)0xFFC00EC4);
		debugfs_create_x16("DMA11_X_COUNT", 0600, parent, (u16 *)0xFFC00ED0);
		debugfs_create_x16("DMA11_X_MODIFY", 0600, parent, (u16 *)0xFFC00ED4);
		debugfs_create_x16("DMA11_Y_COUNT", 0600, parent, (u16 *)0xFFC00ED8);
		debugfs_create_x16("DMA11_Y_MODIFY", 0600, parent, (u16 *)0xFFC00EDC);
		debugfs_create_x16("DMA1_CONFIG", 0600, parent, (u16 *)0xFFC00C48);
		debugfs_create_x32("DMA1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C64);
		debugfs_create_x32("DMA1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C60);
		debugfs_create_x16("DMA1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C70);
		debugfs_create_x16("DMA1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C78);
		debugfs_create_x16("DMA1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C68);
		debugfs_create_x32("DMA1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C40);
		debugfs_create_x16("DMA1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C6C);
		debugfs_create_x32("DMA1_START_ADDR", 0600, parent, (u32 *)0xFFC00C44);
		debugfs_create_x16("DMA1_X_COUNT", 0600, parent, (u16 *)0xFFC00C50);
		debugfs_create_x16("DMA1_X_MODIFY", 0600, parent, (u16 *)0xFFC00C54);
		debugfs_create_x16("DMA1_Y_COUNT", 0600, parent, (u16 *)0xFFC00C58);
		debugfs_create_x16("DMA1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C5C);
		debugfs_create_x16("DMA2_CONFIG", 0600, parent, (u16 *)0xFFC00C88);
		debugfs_create_x32("DMA2_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CA4);
		debugfs_create_x32("DMA2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CA0);
		debugfs_create_x16("DMA2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CB0);
		debugfs_create_x16("DMA2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CB8);
		debugfs_create_x16("DMA2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CA8);
		debugfs_create_x32("DMA2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C80);
		debugfs_create_x16("DMA2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CAC);
		debugfs_create_x32("DMA2_START_ADDR", 0600, parent, (u32 *)0xFFC00C84);
		debugfs_create_x16("DMA2_X_COUNT", 0600, parent, (u16 *)0xFFC00C90);
		debugfs_create_x16("DMA2_X_MODIFY", 0600, parent, (u16 *)0xFFC00C94);
		debugfs_create_x16("DMA2_Y_COUNT", 0600, parent, (u16 *)0xFFC00C98);
		debugfs_create_x16("DMA2_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C9C);
		debugfs_create_x16("DMA3_CONFIG", 0600, parent, (u16 *)0xFFC00CC8);
		debugfs_create_x32("DMA3_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CE4);
		debugfs_create_x32("DMA3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CE0);
		debugfs_create_x16("DMA3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CF0);
		debugfs_create_x16("DMA3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CF8);
		debugfs_create_x16("DMA3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CE8);
		debugfs_create_x32("DMA3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00CC0);
		debugfs_create_x16("DMA3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CEC);
		debugfs_create_x32("DMA3_START_ADDR", 0600, parent, (u32 *)0xFFC00CC4);
		debugfs_create_x16("DMA3_X_COUNT", 0600, parent, (u16 *)0xFFC00CD0);
		debugfs_create_x16("DMA3_X_MODIFY", 0600, parent, (u16 *)0xFFC00CD4);
		debugfs_create_x16("DMA3_Y_COUNT", 0600, parent, (u16 *)0xFFC00CD8);
		debugfs_create_x16("DMA3_Y_MODIFY", 0600, parent, (u16 *)0xFFC00CDC);
		debugfs_create_x16("DMA4_CONFIG", 0600, parent, (u16 *)0xFFC00D08);
		debugfs_create_x32("DMA4_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D24);
		debugfs_create_x32("DMA4_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D20);
		debugfs_create_x16("DMA4_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D30);
		debugfs_create_x16("DMA4_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D38);
		debugfs_create_x16("DMA4_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D28);
		debugfs_create_x32("DMA4_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D00);
		debugfs_create_x16("DMA4_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D2C);
		debugfs_create_x32("DMA4_START_ADDR", 0600, parent, (u32 *)0xFFC00D04);
		debugfs_create_x16("DMA4_X_COUNT", 0600, parent, (u16 *)0xFFC00D10);
		debugfs_create_x16("DMA4_X_MODIFY", 0600, parent, (u16 *)0xFFC00D14);
		debugfs_create_x16("DMA4_Y_COUNT", 0600, parent, (u16 *)0xFFC00D18);
		debugfs_create_x16("DMA4_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D1C);
		debugfs_create_x16("DMA5_CONFIG", 0600, parent, (u16 *)0xFFC00D48);
		debugfs_create_x32("DMA5_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D64);
		debugfs_create_x32("DMA5_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D60);
		debugfs_create_x16("DMA5_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D70);
		debugfs_create_x16("DMA5_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D78);
		debugfs_create_x16("DMA5_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D68);
		debugfs_create_x32("DMA5_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D40);
		debugfs_create_x16("DMA5_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D6C);
		debugfs_create_x32("DMA5_START_ADDR", 0600, parent, (u32 *)0xFFC00D44);
		debugfs_create_x16("DMA5_X_COUNT", 0600, parent, (u16 *)0xFFC00D50);
		debugfs_create_x16("DMA5_X_MODIFY", 0600, parent, (u16 *)0xFFC00D54);
		debugfs_create_x16("DMA5_Y_COUNT", 0600, parent, (u16 *)0xFFC00D58);
		debugfs_create_x16("DMA5_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D5C);
		debugfs_create_x16("DMA6_CONFIG", 0600, parent, (u16 *)0xFFC00D88);
		debugfs_create_x32("DMA6_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DA4);
		debugfs_create_x32("DMA6_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DA0);
		debugfs_create_x16("DMA6_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DB0);
		debugfs_create_x16("DMA6_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DB8);
		debugfs_create_x16("DMA6_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DA8);
		debugfs_create_x32("DMA6_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D80);
		debugfs_create_x16("DMA6_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DAC);
		debugfs_create_x32("DMA6_START_ADDR", 0600, parent, (u32 *)0xFFC00D84);
		debugfs_create_x16("DMA6_X_COUNT", 0600, parent, (u16 *)0xFFC00D90);
		debugfs_create_x16("DMA6_X_MODIFY", 0600, parent, (u16 *)0xFFC00D94);
		debugfs_create_x16("DMA6_Y_COUNT", 0600, parent, (u16 *)0xFFC00D98);
		debugfs_create_x16("DMA6_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D9C);
		debugfs_create_x16("DMA7_CONFIG", 0600, parent, (u16 *)0xFFC00DC8);
		debugfs_create_x32("DMA7_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DE4);
		debugfs_create_x32("DMA7_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DE0);
		debugfs_create_x16("DMA7_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DF0);
		debugfs_create_x16("DMA7_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DF8);
		debugfs_create_x16("DMA7_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DE8);
		debugfs_create_x32("DMA7_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00DC0);
		debugfs_create_x16("DMA7_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DEC);
		debugfs_create_x32("DMA7_START_ADDR", 0600, parent, (u32 *)0xFFC00DC4);
		debugfs_create_x16("DMA7_X_COUNT", 0600, parent, (u16 *)0xFFC00DD0);
		debugfs_create_x16("DMA7_X_MODIFY", 0600, parent, (u16 *)0xFFC00DD4);
		debugfs_create_x16("DMA7_Y_COUNT", 0600, parent, (u16 *)0xFFC00DD8);
		debugfs_create_x16("DMA7_Y_MODIFY", 0600, parent, (u16 *)0xFFC00DDC);
		debugfs_create_x16("DMA8_CONFIG", 0600, parent, (u16 *)0xFFC00E08);
		debugfs_create_x32("DMA8_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E24);
		debugfs_create_x32("DMA8_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E20);
		debugfs_create_x16("DMA8_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E30);
		debugfs_create_x16("DMA8_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E38);
		debugfs_create_x16("DMA8_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E28);
		debugfs_create_x32("DMA8_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E00);
		debugfs_create_x16("DMA8_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E2C);
		debugfs_create_x32("DMA8_START_ADDR", 0600, parent, (u32 *)0xFFC00E04);
		debugfs_create_x16("DMA8_X_COUNT", 0600, parent, (u16 *)0xFFC00E10);
		debugfs_create_x16("DMA8_X_MODIFY", 0600, parent, (u16 *)0xFFC00E14);
		debugfs_create_x16("DMA8_Y_COUNT", 0600, parent, (u16 *)0xFFC00E18);
		debugfs_create_x16("DMA8_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E1C);
		debugfs_create_x16("DMA9_CONFIG", 0600, parent, (u16 *)0xFFC00E48);
		debugfs_create_x32("DMA9_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E64);
		debugfs_create_x32("DMA9_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E60);
		debugfs_create_x16("DMA9_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E70);
		debugfs_create_x16("DMA9_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E78);
		debugfs_create_x16("DMA9_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E68);
		debugfs_create_x32("DMA9_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E40);
		debugfs_create_x16("DMA9_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E6C);
		debugfs_create_x32("DMA9_START_ADDR", 0600, parent, (u32 *)0xFFC00E44);
		debugfs_create_x16("DMA9_X_COUNT", 0600, parent, (u16 *)0xFFC00E50);
		debugfs_create_x16("DMA9_X_MODIFY", 0600, parent, (u16 *)0xFFC00E54);
		debugfs_create_x16("DMA9_Y_COUNT", 0600, parent, (u16 *)0xFFC00E58);
		debugfs_create_x16("DMA9_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E5C);

		parent = debugfs_create_dir("DMA Traffic Control", top);
		debugfs_create_x16("DMA_TC_CNT", 0600, parent, (u16 *)0xFFC00B0C);
		debugfs_create_x16("DMA_TC_PER", 0600, parent, (u16 *)0xFFC00B10);

		parent = debugfs_create_dir("EBIU", top);
		debugfs_create_x32("EBIU_AMBCTL0", 0600, parent, (u32 *)0xFFC00A04);
		debugfs_create_x32("EBIU_AMBCTL1", 0600, parent, (u32 *)0xFFC00A08);
		debugfs_create_x16("EBIU_AMGCTL", 0600, parent, (u16 *)0xFFC00A00);
		debugfs_create_x16("EBIU_SDBCTL", 0600, parent, (u16 *)0xFFC00A14);
		debugfs_create_x32("EBIU_SDGCTL", 0600, parent, (u32 *)0xFFC00A10);
		debugfs_create_x16("EBIU_SDRRC", 0600, parent, (u16 *)0xFFC00A18);
		debugfs_create_x16("EBIU_SDSTAT", 0600, parent, (u16 *)0xFFC00A1C);

		parent = debugfs_create_dir("Ethernet Controller", top);
		debugfs_create_x32("EMAC_ADDRHI", 0600, parent, (u32 *)0xFFC03008);
		debugfs_create_x32("EMAC_ADDRLO", 0600, parent, (u32 *)0xFFC03004);
		debugfs_create_x32("EMAC_FLC", 0600, parent, (u32 *)0xFFC0301C);
		debugfs_create_x32("EMAC_HASHHI", 0600, parent, (u32 *)0xFFC03010);
		debugfs_create_x32("EMAC_HASHLO", 0600, parent, (u32 *)0xFFC0300C);
		debugfs_create_x32("EMAC_MMC_CTL", 0600, parent, (u32 *)0xFFC03080);
		debugfs_create_x32("EMAC_MMC_RIRQE", 0600, parent, (u32 *)0xFFC03088);
		debugfs_create_x32("EMAC_MMC_RIRQS", 0600, parent, (u32 *)0xFFC03084);
		debugfs_create_x32("EMAC_MMC_TIRQE", 0600, parent, (u32 *)0xFFC03090);
		debugfs_create_x32("EMAC_MMC_TIRQS", 0600, parent, (u32 *)0xFFC0308C);
		debugfs_create_x32("EMAC_OPMODE", 0600, parent, (u32 *)0xFFC03000);
		debugfs_create_x32("EMAC_RXC_ALIGN", 0600, parent, (u32 *)0xFFC03108);
		debugfs_create_x32("EMAC_RXC_ALLFRM", 0600, parent, (u32 *)0xFFC03138);
		debugfs_create_x32("EMAC_RXC_ALLOCT", 0600, parent, (u32 *)0xFFC0313C);
		debugfs_create_x32("EMAC_RXC_BROAD", 0600, parent, (u32 *)0xFFC0311C);
		debugfs_create_x32("EMAC_RXC_DMAOVF", 0600, parent, (u32 *)0xFFC03110);
		debugfs_create_x32("EMAC_RXC_EQ64", 0600, parent, (u32 *)0xFFC03148);
		debugfs_create_x32("EMAC_RXC_FCS", 0600, parent, (u32 *)0xFFC03104);
		debugfs_create_x32("EMAC_RXC_GE1024", 0600, parent, (u32 *)0xFFC0315C);
		debugfs_create_x32("EMAC_RXC_LNERRI", 0600, parent, (u32 *)0xFFC03120);
		debugfs_create_x32("EMAC_RXC_LNERRO", 0600, parent, (u32 *)0xFFC03124);
		debugfs_create_x32("EMAC_RXC_LONG", 0600, parent, (u32 *)0xFFC03128);
		debugfs_create_x32("EMAC_RXC_LT1024", 0600, parent, (u32 *)0xFFC03158);
		debugfs_create_x32("EMAC_RXC_LT128", 0600, parent, (u32 *)0xFFC0314C);
		debugfs_create_x32("EMAC_RXC_LT256", 0600, parent, (u32 *)0xFFC03150);
		debugfs_create_x32("EMAC_RXC_LT512", 0600, parent, (u32 *)0xFFC03154);
		debugfs_create_x32("EMAC_RXC_MACCTL", 0600, parent, (u32 *)0xFFC0312C);
		debugfs_create_x32("EMAC_RXC_MULTI", 0600, parent, (u32 *)0xFFC03118);
		debugfs_create_x32("EMAC_RXC_OCTET", 0600, parent, (u32 *)0xFFC0310C);
		debugfs_create_x32("EMAC_RXC_OK", 0600, parent, (u32 *)0xFFC03100);
		debugfs_create_x32("EMAC_RXC_OPCODE", 0600, parent, (u32 *)0xFFC03130);
		debugfs_create_x32("EMAC_RXC_PAUSE", 0600, parent, (u32 *)0xFFC03134);
		debugfs_create_x32("EMAC_RXC_SHORT", 0600, parent, (u32 *)0xFFC03144);
		debugfs_create_x32("EMAC_RXC_TYPED", 0600, parent, (u32 *)0xFFC03140);
		debugfs_create_x32("EMAC_RXC_UNICST", 0600, parent, (u32 *)0xFFC03114);
		debugfs_create_x32("EMAC_RX_IRQE", 0600, parent, (u32 *)0xFFC03070);
		debugfs_create_x32("EMAC_RX_STAT", 0600, parent, (u32 *)0xFFC03068);
		debugfs_create_x32("EMAC_RX_STKY", 0600, parent, (u32 *)0xFFC0306C);
		debugfs_create_x32("EMAC_STAADD", 0600, parent, (u32 *)0xFFC03014);
		debugfs_create_x32("EMAC_STADAT", 0600, parent, (u32 *)0xFFC03018);
		debugfs_create_x32("EMAC_SYSCTL", 0600, parent, (u32 *)0xFFC03060);
		debugfs_create_x32("EMAC_SYSTAT", 0600, parent, (u32 *)0xFFC03064);
		debugfs_create_x32("EMAC_TXC_1COL", 0600, parent, (u32 *)0xFFC03184);
		debugfs_create_x32("EMAC_TXC_ABORT", 0600, parent, (u32 *)0xFFC031D8);
		debugfs_create_x32("EMAC_TXC_ALLFRM", 0600, parent, (u32 *)0xFFC031B8);
		debugfs_create_x32("EMAC_TXC_ALLOCT", 0600, parent, (u32 *)0xFFC031BC);
		debugfs_create_x32("EMAC_TXC_BROAD", 0600, parent, (u32 *)0xFFC031AC);
		debugfs_create_x32("EMAC_TXC_CRSERR", 0600, parent, (u32 *)0xFFC031A0);
		debugfs_create_x32("EMAC_TXC_DEFER", 0600, parent, (u32 *)0xFFC03190);
		debugfs_create_x32("EMAC_TXC_DMAUND", 0600, parent, (u32 *)0xFFC0319C);
		debugfs_create_x32("EMAC_TXC_EQ64", 0600, parent, (u32 *)0xFFC031C0);
		debugfs_create_x32("EMAC_TXC_GE1024", 0600, parent, (u32 *)0xFFC031D4);
		debugfs_create_x32("EMAC_TXC_GT1COL", 0600, parent, (u32 *)0xFFC03188);
		debugfs_create_x32("EMAC_TXC_LATECL", 0600, parent, (u32 *)0xFFC03194);
		debugfs_create_x32("EMAC_TXC_LT1024", 0600, parent, (u32 *)0xFFC031D0);
		debugfs_create_x32("EMAC_TXC_LT128", 0600, parent, (u32 *)0xFFC031C4);
		debugfs_create_x32("EMAC_TXC_LT256", 0600, parent, (u32 *)0xFFC031C8);
		debugfs_create_x32("EMAC_TXC_LT512", 0600, parent, (u32 *)0xFFC031CC);
		debugfs_create_x32("EMAC_TXC_MACCTL", 0600, parent, (u32 *)0xFFC031B4);
		debugfs_create_x32("EMAC_TXC_MULTI", 0600, parent, (u32 *)0xFFC031A8);
		debugfs_create_x32("EMAC_TXC_OCTET", 0600, parent, (u32 *)0xFFC0318C);
		debugfs_create_x32("EMAC_TXC_OK", 0600, parent, (u32 *)0xFFC03180);
		debugfs_create_x32("EMAC_TXC_UNICST", 0600, parent, (u32 *)0xFFC031A4);
		debugfs_create_x32("EMAC_TXC_XS_COL", 0600, parent, (u32 *)0xFFC03198);
		debugfs_create_x32("EMAC_TXC_XS_DFR", 0600, parent, (u32 *)0xFFC031B0);
		debugfs_create_x32("EMAC_TX_IRQE", 0600, parent, (u32 *)0xFFC0307C);
		debugfs_create_x32("EMAC_TX_STAT", 0600, parent, (u32 *)0xFFC03074);
		debugfs_create_x32("EMAC_TX_STKY", 0600, parent, (u32 *)0xFFC03078);
		debugfs_create_x32("EMAC_VLAN1", 0600, parent, (u32 *)0xFFC03020);
		debugfs_create_x32("EMAC_VLAN2", 0600, parent, (u32 *)0xFFC03024);
		debugfs_create_x32("EMAC_WKUP_CTL", 0600, parent, (u32 *)0xFFC0302C);
		debugfs_create_x32("EMAC_WKUP_FFCMD", 0600, parent, (u32 *)0xFFC03040);
		debugfs_create_x32("EMAC_WKUP_FFCRC0", 0600, parent, (u32 *)0xFFC03048);
		debugfs_create_x32("EMAC_WKUP_FFCRC1", 0600, parent, (u32 *)0xFFC0304C);
		debugfs_create_x32("EMAC_WKUP_FFMSK0", 0600, parent, (u32 *)0xFFC03030);
		debugfs_create_x32("EMAC_WKUP_FFMSK1", 0600, parent, (u32 *)0xFFC03034);
		debugfs_create_x32("EMAC_WKUP_FFMSK2", 0600, parent, (u32 *)0xFFC03038);
		debugfs_create_x32("EMAC_WKUP_FFMSK3", 0600, parent, (u32 *)0xFFC0303C);
		debugfs_create_x32("EMAC_WKUP_FFOFF", 0600, parent, (u32 *)0xFFC03044);

		parent = debugfs_create_dir("Event Vectors", top);
		debugfs_create_x32("EVT0", 0600, parent, (u32 *)0xFFE02000);
		debugfs_create_x32("EVT10", 0600, parent, (u32 *)0xFFE02028);
		debugfs_create_x32("EVT11", 0600, parent, (u32 *)0xFFE0202C);
		debugfs_create_x32("EVT12", 0600, parent, (u32 *)0xFFE02030);
		debugfs_create_x32("EVT13", 0600, parent, (u32 *)0xFFE02034);
		debugfs_create_x32("EVT14", 0600, parent, (u32 *)0xFFE02038);
		debugfs_create_x32("EVT15", 0600, parent, (u32 *)0xFFE0203C);
		debugfs_create_x32("EVT1", 0600, parent, (u32 *)0xFFE02004);
		debugfs_create_x32("EVT2", 0600, parent, (u32 *)0xFFE02008);
		debugfs_create_x32("EVT3", 0600, parent, (u32 *)0xFFE0200C);
		debugfs_create_x32("EVT4", 0600, parent, (u32 *)0xFFE02010);
		debugfs_create_x32("EVT5", 0600, parent, (u32 *)0xFFE02014);
		debugfs_create_x32("EVT6", 0600, parent, (u32 *)0xFFE02018);
		debugfs_create_x32("EVT7", 0600, parent, (u32 *)0xFFE0201C);
		debugfs_create_x32("EVT8", 0600, parent, (u32 *)0xFFE02020);
		debugfs_create_x32("EVT9", 0600, parent, (u32 *)0xFFE02024);

		parent = debugfs_create_dir("Extended Registers", top);
		debugfs_create_x32("CHIPID", 0600, parent, (u32 *)0xFFC00014);
		debugfs_create_x32("DSPID", 0600, parent, (u32 *)0xFFE05000);

		parent = debugfs_create_dir("GPIO PIN", top);
		debugfs_create_x16("PORTF_DRIVE", 0600, parent, (u16 *)0xFFC03220);
		debugfs_create_x16("PORTF_HYSTERESIS", 0600, parent, (u16 *)0xFFC03240);
		debugfs_create_x16("PORTF_MUX", 0600, parent, (u16 *)0xFFC03210);
		debugfs_create_x16("PORTF_SLEW", 0600, parent, (u16 *)0xFFC03230);
		debugfs_create_x16("PORTG_DRIVE", 0600, parent, (u16 *)0xFFC03224);
		debugfs_create_x16("PORTG_HYSTERESIS", 0600, parent, (u16 *)0xFFC03244);
		debugfs_create_x16("PORTG_MUX", 0600, parent, (u16 *)0xFFC03214);
		debugfs_create_x16("PORTG_SLEW", 0600, parent, (u16 *)0xFFC03234);
		debugfs_create_x16("PORTH_DRIVE", 0600, parent, (u16 *)0xFFC03228);
		debugfs_create_x16("PORTH_HYSTERESIS", 0600, parent, (u16 *)0xFFC03248);
		debugfs_create_x16("PORTH_MUX", 0600, parent, (u16 *)0xFFC03218);
		debugfs_create_x16("PORTH_SLEW", 0600, parent, (u16 *)0xFFC03238);

		parent = debugfs_create_dir("HOST", top);
		debugfs_create_x16("HOST_CONTROL", 0600, parent, (u16 *)0xFFC03400);
		debugfs_create_x16("HOST_STATUS", 0600, parent, (u16 *)0xFFC03404);
		debugfs_create_x16("HOST_TIMEOUT", 0600, parent, (u16 *)0xFFC03408);

		parent = debugfs_create_dir("Handshake MDMA", top);
		debugfs_create_x16("HMDMA0_BCINIT", 0600, parent, (u16 *)0xFFC03308);
		debugfs_create_x16("HMDMA0_BCOUNT", 0600, parent, (u16 *)0xFFC03318);
		debugfs_create_x16("HMDMA0_CONTROL", 0600, parent, (u16 *)0xFFC03300);
		debugfs_create_x16("HMDMA0_ECINIT", 0600, parent, (u16 *)0xFFC03304);
		debugfs_create_x16("HMDMA0_ECOUNT", 0600, parent, (u16 *)0xFFC03314);
		debugfs_create_x16("HMDMA0_ECOVERFLOW", 0600, parent, (u16 *)0xFFC03310);
		debugfs_create_x16("HMDMA0_ECURGENT", 0600, parent, (u16 *)0xFFC0330C);
		debugfs_create_x16("HMDMA1_BCINIT", 0600, parent, (u16 *)0xFFC03348);
		debugfs_create_x16("HMDMA1_BCOUNT", 0600, parent, (u16 *)0xFFC03358);
		debugfs_create_x16("HMDMA1_CONTROL", 0600, parent, (u16 *)0xFFC03340);
		debugfs_create_x16("HMDMA1_ECINIT", 0600, parent, (u16 *)0xFFC03344);
		debugfs_create_x16("HMDMA1_ECOUNT", 0600, parent, (u16 *)0xFFC03354);
		debugfs_create_x16("HMDMA1_ECOVERFLOW", 0600, parent, (u16 *)0xFFC03350);
		debugfs_create_x16("HMDMA1_ECURGENT", 0600, parent, (u16 *)0xFFC0334C);

		parent = debugfs_create_dir("Interrupt Controller", top);
		debugfs_create_x32("ILAT", 0600, parent, (u32 *)0xFFE0210C);
		debugfs_create_x32("IMASK", 0600, parent, (u32 *)0xFFE02104);
		debugfs_create_x32("IPEND", 0600, parent, (u32 *)0xFFE02108);
		debugfs_create_x32("IPRIO", 0600, parent, (u32 *)0xFFE02110);

		parent = debugfs_create_dir("L1 Code Memory Registers", top);
		debugfs_create_x32("ICPLB_ADDR0", 0600, parent, (u32 *)0xFFE01100);
		debugfs_create_x32("ICPLB_ADDR10", 0600, parent, (u32 *)0xFFE01128);
		debugfs_create_x32("ICPLB_ADDR11", 0600, parent, (u32 *)0xFFE0112C);
		debugfs_create_x32("ICPLB_ADDR12", 0600, parent, (u32 *)0xFFE01130);
		debugfs_create_x32("ICPLB_ADDR13", 0600, parent, (u32 *)0xFFE01134);
		debugfs_create_x32("ICPLB_ADDR14", 0600, parent, (u32 *)0xFFE01138);
		debugfs_create_x32("ICPLB_ADDR15", 0600, parent, (u32 *)0xFFE0113C);
		debugfs_create_x32("ICPLB_ADDR1", 0600, parent, (u32 *)0xFFE01104);
		debugfs_create_x32("ICPLB_ADDR2", 0600, parent, (u32 *)0xFFE01108);
		debugfs_create_x32("ICPLB_ADDR3", 0600, parent, (u32 *)0xFFE0110C);
		debugfs_create_x32("ICPLB_ADDR4", 0600, parent, (u32 *)0xFFE01110);
		debugfs_create_x32("ICPLB_ADDR5", 0600, parent, (u32 *)0xFFE01114);
		debugfs_create_x32("ICPLB_ADDR6", 0600, parent, (u32 *)0xFFE01118);
		debugfs_create_x32("ICPLB_ADDR7", 0600, parent, (u32 *)0xFFE0111C);
		debugfs_create_x32("ICPLB_ADDR8", 0600, parent, (u32 *)0xFFE01120);
		debugfs_create_x32("ICPLB_ADDR9", 0600, parent, (u32 *)0xFFE01124);
		debugfs_create_x32("ICPLB_DATA0", 0600, parent, (u32 *)0xFFE01200);
		debugfs_create_x32("ICPLB_DATA10", 0600, parent, (u32 *)0xFFE01228);
		debugfs_create_x32("ICPLB_DATA11", 0600, parent, (u32 *)0xFFE0122C);
		debugfs_create_x32("ICPLB_DATA12", 0600, parent, (u32 *)0xFFE01230);
		debugfs_create_x32("ICPLB_DATA13", 0600, parent, (u32 *)0xFFE01234);
		debugfs_create_x32("ICPLB_DATA14", 0600, parent, (u32 *)0xFFE01238);
		debugfs_create_x32("ICPLB_DATA15", 0600, parent, (u32 *)0xFFE0123C);
		debugfs_create_x32("ICPLB_DATA1", 0600, parent, (u32 *)0xFFE01204);
		debugfs_create_x32("ICPLB_DATA2", 0600, parent, (u32 *)0xFFE01208);
		debugfs_create_x32("ICPLB_DATA3", 0600, parent, (u32 *)0xFFE0120C);
		debugfs_create_x32("ICPLB_DATA4", 0600, parent, (u32 *)0xFFE01210);
		debugfs_create_x32("ICPLB_DATA5", 0600, parent, (u32 *)0xFFE01214);
		debugfs_create_x32("ICPLB_DATA6", 0600, parent, (u32 *)0xFFE01218);
		debugfs_create_x32("ICPLB_DATA7", 0600, parent, (u32 *)0xFFE0121C);
		debugfs_create_x32("ICPLB_DATA8", 0600, parent, (u32 *)0xFFE01220);
		debugfs_create_x32("ICPLB_DATA9", 0600, parent, (u32 *)0xFFE01224);
		debugfs_create_x32("ICPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0100C);
		debugfs_create_x32("ICPLB_STATUS", 0600, parent, (u32 *)0xFFE01008);
		debugfs_create_x32("IMEM_CONTROL", 0600, parent, (u32 *)0xFFE01004);
		debugfs_create_x32("ITEST_COMMAND", 0600, parent, (u32 *)0xFFE01300);
		debugfs_create_x32("ITEST_DATA0", 0600, parent, (u32 *)0xFFE01400);
		debugfs_create_x32("ITEST_DATA1", 0600, parent, (u32 *)0xFFE01404);

		parent = debugfs_create_dir("L1 Data Memory Registers", top);
		debugfs_create_x32("DCPLB_ADDR0", 0600, parent, (u32 *)0xFFE00100);
		debugfs_create_x32("DCPLB_ADDR10", 0600, parent, (u32 *)0xFFE00128);
		debugfs_create_x32("DCPLB_ADDR11", 0600, parent, (u32 *)0xFFE0012C);
		debugfs_create_x32("DCPLB_ADDR12", 0600, parent, (u32 *)0xFFE00130);
		debugfs_create_x32("DCPLB_ADDR13", 0600, parent, (u32 *)0xFFE00134);
		debugfs_create_x32("DCPLB_ADDR14", 0600, parent, (u32 *)0xFFE00138);
		debugfs_create_x32("DCPLB_ADDR15", 0600, parent, (u32 *)0xFFE0013C);
		debugfs_create_x32("DCPLB_ADDR1", 0600, parent, (u32 *)0xFFE00104);
		debugfs_create_x32("DCPLB_ADDR2", 0600, parent, (u32 *)0xFFE00108);
		debugfs_create_x32("DCPLB_ADDR3", 0600, parent, (u32 *)0xFFE0010C);
		debugfs_create_x32("DCPLB_ADDR4", 0600, parent, (u32 *)0xFFE00110);
		debugfs_create_x32("DCPLB_ADDR5", 0600, parent, (u32 *)0xFFE00114);
		debugfs_create_x32("DCPLB_ADDR6", 0600, parent, (u32 *)0xFFE00118);
		debugfs_create_x32("DCPLB_ADDR7", 0600, parent, (u32 *)0xFFE0011C);
		debugfs_create_x32("DCPLB_ADDR8", 0600, parent, (u32 *)0xFFE00120);
		debugfs_create_x32("DCPLB_ADDR9", 0600, parent, (u32 *)0xFFE00124);
		debugfs_create_x32("DCPLB_DATA0", 0600, parent, (u32 *)0xFFE00200);
		debugfs_create_x32("DCPLB_DATA10", 0600, parent, (u32 *)0xFFE00228);
		debugfs_create_x32("DCPLB_DATA11", 0600, parent, (u32 *)0xFFE0022C);
		debugfs_create_x32("DCPLB_DATA12", 0600, parent, (u32 *)0xFFE00230);
		debugfs_create_x32("DCPLB_DATA13", 0600, parent, (u32 *)0xFFE00234);
		debugfs_create_x32("DCPLB_DATA14", 0600, parent, (u32 *)0xFFE00238);
		debugfs_create_x32("DCPLB_DATA15", 0600, parent, (u32 *)0xFFE0023C);
		debugfs_create_x32("DCPLB_DATA1", 0600, parent, (u32 *)0xFFE00204);
		debugfs_create_x32("DCPLB_DATA2", 0600, parent, (u32 *)0xFFE00208);
		debugfs_create_x32("DCPLB_DATA3", 0600, parent, (u32 *)0xFFE0020C);
		debugfs_create_x32("DCPLB_DATA4", 0600, parent, (u32 *)0xFFE00210);
		debugfs_create_x32("DCPLB_DATA5", 0600, parent, (u32 *)0xFFE00214);
		debugfs_create_x32("DCPLB_DATA6", 0600, parent, (u32 *)0xFFE00218);
		debugfs_create_x32("DCPLB_DATA7", 0600, parent, (u32 *)0xFFE0021C);
		debugfs_create_x32("DCPLB_DATA8", 0600, parent, (u32 *)0xFFE00220);
		debugfs_create_x32("DCPLB_DATA9", 0600, parent, (u32 *)0xFFE00224);
		debugfs_create_x32("DCPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0000C);
		debugfs_create_x32("DCPLB_STATUS", 0600, parent, (u32 *)0xFFE00008);
		debugfs_create_x32("DMEM_CONTROL", 0600, parent, (u32 *)0xFFE00004);
		debugfs_create_x32("DTEST_COMMAND", 0600, parent, (u32 *)0xFFE00300);
		debugfs_create_x32("DTEST_DATA0", 0600, parent, (u32 *)0xFFE00400);
		debugfs_create_x32("DTEST_DATA1", 0600, parent, (u32 *)0xFFE00404);
		debugfs_create_x32("SRAM_BASE_ADDR", 0600, parent, (u32 *)0xFFE00000);

		parent = debugfs_create_dir("MDMA Destination 0", top);
		debugfs_create_x16("MDMA_D0_CONFIG", 0600, parent, (u16 *)0xFFC00F08);
		debugfs_create_x32("MDMA_D0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F24);
		debugfs_create_x32("MDMA_D0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F20);
		debugfs_create_x16("MDMA_D0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F30);
		debugfs_create_x16("MDMA_D0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F38);
		debugfs_create_x16("MDMA_D0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F28);
		debugfs_create_x32("MDMA_D0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F00);
		debugfs_create_x16("MDMA_D0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F2C);
		debugfs_create_x32("MDMA_D0_START_ADDR", 0600, parent, (u32 *)0xFFC00F04);
		debugfs_create_x16("MDMA_D0_X_COUNT", 0600, parent, (u16 *)0xFFC00F10);
		debugfs_create_x16("MDMA_D0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F14);
		debugfs_create_x16("MDMA_D0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F18);
		debugfs_create_x16("MDMA_D0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F1C);

		parent = debugfs_create_dir("MDMA Destination 1", top);
		debugfs_create_x16("MDMA_D1_CONFIG", 0600, parent, (u16 *)0xFFC00F88);
		debugfs_create_x32("MDMA_D1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FA4);
		debugfs_create_x32("MDMA_D1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FA0);
		debugfs_create_x16("MDMA_D1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FB0);
		debugfs_create_x16("MDMA_D1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FB8);
		debugfs_create_x16("MDMA_D1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FA8);
		debugfs_create_x32("MDMA_D1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F80);
		debugfs_create_x16("MDMA_D1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FAC);
		debugfs_create_x32("MDMA_D1_START_ADDR", 0600, parent, (u32 *)0xFFC00F84);
		debugfs_create_x16("MDMA_D1_X_COUNT", 0600, parent, (u16 *)0xFFC00F90);
		debugfs_create_x16("MDMA_D1_X_MODIFY", 0600, parent, (u16 *)0xFFC00F94);
		debugfs_create_x16("MDMA_D1_Y_COUNT", 0600, parent, (u16 *)0xFFC00F98);
		debugfs_create_x16("MDMA_D1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F9C);

		parent = debugfs_create_dir("MDMA Source 0", top);
		debugfs_create_x16("MDMA_S0_CONFIG", 0600, parent, (u16 *)0xFFC00F48);
		debugfs_create_x32("MDMA_S0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F64);
		debugfs_create_x32("MDMA_S0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F60);
		debugfs_create_x16("MDMA_S0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F70);
		debugfs_create_x16("MDMA_S0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F78);
		debugfs_create_x16("MDMA_S0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F68);
		debugfs_create_x32("MDMA_S0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F40);
		debugfs_create_x16("MDMA_S0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F6C);
		debugfs_create_x32("MDMA_S0_START_ADDR", 0600, parent, (u32 *)0xFFC00F44);
		debugfs_create_x16("MDMA_S0_X_COUNT", 0600, parent, (u16 *)0xFFC00F50);
		debugfs_create_x16("MDMA_S0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F54);
		debugfs_create_x16("MDMA_S0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F58);
		debugfs_create_x16("MDMA_S0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F5C);

		parent = debugfs_create_dir("MDMA Source 1", top);
		debugfs_create_x16("MDMA_S1_CONFIG", 0600, parent, (u16 *)0xFFC00FC8);
		debugfs_create_x32("MDMA_S1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FE4);
		debugfs_create_x32("MDMA_S1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FE0);
		debugfs_create_x16("MDMA_S1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FF0);
		debugfs_create_x16("MDMA_S1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FF8);
		debugfs_create_x16("MDMA_S1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FE8);
		debugfs_create_x32("MDMA_S1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00FC0);
		debugfs_create_x16("MDMA_S1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FEC);
		debugfs_create_x32("MDMA_S1_START_ADDR", 0600, parent, (u32 *)0xFFC00FC4);
		debugfs_create_x16("MDMA_S1_X_COUNT", 0600, parent, (u16 *)0xFFC00FD0);
		debugfs_create_x16("MDMA_S1_X_MODIFY", 0600, parent, (u16 *)0xFFC00FD4);
		debugfs_create_x16("MDMA_S1_Y_COUNT", 0600, parent, (u16 *)0xFFC00FD8);
		debugfs_create_x16("MDMA_S1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00FDC);

		parent = debugfs_create_dir("NFC", top);
		debugfs_create_x16("NFC_ADDR", 0600, parent, (u16 *)0xFFC03740);
		debugfs_create_x16("NFC_CMD", 0600, parent, (u16 *)0xFFC03744);
		debugfs_create_x16("NFC_COUNT", 0600, parent, (u16 *)0xFFC03720);
		debugfs_create_x16("NFC_CTL", 0600, parent, (u16 *)0xFFC03700);
		debugfs_create_x16("NFC_DATA_RD", 0600, parent, (u16 *)0xFFC0374C);
		debugfs_create_x16("NFC_DATA_WR", 0600, parent, (u16 *)0xFFC03748);
		debugfs_create_x16("NFC_ECC0", 0600, parent, (u16 *)0xFFC03710);
		debugfs_create_x16("NFC_ECC1", 0600, parent, (u16 *)0xFFC03714);
		debugfs_create_x16("NFC_ECC2", 0600, parent, (u16 *)0xFFC03718);
		debugfs_create_x16("NFC_ECC3", 0600, parent, (u16 *)0xFFC0371C);
		debugfs_create_x16("NFC_IRQMASK", 0600, parent, (u16 *)0xFFC0370C);
		debugfs_create_x16("NFC_IRQSTAT", 0600, parent, (u16 *)0xFFC03708);
		debugfs_create_x16("NFC_PGCTL", 0600, parent, (u16 *)0xFFC03728);
		debugfs_create_x16("NFC_READ", 0600, parent, (u16 *)0xFFC0372C);
		debugfs_create_x16("NFC_RST", 0600, parent, (u16 *)0xFFC03724);
		debugfs_create_x16("NFC_STAT", 0600, parent, (u16 *)0xFFC03704);

		parent = debugfs_create_dir("NON-GPIO", top);
		debugfs_create_x16("NONGPIO_DRIVE", 0600, parent, (u16 *)0xFFC03280);
		debugfs_create_x16("NONGPIO_HYSTERESIS", 0600, parent, (u16 *)0xFFC03288);
		debugfs_create_x16("NONGPIO_SLEW", 0600, parent, (u16 *)0xFFC03284);

		parent = debugfs_create_dir("OTP", top);
		debugfs_create_x16("OTP_BEN", 0600, parent, (u16 *)0xFFC03604);
		debugfs_create_x16("OTP_CONTROL", 0600, parent, (u16 *)0xFFC03600);
		debugfs_create_x32("OTP_DATA0", 0600, parent, (u32 *)0xFFC03680);
		debugfs_create_x32("OTP_DATA1", 0600, parent, (u32 *)0xFFC03684);
		debugfs_create_x32("OTP_DATA2", 0600, parent, (u32 *)0xFFC03688);
		debugfs_create_x32("OTP_DATA3", 0600, parent, (u32 *)0xFFC0368C);
		debugfs_create_x16("OTP_STATUS", 0600, parent, (u16 *)0xFFC03608);
		debugfs_create_x32("OTP_TIMING", 0600, parent, (u32 *)0xFFC0360C);

		parent = debugfs_create_dir("PLL", top);
		debugfs_create_x16("PLL_CTL", 0600, parent, (u16 *)0xFFC00000);
		debugfs_create_x16("PLL_DIV", 0600, parent, (u16 *)0xFFC00004);
		debugfs_create_x16("PLL_LOCKCNT", 0600, parent, (u16 *)0xFFC00010);
		debugfs_create_x16("PLL_STAT", 0600, parent, (u16 *)0xFFC0000C);
		debugfs_create_x16("VR_CTL", 0600, parent, (u16 *)0xFFC00008);

		parent = debugfs_create_dir("PPI", top);
		debugfs_create_x16("PPI_CONTROL", 0600, parent, (u16 *)0xFFC01000);
		debugfs_create_x16("PPI_COUNT", 0600, parent, (u16 *)0xFFC01008);
		debugfs_create_x16("PPI_DELAY", 0600, parent, (u16 *)0xFFC0100C);
		debugfs_create_x16("PPI_FRAME", 0600, parent, (u16 *)0xFFC01010);
		debugfs_create_x16("PPI_STATUS", 0600, parent, (u16 *)0xFFC01004);

		parent = debugfs_create_dir("Performance Monitor", top);
		debugfs_create_x32("PFCNTR0", 0600, parent, (u32 *)0xFFE08100);
		debugfs_create_x32("PFCNTR1", 0600, parent, (u32 *)0xFFE08104);
		debugfs_create_x32("PFCTL", 0600, parent, (u32 *)0xFFE08000);

		parent = debugfs_create_dir("Pin Control", top);
		debugfs_create_x16("PORTF_FER", 0600, parent, (u16 *)0xFFC03200);
		debugfs_create_x16("PORTG_FER", 0600, parent, (u16 *)0xFFC03204);
		debugfs_create_x16("PORTH_FER", 0600, parent, (u16 *)0xFFC03208);

		parent = debugfs_create_dir("Port I-O", top);
		debugfs_create_x16("PORTFIO", 0600, parent, (u16 *)0xFFC00700);
		debugfs_create_x16("PORTFIO_BOTH", 0600, parent, (u16 *)0xFFC0073C);
		debugfs_create_x16("PORTFIO_CLEAR", 0600, parent, (u16 *)0xFFC00704);
		debugfs_create_x16("PORTFIO_DIR", 0600, parent, (u16 *)0xFFC00730);
		debugfs_create_x16("PORTFIO_EDGE", 0600, parent, (u16 *)0xFFC00738);
		debugfs_create_x16("PORTFIO_INEN", 0600, parent, (u16 *)0xFFC00740);
		debugfs_create_x16("PORTFIO_MASKA", 0600, parent, (u16 *)0xFFC00710);
		debugfs_create_x16("PORTFIO_MASKA_CLEAR", 0600, parent, (u16 *)0xFFC00714);
		debugfs_create_x16("PORTFIO_MASKA_SET", 0600, parent, (u16 *)0xFFC00718);
		debugfs_create_x16("PORTFIO_MASKA_TOGGLE", 0600, parent, (u16 *)0xFFC0071C);
		debugfs_create_x16("PORTFIO_MASKB", 0600, parent, (u16 *)0xFFC00720);
		debugfs_create_x16("PORTFIO_MASKB_CLEAR", 0600, parent, (u16 *)0xFFC00724);
		debugfs_create_x16("PORTFIO_MASKB_SET", 0600, parent, (u16 *)0xFFC00728);
		debugfs_create_x16("PORTFIO_MASKB_TOGGLE", 0600, parent, (u16 *)0xFFC0072C);
		debugfs_create_x16("PORTFIO_POLAR", 0600, parent, (u16 *)0xFFC00734);
		debugfs_create_x16("PORTFIO_SET", 0600, parent, (u16 *)0xFFC00708);
		debugfs_create_x16("PORTFIO_TOGGLE", 0600, parent, (u16 *)0xFFC0070C);
		debugfs_create_x16("PORTGIO", 0600, parent, (u16 *)0xFFC01500);
		debugfs_create_x16("PORTGIO_BOTH", 0600, parent, (u16 *)0xFFC0153C);
		debugfs_create_x16("PORTGIO_CLEAR", 0600, parent, (u16 *)0xFFC01504);
		debugfs_create_x16("PORTGIO_DIR", 0600, parent, (u16 *)0xFFC01530);
		debugfs_create_x16("PORTGIO_EDGE", 0600, parent, (u16 *)0xFFC01538);
		debugfs_create_x16("PORTGIO_INEN", 0600, parent, (u16 *)0xFFC01540);
		debugfs_create_x16("PORTGIO_MASKA", 0600, parent, (u16 *)0xFFC01510);
		debugfs_create_x16("PORTGIO_MASKA_CLEAR", 0600, parent, (u16 *)0xFFC01514);
		debugfs_create_x16("PORTGIO_MASKA_SET", 0600, parent, (u16 *)0xFFC01518);
		debugfs_create_x16("PORTGIO_MASKA_TOGGLE", 0600, parent, (u16 *)0xFFC0151C);
		debugfs_create_x16("PORTGIO_MASKB", 0600, parent, (u16 *)0xFFC01520);
		debugfs_create_x16("PORTGIO_MASKB_CLEAR", 0600, parent, (u16 *)0xFFC01524);
		debugfs_create_x16("PORTGIO_MASKB_SET", 0600, parent, (u16 *)0xFFC01528);
		debugfs_create_x16("PORTGIO_MASKB_TOGGLE", 0600, parent, (u16 *)0xFFC0152C);
		debugfs_create_x16("PORTGIO_POLAR", 0600, parent, (u16 *)0xFFC01534);
		debugfs_create_x16("PORTGIO_SET", 0600, parent, (u16 *)0xFFC01508);
		debugfs_create_x16("PORTGIO_TOGGLE", 0600, parent, (u16 *)0xFFC0150C);
		debugfs_create_x16("PORTHIO", 0600, parent, (u16 *)0xFFC01700);
		debugfs_create_x16("PORTHIO_BOTH", 0600, parent, (u16 *)0xFFC0173C);
		debugfs_create_x16("PORTHIO_CLEAR", 0600, parent, (u16 *)0xFFC01704);
		debugfs_create_x16("PORTHIO_DIR", 0600, parent, (u16 *)0xFFC01730);
		debugfs_create_x16("PORTHIO_EDGE", 0600, parent, (u16 *)0xFFC01738);
		debugfs_create_x16("PORTHIO_INEN", 0600, parent, (u16 *)0xFFC01740);
		debugfs_create_x16("PORTHIO_MASKA", 0600, parent, (u16 *)0xFFC01710);
		debugfs_create_x16("PORTHIO_MASKA_CLEAR", 0600, parent, (u16 *)0xFFC01714);
		debugfs_create_x16("PORTHIO_MASKA_SET", 0600, parent, (u16 *)0xFFC01718);
		debugfs_create_x16("PORTHIO_MASKA_TOGGLE", 0600, parent, (u16 *)0xFFC0171C);
		debugfs_create_x16("PORTHIO_MASKB", 0600, parent, (u16 *)0xFFC01720);
		debugfs_create_x16("PORTHIO_MASKB_CLEAR", 0600, parent, (u16 *)0xFFC01724);
		debugfs_create_x16("PORTHIO_MASKB_SET", 0600, parent, (u16 *)0xFFC01728);
		debugfs_create_x16("PORTHIO_MASKB_TOGGLE", 0600, parent, (u16 *)0xFFC0172C);
		debugfs_create_x16("PORTHIO_POLAR", 0600, parent, (u16 *)0xFFC01734);
		debugfs_create_x16("PORTHIO_SET", 0600, parent, (u16 *)0xFFC01708);
		debugfs_create_x16("PORTHIO_TOGGLE", 0600, parent, (u16 *)0xFFC0170C);

		parent = debugfs_create_dir("RTC", top);
		debugfs_create_x32("RTC_ALARM", 0600, parent, (u32 *)0xFFC00310);
		debugfs_create_x16("RTC_ICTL", 0600, parent, (u16 *)0xFFC00304);
		debugfs_create_x16("RTC_ISTAT", 0600, parent, (u16 *)0xFFC00308);
		debugfs_create_x16("RTC_PREN", 0600, parent, (u16 *)0xFFC00314);
		debugfs_create_x32("RTC_STAT", 0600, parent, (u32 *)0xFFC00300);
		debugfs_create_x16("RTC_SWCNT", 0600, parent, (u16 *)0xFFC0030C);

		parent = debugfs_create_dir("SPI", top);
		debugfs_create_x16("SPI_BAUD", 0600, parent, (u16 *)0xFFC00514);
		debugfs_create_x16("SPI_CTL", 0600, parent, (u16 *)0xFFC00500);
		debugfs_create_x16("SPI_FLG", 0600, parent, (u16 *)0xFFC00504);
		debugfs_create_x16("SPI_RDBR", 0600, parent, (u16 *)0xFFC00510);
		debugfs_create_x16("SPI_SHADOW", 0600, parent, (u16 *)0xFFC00518);
		debugfs_create_x16("SPI_STAT", 0600, parent, (u16 *)0xFFC00508);
		debugfs_create_x16("SPI_TDBR", 0600, parent, (u16 *)0xFFC0050C);

		parent = debugfs_create_dir("SPORT", top);
		debugfs_create_x16("SPORT0_CHNL", 0600, parent, (u16 *)0xFFC00834);
		debugfs_create_x16("SPORT0_MCMC1", 0600, parent, (u16 *)0xFFC00838);
		debugfs_create_x16("SPORT0_MCMC2", 0600, parent, (u16 *)0xFFC0083C);
		debugfs_create_x32("SPORT0_MRCS0", 0600, parent, (u32 *)0xFFC00850);
		debugfs_create_x32("SPORT0_MRCS1", 0600, parent, (u32 *)0xFFC00854);
		debugfs_create_x32("SPORT0_MRCS2", 0600, parent, (u32 *)0xFFC00858);
		debugfs_create_x32("SPORT0_MRCS3", 0600, parent, (u32 *)0xFFC0085C);
		debugfs_create_x32("SPORT0_MTCS0", 0600, parent, (u32 *)0xFFC00840);
		debugfs_create_x32("SPORT0_MTCS1", 0600, parent, (u32 *)0xFFC00844);
		debugfs_create_x32("SPORT0_MTCS2", 0600, parent, (u32 *)0xFFC00848);
		debugfs_create_x32("SPORT0_MTCS3", 0600, parent, (u32 *)0xFFC0084C);
		debugfs_create_x16("SPORT0_RCLKDIV", 0600, parent, (u16 *)0xFFC00828);
		debugfs_create_x16("SPORT0_RCR1", 0600, parent, (u16 *)0xFFC00820);
		debugfs_create_x16("SPORT0_RCR2", 0600, parent, (u16 *)0xFFC00824);
		debugfs_create_x16("SPORT0_RFSDIV", 0600, parent, (u16 *)0xFFC0082C);
		debugfs_create_x32("SPORT0_RX", 0600, parent, (u32 *)0xFFC00818);
		debugfs_create_x16("SPORT0_STAT", 0600, parent, (u16 *)0xFFC00830);
		debugfs_create_x16("SPORT0_TCLKDIV", 0600, parent, (u16 *)0xFFC00808);
		debugfs_create_x16("SPORT0_TCR1", 0600, parent, (u16 *)0xFFC00800);
		debugfs_create_x16("SPORT0_TCR2", 0600, parent, (u16 *)0xFFC00804);
		debugfs_create_x16("SPORT0_TFSDIV", 0600, parent, (u16 *)0xFFC0080C);
		debugfs_create_x32("SPORT0_TX", 0600, parent, (u32 *)0xFFC00810);
		debugfs_create_x16("SPORT1_CHNL", 0600, parent, (u16 *)0xFFC00934);
		debugfs_create_x16("SPORT1_MCMC1", 0600, parent, (u16 *)0xFFC00938);
		debugfs_create_x16("SPORT1_MCMC2", 0600, parent, (u16 *)0xFFC0093C);
		debugfs_create_x32("SPORT1_MRCS0", 0600, parent, (u32 *)0xFFC00950);
		debugfs_create_x32("SPORT1_MRCS1", 0600, parent, (u32 *)0xFFC00954);
		debugfs_create_x32("SPORT1_MRCS2", 0600, parent, (u32 *)0xFFC00958);
		debugfs_create_x32("SPORT1_MRCS3", 0600, parent, (u32 *)0xFFC0095C);
		debugfs_create_x32("SPORT1_MTCS0", 0600, parent, (u32 *)0xFFC00940);
		debugfs_create_x32("SPORT1_MTCS1", 0600, parent, (u32 *)0xFFC00944);
		debugfs_create_x32("SPORT1_MTCS2", 0600, parent, (u32 *)0xFFC00948);
		debugfs_create_x32("SPORT1_MTCS3", 0600, parent, (u32 *)0xFFC0094C);
		debugfs_create_x16("SPORT1_RCLKDIV", 0600, parent, (u16 *)0xFFC00928);
		debugfs_create_x16("SPORT1_RCR1", 0600, parent, (u16 *)0xFFC00920);
		debugfs_create_x16("SPORT1_RCR2", 0600, parent, (u16 *)0xFFC00924);
		debugfs_create_x16("SPORT1_RFSDIV", 0600, parent, (u16 *)0xFFC0092C);
		debugfs_create_x32("SPORT1_RX", 0600, parent, (u32 *)0xFFC00918);
		debugfs_create_x16("SPORT1_STAT", 0600, parent, (u16 *)0xFFC00930);
		debugfs_create_x16("SPORT1_TCLKDIV", 0600, parent, (u16 *)0xFFC00908);
		debugfs_create_x16("SPORT1_TCR1", 0600, parent, (u16 *)0xFFC00900);
		debugfs_create_x16("SPORT1_TCR2", 0600, parent, (u16 *)0xFFC00904);
		debugfs_create_x16("SPORT1_TFSDIV", 0600, parent, (u16 *)0xFFC0090C);
		debugfs_create_x32("SPORT1_TX", 0600, parent, (u32 *)0xFFC00910);

		parent = debugfs_create_dir("Security", top);
		debugfs_create_x16("SECURE_CONTROL", 0600, parent, (u16 *)0xFFC03624);
		debugfs_create_x16("SECURE_STATUS", 0600, parent, (u16 *)0xFFC03628);
		debugfs_create_x32("SECURE_SYSSWT", 0600, parent, (u32 *)0xFFC03620);

		parent = debugfs_create_dir("System Interrupt Controller Register File", top);
		debugfs_create_x32("SIC_IAR0", 0600, parent, (u32 *)0xFFC00110);
		debugfs_create_x32("SIC_IAR1", 0600, parent, (u32 *)0xFFC00114);
		debugfs_create_x32("SIC_IAR2", 0600, parent, (u32 *)0xFFC00118);
		debugfs_create_x32("SIC_IAR3", 0600, parent, (u32 *)0xFFC0011C);
		debugfs_create_x32("SIC_IAR4", 0600, parent, (u32 *)0xFFC00150);
		debugfs_create_x32("SIC_IAR5", 0600, parent, (u32 *)0xFFC00154);
		debugfs_create_x32("SIC_IAR6", 0600, parent, (u32 *)0xFFC00158);
		debugfs_create_x32("SIC_IAR7", 0600, parent, (u32 *)0xFFC0015C);
		debugfs_create_x32("SIC_IMASK0", 0600, parent, (u32 *)0xFFC0010C);
		debugfs_create_x32("SIC_IMASK1", 0600, parent, (u32 *)0xFFC0014C);
		debugfs_create_x32("SIC_ISR0", 0600, parent, (u32 *)0xFFC00120);
		debugfs_create_x32("SIC_ISR1", 0600, parent, (u32 *)0xFFC00160);
		debugfs_create_x32("SIC_IWR0", 0600, parent, (u32 *)0xFFC00124);
		debugfs_create_x32("SIC_IWR1", 0600, parent, (u32 *)0xFFC00164);
		debugfs_create_x32("SIC_RVECT", 0600, parent, (u32 *)0xFFC00108);

		parent = debugfs_create_dir("System Reset and Interrupt Control Registers", top);
		debugfs_create_x16("SWRST", 0600, parent, (u16 *)0xFFC00100);
		debugfs_create_x16("SYSCR", 0600, parent, (u16 *)0xFFC00104);

		parent = debugfs_create_dir("TWI", top);
		debugfs_create_x16("TWI_CLKDIV", 0600, parent, (u16 *)0xFFC01400);
		debugfs_create_x16("TWI_CONTROL", 0600, parent, (u16 *)0xFFC01404);
		debugfs_create_x16("TWI_FIFO_CTL", 0600, parent, (u16 *)0xFFC01428);
		debugfs_create_x16("TWI_FIFO_STAT", 0600, parent, (u16 *)0xFFC0142C);
		debugfs_create_x16("TWI_INT_MASK", 0600, parent, (u16 *)0xFFC01424);
		debugfs_create_x16("TWI_INT_STAT", 0600, parent, (u16 *)0xFFC01420);
		debugfs_create_x16("TWI_MASTER_ADDR", 0600, parent, (u16 *)0xFFC0141C);
		debugfs_create_x16("TWI_MASTER_CTL", 0600, parent, (u16 *)0xFFC01414);
		debugfs_create_x16("TWI_MASTER_STAT", 0600, parent, (u16 *)0xFFC01418);
		debugfs_create_x16("TWI_RCV_DATA16", 0600, parent, (u16 *)0xFFC0148C);
		debugfs_create_x16("TWI_RCV_DATA8", 0600, parent, (u16 *)0xFFC01488);
		debugfs_create_x16("TWI_SLAVE_ADDR", 0600, parent, (u16 *)0xFFC01410);
		debugfs_create_x16("TWI_SLAVE_CTL", 0600, parent, (u16 *)0xFFC01408);
		debugfs_create_x16("TWI_SLAVE_STAT", 0600, parent, (u16 *)0xFFC0140C);
		debugfs_create_x16("TWI_XMT_DATA16", 0600, parent, (u16 *)0xFFC01484);
		debugfs_create_x16("TWI_XMT_DATA8", 0600, parent, (u16 *)0xFFC01480);

		parent = debugfs_create_dir("Timer Registers", top);
		debugfs_create_x16("TIMER0_CONFIG", 0600, parent, (u16 *)0xFFC00600);
		debugfs_create_x32("TIMER0_COUNTER", 0600, parent, (u32 *)0xFFC00604);
		debugfs_create_x32("TIMER0_PERIOD", 0600, parent, (u32 *)0xFFC00608);
		debugfs_create_x32("TIMER0_WIDTH", 0600, parent, (u32 *)0xFFC0060C);
		debugfs_create_x16("TIMER1_CONFIG", 0600, parent, (u16 *)0xFFC00610);
		debugfs_create_x32("TIMER1_COUNTER", 0600, parent, (u32 *)0xFFC00614);
		debugfs_create_x32("TIMER1_PERIOD", 0600, parent, (u32 *)0xFFC00618);
		debugfs_create_x32("TIMER1_WIDTH", 0600, parent, (u32 *)0xFFC0061C);
		debugfs_create_x16("TIMER2_CONFIG", 0600, parent, (u16 *)0xFFC00620);
		debugfs_create_x32("TIMER2_COUNTER", 0600, parent, (u32 *)0xFFC00624);
		debugfs_create_x32("TIMER2_PERIOD", 0600, parent, (u32 *)0xFFC00628);
		debugfs_create_x32("TIMER2_WIDTH", 0600, parent, (u32 *)0xFFC0062C);
		debugfs_create_x16("TIMER3_CONFIG", 0600, parent, (u16 *)0xFFC00630);
		debugfs_create_x32("TIMER3_COUNTER", 0600, parent, (u32 *)0xFFC00634);
		debugfs_create_x32("TIMER3_PERIOD", 0600, parent, (u32 *)0xFFC00638);
		debugfs_create_x32("TIMER3_WIDTH", 0600, parent, (u32 *)0xFFC0063C);
		debugfs_create_x16("TIMER4_CONFIG", 0600, parent, (u16 *)0xFFC00640);
		debugfs_create_x32("TIMER4_COUNTER", 0600, parent, (u32 *)0xFFC00644);
		debugfs_create_x32("TIMER4_PERIOD", 0600, parent, (u32 *)0xFFC00648);
		debugfs_create_x32("TIMER4_WIDTH", 0600, parent, (u32 *)0xFFC0064C);
		debugfs_create_x16("TIMER5_CONFIG", 0600, parent, (u16 *)0xFFC00650);
		debugfs_create_x32("TIMER5_COUNTER", 0600, parent, (u32 *)0xFFC00654);
		debugfs_create_x32("TIMER5_PERIOD", 0600, parent, (u32 *)0xFFC00658);
		debugfs_create_x32("TIMER5_WIDTH", 0600, parent, (u32 *)0xFFC0065C);
		debugfs_create_x16("TIMER6_CONFIG", 0600, parent, (u16 *)0xFFC00660);
		debugfs_create_x32("TIMER6_COUNTER", 0600, parent, (u32 *)0xFFC00664);
		debugfs_create_x32("TIMER6_PERIOD", 0600, parent, (u32 *)0xFFC00668);
		debugfs_create_x32("TIMER6_WIDTH", 0600, parent, (u32 *)0xFFC0066C);
		debugfs_create_x16("TIMER7_CONFIG", 0600, parent, (u16 *)0xFFC00670);
		debugfs_create_x32("TIMER7_COUNTER", 0600, parent, (u32 *)0xFFC00674);
		debugfs_create_x32("TIMER7_PERIOD", 0600, parent, (u32 *)0xFFC00678);
		debugfs_create_x32("TIMER7_WIDTH", 0600, parent, (u32 *)0xFFC0067C);
		debugfs_create_x16("TIMER_DISABLE", 0600, parent, (u16 *)0xFFC00684);
		debugfs_create_x16("TIMER_ENABLE", 0600, parent, (u16 *)0xFFC00680);
		debugfs_create_x32("TIMER_STATUS", 0600, parent, (u32 *)0xFFC00688);

		parent = debugfs_create_dir("Trace Unit", top);
		debugfs_create_x32("TBUF", 0600, parent, (u32 *)0xFFE06100);
		debugfs_create_x32("TBUFCTL", 0600, parent, (u32 *)0xFFE06000);
		debugfs_create_x32("TBUFSTAT", 0600, parent, (u32 *)0xFFE06004);

		parent = debugfs_create_dir("UART", top);
		debugfs_create_x16("UART0_DLH", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART0_DLL", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART0_GCTL", 0600, parent, (u16 *)0xFFC00424);
		debugfs_create_x16("UART0_IER", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART0_IIR", 0600, parent, (u16 *)0xFFC00408);
		debugfs_create_x16("UART0_LCR", 0600, parent, (u16 *)0xFFC0040C);
		debugfs_create_x16("UART0_LSR", 0600, parent, (u16 *)0xFFC00414);
		debugfs_create_x16("UART0_MCR", 0600, parent, (u16 *)0xFFC00410);
		debugfs_create_x16("UART0_MSR", 0600, parent, (u16 *)0xFFC00418);
		debugfs_create_x16("UART0_RBR", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART0_SCR", 0600, parent, (u16 *)0xFFC0041C);
		debugfs_create_x16("UART0_THR", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART1_DLH", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("UART1_DLL", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART1_GCTL", 0600, parent, (u16 *)0xFFC02024);
		debugfs_create_x16("UART1_IER", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("UART1_IIR", 0600, parent, (u16 *)0xFFC02008);
		debugfs_create_x16("UART1_LCR", 0600, parent, (u16 *)0xFFC0200C);
		debugfs_create_x16("UART1_LSR", 0600, parent, (u16 *)0xFFC02014);
		debugfs_create_x16("UART1_MCR", 0600, parent, (u16 *)0xFFC02010);
		debugfs_create_x16("UART1_MSR", 0600, parent, (u16 *)0xFFC02018);
		debugfs_create_x16("UART1_RBR", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART1_SCR", 0600, parent, (u16 *)0xFFC0201C);
		debugfs_create_x16("UART1_THR", 0600, parent, (u16 *)0xFFC02000);

		parent = debugfs_create_dir("USB", top);
		debugfs_create_x16("USB_APHY_CALIB", 0600, parent, (u16 *)0xFFC039E4);
		debugfs_create_x16("USB_APHY_CNTRL2", 0600, parent, (u16 *)0xFFC039E8);
		debugfs_create_x16("USB_APHY_CNTRL", 0600, parent, (u16 *)0xFFC039E0);
		debugfs_create_x16("USB_COUNT0", 0600, parent, (u16 *)0xFFC03850);
		debugfs_create_x16("USB_CSR0", 0600, parent, (u16 *)0xFFC03844);
		debugfs_create_x16("USB_DMA0_ADDRHIGH", 0600, parent, (u16 *)0xFFC03C0C);
		debugfs_create_x16("USB_DMA0_ADDRLOW", 0600, parent, (u16 *)0xFFC03C08);
		debugfs_create_x16("USB_DMA0_CONTROL", 0600, parent, (u16 *)0xFFC03C04);
		debugfs_create_x16("USB_DMA0_COUNTHIGH", 0600, parent, (u16 *)0xFFC03C14);
		debugfs_create_x16("USB_DMA0_COUNTLOW", 0600, parent, (u16 *)0xFFC03C10);
		debugfs_create_x16("USB_DMA1_ADDRHIGH", 0600, parent, (u16 *)0xFFC03C2C);
		debugfs_create_x16("USB_DMA1_ADDRLOW", 0600, parent, (u16 *)0xFFC03C28);
		debugfs_create_x16("USB_DMA1_CONTROL", 0600, parent, (u16 *)0xFFC03C24);
		debugfs_create_x16("USB_DMA1_COUNTHIGH", 0600, parent, (u16 *)0xFFC03C34);
		debugfs_create_x16("USB_DMA1_COUNTLOW", 0600, parent, (u16 *)0xFFC03C30);
		debugfs_create_x16("USB_DMA2_ADDRHIGH", 0600, parent, (u16 *)0xFFC03C4C);
		debugfs_create_x16("USB_DMA2_ADDRLOW", 0600, parent, (u16 *)0xFFC03C48);
		debugfs_create_x16("USB_DMA2_CONTROL", 0600, parent, (u16 *)0xFFC03C44);
		debugfs_create_x16("USB_DMA2_COUNTHIGH", 0600, parent, (u16 *)0xFFC03C54);
		debugfs_create_x16("USB_DMA2_COUNTLOW", 0600, parent, (u16 *)0xFFC03C50);
		debugfs_create_x16("USB_DMA3_ADDRHIGH", 0600, parent, (u16 *)0xFFC03C6C);
		debugfs_create_x16("USB_DMA3_ADDRLOW", 0600, parent, (u16 *)0xFFC03C68);
		debugfs_create_x16("USB_DMA3_CONTROL", 0600, parent, (u16 *)0xFFC03C64);
		debugfs_create_x16("USB_DMA3_COUNTHIGH", 0600, parent, (u16 *)0xFFC03C74);
		debugfs_create_x16("USB_DMA3_COUNTLOW", 0600, parent, (u16 *)0xFFC03C70);
		debugfs_create_x16("USB_DMA4_ADDRHIGH", 0600, parent, (u16 *)0xFFC03C8C);
		debugfs_create_x16("USB_DMA4_ADDRLOW", 0600, parent, (u16 *)0xFFC03C88);
		debugfs_create_x16("USB_DMA4_CONTROL", 0600, parent, (u16 *)0xFFC03C84);
		debugfs_create_x16("USB_DMA4_COUNTHIGH", 0600, parent, (u16 *)0xFFC03C94);
		debugfs_create_x16("USB_DMA4_COUNTLOW", 0600, parent, (u16 *)0xFFC03C90);
		debugfs_create_x16("USB_DMA5_ADDRHIGH", 0600, parent, (u16 *)0xFFC03CAC);
		debugfs_create_x16("USB_DMA5_ADDRLOW", 0600, parent, (u16 *)0xFFC03CA8);
		debugfs_create_x16("USB_DMA5_CONTROL", 0600, parent, (u16 *)0xFFC03CA4);
		debugfs_create_x16("USB_DMA5_COUNTHIGH", 0600, parent, (u16 *)0xFFC03CB4);
		debugfs_create_x16("USB_DMA5_COUNTLOW", 0600, parent, (u16 *)0xFFC03CB0);
		debugfs_create_x16("USB_DMA6_ADDRHIGH", 0600, parent, (u16 *)0xFFC03CCC);
		debugfs_create_x16("USB_DMA6_ADDRLOW", 0600, parent, (u16 *)0xFFC03CC8);
		debugfs_create_x16("USB_DMA6_CONTROL", 0600, parent, (u16 *)0xFFC03CC4);
		debugfs_create_x16("USB_DMA6_COUNTHIGH", 0600, parent, (u16 *)0xFFC03CD4);
		debugfs_create_x16("USB_DMA6_COUNTLOW", 0600, parent, (u16 *)0xFFC03CD0);
		debugfs_create_x16("USB_DMA7_ADDRHIGH", 0600, parent, (u16 *)0xFFC03CEC);
		debugfs_create_x16("USB_DMA7_ADDRLOW", 0600, parent, (u16 *)0xFFC03CE8);
		debugfs_create_x16("USB_DMA7_CONTROL", 0600, parent, (u16 *)0xFFC03CE4);
		debugfs_create_x16("USB_DMA7_COUNTHIGH", 0600, parent, (u16 *)0xFFC03CF4);
		debugfs_create_x16("USB_DMA7_COUNTLOW", 0600, parent, (u16 *)0xFFC03CF0);
		debugfs_create_x16("USB_DMA_INTERRUPT", 0600, parent, (u16 *)0xFFC03C00);
		debugfs_create_x16("USB_EP0_FIFO", 0600, parent, (u16 *)0xFFC03880);
		debugfs_create_x16("USB_EP1_FIFO", 0600, parent, (u16 *)0xFFC03888);
		debugfs_create_x16("USB_EP2_FIFO", 0600, parent, (u16 *)0xFFC03890);
		debugfs_create_x16("USB_EP3_FIFO", 0600, parent, (u16 *)0xFFC03898);
		debugfs_create_x16("USB_EP4_FIFO", 0600, parent, (u16 *)0xFFC038A0);
		debugfs_create_x16("USB_EP5_FIFO", 0600, parent, (u16 *)0xFFC038A8);
		debugfs_create_x16("USB_EP6_FIFO", 0600, parent, (u16 *)0xFFC038B0);
		debugfs_create_x16("USB_EP7_FIFO", 0600, parent, (u16 *)0xFFC038B8);
		debugfs_create_x16("USB_EP_NI0_RXCOUNT", 0600, parent, (u16 *)0xFFC03A10);
		debugfs_create_x16("USB_EP_NI0_RXCSR", 0600, parent, (u16 *)0xFFC03A0C);
		debugfs_create_x16("USB_EP_NI0_RXINTERVAL", 0600, parent, (u16 *)0xFFC03A20);
		debugfs_create_x16("USB_EP_NI0_RXMAXP", 0600, parent, (u16 *)0xFFC03A08);
		debugfs_create_x16("USB_EP_NI0_RXTYPE", 0600, parent, (u16 *)0xFFC03A1C);
		debugfs_create_x16("USB_EP_NI0_TXCOUNT", 0600, parent, (u16 *)0xFFC03A28);
		debugfs_create_x16("USB_EP_NI0_TXCSR", 0600, parent, (u16 *)0xFFC03A04);
		debugfs_create_x16("USB_EP_NI0_TXINTERVAL", 0600, parent, (u16 *)0xFFC03A18);
		debugfs_create_x16("USB_EP_NI0_TXMAXP", 0600, parent, (u16 *)0xFFC03A00);
		debugfs_create_x16("USB_EP_NI0_TXTYPE", 0600, parent, (u16 *)0xFFC03A14);
		debugfs_create_x16("USB_EP_NI1_RXCOUNT", 0600, parent, (u16 *)0xFFC03A50);
		debugfs_create_x16("USB_EP_NI1_RXCSR", 0600, parent, (u16 *)0xFFC03A4C);
		debugfs_create_x16("USB_EP_NI1_RXINTERVAL", 0600, parent, (u16 *)0xFFC03A60);
		debugfs_create_x16("USB_EP_NI1_RXMAXP", 0600, parent, (u16 *)0xFFC03A48);
		debugfs_create_x16("USB_EP_NI1_RXTYPE", 0600, parent, (u16 *)0xFFC03A5C);
		debugfs_create_x16("USB_EP_NI1_TXCOUNT", 0600, parent, (u16 *)0xFFC03A68);
		debugfs_create_x16("USB_EP_NI1_TXCSR", 0600, parent, (u16 *)0xFFC03A44);
		debugfs_create_x16("USB_EP_NI1_TXINTERVAL", 0600, parent, (u16 *)0xFFC03A58);
		debugfs_create_x16("USB_EP_NI1_TXMAXP", 0600, parent, (u16 *)0xFFC03A40);
		debugfs_create_x16("USB_EP_NI1_TXTYPE", 0600, parent, (u16 *)0xFFC03A54);
		debugfs_create_x16("USB_EP_NI2_RXCOUNT", 0600, parent, (u16 *)0xFFC03A90);
		debugfs_create_x16("USB_EP_NI2_RXCSR", 0600, parent, (u16 *)0xFFC03A8C);
		debugfs_create_x16("USB_EP_NI2_RXINTERVAL", 0600, parent, (u16 *)0xFFC03AA0);
		debugfs_create_x16("USB_EP_NI2_RXMAXP", 0600, parent, (u16 *)0xFFC03A88);
		debugfs_create_x16("USB_EP_NI2_RXTYPE", 0600, parent, (u16 *)0xFFC03A9C);
		debugfs_create_x16("USB_EP_NI2_TXCOUNT", 0600, parent, (u16 *)0xFFC03AA8);
		debugfs_create_x16("USB_EP_NI2_TXCSR", 0600, parent, (u16 *)0xFFC03A84);
		debugfs_create_x16("USB_EP_NI2_TXINTERVAL", 0600, parent, (u16 *)0xFFC03A98);
		debugfs_create_x16("USB_EP_NI2_TXMAXP", 0600, parent, (u16 *)0xFFC03A80);
		debugfs_create_x16("USB_EP_NI2_TXTYPE", 0600, parent, (u16 *)0xFFC03A94);
		debugfs_create_x16("USB_EP_NI3_RXCOUNT", 0600, parent, (u16 *)0xFFC03AD0);
		debugfs_create_x16("USB_EP_NI3_RXCSR", 0600, parent, (u16 *)0xFFC03ACC);
		debugfs_create_x16("USB_EP_NI3_RXINTERVAL", 0600, parent, (u16 *)0xFFC03AE0);
		debugfs_create_x16("USB_EP_NI3_RXMAXP", 0600, parent, (u16 *)0xFFC03AC8);
		debugfs_create_x16("USB_EP_NI3_RXTYPE", 0600, parent, (u16 *)0xFFC03ADC);
		debugfs_create_x16("USB_EP_NI3_TXCOUNT", 0600, parent, (u16 *)0xFFC03AE8);
		debugfs_create_x16("USB_EP_NI3_TXCSR", 0600, parent, (u16 *)0xFFC03AC4);
		debugfs_create_x16("USB_EP_NI3_TXINTERVAL", 0600, parent, (u16 *)0xFFC03AD8);
		debugfs_create_x16("USB_EP_NI3_TXMAXP", 0600, parent, (u16 *)0xFFC03AC0);
		debugfs_create_x16("USB_EP_NI3_TXTYPE", 0600, parent, (u16 *)0xFFC03AD4);
		debugfs_create_x16("USB_EP_NI4_RXCOUNT", 0600, parent, (u16 *)0xFFC03B10);
		debugfs_create_x16("USB_EP_NI4_RXCSR", 0600, parent, (u16 *)0xFFC03B0C);
		debugfs_create_x16("USB_EP_NI4_RXINTERVAL", 0600, parent, (u16 *)0xFFC03B20);
		debugfs_create_x16("USB_EP_NI4_RXMAXP", 0600, parent, (u16 *)0xFFC03B08);
		debugfs_create_x16("USB_EP_NI4_RXTYPE", 0600, parent, (u16 *)0xFFC03B1C);
		debugfs_create_x16("USB_EP_NI4_TXCOUNT", 0600, parent, (u16 *)0xFFC03B28);
		debugfs_create_x16("USB_EP_NI4_TXCSR", 0600, parent, (u16 *)0xFFC03B04);
		debugfs_create_x16("USB_EP_NI4_TXINTERVAL", 0600, parent, (u16 *)0xFFC03B18);
		debugfs_create_x16("USB_EP_NI4_TXMAXP", 0600, parent, (u16 *)0xFFC03B00);
		debugfs_create_x16("USB_EP_NI4_TXTYPE", 0600, parent, (u16 *)0xFFC03B14);
		debugfs_create_x16("USB_EP_NI5_RXCOUNT", 0600, parent, (u16 *)0xFFC03B50);
		debugfs_create_x16("USB_EP_NI5_RXCSR", 0600, parent, (u16 *)0xFFC03B4C);
		debugfs_create_x16("USB_EP_NI5_RXINTERVAL", 0600, parent, (u16 *)0xFFC03B60);
		debugfs_create_x16("USB_EP_NI5_RXMAXP", 0600, parent, (u16 *)0xFFC03B48);
		debugfs_create_x16("USB_EP_NI5_RXTYPE", 0600, parent, (u16 *)0xFFC03B5C);
		debugfs_create_x16("USB_EP_NI5_TXCOUNT", 0600, parent, (u16 *)0xFFC03B68);
		debugfs_create_x16("USB_EP_NI5_TXCSR", 0600, parent, (u16 *)0xFFC03B44);
		debugfs_create_x16("USB_EP_NI5_TXINTERVAL", 0600, parent, (u16 *)0xFFC03B58);
		debugfs_create_x16("USB_EP_NI5_TXMAXP", 0600, parent, (u16 *)0xFFC03B40);
		debugfs_create_x16("USB_EP_NI5_TXTYPE", 0600, parent, (u16 *)0xFFC03B54);
		debugfs_create_x16("USB_EP_NI6_RXCOUNT", 0600, parent, (u16 *)0xFFC03B90);
		debugfs_create_x16("USB_EP_NI6_RXCSR", 0600, parent, (u16 *)0xFFC03B8C);
		debugfs_create_x16("USB_EP_NI6_RXINTERVAL", 0600, parent, (u16 *)0xFFC03BA0);
		debugfs_create_x16("USB_EP_NI6_RXMAXP", 0600, parent, (u16 *)0xFFC03B88);
		debugfs_create_x16("USB_EP_NI6_RXTYPE", 0600, parent, (u16 *)0xFFC03B9C);
		debugfs_create_x16("USB_EP_NI6_TXCOUNT", 0600, parent, (u16 *)0xFFC03BA8);
		debugfs_create_x16("USB_EP_NI6_TXCSR", 0600, parent, (u16 *)0xFFC03B84);
		debugfs_create_x16("USB_EP_NI6_TXINTERVAL", 0600, parent, (u16 *)0xFFC03B98);
		debugfs_create_x16("USB_EP_NI6_TXMAXP", 0600, parent, (u16 *)0xFFC03B80);
		debugfs_create_x16("USB_EP_NI6_TXTYPE", 0600, parent, (u16 *)0xFFC03B94);
		debugfs_create_x16("USB_EP_NI7_RXCOUNT", 0600, parent, (u16 *)0xFFC03BD0);
		debugfs_create_x16("USB_EP_NI7_RXCSR", 0600, parent, (u16 *)0xFFC03BCC);
		debugfs_create_x16("USB_EP_NI7_RXINTERVAL", 0600, parent, (u16 *)0xFFC03BF0);
		debugfs_create_x16("USB_EP_NI7_RXMAXP", 0600, parent, (u16 *)0xFFC03BC8);
		debugfs_create_x16("USB_EP_NI7_RXTYPE", 0600, parent, (u16 *)0xFFC03BDC);
		debugfs_create_x16("USB_EP_NI7_TXCOUNT", 0600, parent, (u16 *)0xFFC03BF8);
		debugfs_create_x16("USB_EP_NI7_TXCSR", 0600, parent, (u16 *)0xFFC03BC4);
		debugfs_create_x16("USB_EP_NI7_TXINTERVAL", 0600, parent, (u16 *)0xFFC03BD8);
		debugfs_create_x16("USB_EP_NI7_TXMAXP", 0600, parent, (u16 *)0xFFC03BC0);
		debugfs_create_x16("USB_EP_NI7_TXTYPE", 0600, parent, (u16 *)0xFFC03BD4);
		debugfs_create_x16("USB_FADDR", 0600, parent, (u16 *)0xFFC03800);
		debugfs_create_x16("USB_FRAME", 0600, parent, (u16 *)0xFFC03820);
		debugfs_create_x16("USB_FS_EOF1", 0600, parent, (u16 *)0xFFC03954);
		debugfs_create_x16("USB_GLOBAL_CTL", 0600, parent, (u16 *)0xFFC03830);
		debugfs_create_x16("USB_GLOBINTR", 0600, parent, (u16 *)0xFFC0382C);
		debugfs_create_x16("USB_HS_EOF1", 0600, parent, (u16 *)0xFFC03950);
		debugfs_create_x16("USB_INDEX", 0600, parent, (u16 *)0xFFC03824);
		debugfs_create_x16("USB_INTRRX", 0600, parent, (u16 *)0xFFC0380C);
		debugfs_create_x16("USB_INTRRXE", 0600, parent, (u16 *)0xFFC03814);
		debugfs_create_x16("USB_INTRTX", 0600, parent, (u16 *)0xFFC03808);
		debugfs_create_x16("USB_INTRTXE", 0600, parent, (u16 *)0xFFC03810);
		debugfs_create_x16("USB_INTRUSB", 0600, parent, (u16 *)0xFFC03818);
		debugfs_create_x16("USB_INTRUSBE", 0600, parent, (u16 *)0xFFC0381C);
		debugfs_create_x16("USB_LINKINFO", 0600, parent, (u16 *)0xFFC03948);
		debugfs_create_x16("USB_LS_EOF1", 0600, parent, (u16 *)0xFFC03958);
		debugfs_create_x16("USB_NAKLIMIT0", 0600, parent, (u16 *)0xFFC03858);
		debugfs_create_x16("USB_OTG_DEV_CTL", 0600, parent, (u16 *)0xFFC03900);
		debugfs_create_x16("USB_OTG_VBUS_IRQ", 0600, parent, (u16 *)0xFFC03904);
		debugfs_create_x16("USB_OTG_VBUS_MASK", 0600, parent, (u16 *)0xFFC03908);
		debugfs_create_x16("USB_PHY_TEST", 0600, parent, (u16 *)0xFFC039EC);
		debugfs_create_x16("USB_PLLOSC_CTRL", 0600, parent, (u16 *)0xFFC039F0);
		debugfs_create_x16("USB_POWER", 0600, parent, (u16 *)0xFFC03804);
		debugfs_create_x16("USB_RXCOUNT", 0600, parent, (u16 *)0xFFC03850);
		debugfs_create_x16("USB_RXCSR", 0600, parent, (u16 *)0xFFC0384C);
		debugfs_create_x16("USB_RXINTERVAL", 0600, parent, (u16 *)0xFFC03860);
		debugfs_create_x16("USB_RXTYPE", 0600, parent, (u16 *)0xFFC0385C);
		debugfs_create_x16("USB_RX_MAX_PACKET", 0600, parent, (u16 *)0xFFC03848);
		debugfs_create_x16("USB_SRP_CLKDIV", 0600, parent, (u16 *)0xFFC039F4);
		debugfs_create_x16("USB_TESTMODE", 0600, parent, (u16 *)0xFFC03828);
		debugfs_create_x16("USB_TXCOUNT", 0600, parent, (u16 *)0xFFC03868);
		debugfs_create_x16("USB_TXCSR", 0600, parent, (u16 *)0xFFC03844);
		debugfs_create_x16("USB_TXINTERVAL", 0600, parent, (u16 *)0xFFC03858);
		debugfs_create_x16("USB_TXTYPE", 0600, parent, (u16 *)0xFFC03854);
		debugfs_create_x16("USB_TX_MAX_PACKET", 0600, parent, (u16 *)0xFFC03840);
		debugfs_create_x16("USB_VPLEN", 0600, parent, (u16 *)0xFFC0394C);

		parent = debugfs_create_dir("Watchdog", top);
		debugfs_create_x32("WDOG_CNT", 0600, parent, (u32 *)0xFFC00204);
		debugfs_create_x16("WDOG_CTL", 0600, parent, (u16 *)0xFFC00200);
		debugfs_create_x32("WDOG_STAT", 0600, parent, (u32 *)0xFFC00208);

		parent = debugfs_create_dir("Watchpoint and Patch Unit", top);
		debugfs_create_x32("WPDA0", 0600, parent, (u32 *)0xFFE07140);
		debugfs_create_x32("WPDA1", 0600, parent, (u32 *)0xFFE07144);
		debugfs_create_x32("WPDACNT0", 0600, parent, (u32 *)0xFFE07180);
		debugfs_create_x32("WPDACNT1", 0600, parent, (u32 *)0xFFE07184);
		debugfs_create_x32("WPDACTL", 0600, parent, (u32 *)0xFFE07100);
		debugfs_create_x32("WPIA0", 0600, parent, (u32 *)0xFFE07040);
		debugfs_create_x32("WPIA1", 0600, parent, (u32 *)0xFFE07044);
		debugfs_create_x32("WPIA2", 0600, parent, (u32 *)0xFFE07048);
		debugfs_create_x32("WPIA3", 0600, parent, (u32 *)0xFFE0704C);
		debugfs_create_x32("WPIA4", 0600, parent, (u32 *)0xFFE07050);
		debugfs_create_x32("WPIA5", 0600, parent, (u32 *)0xFFE07054);
		debugfs_create_x32("WPIACNT0", 0600, parent, (u32 *)0xFFE07080);
		debugfs_create_x32("WPIACNT1", 0600, parent, (u32 *)0xFFE07084);
		debugfs_create_x32("WPIACNT2", 0600, parent, (u32 *)0xFFE07088);
		debugfs_create_x32("WPIACNT3", 0600, parent, (u32 *)0xFFE0708C);
		debugfs_create_x32("WPIACNT4", 0600, parent, (u32 *)0xFFE07090);
		debugfs_create_x32("WPIACNT5", 0600, parent, (u32 *)0xFFE07094);
		debugfs_create_x32("WPIACTL", 0600, parent, (u32 *)0xFFE07000);
		debugfs_create_x32("WPSTAT", 0600, parent, (u32 *)0xFFE07200);

	}	/* BF527 */

#ifdef __ADSPBF531__
# define USE_BF531 1
#else
# define USE_BF531 0
#endif
	if (USE_BF531) {

		parent = debugfs_create_dir("Core Timer Register File", top);
		debugfs_create_x32("TCNTL", 0600, parent, (u32 *)0xFFE03000);
		debugfs_create_x32("TCOUNT", 0600, parent, (u32 *)0xFFE0300C);
		debugfs_create_x32("TPERIOD", 0600, parent, (u32 *)0xFFE03004);
		debugfs_create_x32("TSCALE", 0600, parent, (u32 *)0xFFE03008);

		parent = debugfs_create_dir("DMA Traffic Control", top);
		debugfs_create_x16("DMA_TC_CNT", 0600, parent, (u16 *)0xFFC00B0C);
		debugfs_create_x16("DMA_TC_PER", 0600, parent, (u16 *)0xFFC00B10);

		parent = debugfs_create_dir("DMAFlex Ch-0 Registers", top);
		debugfs_create_x32("DMA0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C24);
		debugfs_create_x32("DMA0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C20);
		debugfs_create_x32("DMA0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C00);
		debugfs_create_x32("DMA0_START_ADDR", 0600, parent, (u32 *)0xFFC00C04);
		debugfs_create_x16("DMAFLX0_CURXCOUNT", 0600, parent, (u16 *)0xFFC00C30);
		debugfs_create_x16("DMAFLX0_CURYCOUNT", 0600, parent, (u16 *)0xFFC00C38);
		debugfs_create_x16("DMAFLX0_DMACNFG", 0600, parent, (u16 *)0xFFC00C08);
		debugfs_create_x16("DMAFLX0_IRQSTAT", 0600, parent, (u16 *)0xFFC00C28);
		debugfs_create_x16("DMAFLX0_PMAP", 0600, parent, (u16 *)0xFFC00C2C);
		debugfs_create_x16("DMAFLX0_XCOUNT", 0600, parent, (u16 *)0xFFC00C10);
		debugfs_create_x16("DMAFLX0_XMODIFY", 0600, parent, (u16 *)0xFFC00C14);
		debugfs_create_x16("DMAFLX0_YCOUNT", 0600, parent, (u16 *)0xFFC00C18);
		debugfs_create_x16("DMAFLX0_YMODIFY", 0600, parent, (u16 *)0xFFC00C1C);

		parent = debugfs_create_dir("DMAFlex Ch-1 Registers", top);
		debugfs_create_x32("DMA1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C64);
		debugfs_create_x32("DMA1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C60);
		debugfs_create_x32("DMA1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C40);
		debugfs_create_x32("DMA1_START_ADDR", 0600, parent, (u32 *)0xFFC00C44);
		debugfs_create_x16("DMAFLX1_CURXCOUNT", 0600, parent, (u16 *)0xFFC00C70);
		debugfs_create_x16("DMAFLX1_CURYCOUNT", 0600, parent, (u16 *)0xFFC00C78);
		debugfs_create_x16("DMAFLX1_DMACNFG", 0600, parent, (u16 *)0xFFC00C48);
		debugfs_create_x16("DMAFLX1_IRQSTAT", 0600, parent, (u16 *)0xFFC00C68);
		debugfs_create_x16("DMAFLX1_PMAP", 0600, parent, (u16 *)0xFFC00C6C);
		debugfs_create_x16("DMAFLX1_XCOUNT", 0600, parent, (u16 *)0xFFC00C50);
		debugfs_create_x16("DMAFLX1_XMODIFY", 0600, parent, (u16 *)0xFFC00C54);
		debugfs_create_x16("DMAFLX1_YCOUNT", 0600, parent, (u16 *)0xFFC00C58);
		debugfs_create_x16("DMAFLX1_YMODIFY", 0600, parent, (u16 *)0xFFC00C5C);

		parent = debugfs_create_dir("DMAFlex Ch-2 Registers", top);
		debugfs_create_x32("DMA2_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CA4);
		debugfs_create_x32("DMA2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CA0);
		debugfs_create_x32("DMA2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C80);
		debugfs_create_x32("DMA2_START_ADDR", 0600, parent, (u32 *)0xFFC00C84);
		debugfs_create_x16("DMAFLX2_CURXCOUNT", 0600, parent, (u16 *)0xFFC00CB0);
		debugfs_create_x16("DMAFLX2_CURYCOUNT", 0600, parent, (u16 *)0xFFC00CB8);
		debugfs_create_x16("DMAFLX2_DMACNFG", 0600, parent, (u16 *)0xFFC00C88);
		debugfs_create_x16("DMAFLX2_IRQSTAT", 0600, parent, (u16 *)0xFFC00CA8);
		debugfs_create_x16("DMAFLX2_PMAP", 0600, parent, (u16 *)0xFFC00CAC);
		debugfs_create_x16("DMAFLX2_XCOUNT", 0600, parent, (u16 *)0xFFC00C90);
		debugfs_create_x16("DMAFLX2_XMODIFY", 0600, parent, (u16 *)0xFFC00C94);
		debugfs_create_x16("DMAFLX2_YCOUNT", 0600, parent, (u16 *)0xFFC00C98);
		debugfs_create_x16("DMAFLX2_YMODIFY", 0600, parent, (u16 *)0xFFC00C9C);

		parent = debugfs_create_dir("DMAFlex Ch-3 Registers", top);
		debugfs_create_x32("DMA3_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CE4);
		debugfs_create_x32("DMA3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CE0);
		debugfs_create_x32("DMA3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00CC0);
		debugfs_create_x32("DMA3_START_ADDR", 0600, parent, (u32 *)0xFFC00CC4);
		debugfs_create_x16("DMAFLX3_CURXCOUNT", 0600, parent, (u16 *)0xFFC00CF0);
		debugfs_create_x16("DMAFLX3_CURYCOUNT", 0600, parent, (u16 *)0xFFC00CF8);
		debugfs_create_x16("DMAFLX3_DMACNFG", 0600, parent, (u16 *)0xFFC00CC8);
		debugfs_create_x16("DMAFLX3_IRQSTAT", 0600, parent, (u16 *)0xFFC00CE8);
		debugfs_create_x16("DMAFLX3_PMAP", 0600, parent, (u16 *)0xFFC00CEC);
		debugfs_create_x16("DMAFLX3_XCOUNT", 0600, parent, (u16 *)0xFFC00CD0);
		debugfs_create_x16("DMAFLX3_XMODIFY", 0600, parent, (u16 *)0xFFC00CD4);
		debugfs_create_x16("DMAFLX3_YCOUNT", 0600, parent, (u16 *)0xFFC00CD8);
		debugfs_create_x16("DMAFLX3_YMODIFY", 0600, parent, (u16 *)0xFFC00CDC);

		parent = debugfs_create_dir("DMAFlex Ch-4 Registers", top);
		debugfs_create_x32("DMA4_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D24);
		debugfs_create_x32("DMA4_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D20);
		debugfs_create_x32("DMA4_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D00);
		debugfs_create_x32("DMA4_START_ADDR", 0600, parent, (u32 *)0xFFC00D04);
		debugfs_create_x16("DMAFLX4_CURXCOUNT", 0600, parent, (u16 *)0xFFC00D30);
		debugfs_create_x16("DMAFLX4_CURYCOUNT", 0600, parent, (u16 *)0xFFC00D38);
		debugfs_create_x16("DMAFLX4_DMACNFG", 0600, parent, (u16 *)0xFFC00D08);
		debugfs_create_x16("DMAFLX4_IRQSTAT", 0600, parent, (u16 *)0xFFC00D28);
		debugfs_create_x16("DMAFLX4_PMAP", 0600, parent, (u16 *)0xFFC00D2C);
		debugfs_create_x16("DMAFLX4_XCOUNT", 0600, parent, (u16 *)0xFFC00D10);
		debugfs_create_x16("DMAFLX4_XMODIFY", 0600, parent, (u16 *)0xFFC00D14);
		debugfs_create_x16("DMAFLX4_YCOUNT", 0600, parent, (u16 *)0xFFC00D18);
		debugfs_create_x16("DMAFLX4_YMODIFY", 0600, parent, (u16 *)0xFFC00D1C);

		parent = debugfs_create_dir("DMAFlex Ch-5 Registers", top);
		debugfs_create_x32("DMA5_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D64);
		debugfs_create_x32("DMA5_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D60);
		debugfs_create_x32("DMA5_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D40);
		debugfs_create_x32("DMA5_START_ADDR", 0600, parent, (u32 *)0xFFC00D44);
		debugfs_create_x16("DMAFLX5_CURXCOUNT", 0600, parent, (u16 *)0xFFC00D70);
		debugfs_create_x16("DMAFLX5_CURYCOUNT", 0600, parent, (u16 *)0xFFC00D78);
		debugfs_create_x16("DMAFLX5_DMACNFG", 0600, parent, (u16 *)0xFFC00D48);
		debugfs_create_x16("DMAFLX5_IRQSTAT", 0600, parent, (u16 *)0xFFC00D68);
		debugfs_create_x16("DMAFLX5_PMAP", 0600, parent, (u16 *)0xFFC00D6C);
		debugfs_create_x16("DMAFLX5_XCOUNT", 0600, parent, (u16 *)0xFFC00D50);
		debugfs_create_x16("DMAFLX5_XMODIFY", 0600, parent, (u16 *)0xFFC00D54);
		debugfs_create_x16("DMAFLX5_YCOUNT", 0600, parent, (u16 *)0xFFC00D58);
		debugfs_create_x16("DMAFLX5_YMODIFY", 0600, parent, (u16 *)0xFFC00D5C);

		parent = debugfs_create_dir("DMAFlex Ch-6 Registers", top);
		debugfs_create_x32("DMA6_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DA4);
		debugfs_create_x32("DMA6_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DA0);
		debugfs_create_x32("DMA6_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D80);
		debugfs_create_x32("DMA6_START_ADDR", 0600, parent, (u32 *)0xFFC00D84);
		debugfs_create_x16("DMAFLX6_CURXCOUNT", 0600, parent, (u16 *)0xFFC00DB0);
		debugfs_create_x16("DMAFLX6_CURYCOUNT", 0600, parent, (u16 *)0xFFC00DB8);
		debugfs_create_x16("DMAFLX6_DMACNFG", 0600, parent, (u16 *)0xFFC00D88);
		debugfs_create_x16("DMAFLX6_IRQSTAT", 0600, parent, (u16 *)0xFFC00DA8);
		debugfs_create_x16("DMAFLX6_PMAP", 0600, parent, (u16 *)0xFFC00DAC);
		debugfs_create_x16("DMAFLX6_XCOUNT", 0600, parent, (u16 *)0xFFC00D90);
		debugfs_create_x16("DMAFLX6_XMODIFY", 0600, parent, (u16 *)0xFFC00D94);
		debugfs_create_x16("DMAFLX6_YCOUNT", 0600, parent, (u16 *)0xFFC00D98);
		debugfs_create_x16("DMAFLX6_YMODIFY", 0600, parent, (u16 *)0xFFC00D9C);

		parent = debugfs_create_dir("DMAFlex Ch-7 Registers", top);
		debugfs_create_x32("DMA7_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DE4);
		debugfs_create_x32("DMA7_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DE0);
		debugfs_create_x32("DMA7_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00DC0);
		debugfs_create_x32("DMA7_START_ADDR", 0600, parent, (u32 *)0xFFC00DC4);
		debugfs_create_x16("DMAFLX7_CURXCOUNT", 0600, parent, (u16 *)0xFFC00DF0);
		debugfs_create_x16("DMAFLX7_CURYCOUNT", 0600, parent, (u16 *)0xFFC00DF8);
		debugfs_create_x16("DMAFLX7_DMACNFG", 0600, parent, (u16 *)0xFFC00DC8);
		debugfs_create_x16("DMAFLX7_IRQSTAT", 0600, parent, (u16 *)0xFFC00DE8);
		debugfs_create_x16("DMAFLX7_PMAP", 0600, parent, (u16 *)0xFFC00DEC);
		debugfs_create_x16("DMAFLX7_XCOUNT", 0600, parent, (u16 *)0xFFC00DD0);
		debugfs_create_x16("DMAFLX7_XMODIFY", 0600, parent, (u16 *)0xFFC00DD4);
		debugfs_create_x16("DMAFLX7_YCOUNT", 0600, parent, (u16 *)0xFFC00DD8);
		debugfs_create_x16("DMAFLX7_YMODIFY", 0600, parent, (u16 *)0xFFC00DDC);

		parent = debugfs_create_dir("Data Cache Programmable Look-Aside Buffer Fault Address", top);
		debugfs_create_x32("DCPLB_FAULT_STATUS", 0600, parent, (u32 *)0xFFE00008);

		parent = debugfs_create_dir("EBIU", top);
		debugfs_create_x32("EBIU_AMBCTL0", 0600, parent, (u32 *)0xFFC00A04);
		debugfs_create_x32("EBIU_AMBCTL1", 0600, parent, (u32 *)0xFFC00A08);
		debugfs_create_x16("EBIU_AMGCTL", 0600, parent, (u16 *)0xFFC00A00);
		debugfs_create_x16("EBIU_SDBCTL", 0600, parent, (u16 *)0xFFC00A14);
		debugfs_create_x32("EBIU_SDGCTL", 0600, parent, (u32 *)0xFFC00A10);
		debugfs_create_x16("EBIU_SDRRC", 0600, parent, (u16 *)0xFFC00A18);
		debugfs_create_x16("EBIU_SDSTAT", 0600, parent, (u16 *)0xFFC00A1C);

		parent = debugfs_create_dir("Event Vectors", top);
		debugfs_create_x32("EVT0", 0600, parent, (u32 *)0xFFE02000);
		debugfs_create_x32("EVT10", 0600, parent, (u32 *)0xFFE02028);
		debugfs_create_x32("EVT11", 0600, parent, (u32 *)0xFFE0202C);
		debugfs_create_x32("EVT12", 0600, parent, (u32 *)0xFFE02030);
		debugfs_create_x32("EVT13", 0600, parent, (u32 *)0xFFE02034);
		debugfs_create_x32("EVT14", 0600, parent, (u32 *)0xFFE02038);
		debugfs_create_x32("EVT15", 0600, parent, (u32 *)0xFFE0203C);
		debugfs_create_x32("EVT1", 0600, parent, (u32 *)0xFFE02004);
		debugfs_create_x32("EVT2", 0600, parent, (u32 *)0xFFE02008);
		debugfs_create_x32("EVT3", 0600, parent, (u32 *)0xFFE0200C);
		debugfs_create_x32("EVT4", 0600, parent, (u32 *)0xFFE02010);
		debugfs_create_x32("EVT5", 0600, parent, (u32 *)0xFFE02014);
		debugfs_create_x32("EVT6", 0600, parent, (u32 *)0xFFE02018);
		debugfs_create_x32("EVT7", 0600, parent, (u32 *)0xFFE0201C);
		debugfs_create_x32("EVT8", 0600, parent, (u32 *)0xFFE02020);
		debugfs_create_x32("EVT9", 0600, parent, (u32 *)0xFFE02024);

		parent = debugfs_create_dir("Extended Registers", top);
		debugfs_create_x32("CHIPID", 0600, parent, (u32 *)0xFFC00014);
		debugfs_create_x16("DMA0_CONFIG", 0600, parent, (u16 *)0xFFC00C08);
		debugfs_create_x16("DMA0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C30);
		debugfs_create_x16("DMA0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C38);
		debugfs_create_x16("DMA0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C28);
		debugfs_create_x16("DMA0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C2C);
		debugfs_create_x16("DMA0_X_COUNT", 0600, parent, (u16 *)0xFFC00C10);
		debugfs_create_x16("DMA0_X_MODIFY", 0600, parent, (u16 *)0xFFC00C14);
		debugfs_create_x16("DMA0_Y_COUNT", 0600, parent, (u16 *)0xFFC00C18);
		debugfs_create_x16("DMA0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C1C);
		debugfs_create_x16("DMA1_CONFIG", 0600, parent, (u16 *)0xFFC00C48);
		debugfs_create_x16("DMA1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C70);
		debugfs_create_x16("DMA1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C78);
		debugfs_create_x16("DMA1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C68);
		debugfs_create_x16("DMA1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C6C);
		debugfs_create_x16("DMA1_X_COUNT", 0600, parent, (u16 *)0xFFC00C50);
		debugfs_create_x16("DMA1_X_MODIFY", 0600, parent, (u16 *)0xFFC00C54);
		debugfs_create_x16("DMA1_Y_COUNT", 0600, parent, (u16 *)0xFFC00C58);
		debugfs_create_x16("DMA1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C5C);
		debugfs_create_x16("DMA2_CONFIG", 0600, parent, (u16 *)0xFFC00C88);
		debugfs_create_x16("DMA2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CB0);
		debugfs_create_x16("DMA2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CB8);
		debugfs_create_x16("DMA2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CA8);
		debugfs_create_x16("DMA2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CAC);
		debugfs_create_x16("DMA2_X_COUNT", 0600, parent, (u16 *)0xFFC00C90);
		debugfs_create_x16("DMA2_X_MODIFY", 0600, parent, (u16 *)0xFFC00C94);
		debugfs_create_x16("DMA2_Y_COUNT", 0600, parent, (u16 *)0xFFC00C98);
		debugfs_create_x16("DMA2_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C9C);
		debugfs_create_x16("DMA3_CONFIG", 0600, parent, (u16 *)0xFFC00CC8);
		debugfs_create_x16("DMA3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CF0);
		debugfs_create_x16("DMA3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CF8);
		debugfs_create_x16("DMA3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CE8);
		debugfs_create_x16("DMA3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CEC);
		debugfs_create_x16("DMA3_X_COUNT", 0600, parent, (u16 *)0xFFC00CD0);
		debugfs_create_x16("DMA3_X_MODIFY", 0600, parent, (u16 *)0xFFC00CD4);
		debugfs_create_x16("DMA3_Y_COUNT", 0600, parent, (u16 *)0xFFC00CD8);
		debugfs_create_x16("DMA3_Y_MODIFY", 0600, parent, (u16 *)0xFFC00CDC);
		debugfs_create_x16("DMA4_CONFIG", 0600, parent, (u16 *)0xFFC00D08);
		debugfs_create_x16("DMA4_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D30);
		debugfs_create_x16("DMA4_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D38);
		debugfs_create_x16("DMA4_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D28);
		debugfs_create_x16("DMA4_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D2C);
		debugfs_create_x16("DMA4_X_COUNT", 0600, parent, (u16 *)0xFFC00D10);
		debugfs_create_x16("DMA4_X_MODIFY", 0600, parent, (u16 *)0xFFC00D14);
		debugfs_create_x16("DMA4_Y_COUNT", 0600, parent, (u16 *)0xFFC00D18);
		debugfs_create_x16("DMA4_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D1C);
		debugfs_create_x16("DMA5_CONFIG", 0600, parent, (u16 *)0xFFC00D48);
		debugfs_create_x16("DMA5_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D70);
		debugfs_create_x16("DMA5_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D78);
		debugfs_create_x16("DMA5_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D68);
		debugfs_create_x16("DMA5_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D6C);
		debugfs_create_x16("DMA5_X_COUNT", 0600, parent, (u16 *)0xFFC00D50);
		debugfs_create_x16("DMA5_X_MODIFY", 0600, parent, (u16 *)0xFFC00D54);
		debugfs_create_x16("DMA5_Y_COUNT", 0600, parent, (u16 *)0xFFC00D58);
		debugfs_create_x16("DMA5_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D5C);
		debugfs_create_x16("DMA6_CONFIG", 0600, parent, (u16 *)0xFFC00D88);
		debugfs_create_x16("DMA6_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DB0);
		debugfs_create_x16("DMA6_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DB8);
		debugfs_create_x16("DMA6_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DA8);
		debugfs_create_x16("DMA6_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DAC);
		debugfs_create_x16("DMA6_X_COUNT", 0600, parent, (u16 *)0xFFC00D90);
		debugfs_create_x16("DMA6_X_MODIFY", 0600, parent, (u16 *)0xFFC00D94);
		debugfs_create_x16("DMA6_Y_COUNT", 0600, parent, (u16 *)0xFFC00D98);
		debugfs_create_x16("DMA6_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D9C);
		debugfs_create_x16("DMA7_CONFIG", 0600, parent, (u16 *)0xFFC00DC8);
		debugfs_create_x16("DMA7_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DF0);
		debugfs_create_x16("DMA7_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DF8);
		debugfs_create_x16("DMA7_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DE8);
		debugfs_create_x16("DMA7_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DEC);
		debugfs_create_x16("DMA7_X_COUNT", 0600, parent, (u16 *)0xFFC00DD0);
		debugfs_create_x16("DMA7_X_MODIFY", 0600, parent, (u16 *)0xFFC00DD4);
		debugfs_create_x16("DMA7_Y_COUNT", 0600, parent, (u16 *)0xFFC00DD8);
		debugfs_create_x16("DMA7_Y_MODIFY", 0600, parent, (u16 *)0xFFC00DDC);
		debugfs_create_x32("DSPID", 0600, parent, (u32 *)0xFFE05000);
		debugfs_create_x32("EVT_OVERRIDE", 0600, parent, (u32 *)0xFFE02100);
		debugfs_create_x16("FIO_BOTH", 0600, parent, (u16 *)0xFFC0073C);
		debugfs_create_x16("FIO_DIR", 0600, parent, (u16 *)0xFFC00730);
		debugfs_create_x16("FIO_EDGE", 0600, parent, (u16 *)0xFFC00738);
		debugfs_create_x16("FIO_FLAG_C", 0600, parent, (u16 *)0xFFC00704);
		debugfs_create_x16("FIO_FLAG_D", 0600, parent, (u16 *)0xFFC00700);
		debugfs_create_x16("FIO_FLAG_S", 0600, parent, (u16 *)0xFFC00708);
		debugfs_create_x16("FIO_FLAG_T", 0600, parent, (u16 *)0xFFC0070C);
		debugfs_create_x16("FIO_INEN", 0600, parent, (u16 *)0xFFC00740);
		debugfs_create_x16("FIO_MASKA_C", 0600, parent, (u16 *)0xFFC00714);
		debugfs_create_x16("FIO_MASKA_D", 0600, parent, (u16 *)0xFFC00710);
		debugfs_create_x16("FIO_MASKA_S", 0600, parent, (u16 *)0xFFC00718);
		debugfs_create_x16("FIO_MASKA_T", 0600, parent, (u16 *)0xFFC0071C);
		debugfs_create_x16("FIO_MASKB_C", 0600, parent, (u16 *)0xFFC00724);
		debugfs_create_x16("FIO_MASKB_D", 0600, parent, (u16 *)0xFFC00720);
		debugfs_create_x16("FIO_MASKB_S", 0600, parent, (u16 *)0xFFC00728);
		debugfs_create_x16("FIO_MASKB_T", 0600, parent, (u16 *)0xFFC0072C);
		debugfs_create_x16("FIO_POLAR", 0600, parent, (u16 *)0xFFC00734);

		parent = debugfs_create_dir("Interrupt Controller", top);
		debugfs_create_x32("ILAT", 0600, parent, (u32 *)0xFFE0210C);
		debugfs_create_x32("IMASK", 0600, parent, (u32 *)0xFFE02104);
		debugfs_create_x32("IPEND", 0600, parent, (u32 *)0xFFE02108);
		debugfs_create_x32("IPRIO", 0600, parent, (u32 *)0xFFE02110);

		parent = debugfs_create_dir("L1 Code Memory Registers", top);
		debugfs_create_x32("ICPLB_ADDR0", 0600, parent, (u32 *)0xFFE01100);
		debugfs_create_x32("ICPLB_ADDR10", 0600, parent, (u32 *)0xFFE01128);
		debugfs_create_x32("ICPLB_ADDR11", 0600, parent, (u32 *)0xFFE0112C);
		debugfs_create_x32("ICPLB_ADDR12", 0600, parent, (u32 *)0xFFE01130);
		debugfs_create_x32("ICPLB_ADDR13", 0600, parent, (u32 *)0xFFE01134);
		debugfs_create_x32("ICPLB_ADDR14", 0600, parent, (u32 *)0xFFE01138);
		debugfs_create_x32("ICPLB_ADDR15", 0600, parent, (u32 *)0xFFE0113C);
		debugfs_create_x32("ICPLB_ADDR1", 0600, parent, (u32 *)0xFFE01104);
		debugfs_create_x32("ICPLB_ADDR2", 0600, parent, (u32 *)0xFFE01108);
		debugfs_create_x32("ICPLB_ADDR3", 0600, parent, (u32 *)0xFFE0110C);
		debugfs_create_x32("ICPLB_ADDR4", 0600, parent, (u32 *)0xFFE01110);
		debugfs_create_x32("ICPLB_ADDR5", 0600, parent, (u32 *)0xFFE01114);
		debugfs_create_x32("ICPLB_ADDR6", 0600, parent, (u32 *)0xFFE01118);
		debugfs_create_x32("ICPLB_ADDR7", 0600, parent, (u32 *)0xFFE0111C);
		debugfs_create_x32("ICPLB_ADDR8", 0600, parent, (u32 *)0xFFE01120);
		debugfs_create_x32("ICPLB_ADDR9", 0600, parent, (u32 *)0xFFE01124);
		debugfs_create_x32("ICPLB_DATA0", 0600, parent, (u32 *)0xFFE01200);
		debugfs_create_x32("ICPLB_DATA10", 0600, parent, (u32 *)0xFFE01228);
		debugfs_create_x32("ICPLB_DATA11", 0600, parent, (u32 *)0xFFE0122C);
		debugfs_create_x32("ICPLB_DATA12", 0600, parent, (u32 *)0xFFE01230);
		debugfs_create_x32("ICPLB_DATA13", 0600, parent, (u32 *)0xFFE01234);
		debugfs_create_x32("ICPLB_DATA14", 0600, parent, (u32 *)0xFFE01238);
		debugfs_create_x32("ICPLB_DATA15", 0600, parent, (u32 *)0xFFE0123C);
		debugfs_create_x32("ICPLB_DATA1", 0600, parent, (u32 *)0xFFE01204);
		debugfs_create_x32("ICPLB_DATA2", 0600, parent, (u32 *)0xFFE01208);
		debugfs_create_x32("ICPLB_DATA3", 0600, parent, (u32 *)0xFFE0120C);
		debugfs_create_x32("ICPLB_DATA4", 0600, parent, (u32 *)0xFFE01210);
		debugfs_create_x32("ICPLB_DATA5", 0600, parent, (u32 *)0xFFE01214);
		debugfs_create_x32("ICPLB_DATA6", 0600, parent, (u32 *)0xFFE01218);
		debugfs_create_x32("ICPLB_DATA7", 0600, parent, (u32 *)0xFFE0121C);
		debugfs_create_x32("ICPLB_DATA8", 0600, parent, (u32 *)0xFFE01220);
		debugfs_create_x32("ICPLB_DATA9", 0600, parent, (u32 *)0xFFE01224);
		debugfs_create_x32("ICPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0100C);
		debugfs_create_x32("ICPLB_FAULT_STATUS", 0600, parent, (u32 *)0xFFE01008);
		debugfs_create_x32("IMEM_CONTROL", 0600, parent, (u32 *)0xFFE01004);
		debugfs_create_x32("ITEST_COMMAND", 0600, parent, (u32 *)0xFFE01300);
		debugfs_create_x32("ITEST_DATA0", 0600, parent, (u32 *)0xFFE01400);
		debugfs_create_x32("ITEST_DATA1", 0600, parent, (u32 *)0xFFE01404);

		parent = debugfs_create_dir("L1 Data Memory Registers", top);
		debugfs_create_x32("DCPLB_ADDR0", 0600, parent, (u32 *)0xFFE00100);
		debugfs_create_x32("DCPLB_ADDR10", 0600, parent, (u32 *)0xFFE00128);
		debugfs_create_x32("DCPLB_ADDR11", 0600, parent, (u32 *)0xFFE0012C);
		debugfs_create_x32("DCPLB_ADDR12", 0600, parent, (u32 *)0xFFE00130);
		debugfs_create_x32("DCPLB_ADDR13", 0600, parent, (u32 *)0xFFE00134);
		debugfs_create_x32("DCPLB_ADDR14", 0600, parent, (u32 *)0xFFE00138);
		debugfs_create_x32("DCPLB_ADDR15", 0600, parent, (u32 *)0xFFE0013C);
		debugfs_create_x32("DCPLB_ADDR1", 0600, parent, (u32 *)0xFFE00104);
		debugfs_create_x32("DCPLB_ADDR2", 0600, parent, (u32 *)0xFFE00108);
		debugfs_create_x32("DCPLB_ADDR3", 0600, parent, (u32 *)0xFFE0010C);
		debugfs_create_x32("DCPLB_ADDR4", 0600, parent, (u32 *)0xFFE00110);
		debugfs_create_x32("DCPLB_ADDR5", 0600, parent, (u32 *)0xFFE00114);
		debugfs_create_x32("DCPLB_ADDR6", 0600, parent, (u32 *)0xFFE00118);
		debugfs_create_x32("DCPLB_ADDR7", 0600, parent, (u32 *)0xFFE0011C);
		debugfs_create_x32("DCPLB_ADDR8", 0600, parent, (u32 *)0xFFE00120);
		debugfs_create_x32("DCPLB_ADDR9", 0600, parent, (u32 *)0xFFE00124);
		debugfs_create_x32("DCPLB_DATA0", 0600, parent, (u32 *)0xFFE00200);
		debugfs_create_x32("DCPLB_DATA10", 0600, parent, (u32 *)0xFFE00228);
		debugfs_create_x32("DCPLB_DATA11", 0600, parent, (u32 *)0xFFE0022C);
		debugfs_create_x32("DCPLB_DATA12", 0600, parent, (u32 *)0xFFE00230);
		debugfs_create_x32("DCPLB_DATA13", 0600, parent, (u32 *)0xFFE00234);
		debugfs_create_x32("DCPLB_DATA14", 0600, parent, (u32 *)0xFFE00238);
		debugfs_create_x32("DCPLB_DATA15", 0600, parent, (u32 *)0xFFE0023C);
		debugfs_create_x32("DCPLB_DATA1", 0600, parent, (u32 *)0xFFE00204);
		debugfs_create_x32("DCPLB_DATA2", 0600, parent, (u32 *)0xFFE00208);
		debugfs_create_x32("DCPLB_DATA3", 0600, parent, (u32 *)0xFFE0020C);
		debugfs_create_x32("DCPLB_DATA4", 0600, parent, (u32 *)0xFFE00210);
		debugfs_create_x32("DCPLB_DATA5", 0600, parent, (u32 *)0xFFE00214);
		debugfs_create_x32("DCPLB_DATA6", 0600, parent, (u32 *)0xFFE00218);
		debugfs_create_x32("DCPLB_DATA7", 0600, parent, (u32 *)0xFFE0021C);
		debugfs_create_x32("DCPLB_DATA8", 0600, parent, (u32 *)0xFFE00220);
		debugfs_create_x32("DCPLB_DATA9", 0600, parent, (u32 *)0xFFE00224);
		debugfs_create_x32("DCPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0000C);
		debugfs_create_x32("DMEM_CONTROL", 0600, parent, (u32 *)0xFFE00004);
		debugfs_create_x32("DTEST_COMMAND", 0600, parent, (u32 *)0xFFE00300);
		debugfs_create_x32("DTEST_DATA0", 0600, parent, (u32 *)0xFFE00400);
		debugfs_create_x32("DTEST_DATA1", 0600, parent, (u32 *)0xFFE00404);
		debugfs_create_x32("SRAM_BASE_ADDR", 0600, parent, (u32 *)0xFFE00000);

		parent = debugfs_create_dir("MEMDMA0 Destination Registers", top);
		debugfs_create_x16("MDMAFLX0_CURXCOUNT_D", 0600, parent, (u16 *)0xFFC00E30);
		debugfs_create_x16("MDMAFLX0_CURYCOUNT_D", 0600, parent, (u16 *)0xFFC00E38);
		debugfs_create_x16("MDMAFLX0_DMACNFG_D", 0600, parent, (u16 *)0xFFC00E08);
		debugfs_create_x16("MDMAFLX0_IRQSTAT_D", 0600, parent, (u16 *)0xFFC00E28);
		debugfs_create_x16("MDMAFLX0_PMAP_D", 0600, parent, (u16 *)0xFFC00E2C);
		debugfs_create_x16("MDMAFLX0_XCOUNT_D", 0600, parent, (u16 *)0xFFC00E10);
		debugfs_create_x16("MDMAFLX0_XMODIFY_D", 0600, parent, (u16 *)0xFFC00E14);
		debugfs_create_x16("MDMAFLX0_YCOUNT_D", 0600, parent, (u16 *)0xFFC00E18);
		debugfs_create_x16("MDMAFLX0_YMODIFY_D", 0600, parent, (u16 *)0xFFC00E1C);
		debugfs_create_x16("MDMA_D0_CONFIG", 0600, parent, (u16 *)0xFFC00E08);
		debugfs_create_x32("MDMA_D0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E24);
		debugfs_create_x32("MDMA_D0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E20);
		debugfs_create_x16("MDMA_D0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E30);
		debugfs_create_x16("MDMA_D0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E38);
		debugfs_create_x16("MDMA_D0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E28);
		debugfs_create_x32("MDMA_D0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E00);
		debugfs_create_x16("MDMA_D0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E2C);
		debugfs_create_x32("MDMA_D0_START_ADDR", 0600, parent, (u32 *)0xFFC00E04);
		debugfs_create_x16("MDMA_D0_X_COUNT", 0600, parent, (u16 *)0xFFC00E10);
		debugfs_create_x16("MDMA_D0_X_MODIFY", 0600, parent, (u16 *)0xFFC00E14);
		debugfs_create_x16("MDMA_D0_Y_COUNT", 0600, parent, (u16 *)0xFFC00E18);
		debugfs_create_x16("MDMA_D0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E1C);

		parent = debugfs_create_dir("MEMDMA0 Source Registers", top);
		debugfs_create_x16("MDMAFLX0_CURXCOUNT_S", 0600, parent, (u16 *)0xFFC00E70);
		debugfs_create_x16("MDMAFLX0_CURYCOUNT_S", 0600, parent, (u16 *)0xFFC00E78);
		debugfs_create_x16("MDMAFLX0_DMACNFG_S", 0600, parent, (u16 *)0xFFC00E48);
		debugfs_create_x16("MDMAFLX0_IRQSTAT_S", 0600, parent, (u16 *)0xFFC00E68);
		debugfs_create_x16("MDMAFLX0_PMAP_S", 0600, parent, (u16 *)0xFFC00E6C);
		debugfs_create_x16("MDMAFLX0_XCOUNT_S", 0600, parent, (u16 *)0xFFC00E50);
		debugfs_create_x16("MDMAFLX0_XMODIFY_S", 0600, parent, (u16 *)0xFFC00E54);
		debugfs_create_x16("MDMAFLX0_YCOUNT_S", 0600, parent, (u16 *)0xFFC00E58);
		debugfs_create_x16("MDMAFLX0_YMODIFY_S", 0600, parent, (u16 *)0xFFC00E5C);
		debugfs_create_x16("MDMA_S0_CONFIG", 0600, parent, (u16 *)0xFFC00E48);
		debugfs_create_x32("MDMA_S0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E64);
		debugfs_create_x32("MDMA_S0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E60);
		debugfs_create_x16("MDMA_S0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E70);
		debugfs_create_x16("MDMA_S0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E78);
		debugfs_create_x16("MDMA_S0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E68);
		debugfs_create_x32("MDMA_S0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E40);
		debugfs_create_x16("MDMA_S0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E6C);
		debugfs_create_x32("MDMA_S0_START_ADDR", 0600, parent, (u32 *)0xFFC00E44);
		debugfs_create_x16("MDMA_S0_X_COUNT", 0600, parent, (u16 *)0xFFC00E50);
		debugfs_create_x16("MDMA_S0_X_MODIFY", 0600, parent, (u16 *)0xFFC00E54);
		debugfs_create_x16("MDMA_S0_Y_COUNT", 0600, parent, (u16 *)0xFFC00E58);
		debugfs_create_x16("MDMA_S0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E5C);

		parent = debugfs_create_dir("MEMDMA1 Destination Registers", top);
		debugfs_create_x16("MDMAFLX1_CURXCOUNT_D", 0600, parent, (u16 *)0xFFC00EB0);
		debugfs_create_x16("MDMAFLX1_CURYCOUNT_D", 0600, parent, (u16 *)0xFFC00EB8);
		debugfs_create_x16("MDMAFLX1_DMACNFG_D", 0600, parent, (u16 *)0xFFC00E88);
		debugfs_create_x16("MDMAFLX1_IRQSTAT_D", 0600, parent, (u16 *)0xFFC00EA8);
		debugfs_create_x16("MDMAFLX1_PMAP_D", 0600, parent, (u16 *)0xFFC00EAC);
		debugfs_create_x16("MDMAFLX1_XCOUNT_D", 0600, parent, (u16 *)0xFFC00E90);
		debugfs_create_x16("MDMAFLX1_XMODIFY_D", 0600, parent, (u16 *)0xFFC00E94);
		debugfs_create_x16("MDMAFLX1_YCOUNT_D", 0600, parent, (u16 *)0xFFC00E98);
		debugfs_create_x16("MDMAFLX1_YMODIFY_D", 0600, parent, (u16 *)0xFFC00E9C);
		debugfs_create_x16("MDMA_D1_CONFIG", 0600, parent, (u16 *)0xFFC00E88);
		debugfs_create_x32("MDMA_D1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EA4);
		debugfs_create_x32("MDMA_D1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EA0);
		debugfs_create_x16("MDMA_D1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EB0);
		debugfs_create_x16("MDMA_D1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EB8);
		debugfs_create_x16("MDMA_D1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EA8);
		debugfs_create_x32("MDMA_D1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E80);
		debugfs_create_x16("MDMA_D1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EAC);
		debugfs_create_x32("MDMA_D1_START_ADDR", 0600, parent, (u32 *)0xFFC00E84);
		debugfs_create_x16("MDMA_D1_X_COUNT", 0600, parent, (u16 *)0xFFC00E90);
		debugfs_create_x16("MDMA_D1_X_MODIFY", 0600, parent, (u16 *)0xFFC00E94);
		debugfs_create_x16("MDMA_D1_Y_COUNT", 0600, parent, (u16 *)0xFFC00E98);
		debugfs_create_x16("MDMA_D1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E9C);

		parent = debugfs_create_dir("MEMDMA1 Source Registers", top);
		debugfs_create_x16("MDMAFLX1_CURXCOUNT_S", 0600, parent, (u16 *)0xFFC00EF0);
		debugfs_create_x16("MDMAFLX1_CURYCOUNT_S", 0600, parent, (u16 *)0xFFC00EF8);
		debugfs_create_x16("MDMAFLX1_DMACNFG_S", 0600, parent, (u16 *)0xFFC00EC8);
		debugfs_create_x16("MDMAFLX1_IRQSTAT_S", 0600, parent, (u16 *)0xFFC00EE8);
		debugfs_create_x16("MDMAFLX1_PMAP_S", 0600, parent, (u16 *)0xFFC00EEC);
		debugfs_create_x16("MDMAFLX1_XCOUNT_S", 0600, parent, (u16 *)0xFFC00ED0);
		debugfs_create_x16("MDMAFLX1_XMODIFY_S", 0600, parent, (u16 *)0xFFC00ED4);
		debugfs_create_x16("MDMAFLX1_YCOUNT_S", 0600, parent, (u16 *)0xFFC00ED8);
		debugfs_create_x16("MDMAFLX1_YMODIFY_S", 0600, parent, (u16 *)0xFFC00EDC);
		debugfs_create_x16("MDMA_S1_CONFIG", 0600, parent, (u16 *)0xFFC00EC8);
		debugfs_create_x32("MDMA_S1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EE4);
		debugfs_create_x32("MDMA_S1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EE0);
		debugfs_create_x16("MDMA_S1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EF0);
		debugfs_create_x16("MDMA_S1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EF8);
		debugfs_create_x16("MDMA_S1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EE8);
		debugfs_create_x32("MDMA_S1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00EC0);
		debugfs_create_x16("MDMA_S1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EEC);
		debugfs_create_x32("MDMA_S1_START_ADDR", 0600, parent, (u32 *)0xFFC00EC4);
		debugfs_create_x16("MDMA_S1_X_COUNT", 0600, parent, (u16 *)0xFFC00ED0);
		debugfs_create_x16("MDMA_S1_X_MODIFY", 0600, parent, (u16 *)0xFFC00ED4);
		debugfs_create_x16("MDMA_S1_Y_COUNT", 0600, parent, (u16 *)0xFFC00ED8);
		debugfs_create_x16("MDMA_S1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00EDC);

		parent = debugfs_create_dir("PLL", top);
		debugfs_create_x16("PLL_CTL", 0600, parent, (u16 *)0xFFC00000);
		debugfs_create_x16("PLL_DIV", 0600, parent, (u16 *)0xFFC00004);
		debugfs_create_x16("PLL_LOCKCNT", 0600, parent, (u16 *)0xFFC00010);
		debugfs_create_x16("PLL_STAT", 0600, parent, (u16 *)0xFFC0000C);
		debugfs_create_x32("SWRST", 0600, parent, (u32 *)0xFFC00100);
		debugfs_create_x32("SYSCR", 0600, parent, (u32 *)0xFFC00104);
		debugfs_create_x16("VR_CTL", 0600, parent, (u16 *)0xFFC00008);

		parent = debugfs_create_dir("PPI", top);
		debugfs_create_x16("PPI_CONTROL", 0600, parent, (u16 *)0xFFC01000);
		debugfs_create_x16("PPI_COUNT", 0600, parent, (u16 *)0xFFC01008);
		debugfs_create_x16("PPI_DELAY", 0600, parent, (u16 *)0xFFC0100C);
		debugfs_create_x16("PPI_FRAME", 0600, parent, (u16 *)0xFFC01010);
		debugfs_create_x16("PPI_STATUS", 0600, parent, (u16 *)0xFFC01004);

		parent = debugfs_create_dir("Performance Monitor", top);
		debugfs_create_x32("PFCNTR0", 0600, parent, (u32 *)0xFFE08100);
		debugfs_create_x32("PFCNTR1", 0600, parent, (u32 *)0xFFE08104);
		debugfs_create_x32("PFCTL", 0600, parent, (u32 *)0xFFE08000);

		parent = debugfs_create_dir("RTC", top);
		debugfs_create_x32("RTC_ALARM", 0600, parent, (u32 *)0xFFC00310);
		debugfs_create_x16("RTC_ICTL", 0600, parent, (u16 *)0xFFC00304);
		debugfs_create_x16("RTC_ISTAT", 0600, parent, (u16 *)0xFFC00308);
		debugfs_create_x16("RTC_PREN", 0600, parent, (u16 *)0xFFC00314);
		debugfs_create_x32("RTC_STAT", 0600, parent, (u32 *)0xFFC00300);
		debugfs_create_x16("RTC_SWCNT", 0600, parent, (u16 *)0xFFC0030C);

		parent = debugfs_create_dir("SPI", top);
		debugfs_create_x16("SPI_BAUD", 0600, parent, (u16 *)0xFFC00514);
		debugfs_create_x16("SPI_CTL", 0600, parent, (u16 *)0xFFC00500);
		debugfs_create_x16("SPI_FLG", 0600, parent, (u16 *)0xFFC00504);
		debugfs_create_x16("SPI_RDBR", 0600, parent, (u16 *)0xFFC00510);
		debugfs_create_x16("SPI_SHADOW", 0600, parent, (u16 *)0xFFC00518);
		debugfs_create_x16("SPI_STAT", 0600, parent, (u16 *)0xFFC00508);
		debugfs_create_x16("SPI_TDBR", 0600, parent, (u16 *)0xFFC0050C);

		parent = debugfs_create_dir("SPORT", top);
		debugfs_create_x16("SPORT0_CHNL", 0600, parent, (u16 *)0xFFC00834);
		debugfs_create_x16("SPORT0_MCMC1", 0600, parent, (u16 *)0xFFC00838);
		debugfs_create_x16("SPORT0_MCMC2", 0600, parent, (u16 *)0xFFC0083C);
		debugfs_create_x16("SPORT0_RCLKDIV", 0600, parent, (u16 *)0xFFC00828);
		debugfs_create_x16("SPORT0_RCR1", 0600, parent, (u16 *)0xFFC00820);
		debugfs_create_x16("SPORT0_RCR2", 0600, parent, (u16 *)0xFFC00824);
		debugfs_create_x16("SPORT0_RFSDIV", 0600, parent, (u16 *)0xFFC0082C);
		debugfs_create_x32("SPORT0_RX", 0600, parent, (u32 *)0xFFC00818);
		debugfs_create_x16("SPORT0_STAT", 0600, parent, (u16 *)0xFFC00830);
		debugfs_create_x16("SPORT0_TCLKDIV", 0600, parent, (u16 *)0xFFC00808);
		debugfs_create_x16("SPORT0_TCR1", 0600, parent, (u16 *)0xFFC00800);
		debugfs_create_x16("SPORT0_TCR2", 0600, parent, (u16 *)0xFFC00804);
		debugfs_create_x16("SPORT0_TFSDIV", 0600, parent, (u16 *)0xFFC0080C);
		debugfs_create_x32("SPORT0_TX", 0600, parent, (u32 *)0xFFC00810);
		debugfs_create_x16("SPORT1_CHNL", 0600, parent, (u16 *)0xFFC00934);
		debugfs_create_x16("SPORT1_MCMC1", 0600, parent, (u16 *)0xFFC00938);
		debugfs_create_x16("SPORT1_MCMC2", 0600, parent, (u16 *)0xFFC0093C);
		debugfs_create_x16("SPORT1_RCLKDIV", 0600, parent, (u16 *)0xFFC00928);
		debugfs_create_x16("SPORT1_RCR1", 0600, parent, (u16 *)0xFFC00920);
		debugfs_create_x16("SPORT1_RCR2", 0600, parent, (u16 *)0xFFC00924);
		debugfs_create_x16("SPORT1_RFSDIV", 0600, parent, (u16 *)0xFFC0092C);
		debugfs_create_x32("SPORT1_RX", 0600, parent, (u32 *)0xFFC00918);
		debugfs_create_x16("SPORT1_STAT", 0600, parent, (u16 *)0xFFC00930);
		debugfs_create_x16("SPORT1_TCLKDIV", 0600, parent, (u16 *)0xFFC00908);
		debugfs_create_x16("SPORT1_TCR1", 0600, parent, (u16 *)0xFFC00900);
		debugfs_create_x16("SPORT1_TCR2", 0600, parent, (u16 *)0xFFC00904);
		debugfs_create_x16("SPORT1_TFSDIV", 0600, parent, (u16 *)0xFFC0090C);
		debugfs_create_x32("SPORT1_TX", 0600, parent, (u32 *)0xFFC00910);

		parent = debugfs_create_dir("SPT0", top);
		debugfs_create_x16("SPT0_CHNL", 0600, parent, (u16 *)0xFFC00834);
		debugfs_create_x16("SPT0_MCMC1", 0600, parent, (u16 *)0xFFC00838);
		debugfs_create_x16("SPT0_MCMC2", 0600, parent, (u16 *)0xFFC0083C);
		debugfs_create_x32("SPT0_MRCS0", 0600, parent, (u32 *)0xFFC00850);
		debugfs_create_x32("SPT0_MRCS1", 0600, parent, (u32 *)0xFFC00854);
		debugfs_create_x32("SPT0_MRCS2", 0600, parent, (u32 *)0xFFC00858);
		debugfs_create_x32("SPT0_MRCS3", 0600, parent, (u32 *)0xFFC0085C);
		debugfs_create_x32("SPT0_MTCS0", 0600, parent, (u32 *)0xFFC00840);
		debugfs_create_x32("SPT0_MTCS1", 0600, parent, (u32 *)0xFFC00844);
		debugfs_create_x32("SPT0_MTCS2", 0600, parent, (u32 *)0xFFC00848);
		debugfs_create_x32("SPT0_MTCS3", 0600, parent, (u32 *)0xFFC0084C);
		debugfs_create_x16("SPT0_RFSDIV", 0600, parent, (u16 *)0xFFC0082C);
		debugfs_create_x16("SPT0_RSCLKDIV", 0600, parent, (u16 *)0xFFC00828);
		debugfs_create_x32("SPT0_RX", 0600, parent, (u32 *)0xFFC00818);
		debugfs_create_x16("SPT0_RX_CONFIG0", 0600, parent, (u16 *)0xFFC00820);
		debugfs_create_x16("SPT0_RX_CONFIG1", 0600, parent, (u16 *)0xFFC00824);
		debugfs_create_x16("SPT0_STAT", 0600, parent, (u16 *)0xFFC00830);
		debugfs_create_x16("SPT0_TFSDIV", 0600, parent, (u16 *)0xFFC0080C);
		debugfs_create_x16("SPT0_TSCLKDIV", 0600, parent, (u16 *)0xFFC00808);
		debugfs_create_x32("SPT0_TX", 0600, parent, (u32 *)0xFFC00810);
		debugfs_create_x16("SPT0_TX_CONFIG0", 0600, parent, (u16 *)0xFFC00800);
		debugfs_create_x16("SPT0_TX_CONFIG1", 0600, parent, (u16 *)0xFFC00804);
		debugfs_create_x16("SPT1_CHNL", 0600, parent, (u16 *)0xFFC00934);

		parent = debugfs_create_dir("SPT1", top);
		debugfs_create_x16("SPT1_MCMC1", 0600, parent, (u16 *)0xFFC00938);
		debugfs_create_x16("SPT1_MCMC2", 0600, parent, (u16 *)0xFFC0093C);
		debugfs_create_x32("SPT1_MRCS0", 0600, parent, (u32 *)0xFFC00950);
		debugfs_create_x32("SPT1_MRCS1", 0600, parent, (u32 *)0xFFC00954);
		debugfs_create_x32("SPT1_MRCS2", 0600, parent, (u32 *)0xFFC00958);
		debugfs_create_x32("SPT1_MRCS3", 0600, parent, (u32 *)0xFFC0095C);
		debugfs_create_x32("SPT1_MTCS0", 0600, parent, (u32 *)0xFFC00940);
		debugfs_create_x32("SPT1_MTCS1", 0600, parent, (u32 *)0xFFC00944);
		debugfs_create_x32("SPT1_MTCS2", 0600, parent, (u32 *)0xFFC00948);
		debugfs_create_x32("SPT1_MTCS3", 0600, parent, (u32 *)0xFFC0094C);
		debugfs_create_x16("SPT1_RFSDIV", 0600, parent, (u16 *)0xFFC0092C);
		debugfs_create_x16("SPT1_RSCLKDIV", 0600, parent, (u16 *)0xFFC00928);
		debugfs_create_x16("SPT1_RX", 0600, parent, (u16 *)0xFFC00918);
		debugfs_create_x16("SPT1_RX_CONFIG0", 0600, parent, (u16 *)0xFFC00920);
		debugfs_create_x16("SPT1_RX_CONFIG1", 0600, parent, (u16 *)0xFFC00924);
		debugfs_create_x16("SPT1_STAT", 0600, parent, (u16 *)0xFFC00930);
		debugfs_create_x16("SPT1_TFSDIV", 0600, parent, (u16 *)0xFFC0090C);
		debugfs_create_x16("SPT1_TSCLKDIV", 0600, parent, (u16 *)0xFFC00908);
		debugfs_create_x16("SPT1_TX", 0600, parent, (u16 *)0xFFC00910);
		debugfs_create_x16("SPT1_TX_CONFIG0", 0600, parent, (u16 *)0xFFC00900);
		debugfs_create_x16("SPT1_TX_CONFIG1", 0600, parent, (u16 *)0xFFC00904);

		parent = debugfs_create_dir("System Interrupt Controller Register File", top);
		debugfs_create_x32("SIC_IAR0", 0600, parent, (u32 *)0xFFC00110);
		debugfs_create_x32("SIC_IAR1", 0600, parent, (u32 *)0xFFC00114);
		debugfs_create_x32("SIC_IAR2", 0600, parent, (u32 *)0xFFC00118);
		debugfs_create_x32("SIC_IAR3", 0600, parent, (u32 *)0xFFC0011C);
		debugfs_create_x32("SIC_IMASK", 0600, parent, (u32 *)0xFFC0010C);
		debugfs_create_x32("SIC_ISR", 0600, parent, (u32 *)0xFFC00120);
		debugfs_create_x32("SIC_IWR", 0600, parent, (u32 *)0xFFC00124);
		debugfs_create_x16("SIC_RVECT", 0600, parent, (u16 *)0xFFC00108);

		parent = debugfs_create_dir("Timer Registers", top);
		debugfs_create_x16("TIMER0_CONFIG", 0600, parent, (u16 *)0xFFC00600);
		debugfs_create_x32("TIMER0_COUNTER", 0600, parent, (u32 *)0xFFC00604);
		debugfs_create_x32("TIMER0_PERIOD", 0600, parent, (u32 *)0xFFC00608);
		debugfs_create_x32("TIMER0_WIDTH", 0600, parent, (u32 *)0xFFC0060C);
		debugfs_create_x16("TIMER1_CONFIG", 0600, parent, (u16 *)0xFFC00610);
		debugfs_create_x32("TIMER1_COUNTER", 0600, parent, (u32 *)0xFFC00614);
		debugfs_create_x32("TIMER1_PERIOD", 0600, parent, (u32 *)0xFFC00618);
		debugfs_create_x32("TIMER1_WIDTH", 0600, parent, (u32 *)0xFFC0061C);
		debugfs_create_x16("TIMER2_CONFIG", 0600, parent, (u16 *)0xFFC00620);
		debugfs_create_x32("TIMER2_COUNTER", 0600, parent, (u32 *)0xFFC00624);
		debugfs_create_x32("TIMER2_PERIOD", 0600, parent, (u32 *)0xFFC00628);
		debugfs_create_x32("TIMER2_WIDTH", 0600, parent, (u32 *)0xFFC0062C);
		debugfs_create_x16("TIMER_DISABLE", 0600, parent, (u16 *)0xFFC00644);
		debugfs_create_x16("TIMER_ENABLE", 0600, parent, (u16 *)0xFFC00640);
		debugfs_create_x16("TIMER_STATUS", 0600, parent, (u16 *)0xFFC00648);

		parent = debugfs_create_dir("Trace Unit", top);
		debugfs_create_x32("TBUF", 0600, parent, (u32 *)0xFFE06100);
		debugfs_create_x32("TBUFCTL", 0600, parent, (u32 *)0xFFE06000);
		debugfs_create_x32("TBUFSTAT", 0600, parent, (u32 *)0xFFE06004);

		parent = debugfs_create_dir("UART", top);
		debugfs_create_x16("UART_DLH", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART_DLL", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART_GCTL", 0600, parent, (u16 *)0xFFC00424);
		debugfs_create_x16("UART_IER", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART_IIR", 0600, parent, (u16 *)0xFFC00408);
		debugfs_create_x16("UART_LCR", 0600, parent, (u16 *)0xFFC0040C);
		debugfs_create_x16("UART_LSR", 0600, parent, (u16 *)0xFFC00414);
		debugfs_create_x16("UART_MCR", 0600, parent, (u16 *)0xFFC00410);
		debugfs_create_x16("UART_RBR", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART_SCR", 0600, parent, (u16 *)0xFFC0041C);
		debugfs_create_x16("UART_THR", 0600, parent, (u16 *)0xFFC00400);

		parent = debugfs_create_dir("Watchdog", top);
		debugfs_create_x32("WDOG_CNT", 0600, parent, (u32 *)0xFFC00204);
		debugfs_create_x16("WDOG_CTL", 0600, parent, (u16 *)0xFFC00200);
		debugfs_create_x32("WDOG_STAT", 0600, parent, (u32 *)0xFFC00208);

		parent = debugfs_create_dir("Watchpoint and Patch Unit", top);
		debugfs_create_x32("WPDA0", 0600, parent, (u32 *)0xFFE07140);
		debugfs_create_x32("WPDA1", 0600, parent, (u32 *)0xFFE07144);
		debugfs_create_x32("WPDACNT0", 0600, parent, (u32 *)0xFFE07180);
		debugfs_create_x32("WPDACNT1", 0600, parent, (u32 *)0xFFE07184);
		debugfs_create_x32("WPDACTL", 0600, parent, (u32 *)0xFFE07100);
		debugfs_create_x32("WPIA0", 0600, parent, (u32 *)0xFFE07040);
		debugfs_create_x32("WPIA1", 0600, parent, (u32 *)0xFFE07044);
		debugfs_create_x32("WPIA2", 0600, parent, (u32 *)0xFFE07048);
		debugfs_create_x32("WPIA3", 0600, parent, (u32 *)0xFFE0704C);
		debugfs_create_x32("WPIA4", 0600, parent, (u32 *)0xFFE07050);
		debugfs_create_x32("WPIA5", 0600, parent, (u32 *)0xFFE07054);
		debugfs_create_x32("WPIACNT0", 0600, parent, (u32 *)0xFFE07080);
		debugfs_create_x32("WPIACNT1", 0600, parent, (u32 *)0xFFE07084);
		debugfs_create_x32("WPIACNT2", 0600, parent, (u32 *)0xFFE07088);
		debugfs_create_x32("WPIACNT3", 0600, parent, (u32 *)0xFFE0708C);
		debugfs_create_x32("WPIACNT4", 0600, parent, (u32 *)0xFFE07090);
		debugfs_create_x32("WPIACNT5", 0600, parent, (u32 *)0xFFE07094);
		debugfs_create_x32("WPIACTL", 0600, parent, (u32 *)0xFFE07000);
		debugfs_create_x32("WPSTAT", 0600, parent, (u32 *)0xFFE07200);

	}	/* BF531 */

#ifdef __ADSPBF532__
# define USE_BF532 1
#else
# define USE_BF532 0
#endif
	if (USE_BF532) {

		parent = debugfs_create_dir("Core Timer Register File", top);
		debugfs_create_x32("TCNTL", 0600, parent, (u32 *)0xFFE03000);
		debugfs_create_x32("TCOUNT", 0600, parent, (u32 *)0xFFE0300C);
		debugfs_create_x32("TPERIOD", 0600, parent, (u32 *)0xFFE03004);
		debugfs_create_x32("TSCALE", 0600, parent, (u32 *)0xFFE03008);

		parent = debugfs_create_dir("DMA Traffic Control", top);
		debugfs_create_x16("DMA_TC_CNT", 0600, parent, (u16 *)0xFFC00B0C);
		debugfs_create_x16("DMA_TC_PER", 0600, parent, (u16 *)0xFFC00B10);

		parent = debugfs_create_dir("DMAFlex Ch-0 Registers", top);
		debugfs_create_x32("DMA0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C24);
		debugfs_create_x32("DMA0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C20);
		debugfs_create_x32("DMA0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C00);
		debugfs_create_x32("DMA0_START_ADDR", 0600, parent, (u32 *)0xFFC00C04);
		debugfs_create_x16("DMAFLX0_CURXCOUNT", 0600, parent, (u16 *)0xFFC00C30);
		debugfs_create_x16("DMAFLX0_CURYCOUNT", 0600, parent, (u16 *)0xFFC00C38);
		debugfs_create_x16("DMAFLX0_DMACNFG", 0600, parent, (u16 *)0xFFC00C08);
		debugfs_create_x16("DMAFLX0_IRQSTAT", 0600, parent, (u16 *)0xFFC00C28);
		debugfs_create_x16("DMAFLX0_PMAP", 0600, parent, (u16 *)0xFFC00C2C);
		debugfs_create_x16("DMAFLX0_XCOUNT", 0600, parent, (u16 *)0xFFC00C10);
		debugfs_create_x16("DMAFLX0_XMODIFY", 0600, parent, (u16 *)0xFFC00C14);
		debugfs_create_x16("DMAFLX0_YCOUNT", 0600, parent, (u16 *)0xFFC00C18);
		debugfs_create_x16("DMAFLX0_YMODIFY", 0600, parent, (u16 *)0xFFC00C1C);

		parent = debugfs_create_dir("DMAFlex Ch-1 Registers", top);
		debugfs_create_x32("DMA1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C64);
		debugfs_create_x32("DMA1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C60);
		debugfs_create_x32("DMA1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C40);
		debugfs_create_x32("DMA1_START_ADDR", 0600, parent, (u32 *)0xFFC00C44);
		debugfs_create_x16("DMAFLX1_CURXCOUNT", 0600, parent, (u16 *)0xFFC00C70);
		debugfs_create_x16("DMAFLX1_CURYCOUNT", 0600, parent, (u16 *)0xFFC00C78);
		debugfs_create_x16("DMAFLX1_DMACNFG", 0600, parent, (u16 *)0xFFC00C48);
		debugfs_create_x16("DMAFLX1_IRQSTAT", 0600, parent, (u16 *)0xFFC00C68);
		debugfs_create_x16("DMAFLX1_PMAP", 0600, parent, (u16 *)0xFFC00C6C);
		debugfs_create_x16("DMAFLX1_XCOUNT", 0600, parent, (u16 *)0xFFC00C50);
		debugfs_create_x16("DMAFLX1_XMODIFY", 0600, parent, (u16 *)0xFFC00C54);
		debugfs_create_x16("DMAFLX1_YCOUNT", 0600, parent, (u16 *)0xFFC00C58);
		debugfs_create_x16("DMAFLX1_YMODIFY", 0600, parent, (u16 *)0xFFC00C5C);

		parent = debugfs_create_dir("DMAFlex Ch-2 Registers", top);
		debugfs_create_x32("DMA2_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CA4);
		debugfs_create_x32("DMA2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CA0);
		debugfs_create_x32("DMA2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C80);
		debugfs_create_x32("DMA2_START_ADDR", 0600, parent, (u32 *)0xFFC00C84);
		debugfs_create_x16("DMAFLX2_CURXCOUNT", 0600, parent, (u16 *)0xFFC00CB0);
		debugfs_create_x16("DMAFLX2_CURYCOUNT", 0600, parent, (u16 *)0xFFC00CB8);
		debugfs_create_x16("DMAFLX2_DMACNFG", 0600, parent, (u16 *)0xFFC00C88);
		debugfs_create_x16("DMAFLX2_IRQSTAT", 0600, parent, (u16 *)0xFFC00CA8);
		debugfs_create_x16("DMAFLX2_PMAP", 0600, parent, (u16 *)0xFFC00CAC);
		debugfs_create_x16("DMAFLX2_XCOUNT", 0600, parent, (u16 *)0xFFC00C90);
		debugfs_create_x16("DMAFLX2_XMODIFY", 0600, parent, (u16 *)0xFFC00C94);
		debugfs_create_x16("DMAFLX2_YCOUNT", 0600, parent, (u16 *)0xFFC00C98);
		debugfs_create_x16("DMAFLX2_YMODIFY", 0600, parent, (u16 *)0xFFC00C9C);

		parent = debugfs_create_dir("DMAFlex Ch-3 Registers", top);
		debugfs_create_x32("DMA3_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CE4);
		debugfs_create_x32("DMA3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CE0);
		debugfs_create_x32("DMA3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00CC0);
		debugfs_create_x32("DMA3_START_ADDR", 0600, parent, (u32 *)0xFFC00CC4);
		debugfs_create_x16("DMAFLX3_CURXCOUNT", 0600, parent, (u16 *)0xFFC00CF0);
		debugfs_create_x16("DMAFLX3_CURYCOUNT", 0600, parent, (u16 *)0xFFC00CF8);
		debugfs_create_x16("DMAFLX3_DMACNFG", 0600, parent, (u16 *)0xFFC00CC8);
		debugfs_create_x16("DMAFLX3_IRQSTAT", 0600, parent, (u16 *)0xFFC00CE8);
		debugfs_create_x16("DMAFLX3_PMAP", 0600, parent, (u16 *)0xFFC00CEC);
		debugfs_create_x16("DMAFLX3_XCOUNT", 0600, parent, (u16 *)0xFFC00CD0);
		debugfs_create_x16("DMAFLX3_XMODIFY", 0600, parent, (u16 *)0xFFC00CD4);
		debugfs_create_x16("DMAFLX3_YCOUNT", 0600, parent, (u16 *)0xFFC00CD8);
		debugfs_create_x16("DMAFLX3_YMODIFY", 0600, parent, (u16 *)0xFFC00CDC);

		parent = debugfs_create_dir("DMAFlex Ch-4 Registers", top);
		debugfs_create_x32("DMA4_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D24);
		debugfs_create_x32("DMA4_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D20);
		debugfs_create_x32("DMA4_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D00);
		debugfs_create_x32("DMA4_START_ADDR", 0600, parent, (u32 *)0xFFC00D04);
		debugfs_create_x16("DMAFLX4_CURXCOUNT", 0600, parent, (u16 *)0xFFC00D30);
		debugfs_create_x16("DMAFLX4_CURYCOUNT", 0600, parent, (u16 *)0xFFC00D38);
		debugfs_create_x16("DMAFLX4_DMACNFG", 0600, parent, (u16 *)0xFFC00D08);
		debugfs_create_x16("DMAFLX4_IRQSTAT", 0600, parent, (u16 *)0xFFC00D28);
		debugfs_create_x16("DMAFLX4_PMAP", 0600, parent, (u16 *)0xFFC00D2C);
		debugfs_create_x16("DMAFLX4_XCOUNT", 0600, parent, (u16 *)0xFFC00D10);
		debugfs_create_x16("DMAFLX4_XMODIFY", 0600, parent, (u16 *)0xFFC00D14);
		debugfs_create_x16("DMAFLX4_YCOUNT", 0600, parent, (u16 *)0xFFC00D18);
		debugfs_create_x16("DMAFLX4_YMODIFY", 0600, parent, (u16 *)0xFFC00D1C);

		parent = debugfs_create_dir("DMAFlex Ch-5 Registers", top);
		debugfs_create_x32("DMA5_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D64);
		debugfs_create_x32("DMA5_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D60);
		debugfs_create_x32("DMA5_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D40);
		debugfs_create_x32("DMA5_START_ADDR", 0600, parent, (u32 *)0xFFC00D44);
		debugfs_create_x16("DMAFLX5_CURXCOUNT", 0600, parent, (u16 *)0xFFC00D70);
		debugfs_create_x16("DMAFLX5_CURYCOUNT", 0600, parent, (u16 *)0xFFC00D78);
		debugfs_create_x16("DMAFLX5_DMACNFG", 0600, parent, (u16 *)0xFFC00D48);
		debugfs_create_x16("DMAFLX5_IRQSTAT", 0600, parent, (u16 *)0xFFC00D68);
		debugfs_create_x16("DMAFLX5_PMAP", 0600, parent, (u16 *)0xFFC00D6C);
		debugfs_create_x16("DMAFLX5_XCOUNT", 0600, parent, (u16 *)0xFFC00D50);
		debugfs_create_x16("DMAFLX5_XMODIFY", 0600, parent, (u16 *)0xFFC00D54);
		debugfs_create_x16("DMAFLX5_YCOUNT", 0600, parent, (u16 *)0xFFC00D58);
		debugfs_create_x16("DMAFLX5_YMODIFY", 0600, parent, (u16 *)0xFFC00D5C);

		parent = debugfs_create_dir("DMAFlex Ch-6 Registers", top);
		debugfs_create_x32("DMA6_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DA4);
		debugfs_create_x32("DMA6_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DA0);
		debugfs_create_x32("DMA6_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D80);
		debugfs_create_x32("DMA6_START_ADDR", 0600, parent, (u32 *)0xFFC00D84);
		debugfs_create_x16("DMAFLX6_CURXCOUNT", 0600, parent, (u16 *)0xFFC00DB0);
		debugfs_create_x16("DMAFLX6_CURYCOUNT", 0600, parent, (u16 *)0xFFC00DB8);
		debugfs_create_x16("DMAFLX6_DMACNFG", 0600, parent, (u16 *)0xFFC00D88);
		debugfs_create_x16("DMAFLX6_IRQSTAT", 0600, parent, (u16 *)0xFFC00DA8);
		debugfs_create_x16("DMAFLX6_PMAP", 0600, parent, (u16 *)0xFFC00DAC);
		debugfs_create_x16("DMAFLX6_XCOUNT", 0600, parent, (u16 *)0xFFC00D90);
		debugfs_create_x16("DMAFLX6_XMODIFY", 0600, parent, (u16 *)0xFFC00D94);
		debugfs_create_x16("DMAFLX6_YCOUNT", 0600, parent, (u16 *)0xFFC00D98);
		debugfs_create_x16("DMAFLX6_YMODIFY", 0600, parent, (u16 *)0xFFC00D9C);

		parent = debugfs_create_dir("DMAFlex Ch-7 Registers", top);
		debugfs_create_x32("DMA7_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DE4);
		debugfs_create_x32("DMA7_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DE0);
		debugfs_create_x32("DMA7_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00DC0);
		debugfs_create_x32("DMA7_START_ADDR", 0600, parent, (u32 *)0xFFC00DC4);
		debugfs_create_x16("DMAFLX7_CURXCOUNT", 0600, parent, (u16 *)0xFFC00DF0);
		debugfs_create_x16("DMAFLX7_CURYCOUNT", 0600, parent, (u16 *)0xFFC00DF8);
		debugfs_create_x16("DMAFLX7_DMACNFG", 0600, parent, (u16 *)0xFFC00DC8);
		debugfs_create_x16("DMAFLX7_IRQSTAT", 0600, parent, (u16 *)0xFFC00DE8);
		debugfs_create_x16("DMAFLX7_PMAP", 0600, parent, (u16 *)0xFFC00DEC);
		debugfs_create_x16("DMAFLX7_XCOUNT", 0600, parent, (u16 *)0xFFC00DD0);
		debugfs_create_x16("DMAFLX7_XMODIFY", 0600, parent, (u16 *)0xFFC00DD4);
		debugfs_create_x16("DMAFLX7_YCOUNT", 0600, parent, (u16 *)0xFFC00DD8);
		debugfs_create_x16("DMAFLX7_YMODIFY", 0600, parent, (u16 *)0xFFC00DDC);

		parent = debugfs_create_dir("Data Cache Programmable Look-Aside Buffer Fault Address", top);
		debugfs_create_x32("DCPLB_FAULT_STATUS", 0600, parent, (u32 *)0xFFE00008);

		parent = debugfs_create_dir("EBIU", top);
		debugfs_create_x32("EBIU_AMBCTL0", 0600, parent, (u32 *)0xFFC00A04);
		debugfs_create_x32("EBIU_AMBCTL1", 0600, parent, (u32 *)0xFFC00A08);
		debugfs_create_x16("EBIU_AMGCTL", 0600, parent, (u16 *)0xFFC00A00);
		debugfs_create_x16("EBIU_SDBCTL", 0600, parent, (u16 *)0xFFC00A14);
		debugfs_create_x32("EBIU_SDGCTL", 0600, parent, (u32 *)0xFFC00A10);
		debugfs_create_x16("EBIU_SDRRC", 0600, parent, (u16 *)0xFFC00A18);
		debugfs_create_x16("EBIU_SDSTAT", 0600, parent, (u16 *)0xFFC00A1C);

		parent = debugfs_create_dir("Event Vectors", top);
		debugfs_create_x32("EVT0", 0600, parent, (u32 *)0xFFE02000);
		debugfs_create_x32("EVT10", 0600, parent, (u32 *)0xFFE02028);
		debugfs_create_x32("EVT11", 0600, parent, (u32 *)0xFFE0202C);
		debugfs_create_x32("EVT12", 0600, parent, (u32 *)0xFFE02030);
		debugfs_create_x32("EVT13", 0600, parent, (u32 *)0xFFE02034);
		debugfs_create_x32("EVT14", 0600, parent, (u32 *)0xFFE02038);
		debugfs_create_x32("EVT15", 0600, parent, (u32 *)0xFFE0203C);
		debugfs_create_x32("EVT1", 0600, parent, (u32 *)0xFFE02004);
		debugfs_create_x32("EVT2", 0600, parent, (u32 *)0xFFE02008);
		debugfs_create_x32("EVT3", 0600, parent, (u32 *)0xFFE0200C);
		debugfs_create_x32("EVT4", 0600, parent, (u32 *)0xFFE02010);
		debugfs_create_x32("EVT5", 0600, parent, (u32 *)0xFFE02014);
		debugfs_create_x32("EVT6", 0600, parent, (u32 *)0xFFE02018);
		debugfs_create_x32("EVT7", 0600, parent, (u32 *)0xFFE0201C);
		debugfs_create_x32("EVT8", 0600, parent, (u32 *)0xFFE02020);
		debugfs_create_x32("EVT9", 0600, parent, (u32 *)0xFFE02024);

		parent = debugfs_create_dir("Extended Registers", top);
		debugfs_create_x32("CHIPID", 0600, parent, (u32 *)0xFFC00014);
		debugfs_create_x16("DMA0_CONFIG", 0600, parent, (u16 *)0xFFC00C08);
		debugfs_create_x16("DMA0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C30);
		debugfs_create_x16("DMA0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C38);
		debugfs_create_x16("DMA0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C28);
		debugfs_create_x16("DMA0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C2C);
		debugfs_create_x16("DMA0_X_COUNT", 0600, parent, (u16 *)0xFFC00C10);
		debugfs_create_x16("DMA0_X_MODIFY", 0600, parent, (u16 *)0xFFC00C14);
		debugfs_create_x16("DMA0_Y_COUNT", 0600, parent, (u16 *)0xFFC00C18);
		debugfs_create_x16("DMA0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C1C);
		debugfs_create_x16("DMA1_CONFIG", 0600, parent, (u16 *)0xFFC00C48);
		debugfs_create_x16("DMA1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C70);
		debugfs_create_x16("DMA1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C78);
		debugfs_create_x16("DMA1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C68);
		debugfs_create_x16("DMA1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C6C);
		debugfs_create_x16("DMA1_X_COUNT", 0600, parent, (u16 *)0xFFC00C50);
		debugfs_create_x16("DMA1_X_MODIFY", 0600, parent, (u16 *)0xFFC00C54);
		debugfs_create_x16("DMA1_Y_COUNT", 0600, parent, (u16 *)0xFFC00C58);
		debugfs_create_x16("DMA1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C5C);
		debugfs_create_x16("DMA2_CONFIG", 0600, parent, (u16 *)0xFFC00C88);
		debugfs_create_x16("DMA2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CB0);
		debugfs_create_x16("DMA2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CB8);
		debugfs_create_x16("DMA2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CA8);
		debugfs_create_x16("DMA2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CAC);
		debugfs_create_x16("DMA2_X_COUNT", 0600, parent, (u16 *)0xFFC00C90);
		debugfs_create_x16("DMA2_X_MODIFY", 0600, parent, (u16 *)0xFFC00C94);
		debugfs_create_x16("DMA2_Y_COUNT", 0600, parent, (u16 *)0xFFC00C98);
		debugfs_create_x16("DMA2_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C9C);
		debugfs_create_x16("DMA3_CONFIG", 0600, parent, (u16 *)0xFFC00CC8);
		debugfs_create_x16("DMA3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CF0);
		debugfs_create_x16("DMA3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CF8);
		debugfs_create_x16("DMA3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CE8);
		debugfs_create_x16("DMA3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CEC);
		debugfs_create_x16("DMA3_X_COUNT", 0600, parent, (u16 *)0xFFC00CD0);
		debugfs_create_x16("DMA3_X_MODIFY", 0600, parent, (u16 *)0xFFC00CD4);
		debugfs_create_x16("DMA3_Y_COUNT", 0600, parent, (u16 *)0xFFC00CD8);
		debugfs_create_x16("DMA3_Y_MODIFY", 0600, parent, (u16 *)0xFFC00CDC);
		debugfs_create_x16("DMA4_CONFIG", 0600, parent, (u16 *)0xFFC00D08);
		debugfs_create_x16("DMA4_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D30);
		debugfs_create_x16("DMA4_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D38);
		debugfs_create_x16("DMA4_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D28);
		debugfs_create_x16("DMA4_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D2C);
		debugfs_create_x16("DMA4_X_COUNT", 0600, parent, (u16 *)0xFFC00D10);
		debugfs_create_x16("DMA4_X_MODIFY", 0600, parent, (u16 *)0xFFC00D14);
		debugfs_create_x16("DMA4_Y_COUNT", 0600, parent, (u16 *)0xFFC00D18);
		debugfs_create_x16("DMA4_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D1C);
		debugfs_create_x16("DMA5_CONFIG", 0600, parent, (u16 *)0xFFC00D48);
		debugfs_create_x16("DMA5_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D70);
		debugfs_create_x16("DMA5_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D78);
		debugfs_create_x16("DMA5_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D68);
		debugfs_create_x16("DMA5_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D6C);
		debugfs_create_x16("DMA5_X_COUNT", 0600, parent, (u16 *)0xFFC00D50);
		debugfs_create_x16("DMA5_X_MODIFY", 0600, parent, (u16 *)0xFFC00D54);
		debugfs_create_x16("DMA5_Y_COUNT", 0600, parent, (u16 *)0xFFC00D58);
		debugfs_create_x16("DMA5_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D5C);
		debugfs_create_x16("DMA6_CONFIG", 0600, parent, (u16 *)0xFFC00D88);
		debugfs_create_x16("DMA6_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DB0);
		debugfs_create_x16("DMA6_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DB8);
		debugfs_create_x16("DMA6_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DA8);
		debugfs_create_x16("DMA6_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DAC);
		debugfs_create_x16("DMA6_X_COUNT", 0600, parent, (u16 *)0xFFC00D90);
		debugfs_create_x16("DMA6_X_MODIFY", 0600, parent, (u16 *)0xFFC00D94);
		debugfs_create_x16("DMA6_Y_COUNT", 0600, parent, (u16 *)0xFFC00D98);
		debugfs_create_x16("DMA6_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D9C);
		debugfs_create_x16("DMA7_CONFIG", 0600, parent, (u16 *)0xFFC00DC8);
		debugfs_create_x16("DMA7_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DF0);
		debugfs_create_x16("DMA7_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DF8);
		debugfs_create_x16("DMA7_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DE8);
		debugfs_create_x16("DMA7_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DEC);
		debugfs_create_x16("DMA7_X_COUNT", 0600, parent, (u16 *)0xFFC00DD0);
		debugfs_create_x16("DMA7_X_MODIFY", 0600, parent, (u16 *)0xFFC00DD4);
		debugfs_create_x16("DMA7_Y_COUNT", 0600, parent, (u16 *)0xFFC00DD8);
		debugfs_create_x16("DMA7_Y_MODIFY", 0600, parent, (u16 *)0xFFC00DDC);
		debugfs_create_x32("DSPID", 0600, parent, (u32 *)0xFFE05000);
		debugfs_create_x32("EVT_OVERRIDE", 0600, parent, (u32 *)0xFFE02100);
		debugfs_create_x16("FIO_BOTH", 0600, parent, (u16 *)0xFFC0073C);
		debugfs_create_x16("FIO_DIR", 0600, parent, (u16 *)0xFFC00730);
		debugfs_create_x16("FIO_EDGE", 0600, parent, (u16 *)0xFFC00738);
		debugfs_create_x16("FIO_FLAG_C", 0600, parent, (u16 *)0xFFC00704);
		debugfs_create_x16("FIO_FLAG_D", 0600, parent, (u16 *)0xFFC00700);
		debugfs_create_x16("FIO_FLAG_S", 0600, parent, (u16 *)0xFFC00708);
		debugfs_create_x16("FIO_FLAG_T", 0600, parent, (u16 *)0xFFC0070C);
		debugfs_create_x16("FIO_INEN", 0600, parent, (u16 *)0xFFC00740);
		debugfs_create_x16("FIO_MASKA_C", 0600, parent, (u16 *)0xFFC00714);
		debugfs_create_x16("FIO_MASKA_D", 0600, parent, (u16 *)0xFFC00710);
		debugfs_create_x16("FIO_MASKA_S", 0600, parent, (u16 *)0xFFC00718);
		debugfs_create_x16("FIO_MASKA_T", 0600, parent, (u16 *)0xFFC0071C);
		debugfs_create_x16("FIO_MASKB_C", 0600, parent, (u16 *)0xFFC00724);
		debugfs_create_x16("FIO_MASKB_D", 0600, parent, (u16 *)0xFFC00720);
		debugfs_create_x16("FIO_MASKB_S", 0600, parent, (u16 *)0xFFC00728);
		debugfs_create_x16("FIO_MASKB_T", 0600, parent, (u16 *)0xFFC0072C);
		debugfs_create_x16("FIO_POLAR", 0600, parent, (u16 *)0xFFC00734);

		parent = debugfs_create_dir("Interrupt Controller", top);
		debugfs_create_x32("ILAT", 0600, parent, (u32 *)0xFFE0210C);
		debugfs_create_x32("IMASK", 0600, parent, (u32 *)0xFFE02104);
		debugfs_create_x32("IPEND", 0600, parent, (u32 *)0xFFE02108);
		debugfs_create_x32("IPRIO", 0600, parent, (u32 *)0xFFE02110);

		parent = debugfs_create_dir("L1 Code Memory Registers", top);
		debugfs_create_x32("ICPLB_ADDR0", 0600, parent, (u32 *)0xFFE01100);
		debugfs_create_x32("ICPLB_ADDR10", 0600, parent, (u32 *)0xFFE01128);
		debugfs_create_x32("ICPLB_ADDR11", 0600, parent, (u32 *)0xFFE0112C);
		debugfs_create_x32("ICPLB_ADDR12", 0600, parent, (u32 *)0xFFE01130);
		debugfs_create_x32("ICPLB_ADDR13", 0600, parent, (u32 *)0xFFE01134);
		debugfs_create_x32("ICPLB_ADDR14", 0600, parent, (u32 *)0xFFE01138);
		debugfs_create_x32("ICPLB_ADDR15", 0600, parent, (u32 *)0xFFE0113C);
		debugfs_create_x32("ICPLB_ADDR1", 0600, parent, (u32 *)0xFFE01104);
		debugfs_create_x32("ICPLB_ADDR2", 0600, parent, (u32 *)0xFFE01108);
		debugfs_create_x32("ICPLB_ADDR3", 0600, parent, (u32 *)0xFFE0110C);
		debugfs_create_x32("ICPLB_ADDR4", 0600, parent, (u32 *)0xFFE01110);
		debugfs_create_x32("ICPLB_ADDR5", 0600, parent, (u32 *)0xFFE01114);
		debugfs_create_x32("ICPLB_ADDR6", 0600, parent, (u32 *)0xFFE01118);
		debugfs_create_x32("ICPLB_ADDR7", 0600, parent, (u32 *)0xFFE0111C);
		debugfs_create_x32("ICPLB_ADDR8", 0600, parent, (u32 *)0xFFE01120);
		debugfs_create_x32("ICPLB_ADDR9", 0600, parent, (u32 *)0xFFE01124);
		debugfs_create_x32("ICPLB_DATA0", 0600, parent, (u32 *)0xFFE01200);
		debugfs_create_x32("ICPLB_DATA10", 0600, parent, (u32 *)0xFFE01228);
		debugfs_create_x32("ICPLB_DATA11", 0600, parent, (u32 *)0xFFE0122C);
		debugfs_create_x32("ICPLB_DATA12", 0600, parent, (u32 *)0xFFE01230);
		debugfs_create_x32("ICPLB_DATA13", 0600, parent, (u32 *)0xFFE01234);
		debugfs_create_x32("ICPLB_DATA14", 0600, parent, (u32 *)0xFFE01238);
		debugfs_create_x32("ICPLB_DATA15", 0600, parent, (u32 *)0xFFE0123C);
		debugfs_create_x32("ICPLB_DATA1", 0600, parent, (u32 *)0xFFE01204);
		debugfs_create_x32("ICPLB_DATA2", 0600, parent, (u32 *)0xFFE01208);
		debugfs_create_x32("ICPLB_DATA3", 0600, parent, (u32 *)0xFFE0120C);
		debugfs_create_x32("ICPLB_DATA4", 0600, parent, (u32 *)0xFFE01210);
		debugfs_create_x32("ICPLB_DATA5", 0600, parent, (u32 *)0xFFE01214);
		debugfs_create_x32("ICPLB_DATA6", 0600, parent, (u32 *)0xFFE01218);
		debugfs_create_x32("ICPLB_DATA7", 0600, parent, (u32 *)0xFFE0121C);
		debugfs_create_x32("ICPLB_DATA8", 0600, parent, (u32 *)0xFFE01220);
		debugfs_create_x32("ICPLB_DATA9", 0600, parent, (u32 *)0xFFE01224);
		debugfs_create_x32("ICPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0100C);
		debugfs_create_x32("ICPLB_FAULT_STATUS", 0600, parent, (u32 *)0xFFE01008);
		debugfs_create_x32("IMEM_CONTROL", 0600, parent, (u32 *)0xFFE01004);
		debugfs_create_x32("ITEST_COMMAND", 0600, parent, (u32 *)0xFFE01300);
		debugfs_create_x32("ITEST_DATA0", 0600, parent, (u32 *)0xFFE01400);
		debugfs_create_x32("ITEST_DATA1", 0600, parent, (u32 *)0xFFE01404);

		parent = debugfs_create_dir("L1 Data Memory Registers", top);
		debugfs_create_x32("DCPLB_ADDR0", 0600, parent, (u32 *)0xFFE00100);
		debugfs_create_x32("DCPLB_ADDR10", 0600, parent, (u32 *)0xFFE00128);
		debugfs_create_x32("DCPLB_ADDR11", 0600, parent, (u32 *)0xFFE0012C);
		debugfs_create_x32("DCPLB_ADDR12", 0600, parent, (u32 *)0xFFE00130);
		debugfs_create_x32("DCPLB_ADDR13", 0600, parent, (u32 *)0xFFE00134);
		debugfs_create_x32("DCPLB_ADDR14", 0600, parent, (u32 *)0xFFE00138);
		debugfs_create_x32("DCPLB_ADDR15", 0600, parent, (u32 *)0xFFE0013C);
		debugfs_create_x32("DCPLB_ADDR1", 0600, parent, (u32 *)0xFFE00104);
		debugfs_create_x32("DCPLB_ADDR2", 0600, parent, (u32 *)0xFFE00108);
		debugfs_create_x32("DCPLB_ADDR3", 0600, parent, (u32 *)0xFFE0010C);
		debugfs_create_x32("DCPLB_ADDR4", 0600, parent, (u32 *)0xFFE00110);
		debugfs_create_x32("DCPLB_ADDR5", 0600, parent, (u32 *)0xFFE00114);
		debugfs_create_x32("DCPLB_ADDR6", 0600, parent, (u32 *)0xFFE00118);
		debugfs_create_x32("DCPLB_ADDR7", 0600, parent, (u32 *)0xFFE0011C);
		debugfs_create_x32("DCPLB_ADDR8", 0600, parent, (u32 *)0xFFE00120);
		debugfs_create_x32("DCPLB_ADDR9", 0600, parent, (u32 *)0xFFE00124);
		debugfs_create_x32("DCPLB_DATA0", 0600, parent, (u32 *)0xFFE00200);
		debugfs_create_x32("DCPLB_DATA10", 0600, parent, (u32 *)0xFFE00228);
		debugfs_create_x32("DCPLB_DATA11", 0600, parent, (u32 *)0xFFE0022C);
		debugfs_create_x32("DCPLB_DATA12", 0600, parent, (u32 *)0xFFE00230);
		debugfs_create_x32("DCPLB_DATA13", 0600, parent, (u32 *)0xFFE00234);
		debugfs_create_x32("DCPLB_DATA14", 0600, parent, (u32 *)0xFFE00238);
		debugfs_create_x32("DCPLB_DATA15", 0600, parent, (u32 *)0xFFE0023C);
		debugfs_create_x32("DCPLB_DATA1", 0600, parent, (u32 *)0xFFE00204);
		debugfs_create_x32("DCPLB_DATA2", 0600, parent, (u32 *)0xFFE00208);
		debugfs_create_x32("DCPLB_DATA3", 0600, parent, (u32 *)0xFFE0020C);
		debugfs_create_x32("DCPLB_DATA4", 0600, parent, (u32 *)0xFFE00210);
		debugfs_create_x32("DCPLB_DATA5", 0600, parent, (u32 *)0xFFE00214);
		debugfs_create_x32("DCPLB_DATA6", 0600, parent, (u32 *)0xFFE00218);
		debugfs_create_x32("DCPLB_DATA7", 0600, parent, (u32 *)0xFFE0021C);
		debugfs_create_x32("DCPLB_DATA8", 0600, parent, (u32 *)0xFFE00220);
		debugfs_create_x32("DCPLB_DATA9", 0600, parent, (u32 *)0xFFE00224);
		debugfs_create_x32("DCPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0000C);
		debugfs_create_x32("DMEM_CONTROL", 0600, parent, (u32 *)0xFFE00004);
		debugfs_create_x32("DTEST_COMMAND", 0600, parent, (u32 *)0xFFE00300);
		debugfs_create_x32("DTEST_DATA0", 0600, parent, (u32 *)0xFFE00400);
		debugfs_create_x32("DTEST_DATA1", 0600, parent, (u32 *)0xFFE00404);
		debugfs_create_x32("SRAM_BASE_ADDR", 0600, parent, (u32 *)0xFFE00000);

		parent = debugfs_create_dir("MEMDMA0 Destination Registers", top);
		debugfs_create_x16("MDMAFLX0_CURXCOUNT_D", 0600, parent, (u16 *)0xFFC00E30);
		debugfs_create_x16("MDMAFLX0_CURYCOUNT_D", 0600, parent, (u16 *)0xFFC00E38);
		debugfs_create_x16("MDMAFLX0_DMACNFG_D", 0600, parent, (u16 *)0xFFC00E08);
		debugfs_create_x16("MDMAFLX0_IRQSTAT_D", 0600, parent, (u16 *)0xFFC00E28);
		debugfs_create_x16("MDMAFLX0_PMAP_D", 0600, parent, (u16 *)0xFFC00E2C);
		debugfs_create_x16("MDMAFLX0_XCOUNT_D", 0600, parent, (u16 *)0xFFC00E10);
		debugfs_create_x16("MDMAFLX0_XMODIFY_D", 0600, parent, (u16 *)0xFFC00E14);
		debugfs_create_x16("MDMAFLX0_YCOUNT_D", 0600, parent, (u16 *)0xFFC00E18);
		debugfs_create_x16("MDMAFLX0_YMODIFY_D", 0600, parent, (u16 *)0xFFC00E1C);
		debugfs_create_x16("MDMA_D0_CONFIG", 0600, parent, (u16 *)0xFFC00E08);
		debugfs_create_x32("MDMA_D0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E24);
		debugfs_create_x32("MDMA_D0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E20);
		debugfs_create_x16("MDMA_D0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E30);
		debugfs_create_x16("MDMA_D0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E38);
		debugfs_create_x16("MDMA_D0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E28);
		debugfs_create_x32("MDMA_D0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E00);
		debugfs_create_x16("MDMA_D0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E2C);
		debugfs_create_x32("MDMA_D0_START_ADDR", 0600, parent, (u32 *)0xFFC00E04);
		debugfs_create_x16("MDMA_D0_X_COUNT", 0600, parent, (u16 *)0xFFC00E10);
		debugfs_create_x16("MDMA_D0_X_MODIFY", 0600, parent, (u16 *)0xFFC00E14);
		debugfs_create_x16("MDMA_D0_Y_COUNT", 0600, parent, (u16 *)0xFFC00E18);
		debugfs_create_x16("MDMA_D0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E1C);

		parent = debugfs_create_dir("MEMDMA0 Source Registers", top);
		debugfs_create_x16("MDMAFLX0_CURXCOUNT_S", 0600, parent, (u16 *)0xFFC00E70);
		debugfs_create_x16("MDMAFLX0_CURYCOUNT_S", 0600, parent, (u16 *)0xFFC00E78);
		debugfs_create_x16("MDMAFLX0_DMACNFG_S", 0600, parent, (u16 *)0xFFC00E48);
		debugfs_create_x16("MDMAFLX0_IRQSTAT_S", 0600, parent, (u16 *)0xFFC00E68);
		debugfs_create_x16("MDMAFLX0_PMAP_S", 0600, parent, (u16 *)0xFFC00E6C);
		debugfs_create_x16("MDMAFLX0_XCOUNT_S", 0600, parent, (u16 *)0xFFC00E50);
		debugfs_create_x16("MDMAFLX0_XMODIFY_S", 0600, parent, (u16 *)0xFFC00E54);
		debugfs_create_x16("MDMAFLX0_YCOUNT_S", 0600, parent, (u16 *)0xFFC00E58);
		debugfs_create_x16("MDMAFLX0_YMODIFY_S", 0600, parent, (u16 *)0xFFC00E5C);
		debugfs_create_x16("MDMA_S0_CONFIG", 0600, parent, (u16 *)0xFFC00E48);
		debugfs_create_x32("MDMA_S0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E64);
		debugfs_create_x32("MDMA_S0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E60);
		debugfs_create_x16("MDMA_S0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E70);
		debugfs_create_x16("MDMA_S0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E78);
		debugfs_create_x16("MDMA_S0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E68);
		debugfs_create_x32("MDMA_S0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E40);
		debugfs_create_x16("MDMA_S0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E6C);
		debugfs_create_x32("MDMA_S0_START_ADDR", 0600, parent, (u32 *)0xFFC00E44);
		debugfs_create_x16("MDMA_S0_X_COUNT", 0600, parent, (u16 *)0xFFC00E50);
		debugfs_create_x16("MDMA_S0_X_MODIFY", 0600, parent, (u16 *)0xFFC00E54);
		debugfs_create_x16("MDMA_S0_Y_COUNT", 0600, parent, (u16 *)0xFFC00E58);
		debugfs_create_x16("MDMA_S0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E5C);

		parent = debugfs_create_dir("MEMDMA1 Destination Registers", top);
		debugfs_create_x16("MDMAFLX1_CURXCOUNT_D", 0600, parent, (u16 *)0xFFC00EB0);
		debugfs_create_x16("MDMAFLX1_CURYCOUNT_D", 0600, parent, (u16 *)0xFFC00EB8);
		debugfs_create_x16("MDMAFLX1_DMACNFG_D", 0600, parent, (u16 *)0xFFC00E88);
		debugfs_create_x16("MDMAFLX1_IRQSTAT_D", 0600, parent, (u16 *)0xFFC00EA8);
		debugfs_create_x16("MDMAFLX1_PMAP_D", 0600, parent, (u16 *)0xFFC00EAC);
		debugfs_create_x16("MDMAFLX1_XCOUNT_D", 0600, parent, (u16 *)0xFFC00E90);
		debugfs_create_x16("MDMAFLX1_XMODIFY_D", 0600, parent, (u16 *)0xFFC00E94);
		debugfs_create_x16("MDMAFLX1_YCOUNT_D", 0600, parent, (u16 *)0xFFC00E98);
		debugfs_create_x16("MDMAFLX1_YMODIFY_D", 0600, parent, (u16 *)0xFFC00E9C);
		debugfs_create_x16("MDMA_D1_CONFIG", 0600, parent, (u16 *)0xFFC00E88);
		debugfs_create_x32("MDMA_D1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EA4);
		debugfs_create_x32("MDMA_D1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EA0);
		debugfs_create_x16("MDMA_D1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EB0);
		debugfs_create_x16("MDMA_D1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EB8);
		debugfs_create_x16("MDMA_D1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EA8);
		debugfs_create_x32("MDMA_D1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E80);
		debugfs_create_x16("MDMA_D1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EAC);
		debugfs_create_x32("MDMA_D1_START_ADDR", 0600, parent, (u32 *)0xFFC00E84);
		debugfs_create_x16("MDMA_D1_X_COUNT", 0600, parent, (u16 *)0xFFC00E90);
		debugfs_create_x16("MDMA_D1_X_MODIFY", 0600, parent, (u16 *)0xFFC00E94);
		debugfs_create_x16("MDMA_D1_Y_COUNT", 0600, parent, (u16 *)0xFFC00E98);
		debugfs_create_x16("MDMA_D1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E9C);

		parent = debugfs_create_dir("MEMDMA1 Source Registers", top);
		debugfs_create_x16("MDMAFLX1_CURXCOUNT_S", 0600, parent, (u16 *)0xFFC00EF0);
		debugfs_create_x16("MDMAFLX1_CURYCOUNT_S", 0600, parent, (u16 *)0xFFC00EF8);
		debugfs_create_x16("MDMAFLX1_DMACNFG_S", 0600, parent, (u16 *)0xFFC00EC8);
		debugfs_create_x16("MDMAFLX1_IRQSTAT_S", 0600, parent, (u16 *)0xFFC00EE8);
		debugfs_create_x16("MDMAFLX1_PMAP_S", 0600, parent, (u16 *)0xFFC00EEC);
		debugfs_create_x16("MDMAFLX1_XCOUNT_S", 0600, parent, (u16 *)0xFFC00ED0);
		debugfs_create_x16("MDMAFLX1_XMODIFY_S", 0600, parent, (u16 *)0xFFC00ED4);
		debugfs_create_x16("MDMAFLX1_YCOUNT_S", 0600, parent, (u16 *)0xFFC00ED8);
		debugfs_create_x16("MDMAFLX1_YMODIFY_S", 0600, parent, (u16 *)0xFFC00EDC);
		debugfs_create_x16("MDMA_S1_CONFIG", 0600, parent, (u16 *)0xFFC00EC8);
		debugfs_create_x32("MDMA_S1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EE4);
		debugfs_create_x32("MDMA_S1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EE0);
		debugfs_create_x16("MDMA_S1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EF0);
		debugfs_create_x16("MDMA_S1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EF8);
		debugfs_create_x16("MDMA_S1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EE8);
		debugfs_create_x32("MDMA_S1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00EC0);
		debugfs_create_x16("MDMA_S1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EEC);
		debugfs_create_x32("MDMA_S1_START_ADDR", 0600, parent, (u32 *)0xFFC00EC4);
		debugfs_create_x16("MDMA_S1_X_COUNT", 0600, parent, (u16 *)0xFFC00ED0);
		debugfs_create_x16("MDMA_S1_X_MODIFY", 0600, parent, (u16 *)0xFFC00ED4);
		debugfs_create_x16("MDMA_S1_Y_COUNT", 0600, parent, (u16 *)0xFFC00ED8);
		debugfs_create_x16("MDMA_S1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00EDC);

		parent = debugfs_create_dir("PLL", top);
		debugfs_create_x16("PLL_CTL", 0600, parent, (u16 *)0xFFC00000);
		debugfs_create_x16("PLL_DIV", 0600, parent, (u16 *)0xFFC00004);
		debugfs_create_x16("PLL_LOCKCNT", 0600, parent, (u16 *)0xFFC00010);
		debugfs_create_x16("PLL_STAT", 0600, parent, (u16 *)0xFFC0000C);
		debugfs_create_x32("SWRST", 0600, parent, (u32 *)0xFFC00100);
		debugfs_create_x32("SYSCR", 0600, parent, (u32 *)0xFFC00104);
		debugfs_create_x16("VR_CTL", 0600, parent, (u16 *)0xFFC00008);

		parent = debugfs_create_dir("PPI", top);
		debugfs_create_x16("PPI_CONTROL", 0600, parent, (u16 *)0xFFC01000);
		debugfs_create_x16("PPI_COUNT", 0600, parent, (u16 *)0xFFC01008);
		debugfs_create_x16("PPI_DELAY", 0600, parent, (u16 *)0xFFC0100C);
		debugfs_create_x16("PPI_FRAME", 0600, parent, (u16 *)0xFFC01010);
		debugfs_create_x16("PPI_STATUS", 0600, parent, (u16 *)0xFFC01004);

		parent = debugfs_create_dir("Performance Monitor", top);
		debugfs_create_x32("PFCNTR0", 0600, parent, (u32 *)0xFFE08100);
		debugfs_create_x32("PFCNTR1", 0600, parent, (u32 *)0xFFE08104);
		debugfs_create_x32("PFCTL", 0600, parent, (u32 *)0xFFE08000);

		parent = debugfs_create_dir("RTC", top);
		debugfs_create_x32("RTC_ALARM", 0600, parent, (u32 *)0xFFC00310);
		debugfs_create_x16("RTC_ICTL", 0600, parent, (u16 *)0xFFC00304);
		debugfs_create_x16("RTC_ISTAT", 0600, parent, (u16 *)0xFFC00308);
		debugfs_create_x16("RTC_PREN", 0600, parent, (u16 *)0xFFC00314);
		debugfs_create_x32("RTC_STAT", 0600, parent, (u32 *)0xFFC00300);
		debugfs_create_x16("RTC_SWCNT", 0600, parent, (u16 *)0xFFC0030C);

		parent = debugfs_create_dir("SPI", top);
		debugfs_create_x16("SPI_BAUD", 0600, parent, (u16 *)0xFFC00514);
		debugfs_create_x16("SPI_CTL", 0600, parent, (u16 *)0xFFC00500);
		debugfs_create_x16("SPI_FLG", 0600, parent, (u16 *)0xFFC00504);
		debugfs_create_x16("SPI_RDBR", 0600, parent, (u16 *)0xFFC00510);
		debugfs_create_x16("SPI_SHADOW", 0600, parent, (u16 *)0xFFC00518);
		debugfs_create_x16("SPI_STAT", 0600, parent, (u16 *)0xFFC00508);
		debugfs_create_x16("SPI_TDBR", 0600, parent, (u16 *)0xFFC0050C);

		parent = debugfs_create_dir("SPORT", top);
		debugfs_create_x16("SPORT0_CHNL", 0600, parent, (u16 *)0xFFC00834);
		debugfs_create_x16("SPORT0_MCMC1", 0600, parent, (u16 *)0xFFC00838);
		debugfs_create_x16("SPORT0_MCMC2", 0600, parent, (u16 *)0xFFC0083C);
		debugfs_create_x16("SPORT0_RCLKDIV", 0600, parent, (u16 *)0xFFC00828);
		debugfs_create_x16("SPORT0_RCR1", 0600, parent, (u16 *)0xFFC00820);
		debugfs_create_x16("SPORT0_RCR2", 0600, parent, (u16 *)0xFFC00824);
		debugfs_create_x16("SPORT0_RFSDIV", 0600, parent, (u16 *)0xFFC0082C);
		debugfs_create_x32("SPORT0_RX", 0600, parent, (u32 *)0xFFC00818);
		debugfs_create_x16("SPORT0_STAT", 0600, parent, (u16 *)0xFFC00830);
		debugfs_create_x16("SPORT0_TCLKDIV", 0600, parent, (u16 *)0xFFC00808);
		debugfs_create_x16("SPORT0_TCR1", 0600, parent, (u16 *)0xFFC00800);
		debugfs_create_x16("SPORT0_TCR2", 0600, parent, (u16 *)0xFFC00804);
		debugfs_create_x16("SPORT0_TFSDIV", 0600, parent, (u16 *)0xFFC0080C);
		debugfs_create_x32("SPORT0_TX", 0600, parent, (u32 *)0xFFC00810);
		debugfs_create_x16("SPORT1_CHNL", 0600, parent, (u16 *)0xFFC00934);
		debugfs_create_x16("SPORT1_MCMC1", 0600, parent, (u16 *)0xFFC00938);
		debugfs_create_x16("SPORT1_MCMC2", 0600, parent, (u16 *)0xFFC0093C);
		debugfs_create_x16("SPORT1_RCLKDIV", 0600, parent, (u16 *)0xFFC00928);
		debugfs_create_x16("SPORT1_RCR1", 0600, parent, (u16 *)0xFFC00920);
		debugfs_create_x16("SPORT1_RCR2", 0600, parent, (u16 *)0xFFC00924);
		debugfs_create_x16("SPORT1_RFSDIV", 0600, parent, (u16 *)0xFFC0092C);
		debugfs_create_x32("SPORT1_RX", 0600, parent, (u32 *)0xFFC00918);
		debugfs_create_x16("SPORT1_STAT", 0600, parent, (u16 *)0xFFC00930);
		debugfs_create_x16("SPORT1_TCLKDIV", 0600, parent, (u16 *)0xFFC00908);
		debugfs_create_x16("SPORT1_TCR1", 0600, parent, (u16 *)0xFFC00900);
		debugfs_create_x16("SPORT1_TCR2", 0600, parent, (u16 *)0xFFC00904);
		debugfs_create_x16("SPORT1_TFSDIV", 0600, parent, (u16 *)0xFFC0090C);
		debugfs_create_x32("SPORT1_TX", 0600, parent, (u32 *)0xFFC00910);

		parent = debugfs_create_dir("SPT0", top);
		debugfs_create_x16("SPT0_CHNL", 0600, parent, (u16 *)0xFFC00834);
		debugfs_create_x16("SPT0_MCMC1", 0600, parent, (u16 *)0xFFC00838);
		debugfs_create_x16("SPT0_MCMC2", 0600, parent, (u16 *)0xFFC0083C);
		debugfs_create_x32("SPT0_MRCS0", 0600, parent, (u32 *)0xFFC00850);
		debugfs_create_x32("SPT0_MRCS1", 0600, parent, (u32 *)0xFFC00854);
		debugfs_create_x32("SPT0_MRCS2", 0600, parent, (u32 *)0xFFC00858);
		debugfs_create_x32("SPT0_MRCS3", 0600, parent, (u32 *)0xFFC0085C);
		debugfs_create_x32("SPT0_MTCS0", 0600, parent, (u32 *)0xFFC00840);
		debugfs_create_x32("SPT0_MTCS1", 0600, parent, (u32 *)0xFFC00844);
		debugfs_create_x32("SPT0_MTCS2", 0600, parent, (u32 *)0xFFC00848);
		debugfs_create_x32("SPT0_MTCS3", 0600, parent, (u32 *)0xFFC0084C);
		debugfs_create_x16("SPT0_RFSDIV", 0600, parent, (u16 *)0xFFC0082C);
		debugfs_create_x16("SPT0_RSCLKDIV", 0600, parent, (u16 *)0xFFC00828);
		debugfs_create_x32("SPT0_RX", 0600, parent, (u32 *)0xFFC00818);
		debugfs_create_x16("SPT0_RX_CONFIG0", 0600, parent, (u16 *)0xFFC00820);
		debugfs_create_x16("SPT0_RX_CONFIG1", 0600, parent, (u16 *)0xFFC00824);
		debugfs_create_x16("SPT0_STAT", 0600, parent, (u16 *)0xFFC00830);
		debugfs_create_x16("SPT0_TFSDIV", 0600, parent, (u16 *)0xFFC0080C);
		debugfs_create_x16("SPT0_TSCLKDIV", 0600, parent, (u16 *)0xFFC00808);
		debugfs_create_x32("SPT0_TX", 0600, parent, (u32 *)0xFFC00810);
		debugfs_create_x16("SPT0_TX_CONFIG0", 0600, parent, (u16 *)0xFFC00800);
		debugfs_create_x16("SPT0_TX_CONFIG1", 0600, parent, (u16 *)0xFFC00804);
		debugfs_create_x16("SPT1_CHNL", 0600, parent, (u16 *)0xFFC00934);

		parent = debugfs_create_dir("SPT1", top);
		debugfs_create_x16("SPT1_MCMC1", 0600, parent, (u16 *)0xFFC00938);
		debugfs_create_x16("SPT1_MCMC2", 0600, parent, (u16 *)0xFFC0093C);
		debugfs_create_x32("SPT1_MRCS0", 0600, parent, (u32 *)0xFFC00950);
		debugfs_create_x32("SPT1_MRCS1", 0600, parent, (u32 *)0xFFC00954);
		debugfs_create_x32("SPT1_MRCS2", 0600, parent, (u32 *)0xFFC00958);
		debugfs_create_x32("SPT1_MRCS3", 0600, parent, (u32 *)0xFFC0095C);
		debugfs_create_x32("SPT1_MTCS0", 0600, parent, (u32 *)0xFFC00940);
		debugfs_create_x32("SPT1_MTCS1", 0600, parent, (u32 *)0xFFC00944);
		debugfs_create_x32("SPT1_MTCS2", 0600, parent, (u32 *)0xFFC00948);
		debugfs_create_x32("SPT1_MTCS3", 0600, parent, (u32 *)0xFFC0094C);
		debugfs_create_x16("SPT1_RFSDIV", 0600, parent, (u16 *)0xFFC0092C);
		debugfs_create_x16("SPT1_RSCLKDIV", 0600, parent, (u16 *)0xFFC00928);
		debugfs_create_x16("SPT1_RX", 0600, parent, (u16 *)0xFFC00918);
		debugfs_create_x16("SPT1_RX_CONFIG0", 0600, parent, (u16 *)0xFFC00920);
		debugfs_create_x16("SPT1_RX_CONFIG1", 0600, parent, (u16 *)0xFFC00924);
		debugfs_create_x16("SPT1_STAT", 0600, parent, (u16 *)0xFFC00930);
		debugfs_create_x16("SPT1_TFSDIV", 0600, parent, (u16 *)0xFFC0090C);
		debugfs_create_x16("SPT1_TSCLKDIV", 0600, parent, (u16 *)0xFFC00908);
		debugfs_create_x16("SPT1_TX", 0600, parent, (u16 *)0xFFC00910);
		debugfs_create_x16("SPT1_TX_CONFIG0", 0600, parent, (u16 *)0xFFC00900);
		debugfs_create_x16("SPT1_TX_CONFIG1", 0600, parent, (u16 *)0xFFC00904);

		parent = debugfs_create_dir("System Interrupt Controller Register File", top);
		debugfs_create_x32("SIC_IAR0", 0600, parent, (u32 *)0xFFC00110);
		debugfs_create_x32("SIC_IAR1", 0600, parent, (u32 *)0xFFC00114);
		debugfs_create_x32("SIC_IAR2", 0600, parent, (u32 *)0xFFC00118);
		debugfs_create_x32("SIC_IAR3", 0600, parent, (u32 *)0xFFC0011C);
		debugfs_create_x32("SIC_IMASK", 0600, parent, (u32 *)0xFFC0010C);
		debugfs_create_x32("SIC_ISR", 0600, parent, (u32 *)0xFFC00120);
		debugfs_create_x32("SIC_IWR", 0600, parent, (u32 *)0xFFC00124);
		debugfs_create_x16("SIC_RVECT", 0600, parent, (u16 *)0xFFC00108);

		parent = debugfs_create_dir("Timer Registers", top);
		debugfs_create_x16("TIMER0_CONFIG", 0600, parent, (u16 *)0xFFC00600);
		debugfs_create_x32("TIMER0_COUNTER", 0600, parent, (u32 *)0xFFC00604);
		debugfs_create_x32("TIMER0_PERIOD", 0600, parent, (u32 *)0xFFC00608);
		debugfs_create_x32("TIMER0_WIDTH", 0600, parent, (u32 *)0xFFC0060C);
		debugfs_create_x16("TIMER1_CONFIG", 0600, parent, (u16 *)0xFFC00610);
		debugfs_create_x32("TIMER1_COUNTER", 0600, parent, (u32 *)0xFFC00614);
		debugfs_create_x32("TIMER1_PERIOD", 0600, parent, (u32 *)0xFFC00618);
		debugfs_create_x32("TIMER1_WIDTH", 0600, parent, (u32 *)0xFFC0061C);
		debugfs_create_x16("TIMER2_CONFIG", 0600, parent, (u16 *)0xFFC00620);
		debugfs_create_x32("TIMER2_COUNTER", 0600, parent, (u32 *)0xFFC00624);
		debugfs_create_x32("TIMER2_PERIOD", 0600, parent, (u32 *)0xFFC00628);
		debugfs_create_x32("TIMER2_WIDTH", 0600, parent, (u32 *)0xFFC0062C);
		debugfs_create_x16("TIMER_DISABLE", 0600, parent, (u16 *)0xFFC00644);
		debugfs_create_x16("TIMER_ENABLE", 0600, parent, (u16 *)0xFFC00640);
		debugfs_create_x16("TIMER_STATUS", 0600, parent, (u16 *)0xFFC00648);

		parent = debugfs_create_dir("Trace Unit", top);
		debugfs_create_x32("TBUF", 0600, parent, (u32 *)0xFFE06100);
		debugfs_create_x32("TBUFCTL", 0600, parent, (u32 *)0xFFE06000);
		debugfs_create_x32("TBUFSTAT", 0600, parent, (u32 *)0xFFE06004);

		parent = debugfs_create_dir("UART", top);
		debugfs_create_x16("UART_DLH", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART_DLL", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART_GCTL", 0600, parent, (u16 *)0xFFC00424);
		debugfs_create_x16("UART_IER", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART_IIR", 0600, parent, (u16 *)0xFFC00408);
		debugfs_create_x16("UART_LCR", 0600, parent, (u16 *)0xFFC0040C);
		debugfs_create_x16("UART_LSR", 0600, parent, (u16 *)0xFFC00414);
		debugfs_create_x16("UART_MCR", 0600, parent, (u16 *)0xFFC00410);
		debugfs_create_x16("UART_RBR", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART_SCR", 0600, parent, (u16 *)0xFFC0041C);
		debugfs_create_x16("UART_THR", 0600, parent, (u16 *)0xFFC00400);

		parent = debugfs_create_dir("Watchdog", top);
		debugfs_create_x32("WDOG_CNT", 0600, parent, (u32 *)0xFFC00204);
		debugfs_create_x16("WDOG_CTL", 0600, parent, (u16 *)0xFFC00200);
		debugfs_create_x32("WDOG_STAT", 0600, parent, (u32 *)0xFFC00208);

		parent = debugfs_create_dir("Watchpoint and Patch Unit", top);
		debugfs_create_x32("WPDA0", 0600, parent, (u32 *)0xFFE07140);
		debugfs_create_x32("WPDA1", 0600, parent, (u32 *)0xFFE07144);
		debugfs_create_x32("WPDACNT0", 0600, parent, (u32 *)0xFFE07180);
		debugfs_create_x32("WPDACNT1", 0600, parent, (u32 *)0xFFE07184);
		debugfs_create_x32("WPDACTL", 0600, parent, (u32 *)0xFFE07100);
		debugfs_create_x32("WPIA0", 0600, parent, (u32 *)0xFFE07040);
		debugfs_create_x32("WPIA1", 0600, parent, (u32 *)0xFFE07044);
		debugfs_create_x32("WPIA2", 0600, parent, (u32 *)0xFFE07048);
		debugfs_create_x32("WPIA3", 0600, parent, (u32 *)0xFFE0704C);
		debugfs_create_x32("WPIA4", 0600, parent, (u32 *)0xFFE07050);
		debugfs_create_x32("WPIA5", 0600, parent, (u32 *)0xFFE07054);
		debugfs_create_x32("WPIACNT0", 0600, parent, (u32 *)0xFFE07080);
		debugfs_create_x32("WPIACNT1", 0600, parent, (u32 *)0xFFE07084);
		debugfs_create_x32("WPIACNT2", 0600, parent, (u32 *)0xFFE07088);
		debugfs_create_x32("WPIACNT3", 0600, parent, (u32 *)0xFFE0708C);
		debugfs_create_x32("WPIACNT4", 0600, parent, (u32 *)0xFFE07090);
		debugfs_create_x32("WPIACNT5", 0600, parent, (u32 *)0xFFE07094);
		debugfs_create_x32("WPIACTL", 0600, parent, (u32 *)0xFFE07000);
		debugfs_create_x32("WPSTAT", 0600, parent, (u32 *)0xFFE07200);

	}	/* BF532 */

#ifdef __ADSPBF533__
# define USE_BF533 1
#else
# define USE_BF533 0
#endif
	if (USE_BF533) {

		parent = debugfs_create_dir("Core Timer Register File", top);
		debugfs_create_x32("TCNTL", 0600, parent, (u32 *)0xFFE03000);
		debugfs_create_x32("TCOUNT", 0600, parent, (u32 *)0xFFE0300C);
		debugfs_create_x32("TPERIOD", 0600, parent, (u32 *)0xFFE03004);
		debugfs_create_x32("TSCALE", 0600, parent, (u32 *)0xFFE03008);

		parent = debugfs_create_dir("DMA Traffic Control", top);
		debugfs_create_x16("DMA_TC_CNT", 0600, parent, (u16 *)0xFFC00B0C);
		debugfs_create_x16("DMA_TC_PER", 0600, parent, (u16 *)0xFFC00B10);

		parent = debugfs_create_dir("DMAFlex Ch-0 Registers", top);
		debugfs_create_x32("DMA0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C24);
		debugfs_create_x32("DMA0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C20);
		debugfs_create_x32("DMA0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C00);
		debugfs_create_x32("DMA0_START_ADDR", 0600, parent, (u32 *)0xFFC00C04);
		debugfs_create_x16("DMAFLX0_CURXCOUNT", 0600, parent, (u16 *)0xFFC00C30);
		debugfs_create_x16("DMAFLX0_CURYCOUNT", 0600, parent, (u16 *)0xFFC00C38);
		debugfs_create_x16("DMAFLX0_DMACNFG", 0600, parent, (u16 *)0xFFC00C08);
		debugfs_create_x16("DMAFLX0_IRQSTAT", 0600, parent, (u16 *)0xFFC00C28);
		debugfs_create_x16("DMAFLX0_PMAP", 0600, parent, (u16 *)0xFFC00C2C);
		debugfs_create_x16("DMAFLX0_XCOUNT", 0600, parent, (u16 *)0xFFC00C10);
		debugfs_create_x16("DMAFLX0_XMODIFY", 0600, parent, (u16 *)0xFFC00C14);
		debugfs_create_x16("DMAFLX0_YCOUNT", 0600, parent, (u16 *)0xFFC00C18);
		debugfs_create_x16("DMAFLX0_YMODIFY", 0600, parent, (u16 *)0xFFC00C1C);

		parent = debugfs_create_dir("DMAFlex Ch-1 Registers", top);
		debugfs_create_x32("DMA1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C64);
		debugfs_create_x32("DMA1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C60);
		debugfs_create_x32("DMA1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C40);
		debugfs_create_x32("DMA1_START_ADDR", 0600, parent, (u32 *)0xFFC00C44);
		debugfs_create_x16("DMAFLX1_CURXCOUNT", 0600, parent, (u16 *)0xFFC00C70);
		debugfs_create_x16("DMAFLX1_CURYCOUNT", 0600, parent, (u16 *)0xFFC00C78);
		debugfs_create_x16("DMAFLX1_DMACNFG", 0600, parent, (u16 *)0xFFC00C48);
		debugfs_create_x16("DMAFLX1_IRQSTAT", 0600, parent, (u16 *)0xFFC00C68);
		debugfs_create_x16("DMAFLX1_PMAP", 0600, parent, (u16 *)0xFFC00C6C);
		debugfs_create_x16("DMAFLX1_XCOUNT", 0600, parent, (u16 *)0xFFC00C50);
		debugfs_create_x16("DMAFLX1_XMODIFY", 0600, parent, (u16 *)0xFFC00C54);
		debugfs_create_x16("DMAFLX1_YCOUNT", 0600, parent, (u16 *)0xFFC00C58);
		debugfs_create_x16("DMAFLX1_YMODIFY", 0600, parent, (u16 *)0xFFC00C5C);

		parent = debugfs_create_dir("DMAFlex Ch-2 Registers", top);
		debugfs_create_x32("DMA2_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CA4);
		debugfs_create_x32("DMA2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CA0);
		debugfs_create_x32("DMA2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C80);
		debugfs_create_x32("DMA2_START_ADDR", 0600, parent, (u32 *)0xFFC00C84);
		debugfs_create_x16("DMAFLX2_CURXCOUNT", 0600, parent, (u16 *)0xFFC00CB0);
		debugfs_create_x16("DMAFLX2_CURYCOUNT", 0600, parent, (u16 *)0xFFC00CB8);
		debugfs_create_x16("DMAFLX2_DMACNFG", 0600, parent, (u16 *)0xFFC00C88);
		debugfs_create_x16("DMAFLX2_IRQSTAT", 0600, parent, (u16 *)0xFFC00CA8);
		debugfs_create_x16("DMAFLX2_PMAP", 0600, parent, (u16 *)0xFFC00CAC);
		debugfs_create_x16("DMAFLX2_XCOUNT", 0600, parent, (u16 *)0xFFC00C90);
		debugfs_create_x16("DMAFLX2_XMODIFY", 0600, parent, (u16 *)0xFFC00C94);
		debugfs_create_x16("DMAFLX2_YCOUNT", 0600, parent, (u16 *)0xFFC00C98);
		debugfs_create_x16("DMAFLX2_YMODIFY", 0600, parent, (u16 *)0xFFC00C9C);

		parent = debugfs_create_dir("DMAFlex Ch-3 Registers", top);
		debugfs_create_x32("DMA3_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CE4);
		debugfs_create_x32("DMA3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CE0);
		debugfs_create_x32("DMA3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00CC0);
		debugfs_create_x32("DMA3_START_ADDR", 0600, parent, (u32 *)0xFFC00CC4);
		debugfs_create_x16("DMAFLX3_CURXCOUNT", 0600, parent, (u16 *)0xFFC00CF0);
		debugfs_create_x16("DMAFLX3_CURYCOUNT", 0600, parent, (u16 *)0xFFC00CF8);
		debugfs_create_x16("DMAFLX3_DMACNFG", 0600, parent, (u16 *)0xFFC00CC8);
		debugfs_create_x16("DMAFLX3_IRQSTAT", 0600, parent, (u16 *)0xFFC00CE8);
		debugfs_create_x16("DMAFLX3_PMAP", 0600, parent, (u16 *)0xFFC00CEC);
		debugfs_create_x16("DMAFLX3_XCOUNT", 0600, parent, (u16 *)0xFFC00CD0);
		debugfs_create_x16("DMAFLX3_XMODIFY", 0600, parent, (u16 *)0xFFC00CD4);
		debugfs_create_x16("DMAFLX3_YCOUNT", 0600, parent, (u16 *)0xFFC00CD8);
		debugfs_create_x16("DMAFLX3_YMODIFY", 0600, parent, (u16 *)0xFFC00CDC);

		parent = debugfs_create_dir("DMAFlex Ch-4 Registers", top);
		debugfs_create_x32("DMA4_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D24);
		debugfs_create_x32("DMA4_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D20);
		debugfs_create_x32("DMA4_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D00);
		debugfs_create_x32("DMA4_START_ADDR", 0600, parent, (u32 *)0xFFC00D04);
		debugfs_create_x16("DMAFLX4_CURXCOUNT", 0600, parent, (u16 *)0xFFC00D30);
		debugfs_create_x16("DMAFLX4_CURYCOUNT", 0600, parent, (u16 *)0xFFC00D38);
		debugfs_create_x16("DMAFLX4_DMACNFG", 0600, parent, (u16 *)0xFFC00D08);
		debugfs_create_x16("DMAFLX4_IRQSTAT", 0600, parent, (u16 *)0xFFC00D28);
		debugfs_create_x16("DMAFLX4_PMAP", 0600, parent, (u16 *)0xFFC00D2C);
		debugfs_create_x16("DMAFLX4_XCOUNT", 0600, parent, (u16 *)0xFFC00D10);
		debugfs_create_x16("DMAFLX4_XMODIFY", 0600, parent, (u16 *)0xFFC00D14);
		debugfs_create_x16("DMAFLX4_YCOUNT", 0600, parent, (u16 *)0xFFC00D18);
		debugfs_create_x16("DMAFLX4_YMODIFY", 0600, parent, (u16 *)0xFFC00D1C);

		parent = debugfs_create_dir("DMAFlex Ch-5 Registers", top);
		debugfs_create_x32("DMA5_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D64);
		debugfs_create_x32("DMA5_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D60);
		debugfs_create_x32("DMA5_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D40);
		debugfs_create_x32("DMA5_START_ADDR", 0600, parent, (u32 *)0xFFC00D44);
		debugfs_create_x16("DMAFLX5_CURXCOUNT", 0600, parent, (u16 *)0xFFC00D70);
		debugfs_create_x16("DMAFLX5_CURYCOUNT", 0600, parent, (u16 *)0xFFC00D78);
		debugfs_create_x16("DMAFLX5_DMACNFG", 0600, parent, (u16 *)0xFFC00D48);
		debugfs_create_x16("DMAFLX5_IRQSTAT", 0600, parent, (u16 *)0xFFC00D68);
		debugfs_create_x16("DMAFLX5_PMAP", 0600, parent, (u16 *)0xFFC00D6C);
		debugfs_create_x16("DMAFLX5_XCOUNT", 0600, parent, (u16 *)0xFFC00D50);
		debugfs_create_x16("DMAFLX5_XMODIFY", 0600, parent, (u16 *)0xFFC00D54);
		debugfs_create_x16("DMAFLX5_YCOUNT", 0600, parent, (u16 *)0xFFC00D58);
		debugfs_create_x16("DMAFLX5_YMODIFY", 0600, parent, (u16 *)0xFFC00D5C);

		parent = debugfs_create_dir("DMAFlex Ch-6 Registers", top);
		debugfs_create_x32("DMA6_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DA4);
		debugfs_create_x32("DMA6_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DA0);
		debugfs_create_x32("DMA6_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D80);
		debugfs_create_x32("DMA6_START_ADDR", 0600, parent, (u32 *)0xFFC00D84);
		debugfs_create_x16("DMAFLX6_CURXCOUNT", 0600, parent, (u16 *)0xFFC00DB0);
		debugfs_create_x16("DMAFLX6_CURYCOUNT", 0600, parent, (u16 *)0xFFC00DB8);
		debugfs_create_x16("DMAFLX6_DMACNFG", 0600, parent, (u16 *)0xFFC00D88);
		debugfs_create_x16("DMAFLX6_IRQSTAT", 0600, parent, (u16 *)0xFFC00DA8);
		debugfs_create_x16("DMAFLX6_PMAP", 0600, parent, (u16 *)0xFFC00DAC);
		debugfs_create_x16("DMAFLX6_XCOUNT", 0600, parent, (u16 *)0xFFC00D90);
		debugfs_create_x16("DMAFLX6_XMODIFY", 0600, parent, (u16 *)0xFFC00D94);
		debugfs_create_x16("DMAFLX6_YCOUNT", 0600, parent, (u16 *)0xFFC00D98);
		debugfs_create_x16("DMAFLX6_YMODIFY", 0600, parent, (u16 *)0xFFC00D9C);

		parent = debugfs_create_dir("DMAFlex Ch-7 Registers", top);
		debugfs_create_x32("DMA7_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DE4);
		debugfs_create_x32("DMA7_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DE0);
		debugfs_create_x32("DMA7_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00DC0);
		debugfs_create_x32("DMA7_START_ADDR", 0600, parent, (u32 *)0xFFC00DC4);
		debugfs_create_x16("DMAFLX7_CURXCOUNT", 0600, parent, (u16 *)0xFFC00DF0);
		debugfs_create_x16("DMAFLX7_CURYCOUNT", 0600, parent, (u16 *)0xFFC00DF8);
		debugfs_create_x16("DMAFLX7_DMACNFG", 0600, parent, (u16 *)0xFFC00DC8);
		debugfs_create_x16("DMAFLX7_IRQSTAT", 0600, parent, (u16 *)0xFFC00DE8);
		debugfs_create_x16("DMAFLX7_PMAP", 0600, parent, (u16 *)0xFFC00DEC);
		debugfs_create_x16("DMAFLX7_XCOUNT", 0600, parent, (u16 *)0xFFC00DD0);
		debugfs_create_x16("DMAFLX7_XMODIFY", 0600, parent, (u16 *)0xFFC00DD4);
		debugfs_create_x16("DMAFLX7_YCOUNT", 0600, parent, (u16 *)0xFFC00DD8);
		debugfs_create_x16("DMAFLX7_YMODIFY", 0600, parent, (u16 *)0xFFC00DDC);

		parent = debugfs_create_dir("Data Cache Programmable Look-Aside Buffer Fault Address", top);
		debugfs_create_x32("DCPLB_FAULT_STATUS", 0600, parent, (u32 *)0xFFE00008);

		parent = debugfs_create_dir("EBIU", top);
		debugfs_create_x32("EBIU_AMBCTL0", 0600, parent, (u32 *)0xFFC00A04);
		debugfs_create_x32("EBIU_AMBCTL1", 0600, parent, (u32 *)0xFFC00A08);
		debugfs_create_x16("EBIU_AMGCTL", 0600, parent, (u16 *)0xFFC00A00);
		debugfs_create_x16("EBIU_SDBCTL", 0600, parent, (u16 *)0xFFC00A14);
		debugfs_create_x32("EBIU_SDGCTL", 0600, parent, (u32 *)0xFFC00A10);
		debugfs_create_x16("EBIU_SDRRC", 0600, parent, (u16 *)0xFFC00A18);
		debugfs_create_x16("EBIU_SDSTAT", 0600, parent, (u16 *)0xFFC00A1C);

		parent = debugfs_create_dir("Event Vectors", top);
		debugfs_create_x32("EVT0", 0600, parent, (u32 *)0xFFE02000);
		debugfs_create_x32("EVT10", 0600, parent, (u32 *)0xFFE02028);
		debugfs_create_x32("EVT11", 0600, parent, (u32 *)0xFFE0202C);
		debugfs_create_x32("EVT12", 0600, parent, (u32 *)0xFFE02030);
		debugfs_create_x32("EVT13", 0600, parent, (u32 *)0xFFE02034);
		debugfs_create_x32("EVT14", 0600, parent, (u32 *)0xFFE02038);
		debugfs_create_x32("EVT15", 0600, parent, (u32 *)0xFFE0203C);
		debugfs_create_x32("EVT1", 0600, parent, (u32 *)0xFFE02004);
		debugfs_create_x32("EVT2", 0600, parent, (u32 *)0xFFE02008);
		debugfs_create_x32("EVT3", 0600, parent, (u32 *)0xFFE0200C);
		debugfs_create_x32("EVT4", 0600, parent, (u32 *)0xFFE02010);
		debugfs_create_x32("EVT5", 0600, parent, (u32 *)0xFFE02014);
		debugfs_create_x32("EVT6", 0600, parent, (u32 *)0xFFE02018);
		debugfs_create_x32("EVT7", 0600, parent, (u32 *)0xFFE0201C);
		debugfs_create_x32("EVT8", 0600, parent, (u32 *)0xFFE02020);
		debugfs_create_x32("EVT9", 0600, parent, (u32 *)0xFFE02024);

		parent = debugfs_create_dir("Extended Registers", top);
		debugfs_create_x32("CHIPID", 0600, parent, (u32 *)0xFFC00014);
		debugfs_create_x16("DMA0_CONFIG", 0600, parent, (u16 *)0xFFC00C08);
		debugfs_create_x16("DMA0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C30);
		debugfs_create_x16("DMA0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C38);
		debugfs_create_x16("DMA0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C28);
		debugfs_create_x16("DMA0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C2C);
		debugfs_create_x16("DMA0_X_COUNT", 0600, parent, (u16 *)0xFFC00C10);
		debugfs_create_x16("DMA0_X_MODIFY", 0600, parent, (u16 *)0xFFC00C14);
		debugfs_create_x16("DMA0_Y_COUNT", 0600, parent, (u16 *)0xFFC00C18);
		debugfs_create_x16("DMA0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C1C);
		debugfs_create_x16("DMA1_CONFIG", 0600, parent, (u16 *)0xFFC00C48);
		debugfs_create_x16("DMA1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C70);
		debugfs_create_x16("DMA1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C78);
		debugfs_create_x16("DMA1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C68);
		debugfs_create_x16("DMA1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C6C);
		debugfs_create_x16("DMA1_X_COUNT", 0600, parent, (u16 *)0xFFC00C50);
		debugfs_create_x16("DMA1_X_MODIFY", 0600, parent, (u16 *)0xFFC00C54);
		debugfs_create_x16("DMA1_Y_COUNT", 0600, parent, (u16 *)0xFFC00C58);
		debugfs_create_x16("DMA1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C5C);
		debugfs_create_x16("DMA2_CONFIG", 0600, parent, (u16 *)0xFFC00C88);
		debugfs_create_x16("DMA2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CB0);
		debugfs_create_x16("DMA2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CB8);
		debugfs_create_x16("DMA2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CA8);
		debugfs_create_x16("DMA2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CAC);
		debugfs_create_x16("DMA2_X_COUNT", 0600, parent, (u16 *)0xFFC00C90);
		debugfs_create_x16("DMA2_X_MODIFY", 0600, parent, (u16 *)0xFFC00C94);
		debugfs_create_x16("DMA2_Y_COUNT", 0600, parent, (u16 *)0xFFC00C98);
		debugfs_create_x16("DMA2_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C9C);
		debugfs_create_x16("DMA3_CONFIG", 0600, parent, (u16 *)0xFFC00CC8);
		debugfs_create_x16("DMA3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CF0);
		debugfs_create_x16("DMA3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CF8);
		debugfs_create_x16("DMA3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CE8);
		debugfs_create_x16("DMA3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CEC);
		debugfs_create_x16("DMA3_X_COUNT", 0600, parent, (u16 *)0xFFC00CD0);
		debugfs_create_x16("DMA3_X_MODIFY", 0600, parent, (u16 *)0xFFC00CD4);
		debugfs_create_x16("DMA3_Y_COUNT", 0600, parent, (u16 *)0xFFC00CD8);
		debugfs_create_x16("DMA3_Y_MODIFY", 0600, parent, (u16 *)0xFFC00CDC);
		debugfs_create_x16("DMA4_CONFIG", 0600, parent, (u16 *)0xFFC00D08);
		debugfs_create_x16("DMA4_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D30);
		debugfs_create_x16("DMA4_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D38);
		debugfs_create_x16("DMA4_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D28);
		debugfs_create_x16("DMA4_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D2C);
		debugfs_create_x16("DMA4_X_COUNT", 0600, parent, (u16 *)0xFFC00D10);
		debugfs_create_x16("DMA4_X_MODIFY", 0600, parent, (u16 *)0xFFC00D14);
		debugfs_create_x16("DMA4_Y_COUNT", 0600, parent, (u16 *)0xFFC00D18);
		debugfs_create_x16("DMA4_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D1C);
		debugfs_create_x16("DMA5_CONFIG", 0600, parent, (u16 *)0xFFC00D48);
		debugfs_create_x16("DMA5_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D70);
		debugfs_create_x16("DMA5_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D78);
		debugfs_create_x16("DMA5_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D68);
		debugfs_create_x16("DMA5_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D6C);
		debugfs_create_x16("DMA5_X_COUNT", 0600, parent, (u16 *)0xFFC00D50);
		debugfs_create_x16("DMA5_X_MODIFY", 0600, parent, (u16 *)0xFFC00D54);
		debugfs_create_x16("DMA5_Y_COUNT", 0600, parent, (u16 *)0xFFC00D58);
		debugfs_create_x16("DMA5_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D5C);
		debugfs_create_x16("DMA6_CONFIG", 0600, parent, (u16 *)0xFFC00D88);
		debugfs_create_x16("DMA6_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DB0);
		debugfs_create_x16("DMA6_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DB8);
		debugfs_create_x16("DMA6_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DA8);
		debugfs_create_x16("DMA6_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DAC);
		debugfs_create_x16("DMA6_X_COUNT", 0600, parent, (u16 *)0xFFC00D90);
		debugfs_create_x16("DMA6_X_MODIFY", 0600, parent, (u16 *)0xFFC00D94);
		debugfs_create_x16("DMA6_Y_COUNT", 0600, parent, (u16 *)0xFFC00D98);
		debugfs_create_x16("DMA6_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D9C);
		debugfs_create_x16("DMA7_CONFIG", 0600, parent, (u16 *)0xFFC00DC8);
		debugfs_create_x16("DMA7_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DF0);
		debugfs_create_x16("DMA7_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DF8);
		debugfs_create_x16("DMA7_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DE8);
		debugfs_create_x16("DMA7_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DEC);
		debugfs_create_x16("DMA7_X_COUNT", 0600, parent, (u16 *)0xFFC00DD0);
		debugfs_create_x16("DMA7_X_MODIFY", 0600, parent, (u16 *)0xFFC00DD4);
		debugfs_create_x16("DMA7_Y_COUNT", 0600, parent, (u16 *)0xFFC00DD8);
		debugfs_create_x16("DMA7_Y_MODIFY", 0600, parent, (u16 *)0xFFC00DDC);
		debugfs_create_x32("DSPID", 0600, parent, (u32 *)0xFFE05000);
		debugfs_create_x32("EVT_OVERRIDE", 0600, parent, (u32 *)0xFFE02100);
		debugfs_create_x16("FIO_BOTH", 0600, parent, (u16 *)0xFFC0073C);
		debugfs_create_x16("FIO_DIR", 0600, parent, (u16 *)0xFFC00730);
		debugfs_create_x16("FIO_EDGE", 0600, parent, (u16 *)0xFFC00738);
		debugfs_create_x16("FIO_FLAG_C", 0600, parent, (u16 *)0xFFC00704);
		debugfs_create_x16("FIO_FLAG_D", 0600, parent, (u16 *)0xFFC00700);
		debugfs_create_x16("FIO_FLAG_S", 0600, parent, (u16 *)0xFFC00708);
		debugfs_create_x16("FIO_FLAG_T", 0600, parent, (u16 *)0xFFC0070C);
		debugfs_create_x16("FIO_INEN", 0600, parent, (u16 *)0xFFC00740);
		debugfs_create_x16("FIO_MASKA_C", 0600, parent, (u16 *)0xFFC00714);
		debugfs_create_x16("FIO_MASKA_D", 0600, parent, (u16 *)0xFFC00710);
		debugfs_create_x16("FIO_MASKA_S", 0600, parent, (u16 *)0xFFC00718);
		debugfs_create_x16("FIO_MASKA_T", 0600, parent, (u16 *)0xFFC0071C);
		debugfs_create_x16("FIO_MASKB_C", 0600, parent, (u16 *)0xFFC00724);
		debugfs_create_x16("FIO_MASKB_D", 0600, parent, (u16 *)0xFFC00720);
		debugfs_create_x16("FIO_MASKB_S", 0600, parent, (u16 *)0xFFC00728);
		debugfs_create_x16("FIO_MASKB_T", 0600, parent, (u16 *)0xFFC0072C);
		debugfs_create_x16("FIO_POLAR", 0600, parent, (u16 *)0xFFC00734);

		parent = debugfs_create_dir("Interrupt Controller", top);
		debugfs_create_x32("ILAT", 0600, parent, (u32 *)0xFFE0210C);
		debugfs_create_x32("IMASK", 0600, parent, (u32 *)0xFFE02104);
		debugfs_create_x32("IPEND", 0600, parent, (u32 *)0xFFE02108);
		debugfs_create_x32("IPRIO", 0600, parent, (u32 *)0xFFE02110);

		parent = debugfs_create_dir("L1 Code Memory Registers", top);
		debugfs_create_x32("ICPLB_ADDR0", 0600, parent, (u32 *)0xFFE01100);
		debugfs_create_x32("ICPLB_ADDR10", 0600, parent, (u32 *)0xFFE01128);
		debugfs_create_x32("ICPLB_ADDR11", 0600, parent, (u32 *)0xFFE0112C);
		debugfs_create_x32("ICPLB_ADDR12", 0600, parent, (u32 *)0xFFE01130);
		debugfs_create_x32("ICPLB_ADDR13", 0600, parent, (u32 *)0xFFE01134);
		debugfs_create_x32("ICPLB_ADDR14", 0600, parent, (u32 *)0xFFE01138);
		debugfs_create_x32("ICPLB_ADDR15", 0600, parent, (u32 *)0xFFE0113C);
		debugfs_create_x32("ICPLB_ADDR1", 0600, parent, (u32 *)0xFFE01104);
		debugfs_create_x32("ICPLB_ADDR2", 0600, parent, (u32 *)0xFFE01108);
		debugfs_create_x32("ICPLB_ADDR3", 0600, parent, (u32 *)0xFFE0110C);
		debugfs_create_x32("ICPLB_ADDR4", 0600, parent, (u32 *)0xFFE01110);
		debugfs_create_x32("ICPLB_ADDR5", 0600, parent, (u32 *)0xFFE01114);
		debugfs_create_x32("ICPLB_ADDR6", 0600, parent, (u32 *)0xFFE01118);
		debugfs_create_x32("ICPLB_ADDR7", 0600, parent, (u32 *)0xFFE0111C);
		debugfs_create_x32("ICPLB_ADDR8", 0600, parent, (u32 *)0xFFE01120);
		debugfs_create_x32("ICPLB_ADDR9", 0600, parent, (u32 *)0xFFE01124);
		debugfs_create_x32("ICPLB_DATA0", 0600, parent, (u32 *)0xFFE01200);
		debugfs_create_x32("ICPLB_DATA10", 0600, parent, (u32 *)0xFFE01228);
		debugfs_create_x32("ICPLB_DATA11", 0600, parent, (u32 *)0xFFE0122C);
		debugfs_create_x32("ICPLB_DATA12", 0600, parent, (u32 *)0xFFE01230);
		debugfs_create_x32("ICPLB_DATA13", 0600, parent, (u32 *)0xFFE01234);
		debugfs_create_x32("ICPLB_DATA14", 0600, parent, (u32 *)0xFFE01238);
		debugfs_create_x32("ICPLB_DATA15", 0600, parent, (u32 *)0xFFE0123C);
		debugfs_create_x32("ICPLB_DATA1", 0600, parent, (u32 *)0xFFE01204);
		debugfs_create_x32("ICPLB_DATA2", 0600, parent, (u32 *)0xFFE01208);
		debugfs_create_x32("ICPLB_DATA3", 0600, parent, (u32 *)0xFFE0120C);
		debugfs_create_x32("ICPLB_DATA4", 0600, parent, (u32 *)0xFFE01210);
		debugfs_create_x32("ICPLB_DATA5", 0600, parent, (u32 *)0xFFE01214);
		debugfs_create_x32("ICPLB_DATA6", 0600, parent, (u32 *)0xFFE01218);
		debugfs_create_x32("ICPLB_DATA7", 0600, parent, (u32 *)0xFFE0121C);
		debugfs_create_x32("ICPLB_DATA8", 0600, parent, (u32 *)0xFFE01220);
		debugfs_create_x32("ICPLB_DATA9", 0600, parent, (u32 *)0xFFE01224);
		debugfs_create_x32("ICPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0100C);
		debugfs_create_x32("ICPLB_FAULT_STATUS", 0600, parent, (u32 *)0xFFE01008);
		debugfs_create_x32("IMEM_CONTROL", 0600, parent, (u32 *)0xFFE01004);
		debugfs_create_x32("ITEST_COMMAND", 0600, parent, (u32 *)0xFFE01300);
		debugfs_create_x32("ITEST_DATA0", 0600, parent, (u32 *)0xFFE01400);
		debugfs_create_x32("ITEST_DATA1", 0600, parent, (u32 *)0xFFE01404);

		parent = debugfs_create_dir("L1 Data Memory Registers", top);
		debugfs_create_x32("DCPLB_ADDR0", 0600, parent, (u32 *)0xFFE00100);
		debugfs_create_x32("DCPLB_ADDR10", 0600, parent, (u32 *)0xFFE00128);
		debugfs_create_x32("DCPLB_ADDR11", 0600, parent, (u32 *)0xFFE0012C);
		debugfs_create_x32("DCPLB_ADDR12", 0600, parent, (u32 *)0xFFE00130);
		debugfs_create_x32("DCPLB_ADDR13", 0600, parent, (u32 *)0xFFE00134);
		debugfs_create_x32("DCPLB_ADDR14", 0600, parent, (u32 *)0xFFE00138);
		debugfs_create_x32("DCPLB_ADDR15", 0600, parent, (u32 *)0xFFE0013C);
		debugfs_create_x32("DCPLB_ADDR1", 0600, parent, (u32 *)0xFFE00104);
		debugfs_create_x32("DCPLB_ADDR2", 0600, parent, (u32 *)0xFFE00108);
		debugfs_create_x32("DCPLB_ADDR3", 0600, parent, (u32 *)0xFFE0010C);
		debugfs_create_x32("DCPLB_ADDR4", 0600, parent, (u32 *)0xFFE00110);
		debugfs_create_x32("DCPLB_ADDR5", 0600, parent, (u32 *)0xFFE00114);
		debugfs_create_x32("DCPLB_ADDR6", 0600, parent, (u32 *)0xFFE00118);
		debugfs_create_x32("DCPLB_ADDR7", 0600, parent, (u32 *)0xFFE0011C);
		debugfs_create_x32("DCPLB_ADDR8", 0600, parent, (u32 *)0xFFE00120);
		debugfs_create_x32("DCPLB_ADDR9", 0600, parent, (u32 *)0xFFE00124);
		debugfs_create_x32("DCPLB_DATA0", 0600, parent, (u32 *)0xFFE00200);
		debugfs_create_x32("DCPLB_DATA10", 0600, parent, (u32 *)0xFFE00228);
		debugfs_create_x32("DCPLB_DATA11", 0600, parent, (u32 *)0xFFE0022C);
		debugfs_create_x32("DCPLB_DATA12", 0600, parent, (u32 *)0xFFE00230);
		debugfs_create_x32("DCPLB_DATA13", 0600, parent, (u32 *)0xFFE00234);
		debugfs_create_x32("DCPLB_DATA14", 0600, parent, (u32 *)0xFFE00238);
		debugfs_create_x32("DCPLB_DATA15", 0600, parent, (u32 *)0xFFE0023C);
		debugfs_create_x32("DCPLB_DATA1", 0600, parent, (u32 *)0xFFE00204);
		debugfs_create_x32("DCPLB_DATA2", 0600, parent, (u32 *)0xFFE00208);
		debugfs_create_x32("DCPLB_DATA3", 0600, parent, (u32 *)0xFFE0020C);
		debugfs_create_x32("DCPLB_DATA4", 0600, parent, (u32 *)0xFFE00210);
		debugfs_create_x32("DCPLB_DATA5", 0600, parent, (u32 *)0xFFE00214);
		debugfs_create_x32("DCPLB_DATA6", 0600, parent, (u32 *)0xFFE00218);
		debugfs_create_x32("DCPLB_DATA7", 0600, parent, (u32 *)0xFFE0021C);
		debugfs_create_x32("DCPLB_DATA8", 0600, parent, (u32 *)0xFFE00220);
		debugfs_create_x32("DCPLB_DATA9", 0600, parent, (u32 *)0xFFE00224);
		debugfs_create_x32("DCPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0000C);
		debugfs_create_x32("DMEM_CONTROL", 0600, parent, (u32 *)0xFFE00004);
		debugfs_create_x32("DTEST_COMMAND", 0600, parent, (u32 *)0xFFE00300);
		debugfs_create_x32("DTEST_DATA0", 0600, parent, (u32 *)0xFFE00400);
		debugfs_create_x32("DTEST_DATA1", 0600, parent, (u32 *)0xFFE00404);
		debugfs_create_x32("SRAM_BASE_ADDR", 0600, parent, (u32 *)0xFFE00000);

		parent = debugfs_create_dir("MEMDMA0 Destination Registers", top);
		debugfs_create_x16("MDMAFLX0_CURXCOUNT_D", 0600, parent, (u16 *)0xFFC00E30);
		debugfs_create_x16("MDMAFLX0_CURYCOUNT_D", 0600, parent, (u16 *)0xFFC00E38);
		debugfs_create_x16("MDMAFLX0_DMACNFG_D", 0600, parent, (u16 *)0xFFC00E08);
		debugfs_create_x16("MDMAFLX0_IRQSTAT_D", 0600, parent, (u16 *)0xFFC00E28);
		debugfs_create_x16("MDMAFLX0_PMAP_D", 0600, parent, (u16 *)0xFFC00E2C);
		debugfs_create_x16("MDMAFLX0_XCOUNT_D", 0600, parent, (u16 *)0xFFC00E10);
		debugfs_create_x16("MDMAFLX0_XMODIFY_D", 0600, parent, (u16 *)0xFFC00E14);
		debugfs_create_x16("MDMAFLX0_YCOUNT_D", 0600, parent, (u16 *)0xFFC00E18);
		debugfs_create_x16("MDMAFLX0_YMODIFY_D", 0600, parent, (u16 *)0xFFC00E1C);
		debugfs_create_x16("MDMA_D0_CONFIG", 0600, parent, (u16 *)0xFFC00E08);
		debugfs_create_x32("MDMA_D0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E24);
		debugfs_create_x32("MDMA_D0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E20);
		debugfs_create_x16("MDMA_D0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E30);
		debugfs_create_x16("MDMA_D0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E38);
		debugfs_create_x16("MDMA_D0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E28);
		debugfs_create_x32("MDMA_D0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E00);
		debugfs_create_x16("MDMA_D0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E2C);
		debugfs_create_x32("MDMA_D0_START_ADDR", 0600, parent, (u32 *)0xFFC00E04);
		debugfs_create_x16("MDMA_D0_X_COUNT", 0600, parent, (u16 *)0xFFC00E10);
		debugfs_create_x16("MDMA_D0_X_MODIFY", 0600, parent, (u16 *)0xFFC00E14);
		debugfs_create_x16("MDMA_D0_Y_COUNT", 0600, parent, (u16 *)0xFFC00E18);
		debugfs_create_x16("MDMA_D0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E1C);

		parent = debugfs_create_dir("MEMDMA0 Source Registers", top);
		debugfs_create_x16("MDMAFLX0_CURXCOUNT_S", 0600, parent, (u16 *)0xFFC00E70);
		debugfs_create_x16("MDMAFLX0_CURYCOUNT_S", 0600, parent, (u16 *)0xFFC00E78);
		debugfs_create_x16("MDMAFLX0_DMACNFG_S", 0600, parent, (u16 *)0xFFC00E48);
		debugfs_create_x16("MDMAFLX0_IRQSTAT_S", 0600, parent, (u16 *)0xFFC00E68);
		debugfs_create_x16("MDMAFLX0_PMAP_S", 0600, parent, (u16 *)0xFFC00E6C);
		debugfs_create_x16("MDMAFLX0_XCOUNT_S", 0600, parent, (u16 *)0xFFC00E50);
		debugfs_create_x16("MDMAFLX0_XMODIFY_S", 0600, parent, (u16 *)0xFFC00E54);
		debugfs_create_x16("MDMAFLX0_YCOUNT_S", 0600, parent, (u16 *)0xFFC00E58);
		debugfs_create_x16("MDMAFLX0_YMODIFY_S", 0600, parent, (u16 *)0xFFC00E5C);
		debugfs_create_x16("MDMA_S0_CONFIG", 0600, parent, (u16 *)0xFFC00E48);
		debugfs_create_x32("MDMA_S0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E64);
		debugfs_create_x32("MDMA_S0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E60);
		debugfs_create_x16("MDMA_S0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E70);
		debugfs_create_x16("MDMA_S0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E78);
		debugfs_create_x16("MDMA_S0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E68);
		debugfs_create_x32("MDMA_S0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E40);
		debugfs_create_x16("MDMA_S0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E6C);
		debugfs_create_x32("MDMA_S0_START_ADDR", 0600, parent, (u32 *)0xFFC00E44);
		debugfs_create_x16("MDMA_S0_X_COUNT", 0600, parent, (u16 *)0xFFC00E50);
		debugfs_create_x16("MDMA_S0_X_MODIFY", 0600, parent, (u16 *)0xFFC00E54);
		debugfs_create_x16("MDMA_S0_Y_COUNT", 0600, parent, (u16 *)0xFFC00E58);
		debugfs_create_x16("MDMA_S0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E5C);

		parent = debugfs_create_dir("MEMDMA1 Destination Registers", top);
		debugfs_create_x16("MDMAFLX1_CURXCOUNT_D", 0600, parent, (u16 *)0xFFC00EB0);
		debugfs_create_x16("MDMAFLX1_CURYCOUNT_D", 0600, parent, (u16 *)0xFFC00EB8);
		debugfs_create_x16("MDMAFLX1_DMACNFG_D", 0600, parent, (u16 *)0xFFC00E88);
		debugfs_create_x16("MDMAFLX1_IRQSTAT_D", 0600, parent, (u16 *)0xFFC00EA8);
		debugfs_create_x16("MDMAFLX1_PMAP_D", 0600, parent, (u16 *)0xFFC00EAC);
		debugfs_create_x16("MDMAFLX1_XCOUNT_D", 0600, parent, (u16 *)0xFFC00E90);
		debugfs_create_x16("MDMAFLX1_XMODIFY_D", 0600, parent, (u16 *)0xFFC00E94);
		debugfs_create_x16("MDMAFLX1_YCOUNT_D", 0600, parent, (u16 *)0xFFC00E98);
		debugfs_create_x16("MDMAFLX1_YMODIFY_D", 0600, parent, (u16 *)0xFFC00E9C);
		debugfs_create_x16("MDMA_D1_CONFIG", 0600, parent, (u16 *)0xFFC00E88);
		debugfs_create_x32("MDMA_D1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EA4);
		debugfs_create_x32("MDMA_D1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EA0);
		debugfs_create_x16("MDMA_D1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EB0);
		debugfs_create_x16("MDMA_D1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EB8);
		debugfs_create_x16("MDMA_D1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EA8);
		debugfs_create_x32("MDMA_D1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E80);
		debugfs_create_x16("MDMA_D1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EAC);
		debugfs_create_x32("MDMA_D1_START_ADDR", 0600, parent, (u32 *)0xFFC00E84);
		debugfs_create_x16("MDMA_D1_X_COUNT", 0600, parent, (u16 *)0xFFC00E90);
		debugfs_create_x16("MDMA_D1_X_MODIFY", 0600, parent, (u16 *)0xFFC00E94);
		debugfs_create_x16("MDMA_D1_Y_COUNT", 0600, parent, (u16 *)0xFFC00E98);
		debugfs_create_x16("MDMA_D1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E9C);

		parent = debugfs_create_dir("MEMDMA1 Source Registers", top);
		debugfs_create_x16("MDMAFLX1_CURXCOUNT_S", 0600, parent, (u16 *)0xFFC00EF0);
		debugfs_create_x16("MDMAFLX1_CURYCOUNT_S", 0600, parent, (u16 *)0xFFC00EF8);
		debugfs_create_x16("MDMAFLX1_DMACNFG_S", 0600, parent, (u16 *)0xFFC00EC8);
		debugfs_create_x16("MDMAFLX1_IRQSTAT_S", 0600, parent, (u16 *)0xFFC00EE8);
		debugfs_create_x16("MDMAFLX1_PMAP_S", 0600, parent, (u16 *)0xFFC00EEC);
		debugfs_create_x16("MDMAFLX1_XCOUNT_S", 0600, parent, (u16 *)0xFFC00ED0);
		debugfs_create_x16("MDMAFLX1_XMODIFY_S", 0600, parent, (u16 *)0xFFC00ED4);
		debugfs_create_x16("MDMAFLX1_YCOUNT_S", 0600, parent, (u16 *)0xFFC00ED8);
		debugfs_create_x16("MDMAFLX1_YMODIFY_S", 0600, parent, (u16 *)0xFFC00EDC);
		debugfs_create_x16("MDMA_S1_CONFIG", 0600, parent, (u16 *)0xFFC00EC8);
		debugfs_create_x32("MDMA_S1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EE4);
		debugfs_create_x32("MDMA_S1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EE0);
		debugfs_create_x16("MDMA_S1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EF0);
		debugfs_create_x16("MDMA_S1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EF8);
		debugfs_create_x16("MDMA_S1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EE8);
		debugfs_create_x32("MDMA_S1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00EC0);
		debugfs_create_x16("MDMA_S1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EEC);
		debugfs_create_x32("MDMA_S1_START_ADDR", 0600, parent, (u32 *)0xFFC00EC4);
		debugfs_create_x16("MDMA_S1_X_COUNT", 0600, parent, (u16 *)0xFFC00ED0);
		debugfs_create_x16("MDMA_S1_X_MODIFY", 0600, parent, (u16 *)0xFFC00ED4);
		debugfs_create_x16("MDMA_S1_Y_COUNT", 0600, parent, (u16 *)0xFFC00ED8);
		debugfs_create_x16("MDMA_S1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00EDC);

		parent = debugfs_create_dir("PLL", top);
		debugfs_create_x16("PLL_CTL", 0600, parent, (u16 *)0xFFC00000);
		debugfs_create_x16("PLL_DIV", 0600, parent, (u16 *)0xFFC00004);
		debugfs_create_x16("PLL_LOCKCNT", 0600, parent, (u16 *)0xFFC00010);
		debugfs_create_x16("PLL_STAT", 0600, parent, (u16 *)0xFFC0000C);
		debugfs_create_x32("SWRST", 0600, parent, (u32 *)0xFFC00100);
		debugfs_create_x32("SYSCR", 0600, parent, (u32 *)0xFFC00104);
		debugfs_create_x16("VR_CTL", 0600, parent, (u16 *)0xFFC00008);

		parent = debugfs_create_dir("PPI", top);
		debugfs_create_x16("PPI_CONTROL", 0600, parent, (u16 *)0xFFC01000);
		debugfs_create_x16("PPI_COUNT", 0600, parent, (u16 *)0xFFC01008);
		debugfs_create_x16("PPI_DELAY", 0600, parent, (u16 *)0xFFC0100C);
		debugfs_create_x16("PPI_FRAME", 0600, parent, (u16 *)0xFFC01010);
		debugfs_create_x16("PPI_STATUS", 0600, parent, (u16 *)0xFFC01004);

		parent = debugfs_create_dir("Performance Monitor", top);
		debugfs_create_x32("PFCNTR0", 0600, parent, (u32 *)0xFFE08100);
		debugfs_create_x32("PFCNTR1", 0600, parent, (u32 *)0xFFE08104);
		debugfs_create_x32("PFCTL", 0600, parent, (u32 *)0xFFE08000);

		parent = debugfs_create_dir("RTC", top);
		debugfs_create_x32("RTC_ALARM", 0600, parent, (u32 *)0xFFC00310);
		debugfs_create_x16("RTC_ICTL", 0600, parent, (u16 *)0xFFC00304);
		debugfs_create_x16("RTC_ISTAT", 0600, parent, (u16 *)0xFFC00308);
		debugfs_create_x16("RTC_PREN", 0600, parent, (u16 *)0xFFC00314);
		debugfs_create_x32("RTC_STAT", 0600, parent, (u32 *)0xFFC00300);
		debugfs_create_x16("RTC_SWCNT", 0600, parent, (u16 *)0xFFC0030C);

		parent = debugfs_create_dir("SPI", top);
		debugfs_create_x16("SPI_BAUD", 0600, parent, (u16 *)0xFFC00514);
		debugfs_create_x16("SPI_CTL", 0600, parent, (u16 *)0xFFC00500);
		debugfs_create_x16("SPI_FLG", 0600, parent, (u16 *)0xFFC00504);
		debugfs_create_x16("SPI_RDBR", 0600, parent, (u16 *)0xFFC00510);
		debugfs_create_x16("SPI_SHADOW", 0600, parent, (u16 *)0xFFC00518);
		debugfs_create_x16("SPI_STAT", 0600, parent, (u16 *)0xFFC00508);
		debugfs_create_x16("SPI_TDBR", 0600, parent, (u16 *)0xFFC0050C);

		parent = debugfs_create_dir("SPORT", top);
		debugfs_create_x16("SPORT0_CHNL", 0600, parent, (u16 *)0xFFC00834);
		debugfs_create_x16("SPORT0_MCMC1", 0600, parent, (u16 *)0xFFC00838);
		debugfs_create_x16("SPORT0_MCMC2", 0600, parent, (u16 *)0xFFC0083C);
		debugfs_create_x16("SPORT0_RCLKDIV", 0600, parent, (u16 *)0xFFC00828);
		debugfs_create_x16("SPORT0_RCR1", 0600, parent, (u16 *)0xFFC00820);
		debugfs_create_x16("SPORT0_RCR2", 0600, parent, (u16 *)0xFFC00824);
		debugfs_create_x16("SPORT0_RFSDIV", 0600, parent, (u16 *)0xFFC0082C);
		debugfs_create_x32("SPORT0_RX", 0600, parent, (u32 *)0xFFC00818);
		debugfs_create_x16("SPORT0_STAT", 0600, parent, (u16 *)0xFFC00830);
		debugfs_create_x16("SPORT0_TCLKDIV", 0600, parent, (u16 *)0xFFC00808);
		debugfs_create_x16("SPORT0_TCR1", 0600, parent, (u16 *)0xFFC00800);
		debugfs_create_x16("SPORT0_TCR2", 0600, parent, (u16 *)0xFFC00804);
		debugfs_create_x16("SPORT0_TFSDIV", 0600, parent, (u16 *)0xFFC0080C);
		debugfs_create_x32("SPORT0_TX", 0600, parent, (u32 *)0xFFC00810);
		debugfs_create_x16("SPORT1_CHNL", 0600, parent, (u16 *)0xFFC00934);
		debugfs_create_x16("SPORT1_MCMC1", 0600, parent, (u16 *)0xFFC00938);
		debugfs_create_x16("SPORT1_MCMC2", 0600, parent, (u16 *)0xFFC0093C);
		debugfs_create_x16("SPORT1_RCLKDIV", 0600, parent, (u16 *)0xFFC00928);
		debugfs_create_x16("SPORT1_RCR1", 0600, parent, (u16 *)0xFFC00920);
		debugfs_create_x16("SPORT1_RCR2", 0600, parent, (u16 *)0xFFC00924);
		debugfs_create_x16("SPORT1_RFSDIV", 0600, parent, (u16 *)0xFFC0092C);
		debugfs_create_x32("SPORT1_RX", 0600, parent, (u32 *)0xFFC00918);
		debugfs_create_x16("SPORT1_STAT", 0600, parent, (u16 *)0xFFC00930);
		debugfs_create_x16("SPORT1_TCLKDIV", 0600, parent, (u16 *)0xFFC00908);
		debugfs_create_x16("SPORT1_TCR1", 0600, parent, (u16 *)0xFFC00900);
		debugfs_create_x16("SPORT1_TCR2", 0600, parent, (u16 *)0xFFC00904);
		debugfs_create_x16("SPORT1_TFSDIV", 0600, parent, (u16 *)0xFFC0090C);
		debugfs_create_x32("SPORT1_TX", 0600, parent, (u32 *)0xFFC00910);

		parent = debugfs_create_dir("SPT0", top);
		debugfs_create_x16("SPT0_CHNL", 0600, parent, (u16 *)0xFFC00834);
		debugfs_create_x16("SPT0_MCMC1", 0600, parent, (u16 *)0xFFC00838);
		debugfs_create_x16("SPT0_MCMC2", 0600, parent, (u16 *)0xFFC0083C);
		debugfs_create_x32("SPT0_MRCS0", 0600, parent, (u32 *)0xFFC00850);
		debugfs_create_x32("SPT0_MRCS1", 0600, parent, (u32 *)0xFFC00854);
		debugfs_create_x32("SPT0_MRCS2", 0600, parent, (u32 *)0xFFC00858);
		debugfs_create_x32("SPT0_MRCS3", 0600, parent, (u32 *)0xFFC0085C);
		debugfs_create_x32("SPT0_MTCS0", 0600, parent, (u32 *)0xFFC00840);
		debugfs_create_x32("SPT0_MTCS1", 0600, parent, (u32 *)0xFFC00844);
		debugfs_create_x32("SPT0_MTCS2", 0600, parent, (u32 *)0xFFC00848);
		debugfs_create_x32("SPT0_MTCS3", 0600, parent, (u32 *)0xFFC0084C);
		debugfs_create_x16("SPT0_RFSDIV", 0600, parent, (u16 *)0xFFC0082C);
		debugfs_create_x16("SPT0_RSCLKDIV", 0600, parent, (u16 *)0xFFC00828);
		debugfs_create_x32("SPT0_RX", 0600, parent, (u32 *)0xFFC00818);
		debugfs_create_x16("SPT0_RX_CONFIG0", 0600, parent, (u16 *)0xFFC00820);
		debugfs_create_x16("SPT0_RX_CONFIG1", 0600, parent, (u16 *)0xFFC00824);
		debugfs_create_x16("SPT0_STAT", 0600, parent, (u16 *)0xFFC00830);
		debugfs_create_x16("SPT0_TFSDIV", 0600, parent, (u16 *)0xFFC0080C);
		debugfs_create_x16("SPT0_TSCLKDIV", 0600, parent, (u16 *)0xFFC00808);
		debugfs_create_x32("SPT0_TX", 0600, parent, (u32 *)0xFFC00810);
		debugfs_create_x16("SPT0_TX_CONFIG0", 0600, parent, (u16 *)0xFFC00800);
		debugfs_create_x16("SPT0_TX_CONFIG1", 0600, parent, (u16 *)0xFFC00804);
		debugfs_create_x16("SPT1_CHNL", 0600, parent, (u16 *)0xFFC00934);

		parent = debugfs_create_dir("SPT1", top);
		debugfs_create_x16("SPT1_MCMC1", 0600, parent, (u16 *)0xFFC00938);
		debugfs_create_x16("SPT1_MCMC2", 0600, parent, (u16 *)0xFFC0093C);
		debugfs_create_x32("SPT1_MRCS0", 0600, parent, (u32 *)0xFFC00950);
		debugfs_create_x32("SPT1_MRCS1", 0600, parent, (u32 *)0xFFC00954);
		debugfs_create_x32("SPT1_MRCS2", 0600, parent, (u32 *)0xFFC00958);
		debugfs_create_x32("SPT1_MRCS3", 0600, parent, (u32 *)0xFFC0095C);
		debugfs_create_x32("SPT1_MTCS0", 0600, parent, (u32 *)0xFFC00940);
		debugfs_create_x32("SPT1_MTCS1", 0600, parent, (u32 *)0xFFC00944);
		debugfs_create_x32("SPT1_MTCS2", 0600, parent, (u32 *)0xFFC00948);
		debugfs_create_x32("SPT1_MTCS3", 0600, parent, (u32 *)0xFFC0094C);
		debugfs_create_x16("SPT1_RFSDIV", 0600, parent, (u16 *)0xFFC0092C);
		debugfs_create_x16("SPT1_RSCLKDIV", 0600, parent, (u16 *)0xFFC00928);
		debugfs_create_x16("SPT1_RX", 0600, parent, (u16 *)0xFFC00918);
		debugfs_create_x16("SPT1_RX_CONFIG0", 0600, parent, (u16 *)0xFFC00920);
		debugfs_create_x16("SPT1_RX_CONFIG1", 0600, parent, (u16 *)0xFFC00924);
		debugfs_create_x16("SPT1_STAT", 0600, parent, (u16 *)0xFFC00930);
		debugfs_create_x16("SPT1_TFSDIV", 0600, parent, (u16 *)0xFFC0090C);
		debugfs_create_x16("SPT1_TSCLKDIV", 0600, parent, (u16 *)0xFFC00908);
		debugfs_create_x16("SPT1_TX", 0600, parent, (u16 *)0xFFC00910);
		debugfs_create_x16("SPT1_TX_CONFIG0", 0600, parent, (u16 *)0xFFC00900);
		debugfs_create_x16("SPT1_TX_CONFIG1", 0600, parent, (u16 *)0xFFC00904);

		parent = debugfs_create_dir("System Interrupt Controller Register File", top);
		debugfs_create_x32("SIC_IAR0", 0600, parent, (u32 *)0xFFC00110);
		debugfs_create_x32("SIC_IAR1", 0600, parent, (u32 *)0xFFC00114);
		debugfs_create_x32("SIC_IAR2", 0600, parent, (u32 *)0xFFC00118);
		debugfs_create_x32("SIC_IAR3", 0600, parent, (u32 *)0xFFC0011C);
		debugfs_create_x32("SIC_IMASK", 0600, parent, (u32 *)0xFFC0010C);
		debugfs_create_x32("SIC_ISR", 0600, parent, (u32 *)0xFFC00120);
		debugfs_create_x32("SIC_IWR", 0600, parent, (u32 *)0xFFC00124);
		debugfs_create_x16("SIC_RVECT", 0600, parent, (u16 *)0xFFC00108);

		parent = debugfs_create_dir("Timer Registers", top);
		debugfs_create_x16("TIMER0_CONFIG", 0600, parent, (u16 *)0xFFC00600);
		debugfs_create_x32("TIMER0_COUNTER", 0600, parent, (u32 *)0xFFC00604);
		debugfs_create_x32("TIMER0_PERIOD", 0600, parent, (u32 *)0xFFC00608);
		debugfs_create_x32("TIMER0_WIDTH", 0600, parent, (u32 *)0xFFC0060C);
		debugfs_create_x16("TIMER1_CONFIG", 0600, parent, (u16 *)0xFFC00610);
		debugfs_create_x32("TIMER1_COUNTER", 0600, parent, (u32 *)0xFFC00614);
		debugfs_create_x32("TIMER1_PERIOD", 0600, parent, (u32 *)0xFFC00618);
		debugfs_create_x32("TIMER1_WIDTH", 0600, parent, (u32 *)0xFFC0061C);
		debugfs_create_x16("TIMER2_CONFIG", 0600, parent, (u16 *)0xFFC00620);
		debugfs_create_x32("TIMER2_COUNTER", 0600, parent, (u32 *)0xFFC00624);
		debugfs_create_x32("TIMER2_PERIOD", 0600, parent, (u32 *)0xFFC00628);
		debugfs_create_x32("TIMER2_WIDTH", 0600, parent, (u32 *)0xFFC0062C);
		debugfs_create_x16("TIMER_DISABLE", 0600, parent, (u16 *)0xFFC00644);
		debugfs_create_x16("TIMER_ENABLE", 0600, parent, (u16 *)0xFFC00640);
		debugfs_create_x16("TIMER_STATUS", 0600, parent, (u16 *)0xFFC00648);

		parent = debugfs_create_dir("Trace Unit", top);
		debugfs_create_x32("TBUF", 0600, parent, (u32 *)0xFFE06100);
		debugfs_create_x32("TBUFCTL", 0600, parent, (u32 *)0xFFE06000);
		debugfs_create_x32("TBUFSTAT", 0600, parent, (u32 *)0xFFE06004);

		parent = debugfs_create_dir("UART", top);
		debugfs_create_x16("UART_DLH", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART_DLL", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART_GCTL", 0600, parent, (u16 *)0xFFC00424);
		debugfs_create_x16("UART_IER", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART_IIR", 0600, parent, (u16 *)0xFFC00408);
		debugfs_create_x16("UART_LCR", 0600, parent, (u16 *)0xFFC0040C);
		debugfs_create_x16("UART_LSR", 0600, parent, (u16 *)0xFFC00414);
		debugfs_create_x16("UART_MCR", 0600, parent, (u16 *)0xFFC00410);
		debugfs_create_x16("UART_RBR", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART_SCR", 0600, parent, (u16 *)0xFFC0041C);
		debugfs_create_x16("UART_THR", 0600, parent, (u16 *)0xFFC00400);

		parent = debugfs_create_dir("Watchdog", top);
		debugfs_create_x32("WDOG_CNT", 0600, parent, (u32 *)0xFFC00204);
		debugfs_create_x16("WDOG_CTL", 0600, parent, (u16 *)0xFFC00200);
		debugfs_create_x32("WDOG_STAT", 0600, parent, (u32 *)0xFFC00208);

		parent = debugfs_create_dir("Watchpoint and Patch Unit", top);
		debugfs_create_x32("WPDA0", 0600, parent, (u32 *)0xFFE07140);
		debugfs_create_x32("WPDA1", 0600, parent, (u32 *)0xFFE07144);
		debugfs_create_x32("WPDACNT0", 0600, parent, (u32 *)0xFFE07180);
		debugfs_create_x32("WPDACNT1", 0600, parent, (u32 *)0xFFE07184);
		debugfs_create_x32("WPDACTL", 0600, parent, (u32 *)0xFFE07100);
		debugfs_create_x32("WPIA0", 0600, parent, (u32 *)0xFFE07040);
		debugfs_create_x32("WPIA1", 0600, parent, (u32 *)0xFFE07044);
		debugfs_create_x32("WPIA2", 0600, parent, (u32 *)0xFFE07048);
		debugfs_create_x32("WPIA3", 0600, parent, (u32 *)0xFFE0704C);
		debugfs_create_x32("WPIA4", 0600, parent, (u32 *)0xFFE07050);
		debugfs_create_x32("WPIA5", 0600, parent, (u32 *)0xFFE07054);
		debugfs_create_x32("WPIACNT0", 0600, parent, (u32 *)0xFFE07080);
		debugfs_create_x32("WPIACNT1", 0600, parent, (u32 *)0xFFE07084);
		debugfs_create_x32("WPIACNT2", 0600, parent, (u32 *)0xFFE07088);
		debugfs_create_x32("WPIACNT3", 0600, parent, (u32 *)0xFFE0708C);
		debugfs_create_x32("WPIACNT4", 0600, parent, (u32 *)0xFFE07090);
		debugfs_create_x32("WPIACNT5", 0600, parent, (u32 *)0xFFE07094);
		debugfs_create_x32("WPIACTL", 0600, parent, (u32 *)0xFFE07000);
		debugfs_create_x32("WPSTAT", 0600, parent, (u32 *)0xFFE07200);

	}	/* BF533 */

#ifdef __ADSPBF534__
# define USE_BF534 1
#else
# define USE_BF534 0
#endif
	if (USE_BF534) {

		parent = debugfs_create_dir("CAN Controller", top);
		debugfs_create_x16("CAN_AA1", 0600, parent, (u16 *)0xFFC02A14);
		debugfs_create_x16("CAN_AA2", 0600, parent, (u16 *)0xFFC02A54);
		debugfs_create_x16("CAN_AM00H", 0600, parent, (u16 *)0xFFC02B04);
		debugfs_create_x16("CAN_AM00L", 0600, parent, (u16 *)0xFFC02B00);
		debugfs_create_x16("CAN_AM01H", 0600, parent, (u16 *)0xFFC02B0C);
		debugfs_create_x16("CAN_AM01L", 0600, parent, (u16 *)0xFFC02B08);
		debugfs_create_x16("CAN_AM02H", 0600, parent, (u16 *)0xFFC02B14);
		debugfs_create_x16("CAN_AM02L", 0600, parent, (u16 *)0xFFC02B10);
		debugfs_create_x16("CAN_AM03H", 0600, parent, (u16 *)0xFFC02B1C);
		debugfs_create_x16("CAN_AM03L", 0600, parent, (u16 *)0xFFC02B18);
		debugfs_create_x16("CAN_AM04H", 0600, parent, (u16 *)0xFFC02B24);
		debugfs_create_x16("CAN_AM04L", 0600, parent, (u16 *)0xFFC02B20);
		debugfs_create_x16("CAN_AM05H", 0600, parent, (u16 *)0xFFC02B2C);
		debugfs_create_x16("CAN_AM05L", 0600, parent, (u16 *)0xFFC02B28);
		debugfs_create_x16("CAN_AM06H", 0600, parent, (u16 *)0xFFC02B34);
		debugfs_create_x16("CAN_AM06L", 0600, parent, (u16 *)0xFFC02B30);
		debugfs_create_x16("CAN_AM07H", 0600, parent, (u16 *)0xFFC02B3C);
		debugfs_create_x16("CAN_AM07L", 0600, parent, (u16 *)0xFFC02B38);
		debugfs_create_x16("CAN_AM08H", 0600, parent, (u16 *)0xFFC02B44);
		debugfs_create_x16("CAN_AM08L", 0600, parent, (u16 *)0xFFC02B40);
		debugfs_create_x16("CAN_AM09H", 0600, parent, (u16 *)0xFFC02B4C);
		debugfs_create_x16("CAN_AM09L", 0600, parent, (u16 *)0xFFC02B48);
		debugfs_create_x16("CAN_AM10H", 0600, parent, (u16 *)0xFFC02B54);
		debugfs_create_x16("CAN_AM10L", 0600, parent, (u16 *)0xFFC02B50);
		debugfs_create_x16("CAN_AM11H", 0600, parent, (u16 *)0xFFC02B5C);
		debugfs_create_x16("CAN_AM11L", 0600, parent, (u16 *)0xFFC02B58);
		debugfs_create_x16("CAN_AM12H", 0600, parent, (u16 *)0xFFC02B64);
		debugfs_create_x16("CAN_AM12L", 0600, parent, (u16 *)0xFFC02B60);
		debugfs_create_x16("CAN_AM13H", 0600, parent, (u16 *)0xFFC02B6C);
		debugfs_create_x16("CAN_AM13L", 0600, parent, (u16 *)0xFFC02B68);
		debugfs_create_x16("CAN_AM14H", 0600, parent, (u16 *)0xFFC02B74);
		debugfs_create_x16("CAN_AM14L", 0600, parent, (u16 *)0xFFC02B70);
		debugfs_create_x16("CAN_AM15H", 0600, parent, (u16 *)0xFFC02B7C);
		debugfs_create_x16("CAN_AM15L", 0600, parent, (u16 *)0xFFC02B78);
		debugfs_create_x16("CAN_AM16H", 0600, parent, (u16 *)0xFFC02B84);
		debugfs_create_x16("CAN_AM16L", 0600, parent, (u16 *)0xFFC02B80);
		debugfs_create_x16("CAN_AM17H", 0600, parent, (u16 *)0xFFC02B8C);
		debugfs_create_x16("CAN_AM17L", 0600, parent, (u16 *)0xFFC02B88);
		debugfs_create_x16("CAN_AM18H", 0600, parent, (u16 *)0xFFC02B94);
		debugfs_create_x16("CAN_AM18L", 0600, parent, (u16 *)0xFFC02B90);
		debugfs_create_x16("CAN_AM19H", 0600, parent, (u16 *)0xFFC02B9C);
		debugfs_create_x16("CAN_AM19L", 0600, parent, (u16 *)0xFFC02B98);
		debugfs_create_x16("CAN_AM20H", 0600, parent, (u16 *)0xFFC02BA4);
		debugfs_create_x16("CAN_AM20L", 0600, parent, (u16 *)0xFFC02BA0);
		debugfs_create_x16("CAN_AM21H", 0600, parent, (u16 *)0xFFC02BAC);
		debugfs_create_x16("CAN_AM21L", 0600, parent, (u16 *)0xFFC02BA8);
		debugfs_create_x16("CAN_AM22H", 0600, parent, (u16 *)0xFFC02BB4);
		debugfs_create_x16("CAN_AM22L", 0600, parent, (u16 *)0xFFC02BB0);
		debugfs_create_x16("CAN_AM23H", 0600, parent, (u16 *)0xFFC02BBC);
		debugfs_create_x16("CAN_AM23L", 0600, parent, (u16 *)0xFFC02BB8);
		debugfs_create_x16("CAN_AM24H", 0600, parent, (u16 *)0xFFC02BC4);
		debugfs_create_x16("CAN_AM24L", 0600, parent, (u16 *)0xFFC02BC0);
		debugfs_create_x16("CAN_AM25H", 0600, parent, (u16 *)0xFFC02BCC);
		debugfs_create_x16("CAN_AM25L", 0600, parent, (u16 *)0xFFC02BC8);
		debugfs_create_x16("CAN_AM26H", 0600, parent, (u16 *)0xFFC02BD4);
		debugfs_create_x16("CAN_AM26L", 0600, parent, (u16 *)0xFFC02BD0);
		debugfs_create_x16("CAN_AM27H", 0600, parent, (u16 *)0xFFC02BDC);
		debugfs_create_x16("CAN_AM27L", 0600, parent, (u16 *)0xFFC02BD8);
		debugfs_create_x16("CAN_AM28H", 0600, parent, (u16 *)0xFFC02BE4);
		debugfs_create_x16("CAN_AM28L", 0600, parent, (u16 *)0xFFC02BE0);
		debugfs_create_x16("CAN_AM29H", 0600, parent, (u16 *)0xFFC02BEC);
		debugfs_create_x16("CAN_AM29L", 0600, parent, (u16 *)0xFFC02BE8);
		debugfs_create_x16("CAN_AM30H", 0600, parent, (u16 *)0xFFC02BF4);
		debugfs_create_x16("CAN_AM30L", 0600, parent, (u16 *)0xFFC02BF0);
		debugfs_create_x16("CAN_AM31H", 0600, parent, (u16 *)0xFFC02BFC);
		debugfs_create_x16("CAN_AM31L", 0600, parent, (u16 *)0xFFC02BF8);
		debugfs_create_x16("CAN_CEC", 0600, parent, (u16 *)0xFFC02A90);
		debugfs_create_x16("CAN_CLOCK", 0600, parent, (u16 *)0xFFC02A80);
		debugfs_create_x16("CAN_CONTROL", 0600, parent, (u16 *)0xFFC02AA0);
		debugfs_create_x16("CAN_DEBUG", 0600, parent, (u16 *)0xFFC02A88);
		debugfs_create_x16("CAN_ESR", 0600, parent, (u16 *)0xFFC02AB4);
		debugfs_create_x16("CAN_EWR", 0600, parent, (u16 *)0xFFC02AB0);
		debugfs_create_x16("CAN_GIF", 0600, parent, (u16 *)0xFFC02A9C);
		debugfs_create_x16("CAN_GIM", 0600, parent, (u16 *)0xFFC02A98);
		debugfs_create_x16("CAN_GIS", 0600, parent, (u16 *)0xFFC02A94);
		debugfs_create_x16("CAN_INTR", 0600, parent, (u16 *)0xFFC02AA4);
		debugfs_create_x16("CAN_MBIM1", 0600, parent, (u16 *)0xFFC02A28);
		debugfs_create_x16("CAN_MBIM2", 0600, parent, (u16 *)0xFFC02A68);
		debugfs_create_x16("CAN_MBRIF1", 0600, parent, (u16 *)0xFFC02A24);
		debugfs_create_x16("CAN_MBRIF2", 0600, parent, (u16 *)0xFFC02A64);
		debugfs_create_x16("CAN_MBTD", 0600, parent, (u16 *)0xFFC02AAC);
		debugfs_create_x16("CAN_MBTIF1", 0600, parent, (u16 *)0xFFC02A20);
		debugfs_create_x16("CAN_MBTIF2", 0600, parent, (u16 *)0xFFC02A60);
		debugfs_create_x16("CAN_MC1", 0600, parent, (u16 *)0xFFC02A00);
		debugfs_create_x16("CAN_MC2", 0600, parent, (u16 *)0xFFC02A40);
		debugfs_create_x16("CAN_MD1", 0600, parent, (u16 *)0xFFC02A04);
		debugfs_create_x16("CAN_MD2", 0600, parent, (u16 *)0xFFC02A44);
		debugfs_create_x16("CAN_OPSS1", 0600, parent, (u16 *)0xFFC02A30);
		debugfs_create_x16("CAN_OPSS2", 0600, parent, (u16 *)0xFFC02A70);
		debugfs_create_x16("CAN_RFH1", 0600, parent, (u16 *)0xFFC02A2C);
		debugfs_create_x16("CAN_RFH2", 0600, parent, (u16 *)0xFFC02A6C);
		debugfs_create_x16("CAN_RML1", 0600, parent, (u16 *)0xFFC02A1C);
		debugfs_create_x16("CAN_RML2", 0600, parent, (u16 *)0xFFC02A5C);
		debugfs_create_x16("CAN_RMP1", 0600, parent, (u16 *)0xFFC02A18);
		debugfs_create_x16("CAN_RMP2", 0600, parent, (u16 *)0xFFC02A58);
		debugfs_create_x16("CAN_STATUS", 0600, parent, (u16 *)0xFFC02A8C);
		debugfs_create_x16("CAN_TA1", 0600, parent, (u16 *)0xFFC02A10);
		debugfs_create_x16("CAN_TA2", 0600, parent, (u16 *)0xFFC02A50);
		debugfs_create_x16("CAN_TIMING", 0600, parent, (u16 *)0xFFC02A84);
		debugfs_create_x16("CAN_TRR1", 0600, parent, (u16 *)0xFFC02A0C);
		debugfs_create_x16("CAN_TRR2", 0600, parent, (u16 *)0xFFC02A4C);
		debugfs_create_x16("CAN_TRS1", 0600, parent, (u16 *)0xFFC02A08);
		debugfs_create_x16("CAN_TRS2", 0600, parent, (u16 *)0xFFC02A48);
		debugfs_create_x16("CAN_UCCNF", 0600, parent, (u16 *)0xFFC02ACC);
		debugfs_create_x16("CAN_UCCNT", 0600, parent, (u16 *)0xFFC02AC4);
		debugfs_create_x16("CAN_UCRC", 0600, parent, (u16 *)0xFFC02AC8);
		debugfs_create_x16("CAN_UCREG", 0600, parent, (u16 *)0xFFC02AC0);
		debugfs_create_x16("CAN_VERSION2", 0600, parent, (u16 *)0xFFC02AD4);
		debugfs_create_x16("CAN_VERSION", 0600, parent, (u16 *)0xFFC02AA8);

		parent = debugfs_create_dir("Core Timer Register File", top);
		debugfs_create_x32("TCNTL", 0600, parent, (u32 *)0xFFE03000);
		debugfs_create_x32("TCOUNT", 0600, parent, (u32 *)0xFFE0300C);
		debugfs_create_x32("TPERIOD", 0600, parent, (u32 *)0xFFE03004);
		debugfs_create_x32("TSCALE", 0600, parent, (u32 *)0xFFE03008);

		parent = debugfs_create_dir("DMA Controller", top);
		debugfs_create_x16("DMA0_CONFIG", 0600, parent, (u16 *)0xFFC00C08);
		debugfs_create_x32("DMA0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C24);
		debugfs_create_x32("DMA0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C20);
		debugfs_create_x16("DMA0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C30);
		debugfs_create_x16("DMA0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C38);
		debugfs_create_x16("DMA0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C28);
		debugfs_create_x32("DMA0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C00);
		debugfs_create_x16("DMA0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C2C);
		debugfs_create_x32("DMA0_START_ADDR", 0600, parent, (u32 *)0xFFC00C04);
		debugfs_create_x16("DMA0_X_COUNT", 0600, parent, (u16 *)0xFFC00C10);
		debugfs_create_x16("DMA0_X_MODIFY", 0600, parent, (u16 *)0xFFC00C14);
		debugfs_create_x16("DMA0_Y_COUNT", 0600, parent, (u16 *)0xFFC00C18);
		debugfs_create_x16("DMA0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C1C);
		debugfs_create_x16("DMA10_CONFIG", 0600, parent, (u16 *)0xFFC00E88);
		debugfs_create_x32("DMA10_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EA4);
		debugfs_create_x32("DMA10_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EA0);
		debugfs_create_x16("DMA10_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EB0);
		debugfs_create_x16("DMA10_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EB8);
		debugfs_create_x16("DMA10_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EA8);
		debugfs_create_x32("DMA10_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E80);
		debugfs_create_x16("DMA10_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EAC);
		debugfs_create_x32("DMA10_START_ADDR", 0600, parent, (u32 *)0xFFC00E84);
		debugfs_create_x16("DMA10_X_COUNT", 0600, parent, (u16 *)0xFFC00E90);
		debugfs_create_x16("DMA10_X_MODIFY", 0600, parent, (u16 *)0xFFC00E94);
		debugfs_create_x16("DMA10_Y_COUNT", 0600, parent, (u16 *)0xFFC00E98);
		debugfs_create_x16("DMA10_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E9C);
		debugfs_create_x16("DMA11_CONFIG", 0600, parent, (u16 *)0xFFC00EC8);
		debugfs_create_x32("DMA11_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EE4);
		debugfs_create_x32("DMA11_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EE0);
		debugfs_create_x16("DMA11_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EF0);
		debugfs_create_x16("DMA11_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EF8);
		debugfs_create_x16("DMA11_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EE8);
		debugfs_create_x32("DMA11_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00EC0);
		debugfs_create_x16("DMA11_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EEC);
		debugfs_create_x32("DMA11_START_ADDR", 0600, parent, (u32 *)0xFFC00EC4);
		debugfs_create_x16("DMA11_X_COUNT", 0600, parent, (u16 *)0xFFC00ED0);
		debugfs_create_x16("DMA11_X_MODIFY", 0600, parent, (u16 *)0xFFC00ED4);
		debugfs_create_x16("DMA11_Y_COUNT", 0600, parent, (u16 *)0xFFC00ED8);
		debugfs_create_x16("DMA11_Y_MODIFY", 0600, parent, (u16 *)0xFFC00EDC);
		debugfs_create_x16("DMA1_CONFIG", 0600, parent, (u16 *)0xFFC00C48);
		debugfs_create_x32("DMA1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C64);
		debugfs_create_x32("DMA1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C60);
		debugfs_create_x16("DMA1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C70);
		debugfs_create_x16("DMA1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C78);
		debugfs_create_x16("DMA1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C68);
		debugfs_create_x32("DMA1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C40);
		debugfs_create_x16("DMA1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C6C);
		debugfs_create_x32("DMA1_START_ADDR", 0600, parent, (u32 *)0xFFC00C44);
		debugfs_create_x16("DMA1_X_COUNT", 0600, parent, (u16 *)0xFFC00C50);
		debugfs_create_x16("DMA1_X_MODIFY", 0600, parent, (u16 *)0xFFC00C54);
		debugfs_create_x16("DMA1_Y_COUNT", 0600, parent, (u16 *)0xFFC00C58);
		debugfs_create_x16("DMA1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C5C);
		debugfs_create_x16("DMA2_CONFIG", 0600, parent, (u16 *)0xFFC00C88);
		debugfs_create_x32("DMA2_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CA4);
		debugfs_create_x32("DMA2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CA0);
		debugfs_create_x16("DMA2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CB0);
		debugfs_create_x16("DMA2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CB8);
		debugfs_create_x16("DMA2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CA8);
		debugfs_create_x32("DMA2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C80);
		debugfs_create_x16("DMA2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CAC);
		debugfs_create_x32("DMA2_START_ADDR", 0600, parent, (u32 *)0xFFC00C84);
		debugfs_create_x16("DMA2_X_COUNT", 0600, parent, (u16 *)0xFFC00C90);
		debugfs_create_x16("DMA2_X_MODIFY", 0600, parent, (u16 *)0xFFC00C94);
		debugfs_create_x16("DMA2_Y_COUNT", 0600, parent, (u16 *)0xFFC00C98);
		debugfs_create_x16("DMA2_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C9C);
		debugfs_create_x16("DMA3_CONFIG", 0600, parent, (u16 *)0xFFC00CC8);
		debugfs_create_x32("DMA3_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CE4);
		debugfs_create_x32("DMA3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CE0);
		debugfs_create_x16("DMA3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CF0);
		debugfs_create_x16("DMA3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CF8);
		debugfs_create_x16("DMA3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CE8);
		debugfs_create_x32("DMA3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00CC0);
		debugfs_create_x16("DMA3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CEC);
		debugfs_create_x32("DMA3_START_ADDR", 0600, parent, (u32 *)0xFFC00CC4);
		debugfs_create_x16("DMA3_X_COUNT", 0600, parent, (u16 *)0xFFC00CD0);
		debugfs_create_x16("DMA3_X_MODIFY", 0600, parent, (u16 *)0xFFC00CD4);
		debugfs_create_x16("DMA3_Y_COUNT", 0600, parent, (u16 *)0xFFC00CD8);
		debugfs_create_x16("DMA3_Y_MODIFY", 0600, parent, (u16 *)0xFFC00CDC);
		debugfs_create_x16("DMA4_CONFIG", 0600, parent, (u16 *)0xFFC00D08);
		debugfs_create_x32("DMA4_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D24);
		debugfs_create_x32("DMA4_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D20);
		debugfs_create_x16("DMA4_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D30);
		debugfs_create_x16("DMA4_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D38);
		debugfs_create_x16("DMA4_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D28);
		debugfs_create_x32("DMA4_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D00);
		debugfs_create_x16("DMA4_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D2C);
		debugfs_create_x32("DMA4_START_ADDR", 0600, parent, (u32 *)0xFFC00D04);
		debugfs_create_x16("DMA4_X_COUNT", 0600, parent, (u16 *)0xFFC00D10);
		debugfs_create_x16("DMA4_X_MODIFY", 0600, parent, (u16 *)0xFFC00D14);
		debugfs_create_x16("DMA4_Y_COUNT", 0600, parent, (u16 *)0xFFC00D18);
		debugfs_create_x16("DMA4_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D1C);
		debugfs_create_x16("DMA5_CONFIG", 0600, parent, (u16 *)0xFFC00D48);
		debugfs_create_x32("DMA5_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D64);
		debugfs_create_x32("DMA5_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D60);
		debugfs_create_x16("DMA5_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D70);
		debugfs_create_x16("DMA5_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D78);
		debugfs_create_x16("DMA5_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D68);
		debugfs_create_x32("DMA5_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D40);
		debugfs_create_x16("DMA5_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D6C);
		debugfs_create_x32("DMA5_START_ADDR", 0600, parent, (u32 *)0xFFC00D44);
		debugfs_create_x16("DMA5_X_COUNT", 0600, parent, (u16 *)0xFFC00D50);
		debugfs_create_x16("DMA5_X_MODIFY", 0600, parent, (u16 *)0xFFC00D54);
		debugfs_create_x16("DMA5_Y_COUNT", 0600, parent, (u16 *)0xFFC00D58);
		debugfs_create_x16("DMA5_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D5C);
		debugfs_create_x16("DMA6_CONFIG", 0600, parent, (u16 *)0xFFC00D88);
		debugfs_create_x32("DMA6_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DA4);
		debugfs_create_x32("DMA6_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DA0);
		debugfs_create_x16("DMA6_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DB0);
		debugfs_create_x16("DMA6_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DB8);
		debugfs_create_x16("DMA6_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DA8);
		debugfs_create_x32("DMA6_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D80);
		debugfs_create_x16("DMA6_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DAC);
		debugfs_create_x32("DMA6_START_ADDR", 0600, parent, (u32 *)0xFFC00D84);
		debugfs_create_x16("DMA6_X_COUNT", 0600, parent, (u16 *)0xFFC00D90);
		debugfs_create_x16("DMA6_X_MODIFY", 0600, parent, (u16 *)0xFFC00D94);
		debugfs_create_x16("DMA6_Y_COUNT", 0600, parent, (u16 *)0xFFC00D98);
		debugfs_create_x16("DMA6_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D9C);
		debugfs_create_x16("DMA7_CONFIG", 0600, parent, (u16 *)0xFFC00DC8);
		debugfs_create_x32("DMA7_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DE4);
		debugfs_create_x32("DMA7_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DE0);
		debugfs_create_x16("DMA7_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DF0);
		debugfs_create_x16("DMA7_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DF8);
		debugfs_create_x16("DMA7_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DE8);
		debugfs_create_x32("DMA7_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00DC0);
		debugfs_create_x16("DMA7_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DEC);
		debugfs_create_x32("DMA7_START_ADDR", 0600, parent, (u32 *)0xFFC00DC4);
		debugfs_create_x16("DMA7_X_COUNT", 0600, parent, (u16 *)0xFFC00DD0);
		debugfs_create_x16("DMA7_X_MODIFY", 0600, parent, (u16 *)0xFFC00DD4);
		debugfs_create_x16("DMA7_Y_COUNT", 0600, parent, (u16 *)0xFFC00DD8);
		debugfs_create_x16("DMA7_Y_MODIFY", 0600, parent, (u16 *)0xFFC00DDC);
		debugfs_create_x16("DMA8_CONFIG", 0600, parent, (u16 *)0xFFC00E08);
		debugfs_create_x32("DMA8_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E24);
		debugfs_create_x32("DMA8_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E20);
		debugfs_create_x16("DMA8_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E30);
		debugfs_create_x16("DMA8_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E38);
		debugfs_create_x16("DMA8_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E28);
		debugfs_create_x32("DMA8_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E00);
		debugfs_create_x16("DMA8_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E2C);
		debugfs_create_x32("DMA8_START_ADDR", 0600, parent, (u32 *)0xFFC00E04);
		debugfs_create_x16("DMA8_X_COUNT", 0600, parent, (u16 *)0xFFC00E10);
		debugfs_create_x16("DMA8_X_MODIFY", 0600, parent, (u16 *)0xFFC00E14);
		debugfs_create_x16("DMA8_Y_COUNT", 0600, parent, (u16 *)0xFFC00E18);
		debugfs_create_x16("DMA8_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E1C);
		debugfs_create_x16("DMA9_CONFIG", 0600, parent, (u16 *)0xFFC00E48);
		debugfs_create_x32("DMA9_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E64);
		debugfs_create_x32("DMA9_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E60);
		debugfs_create_x16("DMA9_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E70);
		debugfs_create_x16("DMA9_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E78);
		debugfs_create_x16("DMA9_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E68);
		debugfs_create_x32("DMA9_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E40);
		debugfs_create_x16("DMA9_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E6C);
		debugfs_create_x32("DMA9_START_ADDR", 0600, parent, (u32 *)0xFFC00E44);
		debugfs_create_x16("DMA9_X_COUNT", 0600, parent, (u16 *)0xFFC00E50);
		debugfs_create_x16("DMA9_X_MODIFY", 0600, parent, (u16 *)0xFFC00E54);
		debugfs_create_x16("DMA9_Y_COUNT", 0600, parent, (u16 *)0xFFC00E58);
		debugfs_create_x16("DMA9_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E5C);

		parent = debugfs_create_dir("DMA Traffic Control", top);
		debugfs_create_x16("DMA_TC_CNT", 0600, parent, (u16 *)0xFFC00B0C);
		debugfs_create_x16("DMA_TC_PER", 0600, parent, (u16 *)0xFFC00B10);

		parent = debugfs_create_dir("Data Cache Programmable Look-Aside Buffer Fault Address", top);
		debugfs_create_x32("DCPLB_STATUS", 0600, parent, (u32 *)0xFFE00008);

		parent = debugfs_create_dir("EBIU", top);
		debugfs_create_x32("EBIU_AMBCTL0", 0600, parent, (u32 *)0xFFC00A04);
		debugfs_create_x32("EBIU_AMBCTL1", 0600, parent, (u32 *)0xFFC00A08);
		debugfs_create_x16("EBIU_AMGCTL", 0600, parent, (u16 *)0xFFC00A00);
		debugfs_create_x16("EBIU_SDBCTL", 0600, parent, (u16 *)0xFFC00A14);
		debugfs_create_x32("EBIU_SDGCTL", 0600, parent, (u32 *)0xFFC00A10);
		debugfs_create_x16("EBIU_SDRRC", 0600, parent, (u16 *)0xFFC00A18);
		debugfs_create_x16("EBIU_SDSTAT", 0600, parent, (u16 *)0xFFC00A1C);

		parent = debugfs_create_dir("Event Vectors", top);
		debugfs_create_x32("EVT0", 0600, parent, (u32 *)0xFFE02000);
		debugfs_create_x32("EVT10", 0600, parent, (u32 *)0xFFE02028);
		debugfs_create_x32("EVT11", 0600, parent, (u32 *)0xFFE0202C);
		debugfs_create_x32("EVT12", 0600, parent, (u32 *)0xFFE02030);
		debugfs_create_x32("EVT13", 0600, parent, (u32 *)0xFFE02034);
		debugfs_create_x32("EVT14", 0600, parent, (u32 *)0xFFE02038);
		debugfs_create_x32("EVT15", 0600, parent, (u32 *)0xFFE0203C);
		debugfs_create_x32("EVT1", 0600, parent, (u32 *)0xFFE02004);
		debugfs_create_x32("EVT2", 0600, parent, (u32 *)0xFFE02008);
		debugfs_create_x32("EVT3", 0600, parent, (u32 *)0xFFE0200C);
		debugfs_create_x32("EVT4", 0600, parent, (u32 *)0xFFE02010);
		debugfs_create_x32("EVT5", 0600, parent, (u32 *)0xFFE02014);
		debugfs_create_x32("EVT6", 0600, parent, (u32 *)0xFFE02018);
		debugfs_create_x32("EVT7", 0600, parent, (u32 *)0xFFE0201C);
		debugfs_create_x32("EVT8", 0600, parent, (u32 *)0xFFE02020);
		debugfs_create_x32("EVT9", 0600, parent, (u32 *)0xFFE02024);

		parent = debugfs_create_dir("Extended Registers", top);
		debugfs_create_x32("CHIPID", 0600, parent, (u32 *)0xFFC00014);
		debugfs_create_x32("DSPID", 0600, parent, (u32 *)0xFFE05000);

		parent = debugfs_create_dir("Handshake MDMA", top);
		debugfs_create_x16("HMDMA0_BCINIT", 0600, parent, (u16 *)0xFFC03308);
		debugfs_create_x16("HMDMA0_BCOUNT", 0600, parent, (u16 *)0xFFC03318);
		debugfs_create_x16("HMDMA0_CONTROL", 0600, parent, (u16 *)0xFFC03300);
		debugfs_create_x16("HMDMA0_ECINIT", 0600, parent, (u16 *)0xFFC03304);
		debugfs_create_x16("HMDMA0_ECOUNT", 0600, parent, (u16 *)0xFFC03314);
		debugfs_create_x16("HMDMA0_ECOVERFLOW", 0600, parent, (u16 *)0xFFC03310);
		debugfs_create_x16("HMDMA0_ECURGENT", 0600, parent, (u16 *)0xFFC0330C);
		debugfs_create_x16("HMDMA1_BCINIT", 0600, parent, (u16 *)0xFFC03348);
		debugfs_create_x16("HMDMA1_BCOUNT", 0600, parent, (u16 *)0xFFC03358);
		debugfs_create_x16("HMDMA1_CONTROL", 0600, parent, (u16 *)0xFFC03340);
		debugfs_create_x16("HMDMA1_ECINIT", 0600, parent, (u16 *)0xFFC03344);
		debugfs_create_x16("HMDMA1_ECOUNT", 0600, parent, (u16 *)0xFFC03354);
		debugfs_create_x16("HMDMA1_ECOVERFLOW", 0600, parent, (u16 *)0xFFC03350);
		debugfs_create_x16("HMDMA1_ECURGENT", 0600, parent, (u16 *)0xFFC0334C);

		parent = debugfs_create_dir("Interrupt Controller", top);
		debugfs_create_x32("ILAT", 0600, parent, (u32 *)0xFFE0210C);
		debugfs_create_x32("IMASK", 0600, parent, (u32 *)0xFFE02104);
		debugfs_create_x32("IPEND", 0600, parent, (u32 *)0xFFE02108);
		debugfs_create_x32("IPRIO", 0600, parent, (u32 *)0xFFE02110);

		parent = debugfs_create_dir("L1 Code Memory Registers", top);
		debugfs_create_x32("ICPLB_ADDR0", 0600, parent, (u32 *)0xFFE01100);
		debugfs_create_x32("ICPLB_ADDR10", 0600, parent, (u32 *)0xFFE01128);
		debugfs_create_x32("ICPLB_ADDR11", 0600, parent, (u32 *)0xFFE0112C);
		debugfs_create_x32("ICPLB_ADDR12", 0600, parent, (u32 *)0xFFE01130);
		debugfs_create_x32("ICPLB_ADDR13", 0600, parent, (u32 *)0xFFE01134);
		debugfs_create_x32("ICPLB_ADDR14", 0600, parent, (u32 *)0xFFE01138);
		debugfs_create_x32("ICPLB_ADDR15", 0600, parent, (u32 *)0xFFE0113C);
		debugfs_create_x32("ICPLB_ADDR1", 0600, parent, (u32 *)0xFFE01104);
		debugfs_create_x32("ICPLB_ADDR2", 0600, parent, (u32 *)0xFFE01108);
		debugfs_create_x32("ICPLB_ADDR3", 0600, parent, (u32 *)0xFFE0110C);
		debugfs_create_x32("ICPLB_ADDR4", 0600, parent, (u32 *)0xFFE01110);
		debugfs_create_x32("ICPLB_ADDR5", 0600, parent, (u32 *)0xFFE01114);
		debugfs_create_x32("ICPLB_ADDR6", 0600, parent, (u32 *)0xFFE01118);
		debugfs_create_x32("ICPLB_ADDR7", 0600, parent, (u32 *)0xFFE0111C);
		debugfs_create_x32("ICPLB_ADDR8", 0600, parent, (u32 *)0xFFE01120);
		debugfs_create_x32("ICPLB_ADDR9", 0600, parent, (u32 *)0xFFE01124);
		debugfs_create_x32("ICPLB_DATA0", 0600, parent, (u32 *)0xFFE01200);
		debugfs_create_x32("ICPLB_DATA10", 0600, parent, (u32 *)0xFFE01228);
		debugfs_create_x32("ICPLB_DATA11", 0600, parent, (u32 *)0xFFE0122C);
		debugfs_create_x32("ICPLB_DATA12", 0600, parent, (u32 *)0xFFE01230);
		debugfs_create_x32("ICPLB_DATA13", 0600, parent, (u32 *)0xFFE01234);
		debugfs_create_x32("ICPLB_DATA14", 0600, parent, (u32 *)0xFFE01238);
		debugfs_create_x32("ICPLB_DATA15", 0600, parent, (u32 *)0xFFE0123C);
		debugfs_create_x32("ICPLB_DATA1", 0600, parent, (u32 *)0xFFE01204);
		debugfs_create_x32("ICPLB_DATA2", 0600, parent, (u32 *)0xFFE01208);
		debugfs_create_x32("ICPLB_DATA3", 0600, parent, (u32 *)0xFFE0120C);
		debugfs_create_x32("ICPLB_DATA4", 0600, parent, (u32 *)0xFFE01210);
		debugfs_create_x32("ICPLB_DATA5", 0600, parent, (u32 *)0xFFE01214);
		debugfs_create_x32("ICPLB_DATA6", 0600, parent, (u32 *)0xFFE01218);
		debugfs_create_x32("ICPLB_DATA7", 0600, parent, (u32 *)0xFFE0121C);
		debugfs_create_x32("ICPLB_DATA8", 0600, parent, (u32 *)0xFFE01220);
		debugfs_create_x32("ICPLB_DATA9", 0600, parent, (u32 *)0xFFE01224);
		debugfs_create_x32("ICPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0100C);
		debugfs_create_x32("ICPLB_STATUS", 0600, parent, (u32 *)0xFFE01008);
		debugfs_create_x32("IMEM_CONTROL", 0600, parent, (u32 *)0xFFE01004);
		debugfs_create_x32("ITEST_COMMAND", 0600, parent, (u32 *)0xFFE01300);
		debugfs_create_x32("ITEST_DATA0", 0600, parent, (u32 *)0xFFE01400);
		debugfs_create_x32("ITEST_DATA1", 0600, parent, (u32 *)0xFFE01404);

		parent = debugfs_create_dir("L1 Data Memory Registers", top);
		debugfs_create_x32("DCPLB_ADDR0", 0600, parent, (u32 *)0xFFE00100);
		debugfs_create_x32("DCPLB_ADDR10", 0600, parent, (u32 *)0xFFE00128);
		debugfs_create_x32("DCPLB_ADDR11", 0600, parent, (u32 *)0xFFE0012C);
		debugfs_create_x32("DCPLB_ADDR12", 0600, parent, (u32 *)0xFFE00130);
		debugfs_create_x32("DCPLB_ADDR13", 0600, parent, (u32 *)0xFFE00134);
		debugfs_create_x32("DCPLB_ADDR14", 0600, parent, (u32 *)0xFFE00138);
		debugfs_create_x32("DCPLB_ADDR15", 0600, parent, (u32 *)0xFFE0013C);
		debugfs_create_x32("DCPLB_ADDR1", 0600, parent, (u32 *)0xFFE00104);
		debugfs_create_x32("DCPLB_ADDR2", 0600, parent, (u32 *)0xFFE00108);
		debugfs_create_x32("DCPLB_ADDR3", 0600, parent, (u32 *)0xFFE0010C);
		debugfs_create_x32("DCPLB_ADDR4", 0600, parent, (u32 *)0xFFE00110);
		debugfs_create_x32("DCPLB_ADDR5", 0600, parent, (u32 *)0xFFE00114);
		debugfs_create_x32("DCPLB_ADDR6", 0600, parent, (u32 *)0xFFE00118);
		debugfs_create_x32("DCPLB_ADDR7", 0600, parent, (u32 *)0xFFE0011C);
		debugfs_create_x32("DCPLB_ADDR8", 0600, parent, (u32 *)0xFFE00120);
		debugfs_create_x32("DCPLB_ADDR9", 0600, parent, (u32 *)0xFFE00124);
		debugfs_create_x32("DCPLB_DATA0", 0600, parent, (u32 *)0xFFE00200);
		debugfs_create_x32("DCPLB_DATA10", 0600, parent, (u32 *)0xFFE00228);
		debugfs_create_x32("DCPLB_DATA11", 0600, parent, (u32 *)0xFFE0022C);
		debugfs_create_x32("DCPLB_DATA12", 0600, parent, (u32 *)0xFFE00230);
		debugfs_create_x32("DCPLB_DATA13", 0600, parent, (u32 *)0xFFE00234);
		debugfs_create_x32("DCPLB_DATA14", 0600, parent, (u32 *)0xFFE00238);
		debugfs_create_x32("DCPLB_DATA15", 0600, parent, (u32 *)0xFFE0023C);
		debugfs_create_x32("DCPLB_DATA1", 0600, parent, (u32 *)0xFFE00204);
		debugfs_create_x32("DCPLB_DATA2", 0600, parent, (u32 *)0xFFE00208);
		debugfs_create_x32("DCPLB_DATA3", 0600, parent, (u32 *)0xFFE0020C);
		debugfs_create_x32("DCPLB_DATA4", 0600, parent, (u32 *)0xFFE00210);
		debugfs_create_x32("DCPLB_DATA5", 0600, parent, (u32 *)0xFFE00214);
		debugfs_create_x32("DCPLB_DATA6", 0600, parent, (u32 *)0xFFE00218);
		debugfs_create_x32("DCPLB_DATA7", 0600, parent, (u32 *)0xFFE0021C);
		debugfs_create_x32("DCPLB_DATA8", 0600, parent, (u32 *)0xFFE00220);
		debugfs_create_x32("DCPLB_DATA9", 0600, parent, (u32 *)0xFFE00224);
		debugfs_create_x32("DCPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0000C);
		debugfs_create_x32("DMEM_CONTROL", 0600, parent, (u32 *)0xFFE00004);
		debugfs_create_x32("DTEST_COMMAND", 0600, parent, (u32 *)0xFFE00300);
		debugfs_create_x32("DTEST_DATA0", 0600, parent, (u32 *)0xFFE00400);
		debugfs_create_x32("DTEST_DATA1", 0600, parent, (u32 *)0xFFE00404);
		debugfs_create_x32("SRAM_BASE_ADDR", 0600, parent, (u32 *)0xFFE00000);

		parent = debugfs_create_dir("MDMA Destination 0", top);
		debugfs_create_x16("MDMA_D0_CONFIG", 0600, parent, (u16 *)0xFFC00F08);
		debugfs_create_x32("MDMA_D0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F24);
		debugfs_create_x32("MDMA_D0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F20);
		debugfs_create_x16("MDMA_D0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F30);
		debugfs_create_x16("MDMA_D0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F38);
		debugfs_create_x16("MDMA_D0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F28);
		debugfs_create_x32("MDMA_D0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F00);
		debugfs_create_x16("MDMA_D0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F2C);
		debugfs_create_x32("MDMA_D0_START_ADDR", 0600, parent, (u32 *)0xFFC00F04);
		debugfs_create_x16("MDMA_D0_X_COUNT", 0600, parent, (u16 *)0xFFC00F10);
		debugfs_create_x16("MDMA_D0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F14);
		debugfs_create_x16("MDMA_D0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F18);
		debugfs_create_x16("MDMA_D0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F1C);

		parent = debugfs_create_dir("MDMA Destination 1", top);
		debugfs_create_x16("MDMA_D1_CONFIG", 0600, parent, (u16 *)0xFFC00F88);
		debugfs_create_x32("MDMA_D1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FA4);
		debugfs_create_x32("MDMA_D1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FA0);
		debugfs_create_x16("MDMA_D1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FB0);
		debugfs_create_x16("MDMA_D1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FB8);
		debugfs_create_x16("MDMA_D1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FA8);
		debugfs_create_x32("MDMA_D1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F80);
		debugfs_create_x16("MDMA_D1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FAC);
		debugfs_create_x32("MDMA_D1_START_ADDR", 0600, parent, (u32 *)0xFFC00F84);
		debugfs_create_x16("MDMA_D1_X_COUNT", 0600, parent, (u16 *)0xFFC00F90);
		debugfs_create_x16("MDMA_D1_X_MODIFY", 0600, parent, (u16 *)0xFFC00F94);
		debugfs_create_x16("MDMA_D1_Y_COUNT", 0600, parent, (u16 *)0xFFC00F98);
		debugfs_create_x16("MDMA_D1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F9C);

		parent = debugfs_create_dir("MDMA Source 0", top);
		debugfs_create_x16("MDMA_S0_CONFIG", 0600, parent, (u16 *)0xFFC00F48);
		debugfs_create_x32("MDMA_S0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F64);
		debugfs_create_x32("MDMA_S0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F60);
		debugfs_create_x16("MDMA_S0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F70);
		debugfs_create_x16("MDMA_S0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F78);
		debugfs_create_x16("MDMA_S0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F68);
		debugfs_create_x32("MDMA_S0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F40);
		debugfs_create_x16("MDMA_S0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F6C);
		debugfs_create_x32("MDMA_S0_START_ADDR", 0600, parent, (u32 *)0xFFC00F44);
		debugfs_create_x16("MDMA_S0_X_COUNT", 0600, parent, (u16 *)0xFFC00F50);
		debugfs_create_x16("MDMA_S0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F54);
		debugfs_create_x16("MDMA_S0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F58);
		debugfs_create_x16("MDMA_S0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F5C);

		parent = debugfs_create_dir("MDMA Source 1", top);
		debugfs_create_x16("MDMA_S1_CONFIG", 0600, parent, (u16 *)0xFFC00FC8);
		debugfs_create_x32("MDMA_S1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FE4);
		debugfs_create_x32("MDMA_S1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FE0);
		debugfs_create_x16("MDMA_S1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FF0);
		debugfs_create_x16("MDMA_S1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FF8);
		debugfs_create_x16("MDMA_S1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FE8);
		debugfs_create_x32("MDMA_S1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00FC0);
		debugfs_create_x16("MDMA_S1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FEC);
		debugfs_create_x32("MDMA_S1_START_ADDR", 0600, parent, (u32 *)0xFFC00FC4);
		debugfs_create_x16("MDMA_S1_X_COUNT", 0600, parent, (u16 *)0xFFC00FD0);
		debugfs_create_x16("MDMA_S1_X_MODIFY", 0600, parent, (u16 *)0xFFC00FD4);
		debugfs_create_x16("MDMA_S1_Y_COUNT", 0600, parent, (u16 *)0xFFC00FD8);
		debugfs_create_x16("MDMA_S1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00FDC);

		parent = debugfs_create_dir("Mailbox Registers", top);
		debugfs_create_x16("CAN_MB00_DATA0", 0600, parent, (u16 *)0xFFC02C00);
		debugfs_create_x16("CAN_MB00_DATA1", 0600, parent, (u16 *)0xFFC02C04);
		debugfs_create_x16("CAN_MB00_DATA2", 0600, parent, (u16 *)0xFFC02C08);
		debugfs_create_x16("CAN_MB00_DATA3", 0600, parent, (u16 *)0xFFC02C0C);
		debugfs_create_x16("CAN_MB00_ID0", 0600, parent, (u16 *)0xFFC02C18);
		debugfs_create_x16("CAN_MB00_ID1", 0600, parent, (u16 *)0xFFC02C1C);
		debugfs_create_x16("CAN_MB00_LENGTH", 0600, parent, (u16 *)0xFFC02C10);
		debugfs_create_x16("CAN_MB00_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C14);
		debugfs_create_x16("CAN_MB01_DATA0", 0600, parent, (u16 *)0xFFC02C20);
		debugfs_create_x16("CAN_MB01_DATA1", 0600, parent, (u16 *)0xFFC02C24);
		debugfs_create_x16("CAN_MB01_DATA2", 0600, parent, (u16 *)0xFFC02C28);
		debugfs_create_x16("CAN_MB01_DATA3", 0600, parent, (u16 *)0xFFC02C2C);
		debugfs_create_x16("CAN_MB01_ID0", 0600, parent, (u16 *)0xFFC02C38);
		debugfs_create_x16("CAN_MB01_ID1", 0600, parent, (u16 *)0xFFC02C3C);
		debugfs_create_x16("CAN_MB01_LENGTH", 0600, parent, (u16 *)0xFFC02C30);
		debugfs_create_x16("CAN_MB01_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C34);
		debugfs_create_x16("CAN_MB02_DATA0", 0600, parent, (u16 *)0xFFC02C40);
		debugfs_create_x16("CAN_MB02_DATA1", 0600, parent, (u16 *)0xFFC02C44);
		debugfs_create_x16("CAN_MB02_DATA2", 0600, parent, (u16 *)0xFFC02C48);
		debugfs_create_x16("CAN_MB02_DATA3", 0600, parent, (u16 *)0xFFC02C4C);
		debugfs_create_x16("CAN_MB02_ID0", 0600, parent, (u16 *)0xFFC02C58);
		debugfs_create_x16("CAN_MB02_ID1", 0600, parent, (u16 *)0xFFC02C5C);
		debugfs_create_x16("CAN_MB02_LENGTH", 0600, parent, (u16 *)0xFFC02C50);
		debugfs_create_x16("CAN_MB02_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C54);
		debugfs_create_x16("CAN_MB03_DATA0", 0600, parent, (u16 *)0xFFC02C60);
		debugfs_create_x16("CAN_MB03_DATA1", 0600, parent, (u16 *)0xFFC02C64);
		debugfs_create_x16("CAN_MB03_DATA2", 0600, parent, (u16 *)0xFFC02C68);
		debugfs_create_x16("CAN_MB03_DATA3", 0600, parent, (u16 *)0xFFC02C6C);
		debugfs_create_x16("CAN_MB03_ID0", 0600, parent, (u16 *)0xFFC02C78);
		debugfs_create_x16("CAN_MB03_ID1", 0600, parent, (u16 *)0xFFC02C7C);
		debugfs_create_x16("CAN_MB03_LENGTH", 0600, parent, (u16 *)0xFFC02C70);
		debugfs_create_x16("CAN_MB03_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C74);
		debugfs_create_x16("CAN_MB04_DATA0", 0600, parent, (u16 *)0xFFC02C80);
		debugfs_create_x16("CAN_MB04_DATA1", 0600, parent, (u16 *)0xFFC02C84);
		debugfs_create_x16("CAN_MB04_DATA2", 0600, parent, (u16 *)0xFFC02C88);
		debugfs_create_x16("CAN_MB04_DATA3", 0600, parent, (u16 *)0xFFC02C8C);
		debugfs_create_x16("CAN_MB04_ID0", 0600, parent, (u16 *)0xFFC02C98);
		debugfs_create_x16("CAN_MB04_ID1", 0600, parent, (u16 *)0xFFC02C9C);
		debugfs_create_x16("CAN_MB04_LENGTH", 0600, parent, (u16 *)0xFFC02C90);
		debugfs_create_x16("CAN_MB04_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C94);
		debugfs_create_x16("CAN_MB05_DATA0", 0600, parent, (u16 *)0xFFC02CA0);
		debugfs_create_x16("CAN_MB05_DATA1", 0600, parent, (u16 *)0xFFC02CA4);
		debugfs_create_x16("CAN_MB05_DATA2", 0600, parent, (u16 *)0xFFC02CA8);
		debugfs_create_x16("CAN_MB05_DATA3", 0600, parent, (u16 *)0xFFC02CAC);
		debugfs_create_x16("CAN_MB05_ID0", 0600, parent, (u16 *)0xFFC02CB8);
		debugfs_create_x16("CAN_MB05_ID1", 0600, parent, (u16 *)0xFFC02CBC);
		debugfs_create_x16("CAN_MB05_LENGTH", 0600, parent, (u16 *)0xFFC02CB0);
		debugfs_create_x16("CAN_MB05_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CB4);
		debugfs_create_x16("CAN_MB06_DATA0", 0600, parent, (u16 *)0xFFC02CC0);
		debugfs_create_x16("CAN_MB06_DATA1", 0600, parent, (u16 *)0xFFC02CC4);
		debugfs_create_x16("CAN_MB06_DATA2", 0600, parent, (u16 *)0xFFC02CC8);
		debugfs_create_x16("CAN_MB06_DATA3", 0600, parent, (u16 *)0xFFC02CCC);
		debugfs_create_x16("CAN_MB06_ID0", 0600, parent, (u16 *)0xFFC02CD8);
		debugfs_create_x16("CAN_MB06_ID1", 0600, parent, (u16 *)0xFFC02CDC);
		debugfs_create_x16("CAN_MB06_LENGTH", 0600, parent, (u16 *)0xFFC02CD0);
		debugfs_create_x16("CAN_MB06_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CD4);
		debugfs_create_x16("CAN_MB07_DATA0", 0600, parent, (u16 *)0xFFC02CE0);
		debugfs_create_x16("CAN_MB07_DATA1", 0600, parent, (u16 *)0xFFC02CE4);
		debugfs_create_x16("CAN_MB07_DATA2", 0600, parent, (u16 *)0xFFC02CE8);
		debugfs_create_x16("CAN_MB07_DATA3", 0600, parent, (u16 *)0xFFC02CEC);
		debugfs_create_x16("CAN_MB07_ID0", 0600, parent, (u16 *)0xFFC02CF8);
		debugfs_create_x16("CAN_MB07_ID1", 0600, parent, (u16 *)0xFFC02CFC);
		debugfs_create_x16("CAN_MB07_LENGTH", 0600, parent, (u16 *)0xFFC02CF0);
		debugfs_create_x16("CAN_MB07_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CF4);
		debugfs_create_x16("CAN_MB08_DATA0", 0600, parent, (u16 *)0xFFC02D00);
		debugfs_create_x16("CAN_MB08_DATA1", 0600, parent, (u16 *)0xFFC02D04);
		debugfs_create_x16("CAN_MB08_DATA2", 0600, parent, (u16 *)0xFFC02D08);
		debugfs_create_x16("CAN_MB08_DATA3", 0600, parent, (u16 *)0xFFC02D0C);
		debugfs_create_x16("CAN_MB08_ID0", 0600, parent, (u16 *)0xFFC02D18);
		debugfs_create_x16("CAN_MB08_ID1", 0600, parent, (u16 *)0xFFC02D1C);
		debugfs_create_x16("CAN_MB08_LENGTH", 0600, parent, (u16 *)0xFFC02D10);
		debugfs_create_x16("CAN_MB08_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D14);
		debugfs_create_x16("CAN_MB09_DATA0", 0600, parent, (u16 *)0xFFC02D20);
		debugfs_create_x16("CAN_MB09_DATA1", 0600, parent, (u16 *)0xFFC02D24);
		debugfs_create_x16("CAN_MB09_DATA2", 0600, parent, (u16 *)0xFFC02D28);
		debugfs_create_x16("CAN_MB09_DATA3", 0600, parent, (u16 *)0xFFC02D2C);
		debugfs_create_x16("CAN_MB09_ID0", 0600, parent, (u16 *)0xFFC02D38);
		debugfs_create_x16("CAN_MB09_ID1", 0600, parent, (u16 *)0xFFC02D3C);
		debugfs_create_x16("CAN_MB09_LENGTH", 0600, parent, (u16 *)0xFFC02D30);
		debugfs_create_x16("CAN_MB09_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D34);
		debugfs_create_x16("CAN_MB10_DATA0", 0600, parent, (u16 *)0xFFC02D40);
		debugfs_create_x16("CAN_MB10_DATA1", 0600, parent, (u16 *)0xFFC02D44);
		debugfs_create_x16("CAN_MB10_DATA2", 0600, parent, (u16 *)0xFFC02D48);
		debugfs_create_x16("CAN_MB10_DATA3", 0600, parent, (u16 *)0xFFC02D4C);
		debugfs_create_x16("CAN_MB10_ID0", 0600, parent, (u16 *)0xFFC02D58);
		debugfs_create_x16("CAN_MB10_ID1", 0600, parent, (u16 *)0xFFC02D5C);
		debugfs_create_x16("CAN_MB10_LENGTH", 0600, parent, (u16 *)0xFFC02D50);
		debugfs_create_x16("CAN_MB10_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D54);
		debugfs_create_x16("CAN_MB11_DATA0", 0600, parent, (u16 *)0xFFC02D60);
		debugfs_create_x16("CAN_MB11_DATA1", 0600, parent, (u16 *)0xFFC02D64);
		debugfs_create_x16("CAN_MB11_DATA2", 0600, parent, (u16 *)0xFFC02D68);
		debugfs_create_x16("CAN_MB11_DATA3", 0600, parent, (u16 *)0xFFC02D6C);
		debugfs_create_x16("CAN_MB11_ID0", 0600, parent, (u16 *)0xFFC02D78);
		debugfs_create_x16("CAN_MB11_ID1", 0600, parent, (u16 *)0xFFC02D7C);
		debugfs_create_x16("CAN_MB11_LENGTH", 0600, parent, (u16 *)0xFFC02D70);
		debugfs_create_x16("CAN_MB11_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D74);
		debugfs_create_x16("CAN_MB12_DATA0", 0600, parent, (u16 *)0xFFC02D80);
		debugfs_create_x16("CAN_MB12_DATA1", 0600, parent, (u16 *)0xFFC02D84);
		debugfs_create_x16("CAN_MB12_DATA2", 0600, parent, (u16 *)0xFFC02D88);
		debugfs_create_x16("CAN_MB12_DATA3", 0600, parent, (u16 *)0xFFC02D8C);
		debugfs_create_x16("CAN_MB12_ID0", 0600, parent, (u16 *)0xFFC02D98);
		debugfs_create_x16("CAN_MB12_ID1", 0600, parent, (u16 *)0xFFC02D9C);
		debugfs_create_x16("CAN_MB12_LENGTH", 0600, parent, (u16 *)0xFFC02D90);
		debugfs_create_x16("CAN_MB12_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D94);
		debugfs_create_x16("CAN_MB13_DATA0", 0600, parent, (u16 *)0xFFC02DA0);
		debugfs_create_x16("CAN_MB13_DATA1", 0600, parent, (u16 *)0xFFC02DA4);
		debugfs_create_x16("CAN_MB13_DATA2", 0600, parent, (u16 *)0xFFC02DA8);
		debugfs_create_x16("CAN_MB13_DATA3", 0600, parent, (u16 *)0xFFC02DAC);
		debugfs_create_x16("CAN_MB13_ID0", 0600, parent, (u16 *)0xFFC02DB8);
		debugfs_create_x16("CAN_MB13_ID1", 0600, parent, (u16 *)0xFFC02DBC);
		debugfs_create_x16("CAN_MB13_LENGTH", 0600, parent, (u16 *)0xFFC02DB0);
		debugfs_create_x16("CAN_MB13_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DB4);
		debugfs_create_x16("CAN_MB14_DATA0", 0600, parent, (u16 *)0xFFC02DC0);
		debugfs_create_x16("CAN_MB14_DATA1", 0600, parent, (u16 *)0xFFC02DC4);
		debugfs_create_x16("CAN_MB14_DATA2", 0600, parent, (u16 *)0xFFC02DC8);
		debugfs_create_x16("CAN_MB14_DATA3", 0600, parent, (u16 *)0xFFC02DCC);
		debugfs_create_x16("CAN_MB14_ID0", 0600, parent, (u16 *)0xFFC02DD8);
		debugfs_create_x16("CAN_MB14_ID1", 0600, parent, (u16 *)0xFFC02DDC);
		debugfs_create_x16("CAN_MB14_LENGTH", 0600, parent, (u16 *)0xFFC02DD0);
		debugfs_create_x16("CAN_MB14_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DD4);
		debugfs_create_x16("CAN_MB15_DATA0", 0600, parent, (u16 *)0xFFC02DE0);
		debugfs_create_x16("CAN_MB15_DATA1", 0600, parent, (u16 *)0xFFC02DE4);
		debugfs_create_x16("CAN_MB15_DATA2", 0600, parent, (u16 *)0xFFC02DE8);
		debugfs_create_x16("CAN_MB15_DATA3", 0600, parent, (u16 *)0xFFC02DEC);
		debugfs_create_x16("CAN_MB15_ID0", 0600, parent, (u16 *)0xFFC02DF8);
		debugfs_create_x16("CAN_MB15_ID1", 0600, parent, (u16 *)0xFFC02DFC);
		debugfs_create_x16("CAN_MB15_LENGTH", 0600, parent, (u16 *)0xFFC02DF0);
		debugfs_create_x16("CAN_MB15_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DF4);
		debugfs_create_x16("CAN_MB16_DATA0", 0600, parent, (u16 *)0xFFC02E00);
		debugfs_create_x16("CAN_MB16_DATA1", 0600, parent, (u16 *)0xFFC02E04);
		debugfs_create_x16("CAN_MB16_DATA2", 0600, parent, (u16 *)0xFFC02E08);
		debugfs_create_x16("CAN_MB16_DATA3", 0600, parent, (u16 *)0xFFC02E0C);
		debugfs_create_x16("CAN_MB16_ID0", 0600, parent, (u16 *)0xFFC02E18);
		debugfs_create_x16("CAN_MB16_ID1", 0600, parent, (u16 *)0xFFC02E1C);
		debugfs_create_x16("CAN_MB16_LENGTH", 0600, parent, (u16 *)0xFFC02E10);
		debugfs_create_x16("CAN_MB16_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E14);
		debugfs_create_x16("CAN_MB17_DATA0", 0600, parent, (u16 *)0xFFC02E20);
		debugfs_create_x16("CAN_MB17_DATA1", 0600, parent, (u16 *)0xFFC02E24);
		debugfs_create_x16("CAN_MB17_DATA2", 0600, parent, (u16 *)0xFFC02E28);
		debugfs_create_x16("CAN_MB17_DATA3", 0600, parent, (u16 *)0xFFC02E2C);
		debugfs_create_x16("CAN_MB17_ID0", 0600, parent, (u16 *)0xFFC02E38);
		debugfs_create_x16("CAN_MB17_ID1", 0600, parent, (u16 *)0xFFC02E3C);
		debugfs_create_x16("CAN_MB17_LENGTH", 0600, parent, (u16 *)0xFFC02E30);
		debugfs_create_x16("CAN_MB17_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E34);
		debugfs_create_x16("CAN_MB18_DATA0", 0600, parent, (u16 *)0xFFC02E40);
		debugfs_create_x16("CAN_MB18_DATA1", 0600, parent, (u16 *)0xFFC02E44);
		debugfs_create_x16("CAN_MB18_DATA2", 0600, parent, (u16 *)0xFFC02E48);
		debugfs_create_x16("CAN_MB18_DATA3", 0600, parent, (u16 *)0xFFC02E4C);
		debugfs_create_x16("CAN_MB18_ID0", 0600, parent, (u16 *)0xFFC02E58);
		debugfs_create_x16("CAN_MB18_ID1", 0600, parent, (u16 *)0xFFC02E5C);
		debugfs_create_x16("CAN_MB18_LENGTH", 0600, parent, (u16 *)0xFFC02E50);
		debugfs_create_x16("CAN_MB18_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E54);
		debugfs_create_x16("CAN_MB19_DATA0", 0600, parent, (u16 *)0xFFC02E60);
		debugfs_create_x16("CAN_MB19_DATA1", 0600, parent, (u16 *)0xFFC02E64);
		debugfs_create_x16("CAN_MB19_DATA2", 0600, parent, (u16 *)0xFFC02E68);
		debugfs_create_x16("CAN_MB19_DATA3", 0600, parent, (u16 *)0xFFC02E6C);
		debugfs_create_x16("CAN_MB19_ID0", 0600, parent, (u16 *)0xFFC02E78);
		debugfs_create_x16("CAN_MB19_ID1", 0600, parent, (u16 *)0xFFC02E7C);
		debugfs_create_x16("CAN_MB19_LENGTH", 0600, parent, (u16 *)0xFFC02E70);
		debugfs_create_x16("CAN_MB19_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E74);
		debugfs_create_x16("CAN_MB20_DATA0", 0600, parent, (u16 *)0xFFC02E80);
		debugfs_create_x16("CAN_MB20_DATA1", 0600, parent, (u16 *)0xFFC02E84);
		debugfs_create_x16("CAN_MB20_DATA2", 0600, parent, (u16 *)0xFFC02E88);
		debugfs_create_x16("CAN_MB20_DATA3", 0600, parent, (u16 *)0xFFC02E8C);
		debugfs_create_x16("CAN_MB20_ID0", 0600, parent, (u16 *)0xFFC02E98);
		debugfs_create_x16("CAN_MB20_ID1", 0600, parent, (u16 *)0xFFC02E9C);
		debugfs_create_x16("CAN_MB20_LENGTH", 0600, parent, (u16 *)0xFFC02E90);
		debugfs_create_x16("CAN_MB20_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E94);
		debugfs_create_x16("CAN_MB21_DATA0", 0600, parent, (u16 *)0xFFC02EA0);
		debugfs_create_x16("CAN_MB21_DATA1", 0600, parent, (u16 *)0xFFC02EA4);
		debugfs_create_x16("CAN_MB21_DATA2", 0600, parent, (u16 *)0xFFC02EA8);
		debugfs_create_x16("CAN_MB21_DATA3", 0600, parent, (u16 *)0xFFC02EAC);
		debugfs_create_x16("CAN_MB21_ID0", 0600, parent, (u16 *)0xFFC02EB8);
		debugfs_create_x16("CAN_MB21_ID1", 0600, parent, (u16 *)0xFFC02EBC);
		debugfs_create_x16("CAN_MB21_LENGTH", 0600, parent, (u16 *)0xFFC02EB0);
		debugfs_create_x16("CAN_MB21_TIMESTAMP", 0600, parent, (u16 *)0xFFC02EB4);
		debugfs_create_x16("CAN_MB22_DATA0", 0600, parent, (u16 *)0xFFC02EC0);
		debugfs_create_x16("CAN_MB22_DATA1", 0600, parent, (u16 *)0xFFC02EC4);
		debugfs_create_x16("CAN_MB22_DATA2", 0600, parent, (u16 *)0xFFC02EC8);
		debugfs_create_x16("CAN_MB22_DATA3", 0600, parent, (u16 *)0xFFC02ECC);
		debugfs_create_x16("CAN_MB22_ID0", 0600, parent, (u16 *)0xFFC02ED8);
		debugfs_create_x16("CAN_MB22_ID1", 0600, parent, (u16 *)0xFFC02EDC);
		debugfs_create_x16("CAN_MB22_LENGTH", 0600, parent, (u16 *)0xFFC02ED0);
		debugfs_create_x16("CAN_MB22_TIMESTAMP", 0600, parent, (u16 *)0xFFC02ED4);
		debugfs_create_x16("CAN_MB23_DATA0", 0600, parent, (u16 *)0xFFC02EE0);
		debugfs_create_x16("CAN_MB23_DATA1", 0600, parent, (u16 *)0xFFC02EE4);
		debugfs_create_x16("CAN_MB23_DATA2", 0600, parent, (u16 *)0xFFC02EE8);
		debugfs_create_x16("CAN_MB23_DATA3", 0600, parent, (u16 *)0xFFC02EEC);
		debugfs_create_x16("CAN_MB23_ID0", 0600, parent, (u16 *)0xFFC02EF8);
		debugfs_create_x16("CAN_MB23_ID1", 0600, parent, (u16 *)0xFFC02EFC);
		debugfs_create_x16("CAN_MB23_LENGTH", 0600, parent, (u16 *)0xFFC02EF0);
		debugfs_create_x16("CAN_MB23_TIMESTAMP", 0600, parent, (u16 *)0xFFC02EF4);
		debugfs_create_x16("CAN_MB24_DATA0", 0600, parent, (u16 *)0xFFC02F00);
		debugfs_create_x16("CAN_MB24_DATA1", 0600, parent, (u16 *)0xFFC02F04);
		debugfs_create_x16("CAN_MB24_DATA2", 0600, parent, (u16 *)0xFFC02F08);
		debugfs_create_x16("CAN_MB24_DATA3", 0600, parent, (u16 *)0xFFC02F0C);
		debugfs_create_x16("CAN_MB24_ID0", 0600, parent, (u16 *)0xFFC02F18);
		debugfs_create_x16("CAN_MB24_ID1", 0600, parent, (u16 *)0xFFC02F1C);
		debugfs_create_x16("CAN_MB24_LENGTH", 0600, parent, (u16 *)0xFFC02F10);
		debugfs_create_x16("CAN_MB24_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F14);
		debugfs_create_x16("CAN_MB25_DATA0", 0600, parent, (u16 *)0xFFC02F20);
		debugfs_create_x16("CAN_MB25_DATA1", 0600, parent, (u16 *)0xFFC02F24);
		debugfs_create_x16("CAN_MB25_DATA2", 0600, parent, (u16 *)0xFFC02F28);
		debugfs_create_x16("CAN_MB25_DATA3", 0600, parent, (u16 *)0xFFC02F2C);
		debugfs_create_x16("CAN_MB25_ID0", 0600, parent, (u16 *)0xFFC02F38);
		debugfs_create_x16("CAN_MB25_ID1", 0600, parent, (u16 *)0xFFC02F3C);
		debugfs_create_x16("CAN_MB25_LENGTH", 0600, parent, (u16 *)0xFFC02F30);
		debugfs_create_x16("CAN_MB25_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F34);
		debugfs_create_x16("CAN_MB26_DATA0", 0600, parent, (u16 *)0xFFC02F40);
		debugfs_create_x16("CAN_MB26_DATA1", 0600, parent, (u16 *)0xFFC02F44);
		debugfs_create_x16("CAN_MB26_DATA2", 0600, parent, (u16 *)0xFFC02F48);
		debugfs_create_x16("CAN_MB26_DATA3", 0600, parent, (u16 *)0xFFC02F4C);
		debugfs_create_x16("CAN_MB26_ID0", 0600, parent, (u16 *)0xFFC02F58);
		debugfs_create_x16("CAN_MB26_ID1", 0600, parent, (u16 *)0xFFC02F5C);
		debugfs_create_x16("CAN_MB26_LENGTH", 0600, parent, (u16 *)0xFFC02F50);
		debugfs_create_x16("CAN_MB26_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F54);
		debugfs_create_x16("CAN_MB27_DATA0", 0600, parent, (u16 *)0xFFC02F60);
		debugfs_create_x16("CAN_MB27_DATA1", 0600, parent, (u16 *)0xFFC02F64);
		debugfs_create_x16("CAN_MB27_DATA2", 0600, parent, (u16 *)0xFFC02F68);
		debugfs_create_x16("CAN_MB27_DATA3", 0600, parent, (u16 *)0xFFC02F6C);
		debugfs_create_x16("CAN_MB27_ID0", 0600, parent, (u16 *)0xFFC02F78);
		debugfs_create_x16("CAN_MB27_ID1", 0600, parent, (u16 *)0xFFC02F7C);
		debugfs_create_x16("CAN_MB27_LENGTH", 0600, parent, (u16 *)0xFFC02F70);
		debugfs_create_x16("CAN_MB27_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F74);
		debugfs_create_x16("CAN_MB28_DATA0", 0600, parent, (u16 *)0xFFC02F80);
		debugfs_create_x16("CAN_MB28_DATA1", 0600, parent, (u16 *)0xFFC02F84);
		debugfs_create_x16("CAN_MB28_DATA2", 0600, parent, (u16 *)0xFFC02F88);
		debugfs_create_x16("CAN_MB28_DATA3", 0600, parent, (u16 *)0xFFC02F8C);
		debugfs_create_x16("CAN_MB28_ID0", 0600, parent, (u16 *)0xFFC02F98);
		debugfs_create_x16("CAN_MB28_ID1", 0600, parent, (u16 *)0xFFC02F9C);
		debugfs_create_x16("CAN_MB28_LENGTH", 0600, parent, (u16 *)0xFFC02F90);
		debugfs_create_x16("CAN_MB28_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F94);
		debugfs_create_x16("CAN_MB29_DATA0", 0600, parent, (u16 *)0xFFC02FA0);
		debugfs_create_x16("CAN_MB29_DATA1", 0600, parent, (u16 *)0xFFC02FA4);
		debugfs_create_x16("CAN_MB29_DATA2", 0600, parent, (u16 *)0xFFC02FA8);
		debugfs_create_x16("CAN_MB29_DATA3", 0600, parent, (u16 *)0xFFC02FAC);
		debugfs_create_x16("CAN_MB29_ID0", 0600, parent, (u16 *)0xFFC02FB8);
		debugfs_create_x16("CAN_MB29_ID1", 0600, parent, (u16 *)0xFFC02FBC);
		debugfs_create_x16("CAN_MB29_LENGTH", 0600, parent, (u16 *)0xFFC02FB0);
		debugfs_create_x16("CAN_MB29_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FB4);
		debugfs_create_x16("CAN_MB30_DATA0", 0600, parent, (u16 *)0xFFC02FC0);
		debugfs_create_x16("CAN_MB30_DATA1", 0600, parent, (u16 *)0xFFC02FC4);
		debugfs_create_x16("CAN_MB30_DATA2", 0600, parent, (u16 *)0xFFC02FC8);
		debugfs_create_x16("CAN_MB30_DATA3", 0600, parent, (u16 *)0xFFC02FCC);
		debugfs_create_x16("CAN_MB30_ID0", 0600, parent, (u16 *)0xFFC02FD8);
		debugfs_create_x16("CAN_MB30_ID1", 0600, parent, (u16 *)0xFFC02FDC);
		debugfs_create_x16("CAN_MB30_LENGTH", 0600, parent, (u16 *)0xFFC02FD0);
		debugfs_create_x16("CAN_MB30_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FD4);
		debugfs_create_x16("CAN_MB31_DATA0", 0600, parent, (u16 *)0xFFC02FE0);
		debugfs_create_x16("CAN_MB31_DATA1", 0600, parent, (u16 *)0xFFC02FE4);
		debugfs_create_x16("CAN_MB31_DATA2", 0600, parent, (u16 *)0xFFC02FE8);
		debugfs_create_x16("CAN_MB31_DATA3", 0600, parent, (u16 *)0xFFC02FEC);
		debugfs_create_x16("CAN_MB31_ID0", 0600, parent, (u16 *)0xFFC02FF8);
		debugfs_create_x16("CAN_MB31_ID1", 0600, parent, (u16 *)0xFFC02FFC);
		debugfs_create_x16("CAN_MB31_LENGTH", 0600, parent, (u16 *)0xFFC02FF0);
		debugfs_create_x16("CAN_MB31_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FF4);

		parent = debugfs_create_dir("PLL", top);
		debugfs_create_x16("PLL_CTL", 0600, parent, (u16 *)0xFFC00000);
		debugfs_create_x16("PLL_DIV", 0600, parent, (u16 *)0xFFC00004);
		debugfs_create_x16("PLL_LOCKCNT", 0600, parent, (u16 *)0xFFC00010);
		debugfs_create_x16("PLL_STAT", 0600, parent, (u16 *)0xFFC0000C);
		debugfs_create_x16("VR_CTL", 0600, parent, (u16 *)0xFFC00008);

		parent = debugfs_create_dir("PPI", top);
		debugfs_create_x16("PPI_CONTROL", 0600, parent, (u16 *)0xFFC01000);
		debugfs_create_x16("PPI_COUNT", 0600, parent, (u16 *)0xFFC01008);
		debugfs_create_x16("PPI_DELAY", 0600, parent, (u16 *)0xFFC0100C);
		debugfs_create_x16("PPI_FRAME", 0600, parent, (u16 *)0xFFC01010);
		debugfs_create_x16("PPI_STATUS", 0600, parent, (u16 *)0xFFC01004);

		parent = debugfs_create_dir("Performance Monitor", top);
		debugfs_create_x32("PFCNTR0", 0600, parent, (u32 *)0xFFE08100);
		debugfs_create_x32("PFCNTR1", 0600, parent, (u32 *)0xFFE08104);
		debugfs_create_x32("PFCTL", 0600, parent, (u32 *)0xFFE08000);

		parent = debugfs_create_dir("Pin Control", top);
		debugfs_create_x16("PORTF_FER", 0600, parent, (u16 *)0xFFC03200);
		debugfs_create_x16("PORTG_FER", 0600, parent, (u16 *)0xFFC03204);
		debugfs_create_x16("PORTH_FER", 0600, parent, (u16 *)0xFFC03208);
		debugfs_create_x16("PORT_MUX", 0600, parent, (u16 *)0xFFC0320C);

		parent = debugfs_create_dir("Port I-O", top);
		debugfs_create_x16("PORTFIO", 0600, parent, (u16 *)0xFFC00700);
		debugfs_create_x16("PORTFIO_BOTH", 0600, parent, (u16 *)0xFFC0073C);
		debugfs_create_x16("PORTFIO_CLEAR", 0600, parent, (u16 *)0xFFC00704);
		debugfs_create_x16("PORTFIO_DIR", 0600, parent, (u16 *)0xFFC00730);
		debugfs_create_x16("PORTFIO_EDGE", 0600, parent, (u16 *)0xFFC00738);
		debugfs_create_x16("PORTFIO_INEN", 0600, parent, (u16 *)0xFFC00740);
		debugfs_create_x16("PORTFIO_MASKA", 0600, parent, (u16 *)0xFFC00710);
		debugfs_create_x16("PORTFIO_MASKA_CLEAR", 0600, parent, (u16 *)0xFFC00714);
		debugfs_create_x16("PORTFIO_MASKA_SET", 0600, parent, (u16 *)0xFFC00718);
		debugfs_create_x16("PORTFIO_MASKA_TOGGLE", 0600, parent, (u16 *)0xFFC0071C);
		debugfs_create_x16("PORTFIO_MASKB", 0600, parent, (u16 *)0xFFC00720);
		debugfs_create_x16("PORTFIO_MASKB_CLEAR", 0600, parent, (u16 *)0xFFC00724);
		debugfs_create_x16("PORTFIO_MASKB_SET", 0600, parent, (u16 *)0xFFC00728);
		debugfs_create_x16("PORTFIO_MASKB_TOGGLE", 0600, parent, (u16 *)0xFFC0072C);
		debugfs_create_x16("PORTFIO_POLAR", 0600, parent, (u16 *)0xFFC00734);
		debugfs_create_x16("PORTFIO_SET", 0600, parent, (u16 *)0xFFC00708);
		debugfs_create_x16("PORTFIO_TOGGLE", 0600, parent, (u16 *)0xFFC0070C);
		debugfs_create_x16("PORTGIO", 0600, parent, (u16 *)0xFFC01500);
		debugfs_create_x16("PORTGIO_BOTH", 0600, parent, (u16 *)0xFFC0153C);
		debugfs_create_x16("PORTGIO_CLEAR", 0600, parent, (u16 *)0xFFC01504);
		debugfs_create_x16("PORTGIO_DIR", 0600, parent, (u16 *)0xFFC01530);
		debugfs_create_x16("PORTGIO_EDGE", 0600, parent, (u16 *)0xFFC01538);
		debugfs_create_x16("PORTGIO_INEN", 0600, parent, (u16 *)0xFFC01540);
		debugfs_create_x16("PORTGIO_MASKA", 0600, parent, (u16 *)0xFFC01510);
		debugfs_create_x16("PORTGIO_MASKA_CLEAR", 0600, parent, (u16 *)0xFFC01514);
		debugfs_create_x16("PORTGIO_MASKA_SET", 0600, parent, (u16 *)0xFFC01518);
		debugfs_create_x16("PORTGIO_MASKA_TOGGLE", 0600, parent, (u16 *)0xFFC0151C);
		debugfs_create_x16("PORTGIO_MASKB", 0600, parent, (u16 *)0xFFC01520);
		debugfs_create_x16("PORTGIO_MASKB_CLEAR", 0600, parent, (u16 *)0xFFC01524);
		debugfs_create_x16("PORTGIO_MASKB_SET", 0600, parent, (u16 *)0xFFC01528);
		debugfs_create_x16("PORTGIO_MASKB_TOGGLE", 0600, parent, (u16 *)0xFFC0152C);
		debugfs_create_x16("PORTGIO_POLAR", 0600, parent, (u16 *)0xFFC01534);
		debugfs_create_x16("PORTGIO_SET", 0600, parent, (u16 *)0xFFC01508);
		debugfs_create_x16("PORTGIO_TOGGLE", 0600, parent, (u16 *)0xFFC0150C);
		debugfs_create_x16("PORTHIO", 0600, parent, (u16 *)0xFFC01700);
		debugfs_create_x16("PORTHIO_BOTH", 0600, parent, (u16 *)0xFFC0173C);
		debugfs_create_x16("PORTHIO_CLEAR", 0600, parent, (u16 *)0xFFC01704);
		debugfs_create_x16("PORTHIO_DIR", 0600, parent, (u16 *)0xFFC01730);
		debugfs_create_x16("PORTHIO_EDGE", 0600, parent, (u16 *)0xFFC01738);
		debugfs_create_x16("PORTHIO_INEN", 0600, parent, (u16 *)0xFFC01740);
		debugfs_create_x16("PORTHIO_MASKA", 0600, parent, (u16 *)0xFFC01710);
		debugfs_create_x16("PORTHIO_MASKA_CLEAR", 0600, parent, (u16 *)0xFFC01714);
		debugfs_create_x16("PORTHIO_MASKA_SET", 0600, parent, (u16 *)0xFFC01718);
		debugfs_create_x16("PORTHIO_MASKA_TOGGLE", 0600, parent, (u16 *)0xFFC0171C);
		debugfs_create_x16("PORTHIO_MASKB", 0600, parent, (u16 *)0xFFC01720);
		debugfs_create_x16("PORTHIO_MASKB_CLEAR", 0600, parent, (u16 *)0xFFC01724);
		debugfs_create_x16("PORTHIO_MASKB_SET", 0600, parent, (u16 *)0xFFC01728);
		debugfs_create_x16("PORTHIO_MASKB_TOGGLE", 0600, parent, (u16 *)0xFFC0172C);
		debugfs_create_x16("PORTHIO_POLAR", 0600, parent, (u16 *)0xFFC01734);
		debugfs_create_x16("PORTHIO_SET", 0600, parent, (u16 *)0xFFC01708);
		debugfs_create_x16("PORTHIO_TOGGLE", 0600, parent, (u16 *)0xFFC0170C);

		parent = debugfs_create_dir("RTC", top);
		debugfs_create_x32("RTC_ALARM", 0600, parent, (u32 *)0xFFC00310);
		debugfs_create_x16("RTC_ICTL", 0600, parent, (u16 *)0xFFC00304);
		debugfs_create_x16("RTC_ISTAT", 0600, parent, (u16 *)0xFFC00308);
		debugfs_create_x16("RTC_PREN", 0600, parent, (u16 *)0xFFC00314);
		debugfs_create_x32("RTC_STAT", 0600, parent, (u32 *)0xFFC00300);
		debugfs_create_x16("RTC_SWCNT", 0600, parent, (u16 *)0xFFC0030C);

		parent = debugfs_create_dir("SPI", top);
		debugfs_create_x16("SPI_BAUD", 0600, parent, (u16 *)0xFFC00514);
		debugfs_create_x16("SPI_CTL", 0600, parent, (u16 *)0xFFC00500);
		debugfs_create_x16("SPI_FLG", 0600, parent, (u16 *)0xFFC00504);
		debugfs_create_x16("SPI_RDBR", 0600, parent, (u16 *)0xFFC00510);
		debugfs_create_x16("SPI_SHADOW", 0600, parent, (u16 *)0xFFC00518);
		debugfs_create_x16("SPI_STAT", 0600, parent, (u16 *)0xFFC00508);
		debugfs_create_x16("SPI_TDBR", 0600, parent, (u16 *)0xFFC0050C);

		parent = debugfs_create_dir("SPORT", top);
		debugfs_create_x16("SPORT0_CHNL", 0600, parent, (u16 *)0xFFC00834);
		debugfs_create_x16("SPORT0_MCMC1", 0600, parent, (u16 *)0xFFC00838);
		debugfs_create_x16("SPORT0_MCMC2", 0600, parent, (u16 *)0xFFC0083C);
		debugfs_create_x32("SPORT0_MRCS0", 0600, parent, (u32 *)0xFFC00850);
		debugfs_create_x32("SPORT0_MRCS1", 0600, parent, (u32 *)0xFFC00854);
		debugfs_create_x32("SPORT0_MRCS2", 0600, parent, (u32 *)0xFFC00858);
		debugfs_create_x32("SPORT0_MRCS3", 0600, parent, (u32 *)0xFFC0085C);
		debugfs_create_x32("SPORT0_MTCS0", 0600, parent, (u32 *)0xFFC00840);
		debugfs_create_x32("SPORT0_MTCS1", 0600, parent, (u32 *)0xFFC00844);
		debugfs_create_x32("SPORT0_MTCS2", 0600, parent, (u32 *)0xFFC00848);
		debugfs_create_x32("SPORT0_MTCS3", 0600, parent, (u32 *)0xFFC0084C);
		debugfs_create_x16("SPORT0_RCLKDIV", 0600, parent, (u16 *)0xFFC00828);
		debugfs_create_x16("SPORT0_RCR1", 0600, parent, (u16 *)0xFFC00820);
		debugfs_create_x16("SPORT0_RCR2", 0600, parent, (u16 *)0xFFC00824);
		debugfs_create_x16("SPORT0_RFSDIV", 0600, parent, (u16 *)0xFFC0082C);
		debugfs_create_x32("SPORT0_RX", 0600, parent, (u32 *)0xFFC00818);
		debugfs_create_x16("SPORT0_STAT", 0600, parent, (u16 *)0xFFC00830);
		debugfs_create_x16("SPORT0_TCLKDIV", 0600, parent, (u16 *)0xFFC00808);
		debugfs_create_x16("SPORT0_TCR1", 0600, parent, (u16 *)0xFFC00800);
		debugfs_create_x16("SPORT0_TCR2", 0600, parent, (u16 *)0xFFC00804);
		debugfs_create_x16("SPORT0_TFSDIV", 0600, parent, (u16 *)0xFFC0080C);
		debugfs_create_x32("SPORT0_TX", 0600, parent, (u32 *)0xFFC00810);
		debugfs_create_x16("SPORT1_CHNL", 0600, parent, (u16 *)0xFFC00934);
		debugfs_create_x16("SPORT1_MCMC1", 0600, parent, (u16 *)0xFFC00938);
		debugfs_create_x16("SPORT1_MCMC2", 0600, parent, (u16 *)0xFFC0093C);
		debugfs_create_x32("SPORT1_MRCS0", 0600, parent, (u32 *)0xFFC00950);
		debugfs_create_x32("SPORT1_MRCS1", 0600, parent, (u32 *)0xFFC00954);
		debugfs_create_x32("SPORT1_MRCS2", 0600, parent, (u32 *)0xFFC00958);
		debugfs_create_x32("SPORT1_MRCS3", 0600, parent, (u32 *)0xFFC0095C);
		debugfs_create_x32("SPORT1_MTCS0", 0600, parent, (u32 *)0xFFC00940);
		debugfs_create_x32("SPORT1_MTCS1", 0600, parent, (u32 *)0xFFC00944);
		debugfs_create_x32("SPORT1_MTCS2", 0600, parent, (u32 *)0xFFC00948);
		debugfs_create_x32("SPORT1_MTCS3", 0600, parent, (u32 *)0xFFC0094C);
		debugfs_create_x16("SPORT1_RCLKDIV", 0600, parent, (u16 *)0xFFC00928);
		debugfs_create_x16("SPORT1_RCR1", 0600, parent, (u16 *)0xFFC00920);
		debugfs_create_x16("SPORT1_RCR2", 0600, parent, (u16 *)0xFFC00924);
		debugfs_create_x16("SPORT1_RFSDIV", 0600, parent, (u16 *)0xFFC0092C);
		debugfs_create_x32("SPORT1_RX", 0600, parent, (u32 *)0xFFC00918);
		debugfs_create_x16("SPORT1_STAT", 0600, parent, (u16 *)0xFFC00930);
		debugfs_create_x16("SPORT1_TCLKDIV", 0600, parent, (u16 *)0xFFC00908);
		debugfs_create_x16("SPORT1_TCR1", 0600, parent, (u16 *)0xFFC00900);
		debugfs_create_x16("SPORT1_TCR2", 0600, parent, (u16 *)0xFFC00904);
		debugfs_create_x16("SPORT1_TFSDIV", 0600, parent, (u16 *)0xFFC0090C);
		debugfs_create_x32("SPORT1_TX", 0600, parent, (u32 *)0xFFC00910);

		parent = debugfs_create_dir("System Interrupt Controller Register File", top);
		debugfs_create_x32("SIC_IAR0", 0600, parent, (u32 *)0xFFC00110);
		debugfs_create_x32("SIC_IAR1", 0600, parent, (u32 *)0xFFC00114);
		debugfs_create_x32("SIC_IAR2", 0600, parent, (u32 *)0xFFC00118);
		debugfs_create_x32("SIC_IAR3", 0600, parent, (u32 *)0xFFC0011C);
		debugfs_create_x32("SIC_IMASK", 0600, parent, (u32 *)0xFFC0010C);
		debugfs_create_x32("SIC_ISR", 0600, parent, (u32 *)0xFFC00120);
		debugfs_create_x32("SIC_IWR", 0600, parent, (u32 *)0xFFC00124);
		debugfs_create_x32("SIC_RVECT", 0600, parent, (u32 *)0xFFC00108);
		debugfs_create_x16("SWRST", 0600, parent, (u16 *)0xFFC00100);
		debugfs_create_x16("SYSCR", 0600, parent, (u16 *)0xFFC00104);

		parent = debugfs_create_dir("TWI", top);
		debugfs_create_x16("TWI_CLKDIV", 0600, parent, (u16 *)0xFFC01400);
		debugfs_create_x16("TWI_CONTROL", 0600, parent, (u16 *)0xFFC01404);
		debugfs_create_x16("TWI_FIFO_CTL", 0600, parent, (u16 *)0xFFC01428);
		debugfs_create_x16("TWI_FIFO_STAT", 0600, parent, (u16 *)0xFFC0142C);
		debugfs_create_x16("TWI_INT_MASK", 0600, parent, (u16 *)0xFFC01424);
		debugfs_create_x16("TWI_INT_STAT", 0600, parent, (u16 *)0xFFC01420);
		debugfs_create_x16("TWI_MASTER_ADDR", 0600, parent, (u16 *)0xFFC0141C);
		debugfs_create_x16("TWI_MASTER_CTL", 0600, parent, (u16 *)0xFFC01414);
		debugfs_create_x16("TWI_MASTER_STAT", 0600, parent, (u16 *)0xFFC01418);
		debugfs_create_x16("TWI_RCV_DATA16", 0600, parent, (u16 *)0xFFC0148C);
		debugfs_create_x16("TWI_RCV_DATA8", 0600, parent, (u16 *)0xFFC01488);
		debugfs_create_x16("TWI_SLAVE_ADDR", 0600, parent, (u16 *)0xFFC01410);
		debugfs_create_x16("TWI_SLAVE_CTL", 0600, parent, (u16 *)0xFFC01408);
		debugfs_create_x16("TWI_SLAVE_STAT", 0600, parent, (u16 *)0xFFC0140C);
		debugfs_create_x16("TWI_XMT_DATA16", 0600, parent, (u16 *)0xFFC01484);
		debugfs_create_x16("TWI_XMT_DATA8", 0600, parent, (u16 *)0xFFC01480);

		parent = debugfs_create_dir("Timer Registers", top);
		debugfs_create_x16("TIMER0_CONFIG", 0600, parent, (u16 *)0xFFC00600);
		debugfs_create_x32("TIMER0_COUNTER", 0600, parent, (u32 *)0xFFC00604);
		debugfs_create_x32("TIMER0_PERIOD", 0600, parent, (u32 *)0xFFC00608);
		debugfs_create_x32("TIMER0_WIDTH", 0600, parent, (u32 *)0xFFC0060C);
		debugfs_create_x16("TIMER1_CONFIG", 0600, parent, (u16 *)0xFFC00610);
		debugfs_create_x32("TIMER1_COUNTER", 0600, parent, (u32 *)0xFFC00614);
		debugfs_create_x32("TIMER1_PERIOD", 0600, parent, (u32 *)0xFFC00618);
		debugfs_create_x32("TIMER1_WIDTH", 0600, parent, (u32 *)0xFFC0061C);
		debugfs_create_x16("TIMER2_CONFIG", 0600, parent, (u16 *)0xFFC00620);
		debugfs_create_x32("TIMER2_COUNTER", 0600, parent, (u32 *)0xFFC00624);
		debugfs_create_x32("TIMER2_PERIOD", 0600, parent, (u32 *)0xFFC00628);
		debugfs_create_x32("TIMER2_WIDTH", 0600, parent, (u32 *)0xFFC0062C);
		debugfs_create_x16("TIMER3_CONFIG", 0600, parent, (u16 *)0xFFC00630);
		debugfs_create_x32("TIMER3_COUNTER", 0600, parent, (u32 *)0xFFC00634);
		debugfs_create_x32("TIMER3_PERIOD", 0600, parent, (u32 *)0xFFC00638);
		debugfs_create_x32("TIMER3_WIDTH", 0600, parent, (u32 *)0xFFC0063C);
		debugfs_create_x16("TIMER4_CONFIG", 0600, parent, (u16 *)0xFFC00640);
		debugfs_create_x32("TIMER4_COUNTER", 0600, parent, (u32 *)0xFFC00644);
		debugfs_create_x32("TIMER4_PERIOD", 0600, parent, (u32 *)0xFFC00648);
		debugfs_create_x32("TIMER4_WIDTH", 0600, parent, (u32 *)0xFFC0064C);
		debugfs_create_x16("TIMER5_CONFIG", 0600, parent, (u16 *)0xFFC00650);
		debugfs_create_x32("TIMER5_COUNTER", 0600, parent, (u32 *)0xFFC00654);
		debugfs_create_x32("TIMER5_PERIOD", 0600, parent, (u32 *)0xFFC00658);
		debugfs_create_x32("TIMER5_WIDTH", 0600, parent, (u32 *)0xFFC0065C);
		debugfs_create_x16("TIMER6_CONFIG", 0600, parent, (u16 *)0xFFC00660);
		debugfs_create_x32("TIMER6_COUNTER", 0600, parent, (u32 *)0xFFC00664);
		debugfs_create_x32("TIMER6_PERIOD", 0600, parent, (u32 *)0xFFC00668);
		debugfs_create_x32("TIMER6_WIDTH", 0600, parent, (u32 *)0xFFC0066C);
		debugfs_create_x16("TIMER7_CONFIG", 0600, parent, (u16 *)0xFFC00670);
		debugfs_create_x32("TIMER7_COUNTER", 0600, parent, (u32 *)0xFFC00674);
		debugfs_create_x32("TIMER7_PERIOD", 0600, parent, (u32 *)0xFFC00678);
		debugfs_create_x32("TIMER7_WIDTH", 0600, parent, (u32 *)0xFFC0067C);
		debugfs_create_x16("TIMER_DISABLE", 0600, parent, (u16 *)0xFFC00684);
		debugfs_create_x16("TIMER_ENABLE", 0600, parent, (u16 *)0xFFC00680);
		debugfs_create_x32("TIMER_STATUS", 0600, parent, (u32 *)0xFFC00688);

		parent = debugfs_create_dir("Trace Unit", top);
		debugfs_create_x32("TBUF", 0600, parent, (u32 *)0xFFE06100);
		debugfs_create_x32("TBUFCTL", 0600, parent, (u32 *)0xFFE06000);
		debugfs_create_x32("TBUFSTAT", 0600, parent, (u32 *)0xFFE06004);

		parent = debugfs_create_dir("UART", top);
		debugfs_create_x16("UART0_DLH", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART0_DLL", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART0_GCTL", 0600, parent, (u16 *)0xFFC00424);
		debugfs_create_x16("UART0_IER", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART0_IIR", 0600, parent, (u16 *)0xFFC00408);
		debugfs_create_x16("UART0_LCR", 0600, parent, (u16 *)0xFFC0040C);
		debugfs_create_x16("UART0_LSR", 0600, parent, (u16 *)0xFFC00414);
		debugfs_create_x16("UART0_MCR", 0600, parent, (u16 *)0xFFC00410);
		debugfs_create_x16("UART0_MSR", 0600, parent, (u16 *)0xFFC00418);
		debugfs_create_x16("UART0_RBR", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART0_SCR", 0600, parent, (u16 *)0xFFC0041C);
		debugfs_create_x16("UART0_THR", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART1_DLH", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("UART1_DLL", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART1_GCTL", 0600, parent, (u16 *)0xFFC02024);
		debugfs_create_x16("UART1_IER", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("UART1_IIR", 0600, parent, (u16 *)0xFFC02008);
		debugfs_create_x16("UART1_LCR", 0600, parent, (u16 *)0xFFC0200C);
		debugfs_create_x16("UART1_LSR", 0600, parent, (u16 *)0xFFC02014);
		debugfs_create_x16("UART1_MCR", 0600, parent, (u16 *)0xFFC02010);
		debugfs_create_x16("UART1_MSR", 0600, parent, (u16 *)0xFFC02018);
		debugfs_create_x16("UART1_RBR", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART1_SCR", 0600, parent, (u16 *)0xFFC0201C);
		debugfs_create_x16("UART1_THR", 0600, parent, (u16 *)0xFFC02000);

		parent = debugfs_create_dir("Watchdog", top);
		debugfs_create_x32("WDOG_CNT", 0600, parent, (u32 *)0xFFC00204);
		debugfs_create_x16("WDOG_CTL", 0600, parent, (u16 *)0xFFC00200);
		debugfs_create_x32("WDOG_STAT", 0600, parent, (u32 *)0xFFC00208);

		parent = debugfs_create_dir("Watchpoint and Patch Unit", top);
		debugfs_create_x32("WPDA0", 0600, parent, (u32 *)0xFFE07140);
		debugfs_create_x32("WPDA1", 0600, parent, (u32 *)0xFFE07144);
		debugfs_create_x32("WPDACNT0", 0600, parent, (u32 *)0xFFE07180);
		debugfs_create_x32("WPDACNT1", 0600, parent, (u32 *)0xFFE07184);
		debugfs_create_x32("WPDACTL", 0600, parent, (u32 *)0xFFE07100);
		debugfs_create_x32("WPIA0", 0600, parent, (u32 *)0xFFE07040);
		debugfs_create_x32("WPIA1", 0600, parent, (u32 *)0xFFE07044);
		debugfs_create_x32("WPIA2", 0600, parent, (u32 *)0xFFE07048);
		debugfs_create_x32("WPIA3", 0600, parent, (u32 *)0xFFE0704C);
		debugfs_create_x32("WPIA4", 0600, parent, (u32 *)0xFFE07050);
		debugfs_create_x32("WPIA5", 0600, parent, (u32 *)0xFFE07054);
		debugfs_create_x32("WPIACNT0", 0600, parent, (u32 *)0xFFE07080);
		debugfs_create_x32("WPIACNT1", 0600, parent, (u32 *)0xFFE07084);
		debugfs_create_x32("WPIACNT2", 0600, parent, (u32 *)0xFFE07088);
		debugfs_create_x32("WPIACNT3", 0600, parent, (u32 *)0xFFE0708C);
		debugfs_create_x32("WPIACNT4", 0600, parent, (u32 *)0xFFE07090);
		debugfs_create_x32("WPIACNT5", 0600, parent, (u32 *)0xFFE07094);
		debugfs_create_x32("WPIACTL", 0600, parent, (u32 *)0xFFE07000);
		debugfs_create_x32("WPSTAT", 0600, parent, (u32 *)0xFFE07200);

	}	/* BF534 */

#ifdef __ADSPBF535__
# define USE_BF535 1
#else
# define USE_BF535 0
#endif
	if (USE_BF535) {

		parent = debugfs_create_dir("Core Timer Register File", top);
		debugfs_create_x32("TCNTL", 0600, parent, (u32 *)0xFFE03000);
		debugfs_create_x32("TCOUNT", 0600, parent, (u32 *)0xFFE0300C);
		debugfs_create_x32("TPERIOD", 0600, parent, (u32 *)0xFFE03004);
		debugfs_create_x32("TSCALE", 0600, parent, (u32 *)0xFFE03008);

		parent = debugfs_create_dir("EBIU", top);
		debugfs_create_x32("EBIU_AMBCTL0", 0600, parent, (u32 *)0xFFC03C04);
		debugfs_create_x32("EBIU_AMBCTL1", 0600, parent, (u32 *)0xFFC03C08);
		debugfs_create_x16("EBIU_AMGCTL", 0600, parent, (u16 *)0xFFC03C00);
		debugfs_create_x32("EBIU_SDBCTL", 0600, parent, (u32 *)0xFFC04C04);
		debugfs_create_x32("EBIU_SDGCTL", 0600, parent, (u32 *)0xFFC04C00);
		debugfs_create_x16("EBIU_SDRRC", 0600, parent, (u16 *)0xFFC04C0A);
		debugfs_create_x16("EBIU_SDSTAT", 0600, parent, (u16 *)0xFFC04C0E);

		parent = debugfs_create_dir("Event Vectors", top);
		debugfs_create_x32("EVT0", 0600, parent, (u32 *)0xFFE02000);
		debugfs_create_x32("EVT10", 0600, parent, (u32 *)0xFFE02028);
		debugfs_create_x32("EVT11", 0600, parent, (u32 *)0xFFE0202C);
		debugfs_create_x32("EVT12", 0600, parent, (u32 *)0xFFE02030);
		debugfs_create_x32("EVT13", 0600, parent, (u32 *)0xFFE02034);
		debugfs_create_x32("EVT14", 0600, parent, (u32 *)0xFFE02038);
		debugfs_create_x32("EVT15", 0600, parent, (u32 *)0xFFE0203C);
		debugfs_create_x32("EVT1", 0600, parent, (u32 *)0xFFE02004);
		debugfs_create_x32("EVT2", 0600, parent, (u32 *)0xFFE02008);
		debugfs_create_x32("EVT3", 0600, parent, (u32 *)0xFFE0200C);
		debugfs_create_x32("EVT4", 0600, parent, (u32 *)0xFFE02010);
		debugfs_create_x32("EVT5", 0600, parent, (u32 *)0xFFE02014);
		debugfs_create_x32("EVT6", 0600, parent, (u32 *)0xFFE02018);
		debugfs_create_x32("EVT7", 0600, parent, (u32 *)0xFFE0201C);
		debugfs_create_x32("EVT8", 0600, parent, (u32 *)0xFFE02020);
		debugfs_create_x32("EVT9", 0600, parent, (u32 *)0xFFE02024);

		parent = debugfs_create_dir("Extended Registers", top);
		debugfs_create_x32("CHIPID", 0600, parent, (u32 *)0xFFC048C0);
		debugfs_create_x32("DB_ACOMP", 0600, parent, (u32 *)0xFFC04884);
		debugfs_create_x32("DB_CCOMP", 0600, parent, (u32 *)0xFFC04888);
		debugfs_create_x32("DCPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0000C);
		debugfs_create_x32("DCPLB_STATUS", 0600, parent, (u32 *)0xFFE00008);
		debugfs_create_x16("DMA_DBP", 0600, parent, (u16 *)0xFFC04880);
		debugfs_create_x32("DSPID", 0600, parent, (u32 *)0xFFE05000);
		debugfs_create_x16("FIO_BOTH", 0600, parent, (u16 *)0xFFC02418);
		debugfs_create_x16("FIO_DIR", 0600, parent, (u16 *)0xFFC02400);
		debugfs_create_x16("FIO_EDGE", 0600, parent, (u16 *)0xFFC02414);
		debugfs_create_x16("FIO_FLAG_C", 0600, parent, (u16 *)0xFFC02404);
		debugfs_create_x16("FIO_FLAG_S", 0600, parent, (u16 *)0xFFC02406);
		debugfs_create_x16("FIO_MASKA_C", 0600, parent, (u16 *)0xFFC02408);
		debugfs_create_x16("FIO_MASKA_S", 0600, parent, (u16 *)0xFFC0240A);
		debugfs_create_x16("FIO_MASKB_C", 0600, parent, (u16 *)0xFFC0240C);
		debugfs_create_x16("FIO_MASKB_S", 0600, parent, (u16 *)0xFFC0240E);
		debugfs_create_x16("FIO_POLAR", 0600, parent, (u16 *)0xFFC02410);
		debugfs_create_x32("ICPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0100C);
		debugfs_create_x32("ICPLB_STATUS", 0600, parent, (u32 *)0xFFE01008);
		debugfs_create_x16("MDD_DCFG", 0600, parent, (u16 *)0xFFC03802);
		debugfs_create_x16("MDD_DCP", 0600, parent, (u16 *)0xFFC03800);
		debugfs_create_x16("MDD_DCT", 0600, parent, (u16 *)0xFFC03808);
		debugfs_create_x16("MDD_DDR", 0600, parent, (u16 *)0xFFC0380C);
		debugfs_create_x16("MDD_DI", 0600, parent, (u16 *)0xFFC0380E);
		debugfs_create_x16("MDD_DND", 0600, parent, (u16 *)0xFFC0380A);
		debugfs_create_x16("MDD_DSAH", 0600, parent, (u16 *)0xFFC03804);
		debugfs_create_x16("MDD_DSAL", 0600, parent, (u16 *)0xFFC03806);
		debugfs_create_x16("MDS_DCFG", 0600, parent, (u16 *)0xFFC03902);
		debugfs_create_x16("MDS_DCP", 0600, parent, (u16 *)0xFFC03900);
		debugfs_create_x16("MDS_DCT", 0600, parent, (u16 *)0xFFC03908);
		debugfs_create_x16("MDS_DDR", 0600, parent, (u16 *)0xFFC0390C);
		debugfs_create_x16("MDS_DI", 0600, parent, (u16 *)0xFFC0390E);
		debugfs_create_x16("MDS_DND", 0600, parent, (u16 *)0xFFC0390A);
		debugfs_create_x16("MDS_DSAH", 0600, parent, (u16 *)0xFFC03904);
		debugfs_create_x16("MDS_DSAL", 0600, parent, (u16 *)0xFFC03906);
		debugfs_create_x16("TIMER0_CONFIG", 0600, parent, (u16 *)0xFFC02002);
		debugfs_create_x16("TIMER0_COUNTER_HI", 0600, parent, (u16 *)0xFFC02006);
		debugfs_create_x16("TIMER0_COUNTER_LO", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("TIMER0_PERIOD_HI", 0600, parent, (u16 *)0xFFC0200A);
		debugfs_create_x16("TIMER0_PERIOD_LO", 0600, parent, (u16 *)0xFFC02008);
		debugfs_create_x16("TIMER0_STATUS", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("TIMER0_WIDTH_HI", 0600, parent, (u16 *)0xFFC0200E);
		debugfs_create_x16("TIMER0_WIDTH_LO", 0600, parent, (u16 *)0xFFC0200C);
		debugfs_create_x16("TIMER1_CONFIG", 0600, parent, (u16 *)0xFFC02012);
		debugfs_create_x16("TIMER1_COUNTER_HI", 0600, parent, (u16 *)0xFFC02016);
		debugfs_create_x16("TIMER1_COUNTER_LO", 0600, parent, (u16 *)0xFFC02014);
		debugfs_create_x16("TIMER1_PERIOD_HI", 0600, parent, (u16 *)0xFFC0201A);
		debugfs_create_x16("TIMER1_PERIOD_LO", 0600, parent, (u16 *)0xFFC02018);
		debugfs_create_x16("TIMER1_STATUS", 0600, parent, (u16 *)0xFFC02010);
		debugfs_create_x16("TIMER1_WIDTH_HI", 0600, parent, (u16 *)0xFFC0201E);
		debugfs_create_x16("TIMER1_WIDTH_LO", 0600, parent, (u16 *)0xFFC0201C);
		debugfs_create_x16("TIMER2_CONFIG", 0600, parent, (u16 *)0xFFC02022);
		debugfs_create_x16("TIMER2_COUNTER_HI", 0600, parent, (u16 *)0xFFC02026);
		debugfs_create_x16("TIMER2_COUNTER_LO", 0600, parent, (u16 *)0xFFC02024);
		debugfs_create_x16("TIMER2_PERIOD_HI", 0600, parent, (u16 *)0xFFC0202A);
		debugfs_create_x16("TIMER2_PERIOD_LO", 0600, parent, (u16 *)0xFFC02028);
		debugfs_create_x16("TIMER2_STATUS", 0600, parent, (u16 *)0xFFC02020);
		debugfs_create_x16("TIMER2_WIDTH_HI", 0600, parent, (u16 *)0xFFC0202E);
		debugfs_create_x16("TIMER2_WIDTH_LO", 0600, parent, (u16 *)0xFFC0202C);

		parent = debugfs_create_dir("GPIO", top);
		debugfs_create_x16("GPIO_BOTH", 0600, parent, (u16 *)0xFFC02418);
		debugfs_create_x16("GPIO_DIR", 0600, parent, (u16 *)0xFFC02400);
		debugfs_create_x16("GPIO_EDGE", 0600, parent, (u16 *)0xFFC02414);
		debugfs_create_x16("GPIO_FLAG_CLR", 0600, parent, (u16 *)0xFFC02404);
		debugfs_create_x16("GPIO_FLAG_SET", 0600, parent, (u16 *)0xFFC02406);
		debugfs_create_x16("GPIO_MASKA_CLR", 0600, parent, (u16 *)0xFFC02408);
		debugfs_create_x16("GPIO_MASKA_SET", 0600, parent, (u16 *)0xFFC0240A);
		debugfs_create_x16("GPIO_MASKB_CLR", 0600, parent, (u16 *)0xFFC0240C);
		debugfs_create_x16("GPIO_MASKB_SET", 0600, parent, (u16 *)0xFFC0240E);
		debugfs_create_x16("GPIO_POLAR", 0600, parent, (u16 *)0xFFC02410);

		parent = debugfs_create_dir("Interrupt Controller", top);
		debugfs_create_x16("ILAT", 0600, parent, (u16 *)0xFFE0210C);
		debugfs_create_x16("IMASK", 0600, parent, (u16 *)0xFFE02104);
		debugfs_create_x16("IPEND", 0600, parent, (u16 *)0xFFE02108);

		parent = debugfs_create_dir("L1 Code Memory Registers", top);
		debugfs_create_x32("ICPLB_ADDR0", 0600, parent, (u32 *)0xFFE01100);
		debugfs_create_x32("ICPLB_ADDR10", 0600, parent, (u32 *)0xFFE01128);
		debugfs_create_x32("ICPLB_ADDR11", 0600, parent, (u32 *)0xFFE0112C);
		debugfs_create_x32("ICPLB_ADDR12", 0600, parent, (u32 *)0xFFE01130);
		debugfs_create_x32("ICPLB_ADDR13", 0600, parent, (u32 *)0xFFE01134);
		debugfs_create_x32("ICPLB_ADDR14", 0600, parent, (u32 *)0xFFE01138);
		debugfs_create_x32("ICPLB_ADDR15", 0600, parent, (u32 *)0xFFE0113C);
		debugfs_create_x32("ICPLB_ADDR1", 0600, parent, (u32 *)0xFFE01104);
		debugfs_create_x32("ICPLB_ADDR2", 0600, parent, (u32 *)0xFFE01108);
		debugfs_create_x32("ICPLB_ADDR3", 0600, parent, (u32 *)0xFFE0110C);
		debugfs_create_x32("ICPLB_ADDR4", 0600, parent, (u32 *)0xFFE01110);
		debugfs_create_x32("ICPLB_ADDR5", 0600, parent, (u32 *)0xFFE01114);
		debugfs_create_x32("ICPLB_ADDR6", 0600, parent, (u32 *)0xFFE01118);
		debugfs_create_x32("ICPLB_ADDR7", 0600, parent, (u32 *)0xFFE0111C);
		debugfs_create_x32("ICPLB_ADDR8", 0600, parent, (u32 *)0xFFE01120);
		debugfs_create_x32("ICPLB_ADDR9", 0600, parent, (u32 *)0xFFE01124);
		debugfs_create_x32("ICPLB_DATA0", 0600, parent, (u32 *)0xFFE01200);
		debugfs_create_x32("ICPLB_DATA10", 0600, parent, (u32 *)0xFFE01228);
		debugfs_create_x32("ICPLB_DATA11", 0600, parent, (u32 *)0xFFE0122C);
		debugfs_create_x32("ICPLB_DATA12", 0600, parent, (u32 *)0xFFE01230);
		debugfs_create_x32("ICPLB_DATA13", 0600, parent, (u32 *)0xFFE01234);
		debugfs_create_x32("ICPLB_DATA14", 0600, parent, (u32 *)0xFFE01238);
		debugfs_create_x32("ICPLB_DATA15", 0600, parent, (u32 *)0xFFE0123C);
		debugfs_create_x32("ICPLB_DATA1", 0600, parent, (u32 *)0xFFE01204);
		debugfs_create_x32("ICPLB_DATA2", 0600, parent, (u32 *)0xFFE01208);
		debugfs_create_x32("ICPLB_DATA3", 0600, parent, (u32 *)0xFFE0120C);
		debugfs_create_x32("ICPLB_DATA4", 0600, parent, (u32 *)0xFFE01210);
		debugfs_create_x32("ICPLB_DATA5", 0600, parent, (u32 *)0xFFE01214);
		debugfs_create_x32("ICPLB_DATA6", 0600, parent, (u32 *)0xFFE01218);
		debugfs_create_x32("ICPLB_DATA7", 0600, parent, (u32 *)0xFFE0121C);
		debugfs_create_x32("ICPLB_DATA8", 0600, parent, (u32 *)0xFFE01220);
		debugfs_create_x32("ICPLB_DATA9", 0600, parent, (u32 *)0xFFE01224);
		debugfs_create_x32("ICPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0100C);
		debugfs_create_x32("ICPLB_FAULT_STATUS", 0600, parent, (u32 *)0xFFE01008);
		debugfs_create_x32("IMEM_CONTROL", 0600, parent, (u32 *)0xFFE01004);
		debugfs_create_x32("ITEST_COMMAND", 0600, parent, (u32 *)0xFFE01300);
		debugfs_create_x32("ITEST_DATA0", 0600, parent, (u32 *)0xFFE01400);
		debugfs_create_x32("ITEST_DATA1", 0600, parent, (u32 *)0xFFE01404);

		parent = debugfs_create_dir("L1 Data Memory Registers", top);
		debugfs_create_x32("DCPLB_ADDR0", 0600, parent, (u32 *)0xFFE00100);
		debugfs_create_x32("DCPLB_ADDR10", 0600, parent, (u32 *)0xFFE00128);
		debugfs_create_x32("DCPLB_ADDR11", 0600, parent, (u32 *)0xFFE0012C);
		debugfs_create_x32("DCPLB_ADDR12", 0600, parent, (u32 *)0xFFE00130);
		debugfs_create_x32("DCPLB_ADDR13", 0600, parent, (u32 *)0xFFE00134);
		debugfs_create_x32("DCPLB_ADDR14", 0600, parent, (u32 *)0xFFE00138);
		debugfs_create_x32("DCPLB_ADDR15", 0600, parent, (u32 *)0xFFE0013C);
		debugfs_create_x32("DCPLB_ADDR1", 0600, parent, (u32 *)0xFFE00104);
		debugfs_create_x32("DCPLB_ADDR2", 0600, parent, (u32 *)0xFFE00108);
		debugfs_create_x32("DCPLB_ADDR3", 0600, parent, (u32 *)0xFFE0010C);
		debugfs_create_x32("DCPLB_ADDR4", 0600, parent, (u32 *)0xFFE00110);
		debugfs_create_x32("DCPLB_ADDR5", 0600, parent, (u32 *)0xFFE00114);
		debugfs_create_x32("DCPLB_ADDR6", 0600, parent, (u32 *)0xFFE00118);
		debugfs_create_x32("DCPLB_ADDR7", 0600, parent, (u32 *)0xFFE0011C);
		debugfs_create_x32("DCPLB_ADDR8", 0600, parent, (u32 *)0xFFE00120);
		debugfs_create_x32("DCPLB_ADDR9", 0600, parent, (u32 *)0xFFE00124);
		debugfs_create_x32("DCPLB_DATA0", 0600, parent, (u32 *)0xFFE00200);
		debugfs_create_x32("DCPLB_DATA10", 0600, parent, (u32 *)0xFFE00228);
		debugfs_create_x32("DCPLB_DATA11", 0600, parent, (u32 *)0xFFE0022C);
		debugfs_create_x32("DCPLB_DATA12", 0600, parent, (u32 *)0xFFE00230);
		debugfs_create_x32("DCPLB_DATA13", 0600, parent, (u32 *)0xFFE00234);
		debugfs_create_x32("DCPLB_DATA14", 0600, parent, (u32 *)0xFFE00238);
		debugfs_create_x32("DCPLB_DATA15", 0600, parent, (u32 *)0xFFE0023C);
		debugfs_create_x32("DCPLB_DATA1", 0600, parent, (u32 *)0xFFE00204);
		debugfs_create_x32("DCPLB_DATA2", 0600, parent, (u32 *)0xFFE00208);
		debugfs_create_x32("DCPLB_DATA3", 0600, parent, (u32 *)0xFFE0020C);
		debugfs_create_x32("DCPLB_DATA4", 0600, parent, (u32 *)0xFFE00210);
		debugfs_create_x32("DCPLB_DATA5", 0600, parent, (u32 *)0xFFE00214);
		debugfs_create_x32("DCPLB_DATA6", 0600, parent, (u32 *)0xFFE00218);
		debugfs_create_x32("DCPLB_DATA7", 0600, parent, (u32 *)0xFFE0021C);
		debugfs_create_x32("DCPLB_DATA8", 0600, parent, (u32 *)0xFFE00220);
		debugfs_create_x32("DCPLB_DATA9", 0600, parent, (u32 *)0xFFE00224);
		debugfs_create_x32("DCPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0000C);
		debugfs_create_x32("DCPLB_FAULT_STATUS", 0600, parent, (u32 *)0xFFE00008);
		debugfs_create_x32("DMEM_CONTROL", 0600, parent, (u32 *)0xFFE00004);
		debugfs_create_x32("DTEST_COMMAND", 0600, parent, (u32 *)0xFFE00300);
		debugfs_create_x32("DTEST_DATA0", 0600, parent, (u32 *)0xFFE00400);
		debugfs_create_x32("DTEST_DATA1", 0600, parent, (u32 *)0xFFE00404);
		debugfs_create_x32("SRAM_BASE_ADDR", 0600, parent, (u32 *)0xFFE00000);

		parent = debugfs_create_dir("Memory DMA Register File", top);
		debugfs_create_x16("Config_Rd", 0600, parent, (u16 *)0xFFC03902);
		debugfs_create_x16("Config_Wr", 0600, parent, (u16 *)0xFFC03802);
		debugfs_create_x16("Current_desc_Rd", 0600, parent, (u16 *)0xFFC03900);
		debugfs_create_x16("Current_desc_Wr", 0600, parent, (u16 *)0xFFC03800);
		debugfs_create_x16("Desc_ready_Rd", 0600, parent, (u16 *)0xFFC0390C);
		debugfs_create_x16("Desc_ready_Wr", 0600, parent, (u16 *)0xFFC0380C);
		debugfs_create_x16("Interrupt_Stat_Rd", 0600, parent, (u16 *)0xFFC0390E);
		debugfs_create_x16("Interrupt_Stat_Wr", 0600, parent, (u16 *)0xFFC0380E);
		debugfs_create_x16("Next_desc_Rd", 0600, parent, (u16 *)0xFFC0390A);
		debugfs_create_x16("Next_desc_Wr", 0600, parent, (u16 *)0xFFC0380A);
		debugfs_create_x16("Start_addr_Rd", 0600, parent, (u16 *)0xFFC03906);
		debugfs_create_x16("Start_addr_Wr", 0600, parent, (u16 *)0xFFC03806);
		debugfs_create_x16("Start_page_Rd", 0600, parent, (u16 *)0xFFC03904);
		debugfs_create_x16("Start_page_Wr", 0600, parent, (u16 *)0xFFC03804);
		debugfs_create_x16("Word_count_Rd", 0600, parent, (u16 *)0xFFC03908);
		debugfs_create_x16("Word_count_Wr", 0600, parent, (u16 *)0xFFC03808);

		parent = debugfs_create_dir("PCI", top);
		debugfs_create_x32("PCI_CBAP", 0600, parent, (u32 *)0xFFC04014);
		debugfs_create_x32("PCI_CFG_BIST", 0600, parent, (u32 *)0xEEFFFF20);
		debugfs_create_x32("PCI_CFG_CC", 0600, parent, (u32 *)0xEEFFFF18);
		debugfs_create_x32("PCI_CFG_CLS", 0600, parent, (u32 *)0xEEFFFF2C);
		debugfs_create_x32("PCI_CFG_CMD", 0600, parent, (u32 *)0xEEFFFF14);
		debugfs_create_x32("PCI_CFG_DIC", 0600, parent, (u32 *)0xEEFFFF08);
		debugfs_create_x32("PCI_CFG_HT", 0600, parent, (u32 *)0xEEFFFF24);
		debugfs_create_x32("PCI_CFG_IBAR", 0600, parent, (u32 *)0xEEFFFF34);
		debugfs_create_x32("PCI_CFG_IL", 0600, parent, (u32 *)0xEEFFFF4C);
		debugfs_create_x32("PCI_CFG_IP", 0600, parent, (u32 *)0xEEFFFF48);
		debugfs_create_x32("PCI_CFG_MAXL", 0600, parent, (u32 *)0xEEFFFF40);
		debugfs_create_x32("PCI_CFG_MBAR", 0600, parent, (u32 *)0xEEFFFF30);
		debugfs_create_x32("PCI_CFG_MING", 0600, parent, (u32 *)0xEEFFFF44);
		debugfs_create_x32("PCI_CFG_MLT", 0600, parent, (u32 *)0xEEFFFF28);
		debugfs_create_x32("PCI_CFG_RID", 0600, parent, (u32 *)0xEEFFFF1C);
		debugfs_create_x32("PCI_CFG_SID", 0600, parent, (u32 *)0xEEFFFF38);
		debugfs_create_x32("PCI_CFG_STAT", 0600, parent, (u32 *)0xEEFFFF10);
		debugfs_create_x32("PCI_CFG_SVID", 0600, parent, (u32 *)0xEEFFFF3C);
		debugfs_create_x32("PCI_CFG_VIC", 0600, parent, (u32 *)0xEEFFFF0C);
		debugfs_create_x32("PCI_CTL", 0600, parent, (u32 *)0xFFC04000);
		debugfs_create_x32("PCI_DIBARM", 0600, parent, (u32 *)0xEEFFFF04);
		debugfs_create_x32("PCI_DMBARM", 0600, parent, (u32 *)0xEEFFFF00);
		debugfs_create_x32("PCI_HMCTL", 0600, parent, (u32 *)0xEEFFFF50);
		debugfs_create_x32("PCI_IBAP", 0600, parent, (u32 *)0xFFC04010);
		debugfs_create_x32("PCI_ICTL", 0600, parent, (u32 *)0xFFC04008);
		debugfs_create_x32("PCI_MBAP", 0600, parent, (u32 *)0xFFC0400C);
		debugfs_create_x32("PCI_STAT", 0600, parent, (u32 *)0xFFC04004);
		debugfs_create_x32("PCI_TIBAP", 0600, parent, (u32 *)0xFFC0401C);
		debugfs_create_x32("PCI_TMBAP", 0600, parent, (u32 *)0xFFC04018);

		parent = debugfs_create_dir("PLL", top);
		debugfs_create_x32("PLL_CTL", 0600, parent, (u32 *)0xFFC00400);
		debugfs_create_x16("PLL_IOCK", 0600, parent, (u16 *)0xFFC00408);
		debugfs_create_x32("PLL_LOCKCNT", 0600, parent, (u32 *)0xFFC00406);
		debugfs_create_x32("PLL_STAT", 0600, parent, (u32 *)0xFFC00404);
		debugfs_create_x32("SWRST", 0600, parent, (u32 *)0xFFC00410);
		debugfs_create_x32("SYSCR", 0600, parent, (u32 *)0xFFC00414);

		parent = debugfs_create_dir("Performance Monitor", top);
		debugfs_create_x32("PFCNTR0", 0600, parent, (u32 *)0xFFE08100);
		debugfs_create_x32("PFCNTR1", 0600, parent, (u32 *)0xFFE08104);
		debugfs_create_x32("PFCTL", 0600, parent, (u32 *)0xFFE08000);

		parent = debugfs_create_dir("RTC", top);
		debugfs_create_x32("RTC_ALARM", 0600, parent, (u32 *)0xFFC01410);
		debugfs_create_x16("RTC_FAST", 0600, parent, (u16 *)0xFFC01414);
		debugfs_create_x16("RTC_ICTL", 0600, parent, (u16 *)0xFFC01404);
		debugfs_create_x16("RTC_ISTAT", 0600, parent, (u16 *)0xFFC01408);
		debugfs_create_x32("RTC_STAT", 0600, parent, (u32 *)0xFFC01400);
		debugfs_create_x16("RTC_SWCNT", 0600, parent, (u16 *)0xFFC0140C);

		parent = debugfs_create_dir("Real Time Clock Register File", top);
		debugfs_create_x32("RTCALARM", 0600, parent, (u32 *)0xFFC01410);
		debugfs_create_x16("RTCFAST", 0600, parent, (u16 *)0xFFC01414);
		debugfs_create_x16("RTCICTL", 0600, parent, (u16 *)0xFFC01404);
		debugfs_create_x16("RTCISTAT", 0600, parent, (u16 *)0xFFC01408);
		debugfs_create_x32("RTCSTAT", 0600, parent, (u32 *)0xFFC01400);
		debugfs_create_x16("RTCSWCNT", 0600, parent, (u16 *)0xFFC0140C);

		parent = debugfs_create_dir("SPI", top);
		debugfs_create_x16("SPI0_BAUD", 0600, parent, (u16 *)0xFFC0300A);
		debugfs_create_x16("SPI0_CONFIG", 0600, parent, (u16 *)0xFFC03202);
		debugfs_create_x16("SPI0_COUNT", 0600, parent, (u16 *)0xFFC03208);
		debugfs_create_x16("SPI0_CTL", 0600, parent, (u16 *)0xFFC03000);
		debugfs_create_x16("SPI0_CURR_PTR", 0600, parent, (u16 *)0xFFC03200);
		debugfs_create_x16("SPI0_DESCR_RDY", 0600, parent, (u16 *)0xFFC0320C);
		debugfs_create_x16("SPI0_DMACNT", 0600, parent, (u16 *)0xFFC03208);
		debugfs_create_x16("SPI0_DMACONF", 0600, parent, (u16 *)0xFFC03202);
		debugfs_create_x16("SPI0_DMACURR", 0600, parent, (u16 *)0xFFC03200);
		debugfs_create_x16("SPI0_DMADRDY", 0600, parent, (u16 *)0xFFC0320C);
		debugfs_create_x16("SPI0_DMAIRQ", 0600, parent, (u16 *)0xFFC0320E);
		debugfs_create_x16("SPI0_DMANEXT", 0600, parent, (u16 *)0xFFC0320A);
		debugfs_create_x16("SPI0_DMASADD", 0600, parent, (u16 *)0xFFC03206);
		debugfs_create_x16("SPI0_DMASPAGE", 0600, parent, (u16 *)0xFFC03204);
		debugfs_create_x16("SPI0_DMA_INT", 0600, parent, (u16 *)0xFFC0320E);
		debugfs_create_x16("SPI0_FLG", 0600, parent, (u16 *)0xFFC03002);
		debugfs_create_x16("SPI0_NEXT_DESCR", 0600, parent, (u16 *)0xFFC0320A);
		debugfs_create_x16("SPI0_RDBR", 0600, parent, (u16 *)0xFFC03008);
		debugfs_create_x16("SPI0_SHADOW", 0600, parent, (u16 *)0xFFC0300C);
		debugfs_create_x16("SPI0_SPIBAUD", 0600, parent, (u16 *)0xFFC0300A);
		debugfs_create_x16("SPI0_SPICTL", 0600, parent, (u16 *)0xFFC03000);
		debugfs_create_x16("SPI0_SPIFLG", 0600, parent, (u16 *)0xFFC03002);
		debugfs_create_x16("SPI0_SPIST", 0600, parent, (u16 *)0xFFC03004);
		debugfs_create_x16("SPI0_ST", 0600, parent, (u16 *)0xFFC03004);
		debugfs_create_x16("SPI0_START_ADDR_HI", 0600, parent, (u16 *)0xFFC03204);
		debugfs_create_x16("SPI0_START_ADDR_LO", 0600, parent, (u16 *)0xFFC03206);
		debugfs_create_x16("SPI0_TDBR", 0600, parent, (u16 *)0xFFC03006);
		debugfs_create_x16("SPI1_BAUD", 0600, parent, (u16 *)0xFFC0340A);
		debugfs_create_x16("SPI1_CONFIG", 0600, parent, (u16 *)0xFFC03602);
		debugfs_create_x16("SPI1_COUNT", 0600, parent, (u16 *)0xFFC03608);
		debugfs_create_x16("SPI1_CTL", 0600, parent, (u16 *)0xFFC03400);
		debugfs_create_x16("SPI1_CURR_PTR", 0600, parent, (u16 *)0xFFC03600);
		debugfs_create_x16("SPI1_DESCR_RDY", 0600, parent, (u16 *)0xFFC0360C);
		debugfs_create_x16("SPI1_DMACNT", 0600, parent, (u16 *)0xFFC03608);
		debugfs_create_x16("SPI1_DMACONF", 0600, parent, (u16 *)0xFFC03602);
		debugfs_create_x16("SPI1_DMACURR", 0600, parent, (u16 *)0xFFC03600);
		debugfs_create_x16("SPI1_DMADRDY", 0600, parent, (u16 *)0xFFC0360C);
		debugfs_create_x16("SPI1_DMAIRQ", 0600, parent, (u16 *)0xFFC0360E);
		debugfs_create_x16("SPI1_DMANEXT", 0600, parent, (u16 *)0xFFC0360A);
		debugfs_create_x16("SPI1_DMASADD", 0600, parent, (u16 *)0xFFC03606);
		debugfs_create_x16("SPI1_DMASPAGE", 0600, parent, (u16 *)0xFFC03604);
		debugfs_create_x16("SPI1_DMA_INT", 0600, parent, (u16 *)0xFFC0360E);
		debugfs_create_x16("SPI1_FLG", 0600, parent, (u16 *)0xFFC03402);
		debugfs_create_x16("SPI1_NEXT_DESCR", 0600, parent, (u16 *)0xFFC0360A);
		debugfs_create_x16("SPI1_RDBR", 0600, parent, (u16 *)0xFFC03408);
		debugfs_create_x16("SPI1_SHADOW", 0600, parent, (u16 *)0xFFC0340C);
		debugfs_create_x16("SPI1_SPIBAUD", 0600, parent, (u16 *)0xFFC0340A);
		debugfs_create_x16("SPI1_SPICTL", 0600, parent, (u16 *)0xFFC03400);
		debugfs_create_x16("SPI1_SPIFLG", 0600, parent, (u16 *)0xFFC03402);
		debugfs_create_x16("SPI1_SPIST", 0600, parent, (u16 *)0xFFC03404);
		debugfs_create_x16("SPI1_ST", 0600, parent, (u16 *)0xFFC03404);
		debugfs_create_x16("SPI1_START_ADDR_HI", 0600, parent, (u16 *)0xFFC03604);
		debugfs_create_x16("SPI1_START_ADDR_LO", 0600, parent, (u16 *)0xFFC03606);
		debugfs_create_x16("SPI1_TDBR", 0600, parent, (u16 *)0xFFC03406);

		parent = debugfs_create_dir("SPORT", top);
		debugfs_create_x16("SPORT0_CONFIG_DMA_RX", 0600, parent, (u16 *)0xFFC02A02);
		debugfs_create_x16("SPORT0_CONFIG_DMA_TX", 0600, parent, (u16 *)0xFFC02B02);
		debugfs_create_x16("SPORT0_COUNT_RX", 0600, parent, (u16 *)0xFFC02A08);
		debugfs_create_x16("SPORT0_COUNT_TX", 0600, parent, (u16 *)0xFFC02B08);
		debugfs_create_x16("SPORT0_CURR_PTR_RX", 0600, parent, (u16 *)0xFFC02A00);
		debugfs_create_x16("SPORT0_CURR_PTR_TX", 0600, parent, (u16 *)0xFFC02B00);
		debugfs_create_x16("SPORT0_DESCR_RDY_RX", 0600, parent, (u16 *)0xFFC02A0C);
		debugfs_create_x16("SPORT0_DESCR_RDY_TX", 0600, parent, (u16 *)0xFFC02B0C);
		debugfs_create_x16("SPORT0_IRQSTAT_RX", 0600, parent, (u16 *)0xFFC02A0E);
		debugfs_create_x16("SPORT0_IRQSTAT_TX", 0600, parent, (u16 *)0xFFC02B0E);
		debugfs_create_x16("SPORT0_MCMC1", 0600, parent, (u16 *)0xFFC02832);
		debugfs_create_x16("SPORT0_MCMC2", 0600, parent, (u16 *)0xFFC02834);
		debugfs_create_x16("SPORT0_MRCS0", 0600, parent, (u16 *)0xFFC02822);
		debugfs_create_x16("SPORT0_MRCS1", 0600, parent, (u16 *)0xFFC02824);
		debugfs_create_x16("SPORT0_MRCS2", 0600, parent, (u16 *)0xFFC02826);
		debugfs_create_x16("SPORT0_MRCS3", 0600, parent, (u16 *)0xFFC02828);
		debugfs_create_x16("SPORT0_MRCS4", 0600, parent, (u16 *)0xFFC0282A);
		debugfs_create_x16("SPORT0_MRCS5", 0600, parent, (u16 *)0xFFC0282C);
		debugfs_create_x16("SPORT0_MRCS6", 0600, parent, (u16 *)0xFFC0282E);
		debugfs_create_x16("SPORT0_MRCS7", 0600, parent, (u16 *)0xFFC02830);
		debugfs_create_x16("SPORT0_MTCS0", 0600, parent, (u16 *)0xFFC02812);
		debugfs_create_x16("SPORT0_MTCS1", 0600, parent, (u16 *)0xFFC02814);
		debugfs_create_x16("SPORT0_MTCS2", 0600, parent, (u16 *)0xFFC02816);
		debugfs_create_x16("SPORT0_MTCS3", 0600, parent, (u16 *)0xFFC02818);
		debugfs_create_x16("SPORT0_MTCS4", 0600, parent, (u16 *)0xFFC0281A);
		debugfs_create_x16("SPORT0_MTCS5", 0600, parent, (u16 *)0xFFC0281C);
		debugfs_create_x16("SPORT0_MTCS6", 0600, parent, (u16 *)0xFFC0281E);
		debugfs_create_x16("SPORT0_MTCS7", 0600, parent, (u16 *)0xFFC02820);
		debugfs_create_x16("SPORT0_NEXT_DESCR_RX", 0600, parent, (u16 *)0xFFC02A0A);
		debugfs_create_x16("SPORT0_NEXT_DESCR_TX", 0600, parent, (u16 *)0xFFC02B0A);
		debugfs_create_x16("SPORT0_RFSDIV", 0600, parent, (u16 *)0xFFC0280E);
		debugfs_create_x16("SPORT0_RSCLKDIV", 0600, parent, (u16 *)0xFFC0280A);
		debugfs_create_x16("SPORT0_RX", 0600, parent, (u16 *)0xFFC02806);
		debugfs_create_x16("SPORT0_RX_CONFIG", 0600, parent, (u16 *)0xFFC02802);
		debugfs_create_x16("SPORT0_START_ADDR_HI_RX", 0600, parent, (u16 *)0xFFC02A04);
		debugfs_create_x16("SPORT0_START_ADDR_HI_TX", 0600, parent, (u16 *)0xFFC02B04);
		debugfs_create_x16("SPORT0_START_ADDR_LO_RX", 0600, parent, (u16 *)0xFFC02A06);
		debugfs_create_x16("SPORT0_START_ADDR_LO_TX", 0600, parent, (u16 *)0xFFC02B06);
		debugfs_create_x16("SPORT0_STAT", 0600, parent, (u16 *)0xFFC02810);
		debugfs_create_x16("SPORT0_TFSDIV", 0600, parent, (u16 *)0xFFC0280C);
		debugfs_create_x16("SPORT0_TSCLKDIV", 0600, parent, (u16 *)0xFFC02808);
		debugfs_create_x16("SPORT0_TX", 0600, parent, (u16 *)0xFFC02804);
		debugfs_create_x16("SPORT0_TX_CONFIG", 0600, parent, (u16 *)0xFFC02800);
		debugfs_create_x16("SPORT1_CONFIG_DMA_RX", 0600, parent, (u16 *)0xFFC02E02);
		debugfs_create_x16("SPORT1_CONFIG_DMA_TX", 0600, parent, (u16 *)0xFFC02F02);
		debugfs_create_x16("SPORT1_COUNT_RX", 0600, parent, (u16 *)0xFFC02E08);
		debugfs_create_x16("SPORT1_COUNT_TX", 0600, parent, (u16 *)0xFFC02F08);
		debugfs_create_x16("SPORT1_CURR_PTR_RX", 0600, parent, (u16 *)0xFFC02E00);
		debugfs_create_x16("SPORT1_CURR_PTR_TX", 0600, parent, (u16 *)0xFFC02F00);
		debugfs_create_x16("SPORT1_DESCR_RDY_RX", 0600, parent, (u16 *)0xFFC02E0C);
		debugfs_create_x16("SPORT1_DESCR_RDY_TX", 0600, parent, (u16 *)0xFFC02F0C);
		debugfs_create_x16("SPORT1_IRQSTAT_RX", 0600, parent, (u16 *)0xFFC02E0E);
		debugfs_create_x16("SPORT1_IRQSTAT_TX", 0600, parent, (u16 *)0xFFC02F0E);
		debugfs_create_x16("SPORT1_MCMC1", 0600, parent, (u16 *)0xFFC02C32);
		debugfs_create_x16("SPORT1_MCMC2", 0600, parent, (u16 *)0xFFC02C34);
		debugfs_create_x16("SPORT1_MRCS0", 0600, parent, (u16 *)0xFFC02C22);
		debugfs_create_x16("SPORT1_MRCS1", 0600, parent, (u16 *)0xFFC02C24);
		debugfs_create_x16("SPORT1_MRCS2", 0600, parent, (u16 *)0xFFC02C26);
		debugfs_create_x16("SPORT1_MRCS3", 0600, parent, (u16 *)0xFFC02C28);
		debugfs_create_x16("SPORT1_MRCS4", 0600, parent, (u16 *)0xFFC02C2A);
		debugfs_create_x16("SPORT1_MRCS5", 0600, parent, (u16 *)0xFFC02C2C);
		debugfs_create_x16("SPORT1_MRCS6", 0600, parent, (u16 *)0xFFC02C2E);
		debugfs_create_x16("SPORT1_MRCS7", 0600, parent, (u16 *)0xFFC02C30);
		debugfs_create_x16("SPORT1_MTCS0", 0600, parent, (u16 *)0xFFC02C12);
		debugfs_create_x16("SPORT1_MTCS1", 0600, parent, (u16 *)0xFFC02C14);
		debugfs_create_x16("SPORT1_MTCS2", 0600, parent, (u16 *)0xFFC02C16);
		debugfs_create_x16("SPORT1_MTCS3", 0600, parent, (u16 *)0xFFC02C18);
		debugfs_create_x16("SPORT1_MTCS4", 0600, parent, (u16 *)0xFFC02C1A);
		debugfs_create_x16("SPORT1_MTCS5", 0600, parent, (u16 *)0xFFC02C1C);
		debugfs_create_x16("SPORT1_MTCS6", 0600, parent, (u16 *)0xFFC02C1E);
		debugfs_create_x16("SPORT1_MTCS7", 0600, parent, (u16 *)0xFFC02C20);
		debugfs_create_x16("SPORT1_NEXT_DESCR_RX", 0600, parent, (u16 *)0xFFC02E0A);
		debugfs_create_x16("SPORT1_NEXT_DESCR_TX", 0600, parent, (u16 *)0xFFC02F0A);
		debugfs_create_x16("SPORT1_RFSDIV", 0600, parent, (u16 *)0xFFC02C0E);
		debugfs_create_x16("SPORT1_RSCLKDIV", 0600, parent, (u16 *)0xFFC02C0A);
		debugfs_create_x16("SPORT1_RX", 0600, parent, (u16 *)0xFFC02C06);
		debugfs_create_x16("SPORT1_RX_CONFIG", 0600, parent, (u16 *)0xFFC02C02);
		debugfs_create_x16("SPORT1_START_ADDR_HI_RX", 0600, parent, (u16 *)0xFFC02E04);
		debugfs_create_x16("SPORT1_START_ADDR_HI_TX", 0600, parent, (u16 *)0xFFC02F04);
		debugfs_create_x16("SPORT1_START_ADDR_LO_RX", 0600, parent, (u16 *)0xFFC02E06);
		debugfs_create_x16("SPORT1_START_ADDR_LO_TX", 0600, parent, (u16 *)0xFFC02F06);
		debugfs_create_x16("SPORT1_STAT", 0600, parent, (u16 *)0xFFC02C10);
		debugfs_create_x16("SPORT1_TFSDIV", 0600, parent, (u16 *)0xFFC02C0C);
		debugfs_create_x16("SPORT1_TSCLKDIV", 0600, parent, (u16 *)0xFFC02C08);
		debugfs_create_x16("SPORT1_TX", 0600, parent, (u16 *)0xFFC02C04);
		debugfs_create_x16("SPORT1_TX_CONFIG", 0600, parent, (u16 *)0xFFC02C00);

		parent = debugfs_create_dir("SPT0", top);
		debugfs_create_x16("SPT0_MCMC1", 0600, parent, (u16 *)0xFFC02832);
		debugfs_create_x16("SPT0_MCMC2", 0600, parent, (u16 *)0xFFC02834);
		debugfs_create_x32("SPT0_MRCS0", 0600, parent, (u32 *)0xFFC02822);
		debugfs_create_x32("SPT0_MRCS1", 0600, parent, (u32 *)0xFFC02824);
		debugfs_create_x32("SPT0_MRCS2", 0600, parent, (u32 *)0xFFC02826);
		debugfs_create_x32("SPT0_MRCS3", 0600, parent, (u32 *)0xFFC02828);
		debugfs_create_x16("SPT0_MRCS4", 0600, parent, (u16 *)0xFFC0282A);
		debugfs_create_x16("SPT0_MRCS5", 0600, parent, (u16 *)0xFFC0282C);
		debugfs_create_x16("SPT0_MRCS6", 0600, parent, (u16 *)0xFFC0282E);
		debugfs_create_x16("SPT0_MRCS7", 0600, parent, (u16 *)0xFFC02830);
		debugfs_create_x32("SPT0_MTCS0", 0600, parent, (u32 *)0xFFC02812);
		debugfs_create_x32("SPT0_MTCS1", 0600, parent, (u32 *)0xFFC02814);
		debugfs_create_x32("SPT0_MTCS2", 0600, parent, (u32 *)0xFFC02816);
		debugfs_create_x32("SPT0_MTCS3", 0600, parent, (u32 *)0xFFC02818);
		debugfs_create_x16("SPT0_MTCS4", 0600, parent, (u16 *)0xFFC0281A);
		debugfs_create_x16("SPT0_MTCS5", 0600, parent, (u16 *)0xFFC0281C);
		debugfs_create_x16("SPT0_MTCS6", 0600, parent, (u16 *)0xFFC0281E);
		debugfs_create_x16("SPT0_MTCS7", 0600, parent, (u16 *)0xFFC02820);
		debugfs_create_x16("SPT0_RFSDIV", 0600, parent, (u16 *)0xFFC0280E);
		debugfs_create_x16("SPT0_RSCLKDIV", 0600, parent, (u16 *)0xFFC0280A);
		debugfs_create_x32("SPT0_RX", 0600, parent, (u32 *)0xFFC02806);
		debugfs_create_x16("SPT0_RX_CONFIG", 0600, parent, (u16 *)0xFFC02802);
		debugfs_create_x16("SPT0_RX_CONFIG_DMA", 0600, parent, (u16 *)0xFFC02A02);
		debugfs_create_x16("SPT0_RX_COUNT", 0600, parent, (u16 *)0xFFC02A08);
		debugfs_create_x16("SPT0_RX_CURR_PTR", 0600, parent, (u16 *)0xFFC02A00);
		debugfs_create_x16("SPT0_RX_DESCR_RDY", 0600, parent, (u16 *)0xFFC02A0C);
		debugfs_create_x16("SPT0_RX_IRQSTAT", 0600, parent, (u16 *)0xFFC02A0E);
		debugfs_create_x16("SPT0_RX_NEXT_DESCR", 0600, parent, (u16 *)0xFFC02A0A);
		debugfs_create_x16("SPT0_RX_START_ADDR", 0600, parent, (u16 *)0xFFC02A06);
		debugfs_create_x16("SPT0_RX_START_PG", 0600, parent, (u16 *)0xFFC02A04);
		debugfs_create_x16("SPT0_STAT", 0600, parent, (u16 *)0xFFC02810);
		debugfs_create_x16("SPT0_TFSDIV", 0600, parent, (u16 *)0xFFC0280C);
		debugfs_create_x16("SPT0_TSCLKDIV", 0600, parent, (u16 *)0xFFC02808);
		debugfs_create_x32("SPT0_TX", 0600, parent, (u32 *)0xFFC02804);
		debugfs_create_x16("SPT0_TX_CONFIG", 0600, parent, (u16 *)0xFFC02800);
		debugfs_create_x16("SPT0_TX_CONFIG_DMA", 0600, parent, (u16 *)0xFFC02B02);
		debugfs_create_x16("SPT0_TX_COUNT", 0600, parent, (u16 *)0xFFC02B08);
		debugfs_create_x16("SPT0_TX_CURR_PTR", 0600, parent, (u16 *)0xFFC02B00);
		debugfs_create_x16("SPT0_TX_DESCR_RDY", 0600, parent, (u16 *)0xFFC02B0C);
		debugfs_create_x16("SPT0_TX_IRQSTAT", 0600, parent, (u16 *)0xFFC02B0E);
		debugfs_create_x16("SPT0_TX_NEXT_DESCR", 0600, parent, (u16 *)0xFFC02B0A);
		debugfs_create_x16("SPT0_TX_START_ADDR", 0600, parent, (u16 *)0xFFC02B06);
		debugfs_create_x16("SPT0_TX_START_PG", 0600, parent, (u16 *)0xFFC02B04);

		parent = debugfs_create_dir("SPT1", top);
		debugfs_create_x16("SPT1_MCMC1", 0600, parent, (u16 *)0xFFC02C32);
		debugfs_create_x16("SPT1_MCMC2", 0600, parent, (u16 *)0xFFC02C34);
		debugfs_create_x16("SPT1_MRCS0", 0600, parent, (u16 *)0xFFC02C22);
		debugfs_create_x16("SPT1_MRCS1", 0600, parent, (u16 *)0xFFC02C24);
		debugfs_create_x16("SPT1_MRCS2", 0600, parent, (u16 *)0xFFC02C26);
		debugfs_create_x16("SPT1_MRCS3", 0600, parent, (u16 *)0xFFC02C28);
		debugfs_create_x16("SPT1_MRCS4", 0600, parent, (u16 *)0xFFC02C2A);
		debugfs_create_x16("SPT1_MRCS5", 0600, parent, (u16 *)0xFFC02C2C);
		debugfs_create_x16("SPT1_MRCS6", 0600, parent, (u16 *)0xFFC02C2E);
		debugfs_create_x16("SPT1_MRCS7", 0600, parent, (u16 *)0xFFC02C30);
		debugfs_create_x16("SPT1_MTCS0", 0600, parent, (u16 *)0xFFC02C12);
		debugfs_create_x16("SPT1_MTCS1", 0600, parent, (u16 *)0xFFC02C14);
		debugfs_create_x16("SPT1_MTCS2", 0600, parent, (u16 *)0xFFC02C16);
		debugfs_create_x16("SPT1_MTCS3", 0600, parent, (u16 *)0xFFC02C18);
		debugfs_create_x16("SPT1_MTCS4", 0600, parent, (u16 *)0xFFC02C1A);
		debugfs_create_x16("SPT1_MTCS5", 0600, parent, (u16 *)0xFFC02C1C);
		debugfs_create_x16("SPT1_MTCS6", 0600, parent, (u16 *)0xFFC02C1E);
		debugfs_create_x16("SPT1_MTCS7", 0600, parent, (u16 *)0xFFC02C20);
		debugfs_create_x16("SPT1_RFSDIV", 0600, parent, (u16 *)0xFFC02C0E);
		debugfs_create_x16("SPT1_RSCLKDIV", 0600, parent, (u16 *)0xFFC02C0A);
		debugfs_create_x16("SPT1_RX", 0600, parent, (u16 *)0xFFC02C06);
		debugfs_create_x16("SPT1_RX_CONFIG", 0600, parent, (u16 *)0xFFC02C02);
		debugfs_create_x16("SPT1_RX_CONFIG_DMA", 0600, parent, (u16 *)0xFFC02E02);
		debugfs_create_x16("SPT1_RX_COUNT", 0600, parent, (u16 *)0xFFC02E08);
		debugfs_create_x16("SPT1_RX_CURR_PTR", 0600, parent, (u16 *)0xFFC02E00);
		debugfs_create_x16("SPT1_RX_DESCR_RDY", 0600, parent, (u16 *)0xFFC02E0C);
		debugfs_create_x16("SPT1_RX_IRQSTAT", 0600, parent, (u16 *)0xFFC02E0E);
		debugfs_create_x16("SPT1_RX_NEXT_DESCR", 0600, parent, (u16 *)0xFFC02E0A);
		debugfs_create_x16("SPT1_RX_START_ADDR", 0600, parent, (u16 *)0xFFC02E06);
		debugfs_create_x16("SPT1_RX_START_PG", 0600, parent, (u16 *)0xFFC02E04);
		debugfs_create_x16("SPT1_STAT", 0600, parent, (u16 *)0xFFC02C10);
		debugfs_create_x16("SPT1_TFSDIV", 0600, parent, (u16 *)0xFFC02C0C);
		debugfs_create_x16("SPT1_TSCLKDIV", 0600, parent, (u16 *)0xFFC02C08);
		debugfs_create_x16("SPT1_TX", 0600, parent, (u16 *)0xFFC02C04);
		debugfs_create_x16("SPT1_TX_CONFIG", 0600, parent, (u16 *)0xFFC02C00);
		debugfs_create_x16("SPT1_TX_CONFIG_DMA", 0600, parent, (u16 *)0xFFC02F02);
		debugfs_create_x16("SPT1_TX_COUNT", 0600, parent, (u16 *)0xFFC02F08);
		debugfs_create_x16("SPT1_TX_CURR_PTR", 0600, parent, (u16 *)0xFFC02F00);
		debugfs_create_x16("SPT1_TX_DESCR_RDY", 0600, parent, (u16 *)0xFFC02F0C);
		debugfs_create_x16("SPT1_TX_IRQSTAT", 0600, parent, (u16 *)0xFFC02F0E);
		debugfs_create_x16("SPT1_TX_NEXT_DESCR", 0600, parent, (u16 *)0xFFC02F0A);
		debugfs_create_x16("SPT1_TX_START_ADDR", 0600, parent, (u16 *)0xFFC02F06);
		debugfs_create_x16("SPT1_TX_START_PG", 0600, parent, (u16 *)0xFFC02F04);

		parent = debugfs_create_dir("System Interrupt Controller Register File", top);
		debugfs_create_x32("SIC_IAR0", 0600, parent, (u32 *)0xFFC00C04);
		debugfs_create_x32("SIC_IAR1", 0600, parent, (u32 *)0xFFC00C08);
		debugfs_create_x32("SIC_IAR2", 0600, parent, (u32 *)0xFFC00C0C);
		debugfs_create_x32("SIC_IMASK", 0600, parent, (u32 *)0xFFC00C10);
		debugfs_create_x32("SIC_ISR", 0600, parent, (u32 *)0xFFC00C14);
		debugfs_create_x32("SIC_IWR", 0600, parent, (u32 *)0xFFC00C18);
		debugfs_create_x16("SIC_RVECT", 0600, parent, (u16 *)0xFFC00C00);

		parent = debugfs_create_dir("Timers Register File", top);
		debugfs_create_x16("TCONFIG0", 0600, parent, (u16 *)0xFFC02002);
		debugfs_create_x16("TCONFIG1", 0600, parent, (u16 *)0xFFC02012);
		debugfs_create_x16("TCONFIG2", 0600, parent, (u16 *)0xFFC02022);
		debugfs_create_x16("TCOUNT0_HI", 0600, parent, (u16 *)0xFFC02006);
		debugfs_create_x16("TCOUNT0_LO", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("TCOUNT1_HI", 0600, parent, (u16 *)0xFFC02016);
		debugfs_create_x16("TCOUNT1_LO", 0600, parent, (u16 *)0xFFC02014);
		debugfs_create_x16("TCOUNT2_HI", 0600, parent, (u16 *)0xFFC02026);
		debugfs_create_x16("TCOUNT2_LO", 0600, parent, (u16 *)0xFFC02024);
		debugfs_create_x16("TPERIOD0_HI", 0600, parent, (u16 *)0xFFC0200A);
		debugfs_create_x16("TPERIOD0_LO", 0600, parent, (u16 *)0xFFC02008);
		debugfs_create_x16("TPERIOD1_HI", 0600, parent, (u16 *)0xFFC0201A);
		debugfs_create_x16("TPERIOD1_LO", 0600, parent, (u16 *)0xFFC02018);
		debugfs_create_x16("TPERIOD2_HI", 0600, parent, (u16 *)0xFFC0202A);
		debugfs_create_x16("TPERIOD2_LO", 0600, parent, (u16 *)0xFFC02028);
		debugfs_create_x16("TSTATUS0", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("TSTATUS1", 0600, parent, (u16 *)0xFFC02010);
		debugfs_create_x16("TSTATUS2", 0600, parent, (u16 *)0xFFC02020);
		debugfs_create_x16("TSTATUS", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("TWIDTH0_HI", 0600, parent, (u16 *)0xFFC0200E);
		debugfs_create_x16("TWIDTH0_LO", 0600, parent, (u16 *)0xFFC0200C);
		debugfs_create_x16("TWIDTH1_HI", 0600, parent, (u16 *)0xFFC0201E);
		debugfs_create_x16("TWIDTH1_LO", 0600, parent, (u16 *)0xFFC0201C);
		debugfs_create_x16("TWIDTH2_HI", 0600, parent, (u16 *)0xFFC0202E);
		debugfs_create_x16("TWIDTH2_LO", 0600, parent, (u16 *)0xFFC0202C);

		parent = debugfs_create_dir("Trace Unit", top);
		debugfs_create_x32("TBUF", 0600, parent, (u32 *)0xFFE06100);
		debugfs_create_x32("TBUFCTL", 0600, parent, (u32 *)0xFFE06000);
		debugfs_create_x32("TBUFSTAT", 0600, parent, (u32 *)0xFFE06004);

		parent = debugfs_create_dir("UART", top);
		debugfs_create_x16("UART0_CONFIG_RX", 0600, parent, (u16 *)0xFFC01A02);
		debugfs_create_x16("UART0_CONFIG_TX", 0600, parent, (u16 *)0xFFC01B02);
		debugfs_create_x16("UART0_COUNT_RX", 0600, parent, (u16 *)0xFFC01A08);
		debugfs_create_x16("UART0_COUNT_TX", 0600, parent, (u16 *)0xFFC01B08);
		debugfs_create_x16("UART0_CURR_PTR_RX", 0600, parent, (u16 *)0xFFC01A00);
		debugfs_create_x16("UART0_CURR_PTR_TX", 0600, parent, (u16 *)0xFFC01B00);
		debugfs_create_x16("UART0_DESCR_RDY_RX", 0600, parent, (u16 *)0xFFC01A0C);
		debugfs_create_x16("UART0_DESCR_RDY_TX", 0600, parent, (u16 *)0xFFC01B0C);
		debugfs_create_x16("UART0_DLH", 0600, parent, (u16 *)0xFFC01802);
		debugfs_create_x16("UART0_DLL", 0600, parent, (u16 *)0xFFC01800);
		debugfs_create_x16("UART0_IER", 0600, parent, (u16 *)0xFFC01802);
		debugfs_create_x16("UART0_IIR", 0600, parent, (u16 *)0xFFC01804);
		debugfs_create_x16("UART0_IRCR", 0600, parent, (u16 *)0xFFC01810);
		debugfs_create_x16("UART0_IRQSTAT_RX", 0600, parent, (u16 *)0xFFC01A0E);
		debugfs_create_x16("UART0_IRQSTAT_TX", 0600, parent, (u16 *)0xFFC01B0E);
		debugfs_create_x16("UART0_LCR", 0600, parent, (u16 *)0xFFC01806);
		debugfs_create_x16("UART0_LSR", 0600, parent, (u16 *)0xFFC0180A);
		debugfs_create_x16("UART0_MCR", 0600, parent, (u16 *)0xFFC01808);
		debugfs_create_x16("UART0_MSR", 0600, parent, (u16 *)0xFFC0180C);
		debugfs_create_x16("UART0_NEXT_DESCR_RX", 0600, parent, (u16 *)0xFFC01A0A);
		debugfs_create_x16("UART0_NEXT_DESCR_TX", 0600, parent, (u16 *)0xFFC01B0A);
		debugfs_create_x16("UART0_RBR", 0600, parent, (u16 *)0xFFC01800);
		debugfs_create_x16("UART0_RX_CONFIG_DMA", 0600, parent, (u16 *)0xFFC01A02);
		debugfs_create_x16("UART0_RX_COUNT", 0600, parent, (u16 *)0xFFC01A08);
		debugfs_create_x16("UART0_RX_CURR_PTR", 0600, parent, (u16 *)0xFFC01A00);
		debugfs_create_x16("UART0_RX_DESCR_RDY", 0600, parent, (u16 *)0xFFC01A0C);
		debugfs_create_x16("UART0_RX_IRQSTAT", 0600, parent, (u16 *)0xFFC01A0E);
		debugfs_create_x16("UART0_RX_NEXT_DESCR", 0600, parent, (u16 *)0xFFC01A0A);
		debugfs_create_x16("UART0_RX_START_ADDR", 0600, parent, (u16 *)0xFFC01A06);
		debugfs_create_x16("UART0_RX_START_PG", 0600, parent, (u16 *)0xFFC01A04);
		debugfs_create_x16("UART0_SCR", 0600, parent, (u16 *)0xFFC0180E);
		debugfs_create_x16("UART0_START_ADDR_HI_RX", 0600, parent, (u16 *)0xFFC01A04);
		debugfs_create_x16("UART0_START_ADDR_HI_TX", 0600, parent, (u16 *)0xFFC01B04);
		debugfs_create_x16("UART0_START_ADDR_LO_RX", 0600, parent, (u16 *)0xFFC01A06);
		debugfs_create_x16("UART0_START_ADDR_LO_TX", 0600, parent, (u16 *)0xFFC01B06);
		debugfs_create_x16("UART0_THR", 0600, parent, (u16 *)0xFFC01800);
		debugfs_create_x16("UART0_TX_CONFIG_DMA", 0600, parent, (u16 *)0xFFC01B02);
		debugfs_create_x16("UART0_TX_COUNT", 0600, parent, (u16 *)0xFFC01B08);
		debugfs_create_x16("UART0_TX_CURR_PTR", 0600, parent, (u16 *)0xFFC01B00);
		debugfs_create_x16("UART0_TX_DESCR_RDY", 0600, parent, (u16 *)0xFFC01B0C);
		debugfs_create_x16("UART0_TX_IRQSTAT", 0600, parent, (u16 *)0xFFC01B0E);
		debugfs_create_x16("UART0_TX_NEXT_DESCR", 0600, parent, (u16 *)0xFFC01B0A);
		debugfs_create_x16("UART0_TX_START_ADDR", 0600, parent, (u16 *)0xFFC01B06);
		debugfs_create_x16("UART0_TX_START_PG", 0600, parent, (u16 *)0xFFC01B04);
		debugfs_create_x16("UART1_CONFIG_RX", 0600, parent, (u16 *)0xFFC01E02);
		debugfs_create_x16("UART1_CONFIG_TX", 0600, parent, (u16 *)0xFFC01F02);
		debugfs_create_x16("UART1_COUNT_RX", 0600, parent, (u16 *)0xFFC01E08);
		debugfs_create_x16("UART1_COUNT_TX", 0600, parent, (u16 *)0xFFC01F08);
		debugfs_create_x16("UART1_CURR_PTR_RX", 0600, parent, (u16 *)0xFFC01E00);
		debugfs_create_x16("UART1_CURR_PTR_TX", 0600, parent, (u16 *)0xFFC01F00);
		debugfs_create_x16("UART1_DESCR_RDY_RX", 0600, parent, (u16 *)0xFFC01E0C);
		debugfs_create_x16("UART1_DESCR_RDY_TX", 0600, parent, (u16 *)0xFFC01F0C);
		debugfs_create_x16("UART1_DLH", 0600, parent, (u16 *)0xFFC01C02);
		debugfs_create_x16("UART1_DLL", 0600, parent, (u16 *)0xFFC01C00);
		debugfs_create_x16("UART1_IER", 0600, parent, (u16 *)0xFFC01C02);
		debugfs_create_x16("UART1_IIR", 0600, parent, (u16 *)0xFFC01C04);
		debugfs_create_x16("UART1_IRQSTAT_RX", 0600, parent, (u16 *)0xFFC01E0E);
		debugfs_create_x16("UART1_IRQSTAT_TX", 0600, parent, (u16 *)0xFFC01F0E);
		debugfs_create_x16("UART1_LCR", 0600, parent, (u16 *)0xFFC01C06);
		debugfs_create_x16("UART1_LSR", 0600, parent, (u16 *)0xFFC01C0A);
		debugfs_create_x16("UART1_MCR", 0600, parent, (u16 *)0xFFC01C08);
		debugfs_create_x16("UART1_MSR", 0600, parent, (u16 *)0xFFC01C0C);
		debugfs_create_x16("UART1_NEXT_DESCR_RX", 0600, parent, (u16 *)0xFFC01E0A);
		debugfs_create_x16("UART1_NEXT_DESCR_TX", 0600, parent, (u16 *)0xFFC01F0A);
		debugfs_create_x16("UART1_RBR", 0600, parent, (u16 *)0xFFC01C00);
		debugfs_create_x16("UART1_RX_CONFIG_DMA", 0600, parent, (u16 *)0xFFC01E02);
		debugfs_create_x16("UART1_RX_COUNT", 0600, parent, (u16 *)0xFFC01E08);
		debugfs_create_x16("UART1_RX_CURR_PTR", 0600, parent, (u16 *)0xFFC01E00);
		debugfs_create_x16("UART1_RX_DESCR_RDY", 0600, parent, (u16 *)0xFFC01E0C);
		debugfs_create_x16("UART1_RX_IRQSTAT", 0600, parent, (u16 *)0xFFC01E0E);
		debugfs_create_x16("UART1_RX_NEXT_DESCR", 0600, parent, (u16 *)0xFFC01E0A);
		debugfs_create_x16("UART1_RX_START_ADDR", 0600, parent, (u16 *)0xFFC01E06);
		debugfs_create_x16("UART1_RX_START_PG", 0600, parent, (u16 *)0xFFC01E04);
		debugfs_create_x16("UART1_SCR", 0600, parent, (u16 *)0xFFC01C0E);
		debugfs_create_x16("UART1_START_ADDR_HI_RX", 0600, parent, (u16 *)0xFFC01E04);
		debugfs_create_x16("UART1_START_ADDR_HI_TX", 0600, parent, (u16 *)0xFFC01F04);
		debugfs_create_x16("UART1_START_ADDR_LO_RX", 0600, parent, (u16 *)0xFFC01E06);
		debugfs_create_x16("UART1_START_ADDR_LO_TX", 0600, parent, (u16 *)0xFFC01F06);
		debugfs_create_x16("UART1_THR", 0600, parent, (u16 *)0xFFC01C00);
		debugfs_create_x16("UART1_TX_CONFIG_DMA", 0600, parent, (u16 *)0xFFC01F02);
		debugfs_create_x16("UART1_TX_COUNT", 0600, parent, (u16 *)0xFFC01F08);
		debugfs_create_x16("UART1_TX_CURR_PTR", 0600, parent, (u16 *)0xFFC01F00);
		debugfs_create_x16("UART1_TX_DESCR_RDY", 0600, parent, (u16 *)0xFFC01F0C);
		debugfs_create_x16("UART1_TX_IRQSTAT", 0600, parent, (u16 *)0xFFC01F0E);
		debugfs_create_x16("UART1_TX_NEXT_DESCR", 0600, parent, (u16 *)0xFFC01F0A);
		debugfs_create_x16("UART1_TX_START_ADDR", 0600, parent, (u16 *)0xFFC01F06);
		debugfs_create_x16("UART1_TX_START_PG", 0600, parent, (u16 *)0xFFC01F04);

		parent = debugfs_create_dir("USBD", top);
		debugfs_create_x16("USBD_CTRL", 0600, parent, (u16 *)0xFFC0440A);
		debugfs_create_x16("USBD_DMABH", 0600, parent, (u16 *)0xFFC04444);
		debugfs_create_x16("USBD_DMABL", 0600, parent, (u16 *)0xFFC04442);
		debugfs_create_x16("USBD_DMACFG", 0600, parent, (u16 *)0xFFC04440);
		debugfs_create_x16("USBD_DMACT", 0600, parent, (u16 *)0xFFC04446);
		debugfs_create_x16("USBD_DMAIRQ", 0600, parent, (u16 *)0xFFC04448);
		debugfs_create_x16("USBD_EPADR0", 0600, parent, (u16 *)0xFFC04486);
		debugfs_create_x16("USBD_EPADR1", 0600, parent, (u16 *)0xFFC04490);
		debugfs_create_x16("USBD_EPADR2", 0600, parent, (u16 *)0xFFC0449A);
		debugfs_create_x16("USBD_EPADR3", 0600, parent, (u16 *)0xFFC044A4);
		debugfs_create_x16("USBD_EPADR4", 0600, parent, (u16 *)0xFFC044AE);
		debugfs_create_x16("USBD_EPADR5", 0600, parent, (u16 *)0xFFC044B8);
		debugfs_create_x16("USBD_EPADR6", 0600, parent, (u16 *)0xFFC044C2);
		debugfs_create_x16("USBD_EPADR7", 0600, parent, (u16 *)0xFFC044CC);
		debugfs_create_x16("USBD_EPBUF", 0600, parent, (u16 *)0xFFC04406);
		debugfs_create_x16("USBD_EPCFG0", 0600, parent, (u16 *)0xFFC04484);
		debugfs_create_x16("USBD_EPCFG1", 0600, parent, (u16 *)0xFFC0448E);
		debugfs_create_x16("USBD_EPCFG2", 0600, parent, (u16 *)0xFFC04498);
		debugfs_create_x16("USBD_EPCFG3", 0600, parent, (u16 *)0xFFC044A2);
		debugfs_create_x16("USBD_EPCFG4", 0600, parent, (u16 *)0xFFC044AC);
		debugfs_create_x16("USBD_EPCFG5", 0600, parent, (u16 *)0xFFC044B6);
		debugfs_create_x16("USBD_EPCFG6", 0600, parent, (u16 *)0xFFC044C0);
		debugfs_create_x16("USBD_EPCFG7", 0600, parent, (u16 *)0xFFC044CA);
		debugfs_create_x16("USBD_EPLEN0", 0600, parent, (u16 *)0xFFC04488);
		debugfs_create_x16("USBD_EPLEN1", 0600, parent, (u16 *)0xFFC04492);
		debugfs_create_x16("USBD_EPLEN2", 0600, parent, (u16 *)0xFFC0449C);
		debugfs_create_x16("USBD_EPLEN3", 0600, parent, (u16 *)0xFFC044A6);
		debugfs_create_x16("USBD_EPLEN4", 0600, parent, (u16 *)0xFFC044B0);
		debugfs_create_x16("USBD_EPLEN5", 0600, parent, (u16 *)0xFFC044BA);
		debugfs_create_x16("USBD_EPLEN6", 0600, parent, (u16 *)0xFFC044C4);
		debugfs_create_x16("USBD_EPLEN7", 0600, parent, (u16 *)0xFFC044CE);
		debugfs_create_x16("USBD_FRM", 0600, parent, (u16 *)0xFFC04402);
		debugfs_create_x16("USBD_FRMAT", 0600, parent, (u16 *)0xFFC04404);
		debugfs_create_x16("USBD_GINTR", 0600, parent, (u16 *)0xFFC0440C);
		debugfs_create_x16("USBD_GMASK", 0600, parent, (u16 *)0xFFC0440E);
		debugfs_create_x16("USBD_ID", 0600, parent, (u16 *)0xFFC04400);
		debugfs_create_x16("USBD_INTR0", 0600, parent, (u16 *)0xFFC04480);
		debugfs_create_x16("USBD_INTR1", 0600, parent, (u16 *)0xFFC0448A);
		debugfs_create_x16("USBD_INTR2", 0600, parent, (u16 *)0xFFC04494);
		debugfs_create_x16("USBD_INTR3", 0600, parent, (u16 *)0xFFC0449E);
		debugfs_create_x16("USBD_INTR4", 0600, parent, (u16 *)0xFFC044A8);
		debugfs_create_x16("USBD_INTR5", 0600, parent, (u16 *)0xFFC044B2);
		debugfs_create_x16("USBD_INTR6", 0600, parent, (u16 *)0xFFC044BC);
		debugfs_create_x16("USBD_INTR7", 0600, parent, (u16 *)0xFFC044C6);
		debugfs_create_x16("USBD_MASK0", 0600, parent, (u16 *)0xFFC04482);
		debugfs_create_x16("USBD_MASK1", 0600, parent, (u16 *)0xFFC0448C);
		debugfs_create_x16("USBD_MASK2", 0600, parent, (u16 *)0xFFC04496);
		debugfs_create_x16("USBD_MASK3", 0600, parent, (u16 *)0xFFC044A0);
		debugfs_create_x16("USBD_MASK4", 0600, parent, (u16 *)0xFFC044AA);
		debugfs_create_x16("USBD_MASK5", 0600, parent, (u16 *)0xFFC044B4);
		debugfs_create_x16("USBD_MASK6", 0600, parent, (u16 *)0xFFC044BE);
		debugfs_create_x16("USBD_MASK7", 0600, parent, (u16 *)0xFFC044C8);
		debugfs_create_x16("USBD_STAT", 0600, parent, (u16 *)0xFFC04408);

		parent = debugfs_create_dir("Watchdog", top);
		debugfs_create_x32("WDOG_CNT", 0600, parent, (u32 *)0xFFC01004);
		debugfs_create_x16("WDOG_CTL", 0600, parent, (u16 *)0xFFC01000);
		debugfs_create_x32("WDOG_STAT", 0600, parent, (u32 *)0xFFC01008);

		parent = debugfs_create_dir("Watchpoint and Patch Unit", top);
		debugfs_create_x32("WPDA0", 0600, parent, (u32 *)0xFFE07140);
		debugfs_create_x32("WPDA1", 0600, parent, (u32 *)0xFFE07144);
		debugfs_create_x32("WPDACNT0", 0600, parent, (u32 *)0xFFE07180);
		debugfs_create_x32("WPDACNT1", 0600, parent, (u32 *)0xFFE07184);
		debugfs_create_x32("WPDACTL", 0600, parent, (u32 *)0xFFE07100);
		debugfs_create_x32("WPIA0", 0600, parent, (u32 *)0xFFE07040);
		debugfs_create_x32("WPIA1", 0600, parent, (u32 *)0xFFE07044);
		debugfs_create_x32("WPIA2", 0600, parent, (u32 *)0xFFE07048);
		debugfs_create_x32("WPIA3", 0600, parent, (u32 *)0xFFE0704C);
		debugfs_create_x32("WPIA4", 0600, parent, (u32 *)0xFFE07050);
		debugfs_create_x32("WPIA5", 0600, parent, (u32 *)0xFFE07054);
		debugfs_create_x32("WPIACNT0", 0600, parent, (u32 *)0xFFE07080);
		debugfs_create_x32("WPIACNT1", 0600, parent, (u32 *)0xFFE07084);
		debugfs_create_x32("WPIACNT2", 0600, parent, (u32 *)0xFFE07088);
		debugfs_create_x32("WPIACNT3", 0600, parent, (u32 *)0xFFE0708C);
		debugfs_create_x32("WPIACNT4", 0600, parent, (u32 *)0xFFE07090);
		debugfs_create_x32("WPIACNT5", 0600, parent, (u32 *)0xFFE07094);
		debugfs_create_x32("WPIACTL", 0600, parent, (u32 *)0xFFE07000);
		debugfs_create_x32("WPSTAT", 0600, parent, (u32 *)0xFFE07200);

	}	/* BF535 */

#ifdef __ADSPBF536__
# define USE_BF536 1
#else
# define USE_BF536 0
#endif
	if (USE_BF536) {

		parent = debugfs_create_dir("CAN Controller", top);
		debugfs_create_x16("CAN_AA1", 0600, parent, (u16 *)0xFFC02A14);
		debugfs_create_x16("CAN_AA2", 0600, parent, (u16 *)0xFFC02A54);
		debugfs_create_x16("CAN_AM00H", 0600, parent, (u16 *)0xFFC02B04);
		debugfs_create_x16("CAN_AM00L", 0600, parent, (u16 *)0xFFC02B00);
		debugfs_create_x16("CAN_AM01H", 0600, parent, (u16 *)0xFFC02B0C);
		debugfs_create_x16("CAN_AM01L", 0600, parent, (u16 *)0xFFC02B08);
		debugfs_create_x16("CAN_AM02H", 0600, parent, (u16 *)0xFFC02B14);
		debugfs_create_x16("CAN_AM02L", 0600, parent, (u16 *)0xFFC02B10);
		debugfs_create_x16("CAN_AM03H", 0600, parent, (u16 *)0xFFC02B1C);
		debugfs_create_x16("CAN_AM03L", 0600, parent, (u16 *)0xFFC02B18);
		debugfs_create_x16("CAN_AM04H", 0600, parent, (u16 *)0xFFC02B24);
		debugfs_create_x16("CAN_AM04L", 0600, parent, (u16 *)0xFFC02B20);
		debugfs_create_x16("CAN_AM05H", 0600, parent, (u16 *)0xFFC02B2C);
		debugfs_create_x16("CAN_AM05L", 0600, parent, (u16 *)0xFFC02B28);
		debugfs_create_x16("CAN_AM06H", 0600, parent, (u16 *)0xFFC02B34);
		debugfs_create_x16("CAN_AM06L", 0600, parent, (u16 *)0xFFC02B30);
		debugfs_create_x16("CAN_AM07H", 0600, parent, (u16 *)0xFFC02B3C);
		debugfs_create_x16("CAN_AM07L", 0600, parent, (u16 *)0xFFC02B38);
		debugfs_create_x16("CAN_AM08H", 0600, parent, (u16 *)0xFFC02B44);
		debugfs_create_x16("CAN_AM08L", 0600, parent, (u16 *)0xFFC02B40);
		debugfs_create_x16("CAN_AM09H", 0600, parent, (u16 *)0xFFC02B4C);
		debugfs_create_x16("CAN_AM09L", 0600, parent, (u16 *)0xFFC02B48);
		debugfs_create_x16("CAN_AM10H", 0600, parent, (u16 *)0xFFC02B54);
		debugfs_create_x16("CAN_AM10L", 0600, parent, (u16 *)0xFFC02B50);
		debugfs_create_x16("CAN_AM11H", 0600, parent, (u16 *)0xFFC02B5C);
		debugfs_create_x16("CAN_AM11L", 0600, parent, (u16 *)0xFFC02B58);
		debugfs_create_x16("CAN_AM12H", 0600, parent, (u16 *)0xFFC02B64);
		debugfs_create_x16("CAN_AM12L", 0600, parent, (u16 *)0xFFC02B60);
		debugfs_create_x16("CAN_AM13H", 0600, parent, (u16 *)0xFFC02B6C);
		debugfs_create_x16("CAN_AM13L", 0600, parent, (u16 *)0xFFC02B68);
		debugfs_create_x16("CAN_AM14H", 0600, parent, (u16 *)0xFFC02B74);
		debugfs_create_x16("CAN_AM14L", 0600, parent, (u16 *)0xFFC02B70);
		debugfs_create_x16("CAN_AM15H", 0600, parent, (u16 *)0xFFC02B7C);
		debugfs_create_x16("CAN_AM15L", 0600, parent, (u16 *)0xFFC02B78);
		debugfs_create_x16("CAN_AM16H", 0600, parent, (u16 *)0xFFC02B84);
		debugfs_create_x16("CAN_AM16L", 0600, parent, (u16 *)0xFFC02B80);
		debugfs_create_x16("CAN_AM17H", 0600, parent, (u16 *)0xFFC02B8C);
		debugfs_create_x16("CAN_AM17L", 0600, parent, (u16 *)0xFFC02B88);
		debugfs_create_x16("CAN_AM18H", 0600, parent, (u16 *)0xFFC02B94);
		debugfs_create_x16("CAN_AM18L", 0600, parent, (u16 *)0xFFC02B90);
		debugfs_create_x16("CAN_AM19H", 0600, parent, (u16 *)0xFFC02B9C);
		debugfs_create_x16("CAN_AM19L", 0600, parent, (u16 *)0xFFC02B98);
		debugfs_create_x16("CAN_AM20H", 0600, parent, (u16 *)0xFFC02BA4);
		debugfs_create_x16("CAN_AM20L", 0600, parent, (u16 *)0xFFC02BA0);
		debugfs_create_x16("CAN_AM21H", 0600, parent, (u16 *)0xFFC02BAC);
		debugfs_create_x16("CAN_AM21L", 0600, parent, (u16 *)0xFFC02BA8);
		debugfs_create_x16("CAN_AM22H", 0600, parent, (u16 *)0xFFC02BB4);
		debugfs_create_x16("CAN_AM22L", 0600, parent, (u16 *)0xFFC02BB0);
		debugfs_create_x16("CAN_AM23H", 0600, parent, (u16 *)0xFFC02BBC);
		debugfs_create_x16("CAN_AM23L", 0600, parent, (u16 *)0xFFC02BB8);
		debugfs_create_x16("CAN_AM24H", 0600, parent, (u16 *)0xFFC02BC4);
		debugfs_create_x16("CAN_AM24L", 0600, parent, (u16 *)0xFFC02BC0);
		debugfs_create_x16("CAN_AM25H", 0600, parent, (u16 *)0xFFC02BCC);
		debugfs_create_x16("CAN_AM25L", 0600, parent, (u16 *)0xFFC02BC8);
		debugfs_create_x16("CAN_AM26H", 0600, parent, (u16 *)0xFFC02BD4);
		debugfs_create_x16("CAN_AM26L", 0600, parent, (u16 *)0xFFC02BD0);
		debugfs_create_x16("CAN_AM27H", 0600, parent, (u16 *)0xFFC02BDC);
		debugfs_create_x16("CAN_AM27L", 0600, parent, (u16 *)0xFFC02BD8);
		debugfs_create_x16("CAN_AM28H", 0600, parent, (u16 *)0xFFC02BE4);
		debugfs_create_x16("CAN_AM28L", 0600, parent, (u16 *)0xFFC02BE0);
		debugfs_create_x16("CAN_AM29H", 0600, parent, (u16 *)0xFFC02BEC);
		debugfs_create_x16("CAN_AM29L", 0600, parent, (u16 *)0xFFC02BE8);
		debugfs_create_x16("CAN_AM30H", 0600, parent, (u16 *)0xFFC02BF4);
		debugfs_create_x16("CAN_AM30L", 0600, parent, (u16 *)0xFFC02BF0);
		debugfs_create_x16("CAN_AM31H", 0600, parent, (u16 *)0xFFC02BFC);
		debugfs_create_x16("CAN_AM31L", 0600, parent, (u16 *)0xFFC02BF8);
		debugfs_create_x16("CAN_CEC", 0600, parent, (u16 *)0xFFC02A90);
		debugfs_create_x16("CAN_CLOCK", 0600, parent, (u16 *)0xFFC02A80);
		debugfs_create_x16("CAN_CONTROL", 0600, parent, (u16 *)0xFFC02AA0);
		debugfs_create_x16("CAN_DEBUG", 0600, parent, (u16 *)0xFFC02A88);
		debugfs_create_x16("CAN_ESR", 0600, parent, (u16 *)0xFFC02AB4);
		debugfs_create_x16("CAN_EWR", 0600, parent, (u16 *)0xFFC02AB0);
		debugfs_create_x16("CAN_GIF", 0600, parent, (u16 *)0xFFC02A9C);
		debugfs_create_x16("CAN_GIM", 0600, parent, (u16 *)0xFFC02A98);
		debugfs_create_x16("CAN_GIS", 0600, parent, (u16 *)0xFFC02A94);
		debugfs_create_x16("CAN_INTR", 0600, parent, (u16 *)0xFFC02AA4);
		debugfs_create_x16("CAN_MBIM1", 0600, parent, (u16 *)0xFFC02A28);
		debugfs_create_x16("CAN_MBIM2", 0600, parent, (u16 *)0xFFC02A68);
		debugfs_create_x16("CAN_MBRIF1", 0600, parent, (u16 *)0xFFC02A24);
		debugfs_create_x16("CAN_MBRIF2", 0600, parent, (u16 *)0xFFC02A64);
		debugfs_create_x16("CAN_MBTD", 0600, parent, (u16 *)0xFFC02AAC);
		debugfs_create_x16("CAN_MBTIF1", 0600, parent, (u16 *)0xFFC02A20);
		debugfs_create_x16("CAN_MBTIF2", 0600, parent, (u16 *)0xFFC02A60);
		debugfs_create_x16("CAN_MC1", 0600, parent, (u16 *)0xFFC02A00);
		debugfs_create_x16("CAN_MC2", 0600, parent, (u16 *)0xFFC02A40);
		debugfs_create_x16("CAN_MD1", 0600, parent, (u16 *)0xFFC02A04);
		debugfs_create_x16("CAN_MD2", 0600, parent, (u16 *)0xFFC02A44);
		debugfs_create_x16("CAN_OPSS1", 0600, parent, (u16 *)0xFFC02A30);
		debugfs_create_x16("CAN_OPSS2", 0600, parent, (u16 *)0xFFC02A70);
		debugfs_create_x16("CAN_RFH1", 0600, parent, (u16 *)0xFFC02A2C);
		debugfs_create_x16("CAN_RFH2", 0600, parent, (u16 *)0xFFC02A6C);
		debugfs_create_x16("CAN_RML1", 0600, parent, (u16 *)0xFFC02A1C);
		debugfs_create_x16("CAN_RML2", 0600, parent, (u16 *)0xFFC02A5C);
		debugfs_create_x16("CAN_RMP1", 0600, parent, (u16 *)0xFFC02A18);
		debugfs_create_x16("CAN_RMP2", 0600, parent, (u16 *)0xFFC02A58);
		debugfs_create_x16("CAN_STATUS", 0600, parent, (u16 *)0xFFC02A8C);
		debugfs_create_x16("CAN_TA1", 0600, parent, (u16 *)0xFFC02A10);
		debugfs_create_x16("CAN_TA2", 0600, parent, (u16 *)0xFFC02A50);
		debugfs_create_x16("CAN_TIMING", 0600, parent, (u16 *)0xFFC02A84);
		debugfs_create_x16("CAN_TRR1", 0600, parent, (u16 *)0xFFC02A0C);
		debugfs_create_x16("CAN_TRR2", 0600, parent, (u16 *)0xFFC02A4C);
		debugfs_create_x16("CAN_TRS1", 0600, parent, (u16 *)0xFFC02A08);
		debugfs_create_x16("CAN_TRS2", 0600, parent, (u16 *)0xFFC02A48);
		debugfs_create_x16("CAN_UCCNF", 0600, parent, (u16 *)0xFFC02ACC);
		debugfs_create_x16("CAN_UCCNT", 0600, parent, (u16 *)0xFFC02AC4);
		debugfs_create_x16("CAN_UCRC", 0600, parent, (u16 *)0xFFC02AC8);
		debugfs_create_x16("CAN_UCREG", 0600, parent, (u16 *)0xFFC02AC0);
		debugfs_create_x16("CAN_VERSION2", 0600, parent, (u16 *)0xFFC02AD4);
		debugfs_create_x16("CAN_VERSION", 0600, parent, (u16 *)0xFFC02AA8);

		parent = debugfs_create_dir("Core Timer Register File", top);
		debugfs_create_x32("TCNTL", 0600, parent, (u32 *)0xFFE03000);
		debugfs_create_x32("TCOUNT", 0600, parent, (u32 *)0xFFE0300C);
		debugfs_create_x32("TPERIOD", 0600, parent, (u32 *)0xFFE03004);
		debugfs_create_x32("TSCALE", 0600, parent, (u32 *)0xFFE03008);

		parent = debugfs_create_dir("DMA Controller", top);
		debugfs_create_x16("DMA0_CONFIG", 0600, parent, (u16 *)0xFFC00C08);
		debugfs_create_x32("DMA0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C24);
		debugfs_create_x32("DMA0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C20);
		debugfs_create_x16("DMA0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C30);
		debugfs_create_x16("DMA0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C38);
		debugfs_create_x16("DMA0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C28);
		debugfs_create_x32("DMA0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C00);
		debugfs_create_x16("DMA0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C2C);
		debugfs_create_x32("DMA0_START_ADDR", 0600, parent, (u32 *)0xFFC00C04);
		debugfs_create_x16("DMA0_X_COUNT", 0600, parent, (u16 *)0xFFC00C10);
		debugfs_create_x16("DMA0_X_MODIFY", 0600, parent, (u16 *)0xFFC00C14);
		debugfs_create_x16("DMA0_Y_COUNT", 0600, parent, (u16 *)0xFFC00C18);
		debugfs_create_x16("DMA0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C1C);
		debugfs_create_x16("DMA10_CONFIG", 0600, parent, (u16 *)0xFFC00E88);
		debugfs_create_x32("DMA10_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EA4);
		debugfs_create_x32("DMA10_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EA0);
		debugfs_create_x16("DMA10_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EB0);
		debugfs_create_x16("DMA10_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EB8);
		debugfs_create_x16("DMA10_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EA8);
		debugfs_create_x32("DMA10_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E80);
		debugfs_create_x16("DMA10_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EAC);
		debugfs_create_x32("DMA10_START_ADDR", 0600, parent, (u32 *)0xFFC00E84);
		debugfs_create_x16("DMA10_X_COUNT", 0600, parent, (u16 *)0xFFC00E90);
		debugfs_create_x16("DMA10_X_MODIFY", 0600, parent, (u16 *)0xFFC00E94);
		debugfs_create_x16("DMA10_Y_COUNT", 0600, parent, (u16 *)0xFFC00E98);
		debugfs_create_x16("DMA10_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E9C);
		debugfs_create_x16("DMA11_CONFIG", 0600, parent, (u16 *)0xFFC00EC8);
		debugfs_create_x32("DMA11_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EE4);
		debugfs_create_x32("DMA11_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EE0);
		debugfs_create_x16("DMA11_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EF0);
		debugfs_create_x16("DMA11_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EF8);
		debugfs_create_x16("DMA11_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EE8);
		debugfs_create_x32("DMA11_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00EC0);
		debugfs_create_x16("DMA11_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EEC);
		debugfs_create_x32("DMA11_START_ADDR", 0600, parent, (u32 *)0xFFC00EC4);
		debugfs_create_x16("DMA11_X_COUNT", 0600, parent, (u16 *)0xFFC00ED0);
		debugfs_create_x16("DMA11_X_MODIFY", 0600, parent, (u16 *)0xFFC00ED4);
		debugfs_create_x16("DMA11_Y_COUNT", 0600, parent, (u16 *)0xFFC00ED8);
		debugfs_create_x16("DMA11_Y_MODIFY", 0600, parent, (u16 *)0xFFC00EDC);
		debugfs_create_x16("DMA1_CONFIG", 0600, parent, (u16 *)0xFFC00C48);
		debugfs_create_x32("DMA1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C64);
		debugfs_create_x32("DMA1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C60);
		debugfs_create_x16("DMA1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C70);
		debugfs_create_x16("DMA1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C78);
		debugfs_create_x16("DMA1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C68);
		debugfs_create_x32("DMA1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C40);
		debugfs_create_x16("DMA1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C6C);
		debugfs_create_x32("DMA1_START_ADDR", 0600, parent, (u32 *)0xFFC00C44);
		debugfs_create_x16("DMA1_X_COUNT", 0600, parent, (u16 *)0xFFC00C50);
		debugfs_create_x16("DMA1_X_MODIFY", 0600, parent, (u16 *)0xFFC00C54);
		debugfs_create_x16("DMA1_Y_COUNT", 0600, parent, (u16 *)0xFFC00C58);
		debugfs_create_x16("DMA1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C5C);
		debugfs_create_x16("DMA2_CONFIG", 0600, parent, (u16 *)0xFFC00C88);
		debugfs_create_x32("DMA2_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CA4);
		debugfs_create_x32("DMA2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CA0);
		debugfs_create_x16("DMA2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CB0);
		debugfs_create_x16("DMA2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CB8);
		debugfs_create_x16("DMA2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CA8);
		debugfs_create_x32("DMA2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C80);
		debugfs_create_x16("DMA2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CAC);
		debugfs_create_x32("DMA2_START_ADDR", 0600, parent, (u32 *)0xFFC00C84);
		debugfs_create_x16("DMA2_X_COUNT", 0600, parent, (u16 *)0xFFC00C90);
		debugfs_create_x16("DMA2_X_MODIFY", 0600, parent, (u16 *)0xFFC00C94);
		debugfs_create_x16("DMA2_Y_COUNT", 0600, parent, (u16 *)0xFFC00C98);
		debugfs_create_x16("DMA2_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C9C);
		debugfs_create_x16("DMA3_CONFIG", 0600, parent, (u16 *)0xFFC00CC8);
		debugfs_create_x32("DMA3_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CE4);
		debugfs_create_x32("DMA3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CE0);
		debugfs_create_x16("DMA3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CF0);
		debugfs_create_x16("DMA3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CF8);
		debugfs_create_x16("DMA3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CE8);
		debugfs_create_x32("DMA3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00CC0);
		debugfs_create_x16("DMA3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CEC);
		debugfs_create_x32("DMA3_START_ADDR", 0600, parent, (u32 *)0xFFC00CC4);
		debugfs_create_x16("DMA3_X_COUNT", 0600, parent, (u16 *)0xFFC00CD0);
		debugfs_create_x16("DMA3_X_MODIFY", 0600, parent, (u16 *)0xFFC00CD4);
		debugfs_create_x16("DMA3_Y_COUNT", 0600, parent, (u16 *)0xFFC00CD8);
		debugfs_create_x16("DMA3_Y_MODIFY", 0600, parent, (u16 *)0xFFC00CDC);
		debugfs_create_x16("DMA4_CONFIG", 0600, parent, (u16 *)0xFFC00D08);
		debugfs_create_x32("DMA4_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D24);
		debugfs_create_x32("DMA4_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D20);
		debugfs_create_x16("DMA4_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D30);
		debugfs_create_x16("DMA4_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D38);
		debugfs_create_x16("DMA4_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D28);
		debugfs_create_x32("DMA4_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D00);
		debugfs_create_x16("DMA4_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D2C);
		debugfs_create_x32("DMA4_START_ADDR", 0600, parent, (u32 *)0xFFC00D04);
		debugfs_create_x16("DMA4_X_COUNT", 0600, parent, (u16 *)0xFFC00D10);
		debugfs_create_x16("DMA4_X_MODIFY", 0600, parent, (u16 *)0xFFC00D14);
		debugfs_create_x16("DMA4_Y_COUNT", 0600, parent, (u16 *)0xFFC00D18);
		debugfs_create_x16("DMA4_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D1C);
		debugfs_create_x16("DMA5_CONFIG", 0600, parent, (u16 *)0xFFC00D48);
		debugfs_create_x32("DMA5_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D64);
		debugfs_create_x32("DMA5_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D60);
		debugfs_create_x16("DMA5_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D70);
		debugfs_create_x16("DMA5_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D78);
		debugfs_create_x16("DMA5_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D68);
		debugfs_create_x32("DMA5_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D40);
		debugfs_create_x16("DMA5_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D6C);
		debugfs_create_x32("DMA5_START_ADDR", 0600, parent, (u32 *)0xFFC00D44);
		debugfs_create_x16("DMA5_X_COUNT", 0600, parent, (u16 *)0xFFC00D50);
		debugfs_create_x16("DMA5_X_MODIFY", 0600, parent, (u16 *)0xFFC00D54);
		debugfs_create_x16("DMA5_Y_COUNT", 0600, parent, (u16 *)0xFFC00D58);
		debugfs_create_x16("DMA5_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D5C);
		debugfs_create_x16("DMA6_CONFIG", 0600, parent, (u16 *)0xFFC00D88);
		debugfs_create_x32("DMA6_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DA4);
		debugfs_create_x32("DMA6_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DA0);
		debugfs_create_x16("DMA6_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DB0);
		debugfs_create_x16("DMA6_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DB8);
		debugfs_create_x16("DMA6_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DA8);
		debugfs_create_x32("DMA6_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D80);
		debugfs_create_x16("DMA6_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DAC);
		debugfs_create_x32("DMA6_START_ADDR", 0600, parent, (u32 *)0xFFC00D84);
		debugfs_create_x16("DMA6_X_COUNT", 0600, parent, (u16 *)0xFFC00D90);
		debugfs_create_x16("DMA6_X_MODIFY", 0600, parent, (u16 *)0xFFC00D94);
		debugfs_create_x16("DMA6_Y_COUNT", 0600, parent, (u16 *)0xFFC00D98);
		debugfs_create_x16("DMA6_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D9C);
		debugfs_create_x16("DMA7_CONFIG", 0600, parent, (u16 *)0xFFC00DC8);
		debugfs_create_x32("DMA7_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DE4);
		debugfs_create_x32("DMA7_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DE0);
		debugfs_create_x16("DMA7_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DF0);
		debugfs_create_x16("DMA7_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DF8);
		debugfs_create_x16("DMA7_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DE8);
		debugfs_create_x32("DMA7_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00DC0);
		debugfs_create_x16("DMA7_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DEC);
		debugfs_create_x32("DMA7_START_ADDR", 0600, parent, (u32 *)0xFFC00DC4);
		debugfs_create_x16("DMA7_X_COUNT", 0600, parent, (u16 *)0xFFC00DD0);
		debugfs_create_x16("DMA7_X_MODIFY", 0600, parent, (u16 *)0xFFC00DD4);
		debugfs_create_x16("DMA7_Y_COUNT", 0600, parent, (u16 *)0xFFC00DD8);
		debugfs_create_x16("DMA7_Y_MODIFY", 0600, parent, (u16 *)0xFFC00DDC);
		debugfs_create_x16("DMA8_CONFIG", 0600, parent, (u16 *)0xFFC00E08);
		debugfs_create_x32("DMA8_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E24);
		debugfs_create_x32("DMA8_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E20);
		debugfs_create_x16("DMA8_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E30);
		debugfs_create_x16("DMA8_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E38);
		debugfs_create_x16("DMA8_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E28);
		debugfs_create_x32("DMA8_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E00);
		debugfs_create_x16("DMA8_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E2C);
		debugfs_create_x32("DMA8_START_ADDR", 0600, parent, (u32 *)0xFFC00E04);
		debugfs_create_x16("DMA8_X_COUNT", 0600, parent, (u16 *)0xFFC00E10);
		debugfs_create_x16("DMA8_X_MODIFY", 0600, parent, (u16 *)0xFFC00E14);
		debugfs_create_x16("DMA8_Y_COUNT", 0600, parent, (u16 *)0xFFC00E18);
		debugfs_create_x16("DMA8_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E1C);
		debugfs_create_x16("DMA9_CONFIG", 0600, parent, (u16 *)0xFFC00E48);
		debugfs_create_x32("DMA9_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E64);
		debugfs_create_x32("DMA9_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E60);
		debugfs_create_x16("DMA9_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E70);
		debugfs_create_x16("DMA9_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E78);
		debugfs_create_x16("DMA9_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E68);
		debugfs_create_x32("DMA9_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E40);
		debugfs_create_x16("DMA9_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E6C);
		debugfs_create_x32("DMA9_START_ADDR", 0600, parent, (u32 *)0xFFC00E44);
		debugfs_create_x16("DMA9_X_COUNT", 0600, parent, (u16 *)0xFFC00E50);
		debugfs_create_x16("DMA9_X_MODIFY", 0600, parent, (u16 *)0xFFC00E54);
		debugfs_create_x16("DMA9_Y_COUNT", 0600, parent, (u16 *)0xFFC00E58);
		debugfs_create_x16("DMA9_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E5C);

		parent = debugfs_create_dir("DMA Traffic Control", top);
		debugfs_create_x16("DMA_TC_CNT", 0600, parent, (u16 *)0xFFC00B0C);
		debugfs_create_x16("DMA_TC_PER", 0600, parent, (u16 *)0xFFC00B10);

		parent = debugfs_create_dir("Data Cache Programmable Look-Aside Buffer Fault Address", top);
		debugfs_create_x32("DCPLB_STATUS", 0600, parent, (u32 *)0xFFE00008);

		parent = debugfs_create_dir("EBIU", top);
		debugfs_create_x32("EBIU_AMBCTL0", 0600, parent, (u32 *)0xFFC00A04);
		debugfs_create_x32("EBIU_AMBCTL1", 0600, parent, (u32 *)0xFFC00A08);
		debugfs_create_x16("EBIU_AMGCTL", 0600, parent, (u16 *)0xFFC00A00);
		debugfs_create_x16("EBIU_SDBCTL", 0600, parent, (u16 *)0xFFC00A14);
		debugfs_create_x32("EBIU_SDGCTL", 0600, parent, (u32 *)0xFFC00A10);
		debugfs_create_x16("EBIU_SDRRC", 0600, parent, (u16 *)0xFFC00A18);
		debugfs_create_x16("EBIU_SDSTAT", 0600, parent, (u16 *)0xFFC00A1C);

		parent = debugfs_create_dir("Ethernet Controller", top);
		debugfs_create_x32("EMAC_ADDRHI", 0600, parent, (u32 *)0xFFC03008);
		debugfs_create_x32("EMAC_ADDRLO", 0600, parent, (u32 *)0xFFC03004);
		debugfs_create_x32("EMAC_FLC", 0600, parent, (u32 *)0xFFC0301C);
		debugfs_create_x32("EMAC_HASHHI", 0600, parent, (u32 *)0xFFC03010);
		debugfs_create_x32("EMAC_HASHLO", 0600, parent, (u32 *)0xFFC0300C);
		debugfs_create_x32("EMAC_MMC_CTL", 0600, parent, (u32 *)0xFFC03080);
		debugfs_create_x32("EMAC_MMC_RIRQE", 0600, parent, (u32 *)0xFFC03088);
		debugfs_create_x32("EMAC_MMC_RIRQS", 0600, parent, (u32 *)0xFFC03084);
		debugfs_create_x32("EMAC_MMC_TIRQE", 0600, parent, (u32 *)0xFFC03090);
		debugfs_create_x32("EMAC_MMC_TIRQS", 0600, parent, (u32 *)0xFFC0308C);
		debugfs_create_x32("EMAC_OPMODE", 0600, parent, (u32 *)0xFFC03000);
		debugfs_create_x32("EMAC_RXC_ALIGN", 0600, parent, (u32 *)0xFFC03108);
		debugfs_create_x32("EMAC_RXC_ALLFRM", 0600, parent, (u32 *)0xFFC03138);
		debugfs_create_x32("EMAC_RXC_ALLOCT", 0600, parent, (u32 *)0xFFC0313C);
		debugfs_create_x32("EMAC_RXC_BROAD", 0600, parent, (u32 *)0xFFC0311C);
		debugfs_create_x32("EMAC_RXC_DMAOVF", 0600, parent, (u32 *)0xFFC03110);
		debugfs_create_x32("EMAC_RXC_EQ64", 0600, parent, (u32 *)0xFFC03148);
		debugfs_create_x32("EMAC_RXC_FCS", 0600, parent, (u32 *)0xFFC03104);
		debugfs_create_x32("EMAC_RXC_GE1024", 0600, parent, (u32 *)0xFFC0315C);
		debugfs_create_x32("EMAC_RXC_LNERRI", 0600, parent, (u32 *)0xFFC03120);
		debugfs_create_x32("EMAC_RXC_LNERRO", 0600, parent, (u32 *)0xFFC03124);
		debugfs_create_x32("EMAC_RXC_LONG", 0600, parent, (u32 *)0xFFC03128);
		debugfs_create_x32("EMAC_RXC_LT1024", 0600, parent, (u32 *)0xFFC03158);
		debugfs_create_x32("EMAC_RXC_LT128", 0600, parent, (u32 *)0xFFC0314C);
		debugfs_create_x32("EMAC_RXC_LT256", 0600, parent, (u32 *)0xFFC03150);
		debugfs_create_x32("EMAC_RXC_LT512", 0600, parent, (u32 *)0xFFC03154);
		debugfs_create_x32("EMAC_RXC_MACCTL", 0600, parent, (u32 *)0xFFC0312C);
		debugfs_create_x32("EMAC_RXC_MULTI", 0600, parent, (u32 *)0xFFC03118);
		debugfs_create_x32("EMAC_RXC_OCTET", 0600, parent, (u32 *)0xFFC0310C);
		debugfs_create_x32("EMAC_RXC_OK", 0600, parent, (u32 *)0xFFC03100);
		debugfs_create_x32("EMAC_RXC_OPCODE", 0600, parent, (u32 *)0xFFC03130);
		debugfs_create_x32("EMAC_RXC_PAUSE", 0600, parent, (u32 *)0xFFC03134);
		debugfs_create_x32("EMAC_RXC_SHORT", 0600, parent, (u32 *)0xFFC03144);
		debugfs_create_x32("EMAC_RXC_TYPED", 0600, parent, (u32 *)0xFFC03140);
		debugfs_create_x32("EMAC_RXC_UNICST", 0600, parent, (u32 *)0xFFC03114);
		debugfs_create_x32("EMAC_RX_IRQE", 0600, parent, (u32 *)0xFFC03070);
		debugfs_create_x32("EMAC_RX_STAT", 0600, parent, (u32 *)0xFFC03068);
		debugfs_create_x32("EMAC_RX_STKY", 0600, parent, (u32 *)0xFFC0306C);
		debugfs_create_x32("EMAC_STAADD", 0600, parent, (u32 *)0xFFC03014);
		debugfs_create_x32("EMAC_STADAT", 0600, parent, (u32 *)0xFFC03018);
		debugfs_create_x32("EMAC_SYSCTL", 0600, parent, (u32 *)0xFFC03060);
		debugfs_create_x32("EMAC_SYSTAT", 0600, parent, (u32 *)0xFFC03064);
		debugfs_create_x32("EMAC_TXC_1COL", 0600, parent, (u32 *)0xFFC03184);
		debugfs_create_x32("EMAC_TXC_ABORT", 0600, parent, (u32 *)0xFFC031D8);
		debugfs_create_x32("EMAC_TXC_ALLFRM", 0600, parent, (u32 *)0xFFC031B8);
		debugfs_create_x32("EMAC_TXC_ALLOCT", 0600, parent, (u32 *)0xFFC031BC);
		debugfs_create_x32("EMAC_TXC_BROAD", 0600, parent, (u32 *)0xFFC031AC);
		debugfs_create_x32("EMAC_TXC_CRSERR", 0600, parent, (u32 *)0xFFC031A0);
		debugfs_create_x32("EMAC_TXC_DEFER", 0600, parent, (u32 *)0xFFC03190);
		debugfs_create_x32("EMAC_TXC_DMAUND", 0600, parent, (u32 *)0xFFC0319C);
		debugfs_create_x32("EMAC_TXC_EQ64", 0600, parent, (u32 *)0xFFC031C0);
		debugfs_create_x32("EMAC_TXC_GE1024", 0600, parent, (u32 *)0xFFC031D4);
		debugfs_create_x32("EMAC_TXC_GT1COL", 0600, parent, (u32 *)0xFFC03188);
		debugfs_create_x32("EMAC_TXC_LATECL", 0600, parent, (u32 *)0xFFC03194);
		debugfs_create_x32("EMAC_TXC_LT1024", 0600, parent, (u32 *)0xFFC031D0);
		debugfs_create_x32("EMAC_TXC_LT128", 0600, parent, (u32 *)0xFFC031C4);
		debugfs_create_x32("EMAC_TXC_LT256", 0600, parent, (u32 *)0xFFC031C8);
		debugfs_create_x32("EMAC_TXC_LT512", 0600, parent, (u32 *)0xFFC031CC);
		debugfs_create_x32("EMAC_TXC_MACCTL", 0600, parent, (u32 *)0xFFC031B4);
		debugfs_create_x32("EMAC_TXC_MULTI", 0600, parent, (u32 *)0xFFC031A8);
		debugfs_create_x32("EMAC_TXC_OCTET", 0600, parent, (u32 *)0xFFC0318C);
		debugfs_create_x32("EMAC_TXC_OK", 0600, parent, (u32 *)0xFFC03180);
		debugfs_create_x32("EMAC_TXC_UNICST", 0600, parent, (u32 *)0xFFC031A4);
		debugfs_create_x32("EMAC_TXC_XS_COL", 0600, parent, (u32 *)0xFFC03198);
		debugfs_create_x32("EMAC_TXC_XS_DFR", 0600, parent, (u32 *)0xFFC031B0);
		debugfs_create_x32("EMAC_TX_IRQE", 0600, parent, (u32 *)0xFFC0307C);
		debugfs_create_x32("EMAC_TX_STAT", 0600, parent, (u32 *)0xFFC03074);
		debugfs_create_x32("EMAC_TX_STKY", 0600, parent, (u32 *)0xFFC03078);
		debugfs_create_x32("EMAC_VLAN1", 0600, parent, (u32 *)0xFFC03020);
		debugfs_create_x32("EMAC_VLAN2", 0600, parent, (u32 *)0xFFC03024);
		debugfs_create_x32("EMAC_WKUP_CTL", 0600, parent, (u32 *)0xFFC0302C);
		debugfs_create_x32("EMAC_WKUP_FFCMD", 0600, parent, (u32 *)0xFFC03040);
		debugfs_create_x32("EMAC_WKUP_FFCRC0", 0600, parent, (u32 *)0xFFC03048);
		debugfs_create_x32("EMAC_WKUP_FFCRC1", 0600, parent, (u32 *)0xFFC0304C);
		debugfs_create_x32("EMAC_WKUP_FFMSK0", 0600, parent, (u32 *)0xFFC03030);
		debugfs_create_x32("EMAC_WKUP_FFMSK1", 0600, parent, (u32 *)0xFFC03034);
		debugfs_create_x32("EMAC_WKUP_FFMSK2", 0600, parent, (u32 *)0xFFC03038);
		debugfs_create_x32("EMAC_WKUP_FFMSK3", 0600, parent, (u32 *)0xFFC0303C);
		debugfs_create_x32("EMAC_WKUP_FFOFF", 0600, parent, (u32 *)0xFFC03044);

		parent = debugfs_create_dir("Event Vectors", top);
		debugfs_create_x32("EVT0", 0600, parent, (u32 *)0xFFE02000);
		debugfs_create_x32("EVT10", 0600, parent, (u32 *)0xFFE02028);
		debugfs_create_x32("EVT11", 0600, parent, (u32 *)0xFFE0202C);
		debugfs_create_x32("EVT12", 0600, parent, (u32 *)0xFFE02030);
		debugfs_create_x32("EVT13", 0600, parent, (u32 *)0xFFE02034);
		debugfs_create_x32("EVT14", 0600, parent, (u32 *)0xFFE02038);
		debugfs_create_x32("EVT15", 0600, parent, (u32 *)0xFFE0203C);
		debugfs_create_x32("EVT1", 0600, parent, (u32 *)0xFFE02004);
		debugfs_create_x32("EVT2", 0600, parent, (u32 *)0xFFE02008);
		debugfs_create_x32("EVT3", 0600, parent, (u32 *)0xFFE0200C);
		debugfs_create_x32("EVT4", 0600, parent, (u32 *)0xFFE02010);
		debugfs_create_x32("EVT5", 0600, parent, (u32 *)0xFFE02014);
		debugfs_create_x32("EVT6", 0600, parent, (u32 *)0xFFE02018);
		debugfs_create_x32("EVT7", 0600, parent, (u32 *)0xFFE0201C);
		debugfs_create_x32("EVT8", 0600, parent, (u32 *)0xFFE02020);
		debugfs_create_x32("EVT9", 0600, parent, (u32 *)0xFFE02024);

		parent = debugfs_create_dir("Extended Registers", top);
		debugfs_create_x32("CHIPID", 0600, parent, (u32 *)0xFFC00014);
		debugfs_create_x32("DSPID", 0600, parent, (u32 *)0xFFE05000);

		parent = debugfs_create_dir("Handshake MDMA", top);
		debugfs_create_x16("HMDMA0_BCINIT", 0600, parent, (u16 *)0xFFC03308);
		debugfs_create_x16("HMDMA0_BCOUNT", 0600, parent, (u16 *)0xFFC03318);
		debugfs_create_x16("HMDMA0_CONTROL", 0600, parent, (u16 *)0xFFC03300);
		debugfs_create_x16("HMDMA0_ECINIT", 0600, parent, (u16 *)0xFFC03304);
		debugfs_create_x16("HMDMA0_ECOUNT", 0600, parent, (u16 *)0xFFC03314);
		debugfs_create_x16("HMDMA0_ECOVERFLOW", 0600, parent, (u16 *)0xFFC03310);
		debugfs_create_x16("HMDMA0_ECURGENT", 0600, parent, (u16 *)0xFFC0330C);
		debugfs_create_x16("HMDMA1_BCINIT", 0600, parent, (u16 *)0xFFC03348);
		debugfs_create_x16("HMDMA1_BCOUNT", 0600, parent, (u16 *)0xFFC03358);
		debugfs_create_x16("HMDMA1_CONTROL", 0600, parent, (u16 *)0xFFC03340);
		debugfs_create_x16("HMDMA1_ECINIT", 0600, parent, (u16 *)0xFFC03344);
		debugfs_create_x16("HMDMA1_ECOUNT", 0600, parent, (u16 *)0xFFC03354);
		debugfs_create_x16("HMDMA1_ECOVERFLOW", 0600, parent, (u16 *)0xFFC03350);
		debugfs_create_x16("HMDMA1_ECURGENT", 0600, parent, (u16 *)0xFFC0334C);

		parent = debugfs_create_dir("Interrupt Controller", top);
		debugfs_create_x32("ILAT", 0600, parent, (u32 *)0xFFE0210C);
		debugfs_create_x32("IMASK", 0600, parent, (u32 *)0xFFE02104);
		debugfs_create_x32("IPEND", 0600, parent, (u32 *)0xFFE02108);
		debugfs_create_x32("IPRIO", 0600, parent, (u32 *)0xFFE02110);

		parent = debugfs_create_dir("L1 Code Memory Registers", top);
		debugfs_create_x32("ICPLB_ADDR0", 0600, parent, (u32 *)0xFFE01100);
		debugfs_create_x32("ICPLB_ADDR10", 0600, parent, (u32 *)0xFFE01128);
		debugfs_create_x32("ICPLB_ADDR11", 0600, parent, (u32 *)0xFFE0112C);
		debugfs_create_x32("ICPLB_ADDR12", 0600, parent, (u32 *)0xFFE01130);
		debugfs_create_x32("ICPLB_ADDR13", 0600, parent, (u32 *)0xFFE01134);
		debugfs_create_x32("ICPLB_ADDR14", 0600, parent, (u32 *)0xFFE01138);
		debugfs_create_x32("ICPLB_ADDR15", 0600, parent, (u32 *)0xFFE0113C);
		debugfs_create_x32("ICPLB_ADDR1", 0600, parent, (u32 *)0xFFE01104);
		debugfs_create_x32("ICPLB_ADDR2", 0600, parent, (u32 *)0xFFE01108);
		debugfs_create_x32("ICPLB_ADDR3", 0600, parent, (u32 *)0xFFE0110C);
		debugfs_create_x32("ICPLB_ADDR4", 0600, parent, (u32 *)0xFFE01110);
		debugfs_create_x32("ICPLB_ADDR5", 0600, parent, (u32 *)0xFFE01114);
		debugfs_create_x32("ICPLB_ADDR6", 0600, parent, (u32 *)0xFFE01118);
		debugfs_create_x32("ICPLB_ADDR7", 0600, parent, (u32 *)0xFFE0111C);
		debugfs_create_x32("ICPLB_ADDR8", 0600, parent, (u32 *)0xFFE01120);
		debugfs_create_x32("ICPLB_ADDR9", 0600, parent, (u32 *)0xFFE01124);
		debugfs_create_x32("ICPLB_DATA0", 0600, parent, (u32 *)0xFFE01200);
		debugfs_create_x32("ICPLB_DATA10", 0600, parent, (u32 *)0xFFE01228);
		debugfs_create_x32("ICPLB_DATA11", 0600, parent, (u32 *)0xFFE0122C);
		debugfs_create_x32("ICPLB_DATA12", 0600, parent, (u32 *)0xFFE01230);
		debugfs_create_x32("ICPLB_DATA13", 0600, parent, (u32 *)0xFFE01234);
		debugfs_create_x32("ICPLB_DATA14", 0600, parent, (u32 *)0xFFE01238);
		debugfs_create_x32("ICPLB_DATA15", 0600, parent, (u32 *)0xFFE0123C);
		debugfs_create_x32("ICPLB_DATA1", 0600, parent, (u32 *)0xFFE01204);
		debugfs_create_x32("ICPLB_DATA2", 0600, parent, (u32 *)0xFFE01208);
		debugfs_create_x32("ICPLB_DATA3", 0600, parent, (u32 *)0xFFE0120C);
		debugfs_create_x32("ICPLB_DATA4", 0600, parent, (u32 *)0xFFE01210);
		debugfs_create_x32("ICPLB_DATA5", 0600, parent, (u32 *)0xFFE01214);
		debugfs_create_x32("ICPLB_DATA6", 0600, parent, (u32 *)0xFFE01218);
		debugfs_create_x32("ICPLB_DATA7", 0600, parent, (u32 *)0xFFE0121C);
		debugfs_create_x32("ICPLB_DATA8", 0600, parent, (u32 *)0xFFE01220);
		debugfs_create_x32("ICPLB_DATA9", 0600, parent, (u32 *)0xFFE01224);
		debugfs_create_x32("ICPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0100C);
		debugfs_create_x32("ICPLB_STATUS", 0600, parent, (u32 *)0xFFE01008);
		debugfs_create_x32("IMEM_CONTROL", 0600, parent, (u32 *)0xFFE01004);
		debugfs_create_x32("ITEST_COMMAND", 0600, parent, (u32 *)0xFFE01300);
		debugfs_create_x32("ITEST_DATA0", 0600, parent, (u32 *)0xFFE01400);
		debugfs_create_x32("ITEST_DATA1", 0600, parent, (u32 *)0xFFE01404);

		parent = debugfs_create_dir("L1 Data Memory Registers", top);
		debugfs_create_x32("DCPLB_ADDR0", 0600, parent, (u32 *)0xFFE00100);
		debugfs_create_x32("DCPLB_ADDR10", 0600, parent, (u32 *)0xFFE00128);
		debugfs_create_x32("DCPLB_ADDR11", 0600, parent, (u32 *)0xFFE0012C);
		debugfs_create_x32("DCPLB_ADDR12", 0600, parent, (u32 *)0xFFE00130);
		debugfs_create_x32("DCPLB_ADDR13", 0600, parent, (u32 *)0xFFE00134);
		debugfs_create_x32("DCPLB_ADDR14", 0600, parent, (u32 *)0xFFE00138);
		debugfs_create_x32("DCPLB_ADDR15", 0600, parent, (u32 *)0xFFE0013C);
		debugfs_create_x32("DCPLB_ADDR1", 0600, parent, (u32 *)0xFFE00104);
		debugfs_create_x32("DCPLB_ADDR2", 0600, parent, (u32 *)0xFFE00108);
		debugfs_create_x32("DCPLB_ADDR3", 0600, parent, (u32 *)0xFFE0010C);
		debugfs_create_x32("DCPLB_ADDR4", 0600, parent, (u32 *)0xFFE00110);
		debugfs_create_x32("DCPLB_ADDR5", 0600, parent, (u32 *)0xFFE00114);
		debugfs_create_x32("DCPLB_ADDR6", 0600, parent, (u32 *)0xFFE00118);
		debugfs_create_x32("DCPLB_ADDR7", 0600, parent, (u32 *)0xFFE0011C);
		debugfs_create_x32("DCPLB_ADDR8", 0600, parent, (u32 *)0xFFE00120);
		debugfs_create_x32("DCPLB_ADDR9", 0600, parent, (u32 *)0xFFE00124);
		debugfs_create_x32("DCPLB_DATA0", 0600, parent, (u32 *)0xFFE00200);
		debugfs_create_x32("DCPLB_DATA10", 0600, parent, (u32 *)0xFFE00228);
		debugfs_create_x32("DCPLB_DATA11", 0600, parent, (u32 *)0xFFE0022C);
		debugfs_create_x32("DCPLB_DATA12", 0600, parent, (u32 *)0xFFE00230);
		debugfs_create_x32("DCPLB_DATA13", 0600, parent, (u32 *)0xFFE00234);
		debugfs_create_x32("DCPLB_DATA14", 0600, parent, (u32 *)0xFFE00238);
		debugfs_create_x32("DCPLB_DATA15", 0600, parent, (u32 *)0xFFE0023C);
		debugfs_create_x32("DCPLB_DATA1", 0600, parent, (u32 *)0xFFE00204);
		debugfs_create_x32("DCPLB_DATA2", 0600, parent, (u32 *)0xFFE00208);
		debugfs_create_x32("DCPLB_DATA3", 0600, parent, (u32 *)0xFFE0020C);
		debugfs_create_x32("DCPLB_DATA4", 0600, parent, (u32 *)0xFFE00210);
		debugfs_create_x32("DCPLB_DATA5", 0600, parent, (u32 *)0xFFE00214);
		debugfs_create_x32("DCPLB_DATA6", 0600, parent, (u32 *)0xFFE00218);
		debugfs_create_x32("DCPLB_DATA7", 0600, parent, (u32 *)0xFFE0021C);
		debugfs_create_x32("DCPLB_DATA8", 0600, parent, (u32 *)0xFFE00220);
		debugfs_create_x32("DCPLB_DATA9", 0600, parent, (u32 *)0xFFE00224);
		debugfs_create_x32("DCPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0000C);
		debugfs_create_x32("DMEM_CONTROL", 0600, parent, (u32 *)0xFFE00004);
		debugfs_create_x32("DTEST_COMMAND", 0600, parent, (u32 *)0xFFE00300);
		debugfs_create_x32("DTEST_DATA0", 0600, parent, (u32 *)0xFFE00400);
		debugfs_create_x32("DTEST_DATA1", 0600, parent, (u32 *)0xFFE00404);
		debugfs_create_x32("SRAM_BASE_ADDR", 0600, parent, (u32 *)0xFFE00000);

		parent = debugfs_create_dir("MDMA Destination 0", top);
		debugfs_create_x16("MDMA_D0_CONFIG", 0600, parent, (u16 *)0xFFC00F08);
		debugfs_create_x32("MDMA_D0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F24);
		debugfs_create_x32("MDMA_D0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F20);
		debugfs_create_x16("MDMA_D0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F30);
		debugfs_create_x16("MDMA_D0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F38);
		debugfs_create_x16("MDMA_D0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F28);
		debugfs_create_x32("MDMA_D0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F00);
		debugfs_create_x16("MDMA_D0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F2C);
		debugfs_create_x32("MDMA_D0_START_ADDR", 0600, parent, (u32 *)0xFFC00F04);
		debugfs_create_x16("MDMA_D0_X_COUNT", 0600, parent, (u16 *)0xFFC00F10);
		debugfs_create_x16("MDMA_D0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F14);
		debugfs_create_x16("MDMA_D0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F18);
		debugfs_create_x16("MDMA_D0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F1C);

		parent = debugfs_create_dir("MDMA Destination 1", top);
		debugfs_create_x16("MDMA_D1_CONFIG", 0600, parent, (u16 *)0xFFC00F88);
		debugfs_create_x32("MDMA_D1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FA4);
		debugfs_create_x32("MDMA_D1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FA0);
		debugfs_create_x16("MDMA_D1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FB0);
		debugfs_create_x16("MDMA_D1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FB8);
		debugfs_create_x16("MDMA_D1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FA8);
		debugfs_create_x32("MDMA_D1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F80);
		debugfs_create_x16("MDMA_D1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FAC);
		debugfs_create_x32("MDMA_D1_START_ADDR", 0600, parent, (u32 *)0xFFC00F84);
		debugfs_create_x16("MDMA_D1_X_COUNT", 0600, parent, (u16 *)0xFFC00F90);
		debugfs_create_x16("MDMA_D1_X_MODIFY", 0600, parent, (u16 *)0xFFC00F94);
		debugfs_create_x16("MDMA_D1_Y_COUNT", 0600, parent, (u16 *)0xFFC00F98);
		debugfs_create_x16("MDMA_D1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F9C);

		parent = debugfs_create_dir("MDMA Source 0", top);
		debugfs_create_x16("MDMA_S0_CONFIG", 0600, parent, (u16 *)0xFFC00F48);
		debugfs_create_x32("MDMA_S0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F64);
		debugfs_create_x32("MDMA_S0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F60);
		debugfs_create_x16("MDMA_S0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F70);
		debugfs_create_x16("MDMA_S0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F78);
		debugfs_create_x16("MDMA_S0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F68);
		debugfs_create_x32("MDMA_S0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F40);
		debugfs_create_x16("MDMA_S0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F6C);
		debugfs_create_x32("MDMA_S0_START_ADDR", 0600, parent, (u32 *)0xFFC00F44);
		debugfs_create_x16("MDMA_S0_X_COUNT", 0600, parent, (u16 *)0xFFC00F50);
		debugfs_create_x16("MDMA_S0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F54);
		debugfs_create_x16("MDMA_S0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F58);
		debugfs_create_x16("MDMA_S0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F5C);

		parent = debugfs_create_dir("MDMA Source 1", top);
		debugfs_create_x16("MDMA_S1_CONFIG", 0600, parent, (u16 *)0xFFC00FC8);
		debugfs_create_x32("MDMA_S1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FE4);
		debugfs_create_x32("MDMA_S1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FE0);
		debugfs_create_x16("MDMA_S1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FF0);
		debugfs_create_x16("MDMA_S1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FF8);
		debugfs_create_x16("MDMA_S1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FE8);
		debugfs_create_x32("MDMA_S1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00FC0);
		debugfs_create_x16("MDMA_S1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FEC);
		debugfs_create_x32("MDMA_S1_START_ADDR", 0600, parent, (u32 *)0xFFC00FC4);
		debugfs_create_x16("MDMA_S1_X_COUNT", 0600, parent, (u16 *)0xFFC00FD0);
		debugfs_create_x16("MDMA_S1_X_MODIFY", 0600, parent, (u16 *)0xFFC00FD4);
		debugfs_create_x16("MDMA_S1_Y_COUNT", 0600, parent, (u16 *)0xFFC00FD8);
		debugfs_create_x16("MDMA_S1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00FDC);

		parent = debugfs_create_dir("Mailbox Registers", top);
		debugfs_create_x16("CAN_MB00_DATA0", 0600, parent, (u16 *)0xFFC02C00);
		debugfs_create_x16("CAN_MB00_DATA1", 0600, parent, (u16 *)0xFFC02C04);
		debugfs_create_x16("CAN_MB00_DATA2", 0600, parent, (u16 *)0xFFC02C08);
		debugfs_create_x16("CAN_MB00_DATA3", 0600, parent, (u16 *)0xFFC02C0C);
		debugfs_create_x16("CAN_MB00_ID0", 0600, parent, (u16 *)0xFFC02C18);
		debugfs_create_x16("CAN_MB00_ID1", 0600, parent, (u16 *)0xFFC02C1C);
		debugfs_create_x16("CAN_MB00_LENGTH", 0600, parent, (u16 *)0xFFC02C10);
		debugfs_create_x16("CAN_MB00_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C14);
		debugfs_create_x16("CAN_MB01_DATA0", 0600, parent, (u16 *)0xFFC02C20);
		debugfs_create_x16("CAN_MB01_DATA1", 0600, parent, (u16 *)0xFFC02C24);
		debugfs_create_x16("CAN_MB01_DATA2", 0600, parent, (u16 *)0xFFC02C28);
		debugfs_create_x16("CAN_MB01_DATA3", 0600, parent, (u16 *)0xFFC02C2C);
		debugfs_create_x16("CAN_MB01_ID0", 0600, parent, (u16 *)0xFFC02C38);
		debugfs_create_x16("CAN_MB01_ID1", 0600, parent, (u16 *)0xFFC02C3C);
		debugfs_create_x16("CAN_MB01_LENGTH", 0600, parent, (u16 *)0xFFC02C30);
		debugfs_create_x16("CAN_MB01_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C34);
		debugfs_create_x16("CAN_MB02_DATA0", 0600, parent, (u16 *)0xFFC02C40);
		debugfs_create_x16("CAN_MB02_DATA1", 0600, parent, (u16 *)0xFFC02C44);
		debugfs_create_x16("CAN_MB02_DATA2", 0600, parent, (u16 *)0xFFC02C48);
		debugfs_create_x16("CAN_MB02_DATA3", 0600, parent, (u16 *)0xFFC02C4C);
		debugfs_create_x16("CAN_MB02_ID0", 0600, parent, (u16 *)0xFFC02C58);
		debugfs_create_x16("CAN_MB02_ID1", 0600, parent, (u16 *)0xFFC02C5C);
		debugfs_create_x16("CAN_MB02_LENGTH", 0600, parent, (u16 *)0xFFC02C50);
		debugfs_create_x16("CAN_MB02_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C54);
		debugfs_create_x16("CAN_MB03_DATA0", 0600, parent, (u16 *)0xFFC02C60);
		debugfs_create_x16("CAN_MB03_DATA1", 0600, parent, (u16 *)0xFFC02C64);
		debugfs_create_x16("CAN_MB03_DATA2", 0600, parent, (u16 *)0xFFC02C68);
		debugfs_create_x16("CAN_MB03_DATA3", 0600, parent, (u16 *)0xFFC02C6C);
		debugfs_create_x16("CAN_MB03_ID0", 0600, parent, (u16 *)0xFFC02C78);
		debugfs_create_x16("CAN_MB03_ID1", 0600, parent, (u16 *)0xFFC02C7C);
		debugfs_create_x16("CAN_MB03_LENGTH", 0600, parent, (u16 *)0xFFC02C70);
		debugfs_create_x16("CAN_MB03_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C74);
		debugfs_create_x16("CAN_MB04_DATA0", 0600, parent, (u16 *)0xFFC02C80);
		debugfs_create_x16("CAN_MB04_DATA1", 0600, parent, (u16 *)0xFFC02C84);
		debugfs_create_x16("CAN_MB04_DATA2", 0600, parent, (u16 *)0xFFC02C88);
		debugfs_create_x16("CAN_MB04_DATA3", 0600, parent, (u16 *)0xFFC02C8C);
		debugfs_create_x16("CAN_MB04_ID0", 0600, parent, (u16 *)0xFFC02C98);
		debugfs_create_x16("CAN_MB04_ID1", 0600, parent, (u16 *)0xFFC02C9C);
		debugfs_create_x16("CAN_MB04_LENGTH", 0600, parent, (u16 *)0xFFC02C90);
		debugfs_create_x16("CAN_MB04_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C94);
		debugfs_create_x16("CAN_MB05_DATA0", 0600, parent, (u16 *)0xFFC02CA0);
		debugfs_create_x16("CAN_MB05_DATA1", 0600, parent, (u16 *)0xFFC02CA4);
		debugfs_create_x16("CAN_MB05_DATA2", 0600, parent, (u16 *)0xFFC02CA8);
		debugfs_create_x16("CAN_MB05_DATA3", 0600, parent, (u16 *)0xFFC02CAC);
		debugfs_create_x16("CAN_MB05_ID0", 0600, parent, (u16 *)0xFFC02CB8);
		debugfs_create_x16("CAN_MB05_ID1", 0600, parent, (u16 *)0xFFC02CBC);
		debugfs_create_x16("CAN_MB05_LENGTH", 0600, parent, (u16 *)0xFFC02CB0);
		debugfs_create_x16("CAN_MB05_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CB4);
		debugfs_create_x16("CAN_MB06_DATA0", 0600, parent, (u16 *)0xFFC02CC0);
		debugfs_create_x16("CAN_MB06_DATA1", 0600, parent, (u16 *)0xFFC02CC4);
		debugfs_create_x16("CAN_MB06_DATA2", 0600, parent, (u16 *)0xFFC02CC8);
		debugfs_create_x16("CAN_MB06_DATA3", 0600, parent, (u16 *)0xFFC02CCC);
		debugfs_create_x16("CAN_MB06_ID0", 0600, parent, (u16 *)0xFFC02CD8);
		debugfs_create_x16("CAN_MB06_ID1", 0600, parent, (u16 *)0xFFC02CDC);
		debugfs_create_x16("CAN_MB06_LENGTH", 0600, parent, (u16 *)0xFFC02CD0);
		debugfs_create_x16("CAN_MB06_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CD4);
		debugfs_create_x16("CAN_MB07_DATA0", 0600, parent, (u16 *)0xFFC02CE0);
		debugfs_create_x16("CAN_MB07_DATA1", 0600, parent, (u16 *)0xFFC02CE4);
		debugfs_create_x16("CAN_MB07_DATA2", 0600, parent, (u16 *)0xFFC02CE8);
		debugfs_create_x16("CAN_MB07_DATA3", 0600, parent, (u16 *)0xFFC02CEC);
		debugfs_create_x16("CAN_MB07_ID0", 0600, parent, (u16 *)0xFFC02CF8);
		debugfs_create_x16("CAN_MB07_ID1", 0600, parent, (u16 *)0xFFC02CFC);
		debugfs_create_x16("CAN_MB07_LENGTH", 0600, parent, (u16 *)0xFFC02CF0);
		debugfs_create_x16("CAN_MB07_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CF4);
		debugfs_create_x16("CAN_MB08_DATA0", 0600, parent, (u16 *)0xFFC02D00);
		debugfs_create_x16("CAN_MB08_DATA1", 0600, parent, (u16 *)0xFFC02D04);
		debugfs_create_x16("CAN_MB08_DATA2", 0600, parent, (u16 *)0xFFC02D08);
		debugfs_create_x16("CAN_MB08_DATA3", 0600, parent, (u16 *)0xFFC02D0C);
		debugfs_create_x16("CAN_MB08_ID0", 0600, parent, (u16 *)0xFFC02D18);
		debugfs_create_x16("CAN_MB08_ID1", 0600, parent, (u16 *)0xFFC02D1C);
		debugfs_create_x16("CAN_MB08_LENGTH", 0600, parent, (u16 *)0xFFC02D10);
		debugfs_create_x16("CAN_MB08_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D14);
		debugfs_create_x16("CAN_MB09_DATA0", 0600, parent, (u16 *)0xFFC02D20);
		debugfs_create_x16("CAN_MB09_DATA1", 0600, parent, (u16 *)0xFFC02D24);
		debugfs_create_x16("CAN_MB09_DATA2", 0600, parent, (u16 *)0xFFC02D28);
		debugfs_create_x16("CAN_MB09_DATA3", 0600, parent, (u16 *)0xFFC02D2C);
		debugfs_create_x16("CAN_MB09_ID0", 0600, parent, (u16 *)0xFFC02D38);
		debugfs_create_x16("CAN_MB09_ID1", 0600, parent, (u16 *)0xFFC02D3C);
		debugfs_create_x16("CAN_MB09_LENGTH", 0600, parent, (u16 *)0xFFC02D30);
		debugfs_create_x16("CAN_MB09_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D34);
		debugfs_create_x16("CAN_MB10_DATA0", 0600, parent, (u16 *)0xFFC02D40);
		debugfs_create_x16("CAN_MB10_DATA1", 0600, parent, (u16 *)0xFFC02D44);
		debugfs_create_x16("CAN_MB10_DATA2", 0600, parent, (u16 *)0xFFC02D48);
		debugfs_create_x16("CAN_MB10_DATA3", 0600, parent, (u16 *)0xFFC02D4C);
		debugfs_create_x16("CAN_MB10_ID0", 0600, parent, (u16 *)0xFFC02D58);
		debugfs_create_x16("CAN_MB10_ID1", 0600, parent, (u16 *)0xFFC02D5C);
		debugfs_create_x16("CAN_MB10_LENGTH", 0600, parent, (u16 *)0xFFC02D50);
		debugfs_create_x16("CAN_MB10_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D54);
		debugfs_create_x16("CAN_MB11_DATA0", 0600, parent, (u16 *)0xFFC02D60);
		debugfs_create_x16("CAN_MB11_DATA1", 0600, parent, (u16 *)0xFFC02D64);
		debugfs_create_x16("CAN_MB11_DATA2", 0600, parent, (u16 *)0xFFC02D68);
		debugfs_create_x16("CAN_MB11_DATA3", 0600, parent, (u16 *)0xFFC02D6C);
		debugfs_create_x16("CAN_MB11_ID0", 0600, parent, (u16 *)0xFFC02D78);
		debugfs_create_x16("CAN_MB11_ID1", 0600, parent, (u16 *)0xFFC02D7C);
		debugfs_create_x16("CAN_MB11_LENGTH", 0600, parent, (u16 *)0xFFC02D70);
		debugfs_create_x16("CAN_MB11_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D74);
		debugfs_create_x16("CAN_MB12_DATA0", 0600, parent, (u16 *)0xFFC02D80);
		debugfs_create_x16("CAN_MB12_DATA1", 0600, parent, (u16 *)0xFFC02D84);
		debugfs_create_x16("CAN_MB12_DATA2", 0600, parent, (u16 *)0xFFC02D88);
		debugfs_create_x16("CAN_MB12_DATA3", 0600, parent, (u16 *)0xFFC02D8C);
		debugfs_create_x16("CAN_MB12_ID0", 0600, parent, (u16 *)0xFFC02D98);
		debugfs_create_x16("CAN_MB12_ID1", 0600, parent, (u16 *)0xFFC02D9C);
		debugfs_create_x16("CAN_MB12_LENGTH", 0600, parent, (u16 *)0xFFC02D90);
		debugfs_create_x16("CAN_MB12_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D94);
		debugfs_create_x16("CAN_MB13_DATA0", 0600, parent, (u16 *)0xFFC02DA0);
		debugfs_create_x16("CAN_MB13_DATA1", 0600, parent, (u16 *)0xFFC02DA4);
		debugfs_create_x16("CAN_MB13_DATA2", 0600, parent, (u16 *)0xFFC02DA8);
		debugfs_create_x16("CAN_MB13_DATA3", 0600, parent, (u16 *)0xFFC02DAC);
		debugfs_create_x16("CAN_MB13_ID0", 0600, parent, (u16 *)0xFFC02DB8);
		debugfs_create_x16("CAN_MB13_ID1", 0600, parent, (u16 *)0xFFC02DBC);
		debugfs_create_x16("CAN_MB13_LENGTH", 0600, parent, (u16 *)0xFFC02DB0);
		debugfs_create_x16("CAN_MB13_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DB4);
		debugfs_create_x16("CAN_MB14_DATA0", 0600, parent, (u16 *)0xFFC02DC0);
		debugfs_create_x16("CAN_MB14_DATA1", 0600, parent, (u16 *)0xFFC02DC4);
		debugfs_create_x16("CAN_MB14_DATA2", 0600, parent, (u16 *)0xFFC02DC8);
		debugfs_create_x16("CAN_MB14_DATA3", 0600, parent, (u16 *)0xFFC02DCC);
		debugfs_create_x16("CAN_MB14_ID0", 0600, parent, (u16 *)0xFFC02DD8);
		debugfs_create_x16("CAN_MB14_ID1", 0600, parent, (u16 *)0xFFC02DDC);
		debugfs_create_x16("CAN_MB14_LENGTH", 0600, parent, (u16 *)0xFFC02DD0);
		debugfs_create_x16("CAN_MB14_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DD4);
		debugfs_create_x16("CAN_MB15_DATA0", 0600, parent, (u16 *)0xFFC02DE0);
		debugfs_create_x16("CAN_MB15_DATA1", 0600, parent, (u16 *)0xFFC02DE4);
		debugfs_create_x16("CAN_MB15_DATA2", 0600, parent, (u16 *)0xFFC02DE8);
		debugfs_create_x16("CAN_MB15_DATA3", 0600, parent, (u16 *)0xFFC02DEC);
		debugfs_create_x16("CAN_MB15_ID0", 0600, parent, (u16 *)0xFFC02DF8);
		debugfs_create_x16("CAN_MB15_ID1", 0600, parent, (u16 *)0xFFC02DFC);
		debugfs_create_x16("CAN_MB15_LENGTH", 0600, parent, (u16 *)0xFFC02DF0);
		debugfs_create_x16("CAN_MB15_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DF4);
		debugfs_create_x16("CAN_MB16_DATA0", 0600, parent, (u16 *)0xFFC02E00);
		debugfs_create_x16("CAN_MB16_DATA1", 0600, parent, (u16 *)0xFFC02E04);
		debugfs_create_x16("CAN_MB16_DATA2", 0600, parent, (u16 *)0xFFC02E08);
		debugfs_create_x16("CAN_MB16_DATA3", 0600, parent, (u16 *)0xFFC02E0C);
		debugfs_create_x16("CAN_MB16_ID0", 0600, parent, (u16 *)0xFFC02E18);
		debugfs_create_x16("CAN_MB16_ID1", 0600, parent, (u16 *)0xFFC02E1C);
		debugfs_create_x16("CAN_MB16_LENGTH", 0600, parent, (u16 *)0xFFC02E10);
		debugfs_create_x16("CAN_MB16_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E14);
		debugfs_create_x16("CAN_MB17_DATA0", 0600, parent, (u16 *)0xFFC02E20);
		debugfs_create_x16("CAN_MB17_DATA1", 0600, parent, (u16 *)0xFFC02E24);
		debugfs_create_x16("CAN_MB17_DATA2", 0600, parent, (u16 *)0xFFC02E28);
		debugfs_create_x16("CAN_MB17_DATA3", 0600, parent, (u16 *)0xFFC02E2C);
		debugfs_create_x16("CAN_MB17_ID0", 0600, parent, (u16 *)0xFFC02E38);
		debugfs_create_x16("CAN_MB17_ID1", 0600, parent, (u16 *)0xFFC02E3C);
		debugfs_create_x16("CAN_MB17_LENGTH", 0600, parent, (u16 *)0xFFC02E30);
		debugfs_create_x16("CAN_MB17_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E34);
		debugfs_create_x16("CAN_MB18_DATA0", 0600, parent, (u16 *)0xFFC02E40);
		debugfs_create_x16("CAN_MB18_DATA1", 0600, parent, (u16 *)0xFFC02E44);
		debugfs_create_x16("CAN_MB18_DATA2", 0600, parent, (u16 *)0xFFC02E48);
		debugfs_create_x16("CAN_MB18_DATA3", 0600, parent, (u16 *)0xFFC02E4C);
		debugfs_create_x16("CAN_MB18_ID0", 0600, parent, (u16 *)0xFFC02E58);
		debugfs_create_x16("CAN_MB18_ID1", 0600, parent, (u16 *)0xFFC02E5C);
		debugfs_create_x16("CAN_MB18_LENGTH", 0600, parent, (u16 *)0xFFC02E50);
		debugfs_create_x16("CAN_MB18_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E54);
		debugfs_create_x16("CAN_MB19_DATA0", 0600, parent, (u16 *)0xFFC02E60);
		debugfs_create_x16("CAN_MB19_DATA1", 0600, parent, (u16 *)0xFFC02E64);
		debugfs_create_x16("CAN_MB19_DATA2", 0600, parent, (u16 *)0xFFC02E68);
		debugfs_create_x16("CAN_MB19_DATA3", 0600, parent, (u16 *)0xFFC02E6C);
		debugfs_create_x16("CAN_MB19_ID0", 0600, parent, (u16 *)0xFFC02E78);
		debugfs_create_x16("CAN_MB19_ID1", 0600, parent, (u16 *)0xFFC02E7C);
		debugfs_create_x16("CAN_MB19_LENGTH", 0600, parent, (u16 *)0xFFC02E70);
		debugfs_create_x16("CAN_MB19_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E74);
		debugfs_create_x16("CAN_MB20_DATA0", 0600, parent, (u16 *)0xFFC02E80);
		debugfs_create_x16("CAN_MB20_DATA1", 0600, parent, (u16 *)0xFFC02E84);
		debugfs_create_x16("CAN_MB20_DATA2", 0600, parent, (u16 *)0xFFC02E88);
		debugfs_create_x16("CAN_MB20_DATA3", 0600, parent, (u16 *)0xFFC02E8C);
		debugfs_create_x16("CAN_MB20_ID0", 0600, parent, (u16 *)0xFFC02E98);
		debugfs_create_x16("CAN_MB20_ID1", 0600, parent, (u16 *)0xFFC02E9C);
		debugfs_create_x16("CAN_MB20_LENGTH", 0600, parent, (u16 *)0xFFC02E90);
		debugfs_create_x16("CAN_MB20_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E94);
		debugfs_create_x16("CAN_MB21_DATA0", 0600, parent, (u16 *)0xFFC02EA0);
		debugfs_create_x16("CAN_MB21_DATA1", 0600, parent, (u16 *)0xFFC02EA4);
		debugfs_create_x16("CAN_MB21_DATA2", 0600, parent, (u16 *)0xFFC02EA8);
		debugfs_create_x16("CAN_MB21_DATA3", 0600, parent, (u16 *)0xFFC02EAC);
		debugfs_create_x16("CAN_MB21_ID0", 0600, parent, (u16 *)0xFFC02EB8);
		debugfs_create_x16("CAN_MB21_ID1", 0600, parent, (u16 *)0xFFC02EBC);
		debugfs_create_x16("CAN_MB21_LENGTH", 0600, parent, (u16 *)0xFFC02EB0);
		debugfs_create_x16("CAN_MB21_TIMESTAMP", 0600, parent, (u16 *)0xFFC02EB4);
		debugfs_create_x16("CAN_MB22_DATA0", 0600, parent, (u16 *)0xFFC02EC0);
		debugfs_create_x16("CAN_MB22_DATA1", 0600, parent, (u16 *)0xFFC02EC4);
		debugfs_create_x16("CAN_MB22_DATA2", 0600, parent, (u16 *)0xFFC02EC8);
		debugfs_create_x16("CAN_MB22_DATA3", 0600, parent, (u16 *)0xFFC02ECC);
		debugfs_create_x16("CAN_MB22_ID0", 0600, parent, (u16 *)0xFFC02ED8);
		debugfs_create_x16("CAN_MB22_ID1", 0600, parent, (u16 *)0xFFC02EDC);
		debugfs_create_x16("CAN_MB22_LENGTH", 0600, parent, (u16 *)0xFFC02ED0);
		debugfs_create_x16("CAN_MB22_TIMESTAMP", 0600, parent, (u16 *)0xFFC02ED4);
		debugfs_create_x16("CAN_MB23_DATA0", 0600, parent, (u16 *)0xFFC02EE0);
		debugfs_create_x16("CAN_MB23_DATA1", 0600, parent, (u16 *)0xFFC02EE4);
		debugfs_create_x16("CAN_MB23_DATA2", 0600, parent, (u16 *)0xFFC02EE8);
		debugfs_create_x16("CAN_MB23_DATA3", 0600, parent, (u16 *)0xFFC02EEC);
		debugfs_create_x16("CAN_MB23_ID0", 0600, parent, (u16 *)0xFFC02EF8);
		debugfs_create_x16("CAN_MB23_ID1", 0600, parent, (u16 *)0xFFC02EFC);
		debugfs_create_x16("CAN_MB23_LENGTH", 0600, parent, (u16 *)0xFFC02EF0);
		debugfs_create_x16("CAN_MB23_TIMESTAMP", 0600, parent, (u16 *)0xFFC02EF4);
		debugfs_create_x16("CAN_MB24_DATA0", 0600, parent, (u16 *)0xFFC02F00);
		debugfs_create_x16("CAN_MB24_DATA1", 0600, parent, (u16 *)0xFFC02F04);
		debugfs_create_x16("CAN_MB24_DATA2", 0600, parent, (u16 *)0xFFC02F08);
		debugfs_create_x16("CAN_MB24_DATA3", 0600, parent, (u16 *)0xFFC02F0C);
		debugfs_create_x16("CAN_MB24_ID0", 0600, parent, (u16 *)0xFFC02F18);
		debugfs_create_x16("CAN_MB24_ID1", 0600, parent, (u16 *)0xFFC02F1C);
		debugfs_create_x16("CAN_MB24_LENGTH", 0600, parent, (u16 *)0xFFC02F10);
		debugfs_create_x16("CAN_MB24_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F14);
		debugfs_create_x16("CAN_MB25_DATA0", 0600, parent, (u16 *)0xFFC02F20);
		debugfs_create_x16("CAN_MB25_DATA1", 0600, parent, (u16 *)0xFFC02F24);
		debugfs_create_x16("CAN_MB25_DATA2", 0600, parent, (u16 *)0xFFC02F28);
		debugfs_create_x16("CAN_MB25_DATA3", 0600, parent, (u16 *)0xFFC02F2C);
		debugfs_create_x16("CAN_MB25_ID0", 0600, parent, (u16 *)0xFFC02F38);
		debugfs_create_x16("CAN_MB25_ID1", 0600, parent, (u16 *)0xFFC02F3C);
		debugfs_create_x16("CAN_MB25_LENGTH", 0600, parent, (u16 *)0xFFC02F30);
		debugfs_create_x16("CAN_MB25_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F34);
		debugfs_create_x16("CAN_MB26_DATA0", 0600, parent, (u16 *)0xFFC02F40);
		debugfs_create_x16("CAN_MB26_DATA1", 0600, parent, (u16 *)0xFFC02F44);
		debugfs_create_x16("CAN_MB26_DATA2", 0600, parent, (u16 *)0xFFC02F48);
		debugfs_create_x16("CAN_MB26_DATA3", 0600, parent, (u16 *)0xFFC02F4C);
		debugfs_create_x16("CAN_MB26_ID0", 0600, parent, (u16 *)0xFFC02F58);
		debugfs_create_x16("CAN_MB26_ID1", 0600, parent, (u16 *)0xFFC02F5C);
		debugfs_create_x16("CAN_MB26_LENGTH", 0600, parent, (u16 *)0xFFC02F50);
		debugfs_create_x16("CAN_MB26_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F54);
		debugfs_create_x16("CAN_MB27_DATA0", 0600, parent, (u16 *)0xFFC02F60);
		debugfs_create_x16("CAN_MB27_DATA1", 0600, parent, (u16 *)0xFFC02F64);
		debugfs_create_x16("CAN_MB27_DATA2", 0600, parent, (u16 *)0xFFC02F68);
		debugfs_create_x16("CAN_MB27_DATA3", 0600, parent, (u16 *)0xFFC02F6C);
		debugfs_create_x16("CAN_MB27_ID0", 0600, parent, (u16 *)0xFFC02F78);
		debugfs_create_x16("CAN_MB27_ID1", 0600, parent, (u16 *)0xFFC02F7C);
		debugfs_create_x16("CAN_MB27_LENGTH", 0600, parent, (u16 *)0xFFC02F70);
		debugfs_create_x16("CAN_MB27_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F74);
		debugfs_create_x16("CAN_MB28_DATA0", 0600, parent, (u16 *)0xFFC02F80);
		debugfs_create_x16("CAN_MB28_DATA1", 0600, parent, (u16 *)0xFFC02F84);
		debugfs_create_x16("CAN_MB28_DATA2", 0600, parent, (u16 *)0xFFC02F88);
		debugfs_create_x16("CAN_MB28_DATA3", 0600, parent, (u16 *)0xFFC02F8C);
		debugfs_create_x16("CAN_MB28_ID0", 0600, parent, (u16 *)0xFFC02F98);
		debugfs_create_x16("CAN_MB28_ID1", 0600, parent, (u16 *)0xFFC02F9C);
		debugfs_create_x16("CAN_MB28_LENGTH", 0600, parent, (u16 *)0xFFC02F90);
		debugfs_create_x16("CAN_MB28_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F94);
		debugfs_create_x16("CAN_MB29_DATA0", 0600, parent, (u16 *)0xFFC02FA0);
		debugfs_create_x16("CAN_MB29_DATA1", 0600, parent, (u16 *)0xFFC02FA4);
		debugfs_create_x16("CAN_MB29_DATA2", 0600, parent, (u16 *)0xFFC02FA8);
		debugfs_create_x16("CAN_MB29_DATA3", 0600, parent, (u16 *)0xFFC02FAC);
		debugfs_create_x16("CAN_MB29_ID0", 0600, parent, (u16 *)0xFFC02FB8);
		debugfs_create_x16("CAN_MB29_ID1", 0600, parent, (u16 *)0xFFC02FBC);
		debugfs_create_x16("CAN_MB29_LENGTH", 0600, parent, (u16 *)0xFFC02FB0);
		debugfs_create_x16("CAN_MB29_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FB4);
		debugfs_create_x16("CAN_MB30_DATA0", 0600, parent, (u16 *)0xFFC02FC0);
		debugfs_create_x16("CAN_MB30_DATA1", 0600, parent, (u16 *)0xFFC02FC4);
		debugfs_create_x16("CAN_MB30_DATA2", 0600, parent, (u16 *)0xFFC02FC8);
		debugfs_create_x16("CAN_MB30_DATA3", 0600, parent, (u16 *)0xFFC02FCC);
		debugfs_create_x16("CAN_MB30_ID0", 0600, parent, (u16 *)0xFFC02FD8);
		debugfs_create_x16("CAN_MB30_ID1", 0600, parent, (u16 *)0xFFC02FDC);
		debugfs_create_x16("CAN_MB30_LENGTH", 0600, parent, (u16 *)0xFFC02FD0);
		debugfs_create_x16("CAN_MB30_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FD4);
		debugfs_create_x16("CAN_MB31_DATA0", 0600, parent, (u16 *)0xFFC02FE0);
		debugfs_create_x16("CAN_MB31_DATA1", 0600, parent, (u16 *)0xFFC02FE4);
		debugfs_create_x16("CAN_MB31_DATA2", 0600, parent, (u16 *)0xFFC02FE8);
		debugfs_create_x16("CAN_MB31_DATA3", 0600, parent, (u16 *)0xFFC02FEC);
		debugfs_create_x16("CAN_MB31_ID0", 0600, parent, (u16 *)0xFFC02FF8);
		debugfs_create_x16("CAN_MB31_ID1", 0600, parent, (u16 *)0xFFC02FFC);
		debugfs_create_x16("CAN_MB31_LENGTH", 0600, parent, (u16 *)0xFFC02FF0);
		debugfs_create_x16("CAN_MB31_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FF4);

		parent = debugfs_create_dir("PLL", top);
		debugfs_create_x16("PLL_CTL", 0600, parent, (u16 *)0xFFC00000);
		debugfs_create_x16("PLL_DIV", 0600, parent, (u16 *)0xFFC00004);
		debugfs_create_x16("PLL_LOCKCNT", 0600, parent, (u16 *)0xFFC00010);
		debugfs_create_x16("PLL_STAT", 0600, parent, (u16 *)0xFFC0000C);
		debugfs_create_x16("VR_CTL", 0600, parent, (u16 *)0xFFC00008);

		parent = debugfs_create_dir("PPI", top);
		debugfs_create_x16("PPI_CONTROL", 0600, parent, (u16 *)0xFFC01000);
		debugfs_create_x16("PPI_COUNT", 0600, parent, (u16 *)0xFFC01008);
		debugfs_create_x16("PPI_DELAY", 0600, parent, (u16 *)0xFFC0100C);
		debugfs_create_x16("PPI_FRAME", 0600, parent, (u16 *)0xFFC01010);
		debugfs_create_x16("PPI_STATUS", 0600, parent, (u16 *)0xFFC01004);

		parent = debugfs_create_dir("Performance Monitor", top);
		debugfs_create_x32("PFCNTR0", 0600, parent, (u32 *)0xFFE08100);
		debugfs_create_x32("PFCNTR1", 0600, parent, (u32 *)0xFFE08104);
		debugfs_create_x32("PFCTL", 0600, parent, (u32 *)0xFFE08000);

		parent = debugfs_create_dir("Pin Control", top);
		debugfs_create_x16("PORTF_FER", 0600, parent, (u16 *)0xFFC03200);
		debugfs_create_x16("PORTG_FER", 0600, parent, (u16 *)0xFFC03204);
		debugfs_create_x16("PORTH_FER", 0600, parent, (u16 *)0xFFC03208);
		debugfs_create_x16("PORT_MUX", 0600, parent, (u16 *)0xFFC0320C);

		parent = debugfs_create_dir("Port I-O", top);
		debugfs_create_x16("PORTFIO", 0600, parent, (u16 *)0xFFC00700);
		debugfs_create_x16("PORTFIO_BOTH", 0600, parent, (u16 *)0xFFC0073C);
		debugfs_create_x16("PORTFIO_CLEAR", 0600, parent, (u16 *)0xFFC00704);
		debugfs_create_x16("PORTFIO_DIR", 0600, parent, (u16 *)0xFFC00730);
		debugfs_create_x16("PORTFIO_EDGE", 0600, parent, (u16 *)0xFFC00738);
		debugfs_create_x16("PORTFIO_INEN", 0600, parent, (u16 *)0xFFC00740);
		debugfs_create_x16("PORTFIO_MASKA", 0600, parent, (u16 *)0xFFC00710);
		debugfs_create_x16("PORTFIO_MASKA_CLEAR", 0600, parent, (u16 *)0xFFC00714);
		debugfs_create_x16("PORTFIO_MASKA_SET", 0600, parent, (u16 *)0xFFC00718);
		debugfs_create_x16("PORTFIO_MASKA_TOGGLE", 0600, parent, (u16 *)0xFFC0071C);
		debugfs_create_x16("PORTFIO_MASKB", 0600, parent, (u16 *)0xFFC00720);
		debugfs_create_x16("PORTFIO_MASKB_CLEAR", 0600, parent, (u16 *)0xFFC00724);
		debugfs_create_x16("PORTFIO_MASKB_SET", 0600, parent, (u16 *)0xFFC00728);
		debugfs_create_x16("PORTFIO_MASKB_TOGGLE", 0600, parent, (u16 *)0xFFC0072C);
		debugfs_create_x16("PORTFIO_POLAR", 0600, parent, (u16 *)0xFFC00734);
		debugfs_create_x16("PORTFIO_SET", 0600, parent, (u16 *)0xFFC00708);
		debugfs_create_x16("PORTFIO_TOGGLE", 0600, parent, (u16 *)0xFFC0070C);
		debugfs_create_x16("PORTGIO", 0600, parent, (u16 *)0xFFC01500);
		debugfs_create_x16("PORTGIO_BOTH", 0600, parent, (u16 *)0xFFC0153C);
		debugfs_create_x16("PORTGIO_CLEAR", 0600, parent, (u16 *)0xFFC01504);
		debugfs_create_x16("PORTGIO_DIR", 0600, parent, (u16 *)0xFFC01530);
		debugfs_create_x16("PORTGIO_EDGE", 0600, parent, (u16 *)0xFFC01538);
		debugfs_create_x16("PORTGIO_INEN", 0600, parent, (u16 *)0xFFC01540);
		debugfs_create_x16("PORTGIO_MASKA", 0600, parent, (u16 *)0xFFC01510);
		debugfs_create_x16("PORTGIO_MASKA_CLEAR", 0600, parent, (u16 *)0xFFC01514);
		debugfs_create_x16("PORTGIO_MASKA_SET", 0600, parent, (u16 *)0xFFC01518);
		debugfs_create_x16("PORTGIO_MASKA_TOGGLE", 0600, parent, (u16 *)0xFFC0151C);
		debugfs_create_x16("PORTGIO_MASKB", 0600, parent, (u16 *)0xFFC01520);
		debugfs_create_x16("PORTGIO_MASKB_CLEAR", 0600, parent, (u16 *)0xFFC01524);
		debugfs_create_x16("PORTGIO_MASKB_SET", 0600, parent, (u16 *)0xFFC01528);
		debugfs_create_x16("PORTGIO_MASKB_TOGGLE", 0600, parent, (u16 *)0xFFC0152C);
		debugfs_create_x16("PORTGIO_POLAR", 0600, parent, (u16 *)0xFFC01534);
		debugfs_create_x16("PORTGIO_SET", 0600, parent, (u16 *)0xFFC01508);
		debugfs_create_x16("PORTGIO_TOGGLE", 0600, parent, (u16 *)0xFFC0150C);
		debugfs_create_x16("PORTHIO", 0600, parent, (u16 *)0xFFC01700);
		debugfs_create_x16("PORTHIO_BOTH", 0600, parent, (u16 *)0xFFC0173C);
		debugfs_create_x16("PORTHIO_CLEAR", 0600, parent, (u16 *)0xFFC01704);
		debugfs_create_x16("PORTHIO_DIR", 0600, parent, (u16 *)0xFFC01730);
		debugfs_create_x16("PORTHIO_EDGE", 0600, parent, (u16 *)0xFFC01738);
		debugfs_create_x16("PORTHIO_INEN", 0600, parent, (u16 *)0xFFC01740);
		debugfs_create_x16("PORTHIO_MASKA", 0600, parent, (u16 *)0xFFC01710);
		debugfs_create_x16("PORTHIO_MASKA_CLEAR", 0600, parent, (u16 *)0xFFC01714);
		debugfs_create_x16("PORTHIO_MASKA_SET", 0600, parent, (u16 *)0xFFC01718);
		debugfs_create_x16("PORTHIO_MASKA_TOGGLE", 0600, parent, (u16 *)0xFFC0171C);
		debugfs_create_x16("PORTHIO_MASKB", 0600, parent, (u16 *)0xFFC01720);
		debugfs_create_x16("PORTHIO_MASKB_CLEAR", 0600, parent, (u16 *)0xFFC01724);
		debugfs_create_x16("PORTHIO_MASKB_SET", 0600, parent, (u16 *)0xFFC01728);
		debugfs_create_x16("PORTHIO_MASKB_TOGGLE", 0600, parent, (u16 *)0xFFC0172C);
		debugfs_create_x16("PORTHIO_POLAR", 0600, parent, (u16 *)0xFFC01734);
		debugfs_create_x16("PORTHIO_SET", 0600, parent, (u16 *)0xFFC01708);
		debugfs_create_x16("PORTHIO_TOGGLE", 0600, parent, (u16 *)0xFFC0170C);

		parent = debugfs_create_dir("RTC", top);
		debugfs_create_x32("RTC_ALARM", 0600, parent, (u32 *)0xFFC00310);
		debugfs_create_x16("RTC_ICTL", 0600, parent, (u16 *)0xFFC00304);
		debugfs_create_x16("RTC_ISTAT", 0600, parent, (u16 *)0xFFC00308);
		debugfs_create_x16("RTC_PREN", 0600, parent, (u16 *)0xFFC00314);
		debugfs_create_x32("RTC_STAT", 0600, parent, (u32 *)0xFFC00300);
		debugfs_create_x16("RTC_SWCNT", 0600, parent, (u16 *)0xFFC0030C);

		parent = debugfs_create_dir("SPI", top);
		debugfs_create_x16("SPI_BAUD", 0600, parent, (u16 *)0xFFC00514);
		debugfs_create_x16("SPI_CTL", 0600, parent, (u16 *)0xFFC00500);
		debugfs_create_x16("SPI_FLG", 0600, parent, (u16 *)0xFFC00504);
		debugfs_create_x16("SPI_RDBR", 0600, parent, (u16 *)0xFFC00510);
		debugfs_create_x16("SPI_SHADOW", 0600, parent, (u16 *)0xFFC00518);
		debugfs_create_x16("SPI_STAT", 0600, parent, (u16 *)0xFFC00508);
		debugfs_create_x16("SPI_TDBR", 0600, parent, (u16 *)0xFFC0050C);

		parent = debugfs_create_dir("SPORT", top);
		debugfs_create_x16("SPORT0_CHNL", 0600, parent, (u16 *)0xFFC00834);
		debugfs_create_x16("SPORT0_MCMC1", 0600, parent, (u16 *)0xFFC00838);
		debugfs_create_x16("SPORT0_MCMC2", 0600, parent, (u16 *)0xFFC0083C);
		debugfs_create_x32("SPORT0_MRCS0", 0600, parent, (u32 *)0xFFC00850);
		debugfs_create_x32("SPORT0_MRCS1", 0600, parent, (u32 *)0xFFC00854);
		debugfs_create_x32("SPORT0_MRCS2", 0600, parent, (u32 *)0xFFC00858);
		debugfs_create_x32("SPORT0_MRCS3", 0600, parent, (u32 *)0xFFC0085C);
		debugfs_create_x32("SPORT0_MTCS0", 0600, parent, (u32 *)0xFFC00840);
		debugfs_create_x32("SPORT0_MTCS1", 0600, parent, (u32 *)0xFFC00844);
		debugfs_create_x32("SPORT0_MTCS2", 0600, parent, (u32 *)0xFFC00848);
		debugfs_create_x32("SPORT0_MTCS3", 0600, parent, (u32 *)0xFFC0084C);
		debugfs_create_x16("SPORT0_RCLKDIV", 0600, parent, (u16 *)0xFFC00828);
		debugfs_create_x16("SPORT0_RCR1", 0600, parent, (u16 *)0xFFC00820);
		debugfs_create_x16("SPORT0_RCR2", 0600, parent, (u16 *)0xFFC00824);
		debugfs_create_x16("SPORT0_RFSDIV", 0600, parent, (u16 *)0xFFC0082C);
		debugfs_create_x32("SPORT0_RX", 0600, parent, (u32 *)0xFFC00818);
		debugfs_create_x16("SPORT0_STAT", 0600, parent, (u16 *)0xFFC00830);
		debugfs_create_x16("SPORT0_TCLKDIV", 0600, parent, (u16 *)0xFFC00808);
		debugfs_create_x16("SPORT0_TCR1", 0600, parent, (u16 *)0xFFC00800);
		debugfs_create_x16("SPORT0_TCR2", 0600, parent, (u16 *)0xFFC00804);
		debugfs_create_x16("SPORT0_TFSDIV", 0600, parent, (u16 *)0xFFC0080C);
		debugfs_create_x32("SPORT0_TX", 0600, parent, (u32 *)0xFFC00810);
		debugfs_create_x16("SPORT1_CHNL", 0600, parent, (u16 *)0xFFC00934);
		debugfs_create_x16("SPORT1_MCMC1", 0600, parent, (u16 *)0xFFC00938);
		debugfs_create_x16("SPORT1_MCMC2", 0600, parent, (u16 *)0xFFC0093C);
		debugfs_create_x32("SPORT1_MRCS0", 0600, parent, (u32 *)0xFFC00950);
		debugfs_create_x32("SPORT1_MRCS1", 0600, parent, (u32 *)0xFFC00954);
		debugfs_create_x32("SPORT1_MRCS2", 0600, parent, (u32 *)0xFFC00958);
		debugfs_create_x32("SPORT1_MRCS3", 0600, parent, (u32 *)0xFFC0095C);
		debugfs_create_x32("SPORT1_MTCS0", 0600, parent, (u32 *)0xFFC00940);
		debugfs_create_x32("SPORT1_MTCS1", 0600, parent, (u32 *)0xFFC00944);
		debugfs_create_x32("SPORT1_MTCS2", 0600, parent, (u32 *)0xFFC00948);
		debugfs_create_x32("SPORT1_MTCS3", 0600, parent, (u32 *)0xFFC0094C);
		debugfs_create_x16("SPORT1_RCLKDIV", 0600, parent, (u16 *)0xFFC00928);
		debugfs_create_x16("SPORT1_RCR1", 0600, parent, (u16 *)0xFFC00920);
		debugfs_create_x16("SPORT1_RCR2", 0600, parent, (u16 *)0xFFC00924);
		debugfs_create_x16("SPORT1_RFSDIV", 0600, parent, (u16 *)0xFFC0092C);
		debugfs_create_x32("SPORT1_RX", 0600, parent, (u32 *)0xFFC00918);
		debugfs_create_x16("SPORT1_STAT", 0600, parent, (u16 *)0xFFC00930);
		debugfs_create_x16("SPORT1_TCLKDIV", 0600, parent, (u16 *)0xFFC00908);
		debugfs_create_x16("SPORT1_TCR1", 0600, parent, (u16 *)0xFFC00900);
		debugfs_create_x16("SPORT1_TCR2", 0600, parent, (u16 *)0xFFC00904);
		debugfs_create_x16("SPORT1_TFSDIV", 0600, parent, (u16 *)0xFFC0090C);
		debugfs_create_x32("SPORT1_TX", 0600, parent, (u32 *)0xFFC00910);

		parent = debugfs_create_dir("System Interrupt Controller Register File", top);
		debugfs_create_x32("SIC_IAR0", 0600, parent, (u32 *)0xFFC00110);
		debugfs_create_x32("SIC_IAR1", 0600, parent, (u32 *)0xFFC00114);
		debugfs_create_x32("SIC_IAR2", 0600, parent, (u32 *)0xFFC00118);
		debugfs_create_x32("SIC_IAR3", 0600, parent, (u32 *)0xFFC0011C);
		debugfs_create_x32("SIC_IMASK", 0600, parent, (u32 *)0xFFC0010C);
		debugfs_create_x32("SIC_ISR", 0600, parent, (u32 *)0xFFC00120);
		debugfs_create_x32("SIC_IWR", 0600, parent, (u32 *)0xFFC00124);
		debugfs_create_x32("SIC_RVECT", 0600, parent, (u32 *)0xFFC00108);
		debugfs_create_x16("SWRST", 0600, parent, (u16 *)0xFFC00100);
		debugfs_create_x16("SYSCR", 0600, parent, (u16 *)0xFFC00104);

		parent = debugfs_create_dir("TWI", top);
		debugfs_create_x16("TWI_CLKDIV", 0600, parent, (u16 *)0xFFC01400);
		debugfs_create_x16("TWI_CONTROL", 0600, parent, (u16 *)0xFFC01404);
		debugfs_create_x16("TWI_FIFO_CTL", 0600, parent, (u16 *)0xFFC01428);
		debugfs_create_x16("TWI_FIFO_STAT", 0600, parent, (u16 *)0xFFC0142C);
		debugfs_create_x16("TWI_INT_MASK", 0600, parent, (u16 *)0xFFC01424);
		debugfs_create_x16("TWI_INT_STAT", 0600, parent, (u16 *)0xFFC01420);
		debugfs_create_x16("TWI_MASTER_ADDR", 0600, parent, (u16 *)0xFFC0141C);
		debugfs_create_x16("TWI_MASTER_CTL", 0600, parent, (u16 *)0xFFC01414);
		debugfs_create_x16("TWI_MASTER_STAT", 0600, parent, (u16 *)0xFFC01418);
		debugfs_create_x16("TWI_RCV_DATA16", 0600, parent, (u16 *)0xFFC0148C);
		debugfs_create_x16("TWI_RCV_DATA8", 0600, parent, (u16 *)0xFFC01488);
		debugfs_create_x16("TWI_SLAVE_ADDR", 0600, parent, (u16 *)0xFFC01410);
		debugfs_create_x16("TWI_SLAVE_CTL", 0600, parent, (u16 *)0xFFC01408);
		debugfs_create_x16("TWI_SLAVE_STAT", 0600, parent, (u16 *)0xFFC0140C);
		debugfs_create_x16("TWI_XMT_DATA16", 0600, parent, (u16 *)0xFFC01484);
		debugfs_create_x16("TWI_XMT_DATA8", 0600, parent, (u16 *)0xFFC01480);

		parent = debugfs_create_dir("Timer Registers", top);
		debugfs_create_x16("TIMER0_CONFIG", 0600, parent, (u16 *)0xFFC00600);
		debugfs_create_x32("TIMER0_COUNTER", 0600, parent, (u32 *)0xFFC00604);
		debugfs_create_x32("TIMER0_PERIOD", 0600, parent, (u32 *)0xFFC00608);
		debugfs_create_x32("TIMER0_WIDTH", 0600, parent, (u32 *)0xFFC0060C);
		debugfs_create_x16("TIMER1_CONFIG", 0600, parent, (u16 *)0xFFC00610);
		debugfs_create_x32("TIMER1_COUNTER", 0600, parent, (u32 *)0xFFC00614);
		debugfs_create_x32("TIMER1_PERIOD", 0600, parent, (u32 *)0xFFC00618);
		debugfs_create_x32("TIMER1_WIDTH", 0600, parent, (u32 *)0xFFC0061C);
		debugfs_create_x16("TIMER2_CONFIG", 0600, parent, (u16 *)0xFFC00620);
		debugfs_create_x32("TIMER2_COUNTER", 0600, parent, (u32 *)0xFFC00624);
		debugfs_create_x32("TIMER2_PERIOD", 0600, parent, (u32 *)0xFFC00628);
		debugfs_create_x32("TIMER2_WIDTH", 0600, parent, (u32 *)0xFFC0062C);
		debugfs_create_x16("TIMER3_CONFIG", 0600, parent, (u16 *)0xFFC00630);
		debugfs_create_x32("TIMER3_COUNTER", 0600, parent, (u32 *)0xFFC00634);
		debugfs_create_x32("TIMER3_PERIOD", 0600, parent, (u32 *)0xFFC00638);
		debugfs_create_x32("TIMER3_WIDTH", 0600, parent, (u32 *)0xFFC0063C);
		debugfs_create_x16("TIMER4_CONFIG", 0600, parent, (u16 *)0xFFC00640);
		debugfs_create_x32("TIMER4_COUNTER", 0600, parent, (u32 *)0xFFC00644);
		debugfs_create_x32("TIMER4_PERIOD", 0600, parent, (u32 *)0xFFC00648);
		debugfs_create_x32("TIMER4_WIDTH", 0600, parent, (u32 *)0xFFC0064C);
		debugfs_create_x16("TIMER5_CONFIG", 0600, parent, (u16 *)0xFFC00650);
		debugfs_create_x32("TIMER5_COUNTER", 0600, parent, (u32 *)0xFFC00654);
		debugfs_create_x32("TIMER5_PERIOD", 0600, parent, (u32 *)0xFFC00658);
		debugfs_create_x32("TIMER5_WIDTH", 0600, parent, (u32 *)0xFFC0065C);
		debugfs_create_x16("TIMER6_CONFIG", 0600, parent, (u16 *)0xFFC00660);
		debugfs_create_x32("TIMER6_COUNTER", 0600, parent, (u32 *)0xFFC00664);
		debugfs_create_x32("TIMER6_PERIOD", 0600, parent, (u32 *)0xFFC00668);
		debugfs_create_x32("TIMER6_WIDTH", 0600, parent, (u32 *)0xFFC0066C);
		debugfs_create_x16("TIMER7_CONFIG", 0600, parent, (u16 *)0xFFC00670);
		debugfs_create_x32("TIMER7_COUNTER", 0600, parent, (u32 *)0xFFC00674);
		debugfs_create_x32("TIMER7_PERIOD", 0600, parent, (u32 *)0xFFC00678);
		debugfs_create_x32("TIMER7_WIDTH", 0600, parent, (u32 *)0xFFC0067C);
		debugfs_create_x16("TIMER_DISABLE", 0600, parent, (u16 *)0xFFC00684);
		debugfs_create_x16("TIMER_ENABLE", 0600, parent, (u16 *)0xFFC00680);
		debugfs_create_x32("TIMER_STATUS", 0600, parent, (u32 *)0xFFC00688);

		parent = debugfs_create_dir("Trace Unit", top);
		debugfs_create_x32("TBUF", 0600, parent, (u32 *)0xFFE06100);
		debugfs_create_x32("TBUFCTL", 0600, parent, (u32 *)0xFFE06000);
		debugfs_create_x32("TBUFSTAT", 0600, parent, (u32 *)0xFFE06004);

		parent = debugfs_create_dir("UART", top);
		debugfs_create_x16("UART0_DLH", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART0_DLL", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART0_GCTL", 0600, parent, (u16 *)0xFFC00424);
		debugfs_create_x16("UART0_IER", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART0_IIR", 0600, parent, (u16 *)0xFFC00408);
		debugfs_create_x16("UART0_LCR", 0600, parent, (u16 *)0xFFC0040C);
		debugfs_create_x16("UART0_LSR", 0600, parent, (u16 *)0xFFC00414);
		debugfs_create_x16("UART0_MCR", 0600, parent, (u16 *)0xFFC00410);
		debugfs_create_x16("UART0_MSR", 0600, parent, (u16 *)0xFFC00418);
		debugfs_create_x16("UART0_RBR", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART0_SCR", 0600, parent, (u16 *)0xFFC0041C);
		debugfs_create_x16("UART0_THR", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART1_DLH", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("UART1_DLL", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART1_GCTL", 0600, parent, (u16 *)0xFFC02024);
		debugfs_create_x16("UART1_IER", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("UART1_IIR", 0600, parent, (u16 *)0xFFC02008);
		debugfs_create_x16("UART1_LCR", 0600, parent, (u16 *)0xFFC0200C);
		debugfs_create_x16("UART1_LSR", 0600, parent, (u16 *)0xFFC02014);
		debugfs_create_x16("UART1_MCR", 0600, parent, (u16 *)0xFFC02010);
		debugfs_create_x16("UART1_MSR", 0600, parent, (u16 *)0xFFC02018);
		debugfs_create_x16("UART1_RBR", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART1_SCR", 0600, parent, (u16 *)0xFFC0201C);
		debugfs_create_x16("UART1_THR", 0600, parent, (u16 *)0xFFC02000);

		parent = debugfs_create_dir("Watchdog", top);
		debugfs_create_x32("WDOG_CNT", 0600, parent, (u32 *)0xFFC00204);
		debugfs_create_x16("WDOG_CTL", 0600, parent, (u16 *)0xFFC00200);
		debugfs_create_x32("WDOG_STAT", 0600, parent, (u32 *)0xFFC00208);

		parent = debugfs_create_dir("Watchpoint and Patch Unit", top);
		debugfs_create_x32("WPDA0", 0600, parent, (u32 *)0xFFE07140);
		debugfs_create_x32("WPDA1", 0600, parent, (u32 *)0xFFE07144);
		debugfs_create_x32("WPDACNT0", 0600, parent, (u32 *)0xFFE07180);
		debugfs_create_x32("WPDACNT1", 0600, parent, (u32 *)0xFFE07184);
		debugfs_create_x32("WPDACTL", 0600, parent, (u32 *)0xFFE07100);
		debugfs_create_x32("WPIA0", 0600, parent, (u32 *)0xFFE07040);
		debugfs_create_x32("WPIA1", 0600, parent, (u32 *)0xFFE07044);
		debugfs_create_x32("WPIA2", 0600, parent, (u32 *)0xFFE07048);
		debugfs_create_x32("WPIA3", 0600, parent, (u32 *)0xFFE0704C);
		debugfs_create_x32("WPIA4", 0600, parent, (u32 *)0xFFE07050);
		debugfs_create_x32("WPIA5", 0600, parent, (u32 *)0xFFE07054);
		debugfs_create_x32("WPIACNT0", 0600, parent, (u32 *)0xFFE07080);
		debugfs_create_x32("WPIACNT1", 0600, parent, (u32 *)0xFFE07084);
		debugfs_create_x32("WPIACNT2", 0600, parent, (u32 *)0xFFE07088);
		debugfs_create_x32("WPIACNT3", 0600, parent, (u32 *)0xFFE0708C);
		debugfs_create_x32("WPIACNT4", 0600, parent, (u32 *)0xFFE07090);
		debugfs_create_x32("WPIACNT5", 0600, parent, (u32 *)0xFFE07094);
		debugfs_create_x32("WPIACTL", 0600, parent, (u32 *)0xFFE07000);
		debugfs_create_x32("WPSTAT", 0600, parent, (u32 *)0xFFE07200);

	}	/* BF536 */

#ifdef __ADSPBF537__
# define USE_BF537 1
#else
# define USE_BF537 0
#endif
	if (USE_BF537) {

		parent = debugfs_create_dir("CAN Controller", top);
		debugfs_create_x16("CAN_AA1", 0600, parent, (u16 *)0xFFC02A14);
		debugfs_create_x16("CAN_AA2", 0600, parent, (u16 *)0xFFC02A54);
		debugfs_create_x16("CAN_AM00H", 0600, parent, (u16 *)0xFFC02B04);
		debugfs_create_x16("CAN_AM00L", 0600, parent, (u16 *)0xFFC02B00);
		debugfs_create_x16("CAN_AM01H", 0600, parent, (u16 *)0xFFC02B0C);
		debugfs_create_x16("CAN_AM01L", 0600, parent, (u16 *)0xFFC02B08);
		debugfs_create_x16("CAN_AM02H", 0600, parent, (u16 *)0xFFC02B14);
		debugfs_create_x16("CAN_AM02L", 0600, parent, (u16 *)0xFFC02B10);
		debugfs_create_x16("CAN_AM03H", 0600, parent, (u16 *)0xFFC02B1C);
		debugfs_create_x16("CAN_AM03L", 0600, parent, (u16 *)0xFFC02B18);
		debugfs_create_x16("CAN_AM04H", 0600, parent, (u16 *)0xFFC02B24);
		debugfs_create_x16("CAN_AM04L", 0600, parent, (u16 *)0xFFC02B20);
		debugfs_create_x16("CAN_AM05H", 0600, parent, (u16 *)0xFFC02B2C);
		debugfs_create_x16("CAN_AM05L", 0600, parent, (u16 *)0xFFC02B28);
		debugfs_create_x16("CAN_AM06H", 0600, parent, (u16 *)0xFFC02B34);
		debugfs_create_x16("CAN_AM06L", 0600, parent, (u16 *)0xFFC02B30);
		debugfs_create_x16("CAN_AM07H", 0600, parent, (u16 *)0xFFC02B3C);
		debugfs_create_x16("CAN_AM07L", 0600, parent, (u16 *)0xFFC02B38);
		debugfs_create_x16("CAN_AM08H", 0600, parent, (u16 *)0xFFC02B44);
		debugfs_create_x16("CAN_AM08L", 0600, parent, (u16 *)0xFFC02B40);
		debugfs_create_x16("CAN_AM09H", 0600, parent, (u16 *)0xFFC02B4C);
		debugfs_create_x16("CAN_AM09L", 0600, parent, (u16 *)0xFFC02B48);
		debugfs_create_x16("CAN_AM10H", 0600, parent, (u16 *)0xFFC02B54);
		debugfs_create_x16("CAN_AM10L", 0600, parent, (u16 *)0xFFC02B50);
		debugfs_create_x16("CAN_AM11H", 0600, parent, (u16 *)0xFFC02B5C);
		debugfs_create_x16("CAN_AM11L", 0600, parent, (u16 *)0xFFC02B58);
		debugfs_create_x16("CAN_AM12H", 0600, parent, (u16 *)0xFFC02B64);
		debugfs_create_x16("CAN_AM12L", 0600, parent, (u16 *)0xFFC02B60);
		debugfs_create_x16("CAN_AM13H", 0600, parent, (u16 *)0xFFC02B6C);
		debugfs_create_x16("CAN_AM13L", 0600, parent, (u16 *)0xFFC02B68);
		debugfs_create_x16("CAN_AM14H", 0600, parent, (u16 *)0xFFC02B74);
		debugfs_create_x16("CAN_AM14L", 0600, parent, (u16 *)0xFFC02B70);
		debugfs_create_x16("CAN_AM15H", 0600, parent, (u16 *)0xFFC02B7C);
		debugfs_create_x16("CAN_AM15L", 0600, parent, (u16 *)0xFFC02B78);
		debugfs_create_x16("CAN_AM16H", 0600, parent, (u16 *)0xFFC02B84);
		debugfs_create_x16("CAN_AM16L", 0600, parent, (u16 *)0xFFC02B80);
		debugfs_create_x16("CAN_AM17H", 0600, parent, (u16 *)0xFFC02B8C);
		debugfs_create_x16("CAN_AM17L", 0600, parent, (u16 *)0xFFC02B88);
		debugfs_create_x16("CAN_AM18H", 0600, parent, (u16 *)0xFFC02B94);
		debugfs_create_x16("CAN_AM18L", 0600, parent, (u16 *)0xFFC02B90);
		debugfs_create_x16("CAN_AM19H", 0600, parent, (u16 *)0xFFC02B9C);
		debugfs_create_x16("CAN_AM19L", 0600, parent, (u16 *)0xFFC02B98);
		debugfs_create_x16("CAN_AM20H", 0600, parent, (u16 *)0xFFC02BA4);
		debugfs_create_x16("CAN_AM20L", 0600, parent, (u16 *)0xFFC02BA0);
		debugfs_create_x16("CAN_AM21H", 0600, parent, (u16 *)0xFFC02BAC);
		debugfs_create_x16("CAN_AM21L", 0600, parent, (u16 *)0xFFC02BA8);
		debugfs_create_x16("CAN_AM22H", 0600, parent, (u16 *)0xFFC02BB4);
		debugfs_create_x16("CAN_AM22L", 0600, parent, (u16 *)0xFFC02BB0);
		debugfs_create_x16("CAN_AM23H", 0600, parent, (u16 *)0xFFC02BBC);
		debugfs_create_x16("CAN_AM23L", 0600, parent, (u16 *)0xFFC02BB8);
		debugfs_create_x16("CAN_AM24H", 0600, parent, (u16 *)0xFFC02BC4);
		debugfs_create_x16("CAN_AM24L", 0600, parent, (u16 *)0xFFC02BC0);
		debugfs_create_x16("CAN_AM25H", 0600, parent, (u16 *)0xFFC02BCC);
		debugfs_create_x16("CAN_AM25L", 0600, parent, (u16 *)0xFFC02BC8);
		debugfs_create_x16("CAN_AM26H", 0600, parent, (u16 *)0xFFC02BD4);
		debugfs_create_x16("CAN_AM26L", 0600, parent, (u16 *)0xFFC02BD0);
		debugfs_create_x16("CAN_AM27H", 0600, parent, (u16 *)0xFFC02BDC);
		debugfs_create_x16("CAN_AM27L", 0600, parent, (u16 *)0xFFC02BD8);
		debugfs_create_x16("CAN_AM28H", 0600, parent, (u16 *)0xFFC02BE4);
		debugfs_create_x16("CAN_AM28L", 0600, parent, (u16 *)0xFFC02BE0);
		debugfs_create_x16("CAN_AM29H", 0600, parent, (u16 *)0xFFC02BEC);
		debugfs_create_x16("CAN_AM29L", 0600, parent, (u16 *)0xFFC02BE8);
		debugfs_create_x16("CAN_AM30H", 0600, parent, (u16 *)0xFFC02BF4);
		debugfs_create_x16("CAN_AM30L", 0600, parent, (u16 *)0xFFC02BF0);
		debugfs_create_x16("CAN_AM31H", 0600, parent, (u16 *)0xFFC02BFC);
		debugfs_create_x16("CAN_AM31L", 0600, parent, (u16 *)0xFFC02BF8);
		debugfs_create_x16("CAN_CEC", 0600, parent, (u16 *)0xFFC02A90);
		debugfs_create_x16("CAN_CLOCK", 0600, parent, (u16 *)0xFFC02A80);
		debugfs_create_x16("CAN_CONTROL", 0600, parent, (u16 *)0xFFC02AA0);
		debugfs_create_x16("CAN_DEBUG", 0600, parent, (u16 *)0xFFC02A88);
		debugfs_create_x16("CAN_ESR", 0600, parent, (u16 *)0xFFC02AB4);
		debugfs_create_x16("CAN_EWR", 0600, parent, (u16 *)0xFFC02AB0);
		debugfs_create_x16("CAN_GIF", 0600, parent, (u16 *)0xFFC02A9C);
		debugfs_create_x16("CAN_GIM", 0600, parent, (u16 *)0xFFC02A98);
		debugfs_create_x16("CAN_GIS", 0600, parent, (u16 *)0xFFC02A94);
		debugfs_create_x16("CAN_INTR", 0600, parent, (u16 *)0xFFC02AA4);
		debugfs_create_x16("CAN_MBIM1", 0600, parent, (u16 *)0xFFC02A28);
		debugfs_create_x16("CAN_MBIM2", 0600, parent, (u16 *)0xFFC02A68);
		debugfs_create_x16("CAN_MBRIF1", 0600, parent, (u16 *)0xFFC02A24);
		debugfs_create_x16("CAN_MBRIF2", 0600, parent, (u16 *)0xFFC02A64);
		debugfs_create_x16("CAN_MBTD", 0600, parent, (u16 *)0xFFC02AAC);
		debugfs_create_x16("CAN_MBTIF1", 0600, parent, (u16 *)0xFFC02A20);
		debugfs_create_x16("CAN_MBTIF2", 0600, parent, (u16 *)0xFFC02A60);
		debugfs_create_x16("CAN_MC1", 0600, parent, (u16 *)0xFFC02A00);
		debugfs_create_x16("CAN_MC2", 0600, parent, (u16 *)0xFFC02A40);
		debugfs_create_x16("CAN_MD1", 0600, parent, (u16 *)0xFFC02A04);
		debugfs_create_x16("CAN_MD2", 0600, parent, (u16 *)0xFFC02A44);
		debugfs_create_x16("CAN_OPSS1", 0600, parent, (u16 *)0xFFC02A30);
		debugfs_create_x16("CAN_OPSS2", 0600, parent, (u16 *)0xFFC02A70);
		debugfs_create_x16("CAN_RFH1", 0600, parent, (u16 *)0xFFC02A2C);
		debugfs_create_x16("CAN_RFH2", 0600, parent, (u16 *)0xFFC02A6C);
		debugfs_create_x16("CAN_RML1", 0600, parent, (u16 *)0xFFC02A1C);
		debugfs_create_x16("CAN_RML2", 0600, parent, (u16 *)0xFFC02A5C);
		debugfs_create_x16("CAN_RMP1", 0600, parent, (u16 *)0xFFC02A18);
		debugfs_create_x16("CAN_RMP2", 0600, parent, (u16 *)0xFFC02A58);
		debugfs_create_x16("CAN_STATUS", 0600, parent, (u16 *)0xFFC02A8C);
		debugfs_create_x16("CAN_TA1", 0600, parent, (u16 *)0xFFC02A10);
		debugfs_create_x16("CAN_TA2", 0600, parent, (u16 *)0xFFC02A50);
		debugfs_create_x16("CAN_TIMING", 0600, parent, (u16 *)0xFFC02A84);
		debugfs_create_x16("CAN_TRR1", 0600, parent, (u16 *)0xFFC02A0C);
		debugfs_create_x16("CAN_TRR2", 0600, parent, (u16 *)0xFFC02A4C);
		debugfs_create_x16("CAN_TRS1", 0600, parent, (u16 *)0xFFC02A08);
		debugfs_create_x16("CAN_TRS2", 0600, parent, (u16 *)0xFFC02A48);
		debugfs_create_x16("CAN_UCCNF", 0600, parent, (u16 *)0xFFC02ACC);
		debugfs_create_x16("CAN_UCCNT", 0600, parent, (u16 *)0xFFC02AC4);
		debugfs_create_x16("CAN_UCRC", 0600, parent, (u16 *)0xFFC02AC8);
		debugfs_create_x16("CAN_UCREG", 0600, parent, (u16 *)0xFFC02AC0);
		debugfs_create_x16("CAN_VERSION2", 0600, parent, (u16 *)0xFFC02AD4);
		debugfs_create_x16("CAN_VERSION", 0600, parent, (u16 *)0xFFC02AA8);

		parent = debugfs_create_dir("Core Timer Register File", top);
		debugfs_create_x32("TCNTL", 0600, parent, (u32 *)0xFFE03000);
		debugfs_create_x32("TCOUNT", 0600, parent, (u32 *)0xFFE0300C);
		debugfs_create_x32("TPERIOD", 0600, parent, (u32 *)0xFFE03004);
		debugfs_create_x32("TSCALE", 0600, parent, (u32 *)0xFFE03008);

		parent = debugfs_create_dir("DMA Controller", top);
		debugfs_create_x16("DMA0_CONFIG", 0600, parent, (u16 *)0xFFC00C08);
		debugfs_create_x32("DMA0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C24);
		debugfs_create_x32("DMA0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C20);
		debugfs_create_x16("DMA0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C30);
		debugfs_create_x16("DMA0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C38);
		debugfs_create_x16("DMA0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C28);
		debugfs_create_x32("DMA0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C00);
		debugfs_create_x16("DMA0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C2C);
		debugfs_create_x32("DMA0_START_ADDR", 0600, parent, (u32 *)0xFFC00C04);
		debugfs_create_x16("DMA0_X_COUNT", 0600, parent, (u16 *)0xFFC00C10);
		debugfs_create_x16("DMA0_X_MODIFY", 0600, parent, (u16 *)0xFFC00C14);
		debugfs_create_x16("DMA0_Y_COUNT", 0600, parent, (u16 *)0xFFC00C18);
		debugfs_create_x16("DMA0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C1C);
		debugfs_create_x16("DMA10_CONFIG", 0600, parent, (u16 *)0xFFC00E88);
		debugfs_create_x32("DMA10_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EA4);
		debugfs_create_x32("DMA10_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EA0);
		debugfs_create_x16("DMA10_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EB0);
		debugfs_create_x16("DMA10_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EB8);
		debugfs_create_x16("DMA10_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EA8);
		debugfs_create_x32("DMA10_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E80);
		debugfs_create_x16("DMA10_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EAC);
		debugfs_create_x32("DMA10_START_ADDR", 0600, parent, (u32 *)0xFFC00E84);
		debugfs_create_x16("DMA10_X_COUNT", 0600, parent, (u16 *)0xFFC00E90);
		debugfs_create_x16("DMA10_X_MODIFY", 0600, parent, (u16 *)0xFFC00E94);
		debugfs_create_x16("DMA10_Y_COUNT", 0600, parent, (u16 *)0xFFC00E98);
		debugfs_create_x16("DMA10_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E9C);
		debugfs_create_x16("DMA11_CONFIG", 0600, parent, (u16 *)0xFFC00EC8);
		debugfs_create_x32("DMA11_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EE4);
		debugfs_create_x32("DMA11_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EE0);
		debugfs_create_x16("DMA11_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EF0);
		debugfs_create_x16("DMA11_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EF8);
		debugfs_create_x16("DMA11_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EE8);
		debugfs_create_x32("DMA11_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00EC0);
		debugfs_create_x16("DMA11_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EEC);
		debugfs_create_x32("DMA11_START_ADDR", 0600, parent, (u32 *)0xFFC00EC4);
		debugfs_create_x16("DMA11_X_COUNT", 0600, parent, (u16 *)0xFFC00ED0);
		debugfs_create_x16("DMA11_X_MODIFY", 0600, parent, (u16 *)0xFFC00ED4);
		debugfs_create_x16("DMA11_Y_COUNT", 0600, parent, (u16 *)0xFFC00ED8);
		debugfs_create_x16("DMA11_Y_MODIFY", 0600, parent, (u16 *)0xFFC00EDC);
		debugfs_create_x16("DMA1_CONFIG", 0600, parent, (u16 *)0xFFC00C48);
		debugfs_create_x32("DMA1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C64);
		debugfs_create_x32("DMA1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C60);
		debugfs_create_x16("DMA1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C70);
		debugfs_create_x16("DMA1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C78);
		debugfs_create_x16("DMA1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C68);
		debugfs_create_x32("DMA1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C40);
		debugfs_create_x16("DMA1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C6C);
		debugfs_create_x32("DMA1_START_ADDR", 0600, parent, (u32 *)0xFFC00C44);
		debugfs_create_x16("DMA1_X_COUNT", 0600, parent, (u16 *)0xFFC00C50);
		debugfs_create_x16("DMA1_X_MODIFY", 0600, parent, (u16 *)0xFFC00C54);
		debugfs_create_x16("DMA1_Y_COUNT", 0600, parent, (u16 *)0xFFC00C58);
		debugfs_create_x16("DMA1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C5C);
		debugfs_create_x16("DMA2_CONFIG", 0600, parent, (u16 *)0xFFC00C88);
		debugfs_create_x32("DMA2_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CA4);
		debugfs_create_x32("DMA2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CA0);
		debugfs_create_x16("DMA2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CB0);
		debugfs_create_x16("DMA2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CB8);
		debugfs_create_x16("DMA2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CA8);
		debugfs_create_x32("DMA2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C80);
		debugfs_create_x16("DMA2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CAC);
		debugfs_create_x32("DMA2_START_ADDR", 0600, parent, (u32 *)0xFFC00C84);
		debugfs_create_x16("DMA2_X_COUNT", 0600, parent, (u16 *)0xFFC00C90);
		debugfs_create_x16("DMA2_X_MODIFY", 0600, parent, (u16 *)0xFFC00C94);
		debugfs_create_x16("DMA2_Y_COUNT", 0600, parent, (u16 *)0xFFC00C98);
		debugfs_create_x16("DMA2_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C9C);
		debugfs_create_x16("DMA3_CONFIG", 0600, parent, (u16 *)0xFFC00CC8);
		debugfs_create_x32("DMA3_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CE4);
		debugfs_create_x32("DMA3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CE0);
		debugfs_create_x16("DMA3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CF0);
		debugfs_create_x16("DMA3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CF8);
		debugfs_create_x16("DMA3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CE8);
		debugfs_create_x32("DMA3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00CC0);
		debugfs_create_x16("DMA3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CEC);
		debugfs_create_x32("DMA3_START_ADDR", 0600, parent, (u32 *)0xFFC00CC4);
		debugfs_create_x16("DMA3_X_COUNT", 0600, parent, (u16 *)0xFFC00CD0);
		debugfs_create_x16("DMA3_X_MODIFY", 0600, parent, (u16 *)0xFFC00CD4);
		debugfs_create_x16("DMA3_Y_COUNT", 0600, parent, (u16 *)0xFFC00CD8);
		debugfs_create_x16("DMA3_Y_MODIFY", 0600, parent, (u16 *)0xFFC00CDC);
		debugfs_create_x16("DMA4_CONFIG", 0600, parent, (u16 *)0xFFC00D08);
		debugfs_create_x32("DMA4_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D24);
		debugfs_create_x32("DMA4_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D20);
		debugfs_create_x16("DMA4_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D30);
		debugfs_create_x16("DMA4_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D38);
		debugfs_create_x16("DMA4_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D28);
		debugfs_create_x32("DMA4_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D00);
		debugfs_create_x16("DMA4_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D2C);
		debugfs_create_x32("DMA4_START_ADDR", 0600, parent, (u32 *)0xFFC00D04);
		debugfs_create_x16("DMA4_X_COUNT", 0600, parent, (u16 *)0xFFC00D10);
		debugfs_create_x16("DMA4_X_MODIFY", 0600, parent, (u16 *)0xFFC00D14);
		debugfs_create_x16("DMA4_Y_COUNT", 0600, parent, (u16 *)0xFFC00D18);
		debugfs_create_x16("DMA4_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D1C);
		debugfs_create_x16("DMA5_CONFIG", 0600, parent, (u16 *)0xFFC00D48);
		debugfs_create_x32("DMA5_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D64);
		debugfs_create_x32("DMA5_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D60);
		debugfs_create_x16("DMA5_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D70);
		debugfs_create_x16("DMA5_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D78);
		debugfs_create_x16("DMA5_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D68);
		debugfs_create_x32("DMA5_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D40);
		debugfs_create_x16("DMA5_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D6C);
		debugfs_create_x32("DMA5_START_ADDR", 0600, parent, (u32 *)0xFFC00D44);
		debugfs_create_x16("DMA5_X_COUNT", 0600, parent, (u16 *)0xFFC00D50);
		debugfs_create_x16("DMA5_X_MODIFY", 0600, parent, (u16 *)0xFFC00D54);
		debugfs_create_x16("DMA5_Y_COUNT", 0600, parent, (u16 *)0xFFC00D58);
		debugfs_create_x16("DMA5_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D5C);
		debugfs_create_x16("DMA6_CONFIG", 0600, parent, (u16 *)0xFFC00D88);
		debugfs_create_x32("DMA6_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DA4);
		debugfs_create_x32("DMA6_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DA0);
		debugfs_create_x16("DMA6_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DB0);
		debugfs_create_x16("DMA6_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DB8);
		debugfs_create_x16("DMA6_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DA8);
		debugfs_create_x32("DMA6_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D80);
		debugfs_create_x16("DMA6_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DAC);
		debugfs_create_x32("DMA6_START_ADDR", 0600, parent, (u32 *)0xFFC00D84);
		debugfs_create_x16("DMA6_X_COUNT", 0600, parent, (u16 *)0xFFC00D90);
		debugfs_create_x16("DMA6_X_MODIFY", 0600, parent, (u16 *)0xFFC00D94);
		debugfs_create_x16("DMA6_Y_COUNT", 0600, parent, (u16 *)0xFFC00D98);
		debugfs_create_x16("DMA6_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D9C);
		debugfs_create_x16("DMA7_CONFIG", 0600, parent, (u16 *)0xFFC00DC8);
		debugfs_create_x32("DMA7_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DE4);
		debugfs_create_x32("DMA7_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DE0);
		debugfs_create_x16("DMA7_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DF0);
		debugfs_create_x16("DMA7_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DF8);
		debugfs_create_x16("DMA7_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DE8);
		debugfs_create_x32("DMA7_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00DC0);
		debugfs_create_x16("DMA7_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DEC);
		debugfs_create_x32("DMA7_START_ADDR", 0600, parent, (u32 *)0xFFC00DC4);
		debugfs_create_x16("DMA7_X_COUNT", 0600, parent, (u16 *)0xFFC00DD0);
		debugfs_create_x16("DMA7_X_MODIFY", 0600, parent, (u16 *)0xFFC00DD4);
		debugfs_create_x16("DMA7_Y_COUNT", 0600, parent, (u16 *)0xFFC00DD8);
		debugfs_create_x16("DMA7_Y_MODIFY", 0600, parent, (u16 *)0xFFC00DDC);
		debugfs_create_x16("DMA8_CONFIG", 0600, parent, (u16 *)0xFFC00E08);
		debugfs_create_x32("DMA8_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E24);
		debugfs_create_x32("DMA8_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E20);
		debugfs_create_x16("DMA8_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E30);
		debugfs_create_x16("DMA8_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E38);
		debugfs_create_x16("DMA8_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E28);
		debugfs_create_x32("DMA8_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E00);
		debugfs_create_x16("DMA8_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E2C);
		debugfs_create_x32("DMA8_START_ADDR", 0600, parent, (u32 *)0xFFC00E04);
		debugfs_create_x16("DMA8_X_COUNT", 0600, parent, (u16 *)0xFFC00E10);
		debugfs_create_x16("DMA8_X_MODIFY", 0600, parent, (u16 *)0xFFC00E14);
		debugfs_create_x16("DMA8_Y_COUNT", 0600, parent, (u16 *)0xFFC00E18);
		debugfs_create_x16("DMA8_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E1C);
		debugfs_create_x16("DMA9_CONFIG", 0600, parent, (u16 *)0xFFC00E48);
		debugfs_create_x32("DMA9_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E64);
		debugfs_create_x32("DMA9_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E60);
		debugfs_create_x16("DMA9_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E70);
		debugfs_create_x16("DMA9_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E78);
		debugfs_create_x16("DMA9_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E68);
		debugfs_create_x32("DMA9_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E40);
		debugfs_create_x16("DMA9_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E6C);
		debugfs_create_x32("DMA9_START_ADDR", 0600, parent, (u32 *)0xFFC00E44);
		debugfs_create_x16("DMA9_X_COUNT", 0600, parent, (u16 *)0xFFC00E50);
		debugfs_create_x16("DMA9_X_MODIFY", 0600, parent, (u16 *)0xFFC00E54);
		debugfs_create_x16("DMA9_Y_COUNT", 0600, parent, (u16 *)0xFFC00E58);
		debugfs_create_x16("DMA9_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E5C);

		parent = debugfs_create_dir("DMA Traffic Control", top);
		debugfs_create_x16("DMA_TC_CNT", 0600, parent, (u16 *)0xFFC00B0C);
		debugfs_create_x16("DMA_TC_PER", 0600, parent, (u16 *)0xFFC00B10);

		parent = debugfs_create_dir("Data Cache Programmable Look-Aside Buffer Fault Address", top);
		debugfs_create_x32("DCPLB_STATUS", 0600, parent, (u32 *)0xFFE00008);

		parent = debugfs_create_dir("EBIU", top);
		debugfs_create_x32("EBIU_AMBCTL0", 0600, parent, (u32 *)0xFFC00A04);
		debugfs_create_x32("EBIU_AMBCTL1", 0600, parent, (u32 *)0xFFC00A08);
		debugfs_create_x16("EBIU_AMGCTL", 0600, parent, (u16 *)0xFFC00A00);
		debugfs_create_x16("EBIU_SDBCTL", 0600, parent, (u16 *)0xFFC00A14);
		debugfs_create_x32("EBIU_SDGCTL", 0600, parent, (u32 *)0xFFC00A10);
		debugfs_create_x16("EBIU_SDRRC", 0600, parent, (u16 *)0xFFC00A18);
		debugfs_create_x16("EBIU_SDSTAT", 0600, parent, (u16 *)0xFFC00A1C);

		parent = debugfs_create_dir("Ethernet Controller", top);
		debugfs_create_x32("EMAC_ADDRHI", 0600, parent, (u32 *)0xFFC03008);
		debugfs_create_x32("EMAC_ADDRLO", 0600, parent, (u32 *)0xFFC03004);
		debugfs_create_x32("EMAC_FLC", 0600, parent, (u32 *)0xFFC0301C);
		debugfs_create_x32("EMAC_HASHHI", 0600, parent, (u32 *)0xFFC03010);
		debugfs_create_x32("EMAC_HASHLO", 0600, parent, (u32 *)0xFFC0300C);
		debugfs_create_x32("EMAC_MMC_CTL", 0600, parent, (u32 *)0xFFC03080);
		debugfs_create_x32("EMAC_MMC_RIRQE", 0600, parent, (u32 *)0xFFC03088);
		debugfs_create_x32("EMAC_MMC_RIRQS", 0600, parent, (u32 *)0xFFC03084);
		debugfs_create_x32("EMAC_MMC_TIRQE", 0600, parent, (u32 *)0xFFC03090);
		debugfs_create_x32("EMAC_MMC_TIRQS", 0600, parent, (u32 *)0xFFC0308C);
		debugfs_create_x32("EMAC_OPMODE", 0600, parent, (u32 *)0xFFC03000);
		debugfs_create_x32("EMAC_RXC_ALIGN", 0600, parent, (u32 *)0xFFC03108);
		debugfs_create_x32("EMAC_RXC_ALLFRM", 0600, parent, (u32 *)0xFFC03138);
		debugfs_create_x32("EMAC_RXC_ALLOCT", 0600, parent, (u32 *)0xFFC0313C);
		debugfs_create_x32("EMAC_RXC_BROAD", 0600, parent, (u32 *)0xFFC0311C);
		debugfs_create_x32("EMAC_RXC_DMAOVF", 0600, parent, (u32 *)0xFFC03110);
		debugfs_create_x32("EMAC_RXC_EQ64", 0600, parent, (u32 *)0xFFC03148);
		debugfs_create_x32("EMAC_RXC_FCS", 0600, parent, (u32 *)0xFFC03104);
		debugfs_create_x32("EMAC_RXC_GE1024", 0600, parent, (u32 *)0xFFC0315C);
		debugfs_create_x32("EMAC_RXC_LNERRI", 0600, parent, (u32 *)0xFFC03120);
		debugfs_create_x32("EMAC_RXC_LNERRO", 0600, parent, (u32 *)0xFFC03124);
		debugfs_create_x32("EMAC_RXC_LONG", 0600, parent, (u32 *)0xFFC03128);
		debugfs_create_x32("EMAC_RXC_LT1024", 0600, parent, (u32 *)0xFFC03158);
		debugfs_create_x32("EMAC_RXC_LT128", 0600, parent, (u32 *)0xFFC0314C);
		debugfs_create_x32("EMAC_RXC_LT256", 0600, parent, (u32 *)0xFFC03150);
		debugfs_create_x32("EMAC_RXC_LT512", 0600, parent, (u32 *)0xFFC03154);
		debugfs_create_x32("EMAC_RXC_MACCTL", 0600, parent, (u32 *)0xFFC0312C);
		debugfs_create_x32("EMAC_RXC_MULTI", 0600, parent, (u32 *)0xFFC03118);
		debugfs_create_x32("EMAC_RXC_OCTET", 0600, parent, (u32 *)0xFFC0310C);
		debugfs_create_x32("EMAC_RXC_OK", 0600, parent, (u32 *)0xFFC03100);
		debugfs_create_x32("EMAC_RXC_OPCODE", 0600, parent, (u32 *)0xFFC03130);
		debugfs_create_x32("EMAC_RXC_PAUSE", 0600, parent, (u32 *)0xFFC03134);
		debugfs_create_x32("EMAC_RXC_SHORT", 0600, parent, (u32 *)0xFFC03144);
		debugfs_create_x32("EMAC_RXC_TYPED", 0600, parent, (u32 *)0xFFC03140);
		debugfs_create_x32("EMAC_RXC_UNICST", 0600, parent, (u32 *)0xFFC03114);
		debugfs_create_x32("EMAC_RX_IRQE", 0600, parent, (u32 *)0xFFC03070);
		debugfs_create_x32("EMAC_RX_STAT", 0600, parent, (u32 *)0xFFC03068);
		debugfs_create_x32("EMAC_RX_STKY", 0600, parent, (u32 *)0xFFC0306C);
		debugfs_create_x32("EMAC_STAADD", 0600, parent, (u32 *)0xFFC03014);
		debugfs_create_x32("EMAC_STADAT", 0600, parent, (u32 *)0xFFC03018);
		debugfs_create_x32("EMAC_SYSCTL", 0600, parent, (u32 *)0xFFC03060);
		debugfs_create_x32("EMAC_SYSTAT", 0600, parent, (u32 *)0xFFC03064);
		debugfs_create_x32("EMAC_TXC_1COL", 0600, parent, (u32 *)0xFFC03184);
		debugfs_create_x32("EMAC_TXC_ABORT", 0600, parent, (u32 *)0xFFC031D8);
		debugfs_create_x32("EMAC_TXC_ALLFRM", 0600, parent, (u32 *)0xFFC031B8);
		debugfs_create_x32("EMAC_TXC_ALLOCT", 0600, parent, (u32 *)0xFFC031BC);
		debugfs_create_x32("EMAC_TXC_BROAD", 0600, parent, (u32 *)0xFFC031AC);
		debugfs_create_x32("EMAC_TXC_CRSERR", 0600, parent, (u32 *)0xFFC031A0);
		debugfs_create_x32("EMAC_TXC_DEFER", 0600, parent, (u32 *)0xFFC03190);
		debugfs_create_x32("EMAC_TXC_DMAUND", 0600, parent, (u32 *)0xFFC0319C);
		debugfs_create_x32("EMAC_TXC_EQ64", 0600, parent, (u32 *)0xFFC031C0);
		debugfs_create_x32("EMAC_TXC_GE1024", 0600, parent, (u32 *)0xFFC031D4);
		debugfs_create_x32("EMAC_TXC_GT1COL", 0600, parent, (u32 *)0xFFC03188);
		debugfs_create_x32("EMAC_TXC_LATECL", 0600, parent, (u32 *)0xFFC03194);
		debugfs_create_x32("EMAC_TXC_LT1024", 0600, parent, (u32 *)0xFFC031D0);
		debugfs_create_x32("EMAC_TXC_LT128", 0600, parent, (u32 *)0xFFC031C4);
		debugfs_create_x32("EMAC_TXC_LT256", 0600, parent, (u32 *)0xFFC031C8);
		debugfs_create_x32("EMAC_TXC_LT512", 0600, parent, (u32 *)0xFFC031CC);
		debugfs_create_x32("EMAC_TXC_MACCTL", 0600, parent, (u32 *)0xFFC031B4);
		debugfs_create_x32("EMAC_TXC_MULTI", 0600, parent, (u32 *)0xFFC031A8);
		debugfs_create_x32("EMAC_TXC_OCTET", 0600, parent, (u32 *)0xFFC0318C);
		debugfs_create_x32("EMAC_TXC_OK", 0600, parent, (u32 *)0xFFC03180);
		debugfs_create_x32("EMAC_TXC_UNICST", 0600, parent, (u32 *)0xFFC031A4);
		debugfs_create_x32("EMAC_TXC_XS_COL", 0600, parent, (u32 *)0xFFC03198);
		debugfs_create_x32("EMAC_TXC_XS_DFR", 0600, parent, (u32 *)0xFFC031B0);
		debugfs_create_x32("EMAC_TX_IRQE", 0600, parent, (u32 *)0xFFC0307C);
		debugfs_create_x32("EMAC_TX_STAT", 0600, parent, (u32 *)0xFFC03074);
		debugfs_create_x32("EMAC_TX_STKY", 0600, parent, (u32 *)0xFFC03078);
		debugfs_create_x32("EMAC_VLAN1", 0600, parent, (u32 *)0xFFC03020);
		debugfs_create_x32("EMAC_VLAN2", 0600, parent, (u32 *)0xFFC03024);
		debugfs_create_x32("EMAC_WKUP_CTL", 0600, parent, (u32 *)0xFFC0302C);
		debugfs_create_x32("EMAC_WKUP_FFCMD", 0600, parent, (u32 *)0xFFC03040);
		debugfs_create_x32("EMAC_WKUP_FFCRC0", 0600, parent, (u32 *)0xFFC03048);
		debugfs_create_x32("EMAC_WKUP_FFCRC1", 0600, parent, (u32 *)0xFFC0304C);
		debugfs_create_x32("EMAC_WKUP_FFMSK0", 0600, parent, (u32 *)0xFFC03030);
		debugfs_create_x32("EMAC_WKUP_FFMSK1", 0600, parent, (u32 *)0xFFC03034);
		debugfs_create_x32("EMAC_WKUP_FFMSK2", 0600, parent, (u32 *)0xFFC03038);
		debugfs_create_x32("EMAC_WKUP_FFMSK3", 0600, parent, (u32 *)0xFFC0303C);
		debugfs_create_x32("EMAC_WKUP_FFOFF", 0600, parent, (u32 *)0xFFC03044);

		parent = debugfs_create_dir("Event Vectors", top);
		debugfs_create_x32("EVT0", 0600, parent, (u32 *)0xFFE02000);
		debugfs_create_x32("EVT10", 0600, parent, (u32 *)0xFFE02028);
		debugfs_create_x32("EVT11", 0600, parent, (u32 *)0xFFE0202C);
		debugfs_create_x32("EVT12", 0600, parent, (u32 *)0xFFE02030);
		debugfs_create_x32("EVT13", 0600, parent, (u32 *)0xFFE02034);
		debugfs_create_x32("EVT14", 0600, parent, (u32 *)0xFFE02038);
		debugfs_create_x32("EVT15", 0600, parent, (u32 *)0xFFE0203C);
		debugfs_create_x32("EVT1", 0600, parent, (u32 *)0xFFE02004);
		debugfs_create_x32("EVT2", 0600, parent, (u32 *)0xFFE02008);
		debugfs_create_x32("EVT3", 0600, parent, (u32 *)0xFFE0200C);
		debugfs_create_x32("EVT4", 0600, parent, (u32 *)0xFFE02010);
		debugfs_create_x32("EVT5", 0600, parent, (u32 *)0xFFE02014);
		debugfs_create_x32("EVT6", 0600, parent, (u32 *)0xFFE02018);
		debugfs_create_x32("EVT7", 0600, parent, (u32 *)0xFFE0201C);
		debugfs_create_x32("EVT8", 0600, parent, (u32 *)0xFFE02020);
		debugfs_create_x32("EVT9", 0600, parent, (u32 *)0xFFE02024);

		parent = debugfs_create_dir("Extended Registers", top);
		debugfs_create_x32("CHIPID", 0600, parent, (u32 *)0xFFC00014);
		debugfs_create_x32("DSPID", 0600, parent, (u32 *)0xFFE05000);

		parent = debugfs_create_dir("Handshake MDMA", top);
		debugfs_create_x16("HMDMA0_BCINIT", 0600, parent, (u16 *)0xFFC03308);
		debugfs_create_x16("HMDMA0_BCOUNT", 0600, parent, (u16 *)0xFFC03318);
		debugfs_create_x16("HMDMA0_CONTROL", 0600, parent, (u16 *)0xFFC03300);
		debugfs_create_x16("HMDMA0_ECINIT", 0600, parent, (u16 *)0xFFC03304);
		debugfs_create_x16("HMDMA0_ECOUNT", 0600, parent, (u16 *)0xFFC03314);
		debugfs_create_x16("HMDMA0_ECOVERFLOW", 0600, parent, (u16 *)0xFFC03310);
		debugfs_create_x16("HMDMA0_ECURGENT", 0600, parent, (u16 *)0xFFC0330C);
		debugfs_create_x16("HMDMA1_BCINIT", 0600, parent, (u16 *)0xFFC03348);
		debugfs_create_x16("HMDMA1_BCOUNT", 0600, parent, (u16 *)0xFFC03358);
		debugfs_create_x16("HMDMA1_CONTROL", 0600, parent, (u16 *)0xFFC03340);
		debugfs_create_x16("HMDMA1_ECINIT", 0600, parent, (u16 *)0xFFC03344);
		debugfs_create_x16("HMDMA1_ECOUNT", 0600, parent, (u16 *)0xFFC03354);
		debugfs_create_x16("HMDMA1_ECOVERFLOW", 0600, parent, (u16 *)0xFFC03350);
		debugfs_create_x16("HMDMA1_ECURGENT", 0600, parent, (u16 *)0xFFC0334C);

		parent = debugfs_create_dir("Interrupt Controller", top);
		debugfs_create_x32("ILAT", 0600, parent, (u32 *)0xFFE0210C);
		debugfs_create_x32("IMASK", 0600, parent, (u32 *)0xFFE02104);
		debugfs_create_x32("IPEND", 0600, parent, (u32 *)0xFFE02108);
		debugfs_create_x32("IPRIO", 0600, parent, (u32 *)0xFFE02110);

		parent = debugfs_create_dir("L1 Code Memory Registers", top);
		debugfs_create_x32("ICPLB_ADDR0", 0600, parent, (u32 *)0xFFE01100);
		debugfs_create_x32("ICPLB_ADDR10", 0600, parent, (u32 *)0xFFE01128);
		debugfs_create_x32("ICPLB_ADDR11", 0600, parent, (u32 *)0xFFE0112C);
		debugfs_create_x32("ICPLB_ADDR12", 0600, parent, (u32 *)0xFFE01130);
		debugfs_create_x32("ICPLB_ADDR13", 0600, parent, (u32 *)0xFFE01134);
		debugfs_create_x32("ICPLB_ADDR14", 0600, parent, (u32 *)0xFFE01138);
		debugfs_create_x32("ICPLB_ADDR15", 0600, parent, (u32 *)0xFFE0113C);
		debugfs_create_x32("ICPLB_ADDR1", 0600, parent, (u32 *)0xFFE01104);
		debugfs_create_x32("ICPLB_ADDR2", 0600, parent, (u32 *)0xFFE01108);
		debugfs_create_x32("ICPLB_ADDR3", 0600, parent, (u32 *)0xFFE0110C);
		debugfs_create_x32("ICPLB_ADDR4", 0600, parent, (u32 *)0xFFE01110);
		debugfs_create_x32("ICPLB_ADDR5", 0600, parent, (u32 *)0xFFE01114);
		debugfs_create_x32("ICPLB_ADDR6", 0600, parent, (u32 *)0xFFE01118);
		debugfs_create_x32("ICPLB_ADDR7", 0600, parent, (u32 *)0xFFE0111C);
		debugfs_create_x32("ICPLB_ADDR8", 0600, parent, (u32 *)0xFFE01120);
		debugfs_create_x32("ICPLB_ADDR9", 0600, parent, (u32 *)0xFFE01124);
		debugfs_create_x32("ICPLB_DATA0", 0600, parent, (u32 *)0xFFE01200);
		debugfs_create_x32("ICPLB_DATA10", 0600, parent, (u32 *)0xFFE01228);
		debugfs_create_x32("ICPLB_DATA11", 0600, parent, (u32 *)0xFFE0122C);
		debugfs_create_x32("ICPLB_DATA12", 0600, parent, (u32 *)0xFFE01230);
		debugfs_create_x32("ICPLB_DATA13", 0600, parent, (u32 *)0xFFE01234);
		debugfs_create_x32("ICPLB_DATA14", 0600, parent, (u32 *)0xFFE01238);
		debugfs_create_x32("ICPLB_DATA15", 0600, parent, (u32 *)0xFFE0123C);
		debugfs_create_x32("ICPLB_DATA1", 0600, parent, (u32 *)0xFFE01204);
		debugfs_create_x32("ICPLB_DATA2", 0600, parent, (u32 *)0xFFE01208);
		debugfs_create_x32("ICPLB_DATA3", 0600, parent, (u32 *)0xFFE0120C);
		debugfs_create_x32("ICPLB_DATA4", 0600, parent, (u32 *)0xFFE01210);
		debugfs_create_x32("ICPLB_DATA5", 0600, parent, (u32 *)0xFFE01214);
		debugfs_create_x32("ICPLB_DATA6", 0600, parent, (u32 *)0xFFE01218);
		debugfs_create_x32("ICPLB_DATA7", 0600, parent, (u32 *)0xFFE0121C);
		debugfs_create_x32("ICPLB_DATA8", 0600, parent, (u32 *)0xFFE01220);
		debugfs_create_x32("ICPLB_DATA9", 0600, parent, (u32 *)0xFFE01224);
		debugfs_create_x32("ICPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0100C);
		debugfs_create_x32("ICPLB_STATUS", 0600, parent, (u32 *)0xFFE01008);
		debugfs_create_x32("IMEM_CONTROL", 0600, parent, (u32 *)0xFFE01004);
		debugfs_create_x32("ITEST_COMMAND", 0600, parent, (u32 *)0xFFE01300);
		debugfs_create_x32("ITEST_DATA0", 0600, parent, (u32 *)0xFFE01400);
		debugfs_create_x32("ITEST_DATA1", 0600, parent, (u32 *)0xFFE01404);

		parent = debugfs_create_dir("L1 Data Memory Registers", top);
		debugfs_create_x32("DCPLB_ADDR0", 0600, parent, (u32 *)0xFFE00100);
		debugfs_create_x32("DCPLB_ADDR10", 0600, parent, (u32 *)0xFFE00128);
		debugfs_create_x32("DCPLB_ADDR11", 0600, parent, (u32 *)0xFFE0012C);
		debugfs_create_x32("DCPLB_ADDR12", 0600, parent, (u32 *)0xFFE00130);
		debugfs_create_x32("DCPLB_ADDR13", 0600, parent, (u32 *)0xFFE00134);
		debugfs_create_x32("DCPLB_ADDR14", 0600, parent, (u32 *)0xFFE00138);
		debugfs_create_x32("DCPLB_ADDR15", 0600, parent, (u32 *)0xFFE0013C);
		debugfs_create_x32("DCPLB_ADDR1", 0600, parent, (u32 *)0xFFE00104);
		debugfs_create_x32("DCPLB_ADDR2", 0600, parent, (u32 *)0xFFE00108);
		debugfs_create_x32("DCPLB_ADDR3", 0600, parent, (u32 *)0xFFE0010C);
		debugfs_create_x32("DCPLB_ADDR4", 0600, parent, (u32 *)0xFFE00110);
		debugfs_create_x32("DCPLB_ADDR5", 0600, parent, (u32 *)0xFFE00114);
		debugfs_create_x32("DCPLB_ADDR6", 0600, parent, (u32 *)0xFFE00118);
		debugfs_create_x32("DCPLB_ADDR7", 0600, parent, (u32 *)0xFFE0011C);
		debugfs_create_x32("DCPLB_ADDR8", 0600, parent, (u32 *)0xFFE00120);
		debugfs_create_x32("DCPLB_ADDR9", 0600, parent, (u32 *)0xFFE00124);
		debugfs_create_x32("DCPLB_DATA0", 0600, parent, (u32 *)0xFFE00200);
		debugfs_create_x32("DCPLB_DATA10", 0600, parent, (u32 *)0xFFE00228);
		debugfs_create_x32("DCPLB_DATA11", 0600, parent, (u32 *)0xFFE0022C);
		debugfs_create_x32("DCPLB_DATA12", 0600, parent, (u32 *)0xFFE00230);
		debugfs_create_x32("DCPLB_DATA13", 0600, parent, (u32 *)0xFFE00234);
		debugfs_create_x32("DCPLB_DATA14", 0600, parent, (u32 *)0xFFE00238);
		debugfs_create_x32("DCPLB_DATA15", 0600, parent, (u32 *)0xFFE0023C);
		debugfs_create_x32("DCPLB_DATA1", 0600, parent, (u32 *)0xFFE00204);
		debugfs_create_x32("DCPLB_DATA2", 0600, parent, (u32 *)0xFFE00208);
		debugfs_create_x32("DCPLB_DATA3", 0600, parent, (u32 *)0xFFE0020C);
		debugfs_create_x32("DCPLB_DATA4", 0600, parent, (u32 *)0xFFE00210);
		debugfs_create_x32("DCPLB_DATA5", 0600, parent, (u32 *)0xFFE00214);
		debugfs_create_x32("DCPLB_DATA6", 0600, parent, (u32 *)0xFFE00218);
		debugfs_create_x32("DCPLB_DATA7", 0600, parent, (u32 *)0xFFE0021C);
		debugfs_create_x32("DCPLB_DATA8", 0600, parent, (u32 *)0xFFE00220);
		debugfs_create_x32("DCPLB_DATA9", 0600, parent, (u32 *)0xFFE00224);
		debugfs_create_x32("DCPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0000C);
		debugfs_create_x32("DMEM_CONTROL", 0600, parent, (u32 *)0xFFE00004);
		debugfs_create_x32("DTEST_COMMAND", 0600, parent, (u32 *)0xFFE00300);
		debugfs_create_x32("DTEST_DATA0", 0600, parent, (u32 *)0xFFE00400);
		debugfs_create_x32("DTEST_DATA1", 0600, parent, (u32 *)0xFFE00404);
		debugfs_create_x32("SRAM_BASE_ADDR", 0600, parent, (u32 *)0xFFE00000);

		parent = debugfs_create_dir("MDMA Destination 0", top);
		debugfs_create_x16("MDMA_D0_CONFIG", 0600, parent, (u16 *)0xFFC00F08);
		debugfs_create_x32("MDMA_D0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F24);
		debugfs_create_x32("MDMA_D0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F20);
		debugfs_create_x16("MDMA_D0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F30);
		debugfs_create_x16("MDMA_D0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F38);
		debugfs_create_x16("MDMA_D0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F28);
		debugfs_create_x32("MDMA_D0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F00);
		debugfs_create_x16("MDMA_D0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F2C);
		debugfs_create_x32("MDMA_D0_START_ADDR", 0600, parent, (u32 *)0xFFC00F04);
		debugfs_create_x16("MDMA_D0_X_COUNT", 0600, parent, (u16 *)0xFFC00F10);
		debugfs_create_x16("MDMA_D0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F14);
		debugfs_create_x16("MDMA_D0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F18);
		debugfs_create_x16("MDMA_D0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F1C);

		parent = debugfs_create_dir("MDMA Destination 1", top);
		debugfs_create_x16("MDMA_D1_CONFIG", 0600, parent, (u16 *)0xFFC00F88);
		debugfs_create_x32("MDMA_D1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FA4);
		debugfs_create_x32("MDMA_D1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FA0);
		debugfs_create_x16("MDMA_D1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FB0);
		debugfs_create_x16("MDMA_D1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FB8);
		debugfs_create_x16("MDMA_D1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FA8);
		debugfs_create_x32("MDMA_D1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F80);
		debugfs_create_x16("MDMA_D1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FAC);
		debugfs_create_x32("MDMA_D1_START_ADDR", 0600, parent, (u32 *)0xFFC00F84);
		debugfs_create_x16("MDMA_D1_X_COUNT", 0600, parent, (u16 *)0xFFC00F90);
		debugfs_create_x16("MDMA_D1_X_MODIFY", 0600, parent, (u16 *)0xFFC00F94);
		debugfs_create_x16("MDMA_D1_Y_COUNT", 0600, parent, (u16 *)0xFFC00F98);
		debugfs_create_x16("MDMA_D1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F9C);

		parent = debugfs_create_dir("MDMA Source 0", top);
		debugfs_create_x16("MDMA_S0_CONFIG", 0600, parent, (u16 *)0xFFC00F48);
		debugfs_create_x32("MDMA_S0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F64);
		debugfs_create_x32("MDMA_S0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F60);
		debugfs_create_x16("MDMA_S0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F70);
		debugfs_create_x16("MDMA_S0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F78);
		debugfs_create_x16("MDMA_S0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F68);
		debugfs_create_x32("MDMA_S0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F40);
		debugfs_create_x16("MDMA_S0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F6C);
		debugfs_create_x32("MDMA_S0_START_ADDR", 0600, parent, (u32 *)0xFFC00F44);
		debugfs_create_x16("MDMA_S0_X_COUNT", 0600, parent, (u16 *)0xFFC00F50);
		debugfs_create_x16("MDMA_S0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F54);
		debugfs_create_x16("MDMA_S0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F58);
		debugfs_create_x16("MDMA_S0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F5C);

		parent = debugfs_create_dir("MDMA Source 1", top);
		debugfs_create_x16("MDMA_S1_CONFIG", 0600, parent, (u16 *)0xFFC00FC8);
		debugfs_create_x32("MDMA_S1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FE4);
		debugfs_create_x32("MDMA_S1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FE0);
		debugfs_create_x16("MDMA_S1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FF0);
		debugfs_create_x16("MDMA_S1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FF8);
		debugfs_create_x16("MDMA_S1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FE8);
		debugfs_create_x32("MDMA_S1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00FC0);
		debugfs_create_x16("MDMA_S1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FEC);
		debugfs_create_x32("MDMA_S1_START_ADDR", 0600, parent, (u32 *)0xFFC00FC4);
		debugfs_create_x16("MDMA_S1_X_COUNT", 0600, parent, (u16 *)0xFFC00FD0);
		debugfs_create_x16("MDMA_S1_X_MODIFY", 0600, parent, (u16 *)0xFFC00FD4);
		debugfs_create_x16("MDMA_S1_Y_COUNT", 0600, parent, (u16 *)0xFFC00FD8);
		debugfs_create_x16("MDMA_S1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00FDC);

		parent = debugfs_create_dir("Mailbox Registers", top);
		debugfs_create_x16("CAN_MB00_DATA0", 0600, parent, (u16 *)0xFFC02C00);
		debugfs_create_x16("CAN_MB00_DATA1", 0600, parent, (u16 *)0xFFC02C04);
		debugfs_create_x16("CAN_MB00_DATA2", 0600, parent, (u16 *)0xFFC02C08);
		debugfs_create_x16("CAN_MB00_DATA3", 0600, parent, (u16 *)0xFFC02C0C);
		debugfs_create_x16("CAN_MB00_ID0", 0600, parent, (u16 *)0xFFC02C18);
		debugfs_create_x16("CAN_MB00_ID1", 0600, parent, (u16 *)0xFFC02C1C);
		debugfs_create_x16("CAN_MB00_LENGTH", 0600, parent, (u16 *)0xFFC02C10);
		debugfs_create_x16("CAN_MB00_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C14);
		debugfs_create_x16("CAN_MB01_DATA0", 0600, parent, (u16 *)0xFFC02C20);
		debugfs_create_x16("CAN_MB01_DATA1", 0600, parent, (u16 *)0xFFC02C24);
		debugfs_create_x16("CAN_MB01_DATA2", 0600, parent, (u16 *)0xFFC02C28);
		debugfs_create_x16("CAN_MB01_DATA3", 0600, parent, (u16 *)0xFFC02C2C);
		debugfs_create_x16("CAN_MB01_ID0", 0600, parent, (u16 *)0xFFC02C38);
		debugfs_create_x16("CAN_MB01_ID1", 0600, parent, (u16 *)0xFFC02C3C);
		debugfs_create_x16("CAN_MB01_LENGTH", 0600, parent, (u16 *)0xFFC02C30);
		debugfs_create_x16("CAN_MB01_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C34);
		debugfs_create_x16("CAN_MB02_DATA0", 0600, parent, (u16 *)0xFFC02C40);
		debugfs_create_x16("CAN_MB02_DATA1", 0600, parent, (u16 *)0xFFC02C44);
		debugfs_create_x16("CAN_MB02_DATA2", 0600, parent, (u16 *)0xFFC02C48);
		debugfs_create_x16("CAN_MB02_DATA3", 0600, parent, (u16 *)0xFFC02C4C);
		debugfs_create_x16("CAN_MB02_ID0", 0600, parent, (u16 *)0xFFC02C58);
		debugfs_create_x16("CAN_MB02_ID1", 0600, parent, (u16 *)0xFFC02C5C);
		debugfs_create_x16("CAN_MB02_LENGTH", 0600, parent, (u16 *)0xFFC02C50);
		debugfs_create_x16("CAN_MB02_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C54);
		debugfs_create_x16("CAN_MB03_DATA0", 0600, parent, (u16 *)0xFFC02C60);
		debugfs_create_x16("CAN_MB03_DATA1", 0600, parent, (u16 *)0xFFC02C64);
		debugfs_create_x16("CAN_MB03_DATA2", 0600, parent, (u16 *)0xFFC02C68);
		debugfs_create_x16("CAN_MB03_DATA3", 0600, parent, (u16 *)0xFFC02C6C);
		debugfs_create_x16("CAN_MB03_ID0", 0600, parent, (u16 *)0xFFC02C78);
		debugfs_create_x16("CAN_MB03_ID1", 0600, parent, (u16 *)0xFFC02C7C);
		debugfs_create_x16("CAN_MB03_LENGTH", 0600, parent, (u16 *)0xFFC02C70);
		debugfs_create_x16("CAN_MB03_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C74);
		debugfs_create_x16("CAN_MB04_DATA0", 0600, parent, (u16 *)0xFFC02C80);
		debugfs_create_x16("CAN_MB04_DATA1", 0600, parent, (u16 *)0xFFC02C84);
		debugfs_create_x16("CAN_MB04_DATA2", 0600, parent, (u16 *)0xFFC02C88);
		debugfs_create_x16("CAN_MB04_DATA3", 0600, parent, (u16 *)0xFFC02C8C);
		debugfs_create_x16("CAN_MB04_ID0", 0600, parent, (u16 *)0xFFC02C98);
		debugfs_create_x16("CAN_MB04_ID1", 0600, parent, (u16 *)0xFFC02C9C);
		debugfs_create_x16("CAN_MB04_LENGTH", 0600, parent, (u16 *)0xFFC02C90);
		debugfs_create_x16("CAN_MB04_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C94);
		debugfs_create_x16("CAN_MB05_DATA0", 0600, parent, (u16 *)0xFFC02CA0);
		debugfs_create_x16("CAN_MB05_DATA1", 0600, parent, (u16 *)0xFFC02CA4);
		debugfs_create_x16("CAN_MB05_DATA2", 0600, parent, (u16 *)0xFFC02CA8);
		debugfs_create_x16("CAN_MB05_DATA3", 0600, parent, (u16 *)0xFFC02CAC);
		debugfs_create_x16("CAN_MB05_ID0", 0600, parent, (u16 *)0xFFC02CB8);
		debugfs_create_x16("CAN_MB05_ID1", 0600, parent, (u16 *)0xFFC02CBC);
		debugfs_create_x16("CAN_MB05_LENGTH", 0600, parent, (u16 *)0xFFC02CB0);
		debugfs_create_x16("CAN_MB05_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CB4);
		debugfs_create_x16("CAN_MB06_DATA0", 0600, parent, (u16 *)0xFFC02CC0);
		debugfs_create_x16("CAN_MB06_DATA1", 0600, parent, (u16 *)0xFFC02CC4);
		debugfs_create_x16("CAN_MB06_DATA2", 0600, parent, (u16 *)0xFFC02CC8);
		debugfs_create_x16("CAN_MB06_DATA3", 0600, parent, (u16 *)0xFFC02CCC);
		debugfs_create_x16("CAN_MB06_ID0", 0600, parent, (u16 *)0xFFC02CD8);
		debugfs_create_x16("CAN_MB06_ID1", 0600, parent, (u16 *)0xFFC02CDC);
		debugfs_create_x16("CAN_MB06_LENGTH", 0600, parent, (u16 *)0xFFC02CD0);
		debugfs_create_x16("CAN_MB06_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CD4);
		debugfs_create_x16("CAN_MB07_DATA0", 0600, parent, (u16 *)0xFFC02CE0);
		debugfs_create_x16("CAN_MB07_DATA1", 0600, parent, (u16 *)0xFFC02CE4);
		debugfs_create_x16("CAN_MB07_DATA2", 0600, parent, (u16 *)0xFFC02CE8);
		debugfs_create_x16("CAN_MB07_DATA3", 0600, parent, (u16 *)0xFFC02CEC);
		debugfs_create_x16("CAN_MB07_ID0", 0600, parent, (u16 *)0xFFC02CF8);
		debugfs_create_x16("CAN_MB07_ID1", 0600, parent, (u16 *)0xFFC02CFC);
		debugfs_create_x16("CAN_MB07_LENGTH", 0600, parent, (u16 *)0xFFC02CF0);
		debugfs_create_x16("CAN_MB07_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CF4);
		debugfs_create_x16("CAN_MB08_DATA0", 0600, parent, (u16 *)0xFFC02D00);
		debugfs_create_x16("CAN_MB08_DATA1", 0600, parent, (u16 *)0xFFC02D04);
		debugfs_create_x16("CAN_MB08_DATA2", 0600, parent, (u16 *)0xFFC02D08);
		debugfs_create_x16("CAN_MB08_DATA3", 0600, parent, (u16 *)0xFFC02D0C);
		debugfs_create_x16("CAN_MB08_ID0", 0600, parent, (u16 *)0xFFC02D18);
		debugfs_create_x16("CAN_MB08_ID1", 0600, parent, (u16 *)0xFFC02D1C);
		debugfs_create_x16("CAN_MB08_LENGTH", 0600, parent, (u16 *)0xFFC02D10);
		debugfs_create_x16("CAN_MB08_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D14);
		debugfs_create_x16("CAN_MB09_DATA0", 0600, parent, (u16 *)0xFFC02D20);
		debugfs_create_x16("CAN_MB09_DATA1", 0600, parent, (u16 *)0xFFC02D24);
		debugfs_create_x16("CAN_MB09_DATA2", 0600, parent, (u16 *)0xFFC02D28);
		debugfs_create_x16("CAN_MB09_DATA3", 0600, parent, (u16 *)0xFFC02D2C);
		debugfs_create_x16("CAN_MB09_ID0", 0600, parent, (u16 *)0xFFC02D38);
		debugfs_create_x16("CAN_MB09_ID1", 0600, parent, (u16 *)0xFFC02D3C);
		debugfs_create_x16("CAN_MB09_LENGTH", 0600, parent, (u16 *)0xFFC02D30);
		debugfs_create_x16("CAN_MB09_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D34);
		debugfs_create_x16("CAN_MB10_DATA0", 0600, parent, (u16 *)0xFFC02D40);
		debugfs_create_x16("CAN_MB10_DATA1", 0600, parent, (u16 *)0xFFC02D44);
		debugfs_create_x16("CAN_MB10_DATA2", 0600, parent, (u16 *)0xFFC02D48);
		debugfs_create_x16("CAN_MB10_DATA3", 0600, parent, (u16 *)0xFFC02D4C);
		debugfs_create_x16("CAN_MB10_ID0", 0600, parent, (u16 *)0xFFC02D58);
		debugfs_create_x16("CAN_MB10_ID1", 0600, parent, (u16 *)0xFFC02D5C);
		debugfs_create_x16("CAN_MB10_LENGTH", 0600, parent, (u16 *)0xFFC02D50);
		debugfs_create_x16("CAN_MB10_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D54);
		debugfs_create_x16("CAN_MB11_DATA0", 0600, parent, (u16 *)0xFFC02D60);
		debugfs_create_x16("CAN_MB11_DATA1", 0600, parent, (u16 *)0xFFC02D64);
		debugfs_create_x16("CAN_MB11_DATA2", 0600, parent, (u16 *)0xFFC02D68);
		debugfs_create_x16("CAN_MB11_DATA3", 0600, parent, (u16 *)0xFFC02D6C);
		debugfs_create_x16("CAN_MB11_ID0", 0600, parent, (u16 *)0xFFC02D78);
		debugfs_create_x16("CAN_MB11_ID1", 0600, parent, (u16 *)0xFFC02D7C);
		debugfs_create_x16("CAN_MB11_LENGTH", 0600, parent, (u16 *)0xFFC02D70);
		debugfs_create_x16("CAN_MB11_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D74);
		debugfs_create_x16("CAN_MB12_DATA0", 0600, parent, (u16 *)0xFFC02D80);
		debugfs_create_x16("CAN_MB12_DATA1", 0600, parent, (u16 *)0xFFC02D84);
		debugfs_create_x16("CAN_MB12_DATA2", 0600, parent, (u16 *)0xFFC02D88);
		debugfs_create_x16("CAN_MB12_DATA3", 0600, parent, (u16 *)0xFFC02D8C);
		debugfs_create_x16("CAN_MB12_ID0", 0600, parent, (u16 *)0xFFC02D98);
		debugfs_create_x16("CAN_MB12_ID1", 0600, parent, (u16 *)0xFFC02D9C);
		debugfs_create_x16("CAN_MB12_LENGTH", 0600, parent, (u16 *)0xFFC02D90);
		debugfs_create_x16("CAN_MB12_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D94);
		debugfs_create_x16("CAN_MB13_DATA0", 0600, parent, (u16 *)0xFFC02DA0);
		debugfs_create_x16("CAN_MB13_DATA1", 0600, parent, (u16 *)0xFFC02DA4);
		debugfs_create_x16("CAN_MB13_DATA2", 0600, parent, (u16 *)0xFFC02DA8);
		debugfs_create_x16("CAN_MB13_DATA3", 0600, parent, (u16 *)0xFFC02DAC);
		debugfs_create_x16("CAN_MB13_ID0", 0600, parent, (u16 *)0xFFC02DB8);
		debugfs_create_x16("CAN_MB13_ID1", 0600, parent, (u16 *)0xFFC02DBC);
		debugfs_create_x16("CAN_MB13_LENGTH", 0600, parent, (u16 *)0xFFC02DB0);
		debugfs_create_x16("CAN_MB13_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DB4);
		debugfs_create_x16("CAN_MB14_DATA0", 0600, parent, (u16 *)0xFFC02DC0);
		debugfs_create_x16("CAN_MB14_DATA1", 0600, parent, (u16 *)0xFFC02DC4);
		debugfs_create_x16("CAN_MB14_DATA2", 0600, parent, (u16 *)0xFFC02DC8);
		debugfs_create_x16("CAN_MB14_DATA3", 0600, parent, (u16 *)0xFFC02DCC);
		debugfs_create_x16("CAN_MB14_ID0", 0600, parent, (u16 *)0xFFC02DD8);
		debugfs_create_x16("CAN_MB14_ID1", 0600, parent, (u16 *)0xFFC02DDC);
		debugfs_create_x16("CAN_MB14_LENGTH", 0600, parent, (u16 *)0xFFC02DD0);
		debugfs_create_x16("CAN_MB14_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DD4);
		debugfs_create_x16("CAN_MB15_DATA0", 0600, parent, (u16 *)0xFFC02DE0);
		debugfs_create_x16("CAN_MB15_DATA1", 0600, parent, (u16 *)0xFFC02DE4);
		debugfs_create_x16("CAN_MB15_DATA2", 0600, parent, (u16 *)0xFFC02DE8);
		debugfs_create_x16("CAN_MB15_DATA3", 0600, parent, (u16 *)0xFFC02DEC);
		debugfs_create_x16("CAN_MB15_ID0", 0600, parent, (u16 *)0xFFC02DF8);
		debugfs_create_x16("CAN_MB15_ID1", 0600, parent, (u16 *)0xFFC02DFC);
		debugfs_create_x16("CAN_MB15_LENGTH", 0600, parent, (u16 *)0xFFC02DF0);
		debugfs_create_x16("CAN_MB15_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DF4);
		debugfs_create_x16("CAN_MB16_DATA0", 0600, parent, (u16 *)0xFFC02E00);
		debugfs_create_x16("CAN_MB16_DATA1", 0600, parent, (u16 *)0xFFC02E04);
		debugfs_create_x16("CAN_MB16_DATA2", 0600, parent, (u16 *)0xFFC02E08);
		debugfs_create_x16("CAN_MB16_DATA3", 0600, parent, (u16 *)0xFFC02E0C);
		debugfs_create_x16("CAN_MB16_ID0", 0600, parent, (u16 *)0xFFC02E18);
		debugfs_create_x16("CAN_MB16_ID1", 0600, parent, (u16 *)0xFFC02E1C);
		debugfs_create_x16("CAN_MB16_LENGTH", 0600, parent, (u16 *)0xFFC02E10);
		debugfs_create_x16("CAN_MB16_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E14);
		debugfs_create_x16("CAN_MB17_DATA0", 0600, parent, (u16 *)0xFFC02E20);
		debugfs_create_x16("CAN_MB17_DATA1", 0600, parent, (u16 *)0xFFC02E24);
		debugfs_create_x16("CAN_MB17_DATA2", 0600, parent, (u16 *)0xFFC02E28);
		debugfs_create_x16("CAN_MB17_DATA3", 0600, parent, (u16 *)0xFFC02E2C);
		debugfs_create_x16("CAN_MB17_ID0", 0600, parent, (u16 *)0xFFC02E38);
		debugfs_create_x16("CAN_MB17_ID1", 0600, parent, (u16 *)0xFFC02E3C);
		debugfs_create_x16("CAN_MB17_LENGTH", 0600, parent, (u16 *)0xFFC02E30);
		debugfs_create_x16("CAN_MB17_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E34);
		debugfs_create_x16("CAN_MB18_DATA0", 0600, parent, (u16 *)0xFFC02E40);
		debugfs_create_x16("CAN_MB18_DATA1", 0600, parent, (u16 *)0xFFC02E44);
		debugfs_create_x16("CAN_MB18_DATA2", 0600, parent, (u16 *)0xFFC02E48);
		debugfs_create_x16("CAN_MB18_DATA3", 0600, parent, (u16 *)0xFFC02E4C);
		debugfs_create_x16("CAN_MB18_ID0", 0600, parent, (u16 *)0xFFC02E58);
		debugfs_create_x16("CAN_MB18_ID1", 0600, parent, (u16 *)0xFFC02E5C);
		debugfs_create_x16("CAN_MB18_LENGTH", 0600, parent, (u16 *)0xFFC02E50);
		debugfs_create_x16("CAN_MB18_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E54);
		debugfs_create_x16("CAN_MB19_DATA0", 0600, parent, (u16 *)0xFFC02E60);
		debugfs_create_x16("CAN_MB19_DATA1", 0600, parent, (u16 *)0xFFC02E64);
		debugfs_create_x16("CAN_MB19_DATA2", 0600, parent, (u16 *)0xFFC02E68);
		debugfs_create_x16("CAN_MB19_DATA3", 0600, parent, (u16 *)0xFFC02E6C);
		debugfs_create_x16("CAN_MB19_ID0", 0600, parent, (u16 *)0xFFC02E78);
		debugfs_create_x16("CAN_MB19_ID1", 0600, parent, (u16 *)0xFFC02E7C);
		debugfs_create_x16("CAN_MB19_LENGTH", 0600, parent, (u16 *)0xFFC02E70);
		debugfs_create_x16("CAN_MB19_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E74);
		debugfs_create_x16("CAN_MB20_DATA0", 0600, parent, (u16 *)0xFFC02E80);
		debugfs_create_x16("CAN_MB20_DATA1", 0600, parent, (u16 *)0xFFC02E84);
		debugfs_create_x16("CAN_MB20_DATA2", 0600, parent, (u16 *)0xFFC02E88);
		debugfs_create_x16("CAN_MB20_DATA3", 0600, parent, (u16 *)0xFFC02E8C);
		debugfs_create_x16("CAN_MB20_ID0", 0600, parent, (u16 *)0xFFC02E98);
		debugfs_create_x16("CAN_MB20_ID1", 0600, parent, (u16 *)0xFFC02E9C);
		debugfs_create_x16("CAN_MB20_LENGTH", 0600, parent, (u16 *)0xFFC02E90);
		debugfs_create_x16("CAN_MB20_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E94);
		debugfs_create_x16("CAN_MB21_DATA0", 0600, parent, (u16 *)0xFFC02EA0);
		debugfs_create_x16("CAN_MB21_DATA1", 0600, parent, (u16 *)0xFFC02EA4);
		debugfs_create_x16("CAN_MB21_DATA2", 0600, parent, (u16 *)0xFFC02EA8);
		debugfs_create_x16("CAN_MB21_DATA3", 0600, parent, (u16 *)0xFFC02EAC);
		debugfs_create_x16("CAN_MB21_ID0", 0600, parent, (u16 *)0xFFC02EB8);
		debugfs_create_x16("CAN_MB21_ID1", 0600, parent, (u16 *)0xFFC02EBC);
		debugfs_create_x16("CAN_MB21_LENGTH", 0600, parent, (u16 *)0xFFC02EB0);
		debugfs_create_x16("CAN_MB21_TIMESTAMP", 0600, parent, (u16 *)0xFFC02EB4);
		debugfs_create_x16("CAN_MB22_DATA0", 0600, parent, (u16 *)0xFFC02EC0);
		debugfs_create_x16("CAN_MB22_DATA1", 0600, parent, (u16 *)0xFFC02EC4);
		debugfs_create_x16("CAN_MB22_DATA2", 0600, parent, (u16 *)0xFFC02EC8);
		debugfs_create_x16("CAN_MB22_DATA3", 0600, parent, (u16 *)0xFFC02ECC);
		debugfs_create_x16("CAN_MB22_ID0", 0600, parent, (u16 *)0xFFC02ED8);
		debugfs_create_x16("CAN_MB22_ID1", 0600, parent, (u16 *)0xFFC02EDC);
		debugfs_create_x16("CAN_MB22_LENGTH", 0600, parent, (u16 *)0xFFC02ED0);
		debugfs_create_x16("CAN_MB22_TIMESTAMP", 0600, parent, (u16 *)0xFFC02ED4);
		debugfs_create_x16("CAN_MB23_DATA0", 0600, parent, (u16 *)0xFFC02EE0);
		debugfs_create_x16("CAN_MB23_DATA1", 0600, parent, (u16 *)0xFFC02EE4);
		debugfs_create_x16("CAN_MB23_DATA2", 0600, parent, (u16 *)0xFFC02EE8);
		debugfs_create_x16("CAN_MB23_DATA3", 0600, parent, (u16 *)0xFFC02EEC);
		debugfs_create_x16("CAN_MB23_ID0", 0600, parent, (u16 *)0xFFC02EF8);
		debugfs_create_x16("CAN_MB23_ID1", 0600, parent, (u16 *)0xFFC02EFC);
		debugfs_create_x16("CAN_MB23_LENGTH", 0600, parent, (u16 *)0xFFC02EF0);
		debugfs_create_x16("CAN_MB23_TIMESTAMP", 0600, parent, (u16 *)0xFFC02EF4);
		debugfs_create_x16("CAN_MB24_DATA0", 0600, parent, (u16 *)0xFFC02F00);
		debugfs_create_x16("CAN_MB24_DATA1", 0600, parent, (u16 *)0xFFC02F04);
		debugfs_create_x16("CAN_MB24_DATA2", 0600, parent, (u16 *)0xFFC02F08);
		debugfs_create_x16("CAN_MB24_DATA3", 0600, parent, (u16 *)0xFFC02F0C);
		debugfs_create_x16("CAN_MB24_ID0", 0600, parent, (u16 *)0xFFC02F18);
		debugfs_create_x16("CAN_MB24_ID1", 0600, parent, (u16 *)0xFFC02F1C);
		debugfs_create_x16("CAN_MB24_LENGTH", 0600, parent, (u16 *)0xFFC02F10);
		debugfs_create_x16("CAN_MB24_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F14);
		debugfs_create_x16("CAN_MB25_DATA0", 0600, parent, (u16 *)0xFFC02F20);
		debugfs_create_x16("CAN_MB25_DATA1", 0600, parent, (u16 *)0xFFC02F24);
		debugfs_create_x16("CAN_MB25_DATA2", 0600, parent, (u16 *)0xFFC02F28);
		debugfs_create_x16("CAN_MB25_DATA3", 0600, parent, (u16 *)0xFFC02F2C);
		debugfs_create_x16("CAN_MB25_ID0", 0600, parent, (u16 *)0xFFC02F38);
		debugfs_create_x16("CAN_MB25_ID1", 0600, parent, (u16 *)0xFFC02F3C);
		debugfs_create_x16("CAN_MB25_LENGTH", 0600, parent, (u16 *)0xFFC02F30);
		debugfs_create_x16("CAN_MB25_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F34);
		debugfs_create_x16("CAN_MB26_DATA0", 0600, parent, (u16 *)0xFFC02F40);
		debugfs_create_x16("CAN_MB26_DATA1", 0600, parent, (u16 *)0xFFC02F44);
		debugfs_create_x16("CAN_MB26_DATA2", 0600, parent, (u16 *)0xFFC02F48);
		debugfs_create_x16("CAN_MB26_DATA3", 0600, parent, (u16 *)0xFFC02F4C);
		debugfs_create_x16("CAN_MB26_ID0", 0600, parent, (u16 *)0xFFC02F58);
		debugfs_create_x16("CAN_MB26_ID1", 0600, parent, (u16 *)0xFFC02F5C);
		debugfs_create_x16("CAN_MB26_LENGTH", 0600, parent, (u16 *)0xFFC02F50);
		debugfs_create_x16("CAN_MB26_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F54);
		debugfs_create_x16("CAN_MB27_DATA0", 0600, parent, (u16 *)0xFFC02F60);
		debugfs_create_x16("CAN_MB27_DATA1", 0600, parent, (u16 *)0xFFC02F64);
		debugfs_create_x16("CAN_MB27_DATA2", 0600, parent, (u16 *)0xFFC02F68);
		debugfs_create_x16("CAN_MB27_DATA3", 0600, parent, (u16 *)0xFFC02F6C);
		debugfs_create_x16("CAN_MB27_ID0", 0600, parent, (u16 *)0xFFC02F78);
		debugfs_create_x16("CAN_MB27_ID1", 0600, parent, (u16 *)0xFFC02F7C);
		debugfs_create_x16("CAN_MB27_LENGTH", 0600, parent, (u16 *)0xFFC02F70);
		debugfs_create_x16("CAN_MB27_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F74);
		debugfs_create_x16("CAN_MB28_DATA0", 0600, parent, (u16 *)0xFFC02F80);
		debugfs_create_x16("CAN_MB28_DATA1", 0600, parent, (u16 *)0xFFC02F84);
		debugfs_create_x16("CAN_MB28_DATA2", 0600, parent, (u16 *)0xFFC02F88);
		debugfs_create_x16("CAN_MB28_DATA3", 0600, parent, (u16 *)0xFFC02F8C);
		debugfs_create_x16("CAN_MB28_ID0", 0600, parent, (u16 *)0xFFC02F98);
		debugfs_create_x16("CAN_MB28_ID1", 0600, parent, (u16 *)0xFFC02F9C);
		debugfs_create_x16("CAN_MB28_LENGTH", 0600, parent, (u16 *)0xFFC02F90);
		debugfs_create_x16("CAN_MB28_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F94);
		debugfs_create_x16("CAN_MB29_DATA0", 0600, parent, (u16 *)0xFFC02FA0);
		debugfs_create_x16("CAN_MB29_DATA1", 0600, parent, (u16 *)0xFFC02FA4);
		debugfs_create_x16("CAN_MB29_DATA2", 0600, parent, (u16 *)0xFFC02FA8);
		debugfs_create_x16("CAN_MB29_DATA3", 0600, parent, (u16 *)0xFFC02FAC);
		debugfs_create_x16("CAN_MB29_ID0", 0600, parent, (u16 *)0xFFC02FB8);
		debugfs_create_x16("CAN_MB29_ID1", 0600, parent, (u16 *)0xFFC02FBC);
		debugfs_create_x16("CAN_MB29_LENGTH", 0600, parent, (u16 *)0xFFC02FB0);
		debugfs_create_x16("CAN_MB29_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FB4);
		debugfs_create_x16("CAN_MB30_DATA0", 0600, parent, (u16 *)0xFFC02FC0);
		debugfs_create_x16("CAN_MB30_DATA1", 0600, parent, (u16 *)0xFFC02FC4);
		debugfs_create_x16("CAN_MB30_DATA2", 0600, parent, (u16 *)0xFFC02FC8);
		debugfs_create_x16("CAN_MB30_DATA3", 0600, parent, (u16 *)0xFFC02FCC);
		debugfs_create_x16("CAN_MB30_ID0", 0600, parent, (u16 *)0xFFC02FD8);
		debugfs_create_x16("CAN_MB30_ID1", 0600, parent, (u16 *)0xFFC02FDC);
		debugfs_create_x16("CAN_MB30_LENGTH", 0600, parent, (u16 *)0xFFC02FD0);
		debugfs_create_x16("CAN_MB30_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FD4);
		debugfs_create_x16("CAN_MB31_DATA0", 0600, parent, (u16 *)0xFFC02FE0);
		debugfs_create_x16("CAN_MB31_DATA1", 0600, parent, (u16 *)0xFFC02FE4);
		debugfs_create_x16("CAN_MB31_DATA2", 0600, parent, (u16 *)0xFFC02FE8);
		debugfs_create_x16("CAN_MB31_DATA3", 0600, parent, (u16 *)0xFFC02FEC);
		debugfs_create_x16("CAN_MB31_ID0", 0600, parent, (u16 *)0xFFC02FF8);
		debugfs_create_x16("CAN_MB31_ID1", 0600, parent, (u16 *)0xFFC02FFC);
		debugfs_create_x16("CAN_MB31_LENGTH", 0600, parent, (u16 *)0xFFC02FF0);
		debugfs_create_x16("CAN_MB31_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FF4);

		parent = debugfs_create_dir("PLL", top);
		debugfs_create_x16("PLL_CTL", 0600, parent, (u16 *)0xFFC00000);
		debugfs_create_x16("PLL_DIV", 0600, parent, (u16 *)0xFFC00004);
		debugfs_create_x16("PLL_LOCKCNT", 0600, parent, (u16 *)0xFFC00010);
		debugfs_create_x16("PLL_STAT", 0600, parent, (u16 *)0xFFC0000C);
		debugfs_create_x16("VR_CTL", 0600, parent, (u16 *)0xFFC00008);

		parent = debugfs_create_dir("PPI", top);
		debugfs_create_x16("PPI_CONTROL", 0600, parent, (u16 *)0xFFC01000);
		debugfs_create_x16("PPI_COUNT", 0600, parent, (u16 *)0xFFC01008);
		debugfs_create_x16("PPI_DELAY", 0600, parent, (u16 *)0xFFC0100C);
		debugfs_create_x16("PPI_FRAME", 0600, parent, (u16 *)0xFFC01010);
		debugfs_create_x16("PPI_STATUS", 0600, parent, (u16 *)0xFFC01004);

		parent = debugfs_create_dir("Performance Monitor", top);
		debugfs_create_x32("PFCNTR0", 0600, parent, (u32 *)0xFFE08100);
		debugfs_create_x32("PFCNTR1", 0600, parent, (u32 *)0xFFE08104);
		debugfs_create_x32("PFCTL", 0600, parent, (u32 *)0xFFE08000);

		parent = debugfs_create_dir("Pin Control", top);
		debugfs_create_x16("PORTF_FER", 0600, parent, (u16 *)0xFFC03200);
		debugfs_create_x16("PORTG_FER", 0600, parent, (u16 *)0xFFC03204);
		debugfs_create_x16("PORTH_FER", 0600, parent, (u16 *)0xFFC03208);
		debugfs_create_x16("PORT_MUX", 0600, parent, (u16 *)0xFFC0320C);

		parent = debugfs_create_dir("Port I-O", top);
		debugfs_create_x16("PORTFIO", 0600, parent, (u16 *)0xFFC00700);
		debugfs_create_x16("PORTFIO_BOTH", 0600, parent, (u16 *)0xFFC0073C);
		debugfs_create_x16("PORTFIO_CLEAR", 0600, parent, (u16 *)0xFFC00704);
		debugfs_create_x16("PORTFIO_DIR", 0600, parent, (u16 *)0xFFC00730);
		debugfs_create_x16("PORTFIO_EDGE", 0600, parent, (u16 *)0xFFC00738);
		debugfs_create_x16("PORTFIO_INEN", 0600, parent, (u16 *)0xFFC00740);
		debugfs_create_x16("PORTFIO_MASKA", 0600, parent, (u16 *)0xFFC00710);
		debugfs_create_x16("PORTFIO_MASKA_CLEAR", 0600, parent, (u16 *)0xFFC00714);
		debugfs_create_x16("PORTFIO_MASKA_SET", 0600, parent, (u16 *)0xFFC00718);
		debugfs_create_x16("PORTFIO_MASKA_TOGGLE", 0600, parent, (u16 *)0xFFC0071C);
		debugfs_create_x16("PORTFIO_MASKB", 0600, parent, (u16 *)0xFFC00720);
		debugfs_create_x16("PORTFIO_MASKB_CLEAR", 0600, parent, (u16 *)0xFFC00724);
		debugfs_create_x16("PORTFIO_MASKB_SET", 0600, parent, (u16 *)0xFFC00728);
		debugfs_create_x16("PORTFIO_MASKB_TOGGLE", 0600, parent, (u16 *)0xFFC0072C);
		debugfs_create_x16("PORTFIO_POLAR", 0600, parent, (u16 *)0xFFC00734);
		debugfs_create_x16("PORTFIO_SET", 0600, parent, (u16 *)0xFFC00708);
		debugfs_create_x16("PORTFIO_TOGGLE", 0600, parent, (u16 *)0xFFC0070C);
		debugfs_create_x16("PORTGIO", 0600, parent, (u16 *)0xFFC01500);
		debugfs_create_x16("PORTGIO_BOTH", 0600, parent, (u16 *)0xFFC0153C);
		debugfs_create_x16("PORTGIO_CLEAR", 0600, parent, (u16 *)0xFFC01504);
		debugfs_create_x16("PORTGIO_DIR", 0600, parent, (u16 *)0xFFC01530);
		debugfs_create_x16("PORTGIO_EDGE", 0600, parent, (u16 *)0xFFC01538);
		debugfs_create_x16("PORTGIO_INEN", 0600, parent, (u16 *)0xFFC01540);
		debugfs_create_x16("PORTGIO_MASKA", 0600, parent, (u16 *)0xFFC01510);
		debugfs_create_x16("PORTGIO_MASKA_CLEAR", 0600, parent, (u16 *)0xFFC01514);
		debugfs_create_x16("PORTGIO_MASKA_SET", 0600, parent, (u16 *)0xFFC01518);
		debugfs_create_x16("PORTGIO_MASKA_TOGGLE", 0600, parent, (u16 *)0xFFC0151C);
		debugfs_create_x16("PORTGIO_MASKB", 0600, parent, (u16 *)0xFFC01520);
		debugfs_create_x16("PORTGIO_MASKB_CLEAR", 0600, parent, (u16 *)0xFFC01524);
		debugfs_create_x16("PORTGIO_MASKB_SET", 0600, parent, (u16 *)0xFFC01528);
		debugfs_create_x16("PORTGIO_MASKB_TOGGLE", 0600, parent, (u16 *)0xFFC0152C);
		debugfs_create_x16("PORTGIO_POLAR", 0600, parent, (u16 *)0xFFC01534);
		debugfs_create_x16("PORTGIO_SET", 0600, parent, (u16 *)0xFFC01508);
		debugfs_create_x16("PORTGIO_TOGGLE", 0600, parent, (u16 *)0xFFC0150C);
		debugfs_create_x16("PORTHIO", 0600, parent, (u16 *)0xFFC01700);
		debugfs_create_x16("PORTHIO_BOTH", 0600, parent, (u16 *)0xFFC0173C);
		debugfs_create_x16("PORTHIO_CLEAR", 0600, parent, (u16 *)0xFFC01704);
		debugfs_create_x16("PORTHIO_DIR", 0600, parent, (u16 *)0xFFC01730);
		debugfs_create_x16("PORTHIO_EDGE", 0600, parent, (u16 *)0xFFC01738);
		debugfs_create_x16("PORTHIO_INEN", 0600, parent, (u16 *)0xFFC01740);
		debugfs_create_x16("PORTHIO_MASKA", 0600, parent, (u16 *)0xFFC01710);
		debugfs_create_x16("PORTHIO_MASKA_CLEAR", 0600, parent, (u16 *)0xFFC01714);
		debugfs_create_x16("PORTHIO_MASKA_SET", 0600, parent, (u16 *)0xFFC01718);
		debugfs_create_x16("PORTHIO_MASKA_TOGGLE", 0600, parent, (u16 *)0xFFC0171C);
		debugfs_create_x16("PORTHIO_MASKB", 0600, parent, (u16 *)0xFFC01720);
		debugfs_create_x16("PORTHIO_MASKB_CLEAR", 0600, parent, (u16 *)0xFFC01724);
		debugfs_create_x16("PORTHIO_MASKB_SET", 0600, parent, (u16 *)0xFFC01728);
		debugfs_create_x16("PORTHIO_MASKB_TOGGLE", 0600, parent, (u16 *)0xFFC0172C);
		debugfs_create_x16("PORTHIO_POLAR", 0600, parent, (u16 *)0xFFC01734);
		debugfs_create_x16("PORTHIO_SET", 0600, parent, (u16 *)0xFFC01708);
		debugfs_create_x16("PORTHIO_TOGGLE", 0600, parent, (u16 *)0xFFC0170C);

		parent = debugfs_create_dir("RTC", top);
		debugfs_create_x32("RTC_ALARM", 0600, parent, (u32 *)0xFFC00310);
		debugfs_create_x16("RTC_ICTL", 0600, parent, (u16 *)0xFFC00304);
		debugfs_create_x16("RTC_ISTAT", 0600, parent, (u16 *)0xFFC00308);
		debugfs_create_x16("RTC_PREN", 0600, parent, (u16 *)0xFFC00314);
		debugfs_create_x32("RTC_STAT", 0600, parent, (u32 *)0xFFC00300);
		debugfs_create_x16("RTC_SWCNT", 0600, parent, (u16 *)0xFFC0030C);

		parent = debugfs_create_dir("SPI", top);
		debugfs_create_x16("SPI_BAUD", 0600, parent, (u16 *)0xFFC00514);
		debugfs_create_x16("SPI_CTL", 0600, parent, (u16 *)0xFFC00500);
		debugfs_create_x16("SPI_FLG", 0600, parent, (u16 *)0xFFC00504);
		debugfs_create_x16("SPI_RDBR", 0600, parent, (u16 *)0xFFC00510);
		debugfs_create_x16("SPI_SHADOW", 0600, parent, (u16 *)0xFFC00518);
		debugfs_create_x16("SPI_STAT", 0600, parent, (u16 *)0xFFC00508);
		debugfs_create_x16("SPI_TDBR", 0600, parent, (u16 *)0xFFC0050C);

		parent = debugfs_create_dir("SPORT", top);
		debugfs_create_x16("SPORT0_CHNL", 0600, parent, (u16 *)0xFFC00834);
		debugfs_create_x16("SPORT0_MCMC1", 0600, parent, (u16 *)0xFFC00838);
		debugfs_create_x16("SPORT0_MCMC2", 0600, parent, (u16 *)0xFFC0083C);
		debugfs_create_x32("SPORT0_MRCS0", 0600, parent, (u32 *)0xFFC00850);
		debugfs_create_x32("SPORT0_MRCS1", 0600, parent, (u32 *)0xFFC00854);
		debugfs_create_x32("SPORT0_MRCS2", 0600, parent, (u32 *)0xFFC00858);
		debugfs_create_x32("SPORT0_MRCS3", 0600, parent, (u32 *)0xFFC0085C);
		debugfs_create_x32("SPORT0_MTCS0", 0600, parent, (u32 *)0xFFC00840);
		debugfs_create_x32("SPORT0_MTCS1", 0600, parent, (u32 *)0xFFC00844);
		debugfs_create_x32("SPORT0_MTCS2", 0600, parent, (u32 *)0xFFC00848);
		debugfs_create_x32("SPORT0_MTCS3", 0600, parent, (u32 *)0xFFC0084C);
		debugfs_create_x16("SPORT0_RCLKDIV", 0600, parent, (u16 *)0xFFC00828);
		debugfs_create_x16("SPORT0_RCR1", 0600, parent, (u16 *)0xFFC00820);
		debugfs_create_x16("SPORT0_RCR2", 0600, parent, (u16 *)0xFFC00824);
		debugfs_create_x16("SPORT0_RFSDIV", 0600, parent, (u16 *)0xFFC0082C);
		debugfs_create_x32("SPORT0_RX", 0600, parent, (u32 *)0xFFC00818);
		debugfs_create_x16("SPORT0_STAT", 0600, parent, (u16 *)0xFFC00830);
		debugfs_create_x16("SPORT0_TCLKDIV", 0600, parent, (u16 *)0xFFC00808);
		debugfs_create_x16("SPORT0_TCR1", 0600, parent, (u16 *)0xFFC00800);
		debugfs_create_x16("SPORT0_TCR2", 0600, parent, (u16 *)0xFFC00804);
		debugfs_create_x16("SPORT0_TFSDIV", 0600, parent, (u16 *)0xFFC0080C);
		debugfs_create_x32("SPORT0_TX", 0600, parent, (u32 *)0xFFC00810);
		debugfs_create_x16("SPORT1_CHNL", 0600, parent, (u16 *)0xFFC00934);
		debugfs_create_x16("SPORT1_MCMC1", 0600, parent, (u16 *)0xFFC00938);
		debugfs_create_x16("SPORT1_MCMC2", 0600, parent, (u16 *)0xFFC0093C);
		debugfs_create_x32("SPORT1_MRCS0", 0600, parent, (u32 *)0xFFC00950);
		debugfs_create_x32("SPORT1_MRCS1", 0600, parent, (u32 *)0xFFC00954);
		debugfs_create_x32("SPORT1_MRCS2", 0600, parent, (u32 *)0xFFC00958);
		debugfs_create_x32("SPORT1_MRCS3", 0600, parent, (u32 *)0xFFC0095C);
		debugfs_create_x32("SPORT1_MTCS0", 0600, parent, (u32 *)0xFFC00940);
		debugfs_create_x32("SPORT1_MTCS1", 0600, parent, (u32 *)0xFFC00944);
		debugfs_create_x32("SPORT1_MTCS2", 0600, parent, (u32 *)0xFFC00948);
		debugfs_create_x32("SPORT1_MTCS3", 0600, parent, (u32 *)0xFFC0094C);
		debugfs_create_x16("SPORT1_RCLKDIV", 0600, parent, (u16 *)0xFFC00928);
		debugfs_create_x16("SPORT1_RCR1", 0600, parent, (u16 *)0xFFC00920);
		debugfs_create_x16("SPORT1_RCR2", 0600, parent, (u16 *)0xFFC00924);
		debugfs_create_x16("SPORT1_RFSDIV", 0600, parent, (u16 *)0xFFC0092C);
		debugfs_create_x32("SPORT1_RX", 0600, parent, (u32 *)0xFFC00918);
		debugfs_create_x16("SPORT1_STAT", 0600, parent, (u16 *)0xFFC00930);
		debugfs_create_x16("SPORT1_TCLKDIV", 0600, parent, (u16 *)0xFFC00908);
		debugfs_create_x16("SPORT1_TCR1", 0600, parent, (u16 *)0xFFC00900);
		debugfs_create_x16("SPORT1_TCR2", 0600, parent, (u16 *)0xFFC00904);
		debugfs_create_x16("SPORT1_TFSDIV", 0600, parent, (u16 *)0xFFC0090C);
		debugfs_create_x32("SPORT1_TX", 0600, parent, (u32 *)0xFFC00910);

		parent = debugfs_create_dir("System Interrupt Controller Register File", top);
		debugfs_create_x32("SIC_IAR0", 0600, parent, (u32 *)0xFFC00110);
		debugfs_create_x32("SIC_IAR1", 0600, parent, (u32 *)0xFFC00114);
		debugfs_create_x32("SIC_IAR2", 0600, parent, (u32 *)0xFFC00118);
		debugfs_create_x32("SIC_IAR3", 0600, parent, (u32 *)0xFFC0011C);
		debugfs_create_x32("SIC_IMASK", 0600, parent, (u32 *)0xFFC0010C);
		debugfs_create_x32("SIC_ISR", 0600, parent, (u32 *)0xFFC00120);
		debugfs_create_x32("SIC_IWR", 0600, parent, (u32 *)0xFFC00124);
		debugfs_create_x32("SIC_RVECT", 0600, parent, (u32 *)0xFFC00108);
		debugfs_create_x16("SWRST", 0600, parent, (u16 *)0xFFC00100);
		debugfs_create_x16("SYSCR", 0600, parent, (u16 *)0xFFC00104);

		parent = debugfs_create_dir("TWI", top);
		debugfs_create_x16("TWI_CLKDIV", 0600, parent, (u16 *)0xFFC01400);
		debugfs_create_x16("TWI_CONTROL", 0600, parent, (u16 *)0xFFC01404);
		debugfs_create_x16("TWI_FIFO_CTL", 0600, parent, (u16 *)0xFFC01428);
		debugfs_create_x16("TWI_FIFO_STAT", 0600, parent, (u16 *)0xFFC0142C);
		debugfs_create_x16("TWI_INT_MASK", 0600, parent, (u16 *)0xFFC01424);
		debugfs_create_x16("TWI_INT_STAT", 0600, parent, (u16 *)0xFFC01420);
		debugfs_create_x16("TWI_MASTER_ADDR", 0600, parent, (u16 *)0xFFC0141C);
		debugfs_create_x16("TWI_MASTER_CTL", 0600, parent, (u16 *)0xFFC01414);
		debugfs_create_x16("TWI_MASTER_STAT", 0600, parent, (u16 *)0xFFC01418);
		debugfs_create_x16("TWI_RCV_DATA16", 0600, parent, (u16 *)0xFFC0148C);
		debugfs_create_x16("TWI_RCV_DATA8", 0600, parent, (u16 *)0xFFC01488);
		debugfs_create_x16("TWI_SLAVE_ADDR", 0600, parent, (u16 *)0xFFC01410);
		debugfs_create_x16("TWI_SLAVE_CTL", 0600, parent, (u16 *)0xFFC01408);
		debugfs_create_x16("TWI_SLAVE_STAT", 0600, parent, (u16 *)0xFFC0140C);
		debugfs_create_x16("TWI_XMT_DATA16", 0600, parent, (u16 *)0xFFC01484);
		debugfs_create_x16("TWI_XMT_DATA8", 0600, parent, (u16 *)0xFFC01480);

		parent = debugfs_create_dir("Timer Registers", top);
		debugfs_create_x16("TIMER0_CONFIG", 0600, parent, (u16 *)0xFFC00600);
		debugfs_create_x32("TIMER0_COUNTER", 0600, parent, (u32 *)0xFFC00604);
		debugfs_create_x32("TIMER0_PERIOD", 0600, parent, (u32 *)0xFFC00608);
		debugfs_create_x32("TIMER0_WIDTH", 0600, parent, (u32 *)0xFFC0060C);
		debugfs_create_x16("TIMER1_CONFIG", 0600, parent, (u16 *)0xFFC00610);
		debugfs_create_x32("TIMER1_COUNTER", 0600, parent, (u32 *)0xFFC00614);
		debugfs_create_x32("TIMER1_PERIOD", 0600, parent, (u32 *)0xFFC00618);
		debugfs_create_x32("TIMER1_WIDTH", 0600, parent, (u32 *)0xFFC0061C);
		debugfs_create_x16("TIMER2_CONFIG", 0600, parent, (u16 *)0xFFC00620);
		debugfs_create_x32("TIMER2_COUNTER", 0600, parent, (u32 *)0xFFC00624);
		debugfs_create_x32("TIMER2_PERIOD", 0600, parent, (u32 *)0xFFC00628);
		debugfs_create_x32("TIMER2_WIDTH", 0600, parent, (u32 *)0xFFC0062C);
		debugfs_create_x16("TIMER3_CONFIG", 0600, parent, (u16 *)0xFFC00630);
		debugfs_create_x32("TIMER3_COUNTER", 0600, parent, (u32 *)0xFFC00634);
		debugfs_create_x32("TIMER3_PERIOD", 0600, parent, (u32 *)0xFFC00638);
		debugfs_create_x32("TIMER3_WIDTH", 0600, parent, (u32 *)0xFFC0063C);
		debugfs_create_x16("TIMER4_CONFIG", 0600, parent, (u16 *)0xFFC00640);
		debugfs_create_x32("TIMER4_COUNTER", 0600, parent, (u32 *)0xFFC00644);
		debugfs_create_x32("TIMER4_PERIOD", 0600, parent, (u32 *)0xFFC00648);
		debugfs_create_x32("TIMER4_WIDTH", 0600, parent, (u32 *)0xFFC0064C);
		debugfs_create_x16("TIMER5_CONFIG", 0600, parent, (u16 *)0xFFC00650);
		debugfs_create_x32("TIMER5_COUNTER", 0600, parent, (u32 *)0xFFC00654);
		debugfs_create_x32("TIMER5_PERIOD", 0600, parent, (u32 *)0xFFC00658);
		debugfs_create_x32("TIMER5_WIDTH", 0600, parent, (u32 *)0xFFC0065C);
		debugfs_create_x16("TIMER6_CONFIG", 0600, parent, (u16 *)0xFFC00660);
		debugfs_create_x32("TIMER6_COUNTER", 0600, parent, (u32 *)0xFFC00664);
		debugfs_create_x32("TIMER6_PERIOD", 0600, parent, (u32 *)0xFFC00668);
		debugfs_create_x32("TIMER6_WIDTH", 0600, parent, (u32 *)0xFFC0066C);
		debugfs_create_x16("TIMER7_CONFIG", 0600, parent, (u16 *)0xFFC00670);
		debugfs_create_x32("TIMER7_COUNTER", 0600, parent, (u32 *)0xFFC00674);
		debugfs_create_x32("TIMER7_PERIOD", 0600, parent, (u32 *)0xFFC00678);
		debugfs_create_x32("TIMER7_WIDTH", 0600, parent, (u32 *)0xFFC0067C);
		debugfs_create_x16("TIMER_DISABLE", 0600, parent, (u16 *)0xFFC00684);
		debugfs_create_x16("TIMER_ENABLE", 0600, parent, (u16 *)0xFFC00680);
		debugfs_create_x32("TIMER_STATUS", 0600, parent, (u32 *)0xFFC00688);

		parent = debugfs_create_dir("Trace Unit", top);
		debugfs_create_x32("TBUF", 0600, parent, (u32 *)0xFFE06100);
		debugfs_create_x32("TBUFCTL", 0600, parent, (u32 *)0xFFE06000);
		debugfs_create_x32("TBUFSTAT", 0600, parent, (u32 *)0xFFE06004);

		parent = debugfs_create_dir("UART", top);
		debugfs_create_x16("UART0_DLH", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART0_DLL", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART0_GCTL", 0600, parent, (u16 *)0xFFC00424);
		debugfs_create_x16("UART0_IER", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART0_IIR", 0600, parent, (u16 *)0xFFC00408);
		debugfs_create_x16("UART0_LCR", 0600, parent, (u16 *)0xFFC0040C);
		debugfs_create_x16("UART0_LSR", 0600, parent, (u16 *)0xFFC00414);
		debugfs_create_x16("UART0_MCR", 0600, parent, (u16 *)0xFFC00410);
		debugfs_create_x16("UART0_MSR", 0600, parent, (u16 *)0xFFC00418);
		debugfs_create_x16("UART0_RBR", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART0_SCR", 0600, parent, (u16 *)0xFFC0041C);
		debugfs_create_x16("UART0_THR", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART1_DLH", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("UART1_DLL", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART1_GCTL", 0600, parent, (u16 *)0xFFC02024);
		debugfs_create_x16("UART1_IER", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("UART1_IIR", 0600, parent, (u16 *)0xFFC02008);
		debugfs_create_x16("UART1_LCR", 0600, parent, (u16 *)0xFFC0200C);
		debugfs_create_x16("UART1_LSR", 0600, parent, (u16 *)0xFFC02014);
		debugfs_create_x16("UART1_MCR", 0600, parent, (u16 *)0xFFC02010);
		debugfs_create_x16("UART1_MSR", 0600, parent, (u16 *)0xFFC02018);
		debugfs_create_x16("UART1_RBR", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART1_SCR", 0600, parent, (u16 *)0xFFC0201C);
		debugfs_create_x16("UART1_THR", 0600, parent, (u16 *)0xFFC02000);

		parent = debugfs_create_dir("Watchdog", top);
		debugfs_create_x32("WDOG_CNT", 0600, parent, (u32 *)0xFFC00204);
		debugfs_create_x16("WDOG_CTL", 0600, parent, (u16 *)0xFFC00200);
		debugfs_create_x32("WDOG_STAT", 0600, parent, (u32 *)0xFFC00208);

		parent = debugfs_create_dir("Watchpoint and Patch Unit", top);
		debugfs_create_x32("WPDA0", 0600, parent, (u32 *)0xFFE07140);
		debugfs_create_x32("WPDA1", 0600, parent, (u32 *)0xFFE07144);
		debugfs_create_x32("WPDACNT0", 0600, parent, (u32 *)0xFFE07180);
		debugfs_create_x32("WPDACNT1", 0600, parent, (u32 *)0xFFE07184);
		debugfs_create_x32("WPDACTL", 0600, parent, (u32 *)0xFFE07100);
		debugfs_create_x32("WPIA0", 0600, parent, (u32 *)0xFFE07040);
		debugfs_create_x32("WPIA1", 0600, parent, (u32 *)0xFFE07044);
		debugfs_create_x32("WPIA2", 0600, parent, (u32 *)0xFFE07048);
		debugfs_create_x32("WPIA3", 0600, parent, (u32 *)0xFFE0704C);
		debugfs_create_x32("WPIA4", 0600, parent, (u32 *)0xFFE07050);
		debugfs_create_x32("WPIA5", 0600, parent, (u32 *)0xFFE07054);
		debugfs_create_x32("WPIACNT0", 0600, parent, (u32 *)0xFFE07080);
		debugfs_create_x32("WPIACNT1", 0600, parent, (u32 *)0xFFE07084);
		debugfs_create_x32("WPIACNT2", 0600, parent, (u32 *)0xFFE07088);
		debugfs_create_x32("WPIACNT3", 0600, parent, (u32 *)0xFFE0708C);
		debugfs_create_x32("WPIACNT4", 0600, parent, (u32 *)0xFFE07090);
		debugfs_create_x32("WPIACNT5", 0600, parent, (u32 *)0xFFE07094);
		debugfs_create_x32("WPIACTL", 0600, parent, (u32 *)0xFFE07000);
		debugfs_create_x32("WPSTAT", 0600, parent, (u32 *)0xFFE07200);

	}	/* BF537 */

#ifdef __ADSPBF538__
# define USE_BF538 1
#else
# define USE_BF538 0
#endif
	if (USE_BF538) {

		parent = debugfs_create_dir("CAN Controller Registers", top);
		debugfs_create_x16("CAN_AA1", 0600, parent, (u16 *)0xFFC02A14);
		debugfs_create_x16("CAN_AA2", 0600, parent, (u16 *)0xFFC02A54);
		debugfs_create_x16("CAN_AM00H", 0600, parent, (u16 *)0xFFC02B04);
		debugfs_create_x16("CAN_AM00L", 0600, parent, (u16 *)0xFFC02B00);
		debugfs_create_x16("CAN_AM01H", 0600, parent, (u16 *)0xFFC02B0C);
		debugfs_create_x16("CAN_AM01L", 0600, parent, (u16 *)0xFFC02B08);
		debugfs_create_x16("CAN_AM02H", 0600, parent, (u16 *)0xFFC02B14);
		debugfs_create_x16("CAN_AM02L", 0600, parent, (u16 *)0xFFC02B10);
		debugfs_create_x16("CAN_AM03H", 0600, parent, (u16 *)0xFFC02B1C);
		debugfs_create_x16("CAN_AM03L", 0600, parent, (u16 *)0xFFC02B18);
		debugfs_create_x16("CAN_AM04H", 0600, parent, (u16 *)0xFFC02B24);
		debugfs_create_x16("CAN_AM04L", 0600, parent, (u16 *)0xFFC02B20);
		debugfs_create_x16("CAN_AM05H", 0600, parent, (u16 *)0xFFC02B2C);
		debugfs_create_x16("CAN_AM05L", 0600, parent, (u16 *)0xFFC02B28);
		debugfs_create_x16("CAN_AM06H", 0600, parent, (u16 *)0xFFC02B34);
		debugfs_create_x16("CAN_AM06L", 0600, parent, (u16 *)0xFFC02B30);
		debugfs_create_x16("CAN_AM07H", 0600, parent, (u16 *)0xFFC02B3C);
		debugfs_create_x16("CAN_AM07L", 0600, parent, (u16 *)0xFFC02B38);
		debugfs_create_x16("CAN_AM08H", 0600, parent, (u16 *)0xFFC02B44);
		debugfs_create_x16("CAN_AM08L", 0600, parent, (u16 *)0xFFC02B40);
		debugfs_create_x16("CAN_AM09H", 0600, parent, (u16 *)0xFFC02B4C);
		debugfs_create_x16("CAN_AM09L", 0600, parent, (u16 *)0xFFC02B48);
		debugfs_create_x16("CAN_AM10H", 0600, parent, (u16 *)0xFFC02B54);
		debugfs_create_x16("CAN_AM10L", 0600, parent, (u16 *)0xFFC02B50);
		debugfs_create_x16("CAN_AM11H", 0600, parent, (u16 *)0xFFC02B5C);
		debugfs_create_x16("CAN_AM11L", 0600, parent, (u16 *)0xFFC02B58);
		debugfs_create_x16("CAN_AM12H", 0600, parent, (u16 *)0xFFC02B64);
		debugfs_create_x16("CAN_AM12L", 0600, parent, (u16 *)0xFFC02B60);
		debugfs_create_x16("CAN_AM13H", 0600, parent, (u16 *)0xFFC02B6C);
		debugfs_create_x16("CAN_AM13L", 0600, parent, (u16 *)0xFFC02B68);
		debugfs_create_x16("CAN_AM14H", 0600, parent, (u16 *)0xFFC02B74);
		debugfs_create_x16("CAN_AM14L", 0600, parent, (u16 *)0xFFC02B70);
		debugfs_create_x16("CAN_AM15H", 0600, parent, (u16 *)0xFFC02B7C);
		debugfs_create_x16("CAN_AM15L", 0600, parent, (u16 *)0xFFC02B78);
		debugfs_create_x16("CAN_AM16H", 0600, parent, (u16 *)0xFFC02B84);
		debugfs_create_x16("CAN_AM16L", 0600, parent, (u16 *)0xFFC02B80);
		debugfs_create_x16("CAN_AM17H", 0600, parent, (u16 *)0xFFC02B8C);
		debugfs_create_x16("CAN_AM17L", 0600, parent, (u16 *)0xFFC02B88);
		debugfs_create_x16("CAN_AM18H", 0600, parent, (u16 *)0xFFC02B94);
		debugfs_create_x16("CAN_AM18L", 0600, parent, (u16 *)0xFFC02B90);
		debugfs_create_x16("CAN_AM19H", 0600, parent, (u16 *)0xFFC02B9C);
		debugfs_create_x16("CAN_AM19L", 0600, parent, (u16 *)0xFFC02B98);
		debugfs_create_x16("CAN_AM20H", 0600, parent, (u16 *)0xFFC02BA4);
		debugfs_create_x16("CAN_AM20L", 0600, parent, (u16 *)0xFFC02BA0);
		debugfs_create_x16("CAN_AM21H", 0600, parent, (u16 *)0xFFC02BAC);
		debugfs_create_x16("CAN_AM21L", 0600, parent, (u16 *)0xFFC02BA8);
		debugfs_create_x16("CAN_AM22H", 0600, parent, (u16 *)0xFFC02BB4);
		debugfs_create_x16("CAN_AM22L", 0600, parent, (u16 *)0xFFC02BB0);
		debugfs_create_x16("CAN_AM23H", 0600, parent, (u16 *)0xFFC02BBC);
		debugfs_create_x16("CAN_AM23L", 0600, parent, (u16 *)0xFFC02BB8);
		debugfs_create_x16("CAN_AM24H", 0600, parent, (u16 *)0xFFC02BC4);
		debugfs_create_x16("CAN_AM24L", 0600, parent, (u16 *)0xFFC02BC0);
		debugfs_create_x16("CAN_AM25H", 0600, parent, (u16 *)0xFFC02BCC);
		debugfs_create_x16("CAN_AM25L", 0600, parent, (u16 *)0xFFC02BC8);
		debugfs_create_x16("CAN_AM26H", 0600, parent, (u16 *)0xFFC02BD4);
		debugfs_create_x16("CAN_AM26L", 0600, parent, (u16 *)0xFFC02BD0);
		debugfs_create_x16("CAN_AM27H", 0600, parent, (u16 *)0xFFC02BDC);
		debugfs_create_x16("CAN_AM27L", 0600, parent, (u16 *)0xFFC02BD8);
		debugfs_create_x16("CAN_AM28H", 0600, parent, (u16 *)0xFFC02BE4);
		debugfs_create_x16("CAN_AM28L", 0600, parent, (u16 *)0xFFC02BE0);
		debugfs_create_x16("CAN_AM29H", 0600, parent, (u16 *)0xFFC02BEC);
		debugfs_create_x16("CAN_AM29L", 0600, parent, (u16 *)0xFFC02BE8);
		debugfs_create_x16("CAN_AM30H", 0600, parent, (u16 *)0xFFC02BF4);
		debugfs_create_x16("CAN_AM30L", 0600, parent, (u16 *)0xFFC02BF0);
		debugfs_create_x16("CAN_AM31H", 0600, parent, (u16 *)0xFFC02BFC);
		debugfs_create_x16("CAN_AM31L", 0600, parent, (u16 *)0xFFC02BF8);
		debugfs_create_x16("CAN_CEC", 0600, parent, (u16 *)0xFFC02A90);
		debugfs_create_x16("CAN_CLOCK", 0600, parent, (u16 *)0xFFC02A80);
		debugfs_create_x16("CAN_CONTROL", 0600, parent, (u16 *)0xFFC02AA0);
		debugfs_create_x16("CAN_DEBUG", 0600, parent, (u16 *)0xFFC02A88);
		debugfs_create_x16("CAN_ESR", 0600, parent, (u16 *)0xFFC02AB4);
		debugfs_create_x16("CAN_EWR", 0600, parent, (u16 *)0xFFC02AB0);
		debugfs_create_x16("CAN_GIF", 0600, parent, (u16 *)0xFFC02A9C);
		debugfs_create_x16("CAN_GIM", 0600, parent, (u16 *)0xFFC02A98);
		debugfs_create_x16("CAN_GIS", 0600, parent, (u16 *)0xFFC02A94);
		debugfs_create_x16("CAN_INTR", 0600, parent, (u16 *)0xFFC02AA4);
		debugfs_create_x16("CAN_MBIM1", 0600, parent, (u16 *)0xFFC02A28);
		debugfs_create_x16("CAN_MBIM2", 0600, parent, (u16 *)0xFFC02A68);
		debugfs_create_x16("CAN_MBRIF1", 0600, parent, (u16 *)0xFFC02A24);
		debugfs_create_x16("CAN_MBRIF2", 0600, parent, (u16 *)0xFFC02A64);
		debugfs_create_x16("CAN_MBTD", 0600, parent, (u16 *)0xFFC02AAC);
		debugfs_create_x16("CAN_MBTIF1", 0600, parent, (u16 *)0xFFC02A20);
		debugfs_create_x16("CAN_MBTIF2", 0600, parent, (u16 *)0xFFC02A60);
		debugfs_create_x16("CAN_MC1", 0600, parent, (u16 *)0xFFC02A00);
		debugfs_create_x16("CAN_MC2", 0600, parent, (u16 *)0xFFC02A40);
		debugfs_create_x16("CAN_MD1", 0600, parent, (u16 *)0xFFC02A04);
		debugfs_create_x16("CAN_MD2", 0600, parent, (u16 *)0xFFC02A44);
		debugfs_create_x16("CAN_OPSS1", 0600, parent, (u16 *)0xFFC02A30);
		debugfs_create_x16("CAN_OPSS2", 0600, parent, (u16 *)0xFFC02A70);
		debugfs_create_x16("CAN_RFH1", 0600, parent, (u16 *)0xFFC02A2C);
		debugfs_create_x16("CAN_RFH2", 0600, parent, (u16 *)0xFFC02A6C);
		debugfs_create_x16("CAN_RML1", 0600, parent, (u16 *)0xFFC02A1C);
		debugfs_create_x16("CAN_RML2", 0600, parent, (u16 *)0xFFC02A5C);
		debugfs_create_x16("CAN_RMP1", 0600, parent, (u16 *)0xFFC02A18);
		debugfs_create_x16("CAN_RMP2", 0600, parent, (u16 *)0xFFC02A58);
		debugfs_create_x16("CAN_STATUS", 0600, parent, (u16 *)0xFFC02A8C);
		debugfs_create_x16("CAN_TA1", 0600, parent, (u16 *)0xFFC02A10);
		debugfs_create_x16("CAN_TA2", 0600, parent, (u16 *)0xFFC02A50);
		debugfs_create_x16("CAN_TIMING", 0600, parent, (u16 *)0xFFC02A84);
		debugfs_create_x16("CAN_TRR1", 0600, parent, (u16 *)0xFFC02A0C);
		debugfs_create_x16("CAN_TRR2", 0600, parent, (u16 *)0xFFC02A4C);
		debugfs_create_x16("CAN_TRS1", 0600, parent, (u16 *)0xFFC02A08);
		debugfs_create_x16("CAN_TRS2", 0600, parent, (u16 *)0xFFC02A48);
		debugfs_create_x16("CAN_UCCNF", 0600, parent, (u16 *)0xFFC02ACC);
		debugfs_create_x16("CAN_UCCNT", 0600, parent, (u16 *)0xFFC02AC4);
		debugfs_create_x16("CAN_UCRC", 0600, parent, (u16 *)0xFFC02AC8);
		debugfs_create_x16("CAN_UCREG", 0600, parent, (u16 *)0xFFC02AC0);
		debugfs_create_x16("CAN_VERSION2", 0600, parent, (u16 *)0xFFC02AD4);
		debugfs_create_x16("CAN_VERSION", 0600, parent, (u16 *)0xFFC02AA8);

		parent = debugfs_create_dir("CAN Mailbox Registers", top);
		debugfs_create_x16("CAN_MB00_DATA0", 0600, parent, (u16 *)0xFFC02C00);
		debugfs_create_x16("CAN_MB00_DATA1", 0600, parent, (u16 *)0xFFC02C04);
		debugfs_create_x16("CAN_MB00_DATA2", 0600, parent, (u16 *)0xFFC02C08);
		debugfs_create_x16("CAN_MB00_DATA3", 0600, parent, (u16 *)0xFFC02C0C);
		debugfs_create_x16("CAN_MB00_ID0", 0600, parent, (u16 *)0xFFC02C18);
		debugfs_create_x16("CAN_MB00_ID1", 0600, parent, (u16 *)0xFFC02C1C);
		debugfs_create_x16("CAN_MB00_LENGTH", 0600, parent, (u16 *)0xFFC02C10);
		debugfs_create_x16("CAN_MB00_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C14);
		debugfs_create_x16("CAN_MB01_DATA0", 0600, parent, (u16 *)0xFFC02C20);
		debugfs_create_x16("CAN_MB01_DATA1", 0600, parent, (u16 *)0xFFC02C24);
		debugfs_create_x16("CAN_MB01_DATA2", 0600, parent, (u16 *)0xFFC02C28);
		debugfs_create_x16("CAN_MB01_DATA3", 0600, parent, (u16 *)0xFFC02C2C);
		debugfs_create_x16("CAN_MB01_ID0", 0600, parent, (u16 *)0xFFC02C38);
		debugfs_create_x16("CAN_MB01_ID1", 0600, parent, (u16 *)0xFFC02C3C);
		debugfs_create_x16("CAN_MB01_LENGTH", 0600, parent, (u16 *)0xFFC02C30);
		debugfs_create_x16("CAN_MB01_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C34);
		debugfs_create_x16("CAN_MB02_DATA0", 0600, parent, (u16 *)0xFFC02C40);
		debugfs_create_x16("CAN_MB02_DATA1", 0600, parent, (u16 *)0xFFC02C44);
		debugfs_create_x16("CAN_MB02_DATA2", 0600, parent, (u16 *)0xFFC02C48);
		debugfs_create_x16("CAN_MB02_DATA3", 0600, parent, (u16 *)0xFFC02C4C);
		debugfs_create_x16("CAN_MB02_ID0", 0600, parent, (u16 *)0xFFC02C58);
		debugfs_create_x16("CAN_MB02_ID1", 0600, parent, (u16 *)0xFFC02C5C);
		debugfs_create_x16("CAN_MB02_LENGTH", 0600, parent, (u16 *)0xFFC02C50);
		debugfs_create_x16("CAN_MB02_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C54);
		debugfs_create_x16("CAN_MB03_DATA0", 0600, parent, (u16 *)0xFFC02C60);
		debugfs_create_x16("CAN_MB03_DATA1", 0600, parent, (u16 *)0xFFC02C64);
		debugfs_create_x16("CAN_MB03_DATA2", 0600, parent, (u16 *)0xFFC02C68);
		debugfs_create_x16("CAN_MB03_DATA3", 0600, parent, (u16 *)0xFFC02C6C);
		debugfs_create_x16("CAN_MB03_ID0", 0600, parent, (u16 *)0xFFC02C78);
		debugfs_create_x16("CAN_MB03_ID1", 0600, parent, (u16 *)0xFFC02C7C);
		debugfs_create_x16("CAN_MB03_LENGTH", 0600, parent, (u16 *)0xFFC02C70);
		debugfs_create_x16("CAN_MB03_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C74);
		debugfs_create_x16("CAN_MB04_DATA0", 0600, parent, (u16 *)0xFFC02C80);
		debugfs_create_x16("CAN_MB04_DATA1", 0600, parent, (u16 *)0xFFC02C84);
		debugfs_create_x16("CAN_MB04_DATA2", 0600, parent, (u16 *)0xFFC02C88);
		debugfs_create_x16("CAN_MB04_DATA3", 0600, parent, (u16 *)0xFFC02C8C);
		debugfs_create_x16("CAN_MB04_ID0", 0600, parent, (u16 *)0xFFC02C98);
		debugfs_create_x16("CAN_MB04_ID1", 0600, parent, (u16 *)0xFFC02C9C);
		debugfs_create_x16("CAN_MB04_LENGTH", 0600, parent, (u16 *)0xFFC02C90);
		debugfs_create_x16("CAN_MB04_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C94);
		debugfs_create_x16("CAN_MB05_DATA0", 0600, parent, (u16 *)0xFFC02CA0);
		debugfs_create_x16("CAN_MB05_DATA1", 0600, parent, (u16 *)0xFFC02CA4);
		debugfs_create_x16("CAN_MB05_DATA2", 0600, parent, (u16 *)0xFFC02CA8);
		debugfs_create_x16("CAN_MB05_DATA3", 0600, parent, (u16 *)0xFFC02CAC);
		debugfs_create_x16("CAN_MB05_ID0", 0600, parent, (u16 *)0xFFC02CB8);
		debugfs_create_x16("CAN_MB05_ID1", 0600, parent, (u16 *)0xFFC02CBC);
		debugfs_create_x16("CAN_MB05_LENGTH", 0600, parent, (u16 *)0xFFC02CB0);
		debugfs_create_x16("CAN_MB05_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CB4);
		debugfs_create_x16("CAN_MB06_DATA0", 0600, parent, (u16 *)0xFFC02CC0);
		debugfs_create_x16("CAN_MB06_DATA1", 0600, parent, (u16 *)0xFFC02CC4);
		debugfs_create_x16("CAN_MB06_DATA2", 0600, parent, (u16 *)0xFFC02CC8);
		debugfs_create_x16("CAN_MB06_DATA3", 0600, parent, (u16 *)0xFFC02CCC);
		debugfs_create_x16("CAN_MB06_ID0", 0600, parent, (u16 *)0xFFC02CD8);
		debugfs_create_x16("CAN_MB06_ID1", 0600, parent, (u16 *)0xFFC02CDC);
		debugfs_create_x16("CAN_MB06_LENGTH", 0600, parent, (u16 *)0xFFC02CD0);
		debugfs_create_x16("CAN_MB06_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CD4);
		debugfs_create_x16("CAN_MB07_DATA0", 0600, parent, (u16 *)0xFFC02CE0);
		debugfs_create_x16("CAN_MB07_DATA1", 0600, parent, (u16 *)0xFFC02CE4);
		debugfs_create_x16("CAN_MB07_DATA2", 0600, parent, (u16 *)0xFFC02CE8);
		debugfs_create_x16("CAN_MB07_DATA3", 0600, parent, (u16 *)0xFFC02CEC);
		debugfs_create_x16("CAN_MB07_ID0", 0600, parent, (u16 *)0xFFC02CF8);
		debugfs_create_x16("CAN_MB07_ID1", 0600, parent, (u16 *)0xFFC02CFC);
		debugfs_create_x16("CAN_MB07_LENGTH", 0600, parent, (u16 *)0xFFC02CF0);
		debugfs_create_x16("CAN_MB07_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CF4);
		debugfs_create_x16("CAN_MB08_DATA0", 0600, parent, (u16 *)0xFFC02D00);
		debugfs_create_x16("CAN_MB08_DATA1", 0600, parent, (u16 *)0xFFC02D04);
		debugfs_create_x16("CAN_MB08_DATA2", 0600, parent, (u16 *)0xFFC02D08);
		debugfs_create_x16("CAN_MB08_DATA3", 0600, parent, (u16 *)0xFFC02D0C);
		debugfs_create_x16("CAN_MB08_ID0", 0600, parent, (u16 *)0xFFC02D18);
		debugfs_create_x16("CAN_MB08_ID1", 0600, parent, (u16 *)0xFFC02D1C);
		debugfs_create_x16("CAN_MB08_LENGTH", 0600, parent, (u16 *)0xFFC02D10);
		debugfs_create_x16("CAN_MB08_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D14);
		debugfs_create_x16("CAN_MB09_DATA0", 0600, parent, (u16 *)0xFFC02D20);
		debugfs_create_x16("CAN_MB09_DATA1", 0600, parent, (u16 *)0xFFC02D24);
		debugfs_create_x16("CAN_MB09_DATA2", 0600, parent, (u16 *)0xFFC02D28);
		debugfs_create_x16("CAN_MB09_DATA3", 0600, parent, (u16 *)0xFFC02D2C);
		debugfs_create_x16("CAN_MB09_ID0", 0600, parent, (u16 *)0xFFC02D38);
		debugfs_create_x16("CAN_MB09_ID1", 0600, parent, (u16 *)0xFFC02D3C);
		debugfs_create_x16("CAN_MB09_LENGTH", 0600, parent, (u16 *)0xFFC02D30);
		debugfs_create_x16("CAN_MB09_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D34);
		debugfs_create_x16("CAN_MB10_DATA0", 0600, parent, (u16 *)0xFFC02D40);
		debugfs_create_x16("CAN_MB10_DATA1", 0600, parent, (u16 *)0xFFC02D44);
		debugfs_create_x16("CAN_MB10_DATA2", 0600, parent, (u16 *)0xFFC02D48);
		debugfs_create_x16("CAN_MB10_DATA3", 0600, parent, (u16 *)0xFFC02D4C);
		debugfs_create_x16("CAN_MB10_ID0", 0600, parent, (u16 *)0xFFC02D58);
		debugfs_create_x16("CAN_MB10_ID1", 0600, parent, (u16 *)0xFFC02D5C);
		debugfs_create_x16("CAN_MB10_LENGTH", 0600, parent, (u16 *)0xFFC02D50);
		debugfs_create_x16("CAN_MB10_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D54);
		debugfs_create_x16("CAN_MB11_DATA0", 0600, parent, (u16 *)0xFFC02D60);
		debugfs_create_x16("CAN_MB11_DATA1", 0600, parent, (u16 *)0xFFC02D64);
		debugfs_create_x16("CAN_MB11_DATA2", 0600, parent, (u16 *)0xFFC02D68);
		debugfs_create_x16("CAN_MB11_DATA3", 0600, parent, (u16 *)0xFFC02D6C);
		debugfs_create_x16("CAN_MB11_ID0", 0600, parent, (u16 *)0xFFC02D78);
		debugfs_create_x16("CAN_MB11_ID1", 0600, parent, (u16 *)0xFFC02D7C);
		debugfs_create_x16("CAN_MB11_LENGTH", 0600, parent, (u16 *)0xFFC02D70);
		debugfs_create_x16("CAN_MB11_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D74);
		debugfs_create_x16("CAN_MB12_DATA0", 0600, parent, (u16 *)0xFFC02D80);
		debugfs_create_x16("CAN_MB12_DATA1", 0600, parent, (u16 *)0xFFC02D84);
		debugfs_create_x16("CAN_MB12_DATA2", 0600, parent, (u16 *)0xFFC02D88);
		debugfs_create_x16("CAN_MB12_DATA3", 0600, parent, (u16 *)0xFFC02D8C);
		debugfs_create_x16("CAN_MB12_ID0", 0600, parent, (u16 *)0xFFC02D98);
		debugfs_create_x16("CAN_MB12_ID1", 0600, parent, (u16 *)0xFFC02D9C);
		debugfs_create_x16("CAN_MB12_LENGTH", 0600, parent, (u16 *)0xFFC02D90);
		debugfs_create_x16("CAN_MB12_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D94);
		debugfs_create_x16("CAN_MB13_DATA0", 0600, parent, (u16 *)0xFFC02DA0);
		debugfs_create_x16("CAN_MB13_DATA1", 0600, parent, (u16 *)0xFFC02DA4);
		debugfs_create_x16("CAN_MB13_DATA2", 0600, parent, (u16 *)0xFFC02DA8);
		debugfs_create_x16("CAN_MB13_DATA3", 0600, parent, (u16 *)0xFFC02DAC);
		debugfs_create_x16("CAN_MB13_ID0", 0600, parent, (u16 *)0xFFC02DB8);
		debugfs_create_x16("CAN_MB13_ID1", 0600, parent, (u16 *)0xFFC02DBC);
		debugfs_create_x16("CAN_MB13_LENGTH", 0600, parent, (u16 *)0xFFC02DB0);
		debugfs_create_x16("CAN_MB13_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DB4);
		debugfs_create_x16("CAN_MB14_DATA0", 0600, parent, (u16 *)0xFFC02DC0);
		debugfs_create_x16("CAN_MB14_DATA1", 0600, parent, (u16 *)0xFFC02DC4);
		debugfs_create_x16("CAN_MB14_DATA2", 0600, parent, (u16 *)0xFFC02DC8);
		debugfs_create_x16("CAN_MB14_DATA3", 0600, parent, (u16 *)0xFFC02DCC);
		debugfs_create_x16("CAN_MB14_ID0", 0600, parent, (u16 *)0xFFC02DD8);
		debugfs_create_x16("CAN_MB14_ID1", 0600, parent, (u16 *)0xFFC02DDC);
		debugfs_create_x16("CAN_MB14_LENGTH", 0600, parent, (u16 *)0xFFC02DD0);
		debugfs_create_x16("CAN_MB14_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DD4);
		debugfs_create_x16("CAN_MB15_DATA0", 0600, parent, (u16 *)0xFFC02DE0);
		debugfs_create_x16("CAN_MB15_DATA1", 0600, parent, (u16 *)0xFFC02DE4);
		debugfs_create_x16("CAN_MB15_DATA2", 0600, parent, (u16 *)0xFFC02DE8);
		debugfs_create_x16("CAN_MB15_DATA3", 0600, parent, (u16 *)0xFFC02DEC);
		debugfs_create_x16("CAN_MB15_ID0", 0600, parent, (u16 *)0xFFC02DF8);
		debugfs_create_x16("CAN_MB15_ID1", 0600, parent, (u16 *)0xFFC02DFC);
		debugfs_create_x16("CAN_MB15_LENGTH", 0600, parent, (u16 *)0xFFC02DF0);
		debugfs_create_x16("CAN_MB15_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DF4);
		debugfs_create_x16("CAN_MB16_DATA0", 0600, parent, (u16 *)0xFFC02E00);
		debugfs_create_x16("CAN_MB16_DATA1", 0600, parent, (u16 *)0xFFC02E04);
		debugfs_create_x16("CAN_MB16_DATA2", 0600, parent, (u16 *)0xFFC02E08);
		debugfs_create_x16("CAN_MB16_DATA3", 0600, parent, (u16 *)0xFFC02E0C);
		debugfs_create_x16("CAN_MB16_ID0", 0600, parent, (u16 *)0xFFC02E18);
		debugfs_create_x16("CAN_MB16_ID1", 0600, parent, (u16 *)0xFFC02E1C);
		debugfs_create_x16("CAN_MB16_LENGTH", 0600, parent, (u16 *)0xFFC02E10);
		debugfs_create_x16("CAN_MB16_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E14);
		debugfs_create_x16("CAN_MB17_DATA0", 0600, parent, (u16 *)0xFFC02E20);
		debugfs_create_x16("CAN_MB17_DATA1", 0600, parent, (u16 *)0xFFC02E24);
		debugfs_create_x16("CAN_MB17_DATA2", 0600, parent, (u16 *)0xFFC02E28);
		debugfs_create_x16("CAN_MB17_DATA3", 0600, parent, (u16 *)0xFFC02E2C);
		debugfs_create_x16("CAN_MB17_ID0", 0600, parent, (u16 *)0xFFC02E38);
		debugfs_create_x16("CAN_MB17_ID1", 0600, parent, (u16 *)0xFFC02E3C);
		debugfs_create_x16("CAN_MB17_LENGTH", 0600, parent, (u16 *)0xFFC02E30);
		debugfs_create_x16("CAN_MB17_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E34);
		debugfs_create_x16("CAN_MB18_DATA0", 0600, parent, (u16 *)0xFFC02E40);
		debugfs_create_x16("CAN_MB18_DATA1", 0600, parent, (u16 *)0xFFC02E44);
		debugfs_create_x16("CAN_MB18_DATA2", 0600, parent, (u16 *)0xFFC02E48);
		debugfs_create_x16("CAN_MB18_DATA3", 0600, parent, (u16 *)0xFFC02E4C);
		debugfs_create_x16("CAN_MB18_ID0", 0600, parent, (u16 *)0xFFC02E58);
		debugfs_create_x16("CAN_MB18_ID1", 0600, parent, (u16 *)0xFFC02E5C);
		debugfs_create_x16("CAN_MB18_LENGTH", 0600, parent, (u16 *)0xFFC02E50);
		debugfs_create_x16("CAN_MB18_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E54);
		debugfs_create_x16("CAN_MB19_DATA0", 0600, parent, (u16 *)0xFFC02E60);
		debugfs_create_x16("CAN_MB19_DATA1", 0600, parent, (u16 *)0xFFC02E64);
		debugfs_create_x16("CAN_MB19_DATA2", 0600, parent, (u16 *)0xFFC02E68);
		debugfs_create_x16("CAN_MB19_DATA3", 0600, parent, (u16 *)0xFFC02E6C);
		debugfs_create_x16("CAN_MB19_ID0", 0600, parent, (u16 *)0xFFC02E78);
		debugfs_create_x16("CAN_MB19_ID1", 0600, parent, (u16 *)0xFFC02E7C);
		debugfs_create_x16("CAN_MB19_LENGTH", 0600, parent, (u16 *)0xFFC02E70);
		debugfs_create_x16("CAN_MB19_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E74);
		debugfs_create_x16("CAN_MB20_DATA0", 0600, parent, (u16 *)0xFFC02E80);
		debugfs_create_x16("CAN_MB20_DATA1", 0600, parent, (u16 *)0xFFC02E84);
		debugfs_create_x16("CAN_MB20_DATA2", 0600, parent, (u16 *)0xFFC02E88);
		debugfs_create_x16("CAN_MB20_DATA3", 0600, parent, (u16 *)0xFFC02E8C);
		debugfs_create_x16("CAN_MB20_ID0", 0600, parent, (u16 *)0xFFC02E98);
		debugfs_create_x16("CAN_MB20_ID1", 0600, parent, (u16 *)0xFFC02E9C);
		debugfs_create_x16("CAN_MB20_LENGTH", 0600, parent, (u16 *)0xFFC02E90);
		debugfs_create_x16("CAN_MB20_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E94);
		debugfs_create_x16("CAN_MB21_DATA0", 0600, parent, (u16 *)0xFFC02EA0);
		debugfs_create_x16("CAN_MB21_DATA1", 0600, parent, (u16 *)0xFFC02EA4);
		debugfs_create_x16("CAN_MB21_DATA2", 0600, parent, (u16 *)0xFFC02EA8);
		debugfs_create_x16("CAN_MB21_DATA3", 0600, parent, (u16 *)0xFFC02EAC);
		debugfs_create_x16("CAN_MB21_ID0", 0600, parent, (u16 *)0xFFC02EB8);
		debugfs_create_x16("CAN_MB21_ID1", 0600, parent, (u16 *)0xFFC02EBC);
		debugfs_create_x16("CAN_MB21_LENGTH", 0600, parent, (u16 *)0xFFC02EB0);
		debugfs_create_x16("CAN_MB21_TIMESTAMP", 0600, parent, (u16 *)0xFFC02EB4);
		debugfs_create_x16("CAN_MB22_DATA0", 0600, parent, (u16 *)0xFFC02EC0);
		debugfs_create_x16("CAN_MB22_DATA1", 0600, parent, (u16 *)0xFFC02EC4);
		debugfs_create_x16("CAN_MB22_DATA2", 0600, parent, (u16 *)0xFFC02EC8);
		debugfs_create_x16("CAN_MB22_DATA3", 0600, parent, (u16 *)0xFFC02ECC);
		debugfs_create_x16("CAN_MB22_ID0", 0600, parent, (u16 *)0xFFC02ED8);
		debugfs_create_x16("CAN_MB22_ID1", 0600, parent, (u16 *)0xFFC02EDC);
		debugfs_create_x16("CAN_MB22_LENGTH", 0600, parent, (u16 *)0xFFC02ED0);
		debugfs_create_x16("CAN_MB22_TIMESTAMP", 0600, parent, (u16 *)0xFFC02ED4);
		debugfs_create_x16("CAN_MB23_DATA0", 0600, parent, (u16 *)0xFFC02EE0);
		debugfs_create_x16("CAN_MB23_DATA1", 0600, parent, (u16 *)0xFFC02EE4);
		debugfs_create_x16("CAN_MB23_DATA2", 0600, parent, (u16 *)0xFFC02EE8);
		debugfs_create_x16("CAN_MB23_DATA3", 0600, parent, (u16 *)0xFFC02EEC);
		debugfs_create_x16("CAN_MB23_ID0", 0600, parent, (u16 *)0xFFC02EF8);
		debugfs_create_x16("CAN_MB23_ID1", 0600, parent, (u16 *)0xFFC02EFC);
		debugfs_create_x16("CAN_MB23_LENGTH", 0600, parent, (u16 *)0xFFC02EF0);
		debugfs_create_x16("CAN_MB23_TIMESTAMP", 0600, parent, (u16 *)0xFFC02EF4);
		debugfs_create_x16("CAN_MB24_DATA0", 0600, parent, (u16 *)0xFFC02F00);
		debugfs_create_x16("CAN_MB24_DATA1", 0600, parent, (u16 *)0xFFC02F04);
		debugfs_create_x16("CAN_MB24_DATA2", 0600, parent, (u16 *)0xFFC02F08);
		debugfs_create_x16("CAN_MB24_DATA3", 0600, parent, (u16 *)0xFFC02F0C);
		debugfs_create_x16("CAN_MB24_ID0", 0600, parent, (u16 *)0xFFC02F18);
		debugfs_create_x16("CAN_MB24_ID1", 0600, parent, (u16 *)0xFFC02F1C);
		debugfs_create_x16("CAN_MB24_LENGTH", 0600, parent, (u16 *)0xFFC02F10);
		debugfs_create_x16("CAN_MB24_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F14);
		debugfs_create_x16("CAN_MB25_DATA0", 0600, parent, (u16 *)0xFFC02F20);
		debugfs_create_x16("CAN_MB25_DATA1", 0600, parent, (u16 *)0xFFC02F24);
		debugfs_create_x16("CAN_MB25_DATA2", 0600, parent, (u16 *)0xFFC02F28);
		debugfs_create_x16("CAN_MB25_DATA3", 0600, parent, (u16 *)0xFFC02F2C);
		debugfs_create_x16("CAN_MB25_ID0", 0600, parent, (u16 *)0xFFC02F38);
		debugfs_create_x16("CAN_MB25_ID1", 0600, parent, (u16 *)0xFFC02F3C);
		debugfs_create_x16("CAN_MB25_LENGTH", 0600, parent, (u16 *)0xFFC02F30);
		debugfs_create_x16("CAN_MB25_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F34);
		debugfs_create_x16("CAN_MB26_DATA0", 0600, parent, (u16 *)0xFFC02F40);
		debugfs_create_x16("CAN_MB26_DATA1", 0600, parent, (u16 *)0xFFC02F44);
		debugfs_create_x16("CAN_MB26_DATA2", 0600, parent, (u16 *)0xFFC02F48);
		debugfs_create_x16("CAN_MB26_DATA3", 0600, parent, (u16 *)0xFFC02F4C);
		debugfs_create_x16("CAN_MB26_ID0", 0600, parent, (u16 *)0xFFC02F58);
		debugfs_create_x16("CAN_MB26_ID1", 0600, parent, (u16 *)0xFFC02F5C);
		debugfs_create_x16("CAN_MB26_LENGTH", 0600, parent, (u16 *)0xFFC02F50);
		debugfs_create_x16("CAN_MB26_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F54);
		debugfs_create_x16("CAN_MB27_DATA0", 0600, parent, (u16 *)0xFFC02F60);
		debugfs_create_x16("CAN_MB27_DATA1", 0600, parent, (u16 *)0xFFC02F64);
		debugfs_create_x16("CAN_MB27_DATA2", 0600, parent, (u16 *)0xFFC02F68);
		debugfs_create_x16("CAN_MB27_DATA3", 0600, parent, (u16 *)0xFFC02F6C);
		debugfs_create_x16("CAN_MB27_ID0", 0600, parent, (u16 *)0xFFC02F78);
		debugfs_create_x16("CAN_MB27_ID1", 0600, parent, (u16 *)0xFFC02F7C);
		debugfs_create_x16("CAN_MB27_LENGTH", 0600, parent, (u16 *)0xFFC02F70);
		debugfs_create_x16("CAN_MB27_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F74);
		debugfs_create_x16("CAN_MB28_DATA0", 0600, parent, (u16 *)0xFFC02F80);
		debugfs_create_x16("CAN_MB28_DATA1", 0600, parent, (u16 *)0xFFC02F84);
		debugfs_create_x16("CAN_MB28_DATA2", 0600, parent, (u16 *)0xFFC02F88);
		debugfs_create_x16("CAN_MB28_DATA3", 0600, parent, (u16 *)0xFFC02F8C);
		debugfs_create_x16("CAN_MB28_ID0", 0600, parent, (u16 *)0xFFC02F98);
		debugfs_create_x16("CAN_MB28_ID1", 0600, parent, (u16 *)0xFFC02F9C);
		debugfs_create_x16("CAN_MB28_LENGTH", 0600, parent, (u16 *)0xFFC02F90);
		debugfs_create_x16("CAN_MB28_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F94);
		debugfs_create_x16("CAN_MB29_DATA0", 0600, parent, (u16 *)0xFFC02FA0);
		debugfs_create_x16("CAN_MB29_DATA1", 0600, parent, (u16 *)0xFFC02FA4);
		debugfs_create_x16("CAN_MB29_DATA2", 0600, parent, (u16 *)0xFFC02FA8);
		debugfs_create_x16("CAN_MB29_DATA3", 0600, parent, (u16 *)0xFFC02FAC);
		debugfs_create_x16("CAN_MB29_ID0", 0600, parent, (u16 *)0xFFC02FB8);
		debugfs_create_x16("CAN_MB29_ID1", 0600, parent, (u16 *)0xFFC02FBC);
		debugfs_create_x16("CAN_MB29_LENGTH", 0600, parent, (u16 *)0xFFC02FB0);
		debugfs_create_x16("CAN_MB29_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FB4);
		debugfs_create_x16("CAN_MB30_DATA0", 0600, parent, (u16 *)0xFFC02FC0);
		debugfs_create_x16("CAN_MB30_DATA1", 0600, parent, (u16 *)0xFFC02FC4);
		debugfs_create_x16("CAN_MB30_DATA2", 0600, parent, (u16 *)0xFFC02FC8);
		debugfs_create_x16("CAN_MB30_DATA3", 0600, parent, (u16 *)0xFFC02FCC);
		debugfs_create_x16("CAN_MB30_ID0", 0600, parent, (u16 *)0xFFC02FD8);
		debugfs_create_x16("CAN_MB30_ID1", 0600, parent, (u16 *)0xFFC02FDC);
		debugfs_create_x16("CAN_MB30_LENGTH", 0600, parent, (u16 *)0xFFC02FD0);
		debugfs_create_x16("CAN_MB30_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FD4);
		debugfs_create_x16("CAN_MB31_DATA0", 0600, parent, (u16 *)0xFFC02FE0);
		debugfs_create_x16("CAN_MB31_DATA1", 0600, parent, (u16 *)0xFFC02FE4);
		debugfs_create_x16("CAN_MB31_DATA2", 0600, parent, (u16 *)0xFFC02FE8);
		debugfs_create_x16("CAN_MB31_DATA3", 0600, parent, (u16 *)0xFFC02FEC);
		debugfs_create_x16("CAN_MB31_ID0", 0600, parent, (u16 *)0xFFC02FF8);
		debugfs_create_x16("CAN_MB31_ID1", 0600, parent, (u16 *)0xFFC02FFC);
		debugfs_create_x16("CAN_MB31_LENGTH", 0600, parent, (u16 *)0xFFC02FF0);
		debugfs_create_x16("CAN_MB31_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FF4);

		parent = debugfs_create_dir("Core Timer Registers", top);
		debugfs_create_x32("TCNTL", 0600, parent, (u32 *)0xFFE03000);
		debugfs_create_x32("TCOUNT", 0600, parent, (u32 *)0xFFE0300C);
		debugfs_create_x32("TPERIOD", 0600, parent, (u32 *)0xFFE03004);
		debugfs_create_x32("TSCALE", 0600, parent, (u32 *)0xFFE03008);

		parent = debugfs_create_dir("DMA Traffic Control", top);
		debugfs_create_x16("DMA0_TC_CNT", 0600, parent, (u16 *)0xFFC00B10);
		debugfs_create_x16("DMA0_TC_PER", 0600, parent, (u16 *)0xFFC00B0C);
		debugfs_create_x16("DMA1_TC_CNT", 0600, parent, (u16 *)0xFFC01B10);
		debugfs_create_x16("DMA1_TC_PER", 0600, parent, (u16 *)0xFFC01B0C);

		parent = debugfs_create_dir("DMA0 (DMA0 Ch-0) Registers", top);
		debugfs_create_x16("DMA0_CONFIG", 0600, parent, (u16 *)0xFFC00C08);
		debugfs_create_x32("DMA0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C24);
		debugfs_create_x32("DMA0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C20);
		debugfs_create_x16("DMA0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C30);
		debugfs_create_x16("DMA0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C38);
		debugfs_create_x16("DMA0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C28);
		debugfs_create_x32("DMA0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C00);
		debugfs_create_x16("DMA0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C2C);
		debugfs_create_x32("DMA0_START_ADDR", 0600, parent, (u32 *)0xFFC00C04);
		debugfs_create_x16("DMA0_X_COUNT", 0600, parent, (u16 *)0xFFC00C10);
		debugfs_create_x16("DMA0_X_MODIFY", 0600, parent, (u16 *)0xFFC00C14);
		debugfs_create_x16("DMA0_Y_COUNT", 0600, parent, (u16 *)0xFFC00C18);
		debugfs_create_x16("DMA0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C1C);

		parent = debugfs_create_dir("DMA1 (DMA0 Ch-1) Registers", top);
		debugfs_create_x16("DMA1_CONFIG", 0600, parent, (u16 *)0xFFC00C48);
		debugfs_create_x32("DMA1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C64);
		debugfs_create_x32("DMA1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C60);
		debugfs_create_x16("DMA1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C70);
		debugfs_create_x16("DMA1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C78);
		debugfs_create_x16("DMA1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C68);
		debugfs_create_x32("DMA1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C40);
		debugfs_create_x16("DMA1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C6C);
		debugfs_create_x32("DMA1_START_ADDR", 0600, parent, (u32 *)0xFFC00C44);
		debugfs_create_x16("DMA1_X_COUNT", 0600, parent, (u16 *)0xFFC00C50);
		debugfs_create_x16("DMA1_X_MODIFY", 0600, parent, (u16 *)0xFFC00C54);
		debugfs_create_x16("DMA1_Y_COUNT", 0600, parent, (u16 *)0xFFC00C58);
		debugfs_create_x16("DMA1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C5C);

		parent = debugfs_create_dir("DMA10 (DMA1 Ch-2) Registers", top);
		debugfs_create_x16("DMA10_CONFIG", 0600, parent, (u16 *)0xFFC01C88);
		debugfs_create_x32("DMA10_CURR_ADDR", 0600, parent, (u32 *)0xFFC01CA4);
		debugfs_create_x32("DMA10_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01CA0);
		debugfs_create_x16("DMA10_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01CB0);
		debugfs_create_x16("DMA10_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01CB8);
		debugfs_create_x16("DMA10_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01CA8);
		debugfs_create_x32("DMA10_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01C80);
		debugfs_create_x16("DMA10_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01CAC);
		debugfs_create_x32("DMA10_START_ADDR", 0600, parent, (u32 *)0xFFC01C84);
		debugfs_create_x16("DMA10_X_COUNT", 0600, parent, (u16 *)0xFFC01C90);
		debugfs_create_x16("DMA10_X_MODIFY", 0600, parent, (u16 *)0xFFC01C94);
		debugfs_create_x16("DMA10_Y_COUNT", 0600, parent, (u16 *)0xFFC01C98);
		debugfs_create_x16("DMA10_Y_MODIFY", 0600, parent, (u16 *)0xFFC01C9C);

		parent = debugfs_create_dir("DMA11 (DMA1 Ch-3) Registers", top);
		debugfs_create_x16("DMA11_CONFIG", 0600, parent, (u16 *)0xFFC01CC8);
		debugfs_create_x32("DMA11_CURR_ADDR", 0600, parent, (u32 *)0xFFC01CE4);
		debugfs_create_x32("DMA11_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01CE0);
		debugfs_create_x16("DMA11_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01CF0);
		debugfs_create_x16("DMA11_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01CF8);
		debugfs_create_x16("DMA11_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01CE8);
		debugfs_create_x32("DMA11_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01CC0);
		debugfs_create_x16("DMA11_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01CEC);
		debugfs_create_x32("DMA11_START_ADDR", 0600, parent, (u32 *)0xFFC01CC4);
		debugfs_create_x16("DMA11_X_COUNT", 0600, parent, (u16 *)0xFFC01CD0);
		debugfs_create_x16("DMA11_X_MODIFY", 0600, parent, (u16 *)0xFFC01CD4);
		debugfs_create_x16("DMA11_Y_COUNT", 0600, parent, (u16 *)0xFFC01CD8);
		debugfs_create_x16("DMA11_Y_MODIFY", 0600, parent, (u16 *)0xFFC01CDC);

		parent = debugfs_create_dir("DMA12 (DMA1 Ch-4) Registers", top);
		debugfs_create_x16("DMA12_CONFIG", 0600, parent, (u16 *)0xFFC01D08);
		debugfs_create_x32("DMA12_CURR_ADDR", 0600, parent, (u32 *)0xFFC01D24);
		debugfs_create_x32("DMA12_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01D20);
		debugfs_create_x16("DMA12_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01D30);
		debugfs_create_x16("DMA12_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01D38);
		debugfs_create_x16("DMA12_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01D28);
		debugfs_create_x32("DMA12_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01D00);
		debugfs_create_x16("DMA12_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01D2C);
		debugfs_create_x32("DMA12_START_ADDR", 0600, parent, (u32 *)0xFFC01D04);
		debugfs_create_x16("DMA12_X_COUNT", 0600, parent, (u16 *)0xFFC01D10);
		debugfs_create_x16("DMA12_X_MODIFY", 0600, parent, (u16 *)0xFFC01D14);
		debugfs_create_x16("DMA12_Y_COUNT", 0600, parent, (u16 *)0xFFC01D18);
		debugfs_create_x16("DMA12_Y_MODIFY", 0600, parent, (u16 *)0xFFC01D1C);

		parent = debugfs_create_dir("DMA13 (DMA1 Ch-5) Registers", top);
		debugfs_create_x16("DMA13_CONFIG", 0600, parent, (u16 *)0xFFC01D48);
		debugfs_create_x32("DMA13_CURR_ADDR", 0600, parent, (u32 *)0xFFC01D64);
		debugfs_create_x32("DMA13_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01D60);
		debugfs_create_x16("DMA13_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01D70);
		debugfs_create_x16("DMA13_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01D78);
		debugfs_create_x16("DMA13_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01D68);
		debugfs_create_x32("DMA13_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01D40);
		debugfs_create_x16("DMA13_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01D6C);
		debugfs_create_x32("DMA13_START_ADDR", 0600, parent, (u32 *)0xFFC01D44);
		debugfs_create_x16("DMA13_X_COUNT", 0600, parent, (u16 *)0xFFC01D50);
		debugfs_create_x16("DMA13_X_MODIFY", 0600, parent, (u16 *)0xFFC01D54);
		debugfs_create_x16("DMA13_Y_COUNT", 0600, parent, (u16 *)0xFFC01D58);
		debugfs_create_x16("DMA13_Y_MODIFY", 0600, parent, (u16 *)0xFFC01D5C);

		parent = debugfs_create_dir("DMA14 (DMA1 Ch-6) Registers", top);
		debugfs_create_x16("DMA14_CONFIG", 0600, parent, (u16 *)0xFFC01D88);
		debugfs_create_x32("DMA14_CURR_ADDR", 0600, parent, (u32 *)0xFFC01DA4);
		debugfs_create_x32("DMA14_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01DA0);
		debugfs_create_x16("DMA14_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01DB0);
		debugfs_create_x16("DMA14_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01DB8);
		debugfs_create_x16("DMA14_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01DA8);
		debugfs_create_x32("DMA14_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01D80);
		debugfs_create_x16("DMA14_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01DAC);
		debugfs_create_x32("DMA14_START_ADDR", 0600, parent, (u32 *)0xFFC01D84);
		debugfs_create_x16("DMA14_X_COUNT", 0600, parent, (u16 *)0xFFC01D90);
		debugfs_create_x16("DMA14_X_MODIFY", 0600, parent, (u16 *)0xFFC01D94);
		debugfs_create_x16("DMA14_Y_COUNT", 0600, parent, (u16 *)0xFFC01D98);
		debugfs_create_x16("DMA14_Y_MODIFY", 0600, parent, (u16 *)0xFFC01D9C);

		parent = debugfs_create_dir("DMA15 (DMA1 Ch-7) Registers", top);
		debugfs_create_x16("DMA15_CONFIG", 0600, parent, (u16 *)0xFFC01DC8);
		debugfs_create_x32("DMA15_CURR_ADDR", 0600, parent, (u32 *)0xFFC01DE4);
		debugfs_create_x32("DMA15_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01DE0);
		debugfs_create_x16("DMA15_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01DF0);
		debugfs_create_x16("DMA15_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01DF8);
		debugfs_create_x16("DMA15_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01DE8);
		debugfs_create_x32("DMA15_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01DC0);
		debugfs_create_x16("DMA15_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01DEC);
		debugfs_create_x32("DMA15_START_ADDR", 0600, parent, (u32 *)0xFFC01DC4);
		debugfs_create_x16("DMA15_X_COUNT", 0600, parent, (u16 *)0xFFC01DD0);
		debugfs_create_x16("DMA15_X_MODIFY", 0600, parent, (u16 *)0xFFC01DD4);
		debugfs_create_x16("DMA15_Y_COUNT", 0600, parent, (u16 *)0xFFC01DD8);
		debugfs_create_x16("DMA15_Y_MODIFY", 0600, parent, (u16 *)0xFFC01DDC);

		parent = debugfs_create_dir("DMA16 (DMA1 Ch-8) Registers", top);
		debugfs_create_x16("DMA16_CONFIG", 0600, parent, (u16 *)0xFFC01E08);
		debugfs_create_x32("DMA16_CURR_ADDR", 0600, parent, (u32 *)0xFFC01E24);
		debugfs_create_x32("DMA16_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01E20);
		debugfs_create_x16("DMA16_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01E30);
		debugfs_create_x16("DMA16_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01E38);
		debugfs_create_x16("DMA16_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01E28);
		debugfs_create_x32("DMA16_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01E00);
		debugfs_create_x16("DMA16_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01E2C);
		debugfs_create_x32("DMA16_START_ADDR", 0600, parent, (u32 *)0xFFC01E04);
		debugfs_create_x16("DMA16_X_COUNT", 0600, parent, (u16 *)0xFFC01E10);
		debugfs_create_x16("DMA16_X_MODIFY", 0600, parent, (u16 *)0xFFC01E14);
		debugfs_create_x16("DMA16_Y_COUNT", 0600, parent, (u16 *)0xFFC01E18);
		debugfs_create_x16("DMA16_Y_MODIFY", 0600, parent, (u16 *)0xFFC01E1C);

		parent = debugfs_create_dir("DMA17 (DMA1 Ch-9) Registers", top);
		debugfs_create_x16("DMA17_CONFIG", 0600, parent, (u16 *)0xFFC01E48);
		debugfs_create_x32("DMA17_CURR_ADDR", 0600, parent, (u32 *)0xFFC01E64);
		debugfs_create_x32("DMA17_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01E60);
		debugfs_create_x16("DMA17_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01E70);
		debugfs_create_x16("DMA17_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01E78);
		debugfs_create_x16("DMA17_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01E68);
		debugfs_create_x32("DMA17_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01E40);
		debugfs_create_x16("DMA17_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01E6C);
		debugfs_create_x32("DMA17_START_ADDR", 0600, parent, (u32 *)0xFFC01E44);
		debugfs_create_x16("DMA17_X_COUNT", 0600, parent, (u16 *)0xFFC01E50);
		debugfs_create_x16("DMA17_X_MODIFY", 0600, parent, (u16 *)0xFFC01E54);
		debugfs_create_x16("DMA17_Y_COUNT", 0600, parent, (u16 *)0xFFC01E58);
		debugfs_create_x16("DMA17_Y_MODIFY", 0600, parent, (u16 *)0xFFC01E5C);

		parent = debugfs_create_dir("DMA18 (DMA1 Ch-10) Registers", top);
		debugfs_create_x16("DMA18_CONFIG", 0600, parent, (u16 *)0xFFC01E88);
		debugfs_create_x32("DMA18_CURR_ADDR", 0600, parent, (u32 *)0xFFC01EA4);
		debugfs_create_x32("DMA18_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01EA0);
		debugfs_create_x16("DMA18_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01EB0);
		debugfs_create_x16("DMA18_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01EB8);
		debugfs_create_x16("DMA18_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01EA8);
		debugfs_create_x32("DMA18_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01E80);
		debugfs_create_x16("DMA18_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01EAC);
		debugfs_create_x32("DMA18_START_ADDR", 0600, parent, (u32 *)0xFFC01E84);
		debugfs_create_x16("DMA18_X_COUNT", 0600, parent, (u16 *)0xFFC01E90);
		debugfs_create_x16("DMA18_X_MODIFY", 0600, parent, (u16 *)0xFFC01E94);
		debugfs_create_x16("DMA18_Y_COUNT", 0600, parent, (u16 *)0xFFC01E98);
		debugfs_create_x16("DMA18_Y_MODIFY", 0600, parent, (u16 *)0xFFC01E9C);

		parent = debugfs_create_dir("DMA19 (DMA1 Ch-11) Registers", top);
		debugfs_create_x16("DMA19_CONFIG", 0600, parent, (u16 *)0xFFC01EC8);
		debugfs_create_x32("DMA19_CURR_ADDR", 0600, parent, (u32 *)0xFFC01EE4);
		debugfs_create_x32("DMA19_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01EE0);
		debugfs_create_x16("DMA19_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01EF0);
		debugfs_create_x16("DMA19_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01EF8);
		debugfs_create_x16("DMA19_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01EE8);
		debugfs_create_x32("DMA19_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01EC0);
		debugfs_create_x16("DMA19_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01EEC);
		debugfs_create_x32("DMA19_START_ADDR", 0600, parent, (u32 *)0xFFC01EC4);
		debugfs_create_x16("DMA19_X_COUNT", 0600, parent, (u16 *)0xFFC01ED0);
		debugfs_create_x16("DMA19_X_MODIFY", 0600, parent, (u16 *)0xFFC01ED4);
		debugfs_create_x16("DMA19_Y_COUNT", 0600, parent, (u16 *)0xFFC01ED8);
		debugfs_create_x16("DMA19_Y_MODIFY", 0600, parent, (u16 *)0xFFC01EDC);

		parent = debugfs_create_dir("DMA2 (DMA0 Ch-2) Registers", top);
		debugfs_create_x16("DMA2_CONFIG", 0600, parent, (u16 *)0xFFC00C88);
		debugfs_create_x32("DMA2_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CA4);
		debugfs_create_x32("DMA2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CA0);
		debugfs_create_x16("DMA2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CB0);
		debugfs_create_x16("DMA2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CB8);
		debugfs_create_x16("DMA2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CA8);
		debugfs_create_x32("DMA2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C80);
		debugfs_create_x16("DMA2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CAC);
		debugfs_create_x32("DMA2_START_ADDR", 0600, parent, (u32 *)0xFFC00C84);
		debugfs_create_x16("DMA2_X_COUNT", 0600, parent, (u16 *)0xFFC00C90);
		debugfs_create_x16("DMA2_X_MODIFY", 0600, parent, (u16 *)0xFFC00C94);
		debugfs_create_x16("DMA2_Y_COUNT", 0600, parent, (u16 *)0xFFC00C98);
		debugfs_create_x16("DMA2_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C9C);

		parent = debugfs_create_dir("DMA3 (DMA0 Ch-3) Registers", top);
		debugfs_create_x16("DMA3_CONFIG", 0600, parent, (u16 *)0xFFC00CC8);
		debugfs_create_x32("DMA3_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CE4);
		debugfs_create_x32("DMA3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CE0);
		debugfs_create_x16("DMA3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CF0);
		debugfs_create_x16("DMA3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CF8);
		debugfs_create_x16("DMA3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CE8);
		debugfs_create_x32("DMA3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00CC0);
		debugfs_create_x16("DMA3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CEC);
		debugfs_create_x32("DMA3_START_ADDR", 0600, parent, (u32 *)0xFFC00CC4);
		debugfs_create_x16("DMA3_X_COUNT", 0600, parent, (u16 *)0xFFC00CD0);
		debugfs_create_x16("DMA3_X_MODIFY", 0600, parent, (u16 *)0xFFC00CD4);
		debugfs_create_x16("DMA3_Y_COUNT", 0600, parent, (u16 *)0xFFC00CD8);
		debugfs_create_x16("DMA3_Y_MODIFY", 0600, parent, (u16 *)0xFFC00CDC);

		parent = debugfs_create_dir("DMA4 (DMA0 Ch-4) Registers", top);
		debugfs_create_x16("DMA4_CONFIG", 0600, parent, (u16 *)0xFFC00D08);
		debugfs_create_x32("DMA4_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D24);
		debugfs_create_x32("DMA4_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D20);
		debugfs_create_x16("DMA4_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D30);
		debugfs_create_x16("DMA4_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D38);
		debugfs_create_x16("DMA4_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D28);
		debugfs_create_x32("DMA4_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D00);
		debugfs_create_x16("DMA4_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D2C);
		debugfs_create_x32("DMA4_START_ADDR", 0600, parent, (u32 *)0xFFC00D04);
		debugfs_create_x16("DMA4_X_COUNT", 0600, parent, (u16 *)0xFFC00D10);
		debugfs_create_x16("DMA4_X_MODIFY", 0600, parent, (u16 *)0xFFC00D14);
		debugfs_create_x16("DMA4_Y_COUNT", 0600, parent, (u16 *)0xFFC00D18);
		debugfs_create_x16("DMA4_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D1C);

		parent = debugfs_create_dir("DMA5 (DMA0 Ch-5) Registers", top);
		debugfs_create_x16("DMA5_CONFIG", 0600, parent, (u16 *)0xFFC00D48);
		debugfs_create_x32("DMA5_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D64);
		debugfs_create_x32("DMA5_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D60);
		debugfs_create_x16("DMA5_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D70);
		debugfs_create_x16("DMA5_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D78);
		debugfs_create_x16("DMA5_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D68);
		debugfs_create_x32("DMA5_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D40);
		debugfs_create_x16("DMA5_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D6C);
		debugfs_create_x32("DMA5_START_ADDR", 0600, parent, (u32 *)0xFFC00D44);
		debugfs_create_x16("DMA5_X_COUNT", 0600, parent, (u16 *)0xFFC00D50);
		debugfs_create_x16("DMA5_X_MODIFY", 0600, parent, (u16 *)0xFFC00D54);
		debugfs_create_x16("DMA5_Y_COUNT", 0600, parent, (u16 *)0xFFC00D58);
		debugfs_create_x16("DMA5_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D5C);

		parent = debugfs_create_dir("DMA6 (DMA0 Ch-6) Registers", top);
		debugfs_create_x16("DMA6_CONFIG", 0600, parent, (u16 *)0xFFC00D88);
		debugfs_create_x32("DMA6_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DA4);
		debugfs_create_x32("DMA6_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DA0);
		debugfs_create_x16("DMA6_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DB0);
		debugfs_create_x16("DMA6_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DB8);
		debugfs_create_x16("DMA6_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DA8);
		debugfs_create_x32("DMA6_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D80);
		debugfs_create_x16("DMA6_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DAC);
		debugfs_create_x32("DMA6_START_ADDR", 0600, parent, (u32 *)0xFFC00D84);
		debugfs_create_x16("DMA6_X_COUNT", 0600, parent, (u16 *)0xFFC00D90);
		debugfs_create_x16("DMA6_X_MODIFY", 0600, parent, (u16 *)0xFFC00D94);
		debugfs_create_x16("DMA6_Y_COUNT", 0600, parent, (u16 *)0xFFC00D98);
		debugfs_create_x16("DMA6_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D9C);

		parent = debugfs_create_dir("DMA7 (DMA0 Ch-7) Registers", top);
		debugfs_create_x16("DMA7_CONFIG", 0600, parent, (u16 *)0xFFC00DC8);
		debugfs_create_x32("DMA7_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DE4);
		debugfs_create_x32("DMA7_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DE0);
		debugfs_create_x16("DMA7_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DF0);
		debugfs_create_x16("DMA7_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DF8);
		debugfs_create_x16("DMA7_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DE8);
		debugfs_create_x32("DMA7_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00DC0);
		debugfs_create_x16("DMA7_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DEC);
		debugfs_create_x32("DMA7_START_ADDR", 0600, parent, (u32 *)0xFFC00DC4);
		debugfs_create_x16("DMA7_X_COUNT", 0600, parent, (u16 *)0xFFC00DD0);
		debugfs_create_x16("DMA7_X_MODIFY", 0600, parent, (u16 *)0xFFC00DD4);
		debugfs_create_x16("DMA7_Y_COUNT", 0600, parent, (u16 *)0xFFC00DD8);
		debugfs_create_x16("DMA7_Y_MODIFY", 0600, parent, (u16 *)0xFFC00DDC);

		parent = debugfs_create_dir("DMA8 (DMA1 Ch-0) Registers", top);
		debugfs_create_x16("DMA8_CONFIG", 0600, parent, (u16 *)0xFFC01C08);
		debugfs_create_x32("DMA8_CURR_ADDR", 0600, parent, (u32 *)0xFFC01C24);
		debugfs_create_x32("DMA8_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01C20);
		debugfs_create_x16("DMA8_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01C30);
		debugfs_create_x16("DMA8_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01C38);
		debugfs_create_x16("DMA8_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01C28);
		debugfs_create_x32("DMA8_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01C00);
		debugfs_create_x16("DMA8_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01C2C);
		debugfs_create_x32("DMA8_START_ADDR", 0600, parent, (u32 *)0xFFC01C04);
		debugfs_create_x16("DMA8_X_COUNT", 0600, parent, (u16 *)0xFFC01C10);
		debugfs_create_x16("DMA8_X_MODIFY", 0600, parent, (u16 *)0xFFC01C14);
		debugfs_create_x16("DMA8_Y_COUNT", 0600, parent, (u16 *)0xFFC01C18);
		debugfs_create_x16("DMA8_Y_MODIFY", 0600, parent, (u16 *)0xFFC01C1C);

		parent = debugfs_create_dir("DMA9 (DMA1 Ch-1) Registers", top);
		debugfs_create_x16("DMA9_CONFIG", 0600, parent, (u16 *)0xFFC01C48);
		debugfs_create_x32("DMA9_CURR_ADDR", 0600, parent, (u32 *)0xFFC01C64);
		debugfs_create_x32("DMA9_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01C60);
		debugfs_create_x16("DMA9_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01C70);
		debugfs_create_x16("DMA9_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01C78);
		debugfs_create_x16("DMA9_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01C68);
		debugfs_create_x32("DMA9_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01C40);
		debugfs_create_x16("DMA9_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01C6C);
		debugfs_create_x32("DMA9_START_ADDR", 0600, parent, (u32 *)0xFFC01C44);
		debugfs_create_x16("DMA9_X_COUNT", 0600, parent, (u16 *)0xFFC01C50);
		debugfs_create_x16("DMA9_X_MODIFY", 0600, parent, (u16 *)0xFFC01C54);
		debugfs_create_x16("DMA9_Y_COUNT", 0600, parent, (u16 *)0xFFC01C58);
		debugfs_create_x16("DMA9_Y_MODIFY", 0600, parent, (u16 *)0xFFC01C5C);

		parent = debugfs_create_dir("EBIU", top);
		debugfs_create_x32("EBIU_AMBCTL0", 0600, parent, (u32 *)0xFFC00A04);
		debugfs_create_x32("EBIU_AMBCTL1", 0600, parent, (u32 *)0xFFC00A08);
		debugfs_create_x16("EBIU_AMGCTL", 0600, parent, (u16 *)0xFFC00A00);
		debugfs_create_x16("EBIU_SDBCTL", 0600, parent, (u16 *)0xFFC00A14);
		debugfs_create_x32("EBIU_SDGCTL", 0600, parent, (u32 *)0xFFC00A10);
		debugfs_create_x16("EBIU_SDRRC", 0600, parent, (u16 *)0xFFC00A18);
		debugfs_create_x16("EBIU_SDSTAT", 0600, parent, (u16 *)0xFFC00A1C);

		parent = debugfs_create_dir("Event Vectors", top);
		debugfs_create_x32("EVT0", 0600, parent, (u32 *)0xFFE02000);
		debugfs_create_x32("EVT10", 0600, parent, (u32 *)0xFFE02028);
		debugfs_create_x32("EVT11", 0600, parent, (u32 *)0xFFE0202C);
		debugfs_create_x32("EVT12", 0600, parent, (u32 *)0xFFE02030);
		debugfs_create_x32("EVT13", 0600, parent, (u32 *)0xFFE02034);
		debugfs_create_x32("EVT14", 0600, parent, (u32 *)0xFFE02038);
		debugfs_create_x32("EVT15", 0600, parent, (u32 *)0xFFE0203C);
		debugfs_create_x32("EVT1", 0600, parent, (u32 *)0xFFE02004);
		debugfs_create_x32("EVT2", 0600, parent, (u32 *)0xFFE02008);
		debugfs_create_x32("EVT3", 0600, parent, (u32 *)0xFFE0200C);
		debugfs_create_x32("EVT4", 0600, parent, (u32 *)0xFFE02010);
		debugfs_create_x32("EVT5", 0600, parent, (u32 *)0xFFE02014);
		debugfs_create_x32("EVT6", 0600, parent, (u32 *)0xFFE02018);
		debugfs_create_x32("EVT7", 0600, parent, (u32 *)0xFFE0201C);
		debugfs_create_x32("EVT8", 0600, parent, (u32 *)0xFFE02020);
		debugfs_create_x32("EVT9", 0600, parent, (u32 *)0xFFE02024);

		parent = debugfs_create_dir("Extended Registers", top);
		debugfs_create_x32("CHIPID", 0600, parent, (u32 *)0xFFC00014);
		debugfs_create_x32("DSPID", 0600, parent, (u32 *)0xFFE05000);

		parent = debugfs_create_dir("GPIO Port C", top);
		debugfs_create_x16("PORTCIO", 0600, parent, (u16 *)0xFFC01510);
		debugfs_create_x16("PORTCIO_CLEAR", 0600, parent, (u16 *)0xFFC01520);
		debugfs_create_x16("PORTCIO_DIR", 0600, parent, (u16 *)0xFFC01550);
		debugfs_create_x16("PORTCIO_FER", 0600, parent, (u16 *)0xFFC01500);
		debugfs_create_x16("PORTCIO_INEN", 0600, parent, (u16 *)0xFFC01560);
		debugfs_create_x16("PORTCIO_SET", 0600, parent, (u16 *)0xFFC01530);
		debugfs_create_x16("PORTCIO_TOGGLE", 0600, parent, (u16 *)0xFFC01540);

		parent = debugfs_create_dir("GPIO Port D", top);
		debugfs_create_x16("PORTDIO", 0600, parent, (u16 *)0xFFC01514);
		debugfs_create_x16("PORTDIO_CLEAR", 0600, parent, (u16 *)0xFFC01524);
		debugfs_create_x16("PORTDIO_DIR", 0600, parent, (u16 *)0xFFC01554);
		debugfs_create_x16("PORTDIO_FER", 0600, parent, (u16 *)0xFFC01504);
		debugfs_create_x16("PORTDIO_INEN", 0600, parent, (u16 *)0xFFC01564);
		debugfs_create_x16("PORTDIO_SET", 0600, parent, (u16 *)0xFFC01534);
		debugfs_create_x16("PORTDIO_TOGGLE", 0600, parent, (u16 *)0xFFC01544);

		parent = debugfs_create_dir("GPIO Port E", top);
		debugfs_create_x16("PORTEIO", 0600, parent, (u16 *)0xFFC01518);
		debugfs_create_x16("PORTEIO_CLEAR", 0600, parent, (u16 *)0xFFC01528);
		debugfs_create_x16("PORTEIO_DIR", 0600, parent, (u16 *)0xFFC01558);
		debugfs_create_x16("PORTEIO_FER", 0600, parent, (u16 *)0xFFC01508);
		debugfs_create_x16("PORTEIO_INEN", 0600, parent, (u16 *)0xFFC01568);
		debugfs_create_x16("PORTEIO_SET", 0600, parent, (u16 *)0xFFC01538);
		debugfs_create_x16("PORTEIO_TOGGLE", 0600, parent, (u16 *)0xFFC01548);

		parent = debugfs_create_dir("GPIO Port F", top);
		debugfs_create_x16("PORTFIO", 0600, parent, (u16 *)0xFFC00700);
		debugfs_create_x16("PORTFIO_BOTH", 0600, parent, (u16 *)0xFFC0073C);
		debugfs_create_x16("PORTFIO_CLEAR", 0600, parent, (u16 *)0xFFC00704);
		debugfs_create_x16("PORTFIO_DIR", 0600, parent, (u16 *)0xFFC00730);
		debugfs_create_x16("PORTFIO_EDGE", 0600, parent, (u16 *)0xFFC00738);
		debugfs_create_x16("PORTFIO_INEN", 0600, parent, (u16 *)0xFFC00740);
		debugfs_create_x16("PORTFIO_MASKA", 0600, parent, (u16 *)0xFFC00710);
		debugfs_create_x16("PORTFIO_MASKA_CLEAR", 0600, parent, (u16 *)0xFFC00714);
		debugfs_create_x16("PORTFIO_MASKA_SET", 0600, parent, (u16 *)0xFFC00718);
		debugfs_create_x16("PORTFIO_MASKA_TOGGLE", 0600, parent, (u16 *)0xFFC0071C);
		debugfs_create_x16("PORTFIO_MASKB", 0600, parent, (u16 *)0xFFC00720);
		debugfs_create_x16("PORTFIO_MASKB_CLEAR", 0600, parent, (u16 *)0xFFC00724);
		debugfs_create_x16("PORTFIO_MASKB_SET", 0600, parent, (u16 *)0xFFC00728);
		debugfs_create_x16("PORTFIO_MASKB_TOGGLE", 0600, parent, (u16 *)0xFFC0072C);
		debugfs_create_x16("PORTFIO_POLAR", 0600, parent, (u16 *)0xFFC00734);
		debugfs_create_x16("PORTFIO_SET", 0600, parent, (u16 *)0xFFC00708);
		debugfs_create_x16("PORTFIO_TOGGLE", 0600, parent, (u16 *)0xFFC0070C);

		parent = debugfs_create_dir("Interrupt Controller", top);
		debugfs_create_x32("ILAT", 0600, parent, (u32 *)0xFFE0210C);
		debugfs_create_x32("IMASK", 0600, parent, (u32 *)0xFFE02104);
		debugfs_create_x32("IPEND", 0600, parent, (u32 *)0xFFE02108);
		debugfs_create_x32("IPRIO", 0600, parent, (u32 *)0xFFE02110);

		parent = debugfs_create_dir("L1 Code Memory Registers", top);
		debugfs_create_x32("ICPLB_ADDR0", 0600, parent, (u32 *)0xFFE01100);
		debugfs_create_x32("ICPLB_ADDR10", 0600, parent, (u32 *)0xFFE01128);
		debugfs_create_x32("ICPLB_ADDR11", 0600, parent, (u32 *)0xFFE0112C);
		debugfs_create_x32("ICPLB_ADDR12", 0600, parent, (u32 *)0xFFE01130);
		debugfs_create_x32("ICPLB_ADDR13", 0600, parent, (u32 *)0xFFE01134);
		debugfs_create_x32("ICPLB_ADDR14", 0600, parent, (u32 *)0xFFE01138);
		debugfs_create_x32("ICPLB_ADDR15", 0600, parent, (u32 *)0xFFE0113C);
		debugfs_create_x32("ICPLB_ADDR1", 0600, parent, (u32 *)0xFFE01104);
		debugfs_create_x32("ICPLB_ADDR2", 0600, parent, (u32 *)0xFFE01108);
		debugfs_create_x32("ICPLB_ADDR3", 0600, parent, (u32 *)0xFFE0110C);
		debugfs_create_x32("ICPLB_ADDR4", 0600, parent, (u32 *)0xFFE01110);
		debugfs_create_x32("ICPLB_ADDR5", 0600, parent, (u32 *)0xFFE01114);
		debugfs_create_x32("ICPLB_ADDR6", 0600, parent, (u32 *)0xFFE01118);
		debugfs_create_x32("ICPLB_ADDR7", 0600, parent, (u32 *)0xFFE0111C);
		debugfs_create_x32("ICPLB_ADDR8", 0600, parent, (u32 *)0xFFE01120);
		debugfs_create_x32("ICPLB_ADDR9", 0600, parent, (u32 *)0xFFE01124);
		debugfs_create_x32("ICPLB_DATA0", 0600, parent, (u32 *)0xFFE01200);
		debugfs_create_x32("ICPLB_DATA10", 0600, parent, (u32 *)0xFFE01228);
		debugfs_create_x32("ICPLB_DATA11", 0600, parent, (u32 *)0xFFE0122C);
		debugfs_create_x32("ICPLB_DATA12", 0600, parent, (u32 *)0xFFE01230);
		debugfs_create_x32("ICPLB_DATA13", 0600, parent, (u32 *)0xFFE01234);
		debugfs_create_x32("ICPLB_DATA14", 0600, parent, (u32 *)0xFFE01238);
		debugfs_create_x32("ICPLB_DATA15", 0600, parent, (u32 *)0xFFE0123C);
		debugfs_create_x32("ICPLB_DATA1", 0600, parent, (u32 *)0xFFE01204);
		debugfs_create_x32("ICPLB_DATA2", 0600, parent, (u32 *)0xFFE01208);
		debugfs_create_x32("ICPLB_DATA3", 0600, parent, (u32 *)0xFFE0120C);
		debugfs_create_x32("ICPLB_DATA4", 0600, parent, (u32 *)0xFFE01210);
		debugfs_create_x32("ICPLB_DATA5", 0600, parent, (u32 *)0xFFE01214);
		debugfs_create_x32("ICPLB_DATA6", 0600, parent, (u32 *)0xFFE01218);
		debugfs_create_x32("ICPLB_DATA7", 0600, parent, (u32 *)0xFFE0121C);
		debugfs_create_x32("ICPLB_DATA8", 0600, parent, (u32 *)0xFFE01220);
		debugfs_create_x32("ICPLB_DATA9", 0600, parent, (u32 *)0xFFE01224);
		debugfs_create_x32("ICPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0100C);
		debugfs_create_x32("ICPLB_STATUS", 0600, parent, (u32 *)0xFFE01008);
		debugfs_create_x32("IMEM_CONTROL", 0600, parent, (u32 *)0xFFE01004);
		debugfs_create_x32("ITEST_COMMAND", 0600, parent, (u32 *)0xFFE01300);
		debugfs_create_x32("ITEST_DATA0", 0600, parent, (u32 *)0xFFE01400);
		debugfs_create_x32("ITEST_DATA1", 0600, parent, (u32 *)0xFFE01404);

		parent = debugfs_create_dir("L1 Data Memory Registers", top);
		debugfs_create_x32("DCPLB_ADDR0", 0600, parent, (u32 *)0xFFE00100);
		debugfs_create_x32("DCPLB_ADDR10", 0600, parent, (u32 *)0xFFE00128);
		debugfs_create_x32("DCPLB_ADDR11", 0600, parent, (u32 *)0xFFE0012C);
		debugfs_create_x32("DCPLB_ADDR12", 0600, parent, (u32 *)0xFFE00130);
		debugfs_create_x32("DCPLB_ADDR13", 0600, parent, (u32 *)0xFFE00134);
		debugfs_create_x32("DCPLB_ADDR14", 0600, parent, (u32 *)0xFFE00138);
		debugfs_create_x32("DCPLB_ADDR15", 0600, parent, (u32 *)0xFFE0013C);
		debugfs_create_x32("DCPLB_ADDR1", 0600, parent, (u32 *)0xFFE00104);
		debugfs_create_x32("DCPLB_ADDR2", 0600, parent, (u32 *)0xFFE00108);
		debugfs_create_x32("DCPLB_ADDR3", 0600, parent, (u32 *)0xFFE0010C);
		debugfs_create_x32("DCPLB_ADDR4", 0600, parent, (u32 *)0xFFE00110);
		debugfs_create_x32("DCPLB_ADDR5", 0600, parent, (u32 *)0xFFE00114);
		debugfs_create_x32("DCPLB_ADDR6", 0600, parent, (u32 *)0xFFE00118);
		debugfs_create_x32("DCPLB_ADDR7", 0600, parent, (u32 *)0xFFE0011C);
		debugfs_create_x32("DCPLB_ADDR8", 0600, parent, (u32 *)0xFFE00120);
		debugfs_create_x32("DCPLB_ADDR9", 0600, parent, (u32 *)0xFFE00124);
		debugfs_create_x32("DCPLB_DATA0", 0600, parent, (u32 *)0xFFE00200);
		debugfs_create_x32("DCPLB_DATA10", 0600, parent, (u32 *)0xFFE00228);
		debugfs_create_x32("DCPLB_DATA11", 0600, parent, (u32 *)0xFFE0022C);
		debugfs_create_x32("DCPLB_DATA12", 0600, parent, (u32 *)0xFFE00230);
		debugfs_create_x32("DCPLB_DATA13", 0600, parent, (u32 *)0xFFE00234);
		debugfs_create_x32("DCPLB_DATA14", 0600, parent, (u32 *)0xFFE00238);
		debugfs_create_x32("DCPLB_DATA15", 0600, parent, (u32 *)0xFFE0023C);
		debugfs_create_x32("DCPLB_DATA1", 0600, parent, (u32 *)0xFFE00204);
		debugfs_create_x32("DCPLB_DATA2", 0600, parent, (u32 *)0xFFE00208);
		debugfs_create_x32("DCPLB_DATA3", 0600, parent, (u32 *)0xFFE0020C);
		debugfs_create_x32("DCPLB_DATA4", 0600, parent, (u32 *)0xFFE00210);
		debugfs_create_x32("DCPLB_DATA5", 0600, parent, (u32 *)0xFFE00214);
		debugfs_create_x32("DCPLB_DATA6", 0600, parent, (u32 *)0xFFE00218);
		debugfs_create_x32("DCPLB_DATA7", 0600, parent, (u32 *)0xFFE0021C);
		debugfs_create_x32("DCPLB_DATA8", 0600, parent, (u32 *)0xFFE00220);
		debugfs_create_x32("DCPLB_DATA9", 0600, parent, (u32 *)0xFFE00224);
		debugfs_create_x32("DCPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0000C);
		debugfs_create_x32("DCPLB_STATUS", 0600, parent, (u32 *)0xFFE00008);
		debugfs_create_x32("DMEM_CONTROL", 0600, parent, (u32 *)0xFFE00004);
		debugfs_create_x32("DTEST_COMMAND", 0600, parent, (u32 *)0xFFE00300);
		debugfs_create_x32("DTEST_DATA0", 0600, parent, (u32 *)0xFFE00400);
		debugfs_create_x32("DTEST_DATA1", 0600, parent, (u32 *)0xFFE00404);
		debugfs_create_x32("SRAM_BASE_ADDR", 0600, parent, (u32 *)0xFFE00000);

		parent = debugfs_create_dir("MEMDMA0 Destination0 Registers", top);
		debugfs_create_x16("MDMA0_D0_CONFIG", 0600, parent, (u16 *)0xFFC00E08);
		debugfs_create_x32("MDMA0_D0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E24);
		debugfs_create_x32("MDMA0_D0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E20);
		debugfs_create_x16("MDMA0_D0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E30);
		debugfs_create_x16("MDMA0_D0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E38);
		debugfs_create_x16("MDMA0_D0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E28);
		debugfs_create_x32("MDMA0_D0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E00);
		debugfs_create_x16("MDMA0_D0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E2C);
		debugfs_create_x32("MDMA0_D0_START_ADDR", 0600, parent, (u32 *)0xFFC00E04);
		debugfs_create_x16("MDMA0_D0_X_COUNT", 0600, parent, (u16 *)0xFFC00E10);
		debugfs_create_x16("MDMA0_D0_X_MODIFY", 0600, parent, (u16 *)0xFFC00E14);
		debugfs_create_x16("MDMA0_D0_Y_COUNT", 0600, parent, (u16 *)0xFFC00E18);
		debugfs_create_x16("MDMA0_D0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E1C);

		parent = debugfs_create_dir("MEMDMA0 Destination1 Registers", top);
		debugfs_create_x16("MDMA0_D1_CONFIG", 0600, parent, (u16 *)0xFFC00E88);
		debugfs_create_x32("MDMA0_D1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EA4);
		debugfs_create_x32("MDMA0_D1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EA0);
		debugfs_create_x16("MDMA0_D1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EB0);
		debugfs_create_x16("MDMA0_D1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EB8);
		debugfs_create_x16("MDMA0_D1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EA8);
		debugfs_create_x32("MDMA0_D1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E80);
		debugfs_create_x16("MDMA0_D1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EAC);
		debugfs_create_x32("MDMA0_D1_START_ADDR", 0600, parent, (u32 *)0xFFC00E84);
		debugfs_create_x16("MDMA0_D1_X_COUNT", 0600, parent, (u16 *)0xFFC00E90);
		debugfs_create_x16("MDMA0_D1_X_MODIFY", 0600, parent, (u16 *)0xFFC00E94);
		debugfs_create_x16("MDMA0_D1_Y_COUNT", 0600, parent, (u16 *)0xFFC00E98);
		debugfs_create_x16("MDMA0_D1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E9C);

		parent = debugfs_create_dir("MEMDMA0 Source0 Registers", top);
		debugfs_create_x16("MDMA0_S0_CONFIG", 0600, parent, (u16 *)0xFFC00E48);
		debugfs_create_x32("MDMA0_S0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E64);
		debugfs_create_x32("MDMA0_S0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E60);
		debugfs_create_x16("MDMA0_S0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E70);
		debugfs_create_x16("MDMA0_S0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E78);
		debugfs_create_x16("MDMA0_S0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E68);
		debugfs_create_x32("MDMA0_S0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E40);
		debugfs_create_x16("MDMA0_S0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E6C);
		debugfs_create_x32("MDMA0_S0_START_ADDR", 0600, parent, (u32 *)0xFFC00E44);
		debugfs_create_x16("MDMA0_S0_X_COUNT", 0600, parent, (u16 *)0xFFC00E50);
		debugfs_create_x16("MDMA0_S0_X_MODIFY", 0600, parent, (u16 *)0xFFC00E54);
		debugfs_create_x16("MDMA0_S0_Y_COUNT", 0600, parent, (u16 *)0xFFC00E58);
		debugfs_create_x16("MDMA0_S0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E5C);

		parent = debugfs_create_dir("MEMDMA0 Source1 Registers", top);
		debugfs_create_x16("MDMA0_S1_CONFIG", 0600, parent, (u16 *)0xFFC00EC8);
		debugfs_create_x32("MDMA0_S1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EE4);
		debugfs_create_x32("MDMA0_S1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EE0);
		debugfs_create_x16("MDMA0_S1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EF0);
		debugfs_create_x16("MDMA0_S1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EF8);
		debugfs_create_x16("MDMA0_S1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EE8);
		debugfs_create_x32("MDMA0_S1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00EC0);
		debugfs_create_x16("MDMA0_S1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EEC);
		debugfs_create_x32("MDMA0_S1_START_ADDR", 0600, parent, (u32 *)0xFFC00EC4);
		debugfs_create_x16("MDMA0_S1_X_COUNT", 0600, parent, (u16 *)0xFFC00ED0);
		debugfs_create_x16("MDMA0_S1_X_MODIFY", 0600, parent, (u16 *)0xFFC00ED4);
		debugfs_create_x16("MDMA0_S1_Y_COUNT", 0600, parent, (u16 *)0xFFC00ED8);
		debugfs_create_x16("MDMA0_S1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00EDC);

		parent = debugfs_create_dir("MEMDMA1 Destination0 Registers", top);
		debugfs_create_x16("MDMA1_D0_CONFIG", 0600, parent, (u16 *)0xFFC01F08);
		debugfs_create_x32("MDMA1_D0_CURR_ADDR", 0600, parent, (u32 *)0xFFC01F24);
		debugfs_create_x32("MDMA1_D0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01F20);
		debugfs_create_x16("MDMA1_D0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01F30);
		debugfs_create_x16("MDMA1_D0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01F38);
		debugfs_create_x16("MDMA1_D0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01F28);
		debugfs_create_x32("MDMA1_D0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01F00);
		debugfs_create_x16("MDMA1_D0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01F2C);
		debugfs_create_x32("MDMA1_D0_START_ADDR", 0600, parent, (u32 *)0xFFC01F04);
		debugfs_create_x16("MDMA1_D0_X_COUNT", 0600, parent, (u16 *)0xFFC01F10);
		debugfs_create_x16("MDMA1_D0_X_MODIFY", 0600, parent, (u16 *)0xFFC01F14);
		debugfs_create_x16("MDMA1_D0_Y_COUNT", 0600, parent, (u16 *)0xFFC01F18);
		debugfs_create_x16("MDMA1_D0_Y_MODIFY", 0600, parent, (u16 *)0xFFC01F1C);

		parent = debugfs_create_dir("MEMDMA1 Destination1 Registers", top);
		debugfs_create_x16("MDMA1_D1_CONFIG", 0600, parent, (u16 *)0xFFC01F88);
		debugfs_create_x32("MDMA1_D1_CURR_ADDR", 0600, parent, (u32 *)0xFFC01FA4);
		debugfs_create_x32("MDMA1_D1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01FA0);
		debugfs_create_x16("MDMA1_D1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01FB0);
		debugfs_create_x16("MDMA1_D1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01FB8);
		debugfs_create_x16("MDMA1_D1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01FA8);
		debugfs_create_x32("MDMA1_D1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01F80);
		debugfs_create_x16("MDMA1_D1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01FAC);
		debugfs_create_x32("MDMA1_D1_START_ADDR", 0600, parent, (u32 *)0xFFC01F84);
		debugfs_create_x16("MDMA1_D1_X_COUNT", 0600, parent, (u16 *)0xFFC01F90);
		debugfs_create_x16("MDMA1_D1_X_MODIFY", 0600, parent, (u16 *)0xFFC01F94);
		debugfs_create_x16("MDMA1_D1_Y_COUNT", 0600, parent, (u16 *)0xFFC01F98);
		debugfs_create_x16("MDMA1_D1_Y_MODIFY", 0600, parent, (u16 *)0xFFC01F9C);

		parent = debugfs_create_dir("MEMDMA1 Source0 Registers", top);
		debugfs_create_x16("MDMA1_S0_CONFIG", 0600, parent, (u16 *)0xFFC01F48);
		debugfs_create_x32("MDMA1_S0_CURR_ADDR", 0600, parent, (u32 *)0xFFC01F64);
		debugfs_create_x32("MDMA1_S0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01F60);
		debugfs_create_x16("MDMA1_S0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01F70);
		debugfs_create_x16("MDMA1_S0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01F78);
		debugfs_create_x16("MDMA1_S0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01F68);
		debugfs_create_x32("MDMA1_S0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01F40);
		debugfs_create_x16("MDMA1_S0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01F6C);
		debugfs_create_x32("MDMA1_S0_START_ADDR", 0600, parent, (u32 *)0xFFC01F44);
		debugfs_create_x16("MDMA1_S0_X_COUNT", 0600, parent, (u16 *)0xFFC01F50);
		debugfs_create_x16("MDMA1_S0_X_MODIFY", 0600, parent, (u16 *)0xFFC01F54);
		debugfs_create_x16("MDMA1_S0_Y_COUNT", 0600, parent, (u16 *)0xFFC01F58);
		debugfs_create_x16("MDMA1_S0_Y_MODIFY", 0600, parent, (u16 *)0xFFC01F5C);

		parent = debugfs_create_dir("MEMDMA1 Source1 Registers", top);
		debugfs_create_x16("MDMA1_S1_CONFIG", 0600, parent, (u16 *)0xFFC01FC8);
		debugfs_create_x32("MDMA1_S1_CURR_ADDR", 0600, parent, (u32 *)0xFFC01FE4);
		debugfs_create_x32("MDMA1_S1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01FE0);
		debugfs_create_x16("MDMA1_S1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01FF0);
		debugfs_create_x16("MDMA1_S1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01FF8);
		debugfs_create_x16("MDMA1_S1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01FE8);
		debugfs_create_x32("MDMA1_S1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01FC0);
		debugfs_create_x16("MDMA1_S1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01FEC);
		debugfs_create_x32("MDMA1_S1_START_ADDR", 0600, parent, (u32 *)0xFFC01FC4);
		debugfs_create_x16("MDMA1_S1_X_COUNT", 0600, parent, (u16 *)0xFFC01FD0);
		debugfs_create_x16("MDMA1_S1_X_MODIFY", 0600, parent, (u16 *)0xFFC01FD4);
		debugfs_create_x16("MDMA1_S1_Y_COUNT", 0600, parent, (u16 *)0xFFC01FD8);
		debugfs_create_x16("MDMA1_S1_Y_MODIFY", 0600, parent, (u16 *)0xFFC01FDC);

		parent = debugfs_create_dir("PLL", top);
		debugfs_create_x16("PLL_CTL", 0600, parent, (u16 *)0xFFC00000);
		debugfs_create_x16("PLL_DIV", 0600, parent, (u16 *)0xFFC00004);
		debugfs_create_x16("PLL_LOCKCNT", 0600, parent, (u16 *)0xFFC00010);
		debugfs_create_x16("PLL_STAT", 0600, parent, (u16 *)0xFFC0000C);
		debugfs_create_x16("VR_CTL", 0600, parent, (u16 *)0xFFC00008);

		parent = debugfs_create_dir("PPI", top);
		debugfs_create_x16("PPI_CONTROL", 0600, parent, (u16 *)0xFFC01000);
		debugfs_create_x16("PPI_COUNT", 0600, parent, (u16 *)0xFFC01008);
		debugfs_create_x16("PPI_DELAY", 0600, parent, (u16 *)0xFFC0100C);
		debugfs_create_x16("PPI_FRAME", 0600, parent, (u16 *)0xFFC01010);
		debugfs_create_x16("PPI_STATUS", 0600, parent, (u16 *)0xFFC01004);

		parent = debugfs_create_dir("Performance Monitor", top);
		debugfs_create_x32("PFCNTR0", 0600, parent, (u32 *)0xFFE08100);
		debugfs_create_x32("PFCNTR1", 0600, parent, (u32 *)0xFFE08104);
		debugfs_create_x32("PFCTL", 0600, parent, (u32 *)0xFFE08000);

		parent = debugfs_create_dir("RTC", top);
		debugfs_create_x32("RTC_ALARM", 0600, parent, (u32 *)0xFFC00310);
		debugfs_create_x16("RTC_ICTL", 0600, parent, (u16 *)0xFFC00304);
		debugfs_create_x16("RTC_ISTAT", 0600, parent, (u16 *)0xFFC00308);
		debugfs_create_x16("RTC_PREN", 0600, parent, (u16 *)0xFFC00314);
		debugfs_create_x32("RTC_STAT", 0600, parent, (u32 *)0xFFC00300);
		debugfs_create_x16("RTC_SWCNT", 0600, parent, (u16 *)0xFFC0030C);

		parent = debugfs_create_dir("SPI", top);
		debugfs_create_x16("SPI0_BAUD", 0600, parent, (u16 *)0xFFC00514);
		debugfs_create_x16("SPI0_CTL", 0600, parent, (u16 *)0xFFC00500);
		debugfs_create_x16("SPI0_FLG", 0600, parent, (u16 *)0xFFC00504);
		debugfs_create_x16("SPI0_RDBR", 0600, parent, (u16 *)0xFFC00510);
		debugfs_create_x16("SPI0_SHADOW", 0600, parent, (u16 *)0xFFC00518);
		debugfs_create_x16("SPI0_STAT", 0600, parent, (u16 *)0xFFC00508);
		debugfs_create_x16("SPI0_TDBR", 0600, parent, (u16 *)0xFFC0050C);
		debugfs_create_x16("SPI1_BAUD", 0600, parent, (u16 *)0xFFC02314);
		debugfs_create_x16("SPI1_CTL", 0600, parent, (u16 *)0xFFC02300);
		debugfs_create_x16("SPI1_FLG", 0600, parent, (u16 *)0xFFC02304);
		debugfs_create_x16("SPI1_RDBR", 0600, parent, (u16 *)0xFFC02310);
		debugfs_create_x16("SPI1_SHADOW", 0600, parent, (u16 *)0xFFC02318);
		debugfs_create_x16("SPI1_STAT", 0600, parent, (u16 *)0xFFC02308);
		debugfs_create_x16("SPI1_TDBR", 0600, parent, (u16 *)0xFFC0230C);
		debugfs_create_x16("SPI2_BAUD", 0600, parent, (u16 *)0xFFC02414);
		debugfs_create_x16("SPI2_CTL", 0600, parent, (u16 *)0xFFC02400);
		debugfs_create_x16("SPI2_FLG", 0600, parent, (u16 *)0xFFC02404);
		debugfs_create_x16("SPI2_RDBR", 0600, parent, (u16 *)0xFFC02410);
		debugfs_create_x16("SPI2_SHADOW", 0600, parent, (u16 *)0xFFC02418);
		debugfs_create_x16("SPI2_STAT", 0600, parent, (u16 *)0xFFC02408);
		debugfs_create_x16("SPI2_TDBR", 0600, parent, (u16 *)0xFFC0240C);

		parent = debugfs_create_dir("SPORT", top);
		debugfs_create_x16("SPORT0_CHNL", 0600, parent, (u16 *)0xFFC00834);
		debugfs_create_x16("SPORT0_MCMC1", 0600, parent, (u16 *)0xFFC00838);
		debugfs_create_x16("SPORT0_MCMC2", 0600, parent, (u16 *)0xFFC0083C);
		debugfs_create_x32("SPORT0_MRCS0", 0600, parent, (u32 *)0xFFC00850);
		debugfs_create_x32("SPORT0_MRCS1", 0600, parent, (u32 *)0xFFC00854);
		debugfs_create_x32("SPORT0_MRCS2", 0600, parent, (u32 *)0xFFC00858);
		debugfs_create_x32("SPORT0_MRCS3", 0600, parent, (u32 *)0xFFC0085C);
		debugfs_create_x32("SPORT0_MTCS0", 0600, parent, (u32 *)0xFFC00840);
		debugfs_create_x32("SPORT0_MTCS1", 0600, parent, (u32 *)0xFFC00844);
		debugfs_create_x32("SPORT0_MTCS2", 0600, parent, (u32 *)0xFFC00848);
		debugfs_create_x32("SPORT0_MTCS3", 0600, parent, (u32 *)0xFFC0084C);
		debugfs_create_x16("SPORT0_RCLKDIV", 0600, parent, (u16 *)0xFFC00828);
		debugfs_create_x16("SPORT0_RCR1", 0600, parent, (u16 *)0xFFC00820);
		debugfs_create_x16("SPORT0_RCR2", 0600, parent, (u16 *)0xFFC00824);
		debugfs_create_x16("SPORT0_RFSDIV", 0600, parent, (u16 *)0xFFC0082C);
		debugfs_create_x32("SPORT0_RX", 0600, parent, (u32 *)0xFFC00818);
		debugfs_create_x16("SPORT0_STAT", 0600, parent, (u16 *)0xFFC00830);
		debugfs_create_x16("SPORT0_TCLKDIV", 0600, parent, (u16 *)0xFFC00808);
		debugfs_create_x16("SPORT0_TCR1", 0600, parent, (u16 *)0xFFC00800);
		debugfs_create_x16("SPORT0_TCR2", 0600, parent, (u16 *)0xFFC00804);
		debugfs_create_x16("SPORT0_TFSDIV", 0600, parent, (u16 *)0xFFC0080C);
		debugfs_create_x32("SPORT0_TX", 0600, parent, (u32 *)0xFFC00810);
		debugfs_create_x16("SPORT1_CHNL", 0600, parent, (u16 *)0xFFC00934);
		debugfs_create_x16("SPORT1_MCMC1", 0600, parent, (u16 *)0xFFC00938);
		debugfs_create_x16("SPORT1_MCMC2", 0600, parent, (u16 *)0xFFC0093C);
		debugfs_create_x32("SPORT1_MRCS0", 0600, parent, (u32 *)0xFFC00950);
		debugfs_create_x32("SPORT1_MRCS1", 0600, parent, (u32 *)0xFFC00954);
		debugfs_create_x32("SPORT1_MRCS2", 0600, parent, (u32 *)0xFFC00958);
		debugfs_create_x32("SPORT1_MRCS3", 0600, parent, (u32 *)0xFFC0095C);
		debugfs_create_x32("SPORT1_MTCS0", 0600, parent, (u32 *)0xFFC00940);
		debugfs_create_x32("SPORT1_MTCS1", 0600, parent, (u32 *)0xFFC00944);
		debugfs_create_x32("SPORT1_MTCS2", 0600, parent, (u32 *)0xFFC00948);
		debugfs_create_x32("SPORT1_MTCS3", 0600, parent, (u32 *)0xFFC0094C);
		debugfs_create_x16("SPORT1_RCLKDIV", 0600, parent, (u16 *)0xFFC00928);
		debugfs_create_x16("SPORT1_RCR1", 0600, parent, (u16 *)0xFFC00920);
		debugfs_create_x16("SPORT1_RCR2", 0600, parent, (u16 *)0xFFC00924);
		debugfs_create_x16("SPORT1_RFSDIV", 0600, parent, (u16 *)0xFFC0092C);
		debugfs_create_x32("SPORT1_RX", 0600, parent, (u32 *)0xFFC00918);
		debugfs_create_x16("SPORT1_STAT", 0600, parent, (u16 *)0xFFC00930);
		debugfs_create_x16("SPORT1_TCLKDIV", 0600, parent, (u16 *)0xFFC00908);
		debugfs_create_x16("SPORT1_TCR1", 0600, parent, (u16 *)0xFFC00900);
		debugfs_create_x16("SPORT1_TCR2", 0600, parent, (u16 *)0xFFC00904);
		debugfs_create_x16("SPORT1_TFSDIV", 0600, parent, (u16 *)0xFFC0090C);
		debugfs_create_x32("SPORT1_TX", 0600, parent, (u32 *)0xFFC00910);
		debugfs_create_x16("SPORT2_CHNL", 0600, parent, (u16 *)0xFFC02534);
		debugfs_create_x16("SPORT2_MCMC1", 0600, parent, (u16 *)0xFFC02538);
		debugfs_create_x16("SPORT2_MCMC2", 0600, parent, (u16 *)0xFFC0253C);
		debugfs_create_x32("SPORT2_MRCS0", 0600, parent, (u32 *)0xFFC02550);
		debugfs_create_x32("SPORT2_MRCS1", 0600, parent, (u32 *)0xFFC02554);
		debugfs_create_x32("SPORT2_MRCS2", 0600, parent, (u32 *)0xFFC02558);
		debugfs_create_x32("SPORT2_MRCS3", 0600, parent, (u32 *)0xFFC0255C);
		debugfs_create_x32("SPORT2_MTCS0", 0600, parent, (u32 *)0xFFC02540);
		debugfs_create_x32("SPORT2_MTCS1", 0600, parent, (u32 *)0xFFC02544);
		debugfs_create_x32("SPORT2_MTCS2", 0600, parent, (u32 *)0xFFC02548);
		debugfs_create_x32("SPORT2_MTCS3", 0600, parent, (u32 *)0xFFC0254C);
		debugfs_create_x16("SPORT2_RCLKDIV", 0600, parent, (u16 *)0xFFC02528);
		debugfs_create_x16("SPORT2_RCR1", 0600, parent, (u16 *)0xFFC02520);
		debugfs_create_x16("SPORT2_RCR2", 0600, parent, (u16 *)0xFFC02524);
		debugfs_create_x16("SPORT2_RFSDIV", 0600, parent, (u16 *)0xFFC0252C);
		debugfs_create_x32("SPORT2_RX", 0600, parent, (u32 *)0xFFC02518);
		debugfs_create_x16("SPORT2_STAT", 0600, parent, (u16 *)0xFFC02530);
		debugfs_create_x16("SPORT2_TCLKDIV", 0600, parent, (u16 *)0xFFC02508);
		debugfs_create_x16("SPORT2_TCR1", 0600, parent, (u16 *)0xFFC02500);
		debugfs_create_x16("SPORT2_TCR2", 0600, parent, (u16 *)0xFFC02504);
		debugfs_create_x16("SPORT2_TFSDIV", 0600, parent, (u16 *)0xFFC0250C);
		debugfs_create_x32("SPORT2_TX", 0600, parent, (u32 *)0xFFC02510);
		debugfs_create_x16("SPORT3_CHNL", 0600, parent, (u16 *)0xFFC02634);
		debugfs_create_x16("SPORT3_MCMC1", 0600, parent, (u16 *)0xFFC02638);
		debugfs_create_x16("SPORT3_MCMC2", 0600, parent, (u16 *)0xFFC0263C);
		debugfs_create_x32("SPORT3_MRCS0", 0600, parent, (u32 *)0xFFC02650);
		debugfs_create_x32("SPORT3_MRCS1", 0600, parent, (u32 *)0xFFC02654);
		debugfs_create_x32("SPORT3_MRCS2", 0600, parent, (u32 *)0xFFC02658);
		debugfs_create_x32("SPORT3_MRCS3", 0600, parent, (u32 *)0xFFC0265C);
		debugfs_create_x32("SPORT3_MTCS0", 0600, parent, (u32 *)0xFFC02640);
		debugfs_create_x32("SPORT3_MTCS1", 0600, parent, (u32 *)0xFFC02644);
		debugfs_create_x32("SPORT3_MTCS2", 0600, parent, (u32 *)0xFFC02648);
		debugfs_create_x32("SPORT3_MTCS3", 0600, parent, (u32 *)0xFFC0264C);
		debugfs_create_x16("SPORT3_RCLKDIV", 0600, parent, (u16 *)0xFFC02628);
		debugfs_create_x16("SPORT3_RCR1", 0600, parent, (u16 *)0xFFC02620);
		debugfs_create_x16("SPORT3_RCR2", 0600, parent, (u16 *)0xFFC02624);
		debugfs_create_x16("SPORT3_RFSDIV", 0600, parent, (u16 *)0xFFC0262C);
		debugfs_create_x32("SPORT3_RX", 0600, parent, (u32 *)0xFFC02618);
		debugfs_create_x16("SPORT3_STAT", 0600, parent, (u16 *)0xFFC02630);
		debugfs_create_x16("SPORT3_TCLKDIV", 0600, parent, (u16 *)0xFFC02608);
		debugfs_create_x16("SPORT3_TCR1", 0600, parent, (u16 *)0xFFC02600);
		debugfs_create_x16("SPORT3_TCR2", 0600, parent, (u16 *)0xFFC02604);
		debugfs_create_x16("SPORT3_TFSDIV", 0600, parent, (u16 *)0xFFC0260C);
		debugfs_create_x32("SPORT3_TX", 0600, parent, (u32 *)0xFFC02610);

		parent = debugfs_create_dir("System Reset and Interrupt Control Registers", top);
		debugfs_create_x32("SIC_IAR0", 0600, parent, (u32 *)0xFFC00110);
		debugfs_create_x32("SIC_IAR1", 0600, parent, (u32 *)0xFFC00114);
		debugfs_create_x32("SIC_IAR2", 0600, parent, (u32 *)0xFFC00118);
		debugfs_create_x32("SIC_IAR3", 0600, parent, (u32 *)0xFFC0011C);
		debugfs_create_x32("SIC_IAR4", 0600, parent, (u32 *)0xFFC00134);
		debugfs_create_x32("SIC_IAR5", 0600, parent, (u32 *)0xFFC00138);
		debugfs_create_x32("SIC_IAR6", 0600, parent, (u32 *)0xFFC0013C);
		debugfs_create_x32("SIC_IMASK0", 0600, parent, (u32 *)0xFFC0010C);
		debugfs_create_x32("SIC_IMASK1", 0600, parent, (u32 *)0xFFC00128);
		debugfs_create_x32("SIC_ISR0", 0600, parent, (u32 *)0xFFC00120);
		debugfs_create_x32("SIC_ISR1", 0600, parent, (u32 *)0xFFC0012C);
		debugfs_create_x32("SIC_IWR0", 0600, parent, (u32 *)0xFFC00124);
		debugfs_create_x32("SIC_IWR1", 0600, parent, (u32 *)0xFFC00130);
		debugfs_create_x16("SIC_RVECT", 0600, parent, (u16 *)0xFFC00108);
		debugfs_create_x16("SWRST", 0600, parent, (u16 *)0xFFC00100);
		debugfs_create_x16("SYSCR", 0600, parent, (u16 *)0xFFC00104);

		parent = debugfs_create_dir("TWI", top);
		debugfs_create_x16("TWI0_CLKDIV", 0600, parent, (u16 *)0xFFC01400);
		debugfs_create_x16("TWI0_CONTROL", 0600, parent, (u16 *)0xFFC01404);
		debugfs_create_x16("TWI0_FIFO_CTRL", 0600, parent, (u16 *)0xFFC01428);
		debugfs_create_x16("TWI0_FIFO_STAT", 0600, parent, (u16 *)0xFFC0142C);
		debugfs_create_x16("TWI0_INT_MASK", 0600, parent, (u16 *)0xFFC01424);
		debugfs_create_x16("TWI0_INT_STAT", 0600, parent, (u16 *)0xFFC01420);
		debugfs_create_x16("TWI0_MASTER_ADDR", 0600, parent, (u16 *)0xFFC0141C);
		debugfs_create_x16("TWI0_MASTER_CTRL", 0600, parent, (u16 *)0xFFC01414);
		debugfs_create_x16("TWI0_MASTER_STAT", 0600, parent, (u16 *)0xFFC01418);
		debugfs_create_x16("TWI0_RCV_DATA16", 0600, parent, (u16 *)0xFFC0148C);
		debugfs_create_x16("TWI0_RCV_DATA8", 0600, parent, (u16 *)0xFFC01488);
		debugfs_create_x16("TWI0_SLAVE_ADDR", 0600, parent, (u16 *)0xFFC01410);
		debugfs_create_x16("TWI0_SLAVE_CTRL", 0600, parent, (u16 *)0xFFC01408);
		debugfs_create_x16("TWI0_SLAVE_STAT", 0600, parent, (u16 *)0xFFC0140C);
		debugfs_create_x16("TWI0_XMT_DATA16", 0600, parent, (u16 *)0xFFC01484);
		debugfs_create_x16("TWI0_XMT_DATA8", 0600, parent, (u16 *)0xFFC01480);
		debugfs_create_x16("TWI1_CLKDIV", 0600, parent, (u16 *)0xFFC02200);
		debugfs_create_x16("TWI1_CONTROL", 0600, parent, (u16 *)0xFFC02204);
		debugfs_create_x16("TWI1_FIFO_CTRL", 0600, parent, (u16 *)0xFFC02228);
		debugfs_create_x16("TWI1_FIFO_STAT", 0600, parent, (u16 *)0xFFC0222C);
		debugfs_create_x16("TWI1_INT_MASK", 0600, parent, (u16 *)0xFFC02224);
		debugfs_create_x16("TWI1_INT_STAT", 0600, parent, (u16 *)0xFFC02220);
		debugfs_create_x16("TWI1_MASTER_ADDR", 0600, parent, (u16 *)0xFFC0221C);
		debugfs_create_x16("TWI1_MASTER_CTRL", 0600, parent, (u16 *)0xFFC02214);
		debugfs_create_x16("TWI1_MASTER_STAT", 0600, parent, (u16 *)0xFFC02218);
		debugfs_create_x16("TWI1_RCV_DATA16", 0600, parent, (u16 *)0xFFC0228C);
		debugfs_create_x16("TWI1_RCV_DATA8", 0600, parent, (u16 *)0xFFC02288);
		debugfs_create_x16("TWI1_SLAVE_ADDR", 0600, parent, (u16 *)0xFFC02210);
		debugfs_create_x16("TWI1_SLAVE_CTRL", 0600, parent, (u16 *)0xFFC02208);
		debugfs_create_x16("TWI1_SLAVE_STAT", 0600, parent, (u16 *)0xFFC0220C);
		debugfs_create_x16("TWI1_XMT_DATA16", 0600, parent, (u16 *)0xFFC02284);
		debugfs_create_x16("TWI1_XMT_DATA8", 0600, parent, (u16 *)0xFFC02280);

		parent = debugfs_create_dir("Timer Registers", top);
		debugfs_create_x16("TIMER0_CONFIG", 0600, parent, (u16 *)0xFFC00600);
		debugfs_create_x32("TIMER0_COUNTER", 0600, parent, (u32 *)0xFFC00604);
		debugfs_create_x32("TIMER0_PERIOD", 0600, parent, (u32 *)0xFFC00608);
		debugfs_create_x32("TIMER0_WIDTH", 0600, parent, (u32 *)0xFFC0060C);
		debugfs_create_x16("TIMER1_CONFIG", 0600, parent, (u16 *)0xFFC00610);
		debugfs_create_x32("TIMER1_COUNTER", 0600, parent, (u32 *)0xFFC00614);
		debugfs_create_x32("TIMER1_PERIOD", 0600, parent, (u32 *)0xFFC00618);
		debugfs_create_x32("TIMER1_WIDTH", 0600, parent, (u32 *)0xFFC0061C);
		debugfs_create_x16("TIMER2_CONFIG", 0600, parent, (u16 *)0xFFC00620);
		debugfs_create_x32("TIMER2_COUNTER", 0600, parent, (u32 *)0xFFC00624);
		debugfs_create_x32("TIMER2_PERIOD", 0600, parent, (u32 *)0xFFC00628);
		debugfs_create_x32("TIMER2_WIDTH", 0600, parent, (u32 *)0xFFC0062C);
		debugfs_create_x16("TIMER_DISABLE", 0600, parent, (u16 *)0xFFC00644);
		debugfs_create_x16("TIMER_ENABLE", 0600, parent, (u16 *)0xFFC00640);
		debugfs_create_x16("TIMER_STATUS", 0600, parent, (u16 *)0xFFC00648);

		parent = debugfs_create_dir("Trace Unit", top);
		debugfs_create_x32("TBUF", 0600, parent, (u32 *)0xFFE06100);
		debugfs_create_x32("TBUFCTL", 0600, parent, (u32 *)0xFFE06000);
		debugfs_create_x32("TBUFSTAT", 0600, parent, (u32 *)0xFFE06004);

		parent = debugfs_create_dir("UART", top);
		debugfs_create_x16("UART0_DLH", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART0_DLL", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART0_GCTL", 0600, parent, (u16 *)0xFFC00424);
		debugfs_create_x16("UART0_IER", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART0_IIR", 0600, parent, (u16 *)0xFFC00408);
		debugfs_create_x16("UART0_LCR", 0600, parent, (u16 *)0xFFC0040C);
		debugfs_create_x16("UART0_LSR", 0600, parent, (u16 *)0xFFC00414);
		debugfs_create_x16("UART0_MCR", 0600, parent, (u16 *)0xFFC00410);
		debugfs_create_x16("UART0_RBR", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART0_SCR", 0600, parent, (u16 *)0xFFC0041C);
		debugfs_create_x16("UART0_THR", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART1_DLH", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("UART1_DLL", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART1_GCTL", 0600, parent, (u16 *)0xFFC02024);
		debugfs_create_x16("UART1_IER", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("UART1_IIR", 0600, parent, (u16 *)0xFFC02008);
		debugfs_create_x16("UART1_LCR", 0600, parent, (u16 *)0xFFC0200C);
		debugfs_create_x16("UART1_LSR", 0600, parent, (u16 *)0xFFC02014);
		debugfs_create_x16("UART1_MCR", 0600, parent, (u16 *)0xFFC02010);
		debugfs_create_x16("UART1_RBR", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART1_SCR", 0600, parent, (u16 *)0xFFC0201C);
		debugfs_create_x16("UART1_THR", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART2_DLH", 0600, parent, (u16 *)0xFFC02104);
		debugfs_create_x16("UART2_DLL", 0600, parent, (u16 *)0xFFC02100);
		debugfs_create_x16("UART2_GCTL", 0600, parent, (u16 *)0xFFC02124);
		debugfs_create_x16("UART2_IER", 0600, parent, (u16 *)0xFFC02104);
		debugfs_create_x16("UART2_IIR", 0600, parent, (u16 *)0xFFC02108);
		debugfs_create_x16("UART2_LCR", 0600, parent, (u16 *)0xFFC0210C);
		debugfs_create_x16("UART2_LSR", 0600, parent, (u16 *)0xFFC02114);
		debugfs_create_x16("UART2_MCR", 0600, parent, (u16 *)0xFFC02110);
		debugfs_create_x16("UART2_RBR", 0600, parent, (u16 *)0xFFC02100);
		debugfs_create_x16("UART2_SCR", 0600, parent, (u16 *)0xFFC0211C);
		debugfs_create_x16("UART2_THR", 0600, parent, (u16 *)0xFFC02100);

		parent = debugfs_create_dir("Watchdog", top);
		debugfs_create_x32("WDOG_CNT", 0600, parent, (u32 *)0xFFC00204);
		debugfs_create_x16("WDOG_CTL", 0600, parent, (u16 *)0xFFC00200);
		debugfs_create_x32("WDOG_STAT", 0600, parent, (u32 *)0xFFC00208);

		parent = debugfs_create_dir("Watchpoint and Patch Unit", top);
		debugfs_create_x32("WPDA0", 0600, parent, (u32 *)0xFFE07140);
		debugfs_create_x32("WPDA1", 0600, parent, (u32 *)0xFFE07144);
		debugfs_create_x32("WPDACNT0", 0600, parent, (u32 *)0xFFE07180);
		debugfs_create_x32("WPDACNT1", 0600, parent, (u32 *)0xFFE07184);
		debugfs_create_x32("WPDACTL", 0600, parent, (u32 *)0xFFE07100);
		debugfs_create_x32("WPIA0", 0600, parent, (u32 *)0xFFE07040);
		debugfs_create_x32("WPIA1", 0600, parent, (u32 *)0xFFE07044);
		debugfs_create_x32("WPIA2", 0600, parent, (u32 *)0xFFE07048);
		debugfs_create_x32("WPIA3", 0600, parent, (u32 *)0xFFE0704C);
		debugfs_create_x32("WPIA4", 0600, parent, (u32 *)0xFFE07050);
		debugfs_create_x32("WPIA5", 0600, parent, (u32 *)0xFFE07054);
		debugfs_create_x32("WPIACNT0", 0600, parent, (u32 *)0xFFE07080);
		debugfs_create_x32("WPIACNT1", 0600, parent, (u32 *)0xFFE07084);
		debugfs_create_x32("WPIACNT2", 0600, parent, (u32 *)0xFFE07088);
		debugfs_create_x32("WPIACNT3", 0600, parent, (u32 *)0xFFE0708C);
		debugfs_create_x32("WPIACNT4", 0600, parent, (u32 *)0xFFE07090);
		debugfs_create_x32("WPIACNT5", 0600, parent, (u32 *)0xFFE07094);
		debugfs_create_x32("WPIACTL", 0600, parent, (u32 *)0xFFE07000);
		debugfs_create_x32("WPSTAT", 0600, parent, (u32 *)0xFFE07200);

	}	/* BF538 */

#ifdef __ADSPBF539__
# define USE_BF539 1
#else
# define USE_BF539 0
#endif
	if (USE_BF539) {

		parent = debugfs_create_dir("CAN Controller Registers", top);
		debugfs_create_x16("CAN_AA1", 0600, parent, (u16 *)0xFFC02A14);
		debugfs_create_x16("CAN_AA2", 0600, parent, (u16 *)0xFFC02A54);
		debugfs_create_x16("CAN_AM00H", 0600, parent, (u16 *)0xFFC02B04);
		debugfs_create_x16("CAN_AM00L", 0600, parent, (u16 *)0xFFC02B00);
		debugfs_create_x16("CAN_AM01H", 0600, parent, (u16 *)0xFFC02B0C);
		debugfs_create_x16("CAN_AM01L", 0600, parent, (u16 *)0xFFC02B08);
		debugfs_create_x16("CAN_AM02H", 0600, parent, (u16 *)0xFFC02B14);
		debugfs_create_x16("CAN_AM02L", 0600, parent, (u16 *)0xFFC02B10);
		debugfs_create_x16("CAN_AM03H", 0600, parent, (u16 *)0xFFC02B1C);
		debugfs_create_x16("CAN_AM03L", 0600, parent, (u16 *)0xFFC02B18);
		debugfs_create_x16("CAN_AM04H", 0600, parent, (u16 *)0xFFC02B24);
		debugfs_create_x16("CAN_AM04L", 0600, parent, (u16 *)0xFFC02B20);
		debugfs_create_x16("CAN_AM05H", 0600, parent, (u16 *)0xFFC02B2C);
		debugfs_create_x16("CAN_AM05L", 0600, parent, (u16 *)0xFFC02B28);
		debugfs_create_x16("CAN_AM06H", 0600, parent, (u16 *)0xFFC02B34);
		debugfs_create_x16("CAN_AM06L", 0600, parent, (u16 *)0xFFC02B30);
		debugfs_create_x16("CAN_AM07H", 0600, parent, (u16 *)0xFFC02B3C);
		debugfs_create_x16("CAN_AM07L", 0600, parent, (u16 *)0xFFC02B38);
		debugfs_create_x16("CAN_AM08H", 0600, parent, (u16 *)0xFFC02B44);
		debugfs_create_x16("CAN_AM08L", 0600, parent, (u16 *)0xFFC02B40);
		debugfs_create_x16("CAN_AM09H", 0600, parent, (u16 *)0xFFC02B4C);
		debugfs_create_x16("CAN_AM09L", 0600, parent, (u16 *)0xFFC02B48);
		debugfs_create_x16("CAN_AM10H", 0600, parent, (u16 *)0xFFC02B54);
		debugfs_create_x16("CAN_AM10L", 0600, parent, (u16 *)0xFFC02B50);
		debugfs_create_x16("CAN_AM11H", 0600, parent, (u16 *)0xFFC02B5C);
		debugfs_create_x16("CAN_AM11L", 0600, parent, (u16 *)0xFFC02B58);
		debugfs_create_x16("CAN_AM12H", 0600, parent, (u16 *)0xFFC02B64);
		debugfs_create_x16("CAN_AM12L", 0600, parent, (u16 *)0xFFC02B60);
		debugfs_create_x16("CAN_AM13H", 0600, parent, (u16 *)0xFFC02B6C);
		debugfs_create_x16("CAN_AM13L", 0600, parent, (u16 *)0xFFC02B68);
		debugfs_create_x16("CAN_AM14H", 0600, parent, (u16 *)0xFFC02B74);
		debugfs_create_x16("CAN_AM14L", 0600, parent, (u16 *)0xFFC02B70);
		debugfs_create_x16("CAN_AM15H", 0600, parent, (u16 *)0xFFC02B7C);
		debugfs_create_x16("CAN_AM15L", 0600, parent, (u16 *)0xFFC02B78);
		debugfs_create_x16("CAN_AM16H", 0600, parent, (u16 *)0xFFC02B84);
		debugfs_create_x16("CAN_AM16L", 0600, parent, (u16 *)0xFFC02B80);
		debugfs_create_x16("CAN_AM17H", 0600, parent, (u16 *)0xFFC02B8C);
		debugfs_create_x16("CAN_AM17L", 0600, parent, (u16 *)0xFFC02B88);
		debugfs_create_x16("CAN_AM18H", 0600, parent, (u16 *)0xFFC02B94);
		debugfs_create_x16("CAN_AM18L", 0600, parent, (u16 *)0xFFC02B90);
		debugfs_create_x16("CAN_AM19H", 0600, parent, (u16 *)0xFFC02B9C);
		debugfs_create_x16("CAN_AM19L", 0600, parent, (u16 *)0xFFC02B98);
		debugfs_create_x16("CAN_AM20H", 0600, parent, (u16 *)0xFFC02BA4);
		debugfs_create_x16("CAN_AM20L", 0600, parent, (u16 *)0xFFC02BA0);
		debugfs_create_x16("CAN_AM21H", 0600, parent, (u16 *)0xFFC02BAC);
		debugfs_create_x16("CAN_AM21L", 0600, parent, (u16 *)0xFFC02BA8);
		debugfs_create_x16("CAN_AM22H", 0600, parent, (u16 *)0xFFC02BB4);
		debugfs_create_x16("CAN_AM22L", 0600, parent, (u16 *)0xFFC02BB0);
		debugfs_create_x16("CAN_AM23H", 0600, parent, (u16 *)0xFFC02BBC);
		debugfs_create_x16("CAN_AM23L", 0600, parent, (u16 *)0xFFC02BB8);
		debugfs_create_x16("CAN_AM24H", 0600, parent, (u16 *)0xFFC02BC4);
		debugfs_create_x16("CAN_AM24L", 0600, parent, (u16 *)0xFFC02BC0);
		debugfs_create_x16("CAN_AM25H", 0600, parent, (u16 *)0xFFC02BCC);
		debugfs_create_x16("CAN_AM25L", 0600, parent, (u16 *)0xFFC02BC8);
		debugfs_create_x16("CAN_AM26H", 0600, parent, (u16 *)0xFFC02BD4);
		debugfs_create_x16("CAN_AM26L", 0600, parent, (u16 *)0xFFC02BD0);
		debugfs_create_x16("CAN_AM27H", 0600, parent, (u16 *)0xFFC02BDC);
		debugfs_create_x16("CAN_AM27L", 0600, parent, (u16 *)0xFFC02BD8);
		debugfs_create_x16("CAN_AM28H", 0600, parent, (u16 *)0xFFC02BE4);
		debugfs_create_x16("CAN_AM28L", 0600, parent, (u16 *)0xFFC02BE0);
		debugfs_create_x16("CAN_AM29H", 0600, parent, (u16 *)0xFFC02BEC);
		debugfs_create_x16("CAN_AM29L", 0600, parent, (u16 *)0xFFC02BE8);
		debugfs_create_x16("CAN_AM30H", 0600, parent, (u16 *)0xFFC02BF4);
		debugfs_create_x16("CAN_AM30L", 0600, parent, (u16 *)0xFFC02BF0);
		debugfs_create_x16("CAN_AM31H", 0600, parent, (u16 *)0xFFC02BFC);
		debugfs_create_x16("CAN_AM31L", 0600, parent, (u16 *)0xFFC02BF8);
		debugfs_create_x16("CAN_CEC", 0600, parent, (u16 *)0xFFC02A90);
		debugfs_create_x16("CAN_CLOCK", 0600, parent, (u16 *)0xFFC02A80);
		debugfs_create_x16("CAN_CONTROL", 0600, parent, (u16 *)0xFFC02AA0);
		debugfs_create_x16("CAN_DEBUG", 0600, parent, (u16 *)0xFFC02A88);
		debugfs_create_x16("CAN_ESR", 0600, parent, (u16 *)0xFFC02AB4);
		debugfs_create_x16("CAN_EWR", 0600, parent, (u16 *)0xFFC02AB0);
		debugfs_create_x16("CAN_GIF", 0600, parent, (u16 *)0xFFC02A9C);
		debugfs_create_x16("CAN_GIM", 0600, parent, (u16 *)0xFFC02A98);
		debugfs_create_x16("CAN_GIS", 0600, parent, (u16 *)0xFFC02A94);
		debugfs_create_x16("CAN_INTR", 0600, parent, (u16 *)0xFFC02AA4);
		debugfs_create_x16("CAN_MBIM1", 0600, parent, (u16 *)0xFFC02A28);
		debugfs_create_x16("CAN_MBIM2", 0600, parent, (u16 *)0xFFC02A68);
		debugfs_create_x16("CAN_MBRIF1", 0600, parent, (u16 *)0xFFC02A24);
		debugfs_create_x16("CAN_MBRIF2", 0600, parent, (u16 *)0xFFC02A64);
		debugfs_create_x16("CAN_MBTD", 0600, parent, (u16 *)0xFFC02AAC);
		debugfs_create_x16("CAN_MBTIF1", 0600, parent, (u16 *)0xFFC02A20);
		debugfs_create_x16("CAN_MBTIF2", 0600, parent, (u16 *)0xFFC02A60);
		debugfs_create_x16("CAN_MC1", 0600, parent, (u16 *)0xFFC02A00);
		debugfs_create_x16("CAN_MC2", 0600, parent, (u16 *)0xFFC02A40);
		debugfs_create_x16("CAN_MD1", 0600, parent, (u16 *)0xFFC02A04);
		debugfs_create_x16("CAN_MD2", 0600, parent, (u16 *)0xFFC02A44);
		debugfs_create_x16("CAN_OPSS1", 0600, parent, (u16 *)0xFFC02A30);
		debugfs_create_x16("CAN_OPSS2", 0600, parent, (u16 *)0xFFC02A70);
		debugfs_create_x16("CAN_RFH1", 0600, parent, (u16 *)0xFFC02A2C);
		debugfs_create_x16("CAN_RFH2", 0600, parent, (u16 *)0xFFC02A6C);
		debugfs_create_x16("CAN_RML1", 0600, parent, (u16 *)0xFFC02A1C);
		debugfs_create_x16("CAN_RML2", 0600, parent, (u16 *)0xFFC02A5C);
		debugfs_create_x16("CAN_RMP1", 0600, parent, (u16 *)0xFFC02A18);
		debugfs_create_x16("CAN_RMP2", 0600, parent, (u16 *)0xFFC02A58);
		debugfs_create_x16("CAN_STATUS", 0600, parent, (u16 *)0xFFC02A8C);
		debugfs_create_x16("CAN_TA1", 0600, parent, (u16 *)0xFFC02A10);
		debugfs_create_x16("CAN_TA2", 0600, parent, (u16 *)0xFFC02A50);
		debugfs_create_x16("CAN_TIMING", 0600, parent, (u16 *)0xFFC02A84);
		debugfs_create_x16("CAN_TRR1", 0600, parent, (u16 *)0xFFC02A0C);
		debugfs_create_x16("CAN_TRR2", 0600, parent, (u16 *)0xFFC02A4C);
		debugfs_create_x16("CAN_TRS1", 0600, parent, (u16 *)0xFFC02A08);
		debugfs_create_x16("CAN_TRS2", 0600, parent, (u16 *)0xFFC02A48);
		debugfs_create_x16("CAN_UCCNF", 0600, parent, (u16 *)0xFFC02ACC);
		debugfs_create_x16("CAN_UCCNT", 0600, parent, (u16 *)0xFFC02AC4);
		debugfs_create_x16("CAN_UCRC", 0600, parent, (u16 *)0xFFC02AC8);
		debugfs_create_x16("CAN_UCREG", 0600, parent, (u16 *)0xFFC02AC0);
		debugfs_create_x16("CAN_VERSION2", 0600, parent, (u16 *)0xFFC02AD4);
		debugfs_create_x16("CAN_VERSION", 0600, parent, (u16 *)0xFFC02AA8);

		parent = debugfs_create_dir("CAN Mailbox Registers", top);
		debugfs_create_x16("CAN_MB00_DATA0", 0600, parent, (u16 *)0xFFC02C00);
		debugfs_create_x16("CAN_MB00_DATA1", 0600, parent, (u16 *)0xFFC02C04);
		debugfs_create_x16("CAN_MB00_DATA2", 0600, parent, (u16 *)0xFFC02C08);
		debugfs_create_x16("CAN_MB00_DATA3", 0600, parent, (u16 *)0xFFC02C0C);
		debugfs_create_x16("CAN_MB00_ID0", 0600, parent, (u16 *)0xFFC02C18);
		debugfs_create_x16("CAN_MB00_ID1", 0600, parent, (u16 *)0xFFC02C1C);
		debugfs_create_x16("CAN_MB00_LENGTH", 0600, parent, (u16 *)0xFFC02C10);
		debugfs_create_x16("CAN_MB00_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C14);
		debugfs_create_x16("CAN_MB01_DATA0", 0600, parent, (u16 *)0xFFC02C20);
		debugfs_create_x16("CAN_MB01_DATA1", 0600, parent, (u16 *)0xFFC02C24);
		debugfs_create_x16("CAN_MB01_DATA2", 0600, parent, (u16 *)0xFFC02C28);
		debugfs_create_x16("CAN_MB01_DATA3", 0600, parent, (u16 *)0xFFC02C2C);
		debugfs_create_x16("CAN_MB01_ID0", 0600, parent, (u16 *)0xFFC02C38);
		debugfs_create_x16("CAN_MB01_ID1", 0600, parent, (u16 *)0xFFC02C3C);
		debugfs_create_x16("CAN_MB01_LENGTH", 0600, parent, (u16 *)0xFFC02C30);
		debugfs_create_x16("CAN_MB01_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C34);
		debugfs_create_x16("CAN_MB02_DATA0", 0600, parent, (u16 *)0xFFC02C40);
		debugfs_create_x16("CAN_MB02_DATA1", 0600, parent, (u16 *)0xFFC02C44);
		debugfs_create_x16("CAN_MB02_DATA2", 0600, parent, (u16 *)0xFFC02C48);
		debugfs_create_x16("CAN_MB02_DATA3", 0600, parent, (u16 *)0xFFC02C4C);
		debugfs_create_x16("CAN_MB02_ID0", 0600, parent, (u16 *)0xFFC02C58);
		debugfs_create_x16("CAN_MB02_ID1", 0600, parent, (u16 *)0xFFC02C5C);
		debugfs_create_x16("CAN_MB02_LENGTH", 0600, parent, (u16 *)0xFFC02C50);
		debugfs_create_x16("CAN_MB02_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C54);
		debugfs_create_x16("CAN_MB03_DATA0", 0600, parent, (u16 *)0xFFC02C60);
		debugfs_create_x16("CAN_MB03_DATA1", 0600, parent, (u16 *)0xFFC02C64);
		debugfs_create_x16("CAN_MB03_DATA2", 0600, parent, (u16 *)0xFFC02C68);
		debugfs_create_x16("CAN_MB03_DATA3", 0600, parent, (u16 *)0xFFC02C6C);
		debugfs_create_x16("CAN_MB03_ID0", 0600, parent, (u16 *)0xFFC02C78);
		debugfs_create_x16("CAN_MB03_ID1", 0600, parent, (u16 *)0xFFC02C7C);
		debugfs_create_x16("CAN_MB03_LENGTH", 0600, parent, (u16 *)0xFFC02C70);
		debugfs_create_x16("CAN_MB03_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C74);
		debugfs_create_x16("CAN_MB04_DATA0", 0600, parent, (u16 *)0xFFC02C80);
		debugfs_create_x16("CAN_MB04_DATA1", 0600, parent, (u16 *)0xFFC02C84);
		debugfs_create_x16("CAN_MB04_DATA2", 0600, parent, (u16 *)0xFFC02C88);
		debugfs_create_x16("CAN_MB04_DATA3", 0600, parent, (u16 *)0xFFC02C8C);
		debugfs_create_x16("CAN_MB04_ID0", 0600, parent, (u16 *)0xFFC02C98);
		debugfs_create_x16("CAN_MB04_ID1", 0600, parent, (u16 *)0xFFC02C9C);
		debugfs_create_x16("CAN_MB04_LENGTH", 0600, parent, (u16 *)0xFFC02C90);
		debugfs_create_x16("CAN_MB04_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C94);
		debugfs_create_x16("CAN_MB05_DATA0", 0600, parent, (u16 *)0xFFC02CA0);
		debugfs_create_x16("CAN_MB05_DATA1", 0600, parent, (u16 *)0xFFC02CA4);
		debugfs_create_x16("CAN_MB05_DATA2", 0600, parent, (u16 *)0xFFC02CA8);
		debugfs_create_x16("CAN_MB05_DATA3", 0600, parent, (u16 *)0xFFC02CAC);
		debugfs_create_x16("CAN_MB05_ID0", 0600, parent, (u16 *)0xFFC02CB8);
		debugfs_create_x16("CAN_MB05_ID1", 0600, parent, (u16 *)0xFFC02CBC);
		debugfs_create_x16("CAN_MB05_LENGTH", 0600, parent, (u16 *)0xFFC02CB0);
		debugfs_create_x16("CAN_MB05_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CB4);
		debugfs_create_x16("CAN_MB06_DATA0", 0600, parent, (u16 *)0xFFC02CC0);
		debugfs_create_x16("CAN_MB06_DATA1", 0600, parent, (u16 *)0xFFC02CC4);
		debugfs_create_x16("CAN_MB06_DATA2", 0600, parent, (u16 *)0xFFC02CC8);
		debugfs_create_x16("CAN_MB06_DATA3", 0600, parent, (u16 *)0xFFC02CCC);
		debugfs_create_x16("CAN_MB06_ID0", 0600, parent, (u16 *)0xFFC02CD8);
		debugfs_create_x16("CAN_MB06_ID1", 0600, parent, (u16 *)0xFFC02CDC);
		debugfs_create_x16("CAN_MB06_LENGTH", 0600, parent, (u16 *)0xFFC02CD0);
		debugfs_create_x16("CAN_MB06_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CD4);
		debugfs_create_x16("CAN_MB07_DATA0", 0600, parent, (u16 *)0xFFC02CE0);
		debugfs_create_x16("CAN_MB07_DATA1", 0600, parent, (u16 *)0xFFC02CE4);
		debugfs_create_x16("CAN_MB07_DATA2", 0600, parent, (u16 *)0xFFC02CE8);
		debugfs_create_x16("CAN_MB07_DATA3", 0600, parent, (u16 *)0xFFC02CEC);
		debugfs_create_x16("CAN_MB07_ID0", 0600, parent, (u16 *)0xFFC02CF8);
		debugfs_create_x16("CAN_MB07_ID1", 0600, parent, (u16 *)0xFFC02CFC);
		debugfs_create_x16("CAN_MB07_LENGTH", 0600, parent, (u16 *)0xFFC02CF0);
		debugfs_create_x16("CAN_MB07_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CF4);
		debugfs_create_x16("CAN_MB08_DATA0", 0600, parent, (u16 *)0xFFC02D00);
		debugfs_create_x16("CAN_MB08_DATA1", 0600, parent, (u16 *)0xFFC02D04);
		debugfs_create_x16("CAN_MB08_DATA2", 0600, parent, (u16 *)0xFFC02D08);
		debugfs_create_x16("CAN_MB08_DATA3", 0600, parent, (u16 *)0xFFC02D0C);
		debugfs_create_x16("CAN_MB08_ID0", 0600, parent, (u16 *)0xFFC02D18);
		debugfs_create_x16("CAN_MB08_ID1", 0600, parent, (u16 *)0xFFC02D1C);
		debugfs_create_x16("CAN_MB08_LENGTH", 0600, parent, (u16 *)0xFFC02D10);
		debugfs_create_x16("CAN_MB08_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D14);
		debugfs_create_x16("CAN_MB09_DATA0", 0600, parent, (u16 *)0xFFC02D20);
		debugfs_create_x16("CAN_MB09_DATA1", 0600, parent, (u16 *)0xFFC02D24);
		debugfs_create_x16("CAN_MB09_DATA2", 0600, parent, (u16 *)0xFFC02D28);
		debugfs_create_x16("CAN_MB09_DATA3", 0600, parent, (u16 *)0xFFC02D2C);
		debugfs_create_x16("CAN_MB09_ID0", 0600, parent, (u16 *)0xFFC02D38);
		debugfs_create_x16("CAN_MB09_ID1", 0600, parent, (u16 *)0xFFC02D3C);
		debugfs_create_x16("CAN_MB09_LENGTH", 0600, parent, (u16 *)0xFFC02D30);
		debugfs_create_x16("CAN_MB09_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D34);
		debugfs_create_x16("CAN_MB10_DATA0", 0600, parent, (u16 *)0xFFC02D40);
		debugfs_create_x16("CAN_MB10_DATA1", 0600, parent, (u16 *)0xFFC02D44);
		debugfs_create_x16("CAN_MB10_DATA2", 0600, parent, (u16 *)0xFFC02D48);
		debugfs_create_x16("CAN_MB10_DATA3", 0600, parent, (u16 *)0xFFC02D4C);
		debugfs_create_x16("CAN_MB10_ID0", 0600, parent, (u16 *)0xFFC02D58);
		debugfs_create_x16("CAN_MB10_ID1", 0600, parent, (u16 *)0xFFC02D5C);
		debugfs_create_x16("CAN_MB10_LENGTH", 0600, parent, (u16 *)0xFFC02D50);
		debugfs_create_x16("CAN_MB10_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D54);
		debugfs_create_x16("CAN_MB11_DATA0", 0600, parent, (u16 *)0xFFC02D60);
		debugfs_create_x16("CAN_MB11_DATA1", 0600, parent, (u16 *)0xFFC02D64);
		debugfs_create_x16("CAN_MB11_DATA2", 0600, parent, (u16 *)0xFFC02D68);
		debugfs_create_x16("CAN_MB11_DATA3", 0600, parent, (u16 *)0xFFC02D6C);
		debugfs_create_x16("CAN_MB11_ID0", 0600, parent, (u16 *)0xFFC02D78);
		debugfs_create_x16("CAN_MB11_ID1", 0600, parent, (u16 *)0xFFC02D7C);
		debugfs_create_x16("CAN_MB11_LENGTH", 0600, parent, (u16 *)0xFFC02D70);
		debugfs_create_x16("CAN_MB11_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D74);
		debugfs_create_x16("CAN_MB12_DATA0", 0600, parent, (u16 *)0xFFC02D80);
		debugfs_create_x16("CAN_MB12_DATA1", 0600, parent, (u16 *)0xFFC02D84);
		debugfs_create_x16("CAN_MB12_DATA2", 0600, parent, (u16 *)0xFFC02D88);
		debugfs_create_x16("CAN_MB12_DATA3", 0600, parent, (u16 *)0xFFC02D8C);
		debugfs_create_x16("CAN_MB12_ID0", 0600, parent, (u16 *)0xFFC02D98);
		debugfs_create_x16("CAN_MB12_ID1", 0600, parent, (u16 *)0xFFC02D9C);
		debugfs_create_x16("CAN_MB12_LENGTH", 0600, parent, (u16 *)0xFFC02D90);
		debugfs_create_x16("CAN_MB12_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D94);
		debugfs_create_x16("CAN_MB13_DATA0", 0600, parent, (u16 *)0xFFC02DA0);
		debugfs_create_x16("CAN_MB13_DATA1", 0600, parent, (u16 *)0xFFC02DA4);
		debugfs_create_x16("CAN_MB13_DATA2", 0600, parent, (u16 *)0xFFC02DA8);
		debugfs_create_x16("CAN_MB13_DATA3", 0600, parent, (u16 *)0xFFC02DAC);
		debugfs_create_x16("CAN_MB13_ID0", 0600, parent, (u16 *)0xFFC02DB8);
		debugfs_create_x16("CAN_MB13_ID1", 0600, parent, (u16 *)0xFFC02DBC);
		debugfs_create_x16("CAN_MB13_LENGTH", 0600, parent, (u16 *)0xFFC02DB0);
		debugfs_create_x16("CAN_MB13_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DB4);
		debugfs_create_x16("CAN_MB14_DATA0", 0600, parent, (u16 *)0xFFC02DC0);
		debugfs_create_x16("CAN_MB14_DATA1", 0600, parent, (u16 *)0xFFC02DC4);
		debugfs_create_x16("CAN_MB14_DATA2", 0600, parent, (u16 *)0xFFC02DC8);
		debugfs_create_x16("CAN_MB14_DATA3", 0600, parent, (u16 *)0xFFC02DCC);
		debugfs_create_x16("CAN_MB14_ID0", 0600, parent, (u16 *)0xFFC02DD8);
		debugfs_create_x16("CAN_MB14_ID1", 0600, parent, (u16 *)0xFFC02DDC);
		debugfs_create_x16("CAN_MB14_LENGTH", 0600, parent, (u16 *)0xFFC02DD0);
		debugfs_create_x16("CAN_MB14_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DD4);
		debugfs_create_x16("CAN_MB15_DATA0", 0600, parent, (u16 *)0xFFC02DE0);
		debugfs_create_x16("CAN_MB15_DATA1", 0600, parent, (u16 *)0xFFC02DE4);
		debugfs_create_x16("CAN_MB15_DATA2", 0600, parent, (u16 *)0xFFC02DE8);
		debugfs_create_x16("CAN_MB15_DATA3", 0600, parent, (u16 *)0xFFC02DEC);
		debugfs_create_x16("CAN_MB15_ID0", 0600, parent, (u16 *)0xFFC02DF8);
		debugfs_create_x16("CAN_MB15_ID1", 0600, parent, (u16 *)0xFFC02DFC);
		debugfs_create_x16("CAN_MB15_LENGTH", 0600, parent, (u16 *)0xFFC02DF0);
		debugfs_create_x16("CAN_MB15_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DF4);
		debugfs_create_x16("CAN_MB16_DATA0", 0600, parent, (u16 *)0xFFC02E00);
		debugfs_create_x16("CAN_MB16_DATA1", 0600, parent, (u16 *)0xFFC02E04);
		debugfs_create_x16("CAN_MB16_DATA2", 0600, parent, (u16 *)0xFFC02E08);
		debugfs_create_x16("CAN_MB16_DATA3", 0600, parent, (u16 *)0xFFC02E0C);
		debugfs_create_x16("CAN_MB16_ID0", 0600, parent, (u16 *)0xFFC02E18);
		debugfs_create_x16("CAN_MB16_ID1", 0600, parent, (u16 *)0xFFC02E1C);
		debugfs_create_x16("CAN_MB16_LENGTH", 0600, parent, (u16 *)0xFFC02E10);
		debugfs_create_x16("CAN_MB16_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E14);
		debugfs_create_x16("CAN_MB17_DATA0", 0600, parent, (u16 *)0xFFC02E20);
		debugfs_create_x16("CAN_MB17_DATA1", 0600, parent, (u16 *)0xFFC02E24);
		debugfs_create_x16("CAN_MB17_DATA2", 0600, parent, (u16 *)0xFFC02E28);
		debugfs_create_x16("CAN_MB17_DATA3", 0600, parent, (u16 *)0xFFC02E2C);
		debugfs_create_x16("CAN_MB17_ID0", 0600, parent, (u16 *)0xFFC02E38);
		debugfs_create_x16("CAN_MB17_ID1", 0600, parent, (u16 *)0xFFC02E3C);
		debugfs_create_x16("CAN_MB17_LENGTH", 0600, parent, (u16 *)0xFFC02E30);
		debugfs_create_x16("CAN_MB17_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E34);
		debugfs_create_x16("CAN_MB18_DATA0", 0600, parent, (u16 *)0xFFC02E40);
		debugfs_create_x16("CAN_MB18_DATA1", 0600, parent, (u16 *)0xFFC02E44);
		debugfs_create_x16("CAN_MB18_DATA2", 0600, parent, (u16 *)0xFFC02E48);
		debugfs_create_x16("CAN_MB18_DATA3", 0600, parent, (u16 *)0xFFC02E4C);
		debugfs_create_x16("CAN_MB18_ID0", 0600, parent, (u16 *)0xFFC02E58);
		debugfs_create_x16("CAN_MB18_ID1", 0600, parent, (u16 *)0xFFC02E5C);
		debugfs_create_x16("CAN_MB18_LENGTH", 0600, parent, (u16 *)0xFFC02E50);
		debugfs_create_x16("CAN_MB18_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E54);
		debugfs_create_x16("CAN_MB19_DATA0", 0600, parent, (u16 *)0xFFC02E60);
		debugfs_create_x16("CAN_MB19_DATA1", 0600, parent, (u16 *)0xFFC02E64);
		debugfs_create_x16("CAN_MB19_DATA2", 0600, parent, (u16 *)0xFFC02E68);
		debugfs_create_x16("CAN_MB19_DATA3", 0600, parent, (u16 *)0xFFC02E6C);
		debugfs_create_x16("CAN_MB19_ID0", 0600, parent, (u16 *)0xFFC02E78);
		debugfs_create_x16("CAN_MB19_ID1", 0600, parent, (u16 *)0xFFC02E7C);
		debugfs_create_x16("CAN_MB19_LENGTH", 0600, parent, (u16 *)0xFFC02E70);
		debugfs_create_x16("CAN_MB19_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E74);
		debugfs_create_x16("CAN_MB20_DATA0", 0600, parent, (u16 *)0xFFC02E80);
		debugfs_create_x16("CAN_MB20_DATA1", 0600, parent, (u16 *)0xFFC02E84);
		debugfs_create_x16("CAN_MB20_DATA2", 0600, parent, (u16 *)0xFFC02E88);
		debugfs_create_x16("CAN_MB20_DATA3", 0600, parent, (u16 *)0xFFC02E8C);
		debugfs_create_x16("CAN_MB20_ID0", 0600, parent, (u16 *)0xFFC02E98);
		debugfs_create_x16("CAN_MB20_ID1", 0600, parent, (u16 *)0xFFC02E9C);
		debugfs_create_x16("CAN_MB20_LENGTH", 0600, parent, (u16 *)0xFFC02E90);
		debugfs_create_x16("CAN_MB20_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E94);
		debugfs_create_x16("CAN_MB21_DATA0", 0600, parent, (u16 *)0xFFC02EA0);
		debugfs_create_x16("CAN_MB21_DATA1", 0600, parent, (u16 *)0xFFC02EA4);
		debugfs_create_x16("CAN_MB21_DATA2", 0600, parent, (u16 *)0xFFC02EA8);
		debugfs_create_x16("CAN_MB21_DATA3", 0600, parent, (u16 *)0xFFC02EAC);
		debugfs_create_x16("CAN_MB21_ID0", 0600, parent, (u16 *)0xFFC02EB8);
		debugfs_create_x16("CAN_MB21_ID1", 0600, parent, (u16 *)0xFFC02EBC);
		debugfs_create_x16("CAN_MB21_LENGTH", 0600, parent, (u16 *)0xFFC02EB0);
		debugfs_create_x16("CAN_MB21_TIMESTAMP", 0600, parent, (u16 *)0xFFC02EB4);
		debugfs_create_x16("CAN_MB22_DATA0", 0600, parent, (u16 *)0xFFC02EC0);
		debugfs_create_x16("CAN_MB22_DATA1", 0600, parent, (u16 *)0xFFC02EC4);
		debugfs_create_x16("CAN_MB22_DATA2", 0600, parent, (u16 *)0xFFC02EC8);
		debugfs_create_x16("CAN_MB22_DATA3", 0600, parent, (u16 *)0xFFC02ECC);
		debugfs_create_x16("CAN_MB22_ID0", 0600, parent, (u16 *)0xFFC02ED8);
		debugfs_create_x16("CAN_MB22_ID1", 0600, parent, (u16 *)0xFFC02EDC);
		debugfs_create_x16("CAN_MB22_LENGTH", 0600, parent, (u16 *)0xFFC02ED0);
		debugfs_create_x16("CAN_MB22_TIMESTAMP", 0600, parent, (u16 *)0xFFC02ED4);
		debugfs_create_x16("CAN_MB23_DATA0", 0600, parent, (u16 *)0xFFC02EE0);
		debugfs_create_x16("CAN_MB23_DATA1", 0600, parent, (u16 *)0xFFC02EE4);
		debugfs_create_x16("CAN_MB23_DATA2", 0600, parent, (u16 *)0xFFC02EE8);
		debugfs_create_x16("CAN_MB23_DATA3", 0600, parent, (u16 *)0xFFC02EEC);
		debugfs_create_x16("CAN_MB23_ID0", 0600, parent, (u16 *)0xFFC02EF8);
		debugfs_create_x16("CAN_MB23_ID1", 0600, parent, (u16 *)0xFFC02EFC);
		debugfs_create_x16("CAN_MB23_LENGTH", 0600, parent, (u16 *)0xFFC02EF0);
		debugfs_create_x16("CAN_MB23_TIMESTAMP", 0600, parent, (u16 *)0xFFC02EF4);
		debugfs_create_x16("CAN_MB24_DATA0", 0600, parent, (u16 *)0xFFC02F00);
		debugfs_create_x16("CAN_MB24_DATA1", 0600, parent, (u16 *)0xFFC02F04);
		debugfs_create_x16("CAN_MB24_DATA2", 0600, parent, (u16 *)0xFFC02F08);
		debugfs_create_x16("CAN_MB24_DATA3", 0600, parent, (u16 *)0xFFC02F0C);
		debugfs_create_x16("CAN_MB24_ID0", 0600, parent, (u16 *)0xFFC02F18);
		debugfs_create_x16("CAN_MB24_ID1", 0600, parent, (u16 *)0xFFC02F1C);
		debugfs_create_x16("CAN_MB24_LENGTH", 0600, parent, (u16 *)0xFFC02F10);
		debugfs_create_x16("CAN_MB24_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F14);
		debugfs_create_x16("CAN_MB25_DATA0", 0600, parent, (u16 *)0xFFC02F20);
		debugfs_create_x16("CAN_MB25_DATA1", 0600, parent, (u16 *)0xFFC02F24);
		debugfs_create_x16("CAN_MB25_DATA2", 0600, parent, (u16 *)0xFFC02F28);
		debugfs_create_x16("CAN_MB25_DATA3", 0600, parent, (u16 *)0xFFC02F2C);
		debugfs_create_x16("CAN_MB25_ID0", 0600, parent, (u16 *)0xFFC02F38);
		debugfs_create_x16("CAN_MB25_ID1", 0600, parent, (u16 *)0xFFC02F3C);
		debugfs_create_x16("CAN_MB25_LENGTH", 0600, parent, (u16 *)0xFFC02F30);
		debugfs_create_x16("CAN_MB25_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F34);
		debugfs_create_x16("CAN_MB26_DATA0", 0600, parent, (u16 *)0xFFC02F40);
		debugfs_create_x16("CAN_MB26_DATA1", 0600, parent, (u16 *)0xFFC02F44);
		debugfs_create_x16("CAN_MB26_DATA2", 0600, parent, (u16 *)0xFFC02F48);
		debugfs_create_x16("CAN_MB26_DATA3", 0600, parent, (u16 *)0xFFC02F4C);
		debugfs_create_x16("CAN_MB26_ID0", 0600, parent, (u16 *)0xFFC02F58);
		debugfs_create_x16("CAN_MB26_ID1", 0600, parent, (u16 *)0xFFC02F5C);
		debugfs_create_x16("CAN_MB26_LENGTH", 0600, parent, (u16 *)0xFFC02F50);
		debugfs_create_x16("CAN_MB26_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F54);
		debugfs_create_x16("CAN_MB27_DATA0", 0600, parent, (u16 *)0xFFC02F60);
		debugfs_create_x16("CAN_MB27_DATA1", 0600, parent, (u16 *)0xFFC02F64);
		debugfs_create_x16("CAN_MB27_DATA2", 0600, parent, (u16 *)0xFFC02F68);
		debugfs_create_x16("CAN_MB27_DATA3", 0600, parent, (u16 *)0xFFC02F6C);
		debugfs_create_x16("CAN_MB27_ID0", 0600, parent, (u16 *)0xFFC02F78);
		debugfs_create_x16("CAN_MB27_ID1", 0600, parent, (u16 *)0xFFC02F7C);
		debugfs_create_x16("CAN_MB27_LENGTH", 0600, parent, (u16 *)0xFFC02F70);
		debugfs_create_x16("CAN_MB27_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F74);
		debugfs_create_x16("CAN_MB28_DATA0", 0600, parent, (u16 *)0xFFC02F80);
		debugfs_create_x16("CAN_MB28_DATA1", 0600, parent, (u16 *)0xFFC02F84);
		debugfs_create_x16("CAN_MB28_DATA2", 0600, parent, (u16 *)0xFFC02F88);
		debugfs_create_x16("CAN_MB28_DATA3", 0600, parent, (u16 *)0xFFC02F8C);
		debugfs_create_x16("CAN_MB28_ID0", 0600, parent, (u16 *)0xFFC02F98);
		debugfs_create_x16("CAN_MB28_ID1", 0600, parent, (u16 *)0xFFC02F9C);
		debugfs_create_x16("CAN_MB28_LENGTH", 0600, parent, (u16 *)0xFFC02F90);
		debugfs_create_x16("CAN_MB28_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F94);
		debugfs_create_x16("CAN_MB29_DATA0", 0600, parent, (u16 *)0xFFC02FA0);
		debugfs_create_x16("CAN_MB29_DATA1", 0600, parent, (u16 *)0xFFC02FA4);
		debugfs_create_x16("CAN_MB29_DATA2", 0600, parent, (u16 *)0xFFC02FA8);
		debugfs_create_x16("CAN_MB29_DATA3", 0600, parent, (u16 *)0xFFC02FAC);
		debugfs_create_x16("CAN_MB29_ID0", 0600, parent, (u16 *)0xFFC02FB8);
		debugfs_create_x16("CAN_MB29_ID1", 0600, parent, (u16 *)0xFFC02FBC);
		debugfs_create_x16("CAN_MB29_LENGTH", 0600, parent, (u16 *)0xFFC02FB0);
		debugfs_create_x16("CAN_MB29_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FB4);
		debugfs_create_x16("CAN_MB30_DATA0", 0600, parent, (u16 *)0xFFC02FC0);
		debugfs_create_x16("CAN_MB30_DATA1", 0600, parent, (u16 *)0xFFC02FC4);
		debugfs_create_x16("CAN_MB30_DATA2", 0600, parent, (u16 *)0xFFC02FC8);
		debugfs_create_x16("CAN_MB30_DATA3", 0600, parent, (u16 *)0xFFC02FCC);
		debugfs_create_x16("CAN_MB30_ID0", 0600, parent, (u16 *)0xFFC02FD8);
		debugfs_create_x16("CAN_MB30_ID1", 0600, parent, (u16 *)0xFFC02FDC);
		debugfs_create_x16("CAN_MB30_LENGTH", 0600, parent, (u16 *)0xFFC02FD0);
		debugfs_create_x16("CAN_MB30_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FD4);
		debugfs_create_x16("CAN_MB31_DATA0", 0600, parent, (u16 *)0xFFC02FE0);
		debugfs_create_x16("CAN_MB31_DATA1", 0600, parent, (u16 *)0xFFC02FE4);
		debugfs_create_x16("CAN_MB31_DATA2", 0600, parent, (u16 *)0xFFC02FE8);
		debugfs_create_x16("CAN_MB31_DATA3", 0600, parent, (u16 *)0xFFC02FEC);
		debugfs_create_x16("CAN_MB31_ID0", 0600, parent, (u16 *)0xFFC02FF8);
		debugfs_create_x16("CAN_MB31_ID1", 0600, parent, (u16 *)0xFFC02FFC);
		debugfs_create_x16("CAN_MB31_LENGTH", 0600, parent, (u16 *)0xFFC02FF0);
		debugfs_create_x16("CAN_MB31_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FF4);

		parent = debugfs_create_dir("Core Timer Registers", top);
		debugfs_create_x32("TCNTL", 0600, parent, (u32 *)0xFFE03000);
		debugfs_create_x32("TCOUNT", 0600, parent, (u32 *)0xFFE0300C);
		debugfs_create_x32("TPERIOD", 0600, parent, (u32 *)0xFFE03004);
		debugfs_create_x32("TSCALE", 0600, parent, (u32 *)0xFFE03008);

		parent = debugfs_create_dir("DMA Traffic Control", top);
		debugfs_create_x16("DMA0_TC_CNT", 0600, parent, (u16 *)0xFFC00B10);
		debugfs_create_x16("DMA0_TC_PER", 0600, parent, (u16 *)0xFFC00B0C);
		debugfs_create_x16("DMA1_TC_CNT", 0600, parent, (u16 *)0xFFC01B10);
		debugfs_create_x16("DMA1_TC_PER", 0600, parent, (u16 *)0xFFC01B0C);

		parent = debugfs_create_dir("DMA0 (DMA0 Ch-0) Registers", top);
		debugfs_create_x16("DMA0_CONFIG", 0600, parent, (u16 *)0xFFC00C08);
		debugfs_create_x32("DMA0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C24);
		debugfs_create_x32("DMA0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C20);
		debugfs_create_x16("DMA0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C30);
		debugfs_create_x16("DMA0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C38);
		debugfs_create_x16("DMA0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C28);
		debugfs_create_x32("DMA0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C00);
		debugfs_create_x16("DMA0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C2C);
		debugfs_create_x32("DMA0_START_ADDR", 0600, parent, (u32 *)0xFFC00C04);
		debugfs_create_x16("DMA0_X_COUNT", 0600, parent, (u16 *)0xFFC00C10);
		debugfs_create_x16("DMA0_X_MODIFY", 0600, parent, (u16 *)0xFFC00C14);
		debugfs_create_x16("DMA0_Y_COUNT", 0600, parent, (u16 *)0xFFC00C18);
		debugfs_create_x16("DMA0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C1C);

		parent = debugfs_create_dir("DMA1 (DMA0 Ch-1) Registers", top);
		debugfs_create_x16("DMA1_CONFIG", 0600, parent, (u16 *)0xFFC00C48);
		debugfs_create_x32("DMA1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C64);
		debugfs_create_x32("DMA1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C60);
		debugfs_create_x16("DMA1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C70);
		debugfs_create_x16("DMA1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C78);
		debugfs_create_x16("DMA1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C68);
		debugfs_create_x32("DMA1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C40);
		debugfs_create_x16("DMA1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C6C);
		debugfs_create_x32("DMA1_START_ADDR", 0600, parent, (u32 *)0xFFC00C44);
		debugfs_create_x16("DMA1_X_COUNT", 0600, parent, (u16 *)0xFFC00C50);
		debugfs_create_x16("DMA1_X_MODIFY", 0600, parent, (u16 *)0xFFC00C54);
		debugfs_create_x16("DMA1_Y_COUNT", 0600, parent, (u16 *)0xFFC00C58);
		debugfs_create_x16("DMA1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C5C);

		parent = debugfs_create_dir("DMA10 (DMA1 Ch-2) Registers", top);
		debugfs_create_x16("DMA10_CONFIG", 0600, parent, (u16 *)0xFFC01C88);
		debugfs_create_x32("DMA10_CURR_ADDR", 0600, parent, (u32 *)0xFFC01CA4);
		debugfs_create_x32("DMA10_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01CA0);
		debugfs_create_x16("DMA10_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01CB0);
		debugfs_create_x16("DMA10_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01CB8);
		debugfs_create_x16("DMA10_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01CA8);
		debugfs_create_x32("DMA10_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01C80);
		debugfs_create_x16("DMA10_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01CAC);
		debugfs_create_x32("DMA10_START_ADDR", 0600, parent, (u32 *)0xFFC01C84);
		debugfs_create_x16("DMA10_X_COUNT", 0600, parent, (u16 *)0xFFC01C90);
		debugfs_create_x16("DMA10_X_MODIFY", 0600, parent, (u16 *)0xFFC01C94);
		debugfs_create_x16("DMA10_Y_COUNT", 0600, parent, (u16 *)0xFFC01C98);
		debugfs_create_x16("DMA10_Y_MODIFY", 0600, parent, (u16 *)0xFFC01C9C);

		parent = debugfs_create_dir("DMA11 (DMA1 Ch-3) Registers", top);
		debugfs_create_x16("DMA11_CONFIG", 0600, parent, (u16 *)0xFFC01CC8);
		debugfs_create_x32("DMA11_CURR_ADDR", 0600, parent, (u32 *)0xFFC01CE4);
		debugfs_create_x32("DMA11_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01CE0);
		debugfs_create_x16("DMA11_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01CF0);
		debugfs_create_x16("DMA11_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01CF8);
		debugfs_create_x16("DMA11_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01CE8);
		debugfs_create_x32("DMA11_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01CC0);
		debugfs_create_x16("DMA11_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01CEC);
		debugfs_create_x32("DMA11_START_ADDR", 0600, parent, (u32 *)0xFFC01CC4);
		debugfs_create_x16("DMA11_X_COUNT", 0600, parent, (u16 *)0xFFC01CD0);
		debugfs_create_x16("DMA11_X_MODIFY", 0600, parent, (u16 *)0xFFC01CD4);
		debugfs_create_x16("DMA11_Y_COUNT", 0600, parent, (u16 *)0xFFC01CD8);
		debugfs_create_x16("DMA11_Y_MODIFY", 0600, parent, (u16 *)0xFFC01CDC);

		parent = debugfs_create_dir("DMA12 (DMA1 Ch-4) Registers", top);
		debugfs_create_x16("DMA12_CONFIG", 0600, parent, (u16 *)0xFFC01D08);
		debugfs_create_x32("DMA12_CURR_ADDR", 0600, parent, (u32 *)0xFFC01D24);
		debugfs_create_x32("DMA12_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01D20);
		debugfs_create_x16("DMA12_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01D30);
		debugfs_create_x16("DMA12_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01D38);
		debugfs_create_x16("DMA12_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01D28);
		debugfs_create_x32("DMA12_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01D00);
		debugfs_create_x16("DMA12_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01D2C);
		debugfs_create_x32("DMA12_START_ADDR", 0600, parent, (u32 *)0xFFC01D04);
		debugfs_create_x16("DMA12_X_COUNT", 0600, parent, (u16 *)0xFFC01D10);
		debugfs_create_x16("DMA12_X_MODIFY", 0600, parent, (u16 *)0xFFC01D14);
		debugfs_create_x16("DMA12_Y_COUNT", 0600, parent, (u16 *)0xFFC01D18);
		debugfs_create_x16("DMA12_Y_MODIFY", 0600, parent, (u16 *)0xFFC01D1C);

		parent = debugfs_create_dir("DMA13 (DMA1 Ch-5) Registers", top);
		debugfs_create_x16("DMA13_CONFIG", 0600, parent, (u16 *)0xFFC01D48);
		debugfs_create_x32("DMA13_CURR_ADDR", 0600, parent, (u32 *)0xFFC01D64);
		debugfs_create_x32("DMA13_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01D60);
		debugfs_create_x16("DMA13_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01D70);
		debugfs_create_x16("DMA13_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01D78);
		debugfs_create_x16("DMA13_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01D68);
		debugfs_create_x32("DMA13_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01D40);
		debugfs_create_x16("DMA13_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01D6C);
		debugfs_create_x32("DMA13_START_ADDR", 0600, parent, (u32 *)0xFFC01D44);
		debugfs_create_x16("DMA13_X_COUNT", 0600, parent, (u16 *)0xFFC01D50);
		debugfs_create_x16("DMA13_X_MODIFY", 0600, parent, (u16 *)0xFFC01D54);
		debugfs_create_x16("DMA13_Y_COUNT", 0600, parent, (u16 *)0xFFC01D58);
		debugfs_create_x16("DMA13_Y_MODIFY", 0600, parent, (u16 *)0xFFC01D5C);

		parent = debugfs_create_dir("DMA14 (DMA1 Ch-6) Registers", top);
		debugfs_create_x16("DMA14_CONFIG", 0600, parent, (u16 *)0xFFC01D88);
		debugfs_create_x32("DMA14_CURR_ADDR", 0600, parent, (u32 *)0xFFC01DA4);
		debugfs_create_x32("DMA14_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01DA0);
		debugfs_create_x16("DMA14_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01DB0);
		debugfs_create_x16("DMA14_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01DB8);
		debugfs_create_x16("DMA14_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01DA8);
		debugfs_create_x32("DMA14_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01D80);
		debugfs_create_x16("DMA14_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01DAC);
		debugfs_create_x32("DMA14_START_ADDR", 0600, parent, (u32 *)0xFFC01D84);
		debugfs_create_x16("DMA14_X_COUNT", 0600, parent, (u16 *)0xFFC01D90);
		debugfs_create_x16("DMA14_X_MODIFY", 0600, parent, (u16 *)0xFFC01D94);
		debugfs_create_x16("DMA14_Y_COUNT", 0600, parent, (u16 *)0xFFC01D98);
		debugfs_create_x16("DMA14_Y_MODIFY", 0600, parent, (u16 *)0xFFC01D9C);

		parent = debugfs_create_dir("DMA15 (DMA1 Ch-7) Registers", top);
		debugfs_create_x16("DMA15_CONFIG", 0600, parent, (u16 *)0xFFC01DC8);
		debugfs_create_x32("DMA15_CURR_ADDR", 0600, parent, (u32 *)0xFFC01DE4);
		debugfs_create_x32("DMA15_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01DE0);
		debugfs_create_x16("DMA15_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01DF0);
		debugfs_create_x16("DMA15_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01DF8);
		debugfs_create_x16("DMA15_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01DE8);
		debugfs_create_x32("DMA15_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01DC0);
		debugfs_create_x16("DMA15_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01DEC);
		debugfs_create_x32("DMA15_START_ADDR", 0600, parent, (u32 *)0xFFC01DC4);
		debugfs_create_x16("DMA15_X_COUNT", 0600, parent, (u16 *)0xFFC01DD0);
		debugfs_create_x16("DMA15_X_MODIFY", 0600, parent, (u16 *)0xFFC01DD4);
		debugfs_create_x16("DMA15_Y_COUNT", 0600, parent, (u16 *)0xFFC01DD8);
		debugfs_create_x16("DMA15_Y_MODIFY", 0600, parent, (u16 *)0xFFC01DDC);

		parent = debugfs_create_dir("DMA16 (DMA1 Ch-8) Registers", top);
		debugfs_create_x16("DMA16_CONFIG", 0600, parent, (u16 *)0xFFC01E08);
		debugfs_create_x32("DMA16_CURR_ADDR", 0600, parent, (u32 *)0xFFC01E24);
		debugfs_create_x32("DMA16_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01E20);
		debugfs_create_x16("DMA16_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01E30);
		debugfs_create_x16("DMA16_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01E38);
		debugfs_create_x16("DMA16_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01E28);
		debugfs_create_x32("DMA16_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01E00);
		debugfs_create_x16("DMA16_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01E2C);
		debugfs_create_x32("DMA16_START_ADDR", 0600, parent, (u32 *)0xFFC01E04);
		debugfs_create_x16("DMA16_X_COUNT", 0600, parent, (u16 *)0xFFC01E10);
		debugfs_create_x16("DMA16_X_MODIFY", 0600, parent, (u16 *)0xFFC01E14);
		debugfs_create_x16("DMA16_Y_COUNT", 0600, parent, (u16 *)0xFFC01E18);
		debugfs_create_x16("DMA16_Y_MODIFY", 0600, parent, (u16 *)0xFFC01E1C);

		parent = debugfs_create_dir("DMA17 (DMA1 Ch-9) Registers", top);
		debugfs_create_x16("DMA17_CONFIG", 0600, parent, (u16 *)0xFFC01E48);
		debugfs_create_x32("DMA17_CURR_ADDR", 0600, parent, (u32 *)0xFFC01E64);
		debugfs_create_x32("DMA17_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01E60);
		debugfs_create_x16("DMA17_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01E70);
		debugfs_create_x16("DMA17_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01E78);
		debugfs_create_x16("DMA17_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01E68);
		debugfs_create_x32("DMA17_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01E40);
		debugfs_create_x16("DMA17_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01E6C);
		debugfs_create_x32("DMA17_START_ADDR", 0600, parent, (u32 *)0xFFC01E44);
		debugfs_create_x16("DMA17_X_COUNT", 0600, parent, (u16 *)0xFFC01E50);
		debugfs_create_x16("DMA17_X_MODIFY", 0600, parent, (u16 *)0xFFC01E54);
		debugfs_create_x16("DMA17_Y_COUNT", 0600, parent, (u16 *)0xFFC01E58);
		debugfs_create_x16("DMA17_Y_MODIFY", 0600, parent, (u16 *)0xFFC01E5C);

		parent = debugfs_create_dir("DMA18 (DMA1 Ch-10) Registers", top);
		debugfs_create_x16("DMA18_CONFIG", 0600, parent, (u16 *)0xFFC01E88);
		debugfs_create_x32("DMA18_CURR_ADDR", 0600, parent, (u32 *)0xFFC01EA4);
		debugfs_create_x32("DMA18_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01EA0);
		debugfs_create_x16("DMA18_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01EB0);
		debugfs_create_x16("DMA18_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01EB8);
		debugfs_create_x16("DMA18_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01EA8);
		debugfs_create_x32("DMA18_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01E80);
		debugfs_create_x16("DMA18_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01EAC);
		debugfs_create_x32("DMA18_START_ADDR", 0600, parent, (u32 *)0xFFC01E84);
		debugfs_create_x16("DMA18_X_COUNT", 0600, parent, (u16 *)0xFFC01E90);
		debugfs_create_x16("DMA18_X_MODIFY", 0600, parent, (u16 *)0xFFC01E94);
		debugfs_create_x16("DMA18_Y_COUNT", 0600, parent, (u16 *)0xFFC01E98);
		debugfs_create_x16("DMA18_Y_MODIFY", 0600, parent, (u16 *)0xFFC01E9C);

		parent = debugfs_create_dir("DMA19 (DMA1 Ch-11) Registers", top);
		debugfs_create_x16("DMA19_CONFIG", 0600, parent, (u16 *)0xFFC01EC8);
		debugfs_create_x32("DMA19_CURR_ADDR", 0600, parent, (u32 *)0xFFC01EE4);
		debugfs_create_x32("DMA19_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01EE0);
		debugfs_create_x16("DMA19_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01EF0);
		debugfs_create_x16("DMA19_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01EF8);
		debugfs_create_x16("DMA19_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01EE8);
		debugfs_create_x32("DMA19_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01EC0);
		debugfs_create_x16("DMA19_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01EEC);
		debugfs_create_x32("DMA19_START_ADDR", 0600, parent, (u32 *)0xFFC01EC4);
		debugfs_create_x16("DMA19_X_COUNT", 0600, parent, (u16 *)0xFFC01ED0);
		debugfs_create_x16("DMA19_X_MODIFY", 0600, parent, (u16 *)0xFFC01ED4);
		debugfs_create_x16("DMA19_Y_COUNT", 0600, parent, (u16 *)0xFFC01ED8);
		debugfs_create_x16("DMA19_Y_MODIFY", 0600, parent, (u16 *)0xFFC01EDC);

		parent = debugfs_create_dir("DMA2 (DMA0 Ch-2) Registers", top);
		debugfs_create_x16("DMA2_CONFIG", 0600, parent, (u16 *)0xFFC00C88);
		debugfs_create_x32("DMA2_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CA4);
		debugfs_create_x32("DMA2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CA0);
		debugfs_create_x16("DMA2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CB0);
		debugfs_create_x16("DMA2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CB8);
		debugfs_create_x16("DMA2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CA8);
		debugfs_create_x32("DMA2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C80);
		debugfs_create_x16("DMA2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CAC);
		debugfs_create_x32("DMA2_START_ADDR", 0600, parent, (u32 *)0xFFC00C84);
		debugfs_create_x16("DMA2_X_COUNT", 0600, parent, (u16 *)0xFFC00C90);
		debugfs_create_x16("DMA2_X_MODIFY", 0600, parent, (u16 *)0xFFC00C94);
		debugfs_create_x16("DMA2_Y_COUNT", 0600, parent, (u16 *)0xFFC00C98);
		debugfs_create_x16("DMA2_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C9C);

		parent = debugfs_create_dir("DMA3 (DMA0 Ch-3) Registers", top);
		debugfs_create_x16("DMA3_CONFIG", 0600, parent, (u16 *)0xFFC00CC8);
		debugfs_create_x32("DMA3_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CE4);
		debugfs_create_x32("DMA3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CE0);
		debugfs_create_x16("DMA3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CF0);
		debugfs_create_x16("DMA3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CF8);
		debugfs_create_x16("DMA3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CE8);
		debugfs_create_x32("DMA3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00CC0);
		debugfs_create_x16("DMA3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CEC);
		debugfs_create_x32("DMA3_START_ADDR", 0600, parent, (u32 *)0xFFC00CC4);
		debugfs_create_x16("DMA3_X_COUNT", 0600, parent, (u16 *)0xFFC00CD0);
		debugfs_create_x16("DMA3_X_MODIFY", 0600, parent, (u16 *)0xFFC00CD4);
		debugfs_create_x16("DMA3_Y_COUNT", 0600, parent, (u16 *)0xFFC00CD8);
		debugfs_create_x16("DMA3_Y_MODIFY", 0600, parent, (u16 *)0xFFC00CDC);

		parent = debugfs_create_dir("DMA4 (DMA0 Ch-4) Registers", top);
		debugfs_create_x16("DMA4_CONFIG", 0600, parent, (u16 *)0xFFC00D08);
		debugfs_create_x32("DMA4_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D24);
		debugfs_create_x32("DMA4_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D20);
		debugfs_create_x16("DMA4_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D30);
		debugfs_create_x16("DMA4_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D38);
		debugfs_create_x16("DMA4_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D28);
		debugfs_create_x32("DMA4_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D00);
		debugfs_create_x16("DMA4_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D2C);
		debugfs_create_x32("DMA4_START_ADDR", 0600, parent, (u32 *)0xFFC00D04);
		debugfs_create_x16("DMA4_X_COUNT", 0600, parent, (u16 *)0xFFC00D10);
		debugfs_create_x16("DMA4_X_MODIFY", 0600, parent, (u16 *)0xFFC00D14);
		debugfs_create_x16("DMA4_Y_COUNT", 0600, parent, (u16 *)0xFFC00D18);
		debugfs_create_x16("DMA4_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D1C);

		parent = debugfs_create_dir("DMA5 (DMA0 Ch-5) Registers", top);
		debugfs_create_x16("DMA5_CONFIG", 0600, parent, (u16 *)0xFFC00D48);
		debugfs_create_x32("DMA5_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D64);
		debugfs_create_x32("DMA5_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D60);
		debugfs_create_x16("DMA5_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D70);
		debugfs_create_x16("DMA5_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D78);
		debugfs_create_x16("DMA5_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D68);
		debugfs_create_x32("DMA5_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D40);
		debugfs_create_x16("DMA5_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D6C);
		debugfs_create_x32("DMA5_START_ADDR", 0600, parent, (u32 *)0xFFC00D44);
		debugfs_create_x16("DMA5_X_COUNT", 0600, parent, (u16 *)0xFFC00D50);
		debugfs_create_x16("DMA5_X_MODIFY", 0600, parent, (u16 *)0xFFC00D54);
		debugfs_create_x16("DMA5_Y_COUNT", 0600, parent, (u16 *)0xFFC00D58);
		debugfs_create_x16("DMA5_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D5C);

		parent = debugfs_create_dir("DMA6 (DMA0 Ch-6) Registers", top);
		debugfs_create_x16("DMA6_CONFIG", 0600, parent, (u16 *)0xFFC00D88);
		debugfs_create_x32("DMA6_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DA4);
		debugfs_create_x32("DMA6_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DA0);
		debugfs_create_x16("DMA6_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DB0);
		debugfs_create_x16("DMA6_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DB8);
		debugfs_create_x16("DMA6_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DA8);
		debugfs_create_x32("DMA6_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D80);
		debugfs_create_x16("DMA6_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DAC);
		debugfs_create_x32("DMA6_START_ADDR", 0600, parent, (u32 *)0xFFC00D84);
		debugfs_create_x16("DMA6_X_COUNT", 0600, parent, (u16 *)0xFFC00D90);
		debugfs_create_x16("DMA6_X_MODIFY", 0600, parent, (u16 *)0xFFC00D94);
		debugfs_create_x16("DMA6_Y_COUNT", 0600, parent, (u16 *)0xFFC00D98);
		debugfs_create_x16("DMA6_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D9C);

		parent = debugfs_create_dir("DMA7 (DMA0 Ch-7) Registers", top);
		debugfs_create_x16("DMA7_CONFIG", 0600, parent, (u16 *)0xFFC00DC8);
		debugfs_create_x32("DMA7_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DE4);
		debugfs_create_x32("DMA7_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DE0);
		debugfs_create_x16("DMA7_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DF0);
		debugfs_create_x16("DMA7_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DF8);
		debugfs_create_x16("DMA7_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DE8);
		debugfs_create_x32("DMA7_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00DC0);
		debugfs_create_x16("DMA7_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DEC);
		debugfs_create_x32("DMA7_START_ADDR", 0600, parent, (u32 *)0xFFC00DC4);
		debugfs_create_x16("DMA7_X_COUNT", 0600, parent, (u16 *)0xFFC00DD0);
		debugfs_create_x16("DMA7_X_MODIFY", 0600, parent, (u16 *)0xFFC00DD4);
		debugfs_create_x16("DMA7_Y_COUNT", 0600, parent, (u16 *)0xFFC00DD8);
		debugfs_create_x16("DMA7_Y_MODIFY", 0600, parent, (u16 *)0xFFC00DDC);

		parent = debugfs_create_dir("DMA8 (DMA1 Ch-0) Registers", top);
		debugfs_create_x16("DMA8_CONFIG", 0600, parent, (u16 *)0xFFC01C08);
		debugfs_create_x32("DMA8_CURR_ADDR", 0600, parent, (u32 *)0xFFC01C24);
		debugfs_create_x32("DMA8_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01C20);
		debugfs_create_x16("DMA8_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01C30);
		debugfs_create_x16("DMA8_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01C38);
		debugfs_create_x16("DMA8_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01C28);
		debugfs_create_x32("DMA8_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01C00);
		debugfs_create_x16("DMA8_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01C2C);
		debugfs_create_x32("DMA8_START_ADDR", 0600, parent, (u32 *)0xFFC01C04);
		debugfs_create_x16("DMA8_X_COUNT", 0600, parent, (u16 *)0xFFC01C10);
		debugfs_create_x16("DMA8_X_MODIFY", 0600, parent, (u16 *)0xFFC01C14);
		debugfs_create_x16("DMA8_Y_COUNT", 0600, parent, (u16 *)0xFFC01C18);
		debugfs_create_x16("DMA8_Y_MODIFY", 0600, parent, (u16 *)0xFFC01C1C);

		parent = debugfs_create_dir("DMA9 (DMA1 Ch-1) Registers", top);
		debugfs_create_x16("DMA9_CONFIG", 0600, parent, (u16 *)0xFFC01C48);
		debugfs_create_x32("DMA9_CURR_ADDR", 0600, parent, (u32 *)0xFFC01C64);
		debugfs_create_x32("DMA9_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01C60);
		debugfs_create_x16("DMA9_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01C70);
		debugfs_create_x16("DMA9_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01C78);
		debugfs_create_x16("DMA9_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01C68);
		debugfs_create_x32("DMA9_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01C40);
		debugfs_create_x16("DMA9_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01C6C);
		debugfs_create_x32("DMA9_START_ADDR", 0600, parent, (u32 *)0xFFC01C44);
		debugfs_create_x16("DMA9_X_COUNT", 0600, parent, (u16 *)0xFFC01C50);
		debugfs_create_x16("DMA9_X_MODIFY", 0600, parent, (u16 *)0xFFC01C54);
		debugfs_create_x16("DMA9_Y_COUNT", 0600, parent, (u16 *)0xFFC01C58);
		debugfs_create_x16("DMA9_Y_MODIFY", 0600, parent, (u16 *)0xFFC01C5C);

		parent = debugfs_create_dir("EBIU", top);
		debugfs_create_x32("EBIU_AMBCTL0", 0600, parent, (u32 *)0xFFC00A04);
		debugfs_create_x32("EBIU_AMBCTL1", 0600, parent, (u32 *)0xFFC00A08);
		debugfs_create_x16("EBIU_AMGCTL", 0600, parent, (u16 *)0xFFC00A00);
		debugfs_create_x16("EBIU_SDBCTL", 0600, parent, (u16 *)0xFFC00A14);
		debugfs_create_x32("EBIU_SDGCTL", 0600, parent, (u32 *)0xFFC00A10);
		debugfs_create_x16("EBIU_SDRRC", 0600, parent, (u16 *)0xFFC00A18);
		debugfs_create_x16("EBIU_SDSTAT", 0600, parent, (u16 *)0xFFC00A1C);

		parent = debugfs_create_dir("Event Vectors", top);
		debugfs_create_x32("EVT0", 0600, parent, (u32 *)0xFFE02000);
		debugfs_create_x32("EVT10", 0600, parent, (u32 *)0xFFE02028);
		debugfs_create_x32("EVT11", 0600, parent, (u32 *)0xFFE0202C);
		debugfs_create_x32("EVT12", 0600, parent, (u32 *)0xFFE02030);
		debugfs_create_x32("EVT13", 0600, parent, (u32 *)0xFFE02034);
		debugfs_create_x32("EVT14", 0600, parent, (u32 *)0xFFE02038);
		debugfs_create_x32("EVT15", 0600, parent, (u32 *)0xFFE0203C);
		debugfs_create_x32("EVT1", 0600, parent, (u32 *)0xFFE02004);
		debugfs_create_x32("EVT2", 0600, parent, (u32 *)0xFFE02008);
		debugfs_create_x32("EVT3", 0600, parent, (u32 *)0xFFE0200C);
		debugfs_create_x32("EVT4", 0600, parent, (u32 *)0xFFE02010);
		debugfs_create_x32("EVT5", 0600, parent, (u32 *)0xFFE02014);
		debugfs_create_x32("EVT6", 0600, parent, (u32 *)0xFFE02018);
		debugfs_create_x32("EVT7", 0600, parent, (u32 *)0xFFE0201C);
		debugfs_create_x32("EVT8", 0600, parent, (u32 *)0xFFE02020);
		debugfs_create_x32("EVT9", 0600, parent, (u32 *)0xFFE02024);

		parent = debugfs_create_dir("Extended Registers", top);
		debugfs_create_x32("CHIPID", 0600, parent, (u32 *)0xFFC00014);
		debugfs_create_x32("DSPID", 0600, parent, (u32 *)0xFFE05000);

		parent = debugfs_create_dir("General Purpose IO Registers", top);
		debugfs_create_x16("GPIO_C_C", 0600, parent, (u16 *)0xFFC01520);
		debugfs_create_x16("GPIO_C_CNFG", 0600, parent, (u16 *)0xFFC01500);
		debugfs_create_x16("GPIO_C_D", 0600, parent, (u16 *)0xFFC01510);
		debugfs_create_x16("GPIO_C_DIR", 0600, parent, (u16 *)0xFFC01550);
		debugfs_create_x16("GPIO_C_INEN", 0600, parent, (u16 *)0xFFC01560);
		debugfs_create_x16("GPIO_C_S", 0600, parent, (u16 *)0xFFC01530);
		debugfs_create_x16("GPIO_C_T", 0600, parent, (u16 *)0xFFC01540);
		debugfs_create_x16("GPIO_D_C", 0600, parent, (u16 *)0xFFC01524);
		debugfs_create_x16("GPIO_D_CNFG", 0600, parent, (u16 *)0xFFC01504);
		debugfs_create_x16("GPIO_D_D", 0600, parent, (u16 *)0xFFC01514);
		debugfs_create_x16("GPIO_D_DIR", 0600, parent, (u16 *)0xFFC01554);
		debugfs_create_x16("GPIO_D_INEN", 0600, parent, (u16 *)0xFFC01564);
		debugfs_create_x16("GPIO_D_S", 0600, parent, (u16 *)0xFFC01534);
		debugfs_create_x16("GPIO_D_T", 0600, parent, (u16 *)0xFFC01544);
		debugfs_create_x16("GPIO_E_C", 0600, parent, (u16 *)0xFFC01528);
		debugfs_create_x16("GPIO_E_CNFG", 0600, parent, (u16 *)0xFFC01508);
		debugfs_create_x16("GPIO_E_D", 0600, parent, (u16 *)0xFFC01518);
		debugfs_create_x16("GPIO_E_DIR", 0600, parent, (u16 *)0xFFC01558);
		debugfs_create_x16("GPIO_E_INEN", 0600, parent, (u16 *)0xFFC01568);
		debugfs_create_x16("GPIO_E_S", 0600, parent, (u16 *)0xFFC01538);
		debugfs_create_x16("GPIO_E_T", 0600, parent, (u16 *)0xFFC01548);

		parent = debugfs_create_dir("Interrupt Controller", top);
		debugfs_create_x32("ILAT", 0600, parent, (u32 *)0xFFE0210C);
		debugfs_create_x32("IMASK", 0600, parent, (u32 *)0xFFE02104);
		debugfs_create_x32("IPEND", 0600, parent, (u32 *)0xFFE02108);
		debugfs_create_x32("IPRIO", 0600, parent, (u32 *)0xFFE02110);

		parent = debugfs_create_dir("L1 Code Memory Registers", top);
		debugfs_create_x32("ICPLB_ADDR0", 0600, parent, (u32 *)0xFFE01100);
		debugfs_create_x32("ICPLB_ADDR10", 0600, parent, (u32 *)0xFFE01128);
		debugfs_create_x32("ICPLB_ADDR11", 0600, parent, (u32 *)0xFFE0112C);
		debugfs_create_x32("ICPLB_ADDR12", 0600, parent, (u32 *)0xFFE01130);
		debugfs_create_x32("ICPLB_ADDR13", 0600, parent, (u32 *)0xFFE01134);
		debugfs_create_x32("ICPLB_ADDR14", 0600, parent, (u32 *)0xFFE01138);
		debugfs_create_x32("ICPLB_ADDR15", 0600, parent, (u32 *)0xFFE0113C);
		debugfs_create_x32("ICPLB_ADDR1", 0600, parent, (u32 *)0xFFE01104);
		debugfs_create_x32("ICPLB_ADDR2", 0600, parent, (u32 *)0xFFE01108);
		debugfs_create_x32("ICPLB_ADDR3", 0600, parent, (u32 *)0xFFE0110C);
		debugfs_create_x32("ICPLB_ADDR4", 0600, parent, (u32 *)0xFFE01110);
		debugfs_create_x32("ICPLB_ADDR5", 0600, parent, (u32 *)0xFFE01114);
		debugfs_create_x32("ICPLB_ADDR6", 0600, parent, (u32 *)0xFFE01118);
		debugfs_create_x32("ICPLB_ADDR7", 0600, parent, (u32 *)0xFFE0111C);
		debugfs_create_x32("ICPLB_ADDR8", 0600, parent, (u32 *)0xFFE01120);
		debugfs_create_x32("ICPLB_ADDR9", 0600, parent, (u32 *)0xFFE01124);
		debugfs_create_x32("ICPLB_DATA0", 0600, parent, (u32 *)0xFFE01200);
		debugfs_create_x32("ICPLB_DATA10", 0600, parent, (u32 *)0xFFE01228);
		debugfs_create_x32("ICPLB_DATA11", 0600, parent, (u32 *)0xFFE0122C);
		debugfs_create_x32("ICPLB_DATA12", 0600, parent, (u32 *)0xFFE01230);
		debugfs_create_x32("ICPLB_DATA13", 0600, parent, (u32 *)0xFFE01234);
		debugfs_create_x32("ICPLB_DATA14", 0600, parent, (u32 *)0xFFE01238);
		debugfs_create_x32("ICPLB_DATA15", 0600, parent, (u32 *)0xFFE0123C);
		debugfs_create_x32("ICPLB_DATA1", 0600, parent, (u32 *)0xFFE01204);
		debugfs_create_x32("ICPLB_DATA2", 0600, parent, (u32 *)0xFFE01208);
		debugfs_create_x32("ICPLB_DATA3", 0600, parent, (u32 *)0xFFE0120C);
		debugfs_create_x32("ICPLB_DATA4", 0600, parent, (u32 *)0xFFE01210);
		debugfs_create_x32("ICPLB_DATA5", 0600, parent, (u32 *)0xFFE01214);
		debugfs_create_x32("ICPLB_DATA6", 0600, parent, (u32 *)0xFFE01218);
		debugfs_create_x32("ICPLB_DATA7", 0600, parent, (u32 *)0xFFE0121C);
		debugfs_create_x32("ICPLB_DATA8", 0600, parent, (u32 *)0xFFE01220);
		debugfs_create_x32("ICPLB_DATA9", 0600, parent, (u32 *)0xFFE01224);
		debugfs_create_x32("ICPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0100C);
		debugfs_create_x32("ICPLB_STATUS", 0600, parent, (u32 *)0xFFE01008);
		debugfs_create_x32("IMEM_CONTROL", 0600, parent, (u32 *)0xFFE01004);
		debugfs_create_x32("ITEST_COMMAND", 0600, parent, (u32 *)0xFFE01300);
		debugfs_create_x32("ITEST_DATA0", 0600, parent, (u32 *)0xFFE01400);
		debugfs_create_x32("ITEST_DATA1", 0600, parent, (u32 *)0xFFE01404);

		parent = debugfs_create_dir("L1 Data Memory Registers", top);
		debugfs_create_x32("DCPLB_ADDR0", 0600, parent, (u32 *)0xFFE00100);
		debugfs_create_x32("DCPLB_ADDR10", 0600, parent, (u32 *)0xFFE00128);
		debugfs_create_x32("DCPLB_ADDR11", 0600, parent, (u32 *)0xFFE0012C);
		debugfs_create_x32("DCPLB_ADDR12", 0600, parent, (u32 *)0xFFE00130);
		debugfs_create_x32("DCPLB_ADDR13", 0600, parent, (u32 *)0xFFE00134);
		debugfs_create_x32("DCPLB_ADDR14", 0600, parent, (u32 *)0xFFE00138);
		debugfs_create_x32("DCPLB_ADDR15", 0600, parent, (u32 *)0xFFE0013C);
		debugfs_create_x32("DCPLB_ADDR1", 0600, parent, (u32 *)0xFFE00104);
		debugfs_create_x32("DCPLB_ADDR2", 0600, parent, (u32 *)0xFFE00108);
		debugfs_create_x32("DCPLB_ADDR3", 0600, parent, (u32 *)0xFFE0010C);
		debugfs_create_x32("DCPLB_ADDR4", 0600, parent, (u32 *)0xFFE00110);
		debugfs_create_x32("DCPLB_ADDR5", 0600, parent, (u32 *)0xFFE00114);
		debugfs_create_x32("DCPLB_ADDR6", 0600, parent, (u32 *)0xFFE00118);
		debugfs_create_x32("DCPLB_ADDR7", 0600, parent, (u32 *)0xFFE0011C);
		debugfs_create_x32("DCPLB_ADDR8", 0600, parent, (u32 *)0xFFE00120);
		debugfs_create_x32("DCPLB_ADDR9", 0600, parent, (u32 *)0xFFE00124);
		debugfs_create_x32("DCPLB_DATA0", 0600, parent, (u32 *)0xFFE00200);
		debugfs_create_x32("DCPLB_DATA10", 0600, parent, (u32 *)0xFFE00228);
		debugfs_create_x32("DCPLB_DATA11", 0600, parent, (u32 *)0xFFE0022C);
		debugfs_create_x32("DCPLB_DATA12", 0600, parent, (u32 *)0xFFE00230);
		debugfs_create_x32("DCPLB_DATA13", 0600, parent, (u32 *)0xFFE00234);
		debugfs_create_x32("DCPLB_DATA14", 0600, parent, (u32 *)0xFFE00238);
		debugfs_create_x32("DCPLB_DATA15", 0600, parent, (u32 *)0xFFE0023C);
		debugfs_create_x32("DCPLB_DATA1", 0600, parent, (u32 *)0xFFE00204);
		debugfs_create_x32("DCPLB_DATA2", 0600, parent, (u32 *)0xFFE00208);
		debugfs_create_x32("DCPLB_DATA3", 0600, parent, (u32 *)0xFFE0020C);
		debugfs_create_x32("DCPLB_DATA4", 0600, parent, (u32 *)0xFFE00210);
		debugfs_create_x32("DCPLB_DATA5", 0600, parent, (u32 *)0xFFE00214);
		debugfs_create_x32("DCPLB_DATA6", 0600, parent, (u32 *)0xFFE00218);
		debugfs_create_x32("DCPLB_DATA7", 0600, parent, (u32 *)0xFFE0021C);
		debugfs_create_x32("DCPLB_DATA8", 0600, parent, (u32 *)0xFFE00220);
		debugfs_create_x32("DCPLB_DATA9", 0600, parent, (u32 *)0xFFE00224);
		debugfs_create_x32("DCPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0000C);
		debugfs_create_x32("DCPLB_STATUS", 0600, parent, (u32 *)0xFFE00008);
		debugfs_create_x32("DMEM_CONTROL", 0600, parent, (u32 *)0xFFE00004);
		debugfs_create_x32("DTEST_COMMAND", 0600, parent, (u32 *)0xFFE00300);
		debugfs_create_x32("DTEST_DATA0", 0600, parent, (u32 *)0xFFE00400);
		debugfs_create_x32("DTEST_DATA1", 0600, parent, (u32 *)0xFFE00404);
		debugfs_create_x32("SRAM_BASE_ADDR", 0600, parent, (u32 *)0xFFE00000);

		parent = debugfs_create_dir("MEMDMA0 Destination0 Registers", top);
		debugfs_create_x16("MDMA0_D0_CONFIG", 0600, parent, (u16 *)0xFFC00E08);
		debugfs_create_x32("MDMA0_D0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E24);
		debugfs_create_x32("MDMA0_D0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E20);
		debugfs_create_x16("MDMA0_D0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E30);
		debugfs_create_x16("MDMA0_D0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E38);
		debugfs_create_x16("MDMA0_D0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E28);
		debugfs_create_x32("MDMA0_D0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E00);
		debugfs_create_x16("MDMA0_D0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E2C);
		debugfs_create_x32("MDMA0_D0_START_ADDR", 0600, parent, (u32 *)0xFFC00E04);
		debugfs_create_x16("MDMA0_D0_X_COUNT", 0600, parent, (u16 *)0xFFC00E10);
		debugfs_create_x16("MDMA0_D0_X_MODIFY", 0600, parent, (u16 *)0xFFC00E14);
		debugfs_create_x16("MDMA0_D0_Y_COUNT", 0600, parent, (u16 *)0xFFC00E18);
		debugfs_create_x16("MDMA0_D0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E1C);

		parent = debugfs_create_dir("MEMDMA0 Destination1 Registers", top);
		debugfs_create_x16("MDMA0_D1_CONFIG", 0600, parent, (u16 *)0xFFC00E88);
		debugfs_create_x32("MDMA0_D1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EA4);
		debugfs_create_x32("MDMA0_D1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EA0);
		debugfs_create_x16("MDMA0_D1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EB0);
		debugfs_create_x16("MDMA0_D1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EB8);
		debugfs_create_x16("MDMA0_D1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EA8);
		debugfs_create_x32("MDMA0_D1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E80);
		debugfs_create_x16("MDMA0_D1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EAC);
		debugfs_create_x32("MDMA0_D1_START_ADDR", 0600, parent, (u32 *)0xFFC00E84);
		debugfs_create_x16("MDMA0_D1_X_COUNT", 0600, parent, (u16 *)0xFFC00E90);
		debugfs_create_x16("MDMA0_D1_X_MODIFY", 0600, parent, (u16 *)0xFFC00E94);
		debugfs_create_x16("MDMA0_D1_Y_COUNT", 0600, parent, (u16 *)0xFFC00E98);
		debugfs_create_x16("MDMA0_D1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E9C);

		parent = debugfs_create_dir("MEMDMA0 Source0 Registers", top);
		debugfs_create_x16("MDMA0_S0_CONFIG", 0600, parent, (u16 *)0xFFC00E48);
		debugfs_create_x32("MDMA0_S0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E64);
		debugfs_create_x32("MDMA0_S0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E60);
		debugfs_create_x16("MDMA0_S0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E70);
		debugfs_create_x16("MDMA0_S0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E78);
		debugfs_create_x16("MDMA0_S0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E68);
		debugfs_create_x32("MDMA0_S0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E40);
		debugfs_create_x16("MDMA0_S0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E6C);
		debugfs_create_x32("MDMA0_S0_START_ADDR", 0600, parent, (u32 *)0xFFC00E44);
		debugfs_create_x16("MDMA0_S0_X_COUNT", 0600, parent, (u16 *)0xFFC00E50);
		debugfs_create_x16("MDMA0_S0_X_MODIFY", 0600, parent, (u16 *)0xFFC00E54);
		debugfs_create_x16("MDMA0_S0_Y_COUNT", 0600, parent, (u16 *)0xFFC00E58);
		debugfs_create_x16("MDMA0_S0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E5C);

		parent = debugfs_create_dir("MEMDMA0 Source1 Registers", top);
		debugfs_create_x16("MDMA0_S1_CONFIG", 0600, parent, (u16 *)0xFFC00EC8);
		debugfs_create_x32("MDMA0_S1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EE4);
		debugfs_create_x32("MDMA0_S1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EE0);
		debugfs_create_x16("MDMA0_S1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EF0);
		debugfs_create_x16("MDMA0_S1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EF8);
		debugfs_create_x16("MDMA0_S1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EE8);
		debugfs_create_x32("MDMA0_S1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00EC0);
		debugfs_create_x16("MDMA0_S1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EEC);
		debugfs_create_x32("MDMA0_S1_START_ADDR", 0600, parent, (u32 *)0xFFC00EC4);
		debugfs_create_x16("MDMA0_S1_X_COUNT", 0600, parent, (u16 *)0xFFC00ED0);
		debugfs_create_x16("MDMA0_S1_X_MODIFY", 0600, parent, (u16 *)0xFFC00ED4);
		debugfs_create_x16("MDMA0_S1_Y_COUNT", 0600, parent, (u16 *)0xFFC00ED8);
		debugfs_create_x16("MDMA0_S1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00EDC);

		parent = debugfs_create_dir("MEMDMA1 Destination0 Registers", top);
		debugfs_create_x16("MDMA1_D0_CONFIG", 0600, parent, (u16 *)0xFFC01F08);
		debugfs_create_x32("MDMA1_D0_CURR_ADDR", 0600, parent, (u32 *)0xFFC01F24);
		debugfs_create_x32("MDMA1_D0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01F20);
		debugfs_create_x16("MDMA1_D0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01F30);
		debugfs_create_x16("MDMA1_D0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01F38);
		debugfs_create_x16("MDMA1_D0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01F28);
		debugfs_create_x32("MDMA1_D0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01F00);
		debugfs_create_x16("MDMA1_D0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01F2C);
		debugfs_create_x32("MDMA1_D0_START_ADDR", 0600, parent, (u32 *)0xFFC01F04);
		debugfs_create_x16("MDMA1_D0_X_COUNT", 0600, parent, (u16 *)0xFFC01F10);
		debugfs_create_x16("MDMA1_D0_X_MODIFY", 0600, parent, (u16 *)0xFFC01F14);
		debugfs_create_x16("MDMA1_D0_Y_COUNT", 0600, parent, (u16 *)0xFFC01F18);
		debugfs_create_x16("MDMA1_D0_Y_MODIFY", 0600, parent, (u16 *)0xFFC01F1C);

		parent = debugfs_create_dir("MEMDMA1 Destination1 Registers", top);
		debugfs_create_x16("MDMA1_D1_CONFIG", 0600, parent, (u16 *)0xFFC01F88);
		debugfs_create_x32("MDMA1_D1_CURR_ADDR", 0600, parent, (u32 *)0xFFC01FA4);
		debugfs_create_x32("MDMA1_D1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01FA0);
		debugfs_create_x16("MDMA1_D1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01FB0);
		debugfs_create_x16("MDMA1_D1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01FB8);
		debugfs_create_x16("MDMA1_D1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01FA8);
		debugfs_create_x32("MDMA1_D1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01F80);
		debugfs_create_x16("MDMA1_D1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01FAC);
		debugfs_create_x32("MDMA1_D1_START_ADDR", 0600, parent, (u32 *)0xFFC01F84);
		debugfs_create_x16("MDMA1_D1_X_COUNT", 0600, parent, (u16 *)0xFFC01F90);
		debugfs_create_x16("MDMA1_D1_X_MODIFY", 0600, parent, (u16 *)0xFFC01F94);
		debugfs_create_x16("MDMA1_D1_Y_COUNT", 0600, parent, (u16 *)0xFFC01F98);
		debugfs_create_x16("MDMA1_D1_Y_MODIFY", 0600, parent, (u16 *)0xFFC01F9C);

		parent = debugfs_create_dir("MEMDMA1 Source0 Registers", top);
		debugfs_create_x16("MDMA1_S0_CONFIG", 0600, parent, (u16 *)0xFFC01F48);
		debugfs_create_x32("MDMA1_S0_CURR_ADDR", 0600, parent, (u32 *)0xFFC01F64);
		debugfs_create_x32("MDMA1_S0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01F60);
		debugfs_create_x16("MDMA1_S0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01F70);
		debugfs_create_x16("MDMA1_S0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01F78);
		debugfs_create_x16("MDMA1_S0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01F68);
		debugfs_create_x32("MDMA1_S0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01F40);
		debugfs_create_x16("MDMA1_S0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01F6C);
		debugfs_create_x32("MDMA1_S0_START_ADDR", 0600, parent, (u32 *)0xFFC01F44);
		debugfs_create_x16("MDMA1_S0_X_COUNT", 0600, parent, (u16 *)0xFFC01F50);
		debugfs_create_x16("MDMA1_S0_X_MODIFY", 0600, parent, (u16 *)0xFFC01F54);
		debugfs_create_x16("MDMA1_S0_Y_COUNT", 0600, parent, (u16 *)0xFFC01F58);
		debugfs_create_x16("MDMA1_S0_Y_MODIFY", 0600, parent, (u16 *)0xFFC01F5C);

		parent = debugfs_create_dir("MEMDMA1 Source1 Registers", top);
		debugfs_create_x16("MDMA1_S1_CONFIG", 0600, parent, (u16 *)0xFFC01FC8);
		debugfs_create_x32("MDMA1_S1_CURR_ADDR", 0600, parent, (u32 *)0xFFC01FE4);
		debugfs_create_x32("MDMA1_S1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01FE0);
		debugfs_create_x16("MDMA1_S1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01FF0);
		debugfs_create_x16("MDMA1_S1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01FF8);
		debugfs_create_x16("MDMA1_S1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01FE8);
		debugfs_create_x32("MDMA1_S1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01FC0);
		debugfs_create_x16("MDMA1_S1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01FEC);
		debugfs_create_x32("MDMA1_S1_START_ADDR", 0600, parent, (u32 *)0xFFC01FC4);
		debugfs_create_x16("MDMA1_S1_X_COUNT", 0600, parent, (u16 *)0xFFC01FD0);
		debugfs_create_x16("MDMA1_S1_X_MODIFY", 0600, parent, (u16 *)0xFFC01FD4);
		debugfs_create_x16("MDMA1_S1_Y_COUNT", 0600, parent, (u16 *)0xFFC01FD8);
		debugfs_create_x16("MDMA1_S1_Y_MODIFY", 0600, parent, (u16 *)0xFFC01FDC);

		parent = debugfs_create_dir("MXVR Registers", top);
		debugfs_create_x32("MXVR_AADDR", 0600, parent, (u32 *)0xFFC02738);
		debugfs_create_x32("MXVR_ALLOC_0", 0600, parent, (u32 *)0xFFC0273C);
		debugfs_create_x32("MXVR_ALLOC_10", 0600, parent, (u32 *)0xFFC02764);
		debugfs_create_x32("MXVR_ALLOC_11", 0600, parent, (u32 *)0xFFC02768);
		debugfs_create_x32("MXVR_ALLOC_12", 0600, parent, (u32 *)0xFFC0276C);
		debugfs_create_x32("MXVR_ALLOC_13", 0600, parent, (u32 *)0xFFC02770);
		debugfs_create_x32("MXVR_ALLOC_14", 0600, parent, (u32 *)0xFFC02774);
		debugfs_create_x32("MXVR_ALLOC_1", 0600, parent, (u32 *)0xFFC02740);
		debugfs_create_x32("MXVR_ALLOC_2", 0600, parent, (u32 *)0xFFC02744);
		debugfs_create_x32("MXVR_ALLOC_3", 0600, parent, (u32 *)0xFFC02748);
		debugfs_create_x32("MXVR_ALLOC_4", 0600, parent, (u32 *)0xFFC0274C);
		debugfs_create_x32("MXVR_ALLOC_5", 0600, parent, (u32 *)0xFFC02750);
		debugfs_create_x32("MXVR_ALLOC_6", 0600, parent, (u32 *)0xFFC02754);
		debugfs_create_x32("MXVR_ALLOC_7", 0600, parent, (u32 *)0xFFC02758);
		debugfs_create_x32("MXVR_ALLOC_8", 0600, parent, (u32 *)0xFFC0275C);
		debugfs_create_x32("MXVR_ALLOC_9", 0600, parent, (u32 *)0xFFC02760);
		debugfs_create_x32("MXVR_APRB_CURR_ADDR", 0600, parent, (u32 *)0xFFC02840);
		debugfs_create_x32("MXVR_APRB_START_ADDR", 0600, parent, (u32 *)0xFFC0283C);
		debugfs_create_x32("MXVR_APTB_CURR_ADDR", 0600, parent, (u32 *)0xFFC02848);
		debugfs_create_x32("MXVR_APTB_START_ADDR", 0600, parent, (u32 *)0xFFC02844);
		debugfs_create_x16("MXVR_AP_CTL", 0600, parent, (u16 *)0xFFC02838);
		debugfs_create_x16("MXVR_BLOCK_CNT", 0600, parent, (u16 *)0xFFC028C0);
		debugfs_create_x32("MXVR_CMRB_CURR_ADDR", 0600, parent, (u32 *)0xFFC02854);
		debugfs_create_x32("MXVR_CMRB_START_ADDR", 0600, parent, (u32 *)0xFFC02850);
		debugfs_create_x32("MXVR_CMTB_CURR_ADDR", 0600, parent, (u32 *)0xFFC0285C);
		debugfs_create_x32("MXVR_CMTB_START_ADDR", 0600, parent, (u32 *)0xFFC02858);
		debugfs_create_x32("MXVR_CM_CTL", 0600, parent, (u32 *)0xFFC0284C);
		debugfs_create_x16("MXVR_CONFIG", 0600, parent, (u16 *)0xFFC02700);
		debugfs_create_x16("MXVR_DELAY", 0600, parent, (u16 *)0xFFC02728);
		debugfs_create_x32("MXVR_DMA0_CONFIG", 0600, parent, (u32 *)0xFFC02798);
		debugfs_create_x16("MXVR_DMA0_COUNT", 0600, parent, (u16 *)0xFFC027A0);
		debugfs_create_x32("MXVR_DMA0_CURR_ADDR", 0600, parent, (u32 *)0xFFC027A4);
		debugfs_create_x16("MXVR_DMA0_CURR_COUNT", 0600, parent, (u16 *)0xFFC027A8);
		debugfs_create_x32("MXVR_DMA0_START_ADDR", 0600, parent, (u32 *)0xFFC0279C);
		debugfs_create_x32("MXVR_DMA1_CONFIG", 0600, parent, (u32 *)0xFFC027AC);
		debugfs_create_x16("MXVR_DMA1_COUNT", 0600, parent, (u16 *)0xFFC027B4);
		debugfs_create_x32("MXVR_DMA1_CURR_ADDR", 0600, parent, (u32 *)0xFFC027B8);
		debugfs_create_x16("MXVR_DMA1_CURR_COUNT", 0600, parent, (u16 *)0xFFC027BC);
		debugfs_create_x32("MXVR_DMA1_START_ADDR", 0600, parent, (u32 *)0xFFC027B0);
		debugfs_create_x32("MXVR_DMA2_CONFIG", 0600, parent, (u32 *)0xFFC027C0);
		debugfs_create_x16("MXVR_DMA2_COUNT", 0600, parent, (u16 *)0xFFC027C8);
		debugfs_create_x32("MXVR_DMA2_CURR_ADDR", 0600, parent, (u32 *)0xFFC027CC);
		debugfs_create_x16("MXVR_DMA2_CURR_COUNT", 0600, parent, (u16 *)0xFFC027D0);
		debugfs_create_x32("MXVR_DMA2_START_ADDR", 0600, parent, (u32 *)0xFFC027C4);
		debugfs_create_x32("MXVR_DMA3_CONFIG", 0600, parent, (u32 *)0xFFC027D4);
		debugfs_create_x16("MXVR_DMA3_COUNT", 0600, parent, (u16 *)0xFFC027DC);
		debugfs_create_x32("MXVR_DMA3_CURR_ADDR", 0600, parent, (u32 *)0xFFC027E0);
		debugfs_create_x16("MXVR_DMA3_CURR_COUNT", 0600, parent, (u16 *)0xFFC027E4);
		debugfs_create_x32("MXVR_DMA3_START_ADDR", 0600, parent, (u32 *)0xFFC027D8);
		debugfs_create_x32("MXVR_DMA4_CONFIG", 0600, parent, (u32 *)0xFFC027E8);
		debugfs_create_x16("MXVR_DMA4_COUNT", 0600, parent, (u16 *)0xFFC027F0);
		debugfs_create_x32("MXVR_DMA4_CURR_ADDR", 0600, parent, (u32 *)0xFFC027F4);
		debugfs_create_x16("MXVR_DMA4_CURR_COUNT", 0600, parent, (u16 *)0xFFC027F8);
		debugfs_create_x32("MXVR_DMA4_START_ADDR", 0600, parent, (u32 *)0xFFC027EC);
		debugfs_create_x32("MXVR_DMA5_CONFIG", 0600, parent, (u32 *)0xFFC027FC);
		debugfs_create_x16("MXVR_DMA5_COUNT", 0600, parent, (u16 *)0xFFC02804);
		debugfs_create_x32("MXVR_DMA5_CURR_ADDR", 0600, parent, (u32 *)0xFFC02808);
		debugfs_create_x16("MXVR_DMA5_CURR_COUNT", 0600, parent, (u16 *)0xFFC0280C);
		debugfs_create_x32("MXVR_DMA5_START_ADDR", 0600, parent, (u32 *)0xFFC02800);
		debugfs_create_x32("MXVR_DMA6_CONFIG", 0600, parent, (u32 *)0xFFC02810);
		debugfs_create_x16("MXVR_DMA6_COUNT", 0600, parent, (u16 *)0xFFC02818);
		debugfs_create_x32("MXVR_DMA6_CURR_ADDR", 0600, parent, (u32 *)0xFFC0281C);
		debugfs_create_x16("MXVR_DMA6_CURR_COUNT", 0600, parent, (u16 *)0xFFC02820);
		debugfs_create_x32("MXVR_DMA6_START_ADDR", 0600, parent, (u32 *)0xFFC02814);
		debugfs_create_x32("MXVR_DMA7_CONFIG", 0600, parent, (u32 *)0xFFC02824);
		debugfs_create_x16("MXVR_DMA7_COUNT", 0600, parent, (u16 *)0xFFC0282C);
		debugfs_create_x32("MXVR_DMA7_CURR_ADDR", 0600, parent, (u32 *)0xFFC02830);
		debugfs_create_x16("MXVR_DMA7_CURR_COUNT", 0600, parent, (u16 *)0xFFC02834);
		debugfs_create_x32("MXVR_DMA7_START_ADDR", 0600, parent, (u32 *)0xFFC02828);
		debugfs_create_x16("MXVR_FRAME_CNT_0", 0600, parent, (u16 *)0xFFC02878);
		debugfs_create_x16("MXVR_FRAME_CNT_1", 0600, parent, (u16 *)0xFFC0287C);
		debugfs_create_x16("MXVR_GADDR", 0600, parent, (u16 *)0xFFC02734);
		debugfs_create_x32("MXVR_INT_EN_0", 0600, parent, (u32 *)0xFFC02718);
		debugfs_create_x32("MXVR_INT_EN_1", 0600, parent, (u32 *)0xFFC0271C);
		debugfs_create_x32("MXVR_INT_STAT_0", 0600, parent, (u32 *)0xFFC02710);
		debugfs_create_x32("MXVR_INT_STAT_1", 0600, parent, (u32 *)0xFFC02714);
		debugfs_create_x32("MXVR_LADDR", 0600, parent, (u32 *)0xFFC02730);
		debugfs_create_x16("MXVR_MAX_DELAY", 0600, parent, (u16 *)0xFFC0272C);
		debugfs_create_x16("MXVR_MAX_POSITION", 0600, parent, (u16 *)0xFFC02724);
		debugfs_create_x32("MXVR_PAT_DATA_0", 0600, parent, (u32 *)0xFFC02868);
		debugfs_create_x32("MXVR_PAT_DATA_1", 0600, parent, (u32 *)0xFFC02870);
		debugfs_create_x32("MXVR_PAT_EN_0", 0600, parent, (u32 *)0xFFC0286C);
		debugfs_create_x32("MXVR_PAT_EN_1", 0600, parent, (u32 *)0xFFC02874);
		debugfs_create_x32("MXVR_PLL_CTL_0", 0600, parent, (u32 *)0xFFC02704);
		debugfs_create_x32("MXVR_PLL_CTL_1", 0600, parent, (u32 *)0xFFC028BC);
		debugfs_create_x16("MXVR_POSITION", 0600, parent, (u16 *)0xFFC02720);
		debugfs_create_x32("MXVR_ROUTING_0", 0600, parent, (u32 *)0xFFC02880);
		debugfs_create_x32("MXVR_ROUTING_10", 0600, parent, (u32 *)0xFFC028A8);
		debugfs_create_x32("MXVR_ROUTING_11", 0600, parent, (u32 *)0xFFC028AC);
		debugfs_create_x32("MXVR_ROUTING_12", 0600, parent, (u32 *)0xFFC028B0);
		debugfs_create_x32("MXVR_ROUTING_13", 0600, parent, (u32 *)0xFFC028B4);
		debugfs_create_x32("MXVR_ROUTING_14", 0600, parent, (u32 *)0xFFC028B8);
		debugfs_create_x32("MXVR_ROUTING_1", 0600, parent, (u32 *)0xFFC02884);
		debugfs_create_x32("MXVR_ROUTING_2", 0600, parent, (u32 *)0xFFC02888);
		debugfs_create_x32("MXVR_ROUTING_3", 0600, parent, (u32 *)0xFFC0288C);
		debugfs_create_x32("MXVR_ROUTING_4", 0600, parent, (u32 *)0xFFC02890);
		debugfs_create_x32("MXVR_ROUTING_5", 0600, parent, (u32 *)0xFFC02894);
		debugfs_create_x32("MXVR_ROUTING_6", 0600, parent, (u32 *)0xFFC02898);
		debugfs_create_x32("MXVR_ROUTING_7", 0600, parent, (u32 *)0xFFC0289C);
		debugfs_create_x32("MXVR_ROUTING_8", 0600, parent, (u32 *)0xFFC028A0);
		debugfs_create_x32("MXVR_ROUTING_9", 0600, parent, (u32 *)0xFFC028A4);
		debugfs_create_x32("MXVR_RRDB_CURR_ADDR", 0600, parent, (u32 *)0xFFC02864);
		debugfs_create_x32("MXVR_RRDB_START_ADDR", 0600, parent, (u32 *)0xFFC02860);
		debugfs_create_x32("MXVR_STATE_0", 0600, parent, (u32 *)0xFFC02708);
		debugfs_create_x32("MXVR_STATE_1", 0600, parent, (u32 *)0xFFC0270C);
		debugfs_create_x32("MXVR_SYNC_LCHAN_0", 0600, parent, (u32 *)0xFFC02778);
		debugfs_create_x32("MXVR_SYNC_LCHAN_1", 0600, parent, (u32 *)0xFFC0277C);
		debugfs_create_x32("MXVR_SYNC_LCHAN_2", 0600, parent, (u32 *)0xFFC02780);
		debugfs_create_x32("MXVR_SYNC_LCHAN_3", 0600, parent, (u32 *)0xFFC02784);
		debugfs_create_x32("MXVR_SYNC_LCHAN_4", 0600, parent, (u32 *)0xFFC02788);
		debugfs_create_x32("MXVR_SYNC_LCHAN_5", 0600, parent, (u32 *)0xFFC0278C);
		debugfs_create_x32("MXVR_SYNC_LCHAN_6", 0600, parent, (u32 *)0xFFC02790);
		debugfs_create_x32("MXVR_SYNC_LCHAN_7", 0600, parent, (u32 *)0xFFC02794);

		parent = debugfs_create_dir("PLL", top);
		debugfs_create_x16("PLL_CTL", 0600, parent, (u16 *)0xFFC00000);
		debugfs_create_x16("PLL_DIV", 0600, parent, (u16 *)0xFFC00004);
		debugfs_create_x16("PLL_LOCKCNT", 0600, parent, (u16 *)0xFFC00010);
		debugfs_create_x16("PLL_STAT", 0600, parent, (u16 *)0xFFC0000C);
		debugfs_create_x16("VR_CTL", 0600, parent, (u16 *)0xFFC00008);

		parent = debugfs_create_dir("PPI", top);
		debugfs_create_x16("PPI_CONTROL", 0600, parent, (u16 *)0xFFC01000);
		debugfs_create_x16("PPI_COUNT", 0600, parent, (u16 *)0xFFC01008);
		debugfs_create_x16("PPI_DELAY", 0600, parent, (u16 *)0xFFC0100C);
		debugfs_create_x16("PPI_FRAME", 0600, parent, (u16 *)0xFFC01010);
		debugfs_create_x16("PPI_STATUS", 0600, parent, (u16 *)0xFFC01004);

		parent = debugfs_create_dir("Performance Monitor", top);
		debugfs_create_x32("PFCNTR0", 0600, parent, (u32 *)0xFFE08100);
		debugfs_create_x32("PFCNTR1", 0600, parent, (u32 *)0xFFE08104);
		debugfs_create_x32("PFCTL", 0600, parent, (u32 *)0xFFE08000);

		parent = debugfs_create_dir("Programmable Flag Registers", top);
		debugfs_create_x16("FIO_BOTH", 0600, parent, (u16 *)0xFFC0073C);
		debugfs_create_x16("FIO_DIR", 0600, parent, (u16 *)0xFFC00730);
		debugfs_create_x16("FIO_EDGE", 0600, parent, (u16 *)0xFFC00738);
		debugfs_create_x16("FIO_FLAG_C", 0600, parent, (u16 *)0xFFC00704);
		debugfs_create_x16("FIO_FLAG_D", 0600, parent, (u16 *)0xFFC00700);
		debugfs_create_x16("FIO_FLAG_S", 0600, parent, (u16 *)0xFFC00708);
		debugfs_create_x16("FIO_FLAG_T", 0600, parent, (u16 *)0xFFC0070C);
		debugfs_create_x16("FIO_INEN", 0600, parent, (u16 *)0xFFC00740);
		debugfs_create_x16("FIO_MASKA_C", 0600, parent, (u16 *)0xFFC00714);
		debugfs_create_x16("FIO_MASKA_D", 0600, parent, (u16 *)0xFFC00710);
		debugfs_create_x16("FIO_MASKA_S", 0600, parent, (u16 *)0xFFC00718);
		debugfs_create_x16("FIO_MASKA_T", 0600, parent, (u16 *)0xFFC0071C);
		debugfs_create_x16("FIO_MASKB_C", 0600, parent, (u16 *)0xFFC00724);
		debugfs_create_x16("FIO_MASKB_D", 0600, parent, (u16 *)0xFFC00720);
		debugfs_create_x16("FIO_MASKB_S", 0600, parent, (u16 *)0xFFC00728);
		debugfs_create_x16("FIO_MASKB_T", 0600, parent, (u16 *)0xFFC0072C);
		debugfs_create_x16("FIO_POLAR", 0600, parent, (u16 *)0xFFC00734);

		parent = debugfs_create_dir("RTC", top);
		debugfs_create_x32("RTC_ALARM", 0600, parent, (u32 *)0xFFC00310);
		debugfs_create_x16("RTC_ICTL", 0600, parent, (u16 *)0xFFC00304);
		debugfs_create_x16("RTC_ISTAT", 0600, parent, (u16 *)0xFFC00308);
		debugfs_create_x16("RTC_PREN", 0600, parent, (u16 *)0xFFC00314);
		debugfs_create_x32("RTC_STAT", 0600, parent, (u32 *)0xFFC00300);
		debugfs_create_x16("RTC_SWCNT", 0600, parent, (u16 *)0xFFC0030C);

		parent = debugfs_create_dir("SPI", top);
		debugfs_create_x16("SPI0_BAUD", 0600, parent, (u16 *)0xFFC00514);
		debugfs_create_x16("SPI0_CTL", 0600, parent, (u16 *)0xFFC00500);
		debugfs_create_x16("SPI0_FLG", 0600, parent, (u16 *)0xFFC00504);
		debugfs_create_x16("SPI0_RDBR", 0600, parent, (u16 *)0xFFC00510);
		debugfs_create_x16("SPI0_SHADOW", 0600, parent, (u16 *)0xFFC00518);
		debugfs_create_x16("SPI0_STAT", 0600, parent, (u16 *)0xFFC00508);
		debugfs_create_x16("SPI0_TDBR", 0600, parent, (u16 *)0xFFC0050C);
		debugfs_create_x16("SPI1_BAUD", 0600, parent, (u16 *)0xFFC02314);
		debugfs_create_x16("SPI1_CTL", 0600, parent, (u16 *)0xFFC02300);
		debugfs_create_x16("SPI1_FLG", 0600, parent, (u16 *)0xFFC02304);
		debugfs_create_x16("SPI1_RDBR", 0600, parent, (u16 *)0xFFC02310);
		debugfs_create_x16("SPI1_SHADOW", 0600, parent, (u16 *)0xFFC02318);
		debugfs_create_x16("SPI1_STAT", 0600, parent, (u16 *)0xFFC02308);
		debugfs_create_x16("SPI1_TDBR", 0600, parent, (u16 *)0xFFC0230C);
		debugfs_create_x16("SPI2_BAUD", 0600, parent, (u16 *)0xFFC02414);
		debugfs_create_x16("SPI2_CTL", 0600, parent, (u16 *)0xFFC02400);
		debugfs_create_x16("SPI2_FLG", 0600, parent, (u16 *)0xFFC02404);
		debugfs_create_x16("SPI2_RDBR", 0600, parent, (u16 *)0xFFC02410);
		debugfs_create_x16("SPI2_SHADOW", 0600, parent, (u16 *)0xFFC02418);
		debugfs_create_x16("SPI2_STAT", 0600, parent, (u16 *)0xFFC02408);
		debugfs_create_x16("SPI2_TDBR", 0600, parent, (u16 *)0xFFC0240C);

		parent = debugfs_create_dir("SPORT", top);
		debugfs_create_x16("SPORT0_CHNL", 0600, parent, (u16 *)0xFFC00834);
		debugfs_create_x16("SPORT0_MCMC1", 0600, parent, (u16 *)0xFFC00838);
		debugfs_create_x16("SPORT0_MCMC2", 0600, parent, (u16 *)0xFFC0083C);
		debugfs_create_x32("SPORT0_MRCS0", 0600, parent, (u32 *)0xFFC00850);
		debugfs_create_x32("SPORT0_MRCS1", 0600, parent, (u32 *)0xFFC00854);
		debugfs_create_x32("SPORT0_MRCS2", 0600, parent, (u32 *)0xFFC00858);
		debugfs_create_x32("SPORT0_MRCS3", 0600, parent, (u32 *)0xFFC0085C);
		debugfs_create_x32("SPORT0_MTCS0", 0600, parent, (u32 *)0xFFC00840);
		debugfs_create_x32("SPORT0_MTCS1", 0600, parent, (u32 *)0xFFC00844);
		debugfs_create_x32("SPORT0_MTCS2", 0600, parent, (u32 *)0xFFC00848);
		debugfs_create_x32("SPORT0_MTCS3", 0600, parent, (u32 *)0xFFC0084C);
		debugfs_create_x16("SPORT0_RCLKDIV", 0600, parent, (u16 *)0xFFC00828);
		debugfs_create_x16("SPORT0_RCR1", 0600, parent, (u16 *)0xFFC00820);
		debugfs_create_x16("SPORT0_RCR2", 0600, parent, (u16 *)0xFFC00824);
		debugfs_create_x16("SPORT0_RFSDIV", 0600, parent, (u16 *)0xFFC0082C);
		debugfs_create_x32("SPORT0_RX", 0600, parent, (u32 *)0xFFC00818);
		debugfs_create_x16("SPORT0_STAT", 0600, parent, (u16 *)0xFFC00830);
		debugfs_create_x16("SPORT0_TCLKDIV", 0600, parent, (u16 *)0xFFC00808);
		debugfs_create_x16("SPORT0_TCR1", 0600, parent, (u16 *)0xFFC00800);
		debugfs_create_x16("SPORT0_TCR2", 0600, parent, (u16 *)0xFFC00804);
		debugfs_create_x16("SPORT0_TFSDIV", 0600, parent, (u16 *)0xFFC0080C);
		debugfs_create_x32("SPORT0_TX", 0600, parent, (u32 *)0xFFC00810);
		debugfs_create_x16("SPORT1_CHNL", 0600, parent, (u16 *)0xFFC00934);
		debugfs_create_x16("SPORT1_MCMC1", 0600, parent, (u16 *)0xFFC00938);
		debugfs_create_x16("SPORT1_MCMC2", 0600, parent, (u16 *)0xFFC0093C);
		debugfs_create_x32("SPORT1_MRCS0", 0600, parent, (u32 *)0xFFC00950);
		debugfs_create_x32("SPORT1_MRCS1", 0600, parent, (u32 *)0xFFC00954);
		debugfs_create_x32("SPORT1_MRCS2", 0600, parent, (u32 *)0xFFC00958);
		debugfs_create_x32("SPORT1_MRCS3", 0600, parent, (u32 *)0xFFC0095C);
		debugfs_create_x32("SPORT1_MTCS0", 0600, parent, (u32 *)0xFFC00940);
		debugfs_create_x32("SPORT1_MTCS1", 0600, parent, (u32 *)0xFFC00944);
		debugfs_create_x32("SPORT1_MTCS2", 0600, parent, (u32 *)0xFFC00948);
		debugfs_create_x32("SPORT1_MTCS3", 0600, parent, (u32 *)0xFFC0094C);
		debugfs_create_x16("SPORT1_RCLKDIV", 0600, parent, (u16 *)0xFFC00928);
		debugfs_create_x16("SPORT1_RCR1", 0600, parent, (u16 *)0xFFC00920);
		debugfs_create_x16("SPORT1_RCR2", 0600, parent, (u16 *)0xFFC00924);
		debugfs_create_x16("SPORT1_RFSDIV", 0600, parent, (u16 *)0xFFC0092C);
		debugfs_create_x32("SPORT1_RX", 0600, parent, (u32 *)0xFFC00918);
		debugfs_create_x16("SPORT1_STAT", 0600, parent, (u16 *)0xFFC00930);
		debugfs_create_x16("SPORT1_TCLKDIV", 0600, parent, (u16 *)0xFFC00908);
		debugfs_create_x16("SPORT1_TCR1", 0600, parent, (u16 *)0xFFC00900);
		debugfs_create_x16("SPORT1_TCR2", 0600, parent, (u16 *)0xFFC00904);
		debugfs_create_x16("SPORT1_TFSDIV", 0600, parent, (u16 *)0xFFC0090C);
		debugfs_create_x32("SPORT1_TX", 0600, parent, (u32 *)0xFFC00910);
		debugfs_create_x16("SPORT2_CHNL", 0600, parent, (u16 *)0xFFC02534);
		debugfs_create_x16("SPORT2_MCMC1", 0600, parent, (u16 *)0xFFC02538);
		debugfs_create_x16("SPORT2_MCMC2", 0600, parent, (u16 *)0xFFC0253C);
		debugfs_create_x32("SPORT2_MRCS0", 0600, parent, (u32 *)0xFFC02550);
		debugfs_create_x32("SPORT2_MRCS1", 0600, parent, (u32 *)0xFFC02554);
		debugfs_create_x32("SPORT2_MRCS2", 0600, parent, (u32 *)0xFFC02558);
		debugfs_create_x32("SPORT2_MRCS3", 0600, parent, (u32 *)0xFFC0255C);
		debugfs_create_x32("SPORT2_MTCS0", 0600, parent, (u32 *)0xFFC02540);
		debugfs_create_x32("SPORT2_MTCS1", 0600, parent, (u32 *)0xFFC02544);
		debugfs_create_x32("SPORT2_MTCS2", 0600, parent, (u32 *)0xFFC02548);
		debugfs_create_x32("SPORT2_MTCS3", 0600, parent, (u32 *)0xFFC0254C);
		debugfs_create_x16("SPORT2_RCLKDIV", 0600, parent, (u16 *)0xFFC02528);
		debugfs_create_x16("SPORT2_RCR1", 0600, parent, (u16 *)0xFFC02520);
		debugfs_create_x16("SPORT2_RCR2", 0600, parent, (u16 *)0xFFC02524);
		debugfs_create_x16("SPORT2_RFSDIV", 0600, parent, (u16 *)0xFFC0252C);
		debugfs_create_x32("SPORT2_RX", 0600, parent, (u32 *)0xFFC02518);
		debugfs_create_x16("SPORT2_STAT", 0600, parent, (u16 *)0xFFC02530);
		debugfs_create_x16("SPORT2_TCLKDIV", 0600, parent, (u16 *)0xFFC02508);
		debugfs_create_x16("SPORT2_TCR1", 0600, parent, (u16 *)0xFFC02500);
		debugfs_create_x16("SPORT2_TCR2", 0600, parent, (u16 *)0xFFC02504);
		debugfs_create_x16("SPORT2_TFSDIV", 0600, parent, (u16 *)0xFFC0250C);
		debugfs_create_x32("SPORT2_TX", 0600, parent, (u32 *)0xFFC02510);
		debugfs_create_x16("SPORT3_CHNL", 0600, parent, (u16 *)0xFFC02634);
		debugfs_create_x16("SPORT3_MCMC1", 0600, parent, (u16 *)0xFFC02638);
		debugfs_create_x16("SPORT3_MCMC2", 0600, parent, (u16 *)0xFFC0263C);
		debugfs_create_x32("SPORT3_MRCS0", 0600, parent, (u32 *)0xFFC02650);
		debugfs_create_x32("SPORT3_MRCS1", 0600, parent, (u32 *)0xFFC02654);
		debugfs_create_x32("SPORT3_MRCS2", 0600, parent, (u32 *)0xFFC02658);
		debugfs_create_x32("SPORT3_MRCS3", 0600, parent, (u32 *)0xFFC0265C);
		debugfs_create_x32("SPORT3_MTCS0", 0600, parent, (u32 *)0xFFC02640);
		debugfs_create_x32("SPORT3_MTCS1", 0600, parent, (u32 *)0xFFC02644);
		debugfs_create_x32("SPORT3_MTCS2", 0600, parent, (u32 *)0xFFC02648);
		debugfs_create_x32("SPORT3_MTCS3", 0600, parent, (u32 *)0xFFC0264C);
		debugfs_create_x16("SPORT3_RCLKDIV", 0600, parent, (u16 *)0xFFC02628);
		debugfs_create_x16("SPORT3_RCR1", 0600, parent, (u16 *)0xFFC02620);
		debugfs_create_x16("SPORT3_RCR2", 0600, parent, (u16 *)0xFFC02624);
		debugfs_create_x16("SPORT3_RFSDIV", 0600, parent, (u16 *)0xFFC0262C);
		debugfs_create_x32("SPORT3_RX", 0600, parent, (u32 *)0xFFC02618);
		debugfs_create_x16("SPORT3_STAT", 0600, parent, (u16 *)0xFFC02630);
		debugfs_create_x16("SPORT3_TCLKDIV", 0600, parent, (u16 *)0xFFC02608);
		debugfs_create_x16("SPORT3_TCR1", 0600, parent, (u16 *)0xFFC02600);
		debugfs_create_x16("SPORT3_TCR2", 0600, parent, (u16 *)0xFFC02604);
		debugfs_create_x16("SPORT3_TFSDIV", 0600, parent, (u16 *)0xFFC0260C);
		debugfs_create_x32("SPORT3_TX", 0600, parent, (u32 *)0xFFC02610);

		parent = debugfs_create_dir("System Reset and Interrupt Control Registers", top);
		debugfs_create_x32("SIC_IAR0", 0600, parent, (u32 *)0xFFC00110);
		debugfs_create_x32("SIC_IAR1", 0600, parent, (u32 *)0xFFC00114);
		debugfs_create_x32("SIC_IAR2", 0600, parent, (u32 *)0xFFC00118);
		debugfs_create_x32("SIC_IAR3", 0600, parent, (u32 *)0xFFC0011C);
		debugfs_create_x32("SIC_IAR4", 0600, parent, (u32 *)0xFFC00134);
		debugfs_create_x32("SIC_IAR5", 0600, parent, (u32 *)0xFFC00138);
		debugfs_create_x32("SIC_IAR6", 0600, parent, (u32 *)0xFFC0013C);
		debugfs_create_x32("SIC_IMASK0", 0600, parent, (u32 *)0xFFC0010C);
		debugfs_create_x32("SIC_IMASK1", 0600, parent, (u32 *)0xFFC00128);
		debugfs_create_x32("SIC_ISR0", 0600, parent, (u32 *)0xFFC00120);
		debugfs_create_x32("SIC_ISR1", 0600, parent, (u32 *)0xFFC0012C);
		debugfs_create_x32("SIC_IWR0", 0600, parent, (u32 *)0xFFC00124);
		debugfs_create_x32("SIC_IWR1", 0600, parent, (u32 *)0xFFC00130);
		debugfs_create_x16("SIC_RVECT", 0600, parent, (u16 *)0xFFC00108);
		debugfs_create_x16("SWRST", 0600, parent, (u16 *)0xFFC00100);
		debugfs_create_x16("SYSCR", 0600, parent, (u16 *)0xFFC00104);

		parent = debugfs_create_dir("TWI", top);
		debugfs_create_x16("TWI0_CLKDIV", 0600, parent, (u16 *)0xFFC01400);
		debugfs_create_x16("TWI0_CONTROL", 0600, parent, (u16 *)0xFFC01404);
		debugfs_create_x16("TWI0_FIFO_CTRL", 0600, parent, (u16 *)0xFFC01428);
		debugfs_create_x16("TWI0_FIFO_STAT", 0600, parent, (u16 *)0xFFC0142C);
		debugfs_create_x16("TWI0_INT_MASK", 0600, parent, (u16 *)0xFFC01424);
		debugfs_create_x16("TWI0_INT_STAT", 0600, parent, (u16 *)0xFFC01420);
		debugfs_create_x16("TWI0_MASTER_ADDR", 0600, parent, (u16 *)0xFFC0141C);
		debugfs_create_x16("TWI0_MASTER_CTRL", 0600, parent, (u16 *)0xFFC01414);
		debugfs_create_x16("TWI0_MASTER_STAT", 0600, parent, (u16 *)0xFFC01418);
		debugfs_create_x16("TWI0_RCV_DATA16", 0600, parent, (u16 *)0xFFC0148C);
		debugfs_create_x16("TWI0_RCV_DATA8", 0600, parent, (u16 *)0xFFC01488);
		debugfs_create_x16("TWI0_SLAVE_ADDR", 0600, parent, (u16 *)0xFFC01410);
		debugfs_create_x16("TWI0_SLAVE_CTRL", 0600, parent, (u16 *)0xFFC01408);
		debugfs_create_x16("TWI0_SLAVE_STAT", 0600, parent, (u16 *)0xFFC0140C);
		debugfs_create_x16("TWI0_XMT_DATA16", 0600, parent, (u16 *)0xFFC01484);
		debugfs_create_x16("TWI0_XMT_DATA8", 0600, parent, (u16 *)0xFFC01480);
		debugfs_create_x16("TWI1_CLKDIV", 0600, parent, (u16 *)0xFFC02200);
		debugfs_create_x16("TWI1_CONTROL", 0600, parent, (u16 *)0xFFC02204);
		debugfs_create_x16("TWI1_FIFO_CTRL", 0600, parent, (u16 *)0xFFC02228);
		debugfs_create_x16("TWI1_FIFO_STAT", 0600, parent, (u16 *)0xFFC0222C);
		debugfs_create_x16("TWI1_INT_MASK", 0600, parent, (u16 *)0xFFC02224);
		debugfs_create_x16("TWI1_INT_STAT", 0600, parent, (u16 *)0xFFC02220);
		debugfs_create_x16("TWI1_MASTER_ADDR", 0600, parent, (u16 *)0xFFC0221C);
		debugfs_create_x16("TWI1_MASTER_CTRL", 0600, parent, (u16 *)0xFFC02214);
		debugfs_create_x16("TWI1_MASTER_STAT", 0600, parent, (u16 *)0xFFC02218);
		debugfs_create_x16("TWI1_RCV_DATA16", 0600, parent, (u16 *)0xFFC0228C);
		debugfs_create_x16("TWI1_RCV_DATA8", 0600, parent, (u16 *)0xFFC02288);
		debugfs_create_x16("TWI1_SLAVE_ADDR", 0600, parent, (u16 *)0xFFC02210);
		debugfs_create_x16("TWI1_SLAVE_CTRL", 0600, parent, (u16 *)0xFFC02208);
		debugfs_create_x16("TWI1_SLAVE_STAT", 0600, parent, (u16 *)0xFFC0220C);
		debugfs_create_x16("TWI1_XMT_DATA16", 0600, parent, (u16 *)0xFFC02284);
		debugfs_create_x16("TWI1_XMT_DATA8", 0600, parent, (u16 *)0xFFC02280);

		parent = debugfs_create_dir("Timer Registers", top);
		debugfs_create_x16("TIMER0_CONFIG", 0600, parent, (u16 *)0xFFC00600);
		debugfs_create_x32("TIMER0_COUNTER", 0600, parent, (u32 *)0xFFC00604);
		debugfs_create_x32("TIMER0_PERIOD", 0600, parent, (u32 *)0xFFC00608);
		debugfs_create_x32("TIMER0_WIDTH", 0600, parent, (u32 *)0xFFC0060C);
		debugfs_create_x16("TIMER1_CONFIG", 0600, parent, (u16 *)0xFFC00610);
		debugfs_create_x32("TIMER1_COUNTER", 0600, parent, (u32 *)0xFFC00614);
		debugfs_create_x32("TIMER1_PERIOD", 0600, parent, (u32 *)0xFFC00618);
		debugfs_create_x32("TIMER1_WIDTH", 0600, parent, (u32 *)0xFFC0061C);
		debugfs_create_x16("TIMER2_CONFIG", 0600, parent, (u16 *)0xFFC00620);
		debugfs_create_x32("TIMER2_COUNTER", 0600, parent, (u32 *)0xFFC00624);
		debugfs_create_x32("TIMER2_PERIOD", 0600, parent, (u32 *)0xFFC00628);
		debugfs_create_x32("TIMER2_WIDTH", 0600, parent, (u32 *)0xFFC0062C);
		debugfs_create_x16("TIMER_DISABLE", 0600, parent, (u16 *)0xFFC00644);
		debugfs_create_x16("TIMER_ENABLE", 0600, parent, (u16 *)0xFFC00640);
		debugfs_create_x16("TIMER_STATUS", 0600, parent, (u16 *)0xFFC00648);

		parent = debugfs_create_dir("Trace Unit", top);
		debugfs_create_x32("TBUF", 0600, parent, (u32 *)0xFFE06100);
		debugfs_create_x32("TBUFCTL", 0600, parent, (u32 *)0xFFE06000);
		debugfs_create_x32("TBUFSTAT", 0600, parent, (u32 *)0xFFE06004);

		parent = debugfs_create_dir("UART", top);
		debugfs_create_x16("UART0_DLH", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART0_DLL", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART0_GCTL", 0600, parent, (u16 *)0xFFC00424);
		debugfs_create_x16("UART0_IER", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART0_IIR", 0600, parent, (u16 *)0xFFC00408);
		debugfs_create_x16("UART0_LCR", 0600, parent, (u16 *)0xFFC0040C);
		debugfs_create_x16("UART0_LSR", 0600, parent, (u16 *)0xFFC00414);
		debugfs_create_x16("UART0_MCR", 0600, parent, (u16 *)0xFFC00410);
		debugfs_create_x16("UART0_RBR", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART0_SCR", 0600, parent, (u16 *)0xFFC0041C);
		debugfs_create_x16("UART0_THR", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART1_DLH", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("UART1_DLL", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART1_GCTL", 0600, parent, (u16 *)0xFFC02024);
		debugfs_create_x16("UART1_IER", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("UART1_IIR", 0600, parent, (u16 *)0xFFC02008);
		debugfs_create_x16("UART1_LCR", 0600, parent, (u16 *)0xFFC0200C);
		debugfs_create_x16("UART1_LSR", 0600, parent, (u16 *)0xFFC02014);
		debugfs_create_x16("UART1_MCR", 0600, parent, (u16 *)0xFFC02010);
		debugfs_create_x16("UART1_RBR", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART1_SCR", 0600, parent, (u16 *)0xFFC0201C);
		debugfs_create_x16("UART1_THR", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART2_DLH", 0600, parent, (u16 *)0xFFC02104);
		debugfs_create_x16("UART2_DLL", 0600, parent, (u16 *)0xFFC02100);
		debugfs_create_x16("UART2_GCTL", 0600, parent, (u16 *)0xFFC02124);
		debugfs_create_x16("UART2_IER", 0600, parent, (u16 *)0xFFC02104);
		debugfs_create_x16("UART2_IIR", 0600, parent, (u16 *)0xFFC02108);
		debugfs_create_x16("UART2_LCR", 0600, parent, (u16 *)0xFFC0210C);
		debugfs_create_x16("UART2_LSR", 0600, parent, (u16 *)0xFFC02114);
		debugfs_create_x16("UART2_MCR", 0600, parent, (u16 *)0xFFC02110);
		debugfs_create_x16("UART2_RBR", 0600, parent, (u16 *)0xFFC02100);
		debugfs_create_x16("UART2_SCR", 0600, parent, (u16 *)0xFFC0211C);
		debugfs_create_x16("UART2_THR", 0600, parent, (u16 *)0xFFC02100);

		parent = debugfs_create_dir("Watchdog", top);
		debugfs_create_x32("WDOG_CNT", 0600, parent, (u32 *)0xFFC00204);
		debugfs_create_x16("WDOG_CTL", 0600, parent, (u16 *)0xFFC00200);
		debugfs_create_x32("WDOG_STAT", 0600, parent, (u32 *)0xFFC00208);

		parent = debugfs_create_dir("Watchpoint and Patch Unit", top);
		debugfs_create_x32("WPDA0", 0600, parent, (u32 *)0xFFE07140);
		debugfs_create_x32("WPDA1", 0600, parent, (u32 *)0xFFE07144);
		debugfs_create_x32("WPDACNT0", 0600, parent, (u32 *)0xFFE07180);
		debugfs_create_x32("WPDACNT1", 0600, parent, (u32 *)0xFFE07184);
		debugfs_create_x32("WPDACTL", 0600, parent, (u32 *)0xFFE07100);
		debugfs_create_x32("WPIA0", 0600, parent, (u32 *)0xFFE07040);
		debugfs_create_x32("WPIA1", 0600, parent, (u32 *)0xFFE07044);
		debugfs_create_x32("WPIA2", 0600, parent, (u32 *)0xFFE07048);
		debugfs_create_x32("WPIA3", 0600, parent, (u32 *)0xFFE0704C);
		debugfs_create_x32("WPIA4", 0600, parent, (u32 *)0xFFE07050);
		debugfs_create_x32("WPIA5", 0600, parent, (u32 *)0xFFE07054);
		debugfs_create_x32("WPIACNT0", 0600, parent, (u32 *)0xFFE07080);
		debugfs_create_x32("WPIACNT1", 0600, parent, (u32 *)0xFFE07084);
		debugfs_create_x32("WPIACNT2", 0600, parent, (u32 *)0xFFE07088);
		debugfs_create_x32("WPIACNT3", 0600, parent, (u32 *)0xFFE0708C);
		debugfs_create_x32("WPIACNT4", 0600, parent, (u32 *)0xFFE07090);
		debugfs_create_x32("WPIACNT5", 0600, parent, (u32 *)0xFFE07094);
		debugfs_create_x32("WPIACTL", 0600, parent, (u32 *)0xFFE07000);
		debugfs_create_x32("WPSTAT", 0600, parent, (u32 *)0xFFE07200);

	}	/* BF539 */

#ifdef __ADSPBF541__
# define USE_BF541 1
#else
# define USE_BF541 0
#endif
	if (USE_BF541) {

		parent = debugfs_create_dir("ATAPI", top);
		debugfs_create_x16("ATAPI_CONTROL", 0600, parent, (u16 *)0xFFC03800);
		debugfs_create_x16("ATAPI_DEV_ADDR", 0600, parent, (u16 *)0xFFC03808);
		debugfs_create_x16("ATAPI_DEV_RXBUF", 0600, parent, (u16 *)0xFFC03810);
		debugfs_create_x16("ATAPI_DEV_TXBUF", 0600, parent, (u16 *)0xFFC0380C);
		debugfs_create_x16("ATAPI_DMA_TFRCNT", 0600, parent, (u16 *)0xFFC03830);
		debugfs_create_x16("ATAPI_INT_MASK", 0600, parent, (u16 *)0xFFC03814);
		debugfs_create_x16("ATAPI_INT_STATUS", 0600, parent, (u16 *)0xFFC03818);
		debugfs_create_x16("ATAPI_LINE_STATUS", 0600, parent, (u16 *)0xFFC03820);
		debugfs_create_x16("ATAPI_MULTI_TIM_0", 0600, parent, (u16 *)0xFFC03850);
		debugfs_create_x16("ATAPI_MULTI_TIM_1", 0600, parent, (u16 *)0xFFC03854);
		debugfs_create_x16("ATAPI_MULTI_TIM_2", 0600, parent, (u16 *)0xFFC03858);
		debugfs_create_x16("ATAPI_PIO_TFRCNT", 0600, parent, (u16 *)0xFFC0382C);
		debugfs_create_x16("ATAPI_PIO_TIM_0", 0600, parent, (u16 *)0xFFC03844);
		debugfs_create_x16("ATAPI_PIO_TIM_1", 0600, parent, (u16 *)0xFFC03848);
		debugfs_create_x16("ATAPI_REG_TIM_0", 0600, parent, (u16 *)0xFFC03840);
		debugfs_create_x16("ATAPI_SM_STATE", 0600, parent, (u16 *)0xFFC03824);
		debugfs_create_x16("ATAPI_STATUS", 0600, parent, (u16 *)0xFFC03804);
		debugfs_create_x16("ATAPI_TERMINATE", 0600, parent, (u16 *)0xFFC03828);
		debugfs_create_x16("ATAPI_UDMAOUT_TFRCNT", 0600, parent, (u16 *)0xFFC03838);
		debugfs_create_x16("ATAPI_ULTRA_TIM_0", 0600, parent, (u16 *)0xFFC03860);
		debugfs_create_x16("ATAPI_ULTRA_TIM_1", 0600, parent, (u16 *)0xFFC03864);
		debugfs_create_x16("ATAPI_ULTRA_TIM_2", 0600, parent, (u16 *)0xFFC03868);
		debugfs_create_x16("ATAPI_ULTRA_TIM_3", 0600, parent, (u16 *)0xFFC0386C);
		debugfs_create_x16("ATAPI_UMAIN_TFRCNT", 0600, parent, (u16 *)0xFFC03834);
		debugfs_create_x16("ATAPI_XFER_LEN", 0600, parent, (u16 *)0xFFC0381C);

		parent = debugfs_create_dir("CAN0 Acceptance Mask RAM", top);
		debugfs_create_x16("CAN0_AM00H", 0600, parent, (u16 *)0xFFC02B04);
		debugfs_create_x16("CAN0_AM00L", 0600, parent, (u16 *)0xFFC02B00);
		debugfs_create_x16("CAN0_AM01H", 0600, parent, (u16 *)0xFFC02B0C);
		debugfs_create_x16("CAN0_AM01L", 0600, parent, (u16 *)0xFFC02B08);
		debugfs_create_x16("CAN0_AM02H", 0600, parent, (u16 *)0xFFC02B14);
		debugfs_create_x16("CAN0_AM02L", 0600, parent, (u16 *)0xFFC02B10);
		debugfs_create_x16("CAN0_AM03H", 0600, parent, (u16 *)0xFFC02B1C);
		debugfs_create_x16("CAN0_AM03L", 0600, parent, (u16 *)0xFFC02B18);
		debugfs_create_x16("CAN0_AM04H", 0600, parent, (u16 *)0xFFC02B24);
		debugfs_create_x16("CAN0_AM04L", 0600, parent, (u16 *)0xFFC02B20);
		debugfs_create_x16("CAN0_AM05H", 0600, parent, (u16 *)0xFFC02B2C);
		debugfs_create_x16("CAN0_AM05L", 0600, parent, (u16 *)0xFFC02B28);
		debugfs_create_x16("CAN0_AM06H", 0600, parent, (u16 *)0xFFC02B34);
		debugfs_create_x16("CAN0_AM06L", 0600, parent, (u16 *)0xFFC02B30);
		debugfs_create_x16("CAN0_AM07H", 0600, parent, (u16 *)0xFFC02B3C);
		debugfs_create_x16("CAN0_AM07L", 0600, parent, (u16 *)0xFFC02B38);
		debugfs_create_x16("CAN0_AM08H", 0600, parent, (u16 *)0xFFC02B44);
		debugfs_create_x16("CAN0_AM08L", 0600, parent, (u16 *)0xFFC02B40);
		debugfs_create_x16("CAN0_AM09H", 0600, parent, (u16 *)0xFFC02B4C);
		debugfs_create_x16("CAN0_AM09L", 0600, parent, (u16 *)0xFFC02B48);
		debugfs_create_x16("CAN0_AM10H", 0600, parent, (u16 *)0xFFC02B54);
		debugfs_create_x16("CAN0_AM10L", 0600, parent, (u16 *)0xFFC02B50);
		debugfs_create_x16("CAN0_AM11H", 0600, parent, (u16 *)0xFFC02B5C);
		debugfs_create_x16("CAN0_AM11L", 0600, parent, (u16 *)0xFFC02B58);
		debugfs_create_x16("CAN0_AM12H", 0600, parent, (u16 *)0xFFC02B64);
		debugfs_create_x16("CAN0_AM12L", 0600, parent, (u16 *)0xFFC02B60);
		debugfs_create_x16("CAN0_AM13H", 0600, parent, (u16 *)0xFFC02B6C);
		debugfs_create_x16("CAN0_AM13L", 0600, parent, (u16 *)0xFFC02B68);
		debugfs_create_x16("CAN0_AM14H", 0600, parent, (u16 *)0xFFC02B74);
		debugfs_create_x16("CAN0_AM14L", 0600, parent, (u16 *)0xFFC02B70);
		debugfs_create_x16("CAN0_AM15H", 0600, parent, (u16 *)0xFFC02B7C);
		debugfs_create_x16("CAN0_AM15L", 0600, parent, (u16 *)0xFFC02B78);
		debugfs_create_x16("CAN0_AM16H", 0600, parent, (u16 *)0xFFC02B84);
		debugfs_create_x16("CAN0_AM16L", 0600, parent, (u16 *)0xFFC02B80);
		debugfs_create_x16("CAN0_AM17H", 0600, parent, (u16 *)0xFFC02B8C);
		debugfs_create_x16("CAN0_AM17L", 0600, parent, (u16 *)0xFFC02B88);
		debugfs_create_x16("CAN0_AM18H", 0600, parent, (u16 *)0xFFC02B94);
		debugfs_create_x16("CAN0_AM18L", 0600, parent, (u16 *)0xFFC02B90);
		debugfs_create_x16("CAN0_AM19H", 0600, parent, (u16 *)0xFFC02B9C);
		debugfs_create_x16("CAN0_AM19L", 0600, parent, (u16 *)0xFFC02B98);
		debugfs_create_x16("CAN0_AM20H", 0600, parent, (u16 *)0xFFC02BA4);
		debugfs_create_x16("CAN0_AM20L", 0600, parent, (u16 *)0xFFC02BA0);
		debugfs_create_x16("CAN0_AM21H", 0600, parent, (u16 *)0xFFC02BAC);
		debugfs_create_x16("CAN0_AM21L", 0600, parent, (u16 *)0xFFC02BA8);
		debugfs_create_x16("CAN0_AM22H", 0600, parent, (u16 *)0xFFC02BB4);
		debugfs_create_x16("CAN0_AM22L", 0600, parent, (u16 *)0xFFC02BB0);
		debugfs_create_x16("CAN0_AM23H", 0600, parent, (u16 *)0xFFC02BBC);
		debugfs_create_x16("CAN0_AM23L", 0600, parent, (u16 *)0xFFC02BB8);
		debugfs_create_x16("CAN0_AM24H", 0600, parent, (u16 *)0xFFC02BC4);
		debugfs_create_x16("CAN0_AM24L", 0600, parent, (u16 *)0xFFC02BC0);
		debugfs_create_x16("CAN0_AM25H", 0600, parent, (u16 *)0xFFC02BCC);
		debugfs_create_x16("CAN0_AM25L", 0600, parent, (u16 *)0xFFC02BC8);
		debugfs_create_x16("CAN0_AM26H", 0600, parent, (u16 *)0xFFC02BD4);
		debugfs_create_x16("CAN0_AM26L", 0600, parent, (u16 *)0xFFC02BD0);
		debugfs_create_x16("CAN0_AM27H", 0600, parent, (u16 *)0xFFC02BDC);
		debugfs_create_x16("CAN0_AM27L", 0600, parent, (u16 *)0xFFC02BD8);
		debugfs_create_x16("CAN0_AM28H", 0600, parent, (u16 *)0xFFC02BE4);
		debugfs_create_x16("CAN0_AM28L", 0600, parent, (u16 *)0xFFC02BE0);
		debugfs_create_x16("CAN0_AM29H", 0600, parent, (u16 *)0xFFC02BEC);
		debugfs_create_x16("CAN0_AM29L", 0600, parent, (u16 *)0xFFC02BE8);
		debugfs_create_x16("CAN0_AM30H", 0600, parent, (u16 *)0xFFC02BF4);
		debugfs_create_x16("CAN0_AM30L", 0600, parent, (u16 *)0xFFC02BF0);
		debugfs_create_x16("CAN0_AM31H", 0600, parent, (u16 *)0xFFC02BFC);
		debugfs_create_x16("CAN0_AM31L", 0600, parent, (u16 *)0xFFC02BF8);

		parent = debugfs_create_dir("CAN0 Control and Status", top);
		debugfs_create_x16("CAN0_AA1", 0600, parent, (u16 *)0xFFC02A14);
		debugfs_create_x16("CAN0_AA2", 0600, parent, (u16 *)0xFFC02A54);
		debugfs_create_x16("CAN0_CEC", 0600, parent, (u16 *)0xFFC02A90);
		debugfs_create_x16("CAN0_CLOCK", 0600, parent, (u16 *)0xFFC02A80);
		debugfs_create_x16("CAN0_CONTROL", 0600, parent, (u16 *)0xFFC02AA0);
		debugfs_create_x16("CAN0_DEBUG", 0600, parent, (u16 *)0xFFC02A88);
		debugfs_create_x16("CAN0_ESR", 0600, parent, (u16 *)0xFFC02AB4);
		debugfs_create_x16("CAN0_EWR", 0600, parent, (u16 *)0xFFC02AB0);
		debugfs_create_x16("CAN0_GIF", 0600, parent, (u16 *)0xFFC02A9C);
		debugfs_create_x16("CAN0_GIM", 0600, parent, (u16 *)0xFFC02A98);
		debugfs_create_x16("CAN0_GIS", 0600, parent, (u16 *)0xFFC02A94);
		debugfs_create_x16("CAN0_INTR", 0600, parent, (u16 *)0xFFC02AA4);
		debugfs_create_x16("CAN0_MBIM1", 0600, parent, (u16 *)0xFFC02A28);
		debugfs_create_x16("CAN0_MBIM2", 0600, parent, (u16 *)0xFFC02A68);
		debugfs_create_x16("CAN0_MBRIF1", 0600, parent, (u16 *)0xFFC02A24);
		debugfs_create_x16("CAN0_MBRIF2", 0600, parent, (u16 *)0xFFC02A64);
		debugfs_create_x16("CAN0_MBTD", 0600, parent, (u16 *)0xFFC02AAC);
		debugfs_create_x16("CAN0_MBTIF1", 0600, parent, (u16 *)0xFFC02A20);
		debugfs_create_x16("CAN0_MBTIF2", 0600, parent, (u16 *)0xFFC02A60);
		debugfs_create_x16("CAN0_MC1", 0600, parent, (u16 *)0xFFC02A00);
		debugfs_create_x16("CAN0_MC2", 0600, parent, (u16 *)0xFFC02A40);
		debugfs_create_x16("CAN0_MD1", 0600, parent, (u16 *)0xFFC02A04);
		debugfs_create_x16("CAN0_MD2", 0600, parent, (u16 *)0xFFC02A44);
		debugfs_create_x16("CAN0_OPSS1", 0600, parent, (u16 *)0xFFC02A30);
		debugfs_create_x16("CAN0_OPSS2", 0600, parent, (u16 *)0xFFC02A70);
		debugfs_create_x16("CAN0_RFH1", 0600, parent, (u16 *)0xFFC02A2C);
		debugfs_create_x16("CAN0_RFH2", 0600, parent, (u16 *)0xFFC02A6C);
		debugfs_create_x16("CAN0_RML1", 0600, parent, (u16 *)0xFFC02A1C);
		debugfs_create_x16("CAN0_RML2", 0600, parent, (u16 *)0xFFC02A5C);
		debugfs_create_x16("CAN0_RMP1", 0600, parent, (u16 *)0xFFC02A18);
		debugfs_create_x16("CAN0_RMP2", 0600, parent, (u16 *)0xFFC02A58);
		debugfs_create_x16("CAN0_STATUS", 0600, parent, (u16 *)0xFFC02A8C);
		debugfs_create_x16("CAN0_TA1", 0600, parent, (u16 *)0xFFC02A10);
		debugfs_create_x16("CAN0_TA2", 0600, parent, (u16 *)0xFFC02A50);
		debugfs_create_x16("CAN0_TIMING", 0600, parent, (u16 *)0xFFC02A84);
		debugfs_create_x16("CAN0_TRR1", 0600, parent, (u16 *)0xFFC02A0C);
		debugfs_create_x16("CAN0_TRR2", 0600, parent, (u16 *)0xFFC02A4C);
		debugfs_create_x16("CAN0_TRS1", 0600, parent, (u16 *)0xFFC02A08);
		debugfs_create_x16("CAN0_TRS2", 0600, parent, (u16 *)0xFFC02A48);
		debugfs_create_x16("CAN0_UCCNF", 0600, parent, (u16 *)0xFFC02ACC);
		debugfs_create_x16("CAN0_UCCNT", 0600, parent, (u16 *)0xFFC02AC4);
		debugfs_create_x16("CAN0_UCRC", 0600, parent, (u16 *)0xFFC02AC8);

		parent = debugfs_create_dir("CAN0 Mailbox RAM", top);
		debugfs_create_x16("CAN0_MB00_DATA0", 0600, parent, (u16 *)0xFFC02C00);
		debugfs_create_x16("CAN0_MB00_DATA1", 0600, parent, (u16 *)0xFFC02C04);
		debugfs_create_x16("CAN0_MB00_DATA2", 0600, parent, (u16 *)0xFFC02C08);
		debugfs_create_x16("CAN0_MB00_DATA3", 0600, parent, (u16 *)0xFFC02C0C);
		debugfs_create_x16("CAN0_MB00_ID0", 0600, parent, (u16 *)0xFFC02C18);
		debugfs_create_x16("CAN0_MB00_ID1", 0600, parent, (u16 *)0xFFC02C1C);
		debugfs_create_x16("CAN0_MB00_LENGTH", 0600, parent, (u16 *)0xFFC02C10);
		debugfs_create_x16("CAN0_MB00_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C14);
		debugfs_create_x16("CAN0_MB01_DATA0", 0600, parent, (u16 *)0xFFC02C20);
		debugfs_create_x16("CAN0_MB01_DATA1", 0600, parent, (u16 *)0xFFC02C24);
		debugfs_create_x16("CAN0_MB01_DATA2", 0600, parent, (u16 *)0xFFC02C28);
		debugfs_create_x16("CAN0_MB01_DATA3", 0600, parent, (u16 *)0xFFC02C2C);
		debugfs_create_x16("CAN0_MB01_ID0", 0600, parent, (u16 *)0xFFC02C38);
		debugfs_create_x16("CAN0_MB01_ID1", 0600, parent, (u16 *)0xFFC02C3C);
		debugfs_create_x16("CAN0_MB01_LENGTH", 0600, parent, (u16 *)0xFFC02C30);
		debugfs_create_x16("CAN0_MB01_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C34);
		debugfs_create_x16("CAN0_MB02_DATA0", 0600, parent, (u16 *)0xFFC02C40);
		debugfs_create_x16("CAN0_MB02_DATA1", 0600, parent, (u16 *)0xFFC02C44);
		debugfs_create_x16("CAN0_MB02_DATA2", 0600, parent, (u16 *)0xFFC02C48);
		debugfs_create_x16("CAN0_MB02_DATA3", 0600, parent, (u16 *)0xFFC02C4C);
		debugfs_create_x16("CAN0_MB02_ID0", 0600, parent, (u16 *)0xFFC02C58);
		debugfs_create_x16("CAN0_MB02_ID1", 0600, parent, (u16 *)0xFFC02C5C);
		debugfs_create_x16("CAN0_MB02_LENGTH", 0600, parent, (u16 *)0xFFC02C50);
		debugfs_create_x16("CAN0_MB02_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C54);
		debugfs_create_x16("CAN0_MB03_DATA0", 0600, parent, (u16 *)0xFFC02C60);
		debugfs_create_x16("CAN0_MB03_DATA1", 0600, parent, (u16 *)0xFFC02C64);
		debugfs_create_x16("CAN0_MB03_DATA2", 0600, parent, (u16 *)0xFFC02C68);
		debugfs_create_x16("CAN0_MB03_DATA3", 0600, parent, (u16 *)0xFFC02C6C);
		debugfs_create_x16("CAN0_MB03_ID0", 0600, parent, (u16 *)0xFFC02C78);
		debugfs_create_x16("CAN0_MB03_ID1", 0600, parent, (u16 *)0xFFC02C7C);
		debugfs_create_x16("CAN0_MB03_LENGTH", 0600, parent, (u16 *)0xFFC02C70);
		debugfs_create_x16("CAN0_MB03_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C74);
		debugfs_create_x16("CAN0_MB04_DATA0", 0600, parent, (u16 *)0xFFC02C80);
		debugfs_create_x16("CAN0_MB04_DATA1", 0600, parent, (u16 *)0xFFC02C84);
		debugfs_create_x16("CAN0_MB04_DATA2", 0600, parent, (u16 *)0xFFC02C88);
		debugfs_create_x16("CAN0_MB04_DATA3", 0600, parent, (u16 *)0xFFC02C8C);
		debugfs_create_x16("CAN0_MB04_ID0", 0600, parent, (u16 *)0xFFC02C98);
		debugfs_create_x16("CAN0_MB04_ID1", 0600, parent, (u16 *)0xFFC02C9C);
		debugfs_create_x16("CAN0_MB04_LENGTH", 0600, parent, (u16 *)0xFFC02C90);
		debugfs_create_x16("CAN0_MB04_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C94);
		debugfs_create_x16("CAN0_MB05_DATA0", 0600, parent, (u16 *)0xFFC02CA0);
		debugfs_create_x16("CAN0_MB05_DATA1", 0600, parent, (u16 *)0xFFC02CA4);
		debugfs_create_x16("CAN0_MB05_DATA2", 0600, parent, (u16 *)0xFFC02CA8);
		debugfs_create_x16("CAN0_MB05_DATA3", 0600, parent, (u16 *)0xFFC02CAC);
		debugfs_create_x16("CAN0_MB05_ID0", 0600, parent, (u16 *)0xFFC02CB8);
		debugfs_create_x16("CAN0_MB05_ID1", 0600, parent, (u16 *)0xFFC02CBC);
		debugfs_create_x16("CAN0_MB05_LENGTH", 0600, parent, (u16 *)0xFFC02CB0);
		debugfs_create_x16("CAN0_MB05_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CB4);
		debugfs_create_x16("CAN0_MB06_DATA0", 0600, parent, (u16 *)0xFFC02CC0);
		debugfs_create_x16("CAN0_MB06_DATA1", 0600, parent, (u16 *)0xFFC02CC4);
		debugfs_create_x16("CAN0_MB06_DATA2", 0600, parent, (u16 *)0xFFC02CC8);
		debugfs_create_x16("CAN0_MB06_DATA3", 0600, parent, (u16 *)0xFFC02CCC);
		debugfs_create_x16("CAN0_MB06_ID0", 0600, parent, (u16 *)0xFFC02CD8);
		debugfs_create_x16("CAN0_MB06_ID1", 0600, parent, (u16 *)0xFFC02CDC);
		debugfs_create_x16("CAN0_MB06_LENGTH", 0600, parent, (u16 *)0xFFC02CD0);
		debugfs_create_x16("CAN0_MB06_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CD4);
		debugfs_create_x16("CAN0_MB07_DATA0", 0600, parent, (u16 *)0xFFC02CE0);
		debugfs_create_x16("CAN0_MB07_DATA1", 0600, parent, (u16 *)0xFFC02CE4);
		debugfs_create_x16("CAN0_MB07_DATA2", 0600, parent, (u16 *)0xFFC02CE8);
		debugfs_create_x16("CAN0_MB07_DATA3", 0600, parent, (u16 *)0xFFC02CEC);
		debugfs_create_x16("CAN0_MB07_ID0", 0600, parent, (u16 *)0xFFC02CF8);
		debugfs_create_x16("CAN0_MB07_ID1", 0600, parent, (u16 *)0xFFC02CFC);
		debugfs_create_x16("CAN0_MB07_LENGTH", 0600, parent, (u16 *)0xFFC02CF0);
		debugfs_create_x16("CAN0_MB07_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CF4);
		debugfs_create_x16("CAN0_MB08_DATA0", 0600, parent, (u16 *)0xFFC02D00);
		debugfs_create_x16("CAN0_MB08_DATA1", 0600, parent, (u16 *)0xFFC02D04);
		debugfs_create_x16("CAN0_MB08_DATA2", 0600, parent, (u16 *)0xFFC02D08);
		debugfs_create_x16("CAN0_MB08_DATA3", 0600, parent, (u16 *)0xFFC02D0C);
		debugfs_create_x16("CAN0_MB08_ID0", 0600, parent, (u16 *)0xFFC02D18);
		debugfs_create_x16("CAN0_MB08_ID1", 0600, parent, (u16 *)0xFFC02D1C);
		debugfs_create_x16("CAN0_MB08_LENGTH", 0600, parent, (u16 *)0xFFC02D10);
		debugfs_create_x16("CAN0_MB08_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D14);
		debugfs_create_x16("CAN0_MB09_DATA0", 0600, parent, (u16 *)0xFFC02D20);
		debugfs_create_x16("CAN0_MB09_DATA1", 0600, parent, (u16 *)0xFFC02D24);
		debugfs_create_x16("CAN0_MB09_DATA2", 0600, parent, (u16 *)0xFFC02D28);
		debugfs_create_x16("CAN0_MB09_DATA3", 0600, parent, (u16 *)0xFFC02D2C);
		debugfs_create_x16("CAN0_MB09_ID0", 0600, parent, (u16 *)0xFFC02D38);
		debugfs_create_x16("CAN0_MB09_ID1", 0600, parent, (u16 *)0xFFC02D3C);
		debugfs_create_x16("CAN0_MB09_LENGTH", 0600, parent, (u16 *)0xFFC02D30);
		debugfs_create_x16("CAN0_MB09_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D34);
		debugfs_create_x16("CAN0_MB10_DATA0", 0600, parent, (u16 *)0xFFC02D40);
		debugfs_create_x16("CAN0_MB10_DATA1", 0600, parent, (u16 *)0xFFC02D44);
		debugfs_create_x16("CAN0_MB10_DATA2", 0600, parent, (u16 *)0xFFC02D48);
		debugfs_create_x16("CAN0_MB10_DATA3", 0600, parent, (u16 *)0xFFC02D4C);
		debugfs_create_x16("CAN0_MB10_ID0", 0600, parent, (u16 *)0xFFC02D58);
		debugfs_create_x16("CAN0_MB10_ID1", 0600, parent, (u16 *)0xFFC02D5C);
		debugfs_create_x16("CAN0_MB10_LENGTH", 0600, parent, (u16 *)0xFFC02D50);
		debugfs_create_x16("CAN0_MB10_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D54);
		debugfs_create_x16("CAN0_MB11_DATA0", 0600, parent, (u16 *)0xFFC02D60);
		debugfs_create_x16("CAN0_MB11_DATA1", 0600, parent, (u16 *)0xFFC02D64);
		debugfs_create_x16("CAN0_MB11_DATA2", 0600, parent, (u16 *)0xFFC02D68);
		debugfs_create_x16("CAN0_MB11_DATA3", 0600, parent, (u16 *)0xFFC02D6C);
		debugfs_create_x16("CAN0_MB11_ID0", 0600, parent, (u16 *)0xFFC02D78);
		debugfs_create_x16("CAN0_MB11_ID1", 0600, parent, (u16 *)0xFFC02D7C);
		debugfs_create_x16("CAN0_MB11_LENGTH", 0600, parent, (u16 *)0xFFC02D70);
		debugfs_create_x16("CAN0_MB11_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D74);
		debugfs_create_x16("CAN0_MB12_DATA0", 0600, parent, (u16 *)0xFFC02D80);
		debugfs_create_x16("CAN0_MB12_DATA1", 0600, parent, (u16 *)0xFFC02D84);
		debugfs_create_x16("CAN0_MB12_DATA2", 0600, parent, (u16 *)0xFFC02D88);
		debugfs_create_x16("CAN0_MB12_DATA3", 0600, parent, (u16 *)0xFFC02D8C);
		debugfs_create_x16("CAN0_MB12_ID0", 0600, parent, (u16 *)0xFFC02D98);
		debugfs_create_x16("CAN0_MB12_ID1", 0600, parent, (u16 *)0xFFC02D9C);
		debugfs_create_x16("CAN0_MB12_LENGTH", 0600, parent, (u16 *)0xFFC02D90);
		debugfs_create_x16("CAN0_MB12_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D94);
		debugfs_create_x16("CAN0_MB13_DATA0", 0600, parent, (u16 *)0xFFC02DA0);
		debugfs_create_x16("CAN0_MB13_DATA1", 0600, parent, (u16 *)0xFFC02DA4);
		debugfs_create_x16("CAN0_MB13_DATA2", 0600, parent, (u16 *)0xFFC02DA8);
		debugfs_create_x16("CAN0_MB13_DATA3", 0600, parent, (u16 *)0xFFC02DAC);
		debugfs_create_x16("CAN0_MB13_ID0", 0600, parent, (u16 *)0xFFC02DB8);
		debugfs_create_x16("CAN0_MB13_ID1", 0600, parent, (u16 *)0xFFC02DBC);
		debugfs_create_x16("CAN0_MB13_LENGTH", 0600, parent, (u16 *)0xFFC02DB0);
		debugfs_create_x16("CAN0_MB13_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DB4);
		debugfs_create_x16("CAN0_MB14_DATA0", 0600, parent, (u16 *)0xFFC02DC0);
		debugfs_create_x16("CAN0_MB14_DATA1", 0600, parent, (u16 *)0xFFC02DC4);
		debugfs_create_x16("CAN0_MB14_DATA2", 0600, parent, (u16 *)0xFFC02DC8);
		debugfs_create_x16("CAN0_MB14_DATA3", 0600, parent, (u16 *)0xFFC02DCC);
		debugfs_create_x16("CAN0_MB14_ID0", 0600, parent, (u16 *)0xFFC02DD8);
		debugfs_create_x16("CAN0_MB14_ID1", 0600, parent, (u16 *)0xFFC02DDC);
		debugfs_create_x16("CAN0_MB14_LENGTH", 0600, parent, (u16 *)0xFFC02DD0);
		debugfs_create_x16("CAN0_MB14_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DD4);
		debugfs_create_x16("CAN0_MB15_DATA0", 0600, parent, (u16 *)0xFFC02DE0);
		debugfs_create_x16("CAN0_MB15_DATA1", 0600, parent, (u16 *)0xFFC02DE4);
		debugfs_create_x16("CAN0_MB15_DATA2", 0600, parent, (u16 *)0xFFC02DE8);
		debugfs_create_x16("CAN0_MB15_DATA3", 0600, parent, (u16 *)0xFFC02DEC);
		debugfs_create_x16("CAN0_MB15_ID0", 0600, parent, (u16 *)0xFFC02DF8);
		debugfs_create_x16("CAN0_MB15_ID1", 0600, parent, (u16 *)0xFFC02DFC);
		debugfs_create_x16("CAN0_MB15_LENGTH", 0600, parent, (u16 *)0xFFC02DF0);
		debugfs_create_x16("CAN0_MB15_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DF4);
		debugfs_create_x16("CAN0_MB16_DATA0", 0600, parent, (u16 *)0xFFC02E00);
		debugfs_create_x16("CAN0_MB16_DATA1", 0600, parent, (u16 *)0xFFC02E04);
		debugfs_create_x16("CAN0_MB16_DATA2", 0600, parent, (u16 *)0xFFC02E08);
		debugfs_create_x16("CAN0_MB16_DATA3", 0600, parent, (u16 *)0xFFC02E0C);
		debugfs_create_x16("CAN0_MB16_ID0", 0600, parent, (u16 *)0xFFC02E18);
		debugfs_create_x16("CAN0_MB16_ID1", 0600, parent, (u16 *)0xFFC02E1C);
		debugfs_create_x16("CAN0_MB16_LENGTH", 0600, parent, (u16 *)0xFFC02E10);
		debugfs_create_x16("CAN0_MB16_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E14);
		debugfs_create_x16("CAN0_MB17_DATA0", 0600, parent, (u16 *)0xFFC02E20);
		debugfs_create_x16("CAN0_MB17_DATA1", 0600, parent, (u16 *)0xFFC02E24);
		debugfs_create_x16("CAN0_MB17_DATA2", 0600, parent, (u16 *)0xFFC02E28);
		debugfs_create_x16("CAN0_MB17_DATA3", 0600, parent, (u16 *)0xFFC02E2C);
		debugfs_create_x16("CAN0_MB17_ID0", 0600, parent, (u16 *)0xFFC02E38);
		debugfs_create_x16("CAN0_MB17_ID1", 0600, parent, (u16 *)0xFFC02E3C);
		debugfs_create_x16("CAN0_MB17_LENGTH", 0600, parent, (u16 *)0xFFC02E30);
		debugfs_create_x16("CAN0_MB17_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E34);
		debugfs_create_x16("CAN0_MB18_DATA0", 0600, parent, (u16 *)0xFFC02E40);
		debugfs_create_x16("CAN0_MB18_DATA1", 0600, parent, (u16 *)0xFFC02E44);
		debugfs_create_x16("CAN0_MB18_DATA2", 0600, parent, (u16 *)0xFFC02E48);
		debugfs_create_x16("CAN0_MB18_DATA3", 0600, parent, (u16 *)0xFFC02E4C);
		debugfs_create_x16("CAN0_MB18_ID0", 0600, parent, (u16 *)0xFFC02E58);
		debugfs_create_x16("CAN0_MB18_ID1", 0600, parent, (u16 *)0xFFC02E5C);
		debugfs_create_x16("CAN0_MB18_LENGTH", 0600, parent, (u16 *)0xFFC02E50);
		debugfs_create_x16("CAN0_MB18_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E54);
		debugfs_create_x16("CAN0_MB19_DATA0", 0600, parent, (u16 *)0xFFC02E60);
		debugfs_create_x16("CAN0_MB19_DATA1", 0600, parent, (u16 *)0xFFC02E64);
		debugfs_create_x16("CAN0_MB19_DATA2", 0600, parent, (u16 *)0xFFC02E68);
		debugfs_create_x16("CAN0_MB19_DATA3", 0600, parent, (u16 *)0xFFC02E6C);
		debugfs_create_x16("CAN0_MB19_ID0", 0600, parent, (u16 *)0xFFC02E78);
		debugfs_create_x16("CAN0_MB19_ID1", 0600, parent, (u16 *)0xFFC02E7C);
		debugfs_create_x16("CAN0_MB19_LENGTH", 0600, parent, (u16 *)0xFFC02E70);
		debugfs_create_x16("CAN0_MB19_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E74);
		debugfs_create_x16("CAN0_MB20_DATA0", 0600, parent, (u16 *)0xFFC02E80);
		debugfs_create_x16("CAN0_MB20_DATA1", 0600, parent, (u16 *)0xFFC02E84);
		debugfs_create_x16("CAN0_MB20_DATA2", 0600, parent, (u16 *)0xFFC02E88);
		debugfs_create_x16("CAN0_MB20_DATA3", 0600, parent, (u16 *)0xFFC02E8C);
		debugfs_create_x16("CAN0_MB20_ID0", 0600, parent, (u16 *)0xFFC02E98);
		debugfs_create_x16("CAN0_MB20_ID1", 0600, parent, (u16 *)0xFFC02E9C);
		debugfs_create_x16("CAN0_MB20_LENGTH", 0600, parent, (u16 *)0xFFC02E90);
		debugfs_create_x16("CAN0_MB20_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E94);
		debugfs_create_x16("CAN0_MB21_DATA0", 0600, parent, (u16 *)0xFFC02EA0);
		debugfs_create_x16("CAN0_MB21_DATA1", 0600, parent, (u16 *)0xFFC02EA4);
		debugfs_create_x16("CAN0_MB21_DATA2", 0600, parent, (u16 *)0xFFC02EA8);
		debugfs_create_x16("CAN0_MB21_DATA3", 0600, parent, (u16 *)0xFFC02EAC);
		debugfs_create_x16("CAN0_MB21_ID0", 0600, parent, (u16 *)0xFFC02EB8);
		debugfs_create_x16("CAN0_MB21_ID1", 0600, parent, (u16 *)0xFFC02EBC);
		debugfs_create_x16("CAN0_MB21_LENGTH", 0600, parent, (u16 *)0xFFC02EB0);
		debugfs_create_x16("CAN0_MB21_TIMESTAMP", 0600, parent, (u16 *)0xFFC02EB4);
		debugfs_create_x16("CAN0_MB22_DATA0", 0600, parent, (u16 *)0xFFC02EC0);
		debugfs_create_x16("CAN0_MB22_DATA1", 0600, parent, (u16 *)0xFFC02EC4);
		debugfs_create_x16("CAN0_MB22_DATA2", 0600, parent, (u16 *)0xFFC02EC8);
		debugfs_create_x16("CAN0_MB22_DATA3", 0600, parent, (u16 *)0xFFC02ECC);
		debugfs_create_x16("CAN0_MB22_ID0", 0600, parent, (u16 *)0xFFC02ED8);
		debugfs_create_x16("CAN0_MB22_ID1", 0600, parent, (u16 *)0xFFC02EDC);
		debugfs_create_x16("CAN0_MB22_LENGTH", 0600, parent, (u16 *)0xFFC02ED0);
		debugfs_create_x16("CAN0_MB22_TIMESTAMP", 0600, parent, (u16 *)0xFFC02ED4);
		debugfs_create_x16("CAN0_MB23_DATA0", 0600, parent, (u16 *)0xFFC02EE0);
		debugfs_create_x16("CAN0_MB23_DATA1", 0600, parent, (u16 *)0xFFC02EE4);
		debugfs_create_x16("CAN0_MB23_DATA2", 0600, parent, (u16 *)0xFFC02EE8);
		debugfs_create_x16("CAN0_MB23_DATA3", 0600, parent, (u16 *)0xFFC02EEC);
		debugfs_create_x16("CAN0_MB23_ID0", 0600, parent, (u16 *)0xFFC02EF8);
		debugfs_create_x16("CAN0_MB23_ID1", 0600, parent, (u16 *)0xFFC02EFC);
		debugfs_create_x16("CAN0_MB23_LENGTH", 0600, parent, (u16 *)0xFFC02EF0);
		debugfs_create_x16("CAN0_MB23_TIMESTAMP", 0600, parent, (u16 *)0xFFC02EF4);
		debugfs_create_x16("CAN0_MB24_DATA0", 0600, parent, (u16 *)0xFFC02F00);
		debugfs_create_x16("CAN0_MB24_DATA1", 0600, parent, (u16 *)0xFFC02F04);
		debugfs_create_x16("CAN0_MB24_DATA2", 0600, parent, (u16 *)0xFFC02F08);
		debugfs_create_x16("CAN0_MB24_DATA3", 0600, parent, (u16 *)0xFFC02F0C);
		debugfs_create_x16("CAN0_MB24_ID0", 0600, parent, (u16 *)0xFFC02F18);
		debugfs_create_x16("CAN0_MB24_ID1", 0600, parent, (u16 *)0xFFC02F1C);
		debugfs_create_x16("CAN0_MB24_LENGTH", 0600, parent, (u16 *)0xFFC02F10);
		debugfs_create_x16("CAN0_MB24_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F14);
		debugfs_create_x16("CAN0_MB25_DATA0", 0600, parent, (u16 *)0xFFC02F20);
		debugfs_create_x16("CAN0_MB25_DATA1", 0600, parent, (u16 *)0xFFC02F24);
		debugfs_create_x16("CAN0_MB25_DATA2", 0600, parent, (u16 *)0xFFC02F28);
		debugfs_create_x16("CAN0_MB25_DATA3", 0600, parent, (u16 *)0xFFC02F2C);
		debugfs_create_x16("CAN0_MB25_ID0", 0600, parent, (u16 *)0xFFC02F38);
		debugfs_create_x16("CAN0_MB25_ID1", 0600, parent, (u16 *)0xFFC02F3C);
		debugfs_create_x16("CAN0_MB25_LENGTH", 0600, parent, (u16 *)0xFFC02F30);
		debugfs_create_x16("CAN0_MB25_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F34);
		debugfs_create_x16("CAN0_MB26_DATA0", 0600, parent, (u16 *)0xFFC02F40);
		debugfs_create_x16("CAN0_MB26_DATA1", 0600, parent, (u16 *)0xFFC02F44);
		debugfs_create_x16("CAN0_MB26_DATA2", 0600, parent, (u16 *)0xFFC02F48);
		debugfs_create_x16("CAN0_MB26_DATA3", 0600, parent, (u16 *)0xFFC02F4C);
		debugfs_create_x16("CAN0_MB26_ID0", 0600, parent, (u16 *)0xFFC02F58);
		debugfs_create_x16("CAN0_MB26_ID1", 0600, parent, (u16 *)0xFFC02F5C);
		debugfs_create_x16("CAN0_MB26_LENGTH", 0600, parent, (u16 *)0xFFC02F50);
		debugfs_create_x16("CAN0_MB26_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F54);
		debugfs_create_x16("CAN0_MB27_DATA0", 0600, parent, (u16 *)0xFFC02F60);
		debugfs_create_x16("CAN0_MB27_DATA1", 0600, parent, (u16 *)0xFFC02F64);
		debugfs_create_x16("CAN0_MB27_DATA2", 0600, parent, (u16 *)0xFFC02F68);
		debugfs_create_x16("CAN0_MB27_DATA3", 0600, parent, (u16 *)0xFFC02F6C);
		debugfs_create_x16("CAN0_MB27_ID0", 0600, parent, (u16 *)0xFFC02F78);
		debugfs_create_x16("CAN0_MB27_ID1", 0600, parent, (u16 *)0xFFC02F7C);
		debugfs_create_x16("CAN0_MB27_LENGTH", 0600, parent, (u16 *)0xFFC02F70);
		debugfs_create_x16("CAN0_MB27_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F74);
		debugfs_create_x16("CAN0_MB28_DATA0", 0600, parent, (u16 *)0xFFC02F80);
		debugfs_create_x16("CAN0_MB28_DATA1", 0600, parent, (u16 *)0xFFC02F84);
		debugfs_create_x16("CAN0_MB28_DATA2", 0600, parent, (u16 *)0xFFC02F88);
		debugfs_create_x16("CAN0_MB28_DATA3", 0600, parent, (u16 *)0xFFC02F8C);
		debugfs_create_x16("CAN0_MB28_ID0", 0600, parent, (u16 *)0xFFC02F98);
		debugfs_create_x16("CAN0_MB28_ID1", 0600, parent, (u16 *)0xFFC02F9C);
		debugfs_create_x16("CAN0_MB28_LENGTH", 0600, parent, (u16 *)0xFFC02F90);
		debugfs_create_x16("CAN0_MB28_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F94);
		debugfs_create_x16("CAN0_MB29_DATA0", 0600, parent, (u16 *)0xFFC02FA0);
		debugfs_create_x16("CAN0_MB29_DATA1", 0600, parent, (u16 *)0xFFC02FA4);
		debugfs_create_x16("CAN0_MB29_DATA2", 0600, parent, (u16 *)0xFFC02FA8);
		debugfs_create_x16("CAN0_MB29_DATA3", 0600, parent, (u16 *)0xFFC02FAC);
		debugfs_create_x16("CAN0_MB29_ID0", 0600, parent, (u16 *)0xFFC02FB8);
		debugfs_create_x16("CAN0_MB29_ID1", 0600, parent, (u16 *)0xFFC02FBC);
		debugfs_create_x16("CAN0_MB29_LENGTH", 0600, parent, (u16 *)0xFFC02FB0);
		debugfs_create_x16("CAN0_MB29_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FB4);
		debugfs_create_x16("CAN0_MB30_DATA0", 0600, parent, (u16 *)0xFFC02FC0);
		debugfs_create_x16("CAN0_MB30_DATA1", 0600, parent, (u16 *)0xFFC02FC4);
		debugfs_create_x16("CAN0_MB30_DATA2", 0600, parent, (u16 *)0xFFC02FC8);
		debugfs_create_x16("CAN0_MB30_DATA3", 0600, parent, (u16 *)0xFFC02FCC);
		debugfs_create_x16("CAN0_MB30_ID0", 0600, parent, (u16 *)0xFFC02FD8);
		debugfs_create_x16("CAN0_MB30_ID1", 0600, parent, (u16 *)0xFFC02FDC);
		debugfs_create_x16("CAN0_MB30_LENGTH", 0600, parent, (u16 *)0xFFC02FD0);
		debugfs_create_x16("CAN0_MB30_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FD4);
		debugfs_create_x16("CAN0_MB31_DATA0", 0600, parent, (u16 *)0xFFC02FE0);
		debugfs_create_x16("CAN0_MB31_DATA1", 0600, parent, (u16 *)0xFFC02FE4);
		debugfs_create_x16("CAN0_MB31_DATA2", 0600, parent, (u16 *)0xFFC02FE8);
		debugfs_create_x16("CAN0_MB31_DATA3", 0600, parent, (u16 *)0xFFC02FEC);
		debugfs_create_x16("CAN0_MB31_ID0", 0600, parent, (u16 *)0xFFC02FF8);
		debugfs_create_x16("CAN0_MB31_ID1", 0600, parent, (u16 *)0xFFC02FFC);
		debugfs_create_x16("CAN0_MB31_LENGTH", 0600, parent, (u16 *)0xFFC02FF0);
		debugfs_create_x16("CAN0_MB31_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FF4);

		parent = debugfs_create_dir("CORE_TMR", top);
		debugfs_create_x32("TCNTL", 0600, parent, (u32 *)0xFFE03000);
		debugfs_create_x32("TCOUNT", 0600, parent, (u32 *)0xFFE0300C);
		debugfs_create_x32("TPERIOD", 0600, parent, (u32 *)0xFFE03004);
		debugfs_create_x32("TSCALE", 0600, parent, (u32 *)0xFFE03008);

		parent = debugfs_create_dir("Counter", top);
		debugfs_create_x16("CNT_COMMAND", 0600, parent, (u16 *)0xFFC0420C);
		debugfs_create_x16("CNT_CONFIG", 0600, parent, (u16 *)0xFFC04200);
		debugfs_create_x32("CNT_COUNTER", 0600, parent, (u32 *)0xFFC04214);
		debugfs_create_x16("CNT_DEBOUNCE", 0600, parent, (u16 *)0xFFC04210);
		debugfs_create_x16("CNT_IMASK", 0600, parent, (u16 *)0xFFC04204);
		debugfs_create_x32("CNT_MAX", 0600, parent, (u32 *)0xFFC04218);
		debugfs_create_x32("CNT_MIN", 0600, parent, (u32 *)0xFFC0421C);
		debugfs_create_x16("CNT_STATUS", 0600, parent, (u16 *)0xFFC04208);

		parent = debugfs_create_dir("DMA", top);
		debugfs_create_x16("DMA0_CONFIG", 0600, parent, (u16 *)0xFFC00C08);
		debugfs_create_x32("DMA0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C24);
		debugfs_create_x32("DMA0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C20);
		debugfs_create_x16("DMA0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C30);
		debugfs_create_x16("DMA0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C38);
		debugfs_create_x16("DMA0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C28);
		debugfs_create_x32("DMA0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C00);
		debugfs_create_x16("DMA0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C2C);
		debugfs_create_x32("DMA0_START_ADDR", 0600, parent, (u32 *)0xFFC00C04);
		debugfs_create_x16("DMA0_X_COUNT", 0600, parent, (u16 *)0xFFC00C10);
		debugfs_create_x16("DMA0_X_MODIFY", 0600, parent, (u16 *)0xFFC00C14);
		debugfs_create_x16("DMA0_Y_COUNT", 0600, parent, (u16 *)0xFFC00C18);
		debugfs_create_x16("DMA0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C1C);
		debugfs_create_x16("DMA10_CONFIG", 0600, parent, (u16 *)0xFFC00E88);
		debugfs_create_x32("DMA10_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EA4);
		debugfs_create_x32("DMA10_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EA0);
		debugfs_create_x16("DMA10_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EB0);
		debugfs_create_x16("DMA10_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EB8);
		debugfs_create_x16("DMA10_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EA8);
		debugfs_create_x32("DMA10_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E80);
		debugfs_create_x16("DMA10_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EAC);
		debugfs_create_x32("DMA10_START_ADDR", 0600, parent, (u32 *)0xFFC00E84);
		debugfs_create_x16("DMA10_X_COUNT", 0600, parent, (u16 *)0xFFC00E90);
		debugfs_create_x16("DMA10_X_MODIFY", 0600, parent, (u16 *)0xFFC00E94);
		debugfs_create_x16("DMA10_Y_COUNT", 0600, parent, (u16 *)0xFFC00E98);
		debugfs_create_x16("DMA10_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E9C);
		debugfs_create_x16("DMA11_CONFIG", 0600, parent, (u16 *)0xFFC00EC8);
		debugfs_create_x32("DMA11_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EE4);
		debugfs_create_x32("DMA11_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EE0);
		debugfs_create_x16("DMA11_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EF0);
		debugfs_create_x16("DMA11_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EF8);
		debugfs_create_x16("DMA11_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EE8);
		debugfs_create_x32("DMA11_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00EC0);
		debugfs_create_x16("DMA11_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EEC);
		debugfs_create_x32("DMA11_START_ADDR", 0600, parent, (u32 *)0xFFC00EC4);
		debugfs_create_x16("DMA11_X_COUNT", 0600, parent, (u16 *)0xFFC00ED0);
		debugfs_create_x16("DMA11_X_MODIFY", 0600, parent, (u16 *)0xFFC00ED4);
		debugfs_create_x16("DMA11_Y_COUNT", 0600, parent, (u16 *)0xFFC00ED8);
		debugfs_create_x16("DMA11_Y_MODIFY", 0600, parent, (u16 *)0xFFC00EDC);
		debugfs_create_x16("DMA12_CONFIG", 0600, parent, (u16 *)0xFFC01C08);
		debugfs_create_x32("DMA12_CURR_ADDR", 0600, parent, (u32 *)0xFFC01C24);
		debugfs_create_x32("DMA12_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01C20);
		debugfs_create_x16("DMA12_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01C30);
		debugfs_create_x16("DMA12_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01C38);
		debugfs_create_x16("DMA12_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01C28);
		debugfs_create_x32("DMA12_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01C00);
		debugfs_create_x16("DMA12_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01C2C);
		debugfs_create_x32("DMA12_START_ADDR", 0600, parent, (u32 *)0xFFC01C04);
		debugfs_create_x16("DMA12_X_COUNT", 0600, parent, (u16 *)0xFFC01C10);
		debugfs_create_x16("DMA12_X_MODIFY", 0600, parent, (u16 *)0xFFC01C14);
		debugfs_create_x16("DMA12_Y_COUNT", 0600, parent, (u16 *)0xFFC01C18);
		debugfs_create_x16("DMA12_Y_MODIFY", 0600, parent, (u16 *)0xFFC01C1C);
		debugfs_create_x16("DMA13_CONFIG", 0600, parent, (u16 *)0xFFC01C48);
		debugfs_create_x32("DMA13_CURR_ADDR", 0600, parent, (u32 *)0xFFC01C64);
		debugfs_create_x32("DMA13_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01C60);
		debugfs_create_x16("DMA13_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01C70);
		debugfs_create_x16("DMA13_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01C78);
		debugfs_create_x16("DMA13_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01C68);
		debugfs_create_x32("DMA13_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01C40);
		debugfs_create_x16("DMA13_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01C6C);
		debugfs_create_x32("DMA13_START_ADDR", 0600, parent, (u32 *)0xFFC01C44);
		debugfs_create_x16("DMA13_X_COUNT", 0600, parent, (u16 *)0xFFC01C50);
		debugfs_create_x16("DMA13_X_MODIFY", 0600, parent, (u16 *)0xFFC01C54);
		debugfs_create_x16("DMA13_Y_COUNT", 0600, parent, (u16 *)0xFFC01C58);
		debugfs_create_x16("DMA13_Y_MODIFY", 0600, parent, (u16 *)0xFFC01C5C);
		debugfs_create_x16("DMA14_CONFIG", 0600, parent, (u16 *)0xFFC01C88);
		debugfs_create_x32("DMA14_CURR_ADDR", 0600, parent, (u32 *)0xFFC01CA4);
		debugfs_create_x32("DMA14_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01CA0);
		debugfs_create_x16("DMA14_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01CB0);
		debugfs_create_x16("DMA14_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01CB8);
		debugfs_create_x16("DMA14_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01CA8);
		debugfs_create_x32("DMA14_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01C80);
		debugfs_create_x16("DMA14_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01CAC);
		debugfs_create_x32("DMA14_START_ADDR", 0600, parent, (u32 *)0xFFC01C84);
		debugfs_create_x16("DMA14_X_COUNT", 0600, parent, (u16 *)0xFFC01C90);
		debugfs_create_x16("DMA14_X_MODIFY", 0600, parent, (u16 *)0xFFC01C94);
		debugfs_create_x16("DMA14_Y_COUNT", 0600, parent, (u16 *)0xFFC01C98);
		debugfs_create_x16("DMA14_Y_MODIFY", 0600, parent, (u16 *)0xFFC01C9C);
		debugfs_create_x16("DMA15_CONFIG", 0600, parent, (u16 *)0xFFC01CC8);
		debugfs_create_x32("DMA15_CURR_ADDR", 0600, parent, (u32 *)0xFFC01CE4);
		debugfs_create_x32("DMA15_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01CE0);
		debugfs_create_x16("DMA15_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01CF0);
		debugfs_create_x16("DMA15_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01CF8);
		debugfs_create_x16("DMA15_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01CE8);
		debugfs_create_x32("DMA15_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01CC0);
		debugfs_create_x16("DMA15_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01CEC);
		debugfs_create_x32("DMA15_START_ADDR", 0600, parent, (u32 *)0xFFC01CC4);
		debugfs_create_x16("DMA15_X_COUNT", 0600, parent, (u16 *)0xFFC01CD0);
		debugfs_create_x16("DMA15_X_MODIFY", 0600, parent, (u16 *)0xFFC01CD4);
		debugfs_create_x16("DMA15_Y_COUNT", 0600, parent, (u16 *)0xFFC01CD8);
		debugfs_create_x16("DMA15_Y_MODIFY", 0600, parent, (u16 *)0xFFC01CDC);
		debugfs_create_x16("DMA16_CONFIG", 0600, parent, (u16 *)0xFFC01D08);
		debugfs_create_x32("DMA16_CURR_ADDR", 0600, parent, (u32 *)0xFFC01D24);
		debugfs_create_x32("DMA16_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01D20);
		debugfs_create_x16("DMA16_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01D30);
		debugfs_create_x16("DMA16_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01D38);
		debugfs_create_x16("DMA16_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01D28);
		debugfs_create_x32("DMA16_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01D00);
		debugfs_create_x16("DMA16_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01D2C);
		debugfs_create_x32("DMA16_START_ADDR", 0600, parent, (u32 *)0xFFC01D04);
		debugfs_create_x16("DMA16_X_COUNT", 0600, parent, (u16 *)0xFFC01D10);
		debugfs_create_x16("DMA16_X_MODIFY", 0600, parent, (u16 *)0xFFC01D14);
		debugfs_create_x16("DMA16_Y_COUNT", 0600, parent, (u16 *)0xFFC01D18);
		debugfs_create_x16("DMA16_Y_MODIFY", 0600, parent, (u16 *)0xFFC01D1C);
		debugfs_create_x16("DMA17_CONFIG", 0600, parent, (u16 *)0xFFC01D48);
		debugfs_create_x32("DMA17_CURR_ADDR", 0600, parent, (u32 *)0xFFC01D64);
		debugfs_create_x32("DMA17_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01D60);
		debugfs_create_x16("DMA17_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01D70);
		debugfs_create_x16("DMA17_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01D78);
		debugfs_create_x16("DMA17_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01D68);
		debugfs_create_x32("DMA17_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01D40);
		debugfs_create_x16("DMA17_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01D6C);
		debugfs_create_x32("DMA17_START_ADDR", 0600, parent, (u32 *)0xFFC01D44);
		debugfs_create_x16("DMA17_X_COUNT", 0600, parent, (u16 *)0xFFC01D50);
		debugfs_create_x16("DMA17_X_MODIFY", 0600, parent, (u16 *)0xFFC01D54);
		debugfs_create_x16("DMA17_Y_COUNT", 0600, parent, (u16 *)0xFFC01D58);
		debugfs_create_x16("DMA17_Y_MODIFY", 0600, parent, (u16 *)0xFFC01D5C);
		debugfs_create_x16("DMA18_CONFIG", 0600, parent, (u16 *)0xFFC01D88);
		debugfs_create_x32("DMA18_CURR_ADDR", 0600, parent, (u32 *)0xFFC01DA4);
		debugfs_create_x32("DMA18_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01DA0);
		debugfs_create_x16("DMA18_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01DB0);
		debugfs_create_x16("DMA18_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01DB8);
		debugfs_create_x16("DMA18_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01DA8);
		debugfs_create_x32("DMA18_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01D80);
		debugfs_create_x16("DMA18_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01DAC);
		debugfs_create_x32("DMA18_START_ADDR", 0600, parent, (u32 *)0xFFC01D84);
		debugfs_create_x16("DMA18_X_COUNT", 0600, parent, (u16 *)0xFFC01D90);
		debugfs_create_x16("DMA18_X_MODIFY", 0600, parent, (u16 *)0xFFC01D94);
		debugfs_create_x16("DMA18_Y_COUNT", 0600, parent, (u16 *)0xFFC01D98);
		debugfs_create_x16("DMA18_Y_MODIFY", 0600, parent, (u16 *)0xFFC01D9C);
		debugfs_create_x16("DMA19_CONFIG", 0600, parent, (u16 *)0xFFC01DC8);
		debugfs_create_x32("DMA19_CURR_ADDR", 0600, parent, (u32 *)0xFFC01DE4);
		debugfs_create_x32("DMA19_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01DE0);
		debugfs_create_x16("DMA19_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01DF0);
		debugfs_create_x16("DMA19_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01DF8);
		debugfs_create_x16("DMA19_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01DE8);
		debugfs_create_x32("DMA19_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01DC0);
		debugfs_create_x16("DMA19_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01DEC);
		debugfs_create_x32("DMA19_START_ADDR", 0600, parent, (u32 *)0xFFC01DC4);
		debugfs_create_x16("DMA19_X_COUNT", 0600, parent, (u16 *)0xFFC01DD0);
		debugfs_create_x16("DMA19_X_MODIFY", 0600, parent, (u16 *)0xFFC01DD4);
		debugfs_create_x16("DMA19_Y_COUNT", 0600, parent, (u16 *)0xFFC01DD8);
		debugfs_create_x16("DMA19_Y_MODIFY", 0600, parent, (u16 *)0xFFC01DDC);
		debugfs_create_x16("DMA1_CONFIG", 0600, parent, (u16 *)0xFFC00C48);
		debugfs_create_x32("DMA1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C64);
		debugfs_create_x32("DMA1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C60);
		debugfs_create_x16("DMA1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C70);
		debugfs_create_x16("DMA1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C78);
		debugfs_create_x16("DMA1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C68);
		debugfs_create_x32("DMA1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C40);
		debugfs_create_x16("DMA1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C6C);
		debugfs_create_x32("DMA1_START_ADDR", 0600, parent, (u32 *)0xFFC00C44);
		debugfs_create_x16("DMA1_X_COUNT", 0600, parent, (u16 *)0xFFC00C50);
		debugfs_create_x16("DMA1_X_MODIFY", 0600, parent, (u16 *)0xFFC00C54);
		debugfs_create_x16("DMA1_Y_COUNT", 0600, parent, (u16 *)0xFFC00C58);
		debugfs_create_x16("DMA1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C5C);
		debugfs_create_x16("DMA20_CONFIG", 0600, parent, (u16 *)0xFFC01E08);
		debugfs_create_x32("DMA20_CURR_ADDR", 0600, parent, (u32 *)0xFFC01E24);
		debugfs_create_x32("DMA20_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01E20);
		debugfs_create_x16("DMA20_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01E30);
		debugfs_create_x16("DMA20_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01E38);
		debugfs_create_x16("DMA20_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01E28);
		debugfs_create_x32("DMA20_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01E00);
		debugfs_create_x16("DMA20_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01E2C);
		debugfs_create_x32("DMA20_START_ADDR", 0600, parent, (u32 *)0xFFC01E04);
		debugfs_create_x16("DMA20_X_COUNT", 0600, parent, (u16 *)0xFFC01E10);
		debugfs_create_x16("DMA20_X_MODIFY", 0600, parent, (u16 *)0xFFC01E14);
		debugfs_create_x16("DMA20_Y_COUNT", 0600, parent, (u16 *)0xFFC01E18);
		debugfs_create_x16("DMA20_Y_MODIFY", 0600, parent, (u16 *)0xFFC01E1C);
		debugfs_create_x16("DMA21_CONFIG", 0600, parent, (u16 *)0xFFC01E48);
		debugfs_create_x32("DMA21_CURR_ADDR", 0600, parent, (u32 *)0xFFC01E64);
		debugfs_create_x32("DMA21_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01E60);
		debugfs_create_x16("DMA21_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01E70);
		debugfs_create_x16("DMA21_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01E78);
		debugfs_create_x16("DMA21_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01E68);
		debugfs_create_x32("DMA21_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01E40);
		debugfs_create_x16("DMA21_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01E6C);
		debugfs_create_x32("DMA21_START_ADDR", 0600, parent, (u32 *)0xFFC01E44);
		debugfs_create_x16("DMA21_X_COUNT", 0600, parent, (u16 *)0xFFC01E50);
		debugfs_create_x16("DMA21_X_MODIFY", 0600, parent, (u16 *)0xFFC01E54);
		debugfs_create_x16("DMA21_Y_COUNT", 0600, parent, (u16 *)0xFFC01E58);
		debugfs_create_x16("DMA21_Y_MODIFY", 0600, parent, (u16 *)0xFFC01E5C);
		debugfs_create_x16("DMA22_CONFIG", 0600, parent, (u16 *)0xFFC01E88);
		debugfs_create_x32("DMA22_CURR_ADDR", 0600, parent, (u32 *)0xFFC01EA4);
		debugfs_create_x32("DMA22_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01EA0);
		debugfs_create_x16("DMA22_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01EB0);
		debugfs_create_x16("DMA22_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01EB8);
		debugfs_create_x16("DMA22_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01EA8);
		debugfs_create_x32("DMA22_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01E80);
		debugfs_create_x16("DMA22_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01EAC);
		debugfs_create_x32("DMA22_START_ADDR", 0600, parent, (u32 *)0xFFC01E84);
		debugfs_create_x16("DMA22_X_COUNT", 0600, parent, (u16 *)0xFFC01E90);
		debugfs_create_x16("DMA22_X_MODIFY", 0600, parent, (u16 *)0xFFC01E94);
		debugfs_create_x16("DMA22_Y_COUNT", 0600, parent, (u16 *)0xFFC01E98);
		debugfs_create_x16("DMA22_Y_MODIFY", 0600, parent, (u16 *)0xFFC01E9C);
		debugfs_create_x16("DMA23_CONFIG", 0600, parent, (u16 *)0xFFC01EC8);
		debugfs_create_x32("DMA23_CURR_ADDR", 0600, parent, (u32 *)0xFFC01EE4);
		debugfs_create_x32("DMA23_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01EE0);
		debugfs_create_x16("DMA23_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01EF0);
		debugfs_create_x16("DMA23_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01EF8);
		debugfs_create_x16("DMA23_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01EE8);
		debugfs_create_x32("DMA23_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01EC0);
		debugfs_create_x16("DMA23_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01EEC);
		debugfs_create_x32("DMA23_START_ADDR", 0600, parent, (u32 *)0xFFC01EC4);
		debugfs_create_x16("DMA23_X_COUNT", 0600, parent, (u16 *)0xFFC01ED0);
		debugfs_create_x16("DMA23_X_MODIFY", 0600, parent, (u16 *)0xFFC01ED4);
		debugfs_create_x16("DMA23_Y_COUNT", 0600, parent, (u16 *)0xFFC01ED8);
		debugfs_create_x16("DMA23_Y_MODIFY", 0600, parent, (u16 *)0xFFC01EDC);
		debugfs_create_x16("DMA2_CONFIG", 0600, parent, (u16 *)0xFFC00C88);
		debugfs_create_x32("DMA2_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CA4);
		debugfs_create_x32("DMA2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CA0);
		debugfs_create_x16("DMA2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CB0);
		debugfs_create_x16("DMA2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CB8);
		debugfs_create_x16("DMA2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CA8);
		debugfs_create_x32("DMA2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C80);
		debugfs_create_x16("DMA2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CAC);
		debugfs_create_x32("DMA2_START_ADDR", 0600, parent, (u32 *)0xFFC00C84);
		debugfs_create_x16("DMA2_X_COUNT", 0600, parent, (u16 *)0xFFC00C90);
		debugfs_create_x16("DMA2_X_MODIFY", 0600, parent, (u16 *)0xFFC00C94);
		debugfs_create_x16("DMA2_Y_COUNT", 0600, parent, (u16 *)0xFFC00C98);
		debugfs_create_x16("DMA2_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C9C);
		debugfs_create_x16("DMA3_CONFIG", 0600, parent, (u16 *)0xFFC00CC8);
		debugfs_create_x32("DMA3_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CE4);
		debugfs_create_x32("DMA3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CE0);
		debugfs_create_x16("DMA3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CF0);
		debugfs_create_x16("DMA3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CF8);
		debugfs_create_x16("DMA3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CE8);
		debugfs_create_x32("DMA3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00CC0);
		debugfs_create_x16("DMA3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CEC);
		debugfs_create_x32("DMA3_START_ADDR", 0600, parent, (u32 *)0xFFC00CC4);
		debugfs_create_x16("DMA3_X_COUNT", 0600, parent, (u16 *)0xFFC00CD0);
		debugfs_create_x16("DMA3_X_MODIFY", 0600, parent, (u16 *)0xFFC00CD4);
		debugfs_create_x16("DMA3_Y_COUNT", 0600, parent, (u16 *)0xFFC00CD8);
		debugfs_create_x16("DMA3_Y_MODIFY", 0600, parent, (u16 *)0xFFC00CDC);
		debugfs_create_x16("DMA4_CONFIG", 0600, parent, (u16 *)0xFFC00D08);
		debugfs_create_x32("DMA4_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D24);
		debugfs_create_x32("DMA4_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D20);
		debugfs_create_x16("DMA4_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D30);
		debugfs_create_x16("DMA4_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D38);
		debugfs_create_x16("DMA4_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D28);
		debugfs_create_x32("DMA4_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D00);
		debugfs_create_x16("DMA4_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D2C);
		debugfs_create_x32("DMA4_START_ADDR", 0600, parent, (u32 *)0xFFC00D04);
		debugfs_create_x16("DMA4_X_COUNT", 0600, parent, (u16 *)0xFFC00D10);
		debugfs_create_x16("DMA4_X_MODIFY", 0600, parent, (u16 *)0xFFC00D14);
		debugfs_create_x16("DMA4_Y_COUNT", 0600, parent, (u16 *)0xFFC00D18);
		debugfs_create_x16("DMA4_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D1C);
		debugfs_create_x16("DMA5_CONFIG", 0600, parent, (u16 *)0xFFC00D48);
		debugfs_create_x32("DMA5_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D64);
		debugfs_create_x32("DMA5_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D60);
		debugfs_create_x16("DMA5_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D70);
		debugfs_create_x16("DMA5_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D78);
		debugfs_create_x16("DMA5_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D68);
		debugfs_create_x32("DMA5_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D40);
		debugfs_create_x16("DMA5_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D6C);
		debugfs_create_x32("DMA5_START_ADDR", 0600, parent, (u32 *)0xFFC00D44);
		debugfs_create_x16("DMA5_X_COUNT", 0600, parent, (u16 *)0xFFC00D50);
		debugfs_create_x16("DMA5_X_MODIFY", 0600, parent, (u16 *)0xFFC00D54);
		debugfs_create_x16("DMA5_Y_COUNT", 0600, parent, (u16 *)0xFFC00D58);
		debugfs_create_x16("DMA5_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D5C);
		debugfs_create_x16("DMA6_CONFIG", 0600, parent, (u16 *)0xFFC00D88);
		debugfs_create_x32("DMA6_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DA4);
		debugfs_create_x32("DMA6_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DA0);
		debugfs_create_x16("DMA6_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DB0);
		debugfs_create_x16("DMA6_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DB8);
		debugfs_create_x16("DMA6_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DA8);
		debugfs_create_x32("DMA6_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D80);
		debugfs_create_x16("DMA6_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DAC);
		debugfs_create_x32("DMA6_START_ADDR", 0600, parent, (u32 *)0xFFC00D84);
		debugfs_create_x16("DMA6_X_COUNT", 0600, parent, (u16 *)0xFFC00D90);
		debugfs_create_x16("DMA6_X_MODIFY", 0600, parent, (u16 *)0xFFC00D94);
		debugfs_create_x16("DMA6_Y_COUNT", 0600, parent, (u16 *)0xFFC00D98);
		debugfs_create_x16("DMA6_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D9C);
		debugfs_create_x16("DMA7_CONFIG", 0600, parent, (u16 *)0xFFC00DC8);
		debugfs_create_x32("DMA7_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DE4);
		debugfs_create_x32("DMA7_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DE0);
		debugfs_create_x16("DMA7_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DF0);
		debugfs_create_x16("DMA7_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DF8);
		debugfs_create_x16("DMA7_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DE8);
		debugfs_create_x32("DMA7_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00DC0);
		debugfs_create_x16("DMA7_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DEC);
		debugfs_create_x32("DMA7_START_ADDR", 0600, parent, (u32 *)0xFFC00DC4);
		debugfs_create_x16("DMA7_X_COUNT", 0600, parent, (u16 *)0xFFC00DD0);
		debugfs_create_x16("DMA7_X_MODIFY", 0600, parent, (u16 *)0xFFC00DD4);
		debugfs_create_x16("DMA7_Y_COUNT", 0600, parent, (u16 *)0xFFC00DD8);
		debugfs_create_x16("DMA7_Y_MODIFY", 0600, parent, (u16 *)0xFFC00DDC);
		debugfs_create_x16("DMA8_CONFIG", 0600, parent, (u16 *)0xFFC00E08);
		debugfs_create_x32("DMA8_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E24);
		debugfs_create_x32("DMA8_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E20);
		debugfs_create_x16("DMA8_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E30);
		debugfs_create_x16("DMA8_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E38);
		debugfs_create_x16("DMA8_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E28);
		debugfs_create_x32("DMA8_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E00);
		debugfs_create_x16("DMA8_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E2C);
		debugfs_create_x32("DMA8_START_ADDR", 0600, parent, (u32 *)0xFFC00E04);
		debugfs_create_x16("DMA8_X_COUNT", 0600, parent, (u16 *)0xFFC00E10);
		debugfs_create_x16("DMA8_X_MODIFY", 0600, parent, (u16 *)0xFFC00E14);
		debugfs_create_x16("DMA8_Y_COUNT", 0600, parent, (u16 *)0xFFC00E18);
		debugfs_create_x16("DMA8_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E1C);
		debugfs_create_x16("DMA9_CONFIG", 0600, parent, (u16 *)0xFFC00E48);
		debugfs_create_x32("DMA9_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E64);
		debugfs_create_x32("DMA9_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E60);
		debugfs_create_x16("DMA9_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E70);
		debugfs_create_x16("DMA9_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E78);
		debugfs_create_x16("DMA9_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E68);
		debugfs_create_x32("DMA9_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E40);
		debugfs_create_x16("DMA9_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E6C);
		debugfs_create_x32("DMA9_START_ADDR", 0600, parent, (u32 *)0xFFC00E44);
		debugfs_create_x16("DMA9_X_COUNT", 0600, parent, (u16 *)0xFFC00E50);
		debugfs_create_x16("DMA9_X_MODIFY", 0600, parent, (u16 *)0xFFC00E54);
		debugfs_create_x16("DMA9_Y_COUNT", 0600, parent, (u16 *)0xFFC00E58);
		debugfs_create_x16("DMA9_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E5C);
		debugfs_create_x16("DMAC0_TCCNT", 0600, parent, (u16 *)0xFFC00B10);
		debugfs_create_x16("DMAC0_TCPER", 0600, parent, (u16 *)0xFFC00B0C);
		debugfs_create_x16("DMAC1_PERIMUX", 0600, parent, (u16 *)0xFFC04340);
		debugfs_create_x16("DMAC1_TCCNT", 0600, parent, (u16 *)0xFFC01B10);
		debugfs_create_x16("DMAC1_TCPER", 0600, parent, (u16 *)0xFFC01B0C);

		parent = debugfs_create_dir("EBIU", top);
		debugfs_create_x32("EBIU_AMBCTL0", 0600, parent, (u32 *)0xFFC00A04);
		debugfs_create_x32("EBIU_AMBCTL1", 0600, parent, (u32 *)0xFFC00A08);
		debugfs_create_x16("EBIU_AMGCTL", 0600, parent, (u16 *)0xFFC00A00);
		debugfs_create_x32("EBIU_ARBSTAT", 0600, parent, (u32 *)0xFFC00A10);
		debugfs_create_x32("EBIU_DDRACCT", 0600, parent, (u32 *)0xFFC00AA0);
		debugfs_create_x32("EBIU_DDRARCT", 0600, parent, (u32 *)0xFFC00AAC);
		debugfs_create_x32("EBIU_DDRBRC0", 0600, parent, (u32 *)0xFFC00A60);
		debugfs_create_x32("EBIU_DDRBRC1", 0600, parent, (u32 *)0xFFC00A64);
		debugfs_create_x32("EBIU_DDRBRC2", 0600, parent, (u32 *)0xFFC00A68);
		debugfs_create_x32("EBIU_DDRBRC3", 0600, parent, (u32 *)0xFFC00A6C);
		debugfs_create_x32("EBIU_DDRBRC4", 0600, parent, (u32 *)0xFFC00A70);
		debugfs_create_x32("EBIU_DDRBRC5", 0600, parent, (u32 *)0xFFC00A74);
		debugfs_create_x32("EBIU_DDRBRC6", 0600, parent, (u32 *)0xFFC00A78);
		debugfs_create_x32("EBIU_DDRBRC7", 0600, parent, (u32 *)0xFFC00A7C);
		debugfs_create_x32("EBIU_DDRBWC0", 0600, parent, (u32 *)0xFFC00A80);
		debugfs_create_x32("EBIU_DDRBWC1", 0600, parent, (u32 *)0xFFC00A84);
		debugfs_create_x32("EBIU_DDRBWC2", 0600, parent, (u32 *)0xFFC00A88);
		debugfs_create_x32("EBIU_DDRBWC3", 0600, parent, (u32 *)0xFFC00A8C);
		debugfs_create_x32("EBIU_DDRBWC4", 0600, parent, (u32 *)0xFFC00A90);
		debugfs_create_x32("EBIU_DDRBWC5", 0600, parent, (u32 *)0xFFC00A94);
		debugfs_create_x32("EBIU_DDRBWC6", 0600, parent, (u32 *)0xFFC00A98);
		debugfs_create_x32("EBIU_DDRBWC7", 0600, parent, (u32 *)0xFFC00A9C);
		debugfs_create_x32("EBIU_DDRCTL0", 0600, parent, (u32 *)0xFFC00A20);
		debugfs_create_x32("EBIU_DDRCTL1", 0600, parent, (u32 *)0xFFC00A24);
		debugfs_create_x32("EBIU_DDRCTL2", 0600, parent, (u32 *)0xFFC00A28);
		debugfs_create_x32("EBIU_DDRCTL3", 0600, parent, (u32 *)0xFFC00A2C);
		debugfs_create_x32("EBIU_DDRGC0", 0600, parent, (u32 *)0xFFC00AB0);
		debugfs_create_x32("EBIU_DDRGC1", 0600, parent, (u32 *)0xFFC00AB4);
		debugfs_create_x32("EBIU_DDRGC2", 0600, parent, (u32 *)0xFFC00AB8);
		debugfs_create_x32("EBIU_DDRGC3", 0600, parent, (u32 *)0xFFC00ABC);
		debugfs_create_x32("EBIU_DDRMCCL", 0600, parent, (u32 *)0xFFC00AC4);
		debugfs_create_x32("EBIU_DDRMCEN", 0600, parent, (u32 *)0xFFC00AC0);
		debugfs_create_x32("EBIU_DDRQUE", 0600, parent, (u32 *)0xFFC00A30);
		debugfs_create_x32("EBIU_DDRTACT", 0600, parent, (u32 *)0xFFC00AA8);
		debugfs_create_x32("EBIU_ERRADD", 0600, parent, (u32 *)0xFFC00A34);
		debugfs_create_x16("EBIU_ERRMST", 0600, parent, (u16 *)0xFFC00A38);
		debugfs_create_x32("EBIU_FCTL", 0600, parent, (u32 *)0xFFC00A18);
		debugfs_create_x32("EBIU_MBSCTL", 0600, parent, (u32 *)0xFFC00A0C);
		debugfs_create_x32("EBIU_MODE", 0600, parent, (u32 *)0xFFC00A14);
		debugfs_create_x16("EBIU_RSTCTL", 0600, parent, (u16 *)0xFFC00A3C);

		parent = debugfs_create_dir("EPPI", top);
		debugfs_create_x32("EPPI1_CLIP", 0600, parent, (u32 *)0xFFC01334);
		debugfs_create_x16("EPPI1_CLKDIV", 0600, parent, (u16 *)0xFFC0131C);
		debugfs_create_x32("EPPI1_CONTROL", 0600, parent, (u32 *)0xFFC01320);
		debugfs_create_x16("EPPI1_FRAME", 0600, parent, (u16 *)0xFFC01314);
		debugfs_create_x32("EPPI1_FS1P_AVPL", 0600, parent, (u32 *)0xFFC01328);
		debugfs_create_x32("EPPI1_FS1W_HBL", 0600, parent, (u32 *)0xFFC01324);
		debugfs_create_x32("EPPI1_FS2P_LAVF", 0600, parent, (u32 *)0xFFC01330);
		debugfs_create_x32("EPPI1_FS2W_LVB", 0600, parent, (u32 *)0xFFC0132C);
		debugfs_create_x16("EPPI1_HCOUNT", 0600, parent, (u16 *)0xFFC01304);
		debugfs_create_x16("EPPI1_HDELAY", 0600, parent, (u16 *)0xFFC01308);
		debugfs_create_x16("EPPI1_LINE", 0600, parent, (u16 *)0xFFC01318);
		debugfs_create_x16("EPPI1_STATUS", 0600, parent, (u16 *)0xFFC01300);
		debugfs_create_x16("EPPI1_VCOUNT", 0600, parent, (u16 *)0xFFC0130C);
		debugfs_create_x16("EPPI1_VDELAY", 0600, parent, (u16 *)0xFFC01310);
		debugfs_create_x32("EPPI2_CLIP", 0600, parent, (u32 *)0xFFC02934);
		debugfs_create_x16("EPPI2_CLKDIV", 0600, parent, (u16 *)0xFFC0291C);
		debugfs_create_x32("EPPI2_CONTROL", 0600, parent, (u32 *)0xFFC02920);
		debugfs_create_x16("EPPI2_FRAME", 0600, parent, (u16 *)0xFFC02914);
		debugfs_create_x32("EPPI2_FS1P_AVPL", 0600, parent, (u32 *)0xFFC02928);
		debugfs_create_x32("EPPI2_FS1W_HBL", 0600, parent, (u32 *)0xFFC02924);
		debugfs_create_x32("EPPI2_FS2P_LAVF", 0600, parent, (u32 *)0xFFC02930);
		debugfs_create_x32("EPPI2_FS2W_LVB", 0600, parent, (u32 *)0xFFC0292C);
		debugfs_create_x16("EPPI2_HCOUNT", 0600, parent, (u16 *)0xFFC02904);
		debugfs_create_x16("EPPI2_HDELAY", 0600, parent, (u16 *)0xFFC02908);
		debugfs_create_x16("EPPI2_LINE", 0600, parent, (u16 *)0xFFC02918);
		debugfs_create_x16("EPPI2_STATUS", 0600, parent, (u16 *)0xFFC02900);
		debugfs_create_x16("EPPI2_VCOUNT", 0600, parent, (u16 *)0xFFC0290C);
		debugfs_create_x16("EPPI2_VDELAY", 0600, parent, (u16 *)0xFFC02910);

		parent = debugfs_create_dir("Event Vectors", top);
		debugfs_create_x32("EVT0", 0600, parent, (u32 *)0xFFE02000);
		debugfs_create_x32("EVT10", 0600, parent, (u32 *)0xFFE02028);
		debugfs_create_x32("EVT11", 0600, parent, (u32 *)0xFFE0202C);
		debugfs_create_x32("EVT12", 0600, parent, (u32 *)0xFFE02030);
		debugfs_create_x32("EVT13", 0600, parent, (u32 *)0xFFE02034);
		debugfs_create_x32("EVT14", 0600, parent, (u32 *)0xFFE02038);
		debugfs_create_x32("EVT15", 0600, parent, (u32 *)0xFFE0203C);
		debugfs_create_x32("EVT1", 0600, parent, (u32 *)0xFFE02004);
		debugfs_create_x32("EVT2", 0600, parent, (u32 *)0xFFE02008);
		debugfs_create_x32("EVT3", 0600, parent, (u32 *)0xFFE0200C);
		debugfs_create_x32("EVT4", 0600, parent, (u32 *)0xFFE02010);
		debugfs_create_x32("EVT5", 0600, parent, (u32 *)0xFFE02014);
		debugfs_create_x32("EVT6", 0600, parent, (u32 *)0xFFE02018);
		debugfs_create_x32("EVT7", 0600, parent, (u32 *)0xFFE0201C);
		debugfs_create_x32("EVT8", 0600, parent, (u32 *)0xFFE02020);
		debugfs_create_x32("EVT9", 0600, parent, (u32 *)0xFFE02024);

		parent = debugfs_create_dir("Extended Registers", top);
		debugfs_create_x32("CHIPID", 0600, parent, (u32 *)0xFFC00014);
		debugfs_create_x32("DSPID", 0600, parent, (u32 *)0xFFE05000);

		parent = debugfs_create_dir("HMDMA", top);
		debugfs_create_x16("HMDMA0_BCINIT", 0600, parent, (u16 *)0xFFC04508);
		debugfs_create_x16("HMDMA0_BCOUNT", 0600, parent, (u16 *)0xFFC04518);
		debugfs_create_x16("HMDMA0_CONTROL", 0600, parent, (u16 *)0xFFC04500);
		debugfs_create_x16("HMDMA0_ECINIT", 0600, parent, (u16 *)0xFFC04504);
		debugfs_create_x16("HMDMA0_ECOUNT", 0600, parent, (u16 *)0xFFC04514);
		debugfs_create_x16("HMDMA0_ECOVERFLOW", 0600, parent, (u16 *)0xFFC04510);
		debugfs_create_x16("HMDMA0_ECURGENT", 0600, parent, (u16 *)0xFFC0450C);
		debugfs_create_x16("HMDMA1_BCINIT", 0600, parent, (u16 *)0xFFC04548);
		debugfs_create_x16("HMDMA1_BCOUNT", 0600, parent, (u16 *)0xFFC04558);
		debugfs_create_x16("HMDMA1_CONTROL", 0600, parent, (u16 *)0xFFC04540);
		debugfs_create_x16("HMDMA1_ECINIT", 0600, parent, (u16 *)0xFFC04544);
		debugfs_create_x16("HMDMA1_ECOUNT", 0600, parent, (u16 *)0xFFC04554);
		debugfs_create_x16("HMDMA1_ECOVERFLOW", 0600, parent, (u16 *)0xFFC04550);
		debugfs_create_x16("HMDMA1_ECURGENT", 0600, parent, (u16 *)0xFFC0454C);

		parent = debugfs_create_dir("Interrupt Controller", top);
		debugfs_create_x32("ILAT", 0600, parent, (u32 *)0xFFE0210C);
		debugfs_create_x32("IMASK", 0600, parent, (u32 *)0xFFE02104);
		debugfs_create_x32("IPEND", 0600, parent, (u32 *)0xFFE02108);
		debugfs_create_x32("IPRIO", 0600, parent, (u32 *)0xFFE02110);

		parent = debugfs_create_dir("KEYPAD", top);
		debugfs_create_x16("KPAD_CTL", 0600, parent, (u16 *)0xFFC04100);
		debugfs_create_x16("KPAD_MSEL", 0600, parent, (u16 *)0xFFC04108);
		debugfs_create_x16("KPAD_PRESCALE", 0600, parent, (u16 *)0xFFC04104);
		debugfs_create_x16("KPAD_ROWCOL", 0600, parent, (u16 *)0xFFC0410C);
		debugfs_create_x16("KPAD_SOFTEVAL", 0600, parent, (u16 *)0xFFC04114);
		debugfs_create_x16("KPAD_STAT", 0600, parent, (u16 *)0xFFC04110);

		parent = debugfs_create_dir("L1 Code Memory Registers", top);
		debugfs_create_x32("ICPLB_ADDR0", 0600, parent, (u32 *)0xFFE01100);
		debugfs_create_x32("ICPLB_ADDR10", 0600, parent, (u32 *)0xFFE01128);
		debugfs_create_x32("ICPLB_ADDR11", 0600, parent, (u32 *)0xFFE0112C);
		debugfs_create_x32("ICPLB_ADDR12", 0600, parent, (u32 *)0xFFE01130);
		debugfs_create_x32("ICPLB_ADDR13", 0600, parent, (u32 *)0xFFE01134);
		debugfs_create_x32("ICPLB_ADDR14", 0600, parent, (u32 *)0xFFE01138);
		debugfs_create_x32("ICPLB_ADDR15", 0600, parent, (u32 *)0xFFE0113C);
		debugfs_create_x32("ICPLB_ADDR1", 0600, parent, (u32 *)0xFFE01104);
		debugfs_create_x32("ICPLB_ADDR2", 0600, parent, (u32 *)0xFFE01108);
		debugfs_create_x32("ICPLB_ADDR3", 0600, parent, (u32 *)0xFFE0110C);
		debugfs_create_x32("ICPLB_ADDR4", 0600, parent, (u32 *)0xFFE01110);
		debugfs_create_x32("ICPLB_ADDR5", 0600, parent, (u32 *)0xFFE01114);
		debugfs_create_x32("ICPLB_ADDR6", 0600, parent, (u32 *)0xFFE01118);
		debugfs_create_x32("ICPLB_ADDR7", 0600, parent, (u32 *)0xFFE0111C);
		debugfs_create_x32("ICPLB_ADDR8", 0600, parent, (u32 *)0xFFE01120);
		debugfs_create_x32("ICPLB_ADDR9", 0600, parent, (u32 *)0xFFE01124);
		debugfs_create_x32("ICPLB_DATA0", 0600, parent, (u32 *)0xFFE01200);
		debugfs_create_x32("ICPLB_DATA10", 0600, parent, (u32 *)0xFFE01228);
		debugfs_create_x32("ICPLB_DATA11", 0600, parent, (u32 *)0xFFE0122C);
		debugfs_create_x32("ICPLB_DATA12", 0600, parent, (u32 *)0xFFE01230);
		debugfs_create_x32("ICPLB_DATA13", 0600, parent, (u32 *)0xFFE01234);
		debugfs_create_x32("ICPLB_DATA14", 0600, parent, (u32 *)0xFFE01238);
		debugfs_create_x32("ICPLB_DATA15", 0600, parent, (u32 *)0xFFE0123C);
		debugfs_create_x32("ICPLB_DATA1", 0600, parent, (u32 *)0xFFE01204);
		debugfs_create_x32("ICPLB_DATA2", 0600, parent, (u32 *)0xFFE01208);
		debugfs_create_x32("ICPLB_DATA3", 0600, parent, (u32 *)0xFFE0120C);
		debugfs_create_x32("ICPLB_DATA4", 0600, parent, (u32 *)0xFFE01210);
		debugfs_create_x32("ICPLB_DATA5", 0600, parent, (u32 *)0xFFE01214);
		debugfs_create_x32("ICPLB_DATA6", 0600, parent, (u32 *)0xFFE01218);
		debugfs_create_x32("ICPLB_DATA7", 0600, parent, (u32 *)0xFFE0121C);
		debugfs_create_x32("ICPLB_DATA8", 0600, parent, (u32 *)0xFFE01220);
		debugfs_create_x32("ICPLB_DATA9", 0600, parent, (u32 *)0xFFE01224);
		debugfs_create_x32("ICPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0100C);
		debugfs_create_x32("ICPLB_STATUS", 0600, parent, (u32 *)0xFFE01008);
		debugfs_create_x32("IMEM_CONTROL", 0600, parent, (u32 *)0xFFE01004);
		debugfs_create_x32("ITEST_COMMAND", 0600, parent, (u32 *)0xFFE01300);
		debugfs_create_x32("ITEST_DATA0", 0600, parent, (u32 *)0xFFE01400);
		debugfs_create_x32("ITEST_DATA1", 0600, parent, (u32 *)0xFFE01404);

		parent = debugfs_create_dir("L1 Data Memory Registers", top);
		debugfs_create_x32("DCPLB_ADDR0", 0600, parent, (u32 *)0xFFE00100);
		debugfs_create_x32("DCPLB_ADDR10", 0600, parent, (u32 *)0xFFE00128);
		debugfs_create_x32("DCPLB_ADDR11", 0600, parent, (u32 *)0xFFE0012C);
		debugfs_create_x32("DCPLB_ADDR12", 0600, parent, (u32 *)0xFFE00130);
		debugfs_create_x32("DCPLB_ADDR13", 0600, parent, (u32 *)0xFFE00134);
		debugfs_create_x32("DCPLB_ADDR14", 0600, parent, (u32 *)0xFFE00138);
		debugfs_create_x32("DCPLB_ADDR15", 0600, parent, (u32 *)0xFFE0013C);
		debugfs_create_x32("DCPLB_ADDR1", 0600, parent, (u32 *)0xFFE00104);
		debugfs_create_x32("DCPLB_ADDR2", 0600, parent, (u32 *)0xFFE00108);
		debugfs_create_x32("DCPLB_ADDR3", 0600, parent, (u32 *)0xFFE0010C);
		debugfs_create_x32("DCPLB_ADDR4", 0600, parent, (u32 *)0xFFE00110);
		debugfs_create_x32("DCPLB_ADDR5", 0600, parent, (u32 *)0xFFE00114);
		debugfs_create_x32("DCPLB_ADDR6", 0600, parent, (u32 *)0xFFE00118);
		debugfs_create_x32("DCPLB_ADDR7", 0600, parent, (u32 *)0xFFE0011C);
		debugfs_create_x32("DCPLB_ADDR8", 0600, parent, (u32 *)0xFFE00120);
		debugfs_create_x32("DCPLB_ADDR9", 0600, parent, (u32 *)0xFFE00124);
		debugfs_create_x32("DCPLB_DATA0", 0600, parent, (u32 *)0xFFE00200);
		debugfs_create_x32("DCPLB_DATA10", 0600, parent, (u32 *)0xFFE00228);
		debugfs_create_x32("DCPLB_DATA11", 0600, parent, (u32 *)0xFFE0022C);
		debugfs_create_x32("DCPLB_DATA12", 0600, parent, (u32 *)0xFFE00230);
		debugfs_create_x32("DCPLB_DATA13", 0600, parent, (u32 *)0xFFE00234);
		debugfs_create_x32("DCPLB_DATA14", 0600, parent, (u32 *)0xFFE00238);
		debugfs_create_x32("DCPLB_DATA15", 0600, parent, (u32 *)0xFFE0023C);
		debugfs_create_x32("DCPLB_DATA1", 0600, parent, (u32 *)0xFFE00204);
		debugfs_create_x32("DCPLB_DATA2", 0600, parent, (u32 *)0xFFE00208);
		debugfs_create_x32("DCPLB_DATA3", 0600, parent, (u32 *)0xFFE0020C);
		debugfs_create_x32("DCPLB_DATA4", 0600, parent, (u32 *)0xFFE00210);
		debugfs_create_x32("DCPLB_DATA5", 0600, parent, (u32 *)0xFFE00214);
		debugfs_create_x32("DCPLB_DATA6", 0600, parent, (u32 *)0xFFE00218);
		debugfs_create_x32("DCPLB_DATA7", 0600, parent, (u32 *)0xFFE0021C);
		debugfs_create_x32("DCPLB_DATA8", 0600, parent, (u32 *)0xFFE00220);
		debugfs_create_x32("DCPLB_DATA9", 0600, parent, (u32 *)0xFFE00224);
		debugfs_create_x32("DCPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0000C);
		debugfs_create_x32("DCPLB_STATUS", 0600, parent, (u32 *)0xFFE00008);
		debugfs_create_x32("DMEM_CONTROL", 0600, parent, (u32 *)0xFFE00004);
		debugfs_create_x32("DTEST_COMMAND", 0600, parent, (u32 *)0xFFE00300);
		debugfs_create_x32("DTEST_DATA0", 0600, parent, (u32 *)0xFFE00400);
		debugfs_create_x32("DTEST_DATA1", 0600, parent, (u32 *)0xFFE00404);
		debugfs_create_x32("SRAM_BASE_ADDR", 0600, parent, (u32 *)0xFFE00000);

		parent = debugfs_create_dir("MDMA", top);
		debugfs_create_x16("MDMA_D0_CONFIG", 0600, parent, (u16 *)0xFFC00F08);
		debugfs_create_x32("MDMA_D0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F24);
		debugfs_create_x32("MDMA_D0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F20);
		debugfs_create_x16("MDMA_D0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F30);
		debugfs_create_x16("MDMA_D0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F38);
		debugfs_create_x16("MDMA_D0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F28);
		debugfs_create_x32("MDMA_D0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F00);
		debugfs_create_x16("MDMA_D0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F2C);
		debugfs_create_x32("MDMA_D0_START_ADDR", 0600, parent, (u32 *)0xFFC00F04);
		debugfs_create_x16("MDMA_D0_X_COUNT", 0600, parent, (u16 *)0xFFC00F10);
		debugfs_create_x16("MDMA_D0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F14);
		debugfs_create_x16("MDMA_D0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F18);
		debugfs_create_x16("MDMA_D0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F1C);
		debugfs_create_x16("MDMA_D1_CONFIG", 0600, parent, (u16 *)0xFFC00F88);
		debugfs_create_x32("MDMA_D1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FA4);
		debugfs_create_x32("MDMA_D1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FA0);
		debugfs_create_x16("MDMA_D1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FB0);
		debugfs_create_x16("MDMA_D1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FB8);
		debugfs_create_x16("MDMA_D1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FA8);
		debugfs_create_x32("MDMA_D1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F80);
		debugfs_create_x16("MDMA_D1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FAC);
		debugfs_create_x32("MDMA_D1_START_ADDR", 0600, parent, (u32 *)0xFFC00F84);
		debugfs_create_x16("MDMA_D1_X_COUNT", 0600, parent, (u16 *)0xFFC00F90);
		debugfs_create_x16("MDMA_D1_X_MODIFY", 0600, parent, (u16 *)0xFFC00F94);
		debugfs_create_x16("MDMA_D1_Y_COUNT", 0600, parent, (u16 *)0xFFC00F98);
		debugfs_create_x16("MDMA_D1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F9C);
		debugfs_create_x16("MDMA_D2_CONFIG", 0600, parent, (u16 *)0xFFC01F08);
		debugfs_create_x32("MDMA_D2_CURR_ADDR", 0600, parent, (u32 *)0xFFC01F24);
		debugfs_create_x32("MDMA_D2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01F20);
		debugfs_create_x16("MDMA_D2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01F30);
		debugfs_create_x16("MDMA_D2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01F38);
		debugfs_create_x16("MDMA_D2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01F28);
		debugfs_create_x32("MDMA_D2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01F00);
		debugfs_create_x16("MDMA_D2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01F2C);
		debugfs_create_x32("MDMA_D2_START_ADDR", 0600, parent, (u32 *)0xFFC01F04);
		debugfs_create_x16("MDMA_D2_X_COUNT", 0600, parent, (u16 *)0xFFC01F10);
		debugfs_create_x16("MDMA_D2_X_MODIFY", 0600, parent, (u16 *)0xFFC01F14);
		debugfs_create_x16("MDMA_D2_Y_COUNT", 0600, parent, (u16 *)0xFFC01F18);
		debugfs_create_x16("MDMA_D2_Y_MODIFY", 0600, parent, (u16 *)0xFFC01F1C);
		debugfs_create_x16("MDMA_D3_CONFIG", 0600, parent, (u16 *)0xFFC01F88);
		debugfs_create_x32("MDMA_D3_CURR_ADDR", 0600, parent, (u32 *)0xFFC01FA4);
		debugfs_create_x32("MDMA_D3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01FA0);
		debugfs_create_x16("MDMA_D3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01FB0);
		debugfs_create_x16("MDMA_D3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01FB8);
		debugfs_create_x16("MDMA_D3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01FA8);
		debugfs_create_x32("MDMA_D3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01F80);
		debugfs_create_x16("MDMA_D3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01FAC);
		debugfs_create_x32("MDMA_D3_START_ADDR", 0600, parent, (u32 *)0xFFC01F84);
		debugfs_create_x16("MDMA_D3_X_COUNT", 0600, parent, (u16 *)0xFFC01F90);
		debugfs_create_x16("MDMA_D3_X_MODIFY", 0600, parent, (u16 *)0xFFC01F94);
		debugfs_create_x16("MDMA_D3_Y_COUNT", 0600, parent, (u16 *)0xFFC01F98);
		debugfs_create_x16("MDMA_D3_Y_MODIFY", 0600, parent, (u16 *)0xFFC01F9C);
		debugfs_create_x16("MDMA_S0_CONFIG", 0600, parent, (u16 *)0xFFC00F48);
		debugfs_create_x32("MDMA_S0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F64);
		debugfs_create_x32("MDMA_S0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F60);
		debugfs_create_x16("MDMA_S0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F70);
		debugfs_create_x16("MDMA_S0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F78);
		debugfs_create_x16("MDMA_S0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F68);
		debugfs_create_x32("MDMA_S0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F40);
		debugfs_create_x16("MDMA_S0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F6C);
		debugfs_create_x32("MDMA_S0_START_ADDR", 0600, parent, (u32 *)0xFFC00F44);
		debugfs_create_x16("MDMA_S0_X_COUNT", 0600, parent, (u16 *)0xFFC00F50);
		debugfs_create_x16("MDMA_S0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F54);
		debugfs_create_x16("MDMA_S0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F58);
		debugfs_create_x16("MDMA_S0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F5C);
		debugfs_create_x16("MDMA_S1_CONFIG", 0600, parent, (u16 *)0xFFC00FC8);
		debugfs_create_x32("MDMA_S1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FE4);
		debugfs_create_x32("MDMA_S1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FE0);
		debugfs_create_x16("MDMA_S1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FF0);
		debugfs_create_x16("MDMA_S1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FF8);
		debugfs_create_x16("MDMA_S1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FE8);
		debugfs_create_x32("MDMA_S1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00FC0);
		debugfs_create_x16("MDMA_S1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FEC);
		debugfs_create_x32("MDMA_S1_START_ADDR", 0600, parent, (u32 *)0xFFC00FC4);
		debugfs_create_x16("MDMA_S1_X_COUNT", 0600, parent, (u16 *)0xFFC00FD0);
		debugfs_create_x16("MDMA_S1_X_MODIFY", 0600, parent, (u16 *)0xFFC00FD4);
		debugfs_create_x16("MDMA_S1_Y_COUNT", 0600, parent, (u16 *)0xFFC00FD8);
		debugfs_create_x16("MDMA_S1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00FDC);
		debugfs_create_x16("MDMA_S2_CONFIG", 0600, parent, (u16 *)0xFFC01F48);
		debugfs_create_x32("MDMA_S2_CURR_ADDR", 0600, parent, (u32 *)0xFFC01F64);
		debugfs_create_x32("MDMA_S2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01F60);
		debugfs_create_x16("MDMA_S2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01F70);
		debugfs_create_x16("MDMA_S2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01F78);
		debugfs_create_x16("MDMA_S2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01F68);
		debugfs_create_x32("MDMA_S2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01F40);
		debugfs_create_x16("MDMA_S2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01F6C);
		debugfs_create_x32("MDMA_S2_START_ADDR", 0600, parent, (u32 *)0xFFC01F44);
		debugfs_create_x16("MDMA_S2_X_COUNT", 0600, parent, (u16 *)0xFFC01F50);
		debugfs_create_x16("MDMA_S2_X_MODIFY", 0600, parent, (u16 *)0xFFC01F54);
		debugfs_create_x16("MDMA_S2_Y_COUNT", 0600, parent, (u16 *)0xFFC01F58);
		debugfs_create_x16("MDMA_S2_Y_MODIFY", 0600, parent, (u16 *)0xFFC01F5C);
		debugfs_create_x16("MDMA_S3_CONFIG", 0600, parent, (u16 *)0xFFC01FC8);
		debugfs_create_x32("MDMA_S3_CURR_ADDR", 0600, parent, (u32 *)0xFFC01FE4);
		debugfs_create_x32("MDMA_S3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01FE0);
		debugfs_create_x16("MDMA_S3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01FF0);
		debugfs_create_x16("MDMA_S3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01FF8);
		debugfs_create_x16("MDMA_S3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01FE8);
		debugfs_create_x32("MDMA_S3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01FC0);
		debugfs_create_x16("MDMA_S3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01FEC);
		debugfs_create_x32("MDMA_S3_START_ADDR", 0600, parent, (u32 *)0xFFC01FC4);
		debugfs_create_x16("MDMA_S3_X_COUNT", 0600, parent, (u16 *)0xFFC01FD0);
		debugfs_create_x16("MDMA_S3_X_MODIFY", 0600, parent, (u16 *)0xFFC01FD4);
		debugfs_create_x16("MDMA_S3_Y_COUNT", 0600, parent, (u16 *)0xFFC01FD8);
		debugfs_create_x16("MDMA_S3_Y_MODIFY", 0600, parent, (u16 *)0xFFC01FDC);

		parent = debugfs_create_dir("NFC", top);
		debugfs_create_x16("NFC_ADDR", 0600, parent, (u16 *)0xFFC03B40);
		debugfs_create_x16("NFC_CMD", 0600, parent, (u16 *)0xFFC03B44);
		debugfs_create_x16("NFC_COUNT", 0600, parent, (u16 *)0xFFC03B20);
		debugfs_create_x16("NFC_CTL", 0600, parent, (u16 *)0xFFC03B00);
		debugfs_create_x16("NFC_DATA_RD", 0600, parent, (u16 *)0xFFC03B4C);
		debugfs_create_x16("NFC_DATA_WR", 0600, parent, (u16 *)0xFFC03B48);
		debugfs_create_x16("NFC_ECC0", 0600, parent, (u16 *)0xFFC03B10);
		debugfs_create_x16("NFC_ECC1", 0600, parent, (u16 *)0xFFC03B14);
		debugfs_create_x16("NFC_ECC2", 0600, parent, (u16 *)0xFFC03B18);
		debugfs_create_x16("NFC_ECC3", 0600, parent, (u16 *)0xFFC03B1C);
		debugfs_create_x16("NFC_IRQMASK", 0600, parent, (u16 *)0xFFC03B0C);
		debugfs_create_x16("NFC_IRQSTAT", 0600, parent, (u16 *)0xFFC03B08);
		debugfs_create_x16("NFC_PGCTL", 0600, parent, (u16 *)0xFFC03B28);
		debugfs_create_x16("NFC_READ", 0600, parent, (u16 *)0xFFC03B2C);
		debugfs_create_x16("NFC_RST", 0600, parent, (u16 *)0xFFC03B24);
		debugfs_create_x16("NFC_STAT", 0600, parent, (u16 *)0xFFC03B04);

		parent = debugfs_create_dir("OTP", top);
		debugfs_create_x16("OTP_BEN", 0600, parent, (u16 *)0xFFC04304);
		debugfs_create_x16("OTP_CONTROL", 0600, parent, (u16 *)0xFFC04300);
		debugfs_create_x32("OTP_DATA0", 0600, parent, (u32 *)0xFFC04380);
		debugfs_create_x32("OTP_DATA1", 0600, parent, (u32 *)0xFFC04384);
		debugfs_create_x32("OTP_DATA2", 0600, parent, (u32 *)0xFFC04388);
		debugfs_create_x32("OTP_DATA3", 0600, parent, (u32 *)0xFFC0438C);
		debugfs_create_x16("OTP_STATUS", 0600, parent, (u16 *)0xFFC04308);
		debugfs_create_x32("OTP_TIMING", 0600, parent, (u32 *)0xFFC0430C);

		parent = debugfs_create_dir("PINT_0", top);
		debugfs_create_x32("PINT0_ASSIGN", 0600, parent, (u32 *)0xFFC0140C);
		debugfs_create_x32("PINT0_EDGE_CLEAR", 0600, parent, (u32 *)0xFFC01414);
		debugfs_create_x32("PINT0_EDGE_SET", 0600, parent, (u32 *)0xFFC01410);
		debugfs_create_x32("PINT0_INVERT_CLEAR", 0600, parent, (u32 *)0xFFC0141C);
		debugfs_create_x32("PINT0_INVERT_SET", 0600, parent, (u32 *)0xFFC01418);
		debugfs_create_x32("PINT0_IRQ", 0600, parent, (u32 *)0xFFC01408);
		debugfs_create_x32("PINT0_LATCH", 0600, parent, (u32 *)0xFFC01424);
		debugfs_create_x32("PINT0_MASK_CLEAR", 0600, parent, (u32 *)0xFFC01404);
		debugfs_create_x32("PINT0_MASK_SET", 0600, parent, (u32 *)0xFFC01400);
		debugfs_create_x32("PINT0_PINSTATE", 0600, parent, (u32 *)0xFFC01420);

		parent = debugfs_create_dir("PINT_1", top);
		debugfs_create_x32("PINT1_ASSIGN", 0600, parent, (u32 *)0xFFC0143C);
		debugfs_create_x32("PINT1_EDGE_CLEAR", 0600, parent, (u32 *)0xFFC01444);
		debugfs_create_x32("PINT1_EDGE_SET", 0600, parent, (u32 *)0xFFC01440);
		debugfs_create_x32("PINT1_INVERT_CLEAR", 0600, parent, (u32 *)0xFFC0144C);
		debugfs_create_x32("PINT1_INVERT_SET", 0600, parent, (u32 *)0xFFC01448);
		debugfs_create_x32("PINT1_IRQ", 0600, parent, (u32 *)0xFFC01438);
		debugfs_create_x32("PINT1_LATCH", 0600, parent, (u32 *)0xFFC01454);
		debugfs_create_x32("PINT1_MASK_CLEAR", 0600, parent, (u32 *)0xFFC01434);
		debugfs_create_x32("PINT1_MASK_SET", 0600, parent, (u32 *)0xFFC01430);
		debugfs_create_x32("PINT1_PINSTATE", 0600, parent, (u32 *)0xFFC01450);

		parent = debugfs_create_dir("PINT_2", top);
		debugfs_create_x32("PINT2_ASSIGN", 0600, parent, (u32 *)0xFFC0146C);
		debugfs_create_x32("PINT2_EDGE_CLEAR", 0600, parent, (u32 *)0xFFC01474);
		debugfs_create_x32("PINT2_EDGE_SET", 0600, parent, (u32 *)0xFFC01470);
		debugfs_create_x32("PINT2_INVERT_CLEAR", 0600, parent, (u32 *)0xFFC0147C);
		debugfs_create_x32("PINT2_INVERT_SET", 0600, parent, (u32 *)0xFFC01478);
		debugfs_create_x32("PINT2_IRQ", 0600, parent, (u32 *)0xFFC01468);
		debugfs_create_x32("PINT2_LATCH", 0600, parent, (u32 *)0xFFC01484);
		debugfs_create_x32("PINT2_MASK_CLEAR", 0600, parent, (u32 *)0xFFC01464);
		debugfs_create_x32("PINT2_MASK_SET", 0600, parent, (u32 *)0xFFC01460);
		debugfs_create_x32("PINT2_PINSTATE", 0600, parent, (u32 *)0xFFC01480);

		parent = debugfs_create_dir("PINT_3", top);
		debugfs_create_x32("PINT3_ASSIGN", 0600, parent, (u32 *)0xFFC0149C);
		debugfs_create_x32("PINT3_EDGE_CLEAR", 0600, parent, (u32 *)0xFFC014A4);
		debugfs_create_x32("PINT3_EDGE_SET", 0600, parent, (u32 *)0xFFC014A0);
		debugfs_create_x32("PINT3_INVERT_CLEAR", 0600, parent, (u32 *)0xFFC014AC);
		debugfs_create_x32("PINT3_INVERT_SET", 0600, parent, (u32 *)0xFFC014A8);
		debugfs_create_x32("PINT3_IRQ", 0600, parent, (u32 *)0xFFC01498);
		debugfs_create_x32("PINT3_LATCH", 0600, parent, (u32 *)0xFFC014B4);
		debugfs_create_x32("PINT3_MASK_CLEAR", 0600, parent, (u32 *)0xFFC01494);
		debugfs_create_x32("PINT3_MASK_SET", 0600, parent, (u32 *)0xFFC01490);
		debugfs_create_x32("PINT3_PINSTATE", 0600, parent, (u32 *)0xFFC014B0);

		parent = debugfs_create_dir("PLL", top);
		debugfs_create_x16("PLL_CTL", 0600, parent, (u16 *)0xFFC00000);
		debugfs_create_x16("PLL_DIV", 0600, parent, (u16 *)0xFFC00004);
		debugfs_create_x16("PLL_LOCKCNT", 0600, parent, (u16 *)0xFFC00010);
		debugfs_create_x16("PLL_STAT", 0600, parent, (u16 *)0xFFC0000C);
		debugfs_create_x16("VR_CTL", 0600, parent, (u16 *)0xFFC00008);

		parent = debugfs_create_dir("PWM_TMR", top);
		debugfs_create_x16("TIMER0_CONFIG", 0600, parent, (u16 *)0xFFC01600);
		debugfs_create_x32("TIMER0_COUNTER", 0600, parent, (u32 *)0xFFC01604);
		debugfs_create_x32("TIMER0_PERIOD", 0600, parent, (u32 *)0xFFC01608);
		debugfs_create_x32("TIMER0_WIDTH", 0600, parent, (u32 *)0xFFC0160C);
		debugfs_create_x16("TIMER1_CONFIG", 0600, parent, (u16 *)0xFFC01610);
		debugfs_create_x32("TIMER1_COUNTER", 0600, parent, (u32 *)0xFFC01614);
		debugfs_create_x32("TIMER1_PERIOD", 0600, parent, (u32 *)0xFFC01618);
		debugfs_create_x32("TIMER1_WIDTH", 0600, parent, (u32 *)0xFFC0161C);
		debugfs_create_x16("TIMER2_CONFIG", 0600, parent, (u16 *)0xFFC01620);
		debugfs_create_x32("TIMER2_COUNTER", 0600, parent, (u32 *)0xFFC01624);
		debugfs_create_x32("TIMER2_PERIOD", 0600, parent, (u32 *)0xFFC01628);
		debugfs_create_x32("TIMER2_WIDTH", 0600, parent, (u32 *)0xFFC0162C);
		debugfs_create_x16("TIMER3_CONFIG", 0600, parent, (u16 *)0xFFC01630);
		debugfs_create_x32("TIMER3_COUNTER", 0600, parent, (u32 *)0xFFC01634);
		debugfs_create_x32("TIMER3_PERIOD", 0600, parent, (u32 *)0xFFC01638);
		debugfs_create_x32("TIMER3_WIDTH", 0600, parent, (u32 *)0xFFC0163C);
		debugfs_create_x16("TIMER4_CONFIG", 0600, parent, (u16 *)0xFFC01640);
		debugfs_create_x32("TIMER4_COUNTER", 0600, parent, (u32 *)0xFFC01644);
		debugfs_create_x32("TIMER4_PERIOD", 0600, parent, (u32 *)0xFFC01648);
		debugfs_create_x32("TIMER4_WIDTH", 0600, parent, (u32 *)0xFFC0164C);
		debugfs_create_x16("TIMER5_CONFIG", 0600, parent, (u16 *)0xFFC01650);
		debugfs_create_x32("TIMER5_COUNTER", 0600, parent, (u32 *)0xFFC01654);
		debugfs_create_x32("TIMER5_PERIOD", 0600, parent, (u32 *)0xFFC01658);
		debugfs_create_x32("TIMER5_WIDTH", 0600, parent, (u32 *)0xFFC0165C);
		debugfs_create_x16("TIMER6_CONFIG", 0600, parent, (u16 *)0xFFC01660);
		debugfs_create_x32("TIMER6_COUNTER", 0600, parent, (u32 *)0xFFC01664);
		debugfs_create_x32("TIMER6_PERIOD", 0600, parent, (u32 *)0xFFC01668);
		debugfs_create_x32("TIMER6_WIDTH", 0600, parent, (u32 *)0xFFC0166C);
		debugfs_create_x16("TIMER7_CONFIG", 0600, parent, (u16 *)0xFFC01670);
		debugfs_create_x32("TIMER7_COUNTER", 0600, parent, (u32 *)0xFFC01674);
		debugfs_create_x32("TIMER7_PERIOD", 0600, parent, (u32 *)0xFFC01678);
		debugfs_create_x32("TIMER7_WIDTH", 0600, parent, (u32 *)0xFFC0167C);
		debugfs_create_x16("TIMER_DISABLE0", 0600, parent, (u16 *)0xFFC01684);
		debugfs_create_x16("TIMER_ENABLE0", 0600, parent, (u16 *)0xFFC01680);
		debugfs_create_x32("TIMER_STATUS0", 0600, parent, (u32 *)0xFFC01688);

		parent = debugfs_create_dir("Port_A", top);
		debugfs_create_x16("PORTA", 0600, parent, (u16 *)0xFFC014C4);
		debugfs_create_x16("PORTA_CLEAR", 0600, parent, (u16 *)0xFFC014CC);
		debugfs_create_x16("PORTA_DIR_CLEAR", 0600, parent, (u16 *)0xFFC014D4);
		debugfs_create_x16("PORTA_DIR_SET", 0600, parent, (u16 *)0xFFC014D0);
		debugfs_create_x16("PORTA_FER", 0600, parent, (u16 *)0xFFC014C0);
		debugfs_create_x16("PORTA_INEN", 0600, parent, (u16 *)0xFFC014D8);
		debugfs_create_x32("PORTA_MUX", 0600, parent, (u32 *)0xFFC014DC);
		debugfs_create_x16("PORTA_SET", 0600, parent, (u16 *)0xFFC014C8);

		parent = debugfs_create_dir("Port_B", top);
		debugfs_create_x16("PORTB", 0600, parent, (u16 *)0xFFC014E4);
		debugfs_create_x16("PORTB_CLEAR", 0600, parent, (u16 *)0xFFC014EC);
		debugfs_create_x16("PORTB_DIR_CLEAR", 0600, parent, (u16 *)0xFFC014F4);
		debugfs_create_x16("PORTB_DIR_SET", 0600, parent, (u16 *)0xFFC014F0);
		debugfs_create_x16("PORTB_FER", 0600, parent, (u16 *)0xFFC014E0);
		debugfs_create_x16("PORTB_INEN", 0600, parent, (u16 *)0xFFC014F8);
		debugfs_create_x32("PORTB_MUX", 0600, parent, (u32 *)0xFFC014FC);
		debugfs_create_x16("PORTB_SET", 0600, parent, (u16 *)0xFFC014E8);

		parent = debugfs_create_dir("Port_C", top);
		debugfs_create_x16("PORTC", 0600, parent, (u16 *)0xFFC01504);
		debugfs_create_x16("PORTC_CLEAR", 0600, parent, (u16 *)0xFFC0150C);
		debugfs_create_x16("PORTC_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01514);
		debugfs_create_x16("PORTC_DIR_SET", 0600, parent, (u16 *)0xFFC01510);
		debugfs_create_x16("PORTC_FER", 0600, parent, (u16 *)0xFFC01500);
		debugfs_create_x16("PORTC_INEN", 0600, parent, (u16 *)0xFFC01518);
		debugfs_create_x32("PORTC_MUX", 0600, parent, (u32 *)0xFFC0151C);
		debugfs_create_x16("PORTC_SET", 0600, parent, (u16 *)0xFFC01508);

		parent = debugfs_create_dir("Port_D", top);
		debugfs_create_x16("PORTD", 0600, parent, (u16 *)0xFFC01524);
		debugfs_create_x16("PORTD_CLEAR", 0600, parent, (u16 *)0xFFC0152C);
		debugfs_create_x16("PORTD_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01534);
		debugfs_create_x16("PORTD_DIR_SET", 0600, parent, (u16 *)0xFFC01530);
		debugfs_create_x16("PORTD_FER", 0600, parent, (u16 *)0xFFC01520);
		debugfs_create_x16("PORTD_INEN", 0600, parent, (u16 *)0xFFC01538);
		debugfs_create_x32("PORTD_MUX", 0600, parent, (u32 *)0xFFC0153C);
		debugfs_create_x16("PORTD_SET", 0600, parent, (u16 *)0xFFC01528);

		parent = debugfs_create_dir("Port_E", top);
		debugfs_create_x16("PORTE", 0600, parent, (u16 *)0xFFC01544);
		debugfs_create_x16("PORTE_CLEAR", 0600, parent, (u16 *)0xFFC0154C);
		debugfs_create_x16("PORTE_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01554);
		debugfs_create_x16("PORTE_DIR_SET", 0600, parent, (u16 *)0xFFC01550);
		debugfs_create_x16("PORTE_FER", 0600, parent, (u16 *)0xFFC01540);
		debugfs_create_x16("PORTE_INEN", 0600, parent, (u16 *)0xFFC01558);
		debugfs_create_x32("PORTE_MUX", 0600, parent, (u32 *)0xFFC0155C);
		debugfs_create_x16("PORTE_SET", 0600, parent, (u16 *)0xFFC01548);

		parent = debugfs_create_dir("Port_F", top);
		debugfs_create_x16("PORTF", 0600, parent, (u16 *)0xFFC01564);
		debugfs_create_x16("PORTF_CLEAR", 0600, parent, (u16 *)0xFFC0156C);
		debugfs_create_x16("PORTF_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01574);
		debugfs_create_x16("PORTF_DIR_SET", 0600, parent, (u16 *)0xFFC01570);
		debugfs_create_x16("PORTF_FER", 0600, parent, (u16 *)0xFFC01560);
		debugfs_create_x16("PORTF_INEN", 0600, parent, (u16 *)0xFFC01578);
		debugfs_create_x32("PORTF_MUX", 0600, parent, (u32 *)0xFFC0157C);
		debugfs_create_x16("PORTF_SET", 0600, parent, (u16 *)0xFFC01568);

		parent = debugfs_create_dir("Port_G", top);
		debugfs_create_x16("PORTG", 0600, parent, (u16 *)0xFFC01584);
		debugfs_create_x16("PORTG_CLEAR", 0600, parent, (u16 *)0xFFC0158C);
		debugfs_create_x16("PORTG_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01594);
		debugfs_create_x16("PORTG_DIR_SET", 0600, parent, (u16 *)0xFFC01590);
		debugfs_create_x16("PORTG_FER", 0600, parent, (u16 *)0xFFC01580);
		debugfs_create_x16("PORTG_INEN", 0600, parent, (u16 *)0xFFC01598);
		debugfs_create_x32("PORTG_MUX", 0600, parent, (u32 *)0xFFC0159C);
		debugfs_create_x16("PORTG_SET", 0600, parent, (u16 *)0xFFC01588);

		parent = debugfs_create_dir("Port_H", top);
		debugfs_create_x16("PORTH", 0600, parent, (u16 *)0xFFC015A4);
		debugfs_create_x16("PORTH_CLEAR", 0600, parent, (u16 *)0xFFC015AC);
		debugfs_create_x16("PORTH_DIR_CLEAR", 0600, parent, (u16 *)0xFFC015B4);
		debugfs_create_x16("PORTH_DIR_SET", 0600, parent, (u16 *)0xFFC015B0);
		debugfs_create_x16("PORTH_FER", 0600, parent, (u16 *)0xFFC015A0);
		debugfs_create_x16("PORTH_INEN", 0600, parent, (u16 *)0xFFC015B8);
		debugfs_create_x32("PORTH_MUX", 0600, parent, (u32 *)0xFFC015BC);
		debugfs_create_x16("PORTH_SET", 0600, parent, (u16 *)0xFFC015A8);

		parent = debugfs_create_dir("Port_I", top);
		debugfs_create_x16("PORTI", 0600, parent, (u16 *)0xFFC015C4);
		debugfs_create_x16("PORTI_CLEAR", 0600, parent, (u16 *)0xFFC015CC);
		debugfs_create_x16("PORTI_DIR_CLEAR", 0600, parent, (u16 *)0xFFC015D4);
		debugfs_create_x16("PORTI_DIR_SET", 0600, parent, (u16 *)0xFFC015D0);
		debugfs_create_x16("PORTI_FER", 0600, parent, (u16 *)0xFFC015C0);
		debugfs_create_x16("PORTI_INEN", 0600, parent, (u16 *)0xFFC015D8);
		debugfs_create_x32("PORTI_MUX", 0600, parent, (u32 *)0xFFC015DC);
		debugfs_create_x16("PORTI_SET", 0600, parent, (u16 *)0xFFC015C8);

		parent = debugfs_create_dir("Port_J", top);
		debugfs_create_x16("PORTJ", 0600, parent, (u16 *)0xFFC015E4);
		debugfs_create_x16("PORTJ_CLEAR", 0600, parent, (u16 *)0xFFC015EC);
		debugfs_create_x16("PORTJ_DIR_CLEAR", 0600, parent, (u16 *)0xFFC015F4);
		debugfs_create_x16("PORTJ_DIR_SET", 0600, parent, (u16 *)0xFFC015F0);
		debugfs_create_x16("PORTJ_FER", 0600, parent, (u16 *)0xFFC015E0);
		debugfs_create_x16("PORTJ_INEN", 0600, parent, (u16 *)0xFFC015F8);
		debugfs_create_x32("PORTJ_MUX", 0600, parent, (u32 *)0xFFC015FC);
		debugfs_create_x16("PORTJ_SET", 0600, parent, (u16 *)0xFFC015E8);

		parent = debugfs_create_dir("RTC", top);
		debugfs_create_x32("RTC_ALARM", 0600, parent, (u32 *)0xFFC00310);
		debugfs_create_x16("RTC_ICTL", 0600, parent, (u16 *)0xFFC00304);
		debugfs_create_x16("RTC_ISTAT", 0600, parent, (u16 *)0xFFC00308);
		debugfs_create_x16("RTC_PREN", 0600, parent, (u16 *)0xFFC00314);
		debugfs_create_x32("RTC_STAT", 0600, parent, (u32 *)0xFFC00300);
		debugfs_create_x16("RTC_SWCNT", 0600, parent, (u16 *)0xFFC0030C);

		parent = debugfs_create_dir("SDH", top);
		debugfs_create_x32("SDH_ARGUMENT", 0600, parent, (u32 *)0xFFC03908);
		debugfs_create_x16("SDH_CFG", 0600, parent, (u16 *)0xFFC039C8);
		debugfs_create_x16("SDH_CLK_CTL", 0600, parent, (u16 *)0xFFC03904);
		debugfs_create_x16("SDH_COMMAND", 0600, parent, (u16 *)0xFFC0390C);
		debugfs_create_x16("SDH_DATA_CNT", 0600, parent, (u16 *)0xFFC03930);
		debugfs_create_x16("SDH_DATA_CTL", 0600, parent, (u16 *)0xFFC0392C);
		debugfs_create_x16("SDH_DATA_LGTH", 0600, parent, (u16 *)0xFFC03928);
		debugfs_create_x32("SDH_DATA_TIMER", 0600, parent, (u32 *)0xFFC03924);
		debugfs_create_x16("SDH_E_MASK", 0600, parent, (u16 *)0xFFC039C4);
		debugfs_create_x16("SDH_E_STATUS", 0600, parent, (u16 *)0xFFC039C0);
		debugfs_create_x32("SDH_FIFO", 0600, parent, (u32 *)0xFFC03980);
		debugfs_create_x16("SDH_FIFO_CNT", 0600, parent, (u16 *)0xFFC03948);
		debugfs_create_x32("SDH_MASK0", 0600, parent, (u32 *)0xFFC0393C);
		debugfs_create_x32("SDH_MASK1", 0600, parent, (u32 *)0xFFC03940);
		debugfs_create_x16("SDH_PID0", 0600, parent, (u16 *)0xFFC039D0);
		debugfs_create_x16("SDH_PID1", 0600, parent, (u16 *)0xFFC039D4);
		debugfs_create_x16("SDH_PID2", 0600, parent, (u16 *)0xFFC039D8);
		debugfs_create_x16("SDH_PID3", 0600, parent, (u16 *)0xFFC039DC);
		debugfs_create_x16("SDH_PID4", 0600, parent, (u16 *)0xFFC039E0);
		debugfs_create_x16("SDH_PID5", 0600, parent, (u16 *)0xFFC039E4);
		debugfs_create_x16("SDH_PID6", 0600, parent, (u16 *)0xFFC039E8);
		debugfs_create_x16("SDH_PID7", 0600, parent, (u16 *)0xFFC039EC);
		debugfs_create_x16("SDH_PWR_CTL", 0600, parent, (u16 *)0xFFC03900);
		debugfs_create_x16("SDH_RD_WAIT_EN", 0600, parent, (u16 *)0xFFC039CC);
		debugfs_create_x32("SDH_RESPONSE0", 0600, parent, (u32 *)0xFFC03914);
		debugfs_create_x32("SDH_RESPONSE1", 0600, parent, (u32 *)0xFFC03918);
		debugfs_create_x32("SDH_RESPONSE2", 0600, parent, (u32 *)0xFFC0391C);
		debugfs_create_x32("SDH_RESPONSE3", 0600, parent, (u32 *)0xFFC03920);
		debugfs_create_x16("SDH_RESP_CMD", 0600, parent, (u16 *)0xFFC03910);
		debugfs_create_x32("SDH_STATUS", 0600, parent, (u32 *)0xFFC03934);
		debugfs_create_x16("SDH_STATUS_CLR", 0600, parent, (u16 *)0xFFC03938);

		parent = debugfs_create_dir("SIC", top);
		debugfs_create_x32("SIC_IAR0", 0600, parent, (u32 *)0xFFC00130);
		debugfs_create_x32("SIC_IAR10", 0600, parent, (u32 *)0xFFC00158);
		debugfs_create_x32("SIC_IAR11", 0600, parent, (u32 *)0xFFC0015C);
		debugfs_create_x32("SIC_IAR1", 0600, parent, (u32 *)0xFFC00134);
		debugfs_create_x32("SIC_IAR2", 0600, parent, (u32 *)0xFFC00138);
		debugfs_create_x32("SIC_IAR3", 0600, parent, (u32 *)0xFFC0013C);
		debugfs_create_x32("SIC_IAR4", 0600, parent, (u32 *)0xFFC00140);
		debugfs_create_x32("SIC_IAR5", 0600, parent, (u32 *)0xFFC00144);
		debugfs_create_x32("SIC_IAR6", 0600, parent, (u32 *)0xFFC00148);
		debugfs_create_x32("SIC_IAR7", 0600, parent, (u32 *)0xFFC0014C);
		debugfs_create_x32("SIC_IAR8", 0600, parent, (u32 *)0xFFC00150);
		debugfs_create_x32("SIC_IAR9", 0600, parent, (u32 *)0xFFC00154);
		debugfs_create_x32("SIC_IMASK0", 0600, parent, (u32 *)0xFFC0010C);
		debugfs_create_x32("SIC_IMASK1", 0600, parent, (u32 *)0xFFC00110);
		debugfs_create_x32("SIC_IMASK2", 0600, parent, (u32 *)0xFFC00114);
		debugfs_create_x32("SIC_ISR0", 0600, parent, (u32 *)0xFFC00118);
		debugfs_create_x32("SIC_ISR1", 0600, parent, (u32 *)0xFFC0011C);
		debugfs_create_x32("SIC_ISR2", 0600, parent, (u32 *)0xFFC00120);
		debugfs_create_x32("SIC_IWR0", 0600, parent, (u32 *)0xFFC00124);
		debugfs_create_x32("SIC_IWR1", 0600, parent, (u32 *)0xFFC00128);
		debugfs_create_x32("SIC_IWR2", 0600, parent, (u32 *)0xFFC0012C);

		parent = debugfs_create_dir("SPI", top);
		debugfs_create_x16("SPI0_BAUD", 0600, parent, (u16 *)0xFFC00514);
		debugfs_create_x16("SPI0_CTL", 0600, parent, (u16 *)0xFFC00500);
		debugfs_create_x16("SPI0_FLG", 0600, parent, (u16 *)0xFFC00504);
		debugfs_create_x16("SPI0_RDBR", 0600, parent, (u16 *)0xFFC00510);
		debugfs_create_x16("SPI0_SHADOW", 0600, parent, (u16 *)0xFFC00518);
		debugfs_create_x16("SPI0_STAT", 0600, parent, (u16 *)0xFFC00508);
		debugfs_create_x16("SPI0_TDBR", 0600, parent, (u16 *)0xFFC0050C);
		debugfs_create_x16("SPI1_BAUD", 0600, parent, (u16 *)0xFFC02314);
		debugfs_create_x16("SPI1_CTL", 0600, parent, (u16 *)0xFFC02300);
		debugfs_create_x16("SPI1_FLG", 0600, parent, (u16 *)0xFFC02304);
		debugfs_create_x16("SPI1_RDBR", 0600, parent, (u16 *)0xFFC02310);
		debugfs_create_x16("SPI1_SHADOW", 0600, parent, (u16 *)0xFFC02318);
		debugfs_create_x16("SPI1_STAT", 0600, parent, (u16 *)0xFFC02308);
		debugfs_create_x16("SPI1_TDBR", 0600, parent, (u16 *)0xFFC0230C);

		parent = debugfs_create_dir("SPORT", top);
		debugfs_create_x16("SPORT1_CHNL", 0600, parent, (u16 *)0xFFC00934);
		debugfs_create_x16("SPORT1_MCMC1", 0600, parent, (u16 *)0xFFC00938);
		debugfs_create_x16("SPORT1_MCMC2", 0600, parent, (u16 *)0xFFC0093C);
		debugfs_create_x32("SPORT1_MRCS0", 0600, parent, (u32 *)0xFFC00950);
		debugfs_create_x32("SPORT1_MRCS1", 0600, parent, (u32 *)0xFFC00954);
		debugfs_create_x32("SPORT1_MRCS2", 0600, parent, (u32 *)0xFFC00958);
		debugfs_create_x32("SPORT1_MRCS3", 0600, parent, (u32 *)0xFFC0095C);
		debugfs_create_x32("SPORT1_MTCS0", 0600, parent, (u32 *)0xFFC00940);
		debugfs_create_x32("SPORT1_MTCS1", 0600, parent, (u32 *)0xFFC00944);
		debugfs_create_x32("SPORT1_MTCS2", 0600, parent, (u32 *)0xFFC00948);
		debugfs_create_x32("SPORT1_MTCS3", 0600, parent, (u32 *)0xFFC0094C);
		debugfs_create_x16("SPORT1_RCLKDIV", 0600, parent, (u16 *)0xFFC00928);
		debugfs_create_x16("SPORT1_RCR1", 0600, parent, (u16 *)0xFFC00920);
		debugfs_create_x16("SPORT1_RCR2", 0600, parent, (u16 *)0xFFC00924);
		debugfs_create_x16("SPORT1_RFSDIV", 0600, parent, (u16 *)0xFFC0092C);
		debugfs_create_x32("SPORT1_RX", 0600, parent, (u32 *)0xFFC00918);
		debugfs_create_x16("SPORT1_STAT", 0600, parent, (u16 *)0xFFC00930);
		debugfs_create_x16("SPORT1_TCLKDIV", 0600, parent, (u16 *)0xFFC00908);
		debugfs_create_x16("SPORT1_TCR1", 0600, parent, (u16 *)0xFFC00900);
		debugfs_create_x16("SPORT1_TCR2", 0600, parent, (u16 *)0xFFC00904);
		debugfs_create_x16("SPORT1_TFSDIV", 0600, parent, (u16 *)0xFFC0090C);
		debugfs_create_x32("SPORT1_TX", 0600, parent, (u32 *)0xFFC00910);
		debugfs_create_x16("SPORT2_CHNL", 0600, parent, (u16 *)0xFFC02534);
		debugfs_create_x16("SPORT2_MCMC1", 0600, parent, (u16 *)0xFFC02538);
		debugfs_create_x16("SPORT2_MCMC2", 0600, parent, (u16 *)0xFFC0253C);
		debugfs_create_x32("SPORT2_MRCS0", 0600, parent, (u32 *)0xFFC02550);
		debugfs_create_x32("SPORT2_MRCS1", 0600, parent, (u32 *)0xFFC02554);
		debugfs_create_x32("SPORT2_MRCS2", 0600, parent, (u32 *)0xFFC02558);
		debugfs_create_x32("SPORT2_MRCS3", 0600, parent, (u32 *)0xFFC0255C);
		debugfs_create_x32("SPORT2_MTCS0", 0600, parent, (u32 *)0xFFC02540);
		debugfs_create_x32("SPORT2_MTCS1", 0600, parent, (u32 *)0xFFC02544);
		debugfs_create_x32("SPORT2_MTCS2", 0600, parent, (u32 *)0xFFC02548);
		debugfs_create_x32("SPORT2_MTCS3", 0600, parent, (u32 *)0xFFC0254C);
		debugfs_create_x16("SPORT2_RCLKDIV", 0600, parent, (u16 *)0xFFC02528);
		debugfs_create_x16("SPORT2_RCR1", 0600, parent, (u16 *)0xFFC02520);
		debugfs_create_x16("SPORT2_RCR2", 0600, parent, (u16 *)0xFFC02524);
		debugfs_create_x16("SPORT2_RFSDIV", 0600, parent, (u16 *)0xFFC0252C);
		debugfs_create_x32("SPORT2_RX", 0600, parent, (u32 *)0xFFC02518);
		debugfs_create_x16("SPORT2_STAT", 0600, parent, (u16 *)0xFFC02530);
		debugfs_create_x16("SPORT2_TCLKDIV", 0600, parent, (u16 *)0xFFC02508);
		debugfs_create_x16("SPORT2_TCR1", 0600, parent, (u16 *)0xFFC02500);
		debugfs_create_x16("SPORT2_TCR2", 0600, parent, (u16 *)0xFFC02504);
		debugfs_create_x16("SPORT2_TFSDIV", 0600, parent, (u16 *)0xFFC0250C);
		debugfs_create_x32("SPORT2_TX", 0600, parent, (u32 *)0xFFC02510);
		debugfs_create_x16("SPORT3_CHNL", 0600, parent, (u16 *)0xFFC02634);
		debugfs_create_x16("SPORT3_MCMC1", 0600, parent, (u16 *)0xFFC02638);
		debugfs_create_x16("SPORT3_MCMC2", 0600, parent, (u16 *)0xFFC0263C);
		debugfs_create_x32("SPORT3_MRCS0", 0600, parent, (u32 *)0xFFC02650);
		debugfs_create_x32("SPORT3_MRCS1", 0600, parent, (u32 *)0xFFC02654);
		debugfs_create_x32("SPORT3_MRCS2", 0600, parent, (u32 *)0xFFC02658);
		debugfs_create_x32("SPORT3_MRCS3", 0600, parent, (u32 *)0xFFC0265C);
		debugfs_create_x32("SPORT3_MTCS0", 0600, parent, (u32 *)0xFFC02640);
		debugfs_create_x32("SPORT3_MTCS1", 0600, parent, (u32 *)0xFFC02644);
		debugfs_create_x32("SPORT3_MTCS2", 0600, parent, (u32 *)0xFFC02648);
		debugfs_create_x32("SPORT3_MTCS3", 0600, parent, (u32 *)0xFFC0264C);
		debugfs_create_x16("SPORT3_RCLKDIV", 0600, parent, (u16 *)0xFFC02628);
		debugfs_create_x16("SPORT3_RCR1", 0600, parent, (u16 *)0xFFC02620);
		debugfs_create_x16("SPORT3_RCR2", 0600, parent, (u16 *)0xFFC02624);
		debugfs_create_x16("SPORT3_RFSDIV", 0600, parent, (u16 *)0xFFC0262C);
		debugfs_create_x32("SPORT3_RX", 0600, parent, (u32 *)0xFFC02618);
		debugfs_create_x16("SPORT3_STAT", 0600, parent, (u16 *)0xFFC02630);
		debugfs_create_x16("SPORT3_TCLKDIV", 0600, parent, (u16 *)0xFFC02608);
		debugfs_create_x16("SPORT3_TCR1", 0600, parent, (u16 *)0xFFC02600);
		debugfs_create_x16("SPORT3_TCR2", 0600, parent, (u16 *)0xFFC02604);
		debugfs_create_x16("SPORT3_TFSDIV", 0600, parent, (u16 *)0xFFC0260C);
		debugfs_create_x32("SPORT3_TX", 0600, parent, (u32 *)0xFFC02610);

		parent = debugfs_create_dir("Security", top);
		debugfs_create_x16("SECURE_CONTROL", 0600, parent, (u16 *)0xFFC04324);
		debugfs_create_x16("SECURE_STATUS", 0600, parent, (u16 *)0xFFC04328);
		debugfs_create_x32("SECURE_SYSSWT", 0600, parent, (u32 *)0xFFC04320);

		parent = debugfs_create_dir("System Reset and Interrupt Control Registers", top);
		debugfs_create_x16("SWRST", 0600, parent, (u16 *)0xFFC00100);
		debugfs_create_x16("SYSCR", 0600, parent, (u16 *)0xFFC00104);

		parent = debugfs_create_dir("TWI", top);
		debugfs_create_x16("TWI0_CLKDIV", 0600, parent, (u16 *)0xFFC00700);
		debugfs_create_x16("TWI0_CONTROL", 0600, parent, (u16 *)0xFFC00704);
		debugfs_create_x16("TWI0_FIFO_CTL", 0600, parent, (u16 *)0xFFC00728);
		debugfs_create_x16("TWI0_FIFO_STAT", 0600, parent, (u16 *)0xFFC0072C);
		debugfs_create_x16("TWI0_INT_MASK", 0600, parent, (u16 *)0xFFC00724);
		debugfs_create_x16("TWI0_INT_STAT", 0600, parent, (u16 *)0xFFC00720);
		debugfs_create_x16("TWI0_MASTER_ADDR", 0600, parent, (u16 *)0xFFC0071C);
		debugfs_create_x16("TWI0_MASTER_CTL", 0600, parent, (u16 *)0xFFC00714);
		debugfs_create_x16("TWI0_MASTER_STAT", 0600, parent, (u16 *)0xFFC00718);
		debugfs_create_x16("TWI0_RCV_DATA16", 0600, parent, (u16 *)0xFFC0078C);
		debugfs_create_x16("TWI0_RCV_DATA8", 0600, parent, (u16 *)0xFFC00788);
		debugfs_create_x16("TWI0_SLAVE_ADDR", 0600, parent, (u16 *)0xFFC00710);
		debugfs_create_x16("TWI0_SLAVE_CTL", 0600, parent, (u16 *)0xFFC00708);
		debugfs_create_x16("TWI0_SLAVE_STAT", 0600, parent, (u16 *)0xFFC0070C);
		debugfs_create_x16("TWI0_XMT_DATA16", 0600, parent, (u16 *)0xFFC00784);
		debugfs_create_x16("TWI0_XMT_DATA8", 0600, parent, (u16 *)0xFFC00780);

		parent = debugfs_create_dir("UART", top);
		debugfs_create_x16("UART0_DLH", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART0_DLL", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART0_GCTL", 0600, parent, (u16 *)0xFFC00408);
		debugfs_create_x16("UART0_IER_CLEAR", 0600, parent, (u16 *)0xFFC00424);
		debugfs_create_x16("UART0_IER_SET", 0600, parent, (u16 *)0xFFC00420);
		debugfs_create_x16("UART0_LCR", 0600, parent, (u16 *)0xFFC0040C);
		debugfs_create_x16("UART0_LSR", 0600, parent, (u16 *)0xFFC00414);
		debugfs_create_x16("UART0_MCR", 0600, parent, (u16 *)0xFFC00410);
		debugfs_create_x16("UART0_MSR", 0600, parent, (u16 *)0xFFC00418);
		debugfs_create_x16("UART0_RBR", 0600, parent, (u16 *)0xFFC0042C);
		debugfs_create_x16("UART0_SCR", 0600, parent, (u16 *)0xFFC0041C);
		debugfs_create_x16("UART0_THR", 0600, parent, (u16 *)0xFFC00428);
		debugfs_create_x16("UART1_DLH", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("UART1_DLL", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART1_GCTL", 0600, parent, (u16 *)0xFFC02008);
		debugfs_create_x16("UART1_IER_CLEAR", 0600, parent, (u16 *)0xFFC02024);
		debugfs_create_x16("UART1_IER_SET", 0600, parent, (u16 *)0xFFC02020);
		debugfs_create_x16("UART1_LCR", 0600, parent, (u16 *)0xFFC0200C);
		debugfs_create_x16("UART1_LSR", 0600, parent, (u16 *)0xFFC02014);
		debugfs_create_x16("UART1_MCR", 0600, parent, (u16 *)0xFFC02010);
		debugfs_create_x16("UART1_MSR", 0600, parent, (u16 *)0xFFC02018);
		debugfs_create_x16("UART1_RBR", 0600, parent, (u16 *)0xFFC0202C);
		debugfs_create_x16("UART1_SCR", 0600, parent, (u16 *)0xFFC0201C);
		debugfs_create_x16("UART1_THR", 0600, parent, (u16 *)0xFFC02028);
		debugfs_create_x16("UART3_DLH", 0600, parent, (u16 *)0xFFC03104);
		debugfs_create_x16("UART3_DLL", 0600, parent, (u16 *)0xFFC03100);
		debugfs_create_x16("UART3_GCTL", 0600, parent, (u16 *)0xFFC03108);
		debugfs_create_x16("UART3_IER_CLEAR", 0600, parent, (u16 *)0xFFC03124);
		debugfs_create_x16("UART3_IER_SET", 0600, parent, (u16 *)0xFFC03120);
		debugfs_create_x16("UART3_LCR", 0600, parent, (u16 *)0xFFC0310C);
		debugfs_create_x16("UART3_LSR", 0600, parent, (u16 *)0xFFC03114);
		debugfs_create_x16("UART3_MCR", 0600, parent, (u16 *)0xFFC03110);
		debugfs_create_x16("UART3_MSR", 0600, parent, (u16 *)0xFFC03118);
		debugfs_create_x16("UART3_RBR", 0600, parent, (u16 *)0xFFC0312C);
		debugfs_create_x16("UART3_SCR", 0600, parent, (u16 *)0xFFC0311C);
		debugfs_create_x16("UART3_THR", 0600, parent, (u16 *)0xFFC03128);

		parent = debugfs_create_dir("USB", top);
		debugfs_create_x16("USB_APHY_CALIB", 0600, parent, (u16 *)0xFFC03DE4);
		debugfs_create_x16("USB_APHY_CNTRL2", 0600, parent, (u16 *)0xFFC03DE8);
		debugfs_create_x16("USB_APHY_CNTRL", 0600, parent, (u16 *)0xFFC03DE0);
		debugfs_create_x16("USB_COUNT0", 0600, parent, (u16 *)0xFFC03C50);
		debugfs_create_x16("USB_CSR0", 0600, parent, (u16 *)0xFFC03C44);
		debugfs_create_x16("USB_DMA0_ADDRHIGH", 0600, parent, (u16 *)0xFFC0400C);
		debugfs_create_x16("USB_DMA0_ADDRLOW", 0600, parent, (u16 *)0xFFC04008);
		debugfs_create_x16("USB_DMA0_CONTROL", 0600, parent, (u16 *)0xFFC04004);
		debugfs_create_x16("USB_DMA0_COUNTHIGH", 0600, parent, (u16 *)0xFFC04014);
		debugfs_create_x16("USB_DMA0_COUNTLOW", 0600, parent, (u16 *)0xFFC04010);
		debugfs_create_x16("USB_DMA1_ADDRHIGH", 0600, parent, (u16 *)0xFFC0402C);
		debugfs_create_x16("USB_DMA1_ADDRLOW", 0600, parent, (u16 *)0xFFC04028);
		debugfs_create_x16("USB_DMA1_CONTROL", 0600, parent, (u16 *)0xFFC04024);
		debugfs_create_x16("USB_DMA1_COUNTHIGH", 0600, parent, (u16 *)0xFFC04034);
		debugfs_create_x16("USB_DMA1_COUNTLOW", 0600, parent, (u16 *)0xFFC04030);
		debugfs_create_x16("USB_DMA2_ADDRHIGH", 0600, parent, (u16 *)0xFFC0404C);
		debugfs_create_x16("USB_DMA2_ADDRLOW", 0600, parent, (u16 *)0xFFC04048);
		debugfs_create_x16("USB_DMA2_CONTROL", 0600, parent, (u16 *)0xFFC04044);
		debugfs_create_x16("USB_DMA2_COUNTHIGH", 0600, parent, (u16 *)0xFFC04054);
		debugfs_create_x16("USB_DMA2_COUNTLOW", 0600, parent, (u16 *)0xFFC04050);
		debugfs_create_x16("USB_DMA3_ADDRHIGH", 0600, parent, (u16 *)0xFFC0406C);
		debugfs_create_x16("USB_DMA3_ADDRLOW", 0600, parent, (u16 *)0xFFC04068);
		debugfs_create_x16("USB_DMA3_CONTROL", 0600, parent, (u16 *)0xFFC04064);
		debugfs_create_x16("USB_DMA3_COUNTHIGH", 0600, parent, (u16 *)0xFFC04074);
		debugfs_create_x16("USB_DMA3_COUNTLOW", 0600, parent, (u16 *)0xFFC04070);
		debugfs_create_x16("USB_DMA4_ADDRHIGH", 0600, parent, (u16 *)0xFFC0408C);
		debugfs_create_x16("USB_DMA4_ADDRLOW", 0600, parent, (u16 *)0xFFC04088);
		debugfs_create_x16("USB_DMA4_CONTROL", 0600, parent, (u16 *)0xFFC04084);
		debugfs_create_x16("USB_DMA4_COUNTHIGH", 0600, parent, (u16 *)0xFFC04094);
		debugfs_create_x16("USB_DMA4_COUNTLOW", 0600, parent, (u16 *)0xFFC04090);
		debugfs_create_x16("USB_DMA5_ADDRHIGH", 0600, parent, (u16 *)0xFFC040AC);
		debugfs_create_x16("USB_DMA5_ADDRLOW", 0600, parent, (u16 *)0xFFC040A8);
		debugfs_create_x16("USB_DMA5_CONTROL", 0600, parent, (u16 *)0xFFC040A4);
		debugfs_create_x16("USB_DMA5_COUNTHIGH", 0600, parent, (u16 *)0xFFC040B4);
		debugfs_create_x16("USB_DMA5_COUNTLOW", 0600, parent, (u16 *)0xFFC040B0);
		debugfs_create_x16("USB_DMA6_ADDRHIGH", 0600, parent, (u16 *)0xFFC040CC);
		debugfs_create_x16("USB_DMA6_ADDRLOW", 0600, parent, (u16 *)0xFFC040C8);
		debugfs_create_x16("USB_DMA6_CONTROL", 0600, parent, (u16 *)0xFFC040C4);
		debugfs_create_x16("USB_DMA6_COUNTHIGH", 0600, parent, (u16 *)0xFFC040D4);
		debugfs_create_x16("USB_DMA6_COUNTLOW", 0600, parent, (u16 *)0xFFC040D0);
		debugfs_create_x16("USB_DMA7_ADDRHIGH", 0600, parent, (u16 *)0xFFC040EC);
		debugfs_create_x16("USB_DMA7_ADDRLOW", 0600, parent, (u16 *)0xFFC040E8);
		debugfs_create_x16("USB_DMA7_CONTROL", 0600, parent, (u16 *)0xFFC040E4);
		debugfs_create_x16("USB_DMA7_COUNTHIGH", 0600, parent, (u16 *)0xFFC040F4);
		debugfs_create_x16("USB_DMA7_COUNTLOW", 0600, parent, (u16 *)0xFFC040F0);
		debugfs_create_x16("USB_DMA_INTERRUPT", 0600, parent, (u16 *)0xFFC04000);
		debugfs_create_x16("USB_EP0_FIFO", 0600, parent, (u16 *)0xFFC03C80);
		debugfs_create_x16("USB_EP1_FIFO", 0600, parent, (u16 *)0xFFC03C88);
		debugfs_create_x16("USB_EP2_FIFO", 0600, parent, (u16 *)0xFFC03C90);
		debugfs_create_x16("USB_EP3_FIFO", 0600, parent, (u16 *)0xFFC03C98);
		debugfs_create_x16("USB_EP4_FIFO", 0600, parent, (u16 *)0xFFC03CA0);
		debugfs_create_x16("USB_EP5_FIFO", 0600, parent, (u16 *)0xFFC03CA8);
		debugfs_create_x16("USB_EP6_FIFO", 0600, parent, (u16 *)0xFFC03CB0);
		debugfs_create_x16("USB_EP7_FIFO", 0600, parent, (u16 *)0xFFC03CB8);
		debugfs_create_x16("USB_EP_NI0_RXCOUNT", 0600, parent, (u16 *)0xFFC03E10);
		debugfs_create_x16("USB_EP_NI0_RXCSR", 0600, parent, (u16 *)0xFFC03E0C);
		debugfs_create_x16("USB_EP_NI0_RXINTERVAL", 0600, parent, (u16 *)0xFFC03E20);
		debugfs_create_x16("USB_EP_NI0_RXMAXP", 0600, parent, (u16 *)0xFFC03E08);
		debugfs_create_x16("USB_EP_NI0_RXTYPE", 0600, parent, (u16 *)0xFFC03E1C);
		debugfs_create_x16("USB_EP_NI0_TXCOUNT", 0600, parent, (u16 *)0xFFC03E28);
		debugfs_create_x16("USB_EP_NI0_TXCSR", 0600, parent, (u16 *)0xFFC03E04);
		debugfs_create_x16("USB_EP_NI0_TXINTERVAL", 0600, parent, (u16 *)0xFFC03E18);
		debugfs_create_x16("USB_EP_NI0_TXMAXP", 0600, parent, (u16 *)0xFFC03E00);
		debugfs_create_x16("USB_EP_NI0_TXTYPE", 0600, parent, (u16 *)0xFFC03E14);
		debugfs_create_x16("USB_EP_NI1_RXCOUNT", 0600, parent, (u16 *)0xFFC03E50);
		debugfs_create_x16("USB_EP_NI1_RXCSR", 0600, parent, (u16 *)0xFFC03E4C);
		debugfs_create_x16("USB_EP_NI1_RXINTERVAL", 0600, parent, (u16 *)0xFFC03E60);
		debugfs_create_x16("USB_EP_NI1_RXMAXP", 0600, parent, (u16 *)0xFFC03E48);
		debugfs_create_x16("USB_EP_NI1_RXTYPE", 0600, parent, (u16 *)0xFFC03E5C);
		debugfs_create_x16("USB_EP_NI1_TXCOUNT", 0600, parent, (u16 *)0xFFC03E68);
		debugfs_create_x16("USB_EP_NI1_TXCSR", 0600, parent, (u16 *)0xFFC03E44);
		debugfs_create_x16("USB_EP_NI1_TXINTERVAL", 0600, parent, (u16 *)0xFFC03E58);
		debugfs_create_x16("USB_EP_NI1_TXMAXP", 0600, parent, (u16 *)0xFFC03E40);
		debugfs_create_x16("USB_EP_NI1_TXTYPE", 0600, parent, (u16 *)0xFFC03E54);
		debugfs_create_x16("USB_EP_NI2_RXCOUNT", 0600, parent, (u16 *)0xFFC03E90);
		debugfs_create_x16("USB_EP_NI2_RXCSR", 0600, parent, (u16 *)0xFFC03E8C);
		debugfs_create_x16("USB_EP_NI2_RXINTERVAL", 0600, parent, (u16 *)0xFFC03EA0);
		debugfs_create_x16("USB_EP_NI2_RXMAXP", 0600, parent, (u16 *)0xFFC03E88);
		debugfs_create_x16("USB_EP_NI2_RXTYPE", 0600, parent, (u16 *)0xFFC03E9C);
		debugfs_create_x16("USB_EP_NI2_TXCOUNT", 0600, parent, (u16 *)0xFFC03EA8);
		debugfs_create_x16("USB_EP_NI2_TXCSR", 0600, parent, (u16 *)0xFFC03E84);
		debugfs_create_x16("USB_EP_NI2_TXINTERVAL", 0600, parent, (u16 *)0xFFC03E98);
		debugfs_create_x16("USB_EP_NI2_TXMAXP", 0600, parent, (u16 *)0xFFC03E80);
		debugfs_create_x16("USB_EP_NI2_TXTYPE", 0600, parent, (u16 *)0xFFC03E94);
		debugfs_create_x16("USB_EP_NI3_RXCOUNT", 0600, parent, (u16 *)0xFFC03ED0);
		debugfs_create_x16("USB_EP_NI3_RXCSR", 0600, parent, (u16 *)0xFFC03ECC);
		debugfs_create_x16("USB_EP_NI3_RXINTERVAL", 0600, parent, (u16 *)0xFFC03EE0);
		debugfs_create_x16("USB_EP_NI3_RXMAXP", 0600, parent, (u16 *)0xFFC03EC8);
		debugfs_create_x16("USB_EP_NI3_RXTYPE", 0600, parent, (u16 *)0xFFC03EDC);
		debugfs_create_x16("USB_EP_NI3_TXCOUNT", 0600, parent, (u16 *)0xFFC03EE8);
		debugfs_create_x16("USB_EP_NI3_TXCSR", 0600, parent, (u16 *)0xFFC03EC4);
		debugfs_create_x16("USB_EP_NI3_TXINTERVAL", 0600, parent, (u16 *)0xFFC03ED8);
		debugfs_create_x16("USB_EP_NI3_TXMAXP", 0600, parent, (u16 *)0xFFC03EC0);
		debugfs_create_x16("USB_EP_NI3_TXTYPE", 0600, parent, (u16 *)0xFFC03ED4);
		debugfs_create_x16("USB_EP_NI4_RXCOUNT", 0600, parent, (u16 *)0xFFC03F10);
		debugfs_create_x16("USB_EP_NI4_RXCSR", 0600, parent, (u16 *)0xFFC03F0C);
		debugfs_create_x16("USB_EP_NI4_RXINTERVAL", 0600, parent, (u16 *)0xFFC03F20);
		debugfs_create_x16("USB_EP_NI4_RXMAXP", 0600, parent, (u16 *)0xFFC03F08);
		debugfs_create_x16("USB_EP_NI4_RXTYPE", 0600, parent, (u16 *)0xFFC03F1C);
		debugfs_create_x16("USB_EP_NI4_TXCOUNT", 0600, parent, (u16 *)0xFFC03F28);
		debugfs_create_x16("USB_EP_NI4_TXCSR", 0600, parent, (u16 *)0xFFC03F04);
		debugfs_create_x16("USB_EP_NI4_TXINTERVAL", 0600, parent, (u16 *)0xFFC03F18);
		debugfs_create_x16("USB_EP_NI4_TXMAXP", 0600, parent, (u16 *)0xFFC03F00);
		debugfs_create_x16("USB_EP_NI4_TXTYPE", 0600, parent, (u16 *)0xFFC03F14);
		debugfs_create_x16("USB_EP_NI5_RXCOUNT", 0600, parent, (u16 *)0xFFC03F50);
		debugfs_create_x16("USB_EP_NI5_RXCSR", 0600, parent, (u16 *)0xFFC03F4C);
		debugfs_create_x16("USB_EP_NI5_RXINTERVAL", 0600, parent, (u16 *)0xFFC03F60);
		debugfs_create_x16("USB_EP_NI5_RXMAXP", 0600, parent, (u16 *)0xFFC03F48);
		debugfs_create_x16("USB_EP_NI5_RXTYPE", 0600, parent, (u16 *)0xFFC03F5C);
		debugfs_create_x16("USB_EP_NI5_TXCOUNT", 0600, parent, (u16 *)0xFFC03F68);
		debugfs_create_x16("USB_EP_NI5_TXCSR", 0600, parent, (u16 *)0xFFC03F44);
		debugfs_create_x16("USB_EP_NI5_TXINTERVAL", 0600, parent, (u16 *)0xFFC03F58);
		debugfs_create_x16("USB_EP_NI5_TXMAXP", 0600, parent, (u16 *)0xFFC03F40);
		debugfs_create_x16("USB_EP_NI5_TXTYPE", 0600, parent, (u16 *)0xFFC03F54);
		debugfs_create_x16("USB_EP_NI6_RXCOUNT", 0600, parent, (u16 *)0xFFC03F90);
		debugfs_create_x16("USB_EP_NI6_RXCSR", 0600, parent, (u16 *)0xFFC03F8C);
		debugfs_create_x16("USB_EP_NI6_RXINTERVAL", 0600, parent, (u16 *)0xFFC03FA0);
		debugfs_create_x16("USB_EP_NI6_RXMAXP", 0600, parent, (u16 *)0xFFC03F88);
		debugfs_create_x16("USB_EP_NI6_RXTYPE", 0600, parent, (u16 *)0xFFC03F9C);
		debugfs_create_x16("USB_EP_NI6_TXCOUNT", 0600, parent, (u16 *)0xFFC03FA8);
		debugfs_create_x16("USB_EP_NI6_TXCSR", 0600, parent, (u16 *)0xFFC03F84);
		debugfs_create_x16("USB_EP_NI6_TXINTERVAL", 0600, parent, (u16 *)0xFFC03F98);
		debugfs_create_x16("USB_EP_NI6_TXMAXP", 0600, parent, (u16 *)0xFFC03F80);
		debugfs_create_x16("USB_EP_NI6_TXTYPE", 0600, parent, (u16 *)0xFFC03F94);
		debugfs_create_x16("USB_EP_NI7_RXCOUNT", 0600, parent, (u16 *)0xFFC03FD0);
		debugfs_create_x16("USB_EP_NI7_RXCSR", 0600, parent, (u16 *)0xFFC03FCC);
		debugfs_create_x16("USB_EP_NI7_RXINTERVAL", 0600, parent, (u16 *)0xFFC03FF0);
		debugfs_create_x16("USB_EP_NI7_RXMAXP", 0600, parent, (u16 *)0xFFC03FC8);
		debugfs_create_x16("USB_EP_NI7_RXTYPE", 0600, parent, (u16 *)0xFFC03FDC);
		debugfs_create_x16("USB_EP_NI7_TXCOUNT", 0600, parent, (u16 *)0xFFC03FF8);
		debugfs_create_x16("USB_EP_NI7_TXCSR", 0600, parent, (u16 *)0xFFC03FC4);
		debugfs_create_x16("USB_EP_NI7_TXINTERVAL", 0600, parent, (u16 *)0xFFC03FD8);
		debugfs_create_x16("USB_EP_NI7_TXMAXP", 0600, parent, (u16 *)0xFFC03FC0);
		debugfs_create_x16("USB_EP_NI7_TXTYPE", 0600, parent, (u16 *)0xFFC03FD4);
		debugfs_create_x16("USB_FADDR", 0600, parent, (u16 *)0xFFC03C00);
		debugfs_create_x16("USB_FRAME", 0600, parent, (u16 *)0xFFC03C20);
		debugfs_create_x16("USB_FS_EOF1", 0600, parent, (u16 *)0xFFC03D54);
		debugfs_create_x16("USB_GLOBAL_CTL", 0600, parent, (u16 *)0xFFC03C30);
		debugfs_create_x16("USB_GLOBINTR", 0600, parent, (u16 *)0xFFC03C2C);
		debugfs_create_x16("USB_HS_EOF1", 0600, parent, (u16 *)0xFFC03D50);
		debugfs_create_x16("USB_INDEX", 0600, parent, (u16 *)0xFFC03C24);
		debugfs_create_x16("USB_INTRRX", 0600, parent, (u16 *)0xFFC03C0C);
		debugfs_create_x16("USB_INTRRXE", 0600, parent, (u16 *)0xFFC03C14);
		debugfs_create_x16("USB_INTRTX", 0600, parent, (u16 *)0xFFC03C08);
		debugfs_create_x16("USB_INTRTXE", 0600, parent, (u16 *)0xFFC03C10);
		debugfs_create_x16("USB_INTRUSB", 0600, parent, (u16 *)0xFFC03C18);
		debugfs_create_x16("USB_INTRUSBE", 0600, parent, (u16 *)0xFFC03C1C);
		debugfs_create_x16("USB_LINKINFO", 0600, parent, (u16 *)0xFFC03D48);
		debugfs_create_x16("USB_LS_EOF1", 0600, parent, (u16 *)0xFFC03D58);
		debugfs_create_x16("USB_NAKLIMIT0", 0600, parent, (u16 *)0xFFC03C58);
		debugfs_create_x16("USB_OTG_DEV_CTL", 0600, parent, (u16 *)0xFFC03D00);
		debugfs_create_x16("USB_OTG_VBUS_IRQ", 0600, parent, (u16 *)0xFFC03D04);
		debugfs_create_x16("USB_OTG_VBUS_MASK", 0600, parent, (u16 *)0xFFC03D08);
		debugfs_create_x16("USB_PHY_TEST", 0600, parent, (u16 *)0xFFC03DEC);
		debugfs_create_x16("USB_PLLOSC_CTRL", 0600, parent, (u16 *)0xFFC03DF0);
		debugfs_create_x16("USB_POWER", 0600, parent, (u16 *)0xFFC03C04);
		debugfs_create_x16("USB_RXCOUNT", 0600, parent, (u16 *)0xFFC03C50);
		debugfs_create_x16("USB_RXCSR", 0600, parent, (u16 *)0xFFC03C4C);
		debugfs_create_x16("USB_RXINTERVAL", 0600, parent, (u16 *)0xFFC03C60);
		debugfs_create_x16("USB_RXTYPE", 0600, parent, (u16 *)0xFFC03C5C);
		debugfs_create_x16("USB_RX_MAX_PACKET", 0600, parent, (u16 *)0xFFC03C48);
		debugfs_create_x16("USB_SRP_CLKDIV", 0600, parent, (u16 *)0xFFC03DF4);
		debugfs_create_x16("USB_TESTMODE", 0600, parent, (u16 *)0xFFC03C28);
		debugfs_create_x16("USB_TXCOUNT", 0600, parent, (u16 *)0xFFC03C68);
		debugfs_create_x16("USB_TXCSR", 0600, parent, (u16 *)0xFFC03C44);
		debugfs_create_x16("USB_TXINTERVAL", 0600, parent, (u16 *)0xFFC03C58);
		debugfs_create_x16("USB_TXTYPE", 0600, parent, (u16 *)0xFFC03C54);
		debugfs_create_x16("USB_TX_MAX_PACKET", 0600, parent, (u16 *)0xFFC03C40);
		debugfs_create_x16("USB_VPLEN", 0600, parent, (u16 *)0xFFC03D4C);

		parent = debugfs_create_dir("Watchdog", top);
		debugfs_create_x32("WDOG_CNT", 0600, parent, (u32 *)0xFFC00204);
		debugfs_create_x16("WDOG_CTL", 0600, parent, (u16 *)0xFFC00200);
		debugfs_create_x32("WDOG_STAT", 0600, parent, (u32 *)0xFFC00208);

		parent = debugfs_create_dir("Watchpoint and Patch Unit", top);
		debugfs_create_x32("WPDA0", 0600, parent, (u32 *)0xFFE07140);
		debugfs_create_x32("WPDA1", 0600, parent, (u32 *)0xFFE07144);
		debugfs_create_x32("WPDACNT0", 0600, parent, (u32 *)0xFFE07180);
		debugfs_create_x32("WPDACNT1", 0600, parent, (u32 *)0xFFE07184);
		debugfs_create_x32("WPDACTL", 0600, parent, (u32 *)0xFFE07100);
		debugfs_create_x32("WPIA0", 0600, parent, (u32 *)0xFFE07040);
		debugfs_create_x32("WPIA1", 0600, parent, (u32 *)0xFFE07044);
		debugfs_create_x32("WPIA2", 0600, parent, (u32 *)0xFFE07048);
		debugfs_create_x32("WPIA3", 0600, parent, (u32 *)0xFFE0704C);
		debugfs_create_x32("WPIA4", 0600, parent, (u32 *)0xFFE07050);
		debugfs_create_x32("WPIA5", 0600, parent, (u32 *)0xFFE07054);
		debugfs_create_x32("WPIACNT0", 0600, parent, (u32 *)0xFFE07080);
		debugfs_create_x32("WPIACNT1", 0600, parent, (u32 *)0xFFE07084);
		debugfs_create_x32("WPIACNT2", 0600, parent, (u32 *)0xFFE07088);
		debugfs_create_x32("WPIACNT3", 0600, parent, (u32 *)0xFFE0708C);
		debugfs_create_x32("WPIACNT4", 0600, parent, (u32 *)0xFFE07090);
		debugfs_create_x32("WPIACNT5", 0600, parent, (u32 *)0xFFE07094);
		debugfs_create_x32("WPIACTL", 0600, parent, (u32 *)0xFFE07000);
		debugfs_create_x32("WPSTAT", 0600, parent, (u32 *)0xFFE07200);

	}	/* BF541 */

#ifdef __ADSPBF542__
# define USE_BF542 1
#else
# define USE_BF542 0
#endif
	if (USE_BF542) {

		parent = debugfs_create_dir("ATAPI", top);
		debugfs_create_x16("ATAPI_CONTROL", 0600, parent, (u16 *)0xFFC03800);
		debugfs_create_x16("ATAPI_DEV_ADDR", 0600, parent, (u16 *)0xFFC03808);
		debugfs_create_x16("ATAPI_DEV_RXBUF", 0600, parent, (u16 *)0xFFC03810);
		debugfs_create_x16("ATAPI_DEV_TXBUF", 0600, parent, (u16 *)0xFFC0380C);
		debugfs_create_x16("ATAPI_DMA_TFRCNT", 0600, parent, (u16 *)0xFFC03830);
		debugfs_create_x16("ATAPI_INT_MASK", 0600, parent, (u16 *)0xFFC03814);
		debugfs_create_x16("ATAPI_INT_STATUS", 0600, parent, (u16 *)0xFFC03818);
		debugfs_create_x16("ATAPI_LINE_STATUS", 0600, parent, (u16 *)0xFFC03820);
		debugfs_create_x16("ATAPI_MULTI_TIM_0", 0600, parent, (u16 *)0xFFC03850);
		debugfs_create_x16("ATAPI_MULTI_TIM_1", 0600, parent, (u16 *)0xFFC03854);
		debugfs_create_x16("ATAPI_MULTI_TIM_2", 0600, parent, (u16 *)0xFFC03858);
		debugfs_create_x16("ATAPI_PIO_TFRCNT", 0600, parent, (u16 *)0xFFC0382C);
		debugfs_create_x16("ATAPI_PIO_TIM_0", 0600, parent, (u16 *)0xFFC03844);
		debugfs_create_x16("ATAPI_PIO_TIM_1", 0600, parent, (u16 *)0xFFC03848);
		debugfs_create_x16("ATAPI_REG_TIM_0", 0600, parent, (u16 *)0xFFC03840);
		debugfs_create_x16("ATAPI_SM_STATE", 0600, parent, (u16 *)0xFFC03824);
		debugfs_create_x16("ATAPI_STATUS", 0600, parent, (u16 *)0xFFC03804);
		debugfs_create_x16("ATAPI_TERMINATE", 0600, parent, (u16 *)0xFFC03828);
		debugfs_create_x16("ATAPI_UDMAOUT_TFRCNT", 0600, parent, (u16 *)0xFFC03838);
		debugfs_create_x16("ATAPI_ULTRA_TIM_0", 0600, parent, (u16 *)0xFFC03860);
		debugfs_create_x16("ATAPI_ULTRA_TIM_1", 0600, parent, (u16 *)0xFFC03864);
		debugfs_create_x16("ATAPI_ULTRA_TIM_2", 0600, parent, (u16 *)0xFFC03868);
		debugfs_create_x16("ATAPI_ULTRA_TIM_3", 0600, parent, (u16 *)0xFFC0386C);
		debugfs_create_x16("ATAPI_UMAIN_TFRCNT", 0600, parent, (u16 *)0xFFC03834);
		debugfs_create_x16("ATAPI_XFER_LEN", 0600, parent, (u16 *)0xFFC0381C);

		parent = debugfs_create_dir("CAN0 Acceptance Mask RAM", top);
		debugfs_create_x16("CAN0_AM00H", 0600, parent, (u16 *)0xFFC02B04);
		debugfs_create_x16("CAN0_AM00L", 0600, parent, (u16 *)0xFFC02B00);
		debugfs_create_x16("CAN0_AM01H", 0600, parent, (u16 *)0xFFC02B0C);
		debugfs_create_x16("CAN0_AM01L", 0600, parent, (u16 *)0xFFC02B08);
		debugfs_create_x16("CAN0_AM02H", 0600, parent, (u16 *)0xFFC02B14);
		debugfs_create_x16("CAN0_AM02L", 0600, parent, (u16 *)0xFFC02B10);
		debugfs_create_x16("CAN0_AM03H", 0600, parent, (u16 *)0xFFC02B1C);
		debugfs_create_x16("CAN0_AM03L", 0600, parent, (u16 *)0xFFC02B18);
		debugfs_create_x16("CAN0_AM04H", 0600, parent, (u16 *)0xFFC02B24);
		debugfs_create_x16("CAN0_AM04L", 0600, parent, (u16 *)0xFFC02B20);
		debugfs_create_x16("CAN0_AM05H", 0600, parent, (u16 *)0xFFC02B2C);
		debugfs_create_x16("CAN0_AM05L", 0600, parent, (u16 *)0xFFC02B28);
		debugfs_create_x16("CAN0_AM06H", 0600, parent, (u16 *)0xFFC02B34);
		debugfs_create_x16("CAN0_AM06L", 0600, parent, (u16 *)0xFFC02B30);
		debugfs_create_x16("CAN0_AM07H", 0600, parent, (u16 *)0xFFC02B3C);
		debugfs_create_x16("CAN0_AM07L", 0600, parent, (u16 *)0xFFC02B38);
		debugfs_create_x16("CAN0_AM08H", 0600, parent, (u16 *)0xFFC02B44);
		debugfs_create_x16("CAN0_AM08L", 0600, parent, (u16 *)0xFFC02B40);
		debugfs_create_x16("CAN0_AM09H", 0600, parent, (u16 *)0xFFC02B4C);
		debugfs_create_x16("CAN0_AM09L", 0600, parent, (u16 *)0xFFC02B48);
		debugfs_create_x16("CAN0_AM10H", 0600, parent, (u16 *)0xFFC02B54);
		debugfs_create_x16("CAN0_AM10L", 0600, parent, (u16 *)0xFFC02B50);
		debugfs_create_x16("CAN0_AM11H", 0600, parent, (u16 *)0xFFC02B5C);
		debugfs_create_x16("CAN0_AM11L", 0600, parent, (u16 *)0xFFC02B58);
		debugfs_create_x16("CAN0_AM12H", 0600, parent, (u16 *)0xFFC02B64);
		debugfs_create_x16("CAN0_AM12L", 0600, parent, (u16 *)0xFFC02B60);
		debugfs_create_x16("CAN0_AM13H", 0600, parent, (u16 *)0xFFC02B6C);
		debugfs_create_x16("CAN0_AM13L", 0600, parent, (u16 *)0xFFC02B68);
		debugfs_create_x16("CAN0_AM14H", 0600, parent, (u16 *)0xFFC02B74);
		debugfs_create_x16("CAN0_AM14L", 0600, parent, (u16 *)0xFFC02B70);
		debugfs_create_x16("CAN0_AM15H", 0600, parent, (u16 *)0xFFC02B7C);
		debugfs_create_x16("CAN0_AM15L", 0600, parent, (u16 *)0xFFC02B78);
		debugfs_create_x16("CAN0_AM16H", 0600, parent, (u16 *)0xFFC02B84);
		debugfs_create_x16("CAN0_AM16L", 0600, parent, (u16 *)0xFFC02B80);
		debugfs_create_x16("CAN0_AM17H", 0600, parent, (u16 *)0xFFC02B8C);
		debugfs_create_x16("CAN0_AM17L", 0600, parent, (u16 *)0xFFC02B88);
		debugfs_create_x16("CAN0_AM18H", 0600, parent, (u16 *)0xFFC02B94);
		debugfs_create_x16("CAN0_AM18L", 0600, parent, (u16 *)0xFFC02B90);
		debugfs_create_x16("CAN0_AM19H", 0600, parent, (u16 *)0xFFC02B9C);
		debugfs_create_x16("CAN0_AM19L", 0600, parent, (u16 *)0xFFC02B98);
		debugfs_create_x16("CAN0_AM20H", 0600, parent, (u16 *)0xFFC02BA4);
		debugfs_create_x16("CAN0_AM20L", 0600, parent, (u16 *)0xFFC02BA0);
		debugfs_create_x16("CAN0_AM21H", 0600, parent, (u16 *)0xFFC02BAC);
		debugfs_create_x16("CAN0_AM21L", 0600, parent, (u16 *)0xFFC02BA8);
		debugfs_create_x16("CAN0_AM22H", 0600, parent, (u16 *)0xFFC02BB4);
		debugfs_create_x16("CAN0_AM22L", 0600, parent, (u16 *)0xFFC02BB0);
		debugfs_create_x16("CAN0_AM23H", 0600, parent, (u16 *)0xFFC02BBC);
		debugfs_create_x16("CAN0_AM23L", 0600, parent, (u16 *)0xFFC02BB8);
		debugfs_create_x16("CAN0_AM24H", 0600, parent, (u16 *)0xFFC02BC4);
		debugfs_create_x16("CAN0_AM24L", 0600, parent, (u16 *)0xFFC02BC0);
		debugfs_create_x16("CAN0_AM25H", 0600, parent, (u16 *)0xFFC02BCC);
		debugfs_create_x16("CAN0_AM25L", 0600, parent, (u16 *)0xFFC02BC8);
		debugfs_create_x16("CAN0_AM26H", 0600, parent, (u16 *)0xFFC02BD4);
		debugfs_create_x16("CAN0_AM26L", 0600, parent, (u16 *)0xFFC02BD0);
		debugfs_create_x16("CAN0_AM27H", 0600, parent, (u16 *)0xFFC02BDC);
		debugfs_create_x16("CAN0_AM27L", 0600, parent, (u16 *)0xFFC02BD8);
		debugfs_create_x16("CAN0_AM28H", 0600, parent, (u16 *)0xFFC02BE4);
		debugfs_create_x16("CAN0_AM28L", 0600, parent, (u16 *)0xFFC02BE0);
		debugfs_create_x16("CAN0_AM29H", 0600, parent, (u16 *)0xFFC02BEC);
		debugfs_create_x16("CAN0_AM29L", 0600, parent, (u16 *)0xFFC02BE8);
		debugfs_create_x16("CAN0_AM30H", 0600, parent, (u16 *)0xFFC02BF4);
		debugfs_create_x16("CAN0_AM30L", 0600, parent, (u16 *)0xFFC02BF0);
		debugfs_create_x16("CAN0_AM31H", 0600, parent, (u16 *)0xFFC02BFC);
		debugfs_create_x16("CAN0_AM31L", 0600, parent, (u16 *)0xFFC02BF8);

		parent = debugfs_create_dir("CAN0 Control and Status", top);
		debugfs_create_x16("CAN0_AA1", 0600, parent, (u16 *)0xFFC02A14);
		debugfs_create_x16("CAN0_AA2", 0600, parent, (u16 *)0xFFC02A54);
		debugfs_create_x16("CAN0_CEC", 0600, parent, (u16 *)0xFFC02A90);
		debugfs_create_x16("CAN0_CLOCK", 0600, parent, (u16 *)0xFFC02A80);
		debugfs_create_x16("CAN0_CONTROL", 0600, parent, (u16 *)0xFFC02AA0);
		debugfs_create_x16("CAN0_DEBUG", 0600, parent, (u16 *)0xFFC02A88);
		debugfs_create_x16("CAN0_ESR", 0600, parent, (u16 *)0xFFC02AB4);
		debugfs_create_x16("CAN0_EWR", 0600, parent, (u16 *)0xFFC02AB0);
		debugfs_create_x16("CAN0_GIF", 0600, parent, (u16 *)0xFFC02A9C);
		debugfs_create_x16("CAN0_GIM", 0600, parent, (u16 *)0xFFC02A98);
		debugfs_create_x16("CAN0_GIS", 0600, parent, (u16 *)0xFFC02A94);
		debugfs_create_x16("CAN0_INTR", 0600, parent, (u16 *)0xFFC02AA4);
		debugfs_create_x16("CAN0_MBIM1", 0600, parent, (u16 *)0xFFC02A28);
		debugfs_create_x16("CAN0_MBIM2", 0600, parent, (u16 *)0xFFC02A68);
		debugfs_create_x16("CAN0_MBRIF1", 0600, parent, (u16 *)0xFFC02A24);
		debugfs_create_x16("CAN0_MBRIF2", 0600, parent, (u16 *)0xFFC02A64);
		debugfs_create_x16("CAN0_MBTD", 0600, parent, (u16 *)0xFFC02AAC);
		debugfs_create_x16("CAN0_MBTIF1", 0600, parent, (u16 *)0xFFC02A20);
		debugfs_create_x16("CAN0_MBTIF2", 0600, parent, (u16 *)0xFFC02A60);
		debugfs_create_x16("CAN0_MC1", 0600, parent, (u16 *)0xFFC02A00);
		debugfs_create_x16("CAN0_MC2", 0600, parent, (u16 *)0xFFC02A40);
		debugfs_create_x16("CAN0_MD1", 0600, parent, (u16 *)0xFFC02A04);
		debugfs_create_x16("CAN0_MD2", 0600, parent, (u16 *)0xFFC02A44);
		debugfs_create_x16("CAN0_OPSS1", 0600, parent, (u16 *)0xFFC02A30);
		debugfs_create_x16("CAN0_OPSS2", 0600, parent, (u16 *)0xFFC02A70);
		debugfs_create_x16("CAN0_RFH1", 0600, parent, (u16 *)0xFFC02A2C);
		debugfs_create_x16("CAN0_RFH2", 0600, parent, (u16 *)0xFFC02A6C);
		debugfs_create_x16("CAN0_RML1", 0600, parent, (u16 *)0xFFC02A1C);
		debugfs_create_x16("CAN0_RML2", 0600, parent, (u16 *)0xFFC02A5C);
		debugfs_create_x16("CAN0_RMP1", 0600, parent, (u16 *)0xFFC02A18);
		debugfs_create_x16("CAN0_RMP2", 0600, parent, (u16 *)0xFFC02A58);
		debugfs_create_x16("CAN0_STATUS", 0600, parent, (u16 *)0xFFC02A8C);
		debugfs_create_x16("CAN0_TA1", 0600, parent, (u16 *)0xFFC02A10);
		debugfs_create_x16("CAN0_TA2", 0600, parent, (u16 *)0xFFC02A50);
		debugfs_create_x16("CAN0_TIMING", 0600, parent, (u16 *)0xFFC02A84);
		debugfs_create_x16("CAN0_TRR1", 0600, parent, (u16 *)0xFFC02A0C);
		debugfs_create_x16("CAN0_TRR2", 0600, parent, (u16 *)0xFFC02A4C);
		debugfs_create_x16("CAN0_TRS1", 0600, parent, (u16 *)0xFFC02A08);
		debugfs_create_x16("CAN0_TRS2", 0600, parent, (u16 *)0xFFC02A48);
		debugfs_create_x16("CAN0_UCCNF", 0600, parent, (u16 *)0xFFC02ACC);
		debugfs_create_x16("CAN0_UCCNT", 0600, parent, (u16 *)0xFFC02AC4);
		debugfs_create_x16("CAN0_UCRC", 0600, parent, (u16 *)0xFFC02AC8);

		parent = debugfs_create_dir("CAN0 Mailbox RAM", top);
		debugfs_create_x16("CAN0_MB00_DATA0", 0600, parent, (u16 *)0xFFC02C00);
		debugfs_create_x16("CAN0_MB00_DATA1", 0600, parent, (u16 *)0xFFC02C04);
		debugfs_create_x16("CAN0_MB00_DATA2", 0600, parent, (u16 *)0xFFC02C08);
		debugfs_create_x16("CAN0_MB00_DATA3", 0600, parent, (u16 *)0xFFC02C0C);
		debugfs_create_x16("CAN0_MB00_ID0", 0600, parent, (u16 *)0xFFC02C18);
		debugfs_create_x16("CAN0_MB00_ID1", 0600, parent, (u16 *)0xFFC02C1C);
		debugfs_create_x16("CAN0_MB00_LENGTH", 0600, parent, (u16 *)0xFFC02C10);
		debugfs_create_x16("CAN0_MB00_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C14);
		debugfs_create_x16("CAN0_MB01_DATA0", 0600, parent, (u16 *)0xFFC02C20);
		debugfs_create_x16("CAN0_MB01_DATA1", 0600, parent, (u16 *)0xFFC02C24);
		debugfs_create_x16("CAN0_MB01_DATA2", 0600, parent, (u16 *)0xFFC02C28);
		debugfs_create_x16("CAN0_MB01_DATA3", 0600, parent, (u16 *)0xFFC02C2C);
		debugfs_create_x16("CAN0_MB01_ID0", 0600, parent, (u16 *)0xFFC02C38);
		debugfs_create_x16("CAN0_MB01_ID1", 0600, parent, (u16 *)0xFFC02C3C);
		debugfs_create_x16("CAN0_MB01_LENGTH", 0600, parent, (u16 *)0xFFC02C30);
		debugfs_create_x16("CAN0_MB01_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C34);
		debugfs_create_x16("CAN0_MB02_DATA0", 0600, parent, (u16 *)0xFFC02C40);
		debugfs_create_x16("CAN0_MB02_DATA1", 0600, parent, (u16 *)0xFFC02C44);
		debugfs_create_x16("CAN0_MB02_DATA2", 0600, parent, (u16 *)0xFFC02C48);
		debugfs_create_x16("CAN0_MB02_DATA3", 0600, parent, (u16 *)0xFFC02C4C);
		debugfs_create_x16("CAN0_MB02_ID0", 0600, parent, (u16 *)0xFFC02C58);
		debugfs_create_x16("CAN0_MB02_ID1", 0600, parent, (u16 *)0xFFC02C5C);
		debugfs_create_x16("CAN0_MB02_LENGTH", 0600, parent, (u16 *)0xFFC02C50);
		debugfs_create_x16("CAN0_MB02_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C54);
		debugfs_create_x16("CAN0_MB03_DATA0", 0600, parent, (u16 *)0xFFC02C60);
		debugfs_create_x16("CAN0_MB03_DATA1", 0600, parent, (u16 *)0xFFC02C64);
		debugfs_create_x16("CAN0_MB03_DATA2", 0600, parent, (u16 *)0xFFC02C68);
		debugfs_create_x16("CAN0_MB03_DATA3", 0600, parent, (u16 *)0xFFC02C6C);
		debugfs_create_x16("CAN0_MB03_ID0", 0600, parent, (u16 *)0xFFC02C78);
		debugfs_create_x16("CAN0_MB03_ID1", 0600, parent, (u16 *)0xFFC02C7C);
		debugfs_create_x16("CAN0_MB03_LENGTH", 0600, parent, (u16 *)0xFFC02C70);
		debugfs_create_x16("CAN0_MB03_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C74);
		debugfs_create_x16("CAN0_MB04_DATA0", 0600, parent, (u16 *)0xFFC02C80);
		debugfs_create_x16("CAN0_MB04_DATA1", 0600, parent, (u16 *)0xFFC02C84);
		debugfs_create_x16("CAN0_MB04_DATA2", 0600, parent, (u16 *)0xFFC02C88);
		debugfs_create_x16("CAN0_MB04_DATA3", 0600, parent, (u16 *)0xFFC02C8C);
		debugfs_create_x16("CAN0_MB04_ID0", 0600, parent, (u16 *)0xFFC02C98);
		debugfs_create_x16("CAN0_MB04_ID1", 0600, parent, (u16 *)0xFFC02C9C);
		debugfs_create_x16("CAN0_MB04_LENGTH", 0600, parent, (u16 *)0xFFC02C90);
		debugfs_create_x16("CAN0_MB04_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C94);
		debugfs_create_x16("CAN0_MB05_DATA0", 0600, parent, (u16 *)0xFFC02CA0);
		debugfs_create_x16("CAN0_MB05_DATA1", 0600, parent, (u16 *)0xFFC02CA4);
		debugfs_create_x16("CAN0_MB05_DATA2", 0600, parent, (u16 *)0xFFC02CA8);
		debugfs_create_x16("CAN0_MB05_DATA3", 0600, parent, (u16 *)0xFFC02CAC);
		debugfs_create_x16("CAN0_MB05_ID0", 0600, parent, (u16 *)0xFFC02CB8);
		debugfs_create_x16("CAN0_MB05_ID1", 0600, parent, (u16 *)0xFFC02CBC);
		debugfs_create_x16("CAN0_MB05_LENGTH", 0600, parent, (u16 *)0xFFC02CB0);
		debugfs_create_x16("CAN0_MB05_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CB4);
		debugfs_create_x16("CAN0_MB06_DATA0", 0600, parent, (u16 *)0xFFC02CC0);
		debugfs_create_x16("CAN0_MB06_DATA1", 0600, parent, (u16 *)0xFFC02CC4);
		debugfs_create_x16("CAN0_MB06_DATA2", 0600, parent, (u16 *)0xFFC02CC8);
		debugfs_create_x16("CAN0_MB06_DATA3", 0600, parent, (u16 *)0xFFC02CCC);
		debugfs_create_x16("CAN0_MB06_ID0", 0600, parent, (u16 *)0xFFC02CD8);
		debugfs_create_x16("CAN0_MB06_ID1", 0600, parent, (u16 *)0xFFC02CDC);
		debugfs_create_x16("CAN0_MB06_LENGTH", 0600, parent, (u16 *)0xFFC02CD0);
		debugfs_create_x16("CAN0_MB06_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CD4);
		debugfs_create_x16("CAN0_MB07_DATA0", 0600, parent, (u16 *)0xFFC02CE0);
		debugfs_create_x16("CAN0_MB07_DATA1", 0600, parent, (u16 *)0xFFC02CE4);
		debugfs_create_x16("CAN0_MB07_DATA2", 0600, parent, (u16 *)0xFFC02CE8);
		debugfs_create_x16("CAN0_MB07_DATA3", 0600, parent, (u16 *)0xFFC02CEC);
		debugfs_create_x16("CAN0_MB07_ID0", 0600, parent, (u16 *)0xFFC02CF8);
		debugfs_create_x16("CAN0_MB07_ID1", 0600, parent, (u16 *)0xFFC02CFC);
		debugfs_create_x16("CAN0_MB07_LENGTH", 0600, parent, (u16 *)0xFFC02CF0);
		debugfs_create_x16("CAN0_MB07_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CF4);
		debugfs_create_x16("CAN0_MB08_DATA0", 0600, parent, (u16 *)0xFFC02D00);
		debugfs_create_x16("CAN0_MB08_DATA1", 0600, parent, (u16 *)0xFFC02D04);
		debugfs_create_x16("CAN0_MB08_DATA2", 0600, parent, (u16 *)0xFFC02D08);
		debugfs_create_x16("CAN0_MB08_DATA3", 0600, parent, (u16 *)0xFFC02D0C);
		debugfs_create_x16("CAN0_MB08_ID0", 0600, parent, (u16 *)0xFFC02D18);
		debugfs_create_x16("CAN0_MB08_ID1", 0600, parent, (u16 *)0xFFC02D1C);
		debugfs_create_x16("CAN0_MB08_LENGTH", 0600, parent, (u16 *)0xFFC02D10);
		debugfs_create_x16("CAN0_MB08_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D14);
		debugfs_create_x16("CAN0_MB09_DATA0", 0600, parent, (u16 *)0xFFC02D20);
		debugfs_create_x16("CAN0_MB09_DATA1", 0600, parent, (u16 *)0xFFC02D24);
		debugfs_create_x16("CAN0_MB09_DATA2", 0600, parent, (u16 *)0xFFC02D28);
		debugfs_create_x16("CAN0_MB09_DATA3", 0600, parent, (u16 *)0xFFC02D2C);
		debugfs_create_x16("CAN0_MB09_ID0", 0600, parent, (u16 *)0xFFC02D38);
		debugfs_create_x16("CAN0_MB09_ID1", 0600, parent, (u16 *)0xFFC02D3C);
		debugfs_create_x16("CAN0_MB09_LENGTH", 0600, parent, (u16 *)0xFFC02D30);
		debugfs_create_x16("CAN0_MB09_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D34);
		debugfs_create_x16("CAN0_MB10_DATA0", 0600, parent, (u16 *)0xFFC02D40);
		debugfs_create_x16("CAN0_MB10_DATA1", 0600, parent, (u16 *)0xFFC02D44);
		debugfs_create_x16("CAN0_MB10_DATA2", 0600, parent, (u16 *)0xFFC02D48);
		debugfs_create_x16("CAN0_MB10_DATA3", 0600, parent, (u16 *)0xFFC02D4C);
		debugfs_create_x16("CAN0_MB10_ID0", 0600, parent, (u16 *)0xFFC02D58);
		debugfs_create_x16("CAN0_MB10_ID1", 0600, parent, (u16 *)0xFFC02D5C);
		debugfs_create_x16("CAN0_MB10_LENGTH", 0600, parent, (u16 *)0xFFC02D50);
		debugfs_create_x16("CAN0_MB10_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D54);
		debugfs_create_x16("CAN0_MB11_DATA0", 0600, parent, (u16 *)0xFFC02D60);
		debugfs_create_x16("CAN0_MB11_DATA1", 0600, parent, (u16 *)0xFFC02D64);
		debugfs_create_x16("CAN0_MB11_DATA2", 0600, parent, (u16 *)0xFFC02D68);
		debugfs_create_x16("CAN0_MB11_DATA3", 0600, parent, (u16 *)0xFFC02D6C);
		debugfs_create_x16("CAN0_MB11_ID0", 0600, parent, (u16 *)0xFFC02D78);
		debugfs_create_x16("CAN0_MB11_ID1", 0600, parent, (u16 *)0xFFC02D7C);
		debugfs_create_x16("CAN0_MB11_LENGTH", 0600, parent, (u16 *)0xFFC02D70);
		debugfs_create_x16("CAN0_MB11_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D74);
		debugfs_create_x16("CAN0_MB12_DATA0", 0600, parent, (u16 *)0xFFC02D80);
		debugfs_create_x16("CAN0_MB12_DATA1", 0600, parent, (u16 *)0xFFC02D84);
		debugfs_create_x16("CAN0_MB12_DATA2", 0600, parent, (u16 *)0xFFC02D88);
		debugfs_create_x16("CAN0_MB12_DATA3", 0600, parent, (u16 *)0xFFC02D8C);
		debugfs_create_x16("CAN0_MB12_ID0", 0600, parent, (u16 *)0xFFC02D98);
		debugfs_create_x16("CAN0_MB12_ID1", 0600, parent, (u16 *)0xFFC02D9C);
		debugfs_create_x16("CAN0_MB12_LENGTH", 0600, parent, (u16 *)0xFFC02D90);
		debugfs_create_x16("CAN0_MB12_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D94);
		debugfs_create_x16("CAN0_MB13_DATA0", 0600, parent, (u16 *)0xFFC02DA0);
		debugfs_create_x16("CAN0_MB13_DATA1", 0600, parent, (u16 *)0xFFC02DA4);
		debugfs_create_x16("CAN0_MB13_DATA2", 0600, parent, (u16 *)0xFFC02DA8);
		debugfs_create_x16("CAN0_MB13_DATA3", 0600, parent, (u16 *)0xFFC02DAC);
		debugfs_create_x16("CAN0_MB13_ID0", 0600, parent, (u16 *)0xFFC02DB8);
		debugfs_create_x16("CAN0_MB13_ID1", 0600, parent, (u16 *)0xFFC02DBC);
		debugfs_create_x16("CAN0_MB13_LENGTH", 0600, parent, (u16 *)0xFFC02DB0);
		debugfs_create_x16("CAN0_MB13_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DB4);
		debugfs_create_x16("CAN0_MB14_DATA0", 0600, parent, (u16 *)0xFFC02DC0);
		debugfs_create_x16("CAN0_MB14_DATA1", 0600, parent, (u16 *)0xFFC02DC4);
		debugfs_create_x16("CAN0_MB14_DATA2", 0600, parent, (u16 *)0xFFC02DC8);
		debugfs_create_x16("CAN0_MB14_DATA3", 0600, parent, (u16 *)0xFFC02DCC);
		debugfs_create_x16("CAN0_MB14_ID0", 0600, parent, (u16 *)0xFFC02DD8);
		debugfs_create_x16("CAN0_MB14_ID1", 0600, parent, (u16 *)0xFFC02DDC);
		debugfs_create_x16("CAN0_MB14_LENGTH", 0600, parent, (u16 *)0xFFC02DD0);
		debugfs_create_x16("CAN0_MB14_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DD4);
		debugfs_create_x16("CAN0_MB15_DATA0", 0600, parent, (u16 *)0xFFC02DE0);
		debugfs_create_x16("CAN0_MB15_DATA1", 0600, parent, (u16 *)0xFFC02DE4);
		debugfs_create_x16("CAN0_MB15_DATA2", 0600, parent, (u16 *)0xFFC02DE8);
		debugfs_create_x16("CAN0_MB15_DATA3", 0600, parent, (u16 *)0xFFC02DEC);
		debugfs_create_x16("CAN0_MB15_ID0", 0600, parent, (u16 *)0xFFC02DF8);
		debugfs_create_x16("CAN0_MB15_ID1", 0600, parent, (u16 *)0xFFC02DFC);
		debugfs_create_x16("CAN0_MB15_LENGTH", 0600, parent, (u16 *)0xFFC02DF0);
		debugfs_create_x16("CAN0_MB15_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DF4);
		debugfs_create_x16("CAN0_MB16_DATA0", 0600, parent, (u16 *)0xFFC02E00);
		debugfs_create_x16("CAN0_MB16_DATA1", 0600, parent, (u16 *)0xFFC02E04);
		debugfs_create_x16("CAN0_MB16_DATA2", 0600, parent, (u16 *)0xFFC02E08);
		debugfs_create_x16("CAN0_MB16_DATA3", 0600, parent, (u16 *)0xFFC02E0C);
		debugfs_create_x16("CAN0_MB16_ID0", 0600, parent, (u16 *)0xFFC02E18);
		debugfs_create_x16("CAN0_MB16_ID1", 0600, parent, (u16 *)0xFFC02E1C);
		debugfs_create_x16("CAN0_MB16_LENGTH", 0600, parent, (u16 *)0xFFC02E10);
		debugfs_create_x16("CAN0_MB16_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E14);
		debugfs_create_x16("CAN0_MB17_DATA0", 0600, parent, (u16 *)0xFFC02E20);
		debugfs_create_x16("CAN0_MB17_DATA1", 0600, parent, (u16 *)0xFFC02E24);
		debugfs_create_x16("CAN0_MB17_DATA2", 0600, parent, (u16 *)0xFFC02E28);
		debugfs_create_x16("CAN0_MB17_DATA3", 0600, parent, (u16 *)0xFFC02E2C);
		debugfs_create_x16("CAN0_MB17_ID0", 0600, parent, (u16 *)0xFFC02E38);
		debugfs_create_x16("CAN0_MB17_ID1", 0600, parent, (u16 *)0xFFC02E3C);
		debugfs_create_x16("CAN0_MB17_LENGTH", 0600, parent, (u16 *)0xFFC02E30);
		debugfs_create_x16("CAN0_MB17_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E34);
		debugfs_create_x16("CAN0_MB18_DATA0", 0600, parent, (u16 *)0xFFC02E40);
		debugfs_create_x16("CAN0_MB18_DATA1", 0600, parent, (u16 *)0xFFC02E44);
		debugfs_create_x16("CAN0_MB18_DATA2", 0600, parent, (u16 *)0xFFC02E48);
		debugfs_create_x16("CAN0_MB18_DATA3", 0600, parent, (u16 *)0xFFC02E4C);
		debugfs_create_x16("CAN0_MB18_ID0", 0600, parent, (u16 *)0xFFC02E58);
		debugfs_create_x16("CAN0_MB18_ID1", 0600, parent, (u16 *)0xFFC02E5C);
		debugfs_create_x16("CAN0_MB18_LENGTH", 0600, parent, (u16 *)0xFFC02E50);
		debugfs_create_x16("CAN0_MB18_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E54);
		debugfs_create_x16("CAN0_MB19_DATA0", 0600, parent, (u16 *)0xFFC02E60);
		debugfs_create_x16("CAN0_MB19_DATA1", 0600, parent, (u16 *)0xFFC02E64);
		debugfs_create_x16("CAN0_MB19_DATA2", 0600, parent, (u16 *)0xFFC02E68);
		debugfs_create_x16("CAN0_MB19_DATA3", 0600, parent, (u16 *)0xFFC02E6C);
		debugfs_create_x16("CAN0_MB19_ID0", 0600, parent, (u16 *)0xFFC02E78);
		debugfs_create_x16("CAN0_MB19_ID1", 0600, parent, (u16 *)0xFFC02E7C);
		debugfs_create_x16("CAN0_MB19_LENGTH", 0600, parent, (u16 *)0xFFC02E70);
		debugfs_create_x16("CAN0_MB19_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E74);
		debugfs_create_x16("CAN0_MB20_DATA0", 0600, parent, (u16 *)0xFFC02E80);
		debugfs_create_x16("CAN0_MB20_DATA1", 0600, parent, (u16 *)0xFFC02E84);
		debugfs_create_x16("CAN0_MB20_DATA2", 0600, parent, (u16 *)0xFFC02E88);
		debugfs_create_x16("CAN0_MB20_DATA3", 0600, parent, (u16 *)0xFFC02E8C);
		debugfs_create_x16("CAN0_MB20_ID0", 0600, parent, (u16 *)0xFFC02E98);
		debugfs_create_x16("CAN0_MB20_ID1", 0600, parent, (u16 *)0xFFC02E9C);
		debugfs_create_x16("CAN0_MB20_LENGTH", 0600, parent, (u16 *)0xFFC02E90);
		debugfs_create_x16("CAN0_MB20_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E94);
		debugfs_create_x16("CAN0_MB21_DATA0", 0600, parent, (u16 *)0xFFC02EA0);
		debugfs_create_x16("CAN0_MB21_DATA1", 0600, parent, (u16 *)0xFFC02EA4);
		debugfs_create_x16("CAN0_MB21_DATA2", 0600, parent, (u16 *)0xFFC02EA8);
		debugfs_create_x16("CAN0_MB21_DATA3", 0600, parent, (u16 *)0xFFC02EAC);
		debugfs_create_x16("CAN0_MB21_ID0", 0600, parent, (u16 *)0xFFC02EB8);
		debugfs_create_x16("CAN0_MB21_ID1", 0600, parent, (u16 *)0xFFC02EBC);
		debugfs_create_x16("CAN0_MB21_LENGTH", 0600, parent, (u16 *)0xFFC02EB0);
		debugfs_create_x16("CAN0_MB21_TIMESTAMP", 0600, parent, (u16 *)0xFFC02EB4);
		debugfs_create_x16("CAN0_MB22_DATA0", 0600, parent, (u16 *)0xFFC02EC0);
		debugfs_create_x16("CAN0_MB22_DATA1", 0600, parent, (u16 *)0xFFC02EC4);
		debugfs_create_x16("CAN0_MB22_DATA2", 0600, parent, (u16 *)0xFFC02EC8);
		debugfs_create_x16("CAN0_MB22_DATA3", 0600, parent, (u16 *)0xFFC02ECC);
		debugfs_create_x16("CAN0_MB22_ID0", 0600, parent, (u16 *)0xFFC02ED8);
		debugfs_create_x16("CAN0_MB22_ID1", 0600, parent, (u16 *)0xFFC02EDC);
		debugfs_create_x16("CAN0_MB22_LENGTH", 0600, parent, (u16 *)0xFFC02ED0);
		debugfs_create_x16("CAN0_MB22_TIMESTAMP", 0600, parent, (u16 *)0xFFC02ED4);
		debugfs_create_x16("CAN0_MB23_DATA0", 0600, parent, (u16 *)0xFFC02EE0);
		debugfs_create_x16("CAN0_MB23_DATA1", 0600, parent, (u16 *)0xFFC02EE4);
		debugfs_create_x16("CAN0_MB23_DATA2", 0600, parent, (u16 *)0xFFC02EE8);
		debugfs_create_x16("CAN0_MB23_DATA3", 0600, parent, (u16 *)0xFFC02EEC);
		debugfs_create_x16("CAN0_MB23_ID0", 0600, parent, (u16 *)0xFFC02EF8);
		debugfs_create_x16("CAN0_MB23_ID1", 0600, parent, (u16 *)0xFFC02EFC);
		debugfs_create_x16("CAN0_MB23_LENGTH", 0600, parent, (u16 *)0xFFC02EF0);
		debugfs_create_x16("CAN0_MB23_TIMESTAMP", 0600, parent, (u16 *)0xFFC02EF4);
		debugfs_create_x16("CAN0_MB24_DATA0", 0600, parent, (u16 *)0xFFC02F00);
		debugfs_create_x16("CAN0_MB24_DATA1", 0600, parent, (u16 *)0xFFC02F04);
		debugfs_create_x16("CAN0_MB24_DATA2", 0600, parent, (u16 *)0xFFC02F08);
		debugfs_create_x16("CAN0_MB24_DATA3", 0600, parent, (u16 *)0xFFC02F0C);
		debugfs_create_x16("CAN0_MB24_ID0", 0600, parent, (u16 *)0xFFC02F18);
		debugfs_create_x16("CAN0_MB24_ID1", 0600, parent, (u16 *)0xFFC02F1C);
		debugfs_create_x16("CAN0_MB24_LENGTH", 0600, parent, (u16 *)0xFFC02F10);
		debugfs_create_x16("CAN0_MB24_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F14);
		debugfs_create_x16("CAN0_MB25_DATA0", 0600, parent, (u16 *)0xFFC02F20);
		debugfs_create_x16("CAN0_MB25_DATA1", 0600, parent, (u16 *)0xFFC02F24);
		debugfs_create_x16("CAN0_MB25_DATA2", 0600, parent, (u16 *)0xFFC02F28);
		debugfs_create_x16("CAN0_MB25_DATA3", 0600, parent, (u16 *)0xFFC02F2C);
		debugfs_create_x16("CAN0_MB25_ID0", 0600, parent, (u16 *)0xFFC02F38);
		debugfs_create_x16("CAN0_MB25_ID1", 0600, parent, (u16 *)0xFFC02F3C);
		debugfs_create_x16("CAN0_MB25_LENGTH", 0600, parent, (u16 *)0xFFC02F30);
		debugfs_create_x16("CAN0_MB25_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F34);
		debugfs_create_x16("CAN0_MB26_DATA0", 0600, parent, (u16 *)0xFFC02F40);
		debugfs_create_x16("CAN0_MB26_DATA1", 0600, parent, (u16 *)0xFFC02F44);
		debugfs_create_x16("CAN0_MB26_DATA2", 0600, parent, (u16 *)0xFFC02F48);
		debugfs_create_x16("CAN0_MB26_DATA3", 0600, parent, (u16 *)0xFFC02F4C);
		debugfs_create_x16("CAN0_MB26_ID0", 0600, parent, (u16 *)0xFFC02F58);
		debugfs_create_x16("CAN0_MB26_ID1", 0600, parent, (u16 *)0xFFC02F5C);
		debugfs_create_x16("CAN0_MB26_LENGTH", 0600, parent, (u16 *)0xFFC02F50);
		debugfs_create_x16("CAN0_MB26_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F54);
		debugfs_create_x16("CAN0_MB27_DATA0", 0600, parent, (u16 *)0xFFC02F60);
		debugfs_create_x16("CAN0_MB27_DATA1", 0600, parent, (u16 *)0xFFC02F64);
		debugfs_create_x16("CAN0_MB27_DATA2", 0600, parent, (u16 *)0xFFC02F68);
		debugfs_create_x16("CAN0_MB27_DATA3", 0600, parent, (u16 *)0xFFC02F6C);
		debugfs_create_x16("CAN0_MB27_ID0", 0600, parent, (u16 *)0xFFC02F78);
		debugfs_create_x16("CAN0_MB27_ID1", 0600, parent, (u16 *)0xFFC02F7C);
		debugfs_create_x16("CAN0_MB27_LENGTH", 0600, parent, (u16 *)0xFFC02F70);
		debugfs_create_x16("CAN0_MB27_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F74);
		debugfs_create_x16("CAN0_MB28_DATA0", 0600, parent, (u16 *)0xFFC02F80);
		debugfs_create_x16("CAN0_MB28_DATA1", 0600, parent, (u16 *)0xFFC02F84);
		debugfs_create_x16("CAN0_MB28_DATA2", 0600, parent, (u16 *)0xFFC02F88);
		debugfs_create_x16("CAN0_MB28_DATA3", 0600, parent, (u16 *)0xFFC02F8C);
		debugfs_create_x16("CAN0_MB28_ID0", 0600, parent, (u16 *)0xFFC02F98);
		debugfs_create_x16("CAN0_MB28_ID1", 0600, parent, (u16 *)0xFFC02F9C);
		debugfs_create_x16("CAN0_MB28_LENGTH", 0600, parent, (u16 *)0xFFC02F90);
		debugfs_create_x16("CAN0_MB28_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F94);
		debugfs_create_x16("CAN0_MB29_DATA0", 0600, parent, (u16 *)0xFFC02FA0);
		debugfs_create_x16("CAN0_MB29_DATA1", 0600, parent, (u16 *)0xFFC02FA4);
		debugfs_create_x16("CAN0_MB29_DATA2", 0600, parent, (u16 *)0xFFC02FA8);
		debugfs_create_x16("CAN0_MB29_DATA3", 0600, parent, (u16 *)0xFFC02FAC);
		debugfs_create_x16("CAN0_MB29_ID0", 0600, parent, (u16 *)0xFFC02FB8);
		debugfs_create_x16("CAN0_MB29_ID1", 0600, parent, (u16 *)0xFFC02FBC);
		debugfs_create_x16("CAN0_MB29_LENGTH", 0600, parent, (u16 *)0xFFC02FB0);
		debugfs_create_x16("CAN0_MB29_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FB4);
		debugfs_create_x16("CAN0_MB30_DATA0", 0600, parent, (u16 *)0xFFC02FC0);
		debugfs_create_x16("CAN0_MB30_DATA1", 0600, parent, (u16 *)0xFFC02FC4);
		debugfs_create_x16("CAN0_MB30_DATA2", 0600, parent, (u16 *)0xFFC02FC8);
		debugfs_create_x16("CAN0_MB30_DATA3", 0600, parent, (u16 *)0xFFC02FCC);
		debugfs_create_x16("CAN0_MB30_ID0", 0600, parent, (u16 *)0xFFC02FD8);
		debugfs_create_x16("CAN0_MB30_ID1", 0600, parent, (u16 *)0xFFC02FDC);
		debugfs_create_x16("CAN0_MB30_LENGTH", 0600, parent, (u16 *)0xFFC02FD0);
		debugfs_create_x16("CAN0_MB30_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FD4);
		debugfs_create_x16("CAN0_MB31_DATA0", 0600, parent, (u16 *)0xFFC02FE0);
		debugfs_create_x16("CAN0_MB31_DATA1", 0600, parent, (u16 *)0xFFC02FE4);
		debugfs_create_x16("CAN0_MB31_DATA2", 0600, parent, (u16 *)0xFFC02FE8);
		debugfs_create_x16("CAN0_MB31_DATA3", 0600, parent, (u16 *)0xFFC02FEC);
		debugfs_create_x16("CAN0_MB31_ID0", 0600, parent, (u16 *)0xFFC02FF8);
		debugfs_create_x16("CAN0_MB31_ID1", 0600, parent, (u16 *)0xFFC02FFC);
		debugfs_create_x16("CAN0_MB31_LENGTH", 0600, parent, (u16 *)0xFFC02FF0);
		debugfs_create_x16("CAN0_MB31_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FF4);

		parent = debugfs_create_dir("CORE_TMR", top);
		debugfs_create_x32("TCNTL", 0600, parent, (u32 *)0xFFE03000);
		debugfs_create_x32("TCOUNT", 0600, parent, (u32 *)0xFFE0300C);
		debugfs_create_x32("TPERIOD", 0600, parent, (u32 *)0xFFE03004);
		debugfs_create_x32("TSCALE", 0600, parent, (u32 *)0xFFE03008);

		parent = debugfs_create_dir("Counter", top);
		debugfs_create_x16("CNT_COMMAND", 0600, parent, (u16 *)0xFFC0420C);
		debugfs_create_x16("CNT_CONFIG", 0600, parent, (u16 *)0xFFC04200);
		debugfs_create_x32("CNT_COUNTER", 0600, parent, (u32 *)0xFFC04214);
		debugfs_create_x16("CNT_DEBOUNCE", 0600, parent, (u16 *)0xFFC04210);
		debugfs_create_x16("CNT_IMASK", 0600, parent, (u16 *)0xFFC04204);
		debugfs_create_x32("CNT_MAX", 0600, parent, (u32 *)0xFFC04218);
		debugfs_create_x32("CNT_MIN", 0600, parent, (u32 *)0xFFC0421C);
		debugfs_create_x16("CNT_STATUS", 0600, parent, (u16 *)0xFFC04208);

		parent = debugfs_create_dir("DMA", top);
		debugfs_create_x16("DMA0_CONFIG", 0600, parent, (u16 *)0xFFC00C08);
		debugfs_create_x32("DMA0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C24);
		debugfs_create_x32("DMA0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C20);
		debugfs_create_x16("DMA0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C30);
		debugfs_create_x16("DMA0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C38);
		debugfs_create_x16("DMA0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C28);
		debugfs_create_x32("DMA0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C00);
		debugfs_create_x16("DMA0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C2C);
		debugfs_create_x32("DMA0_START_ADDR", 0600, parent, (u32 *)0xFFC00C04);
		debugfs_create_x16("DMA0_X_COUNT", 0600, parent, (u16 *)0xFFC00C10);
		debugfs_create_x16("DMA0_X_MODIFY", 0600, parent, (u16 *)0xFFC00C14);
		debugfs_create_x16("DMA0_Y_COUNT", 0600, parent, (u16 *)0xFFC00C18);
		debugfs_create_x16("DMA0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C1C);
		debugfs_create_x16("DMA10_CONFIG", 0600, parent, (u16 *)0xFFC00E88);
		debugfs_create_x32("DMA10_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EA4);
		debugfs_create_x32("DMA10_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EA0);
		debugfs_create_x16("DMA10_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EB0);
		debugfs_create_x16("DMA10_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EB8);
		debugfs_create_x16("DMA10_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EA8);
		debugfs_create_x32("DMA10_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E80);
		debugfs_create_x16("DMA10_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EAC);
		debugfs_create_x32("DMA10_START_ADDR", 0600, parent, (u32 *)0xFFC00E84);
		debugfs_create_x16("DMA10_X_COUNT", 0600, parent, (u16 *)0xFFC00E90);
		debugfs_create_x16("DMA10_X_MODIFY", 0600, parent, (u16 *)0xFFC00E94);
		debugfs_create_x16("DMA10_Y_COUNT", 0600, parent, (u16 *)0xFFC00E98);
		debugfs_create_x16("DMA10_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E9C);
		debugfs_create_x16("DMA11_CONFIG", 0600, parent, (u16 *)0xFFC00EC8);
		debugfs_create_x32("DMA11_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EE4);
		debugfs_create_x32("DMA11_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EE0);
		debugfs_create_x16("DMA11_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EF0);
		debugfs_create_x16("DMA11_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EF8);
		debugfs_create_x16("DMA11_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EE8);
		debugfs_create_x32("DMA11_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00EC0);
		debugfs_create_x16("DMA11_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EEC);
		debugfs_create_x32("DMA11_START_ADDR", 0600, parent, (u32 *)0xFFC00EC4);
		debugfs_create_x16("DMA11_X_COUNT", 0600, parent, (u16 *)0xFFC00ED0);
		debugfs_create_x16("DMA11_X_MODIFY", 0600, parent, (u16 *)0xFFC00ED4);
		debugfs_create_x16("DMA11_Y_COUNT", 0600, parent, (u16 *)0xFFC00ED8);
		debugfs_create_x16("DMA11_Y_MODIFY", 0600, parent, (u16 *)0xFFC00EDC);
		debugfs_create_x16("DMA12_CONFIG", 0600, parent, (u16 *)0xFFC01C08);
		debugfs_create_x32("DMA12_CURR_ADDR", 0600, parent, (u32 *)0xFFC01C24);
		debugfs_create_x32("DMA12_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01C20);
		debugfs_create_x16("DMA12_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01C30);
		debugfs_create_x16("DMA12_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01C38);
		debugfs_create_x16("DMA12_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01C28);
		debugfs_create_x32("DMA12_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01C00);
		debugfs_create_x16("DMA12_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01C2C);
		debugfs_create_x32("DMA12_START_ADDR", 0600, parent, (u32 *)0xFFC01C04);
		debugfs_create_x16("DMA12_X_COUNT", 0600, parent, (u16 *)0xFFC01C10);
		debugfs_create_x16("DMA12_X_MODIFY", 0600, parent, (u16 *)0xFFC01C14);
		debugfs_create_x16("DMA12_Y_COUNT", 0600, parent, (u16 *)0xFFC01C18);
		debugfs_create_x16("DMA12_Y_MODIFY", 0600, parent, (u16 *)0xFFC01C1C);
		debugfs_create_x16("DMA13_CONFIG", 0600, parent, (u16 *)0xFFC01C48);
		debugfs_create_x32("DMA13_CURR_ADDR", 0600, parent, (u32 *)0xFFC01C64);
		debugfs_create_x32("DMA13_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01C60);
		debugfs_create_x16("DMA13_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01C70);
		debugfs_create_x16("DMA13_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01C78);
		debugfs_create_x16("DMA13_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01C68);
		debugfs_create_x32("DMA13_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01C40);
		debugfs_create_x16("DMA13_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01C6C);
		debugfs_create_x32("DMA13_START_ADDR", 0600, parent, (u32 *)0xFFC01C44);
		debugfs_create_x16("DMA13_X_COUNT", 0600, parent, (u16 *)0xFFC01C50);
		debugfs_create_x16("DMA13_X_MODIFY", 0600, parent, (u16 *)0xFFC01C54);
		debugfs_create_x16("DMA13_Y_COUNT", 0600, parent, (u16 *)0xFFC01C58);
		debugfs_create_x16("DMA13_Y_MODIFY", 0600, parent, (u16 *)0xFFC01C5C);
		debugfs_create_x16("DMA14_CONFIG", 0600, parent, (u16 *)0xFFC01C88);
		debugfs_create_x32("DMA14_CURR_ADDR", 0600, parent, (u32 *)0xFFC01CA4);
		debugfs_create_x32("DMA14_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01CA0);
		debugfs_create_x16("DMA14_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01CB0);
		debugfs_create_x16("DMA14_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01CB8);
		debugfs_create_x16("DMA14_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01CA8);
		debugfs_create_x32("DMA14_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01C80);
		debugfs_create_x16("DMA14_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01CAC);
		debugfs_create_x32("DMA14_START_ADDR", 0600, parent, (u32 *)0xFFC01C84);
		debugfs_create_x16("DMA14_X_COUNT", 0600, parent, (u16 *)0xFFC01C90);
		debugfs_create_x16("DMA14_X_MODIFY", 0600, parent, (u16 *)0xFFC01C94);
		debugfs_create_x16("DMA14_Y_COUNT", 0600, parent, (u16 *)0xFFC01C98);
		debugfs_create_x16("DMA14_Y_MODIFY", 0600, parent, (u16 *)0xFFC01C9C);
		debugfs_create_x16("DMA15_CONFIG", 0600, parent, (u16 *)0xFFC01CC8);
		debugfs_create_x32("DMA15_CURR_ADDR", 0600, parent, (u32 *)0xFFC01CE4);
		debugfs_create_x32("DMA15_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01CE0);
		debugfs_create_x16("DMA15_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01CF0);
		debugfs_create_x16("DMA15_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01CF8);
		debugfs_create_x16("DMA15_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01CE8);
		debugfs_create_x32("DMA15_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01CC0);
		debugfs_create_x16("DMA15_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01CEC);
		debugfs_create_x32("DMA15_START_ADDR", 0600, parent, (u32 *)0xFFC01CC4);
		debugfs_create_x16("DMA15_X_COUNT", 0600, parent, (u16 *)0xFFC01CD0);
		debugfs_create_x16("DMA15_X_MODIFY", 0600, parent, (u16 *)0xFFC01CD4);
		debugfs_create_x16("DMA15_Y_COUNT", 0600, parent, (u16 *)0xFFC01CD8);
		debugfs_create_x16("DMA15_Y_MODIFY", 0600, parent, (u16 *)0xFFC01CDC);
		debugfs_create_x16("DMA16_CONFIG", 0600, parent, (u16 *)0xFFC01D08);
		debugfs_create_x32("DMA16_CURR_ADDR", 0600, parent, (u32 *)0xFFC01D24);
		debugfs_create_x32("DMA16_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01D20);
		debugfs_create_x16("DMA16_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01D30);
		debugfs_create_x16("DMA16_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01D38);
		debugfs_create_x16("DMA16_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01D28);
		debugfs_create_x32("DMA16_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01D00);
		debugfs_create_x16("DMA16_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01D2C);
		debugfs_create_x32("DMA16_START_ADDR", 0600, parent, (u32 *)0xFFC01D04);
		debugfs_create_x16("DMA16_X_COUNT", 0600, parent, (u16 *)0xFFC01D10);
		debugfs_create_x16("DMA16_X_MODIFY", 0600, parent, (u16 *)0xFFC01D14);
		debugfs_create_x16("DMA16_Y_COUNT", 0600, parent, (u16 *)0xFFC01D18);
		debugfs_create_x16("DMA16_Y_MODIFY", 0600, parent, (u16 *)0xFFC01D1C);
		debugfs_create_x16("DMA17_CONFIG", 0600, parent, (u16 *)0xFFC01D48);
		debugfs_create_x32("DMA17_CURR_ADDR", 0600, parent, (u32 *)0xFFC01D64);
		debugfs_create_x32("DMA17_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01D60);
		debugfs_create_x16("DMA17_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01D70);
		debugfs_create_x16("DMA17_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01D78);
		debugfs_create_x16("DMA17_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01D68);
		debugfs_create_x32("DMA17_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01D40);
		debugfs_create_x16("DMA17_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01D6C);
		debugfs_create_x32("DMA17_START_ADDR", 0600, parent, (u32 *)0xFFC01D44);
		debugfs_create_x16("DMA17_X_COUNT", 0600, parent, (u16 *)0xFFC01D50);
		debugfs_create_x16("DMA17_X_MODIFY", 0600, parent, (u16 *)0xFFC01D54);
		debugfs_create_x16("DMA17_Y_COUNT", 0600, parent, (u16 *)0xFFC01D58);
		debugfs_create_x16("DMA17_Y_MODIFY", 0600, parent, (u16 *)0xFFC01D5C);
		debugfs_create_x16("DMA18_CONFIG", 0600, parent, (u16 *)0xFFC01D88);
		debugfs_create_x32("DMA18_CURR_ADDR", 0600, parent, (u32 *)0xFFC01DA4);
		debugfs_create_x32("DMA18_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01DA0);
		debugfs_create_x16("DMA18_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01DB0);
		debugfs_create_x16("DMA18_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01DB8);
		debugfs_create_x16("DMA18_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01DA8);
		debugfs_create_x32("DMA18_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01D80);
		debugfs_create_x16("DMA18_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01DAC);
		debugfs_create_x32("DMA18_START_ADDR", 0600, parent, (u32 *)0xFFC01D84);
		debugfs_create_x16("DMA18_X_COUNT", 0600, parent, (u16 *)0xFFC01D90);
		debugfs_create_x16("DMA18_X_MODIFY", 0600, parent, (u16 *)0xFFC01D94);
		debugfs_create_x16("DMA18_Y_COUNT", 0600, parent, (u16 *)0xFFC01D98);
		debugfs_create_x16("DMA18_Y_MODIFY", 0600, parent, (u16 *)0xFFC01D9C);
		debugfs_create_x16("DMA19_CONFIG", 0600, parent, (u16 *)0xFFC01DC8);
		debugfs_create_x32("DMA19_CURR_ADDR", 0600, parent, (u32 *)0xFFC01DE4);
		debugfs_create_x32("DMA19_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01DE0);
		debugfs_create_x16("DMA19_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01DF0);
		debugfs_create_x16("DMA19_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01DF8);
		debugfs_create_x16("DMA19_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01DE8);
		debugfs_create_x32("DMA19_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01DC0);
		debugfs_create_x16("DMA19_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01DEC);
		debugfs_create_x32("DMA19_START_ADDR", 0600, parent, (u32 *)0xFFC01DC4);
		debugfs_create_x16("DMA19_X_COUNT", 0600, parent, (u16 *)0xFFC01DD0);
		debugfs_create_x16("DMA19_X_MODIFY", 0600, parent, (u16 *)0xFFC01DD4);
		debugfs_create_x16("DMA19_Y_COUNT", 0600, parent, (u16 *)0xFFC01DD8);
		debugfs_create_x16("DMA19_Y_MODIFY", 0600, parent, (u16 *)0xFFC01DDC);
		debugfs_create_x16("DMA1_CONFIG", 0600, parent, (u16 *)0xFFC00C48);
		debugfs_create_x32("DMA1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C64);
		debugfs_create_x32("DMA1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C60);
		debugfs_create_x16("DMA1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C70);
		debugfs_create_x16("DMA1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C78);
		debugfs_create_x16("DMA1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C68);
		debugfs_create_x32("DMA1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C40);
		debugfs_create_x16("DMA1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C6C);
		debugfs_create_x32("DMA1_START_ADDR", 0600, parent, (u32 *)0xFFC00C44);
		debugfs_create_x16("DMA1_X_COUNT", 0600, parent, (u16 *)0xFFC00C50);
		debugfs_create_x16("DMA1_X_MODIFY", 0600, parent, (u16 *)0xFFC00C54);
		debugfs_create_x16("DMA1_Y_COUNT", 0600, parent, (u16 *)0xFFC00C58);
		debugfs_create_x16("DMA1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C5C);
		debugfs_create_x16("DMA20_CONFIG", 0600, parent, (u16 *)0xFFC01E08);
		debugfs_create_x32("DMA20_CURR_ADDR", 0600, parent, (u32 *)0xFFC01E24);
		debugfs_create_x32("DMA20_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01E20);
		debugfs_create_x16("DMA20_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01E30);
		debugfs_create_x16("DMA20_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01E38);
		debugfs_create_x16("DMA20_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01E28);
		debugfs_create_x32("DMA20_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01E00);
		debugfs_create_x16("DMA20_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01E2C);
		debugfs_create_x32("DMA20_START_ADDR", 0600, parent, (u32 *)0xFFC01E04);
		debugfs_create_x16("DMA20_X_COUNT", 0600, parent, (u16 *)0xFFC01E10);
		debugfs_create_x16("DMA20_X_MODIFY", 0600, parent, (u16 *)0xFFC01E14);
		debugfs_create_x16("DMA20_Y_COUNT", 0600, parent, (u16 *)0xFFC01E18);
		debugfs_create_x16("DMA20_Y_MODIFY", 0600, parent, (u16 *)0xFFC01E1C);
		debugfs_create_x16("DMA21_CONFIG", 0600, parent, (u16 *)0xFFC01E48);
		debugfs_create_x32("DMA21_CURR_ADDR", 0600, parent, (u32 *)0xFFC01E64);
		debugfs_create_x32("DMA21_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01E60);
		debugfs_create_x16("DMA21_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01E70);
		debugfs_create_x16("DMA21_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01E78);
		debugfs_create_x16("DMA21_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01E68);
		debugfs_create_x32("DMA21_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01E40);
		debugfs_create_x16("DMA21_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01E6C);
		debugfs_create_x32("DMA21_START_ADDR", 0600, parent, (u32 *)0xFFC01E44);
		debugfs_create_x16("DMA21_X_COUNT", 0600, parent, (u16 *)0xFFC01E50);
		debugfs_create_x16("DMA21_X_MODIFY", 0600, parent, (u16 *)0xFFC01E54);
		debugfs_create_x16("DMA21_Y_COUNT", 0600, parent, (u16 *)0xFFC01E58);
		debugfs_create_x16("DMA21_Y_MODIFY", 0600, parent, (u16 *)0xFFC01E5C);
		debugfs_create_x16("DMA22_CONFIG", 0600, parent, (u16 *)0xFFC01E88);
		debugfs_create_x32("DMA22_CURR_ADDR", 0600, parent, (u32 *)0xFFC01EA4);
		debugfs_create_x32("DMA22_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01EA0);
		debugfs_create_x16("DMA22_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01EB0);
		debugfs_create_x16("DMA22_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01EB8);
		debugfs_create_x16("DMA22_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01EA8);
		debugfs_create_x32("DMA22_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01E80);
		debugfs_create_x16("DMA22_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01EAC);
		debugfs_create_x32("DMA22_START_ADDR", 0600, parent, (u32 *)0xFFC01E84);
		debugfs_create_x16("DMA22_X_COUNT", 0600, parent, (u16 *)0xFFC01E90);
		debugfs_create_x16("DMA22_X_MODIFY", 0600, parent, (u16 *)0xFFC01E94);
		debugfs_create_x16("DMA22_Y_COUNT", 0600, parent, (u16 *)0xFFC01E98);
		debugfs_create_x16("DMA22_Y_MODIFY", 0600, parent, (u16 *)0xFFC01E9C);
		debugfs_create_x16("DMA23_CONFIG", 0600, parent, (u16 *)0xFFC01EC8);
		debugfs_create_x32("DMA23_CURR_ADDR", 0600, parent, (u32 *)0xFFC01EE4);
		debugfs_create_x32("DMA23_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01EE0);
		debugfs_create_x16("DMA23_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01EF0);
		debugfs_create_x16("DMA23_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01EF8);
		debugfs_create_x16("DMA23_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01EE8);
		debugfs_create_x32("DMA23_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01EC0);
		debugfs_create_x16("DMA23_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01EEC);
		debugfs_create_x32("DMA23_START_ADDR", 0600, parent, (u32 *)0xFFC01EC4);
		debugfs_create_x16("DMA23_X_COUNT", 0600, parent, (u16 *)0xFFC01ED0);
		debugfs_create_x16("DMA23_X_MODIFY", 0600, parent, (u16 *)0xFFC01ED4);
		debugfs_create_x16("DMA23_Y_COUNT", 0600, parent, (u16 *)0xFFC01ED8);
		debugfs_create_x16("DMA23_Y_MODIFY", 0600, parent, (u16 *)0xFFC01EDC);
		debugfs_create_x16("DMA2_CONFIG", 0600, parent, (u16 *)0xFFC00C88);
		debugfs_create_x32("DMA2_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CA4);
		debugfs_create_x32("DMA2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CA0);
		debugfs_create_x16("DMA2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CB0);
		debugfs_create_x16("DMA2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CB8);
		debugfs_create_x16("DMA2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CA8);
		debugfs_create_x32("DMA2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C80);
		debugfs_create_x16("DMA2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CAC);
		debugfs_create_x32("DMA2_START_ADDR", 0600, parent, (u32 *)0xFFC00C84);
		debugfs_create_x16("DMA2_X_COUNT", 0600, parent, (u16 *)0xFFC00C90);
		debugfs_create_x16("DMA2_X_MODIFY", 0600, parent, (u16 *)0xFFC00C94);
		debugfs_create_x16("DMA2_Y_COUNT", 0600, parent, (u16 *)0xFFC00C98);
		debugfs_create_x16("DMA2_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C9C);
		debugfs_create_x16("DMA3_CONFIG", 0600, parent, (u16 *)0xFFC00CC8);
		debugfs_create_x32("DMA3_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CE4);
		debugfs_create_x32("DMA3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CE0);
		debugfs_create_x16("DMA3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CF0);
		debugfs_create_x16("DMA3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CF8);
		debugfs_create_x16("DMA3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CE8);
		debugfs_create_x32("DMA3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00CC0);
		debugfs_create_x16("DMA3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CEC);
		debugfs_create_x32("DMA3_START_ADDR", 0600, parent, (u32 *)0xFFC00CC4);
		debugfs_create_x16("DMA3_X_COUNT", 0600, parent, (u16 *)0xFFC00CD0);
		debugfs_create_x16("DMA3_X_MODIFY", 0600, parent, (u16 *)0xFFC00CD4);
		debugfs_create_x16("DMA3_Y_COUNT", 0600, parent, (u16 *)0xFFC00CD8);
		debugfs_create_x16("DMA3_Y_MODIFY", 0600, parent, (u16 *)0xFFC00CDC);
		debugfs_create_x16("DMA4_CONFIG", 0600, parent, (u16 *)0xFFC00D08);
		debugfs_create_x32("DMA4_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D24);
		debugfs_create_x32("DMA4_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D20);
		debugfs_create_x16("DMA4_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D30);
		debugfs_create_x16("DMA4_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D38);
		debugfs_create_x16("DMA4_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D28);
		debugfs_create_x32("DMA4_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D00);
		debugfs_create_x16("DMA4_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D2C);
		debugfs_create_x32("DMA4_START_ADDR", 0600, parent, (u32 *)0xFFC00D04);
		debugfs_create_x16("DMA4_X_COUNT", 0600, parent, (u16 *)0xFFC00D10);
		debugfs_create_x16("DMA4_X_MODIFY", 0600, parent, (u16 *)0xFFC00D14);
		debugfs_create_x16("DMA4_Y_COUNT", 0600, parent, (u16 *)0xFFC00D18);
		debugfs_create_x16("DMA4_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D1C);
		debugfs_create_x16("DMA5_CONFIG", 0600, parent, (u16 *)0xFFC00D48);
		debugfs_create_x32("DMA5_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D64);
		debugfs_create_x32("DMA5_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D60);
		debugfs_create_x16("DMA5_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D70);
		debugfs_create_x16("DMA5_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D78);
		debugfs_create_x16("DMA5_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D68);
		debugfs_create_x32("DMA5_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D40);
		debugfs_create_x16("DMA5_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D6C);
		debugfs_create_x32("DMA5_START_ADDR", 0600, parent, (u32 *)0xFFC00D44);
		debugfs_create_x16("DMA5_X_COUNT", 0600, parent, (u16 *)0xFFC00D50);
		debugfs_create_x16("DMA5_X_MODIFY", 0600, parent, (u16 *)0xFFC00D54);
		debugfs_create_x16("DMA5_Y_COUNT", 0600, parent, (u16 *)0xFFC00D58);
		debugfs_create_x16("DMA5_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D5C);
		debugfs_create_x16("DMA6_CONFIG", 0600, parent, (u16 *)0xFFC00D88);
		debugfs_create_x32("DMA6_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DA4);
		debugfs_create_x32("DMA6_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DA0);
		debugfs_create_x16("DMA6_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DB0);
		debugfs_create_x16("DMA6_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DB8);
		debugfs_create_x16("DMA6_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DA8);
		debugfs_create_x32("DMA6_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D80);
		debugfs_create_x16("DMA6_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DAC);
		debugfs_create_x32("DMA6_START_ADDR", 0600, parent, (u32 *)0xFFC00D84);
		debugfs_create_x16("DMA6_X_COUNT", 0600, parent, (u16 *)0xFFC00D90);
		debugfs_create_x16("DMA6_X_MODIFY", 0600, parent, (u16 *)0xFFC00D94);
		debugfs_create_x16("DMA6_Y_COUNT", 0600, parent, (u16 *)0xFFC00D98);
		debugfs_create_x16("DMA6_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D9C);
		debugfs_create_x16("DMA7_CONFIG", 0600, parent, (u16 *)0xFFC00DC8);
		debugfs_create_x32("DMA7_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DE4);
		debugfs_create_x32("DMA7_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DE0);
		debugfs_create_x16("DMA7_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DF0);
		debugfs_create_x16("DMA7_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DF8);
		debugfs_create_x16("DMA7_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DE8);
		debugfs_create_x32("DMA7_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00DC0);
		debugfs_create_x16("DMA7_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DEC);
		debugfs_create_x32("DMA7_START_ADDR", 0600, parent, (u32 *)0xFFC00DC4);
		debugfs_create_x16("DMA7_X_COUNT", 0600, parent, (u16 *)0xFFC00DD0);
		debugfs_create_x16("DMA7_X_MODIFY", 0600, parent, (u16 *)0xFFC00DD4);
		debugfs_create_x16("DMA7_Y_COUNT", 0600, parent, (u16 *)0xFFC00DD8);
		debugfs_create_x16("DMA7_Y_MODIFY", 0600, parent, (u16 *)0xFFC00DDC);
		debugfs_create_x16("DMA8_CONFIG", 0600, parent, (u16 *)0xFFC00E08);
		debugfs_create_x32("DMA8_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E24);
		debugfs_create_x32("DMA8_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E20);
		debugfs_create_x16("DMA8_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E30);
		debugfs_create_x16("DMA8_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E38);
		debugfs_create_x16("DMA8_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E28);
		debugfs_create_x32("DMA8_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E00);
		debugfs_create_x16("DMA8_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E2C);
		debugfs_create_x32("DMA8_START_ADDR", 0600, parent, (u32 *)0xFFC00E04);
		debugfs_create_x16("DMA8_X_COUNT", 0600, parent, (u16 *)0xFFC00E10);
		debugfs_create_x16("DMA8_X_MODIFY", 0600, parent, (u16 *)0xFFC00E14);
		debugfs_create_x16("DMA8_Y_COUNT", 0600, parent, (u16 *)0xFFC00E18);
		debugfs_create_x16("DMA8_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E1C);
		debugfs_create_x16("DMA9_CONFIG", 0600, parent, (u16 *)0xFFC00E48);
		debugfs_create_x32("DMA9_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E64);
		debugfs_create_x32("DMA9_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E60);
		debugfs_create_x16("DMA9_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E70);
		debugfs_create_x16("DMA9_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E78);
		debugfs_create_x16("DMA9_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E68);
		debugfs_create_x32("DMA9_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E40);
		debugfs_create_x16("DMA9_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E6C);
		debugfs_create_x32("DMA9_START_ADDR", 0600, parent, (u32 *)0xFFC00E44);
		debugfs_create_x16("DMA9_X_COUNT", 0600, parent, (u16 *)0xFFC00E50);
		debugfs_create_x16("DMA9_X_MODIFY", 0600, parent, (u16 *)0xFFC00E54);
		debugfs_create_x16("DMA9_Y_COUNT", 0600, parent, (u16 *)0xFFC00E58);
		debugfs_create_x16("DMA9_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E5C);
		debugfs_create_x16("DMAC0_TCCNT", 0600, parent, (u16 *)0xFFC00B10);
		debugfs_create_x16("DMAC0_TCPER", 0600, parent, (u16 *)0xFFC00B0C);
		debugfs_create_x16("DMAC1_PERIMUX", 0600, parent, (u16 *)0xFFC04340);
		debugfs_create_x16("DMAC1_TCCNT", 0600, parent, (u16 *)0xFFC01B10);
		debugfs_create_x16("DMAC1_TCPER", 0600, parent, (u16 *)0xFFC01B0C);

		parent = debugfs_create_dir("EBIU", top);
		debugfs_create_x32("EBIU_AMBCTL0", 0600, parent, (u32 *)0xFFC00A04);
		debugfs_create_x32("EBIU_AMBCTL1", 0600, parent, (u32 *)0xFFC00A08);
		debugfs_create_x16("EBIU_AMGCTL", 0600, parent, (u16 *)0xFFC00A00);
		debugfs_create_x32("EBIU_ARBSTAT", 0600, parent, (u32 *)0xFFC00A10);
		debugfs_create_x32("EBIU_DDRACCT", 0600, parent, (u32 *)0xFFC00AA0);
		debugfs_create_x32("EBIU_DDRARCT", 0600, parent, (u32 *)0xFFC00AAC);
		debugfs_create_x32("EBIU_DDRBRC0", 0600, parent, (u32 *)0xFFC00A60);
		debugfs_create_x32("EBIU_DDRBRC1", 0600, parent, (u32 *)0xFFC00A64);
		debugfs_create_x32("EBIU_DDRBRC2", 0600, parent, (u32 *)0xFFC00A68);
		debugfs_create_x32("EBIU_DDRBRC3", 0600, parent, (u32 *)0xFFC00A6C);
		debugfs_create_x32("EBIU_DDRBRC4", 0600, parent, (u32 *)0xFFC00A70);
		debugfs_create_x32("EBIU_DDRBRC5", 0600, parent, (u32 *)0xFFC00A74);
		debugfs_create_x32("EBIU_DDRBRC6", 0600, parent, (u32 *)0xFFC00A78);
		debugfs_create_x32("EBIU_DDRBRC7", 0600, parent, (u32 *)0xFFC00A7C);
		debugfs_create_x32("EBIU_DDRBWC0", 0600, parent, (u32 *)0xFFC00A80);
		debugfs_create_x32("EBIU_DDRBWC1", 0600, parent, (u32 *)0xFFC00A84);
		debugfs_create_x32("EBIU_DDRBWC2", 0600, parent, (u32 *)0xFFC00A88);
		debugfs_create_x32("EBIU_DDRBWC3", 0600, parent, (u32 *)0xFFC00A8C);
		debugfs_create_x32("EBIU_DDRBWC4", 0600, parent, (u32 *)0xFFC00A90);
		debugfs_create_x32("EBIU_DDRBWC5", 0600, parent, (u32 *)0xFFC00A94);
		debugfs_create_x32("EBIU_DDRBWC6", 0600, parent, (u32 *)0xFFC00A98);
		debugfs_create_x32("EBIU_DDRBWC7", 0600, parent, (u32 *)0xFFC00A9C);
		debugfs_create_x32("EBIU_DDRCTL0", 0600, parent, (u32 *)0xFFC00A20);
		debugfs_create_x32("EBIU_DDRCTL1", 0600, parent, (u32 *)0xFFC00A24);
		debugfs_create_x32("EBIU_DDRCTL2", 0600, parent, (u32 *)0xFFC00A28);
		debugfs_create_x32("EBIU_DDRCTL3", 0600, parent, (u32 *)0xFFC00A2C);
		debugfs_create_x32("EBIU_DDRGC0", 0600, parent, (u32 *)0xFFC00AB0);
		debugfs_create_x32("EBIU_DDRGC1", 0600, parent, (u32 *)0xFFC00AB4);
		debugfs_create_x32("EBIU_DDRGC2", 0600, parent, (u32 *)0xFFC00AB8);
		debugfs_create_x32("EBIU_DDRGC3", 0600, parent, (u32 *)0xFFC00ABC);
		debugfs_create_x32("EBIU_DDRMCCL", 0600, parent, (u32 *)0xFFC00AC4);
		debugfs_create_x32("EBIU_DDRMCEN", 0600, parent, (u32 *)0xFFC00AC0);
		debugfs_create_x32("EBIU_DDRQUE", 0600, parent, (u32 *)0xFFC00A30);
		debugfs_create_x32("EBIU_DDRTACT", 0600, parent, (u32 *)0xFFC00AA8);
		debugfs_create_x32("EBIU_ERRADD", 0600, parent, (u32 *)0xFFC00A34);
		debugfs_create_x16("EBIU_ERRMST", 0600, parent, (u16 *)0xFFC00A38);
		debugfs_create_x32("EBIU_FCTL", 0600, parent, (u32 *)0xFFC00A18);
		debugfs_create_x32("EBIU_MBSCTL", 0600, parent, (u32 *)0xFFC00A0C);
		debugfs_create_x32("EBIU_MODE", 0600, parent, (u32 *)0xFFC00A14);
		debugfs_create_x16("EBIU_RSTCTL", 0600, parent, (u16 *)0xFFC00A3C);

		parent = debugfs_create_dir("EPPI", top);
		debugfs_create_x32("EPPI1_CLIP", 0600, parent, (u32 *)0xFFC01334);
		debugfs_create_x16("EPPI1_CLKDIV", 0600, parent, (u16 *)0xFFC0131C);
		debugfs_create_x32("EPPI1_CONTROL", 0600, parent, (u32 *)0xFFC01320);
		debugfs_create_x16("EPPI1_FRAME", 0600, parent, (u16 *)0xFFC01314);
		debugfs_create_x32("EPPI1_FS1P_AVPL", 0600, parent, (u32 *)0xFFC01328);
		debugfs_create_x32("EPPI1_FS1W_HBL", 0600, parent, (u32 *)0xFFC01324);
		debugfs_create_x32("EPPI1_FS2P_LAVF", 0600, parent, (u32 *)0xFFC01330);
		debugfs_create_x32("EPPI1_FS2W_LVB", 0600, parent, (u32 *)0xFFC0132C);
		debugfs_create_x16("EPPI1_HCOUNT", 0600, parent, (u16 *)0xFFC01304);
		debugfs_create_x16("EPPI1_HDELAY", 0600, parent, (u16 *)0xFFC01308);
		debugfs_create_x16("EPPI1_LINE", 0600, parent, (u16 *)0xFFC01318);
		debugfs_create_x16("EPPI1_STATUS", 0600, parent, (u16 *)0xFFC01300);
		debugfs_create_x16("EPPI1_VCOUNT", 0600, parent, (u16 *)0xFFC0130C);
		debugfs_create_x16("EPPI1_VDELAY", 0600, parent, (u16 *)0xFFC01310);
		debugfs_create_x32("EPPI2_CLIP", 0600, parent, (u32 *)0xFFC02934);
		debugfs_create_x16("EPPI2_CLKDIV", 0600, parent, (u16 *)0xFFC0291C);
		debugfs_create_x32("EPPI2_CONTROL", 0600, parent, (u32 *)0xFFC02920);
		debugfs_create_x16("EPPI2_FRAME", 0600, parent, (u16 *)0xFFC02914);
		debugfs_create_x32("EPPI2_FS1P_AVPL", 0600, parent, (u32 *)0xFFC02928);
		debugfs_create_x32("EPPI2_FS1W_HBL", 0600, parent, (u32 *)0xFFC02924);
		debugfs_create_x32("EPPI2_FS2P_LAVF", 0600, parent, (u32 *)0xFFC02930);
		debugfs_create_x32("EPPI2_FS2W_LVB", 0600, parent, (u32 *)0xFFC0292C);
		debugfs_create_x16("EPPI2_HCOUNT", 0600, parent, (u16 *)0xFFC02904);
		debugfs_create_x16("EPPI2_HDELAY", 0600, parent, (u16 *)0xFFC02908);
		debugfs_create_x16("EPPI2_LINE", 0600, parent, (u16 *)0xFFC02918);
		debugfs_create_x16("EPPI2_STATUS", 0600, parent, (u16 *)0xFFC02900);
		debugfs_create_x16("EPPI2_VCOUNT", 0600, parent, (u16 *)0xFFC0290C);
		debugfs_create_x16("EPPI2_VDELAY", 0600, parent, (u16 *)0xFFC02910);

		parent = debugfs_create_dir("Event Vectors", top);
		debugfs_create_x32("EVT0", 0600, parent, (u32 *)0xFFE02000);
		debugfs_create_x32("EVT10", 0600, parent, (u32 *)0xFFE02028);
		debugfs_create_x32("EVT11", 0600, parent, (u32 *)0xFFE0202C);
		debugfs_create_x32("EVT12", 0600, parent, (u32 *)0xFFE02030);
		debugfs_create_x32("EVT13", 0600, parent, (u32 *)0xFFE02034);
		debugfs_create_x32("EVT14", 0600, parent, (u32 *)0xFFE02038);
		debugfs_create_x32("EVT15", 0600, parent, (u32 *)0xFFE0203C);
		debugfs_create_x32("EVT1", 0600, parent, (u32 *)0xFFE02004);
		debugfs_create_x32("EVT2", 0600, parent, (u32 *)0xFFE02008);
		debugfs_create_x32("EVT3", 0600, parent, (u32 *)0xFFE0200C);
		debugfs_create_x32("EVT4", 0600, parent, (u32 *)0xFFE02010);
		debugfs_create_x32("EVT5", 0600, parent, (u32 *)0xFFE02014);
		debugfs_create_x32("EVT6", 0600, parent, (u32 *)0xFFE02018);
		debugfs_create_x32("EVT7", 0600, parent, (u32 *)0xFFE0201C);
		debugfs_create_x32("EVT8", 0600, parent, (u32 *)0xFFE02020);
		debugfs_create_x32("EVT9", 0600, parent, (u32 *)0xFFE02024);

		parent = debugfs_create_dir("Extended Registers", top);
		debugfs_create_x32("CHIPID", 0600, parent, (u32 *)0xFFC00014);
		debugfs_create_x32("DSPID", 0600, parent, (u32 *)0xFFE05000);

		parent = debugfs_create_dir("HMDMA", top);
		debugfs_create_x16("HMDMA0_BCINIT", 0600, parent, (u16 *)0xFFC04508);
		debugfs_create_x16("HMDMA0_BCOUNT", 0600, parent, (u16 *)0xFFC04518);
		debugfs_create_x16("HMDMA0_CONTROL", 0600, parent, (u16 *)0xFFC04500);
		debugfs_create_x16("HMDMA0_ECINIT", 0600, parent, (u16 *)0xFFC04504);
		debugfs_create_x16("HMDMA0_ECOUNT", 0600, parent, (u16 *)0xFFC04514);
		debugfs_create_x16("HMDMA0_ECOVERFLOW", 0600, parent, (u16 *)0xFFC04510);
		debugfs_create_x16("HMDMA0_ECURGENT", 0600, parent, (u16 *)0xFFC0450C);
		debugfs_create_x16("HMDMA1_BCINIT", 0600, parent, (u16 *)0xFFC04548);
		debugfs_create_x16("HMDMA1_BCOUNT", 0600, parent, (u16 *)0xFFC04558);
		debugfs_create_x16("HMDMA1_CONTROL", 0600, parent, (u16 *)0xFFC04540);
		debugfs_create_x16("HMDMA1_ECINIT", 0600, parent, (u16 *)0xFFC04544);
		debugfs_create_x16("HMDMA1_ECOUNT", 0600, parent, (u16 *)0xFFC04554);
		debugfs_create_x16("HMDMA1_ECOVERFLOW", 0600, parent, (u16 *)0xFFC04550);
		debugfs_create_x16("HMDMA1_ECURGENT", 0600, parent, (u16 *)0xFFC0454C);

		parent = debugfs_create_dir("Interrupt Controller", top);
		debugfs_create_x32("ILAT", 0600, parent, (u32 *)0xFFE0210C);
		debugfs_create_x32("IMASK", 0600, parent, (u32 *)0xFFE02104);
		debugfs_create_x32("IPEND", 0600, parent, (u32 *)0xFFE02108);
		debugfs_create_x32("IPRIO", 0600, parent, (u32 *)0xFFE02110);

		parent = debugfs_create_dir("KEYPAD", top);
		debugfs_create_x16("KPAD_CTL", 0600, parent, (u16 *)0xFFC04100);
		debugfs_create_x16("KPAD_MSEL", 0600, parent, (u16 *)0xFFC04108);
		debugfs_create_x16("KPAD_PRESCALE", 0600, parent, (u16 *)0xFFC04104);
		debugfs_create_x16("KPAD_ROWCOL", 0600, parent, (u16 *)0xFFC0410C);
		debugfs_create_x16("KPAD_SOFTEVAL", 0600, parent, (u16 *)0xFFC04114);
		debugfs_create_x16("KPAD_STAT", 0600, parent, (u16 *)0xFFC04110);

		parent = debugfs_create_dir("L1 Code Memory Registers", top);
		debugfs_create_x32("ICPLB_ADDR0", 0600, parent, (u32 *)0xFFE01100);
		debugfs_create_x32("ICPLB_ADDR10", 0600, parent, (u32 *)0xFFE01128);
		debugfs_create_x32("ICPLB_ADDR11", 0600, parent, (u32 *)0xFFE0112C);
		debugfs_create_x32("ICPLB_ADDR12", 0600, parent, (u32 *)0xFFE01130);
		debugfs_create_x32("ICPLB_ADDR13", 0600, parent, (u32 *)0xFFE01134);
		debugfs_create_x32("ICPLB_ADDR14", 0600, parent, (u32 *)0xFFE01138);
		debugfs_create_x32("ICPLB_ADDR15", 0600, parent, (u32 *)0xFFE0113C);
		debugfs_create_x32("ICPLB_ADDR1", 0600, parent, (u32 *)0xFFE01104);
		debugfs_create_x32("ICPLB_ADDR2", 0600, parent, (u32 *)0xFFE01108);
		debugfs_create_x32("ICPLB_ADDR3", 0600, parent, (u32 *)0xFFE0110C);
		debugfs_create_x32("ICPLB_ADDR4", 0600, parent, (u32 *)0xFFE01110);
		debugfs_create_x32("ICPLB_ADDR5", 0600, parent, (u32 *)0xFFE01114);
		debugfs_create_x32("ICPLB_ADDR6", 0600, parent, (u32 *)0xFFE01118);
		debugfs_create_x32("ICPLB_ADDR7", 0600, parent, (u32 *)0xFFE0111C);
		debugfs_create_x32("ICPLB_ADDR8", 0600, parent, (u32 *)0xFFE01120);
		debugfs_create_x32("ICPLB_ADDR9", 0600, parent, (u32 *)0xFFE01124);
		debugfs_create_x32("ICPLB_DATA0", 0600, parent, (u32 *)0xFFE01200);
		debugfs_create_x32("ICPLB_DATA10", 0600, parent, (u32 *)0xFFE01228);
		debugfs_create_x32("ICPLB_DATA11", 0600, parent, (u32 *)0xFFE0122C);
		debugfs_create_x32("ICPLB_DATA12", 0600, parent, (u32 *)0xFFE01230);
		debugfs_create_x32("ICPLB_DATA13", 0600, parent, (u32 *)0xFFE01234);
		debugfs_create_x32("ICPLB_DATA14", 0600, parent, (u32 *)0xFFE01238);
		debugfs_create_x32("ICPLB_DATA15", 0600, parent, (u32 *)0xFFE0123C);
		debugfs_create_x32("ICPLB_DATA1", 0600, parent, (u32 *)0xFFE01204);
		debugfs_create_x32("ICPLB_DATA2", 0600, parent, (u32 *)0xFFE01208);
		debugfs_create_x32("ICPLB_DATA3", 0600, parent, (u32 *)0xFFE0120C);
		debugfs_create_x32("ICPLB_DATA4", 0600, parent, (u32 *)0xFFE01210);
		debugfs_create_x32("ICPLB_DATA5", 0600, parent, (u32 *)0xFFE01214);
		debugfs_create_x32("ICPLB_DATA6", 0600, parent, (u32 *)0xFFE01218);
		debugfs_create_x32("ICPLB_DATA7", 0600, parent, (u32 *)0xFFE0121C);
		debugfs_create_x32("ICPLB_DATA8", 0600, parent, (u32 *)0xFFE01220);
		debugfs_create_x32("ICPLB_DATA9", 0600, parent, (u32 *)0xFFE01224);
		debugfs_create_x32("ICPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0100C);
		debugfs_create_x32("ICPLB_STATUS", 0600, parent, (u32 *)0xFFE01008);
		debugfs_create_x32("IMEM_CONTROL", 0600, parent, (u32 *)0xFFE01004);
		debugfs_create_x32("ITEST_COMMAND", 0600, parent, (u32 *)0xFFE01300);
		debugfs_create_x32("ITEST_DATA0", 0600, parent, (u32 *)0xFFE01400);
		debugfs_create_x32("ITEST_DATA1", 0600, parent, (u32 *)0xFFE01404);

		parent = debugfs_create_dir("L1 Data Memory Registers", top);
		debugfs_create_x32("DCPLB_ADDR0", 0600, parent, (u32 *)0xFFE00100);
		debugfs_create_x32("DCPLB_ADDR10", 0600, parent, (u32 *)0xFFE00128);
		debugfs_create_x32("DCPLB_ADDR11", 0600, parent, (u32 *)0xFFE0012C);
		debugfs_create_x32("DCPLB_ADDR12", 0600, parent, (u32 *)0xFFE00130);
		debugfs_create_x32("DCPLB_ADDR13", 0600, parent, (u32 *)0xFFE00134);
		debugfs_create_x32("DCPLB_ADDR14", 0600, parent, (u32 *)0xFFE00138);
		debugfs_create_x32("DCPLB_ADDR15", 0600, parent, (u32 *)0xFFE0013C);
		debugfs_create_x32("DCPLB_ADDR1", 0600, parent, (u32 *)0xFFE00104);
		debugfs_create_x32("DCPLB_ADDR2", 0600, parent, (u32 *)0xFFE00108);
		debugfs_create_x32("DCPLB_ADDR3", 0600, parent, (u32 *)0xFFE0010C);
		debugfs_create_x32("DCPLB_ADDR4", 0600, parent, (u32 *)0xFFE00110);
		debugfs_create_x32("DCPLB_ADDR5", 0600, parent, (u32 *)0xFFE00114);
		debugfs_create_x32("DCPLB_ADDR6", 0600, parent, (u32 *)0xFFE00118);
		debugfs_create_x32("DCPLB_ADDR7", 0600, parent, (u32 *)0xFFE0011C);
		debugfs_create_x32("DCPLB_ADDR8", 0600, parent, (u32 *)0xFFE00120);
		debugfs_create_x32("DCPLB_ADDR9", 0600, parent, (u32 *)0xFFE00124);
		debugfs_create_x32("DCPLB_DATA0", 0600, parent, (u32 *)0xFFE00200);
		debugfs_create_x32("DCPLB_DATA10", 0600, parent, (u32 *)0xFFE00228);
		debugfs_create_x32("DCPLB_DATA11", 0600, parent, (u32 *)0xFFE0022C);
		debugfs_create_x32("DCPLB_DATA12", 0600, parent, (u32 *)0xFFE00230);
		debugfs_create_x32("DCPLB_DATA13", 0600, parent, (u32 *)0xFFE00234);
		debugfs_create_x32("DCPLB_DATA14", 0600, parent, (u32 *)0xFFE00238);
		debugfs_create_x32("DCPLB_DATA15", 0600, parent, (u32 *)0xFFE0023C);
		debugfs_create_x32("DCPLB_DATA1", 0600, parent, (u32 *)0xFFE00204);
		debugfs_create_x32("DCPLB_DATA2", 0600, parent, (u32 *)0xFFE00208);
		debugfs_create_x32("DCPLB_DATA3", 0600, parent, (u32 *)0xFFE0020C);
		debugfs_create_x32("DCPLB_DATA4", 0600, parent, (u32 *)0xFFE00210);
		debugfs_create_x32("DCPLB_DATA5", 0600, parent, (u32 *)0xFFE00214);
		debugfs_create_x32("DCPLB_DATA6", 0600, parent, (u32 *)0xFFE00218);
		debugfs_create_x32("DCPLB_DATA7", 0600, parent, (u32 *)0xFFE0021C);
		debugfs_create_x32("DCPLB_DATA8", 0600, parent, (u32 *)0xFFE00220);
		debugfs_create_x32("DCPLB_DATA9", 0600, parent, (u32 *)0xFFE00224);
		debugfs_create_x32("DCPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0000C);
		debugfs_create_x32("DCPLB_STATUS", 0600, parent, (u32 *)0xFFE00008);
		debugfs_create_x32("DMEM_CONTROL", 0600, parent, (u32 *)0xFFE00004);
		debugfs_create_x32("DTEST_COMMAND", 0600, parent, (u32 *)0xFFE00300);
		debugfs_create_x32("DTEST_DATA0", 0600, parent, (u32 *)0xFFE00400);
		debugfs_create_x32("DTEST_DATA1", 0600, parent, (u32 *)0xFFE00404);
		debugfs_create_x32("SRAM_BASE_ADDR", 0600, parent, (u32 *)0xFFE00000);

		parent = debugfs_create_dir("MDMA", top);
		debugfs_create_x16("MDMA_D0_CONFIG", 0600, parent, (u16 *)0xFFC00F08);
		debugfs_create_x32("MDMA_D0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F24);
		debugfs_create_x32("MDMA_D0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F20);
		debugfs_create_x16("MDMA_D0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F30);
		debugfs_create_x16("MDMA_D0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F38);
		debugfs_create_x16("MDMA_D0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F28);
		debugfs_create_x32("MDMA_D0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F00);
		debugfs_create_x16("MDMA_D0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F2C);
		debugfs_create_x32("MDMA_D0_START_ADDR", 0600, parent, (u32 *)0xFFC00F04);
		debugfs_create_x16("MDMA_D0_X_COUNT", 0600, parent, (u16 *)0xFFC00F10);
		debugfs_create_x16("MDMA_D0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F14);
		debugfs_create_x16("MDMA_D0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F18);
		debugfs_create_x16("MDMA_D0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F1C);
		debugfs_create_x16("MDMA_D1_CONFIG", 0600, parent, (u16 *)0xFFC00F88);
		debugfs_create_x32("MDMA_D1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FA4);
		debugfs_create_x32("MDMA_D1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FA0);
		debugfs_create_x16("MDMA_D1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FB0);
		debugfs_create_x16("MDMA_D1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FB8);
		debugfs_create_x16("MDMA_D1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FA8);
		debugfs_create_x32("MDMA_D1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F80);
		debugfs_create_x16("MDMA_D1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FAC);
		debugfs_create_x32("MDMA_D1_START_ADDR", 0600, parent, (u32 *)0xFFC00F84);
		debugfs_create_x16("MDMA_D1_X_COUNT", 0600, parent, (u16 *)0xFFC00F90);
		debugfs_create_x16("MDMA_D1_X_MODIFY", 0600, parent, (u16 *)0xFFC00F94);
		debugfs_create_x16("MDMA_D1_Y_COUNT", 0600, parent, (u16 *)0xFFC00F98);
		debugfs_create_x16("MDMA_D1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F9C);
		debugfs_create_x16("MDMA_D2_CONFIG", 0600, parent, (u16 *)0xFFC01F08);
		debugfs_create_x32("MDMA_D2_CURR_ADDR", 0600, parent, (u32 *)0xFFC01F24);
		debugfs_create_x32("MDMA_D2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01F20);
		debugfs_create_x16("MDMA_D2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01F30);
		debugfs_create_x16("MDMA_D2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01F38);
		debugfs_create_x16("MDMA_D2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01F28);
		debugfs_create_x32("MDMA_D2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01F00);
		debugfs_create_x16("MDMA_D2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01F2C);
		debugfs_create_x32("MDMA_D2_START_ADDR", 0600, parent, (u32 *)0xFFC01F04);
		debugfs_create_x16("MDMA_D2_X_COUNT", 0600, parent, (u16 *)0xFFC01F10);
		debugfs_create_x16("MDMA_D2_X_MODIFY", 0600, parent, (u16 *)0xFFC01F14);
		debugfs_create_x16("MDMA_D2_Y_COUNT", 0600, parent, (u16 *)0xFFC01F18);
		debugfs_create_x16("MDMA_D2_Y_MODIFY", 0600, parent, (u16 *)0xFFC01F1C);
		debugfs_create_x16("MDMA_D3_CONFIG", 0600, parent, (u16 *)0xFFC01F88);
		debugfs_create_x32("MDMA_D3_CURR_ADDR", 0600, parent, (u32 *)0xFFC01FA4);
		debugfs_create_x32("MDMA_D3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01FA0);
		debugfs_create_x16("MDMA_D3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01FB0);
		debugfs_create_x16("MDMA_D3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01FB8);
		debugfs_create_x16("MDMA_D3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01FA8);
		debugfs_create_x32("MDMA_D3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01F80);
		debugfs_create_x16("MDMA_D3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01FAC);
		debugfs_create_x32("MDMA_D3_START_ADDR", 0600, parent, (u32 *)0xFFC01F84);
		debugfs_create_x16("MDMA_D3_X_COUNT", 0600, parent, (u16 *)0xFFC01F90);
		debugfs_create_x16("MDMA_D3_X_MODIFY", 0600, parent, (u16 *)0xFFC01F94);
		debugfs_create_x16("MDMA_D3_Y_COUNT", 0600, parent, (u16 *)0xFFC01F98);
		debugfs_create_x16("MDMA_D3_Y_MODIFY", 0600, parent, (u16 *)0xFFC01F9C);
		debugfs_create_x16("MDMA_S0_CONFIG", 0600, parent, (u16 *)0xFFC00F48);
		debugfs_create_x32("MDMA_S0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F64);
		debugfs_create_x32("MDMA_S0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F60);
		debugfs_create_x16("MDMA_S0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F70);
		debugfs_create_x16("MDMA_S0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F78);
		debugfs_create_x16("MDMA_S0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F68);
		debugfs_create_x32("MDMA_S0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F40);
		debugfs_create_x16("MDMA_S0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F6C);
		debugfs_create_x32("MDMA_S0_START_ADDR", 0600, parent, (u32 *)0xFFC00F44);
		debugfs_create_x16("MDMA_S0_X_COUNT", 0600, parent, (u16 *)0xFFC00F50);
		debugfs_create_x16("MDMA_S0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F54);
		debugfs_create_x16("MDMA_S0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F58);
		debugfs_create_x16("MDMA_S0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F5C);
		debugfs_create_x16("MDMA_S1_CONFIG", 0600, parent, (u16 *)0xFFC00FC8);
		debugfs_create_x32("MDMA_S1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FE4);
		debugfs_create_x32("MDMA_S1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FE0);
		debugfs_create_x16("MDMA_S1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FF0);
		debugfs_create_x16("MDMA_S1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FF8);
		debugfs_create_x16("MDMA_S1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FE8);
		debugfs_create_x32("MDMA_S1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00FC0);
		debugfs_create_x16("MDMA_S1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FEC);
		debugfs_create_x32("MDMA_S1_START_ADDR", 0600, parent, (u32 *)0xFFC00FC4);
		debugfs_create_x16("MDMA_S1_X_COUNT", 0600, parent, (u16 *)0xFFC00FD0);
		debugfs_create_x16("MDMA_S1_X_MODIFY", 0600, parent, (u16 *)0xFFC00FD4);
		debugfs_create_x16("MDMA_S1_Y_COUNT", 0600, parent, (u16 *)0xFFC00FD8);
		debugfs_create_x16("MDMA_S1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00FDC);
		debugfs_create_x16("MDMA_S2_CONFIG", 0600, parent, (u16 *)0xFFC01F48);
		debugfs_create_x32("MDMA_S2_CURR_ADDR", 0600, parent, (u32 *)0xFFC01F64);
		debugfs_create_x32("MDMA_S2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01F60);
		debugfs_create_x16("MDMA_S2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01F70);
		debugfs_create_x16("MDMA_S2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01F78);
		debugfs_create_x16("MDMA_S2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01F68);
		debugfs_create_x32("MDMA_S2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01F40);
		debugfs_create_x16("MDMA_S2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01F6C);
		debugfs_create_x32("MDMA_S2_START_ADDR", 0600, parent, (u32 *)0xFFC01F44);
		debugfs_create_x16("MDMA_S2_X_COUNT", 0600, parent, (u16 *)0xFFC01F50);
		debugfs_create_x16("MDMA_S2_X_MODIFY", 0600, parent, (u16 *)0xFFC01F54);
		debugfs_create_x16("MDMA_S2_Y_COUNT", 0600, parent, (u16 *)0xFFC01F58);
		debugfs_create_x16("MDMA_S2_Y_MODIFY", 0600, parent, (u16 *)0xFFC01F5C);
		debugfs_create_x16("MDMA_S3_CONFIG", 0600, parent, (u16 *)0xFFC01FC8);
		debugfs_create_x32("MDMA_S3_CURR_ADDR", 0600, parent, (u32 *)0xFFC01FE4);
		debugfs_create_x32("MDMA_S3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01FE0);
		debugfs_create_x16("MDMA_S3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01FF0);
		debugfs_create_x16("MDMA_S3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01FF8);
		debugfs_create_x16("MDMA_S3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01FE8);
		debugfs_create_x32("MDMA_S3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01FC0);
		debugfs_create_x16("MDMA_S3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01FEC);
		debugfs_create_x32("MDMA_S3_START_ADDR", 0600, parent, (u32 *)0xFFC01FC4);
		debugfs_create_x16("MDMA_S3_X_COUNT", 0600, parent, (u16 *)0xFFC01FD0);
		debugfs_create_x16("MDMA_S3_X_MODIFY", 0600, parent, (u16 *)0xFFC01FD4);
		debugfs_create_x16("MDMA_S3_Y_COUNT", 0600, parent, (u16 *)0xFFC01FD8);
		debugfs_create_x16("MDMA_S3_Y_MODIFY", 0600, parent, (u16 *)0xFFC01FDC);

		parent = debugfs_create_dir("NFC", top);
		debugfs_create_x16("NFC_ADDR", 0600, parent, (u16 *)0xFFC03B40);
		debugfs_create_x16("NFC_CMD", 0600, parent, (u16 *)0xFFC03B44);
		debugfs_create_x16("NFC_COUNT", 0600, parent, (u16 *)0xFFC03B20);
		debugfs_create_x16("NFC_CTL", 0600, parent, (u16 *)0xFFC03B00);
		debugfs_create_x16("NFC_DATA_RD", 0600, parent, (u16 *)0xFFC03B4C);
		debugfs_create_x16("NFC_DATA_WR", 0600, parent, (u16 *)0xFFC03B48);
		debugfs_create_x16("NFC_ECC0", 0600, parent, (u16 *)0xFFC03B10);
		debugfs_create_x16("NFC_ECC1", 0600, parent, (u16 *)0xFFC03B14);
		debugfs_create_x16("NFC_ECC2", 0600, parent, (u16 *)0xFFC03B18);
		debugfs_create_x16("NFC_ECC3", 0600, parent, (u16 *)0xFFC03B1C);
		debugfs_create_x16("NFC_IRQMASK", 0600, parent, (u16 *)0xFFC03B0C);
		debugfs_create_x16("NFC_IRQSTAT", 0600, parent, (u16 *)0xFFC03B08);
		debugfs_create_x16("NFC_PGCTL", 0600, parent, (u16 *)0xFFC03B28);
		debugfs_create_x16("NFC_READ", 0600, parent, (u16 *)0xFFC03B2C);
		debugfs_create_x16("NFC_RST", 0600, parent, (u16 *)0xFFC03B24);
		debugfs_create_x16("NFC_STAT", 0600, parent, (u16 *)0xFFC03B04);

		parent = debugfs_create_dir("OTP", top);
		debugfs_create_x16("OTP_BEN", 0600, parent, (u16 *)0xFFC04304);
		debugfs_create_x16("OTP_CONTROL", 0600, parent, (u16 *)0xFFC04300);
		debugfs_create_x32("OTP_DATA0", 0600, parent, (u32 *)0xFFC04380);
		debugfs_create_x32("OTP_DATA1", 0600, parent, (u32 *)0xFFC04384);
		debugfs_create_x32("OTP_DATA2", 0600, parent, (u32 *)0xFFC04388);
		debugfs_create_x32("OTP_DATA3", 0600, parent, (u32 *)0xFFC0438C);
		debugfs_create_x16("OTP_STATUS", 0600, parent, (u16 *)0xFFC04308);
		debugfs_create_x32("OTP_TIMING", 0600, parent, (u32 *)0xFFC0430C);

		parent = debugfs_create_dir("PINT_0", top);
		debugfs_create_x32("PINT0_ASSIGN", 0600, parent, (u32 *)0xFFC0140C);
		debugfs_create_x32("PINT0_EDGE_CLEAR", 0600, parent, (u32 *)0xFFC01414);
		debugfs_create_x32("PINT0_EDGE_SET", 0600, parent, (u32 *)0xFFC01410);
		debugfs_create_x32("PINT0_INVERT_CLEAR", 0600, parent, (u32 *)0xFFC0141C);
		debugfs_create_x32("PINT0_INVERT_SET", 0600, parent, (u32 *)0xFFC01418);
		debugfs_create_x32("PINT0_IRQ", 0600, parent, (u32 *)0xFFC01408);
		debugfs_create_x32("PINT0_LATCH", 0600, parent, (u32 *)0xFFC01424);
		debugfs_create_x32("PINT0_MASK_CLEAR", 0600, parent, (u32 *)0xFFC01404);
		debugfs_create_x32("PINT0_MASK_SET", 0600, parent, (u32 *)0xFFC01400);
		debugfs_create_x32("PINT0_PINSTATE", 0600, parent, (u32 *)0xFFC01420);

		parent = debugfs_create_dir("PINT_1", top);
		debugfs_create_x32("PINT1_ASSIGN", 0600, parent, (u32 *)0xFFC0143C);
		debugfs_create_x32("PINT1_EDGE_CLEAR", 0600, parent, (u32 *)0xFFC01444);
		debugfs_create_x32("PINT1_EDGE_SET", 0600, parent, (u32 *)0xFFC01440);
		debugfs_create_x32("PINT1_INVERT_CLEAR", 0600, parent, (u32 *)0xFFC0144C);
		debugfs_create_x32("PINT1_INVERT_SET", 0600, parent, (u32 *)0xFFC01448);
		debugfs_create_x32("PINT1_IRQ", 0600, parent, (u32 *)0xFFC01438);
		debugfs_create_x32("PINT1_LATCH", 0600, parent, (u32 *)0xFFC01454);
		debugfs_create_x32("PINT1_MASK_CLEAR", 0600, parent, (u32 *)0xFFC01434);
		debugfs_create_x32("PINT1_MASK_SET", 0600, parent, (u32 *)0xFFC01430);
		debugfs_create_x32("PINT1_PINSTATE", 0600, parent, (u32 *)0xFFC01450);

		parent = debugfs_create_dir("PINT_2", top);
		debugfs_create_x32("PINT2_ASSIGN", 0600, parent, (u32 *)0xFFC0146C);
		debugfs_create_x32("PINT2_EDGE_CLEAR", 0600, parent, (u32 *)0xFFC01474);
		debugfs_create_x32("PINT2_EDGE_SET", 0600, parent, (u32 *)0xFFC01470);
		debugfs_create_x32("PINT2_INVERT_CLEAR", 0600, parent, (u32 *)0xFFC0147C);
		debugfs_create_x32("PINT2_INVERT_SET", 0600, parent, (u32 *)0xFFC01478);
		debugfs_create_x32("PINT2_IRQ", 0600, parent, (u32 *)0xFFC01468);
		debugfs_create_x32("PINT2_LATCH", 0600, parent, (u32 *)0xFFC01484);
		debugfs_create_x32("PINT2_MASK_CLEAR", 0600, parent, (u32 *)0xFFC01464);
		debugfs_create_x32("PINT2_MASK_SET", 0600, parent, (u32 *)0xFFC01460);
		debugfs_create_x32("PINT2_PINSTATE", 0600, parent, (u32 *)0xFFC01480);

		parent = debugfs_create_dir("PINT_3", top);
		debugfs_create_x32("PINT3_ASSIGN", 0600, parent, (u32 *)0xFFC0149C);
		debugfs_create_x32("PINT3_EDGE_CLEAR", 0600, parent, (u32 *)0xFFC014A4);
		debugfs_create_x32("PINT3_EDGE_SET", 0600, parent, (u32 *)0xFFC014A0);
		debugfs_create_x32("PINT3_INVERT_CLEAR", 0600, parent, (u32 *)0xFFC014AC);
		debugfs_create_x32("PINT3_INVERT_SET", 0600, parent, (u32 *)0xFFC014A8);
		debugfs_create_x32("PINT3_IRQ", 0600, parent, (u32 *)0xFFC01498);
		debugfs_create_x32("PINT3_LATCH", 0600, parent, (u32 *)0xFFC014B4);
		debugfs_create_x32("PINT3_MASK_CLEAR", 0600, parent, (u32 *)0xFFC01494);
		debugfs_create_x32("PINT3_MASK_SET", 0600, parent, (u32 *)0xFFC01490);
		debugfs_create_x32("PINT3_PINSTATE", 0600, parent, (u32 *)0xFFC014B0);

		parent = debugfs_create_dir("PLL", top);
		debugfs_create_x16("PLL_CTL", 0600, parent, (u16 *)0xFFC00000);
		debugfs_create_x16("PLL_DIV", 0600, parent, (u16 *)0xFFC00004);
		debugfs_create_x16("PLL_LOCKCNT", 0600, parent, (u16 *)0xFFC00010);
		debugfs_create_x16("PLL_STAT", 0600, parent, (u16 *)0xFFC0000C);
		debugfs_create_x16("VR_CTL", 0600, parent, (u16 *)0xFFC00008);

		parent = debugfs_create_dir("PWM_TMR", top);
		debugfs_create_x16("TIMER0_CONFIG", 0600, parent, (u16 *)0xFFC01600);
		debugfs_create_x32("TIMER0_COUNTER", 0600, parent, (u32 *)0xFFC01604);
		debugfs_create_x32("TIMER0_PERIOD", 0600, parent, (u32 *)0xFFC01608);
		debugfs_create_x32("TIMER0_WIDTH", 0600, parent, (u32 *)0xFFC0160C);
		debugfs_create_x16("TIMER1_CONFIG", 0600, parent, (u16 *)0xFFC01610);
		debugfs_create_x32("TIMER1_COUNTER", 0600, parent, (u32 *)0xFFC01614);
		debugfs_create_x32("TIMER1_PERIOD", 0600, parent, (u32 *)0xFFC01618);
		debugfs_create_x32("TIMER1_WIDTH", 0600, parent, (u32 *)0xFFC0161C);
		debugfs_create_x16("TIMER2_CONFIG", 0600, parent, (u16 *)0xFFC01620);
		debugfs_create_x32("TIMER2_COUNTER", 0600, parent, (u32 *)0xFFC01624);
		debugfs_create_x32("TIMER2_PERIOD", 0600, parent, (u32 *)0xFFC01628);
		debugfs_create_x32("TIMER2_WIDTH", 0600, parent, (u32 *)0xFFC0162C);
		debugfs_create_x16("TIMER3_CONFIG", 0600, parent, (u16 *)0xFFC01630);
		debugfs_create_x32("TIMER3_COUNTER", 0600, parent, (u32 *)0xFFC01634);
		debugfs_create_x32("TIMER3_PERIOD", 0600, parent, (u32 *)0xFFC01638);
		debugfs_create_x32("TIMER3_WIDTH", 0600, parent, (u32 *)0xFFC0163C);
		debugfs_create_x16("TIMER4_CONFIG", 0600, parent, (u16 *)0xFFC01640);
		debugfs_create_x32("TIMER4_COUNTER", 0600, parent, (u32 *)0xFFC01644);
		debugfs_create_x32("TIMER4_PERIOD", 0600, parent, (u32 *)0xFFC01648);
		debugfs_create_x32("TIMER4_WIDTH", 0600, parent, (u32 *)0xFFC0164C);
		debugfs_create_x16("TIMER5_CONFIG", 0600, parent, (u16 *)0xFFC01650);
		debugfs_create_x32("TIMER5_COUNTER", 0600, parent, (u32 *)0xFFC01654);
		debugfs_create_x32("TIMER5_PERIOD", 0600, parent, (u32 *)0xFFC01658);
		debugfs_create_x32("TIMER5_WIDTH", 0600, parent, (u32 *)0xFFC0165C);
		debugfs_create_x16("TIMER6_CONFIG", 0600, parent, (u16 *)0xFFC01660);
		debugfs_create_x32("TIMER6_COUNTER", 0600, parent, (u32 *)0xFFC01664);
		debugfs_create_x32("TIMER6_PERIOD", 0600, parent, (u32 *)0xFFC01668);
		debugfs_create_x32("TIMER6_WIDTH", 0600, parent, (u32 *)0xFFC0166C);
		debugfs_create_x16("TIMER7_CONFIG", 0600, parent, (u16 *)0xFFC01670);
		debugfs_create_x32("TIMER7_COUNTER", 0600, parent, (u32 *)0xFFC01674);
		debugfs_create_x32("TIMER7_PERIOD", 0600, parent, (u32 *)0xFFC01678);
		debugfs_create_x32("TIMER7_WIDTH", 0600, parent, (u32 *)0xFFC0167C);
		debugfs_create_x16("TIMER_DISABLE0", 0600, parent, (u16 *)0xFFC01684);
		debugfs_create_x16("TIMER_ENABLE0", 0600, parent, (u16 *)0xFFC01680);
		debugfs_create_x32("TIMER_STATUS0", 0600, parent, (u32 *)0xFFC01688);

		parent = debugfs_create_dir("Port_A", top);
		debugfs_create_x16("PORTA", 0600, parent, (u16 *)0xFFC014C4);
		debugfs_create_x16("PORTA_CLEAR", 0600, parent, (u16 *)0xFFC014CC);
		debugfs_create_x16("PORTA_DIR_CLEAR", 0600, parent, (u16 *)0xFFC014D4);
		debugfs_create_x16("PORTA_DIR_SET", 0600, parent, (u16 *)0xFFC014D0);
		debugfs_create_x16("PORTA_FER", 0600, parent, (u16 *)0xFFC014C0);
		debugfs_create_x16("PORTA_INEN", 0600, parent, (u16 *)0xFFC014D8);
		debugfs_create_x32("PORTA_MUX", 0600, parent, (u32 *)0xFFC014DC);
		debugfs_create_x16("PORTA_SET", 0600, parent, (u16 *)0xFFC014C8);

		parent = debugfs_create_dir("Port_B", top);
		debugfs_create_x16("PORTB", 0600, parent, (u16 *)0xFFC014E4);
		debugfs_create_x16("PORTB_CLEAR", 0600, parent, (u16 *)0xFFC014EC);
		debugfs_create_x16("PORTB_DIR_CLEAR", 0600, parent, (u16 *)0xFFC014F4);
		debugfs_create_x16("PORTB_DIR_SET", 0600, parent, (u16 *)0xFFC014F0);
		debugfs_create_x16("PORTB_FER", 0600, parent, (u16 *)0xFFC014E0);
		debugfs_create_x16("PORTB_INEN", 0600, parent, (u16 *)0xFFC014F8);
		debugfs_create_x32("PORTB_MUX", 0600, parent, (u32 *)0xFFC014FC);
		debugfs_create_x16("PORTB_SET", 0600, parent, (u16 *)0xFFC014E8);

		parent = debugfs_create_dir("Port_C", top);
		debugfs_create_x16("PORTC", 0600, parent, (u16 *)0xFFC01504);
		debugfs_create_x16("PORTC_CLEAR", 0600, parent, (u16 *)0xFFC0150C);
		debugfs_create_x16("PORTC_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01514);
		debugfs_create_x16("PORTC_DIR_SET", 0600, parent, (u16 *)0xFFC01510);
		debugfs_create_x16("PORTC_FER", 0600, parent, (u16 *)0xFFC01500);
		debugfs_create_x16("PORTC_INEN", 0600, parent, (u16 *)0xFFC01518);
		debugfs_create_x32("PORTC_MUX", 0600, parent, (u32 *)0xFFC0151C);
		debugfs_create_x16("PORTC_SET", 0600, parent, (u16 *)0xFFC01508);

		parent = debugfs_create_dir("Port_D", top);
		debugfs_create_x16("PORTD", 0600, parent, (u16 *)0xFFC01524);
		debugfs_create_x16("PORTD_CLEAR", 0600, parent, (u16 *)0xFFC0152C);
		debugfs_create_x16("PORTD_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01534);
		debugfs_create_x16("PORTD_DIR_SET", 0600, parent, (u16 *)0xFFC01530);
		debugfs_create_x16("PORTD_FER", 0600, parent, (u16 *)0xFFC01520);
		debugfs_create_x16("PORTD_INEN", 0600, parent, (u16 *)0xFFC01538);
		debugfs_create_x32("PORTD_MUX", 0600, parent, (u32 *)0xFFC0153C);
		debugfs_create_x16("PORTD_SET", 0600, parent, (u16 *)0xFFC01528);

		parent = debugfs_create_dir("Port_E", top);
		debugfs_create_x16("PORTE", 0600, parent, (u16 *)0xFFC01544);
		debugfs_create_x16("PORTE_CLEAR", 0600, parent, (u16 *)0xFFC0154C);
		debugfs_create_x16("PORTE_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01554);
		debugfs_create_x16("PORTE_DIR_SET", 0600, parent, (u16 *)0xFFC01550);
		debugfs_create_x16("PORTE_FER", 0600, parent, (u16 *)0xFFC01540);
		debugfs_create_x16("PORTE_INEN", 0600, parent, (u16 *)0xFFC01558);
		debugfs_create_x32("PORTE_MUX", 0600, parent, (u32 *)0xFFC0155C);
		debugfs_create_x16("PORTE_SET", 0600, parent, (u16 *)0xFFC01548);

		parent = debugfs_create_dir("Port_F", top);
		debugfs_create_x16("PORTF", 0600, parent, (u16 *)0xFFC01564);
		debugfs_create_x16("PORTF_CLEAR", 0600, parent, (u16 *)0xFFC0156C);
		debugfs_create_x16("PORTF_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01574);
		debugfs_create_x16("PORTF_DIR_SET", 0600, parent, (u16 *)0xFFC01570);
		debugfs_create_x16("PORTF_FER", 0600, parent, (u16 *)0xFFC01560);
		debugfs_create_x16("PORTF_INEN", 0600, parent, (u16 *)0xFFC01578);
		debugfs_create_x32("PORTF_MUX", 0600, parent, (u32 *)0xFFC0157C);
		debugfs_create_x16("PORTF_SET", 0600, parent, (u16 *)0xFFC01568);

		parent = debugfs_create_dir("Port_G", top);
		debugfs_create_x16("PORTG", 0600, parent, (u16 *)0xFFC01584);
		debugfs_create_x16("PORTG_CLEAR", 0600, parent, (u16 *)0xFFC0158C);
		debugfs_create_x16("PORTG_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01594);
		debugfs_create_x16("PORTG_DIR_SET", 0600, parent, (u16 *)0xFFC01590);
		debugfs_create_x16("PORTG_FER", 0600, parent, (u16 *)0xFFC01580);
		debugfs_create_x16("PORTG_INEN", 0600, parent, (u16 *)0xFFC01598);
		debugfs_create_x32("PORTG_MUX", 0600, parent, (u32 *)0xFFC0159C);
		debugfs_create_x16("PORTG_SET", 0600, parent, (u16 *)0xFFC01588);

		parent = debugfs_create_dir("Port_H", top);
		debugfs_create_x16("PORTH", 0600, parent, (u16 *)0xFFC015A4);
		debugfs_create_x16("PORTH_CLEAR", 0600, parent, (u16 *)0xFFC015AC);
		debugfs_create_x16("PORTH_DIR_CLEAR", 0600, parent, (u16 *)0xFFC015B4);
		debugfs_create_x16("PORTH_DIR_SET", 0600, parent, (u16 *)0xFFC015B0);
		debugfs_create_x16("PORTH_FER", 0600, parent, (u16 *)0xFFC015A0);
		debugfs_create_x16("PORTH_INEN", 0600, parent, (u16 *)0xFFC015B8);
		debugfs_create_x32("PORTH_MUX", 0600, parent, (u32 *)0xFFC015BC);
		debugfs_create_x16("PORTH_SET", 0600, parent, (u16 *)0xFFC015A8);

		parent = debugfs_create_dir("Port_I", top);
		debugfs_create_x16("PORTI", 0600, parent, (u16 *)0xFFC015C4);
		debugfs_create_x16("PORTI_CLEAR", 0600, parent, (u16 *)0xFFC015CC);
		debugfs_create_x16("PORTI_DIR_CLEAR", 0600, parent, (u16 *)0xFFC015D4);
		debugfs_create_x16("PORTI_DIR_SET", 0600, parent, (u16 *)0xFFC015D0);
		debugfs_create_x16("PORTI_FER", 0600, parent, (u16 *)0xFFC015C0);
		debugfs_create_x16("PORTI_INEN", 0600, parent, (u16 *)0xFFC015D8);
		debugfs_create_x32("PORTI_MUX", 0600, parent, (u32 *)0xFFC015DC);
		debugfs_create_x16("PORTI_SET", 0600, parent, (u16 *)0xFFC015C8);

		parent = debugfs_create_dir("Port_J", top);
		debugfs_create_x16("PORTJ", 0600, parent, (u16 *)0xFFC015E4);
		debugfs_create_x16("PORTJ_CLEAR", 0600, parent, (u16 *)0xFFC015EC);
		debugfs_create_x16("PORTJ_DIR_CLEAR", 0600, parent, (u16 *)0xFFC015F4);
		debugfs_create_x16("PORTJ_DIR_SET", 0600, parent, (u16 *)0xFFC015F0);
		debugfs_create_x16("PORTJ_FER", 0600, parent, (u16 *)0xFFC015E0);
		debugfs_create_x16("PORTJ_INEN", 0600, parent, (u16 *)0xFFC015F8);
		debugfs_create_x32("PORTJ_MUX", 0600, parent, (u32 *)0xFFC015FC);
		debugfs_create_x16("PORTJ_SET", 0600, parent, (u16 *)0xFFC015E8);

		parent = debugfs_create_dir("RTC", top);
		debugfs_create_x32("RTC_ALARM", 0600, parent, (u32 *)0xFFC00310);
		debugfs_create_x16("RTC_ICTL", 0600, parent, (u16 *)0xFFC00304);
		debugfs_create_x16("RTC_ISTAT", 0600, parent, (u16 *)0xFFC00308);
		debugfs_create_x16("RTC_PREN", 0600, parent, (u16 *)0xFFC00314);
		debugfs_create_x32("RTC_STAT", 0600, parent, (u32 *)0xFFC00300);
		debugfs_create_x16("RTC_SWCNT", 0600, parent, (u16 *)0xFFC0030C);

		parent = debugfs_create_dir("SDH", top);
		debugfs_create_x32("SDH_ARGUMENT", 0600, parent, (u32 *)0xFFC03908);
		debugfs_create_x16("SDH_CFG", 0600, parent, (u16 *)0xFFC039C8);
		debugfs_create_x16("SDH_CLK_CTL", 0600, parent, (u16 *)0xFFC03904);
		debugfs_create_x16("SDH_COMMAND", 0600, parent, (u16 *)0xFFC0390C);
		debugfs_create_x16("SDH_DATA_CNT", 0600, parent, (u16 *)0xFFC03930);
		debugfs_create_x16("SDH_DATA_CTL", 0600, parent, (u16 *)0xFFC0392C);
		debugfs_create_x16("SDH_DATA_LGTH", 0600, parent, (u16 *)0xFFC03928);
		debugfs_create_x32("SDH_DATA_TIMER", 0600, parent, (u32 *)0xFFC03924);
		debugfs_create_x16("SDH_E_MASK", 0600, parent, (u16 *)0xFFC039C4);
		debugfs_create_x16("SDH_E_STATUS", 0600, parent, (u16 *)0xFFC039C0);
		debugfs_create_x32("SDH_FIFO", 0600, parent, (u32 *)0xFFC03980);
		debugfs_create_x16("SDH_FIFO_CNT", 0600, parent, (u16 *)0xFFC03948);
		debugfs_create_x32("SDH_MASK0", 0600, parent, (u32 *)0xFFC0393C);
		debugfs_create_x32("SDH_MASK1", 0600, parent, (u32 *)0xFFC03940);
		debugfs_create_x16("SDH_PID0", 0600, parent, (u16 *)0xFFC039D0);
		debugfs_create_x16("SDH_PID1", 0600, parent, (u16 *)0xFFC039D4);
		debugfs_create_x16("SDH_PID2", 0600, parent, (u16 *)0xFFC039D8);
		debugfs_create_x16("SDH_PID3", 0600, parent, (u16 *)0xFFC039DC);
		debugfs_create_x16("SDH_PID4", 0600, parent, (u16 *)0xFFC039E0);
		debugfs_create_x16("SDH_PID5", 0600, parent, (u16 *)0xFFC039E4);
		debugfs_create_x16("SDH_PID6", 0600, parent, (u16 *)0xFFC039E8);
		debugfs_create_x16("SDH_PID7", 0600, parent, (u16 *)0xFFC039EC);
		debugfs_create_x16("SDH_PWR_CTL", 0600, parent, (u16 *)0xFFC03900);
		debugfs_create_x16("SDH_RD_WAIT_EN", 0600, parent, (u16 *)0xFFC039CC);
		debugfs_create_x32("SDH_RESPONSE0", 0600, parent, (u32 *)0xFFC03914);
		debugfs_create_x32("SDH_RESPONSE1", 0600, parent, (u32 *)0xFFC03918);
		debugfs_create_x32("SDH_RESPONSE2", 0600, parent, (u32 *)0xFFC0391C);
		debugfs_create_x32("SDH_RESPONSE3", 0600, parent, (u32 *)0xFFC03920);
		debugfs_create_x16("SDH_RESP_CMD", 0600, parent, (u16 *)0xFFC03910);
		debugfs_create_x32("SDH_STATUS", 0600, parent, (u32 *)0xFFC03934);
		debugfs_create_x16("SDH_STATUS_CLR", 0600, parent, (u16 *)0xFFC03938);

		parent = debugfs_create_dir("SIC", top);
		debugfs_create_x32("SIC_IAR0", 0600, parent, (u32 *)0xFFC00130);
		debugfs_create_x32("SIC_IAR10", 0600, parent, (u32 *)0xFFC00158);
		debugfs_create_x32("SIC_IAR11", 0600, parent, (u32 *)0xFFC0015C);
		debugfs_create_x32("SIC_IAR1", 0600, parent, (u32 *)0xFFC00134);
		debugfs_create_x32("SIC_IAR2", 0600, parent, (u32 *)0xFFC00138);
		debugfs_create_x32("SIC_IAR3", 0600, parent, (u32 *)0xFFC0013C);
		debugfs_create_x32("SIC_IAR4", 0600, parent, (u32 *)0xFFC00140);
		debugfs_create_x32("SIC_IAR5", 0600, parent, (u32 *)0xFFC00144);
		debugfs_create_x32("SIC_IAR6", 0600, parent, (u32 *)0xFFC00148);
		debugfs_create_x32("SIC_IAR7", 0600, parent, (u32 *)0xFFC0014C);
		debugfs_create_x32("SIC_IAR8", 0600, parent, (u32 *)0xFFC00150);
		debugfs_create_x32("SIC_IAR9", 0600, parent, (u32 *)0xFFC00154);
		debugfs_create_x32("SIC_IMASK0", 0600, parent, (u32 *)0xFFC0010C);
		debugfs_create_x32("SIC_IMASK1", 0600, parent, (u32 *)0xFFC00110);
		debugfs_create_x32("SIC_IMASK2", 0600, parent, (u32 *)0xFFC00114);
		debugfs_create_x32("SIC_ISR0", 0600, parent, (u32 *)0xFFC00118);
		debugfs_create_x32("SIC_ISR1", 0600, parent, (u32 *)0xFFC0011C);
		debugfs_create_x32("SIC_ISR2", 0600, parent, (u32 *)0xFFC00120);
		debugfs_create_x32("SIC_IWR0", 0600, parent, (u32 *)0xFFC00124);
		debugfs_create_x32("SIC_IWR1", 0600, parent, (u32 *)0xFFC00128);
		debugfs_create_x32("SIC_IWR2", 0600, parent, (u32 *)0xFFC0012C);

		parent = debugfs_create_dir("SPI", top);
		debugfs_create_x16("SPI0_BAUD", 0600, parent, (u16 *)0xFFC00514);
		debugfs_create_x16("SPI0_CTL", 0600, parent, (u16 *)0xFFC00500);
		debugfs_create_x16("SPI0_FLG", 0600, parent, (u16 *)0xFFC00504);
		debugfs_create_x16("SPI0_RDBR", 0600, parent, (u16 *)0xFFC00510);
		debugfs_create_x16("SPI0_SHADOW", 0600, parent, (u16 *)0xFFC00518);
		debugfs_create_x16("SPI0_STAT", 0600, parent, (u16 *)0xFFC00508);
		debugfs_create_x16("SPI0_TDBR", 0600, parent, (u16 *)0xFFC0050C);
		debugfs_create_x16("SPI1_BAUD", 0600, parent, (u16 *)0xFFC02314);
		debugfs_create_x16("SPI1_CTL", 0600, parent, (u16 *)0xFFC02300);
		debugfs_create_x16("SPI1_FLG", 0600, parent, (u16 *)0xFFC02304);
		debugfs_create_x16("SPI1_RDBR", 0600, parent, (u16 *)0xFFC02310);
		debugfs_create_x16("SPI1_SHADOW", 0600, parent, (u16 *)0xFFC02318);
		debugfs_create_x16("SPI1_STAT", 0600, parent, (u16 *)0xFFC02308);
		debugfs_create_x16("SPI1_TDBR", 0600, parent, (u16 *)0xFFC0230C);

		parent = debugfs_create_dir("SPORT", top);
		debugfs_create_x16("SPORT1_CHNL", 0600, parent, (u16 *)0xFFC00934);
		debugfs_create_x16("SPORT1_MCMC1", 0600, parent, (u16 *)0xFFC00938);
		debugfs_create_x16("SPORT1_MCMC2", 0600, parent, (u16 *)0xFFC0093C);
		debugfs_create_x32("SPORT1_MRCS0", 0600, parent, (u32 *)0xFFC00950);
		debugfs_create_x32("SPORT1_MRCS1", 0600, parent, (u32 *)0xFFC00954);
		debugfs_create_x32("SPORT1_MRCS2", 0600, parent, (u32 *)0xFFC00958);
		debugfs_create_x32("SPORT1_MRCS3", 0600, parent, (u32 *)0xFFC0095C);
		debugfs_create_x32("SPORT1_MTCS0", 0600, parent, (u32 *)0xFFC00940);
		debugfs_create_x32("SPORT1_MTCS1", 0600, parent, (u32 *)0xFFC00944);
		debugfs_create_x32("SPORT1_MTCS2", 0600, parent, (u32 *)0xFFC00948);
		debugfs_create_x32("SPORT1_MTCS3", 0600, parent, (u32 *)0xFFC0094C);
		debugfs_create_x16("SPORT1_RCLKDIV", 0600, parent, (u16 *)0xFFC00928);
		debugfs_create_x16("SPORT1_RCR1", 0600, parent, (u16 *)0xFFC00920);
		debugfs_create_x16("SPORT1_RCR2", 0600, parent, (u16 *)0xFFC00924);
		debugfs_create_x16("SPORT1_RFSDIV", 0600, parent, (u16 *)0xFFC0092C);
		debugfs_create_x32("SPORT1_RX", 0600, parent, (u32 *)0xFFC00918);
		debugfs_create_x16("SPORT1_STAT", 0600, parent, (u16 *)0xFFC00930);
		debugfs_create_x16("SPORT1_TCLKDIV", 0600, parent, (u16 *)0xFFC00908);
		debugfs_create_x16("SPORT1_TCR1", 0600, parent, (u16 *)0xFFC00900);
		debugfs_create_x16("SPORT1_TCR2", 0600, parent, (u16 *)0xFFC00904);
		debugfs_create_x16("SPORT1_TFSDIV", 0600, parent, (u16 *)0xFFC0090C);
		debugfs_create_x32("SPORT1_TX", 0600, parent, (u32 *)0xFFC00910);
		debugfs_create_x16("SPORT2_CHNL", 0600, parent, (u16 *)0xFFC02534);
		debugfs_create_x16("SPORT2_MCMC1", 0600, parent, (u16 *)0xFFC02538);
		debugfs_create_x16("SPORT2_MCMC2", 0600, parent, (u16 *)0xFFC0253C);
		debugfs_create_x32("SPORT2_MRCS0", 0600, parent, (u32 *)0xFFC02550);
		debugfs_create_x32("SPORT2_MRCS1", 0600, parent, (u32 *)0xFFC02554);
		debugfs_create_x32("SPORT2_MRCS2", 0600, parent, (u32 *)0xFFC02558);
		debugfs_create_x32("SPORT2_MRCS3", 0600, parent, (u32 *)0xFFC0255C);
		debugfs_create_x32("SPORT2_MTCS0", 0600, parent, (u32 *)0xFFC02540);
		debugfs_create_x32("SPORT2_MTCS1", 0600, parent, (u32 *)0xFFC02544);
		debugfs_create_x32("SPORT2_MTCS2", 0600, parent, (u32 *)0xFFC02548);
		debugfs_create_x32("SPORT2_MTCS3", 0600, parent, (u32 *)0xFFC0254C);
		debugfs_create_x16("SPORT2_RCLKDIV", 0600, parent, (u16 *)0xFFC02528);
		debugfs_create_x16("SPORT2_RCR1", 0600, parent, (u16 *)0xFFC02520);
		debugfs_create_x16("SPORT2_RCR2", 0600, parent, (u16 *)0xFFC02524);
		debugfs_create_x16("SPORT2_RFSDIV", 0600, parent, (u16 *)0xFFC0252C);
		debugfs_create_x32("SPORT2_RX", 0600, parent, (u32 *)0xFFC02518);
		debugfs_create_x16("SPORT2_STAT", 0600, parent, (u16 *)0xFFC02530);
		debugfs_create_x16("SPORT2_TCLKDIV", 0600, parent, (u16 *)0xFFC02508);
		debugfs_create_x16("SPORT2_TCR1", 0600, parent, (u16 *)0xFFC02500);
		debugfs_create_x16("SPORT2_TCR2", 0600, parent, (u16 *)0xFFC02504);
		debugfs_create_x16("SPORT2_TFSDIV", 0600, parent, (u16 *)0xFFC0250C);
		debugfs_create_x32("SPORT2_TX", 0600, parent, (u32 *)0xFFC02510);
		debugfs_create_x16("SPORT3_CHNL", 0600, parent, (u16 *)0xFFC02634);
		debugfs_create_x16("SPORT3_MCMC1", 0600, parent, (u16 *)0xFFC02638);
		debugfs_create_x16("SPORT3_MCMC2", 0600, parent, (u16 *)0xFFC0263C);
		debugfs_create_x32("SPORT3_MRCS0", 0600, parent, (u32 *)0xFFC02650);
		debugfs_create_x32("SPORT3_MRCS1", 0600, parent, (u32 *)0xFFC02654);
		debugfs_create_x32("SPORT3_MRCS2", 0600, parent, (u32 *)0xFFC02658);
		debugfs_create_x32("SPORT3_MRCS3", 0600, parent, (u32 *)0xFFC0265C);
		debugfs_create_x32("SPORT3_MTCS0", 0600, parent, (u32 *)0xFFC02640);
		debugfs_create_x32("SPORT3_MTCS1", 0600, parent, (u32 *)0xFFC02644);
		debugfs_create_x32("SPORT3_MTCS2", 0600, parent, (u32 *)0xFFC02648);
		debugfs_create_x32("SPORT3_MTCS3", 0600, parent, (u32 *)0xFFC0264C);
		debugfs_create_x16("SPORT3_RCLKDIV", 0600, parent, (u16 *)0xFFC02628);
		debugfs_create_x16("SPORT3_RCR1", 0600, parent, (u16 *)0xFFC02620);
		debugfs_create_x16("SPORT3_RCR2", 0600, parent, (u16 *)0xFFC02624);
		debugfs_create_x16("SPORT3_RFSDIV", 0600, parent, (u16 *)0xFFC0262C);
		debugfs_create_x32("SPORT3_RX", 0600, parent, (u32 *)0xFFC02618);
		debugfs_create_x16("SPORT3_STAT", 0600, parent, (u16 *)0xFFC02630);
		debugfs_create_x16("SPORT3_TCLKDIV", 0600, parent, (u16 *)0xFFC02608);
		debugfs_create_x16("SPORT3_TCR1", 0600, parent, (u16 *)0xFFC02600);
		debugfs_create_x16("SPORT3_TCR2", 0600, parent, (u16 *)0xFFC02604);
		debugfs_create_x16("SPORT3_TFSDIV", 0600, parent, (u16 *)0xFFC0260C);
		debugfs_create_x32("SPORT3_TX", 0600, parent, (u32 *)0xFFC02610);

		parent = debugfs_create_dir("Security", top);
		debugfs_create_x16("SECURE_CONTROL", 0600, parent, (u16 *)0xFFC04324);
		debugfs_create_x16("SECURE_STATUS", 0600, parent, (u16 *)0xFFC04328);
		debugfs_create_x32("SECURE_SYSSWT", 0600, parent, (u32 *)0xFFC04320);

		parent = debugfs_create_dir("System Reset and Interrupt Control Registers", top);
		debugfs_create_x16("SWRST", 0600, parent, (u16 *)0xFFC00100);
		debugfs_create_x16("SYSCR", 0600, parent, (u16 *)0xFFC00104);

		parent = debugfs_create_dir("TWI", top);
		debugfs_create_x16("TWI0_CLKDIV", 0600, parent, (u16 *)0xFFC00700);
		debugfs_create_x16("TWI0_CONTROL", 0600, parent, (u16 *)0xFFC00704);
		debugfs_create_x16("TWI0_FIFO_CTL", 0600, parent, (u16 *)0xFFC00728);
		debugfs_create_x16("TWI0_FIFO_STAT", 0600, parent, (u16 *)0xFFC0072C);
		debugfs_create_x16("TWI0_INT_MASK", 0600, parent, (u16 *)0xFFC00724);
		debugfs_create_x16("TWI0_INT_STAT", 0600, parent, (u16 *)0xFFC00720);
		debugfs_create_x16("TWI0_MASTER_ADDR", 0600, parent, (u16 *)0xFFC0071C);
		debugfs_create_x16("TWI0_MASTER_CTL", 0600, parent, (u16 *)0xFFC00714);
		debugfs_create_x16("TWI0_MASTER_STAT", 0600, parent, (u16 *)0xFFC00718);
		debugfs_create_x16("TWI0_RCV_DATA16", 0600, parent, (u16 *)0xFFC0078C);
		debugfs_create_x16("TWI0_RCV_DATA8", 0600, parent, (u16 *)0xFFC00788);
		debugfs_create_x16("TWI0_SLAVE_ADDR", 0600, parent, (u16 *)0xFFC00710);
		debugfs_create_x16("TWI0_SLAVE_CTL", 0600, parent, (u16 *)0xFFC00708);
		debugfs_create_x16("TWI0_SLAVE_STAT", 0600, parent, (u16 *)0xFFC0070C);
		debugfs_create_x16("TWI0_XMT_DATA16", 0600, parent, (u16 *)0xFFC00784);
		debugfs_create_x16("TWI0_XMT_DATA8", 0600, parent, (u16 *)0xFFC00780);

		parent = debugfs_create_dir("UART", top);
		debugfs_create_x16("UART0_DLH", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART0_DLL", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART0_GCTL", 0600, parent, (u16 *)0xFFC00408);
		debugfs_create_x16("UART0_IER_CLEAR", 0600, parent, (u16 *)0xFFC00424);
		debugfs_create_x16("UART0_IER_SET", 0600, parent, (u16 *)0xFFC00420);
		debugfs_create_x16("UART0_LCR", 0600, parent, (u16 *)0xFFC0040C);
		debugfs_create_x16("UART0_LSR", 0600, parent, (u16 *)0xFFC00414);
		debugfs_create_x16("UART0_MCR", 0600, parent, (u16 *)0xFFC00410);
		debugfs_create_x16("UART0_MSR", 0600, parent, (u16 *)0xFFC00418);
		debugfs_create_x16("UART0_RBR", 0600, parent, (u16 *)0xFFC0042C);
		debugfs_create_x16("UART0_SCR", 0600, parent, (u16 *)0xFFC0041C);
		debugfs_create_x16("UART0_THR", 0600, parent, (u16 *)0xFFC00428);
		debugfs_create_x16("UART1_DLH", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("UART1_DLL", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART1_GCTL", 0600, parent, (u16 *)0xFFC02008);
		debugfs_create_x16("UART1_IER_CLEAR", 0600, parent, (u16 *)0xFFC02024);
		debugfs_create_x16("UART1_IER_SET", 0600, parent, (u16 *)0xFFC02020);
		debugfs_create_x16("UART1_LCR", 0600, parent, (u16 *)0xFFC0200C);
		debugfs_create_x16("UART1_LSR", 0600, parent, (u16 *)0xFFC02014);
		debugfs_create_x16("UART1_MCR", 0600, parent, (u16 *)0xFFC02010);
		debugfs_create_x16("UART1_MSR", 0600, parent, (u16 *)0xFFC02018);
		debugfs_create_x16("UART1_RBR", 0600, parent, (u16 *)0xFFC0202C);
		debugfs_create_x16("UART1_SCR", 0600, parent, (u16 *)0xFFC0201C);
		debugfs_create_x16("UART1_THR", 0600, parent, (u16 *)0xFFC02028);
		debugfs_create_x16("UART3_DLH", 0600, parent, (u16 *)0xFFC03104);
		debugfs_create_x16("UART3_DLL", 0600, parent, (u16 *)0xFFC03100);
		debugfs_create_x16("UART3_GCTL", 0600, parent, (u16 *)0xFFC03108);
		debugfs_create_x16("UART3_IER_CLEAR", 0600, parent, (u16 *)0xFFC03124);
		debugfs_create_x16("UART3_IER_SET", 0600, parent, (u16 *)0xFFC03120);
		debugfs_create_x16("UART3_LCR", 0600, parent, (u16 *)0xFFC0310C);
		debugfs_create_x16("UART3_LSR", 0600, parent, (u16 *)0xFFC03114);
		debugfs_create_x16("UART3_MCR", 0600, parent, (u16 *)0xFFC03110);
		debugfs_create_x16("UART3_MSR", 0600, parent, (u16 *)0xFFC03118);
		debugfs_create_x16("UART3_RBR", 0600, parent, (u16 *)0xFFC0312C);
		debugfs_create_x16("UART3_SCR", 0600, parent, (u16 *)0xFFC0311C);
		debugfs_create_x16("UART3_THR", 0600, parent, (u16 *)0xFFC03128);

		parent = debugfs_create_dir("USB", top);
		debugfs_create_x16("USB_APHY_CALIB", 0600, parent, (u16 *)0xFFC03DE4);
		debugfs_create_x16("USB_APHY_CNTRL2", 0600, parent, (u16 *)0xFFC03DE8);
		debugfs_create_x16("USB_APHY_CNTRL", 0600, parent, (u16 *)0xFFC03DE0);
		debugfs_create_x16("USB_COUNT0", 0600, parent, (u16 *)0xFFC03C50);
		debugfs_create_x16("USB_CSR0", 0600, parent, (u16 *)0xFFC03C44);
		debugfs_create_x16("USB_DMA0_ADDRHIGH", 0600, parent, (u16 *)0xFFC0400C);
		debugfs_create_x16("USB_DMA0_ADDRLOW", 0600, parent, (u16 *)0xFFC04008);
		debugfs_create_x16("USB_DMA0_CONTROL", 0600, parent, (u16 *)0xFFC04004);
		debugfs_create_x16("USB_DMA0_COUNTHIGH", 0600, parent, (u16 *)0xFFC04014);
		debugfs_create_x16("USB_DMA0_COUNTLOW", 0600, parent, (u16 *)0xFFC04010);
		debugfs_create_x16("USB_DMA1_ADDRHIGH", 0600, parent, (u16 *)0xFFC0402C);
		debugfs_create_x16("USB_DMA1_ADDRLOW", 0600, parent, (u16 *)0xFFC04028);
		debugfs_create_x16("USB_DMA1_CONTROL", 0600, parent, (u16 *)0xFFC04024);
		debugfs_create_x16("USB_DMA1_COUNTHIGH", 0600, parent, (u16 *)0xFFC04034);
		debugfs_create_x16("USB_DMA1_COUNTLOW", 0600, parent, (u16 *)0xFFC04030);
		debugfs_create_x16("USB_DMA2_ADDRHIGH", 0600, parent, (u16 *)0xFFC0404C);
		debugfs_create_x16("USB_DMA2_ADDRLOW", 0600, parent, (u16 *)0xFFC04048);
		debugfs_create_x16("USB_DMA2_CONTROL", 0600, parent, (u16 *)0xFFC04044);
		debugfs_create_x16("USB_DMA2_COUNTHIGH", 0600, parent, (u16 *)0xFFC04054);
		debugfs_create_x16("USB_DMA2_COUNTLOW", 0600, parent, (u16 *)0xFFC04050);
		debugfs_create_x16("USB_DMA3_ADDRHIGH", 0600, parent, (u16 *)0xFFC0406C);
		debugfs_create_x16("USB_DMA3_ADDRLOW", 0600, parent, (u16 *)0xFFC04068);
		debugfs_create_x16("USB_DMA3_CONTROL", 0600, parent, (u16 *)0xFFC04064);
		debugfs_create_x16("USB_DMA3_COUNTHIGH", 0600, parent, (u16 *)0xFFC04074);
		debugfs_create_x16("USB_DMA3_COUNTLOW", 0600, parent, (u16 *)0xFFC04070);
		debugfs_create_x16("USB_DMA4_ADDRHIGH", 0600, parent, (u16 *)0xFFC0408C);
		debugfs_create_x16("USB_DMA4_ADDRLOW", 0600, parent, (u16 *)0xFFC04088);
		debugfs_create_x16("USB_DMA4_CONTROL", 0600, parent, (u16 *)0xFFC04084);
		debugfs_create_x16("USB_DMA4_COUNTHIGH", 0600, parent, (u16 *)0xFFC04094);
		debugfs_create_x16("USB_DMA4_COUNTLOW", 0600, parent, (u16 *)0xFFC04090);
		debugfs_create_x16("USB_DMA5_ADDRHIGH", 0600, parent, (u16 *)0xFFC040AC);
		debugfs_create_x16("USB_DMA5_ADDRLOW", 0600, parent, (u16 *)0xFFC040A8);
		debugfs_create_x16("USB_DMA5_CONTROL", 0600, parent, (u16 *)0xFFC040A4);
		debugfs_create_x16("USB_DMA5_COUNTHIGH", 0600, parent, (u16 *)0xFFC040B4);
		debugfs_create_x16("USB_DMA5_COUNTLOW", 0600, parent, (u16 *)0xFFC040B0);
		debugfs_create_x16("USB_DMA6_ADDRHIGH", 0600, parent, (u16 *)0xFFC040CC);
		debugfs_create_x16("USB_DMA6_ADDRLOW", 0600, parent, (u16 *)0xFFC040C8);
		debugfs_create_x16("USB_DMA6_CONTROL", 0600, parent, (u16 *)0xFFC040C4);
		debugfs_create_x16("USB_DMA6_COUNTHIGH", 0600, parent, (u16 *)0xFFC040D4);
		debugfs_create_x16("USB_DMA6_COUNTLOW", 0600, parent, (u16 *)0xFFC040D0);
		debugfs_create_x16("USB_DMA7_ADDRHIGH", 0600, parent, (u16 *)0xFFC040EC);
		debugfs_create_x16("USB_DMA7_ADDRLOW", 0600, parent, (u16 *)0xFFC040E8);
		debugfs_create_x16("USB_DMA7_CONTROL", 0600, parent, (u16 *)0xFFC040E4);
		debugfs_create_x16("USB_DMA7_COUNTHIGH", 0600, parent, (u16 *)0xFFC040F4);
		debugfs_create_x16("USB_DMA7_COUNTLOW", 0600, parent, (u16 *)0xFFC040F0);
		debugfs_create_x16("USB_DMA_INTERRUPT", 0600, parent, (u16 *)0xFFC04000);
		debugfs_create_x16("USB_EP0_FIFO", 0600, parent, (u16 *)0xFFC03C80);
		debugfs_create_x16("USB_EP1_FIFO", 0600, parent, (u16 *)0xFFC03C88);
		debugfs_create_x16("USB_EP2_FIFO", 0600, parent, (u16 *)0xFFC03C90);
		debugfs_create_x16("USB_EP3_FIFO", 0600, parent, (u16 *)0xFFC03C98);
		debugfs_create_x16("USB_EP4_FIFO", 0600, parent, (u16 *)0xFFC03CA0);
		debugfs_create_x16("USB_EP5_FIFO", 0600, parent, (u16 *)0xFFC03CA8);
		debugfs_create_x16("USB_EP6_FIFO", 0600, parent, (u16 *)0xFFC03CB0);
		debugfs_create_x16("USB_EP7_FIFO", 0600, parent, (u16 *)0xFFC03CB8);
		debugfs_create_x16("USB_EP_NI0_RXCOUNT", 0600, parent, (u16 *)0xFFC03E10);
		debugfs_create_x16("USB_EP_NI0_RXCSR", 0600, parent, (u16 *)0xFFC03E0C);
		debugfs_create_x16("USB_EP_NI0_RXINTERVAL", 0600, parent, (u16 *)0xFFC03E20);
		debugfs_create_x16("USB_EP_NI0_RXMAXP", 0600, parent, (u16 *)0xFFC03E08);
		debugfs_create_x16("USB_EP_NI0_RXTYPE", 0600, parent, (u16 *)0xFFC03E1C);
		debugfs_create_x16("USB_EP_NI0_TXCOUNT", 0600, parent, (u16 *)0xFFC03E28);
		debugfs_create_x16("USB_EP_NI0_TXCSR", 0600, parent, (u16 *)0xFFC03E04);
		debugfs_create_x16("USB_EP_NI0_TXINTERVAL", 0600, parent, (u16 *)0xFFC03E18);
		debugfs_create_x16("USB_EP_NI0_TXMAXP", 0600, parent, (u16 *)0xFFC03E00);
		debugfs_create_x16("USB_EP_NI0_TXTYPE", 0600, parent, (u16 *)0xFFC03E14);
		debugfs_create_x16("USB_EP_NI1_RXCOUNT", 0600, parent, (u16 *)0xFFC03E50);
		debugfs_create_x16("USB_EP_NI1_RXCSR", 0600, parent, (u16 *)0xFFC03E4C);
		debugfs_create_x16("USB_EP_NI1_RXINTERVAL", 0600, parent, (u16 *)0xFFC03E60);
		debugfs_create_x16("USB_EP_NI1_RXMAXP", 0600, parent, (u16 *)0xFFC03E48);
		debugfs_create_x16("USB_EP_NI1_RXTYPE", 0600, parent, (u16 *)0xFFC03E5C);
		debugfs_create_x16("USB_EP_NI1_TXCOUNT", 0600, parent, (u16 *)0xFFC03E68);
		debugfs_create_x16("USB_EP_NI1_TXCSR", 0600, parent, (u16 *)0xFFC03E44);
		debugfs_create_x16("USB_EP_NI1_TXINTERVAL", 0600, parent, (u16 *)0xFFC03E58);
		debugfs_create_x16("USB_EP_NI1_TXMAXP", 0600, parent, (u16 *)0xFFC03E40);
		debugfs_create_x16("USB_EP_NI1_TXTYPE", 0600, parent, (u16 *)0xFFC03E54);
		debugfs_create_x16("USB_EP_NI2_RXCOUNT", 0600, parent, (u16 *)0xFFC03E90);
		debugfs_create_x16("USB_EP_NI2_RXCSR", 0600, parent, (u16 *)0xFFC03E8C);
		debugfs_create_x16("USB_EP_NI2_RXINTERVAL", 0600, parent, (u16 *)0xFFC03EA0);
		debugfs_create_x16("USB_EP_NI2_RXMAXP", 0600, parent, (u16 *)0xFFC03E88);
		debugfs_create_x16("USB_EP_NI2_RXTYPE", 0600, parent, (u16 *)0xFFC03E9C);
		debugfs_create_x16("USB_EP_NI2_TXCOUNT", 0600, parent, (u16 *)0xFFC03EA8);
		debugfs_create_x16("USB_EP_NI2_TXCSR", 0600, parent, (u16 *)0xFFC03E84);
		debugfs_create_x16("USB_EP_NI2_TXINTERVAL", 0600, parent, (u16 *)0xFFC03E98);
		debugfs_create_x16("USB_EP_NI2_TXMAXP", 0600, parent, (u16 *)0xFFC03E80);
		debugfs_create_x16("USB_EP_NI2_TXTYPE", 0600, parent, (u16 *)0xFFC03E94);
		debugfs_create_x16("USB_EP_NI3_RXCOUNT", 0600, parent, (u16 *)0xFFC03ED0);
		debugfs_create_x16("USB_EP_NI3_RXCSR", 0600, parent, (u16 *)0xFFC03ECC);
		debugfs_create_x16("USB_EP_NI3_RXINTERVAL", 0600, parent, (u16 *)0xFFC03EE0);
		debugfs_create_x16("USB_EP_NI3_RXMAXP", 0600, parent, (u16 *)0xFFC03EC8);
		debugfs_create_x16("USB_EP_NI3_RXTYPE", 0600, parent, (u16 *)0xFFC03EDC);
		debugfs_create_x16("USB_EP_NI3_TXCOUNT", 0600, parent, (u16 *)0xFFC03EE8);
		debugfs_create_x16("USB_EP_NI3_TXCSR", 0600, parent, (u16 *)0xFFC03EC4);
		debugfs_create_x16("USB_EP_NI3_TXINTERVAL", 0600, parent, (u16 *)0xFFC03ED8);
		debugfs_create_x16("USB_EP_NI3_TXMAXP", 0600, parent, (u16 *)0xFFC03EC0);
		debugfs_create_x16("USB_EP_NI3_TXTYPE", 0600, parent, (u16 *)0xFFC03ED4);
		debugfs_create_x16("USB_EP_NI4_RXCOUNT", 0600, parent, (u16 *)0xFFC03F10);
		debugfs_create_x16("USB_EP_NI4_RXCSR", 0600, parent, (u16 *)0xFFC03F0C);
		debugfs_create_x16("USB_EP_NI4_RXINTERVAL", 0600, parent, (u16 *)0xFFC03F20);
		debugfs_create_x16("USB_EP_NI4_RXMAXP", 0600, parent, (u16 *)0xFFC03F08);
		debugfs_create_x16("USB_EP_NI4_RXTYPE", 0600, parent, (u16 *)0xFFC03F1C);
		debugfs_create_x16("USB_EP_NI4_TXCOUNT", 0600, parent, (u16 *)0xFFC03F28);
		debugfs_create_x16("USB_EP_NI4_TXCSR", 0600, parent, (u16 *)0xFFC03F04);
		debugfs_create_x16("USB_EP_NI4_TXINTERVAL", 0600, parent, (u16 *)0xFFC03F18);
		debugfs_create_x16("USB_EP_NI4_TXMAXP", 0600, parent, (u16 *)0xFFC03F00);
		debugfs_create_x16("USB_EP_NI4_TXTYPE", 0600, parent, (u16 *)0xFFC03F14);
		debugfs_create_x16("USB_EP_NI5_RXCOUNT", 0600, parent, (u16 *)0xFFC03F50);
		debugfs_create_x16("USB_EP_NI5_RXCSR", 0600, parent, (u16 *)0xFFC03F4C);
		debugfs_create_x16("USB_EP_NI5_RXINTERVAL", 0600, parent, (u16 *)0xFFC03F60);
		debugfs_create_x16("USB_EP_NI5_RXMAXP", 0600, parent, (u16 *)0xFFC03F48);
		debugfs_create_x16("USB_EP_NI5_RXTYPE", 0600, parent, (u16 *)0xFFC03F5C);
		debugfs_create_x16("USB_EP_NI5_TXCOUNT", 0600, parent, (u16 *)0xFFC03F68);
		debugfs_create_x16("USB_EP_NI5_TXCSR", 0600, parent, (u16 *)0xFFC03F44);
		debugfs_create_x16("USB_EP_NI5_TXINTERVAL", 0600, parent, (u16 *)0xFFC03F58);
		debugfs_create_x16("USB_EP_NI5_TXMAXP", 0600, parent, (u16 *)0xFFC03F40);
		debugfs_create_x16("USB_EP_NI5_TXTYPE", 0600, parent, (u16 *)0xFFC03F54);
		debugfs_create_x16("USB_EP_NI6_RXCOUNT", 0600, parent, (u16 *)0xFFC03F90);
		debugfs_create_x16("USB_EP_NI6_RXCSR", 0600, parent, (u16 *)0xFFC03F8C);
		debugfs_create_x16("USB_EP_NI6_RXINTERVAL", 0600, parent, (u16 *)0xFFC03FA0);
		debugfs_create_x16("USB_EP_NI6_RXMAXP", 0600, parent, (u16 *)0xFFC03F88);
		debugfs_create_x16("USB_EP_NI6_RXTYPE", 0600, parent, (u16 *)0xFFC03F9C);
		debugfs_create_x16("USB_EP_NI6_TXCOUNT", 0600, parent, (u16 *)0xFFC03FA8);
		debugfs_create_x16("USB_EP_NI6_TXCSR", 0600, parent, (u16 *)0xFFC03F84);
		debugfs_create_x16("USB_EP_NI6_TXINTERVAL", 0600, parent, (u16 *)0xFFC03F98);
		debugfs_create_x16("USB_EP_NI6_TXMAXP", 0600, parent, (u16 *)0xFFC03F80);
		debugfs_create_x16("USB_EP_NI6_TXTYPE", 0600, parent, (u16 *)0xFFC03F94);
		debugfs_create_x16("USB_EP_NI7_RXCOUNT", 0600, parent, (u16 *)0xFFC03FD0);
		debugfs_create_x16("USB_EP_NI7_RXCSR", 0600, parent, (u16 *)0xFFC03FCC);
		debugfs_create_x16("USB_EP_NI7_RXINTERVAL", 0600, parent, (u16 *)0xFFC03FF0);
		debugfs_create_x16("USB_EP_NI7_RXMAXP", 0600, parent, (u16 *)0xFFC03FC8);
		debugfs_create_x16("USB_EP_NI7_RXTYPE", 0600, parent, (u16 *)0xFFC03FDC);
		debugfs_create_x16("USB_EP_NI7_TXCOUNT", 0600, parent, (u16 *)0xFFC03FF8);
		debugfs_create_x16("USB_EP_NI7_TXCSR", 0600, parent, (u16 *)0xFFC03FC4);
		debugfs_create_x16("USB_EP_NI7_TXINTERVAL", 0600, parent, (u16 *)0xFFC03FD8);
		debugfs_create_x16("USB_EP_NI7_TXMAXP", 0600, parent, (u16 *)0xFFC03FC0);
		debugfs_create_x16("USB_EP_NI7_TXTYPE", 0600, parent, (u16 *)0xFFC03FD4);
		debugfs_create_x16("USB_FADDR", 0600, parent, (u16 *)0xFFC03C00);
		debugfs_create_x16("USB_FRAME", 0600, parent, (u16 *)0xFFC03C20);
		debugfs_create_x16("USB_FS_EOF1", 0600, parent, (u16 *)0xFFC03D54);
		debugfs_create_x16("USB_GLOBAL_CTL", 0600, parent, (u16 *)0xFFC03C30);
		debugfs_create_x16("USB_GLOBINTR", 0600, parent, (u16 *)0xFFC03C2C);
		debugfs_create_x16("USB_HS_EOF1", 0600, parent, (u16 *)0xFFC03D50);
		debugfs_create_x16("USB_INDEX", 0600, parent, (u16 *)0xFFC03C24);
		debugfs_create_x16("USB_INTRRX", 0600, parent, (u16 *)0xFFC03C0C);
		debugfs_create_x16("USB_INTRRXE", 0600, parent, (u16 *)0xFFC03C14);
		debugfs_create_x16("USB_INTRTX", 0600, parent, (u16 *)0xFFC03C08);
		debugfs_create_x16("USB_INTRTXE", 0600, parent, (u16 *)0xFFC03C10);
		debugfs_create_x16("USB_INTRUSB", 0600, parent, (u16 *)0xFFC03C18);
		debugfs_create_x16("USB_INTRUSBE", 0600, parent, (u16 *)0xFFC03C1C);
		debugfs_create_x16("USB_LINKINFO", 0600, parent, (u16 *)0xFFC03D48);
		debugfs_create_x16("USB_LS_EOF1", 0600, parent, (u16 *)0xFFC03D58);
		debugfs_create_x16("USB_NAKLIMIT0", 0600, parent, (u16 *)0xFFC03C58);
		debugfs_create_x16("USB_OTG_DEV_CTL", 0600, parent, (u16 *)0xFFC03D00);
		debugfs_create_x16("USB_OTG_VBUS_IRQ", 0600, parent, (u16 *)0xFFC03D04);
		debugfs_create_x16("USB_OTG_VBUS_MASK", 0600, parent, (u16 *)0xFFC03D08);
		debugfs_create_x16("USB_PHY_TEST", 0600, parent, (u16 *)0xFFC03DEC);
		debugfs_create_x16("USB_PLLOSC_CTRL", 0600, parent, (u16 *)0xFFC03DF0);
		debugfs_create_x16("USB_POWER", 0600, parent, (u16 *)0xFFC03C04);
		debugfs_create_x16("USB_RXCOUNT", 0600, parent, (u16 *)0xFFC03C50);
		debugfs_create_x16("USB_RXCSR", 0600, parent, (u16 *)0xFFC03C4C);
		debugfs_create_x16("USB_RXINTERVAL", 0600, parent, (u16 *)0xFFC03C60);
		debugfs_create_x16("USB_RXTYPE", 0600, parent, (u16 *)0xFFC03C5C);
		debugfs_create_x16("USB_RX_MAX_PACKET", 0600, parent, (u16 *)0xFFC03C48);
		debugfs_create_x16("USB_SRP_CLKDIV", 0600, parent, (u16 *)0xFFC03DF4);
		debugfs_create_x16("USB_TESTMODE", 0600, parent, (u16 *)0xFFC03C28);
		debugfs_create_x16("USB_TXCOUNT", 0600, parent, (u16 *)0xFFC03C68);
		debugfs_create_x16("USB_TXCSR", 0600, parent, (u16 *)0xFFC03C44);
		debugfs_create_x16("USB_TXINTERVAL", 0600, parent, (u16 *)0xFFC03C58);
		debugfs_create_x16("USB_TXTYPE", 0600, parent, (u16 *)0xFFC03C54);
		debugfs_create_x16("USB_TX_MAX_PACKET", 0600, parent, (u16 *)0xFFC03C40);
		debugfs_create_x16("USB_VPLEN", 0600, parent, (u16 *)0xFFC03D4C);

		parent = debugfs_create_dir("Watchdog", top);
		debugfs_create_x32("WDOG_CNT", 0600, parent, (u32 *)0xFFC00204);
		debugfs_create_x16("WDOG_CTL", 0600, parent, (u16 *)0xFFC00200);
		debugfs_create_x32("WDOG_STAT", 0600, parent, (u32 *)0xFFC00208);

		parent = debugfs_create_dir("Watchpoint and Patch Unit", top);
		debugfs_create_x32("WPDA0", 0600, parent, (u32 *)0xFFE07140);
		debugfs_create_x32("WPDA1", 0600, parent, (u32 *)0xFFE07144);
		debugfs_create_x32("WPDACNT0", 0600, parent, (u32 *)0xFFE07180);
		debugfs_create_x32("WPDACNT1", 0600, parent, (u32 *)0xFFE07184);
		debugfs_create_x32("WPDACTL", 0600, parent, (u32 *)0xFFE07100);
		debugfs_create_x32("WPIA0", 0600, parent, (u32 *)0xFFE07040);
		debugfs_create_x32("WPIA1", 0600, parent, (u32 *)0xFFE07044);
		debugfs_create_x32("WPIA2", 0600, parent, (u32 *)0xFFE07048);
		debugfs_create_x32("WPIA3", 0600, parent, (u32 *)0xFFE0704C);
		debugfs_create_x32("WPIA4", 0600, parent, (u32 *)0xFFE07050);
		debugfs_create_x32("WPIA5", 0600, parent, (u32 *)0xFFE07054);
		debugfs_create_x32("WPIACNT0", 0600, parent, (u32 *)0xFFE07080);
		debugfs_create_x32("WPIACNT1", 0600, parent, (u32 *)0xFFE07084);
		debugfs_create_x32("WPIACNT2", 0600, parent, (u32 *)0xFFE07088);
		debugfs_create_x32("WPIACNT3", 0600, parent, (u32 *)0xFFE0708C);
		debugfs_create_x32("WPIACNT4", 0600, parent, (u32 *)0xFFE07090);
		debugfs_create_x32("WPIACNT5", 0600, parent, (u32 *)0xFFE07094);
		debugfs_create_x32("WPIACTL", 0600, parent, (u32 *)0xFFE07000);
		debugfs_create_x32("WPSTAT", 0600, parent, (u32 *)0xFFE07200);

	}	/* BF542 */

#ifdef __ADSPBF544__
# define USE_BF544 1
#else
# define USE_BF544 0
#endif
	if (USE_BF544) {

		parent = debugfs_create_dir("CAN0 Acceptance Mask RAM", top);
		debugfs_create_x16("CAN0_AM00H", 0600, parent, (u16 *)0xFFC02B04);
		debugfs_create_x16("CAN0_AM00L", 0600, parent, (u16 *)0xFFC02B00);
		debugfs_create_x16("CAN0_AM01H", 0600, parent, (u16 *)0xFFC02B0C);
		debugfs_create_x16("CAN0_AM01L", 0600, parent, (u16 *)0xFFC02B08);
		debugfs_create_x16("CAN0_AM02H", 0600, parent, (u16 *)0xFFC02B14);
		debugfs_create_x16("CAN0_AM02L", 0600, parent, (u16 *)0xFFC02B10);
		debugfs_create_x16("CAN0_AM03H", 0600, parent, (u16 *)0xFFC02B1C);
		debugfs_create_x16("CAN0_AM03L", 0600, parent, (u16 *)0xFFC02B18);
		debugfs_create_x16("CAN0_AM04H", 0600, parent, (u16 *)0xFFC02B24);
		debugfs_create_x16("CAN0_AM04L", 0600, parent, (u16 *)0xFFC02B20);
		debugfs_create_x16("CAN0_AM05H", 0600, parent, (u16 *)0xFFC02B2C);
		debugfs_create_x16("CAN0_AM05L", 0600, parent, (u16 *)0xFFC02B28);
		debugfs_create_x16("CAN0_AM06H", 0600, parent, (u16 *)0xFFC02B34);
		debugfs_create_x16("CAN0_AM06L", 0600, parent, (u16 *)0xFFC02B30);
		debugfs_create_x16("CAN0_AM07H", 0600, parent, (u16 *)0xFFC02B3C);
		debugfs_create_x16("CAN0_AM07L", 0600, parent, (u16 *)0xFFC02B38);
		debugfs_create_x16("CAN0_AM08H", 0600, parent, (u16 *)0xFFC02B44);
		debugfs_create_x16("CAN0_AM08L", 0600, parent, (u16 *)0xFFC02B40);
		debugfs_create_x16("CAN0_AM09H", 0600, parent, (u16 *)0xFFC02B4C);
		debugfs_create_x16("CAN0_AM09L", 0600, parent, (u16 *)0xFFC02B48);
		debugfs_create_x16("CAN0_AM10H", 0600, parent, (u16 *)0xFFC02B54);
		debugfs_create_x16("CAN0_AM10L", 0600, parent, (u16 *)0xFFC02B50);
		debugfs_create_x16("CAN0_AM11H", 0600, parent, (u16 *)0xFFC02B5C);
		debugfs_create_x16("CAN0_AM11L", 0600, parent, (u16 *)0xFFC02B58);
		debugfs_create_x16("CAN0_AM12H", 0600, parent, (u16 *)0xFFC02B64);
		debugfs_create_x16("CAN0_AM12L", 0600, parent, (u16 *)0xFFC02B60);
		debugfs_create_x16("CAN0_AM13H", 0600, parent, (u16 *)0xFFC02B6C);
		debugfs_create_x16("CAN0_AM13L", 0600, parent, (u16 *)0xFFC02B68);
		debugfs_create_x16("CAN0_AM14H", 0600, parent, (u16 *)0xFFC02B74);
		debugfs_create_x16("CAN0_AM14L", 0600, parent, (u16 *)0xFFC02B70);
		debugfs_create_x16("CAN0_AM15H", 0600, parent, (u16 *)0xFFC02B7C);
		debugfs_create_x16("CAN0_AM15L", 0600, parent, (u16 *)0xFFC02B78);
		debugfs_create_x16("CAN0_AM16H", 0600, parent, (u16 *)0xFFC02B84);
		debugfs_create_x16("CAN0_AM16L", 0600, parent, (u16 *)0xFFC02B80);
		debugfs_create_x16("CAN0_AM17H", 0600, parent, (u16 *)0xFFC02B8C);
		debugfs_create_x16("CAN0_AM17L", 0600, parent, (u16 *)0xFFC02B88);
		debugfs_create_x16("CAN0_AM18H", 0600, parent, (u16 *)0xFFC02B94);
		debugfs_create_x16("CAN0_AM18L", 0600, parent, (u16 *)0xFFC02B90);
		debugfs_create_x16("CAN0_AM19H", 0600, parent, (u16 *)0xFFC02B9C);
		debugfs_create_x16("CAN0_AM19L", 0600, parent, (u16 *)0xFFC02B98);
		debugfs_create_x16("CAN0_AM20H", 0600, parent, (u16 *)0xFFC02BA4);
		debugfs_create_x16("CAN0_AM20L", 0600, parent, (u16 *)0xFFC02BA0);
		debugfs_create_x16("CAN0_AM21H", 0600, parent, (u16 *)0xFFC02BAC);
		debugfs_create_x16("CAN0_AM21L", 0600, parent, (u16 *)0xFFC02BA8);
		debugfs_create_x16("CAN0_AM22H", 0600, parent, (u16 *)0xFFC02BB4);
		debugfs_create_x16("CAN0_AM22L", 0600, parent, (u16 *)0xFFC02BB0);
		debugfs_create_x16("CAN0_AM23H", 0600, parent, (u16 *)0xFFC02BBC);
		debugfs_create_x16("CAN0_AM23L", 0600, parent, (u16 *)0xFFC02BB8);
		debugfs_create_x16("CAN0_AM24H", 0600, parent, (u16 *)0xFFC02BC4);
		debugfs_create_x16("CAN0_AM24L", 0600, parent, (u16 *)0xFFC02BC0);
		debugfs_create_x16("CAN0_AM25H", 0600, parent, (u16 *)0xFFC02BCC);
		debugfs_create_x16("CAN0_AM25L", 0600, parent, (u16 *)0xFFC02BC8);
		debugfs_create_x16("CAN0_AM26H", 0600, parent, (u16 *)0xFFC02BD4);
		debugfs_create_x16("CAN0_AM26L", 0600, parent, (u16 *)0xFFC02BD0);
		debugfs_create_x16("CAN0_AM27H", 0600, parent, (u16 *)0xFFC02BDC);
		debugfs_create_x16("CAN0_AM27L", 0600, parent, (u16 *)0xFFC02BD8);
		debugfs_create_x16("CAN0_AM28H", 0600, parent, (u16 *)0xFFC02BE4);
		debugfs_create_x16("CAN0_AM28L", 0600, parent, (u16 *)0xFFC02BE0);
		debugfs_create_x16("CAN0_AM29H", 0600, parent, (u16 *)0xFFC02BEC);
		debugfs_create_x16("CAN0_AM29L", 0600, parent, (u16 *)0xFFC02BE8);
		debugfs_create_x16("CAN0_AM30H", 0600, parent, (u16 *)0xFFC02BF4);
		debugfs_create_x16("CAN0_AM30L", 0600, parent, (u16 *)0xFFC02BF0);
		debugfs_create_x16("CAN0_AM31H", 0600, parent, (u16 *)0xFFC02BFC);
		debugfs_create_x16("CAN0_AM31L", 0600, parent, (u16 *)0xFFC02BF8);

		parent = debugfs_create_dir("CAN0 Control and Status", top);
		debugfs_create_x16("CAN0_AA1", 0600, parent, (u16 *)0xFFC02A14);
		debugfs_create_x16("CAN0_AA2", 0600, parent, (u16 *)0xFFC02A54);
		debugfs_create_x16("CAN0_CEC", 0600, parent, (u16 *)0xFFC02A90);
		debugfs_create_x16("CAN0_CLOCK", 0600, parent, (u16 *)0xFFC02A80);
		debugfs_create_x16("CAN0_CONTROL", 0600, parent, (u16 *)0xFFC02AA0);
		debugfs_create_x16("CAN0_DEBUG", 0600, parent, (u16 *)0xFFC02A88);
		debugfs_create_x16("CAN0_ESR", 0600, parent, (u16 *)0xFFC02AB4);
		debugfs_create_x16("CAN0_EWR", 0600, parent, (u16 *)0xFFC02AB0);
		debugfs_create_x16("CAN0_GIF", 0600, parent, (u16 *)0xFFC02A9C);
		debugfs_create_x16("CAN0_GIM", 0600, parent, (u16 *)0xFFC02A98);
		debugfs_create_x16("CAN0_GIS", 0600, parent, (u16 *)0xFFC02A94);
		debugfs_create_x16("CAN0_INTR", 0600, parent, (u16 *)0xFFC02AA4);
		debugfs_create_x16("CAN0_MBIM1", 0600, parent, (u16 *)0xFFC02A28);
		debugfs_create_x16("CAN0_MBIM2", 0600, parent, (u16 *)0xFFC02A68);
		debugfs_create_x16("CAN0_MBRIF1", 0600, parent, (u16 *)0xFFC02A24);
		debugfs_create_x16("CAN0_MBRIF2", 0600, parent, (u16 *)0xFFC02A64);
		debugfs_create_x16("CAN0_MBTD", 0600, parent, (u16 *)0xFFC02AAC);
		debugfs_create_x16("CAN0_MBTIF1", 0600, parent, (u16 *)0xFFC02A20);
		debugfs_create_x16("CAN0_MBTIF2", 0600, parent, (u16 *)0xFFC02A60);
		debugfs_create_x16("CAN0_MC1", 0600, parent, (u16 *)0xFFC02A00);
		debugfs_create_x16("CAN0_MC2", 0600, parent, (u16 *)0xFFC02A40);
		debugfs_create_x16("CAN0_MD1", 0600, parent, (u16 *)0xFFC02A04);
		debugfs_create_x16("CAN0_MD2", 0600, parent, (u16 *)0xFFC02A44);
		debugfs_create_x16("CAN0_OPSS1", 0600, parent, (u16 *)0xFFC02A30);
		debugfs_create_x16("CAN0_OPSS2", 0600, parent, (u16 *)0xFFC02A70);
		debugfs_create_x16("CAN0_RFH1", 0600, parent, (u16 *)0xFFC02A2C);
		debugfs_create_x16("CAN0_RFH2", 0600, parent, (u16 *)0xFFC02A6C);
		debugfs_create_x16("CAN0_RML1", 0600, parent, (u16 *)0xFFC02A1C);
		debugfs_create_x16("CAN0_RML2", 0600, parent, (u16 *)0xFFC02A5C);
		debugfs_create_x16("CAN0_RMP1", 0600, parent, (u16 *)0xFFC02A18);
		debugfs_create_x16("CAN0_RMP2", 0600, parent, (u16 *)0xFFC02A58);
		debugfs_create_x16("CAN0_STATUS", 0600, parent, (u16 *)0xFFC02A8C);
		debugfs_create_x16("CAN0_TA1", 0600, parent, (u16 *)0xFFC02A10);
		debugfs_create_x16("CAN0_TA2", 0600, parent, (u16 *)0xFFC02A50);
		debugfs_create_x16("CAN0_TIMING", 0600, parent, (u16 *)0xFFC02A84);
		debugfs_create_x16("CAN0_TRR1", 0600, parent, (u16 *)0xFFC02A0C);
		debugfs_create_x16("CAN0_TRR2", 0600, parent, (u16 *)0xFFC02A4C);
		debugfs_create_x16("CAN0_TRS1", 0600, parent, (u16 *)0xFFC02A08);
		debugfs_create_x16("CAN0_TRS2", 0600, parent, (u16 *)0xFFC02A48);
		debugfs_create_x16("CAN0_UCCNF", 0600, parent, (u16 *)0xFFC02ACC);
		debugfs_create_x16("CAN0_UCCNT", 0600, parent, (u16 *)0xFFC02AC4);
		debugfs_create_x16("CAN0_UCRC", 0600, parent, (u16 *)0xFFC02AC8);

		parent = debugfs_create_dir("CAN0 Mailbox RAM", top);
		debugfs_create_x16("CAN0_MB00_DATA0", 0600, parent, (u16 *)0xFFC02C00);
		debugfs_create_x16("CAN0_MB00_DATA1", 0600, parent, (u16 *)0xFFC02C04);
		debugfs_create_x16("CAN0_MB00_DATA2", 0600, parent, (u16 *)0xFFC02C08);
		debugfs_create_x16("CAN0_MB00_DATA3", 0600, parent, (u16 *)0xFFC02C0C);
		debugfs_create_x16("CAN0_MB00_ID0", 0600, parent, (u16 *)0xFFC02C18);
		debugfs_create_x16("CAN0_MB00_ID1", 0600, parent, (u16 *)0xFFC02C1C);
		debugfs_create_x16("CAN0_MB00_LENGTH", 0600, parent, (u16 *)0xFFC02C10);
		debugfs_create_x16("CAN0_MB00_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C14);
		debugfs_create_x16("CAN0_MB01_DATA0", 0600, parent, (u16 *)0xFFC02C20);
		debugfs_create_x16("CAN0_MB01_DATA1", 0600, parent, (u16 *)0xFFC02C24);
		debugfs_create_x16("CAN0_MB01_DATA2", 0600, parent, (u16 *)0xFFC02C28);
		debugfs_create_x16("CAN0_MB01_DATA3", 0600, parent, (u16 *)0xFFC02C2C);
		debugfs_create_x16("CAN0_MB01_ID0", 0600, parent, (u16 *)0xFFC02C38);
		debugfs_create_x16("CAN0_MB01_ID1", 0600, parent, (u16 *)0xFFC02C3C);
		debugfs_create_x16("CAN0_MB01_LENGTH", 0600, parent, (u16 *)0xFFC02C30);
		debugfs_create_x16("CAN0_MB01_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C34);
		debugfs_create_x16("CAN0_MB02_DATA0", 0600, parent, (u16 *)0xFFC02C40);
		debugfs_create_x16("CAN0_MB02_DATA1", 0600, parent, (u16 *)0xFFC02C44);
		debugfs_create_x16("CAN0_MB02_DATA2", 0600, parent, (u16 *)0xFFC02C48);
		debugfs_create_x16("CAN0_MB02_DATA3", 0600, parent, (u16 *)0xFFC02C4C);
		debugfs_create_x16("CAN0_MB02_ID0", 0600, parent, (u16 *)0xFFC02C58);
		debugfs_create_x16("CAN0_MB02_ID1", 0600, parent, (u16 *)0xFFC02C5C);
		debugfs_create_x16("CAN0_MB02_LENGTH", 0600, parent, (u16 *)0xFFC02C50);
		debugfs_create_x16("CAN0_MB02_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C54);
		debugfs_create_x16("CAN0_MB03_DATA0", 0600, parent, (u16 *)0xFFC02C60);
		debugfs_create_x16("CAN0_MB03_DATA1", 0600, parent, (u16 *)0xFFC02C64);
		debugfs_create_x16("CAN0_MB03_DATA2", 0600, parent, (u16 *)0xFFC02C68);
		debugfs_create_x16("CAN0_MB03_DATA3", 0600, parent, (u16 *)0xFFC02C6C);
		debugfs_create_x16("CAN0_MB03_ID0", 0600, parent, (u16 *)0xFFC02C78);
		debugfs_create_x16("CAN0_MB03_ID1", 0600, parent, (u16 *)0xFFC02C7C);
		debugfs_create_x16("CAN0_MB03_LENGTH", 0600, parent, (u16 *)0xFFC02C70);
		debugfs_create_x16("CAN0_MB03_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C74);
		debugfs_create_x16("CAN0_MB04_DATA0", 0600, parent, (u16 *)0xFFC02C80);
		debugfs_create_x16("CAN0_MB04_DATA1", 0600, parent, (u16 *)0xFFC02C84);
		debugfs_create_x16("CAN0_MB04_DATA2", 0600, parent, (u16 *)0xFFC02C88);
		debugfs_create_x16("CAN0_MB04_DATA3", 0600, parent, (u16 *)0xFFC02C8C);
		debugfs_create_x16("CAN0_MB04_ID0", 0600, parent, (u16 *)0xFFC02C98);
		debugfs_create_x16("CAN0_MB04_ID1", 0600, parent, (u16 *)0xFFC02C9C);
		debugfs_create_x16("CAN0_MB04_LENGTH", 0600, parent, (u16 *)0xFFC02C90);
		debugfs_create_x16("CAN0_MB04_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C94);
		debugfs_create_x16("CAN0_MB05_DATA0", 0600, parent, (u16 *)0xFFC02CA0);
		debugfs_create_x16("CAN0_MB05_DATA1", 0600, parent, (u16 *)0xFFC02CA4);
		debugfs_create_x16("CAN0_MB05_DATA2", 0600, parent, (u16 *)0xFFC02CA8);
		debugfs_create_x16("CAN0_MB05_DATA3", 0600, parent, (u16 *)0xFFC02CAC);
		debugfs_create_x16("CAN0_MB05_ID0", 0600, parent, (u16 *)0xFFC02CB8);
		debugfs_create_x16("CAN0_MB05_ID1", 0600, parent, (u16 *)0xFFC02CBC);
		debugfs_create_x16("CAN0_MB05_LENGTH", 0600, parent, (u16 *)0xFFC02CB0);
		debugfs_create_x16("CAN0_MB05_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CB4);
		debugfs_create_x16("CAN0_MB06_DATA0", 0600, parent, (u16 *)0xFFC02CC0);
		debugfs_create_x16("CAN0_MB06_DATA1", 0600, parent, (u16 *)0xFFC02CC4);
		debugfs_create_x16("CAN0_MB06_DATA2", 0600, parent, (u16 *)0xFFC02CC8);
		debugfs_create_x16("CAN0_MB06_DATA3", 0600, parent, (u16 *)0xFFC02CCC);
		debugfs_create_x16("CAN0_MB06_ID0", 0600, parent, (u16 *)0xFFC02CD8);
		debugfs_create_x16("CAN0_MB06_ID1", 0600, parent, (u16 *)0xFFC02CDC);
		debugfs_create_x16("CAN0_MB06_LENGTH", 0600, parent, (u16 *)0xFFC02CD0);
		debugfs_create_x16("CAN0_MB06_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CD4);
		debugfs_create_x16("CAN0_MB07_DATA0", 0600, parent, (u16 *)0xFFC02CE0);
		debugfs_create_x16("CAN0_MB07_DATA1", 0600, parent, (u16 *)0xFFC02CE4);
		debugfs_create_x16("CAN0_MB07_DATA2", 0600, parent, (u16 *)0xFFC02CE8);
		debugfs_create_x16("CAN0_MB07_DATA3", 0600, parent, (u16 *)0xFFC02CEC);
		debugfs_create_x16("CAN0_MB07_ID0", 0600, parent, (u16 *)0xFFC02CF8);
		debugfs_create_x16("CAN0_MB07_ID1", 0600, parent, (u16 *)0xFFC02CFC);
		debugfs_create_x16("CAN0_MB07_LENGTH", 0600, parent, (u16 *)0xFFC02CF0);
		debugfs_create_x16("CAN0_MB07_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CF4);
		debugfs_create_x16("CAN0_MB08_DATA0", 0600, parent, (u16 *)0xFFC02D00);
		debugfs_create_x16("CAN0_MB08_DATA1", 0600, parent, (u16 *)0xFFC02D04);
		debugfs_create_x16("CAN0_MB08_DATA2", 0600, parent, (u16 *)0xFFC02D08);
		debugfs_create_x16("CAN0_MB08_DATA3", 0600, parent, (u16 *)0xFFC02D0C);
		debugfs_create_x16("CAN0_MB08_ID0", 0600, parent, (u16 *)0xFFC02D18);
		debugfs_create_x16("CAN0_MB08_ID1", 0600, parent, (u16 *)0xFFC02D1C);
		debugfs_create_x16("CAN0_MB08_LENGTH", 0600, parent, (u16 *)0xFFC02D10);
		debugfs_create_x16("CAN0_MB08_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D14);
		debugfs_create_x16("CAN0_MB09_DATA0", 0600, parent, (u16 *)0xFFC02D20);
		debugfs_create_x16("CAN0_MB09_DATA1", 0600, parent, (u16 *)0xFFC02D24);
		debugfs_create_x16("CAN0_MB09_DATA2", 0600, parent, (u16 *)0xFFC02D28);
		debugfs_create_x16("CAN0_MB09_DATA3", 0600, parent, (u16 *)0xFFC02D2C);
		debugfs_create_x16("CAN0_MB09_ID0", 0600, parent, (u16 *)0xFFC02D38);
		debugfs_create_x16("CAN0_MB09_ID1", 0600, parent, (u16 *)0xFFC02D3C);
		debugfs_create_x16("CAN0_MB09_LENGTH", 0600, parent, (u16 *)0xFFC02D30);
		debugfs_create_x16("CAN0_MB09_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D34);
		debugfs_create_x16("CAN0_MB10_DATA0", 0600, parent, (u16 *)0xFFC02D40);
		debugfs_create_x16("CAN0_MB10_DATA1", 0600, parent, (u16 *)0xFFC02D44);
		debugfs_create_x16("CAN0_MB10_DATA2", 0600, parent, (u16 *)0xFFC02D48);
		debugfs_create_x16("CAN0_MB10_DATA3", 0600, parent, (u16 *)0xFFC02D4C);
		debugfs_create_x16("CAN0_MB10_ID0", 0600, parent, (u16 *)0xFFC02D58);
		debugfs_create_x16("CAN0_MB10_ID1", 0600, parent, (u16 *)0xFFC02D5C);
		debugfs_create_x16("CAN0_MB10_LENGTH", 0600, parent, (u16 *)0xFFC02D50);
		debugfs_create_x16("CAN0_MB10_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D54);
		debugfs_create_x16("CAN0_MB11_DATA0", 0600, parent, (u16 *)0xFFC02D60);
		debugfs_create_x16("CAN0_MB11_DATA1", 0600, parent, (u16 *)0xFFC02D64);
		debugfs_create_x16("CAN0_MB11_DATA2", 0600, parent, (u16 *)0xFFC02D68);
		debugfs_create_x16("CAN0_MB11_DATA3", 0600, parent, (u16 *)0xFFC02D6C);
		debugfs_create_x16("CAN0_MB11_ID0", 0600, parent, (u16 *)0xFFC02D78);
		debugfs_create_x16("CAN0_MB11_ID1", 0600, parent, (u16 *)0xFFC02D7C);
		debugfs_create_x16("CAN0_MB11_LENGTH", 0600, parent, (u16 *)0xFFC02D70);
		debugfs_create_x16("CAN0_MB11_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D74);
		debugfs_create_x16("CAN0_MB12_DATA0", 0600, parent, (u16 *)0xFFC02D80);
		debugfs_create_x16("CAN0_MB12_DATA1", 0600, parent, (u16 *)0xFFC02D84);
		debugfs_create_x16("CAN0_MB12_DATA2", 0600, parent, (u16 *)0xFFC02D88);
		debugfs_create_x16("CAN0_MB12_DATA3", 0600, parent, (u16 *)0xFFC02D8C);
		debugfs_create_x16("CAN0_MB12_ID0", 0600, parent, (u16 *)0xFFC02D98);
		debugfs_create_x16("CAN0_MB12_ID1", 0600, parent, (u16 *)0xFFC02D9C);
		debugfs_create_x16("CAN0_MB12_LENGTH", 0600, parent, (u16 *)0xFFC02D90);
		debugfs_create_x16("CAN0_MB12_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D94);
		debugfs_create_x16("CAN0_MB13_DATA0", 0600, parent, (u16 *)0xFFC02DA0);
		debugfs_create_x16("CAN0_MB13_DATA1", 0600, parent, (u16 *)0xFFC02DA4);
		debugfs_create_x16("CAN0_MB13_DATA2", 0600, parent, (u16 *)0xFFC02DA8);
		debugfs_create_x16("CAN0_MB13_DATA3", 0600, parent, (u16 *)0xFFC02DAC);
		debugfs_create_x16("CAN0_MB13_ID0", 0600, parent, (u16 *)0xFFC02DB8);
		debugfs_create_x16("CAN0_MB13_ID1", 0600, parent, (u16 *)0xFFC02DBC);
		debugfs_create_x16("CAN0_MB13_LENGTH", 0600, parent, (u16 *)0xFFC02DB0);
		debugfs_create_x16("CAN0_MB13_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DB4);
		debugfs_create_x16("CAN0_MB14_DATA0", 0600, parent, (u16 *)0xFFC02DC0);
		debugfs_create_x16("CAN0_MB14_DATA1", 0600, parent, (u16 *)0xFFC02DC4);
		debugfs_create_x16("CAN0_MB14_DATA2", 0600, parent, (u16 *)0xFFC02DC8);
		debugfs_create_x16("CAN0_MB14_DATA3", 0600, parent, (u16 *)0xFFC02DCC);
		debugfs_create_x16("CAN0_MB14_ID0", 0600, parent, (u16 *)0xFFC02DD8);
		debugfs_create_x16("CAN0_MB14_ID1", 0600, parent, (u16 *)0xFFC02DDC);
		debugfs_create_x16("CAN0_MB14_LENGTH", 0600, parent, (u16 *)0xFFC02DD0);
		debugfs_create_x16("CAN0_MB14_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DD4);
		debugfs_create_x16("CAN0_MB15_DATA0", 0600, parent, (u16 *)0xFFC02DE0);
		debugfs_create_x16("CAN0_MB15_DATA1", 0600, parent, (u16 *)0xFFC02DE4);
		debugfs_create_x16("CAN0_MB15_DATA2", 0600, parent, (u16 *)0xFFC02DE8);
		debugfs_create_x16("CAN0_MB15_DATA3", 0600, parent, (u16 *)0xFFC02DEC);
		debugfs_create_x16("CAN0_MB15_ID0", 0600, parent, (u16 *)0xFFC02DF8);
		debugfs_create_x16("CAN0_MB15_ID1", 0600, parent, (u16 *)0xFFC02DFC);
		debugfs_create_x16("CAN0_MB15_LENGTH", 0600, parent, (u16 *)0xFFC02DF0);
		debugfs_create_x16("CAN0_MB15_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DF4);
		debugfs_create_x16("CAN0_MB16_DATA0", 0600, parent, (u16 *)0xFFC02E00);
		debugfs_create_x16("CAN0_MB16_DATA1", 0600, parent, (u16 *)0xFFC02E04);
		debugfs_create_x16("CAN0_MB16_DATA2", 0600, parent, (u16 *)0xFFC02E08);
		debugfs_create_x16("CAN0_MB16_DATA3", 0600, parent, (u16 *)0xFFC02E0C);
		debugfs_create_x16("CAN0_MB16_ID0", 0600, parent, (u16 *)0xFFC02E18);
		debugfs_create_x16("CAN0_MB16_ID1", 0600, parent, (u16 *)0xFFC02E1C);
		debugfs_create_x16("CAN0_MB16_LENGTH", 0600, parent, (u16 *)0xFFC02E10);
		debugfs_create_x16("CAN0_MB16_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E14);
		debugfs_create_x16("CAN0_MB17_DATA0", 0600, parent, (u16 *)0xFFC02E20);
		debugfs_create_x16("CAN0_MB17_DATA1", 0600, parent, (u16 *)0xFFC02E24);
		debugfs_create_x16("CAN0_MB17_DATA2", 0600, parent, (u16 *)0xFFC02E28);
		debugfs_create_x16("CAN0_MB17_DATA3", 0600, parent, (u16 *)0xFFC02E2C);
		debugfs_create_x16("CAN0_MB17_ID0", 0600, parent, (u16 *)0xFFC02E38);
		debugfs_create_x16("CAN0_MB17_ID1", 0600, parent, (u16 *)0xFFC02E3C);
		debugfs_create_x16("CAN0_MB17_LENGTH", 0600, parent, (u16 *)0xFFC02E30);
		debugfs_create_x16("CAN0_MB17_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E34);
		debugfs_create_x16("CAN0_MB18_DATA0", 0600, parent, (u16 *)0xFFC02E40);
		debugfs_create_x16("CAN0_MB18_DATA1", 0600, parent, (u16 *)0xFFC02E44);
		debugfs_create_x16("CAN0_MB18_DATA2", 0600, parent, (u16 *)0xFFC02E48);
		debugfs_create_x16("CAN0_MB18_DATA3", 0600, parent, (u16 *)0xFFC02E4C);
		debugfs_create_x16("CAN0_MB18_ID0", 0600, parent, (u16 *)0xFFC02E58);
		debugfs_create_x16("CAN0_MB18_ID1", 0600, parent, (u16 *)0xFFC02E5C);
		debugfs_create_x16("CAN0_MB18_LENGTH", 0600, parent, (u16 *)0xFFC02E50);
		debugfs_create_x16("CAN0_MB18_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E54);
		debugfs_create_x16("CAN0_MB19_DATA0", 0600, parent, (u16 *)0xFFC02E60);
		debugfs_create_x16("CAN0_MB19_DATA1", 0600, parent, (u16 *)0xFFC02E64);
		debugfs_create_x16("CAN0_MB19_DATA2", 0600, parent, (u16 *)0xFFC02E68);
		debugfs_create_x16("CAN0_MB19_DATA3", 0600, parent, (u16 *)0xFFC02E6C);
		debugfs_create_x16("CAN0_MB19_ID0", 0600, parent, (u16 *)0xFFC02E78);
		debugfs_create_x16("CAN0_MB19_ID1", 0600, parent, (u16 *)0xFFC02E7C);
		debugfs_create_x16("CAN0_MB19_LENGTH", 0600, parent, (u16 *)0xFFC02E70);
		debugfs_create_x16("CAN0_MB19_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E74);
		debugfs_create_x16("CAN0_MB20_DATA0", 0600, parent, (u16 *)0xFFC02E80);
		debugfs_create_x16("CAN0_MB20_DATA1", 0600, parent, (u16 *)0xFFC02E84);
		debugfs_create_x16("CAN0_MB20_DATA2", 0600, parent, (u16 *)0xFFC02E88);
		debugfs_create_x16("CAN0_MB20_DATA3", 0600, parent, (u16 *)0xFFC02E8C);
		debugfs_create_x16("CAN0_MB20_ID0", 0600, parent, (u16 *)0xFFC02E98);
		debugfs_create_x16("CAN0_MB20_ID1", 0600, parent, (u16 *)0xFFC02E9C);
		debugfs_create_x16("CAN0_MB20_LENGTH", 0600, parent, (u16 *)0xFFC02E90);
		debugfs_create_x16("CAN0_MB20_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E94);
		debugfs_create_x16("CAN0_MB21_DATA0", 0600, parent, (u16 *)0xFFC02EA0);
		debugfs_create_x16("CAN0_MB21_DATA1", 0600, parent, (u16 *)0xFFC02EA4);
		debugfs_create_x16("CAN0_MB21_DATA2", 0600, parent, (u16 *)0xFFC02EA8);
		debugfs_create_x16("CAN0_MB21_DATA3", 0600, parent, (u16 *)0xFFC02EAC);
		debugfs_create_x16("CAN0_MB21_ID0", 0600, parent, (u16 *)0xFFC02EB8);
		debugfs_create_x16("CAN0_MB21_ID1", 0600, parent, (u16 *)0xFFC02EBC);
		debugfs_create_x16("CAN0_MB21_LENGTH", 0600, parent, (u16 *)0xFFC02EB0);
		debugfs_create_x16("CAN0_MB21_TIMESTAMP", 0600, parent, (u16 *)0xFFC02EB4);
		debugfs_create_x16("CAN0_MB22_DATA0", 0600, parent, (u16 *)0xFFC02EC0);
		debugfs_create_x16("CAN0_MB22_DATA1", 0600, parent, (u16 *)0xFFC02EC4);
		debugfs_create_x16("CAN0_MB22_DATA2", 0600, parent, (u16 *)0xFFC02EC8);
		debugfs_create_x16("CAN0_MB22_DATA3", 0600, parent, (u16 *)0xFFC02ECC);
		debugfs_create_x16("CAN0_MB22_ID0", 0600, parent, (u16 *)0xFFC02ED8);
		debugfs_create_x16("CAN0_MB22_ID1", 0600, parent, (u16 *)0xFFC02EDC);
		debugfs_create_x16("CAN0_MB22_LENGTH", 0600, parent, (u16 *)0xFFC02ED0);
		debugfs_create_x16("CAN0_MB22_TIMESTAMP", 0600, parent, (u16 *)0xFFC02ED4);
		debugfs_create_x16("CAN0_MB23_DATA0", 0600, parent, (u16 *)0xFFC02EE0);
		debugfs_create_x16("CAN0_MB23_DATA1", 0600, parent, (u16 *)0xFFC02EE4);
		debugfs_create_x16("CAN0_MB23_DATA2", 0600, parent, (u16 *)0xFFC02EE8);
		debugfs_create_x16("CAN0_MB23_DATA3", 0600, parent, (u16 *)0xFFC02EEC);
		debugfs_create_x16("CAN0_MB23_ID0", 0600, parent, (u16 *)0xFFC02EF8);
		debugfs_create_x16("CAN0_MB23_ID1", 0600, parent, (u16 *)0xFFC02EFC);
		debugfs_create_x16("CAN0_MB23_LENGTH", 0600, parent, (u16 *)0xFFC02EF0);
		debugfs_create_x16("CAN0_MB23_TIMESTAMP", 0600, parent, (u16 *)0xFFC02EF4);
		debugfs_create_x16("CAN0_MB24_DATA0", 0600, parent, (u16 *)0xFFC02F00);
		debugfs_create_x16("CAN0_MB24_DATA1", 0600, parent, (u16 *)0xFFC02F04);
		debugfs_create_x16("CAN0_MB24_DATA2", 0600, parent, (u16 *)0xFFC02F08);
		debugfs_create_x16("CAN0_MB24_DATA3", 0600, parent, (u16 *)0xFFC02F0C);
		debugfs_create_x16("CAN0_MB24_ID0", 0600, parent, (u16 *)0xFFC02F18);
		debugfs_create_x16("CAN0_MB24_ID1", 0600, parent, (u16 *)0xFFC02F1C);
		debugfs_create_x16("CAN0_MB24_LENGTH", 0600, parent, (u16 *)0xFFC02F10);
		debugfs_create_x16("CAN0_MB24_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F14);
		debugfs_create_x16("CAN0_MB25_DATA0", 0600, parent, (u16 *)0xFFC02F20);
		debugfs_create_x16("CAN0_MB25_DATA1", 0600, parent, (u16 *)0xFFC02F24);
		debugfs_create_x16("CAN0_MB25_DATA2", 0600, parent, (u16 *)0xFFC02F28);
		debugfs_create_x16("CAN0_MB25_DATA3", 0600, parent, (u16 *)0xFFC02F2C);
		debugfs_create_x16("CAN0_MB25_ID0", 0600, parent, (u16 *)0xFFC02F38);
		debugfs_create_x16("CAN0_MB25_ID1", 0600, parent, (u16 *)0xFFC02F3C);
		debugfs_create_x16("CAN0_MB25_LENGTH", 0600, parent, (u16 *)0xFFC02F30);
		debugfs_create_x16("CAN0_MB25_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F34);
		debugfs_create_x16("CAN0_MB26_DATA0", 0600, parent, (u16 *)0xFFC02F40);
		debugfs_create_x16("CAN0_MB26_DATA1", 0600, parent, (u16 *)0xFFC02F44);
		debugfs_create_x16("CAN0_MB26_DATA2", 0600, parent, (u16 *)0xFFC02F48);
		debugfs_create_x16("CAN0_MB26_DATA3", 0600, parent, (u16 *)0xFFC02F4C);
		debugfs_create_x16("CAN0_MB26_ID0", 0600, parent, (u16 *)0xFFC02F58);
		debugfs_create_x16("CAN0_MB26_ID1", 0600, parent, (u16 *)0xFFC02F5C);
		debugfs_create_x16("CAN0_MB26_LENGTH", 0600, parent, (u16 *)0xFFC02F50);
		debugfs_create_x16("CAN0_MB26_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F54);
		debugfs_create_x16("CAN0_MB27_DATA0", 0600, parent, (u16 *)0xFFC02F60);
		debugfs_create_x16("CAN0_MB27_DATA1", 0600, parent, (u16 *)0xFFC02F64);
		debugfs_create_x16("CAN0_MB27_DATA2", 0600, parent, (u16 *)0xFFC02F68);
		debugfs_create_x16("CAN0_MB27_DATA3", 0600, parent, (u16 *)0xFFC02F6C);
		debugfs_create_x16("CAN0_MB27_ID0", 0600, parent, (u16 *)0xFFC02F78);
		debugfs_create_x16("CAN0_MB27_ID1", 0600, parent, (u16 *)0xFFC02F7C);
		debugfs_create_x16("CAN0_MB27_LENGTH", 0600, parent, (u16 *)0xFFC02F70);
		debugfs_create_x16("CAN0_MB27_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F74);
		debugfs_create_x16("CAN0_MB28_DATA0", 0600, parent, (u16 *)0xFFC02F80);
		debugfs_create_x16("CAN0_MB28_DATA1", 0600, parent, (u16 *)0xFFC02F84);
		debugfs_create_x16("CAN0_MB28_DATA2", 0600, parent, (u16 *)0xFFC02F88);
		debugfs_create_x16("CAN0_MB28_DATA3", 0600, parent, (u16 *)0xFFC02F8C);
		debugfs_create_x16("CAN0_MB28_ID0", 0600, parent, (u16 *)0xFFC02F98);
		debugfs_create_x16("CAN0_MB28_ID1", 0600, parent, (u16 *)0xFFC02F9C);
		debugfs_create_x16("CAN0_MB28_LENGTH", 0600, parent, (u16 *)0xFFC02F90);
		debugfs_create_x16("CAN0_MB28_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F94);
		debugfs_create_x16("CAN0_MB29_DATA0", 0600, parent, (u16 *)0xFFC02FA0);
		debugfs_create_x16("CAN0_MB29_DATA1", 0600, parent, (u16 *)0xFFC02FA4);
		debugfs_create_x16("CAN0_MB29_DATA2", 0600, parent, (u16 *)0xFFC02FA8);
		debugfs_create_x16("CAN0_MB29_DATA3", 0600, parent, (u16 *)0xFFC02FAC);
		debugfs_create_x16("CAN0_MB29_ID0", 0600, parent, (u16 *)0xFFC02FB8);
		debugfs_create_x16("CAN0_MB29_ID1", 0600, parent, (u16 *)0xFFC02FBC);
		debugfs_create_x16("CAN0_MB29_LENGTH", 0600, parent, (u16 *)0xFFC02FB0);
		debugfs_create_x16("CAN0_MB29_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FB4);
		debugfs_create_x16("CAN0_MB30_DATA0", 0600, parent, (u16 *)0xFFC02FC0);
		debugfs_create_x16("CAN0_MB30_DATA1", 0600, parent, (u16 *)0xFFC02FC4);
		debugfs_create_x16("CAN0_MB30_DATA2", 0600, parent, (u16 *)0xFFC02FC8);
		debugfs_create_x16("CAN0_MB30_DATA3", 0600, parent, (u16 *)0xFFC02FCC);
		debugfs_create_x16("CAN0_MB30_ID0", 0600, parent, (u16 *)0xFFC02FD8);
		debugfs_create_x16("CAN0_MB30_ID1", 0600, parent, (u16 *)0xFFC02FDC);
		debugfs_create_x16("CAN0_MB30_LENGTH", 0600, parent, (u16 *)0xFFC02FD0);
		debugfs_create_x16("CAN0_MB30_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FD4);
		debugfs_create_x16("CAN0_MB31_DATA0", 0600, parent, (u16 *)0xFFC02FE0);
		debugfs_create_x16("CAN0_MB31_DATA1", 0600, parent, (u16 *)0xFFC02FE4);
		debugfs_create_x16("CAN0_MB31_DATA2", 0600, parent, (u16 *)0xFFC02FE8);
		debugfs_create_x16("CAN0_MB31_DATA3", 0600, parent, (u16 *)0xFFC02FEC);
		debugfs_create_x16("CAN0_MB31_ID0", 0600, parent, (u16 *)0xFFC02FF8);
		debugfs_create_x16("CAN0_MB31_ID1", 0600, parent, (u16 *)0xFFC02FFC);
		debugfs_create_x16("CAN0_MB31_LENGTH", 0600, parent, (u16 *)0xFFC02FF0);
		debugfs_create_x16("CAN0_MB31_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FF4);

		parent = debugfs_create_dir("CAN1 Acceptance Mask RAM", top);
		debugfs_create_x16("CAN1_AM00H", 0600, parent, (u16 *)0xFFC03304);
		debugfs_create_x16("CAN1_AM00L", 0600, parent, (u16 *)0xFFC03300);
		debugfs_create_x16("CAN1_AM01H", 0600, parent, (u16 *)0xFFC0330C);
		debugfs_create_x16("CAN1_AM01L", 0600, parent, (u16 *)0xFFC03308);
		debugfs_create_x16("CAN1_AM02H", 0600, parent, (u16 *)0xFFC03314);
		debugfs_create_x16("CAN1_AM02L", 0600, parent, (u16 *)0xFFC03310);
		debugfs_create_x16("CAN1_AM03H", 0600, parent, (u16 *)0xFFC0331C);
		debugfs_create_x16("CAN1_AM03L", 0600, parent, (u16 *)0xFFC03318);
		debugfs_create_x16("CAN1_AM04H", 0600, parent, (u16 *)0xFFC03324);
		debugfs_create_x16("CAN1_AM04L", 0600, parent, (u16 *)0xFFC03320);
		debugfs_create_x16("CAN1_AM05H", 0600, parent, (u16 *)0xFFC0332C);
		debugfs_create_x16("CAN1_AM05L", 0600, parent, (u16 *)0xFFC03328);
		debugfs_create_x16("CAN1_AM06H", 0600, parent, (u16 *)0xFFC03334);
		debugfs_create_x16("CAN1_AM06L", 0600, parent, (u16 *)0xFFC03330);
		debugfs_create_x16("CAN1_AM07H", 0600, parent, (u16 *)0xFFC0333C);
		debugfs_create_x16("CAN1_AM07L", 0600, parent, (u16 *)0xFFC03338);
		debugfs_create_x16("CAN1_AM08H", 0600, parent, (u16 *)0xFFC03344);
		debugfs_create_x16("CAN1_AM08L", 0600, parent, (u16 *)0xFFC03340);
		debugfs_create_x16("CAN1_AM09H", 0600, parent, (u16 *)0xFFC0334C);
		debugfs_create_x16("CAN1_AM09L", 0600, parent, (u16 *)0xFFC03348);
		debugfs_create_x16("CAN1_AM10H", 0600, parent, (u16 *)0xFFC03354);
		debugfs_create_x16("CAN1_AM10L", 0600, parent, (u16 *)0xFFC03350);
		debugfs_create_x16("CAN1_AM11H", 0600, parent, (u16 *)0xFFC0335C);
		debugfs_create_x16("CAN1_AM11L", 0600, parent, (u16 *)0xFFC03358);
		debugfs_create_x16("CAN1_AM12H", 0600, parent, (u16 *)0xFFC03364);
		debugfs_create_x16("CAN1_AM12L", 0600, parent, (u16 *)0xFFC03360);
		debugfs_create_x16("CAN1_AM13H", 0600, parent, (u16 *)0xFFC0336C);
		debugfs_create_x16("CAN1_AM13L", 0600, parent, (u16 *)0xFFC03368);
		debugfs_create_x16("CAN1_AM14H", 0600, parent, (u16 *)0xFFC03374);
		debugfs_create_x16("CAN1_AM14L", 0600, parent, (u16 *)0xFFC03370);
		debugfs_create_x16("CAN1_AM15H", 0600, parent, (u16 *)0xFFC0337C);
		debugfs_create_x16("CAN1_AM15L", 0600, parent, (u16 *)0xFFC03378);
		debugfs_create_x16("CAN1_AM16H", 0600, parent, (u16 *)0xFFC03384);
		debugfs_create_x16("CAN1_AM16L", 0600, parent, (u16 *)0xFFC03380);
		debugfs_create_x16("CAN1_AM17H", 0600, parent, (u16 *)0xFFC0338C);
		debugfs_create_x16("CAN1_AM17L", 0600, parent, (u16 *)0xFFC03388);
		debugfs_create_x16("CAN1_AM18H", 0600, parent, (u16 *)0xFFC03394);
		debugfs_create_x16("CAN1_AM18L", 0600, parent, (u16 *)0xFFC03390);
		debugfs_create_x16("CAN1_AM19H", 0600, parent, (u16 *)0xFFC0339C);
		debugfs_create_x16("CAN1_AM19L", 0600, parent, (u16 *)0xFFC03398);
		debugfs_create_x16("CAN1_AM20H", 0600, parent, (u16 *)0xFFC033A4);
		debugfs_create_x16("CAN1_AM20L", 0600, parent, (u16 *)0xFFC033A0);
		debugfs_create_x16("CAN1_AM21H", 0600, parent, (u16 *)0xFFC033AC);
		debugfs_create_x16("CAN1_AM21L", 0600, parent, (u16 *)0xFFC033A8);
		debugfs_create_x16("CAN1_AM22H", 0600, parent, (u16 *)0xFFC033B4);
		debugfs_create_x16("CAN1_AM22L", 0600, parent, (u16 *)0xFFC033B0);
		debugfs_create_x16("CAN1_AM23H", 0600, parent, (u16 *)0xFFC033BC);
		debugfs_create_x16("CAN1_AM23L", 0600, parent, (u16 *)0xFFC033B8);
		debugfs_create_x16("CAN1_AM24H", 0600, parent, (u16 *)0xFFC033C4);
		debugfs_create_x16("CAN1_AM24L", 0600, parent, (u16 *)0xFFC033C0);
		debugfs_create_x16("CAN1_AM25H", 0600, parent, (u16 *)0xFFC033CC);
		debugfs_create_x16("CAN1_AM25L", 0600, parent, (u16 *)0xFFC033C8);
		debugfs_create_x16("CAN1_AM26H", 0600, parent, (u16 *)0xFFC033D4);
		debugfs_create_x16("CAN1_AM26L", 0600, parent, (u16 *)0xFFC033D0);
		debugfs_create_x16("CAN1_AM27H", 0600, parent, (u16 *)0xFFC033DC);
		debugfs_create_x16("CAN1_AM27L", 0600, parent, (u16 *)0xFFC033D8);
		debugfs_create_x16("CAN1_AM28H", 0600, parent, (u16 *)0xFFC033E4);
		debugfs_create_x16("CAN1_AM28L", 0600, parent, (u16 *)0xFFC033E0);
		debugfs_create_x16("CAN1_AM29H", 0600, parent, (u16 *)0xFFC033EC);
		debugfs_create_x16("CAN1_AM29L", 0600, parent, (u16 *)0xFFC033E8);
		debugfs_create_x16("CAN1_AM30H", 0600, parent, (u16 *)0xFFC033F4);
		debugfs_create_x16("CAN1_AM30L", 0600, parent, (u16 *)0xFFC033F0);
		debugfs_create_x16("CAN1_AM31H", 0600, parent, (u16 *)0xFFC033FC);
		debugfs_create_x16("CAN1_AM31L", 0600, parent, (u16 *)0xFFC033F8);

		parent = debugfs_create_dir("CAN1 Control and Status", top);
		debugfs_create_x16("CAN1_AA1", 0600, parent, (u16 *)0xFFC03214);
		debugfs_create_x16("CAN1_AA2", 0600, parent, (u16 *)0xFFC03254);
		debugfs_create_x16("CAN1_CEC", 0600, parent, (u16 *)0xFFC03290);
		debugfs_create_x16("CAN1_CLOCK", 0600, parent, (u16 *)0xFFC03280);
		debugfs_create_x16("CAN1_CONTROL", 0600, parent, (u16 *)0xFFC032A0);
		debugfs_create_x16("CAN1_DEBUG", 0600, parent, (u16 *)0xFFC03288);
		debugfs_create_x16("CAN1_ESR", 0600, parent, (u16 *)0xFFC032B4);
		debugfs_create_x16("CAN1_EWR", 0600, parent, (u16 *)0xFFC032B0);
		debugfs_create_x16("CAN1_GIF", 0600, parent, (u16 *)0xFFC0329C);
		debugfs_create_x16("CAN1_GIM", 0600, parent, (u16 *)0xFFC03298);
		debugfs_create_x16("CAN1_GIS", 0600, parent, (u16 *)0xFFC03294);
		debugfs_create_x16("CAN1_INTR", 0600, parent, (u16 *)0xFFC032A4);
		debugfs_create_x16("CAN1_MBIM1", 0600, parent, (u16 *)0xFFC03228);
		debugfs_create_x16("CAN1_MBIM2", 0600, parent, (u16 *)0xFFC03268);
		debugfs_create_x16("CAN1_MBRIF1", 0600, parent, (u16 *)0xFFC03224);
		debugfs_create_x16("CAN1_MBRIF2", 0600, parent, (u16 *)0xFFC03264);
		debugfs_create_x16("CAN1_MBTD", 0600, parent, (u16 *)0xFFC032AC);
		debugfs_create_x16("CAN1_MBTIF1", 0600, parent, (u16 *)0xFFC03220);
		debugfs_create_x16("CAN1_MBTIF2", 0600, parent, (u16 *)0xFFC03260);
		debugfs_create_x16("CAN1_MC1", 0600, parent, (u16 *)0xFFC03200);
		debugfs_create_x16("CAN1_MC2", 0600, parent, (u16 *)0xFFC03240);
		debugfs_create_x16("CAN1_MD1", 0600, parent, (u16 *)0xFFC03204);
		debugfs_create_x16("CAN1_MD2", 0600, parent, (u16 *)0xFFC03244);
		debugfs_create_x16("CAN1_OPSS1", 0600, parent, (u16 *)0xFFC03230);
		debugfs_create_x16("CAN1_OPSS2", 0600, parent, (u16 *)0xFFC03270);
		debugfs_create_x16("CAN1_RFH1", 0600, parent, (u16 *)0xFFC0322C);
		debugfs_create_x16("CAN1_RFH2", 0600, parent, (u16 *)0xFFC0326C);
		debugfs_create_x16("CAN1_RML1", 0600, parent, (u16 *)0xFFC0321C);
		debugfs_create_x16("CAN1_RML2", 0600, parent, (u16 *)0xFFC0325C);
		debugfs_create_x16("CAN1_RMP1", 0600, parent, (u16 *)0xFFC03218);
		debugfs_create_x16("CAN1_RMP2", 0600, parent, (u16 *)0xFFC03258);
		debugfs_create_x16("CAN1_STATUS", 0600, parent, (u16 *)0xFFC0328C);
		debugfs_create_x16("CAN1_TA1", 0600, parent, (u16 *)0xFFC03210);
		debugfs_create_x16("CAN1_TA2", 0600, parent, (u16 *)0xFFC03250);
		debugfs_create_x16("CAN1_TIMING", 0600, parent, (u16 *)0xFFC03284);
		debugfs_create_x16("CAN1_TRR1", 0600, parent, (u16 *)0xFFC0320C);
		debugfs_create_x16("CAN1_TRR2", 0600, parent, (u16 *)0xFFC0324C);
		debugfs_create_x16("CAN1_TRS1", 0600, parent, (u16 *)0xFFC03208);
		debugfs_create_x16("CAN1_TRS2", 0600, parent, (u16 *)0xFFC03248);
		debugfs_create_x16("CAN1_UCCNF", 0600, parent, (u16 *)0xFFC032CC);
		debugfs_create_x16("CAN1_UCCNT", 0600, parent, (u16 *)0xFFC032C4);
		debugfs_create_x16("CAN1_UCRC", 0600, parent, (u16 *)0xFFC032C8);

		parent = debugfs_create_dir("CAN1 Mailbox RAM", top);
		debugfs_create_x16("CAN1_MB00_DATA0", 0600, parent, (u16 *)0xFFC03400);
		debugfs_create_x16("CAN1_MB00_DATA1", 0600, parent, (u16 *)0xFFC03404);
		debugfs_create_x16("CAN1_MB00_DATA2", 0600, parent, (u16 *)0xFFC03408);
		debugfs_create_x16("CAN1_MB00_DATA3", 0600, parent, (u16 *)0xFFC0340C);
		debugfs_create_x16("CAN1_MB00_ID0", 0600, parent, (u16 *)0xFFC03418);
		debugfs_create_x16("CAN1_MB00_ID1", 0600, parent, (u16 *)0xFFC0341C);
		debugfs_create_x16("CAN1_MB00_LENGTH", 0600, parent, (u16 *)0xFFC03410);
		debugfs_create_x16("CAN1_MB00_TIMESTAMP", 0600, parent, (u16 *)0xFFC03414);
		debugfs_create_x16("CAN1_MB01_DATA0", 0600, parent, (u16 *)0xFFC03420);
		debugfs_create_x16("CAN1_MB01_DATA1", 0600, parent, (u16 *)0xFFC03424);
		debugfs_create_x16("CAN1_MB01_DATA2", 0600, parent, (u16 *)0xFFC03428);
		debugfs_create_x16("CAN1_MB01_DATA3", 0600, parent, (u16 *)0xFFC0342C);
		debugfs_create_x16("CAN1_MB01_ID0", 0600, parent, (u16 *)0xFFC03438);
		debugfs_create_x16("CAN1_MB01_ID1", 0600, parent, (u16 *)0xFFC0343C);
		debugfs_create_x16("CAN1_MB01_LENGTH", 0600, parent, (u16 *)0xFFC03430);
		debugfs_create_x16("CAN1_MB01_TIMESTAMP", 0600, parent, (u16 *)0xFFC03434);
		debugfs_create_x16("CAN1_MB02_DATA0", 0600, parent, (u16 *)0xFFC03440);
		debugfs_create_x16("CAN1_MB02_DATA1", 0600, parent, (u16 *)0xFFC03444);
		debugfs_create_x16("CAN1_MB02_DATA2", 0600, parent, (u16 *)0xFFC03448);
		debugfs_create_x16("CAN1_MB02_DATA3", 0600, parent, (u16 *)0xFFC0344C);
		debugfs_create_x16("CAN1_MB02_ID0", 0600, parent, (u16 *)0xFFC03458);
		debugfs_create_x16("CAN1_MB02_ID1", 0600, parent, (u16 *)0xFFC0345C);
		debugfs_create_x16("CAN1_MB02_LENGTH", 0600, parent, (u16 *)0xFFC03450);
		debugfs_create_x16("CAN1_MB02_TIMESTAMP", 0600, parent, (u16 *)0xFFC03454);
		debugfs_create_x16("CAN1_MB03_DATA0", 0600, parent, (u16 *)0xFFC03460);
		debugfs_create_x16("CAN1_MB03_DATA1", 0600, parent, (u16 *)0xFFC03464);
		debugfs_create_x16("CAN1_MB03_DATA2", 0600, parent, (u16 *)0xFFC03468);
		debugfs_create_x16("CAN1_MB03_DATA3", 0600, parent, (u16 *)0xFFC0346C);
		debugfs_create_x16("CAN1_MB03_ID0", 0600, parent, (u16 *)0xFFC03478);
		debugfs_create_x16("CAN1_MB03_ID1", 0600, parent, (u16 *)0xFFC0347C);
		debugfs_create_x16("CAN1_MB03_LENGTH", 0600, parent, (u16 *)0xFFC03470);
		debugfs_create_x16("CAN1_MB03_TIMESTAMP", 0600, parent, (u16 *)0xFFC03474);
		debugfs_create_x16("CAN1_MB04_DATA0", 0600, parent, (u16 *)0xFFC03480);
		debugfs_create_x16("CAN1_MB04_DATA1", 0600, parent, (u16 *)0xFFC03484);
		debugfs_create_x16("CAN1_MB04_DATA2", 0600, parent, (u16 *)0xFFC03488);
		debugfs_create_x16("CAN1_MB04_DATA3", 0600, parent, (u16 *)0xFFC0348C);
		debugfs_create_x16("CAN1_MB04_ID0", 0600, parent, (u16 *)0xFFC03498);
		debugfs_create_x16("CAN1_MB04_ID1", 0600, parent, (u16 *)0xFFC0349C);
		debugfs_create_x16("CAN1_MB04_LENGTH", 0600, parent, (u16 *)0xFFC03490);
		debugfs_create_x16("CAN1_MB04_TIMESTAMP", 0600, parent, (u16 *)0xFFC03494);
		debugfs_create_x16("CAN1_MB05_DATA0", 0600, parent, (u16 *)0xFFC034A0);
		debugfs_create_x16("CAN1_MB05_DATA1", 0600, parent, (u16 *)0xFFC034A4);
		debugfs_create_x16("CAN1_MB05_DATA2", 0600, parent, (u16 *)0xFFC034A8);
		debugfs_create_x16("CAN1_MB05_DATA3", 0600, parent, (u16 *)0xFFC034AC);
		debugfs_create_x16("CAN1_MB05_ID0", 0600, parent, (u16 *)0xFFC034B8);
		debugfs_create_x16("CAN1_MB05_ID1", 0600, parent, (u16 *)0xFFC034BC);
		debugfs_create_x16("CAN1_MB05_LENGTH", 0600, parent, (u16 *)0xFFC034B0);
		debugfs_create_x16("CAN1_MB05_TIMESTAMP", 0600, parent, (u16 *)0xFFC034B4);
		debugfs_create_x16("CAN1_MB06_DATA0", 0600, parent, (u16 *)0xFFC034C0);
		debugfs_create_x16("CAN1_MB06_DATA1", 0600, parent, (u16 *)0xFFC034C4);
		debugfs_create_x16("CAN1_MB06_DATA2", 0600, parent, (u16 *)0xFFC034C8);
		debugfs_create_x16("CAN1_MB06_DATA3", 0600, parent, (u16 *)0xFFC034CC);
		debugfs_create_x16("CAN1_MB06_ID0", 0600, parent, (u16 *)0xFFC034D8);
		debugfs_create_x16("CAN1_MB06_ID1", 0600, parent, (u16 *)0xFFC034DC);
		debugfs_create_x16("CAN1_MB06_LENGTH", 0600, parent, (u16 *)0xFFC034D0);
		debugfs_create_x16("CAN1_MB06_TIMESTAMP", 0600, parent, (u16 *)0xFFC034D4);
		debugfs_create_x16("CAN1_MB07_DATA0", 0600, parent, (u16 *)0xFFC034E0);
		debugfs_create_x16("CAN1_MB07_DATA1", 0600, parent, (u16 *)0xFFC034E4);
		debugfs_create_x16("CAN1_MB07_DATA2", 0600, parent, (u16 *)0xFFC034E8);
		debugfs_create_x16("CAN1_MB07_DATA3", 0600, parent, (u16 *)0xFFC034EC);
		debugfs_create_x16("CAN1_MB07_ID0", 0600, parent, (u16 *)0xFFC034F8);
		debugfs_create_x16("CAN1_MB07_ID1", 0600, parent, (u16 *)0xFFC034FC);
		debugfs_create_x16("CAN1_MB07_LENGTH", 0600, parent, (u16 *)0xFFC034F0);
		debugfs_create_x16("CAN1_MB07_TIMESTAMP", 0600, parent, (u16 *)0xFFC034F4);
		debugfs_create_x16("CAN1_MB08_DATA0", 0600, parent, (u16 *)0xFFC03500);
		debugfs_create_x16("CAN1_MB08_DATA1", 0600, parent, (u16 *)0xFFC03504);
		debugfs_create_x16("CAN1_MB08_DATA2", 0600, parent, (u16 *)0xFFC03508);
		debugfs_create_x16("CAN1_MB08_DATA3", 0600, parent, (u16 *)0xFFC0350C);
		debugfs_create_x16("CAN1_MB08_ID0", 0600, parent, (u16 *)0xFFC03518);
		debugfs_create_x16("CAN1_MB08_ID1", 0600, parent, (u16 *)0xFFC0351C);
		debugfs_create_x16("CAN1_MB08_LENGTH", 0600, parent, (u16 *)0xFFC03510);
		debugfs_create_x16("CAN1_MB08_TIMESTAMP", 0600, parent, (u16 *)0xFFC03514);
		debugfs_create_x16("CAN1_MB09_DATA0", 0600, parent, (u16 *)0xFFC03520);
		debugfs_create_x16("CAN1_MB09_DATA1", 0600, parent, (u16 *)0xFFC03524);
		debugfs_create_x16("CAN1_MB09_DATA2", 0600, parent, (u16 *)0xFFC03528);
		debugfs_create_x16("CAN1_MB09_DATA3", 0600, parent, (u16 *)0xFFC0352C);
		debugfs_create_x16("CAN1_MB09_ID0", 0600, parent, (u16 *)0xFFC03538);
		debugfs_create_x16("CAN1_MB09_ID1", 0600, parent, (u16 *)0xFFC0353C);
		debugfs_create_x16("CAN1_MB09_LENGTH", 0600, parent, (u16 *)0xFFC03530);
		debugfs_create_x16("CAN1_MB09_TIMESTAMP", 0600, parent, (u16 *)0xFFC03534);
		debugfs_create_x16("CAN1_MB10_DATA0", 0600, parent, (u16 *)0xFFC03540);
		debugfs_create_x16("CAN1_MB10_DATA1", 0600, parent, (u16 *)0xFFC03544);
		debugfs_create_x16("CAN1_MB10_DATA2", 0600, parent, (u16 *)0xFFC03548);
		debugfs_create_x16("CAN1_MB10_DATA3", 0600, parent, (u16 *)0xFFC0354C);
		debugfs_create_x16("CAN1_MB10_ID0", 0600, parent, (u16 *)0xFFC03558);
		debugfs_create_x16("CAN1_MB10_ID1", 0600, parent, (u16 *)0xFFC0355C);
		debugfs_create_x16("CAN1_MB10_LENGTH", 0600, parent, (u16 *)0xFFC03550);
		debugfs_create_x16("CAN1_MB10_TIMESTAMP", 0600, parent, (u16 *)0xFFC03554);
		debugfs_create_x16("CAN1_MB11_DATA0", 0600, parent, (u16 *)0xFFC03560);
		debugfs_create_x16("CAN1_MB11_DATA1", 0600, parent, (u16 *)0xFFC03564);
		debugfs_create_x16("CAN1_MB11_DATA2", 0600, parent, (u16 *)0xFFC03568);
		debugfs_create_x16("CAN1_MB11_DATA3", 0600, parent, (u16 *)0xFFC0356C);
		debugfs_create_x16("CAN1_MB11_ID0", 0600, parent, (u16 *)0xFFC03578);
		debugfs_create_x16("CAN1_MB11_ID1", 0600, parent, (u16 *)0xFFC0357C);
		debugfs_create_x16("CAN1_MB11_LENGTH", 0600, parent, (u16 *)0xFFC03570);
		debugfs_create_x16("CAN1_MB11_TIMESTAMP", 0600, parent, (u16 *)0xFFC03574);
		debugfs_create_x16("CAN1_MB12_DATA0", 0600, parent, (u16 *)0xFFC03580);
		debugfs_create_x16("CAN1_MB12_DATA1", 0600, parent, (u16 *)0xFFC03584);
		debugfs_create_x16("CAN1_MB12_DATA2", 0600, parent, (u16 *)0xFFC03588);
		debugfs_create_x16("CAN1_MB12_DATA3", 0600, parent, (u16 *)0xFFC0358C);
		debugfs_create_x16("CAN1_MB12_ID0", 0600, parent, (u16 *)0xFFC03598);
		debugfs_create_x16("CAN1_MB12_ID1", 0600, parent, (u16 *)0xFFC0359C);
		debugfs_create_x16("CAN1_MB12_LENGTH", 0600, parent, (u16 *)0xFFC03590);
		debugfs_create_x16("CAN1_MB12_TIMESTAMP", 0600, parent, (u16 *)0xFFC03594);
		debugfs_create_x16("CAN1_MB13_DATA0", 0600, parent, (u16 *)0xFFC035A0);
		debugfs_create_x16("CAN1_MB13_DATA1", 0600, parent, (u16 *)0xFFC035A4);
		debugfs_create_x16("CAN1_MB13_DATA2", 0600, parent, (u16 *)0xFFC035A8);
		debugfs_create_x16("CAN1_MB13_DATA3", 0600, parent, (u16 *)0xFFC035AC);
		debugfs_create_x16("CAN1_MB13_ID0", 0600, parent, (u16 *)0xFFC035B8);
		debugfs_create_x16("CAN1_MB13_ID1", 0600, parent, (u16 *)0xFFC035BC);
		debugfs_create_x16("CAN1_MB13_LENGTH", 0600, parent, (u16 *)0xFFC035B0);
		debugfs_create_x16("CAN1_MB13_TIMESTAMP", 0600, parent, (u16 *)0xFFC035B4);
		debugfs_create_x16("CAN1_MB14_DATA0", 0600, parent, (u16 *)0xFFC035C0);
		debugfs_create_x16("CAN1_MB14_DATA1", 0600, parent, (u16 *)0xFFC035C4);
		debugfs_create_x16("CAN1_MB14_DATA2", 0600, parent, (u16 *)0xFFC035C8);
		debugfs_create_x16("CAN1_MB14_DATA3", 0600, parent, (u16 *)0xFFC035CC);
		debugfs_create_x16("CAN1_MB14_ID0", 0600, parent, (u16 *)0xFFC035D8);
		debugfs_create_x16("CAN1_MB14_ID1", 0600, parent, (u16 *)0xFFC035DC);
		debugfs_create_x16("CAN1_MB14_LENGTH", 0600, parent, (u16 *)0xFFC035D0);
		debugfs_create_x16("CAN1_MB14_TIMESTAMP", 0600, parent, (u16 *)0xFFC035D4);
		debugfs_create_x16("CAN1_MB15_DATA0", 0600, parent, (u16 *)0xFFC035E0);
		debugfs_create_x16("CAN1_MB15_DATA1", 0600, parent, (u16 *)0xFFC035E4);
		debugfs_create_x16("CAN1_MB15_DATA2", 0600, parent, (u16 *)0xFFC035E8);
		debugfs_create_x16("CAN1_MB15_DATA3", 0600, parent, (u16 *)0xFFC035EC);
		debugfs_create_x16("CAN1_MB15_ID0", 0600, parent, (u16 *)0xFFC035F8);
		debugfs_create_x16("CAN1_MB15_ID1", 0600, parent, (u16 *)0xFFC035FC);
		debugfs_create_x16("CAN1_MB15_LENGTH", 0600, parent, (u16 *)0xFFC035F0);
		debugfs_create_x16("CAN1_MB15_TIMESTAMP", 0600, parent, (u16 *)0xFFC035F4);
		debugfs_create_x16("CAN1_MB16_DATA0", 0600, parent, (u16 *)0xFFC03600);
		debugfs_create_x16("CAN1_MB16_DATA1", 0600, parent, (u16 *)0xFFC03604);
		debugfs_create_x16("CAN1_MB16_DATA2", 0600, parent, (u16 *)0xFFC03608);
		debugfs_create_x16("CAN1_MB16_DATA3", 0600, parent, (u16 *)0xFFC0360C);
		debugfs_create_x16("CAN1_MB16_ID0", 0600, parent, (u16 *)0xFFC03618);
		debugfs_create_x16("CAN1_MB16_ID1", 0600, parent, (u16 *)0xFFC0361C);
		debugfs_create_x16("CAN1_MB16_LENGTH", 0600, parent, (u16 *)0xFFC03610);
		debugfs_create_x16("CAN1_MB16_TIMESTAMP", 0600, parent, (u16 *)0xFFC03614);
		debugfs_create_x16("CAN1_MB17_DATA0", 0600, parent, (u16 *)0xFFC03620);
		debugfs_create_x16("CAN1_MB17_DATA1", 0600, parent, (u16 *)0xFFC03624);
		debugfs_create_x16("CAN1_MB17_DATA2", 0600, parent, (u16 *)0xFFC03628);
		debugfs_create_x16("CAN1_MB17_DATA3", 0600, parent, (u16 *)0xFFC0362C);
		debugfs_create_x16("CAN1_MB17_ID0", 0600, parent, (u16 *)0xFFC03638);
		debugfs_create_x16("CAN1_MB17_ID1", 0600, parent, (u16 *)0xFFC0363C);
		debugfs_create_x16("CAN1_MB17_LENGTH", 0600, parent, (u16 *)0xFFC03630);
		debugfs_create_x16("CAN1_MB17_TIMESTAMP", 0600, parent, (u16 *)0xFFC03634);
		debugfs_create_x16("CAN1_MB18_DATA0", 0600, parent, (u16 *)0xFFC03640);
		debugfs_create_x16("CAN1_MB18_DATA1", 0600, parent, (u16 *)0xFFC03644);
		debugfs_create_x16("CAN1_MB18_DATA2", 0600, parent, (u16 *)0xFFC03648);
		debugfs_create_x16("CAN1_MB18_DATA3", 0600, parent, (u16 *)0xFFC0364C);
		debugfs_create_x16("CAN1_MB18_ID0", 0600, parent, (u16 *)0xFFC03658);
		debugfs_create_x16("CAN1_MB18_ID1", 0600, parent, (u16 *)0xFFC0365C);
		debugfs_create_x16("CAN1_MB18_LENGTH", 0600, parent, (u16 *)0xFFC03650);
		debugfs_create_x16("CAN1_MB18_TIMESTAMP", 0600, parent, (u16 *)0xFFC03654);
		debugfs_create_x16("CAN1_MB19_DATA0", 0600, parent, (u16 *)0xFFC03660);
		debugfs_create_x16("CAN1_MB19_DATA1", 0600, parent, (u16 *)0xFFC03664);
		debugfs_create_x16("CAN1_MB19_DATA2", 0600, parent, (u16 *)0xFFC03668);
		debugfs_create_x16("CAN1_MB19_DATA3", 0600, parent, (u16 *)0xFFC0366C);
		debugfs_create_x16("CAN1_MB19_ID0", 0600, parent, (u16 *)0xFFC03678);
		debugfs_create_x16("CAN1_MB19_ID1", 0600, parent, (u16 *)0xFFC0367C);
		debugfs_create_x16("CAN1_MB19_LENGTH", 0600, parent, (u16 *)0xFFC03670);
		debugfs_create_x16("CAN1_MB19_TIMESTAMP", 0600, parent, (u16 *)0xFFC03674);
		debugfs_create_x16("CAN1_MB20_DATA0", 0600, parent, (u16 *)0xFFC03680);
		debugfs_create_x16("CAN1_MB20_DATA1", 0600, parent, (u16 *)0xFFC03684);
		debugfs_create_x16("CAN1_MB20_DATA2", 0600, parent, (u16 *)0xFFC03688);
		debugfs_create_x16("CAN1_MB20_DATA3", 0600, parent, (u16 *)0xFFC0368C);
		debugfs_create_x16("CAN1_MB20_ID0", 0600, parent, (u16 *)0xFFC03698);
		debugfs_create_x16("CAN1_MB20_ID1", 0600, parent, (u16 *)0xFFC0369C);
		debugfs_create_x16("CAN1_MB20_LENGTH", 0600, parent, (u16 *)0xFFC03690);
		debugfs_create_x16("CAN1_MB20_TIMESTAMP", 0600, parent, (u16 *)0xFFC03694);
		debugfs_create_x16("CAN1_MB21_DATA0", 0600, parent, (u16 *)0xFFC036A0);
		debugfs_create_x16("CAN1_MB21_DATA1", 0600, parent, (u16 *)0xFFC036A4);
		debugfs_create_x16("CAN1_MB21_DATA2", 0600, parent, (u16 *)0xFFC036A8);
		debugfs_create_x16("CAN1_MB21_DATA3", 0600, parent, (u16 *)0xFFC036AC);
		debugfs_create_x16("CAN1_MB21_ID0", 0600, parent, (u16 *)0xFFC036B8);
		debugfs_create_x16("CAN1_MB21_ID1", 0600, parent, (u16 *)0xFFC036BC);
		debugfs_create_x16("CAN1_MB21_LENGTH", 0600, parent, (u16 *)0xFFC036B0);
		debugfs_create_x16("CAN1_MB21_TIMESTAMP", 0600, parent, (u16 *)0xFFC036B4);
		debugfs_create_x16("CAN1_MB22_DATA0", 0600, parent, (u16 *)0xFFC036C0);
		debugfs_create_x16("CAN1_MB22_DATA1", 0600, parent, (u16 *)0xFFC036C4);
		debugfs_create_x16("CAN1_MB22_DATA2", 0600, parent, (u16 *)0xFFC036C8);
		debugfs_create_x16("CAN1_MB22_DATA3", 0600, parent, (u16 *)0xFFC036CC);
		debugfs_create_x16("CAN1_MB22_ID0", 0600, parent, (u16 *)0xFFC036D8);
		debugfs_create_x16("CAN1_MB22_ID1", 0600, parent, (u16 *)0xFFC036DC);
		debugfs_create_x16("CAN1_MB22_LENGTH", 0600, parent, (u16 *)0xFFC036D0);
		debugfs_create_x16("CAN1_MB22_TIMESTAMP", 0600, parent, (u16 *)0xFFC036D4);
		debugfs_create_x16("CAN1_MB23_DATA0", 0600, parent, (u16 *)0xFFC036E0);
		debugfs_create_x16("CAN1_MB23_DATA1", 0600, parent, (u16 *)0xFFC036E4);
		debugfs_create_x16("CAN1_MB23_DATA2", 0600, parent, (u16 *)0xFFC036E8);
		debugfs_create_x16("CAN1_MB23_DATA3", 0600, parent, (u16 *)0xFFC036EC);
		debugfs_create_x16("CAN1_MB23_ID0", 0600, parent, (u16 *)0xFFC036F8);
		debugfs_create_x16("CAN1_MB23_ID1", 0600, parent, (u16 *)0xFFC036FC);
		debugfs_create_x16("CAN1_MB23_LENGTH", 0600, parent, (u16 *)0xFFC036F0);
		debugfs_create_x16("CAN1_MB23_TIMESTAMP", 0600, parent, (u16 *)0xFFC036F4);
		debugfs_create_x16("CAN1_MB24_DATA0", 0600, parent, (u16 *)0xFFC03700);
		debugfs_create_x16("CAN1_MB24_DATA1", 0600, parent, (u16 *)0xFFC03704);
		debugfs_create_x16("CAN1_MB24_DATA2", 0600, parent, (u16 *)0xFFC03708);
		debugfs_create_x16("CAN1_MB24_DATA3", 0600, parent, (u16 *)0xFFC0370C);
		debugfs_create_x16("CAN1_MB24_ID0", 0600, parent, (u16 *)0xFFC03718);
		debugfs_create_x16("CAN1_MB24_ID1", 0600, parent, (u16 *)0xFFC0371C);
		debugfs_create_x16("CAN1_MB24_LENGTH", 0600, parent, (u16 *)0xFFC03710);
		debugfs_create_x16("CAN1_MB24_TIMESTAMP", 0600, parent, (u16 *)0xFFC03714);
		debugfs_create_x16("CAN1_MB25_DATA0", 0600, parent, (u16 *)0xFFC03720);
		debugfs_create_x16("CAN1_MB25_DATA1", 0600, parent, (u16 *)0xFFC03724);
		debugfs_create_x16("CAN1_MB25_DATA2", 0600, parent, (u16 *)0xFFC03728);
		debugfs_create_x16("CAN1_MB25_DATA3", 0600, parent, (u16 *)0xFFC0372C);
		debugfs_create_x16("CAN1_MB25_ID0", 0600, parent, (u16 *)0xFFC03738);
		debugfs_create_x16("CAN1_MB25_ID1", 0600, parent, (u16 *)0xFFC0373C);
		debugfs_create_x16("CAN1_MB25_LENGTH", 0600, parent, (u16 *)0xFFC03730);
		debugfs_create_x16("CAN1_MB25_TIMESTAMP", 0600, parent, (u16 *)0xFFC03734);
		debugfs_create_x16("CAN1_MB26_DATA0", 0600, parent, (u16 *)0xFFC03740);
		debugfs_create_x16("CAN1_MB26_DATA1", 0600, parent, (u16 *)0xFFC03744);
		debugfs_create_x16("CAN1_MB26_DATA2", 0600, parent, (u16 *)0xFFC03748);
		debugfs_create_x16("CAN1_MB26_DATA3", 0600, parent, (u16 *)0xFFC0374C);
		debugfs_create_x16("CAN1_MB26_ID0", 0600, parent, (u16 *)0xFFC03758);
		debugfs_create_x16("CAN1_MB26_ID1", 0600, parent, (u16 *)0xFFC0375C);
		debugfs_create_x16("CAN1_MB26_LENGTH", 0600, parent, (u16 *)0xFFC03750);
		debugfs_create_x16("CAN1_MB26_TIMESTAMP", 0600, parent, (u16 *)0xFFC03754);
		debugfs_create_x16("CAN1_MB27_DATA0", 0600, parent, (u16 *)0xFFC03760);
		debugfs_create_x16("CAN1_MB27_DATA1", 0600, parent, (u16 *)0xFFC03764);
		debugfs_create_x16("CAN1_MB27_DATA2", 0600, parent, (u16 *)0xFFC03768);
		debugfs_create_x16("CAN1_MB27_DATA3", 0600, parent, (u16 *)0xFFC0376C);
		debugfs_create_x16("CAN1_MB27_ID0", 0600, parent, (u16 *)0xFFC03778);
		debugfs_create_x16("CAN1_MB27_ID1", 0600, parent, (u16 *)0xFFC0377C);
		debugfs_create_x16("CAN1_MB27_LENGTH", 0600, parent, (u16 *)0xFFC03770);
		debugfs_create_x16("CAN1_MB27_TIMESTAMP", 0600, parent, (u16 *)0xFFC03774);
		debugfs_create_x16("CAN1_MB28_DATA0", 0600, parent, (u16 *)0xFFC03780);
		debugfs_create_x16("CAN1_MB28_DATA1", 0600, parent, (u16 *)0xFFC03784);
		debugfs_create_x16("CAN1_MB28_DATA2", 0600, parent, (u16 *)0xFFC03788);
		debugfs_create_x16("CAN1_MB28_DATA3", 0600, parent, (u16 *)0xFFC0378C);
		debugfs_create_x16("CAN1_MB28_ID0", 0600, parent, (u16 *)0xFFC03798);
		debugfs_create_x16("CAN1_MB28_ID1", 0600, parent, (u16 *)0xFFC0379C);
		debugfs_create_x16("CAN1_MB28_LENGTH", 0600, parent, (u16 *)0xFFC03790);
		debugfs_create_x16("CAN1_MB28_TIMESTAMP", 0600, parent, (u16 *)0xFFC03794);
		debugfs_create_x16("CAN1_MB29_DATA0", 0600, parent, (u16 *)0xFFC037A0);
		debugfs_create_x16("CAN1_MB29_DATA1", 0600, parent, (u16 *)0xFFC037A4);
		debugfs_create_x16("CAN1_MB29_DATA2", 0600, parent, (u16 *)0xFFC037A8);
		debugfs_create_x16("CAN1_MB29_DATA3", 0600, parent, (u16 *)0xFFC037AC);
		debugfs_create_x16("CAN1_MB29_ID0", 0600, parent, (u16 *)0xFFC037B8);
		debugfs_create_x16("CAN1_MB29_ID1", 0600, parent, (u16 *)0xFFC037BC);
		debugfs_create_x16("CAN1_MB29_LENGTH", 0600, parent, (u16 *)0xFFC037B0);
		debugfs_create_x16("CAN1_MB29_TIMESTAMP", 0600, parent, (u16 *)0xFFC037B4);
		debugfs_create_x16("CAN1_MB30_DATA0", 0600, parent, (u16 *)0xFFC037C0);
		debugfs_create_x16("CAN1_MB30_DATA1", 0600, parent, (u16 *)0xFFC037C4);
		debugfs_create_x16("CAN1_MB30_DATA2", 0600, parent, (u16 *)0xFFC037C8);
		debugfs_create_x16("CAN1_MB30_DATA3", 0600, parent, (u16 *)0xFFC037CC);
		debugfs_create_x16("CAN1_MB30_ID0", 0600, parent, (u16 *)0xFFC037D8);
		debugfs_create_x16("CAN1_MB30_ID1", 0600, parent, (u16 *)0xFFC037DC);
		debugfs_create_x16("CAN1_MB30_LENGTH", 0600, parent, (u16 *)0xFFC037D0);
		debugfs_create_x16("CAN1_MB30_TIMESTAMP", 0600, parent, (u16 *)0xFFC037D4);
		debugfs_create_x16("CAN1_MB31_DATA0", 0600, parent, (u16 *)0xFFC037E0);
		debugfs_create_x16("CAN1_MB31_DATA1", 0600, parent, (u16 *)0xFFC037E4);
		debugfs_create_x16("CAN1_MB31_DATA2", 0600, parent, (u16 *)0xFFC037E8);
		debugfs_create_x16("CAN1_MB31_DATA3", 0600, parent, (u16 *)0xFFC037EC);
		debugfs_create_x16("CAN1_MB31_ID0", 0600, parent, (u16 *)0xFFC037F8);
		debugfs_create_x16("CAN1_MB31_ID1", 0600, parent, (u16 *)0xFFC037FC);
		debugfs_create_x16("CAN1_MB31_LENGTH", 0600, parent, (u16 *)0xFFC037F0);
		debugfs_create_x16("CAN1_MB31_TIMESTAMP", 0600, parent, (u16 *)0xFFC037F4);

		parent = debugfs_create_dir("CORE_TMR", top);
		debugfs_create_x32("TCNTL", 0600, parent, (u32 *)0xFFE03000);
		debugfs_create_x32("TCOUNT", 0600, parent, (u32 *)0xFFE0300C);
		debugfs_create_x32("TPERIOD", 0600, parent, (u32 *)0xFFE03004);
		debugfs_create_x32("TSCALE", 0600, parent, (u32 *)0xFFE03008);

		parent = debugfs_create_dir("Counter", top);
		debugfs_create_x16("CNT_COMMAND", 0600, parent, (u16 *)0xFFC0420C);
		debugfs_create_x16("CNT_CONFIG", 0600, parent, (u16 *)0xFFC04200);
		debugfs_create_x32("CNT_COUNTER", 0600, parent, (u32 *)0xFFC04214);
		debugfs_create_x16("CNT_DEBOUNCE", 0600, parent, (u16 *)0xFFC04210);
		debugfs_create_x16("CNT_IMASK", 0600, parent, (u16 *)0xFFC04204);
		debugfs_create_x32("CNT_MAX", 0600, parent, (u32 *)0xFFC04218);
		debugfs_create_x32("CNT_MIN", 0600, parent, (u32 *)0xFFC0421C);
		debugfs_create_x16("CNT_STATUS", 0600, parent, (u16 *)0xFFC04208);

		parent = debugfs_create_dir("DMA", top);
		debugfs_create_x16("DMA0_CONFIG", 0600, parent, (u16 *)0xFFC00C08);
		debugfs_create_x32("DMA0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C24);
		debugfs_create_x32("DMA0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C20);
		debugfs_create_x16("DMA0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C30);
		debugfs_create_x16("DMA0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C38);
		debugfs_create_x16("DMA0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C28);
		debugfs_create_x32("DMA0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C00);
		debugfs_create_x16("DMA0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C2C);
		debugfs_create_x32("DMA0_START_ADDR", 0600, parent, (u32 *)0xFFC00C04);
		debugfs_create_x16("DMA0_X_COUNT", 0600, parent, (u16 *)0xFFC00C10);
		debugfs_create_x16("DMA0_X_MODIFY", 0600, parent, (u16 *)0xFFC00C14);
		debugfs_create_x16("DMA0_Y_COUNT", 0600, parent, (u16 *)0xFFC00C18);
		debugfs_create_x16("DMA0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C1C);
		debugfs_create_x16("DMA10_CONFIG", 0600, parent, (u16 *)0xFFC00E88);
		debugfs_create_x32("DMA10_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EA4);
		debugfs_create_x32("DMA10_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EA0);
		debugfs_create_x16("DMA10_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EB0);
		debugfs_create_x16("DMA10_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EB8);
		debugfs_create_x16("DMA10_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EA8);
		debugfs_create_x32("DMA10_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E80);
		debugfs_create_x16("DMA10_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EAC);
		debugfs_create_x32("DMA10_START_ADDR", 0600, parent, (u32 *)0xFFC00E84);
		debugfs_create_x16("DMA10_X_COUNT", 0600, parent, (u16 *)0xFFC00E90);
		debugfs_create_x16("DMA10_X_MODIFY", 0600, parent, (u16 *)0xFFC00E94);
		debugfs_create_x16("DMA10_Y_COUNT", 0600, parent, (u16 *)0xFFC00E98);
		debugfs_create_x16("DMA10_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E9C);
		debugfs_create_x16("DMA11_CONFIG", 0600, parent, (u16 *)0xFFC00EC8);
		debugfs_create_x32("DMA11_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EE4);
		debugfs_create_x32("DMA11_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EE0);
		debugfs_create_x16("DMA11_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EF0);
		debugfs_create_x16("DMA11_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EF8);
		debugfs_create_x16("DMA11_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EE8);
		debugfs_create_x32("DMA11_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00EC0);
		debugfs_create_x16("DMA11_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EEC);
		debugfs_create_x32("DMA11_START_ADDR", 0600, parent, (u32 *)0xFFC00EC4);
		debugfs_create_x16("DMA11_X_COUNT", 0600, parent, (u16 *)0xFFC00ED0);
		debugfs_create_x16("DMA11_X_MODIFY", 0600, parent, (u16 *)0xFFC00ED4);
		debugfs_create_x16("DMA11_Y_COUNT", 0600, parent, (u16 *)0xFFC00ED8);
		debugfs_create_x16("DMA11_Y_MODIFY", 0600, parent, (u16 *)0xFFC00EDC);
		debugfs_create_x16("DMA12_CONFIG", 0600, parent, (u16 *)0xFFC01C08);
		debugfs_create_x32("DMA12_CURR_ADDR", 0600, parent, (u32 *)0xFFC01C24);
		debugfs_create_x32("DMA12_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01C20);
		debugfs_create_x16("DMA12_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01C30);
		debugfs_create_x16("DMA12_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01C38);
		debugfs_create_x16("DMA12_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01C28);
		debugfs_create_x32("DMA12_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01C00);
		debugfs_create_x16("DMA12_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01C2C);
		debugfs_create_x32("DMA12_START_ADDR", 0600, parent, (u32 *)0xFFC01C04);
		debugfs_create_x16("DMA12_X_COUNT", 0600, parent, (u16 *)0xFFC01C10);
		debugfs_create_x16("DMA12_X_MODIFY", 0600, parent, (u16 *)0xFFC01C14);
		debugfs_create_x16("DMA12_Y_COUNT", 0600, parent, (u16 *)0xFFC01C18);
		debugfs_create_x16("DMA12_Y_MODIFY", 0600, parent, (u16 *)0xFFC01C1C);
		debugfs_create_x16("DMA13_CONFIG", 0600, parent, (u16 *)0xFFC01C48);
		debugfs_create_x32("DMA13_CURR_ADDR", 0600, parent, (u32 *)0xFFC01C64);
		debugfs_create_x32("DMA13_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01C60);
		debugfs_create_x16("DMA13_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01C70);
		debugfs_create_x16("DMA13_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01C78);
		debugfs_create_x16("DMA13_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01C68);
		debugfs_create_x32("DMA13_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01C40);
		debugfs_create_x16("DMA13_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01C6C);
		debugfs_create_x32("DMA13_START_ADDR", 0600, parent, (u32 *)0xFFC01C44);
		debugfs_create_x16("DMA13_X_COUNT", 0600, parent, (u16 *)0xFFC01C50);
		debugfs_create_x16("DMA13_X_MODIFY", 0600, parent, (u16 *)0xFFC01C54);
		debugfs_create_x16("DMA13_Y_COUNT", 0600, parent, (u16 *)0xFFC01C58);
		debugfs_create_x16("DMA13_Y_MODIFY", 0600, parent, (u16 *)0xFFC01C5C);
		debugfs_create_x16("DMA14_CONFIG", 0600, parent, (u16 *)0xFFC01C88);
		debugfs_create_x32("DMA14_CURR_ADDR", 0600, parent, (u32 *)0xFFC01CA4);
		debugfs_create_x32("DMA14_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01CA0);
		debugfs_create_x16("DMA14_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01CB0);
		debugfs_create_x16("DMA14_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01CB8);
		debugfs_create_x16("DMA14_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01CA8);
		debugfs_create_x32("DMA14_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01C80);
		debugfs_create_x16("DMA14_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01CAC);
		debugfs_create_x32("DMA14_START_ADDR", 0600, parent, (u32 *)0xFFC01C84);
		debugfs_create_x16("DMA14_X_COUNT", 0600, parent, (u16 *)0xFFC01C90);
		debugfs_create_x16("DMA14_X_MODIFY", 0600, parent, (u16 *)0xFFC01C94);
		debugfs_create_x16("DMA14_Y_COUNT", 0600, parent, (u16 *)0xFFC01C98);
		debugfs_create_x16("DMA14_Y_MODIFY", 0600, parent, (u16 *)0xFFC01C9C);
		debugfs_create_x16("DMA15_CONFIG", 0600, parent, (u16 *)0xFFC01CC8);
		debugfs_create_x32("DMA15_CURR_ADDR", 0600, parent, (u32 *)0xFFC01CE4);
		debugfs_create_x32("DMA15_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01CE0);
		debugfs_create_x16("DMA15_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01CF0);
		debugfs_create_x16("DMA15_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01CF8);
		debugfs_create_x16("DMA15_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01CE8);
		debugfs_create_x32("DMA15_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01CC0);
		debugfs_create_x16("DMA15_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01CEC);
		debugfs_create_x32("DMA15_START_ADDR", 0600, parent, (u32 *)0xFFC01CC4);
		debugfs_create_x16("DMA15_X_COUNT", 0600, parent, (u16 *)0xFFC01CD0);
		debugfs_create_x16("DMA15_X_MODIFY", 0600, parent, (u16 *)0xFFC01CD4);
		debugfs_create_x16("DMA15_Y_COUNT", 0600, parent, (u16 *)0xFFC01CD8);
		debugfs_create_x16("DMA15_Y_MODIFY", 0600, parent, (u16 *)0xFFC01CDC);
		debugfs_create_x16("DMA16_CONFIG", 0600, parent, (u16 *)0xFFC01D08);
		debugfs_create_x32("DMA16_CURR_ADDR", 0600, parent, (u32 *)0xFFC01D24);
		debugfs_create_x32("DMA16_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01D20);
		debugfs_create_x16("DMA16_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01D30);
		debugfs_create_x16("DMA16_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01D38);
		debugfs_create_x16("DMA16_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01D28);
		debugfs_create_x32("DMA16_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01D00);
		debugfs_create_x16("DMA16_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01D2C);
		debugfs_create_x32("DMA16_START_ADDR", 0600, parent, (u32 *)0xFFC01D04);
		debugfs_create_x16("DMA16_X_COUNT", 0600, parent, (u16 *)0xFFC01D10);
		debugfs_create_x16("DMA16_X_MODIFY", 0600, parent, (u16 *)0xFFC01D14);
		debugfs_create_x16("DMA16_Y_COUNT", 0600, parent, (u16 *)0xFFC01D18);
		debugfs_create_x16("DMA16_Y_MODIFY", 0600, parent, (u16 *)0xFFC01D1C);
		debugfs_create_x16("DMA17_CONFIG", 0600, parent, (u16 *)0xFFC01D48);
		debugfs_create_x32("DMA17_CURR_ADDR", 0600, parent, (u32 *)0xFFC01D64);
		debugfs_create_x32("DMA17_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01D60);
		debugfs_create_x16("DMA17_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01D70);
		debugfs_create_x16("DMA17_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01D78);
		debugfs_create_x16("DMA17_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01D68);
		debugfs_create_x32("DMA17_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01D40);
		debugfs_create_x16("DMA17_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01D6C);
		debugfs_create_x32("DMA17_START_ADDR", 0600, parent, (u32 *)0xFFC01D44);
		debugfs_create_x16("DMA17_X_COUNT", 0600, parent, (u16 *)0xFFC01D50);
		debugfs_create_x16("DMA17_X_MODIFY", 0600, parent, (u16 *)0xFFC01D54);
		debugfs_create_x16("DMA17_Y_COUNT", 0600, parent, (u16 *)0xFFC01D58);
		debugfs_create_x16("DMA17_Y_MODIFY", 0600, parent, (u16 *)0xFFC01D5C);
		debugfs_create_x16("DMA18_CONFIG", 0600, parent, (u16 *)0xFFC01D88);
		debugfs_create_x32("DMA18_CURR_ADDR", 0600, parent, (u32 *)0xFFC01DA4);
		debugfs_create_x32("DMA18_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01DA0);
		debugfs_create_x16("DMA18_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01DB0);
		debugfs_create_x16("DMA18_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01DB8);
		debugfs_create_x16("DMA18_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01DA8);
		debugfs_create_x32("DMA18_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01D80);
		debugfs_create_x16("DMA18_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01DAC);
		debugfs_create_x32("DMA18_START_ADDR", 0600, parent, (u32 *)0xFFC01D84);
		debugfs_create_x16("DMA18_X_COUNT", 0600, parent, (u16 *)0xFFC01D90);
		debugfs_create_x16("DMA18_X_MODIFY", 0600, parent, (u16 *)0xFFC01D94);
		debugfs_create_x16("DMA18_Y_COUNT", 0600, parent, (u16 *)0xFFC01D98);
		debugfs_create_x16("DMA18_Y_MODIFY", 0600, parent, (u16 *)0xFFC01D9C);
		debugfs_create_x16("DMA19_CONFIG", 0600, parent, (u16 *)0xFFC01DC8);
		debugfs_create_x32("DMA19_CURR_ADDR", 0600, parent, (u32 *)0xFFC01DE4);
		debugfs_create_x32("DMA19_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01DE0);
		debugfs_create_x16("DMA19_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01DF0);
		debugfs_create_x16("DMA19_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01DF8);
		debugfs_create_x16("DMA19_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01DE8);
		debugfs_create_x32("DMA19_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01DC0);
		debugfs_create_x16("DMA19_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01DEC);
		debugfs_create_x32("DMA19_START_ADDR", 0600, parent, (u32 *)0xFFC01DC4);
		debugfs_create_x16("DMA19_X_COUNT", 0600, parent, (u16 *)0xFFC01DD0);
		debugfs_create_x16("DMA19_X_MODIFY", 0600, parent, (u16 *)0xFFC01DD4);
		debugfs_create_x16("DMA19_Y_COUNT", 0600, parent, (u16 *)0xFFC01DD8);
		debugfs_create_x16("DMA19_Y_MODIFY", 0600, parent, (u16 *)0xFFC01DDC);
		debugfs_create_x16("DMA1_CONFIG", 0600, parent, (u16 *)0xFFC00C48);
		debugfs_create_x32("DMA1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C64);
		debugfs_create_x32("DMA1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C60);
		debugfs_create_x16("DMA1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C70);
		debugfs_create_x16("DMA1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C78);
		debugfs_create_x16("DMA1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C68);
		debugfs_create_x32("DMA1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C40);
		debugfs_create_x16("DMA1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C6C);
		debugfs_create_x32("DMA1_START_ADDR", 0600, parent, (u32 *)0xFFC00C44);
		debugfs_create_x16("DMA1_X_COUNT", 0600, parent, (u16 *)0xFFC00C50);
		debugfs_create_x16("DMA1_X_MODIFY", 0600, parent, (u16 *)0xFFC00C54);
		debugfs_create_x16("DMA1_Y_COUNT", 0600, parent, (u16 *)0xFFC00C58);
		debugfs_create_x16("DMA1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C5C);
		debugfs_create_x16("DMA20_CONFIG", 0600, parent, (u16 *)0xFFC01E08);
		debugfs_create_x32("DMA20_CURR_ADDR", 0600, parent, (u32 *)0xFFC01E24);
		debugfs_create_x32("DMA20_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01E20);
		debugfs_create_x16("DMA20_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01E30);
		debugfs_create_x16("DMA20_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01E38);
		debugfs_create_x16("DMA20_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01E28);
		debugfs_create_x32("DMA20_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01E00);
		debugfs_create_x16("DMA20_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01E2C);
		debugfs_create_x32("DMA20_START_ADDR", 0600, parent, (u32 *)0xFFC01E04);
		debugfs_create_x16("DMA20_X_COUNT", 0600, parent, (u16 *)0xFFC01E10);
		debugfs_create_x16("DMA20_X_MODIFY", 0600, parent, (u16 *)0xFFC01E14);
		debugfs_create_x16("DMA20_Y_COUNT", 0600, parent, (u16 *)0xFFC01E18);
		debugfs_create_x16("DMA20_Y_MODIFY", 0600, parent, (u16 *)0xFFC01E1C);
		debugfs_create_x16("DMA21_CONFIG", 0600, parent, (u16 *)0xFFC01E48);
		debugfs_create_x32("DMA21_CURR_ADDR", 0600, parent, (u32 *)0xFFC01E64);
		debugfs_create_x32("DMA21_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01E60);
		debugfs_create_x16("DMA21_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01E70);
		debugfs_create_x16("DMA21_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01E78);
		debugfs_create_x16("DMA21_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01E68);
		debugfs_create_x32("DMA21_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01E40);
		debugfs_create_x16("DMA21_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01E6C);
		debugfs_create_x32("DMA21_START_ADDR", 0600, parent, (u32 *)0xFFC01E44);
		debugfs_create_x16("DMA21_X_COUNT", 0600, parent, (u16 *)0xFFC01E50);
		debugfs_create_x16("DMA21_X_MODIFY", 0600, parent, (u16 *)0xFFC01E54);
		debugfs_create_x16("DMA21_Y_COUNT", 0600, parent, (u16 *)0xFFC01E58);
		debugfs_create_x16("DMA21_Y_MODIFY", 0600, parent, (u16 *)0xFFC01E5C);
		debugfs_create_x16("DMA22_CONFIG", 0600, parent, (u16 *)0xFFC01E88);
		debugfs_create_x32("DMA22_CURR_ADDR", 0600, parent, (u32 *)0xFFC01EA4);
		debugfs_create_x32("DMA22_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01EA0);
		debugfs_create_x16("DMA22_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01EB0);
		debugfs_create_x16("DMA22_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01EB8);
		debugfs_create_x16("DMA22_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01EA8);
		debugfs_create_x32("DMA22_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01E80);
		debugfs_create_x16("DMA22_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01EAC);
		debugfs_create_x32("DMA22_START_ADDR", 0600, parent, (u32 *)0xFFC01E84);
		debugfs_create_x16("DMA22_X_COUNT", 0600, parent, (u16 *)0xFFC01E90);
		debugfs_create_x16("DMA22_X_MODIFY", 0600, parent, (u16 *)0xFFC01E94);
		debugfs_create_x16("DMA22_Y_COUNT", 0600, parent, (u16 *)0xFFC01E98);
		debugfs_create_x16("DMA22_Y_MODIFY", 0600, parent, (u16 *)0xFFC01E9C);
		debugfs_create_x16("DMA23_CONFIG", 0600, parent, (u16 *)0xFFC01EC8);
		debugfs_create_x32("DMA23_CURR_ADDR", 0600, parent, (u32 *)0xFFC01EE4);
		debugfs_create_x32("DMA23_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01EE0);
		debugfs_create_x16("DMA23_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01EF0);
		debugfs_create_x16("DMA23_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01EF8);
		debugfs_create_x16("DMA23_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01EE8);
		debugfs_create_x32("DMA23_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01EC0);
		debugfs_create_x16("DMA23_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01EEC);
		debugfs_create_x32("DMA23_START_ADDR", 0600, parent, (u32 *)0xFFC01EC4);
		debugfs_create_x16("DMA23_X_COUNT", 0600, parent, (u16 *)0xFFC01ED0);
		debugfs_create_x16("DMA23_X_MODIFY", 0600, parent, (u16 *)0xFFC01ED4);
		debugfs_create_x16("DMA23_Y_COUNT", 0600, parent, (u16 *)0xFFC01ED8);
		debugfs_create_x16("DMA23_Y_MODIFY", 0600, parent, (u16 *)0xFFC01EDC);
		debugfs_create_x16("DMA2_CONFIG", 0600, parent, (u16 *)0xFFC00C88);
		debugfs_create_x32("DMA2_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CA4);
		debugfs_create_x32("DMA2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CA0);
		debugfs_create_x16("DMA2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CB0);
		debugfs_create_x16("DMA2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CB8);
		debugfs_create_x16("DMA2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CA8);
		debugfs_create_x32("DMA2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C80);
		debugfs_create_x16("DMA2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CAC);
		debugfs_create_x32("DMA2_START_ADDR", 0600, parent, (u32 *)0xFFC00C84);
		debugfs_create_x16("DMA2_X_COUNT", 0600, parent, (u16 *)0xFFC00C90);
		debugfs_create_x16("DMA2_X_MODIFY", 0600, parent, (u16 *)0xFFC00C94);
		debugfs_create_x16("DMA2_Y_COUNT", 0600, parent, (u16 *)0xFFC00C98);
		debugfs_create_x16("DMA2_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C9C);
		debugfs_create_x16("DMA3_CONFIG", 0600, parent, (u16 *)0xFFC00CC8);
		debugfs_create_x32("DMA3_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CE4);
		debugfs_create_x32("DMA3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CE0);
		debugfs_create_x16("DMA3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CF0);
		debugfs_create_x16("DMA3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CF8);
		debugfs_create_x16("DMA3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CE8);
		debugfs_create_x32("DMA3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00CC0);
		debugfs_create_x16("DMA3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CEC);
		debugfs_create_x32("DMA3_START_ADDR", 0600, parent, (u32 *)0xFFC00CC4);
		debugfs_create_x16("DMA3_X_COUNT", 0600, parent, (u16 *)0xFFC00CD0);
		debugfs_create_x16("DMA3_X_MODIFY", 0600, parent, (u16 *)0xFFC00CD4);
		debugfs_create_x16("DMA3_Y_COUNT", 0600, parent, (u16 *)0xFFC00CD8);
		debugfs_create_x16("DMA3_Y_MODIFY", 0600, parent, (u16 *)0xFFC00CDC);
		debugfs_create_x16("DMA4_CONFIG", 0600, parent, (u16 *)0xFFC00D08);
		debugfs_create_x32("DMA4_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D24);
		debugfs_create_x32("DMA4_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D20);
		debugfs_create_x16("DMA4_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D30);
		debugfs_create_x16("DMA4_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D38);
		debugfs_create_x16("DMA4_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D28);
		debugfs_create_x32("DMA4_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D00);
		debugfs_create_x16("DMA4_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D2C);
		debugfs_create_x32("DMA4_START_ADDR", 0600, parent, (u32 *)0xFFC00D04);
		debugfs_create_x16("DMA4_X_COUNT", 0600, parent, (u16 *)0xFFC00D10);
		debugfs_create_x16("DMA4_X_MODIFY", 0600, parent, (u16 *)0xFFC00D14);
		debugfs_create_x16("DMA4_Y_COUNT", 0600, parent, (u16 *)0xFFC00D18);
		debugfs_create_x16("DMA4_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D1C);
		debugfs_create_x16("DMA5_CONFIG", 0600, parent, (u16 *)0xFFC00D48);
		debugfs_create_x32("DMA5_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D64);
		debugfs_create_x32("DMA5_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D60);
		debugfs_create_x16("DMA5_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D70);
		debugfs_create_x16("DMA5_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D78);
		debugfs_create_x16("DMA5_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D68);
		debugfs_create_x32("DMA5_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D40);
		debugfs_create_x16("DMA5_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D6C);
		debugfs_create_x32("DMA5_START_ADDR", 0600, parent, (u32 *)0xFFC00D44);
		debugfs_create_x16("DMA5_X_COUNT", 0600, parent, (u16 *)0xFFC00D50);
		debugfs_create_x16("DMA5_X_MODIFY", 0600, parent, (u16 *)0xFFC00D54);
		debugfs_create_x16("DMA5_Y_COUNT", 0600, parent, (u16 *)0xFFC00D58);
		debugfs_create_x16("DMA5_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D5C);
		debugfs_create_x16("DMA6_CONFIG", 0600, parent, (u16 *)0xFFC00D88);
		debugfs_create_x32("DMA6_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DA4);
		debugfs_create_x32("DMA6_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DA0);
		debugfs_create_x16("DMA6_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DB0);
		debugfs_create_x16("DMA6_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DB8);
		debugfs_create_x16("DMA6_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DA8);
		debugfs_create_x32("DMA6_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D80);
		debugfs_create_x16("DMA6_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DAC);
		debugfs_create_x32("DMA6_START_ADDR", 0600, parent, (u32 *)0xFFC00D84);
		debugfs_create_x16("DMA6_X_COUNT", 0600, parent, (u16 *)0xFFC00D90);
		debugfs_create_x16("DMA6_X_MODIFY", 0600, parent, (u16 *)0xFFC00D94);
		debugfs_create_x16("DMA6_Y_COUNT", 0600, parent, (u16 *)0xFFC00D98);
		debugfs_create_x16("DMA6_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D9C);
		debugfs_create_x16("DMA7_CONFIG", 0600, parent, (u16 *)0xFFC00DC8);
		debugfs_create_x32("DMA7_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DE4);
		debugfs_create_x32("DMA7_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DE0);
		debugfs_create_x16("DMA7_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DF0);
		debugfs_create_x16("DMA7_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DF8);
		debugfs_create_x16("DMA7_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DE8);
		debugfs_create_x32("DMA7_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00DC0);
		debugfs_create_x16("DMA7_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DEC);
		debugfs_create_x32("DMA7_START_ADDR", 0600, parent, (u32 *)0xFFC00DC4);
		debugfs_create_x16("DMA7_X_COUNT", 0600, parent, (u16 *)0xFFC00DD0);
		debugfs_create_x16("DMA7_X_MODIFY", 0600, parent, (u16 *)0xFFC00DD4);
		debugfs_create_x16("DMA7_Y_COUNT", 0600, parent, (u16 *)0xFFC00DD8);
		debugfs_create_x16("DMA7_Y_MODIFY", 0600, parent, (u16 *)0xFFC00DDC);
		debugfs_create_x16("DMA8_CONFIG", 0600, parent, (u16 *)0xFFC00E08);
		debugfs_create_x32("DMA8_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E24);
		debugfs_create_x32("DMA8_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E20);
		debugfs_create_x16("DMA8_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E30);
		debugfs_create_x16("DMA8_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E38);
		debugfs_create_x16("DMA8_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E28);
		debugfs_create_x32("DMA8_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E00);
		debugfs_create_x16("DMA8_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E2C);
		debugfs_create_x32("DMA8_START_ADDR", 0600, parent, (u32 *)0xFFC00E04);
		debugfs_create_x16("DMA8_X_COUNT", 0600, parent, (u16 *)0xFFC00E10);
		debugfs_create_x16("DMA8_X_MODIFY", 0600, parent, (u16 *)0xFFC00E14);
		debugfs_create_x16("DMA8_Y_COUNT", 0600, parent, (u16 *)0xFFC00E18);
		debugfs_create_x16("DMA8_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E1C);
		debugfs_create_x16("DMA9_CONFIG", 0600, parent, (u16 *)0xFFC00E48);
		debugfs_create_x32("DMA9_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E64);
		debugfs_create_x32("DMA9_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E60);
		debugfs_create_x16("DMA9_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E70);
		debugfs_create_x16("DMA9_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E78);
		debugfs_create_x16("DMA9_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E68);
		debugfs_create_x32("DMA9_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E40);
		debugfs_create_x16("DMA9_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E6C);
		debugfs_create_x32("DMA9_START_ADDR", 0600, parent, (u32 *)0xFFC00E44);
		debugfs_create_x16("DMA9_X_COUNT", 0600, parent, (u16 *)0xFFC00E50);
		debugfs_create_x16("DMA9_X_MODIFY", 0600, parent, (u16 *)0xFFC00E54);
		debugfs_create_x16("DMA9_Y_COUNT", 0600, parent, (u16 *)0xFFC00E58);
		debugfs_create_x16("DMA9_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E5C);
		debugfs_create_x16("DMAC0_TCCNT", 0600, parent, (u16 *)0xFFC00B10);
		debugfs_create_x16("DMAC0_TCPER", 0600, parent, (u16 *)0xFFC00B0C);
		debugfs_create_x16("DMAC1_PERIMUX", 0600, parent, (u16 *)0xFFC04340);
		debugfs_create_x16("DMAC1_TCCNT", 0600, parent, (u16 *)0xFFC01B10);
		debugfs_create_x16("DMAC1_TCPER", 0600, parent, (u16 *)0xFFC01B0C);

		parent = debugfs_create_dir("EBIU", top);
		debugfs_create_x32("EBIU_AMBCTL0", 0600, parent, (u32 *)0xFFC00A04);
		debugfs_create_x32("EBIU_AMBCTL1", 0600, parent, (u32 *)0xFFC00A08);
		debugfs_create_x16("EBIU_AMGCTL", 0600, parent, (u16 *)0xFFC00A00);
		debugfs_create_x32("EBIU_ARBSTAT", 0600, parent, (u32 *)0xFFC00A10);
		debugfs_create_x32("EBIU_DDRACCT", 0600, parent, (u32 *)0xFFC00AA0);
		debugfs_create_x32("EBIU_DDRARCT", 0600, parent, (u32 *)0xFFC00AAC);
		debugfs_create_x32("EBIU_DDRBRC0", 0600, parent, (u32 *)0xFFC00A60);
		debugfs_create_x32("EBIU_DDRBRC1", 0600, parent, (u32 *)0xFFC00A64);
		debugfs_create_x32("EBIU_DDRBRC2", 0600, parent, (u32 *)0xFFC00A68);
		debugfs_create_x32("EBIU_DDRBRC3", 0600, parent, (u32 *)0xFFC00A6C);
		debugfs_create_x32("EBIU_DDRBRC4", 0600, parent, (u32 *)0xFFC00A70);
		debugfs_create_x32("EBIU_DDRBRC5", 0600, parent, (u32 *)0xFFC00A74);
		debugfs_create_x32("EBIU_DDRBRC6", 0600, parent, (u32 *)0xFFC00A78);
		debugfs_create_x32("EBIU_DDRBRC7", 0600, parent, (u32 *)0xFFC00A7C);
		debugfs_create_x32("EBIU_DDRBWC0", 0600, parent, (u32 *)0xFFC00A80);
		debugfs_create_x32("EBIU_DDRBWC1", 0600, parent, (u32 *)0xFFC00A84);
		debugfs_create_x32("EBIU_DDRBWC2", 0600, parent, (u32 *)0xFFC00A88);
		debugfs_create_x32("EBIU_DDRBWC3", 0600, parent, (u32 *)0xFFC00A8C);
		debugfs_create_x32("EBIU_DDRBWC4", 0600, parent, (u32 *)0xFFC00A90);
		debugfs_create_x32("EBIU_DDRBWC5", 0600, parent, (u32 *)0xFFC00A94);
		debugfs_create_x32("EBIU_DDRBWC6", 0600, parent, (u32 *)0xFFC00A98);
		debugfs_create_x32("EBIU_DDRBWC7", 0600, parent, (u32 *)0xFFC00A9C);
		debugfs_create_x32("EBIU_DDRCTL0", 0600, parent, (u32 *)0xFFC00A20);
		debugfs_create_x32("EBIU_DDRCTL1", 0600, parent, (u32 *)0xFFC00A24);
		debugfs_create_x32("EBIU_DDRCTL2", 0600, parent, (u32 *)0xFFC00A28);
		debugfs_create_x32("EBIU_DDRCTL3", 0600, parent, (u32 *)0xFFC00A2C);
		debugfs_create_x32("EBIU_DDRGC0", 0600, parent, (u32 *)0xFFC00AB0);
		debugfs_create_x32("EBIU_DDRGC1", 0600, parent, (u32 *)0xFFC00AB4);
		debugfs_create_x32("EBIU_DDRGC2", 0600, parent, (u32 *)0xFFC00AB8);
		debugfs_create_x32("EBIU_DDRGC3", 0600, parent, (u32 *)0xFFC00ABC);
		debugfs_create_x32("EBIU_DDRMCCL", 0600, parent, (u32 *)0xFFC00AC4);
		debugfs_create_x32("EBIU_DDRMCEN", 0600, parent, (u32 *)0xFFC00AC0);
		debugfs_create_x32("EBIU_DDRQUE", 0600, parent, (u32 *)0xFFC00A30);
		debugfs_create_x32("EBIU_DDRTACT", 0600, parent, (u32 *)0xFFC00AA8);
		debugfs_create_x32("EBIU_ERRADD", 0600, parent, (u32 *)0xFFC00A34);
		debugfs_create_x16("EBIU_ERRMST", 0600, parent, (u16 *)0xFFC00A38);
		debugfs_create_x32("EBIU_FCTL", 0600, parent, (u32 *)0xFFC00A18);
		debugfs_create_x32("EBIU_MBSCTL", 0600, parent, (u32 *)0xFFC00A0C);
		debugfs_create_x32("EBIU_MODE", 0600, parent, (u32 *)0xFFC00A14);
		debugfs_create_x16("EBIU_RSTCTL", 0600, parent, (u16 *)0xFFC00A3C);

		parent = debugfs_create_dir("EPPI", top);
		debugfs_create_x32("EPPI0_CLIP", 0600, parent, (u32 *)0xFFC01034);
		debugfs_create_x16("EPPI0_CLKDIV", 0600, parent, (u16 *)0xFFC0101C);
		debugfs_create_x32("EPPI0_CONTROL", 0600, parent, (u32 *)0xFFC01020);
		debugfs_create_x16("EPPI0_FRAME", 0600, parent, (u16 *)0xFFC01014);
		debugfs_create_x32("EPPI0_FS1P_AVPL", 0600, parent, (u32 *)0xFFC01028);
		debugfs_create_x32("EPPI0_FS1W_HBL", 0600, parent, (u32 *)0xFFC01024);
		debugfs_create_x32("EPPI0_FS2P_LAVF", 0600, parent, (u32 *)0xFFC01030);
		debugfs_create_x32("EPPI0_FS2W_LVB", 0600, parent, (u32 *)0xFFC0102C);
		debugfs_create_x16("EPPI0_HCOUNT", 0600, parent, (u16 *)0xFFC01004);
		debugfs_create_x16("EPPI0_HDELAY", 0600, parent, (u16 *)0xFFC01008);
		debugfs_create_x16("EPPI0_LINE", 0600, parent, (u16 *)0xFFC01018);
		debugfs_create_x16("EPPI0_STATUS", 0600, parent, (u16 *)0xFFC01000);
		debugfs_create_x16("EPPI0_VCOUNT", 0600, parent, (u16 *)0xFFC0100C);
		debugfs_create_x16("EPPI0_VDELAY", 0600, parent, (u16 *)0xFFC01010);
		debugfs_create_x32("EPPI1_CLIP", 0600, parent, (u32 *)0xFFC01334);
		debugfs_create_x16("EPPI1_CLKDIV", 0600, parent, (u16 *)0xFFC0131C);
		debugfs_create_x32("EPPI1_CONTROL", 0600, parent, (u32 *)0xFFC01320);
		debugfs_create_x16("EPPI1_FRAME", 0600, parent, (u16 *)0xFFC01314);
		debugfs_create_x32("EPPI1_FS1P_AVPL", 0600, parent, (u32 *)0xFFC01328);
		debugfs_create_x32("EPPI1_FS1W_HBL", 0600, parent, (u32 *)0xFFC01324);
		debugfs_create_x32("EPPI1_FS2P_LAVF", 0600, parent, (u32 *)0xFFC01330);
		debugfs_create_x32("EPPI1_FS2W_LVB", 0600, parent, (u32 *)0xFFC0132C);
		debugfs_create_x16("EPPI1_HCOUNT", 0600, parent, (u16 *)0xFFC01304);
		debugfs_create_x16("EPPI1_HDELAY", 0600, parent, (u16 *)0xFFC01308);
		debugfs_create_x16("EPPI1_LINE", 0600, parent, (u16 *)0xFFC01318);
		debugfs_create_x16("EPPI1_STATUS", 0600, parent, (u16 *)0xFFC01300);
		debugfs_create_x16("EPPI1_VCOUNT", 0600, parent, (u16 *)0xFFC0130C);
		debugfs_create_x16("EPPI1_VDELAY", 0600, parent, (u16 *)0xFFC01310);
		debugfs_create_x32("EPPI2_CLIP", 0600, parent, (u32 *)0xFFC02934);
		debugfs_create_x16("EPPI2_CLKDIV", 0600, parent, (u16 *)0xFFC0291C);
		debugfs_create_x32("EPPI2_CONTROL", 0600, parent, (u32 *)0xFFC02920);
		debugfs_create_x16("EPPI2_FRAME", 0600, parent, (u16 *)0xFFC02914);
		debugfs_create_x32("EPPI2_FS1P_AVPL", 0600, parent, (u32 *)0xFFC02928);
		debugfs_create_x32("EPPI2_FS1W_HBL", 0600, parent, (u32 *)0xFFC02924);
		debugfs_create_x32("EPPI2_FS2P_LAVF", 0600, parent, (u32 *)0xFFC02930);
		debugfs_create_x32("EPPI2_FS2W_LVB", 0600, parent, (u32 *)0xFFC0292C);
		debugfs_create_x16("EPPI2_HCOUNT", 0600, parent, (u16 *)0xFFC02904);
		debugfs_create_x16("EPPI2_HDELAY", 0600, parent, (u16 *)0xFFC02908);
		debugfs_create_x16("EPPI2_LINE", 0600, parent, (u16 *)0xFFC02918);
		debugfs_create_x16("EPPI2_STATUS", 0600, parent, (u16 *)0xFFC02900);
		debugfs_create_x16("EPPI2_VCOUNT", 0600, parent, (u16 *)0xFFC0290C);
		debugfs_create_x16("EPPI2_VDELAY", 0600, parent, (u16 *)0xFFC02910);

		parent = debugfs_create_dir("Event Vectors", top);
		debugfs_create_x32("EVT0", 0600, parent, (u32 *)0xFFE02000);
		debugfs_create_x32("EVT10", 0600, parent, (u32 *)0xFFE02028);
		debugfs_create_x32("EVT11", 0600, parent, (u32 *)0xFFE0202C);
		debugfs_create_x32("EVT12", 0600, parent, (u32 *)0xFFE02030);
		debugfs_create_x32("EVT13", 0600, parent, (u32 *)0xFFE02034);
		debugfs_create_x32("EVT14", 0600, parent, (u32 *)0xFFE02038);
		debugfs_create_x32("EVT15", 0600, parent, (u32 *)0xFFE0203C);
		debugfs_create_x32("EVT1", 0600, parent, (u32 *)0xFFE02004);
		debugfs_create_x32("EVT2", 0600, parent, (u32 *)0xFFE02008);
		debugfs_create_x32("EVT3", 0600, parent, (u32 *)0xFFE0200C);
		debugfs_create_x32("EVT4", 0600, parent, (u32 *)0xFFE02010);
		debugfs_create_x32("EVT5", 0600, parent, (u32 *)0xFFE02014);
		debugfs_create_x32("EVT6", 0600, parent, (u32 *)0xFFE02018);
		debugfs_create_x32("EVT7", 0600, parent, (u32 *)0xFFE0201C);
		debugfs_create_x32("EVT8", 0600, parent, (u32 *)0xFFE02020);
		debugfs_create_x32("EVT9", 0600, parent, (u32 *)0xFFE02024);

		parent = debugfs_create_dir("Extended Registers", top);
		debugfs_create_x32("CHIPID", 0600, parent, (u32 *)0xFFC00014);
		debugfs_create_x32("DSPID", 0600, parent, (u32 *)0xFFE05000);

		parent = debugfs_create_dir("HMDMA", top);
		debugfs_create_x16("HMDMA0_BCINIT", 0600, parent, (u16 *)0xFFC04508);
		debugfs_create_x16("HMDMA0_BCOUNT", 0600, parent, (u16 *)0xFFC04518);
		debugfs_create_x16("HMDMA0_CONTROL", 0600, parent, (u16 *)0xFFC04500);
		debugfs_create_x16("HMDMA0_ECINIT", 0600, parent, (u16 *)0xFFC04504);
		debugfs_create_x16("HMDMA0_ECOUNT", 0600, parent, (u16 *)0xFFC04514);
		debugfs_create_x16("HMDMA0_ECOVERFLOW", 0600, parent, (u16 *)0xFFC04510);
		debugfs_create_x16("HMDMA0_ECURGENT", 0600, parent, (u16 *)0xFFC0450C);
		debugfs_create_x16("HMDMA1_BCINIT", 0600, parent, (u16 *)0xFFC04548);
		debugfs_create_x16("HMDMA1_BCOUNT", 0600, parent, (u16 *)0xFFC04558);
		debugfs_create_x16("HMDMA1_CONTROL", 0600, parent, (u16 *)0xFFC04540);
		debugfs_create_x16("HMDMA1_ECINIT", 0600, parent, (u16 *)0xFFC04544);
		debugfs_create_x16("HMDMA1_ECOUNT", 0600, parent, (u16 *)0xFFC04554);
		debugfs_create_x16("HMDMA1_ECOVERFLOW", 0600, parent, (u16 *)0xFFC04550);
		debugfs_create_x16("HMDMA1_ECURGENT", 0600, parent, (u16 *)0xFFC0454C);

		parent = debugfs_create_dir("HOSTDP", top);
		debugfs_create_x16("HOST_CONTROL", 0600, parent, (u16 *)0xFFC03A00);
		debugfs_create_x16("HOST_STATUS", 0600, parent, (u16 *)0xFFC03A04);
		debugfs_create_x16("HOST_TIMEOUT", 0600, parent, (u16 *)0xFFC03A08);

		parent = debugfs_create_dir("Interrupt Controller", top);
		debugfs_create_x32("ILAT", 0600, parent, (u32 *)0xFFE0210C);
		debugfs_create_x32("IMASK", 0600, parent, (u32 *)0xFFE02104);
		debugfs_create_x32("IPEND", 0600, parent, (u32 *)0xFFE02108);
		debugfs_create_x32("IPRIO", 0600, parent, (u32 *)0xFFE02110);

		parent = debugfs_create_dir("L1 Code Memory Registers", top);
		debugfs_create_x32("ICPLB_ADDR0", 0600, parent, (u32 *)0xFFE01100);
		debugfs_create_x32("ICPLB_ADDR10", 0600, parent, (u32 *)0xFFE01128);
		debugfs_create_x32("ICPLB_ADDR11", 0600, parent, (u32 *)0xFFE0112C);
		debugfs_create_x32("ICPLB_ADDR12", 0600, parent, (u32 *)0xFFE01130);
		debugfs_create_x32("ICPLB_ADDR13", 0600, parent, (u32 *)0xFFE01134);
		debugfs_create_x32("ICPLB_ADDR14", 0600, parent, (u32 *)0xFFE01138);
		debugfs_create_x32("ICPLB_ADDR15", 0600, parent, (u32 *)0xFFE0113C);
		debugfs_create_x32("ICPLB_ADDR1", 0600, parent, (u32 *)0xFFE01104);
		debugfs_create_x32("ICPLB_ADDR2", 0600, parent, (u32 *)0xFFE01108);
		debugfs_create_x32("ICPLB_ADDR3", 0600, parent, (u32 *)0xFFE0110C);
		debugfs_create_x32("ICPLB_ADDR4", 0600, parent, (u32 *)0xFFE01110);
		debugfs_create_x32("ICPLB_ADDR5", 0600, parent, (u32 *)0xFFE01114);
		debugfs_create_x32("ICPLB_ADDR6", 0600, parent, (u32 *)0xFFE01118);
		debugfs_create_x32("ICPLB_ADDR7", 0600, parent, (u32 *)0xFFE0111C);
		debugfs_create_x32("ICPLB_ADDR8", 0600, parent, (u32 *)0xFFE01120);
		debugfs_create_x32("ICPLB_ADDR9", 0600, parent, (u32 *)0xFFE01124);
		debugfs_create_x32("ICPLB_DATA0", 0600, parent, (u32 *)0xFFE01200);
		debugfs_create_x32("ICPLB_DATA10", 0600, parent, (u32 *)0xFFE01228);
		debugfs_create_x32("ICPLB_DATA11", 0600, parent, (u32 *)0xFFE0122C);
		debugfs_create_x32("ICPLB_DATA12", 0600, parent, (u32 *)0xFFE01230);
		debugfs_create_x32("ICPLB_DATA13", 0600, parent, (u32 *)0xFFE01234);
		debugfs_create_x32("ICPLB_DATA14", 0600, parent, (u32 *)0xFFE01238);
		debugfs_create_x32("ICPLB_DATA15", 0600, parent, (u32 *)0xFFE0123C);
		debugfs_create_x32("ICPLB_DATA1", 0600, parent, (u32 *)0xFFE01204);
		debugfs_create_x32("ICPLB_DATA2", 0600, parent, (u32 *)0xFFE01208);
		debugfs_create_x32("ICPLB_DATA3", 0600, parent, (u32 *)0xFFE0120C);
		debugfs_create_x32("ICPLB_DATA4", 0600, parent, (u32 *)0xFFE01210);
		debugfs_create_x32("ICPLB_DATA5", 0600, parent, (u32 *)0xFFE01214);
		debugfs_create_x32("ICPLB_DATA6", 0600, parent, (u32 *)0xFFE01218);
		debugfs_create_x32("ICPLB_DATA7", 0600, parent, (u32 *)0xFFE0121C);
		debugfs_create_x32("ICPLB_DATA8", 0600, parent, (u32 *)0xFFE01220);
		debugfs_create_x32("ICPLB_DATA9", 0600, parent, (u32 *)0xFFE01224);
		debugfs_create_x32("ICPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0100C);
		debugfs_create_x32("ICPLB_STATUS", 0600, parent, (u32 *)0xFFE01008);
		debugfs_create_x32("IMEM_CONTROL", 0600, parent, (u32 *)0xFFE01004);
		debugfs_create_x32("ITEST_COMMAND", 0600, parent, (u32 *)0xFFE01300);
		debugfs_create_x32("ITEST_DATA0", 0600, parent, (u32 *)0xFFE01400);
		debugfs_create_x32("ITEST_DATA1", 0600, parent, (u32 *)0xFFE01404);

		parent = debugfs_create_dir("L1 Data Memory Registers", top);
		debugfs_create_x32("DCPLB_ADDR0", 0600, parent, (u32 *)0xFFE00100);
		debugfs_create_x32("DCPLB_ADDR10", 0600, parent, (u32 *)0xFFE00128);
		debugfs_create_x32("DCPLB_ADDR11", 0600, parent, (u32 *)0xFFE0012C);
		debugfs_create_x32("DCPLB_ADDR12", 0600, parent, (u32 *)0xFFE00130);
		debugfs_create_x32("DCPLB_ADDR13", 0600, parent, (u32 *)0xFFE00134);
		debugfs_create_x32("DCPLB_ADDR14", 0600, parent, (u32 *)0xFFE00138);
		debugfs_create_x32("DCPLB_ADDR15", 0600, parent, (u32 *)0xFFE0013C);
		debugfs_create_x32("DCPLB_ADDR1", 0600, parent, (u32 *)0xFFE00104);
		debugfs_create_x32("DCPLB_ADDR2", 0600, parent, (u32 *)0xFFE00108);
		debugfs_create_x32("DCPLB_ADDR3", 0600, parent, (u32 *)0xFFE0010C);
		debugfs_create_x32("DCPLB_ADDR4", 0600, parent, (u32 *)0xFFE00110);
		debugfs_create_x32("DCPLB_ADDR5", 0600, parent, (u32 *)0xFFE00114);
		debugfs_create_x32("DCPLB_ADDR6", 0600, parent, (u32 *)0xFFE00118);
		debugfs_create_x32("DCPLB_ADDR7", 0600, parent, (u32 *)0xFFE0011C);
		debugfs_create_x32("DCPLB_ADDR8", 0600, parent, (u32 *)0xFFE00120);
		debugfs_create_x32("DCPLB_ADDR9", 0600, parent, (u32 *)0xFFE00124);
		debugfs_create_x32("DCPLB_DATA0", 0600, parent, (u32 *)0xFFE00200);
		debugfs_create_x32("DCPLB_DATA10", 0600, parent, (u32 *)0xFFE00228);
		debugfs_create_x32("DCPLB_DATA11", 0600, parent, (u32 *)0xFFE0022C);
		debugfs_create_x32("DCPLB_DATA12", 0600, parent, (u32 *)0xFFE00230);
		debugfs_create_x32("DCPLB_DATA13", 0600, parent, (u32 *)0xFFE00234);
		debugfs_create_x32("DCPLB_DATA14", 0600, parent, (u32 *)0xFFE00238);
		debugfs_create_x32("DCPLB_DATA15", 0600, parent, (u32 *)0xFFE0023C);
		debugfs_create_x32("DCPLB_DATA1", 0600, parent, (u32 *)0xFFE00204);
		debugfs_create_x32("DCPLB_DATA2", 0600, parent, (u32 *)0xFFE00208);
		debugfs_create_x32("DCPLB_DATA3", 0600, parent, (u32 *)0xFFE0020C);
		debugfs_create_x32("DCPLB_DATA4", 0600, parent, (u32 *)0xFFE00210);
		debugfs_create_x32("DCPLB_DATA5", 0600, parent, (u32 *)0xFFE00214);
		debugfs_create_x32("DCPLB_DATA6", 0600, parent, (u32 *)0xFFE00218);
		debugfs_create_x32("DCPLB_DATA7", 0600, parent, (u32 *)0xFFE0021C);
		debugfs_create_x32("DCPLB_DATA8", 0600, parent, (u32 *)0xFFE00220);
		debugfs_create_x32("DCPLB_DATA9", 0600, parent, (u32 *)0xFFE00224);
		debugfs_create_x32("DCPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0000C);
		debugfs_create_x32("DCPLB_STATUS", 0600, parent, (u32 *)0xFFE00008);
		debugfs_create_x32("DMEM_CONTROL", 0600, parent, (u32 *)0xFFE00004);
		debugfs_create_x32("DTEST_COMMAND", 0600, parent, (u32 *)0xFFE00300);
		debugfs_create_x32("DTEST_DATA0", 0600, parent, (u32 *)0xFFE00400);
		debugfs_create_x32("DTEST_DATA1", 0600, parent, (u32 *)0xFFE00404);
		debugfs_create_x32("SRAM_BASE_ADDR", 0600, parent, (u32 *)0xFFE00000);

		parent = debugfs_create_dir("MDMA", top);
		debugfs_create_x16("MDMA_D0_CONFIG", 0600, parent, (u16 *)0xFFC00F08);
		debugfs_create_x32("MDMA_D0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F24);
		debugfs_create_x32("MDMA_D0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F20);
		debugfs_create_x16("MDMA_D0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F30);
		debugfs_create_x16("MDMA_D0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F38);
		debugfs_create_x16("MDMA_D0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F28);
		debugfs_create_x32("MDMA_D0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F00);
		debugfs_create_x16("MDMA_D0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F2C);
		debugfs_create_x32("MDMA_D0_START_ADDR", 0600, parent, (u32 *)0xFFC00F04);
		debugfs_create_x16("MDMA_D0_X_COUNT", 0600, parent, (u16 *)0xFFC00F10);
		debugfs_create_x16("MDMA_D0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F14);
		debugfs_create_x16("MDMA_D0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F18);
		debugfs_create_x16("MDMA_D0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F1C);
		debugfs_create_x16("MDMA_D1_CONFIG", 0600, parent, (u16 *)0xFFC00F88);
		debugfs_create_x32("MDMA_D1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FA4);
		debugfs_create_x32("MDMA_D1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FA0);
		debugfs_create_x16("MDMA_D1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FB0);
		debugfs_create_x16("MDMA_D1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FB8);
		debugfs_create_x16("MDMA_D1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FA8);
		debugfs_create_x32("MDMA_D1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F80);
		debugfs_create_x16("MDMA_D1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FAC);
		debugfs_create_x32("MDMA_D1_START_ADDR", 0600, parent, (u32 *)0xFFC00F84);
		debugfs_create_x16("MDMA_D1_X_COUNT", 0600, parent, (u16 *)0xFFC00F90);
		debugfs_create_x16("MDMA_D1_X_MODIFY", 0600, parent, (u16 *)0xFFC00F94);
		debugfs_create_x16("MDMA_D1_Y_COUNT", 0600, parent, (u16 *)0xFFC00F98);
		debugfs_create_x16("MDMA_D1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F9C);
		debugfs_create_x16("MDMA_D2_CONFIG", 0600, parent, (u16 *)0xFFC01F08);
		debugfs_create_x32("MDMA_D2_CURR_ADDR", 0600, parent, (u32 *)0xFFC01F24);
		debugfs_create_x32("MDMA_D2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01F20);
		debugfs_create_x16("MDMA_D2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01F30);
		debugfs_create_x16("MDMA_D2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01F38);
		debugfs_create_x16("MDMA_D2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01F28);
		debugfs_create_x32("MDMA_D2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01F00);
		debugfs_create_x16("MDMA_D2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01F2C);
		debugfs_create_x32("MDMA_D2_START_ADDR", 0600, parent, (u32 *)0xFFC01F04);
		debugfs_create_x16("MDMA_D2_X_COUNT", 0600, parent, (u16 *)0xFFC01F10);
		debugfs_create_x16("MDMA_D2_X_MODIFY", 0600, parent, (u16 *)0xFFC01F14);
		debugfs_create_x16("MDMA_D2_Y_COUNT", 0600, parent, (u16 *)0xFFC01F18);
		debugfs_create_x16("MDMA_D2_Y_MODIFY", 0600, parent, (u16 *)0xFFC01F1C);
		debugfs_create_x16("MDMA_D3_CONFIG", 0600, parent, (u16 *)0xFFC01F88);
		debugfs_create_x32("MDMA_D3_CURR_ADDR", 0600, parent, (u32 *)0xFFC01FA4);
		debugfs_create_x32("MDMA_D3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01FA0);
		debugfs_create_x16("MDMA_D3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01FB0);
		debugfs_create_x16("MDMA_D3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01FB8);
		debugfs_create_x16("MDMA_D3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01FA8);
		debugfs_create_x32("MDMA_D3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01F80);
		debugfs_create_x16("MDMA_D3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01FAC);
		debugfs_create_x32("MDMA_D3_START_ADDR", 0600, parent, (u32 *)0xFFC01F84);
		debugfs_create_x16("MDMA_D3_X_COUNT", 0600, parent, (u16 *)0xFFC01F90);
		debugfs_create_x16("MDMA_D3_X_MODIFY", 0600, parent, (u16 *)0xFFC01F94);
		debugfs_create_x16("MDMA_D3_Y_COUNT", 0600, parent, (u16 *)0xFFC01F98);
		debugfs_create_x16("MDMA_D3_Y_MODIFY", 0600, parent, (u16 *)0xFFC01F9C);
		debugfs_create_x16("MDMA_S0_CONFIG", 0600, parent, (u16 *)0xFFC00F48);
		debugfs_create_x32("MDMA_S0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F64);
		debugfs_create_x32("MDMA_S0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F60);
		debugfs_create_x16("MDMA_S0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F70);
		debugfs_create_x16("MDMA_S0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F78);
		debugfs_create_x16("MDMA_S0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F68);
		debugfs_create_x32("MDMA_S0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F40);
		debugfs_create_x16("MDMA_S0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F6C);
		debugfs_create_x32("MDMA_S0_START_ADDR", 0600, parent, (u32 *)0xFFC00F44);
		debugfs_create_x16("MDMA_S0_X_COUNT", 0600, parent, (u16 *)0xFFC00F50);
		debugfs_create_x16("MDMA_S0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F54);
		debugfs_create_x16("MDMA_S0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F58);
		debugfs_create_x16("MDMA_S0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F5C);
		debugfs_create_x16("MDMA_S1_CONFIG", 0600, parent, (u16 *)0xFFC00FC8);
		debugfs_create_x32("MDMA_S1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FE4);
		debugfs_create_x32("MDMA_S1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FE0);
		debugfs_create_x16("MDMA_S1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FF0);
		debugfs_create_x16("MDMA_S1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FF8);
		debugfs_create_x16("MDMA_S1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FE8);
		debugfs_create_x32("MDMA_S1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00FC0);
		debugfs_create_x16("MDMA_S1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FEC);
		debugfs_create_x32("MDMA_S1_START_ADDR", 0600, parent, (u32 *)0xFFC00FC4);
		debugfs_create_x16("MDMA_S1_X_COUNT", 0600, parent, (u16 *)0xFFC00FD0);
		debugfs_create_x16("MDMA_S1_X_MODIFY", 0600, parent, (u16 *)0xFFC00FD4);
		debugfs_create_x16("MDMA_S1_Y_COUNT", 0600, parent, (u16 *)0xFFC00FD8);
		debugfs_create_x16("MDMA_S1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00FDC);
		debugfs_create_x16("MDMA_S2_CONFIG", 0600, parent, (u16 *)0xFFC01F48);
		debugfs_create_x32("MDMA_S2_CURR_ADDR", 0600, parent, (u32 *)0xFFC01F64);
		debugfs_create_x32("MDMA_S2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01F60);
		debugfs_create_x16("MDMA_S2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01F70);
		debugfs_create_x16("MDMA_S2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01F78);
		debugfs_create_x16("MDMA_S2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01F68);
		debugfs_create_x32("MDMA_S2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01F40);
		debugfs_create_x16("MDMA_S2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01F6C);
		debugfs_create_x32("MDMA_S2_START_ADDR", 0600, parent, (u32 *)0xFFC01F44);
		debugfs_create_x16("MDMA_S2_X_COUNT", 0600, parent, (u16 *)0xFFC01F50);
		debugfs_create_x16("MDMA_S2_X_MODIFY", 0600, parent, (u16 *)0xFFC01F54);
		debugfs_create_x16("MDMA_S2_Y_COUNT", 0600, parent, (u16 *)0xFFC01F58);
		debugfs_create_x16("MDMA_S2_Y_MODIFY", 0600, parent, (u16 *)0xFFC01F5C);
		debugfs_create_x16("MDMA_S3_CONFIG", 0600, parent, (u16 *)0xFFC01FC8);
		debugfs_create_x32("MDMA_S3_CURR_ADDR", 0600, parent, (u32 *)0xFFC01FE4);
		debugfs_create_x32("MDMA_S3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01FE0);
		debugfs_create_x16("MDMA_S3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01FF0);
		debugfs_create_x16("MDMA_S3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01FF8);
		debugfs_create_x16("MDMA_S3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01FE8);
		debugfs_create_x32("MDMA_S3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01FC0);
		debugfs_create_x16("MDMA_S3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01FEC);
		debugfs_create_x32("MDMA_S3_START_ADDR", 0600, parent, (u32 *)0xFFC01FC4);
		debugfs_create_x16("MDMA_S3_X_COUNT", 0600, parent, (u16 *)0xFFC01FD0);
		debugfs_create_x16("MDMA_S3_X_MODIFY", 0600, parent, (u16 *)0xFFC01FD4);
		debugfs_create_x16("MDMA_S3_Y_COUNT", 0600, parent, (u16 *)0xFFC01FD8);
		debugfs_create_x16("MDMA_S3_Y_MODIFY", 0600, parent, (u16 *)0xFFC01FDC);

		parent = debugfs_create_dir("NFC", top);
		debugfs_create_x16("NFC_ADDR", 0600, parent, (u16 *)0xFFC03B40);
		debugfs_create_x16("NFC_CMD", 0600, parent, (u16 *)0xFFC03B44);
		debugfs_create_x16("NFC_COUNT", 0600, parent, (u16 *)0xFFC03B20);
		debugfs_create_x16("NFC_CTL", 0600, parent, (u16 *)0xFFC03B00);
		debugfs_create_x16("NFC_DATA_RD", 0600, parent, (u16 *)0xFFC03B4C);
		debugfs_create_x16("NFC_DATA_WR", 0600, parent, (u16 *)0xFFC03B48);
		debugfs_create_x16("NFC_ECC0", 0600, parent, (u16 *)0xFFC03B10);
		debugfs_create_x16("NFC_ECC1", 0600, parent, (u16 *)0xFFC03B14);
		debugfs_create_x16("NFC_ECC2", 0600, parent, (u16 *)0xFFC03B18);
		debugfs_create_x16("NFC_ECC3", 0600, parent, (u16 *)0xFFC03B1C);
		debugfs_create_x16("NFC_IRQMASK", 0600, parent, (u16 *)0xFFC03B0C);
		debugfs_create_x16("NFC_IRQSTAT", 0600, parent, (u16 *)0xFFC03B08);
		debugfs_create_x16("NFC_PGCTL", 0600, parent, (u16 *)0xFFC03B28);
		debugfs_create_x16("NFC_READ", 0600, parent, (u16 *)0xFFC03B2C);
		debugfs_create_x16("NFC_RST", 0600, parent, (u16 *)0xFFC03B24);
		debugfs_create_x16("NFC_STAT", 0600, parent, (u16 *)0xFFC03B04);

		parent = debugfs_create_dir("OTP", top);
		debugfs_create_x16("OTP_BEN", 0600, parent, (u16 *)0xFFC04304);
		debugfs_create_x16("OTP_CONTROL", 0600, parent, (u16 *)0xFFC04300);
		debugfs_create_x32("OTP_DATA0", 0600, parent, (u32 *)0xFFC04380);
		debugfs_create_x32("OTP_DATA1", 0600, parent, (u32 *)0xFFC04384);
		debugfs_create_x32("OTP_DATA2", 0600, parent, (u32 *)0xFFC04388);
		debugfs_create_x32("OTP_DATA3", 0600, parent, (u32 *)0xFFC0438C);
		debugfs_create_x16("OTP_STATUS", 0600, parent, (u16 *)0xFFC04308);
		debugfs_create_x32("OTP_TIMING", 0600, parent, (u32 *)0xFFC0430C);

		parent = debugfs_create_dir("PINT_0", top);
		debugfs_create_x32("PINT0_ASSIGN", 0600, parent, (u32 *)0xFFC0140C);
		debugfs_create_x32("PINT0_EDGE_CLEAR", 0600, parent, (u32 *)0xFFC01414);
		debugfs_create_x32("PINT0_EDGE_SET", 0600, parent, (u32 *)0xFFC01410);
		debugfs_create_x32("PINT0_INVERT_CLEAR", 0600, parent, (u32 *)0xFFC0141C);
		debugfs_create_x32("PINT0_INVERT_SET", 0600, parent, (u32 *)0xFFC01418);
		debugfs_create_x32("PINT0_IRQ", 0600, parent, (u32 *)0xFFC01408);
		debugfs_create_x32("PINT0_LATCH", 0600, parent, (u32 *)0xFFC01424);
		debugfs_create_x32("PINT0_MASK_CLEAR", 0600, parent, (u32 *)0xFFC01404);
		debugfs_create_x32("PINT0_MASK_SET", 0600, parent, (u32 *)0xFFC01400);
		debugfs_create_x32("PINT0_PINSTATE", 0600, parent, (u32 *)0xFFC01420);

		parent = debugfs_create_dir("PINT_1", top);
		debugfs_create_x32("PINT1_ASSIGN", 0600, parent, (u32 *)0xFFC0143C);
		debugfs_create_x32("PINT1_EDGE_CLEAR", 0600, parent, (u32 *)0xFFC01444);
		debugfs_create_x32("PINT1_EDGE_SET", 0600, parent, (u32 *)0xFFC01440);
		debugfs_create_x32("PINT1_INVERT_CLEAR", 0600, parent, (u32 *)0xFFC0144C);
		debugfs_create_x32("PINT1_INVERT_SET", 0600, parent, (u32 *)0xFFC01448);
		debugfs_create_x32("PINT1_IRQ", 0600, parent, (u32 *)0xFFC01438);
		debugfs_create_x32("PINT1_LATCH", 0600, parent, (u32 *)0xFFC01454);
		debugfs_create_x32("PINT1_MASK_CLEAR", 0600, parent, (u32 *)0xFFC01434);
		debugfs_create_x32("PINT1_MASK_SET", 0600, parent, (u32 *)0xFFC01430);
		debugfs_create_x32("PINT1_PINSTATE", 0600, parent, (u32 *)0xFFC01450);

		parent = debugfs_create_dir("PINT_2", top);
		debugfs_create_x32("PINT2_ASSIGN", 0600, parent, (u32 *)0xFFC0146C);
		debugfs_create_x32("PINT2_EDGE_CLEAR", 0600, parent, (u32 *)0xFFC01474);
		debugfs_create_x32("PINT2_EDGE_SET", 0600, parent, (u32 *)0xFFC01470);
		debugfs_create_x32("PINT2_INVERT_CLEAR", 0600, parent, (u32 *)0xFFC0147C);
		debugfs_create_x32("PINT2_INVERT_SET", 0600, parent, (u32 *)0xFFC01478);
		debugfs_create_x32("PINT2_IRQ", 0600, parent, (u32 *)0xFFC01468);
		debugfs_create_x32("PINT2_LATCH", 0600, parent, (u32 *)0xFFC01484);
		debugfs_create_x32("PINT2_MASK_CLEAR", 0600, parent, (u32 *)0xFFC01464);
		debugfs_create_x32("PINT2_MASK_SET", 0600, parent, (u32 *)0xFFC01460);
		debugfs_create_x32("PINT2_PINSTATE", 0600, parent, (u32 *)0xFFC01480);

		parent = debugfs_create_dir("PINT_3", top);
		debugfs_create_x32("PINT3_ASSIGN", 0600, parent, (u32 *)0xFFC0149C);
		debugfs_create_x32("PINT3_EDGE_CLEAR", 0600, parent, (u32 *)0xFFC014A4);
		debugfs_create_x32("PINT3_EDGE_SET", 0600, parent, (u32 *)0xFFC014A0);
		debugfs_create_x32("PINT3_INVERT_CLEAR", 0600, parent, (u32 *)0xFFC014AC);
		debugfs_create_x32("PINT3_INVERT_SET", 0600, parent, (u32 *)0xFFC014A8);
		debugfs_create_x32("PINT3_IRQ", 0600, parent, (u32 *)0xFFC01498);
		debugfs_create_x32("PINT3_LATCH", 0600, parent, (u32 *)0xFFC014B4);
		debugfs_create_x32("PINT3_MASK_CLEAR", 0600, parent, (u32 *)0xFFC01494);
		debugfs_create_x32("PINT3_MASK_SET", 0600, parent, (u32 *)0xFFC01490);
		debugfs_create_x32("PINT3_PINSTATE", 0600, parent, (u32 *)0xFFC014B0);

		parent = debugfs_create_dir("PIXC", top);
		debugfs_create_x16("PIXC_AHEND", 0600, parent, (u16 *)0xFFC04410);
		debugfs_create_x16("PIXC_AHSTART", 0600, parent, (u16 *)0xFFC0440C);
		debugfs_create_x16("PIXC_ATRANSP", 0600, parent, (u16 *)0xFFC0441C);
		debugfs_create_x16("PIXC_AVEND", 0600, parent, (u16 *)0xFFC04418);
		debugfs_create_x16("PIXC_AVSTART", 0600, parent, (u16 *)0xFFC04414);
		debugfs_create_x16("PIXC_BHEND", 0600, parent, (u16 *)0xFFC04424);
		debugfs_create_x16("PIXC_BHSTART", 0600, parent, (u16 *)0xFFC04420);
		debugfs_create_x16("PIXC_BTRANSP", 0600, parent, (u16 *)0xFFC04430);
		debugfs_create_x32("PIXC_BVCON", 0600, parent, (u32 *)0xFFC04448);
		debugfs_create_x16("PIXC_BVEND", 0600, parent, (u16 *)0xFFC0442C);
		debugfs_create_x16("PIXC_BVSTART", 0600, parent, (u16 *)0xFFC04428);
		debugfs_create_x32("PIXC_CCBIAS", 0600, parent, (u32 *)0xFFC0444C);
		debugfs_create_x16("PIXC_CTL", 0600, parent, (u16 *)0xFFC04400);
		debugfs_create_x32("PIXC_GUCON", 0600, parent, (u32 *)0xFFC04444);
		debugfs_create_x16("PIXC_INTRSTAT", 0600, parent, (u16 *)0xFFC0443C);
		debugfs_create_x16("PIXC_LPF", 0600, parent, (u16 *)0xFFC04408);
		debugfs_create_x16("PIXC_PPL", 0600, parent, (u16 *)0xFFC04404);
		debugfs_create_x32("PIXC_RYCON", 0600, parent, (u32 *)0xFFC04440);
		debugfs_create_x32("PIXC_TC", 0600, parent, (u32 *)0xFFC04450);

		parent = debugfs_create_dir("PLL", top);
		debugfs_create_x16("PLL_CTL", 0600, parent, (u16 *)0xFFC00000);
		debugfs_create_x16("PLL_DIV", 0600, parent, (u16 *)0xFFC00004);
		debugfs_create_x16("PLL_LOCKCNT", 0600, parent, (u16 *)0xFFC00010);
		debugfs_create_x16("PLL_STAT", 0600, parent, (u16 *)0xFFC0000C);
		debugfs_create_x16("VR_CTL", 0600, parent, (u16 *)0xFFC00008);

		parent = debugfs_create_dir("PWM_TMR", top);
		debugfs_create_x16("TIMER0_CONFIG", 0600, parent, (u16 *)0xFFC01600);
		debugfs_create_x32("TIMER0_COUNTER", 0600, parent, (u32 *)0xFFC01604);
		debugfs_create_x32("TIMER0_PERIOD", 0600, parent, (u32 *)0xFFC01608);
		debugfs_create_x32("TIMER0_WIDTH", 0600, parent, (u32 *)0xFFC0160C);
		debugfs_create_x16("TIMER10_CONFIG", 0600, parent, (u16 *)0xFFC00620);
		debugfs_create_x32("TIMER10_COUNTER", 0600, parent, (u32 *)0xFFC00624);
		debugfs_create_x32("TIMER10_PERIOD", 0600, parent, (u32 *)0xFFC00628);
		debugfs_create_x32("TIMER10_WIDTH", 0600, parent, (u32 *)0xFFC0062C);
		debugfs_create_x16("TIMER1_CONFIG", 0600, parent, (u16 *)0xFFC01610);
		debugfs_create_x32("TIMER1_COUNTER", 0600, parent, (u32 *)0xFFC01614);
		debugfs_create_x32("TIMER1_PERIOD", 0600, parent, (u32 *)0xFFC01618);
		debugfs_create_x32("TIMER1_WIDTH", 0600, parent, (u32 *)0xFFC0161C);
		debugfs_create_x16("TIMER2_CONFIG", 0600, parent, (u16 *)0xFFC01620);
		debugfs_create_x32("TIMER2_COUNTER", 0600, parent, (u32 *)0xFFC01624);
		debugfs_create_x32("TIMER2_PERIOD", 0600, parent, (u32 *)0xFFC01628);
		debugfs_create_x32("TIMER2_WIDTH", 0600, parent, (u32 *)0xFFC0162C);
		debugfs_create_x16("TIMER3_CONFIG", 0600, parent, (u16 *)0xFFC01630);
		debugfs_create_x32("TIMER3_COUNTER", 0600, parent, (u32 *)0xFFC01634);
		debugfs_create_x32("TIMER3_PERIOD", 0600, parent, (u32 *)0xFFC01638);
		debugfs_create_x32("TIMER3_WIDTH", 0600, parent, (u32 *)0xFFC0163C);
		debugfs_create_x16("TIMER4_CONFIG", 0600, parent, (u16 *)0xFFC01640);
		debugfs_create_x32("TIMER4_COUNTER", 0600, parent, (u32 *)0xFFC01644);
		debugfs_create_x32("TIMER4_PERIOD", 0600, parent, (u32 *)0xFFC01648);
		debugfs_create_x32("TIMER4_WIDTH", 0600, parent, (u32 *)0xFFC0164C);
		debugfs_create_x16("TIMER5_CONFIG", 0600, parent, (u16 *)0xFFC01650);
		debugfs_create_x32("TIMER5_COUNTER", 0600, parent, (u32 *)0xFFC01654);
		debugfs_create_x32("TIMER5_PERIOD", 0600, parent, (u32 *)0xFFC01658);
		debugfs_create_x32("TIMER5_WIDTH", 0600, parent, (u32 *)0xFFC0165C);
		debugfs_create_x16("TIMER6_CONFIG", 0600, parent, (u16 *)0xFFC01660);
		debugfs_create_x32("TIMER6_COUNTER", 0600, parent, (u32 *)0xFFC01664);
		debugfs_create_x32("TIMER6_PERIOD", 0600, parent, (u32 *)0xFFC01668);
		debugfs_create_x32("TIMER6_WIDTH", 0600, parent, (u32 *)0xFFC0166C);
		debugfs_create_x16("TIMER7_CONFIG", 0600, parent, (u16 *)0xFFC01670);
		debugfs_create_x32("TIMER7_COUNTER", 0600, parent, (u32 *)0xFFC01674);
		debugfs_create_x32("TIMER7_PERIOD", 0600, parent, (u32 *)0xFFC01678);
		debugfs_create_x32("TIMER7_WIDTH", 0600, parent, (u32 *)0xFFC0167C);
		debugfs_create_x16("TIMER8_CONFIG", 0600, parent, (u16 *)0xFFC00600);
		debugfs_create_x32("TIMER8_COUNTER", 0600, parent, (u32 *)0xFFC00604);
		debugfs_create_x32("TIMER8_PERIOD", 0600, parent, (u32 *)0xFFC00608);
		debugfs_create_x32("TIMER8_WIDTH", 0600, parent, (u32 *)0xFFC0060C);
		debugfs_create_x16("TIMER9_CONFIG", 0600, parent, (u16 *)0xFFC00610);
		debugfs_create_x32("TIMER9_COUNTER", 0600, parent, (u32 *)0xFFC00614);
		debugfs_create_x32("TIMER9_PERIOD", 0600, parent, (u32 *)0xFFC00618);
		debugfs_create_x32("TIMER9_WIDTH", 0600, parent, (u32 *)0xFFC0061C);
		debugfs_create_x16("TIMER_DISABLE0", 0600, parent, (u16 *)0xFFC01684);
		debugfs_create_x16("TIMER_DISABLE1", 0600, parent, (u16 *)0xFFC00644);
		debugfs_create_x16("TIMER_ENABLE0", 0600, parent, (u16 *)0xFFC01680);
		debugfs_create_x16("TIMER_ENABLE1", 0600, parent, (u16 *)0xFFC00640);
		debugfs_create_x32("TIMER_STATUS0", 0600, parent, (u32 *)0xFFC01688);
		debugfs_create_x32("TIMER_STATUS1", 0600, parent, (u32 *)0xFFC00648);

		parent = debugfs_create_dir("Port_A", top);
		debugfs_create_x16("PORTA", 0600, parent, (u16 *)0xFFC014C4);
		debugfs_create_x16("PORTA_CLEAR", 0600, parent, (u16 *)0xFFC014CC);
		debugfs_create_x16("PORTA_DIR_CLEAR", 0600, parent, (u16 *)0xFFC014D4);
		debugfs_create_x16("PORTA_DIR_SET", 0600, parent, (u16 *)0xFFC014D0);
		debugfs_create_x16("PORTA_FER", 0600, parent, (u16 *)0xFFC014C0);
		debugfs_create_x16("PORTA_INEN", 0600, parent, (u16 *)0xFFC014D8);
		debugfs_create_x32("PORTA_MUX", 0600, parent, (u32 *)0xFFC014DC);
		debugfs_create_x16("PORTA_SET", 0600, parent, (u16 *)0xFFC014C8);

		parent = debugfs_create_dir("Port_B", top);
		debugfs_create_x16("PORTB", 0600, parent, (u16 *)0xFFC014E4);
		debugfs_create_x16("PORTB_CLEAR", 0600, parent, (u16 *)0xFFC014EC);
		debugfs_create_x16("PORTB_DIR_CLEAR", 0600, parent, (u16 *)0xFFC014F4);
		debugfs_create_x16("PORTB_DIR_SET", 0600, parent, (u16 *)0xFFC014F0);
		debugfs_create_x16("PORTB_FER", 0600, parent, (u16 *)0xFFC014E0);
		debugfs_create_x16("PORTB_INEN", 0600, parent, (u16 *)0xFFC014F8);
		debugfs_create_x32("PORTB_MUX", 0600, parent, (u32 *)0xFFC014FC);
		debugfs_create_x16("PORTB_SET", 0600, parent, (u16 *)0xFFC014E8);

		parent = debugfs_create_dir("Port_C", top);
		debugfs_create_x16("PORTC", 0600, parent, (u16 *)0xFFC01504);
		debugfs_create_x16("PORTC_CLEAR", 0600, parent, (u16 *)0xFFC0150C);
		debugfs_create_x16("PORTC_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01514);
		debugfs_create_x16("PORTC_DIR_SET", 0600, parent, (u16 *)0xFFC01510);
		debugfs_create_x16("PORTC_FER", 0600, parent, (u16 *)0xFFC01500);
		debugfs_create_x16("PORTC_INEN", 0600, parent, (u16 *)0xFFC01518);
		debugfs_create_x32("PORTC_MUX", 0600, parent, (u32 *)0xFFC0151C);
		debugfs_create_x16("PORTC_SET", 0600, parent, (u16 *)0xFFC01508);

		parent = debugfs_create_dir("Port_D", top);
		debugfs_create_x16("PORTD", 0600, parent, (u16 *)0xFFC01524);
		debugfs_create_x16("PORTD_CLEAR", 0600, parent, (u16 *)0xFFC0152C);
		debugfs_create_x16("PORTD_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01534);
		debugfs_create_x16("PORTD_DIR_SET", 0600, parent, (u16 *)0xFFC01530);
		debugfs_create_x16("PORTD_FER", 0600, parent, (u16 *)0xFFC01520);
		debugfs_create_x16("PORTD_INEN", 0600, parent, (u16 *)0xFFC01538);
		debugfs_create_x32("PORTD_MUX", 0600, parent, (u32 *)0xFFC0153C);
		debugfs_create_x16("PORTD_SET", 0600, parent, (u16 *)0xFFC01528);

		parent = debugfs_create_dir("Port_E", top);
		debugfs_create_x16("PORTE", 0600, parent, (u16 *)0xFFC01544);
		debugfs_create_x16("PORTE_CLEAR", 0600, parent, (u16 *)0xFFC0154C);
		debugfs_create_x16("PORTE_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01554);
		debugfs_create_x16("PORTE_DIR_SET", 0600, parent, (u16 *)0xFFC01550);
		debugfs_create_x16("PORTE_FER", 0600, parent, (u16 *)0xFFC01540);
		debugfs_create_x16("PORTE_INEN", 0600, parent, (u16 *)0xFFC01558);
		debugfs_create_x32("PORTE_MUX", 0600, parent, (u32 *)0xFFC0155C);
		debugfs_create_x16("PORTE_SET", 0600, parent, (u16 *)0xFFC01548);

		parent = debugfs_create_dir("Port_F", top);
		debugfs_create_x16("PORTF", 0600, parent, (u16 *)0xFFC01564);
		debugfs_create_x16("PORTF_CLEAR", 0600, parent, (u16 *)0xFFC0156C);
		debugfs_create_x16("PORTF_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01574);
		debugfs_create_x16("PORTF_DIR_SET", 0600, parent, (u16 *)0xFFC01570);
		debugfs_create_x16("PORTF_FER", 0600, parent, (u16 *)0xFFC01560);
		debugfs_create_x16("PORTF_INEN", 0600, parent, (u16 *)0xFFC01578);
		debugfs_create_x32("PORTF_MUX", 0600, parent, (u32 *)0xFFC0157C);
		debugfs_create_x16("PORTF_SET", 0600, parent, (u16 *)0xFFC01568);

		parent = debugfs_create_dir("Port_G", top);
		debugfs_create_x16("PORTG", 0600, parent, (u16 *)0xFFC01584);
		debugfs_create_x16("PORTG_CLEAR", 0600, parent, (u16 *)0xFFC0158C);
		debugfs_create_x16("PORTG_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01594);
		debugfs_create_x16("PORTG_DIR_SET", 0600, parent, (u16 *)0xFFC01590);
		debugfs_create_x16("PORTG_FER", 0600, parent, (u16 *)0xFFC01580);
		debugfs_create_x16("PORTG_INEN", 0600, parent, (u16 *)0xFFC01598);
		debugfs_create_x32("PORTG_MUX", 0600, parent, (u32 *)0xFFC0159C);
		debugfs_create_x16("PORTG_SET", 0600, parent, (u16 *)0xFFC01588);

		parent = debugfs_create_dir("Port_H", top);
		debugfs_create_x16("PORTH", 0600, parent, (u16 *)0xFFC015A4);
		debugfs_create_x16("PORTH_CLEAR", 0600, parent, (u16 *)0xFFC015AC);
		debugfs_create_x16("PORTH_DIR_CLEAR", 0600, parent, (u16 *)0xFFC015B4);
		debugfs_create_x16("PORTH_DIR_SET", 0600, parent, (u16 *)0xFFC015B0);
		debugfs_create_x16("PORTH_FER", 0600, parent, (u16 *)0xFFC015A0);
		debugfs_create_x16("PORTH_INEN", 0600, parent, (u16 *)0xFFC015B8);
		debugfs_create_x32("PORTH_MUX", 0600, parent, (u32 *)0xFFC015BC);
		debugfs_create_x16("PORTH_SET", 0600, parent, (u16 *)0xFFC015A8);

		parent = debugfs_create_dir("Port_I", top);
		debugfs_create_x16("PORTI", 0600, parent, (u16 *)0xFFC015C4);
		debugfs_create_x16("PORTI_CLEAR", 0600, parent, (u16 *)0xFFC015CC);
		debugfs_create_x16("PORTI_DIR_CLEAR", 0600, parent, (u16 *)0xFFC015D4);
		debugfs_create_x16("PORTI_DIR_SET", 0600, parent, (u16 *)0xFFC015D0);
		debugfs_create_x16("PORTI_FER", 0600, parent, (u16 *)0xFFC015C0);
		debugfs_create_x16("PORTI_INEN", 0600, parent, (u16 *)0xFFC015D8);
		debugfs_create_x32("PORTI_MUX", 0600, parent, (u32 *)0xFFC015DC);
		debugfs_create_x16("PORTI_SET", 0600, parent, (u16 *)0xFFC015C8);

		parent = debugfs_create_dir("Port_J", top);
		debugfs_create_x16("PORTJ", 0600, parent, (u16 *)0xFFC015E4);
		debugfs_create_x16("PORTJ_CLEAR", 0600, parent, (u16 *)0xFFC015EC);
		debugfs_create_x16("PORTJ_DIR_CLEAR", 0600, parent, (u16 *)0xFFC015F4);
		debugfs_create_x16("PORTJ_DIR_SET", 0600, parent, (u16 *)0xFFC015F0);
		debugfs_create_x16("PORTJ_FER", 0600, parent, (u16 *)0xFFC015E0);
		debugfs_create_x16("PORTJ_INEN", 0600, parent, (u16 *)0xFFC015F8);
		debugfs_create_x32("PORTJ_MUX", 0600, parent, (u32 *)0xFFC015FC);
		debugfs_create_x16("PORTJ_SET", 0600, parent, (u16 *)0xFFC015E8);

		parent = debugfs_create_dir("RTC", top);
		debugfs_create_x32("RTC_ALARM", 0600, parent, (u32 *)0xFFC00310);
		debugfs_create_x16("RTC_ICTL", 0600, parent, (u16 *)0xFFC00304);
		debugfs_create_x16("RTC_ISTAT", 0600, parent, (u16 *)0xFFC00308);
		debugfs_create_x16("RTC_PREN", 0600, parent, (u16 *)0xFFC00314);
		debugfs_create_x32("RTC_STAT", 0600, parent, (u32 *)0xFFC00300);
		debugfs_create_x16("RTC_SWCNT", 0600, parent, (u16 *)0xFFC0030C);

		parent = debugfs_create_dir("SIC", top);
		debugfs_create_x32("SIC_IAR0", 0600, parent, (u32 *)0xFFC00130);
		debugfs_create_x32("SIC_IAR10", 0600, parent, (u32 *)0xFFC00158);
		debugfs_create_x32("SIC_IAR11", 0600, parent, (u32 *)0xFFC0015C);
		debugfs_create_x32("SIC_IAR1", 0600, parent, (u32 *)0xFFC00134);
		debugfs_create_x32("SIC_IAR2", 0600, parent, (u32 *)0xFFC00138);
		debugfs_create_x32("SIC_IAR3", 0600, parent, (u32 *)0xFFC0013C);
		debugfs_create_x32("SIC_IAR4", 0600, parent, (u32 *)0xFFC00140);
		debugfs_create_x32("SIC_IAR5", 0600, parent, (u32 *)0xFFC00144);
		debugfs_create_x32("SIC_IAR6", 0600, parent, (u32 *)0xFFC00148);
		debugfs_create_x32("SIC_IAR7", 0600, parent, (u32 *)0xFFC0014C);
		debugfs_create_x32("SIC_IAR8", 0600, parent, (u32 *)0xFFC00150);
		debugfs_create_x32("SIC_IAR9", 0600, parent, (u32 *)0xFFC00154);
		debugfs_create_x32("SIC_IMASK0", 0600, parent, (u32 *)0xFFC0010C);
		debugfs_create_x32("SIC_IMASK1", 0600, parent, (u32 *)0xFFC00110);
		debugfs_create_x32("SIC_IMASK2", 0600, parent, (u32 *)0xFFC00114);
		debugfs_create_x32("SIC_ISR0", 0600, parent, (u32 *)0xFFC00118);
		debugfs_create_x32("SIC_ISR1", 0600, parent, (u32 *)0xFFC0011C);
		debugfs_create_x32("SIC_ISR2", 0600, parent, (u32 *)0xFFC00120);
		debugfs_create_x32("SIC_IWR0", 0600, parent, (u32 *)0xFFC00124);
		debugfs_create_x32("SIC_IWR1", 0600, parent, (u32 *)0xFFC00128);
		debugfs_create_x32("SIC_IWR2", 0600, parent, (u32 *)0xFFC0012C);

		parent = debugfs_create_dir("SPI", top);
		debugfs_create_x16("SPI0_BAUD", 0600, parent, (u16 *)0xFFC00514);
		debugfs_create_x16("SPI0_CTL", 0600, parent, (u16 *)0xFFC00500);
		debugfs_create_x16("SPI0_FLG", 0600, parent, (u16 *)0xFFC00504);
		debugfs_create_x16("SPI0_RDBR", 0600, parent, (u16 *)0xFFC00510);
		debugfs_create_x16("SPI0_SHADOW", 0600, parent, (u16 *)0xFFC00518);
		debugfs_create_x16("SPI0_STAT", 0600, parent, (u16 *)0xFFC00508);
		debugfs_create_x16("SPI0_TDBR", 0600, parent, (u16 *)0xFFC0050C);
		debugfs_create_x16("SPI1_BAUD", 0600, parent, (u16 *)0xFFC02314);
		debugfs_create_x16("SPI1_CTL", 0600, parent, (u16 *)0xFFC02300);
		debugfs_create_x16("SPI1_FLG", 0600, parent, (u16 *)0xFFC02304);
		debugfs_create_x16("SPI1_RDBR", 0600, parent, (u16 *)0xFFC02310);
		debugfs_create_x16("SPI1_SHADOW", 0600, parent, (u16 *)0xFFC02318);
		debugfs_create_x16("SPI1_STAT", 0600, parent, (u16 *)0xFFC02308);
		debugfs_create_x16("SPI1_TDBR", 0600, parent, (u16 *)0xFFC0230C);

		parent = debugfs_create_dir("SPORT", top);
		debugfs_create_x16("SPORT1_CHNL", 0600, parent, (u16 *)0xFFC00934);
		debugfs_create_x16("SPORT1_MCMC1", 0600, parent, (u16 *)0xFFC00938);
		debugfs_create_x16("SPORT1_MCMC2", 0600, parent, (u16 *)0xFFC0093C);
		debugfs_create_x32("SPORT1_MRCS0", 0600, parent, (u32 *)0xFFC00950);
		debugfs_create_x32("SPORT1_MRCS1", 0600, parent, (u32 *)0xFFC00954);
		debugfs_create_x32("SPORT1_MRCS2", 0600, parent, (u32 *)0xFFC00958);
		debugfs_create_x32("SPORT1_MRCS3", 0600, parent, (u32 *)0xFFC0095C);
		debugfs_create_x32("SPORT1_MTCS0", 0600, parent, (u32 *)0xFFC00940);
		debugfs_create_x32("SPORT1_MTCS1", 0600, parent, (u32 *)0xFFC00944);
		debugfs_create_x32("SPORT1_MTCS2", 0600, parent, (u32 *)0xFFC00948);
		debugfs_create_x32("SPORT1_MTCS3", 0600, parent, (u32 *)0xFFC0094C);
		debugfs_create_x16("SPORT1_RCLKDIV", 0600, parent, (u16 *)0xFFC00928);
		debugfs_create_x16("SPORT1_RCR1", 0600, parent, (u16 *)0xFFC00920);
		debugfs_create_x16("SPORT1_RCR2", 0600, parent, (u16 *)0xFFC00924);
		debugfs_create_x16("SPORT1_RFSDIV", 0600, parent, (u16 *)0xFFC0092C);
		debugfs_create_x32("SPORT1_RX", 0600, parent, (u32 *)0xFFC00918);
		debugfs_create_x16("SPORT1_STAT", 0600, parent, (u16 *)0xFFC00930);
		debugfs_create_x16("SPORT1_TCLKDIV", 0600, parent, (u16 *)0xFFC00908);
		debugfs_create_x16("SPORT1_TCR1", 0600, parent, (u16 *)0xFFC00900);
		debugfs_create_x16("SPORT1_TCR2", 0600, parent, (u16 *)0xFFC00904);
		debugfs_create_x16("SPORT1_TFSDIV", 0600, parent, (u16 *)0xFFC0090C);
		debugfs_create_x32("SPORT1_TX", 0600, parent, (u32 *)0xFFC00910);
		debugfs_create_x16("SPORT2_CHNL", 0600, parent, (u16 *)0xFFC02534);
		debugfs_create_x16("SPORT2_MCMC1", 0600, parent, (u16 *)0xFFC02538);
		debugfs_create_x16("SPORT2_MCMC2", 0600, parent, (u16 *)0xFFC0253C);
		debugfs_create_x32("SPORT2_MRCS0", 0600, parent, (u32 *)0xFFC02550);
		debugfs_create_x32("SPORT2_MRCS1", 0600, parent, (u32 *)0xFFC02554);
		debugfs_create_x32("SPORT2_MRCS2", 0600, parent, (u32 *)0xFFC02558);
		debugfs_create_x32("SPORT2_MRCS3", 0600, parent, (u32 *)0xFFC0255C);
		debugfs_create_x32("SPORT2_MTCS0", 0600, parent, (u32 *)0xFFC02540);
		debugfs_create_x32("SPORT2_MTCS1", 0600, parent, (u32 *)0xFFC02544);
		debugfs_create_x32("SPORT2_MTCS2", 0600, parent, (u32 *)0xFFC02548);
		debugfs_create_x32("SPORT2_MTCS3", 0600, parent, (u32 *)0xFFC0254C);
		debugfs_create_x16("SPORT2_RCLKDIV", 0600, parent, (u16 *)0xFFC02528);
		debugfs_create_x16("SPORT2_RCR1", 0600, parent, (u16 *)0xFFC02520);
		debugfs_create_x16("SPORT2_RCR2", 0600, parent, (u16 *)0xFFC02524);
		debugfs_create_x16("SPORT2_RFSDIV", 0600, parent, (u16 *)0xFFC0252C);
		debugfs_create_x32("SPORT2_RX", 0600, parent, (u32 *)0xFFC02518);
		debugfs_create_x16("SPORT2_STAT", 0600, parent, (u16 *)0xFFC02530);
		debugfs_create_x16("SPORT2_TCLKDIV", 0600, parent, (u16 *)0xFFC02508);
		debugfs_create_x16("SPORT2_TCR1", 0600, parent, (u16 *)0xFFC02500);
		debugfs_create_x16("SPORT2_TCR2", 0600, parent, (u16 *)0xFFC02504);
		debugfs_create_x16("SPORT2_TFSDIV", 0600, parent, (u16 *)0xFFC0250C);
		debugfs_create_x32("SPORT2_TX", 0600, parent, (u32 *)0xFFC02510);
		debugfs_create_x16("SPORT3_CHNL", 0600, parent, (u16 *)0xFFC02634);
		debugfs_create_x16("SPORT3_MCMC1", 0600, parent, (u16 *)0xFFC02638);
		debugfs_create_x16("SPORT3_MCMC2", 0600, parent, (u16 *)0xFFC0263C);
		debugfs_create_x32("SPORT3_MRCS0", 0600, parent, (u32 *)0xFFC02650);
		debugfs_create_x32("SPORT3_MRCS1", 0600, parent, (u32 *)0xFFC02654);
		debugfs_create_x32("SPORT3_MRCS2", 0600, parent, (u32 *)0xFFC02658);
		debugfs_create_x32("SPORT3_MRCS3", 0600, parent, (u32 *)0xFFC0265C);
		debugfs_create_x32("SPORT3_MTCS0", 0600, parent, (u32 *)0xFFC02640);
		debugfs_create_x32("SPORT3_MTCS1", 0600, parent, (u32 *)0xFFC02644);
		debugfs_create_x32("SPORT3_MTCS2", 0600, parent, (u32 *)0xFFC02648);
		debugfs_create_x32("SPORT3_MTCS3", 0600, parent, (u32 *)0xFFC0264C);
		debugfs_create_x16("SPORT3_RCLKDIV", 0600, parent, (u16 *)0xFFC02628);
		debugfs_create_x16("SPORT3_RCR1", 0600, parent, (u16 *)0xFFC02620);
		debugfs_create_x16("SPORT3_RCR2", 0600, parent, (u16 *)0xFFC02624);
		debugfs_create_x16("SPORT3_RFSDIV", 0600, parent, (u16 *)0xFFC0262C);
		debugfs_create_x32("SPORT3_RX", 0600, parent, (u32 *)0xFFC02618);
		debugfs_create_x16("SPORT3_STAT", 0600, parent, (u16 *)0xFFC02630);
		debugfs_create_x16("SPORT3_TCLKDIV", 0600, parent, (u16 *)0xFFC02608);
		debugfs_create_x16("SPORT3_TCR1", 0600, parent, (u16 *)0xFFC02600);
		debugfs_create_x16("SPORT3_TCR2", 0600, parent, (u16 *)0xFFC02604);
		debugfs_create_x16("SPORT3_TFSDIV", 0600, parent, (u16 *)0xFFC0260C);
		debugfs_create_x32("SPORT3_TX", 0600, parent, (u32 *)0xFFC02610);

		parent = debugfs_create_dir("Security", top);
		debugfs_create_x16("SECURE_CONTROL", 0600, parent, (u16 *)0xFFC04324);
		debugfs_create_x16("SECURE_STATUS", 0600, parent, (u16 *)0xFFC04328);
		debugfs_create_x32("SECURE_SYSSWT", 0600, parent, (u32 *)0xFFC04320);

		parent = debugfs_create_dir("System Reset and Interrupt Control Registers", top);
		debugfs_create_x16("SWRST", 0600, parent, (u16 *)0xFFC00100);
		debugfs_create_x16("SYSCR", 0600, parent, (u16 *)0xFFC00104);

		parent = debugfs_create_dir("TWI", top);
		debugfs_create_x16("TWI0_CLKDIV", 0600, parent, (u16 *)0xFFC00700);
		debugfs_create_x16("TWI0_CONTROL", 0600, parent, (u16 *)0xFFC00704);
		debugfs_create_x16("TWI0_FIFO_CTL", 0600, parent, (u16 *)0xFFC00728);
		debugfs_create_x16("TWI0_FIFO_STAT", 0600, parent, (u16 *)0xFFC0072C);
		debugfs_create_x16("TWI0_INT_MASK", 0600, parent, (u16 *)0xFFC00724);
		debugfs_create_x16("TWI0_INT_STAT", 0600, parent, (u16 *)0xFFC00720);
		debugfs_create_x16("TWI0_MASTER_ADDR", 0600, parent, (u16 *)0xFFC0071C);
		debugfs_create_x16("TWI0_MASTER_CTL", 0600, parent, (u16 *)0xFFC00714);
		debugfs_create_x16("TWI0_MASTER_STAT", 0600, parent, (u16 *)0xFFC00718);
		debugfs_create_x16("TWI0_RCV_DATA16", 0600, parent, (u16 *)0xFFC0078C);
		debugfs_create_x16("TWI0_RCV_DATA8", 0600, parent, (u16 *)0xFFC00788);
		debugfs_create_x16("TWI0_SLAVE_ADDR", 0600, parent, (u16 *)0xFFC00710);
		debugfs_create_x16("TWI0_SLAVE_CTL", 0600, parent, (u16 *)0xFFC00708);
		debugfs_create_x16("TWI0_SLAVE_STAT", 0600, parent, (u16 *)0xFFC0070C);
		debugfs_create_x16("TWI0_XMT_DATA16", 0600, parent, (u16 *)0xFFC00784);
		debugfs_create_x16("TWI0_XMT_DATA8", 0600, parent, (u16 *)0xFFC00780);
		debugfs_create_x16("TWI1_CLKDIV", 0600, parent, (u16 *)0xFFC02200);
		debugfs_create_x16("TWI1_CONTROL", 0600, parent, (u16 *)0xFFC02204);
		debugfs_create_x16("TWI1_FIFO_CTL", 0600, parent, (u16 *)0xFFC02228);
		debugfs_create_x16("TWI1_FIFO_STAT", 0600, parent, (u16 *)0xFFC0222C);
		debugfs_create_x16("TWI1_INT_MASK", 0600, parent, (u16 *)0xFFC02224);
		debugfs_create_x16("TWI1_INT_STAT", 0600, parent, (u16 *)0xFFC02220);
		debugfs_create_x16("TWI1_MASTER_ADDR", 0600, parent, (u16 *)0xFFC0221C);
		debugfs_create_x16("TWI1_MASTER_CTL", 0600, parent, (u16 *)0xFFC02214);
		debugfs_create_x16("TWI1_MASTER_STAT", 0600, parent, (u16 *)0xFFC02218);
		debugfs_create_x16("TWI1_RCV_DATA16", 0600, parent, (u16 *)0xFFC0228C);
		debugfs_create_x16("TWI1_RCV_DATA8", 0600, parent, (u16 *)0xFFC02288);
		debugfs_create_x16("TWI1_SLAVE_ADDR", 0600, parent, (u16 *)0xFFC02210);
		debugfs_create_x16("TWI1_SLAVE_CTL", 0600, parent, (u16 *)0xFFC02208);
		debugfs_create_x16("TWI1_SLAVE_STAT", 0600, parent, (u16 *)0xFFC0220C);
		debugfs_create_x16("TWI1_XMT_DATA16", 0600, parent, (u16 *)0xFFC02284);
		debugfs_create_x16("TWI1_XMT_DATA8", 0600, parent, (u16 *)0xFFC02280);

		parent = debugfs_create_dir("UART", top);
		debugfs_create_x16("UART0_DLH", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART0_DLL", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART0_GCTL", 0600, parent, (u16 *)0xFFC00408);
		debugfs_create_x16("UART0_IER_CLEAR", 0600, parent, (u16 *)0xFFC00424);
		debugfs_create_x16("UART0_IER_SET", 0600, parent, (u16 *)0xFFC00420);
		debugfs_create_x16("UART0_LCR", 0600, parent, (u16 *)0xFFC0040C);
		debugfs_create_x16("UART0_LSR", 0600, parent, (u16 *)0xFFC00414);
		debugfs_create_x16("UART0_MCR", 0600, parent, (u16 *)0xFFC00410);
		debugfs_create_x16("UART0_MSR", 0600, parent, (u16 *)0xFFC00418);
		debugfs_create_x16("UART0_RBR", 0600, parent, (u16 *)0xFFC0042C);
		debugfs_create_x16("UART0_SCR", 0600, parent, (u16 *)0xFFC0041C);
		debugfs_create_x16("UART0_THR", 0600, parent, (u16 *)0xFFC00428);
		debugfs_create_x16("UART1_DLH", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("UART1_DLL", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART1_GCTL", 0600, parent, (u16 *)0xFFC02008);
		debugfs_create_x16("UART1_IER_CLEAR", 0600, parent, (u16 *)0xFFC02024);
		debugfs_create_x16("UART1_IER_SET", 0600, parent, (u16 *)0xFFC02020);
		debugfs_create_x16("UART1_LCR", 0600, parent, (u16 *)0xFFC0200C);
		debugfs_create_x16("UART1_LSR", 0600, parent, (u16 *)0xFFC02014);
		debugfs_create_x16("UART1_MCR", 0600, parent, (u16 *)0xFFC02010);
		debugfs_create_x16("UART1_MSR", 0600, parent, (u16 *)0xFFC02018);
		debugfs_create_x16("UART1_RBR", 0600, parent, (u16 *)0xFFC0202C);
		debugfs_create_x16("UART1_SCR", 0600, parent, (u16 *)0xFFC0201C);
		debugfs_create_x16("UART1_THR", 0600, parent, (u16 *)0xFFC02028);
		debugfs_create_x16("UART3_DLH", 0600, parent, (u16 *)0xFFC03104);
		debugfs_create_x16("UART3_DLL", 0600, parent, (u16 *)0xFFC03100);
		debugfs_create_x16("UART3_GCTL", 0600, parent, (u16 *)0xFFC03108);
		debugfs_create_x16("UART3_IER_CLEAR", 0600, parent, (u16 *)0xFFC03124);
		debugfs_create_x16("UART3_IER_SET", 0600, parent, (u16 *)0xFFC03120);
		debugfs_create_x16("UART3_LCR", 0600, parent, (u16 *)0xFFC0310C);
		debugfs_create_x16("UART3_LSR", 0600, parent, (u16 *)0xFFC03114);
		debugfs_create_x16("UART3_MCR", 0600, parent, (u16 *)0xFFC03110);
		debugfs_create_x16("UART3_MSR", 0600, parent, (u16 *)0xFFC03118);
		debugfs_create_x16("UART3_RBR", 0600, parent, (u16 *)0xFFC0312C);
		debugfs_create_x16("UART3_SCR", 0600, parent, (u16 *)0xFFC0311C);
		debugfs_create_x16("UART3_THR", 0600, parent, (u16 *)0xFFC03128);

		parent = debugfs_create_dir("Watchdog", top);
		debugfs_create_x32("WDOG_CNT", 0600, parent, (u32 *)0xFFC00204);
		debugfs_create_x16("WDOG_CTL", 0600, parent, (u16 *)0xFFC00200);
		debugfs_create_x32("WDOG_STAT", 0600, parent, (u32 *)0xFFC00208);

		parent = debugfs_create_dir("Watchpoint and Patch Unit", top);
		debugfs_create_x32("WPDA0", 0600, parent, (u32 *)0xFFE07140);
		debugfs_create_x32("WPDA1", 0600, parent, (u32 *)0xFFE07144);
		debugfs_create_x32("WPDACNT0", 0600, parent, (u32 *)0xFFE07180);
		debugfs_create_x32("WPDACNT1", 0600, parent, (u32 *)0xFFE07184);
		debugfs_create_x32("WPDACTL", 0600, parent, (u32 *)0xFFE07100);
		debugfs_create_x32("WPIA0", 0600, parent, (u32 *)0xFFE07040);
		debugfs_create_x32("WPIA1", 0600, parent, (u32 *)0xFFE07044);
		debugfs_create_x32("WPIA2", 0600, parent, (u32 *)0xFFE07048);
		debugfs_create_x32("WPIA3", 0600, parent, (u32 *)0xFFE0704C);
		debugfs_create_x32("WPIA4", 0600, parent, (u32 *)0xFFE07050);
		debugfs_create_x32("WPIA5", 0600, parent, (u32 *)0xFFE07054);
		debugfs_create_x32("WPIACNT0", 0600, parent, (u32 *)0xFFE07080);
		debugfs_create_x32("WPIACNT1", 0600, parent, (u32 *)0xFFE07084);
		debugfs_create_x32("WPIACNT2", 0600, parent, (u32 *)0xFFE07088);
		debugfs_create_x32("WPIACNT3", 0600, parent, (u32 *)0xFFE0708C);
		debugfs_create_x32("WPIACNT4", 0600, parent, (u32 *)0xFFE07090);
		debugfs_create_x32("WPIACNT5", 0600, parent, (u32 *)0xFFE07094);
		debugfs_create_x32("WPIACTL", 0600, parent, (u32 *)0xFFE07000);
		debugfs_create_x32("WPSTAT", 0600, parent, (u32 *)0xFFE07200);

	}	/* BF544 */

#ifdef __ADSPBF547__
# define USE_BF547 1
#else
# define USE_BF547 0
#endif
	if (USE_BF547) {

		parent = debugfs_create_dir("ATAPI", top);
		debugfs_create_x16("ATAPI_CONTROL", 0600, parent, (u16 *)0xFFC03800);
		debugfs_create_x16("ATAPI_DEV_ADDR", 0600, parent, (u16 *)0xFFC03808);
		debugfs_create_x16("ATAPI_DEV_RXBUF", 0600, parent, (u16 *)0xFFC03810);
		debugfs_create_x16("ATAPI_DEV_TXBUF", 0600, parent, (u16 *)0xFFC0380C);
		debugfs_create_x16("ATAPI_DMA_TFRCNT", 0600, parent, (u16 *)0xFFC03830);
		debugfs_create_x16("ATAPI_INT_MASK", 0600, parent, (u16 *)0xFFC03814);
		debugfs_create_x16("ATAPI_INT_STATUS", 0600, parent, (u16 *)0xFFC03818);
		debugfs_create_x16("ATAPI_LINE_STATUS", 0600, parent, (u16 *)0xFFC03820);
		debugfs_create_x16("ATAPI_MULTI_TIM_0", 0600, parent, (u16 *)0xFFC03850);
		debugfs_create_x16("ATAPI_MULTI_TIM_1", 0600, parent, (u16 *)0xFFC03854);
		debugfs_create_x16("ATAPI_MULTI_TIM_2", 0600, parent, (u16 *)0xFFC03858);
		debugfs_create_x16("ATAPI_PIO_TFRCNT", 0600, parent, (u16 *)0xFFC0382C);
		debugfs_create_x16("ATAPI_PIO_TIM_0", 0600, parent, (u16 *)0xFFC03844);
		debugfs_create_x16("ATAPI_PIO_TIM_1", 0600, parent, (u16 *)0xFFC03848);
		debugfs_create_x16("ATAPI_REG_TIM_0", 0600, parent, (u16 *)0xFFC03840);
		debugfs_create_x16("ATAPI_SM_STATE", 0600, parent, (u16 *)0xFFC03824);
		debugfs_create_x16("ATAPI_STATUS", 0600, parent, (u16 *)0xFFC03804);
		debugfs_create_x16("ATAPI_TERMINATE", 0600, parent, (u16 *)0xFFC03828);
		debugfs_create_x16("ATAPI_UDMAOUT_TFRCNT", 0600, parent, (u16 *)0xFFC03838);
		debugfs_create_x16("ATAPI_ULTRA_TIM_0", 0600, parent, (u16 *)0xFFC03860);
		debugfs_create_x16("ATAPI_ULTRA_TIM_1", 0600, parent, (u16 *)0xFFC03864);
		debugfs_create_x16("ATAPI_ULTRA_TIM_2", 0600, parent, (u16 *)0xFFC03868);
		debugfs_create_x16("ATAPI_ULTRA_TIM_3", 0600, parent, (u16 *)0xFFC0386C);
		debugfs_create_x16("ATAPI_UMAIN_TFRCNT", 0600, parent, (u16 *)0xFFC03834);
		debugfs_create_x16("ATAPI_XFER_LEN", 0600, parent, (u16 *)0xFFC0381C);

		parent = debugfs_create_dir("CORE_TMR", top);
		debugfs_create_x32("TCNTL", 0600, parent, (u32 *)0xFFE03000);
		debugfs_create_x32("TCOUNT", 0600, parent, (u32 *)0xFFE0300C);
		debugfs_create_x32("TPERIOD", 0600, parent, (u32 *)0xFFE03004);
		debugfs_create_x32("TSCALE", 0600, parent, (u32 *)0xFFE03008);

		parent = debugfs_create_dir("Counter", top);
		debugfs_create_x16("CNT_COMMAND", 0600, parent, (u16 *)0xFFC0420C);
		debugfs_create_x16("CNT_CONFIG", 0600, parent, (u16 *)0xFFC04200);
		debugfs_create_x32("CNT_COUNTER", 0600, parent, (u32 *)0xFFC04214);
		debugfs_create_x16("CNT_DEBOUNCE", 0600, parent, (u16 *)0xFFC04210);
		debugfs_create_x16("CNT_IMASK", 0600, parent, (u16 *)0xFFC04204);
		debugfs_create_x32("CNT_MAX", 0600, parent, (u32 *)0xFFC04218);
		debugfs_create_x32("CNT_MIN", 0600, parent, (u32 *)0xFFC0421C);
		debugfs_create_x16("CNT_STATUS", 0600, parent, (u16 *)0xFFC04208);

		parent = debugfs_create_dir("DMA", top);
		debugfs_create_x16("DMA0_CONFIG", 0600, parent, (u16 *)0xFFC00C08);
		debugfs_create_x32("DMA0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C24);
		debugfs_create_x32("DMA0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C20);
		debugfs_create_x16("DMA0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C30);
		debugfs_create_x16("DMA0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C38);
		debugfs_create_x16("DMA0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C28);
		debugfs_create_x32("DMA0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C00);
		debugfs_create_x16("DMA0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C2C);
		debugfs_create_x32("DMA0_START_ADDR", 0600, parent, (u32 *)0xFFC00C04);
		debugfs_create_x16("DMA0_X_COUNT", 0600, parent, (u16 *)0xFFC00C10);
		debugfs_create_x16("DMA0_X_MODIFY", 0600, parent, (u16 *)0xFFC00C14);
		debugfs_create_x16("DMA0_Y_COUNT", 0600, parent, (u16 *)0xFFC00C18);
		debugfs_create_x16("DMA0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C1C);
		debugfs_create_x16("DMA10_CONFIG", 0600, parent, (u16 *)0xFFC00E88);
		debugfs_create_x32("DMA10_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EA4);
		debugfs_create_x32("DMA10_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EA0);
		debugfs_create_x16("DMA10_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EB0);
		debugfs_create_x16("DMA10_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EB8);
		debugfs_create_x16("DMA10_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EA8);
		debugfs_create_x32("DMA10_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E80);
		debugfs_create_x16("DMA10_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EAC);
		debugfs_create_x32("DMA10_START_ADDR", 0600, parent, (u32 *)0xFFC00E84);
		debugfs_create_x16("DMA10_X_COUNT", 0600, parent, (u16 *)0xFFC00E90);
		debugfs_create_x16("DMA10_X_MODIFY", 0600, parent, (u16 *)0xFFC00E94);
		debugfs_create_x16("DMA10_Y_COUNT", 0600, parent, (u16 *)0xFFC00E98);
		debugfs_create_x16("DMA10_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E9C);
		debugfs_create_x16("DMA11_CONFIG", 0600, parent, (u16 *)0xFFC00EC8);
		debugfs_create_x32("DMA11_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EE4);
		debugfs_create_x32("DMA11_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EE0);
		debugfs_create_x16("DMA11_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EF0);
		debugfs_create_x16("DMA11_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EF8);
		debugfs_create_x16("DMA11_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EE8);
		debugfs_create_x32("DMA11_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00EC0);
		debugfs_create_x16("DMA11_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EEC);
		debugfs_create_x32("DMA11_START_ADDR", 0600, parent, (u32 *)0xFFC00EC4);
		debugfs_create_x16("DMA11_X_COUNT", 0600, parent, (u16 *)0xFFC00ED0);
		debugfs_create_x16("DMA11_X_MODIFY", 0600, parent, (u16 *)0xFFC00ED4);
		debugfs_create_x16("DMA11_Y_COUNT", 0600, parent, (u16 *)0xFFC00ED8);
		debugfs_create_x16("DMA11_Y_MODIFY", 0600, parent, (u16 *)0xFFC00EDC);
		debugfs_create_x16("DMA12_CONFIG", 0600, parent, (u16 *)0xFFC01C08);
		debugfs_create_x32("DMA12_CURR_ADDR", 0600, parent, (u32 *)0xFFC01C24);
		debugfs_create_x32("DMA12_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01C20);
		debugfs_create_x16("DMA12_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01C30);
		debugfs_create_x16("DMA12_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01C38);
		debugfs_create_x16("DMA12_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01C28);
		debugfs_create_x32("DMA12_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01C00);
		debugfs_create_x16("DMA12_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01C2C);
		debugfs_create_x32("DMA12_START_ADDR", 0600, parent, (u32 *)0xFFC01C04);
		debugfs_create_x16("DMA12_X_COUNT", 0600, parent, (u16 *)0xFFC01C10);
		debugfs_create_x16("DMA12_X_MODIFY", 0600, parent, (u16 *)0xFFC01C14);
		debugfs_create_x16("DMA12_Y_COUNT", 0600, parent, (u16 *)0xFFC01C18);
		debugfs_create_x16("DMA12_Y_MODIFY", 0600, parent, (u16 *)0xFFC01C1C);
		debugfs_create_x16("DMA13_CONFIG", 0600, parent, (u16 *)0xFFC01C48);
		debugfs_create_x32("DMA13_CURR_ADDR", 0600, parent, (u32 *)0xFFC01C64);
		debugfs_create_x32("DMA13_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01C60);
		debugfs_create_x16("DMA13_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01C70);
		debugfs_create_x16("DMA13_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01C78);
		debugfs_create_x16("DMA13_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01C68);
		debugfs_create_x32("DMA13_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01C40);
		debugfs_create_x16("DMA13_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01C6C);
		debugfs_create_x32("DMA13_START_ADDR", 0600, parent, (u32 *)0xFFC01C44);
		debugfs_create_x16("DMA13_X_COUNT", 0600, parent, (u16 *)0xFFC01C50);
		debugfs_create_x16("DMA13_X_MODIFY", 0600, parent, (u16 *)0xFFC01C54);
		debugfs_create_x16("DMA13_Y_COUNT", 0600, parent, (u16 *)0xFFC01C58);
		debugfs_create_x16("DMA13_Y_MODIFY", 0600, parent, (u16 *)0xFFC01C5C);
		debugfs_create_x16("DMA14_CONFIG", 0600, parent, (u16 *)0xFFC01C88);
		debugfs_create_x32("DMA14_CURR_ADDR", 0600, parent, (u32 *)0xFFC01CA4);
		debugfs_create_x32("DMA14_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01CA0);
		debugfs_create_x16("DMA14_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01CB0);
		debugfs_create_x16("DMA14_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01CB8);
		debugfs_create_x16("DMA14_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01CA8);
		debugfs_create_x32("DMA14_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01C80);
		debugfs_create_x16("DMA14_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01CAC);
		debugfs_create_x32("DMA14_START_ADDR", 0600, parent, (u32 *)0xFFC01C84);
		debugfs_create_x16("DMA14_X_COUNT", 0600, parent, (u16 *)0xFFC01C90);
		debugfs_create_x16("DMA14_X_MODIFY", 0600, parent, (u16 *)0xFFC01C94);
		debugfs_create_x16("DMA14_Y_COUNT", 0600, parent, (u16 *)0xFFC01C98);
		debugfs_create_x16("DMA14_Y_MODIFY", 0600, parent, (u16 *)0xFFC01C9C);
		debugfs_create_x16("DMA15_CONFIG", 0600, parent, (u16 *)0xFFC01CC8);
		debugfs_create_x32("DMA15_CURR_ADDR", 0600, parent, (u32 *)0xFFC01CE4);
		debugfs_create_x32("DMA15_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01CE0);
		debugfs_create_x16("DMA15_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01CF0);
		debugfs_create_x16("DMA15_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01CF8);
		debugfs_create_x16("DMA15_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01CE8);
		debugfs_create_x32("DMA15_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01CC0);
		debugfs_create_x16("DMA15_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01CEC);
		debugfs_create_x32("DMA15_START_ADDR", 0600, parent, (u32 *)0xFFC01CC4);
		debugfs_create_x16("DMA15_X_COUNT", 0600, parent, (u16 *)0xFFC01CD0);
		debugfs_create_x16("DMA15_X_MODIFY", 0600, parent, (u16 *)0xFFC01CD4);
		debugfs_create_x16("DMA15_Y_COUNT", 0600, parent, (u16 *)0xFFC01CD8);
		debugfs_create_x16("DMA15_Y_MODIFY", 0600, parent, (u16 *)0xFFC01CDC);
		debugfs_create_x16("DMA16_CONFIG", 0600, parent, (u16 *)0xFFC01D08);
		debugfs_create_x32("DMA16_CURR_ADDR", 0600, parent, (u32 *)0xFFC01D24);
		debugfs_create_x32("DMA16_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01D20);
		debugfs_create_x16("DMA16_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01D30);
		debugfs_create_x16("DMA16_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01D38);
		debugfs_create_x16("DMA16_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01D28);
		debugfs_create_x32("DMA16_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01D00);
		debugfs_create_x16("DMA16_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01D2C);
		debugfs_create_x32("DMA16_START_ADDR", 0600, parent, (u32 *)0xFFC01D04);
		debugfs_create_x16("DMA16_X_COUNT", 0600, parent, (u16 *)0xFFC01D10);
		debugfs_create_x16("DMA16_X_MODIFY", 0600, parent, (u16 *)0xFFC01D14);
		debugfs_create_x16("DMA16_Y_COUNT", 0600, parent, (u16 *)0xFFC01D18);
		debugfs_create_x16("DMA16_Y_MODIFY", 0600, parent, (u16 *)0xFFC01D1C);
		debugfs_create_x16("DMA17_CONFIG", 0600, parent, (u16 *)0xFFC01D48);
		debugfs_create_x32("DMA17_CURR_ADDR", 0600, parent, (u32 *)0xFFC01D64);
		debugfs_create_x32("DMA17_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01D60);
		debugfs_create_x16("DMA17_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01D70);
		debugfs_create_x16("DMA17_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01D78);
		debugfs_create_x16("DMA17_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01D68);
		debugfs_create_x32("DMA17_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01D40);
		debugfs_create_x16("DMA17_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01D6C);
		debugfs_create_x32("DMA17_START_ADDR", 0600, parent, (u32 *)0xFFC01D44);
		debugfs_create_x16("DMA17_X_COUNT", 0600, parent, (u16 *)0xFFC01D50);
		debugfs_create_x16("DMA17_X_MODIFY", 0600, parent, (u16 *)0xFFC01D54);
		debugfs_create_x16("DMA17_Y_COUNT", 0600, parent, (u16 *)0xFFC01D58);
		debugfs_create_x16("DMA17_Y_MODIFY", 0600, parent, (u16 *)0xFFC01D5C);
		debugfs_create_x16("DMA18_CONFIG", 0600, parent, (u16 *)0xFFC01D88);
		debugfs_create_x32("DMA18_CURR_ADDR", 0600, parent, (u32 *)0xFFC01DA4);
		debugfs_create_x32("DMA18_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01DA0);
		debugfs_create_x16("DMA18_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01DB0);
		debugfs_create_x16("DMA18_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01DB8);
		debugfs_create_x16("DMA18_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01DA8);
		debugfs_create_x32("DMA18_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01D80);
		debugfs_create_x16("DMA18_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01DAC);
		debugfs_create_x32("DMA18_START_ADDR", 0600, parent, (u32 *)0xFFC01D84);
		debugfs_create_x16("DMA18_X_COUNT", 0600, parent, (u16 *)0xFFC01D90);
		debugfs_create_x16("DMA18_X_MODIFY", 0600, parent, (u16 *)0xFFC01D94);
		debugfs_create_x16("DMA18_Y_COUNT", 0600, parent, (u16 *)0xFFC01D98);
		debugfs_create_x16("DMA18_Y_MODIFY", 0600, parent, (u16 *)0xFFC01D9C);
		debugfs_create_x16("DMA19_CONFIG", 0600, parent, (u16 *)0xFFC01DC8);
		debugfs_create_x32("DMA19_CURR_ADDR", 0600, parent, (u32 *)0xFFC01DE4);
		debugfs_create_x32("DMA19_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01DE0);
		debugfs_create_x16("DMA19_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01DF0);
		debugfs_create_x16("DMA19_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01DF8);
		debugfs_create_x16("DMA19_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01DE8);
		debugfs_create_x32("DMA19_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01DC0);
		debugfs_create_x16("DMA19_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01DEC);
		debugfs_create_x32("DMA19_START_ADDR", 0600, parent, (u32 *)0xFFC01DC4);
		debugfs_create_x16("DMA19_X_COUNT", 0600, parent, (u16 *)0xFFC01DD0);
		debugfs_create_x16("DMA19_X_MODIFY", 0600, parent, (u16 *)0xFFC01DD4);
		debugfs_create_x16("DMA19_Y_COUNT", 0600, parent, (u16 *)0xFFC01DD8);
		debugfs_create_x16("DMA19_Y_MODIFY", 0600, parent, (u16 *)0xFFC01DDC);
		debugfs_create_x16("DMA1_CONFIG", 0600, parent, (u16 *)0xFFC00C48);
		debugfs_create_x32("DMA1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C64);
		debugfs_create_x32("DMA1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C60);
		debugfs_create_x16("DMA1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C70);
		debugfs_create_x16("DMA1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C78);
		debugfs_create_x16("DMA1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C68);
		debugfs_create_x32("DMA1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C40);
		debugfs_create_x16("DMA1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C6C);
		debugfs_create_x32("DMA1_START_ADDR", 0600, parent, (u32 *)0xFFC00C44);
		debugfs_create_x16("DMA1_X_COUNT", 0600, parent, (u16 *)0xFFC00C50);
		debugfs_create_x16("DMA1_X_MODIFY", 0600, parent, (u16 *)0xFFC00C54);
		debugfs_create_x16("DMA1_Y_COUNT", 0600, parent, (u16 *)0xFFC00C58);
		debugfs_create_x16("DMA1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C5C);
		debugfs_create_x16("DMA20_CONFIG", 0600, parent, (u16 *)0xFFC01E08);
		debugfs_create_x32("DMA20_CURR_ADDR", 0600, parent, (u32 *)0xFFC01E24);
		debugfs_create_x32("DMA20_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01E20);
		debugfs_create_x16("DMA20_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01E30);
		debugfs_create_x16("DMA20_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01E38);
		debugfs_create_x16("DMA20_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01E28);
		debugfs_create_x32("DMA20_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01E00);
		debugfs_create_x16("DMA20_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01E2C);
		debugfs_create_x32("DMA20_START_ADDR", 0600, parent, (u32 *)0xFFC01E04);
		debugfs_create_x16("DMA20_X_COUNT", 0600, parent, (u16 *)0xFFC01E10);
		debugfs_create_x16("DMA20_X_MODIFY", 0600, parent, (u16 *)0xFFC01E14);
		debugfs_create_x16("DMA20_Y_COUNT", 0600, parent, (u16 *)0xFFC01E18);
		debugfs_create_x16("DMA20_Y_MODIFY", 0600, parent, (u16 *)0xFFC01E1C);
		debugfs_create_x16("DMA21_CONFIG", 0600, parent, (u16 *)0xFFC01E48);
		debugfs_create_x32("DMA21_CURR_ADDR", 0600, parent, (u32 *)0xFFC01E64);
		debugfs_create_x32("DMA21_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01E60);
		debugfs_create_x16("DMA21_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01E70);
		debugfs_create_x16("DMA21_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01E78);
		debugfs_create_x16("DMA21_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01E68);
		debugfs_create_x32("DMA21_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01E40);
		debugfs_create_x16("DMA21_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01E6C);
		debugfs_create_x32("DMA21_START_ADDR", 0600, parent, (u32 *)0xFFC01E44);
		debugfs_create_x16("DMA21_X_COUNT", 0600, parent, (u16 *)0xFFC01E50);
		debugfs_create_x16("DMA21_X_MODIFY", 0600, parent, (u16 *)0xFFC01E54);
		debugfs_create_x16("DMA21_Y_COUNT", 0600, parent, (u16 *)0xFFC01E58);
		debugfs_create_x16("DMA21_Y_MODIFY", 0600, parent, (u16 *)0xFFC01E5C);
		debugfs_create_x16("DMA22_CONFIG", 0600, parent, (u16 *)0xFFC01E88);
		debugfs_create_x32("DMA22_CURR_ADDR", 0600, parent, (u32 *)0xFFC01EA4);
		debugfs_create_x32("DMA22_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01EA0);
		debugfs_create_x16("DMA22_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01EB0);
		debugfs_create_x16("DMA22_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01EB8);
		debugfs_create_x16("DMA22_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01EA8);
		debugfs_create_x32("DMA22_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01E80);
		debugfs_create_x16("DMA22_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01EAC);
		debugfs_create_x32("DMA22_START_ADDR", 0600, parent, (u32 *)0xFFC01E84);
		debugfs_create_x16("DMA22_X_COUNT", 0600, parent, (u16 *)0xFFC01E90);
		debugfs_create_x16("DMA22_X_MODIFY", 0600, parent, (u16 *)0xFFC01E94);
		debugfs_create_x16("DMA22_Y_COUNT", 0600, parent, (u16 *)0xFFC01E98);
		debugfs_create_x16("DMA22_Y_MODIFY", 0600, parent, (u16 *)0xFFC01E9C);
		debugfs_create_x16("DMA23_CONFIG", 0600, parent, (u16 *)0xFFC01EC8);
		debugfs_create_x32("DMA23_CURR_ADDR", 0600, parent, (u32 *)0xFFC01EE4);
		debugfs_create_x32("DMA23_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01EE0);
		debugfs_create_x16("DMA23_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01EF0);
		debugfs_create_x16("DMA23_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01EF8);
		debugfs_create_x16("DMA23_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01EE8);
		debugfs_create_x32("DMA23_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01EC0);
		debugfs_create_x16("DMA23_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01EEC);
		debugfs_create_x32("DMA23_START_ADDR", 0600, parent, (u32 *)0xFFC01EC4);
		debugfs_create_x16("DMA23_X_COUNT", 0600, parent, (u16 *)0xFFC01ED0);
		debugfs_create_x16("DMA23_X_MODIFY", 0600, parent, (u16 *)0xFFC01ED4);
		debugfs_create_x16("DMA23_Y_COUNT", 0600, parent, (u16 *)0xFFC01ED8);
		debugfs_create_x16("DMA23_Y_MODIFY", 0600, parent, (u16 *)0xFFC01EDC);
		debugfs_create_x16("DMA2_CONFIG", 0600, parent, (u16 *)0xFFC00C88);
		debugfs_create_x32("DMA2_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CA4);
		debugfs_create_x32("DMA2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CA0);
		debugfs_create_x16("DMA2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CB0);
		debugfs_create_x16("DMA2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CB8);
		debugfs_create_x16("DMA2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CA8);
		debugfs_create_x32("DMA2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C80);
		debugfs_create_x16("DMA2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CAC);
		debugfs_create_x32("DMA2_START_ADDR", 0600, parent, (u32 *)0xFFC00C84);
		debugfs_create_x16("DMA2_X_COUNT", 0600, parent, (u16 *)0xFFC00C90);
		debugfs_create_x16("DMA2_X_MODIFY", 0600, parent, (u16 *)0xFFC00C94);
		debugfs_create_x16("DMA2_Y_COUNT", 0600, parent, (u16 *)0xFFC00C98);
		debugfs_create_x16("DMA2_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C9C);
		debugfs_create_x16("DMA3_CONFIG", 0600, parent, (u16 *)0xFFC00CC8);
		debugfs_create_x32("DMA3_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CE4);
		debugfs_create_x32("DMA3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CE0);
		debugfs_create_x16("DMA3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CF0);
		debugfs_create_x16("DMA3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CF8);
		debugfs_create_x16("DMA3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CE8);
		debugfs_create_x32("DMA3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00CC0);
		debugfs_create_x16("DMA3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CEC);
		debugfs_create_x32("DMA3_START_ADDR", 0600, parent, (u32 *)0xFFC00CC4);
		debugfs_create_x16("DMA3_X_COUNT", 0600, parent, (u16 *)0xFFC00CD0);
		debugfs_create_x16("DMA3_X_MODIFY", 0600, parent, (u16 *)0xFFC00CD4);
		debugfs_create_x16("DMA3_Y_COUNT", 0600, parent, (u16 *)0xFFC00CD8);
		debugfs_create_x16("DMA3_Y_MODIFY", 0600, parent, (u16 *)0xFFC00CDC);
		debugfs_create_x16("DMA4_CONFIG", 0600, parent, (u16 *)0xFFC00D08);
		debugfs_create_x32("DMA4_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D24);
		debugfs_create_x32("DMA4_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D20);
		debugfs_create_x16("DMA4_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D30);
		debugfs_create_x16("DMA4_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D38);
		debugfs_create_x16("DMA4_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D28);
		debugfs_create_x32("DMA4_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D00);
		debugfs_create_x16("DMA4_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D2C);
		debugfs_create_x32("DMA4_START_ADDR", 0600, parent, (u32 *)0xFFC00D04);
		debugfs_create_x16("DMA4_X_COUNT", 0600, parent, (u16 *)0xFFC00D10);
		debugfs_create_x16("DMA4_X_MODIFY", 0600, parent, (u16 *)0xFFC00D14);
		debugfs_create_x16("DMA4_Y_COUNT", 0600, parent, (u16 *)0xFFC00D18);
		debugfs_create_x16("DMA4_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D1C);
		debugfs_create_x16("DMA5_CONFIG", 0600, parent, (u16 *)0xFFC00D48);
		debugfs_create_x32("DMA5_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D64);
		debugfs_create_x32("DMA5_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D60);
		debugfs_create_x16("DMA5_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D70);
		debugfs_create_x16("DMA5_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D78);
		debugfs_create_x16("DMA5_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D68);
		debugfs_create_x32("DMA5_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D40);
		debugfs_create_x16("DMA5_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D6C);
		debugfs_create_x32("DMA5_START_ADDR", 0600, parent, (u32 *)0xFFC00D44);
		debugfs_create_x16("DMA5_X_COUNT", 0600, parent, (u16 *)0xFFC00D50);
		debugfs_create_x16("DMA5_X_MODIFY", 0600, parent, (u16 *)0xFFC00D54);
		debugfs_create_x16("DMA5_Y_COUNT", 0600, parent, (u16 *)0xFFC00D58);
		debugfs_create_x16("DMA5_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D5C);
		debugfs_create_x16("DMA6_CONFIG", 0600, parent, (u16 *)0xFFC00D88);
		debugfs_create_x32("DMA6_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DA4);
		debugfs_create_x32("DMA6_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DA0);
		debugfs_create_x16("DMA6_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DB0);
		debugfs_create_x16("DMA6_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DB8);
		debugfs_create_x16("DMA6_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DA8);
		debugfs_create_x32("DMA6_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D80);
		debugfs_create_x16("DMA6_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DAC);
		debugfs_create_x32("DMA6_START_ADDR", 0600, parent, (u32 *)0xFFC00D84);
		debugfs_create_x16("DMA6_X_COUNT", 0600, parent, (u16 *)0xFFC00D90);
		debugfs_create_x16("DMA6_X_MODIFY", 0600, parent, (u16 *)0xFFC00D94);
		debugfs_create_x16("DMA6_Y_COUNT", 0600, parent, (u16 *)0xFFC00D98);
		debugfs_create_x16("DMA6_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D9C);
		debugfs_create_x16("DMA7_CONFIG", 0600, parent, (u16 *)0xFFC00DC8);
		debugfs_create_x32("DMA7_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DE4);
		debugfs_create_x32("DMA7_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DE0);
		debugfs_create_x16("DMA7_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DF0);
		debugfs_create_x16("DMA7_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DF8);
		debugfs_create_x16("DMA7_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DE8);
		debugfs_create_x32("DMA7_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00DC0);
		debugfs_create_x16("DMA7_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DEC);
		debugfs_create_x32("DMA7_START_ADDR", 0600, parent, (u32 *)0xFFC00DC4);
		debugfs_create_x16("DMA7_X_COUNT", 0600, parent, (u16 *)0xFFC00DD0);
		debugfs_create_x16("DMA7_X_MODIFY", 0600, parent, (u16 *)0xFFC00DD4);
		debugfs_create_x16("DMA7_Y_COUNT", 0600, parent, (u16 *)0xFFC00DD8);
		debugfs_create_x16("DMA7_Y_MODIFY", 0600, parent, (u16 *)0xFFC00DDC);
		debugfs_create_x16("DMA8_CONFIG", 0600, parent, (u16 *)0xFFC00E08);
		debugfs_create_x32("DMA8_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E24);
		debugfs_create_x32("DMA8_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E20);
		debugfs_create_x16("DMA8_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E30);
		debugfs_create_x16("DMA8_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E38);
		debugfs_create_x16("DMA8_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E28);
		debugfs_create_x32("DMA8_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E00);
		debugfs_create_x16("DMA8_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E2C);
		debugfs_create_x32("DMA8_START_ADDR", 0600, parent, (u32 *)0xFFC00E04);
		debugfs_create_x16("DMA8_X_COUNT", 0600, parent, (u16 *)0xFFC00E10);
		debugfs_create_x16("DMA8_X_MODIFY", 0600, parent, (u16 *)0xFFC00E14);
		debugfs_create_x16("DMA8_Y_COUNT", 0600, parent, (u16 *)0xFFC00E18);
		debugfs_create_x16("DMA8_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E1C);
		debugfs_create_x16("DMA9_CONFIG", 0600, parent, (u16 *)0xFFC00E48);
		debugfs_create_x32("DMA9_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E64);
		debugfs_create_x32("DMA9_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E60);
		debugfs_create_x16("DMA9_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E70);
		debugfs_create_x16("DMA9_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E78);
		debugfs_create_x16("DMA9_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E68);
		debugfs_create_x32("DMA9_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E40);
		debugfs_create_x16("DMA9_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E6C);
		debugfs_create_x32("DMA9_START_ADDR", 0600, parent, (u32 *)0xFFC00E44);
		debugfs_create_x16("DMA9_X_COUNT", 0600, parent, (u16 *)0xFFC00E50);
		debugfs_create_x16("DMA9_X_MODIFY", 0600, parent, (u16 *)0xFFC00E54);
		debugfs_create_x16("DMA9_Y_COUNT", 0600, parent, (u16 *)0xFFC00E58);
		debugfs_create_x16("DMA9_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E5C);
		debugfs_create_x16("DMAC0_TCCNT", 0600, parent, (u16 *)0xFFC00B10);
		debugfs_create_x16("DMAC0_TCPER", 0600, parent, (u16 *)0xFFC00B0C);
		debugfs_create_x16("DMAC1_PERIMUX", 0600, parent, (u16 *)0xFFC04340);
		debugfs_create_x16("DMAC1_TCCNT", 0600, parent, (u16 *)0xFFC01B10);
		debugfs_create_x16("DMAC1_TCPER", 0600, parent, (u16 *)0xFFC01B0C);

		parent = debugfs_create_dir("EBIU", top);
		debugfs_create_x32("EBIU_AMBCTL0", 0600, parent, (u32 *)0xFFC00A04);
		debugfs_create_x32("EBIU_AMBCTL1", 0600, parent, (u32 *)0xFFC00A08);
		debugfs_create_x16("EBIU_AMGCTL", 0600, parent, (u16 *)0xFFC00A00);
		debugfs_create_x32("EBIU_ARBSTAT", 0600, parent, (u32 *)0xFFC00A10);
		debugfs_create_x32("EBIU_DDRACCT", 0600, parent, (u32 *)0xFFC00AA0);
		debugfs_create_x32("EBIU_DDRARCT", 0600, parent, (u32 *)0xFFC00AAC);
		debugfs_create_x32("EBIU_DDRBRC0", 0600, parent, (u32 *)0xFFC00A60);
		debugfs_create_x32("EBIU_DDRBRC1", 0600, parent, (u32 *)0xFFC00A64);
		debugfs_create_x32("EBIU_DDRBRC2", 0600, parent, (u32 *)0xFFC00A68);
		debugfs_create_x32("EBIU_DDRBRC3", 0600, parent, (u32 *)0xFFC00A6C);
		debugfs_create_x32("EBIU_DDRBRC4", 0600, parent, (u32 *)0xFFC00A70);
		debugfs_create_x32("EBIU_DDRBRC5", 0600, parent, (u32 *)0xFFC00A74);
		debugfs_create_x32("EBIU_DDRBRC6", 0600, parent, (u32 *)0xFFC00A78);
		debugfs_create_x32("EBIU_DDRBRC7", 0600, parent, (u32 *)0xFFC00A7C);
		debugfs_create_x32("EBIU_DDRBWC0", 0600, parent, (u32 *)0xFFC00A80);
		debugfs_create_x32("EBIU_DDRBWC1", 0600, parent, (u32 *)0xFFC00A84);
		debugfs_create_x32("EBIU_DDRBWC2", 0600, parent, (u32 *)0xFFC00A88);
		debugfs_create_x32("EBIU_DDRBWC3", 0600, parent, (u32 *)0xFFC00A8C);
		debugfs_create_x32("EBIU_DDRBWC4", 0600, parent, (u32 *)0xFFC00A90);
		debugfs_create_x32("EBIU_DDRBWC5", 0600, parent, (u32 *)0xFFC00A94);
		debugfs_create_x32("EBIU_DDRBWC6", 0600, parent, (u32 *)0xFFC00A98);
		debugfs_create_x32("EBIU_DDRBWC7", 0600, parent, (u32 *)0xFFC00A9C);
		debugfs_create_x32("EBIU_DDRCTL0", 0600, parent, (u32 *)0xFFC00A20);
		debugfs_create_x32("EBIU_DDRCTL1", 0600, parent, (u32 *)0xFFC00A24);
		debugfs_create_x32("EBIU_DDRCTL2", 0600, parent, (u32 *)0xFFC00A28);
		debugfs_create_x32("EBIU_DDRCTL3", 0600, parent, (u32 *)0xFFC00A2C);
		debugfs_create_x32("EBIU_DDRGC0", 0600, parent, (u32 *)0xFFC00AB0);
		debugfs_create_x32("EBIU_DDRGC1", 0600, parent, (u32 *)0xFFC00AB4);
		debugfs_create_x32("EBIU_DDRGC2", 0600, parent, (u32 *)0xFFC00AB8);
		debugfs_create_x32("EBIU_DDRGC3", 0600, parent, (u32 *)0xFFC00ABC);
		debugfs_create_x32("EBIU_DDRMCCL", 0600, parent, (u32 *)0xFFC00AC4);
		debugfs_create_x32("EBIU_DDRMCEN", 0600, parent, (u32 *)0xFFC00AC0);
		debugfs_create_x32("EBIU_DDRQUE", 0600, parent, (u32 *)0xFFC00A30);
		debugfs_create_x32("EBIU_DDRTACT", 0600, parent, (u32 *)0xFFC00AA8);
		debugfs_create_x32("EBIU_ERRADD", 0600, parent, (u32 *)0xFFC00A34);
		debugfs_create_x16("EBIU_ERRMST", 0600, parent, (u16 *)0xFFC00A38);
		debugfs_create_x32("EBIU_FCTL", 0600, parent, (u32 *)0xFFC00A18);
		debugfs_create_x32("EBIU_MBSCTL", 0600, parent, (u32 *)0xFFC00A0C);
		debugfs_create_x32("EBIU_MODE", 0600, parent, (u32 *)0xFFC00A14);
		debugfs_create_x16("EBIU_RSTCTL", 0600, parent, (u16 *)0xFFC00A3C);

		parent = debugfs_create_dir("EPPI", top);
		debugfs_create_x32("EPPI0_CLIP", 0600, parent, (u32 *)0xFFC01034);
		debugfs_create_x16("EPPI0_CLKDIV", 0600, parent, (u16 *)0xFFC0101C);
		debugfs_create_x32("EPPI0_CONTROL", 0600, parent, (u32 *)0xFFC01020);
		debugfs_create_x16("EPPI0_FRAME", 0600, parent, (u16 *)0xFFC01014);
		debugfs_create_x32("EPPI0_FS1P_AVPL", 0600, parent, (u32 *)0xFFC01028);
		debugfs_create_x32("EPPI0_FS1W_HBL", 0600, parent, (u32 *)0xFFC01024);
		debugfs_create_x32("EPPI0_FS2P_LAVF", 0600, parent, (u32 *)0xFFC01030);
		debugfs_create_x32("EPPI0_FS2W_LVB", 0600, parent, (u32 *)0xFFC0102C);
		debugfs_create_x16("EPPI0_HCOUNT", 0600, parent, (u16 *)0xFFC01004);
		debugfs_create_x16("EPPI0_HDELAY", 0600, parent, (u16 *)0xFFC01008);
		debugfs_create_x16("EPPI0_LINE", 0600, parent, (u16 *)0xFFC01018);
		debugfs_create_x16("EPPI0_STATUS", 0600, parent, (u16 *)0xFFC01000);
		debugfs_create_x16("EPPI0_VCOUNT", 0600, parent, (u16 *)0xFFC0100C);
		debugfs_create_x16("EPPI0_VDELAY", 0600, parent, (u16 *)0xFFC01010);
		debugfs_create_x32("EPPI1_CLIP", 0600, parent, (u32 *)0xFFC01334);
		debugfs_create_x16("EPPI1_CLKDIV", 0600, parent, (u16 *)0xFFC0131C);
		debugfs_create_x32("EPPI1_CONTROL", 0600, parent, (u32 *)0xFFC01320);
		debugfs_create_x16("EPPI1_FRAME", 0600, parent, (u16 *)0xFFC01314);
		debugfs_create_x32("EPPI1_FS1P_AVPL", 0600, parent, (u32 *)0xFFC01328);
		debugfs_create_x32("EPPI1_FS1W_HBL", 0600, parent, (u32 *)0xFFC01324);
		debugfs_create_x32("EPPI1_FS2P_LAVF", 0600, parent, (u32 *)0xFFC01330);
		debugfs_create_x32("EPPI1_FS2W_LVB", 0600, parent, (u32 *)0xFFC0132C);
		debugfs_create_x16("EPPI1_HCOUNT", 0600, parent, (u16 *)0xFFC01304);
		debugfs_create_x16("EPPI1_HDELAY", 0600, parent, (u16 *)0xFFC01308);
		debugfs_create_x16("EPPI1_LINE", 0600, parent, (u16 *)0xFFC01318);
		debugfs_create_x16("EPPI1_STATUS", 0600, parent, (u16 *)0xFFC01300);
		debugfs_create_x16("EPPI1_VCOUNT", 0600, parent, (u16 *)0xFFC0130C);
		debugfs_create_x16("EPPI1_VDELAY", 0600, parent, (u16 *)0xFFC01310);
		debugfs_create_x32("EPPI2_CLIP", 0600, parent, (u32 *)0xFFC02934);
		debugfs_create_x16("EPPI2_CLKDIV", 0600, parent, (u16 *)0xFFC0291C);
		debugfs_create_x32("EPPI2_CONTROL", 0600, parent, (u32 *)0xFFC02920);
		debugfs_create_x16("EPPI2_FRAME", 0600, parent, (u16 *)0xFFC02914);
		debugfs_create_x32("EPPI2_FS1P_AVPL", 0600, parent, (u32 *)0xFFC02928);
		debugfs_create_x32("EPPI2_FS1W_HBL", 0600, parent, (u32 *)0xFFC02924);
		debugfs_create_x32("EPPI2_FS2P_LAVF", 0600, parent, (u32 *)0xFFC02930);
		debugfs_create_x32("EPPI2_FS2W_LVB", 0600, parent, (u32 *)0xFFC0292C);
		debugfs_create_x16("EPPI2_HCOUNT", 0600, parent, (u16 *)0xFFC02904);
		debugfs_create_x16("EPPI2_HDELAY", 0600, parent, (u16 *)0xFFC02908);
		debugfs_create_x16("EPPI2_LINE", 0600, parent, (u16 *)0xFFC02918);
		debugfs_create_x16("EPPI2_STATUS", 0600, parent, (u16 *)0xFFC02900);
		debugfs_create_x16("EPPI2_VCOUNT", 0600, parent, (u16 *)0xFFC0290C);
		debugfs_create_x16("EPPI2_VDELAY", 0600, parent, (u16 *)0xFFC02910);

		parent = debugfs_create_dir("Event Vector Registers", top);
		debugfs_create_x32("EVT0", 0600, parent, (u32 *)0xFFE02000);
		debugfs_create_x32("EVT10", 0600, parent, (u32 *)0xFFE02028);
		debugfs_create_x32("EVT11", 0600, parent, (u32 *)0xFFE0202C);
		debugfs_create_x32("EVT12", 0600, parent, (u32 *)0xFFE02030);
		debugfs_create_x32("EVT13", 0600, parent, (u32 *)0xFFE02034);
		debugfs_create_x32("EVT14", 0600, parent, (u32 *)0xFFE02038);
		debugfs_create_x32("EVT15", 0600, parent, (u32 *)0xFFE0203C);
		debugfs_create_x32("EVT1", 0600, parent, (u32 *)0xFFE02004);
		debugfs_create_x32("EVT2", 0600, parent, (u32 *)0xFFE02008);
		debugfs_create_x32("EVT3", 0600, parent, (u32 *)0xFFE0200C);
		debugfs_create_x32("EVT4", 0600, parent, (u32 *)0xFFE02010);
		debugfs_create_x32("EVT5", 0600, parent, (u32 *)0xFFE02014);
		debugfs_create_x32("EVT6", 0600, parent, (u32 *)0xFFE02018);
		debugfs_create_x32("EVT7", 0600, parent, (u32 *)0xFFE0201C);
		debugfs_create_x32("EVT8", 0600, parent, (u32 *)0xFFE02020);
		debugfs_create_x32("EVT9", 0600, parent, (u32 *)0xFFE02024);

		parent = debugfs_create_dir("Extended Registers", top);
		debugfs_create_x32("CHIPID", 0600, parent, (u32 *)0xFFC00014);
		debugfs_create_x32("DSPID", 0600, parent, (u32 *)0xFFE05000);

		parent = debugfs_create_dir("HMDMA", top);
		debugfs_create_x16("HMDMA0_BCINIT", 0600, parent, (u16 *)0xFFC04508);
		debugfs_create_x16("HMDMA0_BCOUNT", 0600, parent, (u16 *)0xFFC04518);
		debugfs_create_x16("HMDMA0_CONTROL", 0600, parent, (u16 *)0xFFC04500);
		debugfs_create_x16("HMDMA0_ECINIT", 0600, parent, (u16 *)0xFFC04504);
		debugfs_create_x16("HMDMA0_ECOUNT", 0600, parent, (u16 *)0xFFC04514);
		debugfs_create_x16("HMDMA0_ECOVERFLOW", 0600, parent, (u16 *)0xFFC04510);
		debugfs_create_x16("HMDMA0_ECURGENT", 0600, parent, (u16 *)0xFFC0450C);
		debugfs_create_x16("HMDMA1_BCINIT", 0600, parent, (u16 *)0xFFC04548);
		debugfs_create_x16("HMDMA1_BCOUNT", 0600, parent, (u16 *)0xFFC04558);
		debugfs_create_x16("HMDMA1_CONTROL", 0600, parent, (u16 *)0xFFC04540);
		debugfs_create_x16("HMDMA1_ECINIT", 0600, parent, (u16 *)0xFFC04544);
		debugfs_create_x16("HMDMA1_ECOUNT", 0600, parent, (u16 *)0xFFC04554);
		debugfs_create_x16("HMDMA1_ECOVERFLOW", 0600, parent, (u16 *)0xFFC04550);
		debugfs_create_x16("HMDMA1_ECURGENT", 0600, parent, (u16 *)0xFFC0454C);

		parent = debugfs_create_dir("HOSTDP", top);
		debugfs_create_x16("HOST_CONTROL", 0600, parent, (u16 *)0xFFC03A00);
		debugfs_create_x16("HOST_STATUS", 0600, parent, (u16 *)0xFFC03A04);
		debugfs_create_x16("HOST_TIMEOUT", 0600, parent, (u16 *)0xFFC03A08);

		parent = debugfs_create_dir("Interrupt Controller", top);
		debugfs_create_x32("ILAT", 0600, parent, (u32 *)0xFFE0210C);
		debugfs_create_x32("IMASK", 0600, parent, (u32 *)0xFFE02104);
		debugfs_create_x32("IPEND", 0600, parent, (u32 *)0xFFE02108);
		debugfs_create_x32("IPRIO", 0600, parent, (u32 *)0xFFE02110);

		parent = debugfs_create_dir("KEYPAD", top);
		debugfs_create_x16("KPAD_CTL", 0600, parent, (u16 *)0xFFC04100);
		debugfs_create_x16("KPAD_MSEL", 0600, parent, (u16 *)0xFFC04108);
		debugfs_create_x16("KPAD_PRESCALE", 0600, parent, (u16 *)0xFFC04104);
		debugfs_create_x16("KPAD_ROWCOL", 0600, parent, (u16 *)0xFFC0410C);
		debugfs_create_x16("KPAD_SOFTEVAL", 0600, parent, (u16 *)0xFFC04114);
		debugfs_create_x16("KPAD_STAT", 0600, parent, (u16 *)0xFFC04110);

		parent = debugfs_create_dir("L1 Code Memory Registers", top);
		debugfs_create_x32("ICPLB_ADDR0", 0600, parent, (u32 *)0xFFE01100);
		debugfs_create_x32("ICPLB_ADDR10", 0600, parent, (u32 *)0xFFE01128);
		debugfs_create_x32("ICPLB_ADDR11", 0600, parent, (u32 *)0xFFE0112C);
		debugfs_create_x32("ICPLB_ADDR12", 0600, parent, (u32 *)0xFFE01130);
		debugfs_create_x32("ICPLB_ADDR13", 0600, parent, (u32 *)0xFFE01134);
		debugfs_create_x32("ICPLB_ADDR14", 0600, parent, (u32 *)0xFFE01138);
		debugfs_create_x32("ICPLB_ADDR15", 0600, parent, (u32 *)0xFFE0113C);
		debugfs_create_x32("ICPLB_ADDR1", 0600, parent, (u32 *)0xFFE01104);
		debugfs_create_x32("ICPLB_ADDR2", 0600, parent, (u32 *)0xFFE01108);
		debugfs_create_x32("ICPLB_ADDR3", 0600, parent, (u32 *)0xFFE0110C);
		debugfs_create_x32("ICPLB_ADDR4", 0600, parent, (u32 *)0xFFE01110);
		debugfs_create_x32("ICPLB_ADDR5", 0600, parent, (u32 *)0xFFE01114);
		debugfs_create_x32("ICPLB_ADDR6", 0600, parent, (u32 *)0xFFE01118);
		debugfs_create_x32("ICPLB_ADDR7", 0600, parent, (u32 *)0xFFE0111C);
		debugfs_create_x32("ICPLB_ADDR8", 0600, parent, (u32 *)0xFFE01120);
		debugfs_create_x32("ICPLB_ADDR9", 0600, parent, (u32 *)0xFFE01124);
		debugfs_create_x32("ICPLB_DATA0", 0600, parent, (u32 *)0xFFE01200);
		debugfs_create_x32("ICPLB_DATA10", 0600, parent, (u32 *)0xFFE01228);
		debugfs_create_x32("ICPLB_DATA11", 0600, parent, (u32 *)0xFFE0122C);
		debugfs_create_x32("ICPLB_DATA12", 0600, parent, (u32 *)0xFFE01230);
		debugfs_create_x32("ICPLB_DATA13", 0600, parent, (u32 *)0xFFE01234);
		debugfs_create_x32("ICPLB_DATA14", 0600, parent, (u32 *)0xFFE01238);
		debugfs_create_x32("ICPLB_DATA15", 0600, parent, (u32 *)0xFFE0123C);
		debugfs_create_x32("ICPLB_DATA1", 0600, parent, (u32 *)0xFFE01204);
		debugfs_create_x32("ICPLB_DATA2", 0600, parent, (u32 *)0xFFE01208);
		debugfs_create_x32("ICPLB_DATA3", 0600, parent, (u32 *)0xFFE0120C);
		debugfs_create_x32("ICPLB_DATA4", 0600, parent, (u32 *)0xFFE01210);
		debugfs_create_x32("ICPLB_DATA5", 0600, parent, (u32 *)0xFFE01214);
		debugfs_create_x32("ICPLB_DATA6", 0600, parent, (u32 *)0xFFE01218);
		debugfs_create_x32("ICPLB_DATA7", 0600, parent, (u32 *)0xFFE0121C);
		debugfs_create_x32("ICPLB_DATA8", 0600, parent, (u32 *)0xFFE01220);
		debugfs_create_x32("ICPLB_DATA9", 0600, parent, (u32 *)0xFFE01224);
		debugfs_create_x32("ICPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0100C);
		debugfs_create_x32("ICPLB_STATUS", 0600, parent, (u32 *)0xFFE01008);
		debugfs_create_x32("IMEM_CONTROL", 0600, parent, (u32 *)0xFFE01004);
		debugfs_create_x32("ITEST_COMMAND", 0600, parent, (u32 *)0xFFE01300);
		debugfs_create_x32("ITEST_DATA0", 0600, parent, (u32 *)0xFFE01400);
		debugfs_create_x32("ITEST_DATA1", 0600, parent, (u32 *)0xFFE01404);

		parent = debugfs_create_dir("L1 Data Memory Registers", top);
		debugfs_create_x32("DCPLB_ADDR0", 0600, parent, (u32 *)0xFFE00100);
		debugfs_create_x32("DCPLB_ADDR10", 0600, parent, (u32 *)0xFFE00128);
		debugfs_create_x32("DCPLB_ADDR11", 0600, parent, (u32 *)0xFFE0012C);
		debugfs_create_x32("DCPLB_ADDR12", 0600, parent, (u32 *)0xFFE00130);
		debugfs_create_x32("DCPLB_ADDR13", 0600, parent, (u32 *)0xFFE00134);
		debugfs_create_x32("DCPLB_ADDR14", 0600, parent, (u32 *)0xFFE00138);
		debugfs_create_x32("DCPLB_ADDR15", 0600, parent, (u32 *)0xFFE0013C);
		debugfs_create_x32("DCPLB_ADDR1", 0600, parent, (u32 *)0xFFE00104);
		debugfs_create_x32("DCPLB_ADDR2", 0600, parent, (u32 *)0xFFE00108);
		debugfs_create_x32("DCPLB_ADDR3", 0600, parent, (u32 *)0xFFE0010C);
		debugfs_create_x32("DCPLB_ADDR4", 0600, parent, (u32 *)0xFFE00110);
		debugfs_create_x32("DCPLB_ADDR5", 0600, parent, (u32 *)0xFFE00114);
		debugfs_create_x32("DCPLB_ADDR6", 0600, parent, (u32 *)0xFFE00118);
		debugfs_create_x32("DCPLB_ADDR7", 0600, parent, (u32 *)0xFFE0011C);
		debugfs_create_x32("DCPLB_ADDR8", 0600, parent, (u32 *)0xFFE00120);
		debugfs_create_x32("DCPLB_ADDR9", 0600, parent, (u32 *)0xFFE00124);
		debugfs_create_x32("DCPLB_DATA0", 0600, parent, (u32 *)0xFFE00200);
		debugfs_create_x32("DCPLB_DATA10", 0600, parent, (u32 *)0xFFE00228);
		debugfs_create_x32("DCPLB_DATA11", 0600, parent, (u32 *)0xFFE0022C);
		debugfs_create_x32("DCPLB_DATA12", 0600, parent, (u32 *)0xFFE00230);
		debugfs_create_x32("DCPLB_DATA13", 0600, parent, (u32 *)0xFFE00234);
		debugfs_create_x32("DCPLB_DATA14", 0600, parent, (u32 *)0xFFE00238);
		debugfs_create_x32("DCPLB_DATA15", 0600, parent, (u32 *)0xFFE0023C);
		debugfs_create_x32("DCPLB_DATA1", 0600, parent, (u32 *)0xFFE00204);
		debugfs_create_x32("DCPLB_DATA2", 0600, parent, (u32 *)0xFFE00208);
		debugfs_create_x32("DCPLB_DATA3", 0600, parent, (u32 *)0xFFE0020C);
		debugfs_create_x32("DCPLB_DATA4", 0600, parent, (u32 *)0xFFE00210);
		debugfs_create_x32("DCPLB_DATA5", 0600, parent, (u32 *)0xFFE00214);
		debugfs_create_x32("DCPLB_DATA6", 0600, parent, (u32 *)0xFFE00218);
		debugfs_create_x32("DCPLB_DATA7", 0600, parent, (u32 *)0xFFE0021C);
		debugfs_create_x32("DCPLB_DATA8", 0600, parent, (u32 *)0xFFE00220);
		debugfs_create_x32("DCPLB_DATA9", 0600, parent, (u32 *)0xFFE00224);
		debugfs_create_x32("DCPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0000C);
		debugfs_create_x32("DCPLB_STATUS", 0600, parent, (u32 *)0xFFE00008);
		debugfs_create_x32("DMEM_CONTROL", 0600, parent, (u32 *)0xFFE00004);
		debugfs_create_x32("DTEST_COMMAND", 0600, parent, (u32 *)0xFFE00300);
		debugfs_create_x32("DTEST_DATA0", 0600, parent, (u32 *)0xFFE00400);
		debugfs_create_x32("DTEST_DATA1", 0600, parent, (u32 *)0xFFE00404);
		debugfs_create_x32("SRAM_BASE_ADDR", 0600, parent, (u32 *)0xFFE00000);

		parent = debugfs_create_dir("MDMA", top);
		debugfs_create_x16("MDMA_D0_CONFIG", 0600, parent, (u16 *)0xFFC00F08);
		debugfs_create_x32("MDMA_D0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F24);
		debugfs_create_x32("MDMA_D0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F20);
		debugfs_create_x16("MDMA_D0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F30);
		debugfs_create_x16("MDMA_D0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F38);
		debugfs_create_x16("MDMA_D0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F28);
		debugfs_create_x32("MDMA_D0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F00);
		debugfs_create_x16("MDMA_D0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F2C);
		debugfs_create_x32("MDMA_D0_START_ADDR", 0600, parent, (u32 *)0xFFC00F04);
		debugfs_create_x16("MDMA_D0_X_COUNT", 0600, parent, (u16 *)0xFFC00F10);
		debugfs_create_x16("MDMA_D0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F14);
		debugfs_create_x16("MDMA_D0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F18);
		debugfs_create_x16("MDMA_D0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F1C);
		debugfs_create_x16("MDMA_D1_CONFIG", 0600, parent, (u16 *)0xFFC00F88);
		debugfs_create_x32("MDMA_D1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FA4);
		debugfs_create_x32("MDMA_D1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FA0);
		debugfs_create_x16("MDMA_D1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FB0);
		debugfs_create_x16("MDMA_D1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FB8);
		debugfs_create_x16("MDMA_D1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FA8);
		debugfs_create_x32("MDMA_D1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F80);
		debugfs_create_x16("MDMA_D1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FAC);
		debugfs_create_x32("MDMA_D1_START_ADDR", 0600, parent, (u32 *)0xFFC00F84);
		debugfs_create_x16("MDMA_D1_X_COUNT", 0600, parent, (u16 *)0xFFC00F90);
		debugfs_create_x16("MDMA_D1_X_MODIFY", 0600, parent, (u16 *)0xFFC00F94);
		debugfs_create_x16("MDMA_D1_Y_COUNT", 0600, parent, (u16 *)0xFFC00F98);
		debugfs_create_x16("MDMA_D1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F9C);
		debugfs_create_x16("MDMA_D2_CONFIG", 0600, parent, (u16 *)0xFFC01F08);
		debugfs_create_x32("MDMA_D2_CURR_ADDR", 0600, parent, (u32 *)0xFFC01F24);
		debugfs_create_x32("MDMA_D2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01F20);
		debugfs_create_x16("MDMA_D2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01F30);
		debugfs_create_x16("MDMA_D2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01F38);
		debugfs_create_x16("MDMA_D2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01F28);
		debugfs_create_x32("MDMA_D2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01F00);
		debugfs_create_x16("MDMA_D2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01F2C);
		debugfs_create_x32("MDMA_D2_START_ADDR", 0600, parent, (u32 *)0xFFC01F04);
		debugfs_create_x16("MDMA_D2_X_COUNT", 0600, parent, (u16 *)0xFFC01F10);
		debugfs_create_x16("MDMA_D2_X_MODIFY", 0600, parent, (u16 *)0xFFC01F14);
		debugfs_create_x16("MDMA_D2_Y_COUNT", 0600, parent, (u16 *)0xFFC01F18);
		debugfs_create_x16("MDMA_D2_Y_MODIFY", 0600, parent, (u16 *)0xFFC01F1C);
		debugfs_create_x16("MDMA_D3_CONFIG", 0600, parent, (u16 *)0xFFC01F88);
		debugfs_create_x32("MDMA_D3_CURR_ADDR", 0600, parent, (u32 *)0xFFC01FA4);
		debugfs_create_x32("MDMA_D3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01FA0);
		debugfs_create_x16("MDMA_D3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01FB0);
		debugfs_create_x16("MDMA_D3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01FB8);
		debugfs_create_x16("MDMA_D3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01FA8);
		debugfs_create_x32("MDMA_D3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01F80);
		debugfs_create_x16("MDMA_D3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01FAC);
		debugfs_create_x32("MDMA_D3_START_ADDR", 0600, parent, (u32 *)0xFFC01F84);
		debugfs_create_x16("MDMA_D3_X_COUNT", 0600, parent, (u16 *)0xFFC01F90);
		debugfs_create_x16("MDMA_D3_X_MODIFY", 0600, parent, (u16 *)0xFFC01F94);
		debugfs_create_x16("MDMA_D3_Y_COUNT", 0600, parent, (u16 *)0xFFC01F98);
		debugfs_create_x16("MDMA_D3_Y_MODIFY", 0600, parent, (u16 *)0xFFC01F9C);
		debugfs_create_x16("MDMA_S0_CONFIG", 0600, parent, (u16 *)0xFFC00F48);
		debugfs_create_x32("MDMA_S0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F64);
		debugfs_create_x32("MDMA_S0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F60);
		debugfs_create_x16("MDMA_S0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F70);
		debugfs_create_x16("MDMA_S0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F78);
		debugfs_create_x16("MDMA_S0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F68);
		debugfs_create_x32("MDMA_S0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F40);
		debugfs_create_x16("MDMA_S0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F6C);
		debugfs_create_x32("MDMA_S0_START_ADDR", 0600, parent, (u32 *)0xFFC00F44);
		debugfs_create_x16("MDMA_S0_X_COUNT", 0600, parent, (u16 *)0xFFC00F50);
		debugfs_create_x16("MDMA_S0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F54);
		debugfs_create_x16("MDMA_S0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F58);
		debugfs_create_x16("MDMA_S0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F5C);
		debugfs_create_x16("MDMA_S1_CONFIG", 0600, parent, (u16 *)0xFFC00FC8);
		debugfs_create_x32("MDMA_S1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FE4);
		debugfs_create_x32("MDMA_S1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FE0);
		debugfs_create_x16("MDMA_S1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FF0);
		debugfs_create_x16("MDMA_S1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FF8);
		debugfs_create_x16("MDMA_S1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FE8);
		debugfs_create_x32("MDMA_S1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00FC0);
		debugfs_create_x16("MDMA_S1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FEC);
		debugfs_create_x32("MDMA_S1_START_ADDR", 0600, parent, (u32 *)0xFFC00FC4);
		debugfs_create_x16("MDMA_S1_X_COUNT", 0600, parent, (u16 *)0xFFC00FD0);
		debugfs_create_x16("MDMA_S1_X_MODIFY", 0600, parent, (u16 *)0xFFC00FD4);
		debugfs_create_x16("MDMA_S1_Y_COUNT", 0600, parent, (u16 *)0xFFC00FD8);
		debugfs_create_x16("MDMA_S1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00FDC);
		debugfs_create_x16("MDMA_S2_CONFIG", 0600, parent, (u16 *)0xFFC01F48);
		debugfs_create_x32("MDMA_S2_CURR_ADDR", 0600, parent, (u32 *)0xFFC01F64);
		debugfs_create_x32("MDMA_S2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01F60);
		debugfs_create_x16("MDMA_S2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01F70);
		debugfs_create_x16("MDMA_S2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01F78);
		debugfs_create_x16("MDMA_S2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01F68);
		debugfs_create_x32("MDMA_S2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01F40);
		debugfs_create_x16("MDMA_S2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01F6C);
		debugfs_create_x32("MDMA_S2_START_ADDR", 0600, parent, (u32 *)0xFFC01F44);
		debugfs_create_x16("MDMA_S2_X_COUNT", 0600, parent, (u16 *)0xFFC01F50);
		debugfs_create_x16("MDMA_S2_X_MODIFY", 0600, parent, (u16 *)0xFFC01F54);
		debugfs_create_x16("MDMA_S2_Y_COUNT", 0600, parent, (u16 *)0xFFC01F58);
		debugfs_create_x16("MDMA_S2_Y_MODIFY", 0600, parent, (u16 *)0xFFC01F5C);
		debugfs_create_x16("MDMA_S3_CONFIG", 0600, parent, (u16 *)0xFFC01FC8);
		debugfs_create_x32("MDMA_S3_CURR_ADDR", 0600, parent, (u32 *)0xFFC01FE4);
		debugfs_create_x32("MDMA_S3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01FE0);
		debugfs_create_x16("MDMA_S3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01FF0);
		debugfs_create_x16("MDMA_S3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01FF8);
		debugfs_create_x16("MDMA_S3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01FE8);
		debugfs_create_x32("MDMA_S3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01FC0);
		debugfs_create_x16("MDMA_S3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01FEC);
		debugfs_create_x32("MDMA_S3_START_ADDR", 0600, parent, (u32 *)0xFFC01FC4);
		debugfs_create_x16("MDMA_S3_X_COUNT", 0600, parent, (u16 *)0xFFC01FD0);
		debugfs_create_x16("MDMA_S3_X_MODIFY", 0600, parent, (u16 *)0xFFC01FD4);
		debugfs_create_x16("MDMA_S3_Y_COUNT", 0600, parent, (u16 *)0xFFC01FD8);
		debugfs_create_x16("MDMA_S3_Y_MODIFY", 0600, parent, (u16 *)0xFFC01FDC);

		parent = debugfs_create_dir("NFC", top);
		debugfs_create_x16("NFC_ADDR", 0600, parent, (u16 *)0xFFC03B40);
		debugfs_create_x16("NFC_CMD", 0600, parent, (u16 *)0xFFC03B44);
		debugfs_create_x16("NFC_COUNT", 0600, parent, (u16 *)0xFFC03B20);
		debugfs_create_x16("NFC_CTL", 0600, parent, (u16 *)0xFFC03B00);
		debugfs_create_x16("NFC_DATA_RD", 0600, parent, (u16 *)0xFFC03B4C);
		debugfs_create_x16("NFC_DATA_WR", 0600, parent, (u16 *)0xFFC03B48);
		debugfs_create_x16("NFC_ECC0", 0600, parent, (u16 *)0xFFC03B10);
		debugfs_create_x16("NFC_ECC1", 0600, parent, (u16 *)0xFFC03B14);
		debugfs_create_x16("NFC_ECC2", 0600, parent, (u16 *)0xFFC03B18);
		debugfs_create_x16("NFC_ECC3", 0600, parent, (u16 *)0xFFC03B1C);
		debugfs_create_x16("NFC_IRQMASK", 0600, parent, (u16 *)0xFFC03B0C);
		debugfs_create_x16("NFC_IRQSTAT", 0600, parent, (u16 *)0xFFC03B08);
		debugfs_create_x16("NFC_PGCTL", 0600, parent, (u16 *)0xFFC03B28);
		debugfs_create_x16("NFC_READ", 0600, parent, (u16 *)0xFFC03B2C);
		debugfs_create_x16("NFC_RST", 0600, parent, (u16 *)0xFFC03B24);
		debugfs_create_x16("NFC_STAT", 0600, parent, (u16 *)0xFFC03B04);

		parent = debugfs_create_dir("OTP", top);
		debugfs_create_x16("OTP_BEN", 0600, parent, (u16 *)0xFFC04304);
		debugfs_create_x16("OTP_CONTROL", 0600, parent, (u16 *)0xFFC04300);
		debugfs_create_x32("OTP_DATA0", 0600, parent, (u32 *)0xFFC04380);
		debugfs_create_x32("OTP_DATA1", 0600, parent, (u32 *)0xFFC04384);
		debugfs_create_x32("OTP_DATA2", 0600, parent, (u32 *)0xFFC04388);
		debugfs_create_x32("OTP_DATA3", 0600, parent, (u32 *)0xFFC0438C);
		debugfs_create_x16("OTP_STATUS", 0600, parent, (u16 *)0xFFC04308);
		debugfs_create_x32("OTP_TIMING", 0600, parent, (u32 *)0xFFC0430C);

		parent = debugfs_create_dir("PINT_0", top);
		debugfs_create_x32("PINT0_ASSIGN", 0600, parent, (u32 *)0xFFC0140C);
		debugfs_create_x32("PINT0_EDGE_CLEAR", 0600, parent, (u32 *)0xFFC01414);
		debugfs_create_x32("PINT0_EDGE_SET", 0600, parent, (u32 *)0xFFC01410);
		debugfs_create_x32("PINT0_INVERT_CLEAR", 0600, parent, (u32 *)0xFFC0141C);
		debugfs_create_x32("PINT0_INVERT_SET", 0600, parent, (u32 *)0xFFC01418);
		debugfs_create_x32("PINT0_IRQ", 0600, parent, (u32 *)0xFFC01408);
		debugfs_create_x32("PINT0_LATCH", 0600, parent, (u32 *)0xFFC01424);
		debugfs_create_x32("PINT0_MASK_CLEAR", 0600, parent, (u32 *)0xFFC01404);
		debugfs_create_x32("PINT0_MASK_SET", 0600, parent, (u32 *)0xFFC01400);
		debugfs_create_x32("PINT0_PINSTATE", 0600, parent, (u32 *)0xFFC01420);

		parent = debugfs_create_dir("PINT_1", top);
		debugfs_create_x32("PINT1_ASSIGN", 0600, parent, (u32 *)0xFFC0143C);
		debugfs_create_x32("PINT1_EDGE_CLEAR", 0600, parent, (u32 *)0xFFC01444);
		debugfs_create_x32("PINT1_EDGE_SET", 0600, parent, (u32 *)0xFFC01440);
		debugfs_create_x32("PINT1_INVERT_CLEAR", 0600, parent, (u32 *)0xFFC0144C);
		debugfs_create_x32("PINT1_INVERT_SET", 0600, parent, (u32 *)0xFFC01448);
		debugfs_create_x32("PINT1_IRQ", 0600, parent, (u32 *)0xFFC01438);
		debugfs_create_x32("PINT1_LATCH", 0600, parent, (u32 *)0xFFC01454);
		debugfs_create_x32("PINT1_MASK_CLEAR", 0600, parent, (u32 *)0xFFC01434);
		debugfs_create_x32("PINT1_MASK_SET", 0600, parent, (u32 *)0xFFC01430);
		debugfs_create_x32("PINT1_PINSTATE", 0600, parent, (u32 *)0xFFC01450);

		parent = debugfs_create_dir("PINT_2", top);
		debugfs_create_x32("PINT2_ASSIGN", 0600, parent, (u32 *)0xFFC0146C);
		debugfs_create_x32("PINT2_EDGE_CLEAR", 0600, parent, (u32 *)0xFFC01474);
		debugfs_create_x32("PINT2_EDGE_SET", 0600, parent, (u32 *)0xFFC01470);
		debugfs_create_x32("PINT2_INVERT_CLEAR", 0600, parent, (u32 *)0xFFC0147C);
		debugfs_create_x32("PINT2_INVERT_SET", 0600, parent, (u32 *)0xFFC01478);
		debugfs_create_x32("PINT2_IRQ", 0600, parent, (u32 *)0xFFC01468);
		debugfs_create_x32("PINT2_LATCH", 0600, parent, (u32 *)0xFFC01484);
		debugfs_create_x32("PINT2_MASK_CLEAR", 0600, parent, (u32 *)0xFFC01464);
		debugfs_create_x32("PINT2_MASK_SET", 0600, parent, (u32 *)0xFFC01460);
		debugfs_create_x32("PINT2_PINSTATE", 0600, parent, (u32 *)0xFFC01480);

		parent = debugfs_create_dir("PINT_3", top);
		debugfs_create_x32("PINT3_ASSIGN", 0600, parent, (u32 *)0xFFC0149C);
		debugfs_create_x32("PINT3_EDGE_CLEAR", 0600, parent, (u32 *)0xFFC014A4);
		debugfs_create_x32("PINT3_EDGE_SET", 0600, parent, (u32 *)0xFFC014A0);
		debugfs_create_x32("PINT3_INVERT_CLEAR", 0600, parent, (u32 *)0xFFC014AC);
		debugfs_create_x32("PINT3_INVERT_SET", 0600, parent, (u32 *)0xFFC014A8);
		debugfs_create_x32("PINT3_IRQ", 0600, parent, (u32 *)0xFFC01498);
		debugfs_create_x32("PINT3_LATCH", 0600, parent, (u32 *)0xFFC014B4);
		debugfs_create_x32("PINT3_MASK_CLEAR", 0600, parent, (u32 *)0xFFC01494);
		debugfs_create_x32("PINT3_MASK_SET", 0600, parent, (u32 *)0xFFC01490);
		debugfs_create_x32("PINT3_PINSTATE", 0600, parent, (u32 *)0xFFC014B0);

		parent = debugfs_create_dir("PIXC", top);
		debugfs_create_x16("PIXC_AHEND", 0600, parent, (u16 *)0xFFC04410);
		debugfs_create_x16("PIXC_AHSTART", 0600, parent, (u16 *)0xFFC0440C);
		debugfs_create_x16("PIXC_ATRANSP", 0600, parent, (u16 *)0xFFC0441C);
		debugfs_create_x16("PIXC_AVEND", 0600, parent, (u16 *)0xFFC04418);
		debugfs_create_x16("PIXC_AVSTART", 0600, parent, (u16 *)0xFFC04414);
		debugfs_create_x16("PIXC_BHEND", 0600, parent, (u16 *)0xFFC04424);
		debugfs_create_x16("PIXC_BHSTART", 0600, parent, (u16 *)0xFFC04420);
		debugfs_create_x16("PIXC_BTRANSP", 0600, parent, (u16 *)0xFFC04430);
		debugfs_create_x32("PIXC_BVCON", 0600, parent, (u32 *)0xFFC04448);
		debugfs_create_x16("PIXC_BVEND", 0600, parent, (u16 *)0xFFC0442C);
		debugfs_create_x16("PIXC_BVSTART", 0600, parent, (u16 *)0xFFC04428);
		debugfs_create_x32("PIXC_CCBIAS", 0600, parent, (u32 *)0xFFC0444C);
		debugfs_create_x16("PIXC_CTL", 0600, parent, (u16 *)0xFFC04400);
		debugfs_create_x32("PIXC_GUCON", 0600, parent, (u32 *)0xFFC04444);
		debugfs_create_x16("PIXC_INTRSTAT", 0600, parent, (u16 *)0xFFC0443C);
		debugfs_create_x16("PIXC_LPF", 0600, parent, (u16 *)0xFFC04408);
		debugfs_create_x16("PIXC_PPL", 0600, parent, (u16 *)0xFFC04404);
		debugfs_create_x32("PIXC_RYCON", 0600, parent, (u32 *)0xFFC04440);
		debugfs_create_x32("PIXC_TC", 0600, parent, (u32 *)0xFFC04450);

		parent = debugfs_create_dir("PLL", top);
		debugfs_create_x16("PLL_CTL", 0600, parent, (u16 *)0xFFC00000);
		debugfs_create_x16("PLL_DIV", 0600, parent, (u16 *)0xFFC00004);
		debugfs_create_x16("PLL_LOCKCNT", 0600, parent, (u16 *)0xFFC00010);
		debugfs_create_x16("PLL_STAT", 0600, parent, (u16 *)0xFFC0000C);
		debugfs_create_x16("VR_CTL", 0600, parent, (u16 *)0xFFC00008);

		parent = debugfs_create_dir("PWM_TMR", top);
		debugfs_create_x16("TIMER0_CONFIG", 0600, parent, (u16 *)0xFFC01600);
		debugfs_create_x32("TIMER0_COUNTER", 0600, parent, (u32 *)0xFFC01604);
		debugfs_create_x32("TIMER0_PERIOD", 0600, parent, (u32 *)0xFFC01608);
		debugfs_create_x32("TIMER0_WIDTH", 0600, parent, (u32 *)0xFFC0160C);
		debugfs_create_x16("TIMER10_CONFIG", 0600, parent, (u16 *)0xFFC00620);
		debugfs_create_x32("TIMER10_COUNTER", 0600, parent, (u32 *)0xFFC00624);
		debugfs_create_x32("TIMER10_PERIOD", 0600, parent, (u32 *)0xFFC00628);
		debugfs_create_x32("TIMER10_WIDTH", 0600, parent, (u32 *)0xFFC0062C);
		debugfs_create_x16("TIMER1_CONFIG", 0600, parent, (u16 *)0xFFC01610);
		debugfs_create_x32("TIMER1_COUNTER", 0600, parent, (u32 *)0xFFC01614);
		debugfs_create_x32("TIMER1_PERIOD", 0600, parent, (u32 *)0xFFC01618);
		debugfs_create_x32("TIMER1_WIDTH", 0600, parent, (u32 *)0xFFC0161C);
		debugfs_create_x16("TIMER2_CONFIG", 0600, parent, (u16 *)0xFFC01620);
		debugfs_create_x32("TIMER2_COUNTER", 0600, parent, (u32 *)0xFFC01624);
		debugfs_create_x32("TIMER2_PERIOD", 0600, parent, (u32 *)0xFFC01628);
		debugfs_create_x32("TIMER2_WIDTH", 0600, parent, (u32 *)0xFFC0162C);
		debugfs_create_x16("TIMER3_CONFIG", 0600, parent, (u16 *)0xFFC01630);
		debugfs_create_x32("TIMER3_COUNTER", 0600, parent, (u32 *)0xFFC01634);
		debugfs_create_x32("TIMER3_PERIOD", 0600, parent, (u32 *)0xFFC01638);
		debugfs_create_x32("TIMER3_WIDTH", 0600, parent, (u32 *)0xFFC0163C);
		debugfs_create_x16("TIMER4_CONFIG", 0600, parent, (u16 *)0xFFC01640);
		debugfs_create_x32("TIMER4_COUNTER", 0600, parent, (u32 *)0xFFC01644);
		debugfs_create_x32("TIMER4_PERIOD", 0600, parent, (u32 *)0xFFC01648);
		debugfs_create_x32("TIMER4_WIDTH", 0600, parent, (u32 *)0xFFC0164C);
		debugfs_create_x16("TIMER5_CONFIG", 0600, parent, (u16 *)0xFFC01650);
		debugfs_create_x32("TIMER5_COUNTER", 0600, parent, (u32 *)0xFFC01654);
		debugfs_create_x32("TIMER5_PERIOD", 0600, parent, (u32 *)0xFFC01658);
		debugfs_create_x32("TIMER5_WIDTH", 0600, parent, (u32 *)0xFFC0165C);
		debugfs_create_x16("TIMER6_CONFIG", 0600, parent, (u16 *)0xFFC01660);
		debugfs_create_x32("TIMER6_COUNTER", 0600, parent, (u32 *)0xFFC01664);
		debugfs_create_x32("TIMER6_PERIOD", 0600, parent, (u32 *)0xFFC01668);
		debugfs_create_x32("TIMER6_WIDTH", 0600, parent, (u32 *)0xFFC0166C);
		debugfs_create_x16("TIMER7_CONFIG", 0600, parent, (u16 *)0xFFC01670);
		debugfs_create_x32("TIMER7_COUNTER", 0600, parent, (u32 *)0xFFC01674);
		debugfs_create_x32("TIMER7_PERIOD", 0600, parent, (u32 *)0xFFC01678);
		debugfs_create_x32("TIMER7_WIDTH", 0600, parent, (u32 *)0xFFC0167C);
		debugfs_create_x16("TIMER8_CONFIG", 0600, parent, (u16 *)0xFFC00600);
		debugfs_create_x32("TIMER8_COUNTER", 0600, parent, (u32 *)0xFFC00604);
		debugfs_create_x32("TIMER8_PERIOD", 0600, parent, (u32 *)0xFFC00608);
		debugfs_create_x32("TIMER8_WIDTH", 0600, parent, (u32 *)0xFFC0060C);
		debugfs_create_x16("TIMER9_CONFIG", 0600, parent, (u16 *)0xFFC00610);
		debugfs_create_x32("TIMER9_COUNTER", 0600, parent, (u32 *)0xFFC00614);
		debugfs_create_x32("TIMER9_PERIOD", 0600, parent, (u32 *)0xFFC00618);
		debugfs_create_x32("TIMER9_WIDTH", 0600, parent, (u32 *)0xFFC0061C);
		debugfs_create_x16("TIMER_DISABLE0", 0600, parent, (u16 *)0xFFC01684);
		debugfs_create_x16("TIMER_DISABLE1", 0600, parent, (u16 *)0xFFC00644);
		debugfs_create_x16("TIMER_ENABLE0", 0600, parent, (u16 *)0xFFC01680);
		debugfs_create_x16("TIMER_ENABLE1", 0600, parent, (u16 *)0xFFC00640);
		debugfs_create_x32("TIMER_STATUS0", 0600, parent, (u32 *)0xFFC01688);
		debugfs_create_x32("TIMER_STATUS1", 0600, parent, (u32 *)0xFFC00648);

		parent = debugfs_create_dir("Port_A", top);
		debugfs_create_x16("PORTA", 0600, parent, (u16 *)0xFFC014C4);
		debugfs_create_x16("PORTA_CLEAR", 0600, parent, (u16 *)0xFFC014CC);
		debugfs_create_x16("PORTA_DIR_CLEAR", 0600, parent, (u16 *)0xFFC014D4);
		debugfs_create_x16("PORTA_DIR_SET", 0600, parent, (u16 *)0xFFC014D0);
		debugfs_create_x16("PORTA_FER", 0600, parent, (u16 *)0xFFC014C0);
		debugfs_create_x16("PORTA_INEN", 0600, parent, (u16 *)0xFFC014D8);
		debugfs_create_x32("PORTA_MUX", 0600, parent, (u32 *)0xFFC014DC);
		debugfs_create_x16("PORTA_SET", 0600, parent, (u16 *)0xFFC014C8);

		parent = debugfs_create_dir("Port_B", top);
		debugfs_create_x16("PORTB", 0600, parent, (u16 *)0xFFC014E4);
		debugfs_create_x16("PORTB_CLEAR", 0600, parent, (u16 *)0xFFC014EC);
		debugfs_create_x16("PORTB_DIR_CLEAR", 0600, parent, (u16 *)0xFFC014F4);
		debugfs_create_x16("PORTB_DIR_SET", 0600, parent, (u16 *)0xFFC014F0);
		debugfs_create_x16("PORTB_FER", 0600, parent, (u16 *)0xFFC014E0);
		debugfs_create_x16("PORTB_INEN", 0600, parent, (u16 *)0xFFC014F8);
		debugfs_create_x32("PORTB_MUX", 0600, parent, (u32 *)0xFFC014FC);
		debugfs_create_x16("PORTB_SET", 0600, parent, (u16 *)0xFFC014E8);

		parent = debugfs_create_dir("Port_C", top);
		debugfs_create_x16("PORTC", 0600, parent, (u16 *)0xFFC01504);
		debugfs_create_x16("PORTC_CLEAR", 0600, parent, (u16 *)0xFFC0150C);
		debugfs_create_x16("PORTC_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01514);
		debugfs_create_x16("PORTC_DIR_SET", 0600, parent, (u16 *)0xFFC01510);
		debugfs_create_x16("PORTC_FER", 0600, parent, (u16 *)0xFFC01500);
		debugfs_create_x16("PORTC_INEN", 0600, parent, (u16 *)0xFFC01518);
		debugfs_create_x32("PORTC_MUX", 0600, parent, (u32 *)0xFFC0151C);
		debugfs_create_x16("PORTC_SET", 0600, parent, (u16 *)0xFFC01508);

		parent = debugfs_create_dir("Port_D", top);
		debugfs_create_x16("PORTD", 0600, parent, (u16 *)0xFFC01524);
		debugfs_create_x16("PORTD_CLEAR", 0600, parent, (u16 *)0xFFC0152C);
		debugfs_create_x16("PORTD_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01534);
		debugfs_create_x16("PORTD_DIR_SET", 0600, parent, (u16 *)0xFFC01530);
		debugfs_create_x16("PORTD_FER", 0600, parent, (u16 *)0xFFC01520);
		debugfs_create_x16("PORTD_INEN", 0600, parent, (u16 *)0xFFC01538);
		debugfs_create_x32("PORTD_MUX", 0600, parent, (u32 *)0xFFC0153C);
		debugfs_create_x16("PORTD_SET", 0600, parent, (u16 *)0xFFC01528);

		parent = debugfs_create_dir("Port_E", top);
		debugfs_create_x16("PORTE", 0600, parent, (u16 *)0xFFC01544);
		debugfs_create_x16("PORTE_CLEAR", 0600, parent, (u16 *)0xFFC0154C);
		debugfs_create_x16("PORTE_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01554);
		debugfs_create_x16("PORTE_DIR_SET", 0600, parent, (u16 *)0xFFC01550);
		debugfs_create_x16("PORTE_FER", 0600, parent, (u16 *)0xFFC01540);
		debugfs_create_x16("PORTE_INEN", 0600, parent, (u16 *)0xFFC01558);
		debugfs_create_x32("PORTE_MUX", 0600, parent, (u32 *)0xFFC0155C);
		debugfs_create_x16("PORTE_SET", 0600, parent, (u16 *)0xFFC01548);

		parent = debugfs_create_dir("Port_F", top);
		debugfs_create_x16("PORTF", 0600, parent, (u16 *)0xFFC01564);
		debugfs_create_x16("PORTF_CLEAR", 0600, parent, (u16 *)0xFFC0156C);
		debugfs_create_x16("PORTF_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01574);
		debugfs_create_x16("PORTF_DIR_SET", 0600, parent, (u16 *)0xFFC01570);
		debugfs_create_x16("PORTF_FER", 0600, parent, (u16 *)0xFFC01560);
		debugfs_create_x16("PORTF_INEN", 0600, parent, (u16 *)0xFFC01578);
		debugfs_create_x32("PORTF_MUX", 0600, parent, (u32 *)0xFFC0157C);
		debugfs_create_x16("PORTF_SET", 0600, parent, (u16 *)0xFFC01568);

		parent = debugfs_create_dir("Port_G", top);
		debugfs_create_x16("PORTG", 0600, parent, (u16 *)0xFFC01584);
		debugfs_create_x16("PORTG_CLEAR", 0600, parent, (u16 *)0xFFC0158C);
		debugfs_create_x16("PORTG_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01594);
		debugfs_create_x16("PORTG_DIR_SET", 0600, parent, (u16 *)0xFFC01590);
		debugfs_create_x16("PORTG_FER", 0600, parent, (u16 *)0xFFC01580);
		debugfs_create_x16("PORTG_INEN", 0600, parent, (u16 *)0xFFC01598);
		debugfs_create_x32("PORTG_MUX", 0600, parent, (u32 *)0xFFC0159C);
		debugfs_create_x16("PORTG_SET", 0600, parent, (u16 *)0xFFC01588);

		parent = debugfs_create_dir("Port_H", top);
		debugfs_create_x16("PORTH", 0600, parent, (u16 *)0xFFC015A4);
		debugfs_create_x16("PORTH_CLEAR", 0600, parent, (u16 *)0xFFC015AC);
		debugfs_create_x16("PORTH_DIR_CLEAR", 0600, parent, (u16 *)0xFFC015B4);
		debugfs_create_x16("PORTH_DIR_SET", 0600, parent, (u16 *)0xFFC015B0);
		debugfs_create_x16("PORTH_FER", 0600, parent, (u16 *)0xFFC015A0);
		debugfs_create_x16("PORTH_INEN", 0600, parent, (u16 *)0xFFC015B8);
		debugfs_create_x32("PORTH_MUX", 0600, parent, (u32 *)0xFFC015BC);
		debugfs_create_x16("PORTH_SET", 0600, parent, (u16 *)0xFFC015A8);

		parent = debugfs_create_dir("Port_I", top);
		debugfs_create_x16("PORTI", 0600, parent, (u16 *)0xFFC015C4);
		debugfs_create_x16("PORTI_CLEAR", 0600, parent, (u16 *)0xFFC015CC);
		debugfs_create_x16("PORTI_DIR_CLEAR", 0600, parent, (u16 *)0xFFC015D4);
		debugfs_create_x16("PORTI_DIR_SET", 0600, parent, (u16 *)0xFFC015D0);
		debugfs_create_x16("PORTI_FER", 0600, parent, (u16 *)0xFFC015C0);
		debugfs_create_x16("PORTI_INEN", 0600, parent, (u16 *)0xFFC015D8);
		debugfs_create_x32("PORTI_MUX", 0600, parent, (u32 *)0xFFC015DC);
		debugfs_create_x16("PORTI_SET", 0600, parent, (u16 *)0xFFC015C8);

		parent = debugfs_create_dir("Port_J", top);
		debugfs_create_x16("PORTJ", 0600, parent, (u16 *)0xFFC015E4);
		debugfs_create_x16("PORTJ_CLEAR", 0600, parent, (u16 *)0xFFC015EC);
		debugfs_create_x16("PORTJ_DIR_CLEAR", 0600, parent, (u16 *)0xFFC015F4);
		debugfs_create_x16("PORTJ_DIR_SET", 0600, parent, (u16 *)0xFFC015F0);
		debugfs_create_x16("PORTJ_FER", 0600, parent, (u16 *)0xFFC015E0);
		debugfs_create_x16("PORTJ_INEN", 0600, parent, (u16 *)0xFFC015F8);
		debugfs_create_x32("PORTJ_MUX", 0600, parent, (u32 *)0xFFC015FC);
		debugfs_create_x16("PORTJ_SET", 0600, parent, (u16 *)0xFFC015E8);

		parent = debugfs_create_dir("RTC", top);
		debugfs_create_x32("RTC_ALARM", 0600, parent, (u32 *)0xFFC00310);
		debugfs_create_x16("RTC_ICTL", 0600, parent, (u16 *)0xFFC00304);
		debugfs_create_x16("RTC_ISTAT", 0600, parent, (u16 *)0xFFC00308);
		debugfs_create_x16("RTC_PREN", 0600, parent, (u16 *)0xFFC00314);
		debugfs_create_x32("RTC_STAT", 0600, parent, (u32 *)0xFFC00300);
		debugfs_create_x16("RTC_SWCNT", 0600, parent, (u16 *)0xFFC0030C);

		parent = debugfs_create_dir("SDH", top);
		debugfs_create_x32("SDH_ARGUMENT", 0600, parent, (u32 *)0xFFC03908);
		debugfs_create_x16("SDH_CFG", 0600, parent, (u16 *)0xFFC039C8);
		debugfs_create_x16("SDH_CLK_CTL", 0600, parent, (u16 *)0xFFC03904);
		debugfs_create_x16("SDH_COMMAND", 0600, parent, (u16 *)0xFFC0390C);
		debugfs_create_x16("SDH_DATA_CNT", 0600, parent, (u16 *)0xFFC03930);
		debugfs_create_x16("SDH_DATA_CTL", 0600, parent, (u16 *)0xFFC0392C);
		debugfs_create_x16("SDH_DATA_LGTH", 0600, parent, (u16 *)0xFFC03928);
		debugfs_create_x32("SDH_DATA_TIMER", 0600, parent, (u32 *)0xFFC03924);
		debugfs_create_x16("SDH_E_MASK", 0600, parent, (u16 *)0xFFC039C4);
		debugfs_create_x16("SDH_E_STATUS", 0600, parent, (u16 *)0xFFC039C0);
		debugfs_create_x32("SDH_FIFO", 0600, parent, (u32 *)0xFFC03980);
		debugfs_create_x16("SDH_FIFO_CNT", 0600, parent, (u16 *)0xFFC03948);
		debugfs_create_x32("SDH_MASK0", 0600, parent, (u32 *)0xFFC0393C);
		debugfs_create_x32("SDH_MASK1", 0600, parent, (u32 *)0xFFC03940);
		debugfs_create_x16("SDH_PID0", 0600, parent, (u16 *)0xFFC039D0);
		debugfs_create_x16("SDH_PID1", 0600, parent, (u16 *)0xFFC039D4);
		debugfs_create_x16("SDH_PID2", 0600, parent, (u16 *)0xFFC039D8);
		debugfs_create_x16("SDH_PID3", 0600, parent, (u16 *)0xFFC039DC);
		debugfs_create_x16("SDH_PID4", 0600, parent, (u16 *)0xFFC039E0);
		debugfs_create_x16("SDH_PID5", 0600, parent, (u16 *)0xFFC039E4);
		debugfs_create_x16("SDH_PID6", 0600, parent, (u16 *)0xFFC039E8);
		debugfs_create_x16("SDH_PID7", 0600, parent, (u16 *)0xFFC039EC);
		debugfs_create_x16("SDH_PWR_CTL", 0600, parent, (u16 *)0xFFC03900);
		debugfs_create_x16("SDH_RD_WAIT_EN", 0600, parent, (u16 *)0xFFC039CC);
		debugfs_create_x32("SDH_RESPONSE0", 0600, parent, (u32 *)0xFFC03914);
		debugfs_create_x32("SDH_RESPONSE1", 0600, parent, (u32 *)0xFFC03918);
		debugfs_create_x32("SDH_RESPONSE2", 0600, parent, (u32 *)0xFFC0391C);
		debugfs_create_x32("SDH_RESPONSE3", 0600, parent, (u32 *)0xFFC03920);
		debugfs_create_x16("SDH_RESP_CMD", 0600, parent, (u16 *)0xFFC03910);
		debugfs_create_x32("SDH_STATUS", 0600, parent, (u32 *)0xFFC03934);
		debugfs_create_x16("SDH_STATUS_CLR", 0600, parent, (u16 *)0xFFC03938);

		parent = debugfs_create_dir("SIC", top);
		debugfs_create_x32("SIC_IAR0", 0600, parent, (u32 *)0xFFC00130);
		debugfs_create_x32("SIC_IAR10", 0600, parent, (u32 *)0xFFC00158);
		debugfs_create_x32("SIC_IAR11", 0600, parent, (u32 *)0xFFC0015C);
		debugfs_create_x32("SIC_IAR1", 0600, parent, (u32 *)0xFFC00134);
		debugfs_create_x32("SIC_IAR2", 0600, parent, (u32 *)0xFFC00138);
		debugfs_create_x32("SIC_IAR3", 0600, parent, (u32 *)0xFFC0013C);
		debugfs_create_x32("SIC_IAR4", 0600, parent, (u32 *)0xFFC00140);
		debugfs_create_x32("SIC_IAR5", 0600, parent, (u32 *)0xFFC00144);
		debugfs_create_x32("SIC_IAR6", 0600, parent, (u32 *)0xFFC00148);
		debugfs_create_x32("SIC_IAR7", 0600, parent, (u32 *)0xFFC0014C);
		debugfs_create_x32("SIC_IAR8", 0600, parent, (u32 *)0xFFC00150);
		debugfs_create_x32("SIC_IAR9", 0600, parent, (u32 *)0xFFC00154);
		debugfs_create_x32("SIC_IMASK0", 0600, parent, (u32 *)0xFFC0010C);
		debugfs_create_x32("SIC_IMASK1", 0600, parent, (u32 *)0xFFC00110);
		debugfs_create_x32("SIC_IMASK2", 0600, parent, (u32 *)0xFFC00114);
		debugfs_create_x32("SIC_ISR0", 0600, parent, (u32 *)0xFFC00118);
		debugfs_create_x32("SIC_ISR1", 0600, parent, (u32 *)0xFFC0011C);
		debugfs_create_x32("SIC_ISR2", 0600, parent, (u32 *)0xFFC00120);
		debugfs_create_x32("SIC_IWR0", 0600, parent, (u32 *)0xFFC00124);
		debugfs_create_x32("SIC_IWR1", 0600, parent, (u32 *)0xFFC00128);
		debugfs_create_x32("SIC_IWR2", 0600, parent, (u32 *)0xFFC0012C);

		parent = debugfs_create_dir("SPI", top);
		debugfs_create_x16("SPI0_BAUD", 0600, parent, (u16 *)0xFFC00514);
		debugfs_create_x16("SPI0_CTL", 0600, parent, (u16 *)0xFFC00500);
		debugfs_create_x16("SPI0_FLG", 0600, parent, (u16 *)0xFFC00504);
		debugfs_create_x16("SPI0_RDBR", 0600, parent, (u16 *)0xFFC00510);
		debugfs_create_x16("SPI0_SHADOW", 0600, parent, (u16 *)0xFFC00518);
		debugfs_create_x16("SPI0_STAT", 0600, parent, (u16 *)0xFFC00508);
		debugfs_create_x16("SPI0_TDBR", 0600, parent, (u16 *)0xFFC0050C);
		debugfs_create_x16("SPI1_BAUD", 0600, parent, (u16 *)0xFFC02314);
		debugfs_create_x16("SPI1_CTL", 0600, parent, (u16 *)0xFFC02300);
		debugfs_create_x16("SPI1_FLG", 0600, parent, (u16 *)0xFFC02304);
		debugfs_create_x16("SPI1_RDBR", 0600, parent, (u16 *)0xFFC02310);
		debugfs_create_x16("SPI1_SHADOW", 0600, parent, (u16 *)0xFFC02318);
		debugfs_create_x16("SPI1_STAT", 0600, parent, (u16 *)0xFFC02308);
		debugfs_create_x16("SPI1_TDBR", 0600, parent, (u16 *)0xFFC0230C);
		debugfs_create_x16("SPI2_BAUD", 0600, parent, (u16 *)0xFFC02414);
		debugfs_create_x16("SPI2_CTL", 0600, parent, (u16 *)0xFFC02400);
		debugfs_create_x16("SPI2_FLG", 0600, parent, (u16 *)0xFFC02404);
		debugfs_create_x16("SPI2_RDBR", 0600, parent, (u16 *)0xFFC02410);
		debugfs_create_x16("SPI2_SHADOW", 0600, parent, (u16 *)0xFFC02418);
		debugfs_create_x16("SPI2_STAT", 0600, parent, (u16 *)0xFFC02408);
		debugfs_create_x16("SPI2_TDBR", 0600, parent, (u16 *)0xFFC0240C);

		parent = debugfs_create_dir("SPORT", top);
		debugfs_create_x16("SPORT0_CHNL", 0600, parent, (u16 *)0xFFC00834);
		debugfs_create_x16("SPORT0_MCMC1", 0600, parent, (u16 *)0xFFC00838);
		debugfs_create_x16("SPORT0_MCMC2", 0600, parent, (u16 *)0xFFC0083C);
		debugfs_create_x32("SPORT0_MRCS0", 0600, parent, (u32 *)0xFFC00850);
		debugfs_create_x32("SPORT0_MRCS1", 0600, parent, (u32 *)0xFFC00854);
		debugfs_create_x32("SPORT0_MRCS2", 0600, parent, (u32 *)0xFFC00858);
		debugfs_create_x32("SPORT0_MRCS3", 0600, parent, (u32 *)0xFFC0085C);
		debugfs_create_x32("SPORT0_MTCS0", 0600, parent, (u32 *)0xFFC00840);
		debugfs_create_x32("SPORT0_MTCS1", 0600, parent, (u32 *)0xFFC00844);
		debugfs_create_x32("SPORT0_MTCS2", 0600, parent, (u32 *)0xFFC00848);
		debugfs_create_x32("SPORT0_MTCS3", 0600, parent, (u32 *)0xFFC0084C);
		debugfs_create_x16("SPORT0_RCLKDIV", 0600, parent, (u16 *)0xFFC00828);
		debugfs_create_x16("SPORT0_RCR1", 0600, parent, (u16 *)0xFFC00820);
		debugfs_create_x16("SPORT0_RCR2", 0600, parent, (u16 *)0xFFC00824);
		debugfs_create_x16("SPORT0_RFSDIV", 0600, parent, (u16 *)0xFFC0082C);
		debugfs_create_x32("SPORT0_RX", 0600, parent, (u32 *)0xFFC00818);
		debugfs_create_x16("SPORT0_STAT", 0600, parent, (u16 *)0xFFC00830);
		debugfs_create_x16("SPORT0_TCLKDIV", 0600, parent, (u16 *)0xFFC00808);
		debugfs_create_x16("SPORT0_TCR1", 0600, parent, (u16 *)0xFFC00800);
		debugfs_create_x16("SPORT0_TCR2", 0600, parent, (u16 *)0xFFC00804);
		debugfs_create_x16("SPORT0_TFSDIV", 0600, parent, (u16 *)0xFFC0080C);
		debugfs_create_x32("SPORT0_TX", 0600, parent, (u32 *)0xFFC00810);
		debugfs_create_x16("SPORT1_CHNL", 0600, parent, (u16 *)0xFFC00934);
		debugfs_create_x16("SPORT1_MCMC1", 0600, parent, (u16 *)0xFFC00938);
		debugfs_create_x16("SPORT1_MCMC2", 0600, parent, (u16 *)0xFFC0093C);
		debugfs_create_x32("SPORT1_MRCS0", 0600, parent, (u32 *)0xFFC00950);
		debugfs_create_x32("SPORT1_MRCS1", 0600, parent, (u32 *)0xFFC00954);
		debugfs_create_x32("SPORT1_MRCS2", 0600, parent, (u32 *)0xFFC00958);
		debugfs_create_x32("SPORT1_MRCS3", 0600, parent, (u32 *)0xFFC0095C);
		debugfs_create_x32("SPORT1_MTCS0", 0600, parent, (u32 *)0xFFC00940);
		debugfs_create_x32("SPORT1_MTCS1", 0600, parent, (u32 *)0xFFC00944);
		debugfs_create_x32("SPORT1_MTCS2", 0600, parent, (u32 *)0xFFC00948);
		debugfs_create_x32("SPORT1_MTCS3", 0600, parent, (u32 *)0xFFC0094C);
		debugfs_create_x16("SPORT1_RCLKDIV", 0600, parent, (u16 *)0xFFC00928);
		debugfs_create_x16("SPORT1_RCR1", 0600, parent, (u16 *)0xFFC00920);
		debugfs_create_x16("SPORT1_RCR2", 0600, parent, (u16 *)0xFFC00924);
		debugfs_create_x16("SPORT1_RFSDIV", 0600, parent, (u16 *)0xFFC0092C);
		debugfs_create_x32("SPORT1_RX", 0600, parent, (u32 *)0xFFC00918);
		debugfs_create_x16("SPORT1_STAT", 0600, parent, (u16 *)0xFFC00930);
		debugfs_create_x16("SPORT1_TCLKDIV", 0600, parent, (u16 *)0xFFC00908);
		debugfs_create_x16("SPORT1_TCR1", 0600, parent, (u16 *)0xFFC00900);
		debugfs_create_x16("SPORT1_TCR2", 0600, parent, (u16 *)0xFFC00904);
		debugfs_create_x16("SPORT1_TFSDIV", 0600, parent, (u16 *)0xFFC0090C);
		debugfs_create_x32("SPORT1_TX", 0600, parent, (u32 *)0xFFC00910);
		debugfs_create_x16("SPORT2_CHNL", 0600, parent, (u16 *)0xFFC02534);
		debugfs_create_x16("SPORT2_MCMC1", 0600, parent, (u16 *)0xFFC02538);
		debugfs_create_x16("SPORT2_MCMC2", 0600, parent, (u16 *)0xFFC0253C);
		debugfs_create_x32("SPORT2_MRCS0", 0600, parent, (u32 *)0xFFC02550);
		debugfs_create_x32("SPORT2_MRCS1", 0600, parent, (u32 *)0xFFC02554);
		debugfs_create_x32("SPORT2_MRCS2", 0600, parent, (u32 *)0xFFC02558);
		debugfs_create_x32("SPORT2_MRCS3", 0600, parent, (u32 *)0xFFC0255C);
		debugfs_create_x32("SPORT2_MTCS0", 0600, parent, (u32 *)0xFFC02540);
		debugfs_create_x32("SPORT2_MTCS1", 0600, parent, (u32 *)0xFFC02544);
		debugfs_create_x32("SPORT2_MTCS2", 0600, parent, (u32 *)0xFFC02548);
		debugfs_create_x32("SPORT2_MTCS3", 0600, parent, (u32 *)0xFFC0254C);
		debugfs_create_x16("SPORT2_RCLKDIV", 0600, parent, (u16 *)0xFFC02528);
		debugfs_create_x16("SPORT2_RCR1", 0600, parent, (u16 *)0xFFC02520);
		debugfs_create_x16("SPORT2_RCR2", 0600, parent, (u16 *)0xFFC02524);
		debugfs_create_x16("SPORT2_RFSDIV", 0600, parent, (u16 *)0xFFC0252C);
		debugfs_create_x32("SPORT2_RX", 0600, parent, (u32 *)0xFFC02518);
		debugfs_create_x16("SPORT2_STAT", 0600, parent, (u16 *)0xFFC02530);
		debugfs_create_x16("SPORT2_TCLKDIV", 0600, parent, (u16 *)0xFFC02508);
		debugfs_create_x16("SPORT2_TCR1", 0600, parent, (u16 *)0xFFC02500);
		debugfs_create_x16("SPORT2_TCR2", 0600, parent, (u16 *)0xFFC02504);
		debugfs_create_x16("SPORT2_TFSDIV", 0600, parent, (u16 *)0xFFC0250C);
		debugfs_create_x32("SPORT2_TX", 0600, parent, (u32 *)0xFFC02510);
		debugfs_create_x16("SPORT3_CHNL", 0600, parent, (u16 *)0xFFC02634);
		debugfs_create_x16("SPORT3_MCMC1", 0600, parent, (u16 *)0xFFC02638);
		debugfs_create_x16("SPORT3_MCMC2", 0600, parent, (u16 *)0xFFC0263C);
		debugfs_create_x32("SPORT3_MRCS0", 0600, parent, (u32 *)0xFFC02650);
		debugfs_create_x32("SPORT3_MRCS1", 0600, parent, (u32 *)0xFFC02654);
		debugfs_create_x32("SPORT3_MRCS2", 0600, parent, (u32 *)0xFFC02658);
		debugfs_create_x32("SPORT3_MRCS3", 0600, parent, (u32 *)0xFFC0265C);
		debugfs_create_x32("SPORT3_MTCS0", 0600, parent, (u32 *)0xFFC02640);
		debugfs_create_x32("SPORT3_MTCS1", 0600, parent, (u32 *)0xFFC02644);
		debugfs_create_x32("SPORT3_MTCS2", 0600, parent, (u32 *)0xFFC02648);
		debugfs_create_x32("SPORT3_MTCS3", 0600, parent, (u32 *)0xFFC0264C);
		debugfs_create_x16("SPORT3_RCLKDIV", 0600, parent, (u16 *)0xFFC02628);
		debugfs_create_x16("SPORT3_RCR1", 0600, parent, (u16 *)0xFFC02620);
		debugfs_create_x16("SPORT3_RCR2", 0600, parent, (u16 *)0xFFC02624);
		debugfs_create_x16("SPORT3_RFSDIV", 0600, parent, (u16 *)0xFFC0262C);
		debugfs_create_x32("SPORT3_RX", 0600, parent, (u32 *)0xFFC02618);
		debugfs_create_x16("SPORT3_STAT", 0600, parent, (u16 *)0xFFC02630);
		debugfs_create_x16("SPORT3_TCLKDIV", 0600, parent, (u16 *)0xFFC02608);
		debugfs_create_x16("SPORT3_TCR1", 0600, parent, (u16 *)0xFFC02600);
		debugfs_create_x16("SPORT3_TCR2", 0600, parent, (u16 *)0xFFC02604);
		debugfs_create_x16("SPORT3_TFSDIV", 0600, parent, (u16 *)0xFFC0260C);
		debugfs_create_x32("SPORT3_TX", 0600, parent, (u32 *)0xFFC02610);

		parent = debugfs_create_dir("Security", top);
		debugfs_create_x16("SECURE_CONTROL", 0600, parent, (u16 *)0xFFC04324);
		debugfs_create_x16("SECURE_STATUS", 0600, parent, (u16 *)0xFFC04328);
		debugfs_create_x32("SECURE_SYSSWT", 0600, parent, (u32 *)0xFFC04320);

		parent = debugfs_create_dir("System Reset and Interrupt Control Registers", top);
		debugfs_create_x16("SWRST", 0600, parent, (u16 *)0xFFC00100);
		debugfs_create_x16("SYSCR", 0600, parent, (u16 *)0xFFC00104);

		parent = debugfs_create_dir("TWI", top);
		debugfs_create_x16("TWI0_CLKDIV", 0600, parent, (u16 *)0xFFC00700);
		debugfs_create_x16("TWI0_CONTROL", 0600, parent, (u16 *)0xFFC00704);
		debugfs_create_x16("TWI0_FIFO_CTL", 0600, parent, (u16 *)0xFFC00728);
		debugfs_create_x16("TWI0_FIFO_STAT", 0600, parent, (u16 *)0xFFC0072C);
		debugfs_create_x16("TWI0_INT_MASK", 0600, parent, (u16 *)0xFFC00724);
		debugfs_create_x16("TWI0_INT_STAT", 0600, parent, (u16 *)0xFFC00720);
		debugfs_create_x16("TWI0_MASTER_ADDR", 0600, parent, (u16 *)0xFFC0071C);
		debugfs_create_x16("TWI0_MASTER_CTL", 0600, parent, (u16 *)0xFFC00714);
		debugfs_create_x16("TWI0_MASTER_STAT", 0600, parent, (u16 *)0xFFC00718);
		debugfs_create_x16("TWI0_RCV_DATA16", 0600, parent, (u16 *)0xFFC0078C);
		debugfs_create_x16("TWI0_RCV_DATA8", 0600, parent, (u16 *)0xFFC00788);
		debugfs_create_x16("TWI0_SLAVE_ADDR", 0600, parent, (u16 *)0xFFC00710);
		debugfs_create_x16("TWI0_SLAVE_CTL", 0600, parent, (u16 *)0xFFC00708);
		debugfs_create_x16("TWI0_SLAVE_STAT", 0600, parent, (u16 *)0xFFC0070C);
		debugfs_create_x16("TWI0_XMT_DATA16", 0600, parent, (u16 *)0xFFC00784);
		debugfs_create_x16("TWI0_XMT_DATA8", 0600, parent, (u16 *)0xFFC00780);
		debugfs_create_x16("TWI1_CLKDIV", 0600, parent, (u16 *)0xFFC02200);
		debugfs_create_x16("TWI1_CONTROL", 0600, parent, (u16 *)0xFFC02204);
		debugfs_create_x16("TWI1_FIFO_CTL", 0600, parent, (u16 *)0xFFC02228);
		debugfs_create_x16("TWI1_FIFO_STAT", 0600, parent, (u16 *)0xFFC0222C);
		debugfs_create_x16("TWI1_INT_MASK", 0600, parent, (u16 *)0xFFC02224);
		debugfs_create_x16("TWI1_INT_STAT", 0600, parent, (u16 *)0xFFC02220);
		debugfs_create_x16("TWI1_MASTER_ADDR", 0600, parent, (u16 *)0xFFC0221C);
		debugfs_create_x16("TWI1_MASTER_CTL", 0600, parent, (u16 *)0xFFC02214);
		debugfs_create_x16("TWI1_MASTER_STAT", 0600, parent, (u16 *)0xFFC02218);
		debugfs_create_x16("TWI1_RCV_DATA16", 0600, parent, (u16 *)0xFFC0228C);
		debugfs_create_x16("TWI1_RCV_DATA8", 0600, parent, (u16 *)0xFFC02288);
		debugfs_create_x16("TWI1_SLAVE_ADDR", 0600, parent, (u16 *)0xFFC02210);
		debugfs_create_x16("TWI1_SLAVE_CTL", 0600, parent, (u16 *)0xFFC02208);
		debugfs_create_x16("TWI1_SLAVE_STAT", 0600, parent, (u16 *)0xFFC0220C);
		debugfs_create_x16("TWI1_XMT_DATA16", 0600, parent, (u16 *)0xFFC02284);
		debugfs_create_x16("TWI1_XMT_DATA8", 0600, parent, (u16 *)0xFFC02280);

		parent = debugfs_create_dir("UART0", top);
		debugfs_create_x16("UART0_DLH", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART0_DLL", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART0_GCTL", 0600, parent, (u16 *)0xFFC00408);
		debugfs_create_x16("UART0_IER_CLEAR", 0600, parent, (u16 *)0xFFC00424);
		debugfs_create_x16("UART0_IER_SET", 0600, parent, (u16 *)0xFFC00420);
		debugfs_create_x16("UART0_LCR", 0600, parent, (u16 *)0xFFC0040C);
		debugfs_create_x16("UART0_LSR", 0600, parent, (u16 *)0xFFC00414);
		debugfs_create_x16("UART0_MCR", 0600, parent, (u16 *)0xFFC00410);
		debugfs_create_x16("UART0_MSR", 0600, parent, (u16 *)0xFFC00418);
		debugfs_create_x16("UART0_RBR", 0600, parent, (u16 *)0xFFC0042C);
		debugfs_create_x16("UART0_SCR", 0600, parent, (u16 *)0xFFC0041C);
		debugfs_create_x16("UART0_THR", 0600, parent, (u16 *)0xFFC00428);

		parent = debugfs_create_dir("UART1", top);
		debugfs_create_x16("UART1_DLH", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("UART1_DLL", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART1_GCTL", 0600, parent, (u16 *)0xFFC02008);
		debugfs_create_x16("UART1_IER_CLEAR", 0600, parent, (u16 *)0xFFC02024);
		debugfs_create_x16("UART1_IER_SET", 0600, parent, (u16 *)0xFFC02020);
		debugfs_create_x16("UART1_LCR", 0600, parent, (u16 *)0xFFC0200C);
		debugfs_create_x16("UART1_LSR", 0600, parent, (u16 *)0xFFC02014);
		debugfs_create_x16("UART1_MCR", 0600, parent, (u16 *)0xFFC02010);
		debugfs_create_x16("UART1_MSR", 0600, parent, (u16 *)0xFFC02018);
		debugfs_create_x16("UART1_RBR", 0600, parent, (u16 *)0xFFC0202C);
		debugfs_create_x16("UART1_SCR", 0600, parent, (u16 *)0xFFC0201C);
		debugfs_create_x16("UART1_THR", 0600, parent, (u16 *)0xFFC02028);

		parent = debugfs_create_dir("UART2", top);
		debugfs_create_x16("UART2_DLH", 0600, parent, (u16 *)0xFFC02104);
		debugfs_create_x16("UART2_DLL", 0600, parent, (u16 *)0xFFC02100);
		debugfs_create_x16("UART2_GCTL", 0600, parent, (u16 *)0xFFC02108);
		debugfs_create_x16("UART2_IER_CLEAR", 0600, parent, (u16 *)0xFFC02124);
		debugfs_create_x16("UART2_IER_SET", 0600, parent, (u16 *)0xFFC02120);
		debugfs_create_x16("UART2_LCR", 0600, parent, (u16 *)0xFFC0210C);
		debugfs_create_x16("UART2_LSR", 0600, parent, (u16 *)0xFFC02114);
		debugfs_create_x16("UART2_MCR", 0600, parent, (u16 *)0xFFC02110);
		debugfs_create_x16("UART2_MSR", 0600, parent, (u16 *)0xFFC02118);
		debugfs_create_x16("UART2_RBR", 0600, parent, (u16 *)0xFFC0212C);
		debugfs_create_x16("UART2_SCR", 0600, parent, (u16 *)0xFFC0211C);
		debugfs_create_x16("UART2_THR", 0600, parent, (u16 *)0xFFC02128);

		parent = debugfs_create_dir("UART3", top);
		debugfs_create_x16("UART3_DLH", 0600, parent, (u16 *)0xFFC03104);
		debugfs_create_x16("UART3_DLL", 0600, parent, (u16 *)0xFFC03100);
		debugfs_create_x16("UART3_GCTL", 0600, parent, (u16 *)0xFFC03108);
		debugfs_create_x16("UART3_IER_CLEAR", 0600, parent, (u16 *)0xFFC03124);
		debugfs_create_x16("UART3_IER_SET", 0600, parent, (u16 *)0xFFC03120);
		debugfs_create_x16("UART3_LCR", 0600, parent, (u16 *)0xFFC0310C);
		debugfs_create_x16("UART3_LSR", 0600, parent, (u16 *)0xFFC03114);
		debugfs_create_x16("UART3_MCR", 0600, parent, (u16 *)0xFFC03110);
		debugfs_create_x16("UART3_MSR", 0600, parent, (u16 *)0xFFC03118);
		debugfs_create_x16("UART3_RBR", 0600, parent, (u16 *)0xFFC0312C);
		debugfs_create_x16("UART3_SCR", 0600, parent, (u16 *)0xFFC0311C);
		debugfs_create_x16("UART3_THR", 0600, parent, (u16 *)0xFFC03128);

		parent = debugfs_create_dir("USB", top);
		debugfs_create_x16("USB_APHY_CALIB", 0600, parent, (u16 *)0xFFC03DE4);
		debugfs_create_x16("USB_APHY_CNTRL2", 0600, parent, (u16 *)0xFFC03DE8);
		debugfs_create_x16("USB_APHY_CNTRL", 0600, parent, (u16 *)0xFFC03DE0);
		debugfs_create_x16("USB_COUNT0", 0600, parent, (u16 *)0xFFC03C50);
		debugfs_create_x16("USB_CSR0", 0600, parent, (u16 *)0xFFC03C44);
		debugfs_create_x16("USB_DMA0_ADDRHIGH", 0600, parent, (u16 *)0xFFC0400C);
		debugfs_create_x16("USB_DMA0_ADDRLOW", 0600, parent, (u16 *)0xFFC04008);
		debugfs_create_x16("USB_DMA0_CONTROL", 0600, parent, (u16 *)0xFFC04004);
		debugfs_create_x16("USB_DMA0_COUNTHIGH", 0600, parent, (u16 *)0xFFC04014);
		debugfs_create_x16("USB_DMA0_COUNTLOW", 0600, parent, (u16 *)0xFFC04010);
		debugfs_create_x16("USB_DMA1_ADDRHIGH", 0600, parent, (u16 *)0xFFC0402C);
		debugfs_create_x16("USB_DMA1_ADDRLOW", 0600, parent, (u16 *)0xFFC04028);
		debugfs_create_x16("USB_DMA1_CONTROL", 0600, parent, (u16 *)0xFFC04024);
		debugfs_create_x16("USB_DMA1_COUNTHIGH", 0600, parent, (u16 *)0xFFC04034);
		debugfs_create_x16("USB_DMA1_COUNTLOW", 0600, parent, (u16 *)0xFFC04030);
		debugfs_create_x16("USB_DMA2_ADDRHIGH", 0600, parent, (u16 *)0xFFC0404C);
		debugfs_create_x16("USB_DMA2_ADDRLOW", 0600, parent, (u16 *)0xFFC04048);
		debugfs_create_x16("USB_DMA2_CONTROL", 0600, parent, (u16 *)0xFFC04044);
		debugfs_create_x16("USB_DMA2_COUNTHIGH", 0600, parent, (u16 *)0xFFC04054);
		debugfs_create_x16("USB_DMA2_COUNTLOW", 0600, parent, (u16 *)0xFFC04050);
		debugfs_create_x16("USB_DMA3_ADDRHIGH", 0600, parent, (u16 *)0xFFC0406C);
		debugfs_create_x16("USB_DMA3_ADDRLOW", 0600, parent, (u16 *)0xFFC04068);
		debugfs_create_x16("USB_DMA3_CONTROL", 0600, parent, (u16 *)0xFFC04064);
		debugfs_create_x16("USB_DMA3_COUNTHIGH", 0600, parent, (u16 *)0xFFC04074);
		debugfs_create_x16("USB_DMA3_COUNTLOW", 0600, parent, (u16 *)0xFFC04070);
		debugfs_create_x16("USB_DMA4_ADDRHIGH", 0600, parent, (u16 *)0xFFC0408C);
		debugfs_create_x16("USB_DMA4_ADDRLOW", 0600, parent, (u16 *)0xFFC04088);
		debugfs_create_x16("USB_DMA4_CONTROL", 0600, parent, (u16 *)0xFFC04084);
		debugfs_create_x16("USB_DMA4_COUNTHIGH", 0600, parent, (u16 *)0xFFC04094);
		debugfs_create_x16("USB_DMA4_COUNTLOW", 0600, parent, (u16 *)0xFFC04090);
		debugfs_create_x16("USB_DMA5_ADDRHIGH", 0600, parent, (u16 *)0xFFC040AC);
		debugfs_create_x16("USB_DMA5_ADDRLOW", 0600, parent, (u16 *)0xFFC040A8);
		debugfs_create_x16("USB_DMA5_CONTROL", 0600, parent, (u16 *)0xFFC040A4);
		debugfs_create_x16("USB_DMA5_COUNTHIGH", 0600, parent, (u16 *)0xFFC040B4);
		debugfs_create_x16("USB_DMA5_COUNTLOW", 0600, parent, (u16 *)0xFFC040B0);
		debugfs_create_x16("USB_DMA6_ADDRHIGH", 0600, parent, (u16 *)0xFFC040CC);
		debugfs_create_x16("USB_DMA6_ADDRLOW", 0600, parent, (u16 *)0xFFC040C8);
		debugfs_create_x16("USB_DMA6_CONTROL", 0600, parent, (u16 *)0xFFC040C4);
		debugfs_create_x16("USB_DMA6_COUNTHIGH", 0600, parent, (u16 *)0xFFC040D4);
		debugfs_create_x16("USB_DMA6_COUNTLOW", 0600, parent, (u16 *)0xFFC040D0);
		debugfs_create_x16("USB_DMA7_ADDRHIGH", 0600, parent, (u16 *)0xFFC040EC);
		debugfs_create_x16("USB_DMA7_ADDRLOW", 0600, parent, (u16 *)0xFFC040E8);
		debugfs_create_x16("USB_DMA7_CONTROL", 0600, parent, (u16 *)0xFFC040E4);
		debugfs_create_x16("USB_DMA7_COUNTHIGH", 0600, parent, (u16 *)0xFFC040F4);
		debugfs_create_x16("USB_DMA7_COUNTLOW", 0600, parent, (u16 *)0xFFC040F0);
		debugfs_create_x16("USB_DMA_INTERRUPT", 0600, parent, (u16 *)0xFFC04000);
		debugfs_create_x16("USB_EP0_FIFO", 0600, parent, (u16 *)0xFFC03C80);
		debugfs_create_x16("USB_EP1_FIFO", 0600, parent, (u16 *)0xFFC03C88);
		debugfs_create_x16("USB_EP2_FIFO", 0600, parent, (u16 *)0xFFC03C90);
		debugfs_create_x16("USB_EP3_FIFO", 0600, parent, (u16 *)0xFFC03C98);
		debugfs_create_x16("USB_EP4_FIFO", 0600, parent, (u16 *)0xFFC03CA0);
		debugfs_create_x16("USB_EP5_FIFO", 0600, parent, (u16 *)0xFFC03CA8);
		debugfs_create_x16("USB_EP6_FIFO", 0600, parent, (u16 *)0xFFC03CB0);
		debugfs_create_x16("USB_EP7_FIFO", 0600, parent, (u16 *)0xFFC03CB8);
		debugfs_create_x16("USB_EP_NI0_RXCOUNT", 0600, parent, (u16 *)0xFFC03E10);
		debugfs_create_x16("USB_EP_NI0_RXCSR", 0600, parent, (u16 *)0xFFC03E0C);
		debugfs_create_x16("USB_EP_NI0_RXINTERVAL", 0600, parent, (u16 *)0xFFC03E20);
		debugfs_create_x16("USB_EP_NI0_RXMAXP", 0600, parent, (u16 *)0xFFC03E08);
		debugfs_create_x16("USB_EP_NI0_RXTYPE", 0600, parent, (u16 *)0xFFC03E1C);
		debugfs_create_x16("USB_EP_NI0_TXCOUNT", 0600, parent, (u16 *)0xFFC03E28);
		debugfs_create_x16("USB_EP_NI0_TXCSR", 0600, parent, (u16 *)0xFFC03E04);
		debugfs_create_x16("USB_EP_NI0_TXINTERVAL", 0600, parent, (u16 *)0xFFC03E18);
		debugfs_create_x16("USB_EP_NI0_TXMAXP", 0600, parent, (u16 *)0xFFC03E00);
		debugfs_create_x16("USB_EP_NI0_TXTYPE", 0600, parent, (u16 *)0xFFC03E14);
		debugfs_create_x16("USB_EP_NI1_RXCOUNT", 0600, parent, (u16 *)0xFFC03E50);
		debugfs_create_x16("USB_EP_NI1_RXCSR", 0600, parent, (u16 *)0xFFC03E4C);
		debugfs_create_x16("USB_EP_NI1_RXINTERVAL", 0600, parent, (u16 *)0xFFC03E60);
		debugfs_create_x16("USB_EP_NI1_RXMAXP", 0600, parent, (u16 *)0xFFC03E48);
		debugfs_create_x16("USB_EP_NI1_RXTYPE", 0600, parent, (u16 *)0xFFC03E5C);
		debugfs_create_x16("USB_EP_NI1_TXCOUNT", 0600, parent, (u16 *)0xFFC03E68);
		debugfs_create_x16("USB_EP_NI1_TXCSR", 0600, parent, (u16 *)0xFFC03E44);
		debugfs_create_x16("USB_EP_NI1_TXINTERVAL", 0600, parent, (u16 *)0xFFC03E58);
		debugfs_create_x16("USB_EP_NI1_TXMAXP", 0600, parent, (u16 *)0xFFC03E40);
		debugfs_create_x16("USB_EP_NI1_TXTYPE", 0600, parent, (u16 *)0xFFC03E54);
		debugfs_create_x16("USB_EP_NI2_RXCOUNT", 0600, parent, (u16 *)0xFFC03E90);
		debugfs_create_x16("USB_EP_NI2_RXCSR", 0600, parent, (u16 *)0xFFC03E8C);
		debugfs_create_x16("USB_EP_NI2_RXINTERVAL", 0600, parent, (u16 *)0xFFC03EA0);
		debugfs_create_x16("USB_EP_NI2_RXMAXP", 0600, parent, (u16 *)0xFFC03E88);
		debugfs_create_x16("USB_EP_NI2_RXTYPE", 0600, parent, (u16 *)0xFFC03E9C);
		debugfs_create_x16("USB_EP_NI2_TXCOUNT", 0600, parent, (u16 *)0xFFC03EA8);
		debugfs_create_x16("USB_EP_NI2_TXCSR", 0600, parent, (u16 *)0xFFC03E84);
		debugfs_create_x16("USB_EP_NI2_TXINTERVAL", 0600, parent, (u16 *)0xFFC03E98);
		debugfs_create_x16("USB_EP_NI2_TXMAXP", 0600, parent, (u16 *)0xFFC03E80);
		debugfs_create_x16("USB_EP_NI2_TXTYPE", 0600, parent, (u16 *)0xFFC03E94);
		debugfs_create_x16("USB_EP_NI3_RXCOUNT", 0600, parent, (u16 *)0xFFC03ED0);
		debugfs_create_x16("USB_EP_NI3_RXCSR", 0600, parent, (u16 *)0xFFC03ECC);
		debugfs_create_x16("USB_EP_NI3_RXINTERVAL", 0600, parent, (u16 *)0xFFC03EE0);
		debugfs_create_x16("USB_EP_NI3_RXMAXP", 0600, parent, (u16 *)0xFFC03EC8);
		debugfs_create_x16("USB_EP_NI3_RXTYPE", 0600, parent, (u16 *)0xFFC03EDC);
		debugfs_create_x16("USB_EP_NI3_TXCOUNT", 0600, parent, (u16 *)0xFFC03EE8);
		debugfs_create_x16("USB_EP_NI3_TXCSR", 0600, parent, (u16 *)0xFFC03EC4);
		debugfs_create_x16("USB_EP_NI3_TXINTERVAL", 0600, parent, (u16 *)0xFFC03ED8);
		debugfs_create_x16("USB_EP_NI3_TXMAXP", 0600, parent, (u16 *)0xFFC03EC0);
		debugfs_create_x16("USB_EP_NI3_TXTYPE", 0600, parent, (u16 *)0xFFC03ED4);
		debugfs_create_x16("USB_EP_NI4_RXCOUNT", 0600, parent, (u16 *)0xFFC03F10);
		debugfs_create_x16("USB_EP_NI4_RXCSR", 0600, parent, (u16 *)0xFFC03F0C);
		debugfs_create_x16("USB_EP_NI4_RXINTERVAL", 0600, parent, (u16 *)0xFFC03F20);
		debugfs_create_x16("USB_EP_NI4_RXMAXP", 0600, parent, (u16 *)0xFFC03F08);
		debugfs_create_x16("USB_EP_NI4_RXTYPE", 0600, parent, (u16 *)0xFFC03F1C);
		debugfs_create_x16("USB_EP_NI4_TXCOUNT", 0600, parent, (u16 *)0xFFC03F28);
		debugfs_create_x16("USB_EP_NI4_TXCSR", 0600, parent, (u16 *)0xFFC03F04);
		debugfs_create_x16("USB_EP_NI4_TXINTERVAL", 0600, parent, (u16 *)0xFFC03F18);
		debugfs_create_x16("USB_EP_NI4_TXMAXP", 0600, parent, (u16 *)0xFFC03F00);
		debugfs_create_x16("USB_EP_NI4_TXTYPE", 0600, parent, (u16 *)0xFFC03F14);
		debugfs_create_x16("USB_EP_NI5_RXCOUNT", 0600, parent, (u16 *)0xFFC03F50);
		debugfs_create_x16("USB_EP_NI5_RXCSR", 0600, parent, (u16 *)0xFFC03F4C);
		debugfs_create_x16("USB_EP_NI5_RXINTERVAL", 0600, parent, (u16 *)0xFFC03F60);
		debugfs_create_x16("USB_EP_NI5_RXMAXP", 0600, parent, (u16 *)0xFFC03F48);
		debugfs_create_x16("USB_EP_NI5_RXTYPE", 0600, parent, (u16 *)0xFFC03F5C);
		debugfs_create_x16("USB_EP_NI5_TXCOUNT", 0600, parent, (u16 *)0xFFC03F68);
		debugfs_create_x16("USB_EP_NI5_TXCSR", 0600, parent, (u16 *)0xFFC03F44);
		debugfs_create_x16("USB_EP_NI5_TXINTERVAL", 0600, parent, (u16 *)0xFFC03F58);
		debugfs_create_x16("USB_EP_NI5_TXMAXP", 0600, parent, (u16 *)0xFFC03F40);
		debugfs_create_x16("USB_EP_NI5_TXTYPE", 0600, parent, (u16 *)0xFFC03F54);
		debugfs_create_x16("USB_EP_NI6_RXCOUNT", 0600, parent, (u16 *)0xFFC03F90);
		debugfs_create_x16("USB_EP_NI6_RXCSR", 0600, parent, (u16 *)0xFFC03F8C);
		debugfs_create_x16("USB_EP_NI6_RXINTERVAL", 0600, parent, (u16 *)0xFFC03FA0);
		debugfs_create_x16("USB_EP_NI6_RXMAXP", 0600, parent, (u16 *)0xFFC03F88);
		debugfs_create_x16("USB_EP_NI6_RXTYPE", 0600, parent, (u16 *)0xFFC03F9C);
		debugfs_create_x16("USB_EP_NI6_TXCOUNT", 0600, parent, (u16 *)0xFFC03FA8);
		debugfs_create_x16("USB_EP_NI6_TXCSR", 0600, parent, (u16 *)0xFFC03F84);
		debugfs_create_x16("USB_EP_NI6_TXINTERVAL", 0600, parent, (u16 *)0xFFC03F98);
		debugfs_create_x16("USB_EP_NI6_TXMAXP", 0600, parent, (u16 *)0xFFC03F80);
		debugfs_create_x16("USB_EP_NI6_TXTYPE", 0600, parent, (u16 *)0xFFC03F94);
		debugfs_create_x16("USB_EP_NI7_RXCOUNT", 0600, parent, (u16 *)0xFFC03FD0);
		debugfs_create_x16("USB_EP_NI7_RXCSR", 0600, parent, (u16 *)0xFFC03FCC);
		debugfs_create_x16("USB_EP_NI7_RXINTERVAL", 0600, parent, (u16 *)0xFFC03FF0);
		debugfs_create_x16("USB_EP_NI7_RXMAXP", 0600, parent, (u16 *)0xFFC03FC8);
		debugfs_create_x16("USB_EP_NI7_RXTYPE", 0600, parent, (u16 *)0xFFC03FDC);
		debugfs_create_x16("USB_EP_NI7_TXCOUNT", 0600, parent, (u16 *)0xFFC03FF8);
		debugfs_create_x16("USB_EP_NI7_TXCSR", 0600, parent, (u16 *)0xFFC03FC4);
		debugfs_create_x16("USB_EP_NI7_TXINTERVAL", 0600, parent, (u16 *)0xFFC03FD8);
		debugfs_create_x16("USB_EP_NI7_TXMAXP", 0600, parent, (u16 *)0xFFC03FC0);
		debugfs_create_x16("USB_EP_NI7_TXTYPE", 0600, parent, (u16 *)0xFFC03FD4);
		debugfs_create_x16("USB_FADDR", 0600, parent, (u16 *)0xFFC03C00);
		debugfs_create_x16("USB_FRAME", 0600, parent, (u16 *)0xFFC03C20);
		debugfs_create_x16("USB_FS_EOF1", 0600, parent, (u16 *)0xFFC03D54);
		debugfs_create_x16("USB_GLOBAL_CTL", 0600, parent, (u16 *)0xFFC03C30);
		debugfs_create_x16("USB_GLOBINTR", 0600, parent, (u16 *)0xFFC03C2C);
		debugfs_create_x16("USB_HS_EOF1", 0600, parent, (u16 *)0xFFC03D50);
		debugfs_create_x16("USB_INDEX", 0600, parent, (u16 *)0xFFC03C24);
		debugfs_create_x16("USB_INTRRX", 0600, parent, (u16 *)0xFFC03C0C);
		debugfs_create_x16("USB_INTRRXE", 0600, parent, (u16 *)0xFFC03C14);
		debugfs_create_x16("USB_INTRTX", 0600, parent, (u16 *)0xFFC03C08);
		debugfs_create_x16("USB_INTRTXE", 0600, parent, (u16 *)0xFFC03C10);
		debugfs_create_x16("USB_INTRUSB", 0600, parent, (u16 *)0xFFC03C18);
		debugfs_create_x16("USB_INTRUSBE", 0600, parent, (u16 *)0xFFC03C1C);
		debugfs_create_x16("USB_LINKINFO", 0600, parent, (u16 *)0xFFC03D48);
		debugfs_create_x16("USB_LS_EOF1", 0600, parent, (u16 *)0xFFC03D58);
		debugfs_create_x16("USB_NAKLIMIT0", 0600, parent, (u16 *)0xFFC03C58);
		debugfs_create_x16("USB_OTG_DEV_CTL", 0600, parent, (u16 *)0xFFC03D00);
		debugfs_create_x16("USB_OTG_VBUS_IRQ", 0600, parent, (u16 *)0xFFC03D04);
		debugfs_create_x16("USB_OTG_VBUS_MASK", 0600, parent, (u16 *)0xFFC03D08);
		debugfs_create_x16("USB_PHY_TEST", 0600, parent, (u16 *)0xFFC03DEC);
		debugfs_create_x16("USB_PLLOSC_CTRL", 0600, parent, (u16 *)0xFFC03DF0);
		debugfs_create_x16("USB_POWER", 0600, parent, (u16 *)0xFFC03C04);
		debugfs_create_x16("USB_RXCOUNT", 0600, parent, (u16 *)0xFFC03C50);
		debugfs_create_x16("USB_RXCSR", 0600, parent, (u16 *)0xFFC03C4C);
		debugfs_create_x16("USB_RXINTERVAL", 0600, parent, (u16 *)0xFFC03C60);
		debugfs_create_x16("USB_RXTYPE", 0600, parent, (u16 *)0xFFC03C5C);
		debugfs_create_x16("USB_RX_MAX_PACKET", 0600, parent, (u16 *)0xFFC03C48);
		debugfs_create_x16("USB_SRP_CLKDIV", 0600, parent, (u16 *)0xFFC03DF4);
		debugfs_create_x16("USB_TESTMODE", 0600, parent, (u16 *)0xFFC03C28);
		debugfs_create_x16("USB_TXCOUNT", 0600, parent, (u16 *)0xFFC03C68);
		debugfs_create_x16("USB_TXCSR", 0600, parent, (u16 *)0xFFC03C44);
		debugfs_create_x16("USB_TXINTERVAL", 0600, parent, (u16 *)0xFFC03C58);
		debugfs_create_x16("USB_TXTYPE", 0600, parent, (u16 *)0xFFC03C54);
		debugfs_create_x16("USB_TX_MAX_PACKET", 0600, parent, (u16 *)0xFFC03C40);
		debugfs_create_x16("USB_VPLEN", 0600, parent, (u16 *)0xFFC03D4C);

		parent = debugfs_create_dir("WDOG", top);
		debugfs_create_x32("WDOG_CNT", 0600, parent, (u32 *)0xFFC00204);
		debugfs_create_x16("WDOG_CTL", 0600, parent, (u16 *)0xFFC00200);
		debugfs_create_x32("WDOG_STAT", 0600, parent, (u32 *)0xFFC00208);

		parent = debugfs_create_dir("Watchpoint and Patch Unit", top);
		debugfs_create_x32("WPDA0", 0600, parent, (u32 *)0xFFE07140);
		debugfs_create_x32("WPDA1", 0600, parent, (u32 *)0xFFE07144);
		debugfs_create_x32("WPDACNT0", 0600, parent, (u32 *)0xFFE07180);
		debugfs_create_x32("WPDACNT1", 0600, parent, (u32 *)0xFFE07184);
		debugfs_create_x32("WPDACTL", 0600, parent, (u32 *)0xFFE07100);
		debugfs_create_x32("WPIA0", 0600, parent, (u32 *)0xFFE07040);
		debugfs_create_x32("WPIA1", 0600, parent, (u32 *)0xFFE07044);
		debugfs_create_x32("WPIA2", 0600, parent, (u32 *)0xFFE07048);
		debugfs_create_x32("WPIA3", 0600, parent, (u32 *)0xFFE0704C);
		debugfs_create_x32("WPIA4", 0600, parent, (u32 *)0xFFE07050);
		debugfs_create_x32("WPIA5", 0600, parent, (u32 *)0xFFE07054);
		debugfs_create_x32("WPIACNT0", 0600, parent, (u32 *)0xFFE07080);
		debugfs_create_x32("WPIACNT1", 0600, parent, (u32 *)0xFFE07084);
		debugfs_create_x32("WPIACNT2", 0600, parent, (u32 *)0xFFE07088);
		debugfs_create_x32("WPIACNT3", 0600, parent, (u32 *)0xFFE0708C);
		debugfs_create_x32("WPIACNT4", 0600, parent, (u32 *)0xFFE07090);
		debugfs_create_x32("WPIACNT5", 0600, parent, (u32 *)0xFFE07094);
		debugfs_create_x32("WPIACTL", 0600, parent, (u32 *)0xFFE07000);
		debugfs_create_x32("WPSTAT", 0600, parent, (u32 *)0xFFE07200);

	}	/* BF547 */

#ifdef __ADSPBF548__
# define USE_BF548 1
#else
# define USE_BF548 0
#endif
	if (USE_BF548) {

		parent = debugfs_create_dir("ATAPI", top);
		debugfs_create_x16("ATAPI_CONTROL", 0600, parent, (u16 *)0xFFC03800);
		debugfs_create_x16("ATAPI_DEV_ADDR", 0600, parent, (u16 *)0xFFC03808);
		debugfs_create_x16("ATAPI_DEV_RXBUF", 0600, parent, (u16 *)0xFFC03810);
		debugfs_create_x16("ATAPI_DEV_TXBUF", 0600, parent, (u16 *)0xFFC0380C);
		debugfs_create_x16("ATAPI_DMA_TFRCNT", 0600, parent, (u16 *)0xFFC03830);
		debugfs_create_x16("ATAPI_INT_MASK", 0600, parent, (u16 *)0xFFC03814);
		debugfs_create_x16("ATAPI_INT_STATUS", 0600, parent, (u16 *)0xFFC03818);
		debugfs_create_x16("ATAPI_LINE_STATUS", 0600, parent, (u16 *)0xFFC03820);
		debugfs_create_x16("ATAPI_MULTI_TIM_0", 0600, parent, (u16 *)0xFFC03850);
		debugfs_create_x16("ATAPI_MULTI_TIM_1", 0600, parent, (u16 *)0xFFC03854);
		debugfs_create_x16("ATAPI_MULTI_TIM_2", 0600, parent, (u16 *)0xFFC03858);
		debugfs_create_x16("ATAPI_PIO_TFRCNT", 0600, parent, (u16 *)0xFFC0382C);
		debugfs_create_x16("ATAPI_PIO_TIM_0", 0600, parent, (u16 *)0xFFC03844);
		debugfs_create_x16("ATAPI_PIO_TIM_1", 0600, parent, (u16 *)0xFFC03848);
		debugfs_create_x16("ATAPI_REG_TIM_0", 0600, parent, (u16 *)0xFFC03840);
		debugfs_create_x16("ATAPI_SM_STATE", 0600, parent, (u16 *)0xFFC03824);
		debugfs_create_x16("ATAPI_STATUS", 0600, parent, (u16 *)0xFFC03804);
		debugfs_create_x16("ATAPI_TERMINATE", 0600, parent, (u16 *)0xFFC03828);
		debugfs_create_x16("ATAPI_UDMAOUT_TFRCNT", 0600, parent, (u16 *)0xFFC03838);
		debugfs_create_x16("ATAPI_ULTRA_TIM_0", 0600, parent, (u16 *)0xFFC03860);
		debugfs_create_x16("ATAPI_ULTRA_TIM_1", 0600, parent, (u16 *)0xFFC03864);
		debugfs_create_x16("ATAPI_ULTRA_TIM_2", 0600, parent, (u16 *)0xFFC03868);
		debugfs_create_x16("ATAPI_ULTRA_TIM_3", 0600, parent, (u16 *)0xFFC0386C);
		debugfs_create_x16("ATAPI_UMAIN_TFRCNT", 0600, parent, (u16 *)0xFFC03834);
		debugfs_create_x16("ATAPI_XFER_LEN", 0600, parent, (u16 *)0xFFC0381C);

		parent = debugfs_create_dir("CAN0 Acceptance Mask RAM", top);
		debugfs_create_x16("CAN0_AM00H", 0600, parent, (u16 *)0xFFC02B04);
		debugfs_create_x16("CAN0_AM00L", 0600, parent, (u16 *)0xFFC02B00);
		debugfs_create_x16("CAN0_AM01H", 0600, parent, (u16 *)0xFFC02B0C);
		debugfs_create_x16("CAN0_AM01L", 0600, parent, (u16 *)0xFFC02B08);
		debugfs_create_x16("CAN0_AM02H", 0600, parent, (u16 *)0xFFC02B14);
		debugfs_create_x16("CAN0_AM02L", 0600, parent, (u16 *)0xFFC02B10);
		debugfs_create_x16("CAN0_AM03H", 0600, parent, (u16 *)0xFFC02B1C);
		debugfs_create_x16("CAN0_AM03L", 0600, parent, (u16 *)0xFFC02B18);
		debugfs_create_x16("CAN0_AM04H", 0600, parent, (u16 *)0xFFC02B24);
		debugfs_create_x16("CAN0_AM04L", 0600, parent, (u16 *)0xFFC02B20);
		debugfs_create_x16("CAN0_AM05H", 0600, parent, (u16 *)0xFFC02B2C);
		debugfs_create_x16("CAN0_AM05L", 0600, parent, (u16 *)0xFFC02B28);
		debugfs_create_x16("CAN0_AM06H", 0600, parent, (u16 *)0xFFC02B34);
		debugfs_create_x16("CAN0_AM06L", 0600, parent, (u16 *)0xFFC02B30);
		debugfs_create_x16("CAN0_AM07H", 0600, parent, (u16 *)0xFFC02B3C);
		debugfs_create_x16("CAN0_AM07L", 0600, parent, (u16 *)0xFFC02B38);
		debugfs_create_x16("CAN0_AM08H", 0600, parent, (u16 *)0xFFC02B44);
		debugfs_create_x16("CAN0_AM08L", 0600, parent, (u16 *)0xFFC02B40);
		debugfs_create_x16("CAN0_AM09H", 0600, parent, (u16 *)0xFFC02B4C);
		debugfs_create_x16("CAN0_AM09L", 0600, parent, (u16 *)0xFFC02B48);
		debugfs_create_x16("CAN0_AM10H", 0600, parent, (u16 *)0xFFC02B54);
		debugfs_create_x16("CAN0_AM10L", 0600, parent, (u16 *)0xFFC02B50);
		debugfs_create_x16("CAN0_AM11H", 0600, parent, (u16 *)0xFFC02B5C);
		debugfs_create_x16("CAN0_AM11L", 0600, parent, (u16 *)0xFFC02B58);
		debugfs_create_x16("CAN0_AM12H", 0600, parent, (u16 *)0xFFC02B64);
		debugfs_create_x16("CAN0_AM12L", 0600, parent, (u16 *)0xFFC02B60);
		debugfs_create_x16("CAN0_AM13H", 0600, parent, (u16 *)0xFFC02B6C);
		debugfs_create_x16("CAN0_AM13L", 0600, parent, (u16 *)0xFFC02B68);
		debugfs_create_x16("CAN0_AM14H", 0600, parent, (u16 *)0xFFC02B74);
		debugfs_create_x16("CAN0_AM14L", 0600, parent, (u16 *)0xFFC02B70);
		debugfs_create_x16("CAN0_AM15H", 0600, parent, (u16 *)0xFFC02B7C);
		debugfs_create_x16("CAN0_AM15L", 0600, parent, (u16 *)0xFFC02B78);
		debugfs_create_x16("CAN0_AM16H", 0600, parent, (u16 *)0xFFC02B84);
		debugfs_create_x16("CAN0_AM16L", 0600, parent, (u16 *)0xFFC02B80);
		debugfs_create_x16("CAN0_AM17H", 0600, parent, (u16 *)0xFFC02B8C);
		debugfs_create_x16("CAN0_AM17L", 0600, parent, (u16 *)0xFFC02B88);
		debugfs_create_x16("CAN0_AM18H", 0600, parent, (u16 *)0xFFC02B94);
		debugfs_create_x16("CAN0_AM18L", 0600, parent, (u16 *)0xFFC02B90);
		debugfs_create_x16("CAN0_AM19H", 0600, parent, (u16 *)0xFFC02B9C);
		debugfs_create_x16("CAN0_AM19L", 0600, parent, (u16 *)0xFFC02B98);
		debugfs_create_x16("CAN0_AM20H", 0600, parent, (u16 *)0xFFC02BA4);
		debugfs_create_x16("CAN0_AM20L", 0600, parent, (u16 *)0xFFC02BA0);
		debugfs_create_x16("CAN0_AM21H", 0600, parent, (u16 *)0xFFC02BAC);
		debugfs_create_x16("CAN0_AM21L", 0600, parent, (u16 *)0xFFC02BA8);
		debugfs_create_x16("CAN0_AM22H", 0600, parent, (u16 *)0xFFC02BB4);
		debugfs_create_x16("CAN0_AM22L", 0600, parent, (u16 *)0xFFC02BB0);
		debugfs_create_x16("CAN0_AM23H", 0600, parent, (u16 *)0xFFC02BBC);
		debugfs_create_x16("CAN0_AM23L", 0600, parent, (u16 *)0xFFC02BB8);
		debugfs_create_x16("CAN0_AM24H", 0600, parent, (u16 *)0xFFC02BC4);
		debugfs_create_x16("CAN0_AM24L", 0600, parent, (u16 *)0xFFC02BC0);
		debugfs_create_x16("CAN0_AM25H", 0600, parent, (u16 *)0xFFC02BCC);
		debugfs_create_x16("CAN0_AM25L", 0600, parent, (u16 *)0xFFC02BC8);
		debugfs_create_x16("CAN0_AM26H", 0600, parent, (u16 *)0xFFC02BD4);
		debugfs_create_x16("CAN0_AM26L", 0600, parent, (u16 *)0xFFC02BD0);
		debugfs_create_x16("CAN0_AM27H", 0600, parent, (u16 *)0xFFC02BDC);
		debugfs_create_x16("CAN0_AM27L", 0600, parent, (u16 *)0xFFC02BD8);
		debugfs_create_x16("CAN0_AM28H", 0600, parent, (u16 *)0xFFC02BE4);
		debugfs_create_x16("CAN0_AM28L", 0600, parent, (u16 *)0xFFC02BE0);
		debugfs_create_x16("CAN0_AM29H", 0600, parent, (u16 *)0xFFC02BEC);
		debugfs_create_x16("CAN0_AM29L", 0600, parent, (u16 *)0xFFC02BE8);
		debugfs_create_x16("CAN0_AM30H", 0600, parent, (u16 *)0xFFC02BF4);
		debugfs_create_x16("CAN0_AM30L", 0600, parent, (u16 *)0xFFC02BF0);
		debugfs_create_x16("CAN0_AM31H", 0600, parent, (u16 *)0xFFC02BFC);
		debugfs_create_x16("CAN0_AM31L", 0600, parent, (u16 *)0xFFC02BF8);

		parent = debugfs_create_dir("CAN0 Control and Status", top);
		debugfs_create_x16("CAN0_AA1", 0600, parent, (u16 *)0xFFC02A14);
		debugfs_create_x16("CAN0_AA2", 0600, parent, (u16 *)0xFFC02A54);
		debugfs_create_x16("CAN0_CEC", 0600, parent, (u16 *)0xFFC02A90);
		debugfs_create_x16("CAN0_CLOCK", 0600, parent, (u16 *)0xFFC02A80);
		debugfs_create_x16("CAN0_CONTROL", 0600, parent, (u16 *)0xFFC02AA0);
		debugfs_create_x16("CAN0_DEBUG", 0600, parent, (u16 *)0xFFC02A88);
		debugfs_create_x16("CAN0_ESR", 0600, parent, (u16 *)0xFFC02AB4);
		debugfs_create_x16("CAN0_EWR", 0600, parent, (u16 *)0xFFC02AB0);
		debugfs_create_x16("CAN0_GIF", 0600, parent, (u16 *)0xFFC02A9C);
		debugfs_create_x16("CAN0_GIM", 0600, parent, (u16 *)0xFFC02A98);
		debugfs_create_x16("CAN0_GIS", 0600, parent, (u16 *)0xFFC02A94);
		debugfs_create_x16("CAN0_INTR", 0600, parent, (u16 *)0xFFC02AA4);
		debugfs_create_x16("CAN0_MBIM1", 0600, parent, (u16 *)0xFFC02A28);
		debugfs_create_x16("CAN0_MBIM2", 0600, parent, (u16 *)0xFFC02A68);
		debugfs_create_x16("CAN0_MBRIF1", 0600, parent, (u16 *)0xFFC02A24);
		debugfs_create_x16("CAN0_MBRIF2", 0600, parent, (u16 *)0xFFC02A64);
		debugfs_create_x16("CAN0_MBTD", 0600, parent, (u16 *)0xFFC02AAC);
		debugfs_create_x16("CAN0_MBTIF1", 0600, parent, (u16 *)0xFFC02A20);
		debugfs_create_x16("CAN0_MBTIF2", 0600, parent, (u16 *)0xFFC02A60);
		debugfs_create_x16("CAN0_MC1", 0600, parent, (u16 *)0xFFC02A00);
		debugfs_create_x16("CAN0_MC2", 0600, parent, (u16 *)0xFFC02A40);
		debugfs_create_x16("CAN0_MD1", 0600, parent, (u16 *)0xFFC02A04);
		debugfs_create_x16("CAN0_MD2", 0600, parent, (u16 *)0xFFC02A44);
		debugfs_create_x16("CAN0_OPSS1", 0600, parent, (u16 *)0xFFC02A30);
		debugfs_create_x16("CAN0_OPSS2", 0600, parent, (u16 *)0xFFC02A70);
		debugfs_create_x16("CAN0_RFH1", 0600, parent, (u16 *)0xFFC02A2C);
		debugfs_create_x16("CAN0_RFH2", 0600, parent, (u16 *)0xFFC02A6C);
		debugfs_create_x16("CAN0_RML1", 0600, parent, (u16 *)0xFFC02A1C);
		debugfs_create_x16("CAN0_RML2", 0600, parent, (u16 *)0xFFC02A5C);
		debugfs_create_x16("CAN0_RMP1", 0600, parent, (u16 *)0xFFC02A18);
		debugfs_create_x16("CAN0_RMP2", 0600, parent, (u16 *)0xFFC02A58);
		debugfs_create_x16("CAN0_STATUS", 0600, parent, (u16 *)0xFFC02A8C);
		debugfs_create_x16("CAN0_TA1", 0600, parent, (u16 *)0xFFC02A10);
		debugfs_create_x16("CAN0_TA2", 0600, parent, (u16 *)0xFFC02A50);
		debugfs_create_x16("CAN0_TIMING", 0600, parent, (u16 *)0xFFC02A84);
		debugfs_create_x16("CAN0_TRR1", 0600, parent, (u16 *)0xFFC02A0C);
		debugfs_create_x16("CAN0_TRR2", 0600, parent, (u16 *)0xFFC02A4C);
		debugfs_create_x16("CAN0_TRS1", 0600, parent, (u16 *)0xFFC02A08);
		debugfs_create_x16("CAN0_TRS2", 0600, parent, (u16 *)0xFFC02A48);
		debugfs_create_x16("CAN0_UCCNF", 0600, parent, (u16 *)0xFFC02ACC);
		debugfs_create_x16("CAN0_UCCNT", 0600, parent, (u16 *)0xFFC02AC4);
		debugfs_create_x16("CAN0_UCRC", 0600, parent, (u16 *)0xFFC02AC8);

		parent = debugfs_create_dir("CAN0 Mailbox RAM", top);
		debugfs_create_x16("CAN0_MB00_DATA0", 0600, parent, (u16 *)0xFFC02C00);
		debugfs_create_x16("CAN0_MB00_DATA1", 0600, parent, (u16 *)0xFFC02C04);
		debugfs_create_x16("CAN0_MB00_DATA2", 0600, parent, (u16 *)0xFFC02C08);
		debugfs_create_x16("CAN0_MB00_DATA3", 0600, parent, (u16 *)0xFFC02C0C);
		debugfs_create_x16("CAN0_MB00_ID0", 0600, parent, (u16 *)0xFFC02C18);
		debugfs_create_x16("CAN0_MB00_ID1", 0600, parent, (u16 *)0xFFC02C1C);
		debugfs_create_x16("CAN0_MB00_LENGTH", 0600, parent, (u16 *)0xFFC02C10);
		debugfs_create_x16("CAN0_MB00_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C14);
		debugfs_create_x16("CAN0_MB01_DATA0", 0600, parent, (u16 *)0xFFC02C20);
		debugfs_create_x16("CAN0_MB01_DATA1", 0600, parent, (u16 *)0xFFC02C24);
		debugfs_create_x16("CAN0_MB01_DATA2", 0600, parent, (u16 *)0xFFC02C28);
		debugfs_create_x16("CAN0_MB01_DATA3", 0600, parent, (u16 *)0xFFC02C2C);
		debugfs_create_x16("CAN0_MB01_ID0", 0600, parent, (u16 *)0xFFC02C38);
		debugfs_create_x16("CAN0_MB01_ID1", 0600, parent, (u16 *)0xFFC02C3C);
		debugfs_create_x16("CAN0_MB01_LENGTH", 0600, parent, (u16 *)0xFFC02C30);
		debugfs_create_x16("CAN0_MB01_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C34);
		debugfs_create_x16("CAN0_MB02_DATA0", 0600, parent, (u16 *)0xFFC02C40);
		debugfs_create_x16("CAN0_MB02_DATA1", 0600, parent, (u16 *)0xFFC02C44);
		debugfs_create_x16("CAN0_MB02_DATA2", 0600, parent, (u16 *)0xFFC02C48);
		debugfs_create_x16("CAN0_MB02_DATA3", 0600, parent, (u16 *)0xFFC02C4C);
		debugfs_create_x16("CAN0_MB02_ID0", 0600, parent, (u16 *)0xFFC02C58);
		debugfs_create_x16("CAN0_MB02_ID1", 0600, parent, (u16 *)0xFFC02C5C);
		debugfs_create_x16("CAN0_MB02_LENGTH", 0600, parent, (u16 *)0xFFC02C50);
		debugfs_create_x16("CAN0_MB02_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C54);
		debugfs_create_x16("CAN0_MB03_DATA0", 0600, parent, (u16 *)0xFFC02C60);
		debugfs_create_x16("CAN0_MB03_DATA1", 0600, parent, (u16 *)0xFFC02C64);
		debugfs_create_x16("CAN0_MB03_DATA2", 0600, parent, (u16 *)0xFFC02C68);
		debugfs_create_x16("CAN0_MB03_DATA3", 0600, parent, (u16 *)0xFFC02C6C);
		debugfs_create_x16("CAN0_MB03_ID0", 0600, parent, (u16 *)0xFFC02C78);
		debugfs_create_x16("CAN0_MB03_ID1", 0600, parent, (u16 *)0xFFC02C7C);
		debugfs_create_x16("CAN0_MB03_LENGTH", 0600, parent, (u16 *)0xFFC02C70);
		debugfs_create_x16("CAN0_MB03_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C74);
		debugfs_create_x16("CAN0_MB04_DATA0", 0600, parent, (u16 *)0xFFC02C80);
		debugfs_create_x16("CAN0_MB04_DATA1", 0600, parent, (u16 *)0xFFC02C84);
		debugfs_create_x16("CAN0_MB04_DATA2", 0600, parent, (u16 *)0xFFC02C88);
		debugfs_create_x16("CAN0_MB04_DATA3", 0600, parent, (u16 *)0xFFC02C8C);
		debugfs_create_x16("CAN0_MB04_ID0", 0600, parent, (u16 *)0xFFC02C98);
		debugfs_create_x16("CAN0_MB04_ID1", 0600, parent, (u16 *)0xFFC02C9C);
		debugfs_create_x16("CAN0_MB04_LENGTH", 0600, parent, (u16 *)0xFFC02C90);
		debugfs_create_x16("CAN0_MB04_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C94);
		debugfs_create_x16("CAN0_MB05_DATA0", 0600, parent, (u16 *)0xFFC02CA0);
		debugfs_create_x16("CAN0_MB05_DATA1", 0600, parent, (u16 *)0xFFC02CA4);
		debugfs_create_x16("CAN0_MB05_DATA2", 0600, parent, (u16 *)0xFFC02CA8);
		debugfs_create_x16("CAN0_MB05_DATA3", 0600, parent, (u16 *)0xFFC02CAC);
		debugfs_create_x16("CAN0_MB05_ID0", 0600, parent, (u16 *)0xFFC02CB8);
		debugfs_create_x16("CAN0_MB05_ID1", 0600, parent, (u16 *)0xFFC02CBC);
		debugfs_create_x16("CAN0_MB05_LENGTH", 0600, parent, (u16 *)0xFFC02CB0);
		debugfs_create_x16("CAN0_MB05_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CB4);
		debugfs_create_x16("CAN0_MB06_DATA0", 0600, parent, (u16 *)0xFFC02CC0);
		debugfs_create_x16("CAN0_MB06_DATA1", 0600, parent, (u16 *)0xFFC02CC4);
		debugfs_create_x16("CAN0_MB06_DATA2", 0600, parent, (u16 *)0xFFC02CC8);
		debugfs_create_x16("CAN0_MB06_DATA3", 0600, parent, (u16 *)0xFFC02CCC);
		debugfs_create_x16("CAN0_MB06_ID0", 0600, parent, (u16 *)0xFFC02CD8);
		debugfs_create_x16("CAN0_MB06_ID1", 0600, parent, (u16 *)0xFFC02CDC);
		debugfs_create_x16("CAN0_MB06_LENGTH", 0600, parent, (u16 *)0xFFC02CD0);
		debugfs_create_x16("CAN0_MB06_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CD4);
		debugfs_create_x16("CAN0_MB07_DATA0", 0600, parent, (u16 *)0xFFC02CE0);
		debugfs_create_x16("CAN0_MB07_DATA1", 0600, parent, (u16 *)0xFFC02CE4);
		debugfs_create_x16("CAN0_MB07_DATA2", 0600, parent, (u16 *)0xFFC02CE8);
		debugfs_create_x16("CAN0_MB07_DATA3", 0600, parent, (u16 *)0xFFC02CEC);
		debugfs_create_x16("CAN0_MB07_ID0", 0600, parent, (u16 *)0xFFC02CF8);
		debugfs_create_x16("CAN0_MB07_ID1", 0600, parent, (u16 *)0xFFC02CFC);
		debugfs_create_x16("CAN0_MB07_LENGTH", 0600, parent, (u16 *)0xFFC02CF0);
		debugfs_create_x16("CAN0_MB07_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CF4);
		debugfs_create_x16("CAN0_MB08_DATA0", 0600, parent, (u16 *)0xFFC02D00);
		debugfs_create_x16("CAN0_MB08_DATA1", 0600, parent, (u16 *)0xFFC02D04);
		debugfs_create_x16("CAN0_MB08_DATA2", 0600, parent, (u16 *)0xFFC02D08);
		debugfs_create_x16("CAN0_MB08_DATA3", 0600, parent, (u16 *)0xFFC02D0C);
		debugfs_create_x16("CAN0_MB08_ID0", 0600, parent, (u16 *)0xFFC02D18);
		debugfs_create_x16("CAN0_MB08_ID1", 0600, parent, (u16 *)0xFFC02D1C);
		debugfs_create_x16("CAN0_MB08_LENGTH", 0600, parent, (u16 *)0xFFC02D10);
		debugfs_create_x16("CAN0_MB08_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D14);
		debugfs_create_x16("CAN0_MB09_DATA0", 0600, parent, (u16 *)0xFFC02D20);
		debugfs_create_x16("CAN0_MB09_DATA1", 0600, parent, (u16 *)0xFFC02D24);
		debugfs_create_x16("CAN0_MB09_DATA2", 0600, parent, (u16 *)0xFFC02D28);
		debugfs_create_x16("CAN0_MB09_DATA3", 0600, parent, (u16 *)0xFFC02D2C);
		debugfs_create_x16("CAN0_MB09_ID0", 0600, parent, (u16 *)0xFFC02D38);
		debugfs_create_x16("CAN0_MB09_ID1", 0600, parent, (u16 *)0xFFC02D3C);
		debugfs_create_x16("CAN0_MB09_LENGTH", 0600, parent, (u16 *)0xFFC02D30);
		debugfs_create_x16("CAN0_MB09_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D34);
		debugfs_create_x16("CAN0_MB10_DATA0", 0600, parent, (u16 *)0xFFC02D40);
		debugfs_create_x16("CAN0_MB10_DATA1", 0600, parent, (u16 *)0xFFC02D44);
		debugfs_create_x16("CAN0_MB10_DATA2", 0600, parent, (u16 *)0xFFC02D48);
		debugfs_create_x16("CAN0_MB10_DATA3", 0600, parent, (u16 *)0xFFC02D4C);
		debugfs_create_x16("CAN0_MB10_ID0", 0600, parent, (u16 *)0xFFC02D58);
		debugfs_create_x16("CAN0_MB10_ID1", 0600, parent, (u16 *)0xFFC02D5C);
		debugfs_create_x16("CAN0_MB10_LENGTH", 0600, parent, (u16 *)0xFFC02D50);
		debugfs_create_x16("CAN0_MB10_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D54);
		debugfs_create_x16("CAN0_MB11_DATA0", 0600, parent, (u16 *)0xFFC02D60);
		debugfs_create_x16("CAN0_MB11_DATA1", 0600, parent, (u16 *)0xFFC02D64);
		debugfs_create_x16("CAN0_MB11_DATA2", 0600, parent, (u16 *)0xFFC02D68);
		debugfs_create_x16("CAN0_MB11_DATA3", 0600, parent, (u16 *)0xFFC02D6C);
		debugfs_create_x16("CAN0_MB11_ID0", 0600, parent, (u16 *)0xFFC02D78);
		debugfs_create_x16("CAN0_MB11_ID1", 0600, parent, (u16 *)0xFFC02D7C);
		debugfs_create_x16("CAN0_MB11_LENGTH", 0600, parent, (u16 *)0xFFC02D70);
		debugfs_create_x16("CAN0_MB11_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D74);
		debugfs_create_x16("CAN0_MB12_DATA0", 0600, parent, (u16 *)0xFFC02D80);
		debugfs_create_x16("CAN0_MB12_DATA1", 0600, parent, (u16 *)0xFFC02D84);
		debugfs_create_x16("CAN0_MB12_DATA2", 0600, parent, (u16 *)0xFFC02D88);
		debugfs_create_x16("CAN0_MB12_DATA3", 0600, parent, (u16 *)0xFFC02D8C);
		debugfs_create_x16("CAN0_MB12_ID0", 0600, parent, (u16 *)0xFFC02D98);
		debugfs_create_x16("CAN0_MB12_ID1", 0600, parent, (u16 *)0xFFC02D9C);
		debugfs_create_x16("CAN0_MB12_LENGTH", 0600, parent, (u16 *)0xFFC02D90);
		debugfs_create_x16("CAN0_MB12_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D94);
		debugfs_create_x16("CAN0_MB13_DATA0", 0600, parent, (u16 *)0xFFC02DA0);
		debugfs_create_x16("CAN0_MB13_DATA1", 0600, parent, (u16 *)0xFFC02DA4);
		debugfs_create_x16("CAN0_MB13_DATA2", 0600, parent, (u16 *)0xFFC02DA8);
		debugfs_create_x16("CAN0_MB13_DATA3", 0600, parent, (u16 *)0xFFC02DAC);
		debugfs_create_x16("CAN0_MB13_ID0", 0600, parent, (u16 *)0xFFC02DB8);
		debugfs_create_x16("CAN0_MB13_ID1", 0600, parent, (u16 *)0xFFC02DBC);
		debugfs_create_x16("CAN0_MB13_LENGTH", 0600, parent, (u16 *)0xFFC02DB0);
		debugfs_create_x16("CAN0_MB13_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DB4);
		debugfs_create_x16("CAN0_MB14_DATA0", 0600, parent, (u16 *)0xFFC02DC0);
		debugfs_create_x16("CAN0_MB14_DATA1", 0600, parent, (u16 *)0xFFC02DC4);
		debugfs_create_x16("CAN0_MB14_DATA2", 0600, parent, (u16 *)0xFFC02DC8);
		debugfs_create_x16("CAN0_MB14_DATA3", 0600, parent, (u16 *)0xFFC02DCC);
		debugfs_create_x16("CAN0_MB14_ID0", 0600, parent, (u16 *)0xFFC02DD8);
		debugfs_create_x16("CAN0_MB14_ID1", 0600, parent, (u16 *)0xFFC02DDC);
		debugfs_create_x16("CAN0_MB14_LENGTH", 0600, parent, (u16 *)0xFFC02DD0);
		debugfs_create_x16("CAN0_MB14_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DD4);
		debugfs_create_x16("CAN0_MB15_DATA0", 0600, parent, (u16 *)0xFFC02DE0);
		debugfs_create_x16("CAN0_MB15_DATA1", 0600, parent, (u16 *)0xFFC02DE4);
		debugfs_create_x16("CAN0_MB15_DATA2", 0600, parent, (u16 *)0xFFC02DE8);
		debugfs_create_x16("CAN0_MB15_DATA3", 0600, parent, (u16 *)0xFFC02DEC);
		debugfs_create_x16("CAN0_MB15_ID0", 0600, parent, (u16 *)0xFFC02DF8);
		debugfs_create_x16("CAN0_MB15_ID1", 0600, parent, (u16 *)0xFFC02DFC);
		debugfs_create_x16("CAN0_MB15_LENGTH", 0600, parent, (u16 *)0xFFC02DF0);
		debugfs_create_x16("CAN0_MB15_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DF4);
		debugfs_create_x16("CAN0_MB16_DATA0", 0600, parent, (u16 *)0xFFC02E00);
		debugfs_create_x16("CAN0_MB16_DATA1", 0600, parent, (u16 *)0xFFC02E04);
		debugfs_create_x16("CAN0_MB16_DATA2", 0600, parent, (u16 *)0xFFC02E08);
		debugfs_create_x16("CAN0_MB16_DATA3", 0600, parent, (u16 *)0xFFC02E0C);
		debugfs_create_x16("CAN0_MB16_ID0", 0600, parent, (u16 *)0xFFC02E18);
		debugfs_create_x16("CAN0_MB16_ID1", 0600, parent, (u16 *)0xFFC02E1C);
		debugfs_create_x16("CAN0_MB16_LENGTH", 0600, parent, (u16 *)0xFFC02E10);
		debugfs_create_x16("CAN0_MB16_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E14);
		debugfs_create_x16("CAN0_MB17_DATA0", 0600, parent, (u16 *)0xFFC02E20);
		debugfs_create_x16("CAN0_MB17_DATA1", 0600, parent, (u16 *)0xFFC02E24);
		debugfs_create_x16("CAN0_MB17_DATA2", 0600, parent, (u16 *)0xFFC02E28);
		debugfs_create_x16("CAN0_MB17_DATA3", 0600, parent, (u16 *)0xFFC02E2C);
		debugfs_create_x16("CAN0_MB17_ID0", 0600, parent, (u16 *)0xFFC02E38);
		debugfs_create_x16("CAN0_MB17_ID1", 0600, parent, (u16 *)0xFFC02E3C);
		debugfs_create_x16("CAN0_MB17_LENGTH", 0600, parent, (u16 *)0xFFC02E30);
		debugfs_create_x16("CAN0_MB17_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E34);
		debugfs_create_x16("CAN0_MB18_DATA0", 0600, parent, (u16 *)0xFFC02E40);
		debugfs_create_x16("CAN0_MB18_DATA1", 0600, parent, (u16 *)0xFFC02E44);
		debugfs_create_x16("CAN0_MB18_DATA2", 0600, parent, (u16 *)0xFFC02E48);
		debugfs_create_x16("CAN0_MB18_DATA3", 0600, parent, (u16 *)0xFFC02E4C);
		debugfs_create_x16("CAN0_MB18_ID0", 0600, parent, (u16 *)0xFFC02E58);
		debugfs_create_x16("CAN0_MB18_ID1", 0600, parent, (u16 *)0xFFC02E5C);
		debugfs_create_x16("CAN0_MB18_LENGTH", 0600, parent, (u16 *)0xFFC02E50);
		debugfs_create_x16("CAN0_MB18_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E54);
		debugfs_create_x16("CAN0_MB19_DATA0", 0600, parent, (u16 *)0xFFC02E60);
		debugfs_create_x16("CAN0_MB19_DATA1", 0600, parent, (u16 *)0xFFC02E64);
		debugfs_create_x16("CAN0_MB19_DATA2", 0600, parent, (u16 *)0xFFC02E68);
		debugfs_create_x16("CAN0_MB19_DATA3", 0600, parent, (u16 *)0xFFC02E6C);
		debugfs_create_x16("CAN0_MB19_ID0", 0600, parent, (u16 *)0xFFC02E78);
		debugfs_create_x16("CAN0_MB19_ID1", 0600, parent, (u16 *)0xFFC02E7C);
		debugfs_create_x16("CAN0_MB19_LENGTH", 0600, parent, (u16 *)0xFFC02E70);
		debugfs_create_x16("CAN0_MB19_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E74);
		debugfs_create_x16("CAN0_MB20_DATA0", 0600, parent, (u16 *)0xFFC02E80);
		debugfs_create_x16("CAN0_MB20_DATA1", 0600, parent, (u16 *)0xFFC02E84);
		debugfs_create_x16("CAN0_MB20_DATA2", 0600, parent, (u16 *)0xFFC02E88);
		debugfs_create_x16("CAN0_MB20_DATA3", 0600, parent, (u16 *)0xFFC02E8C);
		debugfs_create_x16("CAN0_MB20_ID0", 0600, parent, (u16 *)0xFFC02E98);
		debugfs_create_x16("CAN0_MB20_ID1", 0600, parent, (u16 *)0xFFC02E9C);
		debugfs_create_x16("CAN0_MB20_LENGTH", 0600, parent, (u16 *)0xFFC02E90);
		debugfs_create_x16("CAN0_MB20_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E94);
		debugfs_create_x16("CAN0_MB21_DATA0", 0600, parent, (u16 *)0xFFC02EA0);
		debugfs_create_x16("CAN0_MB21_DATA1", 0600, parent, (u16 *)0xFFC02EA4);
		debugfs_create_x16("CAN0_MB21_DATA2", 0600, parent, (u16 *)0xFFC02EA8);
		debugfs_create_x16("CAN0_MB21_DATA3", 0600, parent, (u16 *)0xFFC02EAC);
		debugfs_create_x16("CAN0_MB21_ID0", 0600, parent, (u16 *)0xFFC02EB8);
		debugfs_create_x16("CAN0_MB21_ID1", 0600, parent, (u16 *)0xFFC02EBC);
		debugfs_create_x16("CAN0_MB21_LENGTH", 0600, parent, (u16 *)0xFFC02EB0);
		debugfs_create_x16("CAN0_MB21_TIMESTAMP", 0600, parent, (u16 *)0xFFC02EB4);
		debugfs_create_x16("CAN0_MB22_DATA0", 0600, parent, (u16 *)0xFFC02EC0);
		debugfs_create_x16("CAN0_MB22_DATA1", 0600, parent, (u16 *)0xFFC02EC4);
		debugfs_create_x16("CAN0_MB22_DATA2", 0600, parent, (u16 *)0xFFC02EC8);
		debugfs_create_x16("CAN0_MB22_DATA3", 0600, parent, (u16 *)0xFFC02ECC);
		debugfs_create_x16("CAN0_MB22_ID0", 0600, parent, (u16 *)0xFFC02ED8);
		debugfs_create_x16("CAN0_MB22_ID1", 0600, parent, (u16 *)0xFFC02EDC);
		debugfs_create_x16("CAN0_MB22_LENGTH", 0600, parent, (u16 *)0xFFC02ED0);
		debugfs_create_x16("CAN0_MB22_TIMESTAMP", 0600, parent, (u16 *)0xFFC02ED4);
		debugfs_create_x16("CAN0_MB23_DATA0", 0600, parent, (u16 *)0xFFC02EE0);
		debugfs_create_x16("CAN0_MB23_DATA1", 0600, parent, (u16 *)0xFFC02EE4);
		debugfs_create_x16("CAN0_MB23_DATA2", 0600, parent, (u16 *)0xFFC02EE8);
		debugfs_create_x16("CAN0_MB23_DATA3", 0600, parent, (u16 *)0xFFC02EEC);
		debugfs_create_x16("CAN0_MB23_ID0", 0600, parent, (u16 *)0xFFC02EF8);
		debugfs_create_x16("CAN0_MB23_ID1", 0600, parent, (u16 *)0xFFC02EFC);
		debugfs_create_x16("CAN0_MB23_LENGTH", 0600, parent, (u16 *)0xFFC02EF0);
		debugfs_create_x16("CAN0_MB23_TIMESTAMP", 0600, parent, (u16 *)0xFFC02EF4);
		debugfs_create_x16("CAN0_MB24_DATA0", 0600, parent, (u16 *)0xFFC02F00);
		debugfs_create_x16("CAN0_MB24_DATA1", 0600, parent, (u16 *)0xFFC02F04);
		debugfs_create_x16("CAN0_MB24_DATA2", 0600, parent, (u16 *)0xFFC02F08);
		debugfs_create_x16("CAN0_MB24_DATA3", 0600, parent, (u16 *)0xFFC02F0C);
		debugfs_create_x16("CAN0_MB24_ID0", 0600, parent, (u16 *)0xFFC02F18);
		debugfs_create_x16("CAN0_MB24_ID1", 0600, parent, (u16 *)0xFFC02F1C);
		debugfs_create_x16("CAN0_MB24_LENGTH", 0600, parent, (u16 *)0xFFC02F10);
		debugfs_create_x16("CAN0_MB24_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F14);
		debugfs_create_x16("CAN0_MB25_DATA0", 0600, parent, (u16 *)0xFFC02F20);
		debugfs_create_x16("CAN0_MB25_DATA1", 0600, parent, (u16 *)0xFFC02F24);
		debugfs_create_x16("CAN0_MB25_DATA2", 0600, parent, (u16 *)0xFFC02F28);
		debugfs_create_x16("CAN0_MB25_DATA3", 0600, parent, (u16 *)0xFFC02F2C);
		debugfs_create_x16("CAN0_MB25_ID0", 0600, parent, (u16 *)0xFFC02F38);
		debugfs_create_x16("CAN0_MB25_ID1", 0600, parent, (u16 *)0xFFC02F3C);
		debugfs_create_x16("CAN0_MB25_LENGTH", 0600, parent, (u16 *)0xFFC02F30);
		debugfs_create_x16("CAN0_MB25_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F34);
		debugfs_create_x16("CAN0_MB26_DATA0", 0600, parent, (u16 *)0xFFC02F40);
		debugfs_create_x16("CAN0_MB26_DATA1", 0600, parent, (u16 *)0xFFC02F44);
		debugfs_create_x16("CAN0_MB26_DATA2", 0600, parent, (u16 *)0xFFC02F48);
		debugfs_create_x16("CAN0_MB26_DATA3", 0600, parent, (u16 *)0xFFC02F4C);
		debugfs_create_x16("CAN0_MB26_ID0", 0600, parent, (u16 *)0xFFC02F58);
		debugfs_create_x16("CAN0_MB26_ID1", 0600, parent, (u16 *)0xFFC02F5C);
		debugfs_create_x16("CAN0_MB26_LENGTH", 0600, parent, (u16 *)0xFFC02F50);
		debugfs_create_x16("CAN0_MB26_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F54);
		debugfs_create_x16("CAN0_MB27_DATA0", 0600, parent, (u16 *)0xFFC02F60);
		debugfs_create_x16("CAN0_MB27_DATA1", 0600, parent, (u16 *)0xFFC02F64);
		debugfs_create_x16("CAN0_MB27_DATA2", 0600, parent, (u16 *)0xFFC02F68);
		debugfs_create_x16("CAN0_MB27_DATA3", 0600, parent, (u16 *)0xFFC02F6C);
		debugfs_create_x16("CAN0_MB27_ID0", 0600, parent, (u16 *)0xFFC02F78);
		debugfs_create_x16("CAN0_MB27_ID1", 0600, parent, (u16 *)0xFFC02F7C);
		debugfs_create_x16("CAN0_MB27_LENGTH", 0600, parent, (u16 *)0xFFC02F70);
		debugfs_create_x16("CAN0_MB27_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F74);
		debugfs_create_x16("CAN0_MB28_DATA0", 0600, parent, (u16 *)0xFFC02F80);
		debugfs_create_x16("CAN0_MB28_DATA1", 0600, parent, (u16 *)0xFFC02F84);
		debugfs_create_x16("CAN0_MB28_DATA2", 0600, parent, (u16 *)0xFFC02F88);
		debugfs_create_x16("CAN0_MB28_DATA3", 0600, parent, (u16 *)0xFFC02F8C);
		debugfs_create_x16("CAN0_MB28_ID0", 0600, parent, (u16 *)0xFFC02F98);
		debugfs_create_x16("CAN0_MB28_ID1", 0600, parent, (u16 *)0xFFC02F9C);
		debugfs_create_x16("CAN0_MB28_LENGTH", 0600, parent, (u16 *)0xFFC02F90);
		debugfs_create_x16("CAN0_MB28_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F94);
		debugfs_create_x16("CAN0_MB29_DATA0", 0600, parent, (u16 *)0xFFC02FA0);
		debugfs_create_x16("CAN0_MB29_DATA1", 0600, parent, (u16 *)0xFFC02FA4);
		debugfs_create_x16("CAN0_MB29_DATA2", 0600, parent, (u16 *)0xFFC02FA8);
		debugfs_create_x16("CAN0_MB29_DATA3", 0600, parent, (u16 *)0xFFC02FAC);
		debugfs_create_x16("CAN0_MB29_ID0", 0600, parent, (u16 *)0xFFC02FB8);
		debugfs_create_x16("CAN0_MB29_ID1", 0600, parent, (u16 *)0xFFC02FBC);
		debugfs_create_x16("CAN0_MB29_LENGTH", 0600, parent, (u16 *)0xFFC02FB0);
		debugfs_create_x16("CAN0_MB29_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FB4);
		debugfs_create_x16("CAN0_MB30_DATA0", 0600, parent, (u16 *)0xFFC02FC0);
		debugfs_create_x16("CAN0_MB30_DATA1", 0600, parent, (u16 *)0xFFC02FC4);
		debugfs_create_x16("CAN0_MB30_DATA2", 0600, parent, (u16 *)0xFFC02FC8);
		debugfs_create_x16("CAN0_MB30_DATA3", 0600, parent, (u16 *)0xFFC02FCC);
		debugfs_create_x16("CAN0_MB30_ID0", 0600, parent, (u16 *)0xFFC02FD8);
		debugfs_create_x16("CAN0_MB30_ID1", 0600, parent, (u16 *)0xFFC02FDC);
		debugfs_create_x16("CAN0_MB30_LENGTH", 0600, parent, (u16 *)0xFFC02FD0);
		debugfs_create_x16("CAN0_MB30_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FD4);
		debugfs_create_x16("CAN0_MB31_DATA0", 0600, parent, (u16 *)0xFFC02FE0);
		debugfs_create_x16("CAN0_MB31_DATA1", 0600, parent, (u16 *)0xFFC02FE4);
		debugfs_create_x16("CAN0_MB31_DATA2", 0600, parent, (u16 *)0xFFC02FE8);
		debugfs_create_x16("CAN0_MB31_DATA3", 0600, parent, (u16 *)0xFFC02FEC);
		debugfs_create_x16("CAN0_MB31_ID0", 0600, parent, (u16 *)0xFFC02FF8);
		debugfs_create_x16("CAN0_MB31_ID1", 0600, parent, (u16 *)0xFFC02FFC);
		debugfs_create_x16("CAN0_MB31_LENGTH", 0600, parent, (u16 *)0xFFC02FF0);
		debugfs_create_x16("CAN0_MB31_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FF4);

		parent = debugfs_create_dir("CAN1 Acceptance Mask RAM", top);
		debugfs_create_x16("CAN1_AM00H", 0600, parent, (u16 *)0xFFC03304);
		debugfs_create_x16("CAN1_AM00L", 0600, parent, (u16 *)0xFFC03300);
		debugfs_create_x16("CAN1_AM01H", 0600, parent, (u16 *)0xFFC0330C);
		debugfs_create_x16("CAN1_AM01L", 0600, parent, (u16 *)0xFFC03308);
		debugfs_create_x16("CAN1_AM02H", 0600, parent, (u16 *)0xFFC03314);
		debugfs_create_x16("CAN1_AM02L", 0600, parent, (u16 *)0xFFC03310);
		debugfs_create_x16("CAN1_AM03H", 0600, parent, (u16 *)0xFFC0331C);
		debugfs_create_x16("CAN1_AM03L", 0600, parent, (u16 *)0xFFC03318);
		debugfs_create_x16("CAN1_AM04H", 0600, parent, (u16 *)0xFFC03324);
		debugfs_create_x16("CAN1_AM04L", 0600, parent, (u16 *)0xFFC03320);
		debugfs_create_x16("CAN1_AM05H", 0600, parent, (u16 *)0xFFC0332C);
		debugfs_create_x16("CAN1_AM05L", 0600, parent, (u16 *)0xFFC03328);
		debugfs_create_x16("CAN1_AM06H", 0600, parent, (u16 *)0xFFC03334);
		debugfs_create_x16("CAN1_AM06L", 0600, parent, (u16 *)0xFFC03330);
		debugfs_create_x16("CAN1_AM07H", 0600, parent, (u16 *)0xFFC0333C);
		debugfs_create_x16("CAN1_AM07L", 0600, parent, (u16 *)0xFFC03338);
		debugfs_create_x16("CAN1_AM08H", 0600, parent, (u16 *)0xFFC03344);
		debugfs_create_x16("CAN1_AM08L", 0600, parent, (u16 *)0xFFC03340);
		debugfs_create_x16("CAN1_AM09H", 0600, parent, (u16 *)0xFFC0334C);
		debugfs_create_x16("CAN1_AM09L", 0600, parent, (u16 *)0xFFC03348);
		debugfs_create_x16("CAN1_AM10H", 0600, parent, (u16 *)0xFFC03354);
		debugfs_create_x16("CAN1_AM10L", 0600, parent, (u16 *)0xFFC03350);
		debugfs_create_x16("CAN1_AM11H", 0600, parent, (u16 *)0xFFC0335C);
		debugfs_create_x16("CAN1_AM11L", 0600, parent, (u16 *)0xFFC03358);
		debugfs_create_x16("CAN1_AM12H", 0600, parent, (u16 *)0xFFC03364);
		debugfs_create_x16("CAN1_AM12L", 0600, parent, (u16 *)0xFFC03360);
		debugfs_create_x16("CAN1_AM13H", 0600, parent, (u16 *)0xFFC0336C);
		debugfs_create_x16("CAN1_AM13L", 0600, parent, (u16 *)0xFFC03368);
		debugfs_create_x16("CAN1_AM14H", 0600, parent, (u16 *)0xFFC03374);
		debugfs_create_x16("CAN1_AM14L", 0600, parent, (u16 *)0xFFC03370);
		debugfs_create_x16("CAN1_AM15H", 0600, parent, (u16 *)0xFFC0337C);
		debugfs_create_x16("CAN1_AM15L", 0600, parent, (u16 *)0xFFC03378);
		debugfs_create_x16("CAN1_AM16H", 0600, parent, (u16 *)0xFFC03384);
		debugfs_create_x16("CAN1_AM16L", 0600, parent, (u16 *)0xFFC03380);
		debugfs_create_x16("CAN1_AM17H", 0600, parent, (u16 *)0xFFC0338C);
		debugfs_create_x16("CAN1_AM17L", 0600, parent, (u16 *)0xFFC03388);
		debugfs_create_x16("CAN1_AM18H", 0600, parent, (u16 *)0xFFC03394);
		debugfs_create_x16("CAN1_AM18L", 0600, parent, (u16 *)0xFFC03390);
		debugfs_create_x16("CAN1_AM19H", 0600, parent, (u16 *)0xFFC0339C);
		debugfs_create_x16("CAN1_AM19L", 0600, parent, (u16 *)0xFFC03398);
		debugfs_create_x16("CAN1_AM20H", 0600, parent, (u16 *)0xFFC033A4);
		debugfs_create_x16("CAN1_AM20L", 0600, parent, (u16 *)0xFFC033A0);
		debugfs_create_x16("CAN1_AM21H", 0600, parent, (u16 *)0xFFC033AC);
		debugfs_create_x16("CAN1_AM21L", 0600, parent, (u16 *)0xFFC033A8);
		debugfs_create_x16("CAN1_AM22H", 0600, parent, (u16 *)0xFFC033B4);
		debugfs_create_x16("CAN1_AM22L", 0600, parent, (u16 *)0xFFC033B0);
		debugfs_create_x16("CAN1_AM23H", 0600, parent, (u16 *)0xFFC033BC);
		debugfs_create_x16("CAN1_AM23L", 0600, parent, (u16 *)0xFFC033B8);
		debugfs_create_x16("CAN1_AM24H", 0600, parent, (u16 *)0xFFC033C4);
		debugfs_create_x16("CAN1_AM24L", 0600, parent, (u16 *)0xFFC033C0);
		debugfs_create_x16("CAN1_AM25H", 0600, parent, (u16 *)0xFFC033CC);
		debugfs_create_x16("CAN1_AM25L", 0600, parent, (u16 *)0xFFC033C8);
		debugfs_create_x16("CAN1_AM26H", 0600, parent, (u16 *)0xFFC033D4);
		debugfs_create_x16("CAN1_AM26L", 0600, parent, (u16 *)0xFFC033D0);
		debugfs_create_x16("CAN1_AM27H", 0600, parent, (u16 *)0xFFC033DC);
		debugfs_create_x16("CAN1_AM27L", 0600, parent, (u16 *)0xFFC033D8);
		debugfs_create_x16("CAN1_AM28H", 0600, parent, (u16 *)0xFFC033E4);
		debugfs_create_x16("CAN1_AM28L", 0600, parent, (u16 *)0xFFC033E0);
		debugfs_create_x16("CAN1_AM29H", 0600, parent, (u16 *)0xFFC033EC);
		debugfs_create_x16("CAN1_AM29L", 0600, parent, (u16 *)0xFFC033E8);
		debugfs_create_x16("CAN1_AM30H", 0600, parent, (u16 *)0xFFC033F4);
		debugfs_create_x16("CAN1_AM30L", 0600, parent, (u16 *)0xFFC033F0);
		debugfs_create_x16("CAN1_AM31H", 0600, parent, (u16 *)0xFFC033FC);
		debugfs_create_x16("CAN1_AM31L", 0600, parent, (u16 *)0xFFC033F8);

		parent = debugfs_create_dir("CAN1 Control and Status", top);
		debugfs_create_x16("CAN1_AA1", 0600, parent, (u16 *)0xFFC03214);
		debugfs_create_x16("CAN1_AA2", 0600, parent, (u16 *)0xFFC03254);
		debugfs_create_x16("CAN1_CEC", 0600, parent, (u16 *)0xFFC03290);
		debugfs_create_x16("CAN1_CLOCK", 0600, parent, (u16 *)0xFFC03280);
		debugfs_create_x16("CAN1_CONTROL", 0600, parent, (u16 *)0xFFC032A0);
		debugfs_create_x16("CAN1_DEBUG", 0600, parent, (u16 *)0xFFC03288);
		debugfs_create_x16("CAN1_ESR", 0600, parent, (u16 *)0xFFC032B4);
		debugfs_create_x16("CAN1_EWR", 0600, parent, (u16 *)0xFFC032B0);
		debugfs_create_x16("CAN1_GIF", 0600, parent, (u16 *)0xFFC0329C);
		debugfs_create_x16("CAN1_GIM", 0600, parent, (u16 *)0xFFC03298);
		debugfs_create_x16("CAN1_GIS", 0600, parent, (u16 *)0xFFC03294);
		debugfs_create_x16("CAN1_INTR", 0600, parent, (u16 *)0xFFC032A4);
		debugfs_create_x16("CAN1_MBIM1", 0600, parent, (u16 *)0xFFC03228);
		debugfs_create_x16("CAN1_MBIM2", 0600, parent, (u16 *)0xFFC03268);
		debugfs_create_x16("CAN1_MBRIF1", 0600, parent, (u16 *)0xFFC03224);
		debugfs_create_x16("CAN1_MBRIF2", 0600, parent, (u16 *)0xFFC03264);
		debugfs_create_x16("CAN1_MBTD", 0600, parent, (u16 *)0xFFC032AC);
		debugfs_create_x16("CAN1_MBTIF1", 0600, parent, (u16 *)0xFFC03220);
		debugfs_create_x16("CAN1_MBTIF2", 0600, parent, (u16 *)0xFFC03260);
		debugfs_create_x16("CAN1_MC1", 0600, parent, (u16 *)0xFFC03200);
		debugfs_create_x16("CAN1_MC2", 0600, parent, (u16 *)0xFFC03240);
		debugfs_create_x16("CAN1_MD1", 0600, parent, (u16 *)0xFFC03204);
		debugfs_create_x16("CAN1_MD2", 0600, parent, (u16 *)0xFFC03244);
		debugfs_create_x16("CAN1_OPSS1", 0600, parent, (u16 *)0xFFC03230);
		debugfs_create_x16("CAN1_OPSS2", 0600, parent, (u16 *)0xFFC03270);
		debugfs_create_x16("CAN1_RFH1", 0600, parent, (u16 *)0xFFC0322C);
		debugfs_create_x16("CAN1_RFH2", 0600, parent, (u16 *)0xFFC0326C);
		debugfs_create_x16("CAN1_RML1", 0600, parent, (u16 *)0xFFC0321C);
		debugfs_create_x16("CAN1_RML2", 0600, parent, (u16 *)0xFFC0325C);
		debugfs_create_x16("CAN1_RMP1", 0600, parent, (u16 *)0xFFC03218);
		debugfs_create_x16("CAN1_RMP2", 0600, parent, (u16 *)0xFFC03258);
		debugfs_create_x16("CAN1_STATUS", 0600, parent, (u16 *)0xFFC0328C);
		debugfs_create_x16("CAN1_TA1", 0600, parent, (u16 *)0xFFC03210);
		debugfs_create_x16("CAN1_TA2", 0600, parent, (u16 *)0xFFC03250);
		debugfs_create_x16("CAN1_TIMING", 0600, parent, (u16 *)0xFFC03284);
		debugfs_create_x16("CAN1_TRR1", 0600, parent, (u16 *)0xFFC0320C);
		debugfs_create_x16("CAN1_TRR2", 0600, parent, (u16 *)0xFFC0324C);
		debugfs_create_x16("CAN1_TRS1", 0600, parent, (u16 *)0xFFC03208);
		debugfs_create_x16("CAN1_TRS2", 0600, parent, (u16 *)0xFFC03248);
		debugfs_create_x16("CAN1_UCCNF", 0600, parent, (u16 *)0xFFC032CC);
		debugfs_create_x16("CAN1_UCCNT", 0600, parent, (u16 *)0xFFC032C4);
		debugfs_create_x16("CAN1_UCRC", 0600, parent, (u16 *)0xFFC032C8);

		parent = debugfs_create_dir("CAN1 Mailbox RAM", top);
		debugfs_create_x16("CAN1_MB00_DATA0", 0600, parent, (u16 *)0xFFC03400);
		debugfs_create_x16("CAN1_MB00_DATA1", 0600, parent, (u16 *)0xFFC03404);
		debugfs_create_x16("CAN1_MB00_DATA2", 0600, parent, (u16 *)0xFFC03408);
		debugfs_create_x16("CAN1_MB00_DATA3", 0600, parent, (u16 *)0xFFC0340C);
		debugfs_create_x16("CAN1_MB00_ID0", 0600, parent, (u16 *)0xFFC03418);
		debugfs_create_x16("CAN1_MB00_ID1", 0600, parent, (u16 *)0xFFC0341C);
		debugfs_create_x16("CAN1_MB00_LENGTH", 0600, parent, (u16 *)0xFFC03410);
		debugfs_create_x16("CAN1_MB00_TIMESTAMP", 0600, parent, (u16 *)0xFFC03414);
		debugfs_create_x16("CAN1_MB01_DATA0", 0600, parent, (u16 *)0xFFC03420);
		debugfs_create_x16("CAN1_MB01_DATA1", 0600, parent, (u16 *)0xFFC03424);
		debugfs_create_x16("CAN1_MB01_DATA2", 0600, parent, (u16 *)0xFFC03428);
		debugfs_create_x16("CAN1_MB01_DATA3", 0600, parent, (u16 *)0xFFC0342C);
		debugfs_create_x16("CAN1_MB01_ID0", 0600, parent, (u16 *)0xFFC03438);
		debugfs_create_x16("CAN1_MB01_ID1", 0600, parent, (u16 *)0xFFC0343C);
		debugfs_create_x16("CAN1_MB01_LENGTH", 0600, parent, (u16 *)0xFFC03430);
		debugfs_create_x16("CAN1_MB01_TIMESTAMP", 0600, parent, (u16 *)0xFFC03434);
		debugfs_create_x16("CAN1_MB02_DATA0", 0600, parent, (u16 *)0xFFC03440);
		debugfs_create_x16("CAN1_MB02_DATA1", 0600, parent, (u16 *)0xFFC03444);
		debugfs_create_x16("CAN1_MB02_DATA2", 0600, parent, (u16 *)0xFFC03448);
		debugfs_create_x16("CAN1_MB02_DATA3", 0600, parent, (u16 *)0xFFC0344C);
		debugfs_create_x16("CAN1_MB02_ID0", 0600, parent, (u16 *)0xFFC03458);
		debugfs_create_x16("CAN1_MB02_ID1", 0600, parent, (u16 *)0xFFC0345C);
		debugfs_create_x16("CAN1_MB02_LENGTH", 0600, parent, (u16 *)0xFFC03450);
		debugfs_create_x16("CAN1_MB02_TIMESTAMP", 0600, parent, (u16 *)0xFFC03454);
		debugfs_create_x16("CAN1_MB03_DATA0", 0600, parent, (u16 *)0xFFC03460);
		debugfs_create_x16("CAN1_MB03_DATA1", 0600, parent, (u16 *)0xFFC03464);
		debugfs_create_x16("CAN1_MB03_DATA2", 0600, parent, (u16 *)0xFFC03468);
		debugfs_create_x16("CAN1_MB03_DATA3", 0600, parent, (u16 *)0xFFC0346C);
		debugfs_create_x16("CAN1_MB03_ID0", 0600, parent, (u16 *)0xFFC03478);
		debugfs_create_x16("CAN1_MB03_ID1", 0600, parent, (u16 *)0xFFC0347C);
		debugfs_create_x16("CAN1_MB03_LENGTH", 0600, parent, (u16 *)0xFFC03470);
		debugfs_create_x16("CAN1_MB03_TIMESTAMP", 0600, parent, (u16 *)0xFFC03474);
		debugfs_create_x16("CAN1_MB04_DATA0", 0600, parent, (u16 *)0xFFC03480);
		debugfs_create_x16("CAN1_MB04_DATA1", 0600, parent, (u16 *)0xFFC03484);
		debugfs_create_x16("CAN1_MB04_DATA2", 0600, parent, (u16 *)0xFFC03488);
		debugfs_create_x16("CAN1_MB04_DATA3", 0600, parent, (u16 *)0xFFC0348C);
		debugfs_create_x16("CAN1_MB04_ID0", 0600, parent, (u16 *)0xFFC03498);
		debugfs_create_x16("CAN1_MB04_ID1", 0600, parent, (u16 *)0xFFC0349C);
		debugfs_create_x16("CAN1_MB04_LENGTH", 0600, parent, (u16 *)0xFFC03490);
		debugfs_create_x16("CAN1_MB04_TIMESTAMP", 0600, parent, (u16 *)0xFFC03494);
		debugfs_create_x16("CAN1_MB05_DATA0", 0600, parent, (u16 *)0xFFC034A0);
		debugfs_create_x16("CAN1_MB05_DATA1", 0600, parent, (u16 *)0xFFC034A4);
		debugfs_create_x16("CAN1_MB05_DATA2", 0600, parent, (u16 *)0xFFC034A8);
		debugfs_create_x16("CAN1_MB05_DATA3", 0600, parent, (u16 *)0xFFC034AC);
		debugfs_create_x16("CAN1_MB05_ID0", 0600, parent, (u16 *)0xFFC034B8);
		debugfs_create_x16("CAN1_MB05_ID1", 0600, parent, (u16 *)0xFFC034BC);
		debugfs_create_x16("CAN1_MB05_LENGTH", 0600, parent, (u16 *)0xFFC034B0);
		debugfs_create_x16("CAN1_MB05_TIMESTAMP", 0600, parent, (u16 *)0xFFC034B4);
		debugfs_create_x16("CAN1_MB06_DATA0", 0600, parent, (u16 *)0xFFC034C0);
		debugfs_create_x16("CAN1_MB06_DATA1", 0600, parent, (u16 *)0xFFC034C4);
		debugfs_create_x16("CAN1_MB06_DATA2", 0600, parent, (u16 *)0xFFC034C8);
		debugfs_create_x16("CAN1_MB06_DATA3", 0600, parent, (u16 *)0xFFC034CC);
		debugfs_create_x16("CAN1_MB06_ID0", 0600, parent, (u16 *)0xFFC034D8);
		debugfs_create_x16("CAN1_MB06_ID1", 0600, parent, (u16 *)0xFFC034DC);
		debugfs_create_x16("CAN1_MB06_LENGTH", 0600, parent, (u16 *)0xFFC034D0);
		debugfs_create_x16("CAN1_MB06_TIMESTAMP", 0600, parent, (u16 *)0xFFC034D4);
		debugfs_create_x16("CAN1_MB07_DATA0", 0600, parent, (u16 *)0xFFC034E0);
		debugfs_create_x16("CAN1_MB07_DATA1", 0600, parent, (u16 *)0xFFC034E4);
		debugfs_create_x16("CAN1_MB07_DATA2", 0600, parent, (u16 *)0xFFC034E8);
		debugfs_create_x16("CAN1_MB07_DATA3", 0600, parent, (u16 *)0xFFC034EC);
		debugfs_create_x16("CAN1_MB07_ID0", 0600, parent, (u16 *)0xFFC034F8);
		debugfs_create_x16("CAN1_MB07_ID1", 0600, parent, (u16 *)0xFFC034FC);
		debugfs_create_x16("CAN1_MB07_LENGTH", 0600, parent, (u16 *)0xFFC034F0);
		debugfs_create_x16("CAN1_MB07_TIMESTAMP", 0600, parent, (u16 *)0xFFC034F4);
		debugfs_create_x16("CAN1_MB08_DATA0", 0600, parent, (u16 *)0xFFC03500);
		debugfs_create_x16("CAN1_MB08_DATA1", 0600, parent, (u16 *)0xFFC03504);
		debugfs_create_x16("CAN1_MB08_DATA2", 0600, parent, (u16 *)0xFFC03508);
		debugfs_create_x16("CAN1_MB08_DATA3", 0600, parent, (u16 *)0xFFC0350C);
		debugfs_create_x16("CAN1_MB08_ID0", 0600, parent, (u16 *)0xFFC03518);
		debugfs_create_x16("CAN1_MB08_ID1", 0600, parent, (u16 *)0xFFC0351C);
		debugfs_create_x16("CAN1_MB08_LENGTH", 0600, parent, (u16 *)0xFFC03510);
		debugfs_create_x16("CAN1_MB08_TIMESTAMP", 0600, parent, (u16 *)0xFFC03514);
		debugfs_create_x16("CAN1_MB09_DATA0", 0600, parent, (u16 *)0xFFC03520);
		debugfs_create_x16("CAN1_MB09_DATA1", 0600, parent, (u16 *)0xFFC03524);
		debugfs_create_x16("CAN1_MB09_DATA2", 0600, parent, (u16 *)0xFFC03528);
		debugfs_create_x16("CAN1_MB09_DATA3", 0600, parent, (u16 *)0xFFC0352C);
		debugfs_create_x16("CAN1_MB09_ID0", 0600, parent, (u16 *)0xFFC03538);
		debugfs_create_x16("CAN1_MB09_ID1", 0600, parent, (u16 *)0xFFC0353C);
		debugfs_create_x16("CAN1_MB09_LENGTH", 0600, parent, (u16 *)0xFFC03530);
		debugfs_create_x16("CAN1_MB09_TIMESTAMP", 0600, parent, (u16 *)0xFFC03534);
		debugfs_create_x16("CAN1_MB10_DATA0", 0600, parent, (u16 *)0xFFC03540);
		debugfs_create_x16("CAN1_MB10_DATA1", 0600, parent, (u16 *)0xFFC03544);
		debugfs_create_x16("CAN1_MB10_DATA2", 0600, parent, (u16 *)0xFFC03548);
		debugfs_create_x16("CAN1_MB10_DATA3", 0600, parent, (u16 *)0xFFC0354C);
		debugfs_create_x16("CAN1_MB10_ID0", 0600, parent, (u16 *)0xFFC03558);
		debugfs_create_x16("CAN1_MB10_ID1", 0600, parent, (u16 *)0xFFC0355C);
		debugfs_create_x16("CAN1_MB10_LENGTH", 0600, parent, (u16 *)0xFFC03550);
		debugfs_create_x16("CAN1_MB10_TIMESTAMP", 0600, parent, (u16 *)0xFFC03554);
		debugfs_create_x16("CAN1_MB11_DATA0", 0600, parent, (u16 *)0xFFC03560);
		debugfs_create_x16("CAN1_MB11_DATA1", 0600, parent, (u16 *)0xFFC03564);
		debugfs_create_x16("CAN1_MB11_DATA2", 0600, parent, (u16 *)0xFFC03568);
		debugfs_create_x16("CAN1_MB11_DATA3", 0600, parent, (u16 *)0xFFC0356C);
		debugfs_create_x16("CAN1_MB11_ID0", 0600, parent, (u16 *)0xFFC03578);
		debugfs_create_x16("CAN1_MB11_ID1", 0600, parent, (u16 *)0xFFC0357C);
		debugfs_create_x16("CAN1_MB11_LENGTH", 0600, parent, (u16 *)0xFFC03570);
		debugfs_create_x16("CAN1_MB11_TIMESTAMP", 0600, parent, (u16 *)0xFFC03574);
		debugfs_create_x16("CAN1_MB12_DATA0", 0600, parent, (u16 *)0xFFC03580);
		debugfs_create_x16("CAN1_MB12_DATA1", 0600, parent, (u16 *)0xFFC03584);
		debugfs_create_x16("CAN1_MB12_DATA2", 0600, parent, (u16 *)0xFFC03588);
		debugfs_create_x16("CAN1_MB12_DATA3", 0600, parent, (u16 *)0xFFC0358C);
		debugfs_create_x16("CAN1_MB12_ID0", 0600, parent, (u16 *)0xFFC03598);
		debugfs_create_x16("CAN1_MB12_ID1", 0600, parent, (u16 *)0xFFC0359C);
		debugfs_create_x16("CAN1_MB12_LENGTH", 0600, parent, (u16 *)0xFFC03590);
		debugfs_create_x16("CAN1_MB12_TIMESTAMP", 0600, parent, (u16 *)0xFFC03594);
		debugfs_create_x16("CAN1_MB13_DATA0", 0600, parent, (u16 *)0xFFC035A0);
		debugfs_create_x16("CAN1_MB13_DATA1", 0600, parent, (u16 *)0xFFC035A4);
		debugfs_create_x16("CAN1_MB13_DATA2", 0600, parent, (u16 *)0xFFC035A8);
		debugfs_create_x16("CAN1_MB13_DATA3", 0600, parent, (u16 *)0xFFC035AC);
		debugfs_create_x16("CAN1_MB13_ID0", 0600, parent, (u16 *)0xFFC035B8);
		debugfs_create_x16("CAN1_MB13_ID1", 0600, parent, (u16 *)0xFFC035BC);
		debugfs_create_x16("CAN1_MB13_LENGTH", 0600, parent, (u16 *)0xFFC035B0);
		debugfs_create_x16("CAN1_MB13_TIMESTAMP", 0600, parent, (u16 *)0xFFC035B4);
		debugfs_create_x16("CAN1_MB14_DATA0", 0600, parent, (u16 *)0xFFC035C0);
		debugfs_create_x16("CAN1_MB14_DATA1", 0600, parent, (u16 *)0xFFC035C4);
		debugfs_create_x16("CAN1_MB14_DATA2", 0600, parent, (u16 *)0xFFC035C8);
		debugfs_create_x16("CAN1_MB14_DATA3", 0600, parent, (u16 *)0xFFC035CC);
		debugfs_create_x16("CAN1_MB14_ID0", 0600, parent, (u16 *)0xFFC035D8);
		debugfs_create_x16("CAN1_MB14_ID1", 0600, parent, (u16 *)0xFFC035DC);
		debugfs_create_x16("CAN1_MB14_LENGTH", 0600, parent, (u16 *)0xFFC035D0);
		debugfs_create_x16("CAN1_MB14_TIMESTAMP", 0600, parent, (u16 *)0xFFC035D4);
		debugfs_create_x16("CAN1_MB15_DATA0", 0600, parent, (u16 *)0xFFC035E0);
		debugfs_create_x16("CAN1_MB15_DATA1", 0600, parent, (u16 *)0xFFC035E4);
		debugfs_create_x16("CAN1_MB15_DATA2", 0600, parent, (u16 *)0xFFC035E8);
		debugfs_create_x16("CAN1_MB15_DATA3", 0600, parent, (u16 *)0xFFC035EC);
		debugfs_create_x16("CAN1_MB15_ID0", 0600, parent, (u16 *)0xFFC035F8);
		debugfs_create_x16("CAN1_MB15_ID1", 0600, parent, (u16 *)0xFFC035FC);
		debugfs_create_x16("CAN1_MB15_LENGTH", 0600, parent, (u16 *)0xFFC035F0);
		debugfs_create_x16("CAN1_MB15_TIMESTAMP", 0600, parent, (u16 *)0xFFC035F4);
		debugfs_create_x16("CAN1_MB16_DATA0", 0600, parent, (u16 *)0xFFC03600);
		debugfs_create_x16("CAN1_MB16_DATA1", 0600, parent, (u16 *)0xFFC03604);
		debugfs_create_x16("CAN1_MB16_DATA2", 0600, parent, (u16 *)0xFFC03608);
		debugfs_create_x16("CAN1_MB16_DATA3", 0600, parent, (u16 *)0xFFC0360C);
		debugfs_create_x16("CAN1_MB16_ID0", 0600, parent, (u16 *)0xFFC03618);
		debugfs_create_x16("CAN1_MB16_ID1", 0600, parent, (u16 *)0xFFC0361C);
		debugfs_create_x16("CAN1_MB16_LENGTH", 0600, parent, (u16 *)0xFFC03610);
		debugfs_create_x16("CAN1_MB16_TIMESTAMP", 0600, parent, (u16 *)0xFFC03614);
		debugfs_create_x16("CAN1_MB17_DATA0", 0600, parent, (u16 *)0xFFC03620);
		debugfs_create_x16("CAN1_MB17_DATA1", 0600, parent, (u16 *)0xFFC03624);
		debugfs_create_x16("CAN1_MB17_DATA2", 0600, parent, (u16 *)0xFFC03628);
		debugfs_create_x16("CAN1_MB17_DATA3", 0600, parent, (u16 *)0xFFC0362C);
		debugfs_create_x16("CAN1_MB17_ID0", 0600, parent, (u16 *)0xFFC03638);
		debugfs_create_x16("CAN1_MB17_ID1", 0600, parent, (u16 *)0xFFC0363C);
		debugfs_create_x16("CAN1_MB17_LENGTH", 0600, parent, (u16 *)0xFFC03630);
		debugfs_create_x16("CAN1_MB17_TIMESTAMP", 0600, parent, (u16 *)0xFFC03634);
		debugfs_create_x16("CAN1_MB18_DATA0", 0600, parent, (u16 *)0xFFC03640);
		debugfs_create_x16("CAN1_MB18_DATA1", 0600, parent, (u16 *)0xFFC03644);
		debugfs_create_x16("CAN1_MB18_DATA2", 0600, parent, (u16 *)0xFFC03648);
		debugfs_create_x16("CAN1_MB18_DATA3", 0600, parent, (u16 *)0xFFC0364C);
		debugfs_create_x16("CAN1_MB18_ID0", 0600, parent, (u16 *)0xFFC03658);
		debugfs_create_x16("CAN1_MB18_ID1", 0600, parent, (u16 *)0xFFC0365C);
		debugfs_create_x16("CAN1_MB18_LENGTH", 0600, parent, (u16 *)0xFFC03650);
		debugfs_create_x16("CAN1_MB18_TIMESTAMP", 0600, parent, (u16 *)0xFFC03654);
		debugfs_create_x16("CAN1_MB19_DATA0", 0600, parent, (u16 *)0xFFC03660);
		debugfs_create_x16("CAN1_MB19_DATA1", 0600, parent, (u16 *)0xFFC03664);
		debugfs_create_x16("CAN1_MB19_DATA2", 0600, parent, (u16 *)0xFFC03668);
		debugfs_create_x16("CAN1_MB19_DATA3", 0600, parent, (u16 *)0xFFC0366C);
		debugfs_create_x16("CAN1_MB19_ID0", 0600, parent, (u16 *)0xFFC03678);
		debugfs_create_x16("CAN1_MB19_ID1", 0600, parent, (u16 *)0xFFC0367C);
		debugfs_create_x16("CAN1_MB19_LENGTH", 0600, parent, (u16 *)0xFFC03670);
		debugfs_create_x16("CAN1_MB19_TIMESTAMP", 0600, parent, (u16 *)0xFFC03674);
		debugfs_create_x16("CAN1_MB20_DATA0", 0600, parent, (u16 *)0xFFC03680);
		debugfs_create_x16("CAN1_MB20_DATA1", 0600, parent, (u16 *)0xFFC03684);
		debugfs_create_x16("CAN1_MB20_DATA2", 0600, parent, (u16 *)0xFFC03688);
		debugfs_create_x16("CAN1_MB20_DATA3", 0600, parent, (u16 *)0xFFC0368C);
		debugfs_create_x16("CAN1_MB20_ID0", 0600, parent, (u16 *)0xFFC03698);
		debugfs_create_x16("CAN1_MB20_ID1", 0600, parent, (u16 *)0xFFC0369C);
		debugfs_create_x16("CAN1_MB20_LENGTH", 0600, parent, (u16 *)0xFFC03690);
		debugfs_create_x16("CAN1_MB20_TIMESTAMP", 0600, parent, (u16 *)0xFFC03694);
		debugfs_create_x16("CAN1_MB21_DATA0", 0600, parent, (u16 *)0xFFC036A0);
		debugfs_create_x16("CAN1_MB21_DATA1", 0600, parent, (u16 *)0xFFC036A4);
		debugfs_create_x16("CAN1_MB21_DATA2", 0600, parent, (u16 *)0xFFC036A8);
		debugfs_create_x16("CAN1_MB21_DATA3", 0600, parent, (u16 *)0xFFC036AC);
		debugfs_create_x16("CAN1_MB21_ID0", 0600, parent, (u16 *)0xFFC036B8);
		debugfs_create_x16("CAN1_MB21_ID1", 0600, parent, (u16 *)0xFFC036BC);
		debugfs_create_x16("CAN1_MB21_LENGTH", 0600, parent, (u16 *)0xFFC036B0);
		debugfs_create_x16("CAN1_MB21_TIMESTAMP", 0600, parent, (u16 *)0xFFC036B4);
		debugfs_create_x16("CAN1_MB22_DATA0", 0600, parent, (u16 *)0xFFC036C0);
		debugfs_create_x16("CAN1_MB22_DATA1", 0600, parent, (u16 *)0xFFC036C4);
		debugfs_create_x16("CAN1_MB22_DATA2", 0600, parent, (u16 *)0xFFC036C8);
		debugfs_create_x16("CAN1_MB22_DATA3", 0600, parent, (u16 *)0xFFC036CC);
		debugfs_create_x16("CAN1_MB22_ID0", 0600, parent, (u16 *)0xFFC036D8);
		debugfs_create_x16("CAN1_MB22_ID1", 0600, parent, (u16 *)0xFFC036DC);
		debugfs_create_x16("CAN1_MB22_LENGTH", 0600, parent, (u16 *)0xFFC036D0);
		debugfs_create_x16("CAN1_MB22_TIMESTAMP", 0600, parent, (u16 *)0xFFC036D4);
		debugfs_create_x16("CAN1_MB23_DATA0", 0600, parent, (u16 *)0xFFC036E0);
		debugfs_create_x16("CAN1_MB23_DATA1", 0600, parent, (u16 *)0xFFC036E4);
		debugfs_create_x16("CAN1_MB23_DATA2", 0600, parent, (u16 *)0xFFC036E8);
		debugfs_create_x16("CAN1_MB23_DATA3", 0600, parent, (u16 *)0xFFC036EC);
		debugfs_create_x16("CAN1_MB23_ID0", 0600, parent, (u16 *)0xFFC036F8);
		debugfs_create_x16("CAN1_MB23_ID1", 0600, parent, (u16 *)0xFFC036FC);
		debugfs_create_x16("CAN1_MB23_LENGTH", 0600, parent, (u16 *)0xFFC036F0);
		debugfs_create_x16("CAN1_MB23_TIMESTAMP", 0600, parent, (u16 *)0xFFC036F4);
		debugfs_create_x16("CAN1_MB24_DATA0", 0600, parent, (u16 *)0xFFC03700);
		debugfs_create_x16("CAN1_MB24_DATA1", 0600, parent, (u16 *)0xFFC03704);
		debugfs_create_x16("CAN1_MB24_DATA2", 0600, parent, (u16 *)0xFFC03708);
		debugfs_create_x16("CAN1_MB24_DATA3", 0600, parent, (u16 *)0xFFC0370C);
		debugfs_create_x16("CAN1_MB24_ID0", 0600, parent, (u16 *)0xFFC03718);
		debugfs_create_x16("CAN1_MB24_ID1", 0600, parent, (u16 *)0xFFC0371C);
		debugfs_create_x16("CAN1_MB24_LENGTH", 0600, parent, (u16 *)0xFFC03710);
		debugfs_create_x16("CAN1_MB24_TIMESTAMP", 0600, parent, (u16 *)0xFFC03714);
		debugfs_create_x16("CAN1_MB25_DATA0", 0600, parent, (u16 *)0xFFC03720);
		debugfs_create_x16("CAN1_MB25_DATA1", 0600, parent, (u16 *)0xFFC03724);
		debugfs_create_x16("CAN1_MB25_DATA2", 0600, parent, (u16 *)0xFFC03728);
		debugfs_create_x16("CAN1_MB25_DATA3", 0600, parent, (u16 *)0xFFC0372C);
		debugfs_create_x16("CAN1_MB25_ID0", 0600, parent, (u16 *)0xFFC03738);
		debugfs_create_x16("CAN1_MB25_ID1", 0600, parent, (u16 *)0xFFC0373C);
		debugfs_create_x16("CAN1_MB25_LENGTH", 0600, parent, (u16 *)0xFFC03730);
		debugfs_create_x16("CAN1_MB25_TIMESTAMP", 0600, parent, (u16 *)0xFFC03734);
		debugfs_create_x16("CAN1_MB26_DATA0", 0600, parent, (u16 *)0xFFC03740);
		debugfs_create_x16("CAN1_MB26_DATA1", 0600, parent, (u16 *)0xFFC03744);
		debugfs_create_x16("CAN1_MB26_DATA2", 0600, parent, (u16 *)0xFFC03748);
		debugfs_create_x16("CAN1_MB26_DATA3", 0600, parent, (u16 *)0xFFC0374C);
		debugfs_create_x16("CAN1_MB26_ID0", 0600, parent, (u16 *)0xFFC03758);
		debugfs_create_x16("CAN1_MB26_ID1", 0600, parent, (u16 *)0xFFC0375C);
		debugfs_create_x16("CAN1_MB26_LENGTH", 0600, parent, (u16 *)0xFFC03750);
		debugfs_create_x16("CAN1_MB26_TIMESTAMP", 0600, parent, (u16 *)0xFFC03754);
		debugfs_create_x16("CAN1_MB27_DATA0", 0600, parent, (u16 *)0xFFC03760);
		debugfs_create_x16("CAN1_MB27_DATA1", 0600, parent, (u16 *)0xFFC03764);
		debugfs_create_x16("CAN1_MB27_DATA2", 0600, parent, (u16 *)0xFFC03768);
		debugfs_create_x16("CAN1_MB27_DATA3", 0600, parent, (u16 *)0xFFC0376C);
		debugfs_create_x16("CAN1_MB27_ID0", 0600, parent, (u16 *)0xFFC03778);
		debugfs_create_x16("CAN1_MB27_ID1", 0600, parent, (u16 *)0xFFC0377C);
		debugfs_create_x16("CAN1_MB27_LENGTH", 0600, parent, (u16 *)0xFFC03770);
		debugfs_create_x16("CAN1_MB27_TIMESTAMP", 0600, parent, (u16 *)0xFFC03774);
		debugfs_create_x16("CAN1_MB28_DATA0", 0600, parent, (u16 *)0xFFC03780);
		debugfs_create_x16("CAN1_MB28_DATA1", 0600, parent, (u16 *)0xFFC03784);
		debugfs_create_x16("CAN1_MB28_DATA2", 0600, parent, (u16 *)0xFFC03788);
		debugfs_create_x16("CAN1_MB28_DATA3", 0600, parent, (u16 *)0xFFC0378C);
		debugfs_create_x16("CAN1_MB28_ID0", 0600, parent, (u16 *)0xFFC03798);
		debugfs_create_x16("CAN1_MB28_ID1", 0600, parent, (u16 *)0xFFC0379C);
		debugfs_create_x16("CAN1_MB28_LENGTH", 0600, parent, (u16 *)0xFFC03790);
		debugfs_create_x16("CAN1_MB28_TIMESTAMP", 0600, parent, (u16 *)0xFFC03794);
		debugfs_create_x16("CAN1_MB29_DATA0", 0600, parent, (u16 *)0xFFC037A0);
		debugfs_create_x16("CAN1_MB29_DATA1", 0600, parent, (u16 *)0xFFC037A4);
		debugfs_create_x16("CAN1_MB29_DATA2", 0600, parent, (u16 *)0xFFC037A8);
		debugfs_create_x16("CAN1_MB29_DATA3", 0600, parent, (u16 *)0xFFC037AC);
		debugfs_create_x16("CAN1_MB29_ID0", 0600, parent, (u16 *)0xFFC037B8);
		debugfs_create_x16("CAN1_MB29_ID1", 0600, parent, (u16 *)0xFFC037BC);
		debugfs_create_x16("CAN1_MB29_LENGTH", 0600, parent, (u16 *)0xFFC037B0);
		debugfs_create_x16("CAN1_MB29_TIMESTAMP", 0600, parent, (u16 *)0xFFC037B4);
		debugfs_create_x16("CAN1_MB30_DATA0", 0600, parent, (u16 *)0xFFC037C0);
		debugfs_create_x16("CAN1_MB30_DATA1", 0600, parent, (u16 *)0xFFC037C4);
		debugfs_create_x16("CAN1_MB30_DATA2", 0600, parent, (u16 *)0xFFC037C8);
		debugfs_create_x16("CAN1_MB30_DATA3", 0600, parent, (u16 *)0xFFC037CC);
		debugfs_create_x16("CAN1_MB30_ID0", 0600, parent, (u16 *)0xFFC037D8);
		debugfs_create_x16("CAN1_MB30_ID1", 0600, parent, (u16 *)0xFFC037DC);
		debugfs_create_x16("CAN1_MB30_LENGTH", 0600, parent, (u16 *)0xFFC037D0);
		debugfs_create_x16("CAN1_MB30_TIMESTAMP", 0600, parent, (u16 *)0xFFC037D4);
		debugfs_create_x16("CAN1_MB31_DATA0", 0600, parent, (u16 *)0xFFC037E0);
		debugfs_create_x16("CAN1_MB31_DATA1", 0600, parent, (u16 *)0xFFC037E4);
		debugfs_create_x16("CAN1_MB31_DATA2", 0600, parent, (u16 *)0xFFC037E8);
		debugfs_create_x16("CAN1_MB31_DATA3", 0600, parent, (u16 *)0xFFC037EC);
		debugfs_create_x16("CAN1_MB31_ID0", 0600, parent, (u16 *)0xFFC037F8);
		debugfs_create_x16("CAN1_MB31_ID1", 0600, parent, (u16 *)0xFFC037FC);
		debugfs_create_x16("CAN1_MB31_LENGTH", 0600, parent, (u16 *)0xFFC037F0);
		debugfs_create_x16("CAN1_MB31_TIMESTAMP", 0600, parent, (u16 *)0xFFC037F4);

		parent = debugfs_create_dir("CORE_TMR", top);
		debugfs_create_x32("TCNTL", 0600, parent, (u32 *)0xFFE03000);
		debugfs_create_x32("TCOUNT", 0600, parent, (u32 *)0xFFE0300C);
		debugfs_create_x32("TPERIOD", 0600, parent, (u32 *)0xFFE03004);
		debugfs_create_x32("TSCALE", 0600, parent, (u32 *)0xFFE03008);

		parent = debugfs_create_dir("Counter", top);
		debugfs_create_x16("CNT_COMMAND", 0600, parent, (u16 *)0xFFC0420C);
		debugfs_create_x16("CNT_CONFIG", 0600, parent, (u16 *)0xFFC04200);
		debugfs_create_x32("CNT_COUNTER", 0600, parent, (u32 *)0xFFC04214);
		debugfs_create_x16("CNT_DEBOUNCE", 0600, parent, (u16 *)0xFFC04210);
		debugfs_create_x16("CNT_IMASK", 0600, parent, (u16 *)0xFFC04204);
		debugfs_create_x32("CNT_MAX", 0600, parent, (u32 *)0xFFC04218);
		debugfs_create_x32("CNT_MIN", 0600, parent, (u32 *)0xFFC0421C);
		debugfs_create_x16("CNT_STATUS", 0600, parent, (u16 *)0xFFC04208);

		parent = debugfs_create_dir("DMA", top);
		debugfs_create_x16("DMA0_CONFIG", 0600, parent, (u16 *)0xFFC00C08);
		debugfs_create_x32("DMA0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C24);
		debugfs_create_x32("DMA0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C20);
		debugfs_create_x16("DMA0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C30);
		debugfs_create_x16("DMA0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C38);
		debugfs_create_x16("DMA0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C28);
		debugfs_create_x32("DMA0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C00);
		debugfs_create_x16("DMA0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C2C);
		debugfs_create_x32("DMA0_START_ADDR", 0600, parent, (u32 *)0xFFC00C04);
		debugfs_create_x16("DMA0_X_COUNT", 0600, parent, (u16 *)0xFFC00C10);
		debugfs_create_x16("DMA0_X_MODIFY", 0600, parent, (u16 *)0xFFC00C14);
		debugfs_create_x16("DMA0_Y_COUNT", 0600, parent, (u16 *)0xFFC00C18);
		debugfs_create_x16("DMA0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C1C);
		debugfs_create_x16("DMA10_CONFIG", 0600, parent, (u16 *)0xFFC00E88);
		debugfs_create_x32("DMA10_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EA4);
		debugfs_create_x32("DMA10_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EA0);
		debugfs_create_x16("DMA10_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EB0);
		debugfs_create_x16("DMA10_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EB8);
		debugfs_create_x16("DMA10_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EA8);
		debugfs_create_x32("DMA10_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E80);
		debugfs_create_x16("DMA10_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EAC);
		debugfs_create_x32("DMA10_START_ADDR", 0600, parent, (u32 *)0xFFC00E84);
		debugfs_create_x16("DMA10_X_COUNT", 0600, parent, (u16 *)0xFFC00E90);
		debugfs_create_x16("DMA10_X_MODIFY", 0600, parent, (u16 *)0xFFC00E94);
		debugfs_create_x16("DMA10_Y_COUNT", 0600, parent, (u16 *)0xFFC00E98);
		debugfs_create_x16("DMA10_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E9C);
		debugfs_create_x16("DMA11_CONFIG", 0600, parent, (u16 *)0xFFC00EC8);
		debugfs_create_x32("DMA11_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EE4);
		debugfs_create_x32("DMA11_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EE0);
		debugfs_create_x16("DMA11_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EF0);
		debugfs_create_x16("DMA11_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EF8);
		debugfs_create_x16("DMA11_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EE8);
		debugfs_create_x32("DMA11_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00EC0);
		debugfs_create_x16("DMA11_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EEC);
		debugfs_create_x32("DMA11_START_ADDR", 0600, parent, (u32 *)0xFFC00EC4);
		debugfs_create_x16("DMA11_X_COUNT", 0600, parent, (u16 *)0xFFC00ED0);
		debugfs_create_x16("DMA11_X_MODIFY", 0600, parent, (u16 *)0xFFC00ED4);
		debugfs_create_x16("DMA11_Y_COUNT", 0600, parent, (u16 *)0xFFC00ED8);
		debugfs_create_x16("DMA11_Y_MODIFY", 0600, parent, (u16 *)0xFFC00EDC);
		debugfs_create_x16("DMA12_CONFIG", 0600, parent, (u16 *)0xFFC01C08);
		debugfs_create_x32("DMA12_CURR_ADDR", 0600, parent, (u32 *)0xFFC01C24);
		debugfs_create_x32("DMA12_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01C20);
		debugfs_create_x16("DMA12_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01C30);
		debugfs_create_x16("DMA12_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01C38);
		debugfs_create_x16("DMA12_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01C28);
		debugfs_create_x32("DMA12_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01C00);
		debugfs_create_x16("DMA12_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01C2C);
		debugfs_create_x32("DMA12_START_ADDR", 0600, parent, (u32 *)0xFFC01C04);
		debugfs_create_x16("DMA12_X_COUNT", 0600, parent, (u16 *)0xFFC01C10);
		debugfs_create_x16("DMA12_X_MODIFY", 0600, parent, (u16 *)0xFFC01C14);
		debugfs_create_x16("DMA12_Y_COUNT", 0600, parent, (u16 *)0xFFC01C18);
		debugfs_create_x16("DMA12_Y_MODIFY", 0600, parent, (u16 *)0xFFC01C1C);
		debugfs_create_x16("DMA13_CONFIG", 0600, parent, (u16 *)0xFFC01C48);
		debugfs_create_x32("DMA13_CURR_ADDR", 0600, parent, (u32 *)0xFFC01C64);
		debugfs_create_x32("DMA13_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01C60);
		debugfs_create_x16("DMA13_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01C70);
		debugfs_create_x16("DMA13_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01C78);
		debugfs_create_x16("DMA13_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01C68);
		debugfs_create_x32("DMA13_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01C40);
		debugfs_create_x16("DMA13_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01C6C);
		debugfs_create_x32("DMA13_START_ADDR", 0600, parent, (u32 *)0xFFC01C44);
		debugfs_create_x16("DMA13_X_COUNT", 0600, parent, (u16 *)0xFFC01C50);
		debugfs_create_x16("DMA13_X_MODIFY", 0600, parent, (u16 *)0xFFC01C54);
		debugfs_create_x16("DMA13_Y_COUNT", 0600, parent, (u16 *)0xFFC01C58);
		debugfs_create_x16("DMA13_Y_MODIFY", 0600, parent, (u16 *)0xFFC01C5C);
		debugfs_create_x16("DMA14_CONFIG", 0600, parent, (u16 *)0xFFC01C88);
		debugfs_create_x32("DMA14_CURR_ADDR", 0600, parent, (u32 *)0xFFC01CA4);
		debugfs_create_x32("DMA14_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01CA0);
		debugfs_create_x16("DMA14_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01CB0);
		debugfs_create_x16("DMA14_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01CB8);
		debugfs_create_x16("DMA14_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01CA8);
		debugfs_create_x32("DMA14_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01C80);
		debugfs_create_x16("DMA14_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01CAC);
		debugfs_create_x32("DMA14_START_ADDR", 0600, parent, (u32 *)0xFFC01C84);
		debugfs_create_x16("DMA14_X_COUNT", 0600, parent, (u16 *)0xFFC01C90);
		debugfs_create_x16("DMA14_X_MODIFY", 0600, parent, (u16 *)0xFFC01C94);
		debugfs_create_x16("DMA14_Y_COUNT", 0600, parent, (u16 *)0xFFC01C98);
		debugfs_create_x16("DMA14_Y_MODIFY", 0600, parent, (u16 *)0xFFC01C9C);
		debugfs_create_x16("DMA15_CONFIG", 0600, parent, (u16 *)0xFFC01CC8);
		debugfs_create_x32("DMA15_CURR_ADDR", 0600, parent, (u32 *)0xFFC01CE4);
		debugfs_create_x32("DMA15_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01CE0);
		debugfs_create_x16("DMA15_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01CF0);
		debugfs_create_x16("DMA15_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01CF8);
		debugfs_create_x16("DMA15_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01CE8);
		debugfs_create_x32("DMA15_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01CC0);
		debugfs_create_x16("DMA15_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01CEC);
		debugfs_create_x32("DMA15_START_ADDR", 0600, parent, (u32 *)0xFFC01CC4);
		debugfs_create_x16("DMA15_X_COUNT", 0600, parent, (u16 *)0xFFC01CD0);
		debugfs_create_x16("DMA15_X_MODIFY", 0600, parent, (u16 *)0xFFC01CD4);
		debugfs_create_x16("DMA15_Y_COUNT", 0600, parent, (u16 *)0xFFC01CD8);
		debugfs_create_x16("DMA15_Y_MODIFY", 0600, parent, (u16 *)0xFFC01CDC);
		debugfs_create_x16("DMA16_CONFIG", 0600, parent, (u16 *)0xFFC01D08);
		debugfs_create_x32("DMA16_CURR_ADDR", 0600, parent, (u32 *)0xFFC01D24);
		debugfs_create_x32("DMA16_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01D20);
		debugfs_create_x16("DMA16_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01D30);
		debugfs_create_x16("DMA16_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01D38);
		debugfs_create_x16("DMA16_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01D28);
		debugfs_create_x32("DMA16_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01D00);
		debugfs_create_x16("DMA16_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01D2C);
		debugfs_create_x32("DMA16_START_ADDR", 0600, parent, (u32 *)0xFFC01D04);
		debugfs_create_x16("DMA16_X_COUNT", 0600, parent, (u16 *)0xFFC01D10);
		debugfs_create_x16("DMA16_X_MODIFY", 0600, parent, (u16 *)0xFFC01D14);
		debugfs_create_x16("DMA16_Y_COUNT", 0600, parent, (u16 *)0xFFC01D18);
		debugfs_create_x16("DMA16_Y_MODIFY", 0600, parent, (u16 *)0xFFC01D1C);
		debugfs_create_x16("DMA17_CONFIG", 0600, parent, (u16 *)0xFFC01D48);
		debugfs_create_x32("DMA17_CURR_ADDR", 0600, parent, (u32 *)0xFFC01D64);
		debugfs_create_x32("DMA17_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01D60);
		debugfs_create_x16("DMA17_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01D70);
		debugfs_create_x16("DMA17_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01D78);
		debugfs_create_x16("DMA17_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01D68);
		debugfs_create_x32("DMA17_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01D40);
		debugfs_create_x16("DMA17_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01D6C);
		debugfs_create_x32("DMA17_START_ADDR", 0600, parent, (u32 *)0xFFC01D44);
		debugfs_create_x16("DMA17_X_COUNT", 0600, parent, (u16 *)0xFFC01D50);
		debugfs_create_x16("DMA17_X_MODIFY", 0600, parent, (u16 *)0xFFC01D54);
		debugfs_create_x16("DMA17_Y_COUNT", 0600, parent, (u16 *)0xFFC01D58);
		debugfs_create_x16("DMA17_Y_MODIFY", 0600, parent, (u16 *)0xFFC01D5C);
		debugfs_create_x16("DMA18_CONFIG", 0600, parent, (u16 *)0xFFC01D88);
		debugfs_create_x32("DMA18_CURR_ADDR", 0600, parent, (u32 *)0xFFC01DA4);
		debugfs_create_x32("DMA18_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01DA0);
		debugfs_create_x16("DMA18_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01DB0);
		debugfs_create_x16("DMA18_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01DB8);
		debugfs_create_x16("DMA18_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01DA8);
		debugfs_create_x32("DMA18_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01D80);
		debugfs_create_x16("DMA18_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01DAC);
		debugfs_create_x32("DMA18_START_ADDR", 0600, parent, (u32 *)0xFFC01D84);
		debugfs_create_x16("DMA18_X_COUNT", 0600, parent, (u16 *)0xFFC01D90);
		debugfs_create_x16("DMA18_X_MODIFY", 0600, parent, (u16 *)0xFFC01D94);
		debugfs_create_x16("DMA18_Y_COUNT", 0600, parent, (u16 *)0xFFC01D98);
		debugfs_create_x16("DMA18_Y_MODIFY", 0600, parent, (u16 *)0xFFC01D9C);
		debugfs_create_x16("DMA19_CONFIG", 0600, parent, (u16 *)0xFFC01DC8);
		debugfs_create_x32("DMA19_CURR_ADDR", 0600, parent, (u32 *)0xFFC01DE4);
		debugfs_create_x32("DMA19_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01DE0);
		debugfs_create_x16("DMA19_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01DF0);
		debugfs_create_x16("DMA19_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01DF8);
		debugfs_create_x16("DMA19_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01DE8);
		debugfs_create_x32("DMA19_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01DC0);
		debugfs_create_x16("DMA19_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01DEC);
		debugfs_create_x32("DMA19_START_ADDR", 0600, parent, (u32 *)0xFFC01DC4);
		debugfs_create_x16("DMA19_X_COUNT", 0600, parent, (u16 *)0xFFC01DD0);
		debugfs_create_x16("DMA19_X_MODIFY", 0600, parent, (u16 *)0xFFC01DD4);
		debugfs_create_x16("DMA19_Y_COUNT", 0600, parent, (u16 *)0xFFC01DD8);
		debugfs_create_x16("DMA19_Y_MODIFY", 0600, parent, (u16 *)0xFFC01DDC);
		debugfs_create_x16("DMA1_CONFIG", 0600, parent, (u16 *)0xFFC00C48);
		debugfs_create_x32("DMA1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C64);
		debugfs_create_x32("DMA1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C60);
		debugfs_create_x16("DMA1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C70);
		debugfs_create_x16("DMA1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C78);
		debugfs_create_x16("DMA1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C68);
		debugfs_create_x32("DMA1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C40);
		debugfs_create_x16("DMA1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C6C);
		debugfs_create_x32("DMA1_START_ADDR", 0600, parent, (u32 *)0xFFC00C44);
		debugfs_create_x16("DMA1_X_COUNT", 0600, parent, (u16 *)0xFFC00C50);
		debugfs_create_x16("DMA1_X_MODIFY", 0600, parent, (u16 *)0xFFC00C54);
		debugfs_create_x16("DMA1_Y_COUNT", 0600, parent, (u16 *)0xFFC00C58);
		debugfs_create_x16("DMA1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C5C);
		debugfs_create_x16("DMA20_CONFIG", 0600, parent, (u16 *)0xFFC01E08);
		debugfs_create_x32("DMA20_CURR_ADDR", 0600, parent, (u32 *)0xFFC01E24);
		debugfs_create_x32("DMA20_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01E20);
		debugfs_create_x16("DMA20_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01E30);
		debugfs_create_x16("DMA20_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01E38);
		debugfs_create_x16("DMA20_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01E28);
		debugfs_create_x32("DMA20_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01E00);
		debugfs_create_x16("DMA20_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01E2C);
		debugfs_create_x32("DMA20_START_ADDR", 0600, parent, (u32 *)0xFFC01E04);
		debugfs_create_x16("DMA20_X_COUNT", 0600, parent, (u16 *)0xFFC01E10);
		debugfs_create_x16("DMA20_X_MODIFY", 0600, parent, (u16 *)0xFFC01E14);
		debugfs_create_x16("DMA20_Y_COUNT", 0600, parent, (u16 *)0xFFC01E18);
		debugfs_create_x16("DMA20_Y_MODIFY", 0600, parent, (u16 *)0xFFC01E1C);
		debugfs_create_x16("DMA21_CONFIG", 0600, parent, (u16 *)0xFFC01E48);
		debugfs_create_x32("DMA21_CURR_ADDR", 0600, parent, (u32 *)0xFFC01E64);
		debugfs_create_x32("DMA21_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01E60);
		debugfs_create_x16("DMA21_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01E70);
		debugfs_create_x16("DMA21_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01E78);
		debugfs_create_x16("DMA21_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01E68);
		debugfs_create_x32("DMA21_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01E40);
		debugfs_create_x16("DMA21_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01E6C);
		debugfs_create_x32("DMA21_START_ADDR", 0600, parent, (u32 *)0xFFC01E44);
		debugfs_create_x16("DMA21_X_COUNT", 0600, parent, (u16 *)0xFFC01E50);
		debugfs_create_x16("DMA21_X_MODIFY", 0600, parent, (u16 *)0xFFC01E54);
		debugfs_create_x16("DMA21_Y_COUNT", 0600, parent, (u16 *)0xFFC01E58);
		debugfs_create_x16("DMA21_Y_MODIFY", 0600, parent, (u16 *)0xFFC01E5C);
		debugfs_create_x16("DMA22_CONFIG", 0600, parent, (u16 *)0xFFC01E88);
		debugfs_create_x32("DMA22_CURR_ADDR", 0600, parent, (u32 *)0xFFC01EA4);
		debugfs_create_x32("DMA22_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01EA0);
		debugfs_create_x16("DMA22_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01EB0);
		debugfs_create_x16("DMA22_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01EB8);
		debugfs_create_x16("DMA22_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01EA8);
		debugfs_create_x32("DMA22_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01E80);
		debugfs_create_x16("DMA22_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01EAC);
		debugfs_create_x32("DMA22_START_ADDR", 0600, parent, (u32 *)0xFFC01E84);
		debugfs_create_x16("DMA22_X_COUNT", 0600, parent, (u16 *)0xFFC01E90);
		debugfs_create_x16("DMA22_X_MODIFY", 0600, parent, (u16 *)0xFFC01E94);
		debugfs_create_x16("DMA22_Y_COUNT", 0600, parent, (u16 *)0xFFC01E98);
		debugfs_create_x16("DMA22_Y_MODIFY", 0600, parent, (u16 *)0xFFC01E9C);
		debugfs_create_x16("DMA23_CONFIG", 0600, parent, (u16 *)0xFFC01EC8);
		debugfs_create_x32("DMA23_CURR_ADDR", 0600, parent, (u32 *)0xFFC01EE4);
		debugfs_create_x32("DMA23_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01EE0);
		debugfs_create_x16("DMA23_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01EF0);
		debugfs_create_x16("DMA23_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01EF8);
		debugfs_create_x16("DMA23_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01EE8);
		debugfs_create_x32("DMA23_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01EC0);
		debugfs_create_x16("DMA23_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01EEC);
		debugfs_create_x32("DMA23_START_ADDR", 0600, parent, (u32 *)0xFFC01EC4);
		debugfs_create_x16("DMA23_X_COUNT", 0600, parent, (u16 *)0xFFC01ED0);
		debugfs_create_x16("DMA23_X_MODIFY", 0600, parent, (u16 *)0xFFC01ED4);
		debugfs_create_x16("DMA23_Y_COUNT", 0600, parent, (u16 *)0xFFC01ED8);
		debugfs_create_x16("DMA23_Y_MODIFY", 0600, parent, (u16 *)0xFFC01EDC);
		debugfs_create_x16("DMA2_CONFIG", 0600, parent, (u16 *)0xFFC00C88);
		debugfs_create_x32("DMA2_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CA4);
		debugfs_create_x32("DMA2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CA0);
		debugfs_create_x16("DMA2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CB0);
		debugfs_create_x16("DMA2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CB8);
		debugfs_create_x16("DMA2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CA8);
		debugfs_create_x32("DMA2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C80);
		debugfs_create_x16("DMA2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CAC);
		debugfs_create_x32("DMA2_START_ADDR", 0600, parent, (u32 *)0xFFC00C84);
		debugfs_create_x16("DMA2_X_COUNT", 0600, parent, (u16 *)0xFFC00C90);
		debugfs_create_x16("DMA2_X_MODIFY", 0600, parent, (u16 *)0xFFC00C94);
		debugfs_create_x16("DMA2_Y_COUNT", 0600, parent, (u16 *)0xFFC00C98);
		debugfs_create_x16("DMA2_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C9C);
		debugfs_create_x16("DMA3_CONFIG", 0600, parent, (u16 *)0xFFC00CC8);
		debugfs_create_x32("DMA3_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CE4);
		debugfs_create_x32("DMA3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CE0);
		debugfs_create_x16("DMA3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CF0);
		debugfs_create_x16("DMA3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CF8);
		debugfs_create_x16("DMA3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CE8);
		debugfs_create_x32("DMA3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00CC0);
		debugfs_create_x16("DMA3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CEC);
		debugfs_create_x32("DMA3_START_ADDR", 0600, parent, (u32 *)0xFFC00CC4);
		debugfs_create_x16("DMA3_X_COUNT", 0600, parent, (u16 *)0xFFC00CD0);
		debugfs_create_x16("DMA3_X_MODIFY", 0600, parent, (u16 *)0xFFC00CD4);
		debugfs_create_x16("DMA3_Y_COUNT", 0600, parent, (u16 *)0xFFC00CD8);
		debugfs_create_x16("DMA3_Y_MODIFY", 0600, parent, (u16 *)0xFFC00CDC);
		debugfs_create_x16("DMA4_CONFIG", 0600, parent, (u16 *)0xFFC00D08);
		debugfs_create_x32("DMA4_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D24);
		debugfs_create_x32("DMA4_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D20);
		debugfs_create_x16("DMA4_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D30);
		debugfs_create_x16("DMA4_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D38);
		debugfs_create_x16("DMA4_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D28);
		debugfs_create_x32("DMA4_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D00);
		debugfs_create_x16("DMA4_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D2C);
		debugfs_create_x32("DMA4_START_ADDR", 0600, parent, (u32 *)0xFFC00D04);
		debugfs_create_x16("DMA4_X_COUNT", 0600, parent, (u16 *)0xFFC00D10);
		debugfs_create_x16("DMA4_X_MODIFY", 0600, parent, (u16 *)0xFFC00D14);
		debugfs_create_x16("DMA4_Y_COUNT", 0600, parent, (u16 *)0xFFC00D18);
		debugfs_create_x16("DMA4_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D1C);
		debugfs_create_x16("DMA5_CONFIG", 0600, parent, (u16 *)0xFFC00D48);
		debugfs_create_x32("DMA5_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D64);
		debugfs_create_x32("DMA5_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D60);
		debugfs_create_x16("DMA5_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D70);
		debugfs_create_x16("DMA5_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D78);
		debugfs_create_x16("DMA5_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D68);
		debugfs_create_x32("DMA5_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D40);
		debugfs_create_x16("DMA5_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D6C);
		debugfs_create_x32("DMA5_START_ADDR", 0600, parent, (u32 *)0xFFC00D44);
		debugfs_create_x16("DMA5_X_COUNT", 0600, parent, (u16 *)0xFFC00D50);
		debugfs_create_x16("DMA5_X_MODIFY", 0600, parent, (u16 *)0xFFC00D54);
		debugfs_create_x16("DMA5_Y_COUNT", 0600, parent, (u16 *)0xFFC00D58);
		debugfs_create_x16("DMA5_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D5C);
		debugfs_create_x16("DMA6_CONFIG", 0600, parent, (u16 *)0xFFC00D88);
		debugfs_create_x32("DMA6_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DA4);
		debugfs_create_x32("DMA6_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DA0);
		debugfs_create_x16("DMA6_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DB0);
		debugfs_create_x16("DMA6_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DB8);
		debugfs_create_x16("DMA6_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DA8);
		debugfs_create_x32("DMA6_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D80);
		debugfs_create_x16("DMA6_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DAC);
		debugfs_create_x32("DMA6_START_ADDR", 0600, parent, (u32 *)0xFFC00D84);
		debugfs_create_x16("DMA6_X_COUNT", 0600, parent, (u16 *)0xFFC00D90);
		debugfs_create_x16("DMA6_X_MODIFY", 0600, parent, (u16 *)0xFFC00D94);
		debugfs_create_x16("DMA6_Y_COUNT", 0600, parent, (u16 *)0xFFC00D98);
		debugfs_create_x16("DMA6_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D9C);
		debugfs_create_x16("DMA7_CONFIG", 0600, parent, (u16 *)0xFFC00DC8);
		debugfs_create_x32("DMA7_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DE4);
		debugfs_create_x32("DMA7_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DE0);
		debugfs_create_x16("DMA7_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DF0);
		debugfs_create_x16("DMA7_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DF8);
		debugfs_create_x16("DMA7_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DE8);
		debugfs_create_x32("DMA7_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00DC0);
		debugfs_create_x16("DMA7_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DEC);
		debugfs_create_x32("DMA7_START_ADDR", 0600, parent, (u32 *)0xFFC00DC4);
		debugfs_create_x16("DMA7_X_COUNT", 0600, parent, (u16 *)0xFFC00DD0);
		debugfs_create_x16("DMA7_X_MODIFY", 0600, parent, (u16 *)0xFFC00DD4);
		debugfs_create_x16("DMA7_Y_COUNT", 0600, parent, (u16 *)0xFFC00DD8);
		debugfs_create_x16("DMA7_Y_MODIFY", 0600, parent, (u16 *)0xFFC00DDC);
		debugfs_create_x16("DMA8_CONFIG", 0600, parent, (u16 *)0xFFC00E08);
		debugfs_create_x32("DMA8_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E24);
		debugfs_create_x32("DMA8_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E20);
		debugfs_create_x16("DMA8_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E30);
		debugfs_create_x16("DMA8_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E38);
		debugfs_create_x16("DMA8_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E28);
		debugfs_create_x32("DMA8_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E00);
		debugfs_create_x16("DMA8_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E2C);
		debugfs_create_x32("DMA8_START_ADDR", 0600, parent, (u32 *)0xFFC00E04);
		debugfs_create_x16("DMA8_X_COUNT", 0600, parent, (u16 *)0xFFC00E10);
		debugfs_create_x16("DMA8_X_MODIFY", 0600, parent, (u16 *)0xFFC00E14);
		debugfs_create_x16("DMA8_Y_COUNT", 0600, parent, (u16 *)0xFFC00E18);
		debugfs_create_x16("DMA8_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E1C);
		debugfs_create_x16("DMA9_CONFIG", 0600, parent, (u16 *)0xFFC00E48);
		debugfs_create_x32("DMA9_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E64);
		debugfs_create_x32("DMA9_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E60);
		debugfs_create_x16("DMA9_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E70);
		debugfs_create_x16("DMA9_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E78);
		debugfs_create_x16("DMA9_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E68);
		debugfs_create_x32("DMA9_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E40);
		debugfs_create_x16("DMA9_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E6C);
		debugfs_create_x32("DMA9_START_ADDR", 0600, parent, (u32 *)0xFFC00E44);
		debugfs_create_x16("DMA9_X_COUNT", 0600, parent, (u16 *)0xFFC00E50);
		debugfs_create_x16("DMA9_X_MODIFY", 0600, parent, (u16 *)0xFFC00E54);
		debugfs_create_x16("DMA9_Y_COUNT", 0600, parent, (u16 *)0xFFC00E58);
		debugfs_create_x16("DMA9_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E5C);
		debugfs_create_x16("DMAC0_TCCNT", 0600, parent, (u16 *)0xFFC00B10);
		debugfs_create_x16("DMAC0_TCPER", 0600, parent, (u16 *)0xFFC00B0C);
		debugfs_create_x16("DMAC1_PERIMUX", 0600, parent, (u16 *)0xFFC04340);
		debugfs_create_x16("DMAC1_TCCNT", 0600, parent, (u16 *)0xFFC01B10);
		debugfs_create_x16("DMAC1_TCPER", 0600, parent, (u16 *)0xFFC01B0C);

		parent = debugfs_create_dir("EBIU", top);
		debugfs_create_x32("EBIU_AMBCTL0", 0600, parent, (u32 *)0xFFC00A04);
		debugfs_create_x32("EBIU_AMBCTL1", 0600, parent, (u32 *)0xFFC00A08);
		debugfs_create_x16("EBIU_AMGCTL", 0600, parent, (u16 *)0xFFC00A00);
		debugfs_create_x32("EBIU_ARBSTAT", 0600, parent, (u32 *)0xFFC00A10);
		debugfs_create_x32("EBIU_DDRACCT", 0600, parent, (u32 *)0xFFC00AA0);
		debugfs_create_x32("EBIU_DDRARCT", 0600, parent, (u32 *)0xFFC00AAC);
		debugfs_create_x32("EBIU_DDRBRC0", 0600, parent, (u32 *)0xFFC00A60);
		debugfs_create_x32("EBIU_DDRBRC1", 0600, parent, (u32 *)0xFFC00A64);
		debugfs_create_x32("EBIU_DDRBRC2", 0600, parent, (u32 *)0xFFC00A68);
		debugfs_create_x32("EBIU_DDRBRC3", 0600, parent, (u32 *)0xFFC00A6C);
		debugfs_create_x32("EBIU_DDRBRC4", 0600, parent, (u32 *)0xFFC00A70);
		debugfs_create_x32("EBIU_DDRBRC5", 0600, parent, (u32 *)0xFFC00A74);
		debugfs_create_x32("EBIU_DDRBRC6", 0600, parent, (u32 *)0xFFC00A78);
		debugfs_create_x32("EBIU_DDRBRC7", 0600, parent, (u32 *)0xFFC00A7C);
		debugfs_create_x32("EBIU_DDRBWC0", 0600, parent, (u32 *)0xFFC00A80);
		debugfs_create_x32("EBIU_DDRBWC1", 0600, parent, (u32 *)0xFFC00A84);
		debugfs_create_x32("EBIU_DDRBWC2", 0600, parent, (u32 *)0xFFC00A88);
		debugfs_create_x32("EBIU_DDRBWC3", 0600, parent, (u32 *)0xFFC00A8C);
		debugfs_create_x32("EBIU_DDRBWC4", 0600, parent, (u32 *)0xFFC00A90);
		debugfs_create_x32("EBIU_DDRBWC5", 0600, parent, (u32 *)0xFFC00A94);
		debugfs_create_x32("EBIU_DDRBWC6", 0600, parent, (u32 *)0xFFC00A98);
		debugfs_create_x32("EBIU_DDRBWC7", 0600, parent, (u32 *)0xFFC00A9C);
		debugfs_create_x32("EBIU_DDRCTL0", 0600, parent, (u32 *)0xFFC00A20);
		debugfs_create_x32("EBIU_DDRCTL1", 0600, parent, (u32 *)0xFFC00A24);
		debugfs_create_x32("EBIU_DDRCTL2", 0600, parent, (u32 *)0xFFC00A28);
		debugfs_create_x32("EBIU_DDRCTL3", 0600, parent, (u32 *)0xFFC00A2C);
		debugfs_create_x32("EBIU_DDRGC0", 0600, parent, (u32 *)0xFFC00AB0);
		debugfs_create_x32("EBIU_DDRGC1", 0600, parent, (u32 *)0xFFC00AB4);
		debugfs_create_x32("EBIU_DDRGC2", 0600, parent, (u32 *)0xFFC00AB8);
		debugfs_create_x32("EBIU_DDRGC3", 0600, parent, (u32 *)0xFFC00ABC);
		debugfs_create_x32("EBIU_DDRMCCL", 0600, parent, (u32 *)0xFFC00AC4);
		debugfs_create_x32("EBIU_DDRMCEN", 0600, parent, (u32 *)0xFFC00AC0);
		debugfs_create_x32("EBIU_DDRQUE", 0600, parent, (u32 *)0xFFC00A30);
		debugfs_create_x32("EBIU_DDRTACT", 0600, parent, (u32 *)0xFFC00AA8);
		debugfs_create_x32("EBIU_ERRADD", 0600, parent, (u32 *)0xFFC00A34);
		debugfs_create_x16("EBIU_ERRMST", 0600, parent, (u16 *)0xFFC00A38);
		debugfs_create_x32("EBIU_FCTL", 0600, parent, (u32 *)0xFFC00A18);
		debugfs_create_x32("EBIU_MBSCTL", 0600, parent, (u32 *)0xFFC00A0C);
		debugfs_create_x32("EBIU_MODE", 0600, parent, (u32 *)0xFFC00A14);
		debugfs_create_x16("EBIU_RSTCTL", 0600, parent, (u16 *)0xFFC00A3C);

		parent = debugfs_create_dir("EPPI", top);
		debugfs_create_x32("EPPI0_CLIP", 0600, parent, (u32 *)0xFFC01034);
		debugfs_create_x16("EPPI0_CLKDIV", 0600, parent, (u16 *)0xFFC0101C);
		debugfs_create_x32("EPPI0_CONTROL", 0600, parent, (u32 *)0xFFC01020);
		debugfs_create_x16("EPPI0_FRAME", 0600, parent, (u16 *)0xFFC01014);
		debugfs_create_x32("EPPI0_FS1P_AVPL", 0600, parent, (u32 *)0xFFC01028);
		debugfs_create_x32("EPPI0_FS1W_HBL", 0600, parent, (u32 *)0xFFC01024);
		debugfs_create_x32("EPPI0_FS2P_LAVF", 0600, parent, (u32 *)0xFFC01030);
		debugfs_create_x32("EPPI0_FS2W_LVB", 0600, parent, (u32 *)0xFFC0102C);
		debugfs_create_x16("EPPI0_HCOUNT", 0600, parent, (u16 *)0xFFC01004);
		debugfs_create_x16("EPPI0_HDELAY", 0600, parent, (u16 *)0xFFC01008);
		debugfs_create_x16("EPPI0_LINE", 0600, parent, (u16 *)0xFFC01018);
		debugfs_create_x16("EPPI0_STATUS", 0600, parent, (u16 *)0xFFC01000);
		debugfs_create_x16("EPPI0_VCOUNT", 0600, parent, (u16 *)0xFFC0100C);
		debugfs_create_x16("EPPI0_VDELAY", 0600, parent, (u16 *)0xFFC01010);
		debugfs_create_x32("EPPI1_CLIP", 0600, parent, (u32 *)0xFFC01334);
		debugfs_create_x16("EPPI1_CLKDIV", 0600, parent, (u16 *)0xFFC0131C);
		debugfs_create_x32("EPPI1_CONTROL", 0600, parent, (u32 *)0xFFC01320);
		debugfs_create_x16("EPPI1_FRAME", 0600, parent, (u16 *)0xFFC01314);
		debugfs_create_x32("EPPI1_FS1P_AVPL", 0600, parent, (u32 *)0xFFC01328);
		debugfs_create_x32("EPPI1_FS1W_HBL", 0600, parent, (u32 *)0xFFC01324);
		debugfs_create_x32("EPPI1_FS2P_LAVF", 0600, parent, (u32 *)0xFFC01330);
		debugfs_create_x32("EPPI1_FS2W_LVB", 0600, parent, (u32 *)0xFFC0132C);
		debugfs_create_x16("EPPI1_HCOUNT", 0600, parent, (u16 *)0xFFC01304);
		debugfs_create_x16("EPPI1_HDELAY", 0600, parent, (u16 *)0xFFC01308);
		debugfs_create_x16("EPPI1_LINE", 0600, parent, (u16 *)0xFFC01318);
		debugfs_create_x16("EPPI1_STATUS", 0600, parent, (u16 *)0xFFC01300);
		debugfs_create_x16("EPPI1_VCOUNT", 0600, parent, (u16 *)0xFFC0130C);
		debugfs_create_x16("EPPI1_VDELAY", 0600, parent, (u16 *)0xFFC01310);
		debugfs_create_x32("EPPI2_CLIP", 0600, parent, (u32 *)0xFFC02934);
		debugfs_create_x16("EPPI2_CLKDIV", 0600, parent, (u16 *)0xFFC0291C);
		debugfs_create_x32("EPPI2_CONTROL", 0600, parent, (u32 *)0xFFC02920);
		debugfs_create_x16("EPPI2_FRAME", 0600, parent, (u16 *)0xFFC02914);
		debugfs_create_x32("EPPI2_FS1P_AVPL", 0600, parent, (u32 *)0xFFC02928);
		debugfs_create_x32("EPPI2_FS1W_HBL", 0600, parent, (u32 *)0xFFC02924);
		debugfs_create_x32("EPPI2_FS2P_LAVF", 0600, parent, (u32 *)0xFFC02930);
		debugfs_create_x32("EPPI2_FS2W_LVB", 0600, parent, (u32 *)0xFFC0292C);
		debugfs_create_x16("EPPI2_HCOUNT", 0600, parent, (u16 *)0xFFC02904);
		debugfs_create_x16("EPPI2_HDELAY", 0600, parent, (u16 *)0xFFC02908);
		debugfs_create_x16("EPPI2_LINE", 0600, parent, (u16 *)0xFFC02918);
		debugfs_create_x16("EPPI2_STATUS", 0600, parent, (u16 *)0xFFC02900);
		debugfs_create_x16("EPPI2_VCOUNT", 0600, parent, (u16 *)0xFFC0290C);
		debugfs_create_x16("EPPI2_VDELAY", 0600, parent, (u16 *)0xFFC02910);

		parent = debugfs_create_dir("Event Vectors", top);
		debugfs_create_x32("EVT0", 0600, parent, (u32 *)0xFFE02000);
		debugfs_create_x32("EVT10", 0600, parent, (u32 *)0xFFE02028);
		debugfs_create_x32("EVT11", 0600, parent, (u32 *)0xFFE0202C);
		debugfs_create_x32("EVT12", 0600, parent, (u32 *)0xFFE02030);
		debugfs_create_x32("EVT13", 0600, parent, (u32 *)0xFFE02034);
		debugfs_create_x32("EVT14", 0600, parent, (u32 *)0xFFE02038);
		debugfs_create_x32("EVT15", 0600, parent, (u32 *)0xFFE0203C);
		debugfs_create_x32("EVT1", 0600, parent, (u32 *)0xFFE02004);
		debugfs_create_x32("EVT2", 0600, parent, (u32 *)0xFFE02008);
		debugfs_create_x32("EVT3", 0600, parent, (u32 *)0xFFE0200C);
		debugfs_create_x32("EVT4", 0600, parent, (u32 *)0xFFE02010);
		debugfs_create_x32("EVT5", 0600, parent, (u32 *)0xFFE02014);
		debugfs_create_x32("EVT6", 0600, parent, (u32 *)0xFFE02018);
		debugfs_create_x32("EVT7", 0600, parent, (u32 *)0xFFE0201C);
		debugfs_create_x32("EVT8", 0600, parent, (u32 *)0xFFE02020);
		debugfs_create_x32("EVT9", 0600, parent, (u32 *)0xFFE02024);

		parent = debugfs_create_dir("Extended Registers", top);
		debugfs_create_x32("CHIPID", 0600, parent, (u32 *)0xFFC00014);
		debugfs_create_x32("DSPID", 0600, parent, (u32 *)0xFFE05000);

		parent = debugfs_create_dir("HMDMA", top);
		debugfs_create_x16("HMDMA0_BCINIT", 0600, parent, (u16 *)0xFFC04508);
		debugfs_create_x16("HMDMA0_BCOUNT", 0600, parent, (u16 *)0xFFC04518);
		debugfs_create_x16("HMDMA0_CONTROL", 0600, parent, (u16 *)0xFFC04500);
		debugfs_create_x16("HMDMA0_ECINIT", 0600, parent, (u16 *)0xFFC04504);
		debugfs_create_x16("HMDMA0_ECOUNT", 0600, parent, (u16 *)0xFFC04514);
		debugfs_create_x16("HMDMA0_ECOVERFLOW", 0600, parent, (u16 *)0xFFC04510);
		debugfs_create_x16("HMDMA0_ECURGENT", 0600, parent, (u16 *)0xFFC0450C);
		debugfs_create_x16("HMDMA1_BCINIT", 0600, parent, (u16 *)0xFFC04548);
		debugfs_create_x16("HMDMA1_BCOUNT", 0600, parent, (u16 *)0xFFC04558);
		debugfs_create_x16("HMDMA1_CONTROL", 0600, parent, (u16 *)0xFFC04540);
		debugfs_create_x16("HMDMA1_ECINIT", 0600, parent, (u16 *)0xFFC04544);
		debugfs_create_x16("HMDMA1_ECOUNT", 0600, parent, (u16 *)0xFFC04554);
		debugfs_create_x16("HMDMA1_ECOVERFLOW", 0600, parent, (u16 *)0xFFC04550);
		debugfs_create_x16("HMDMA1_ECURGENT", 0600, parent, (u16 *)0xFFC0454C);

		parent = debugfs_create_dir("HOSTDP", top);
		debugfs_create_x16("HOST_CONTROL", 0600, parent, (u16 *)0xFFC03A00);
		debugfs_create_x16("HOST_STATUS", 0600, parent, (u16 *)0xFFC03A04);
		debugfs_create_x16("HOST_TIMEOUT", 0600, parent, (u16 *)0xFFC03A08);

		parent = debugfs_create_dir("Interrupt Controller", top);
		debugfs_create_x32("ILAT", 0600, parent, (u32 *)0xFFE0210C);
		debugfs_create_x32("IMASK", 0600, parent, (u32 *)0xFFE02104);
		debugfs_create_x32("IPEND", 0600, parent, (u32 *)0xFFE02108);
		debugfs_create_x32("IPRIO", 0600, parent, (u32 *)0xFFE02110);

		parent = debugfs_create_dir("KEYPAD", top);
		debugfs_create_x16("KPAD_CTL", 0600, parent, (u16 *)0xFFC04100);
		debugfs_create_x16("KPAD_MSEL", 0600, parent, (u16 *)0xFFC04108);
		debugfs_create_x16("KPAD_PRESCALE", 0600, parent, (u16 *)0xFFC04104);
		debugfs_create_x16("KPAD_ROWCOL", 0600, parent, (u16 *)0xFFC0410C);
		debugfs_create_x16("KPAD_SOFTEVAL", 0600, parent, (u16 *)0xFFC04114);
		debugfs_create_x16("KPAD_STAT", 0600, parent, (u16 *)0xFFC04110);

		parent = debugfs_create_dir("L1 Code Memory Registers", top);
		debugfs_create_x32("ICPLB_ADDR0", 0600, parent, (u32 *)0xFFE01100);
		debugfs_create_x32("ICPLB_ADDR10", 0600, parent, (u32 *)0xFFE01128);
		debugfs_create_x32("ICPLB_ADDR11", 0600, parent, (u32 *)0xFFE0112C);
		debugfs_create_x32("ICPLB_ADDR12", 0600, parent, (u32 *)0xFFE01130);
		debugfs_create_x32("ICPLB_ADDR13", 0600, parent, (u32 *)0xFFE01134);
		debugfs_create_x32("ICPLB_ADDR14", 0600, parent, (u32 *)0xFFE01138);
		debugfs_create_x32("ICPLB_ADDR15", 0600, parent, (u32 *)0xFFE0113C);
		debugfs_create_x32("ICPLB_ADDR1", 0600, parent, (u32 *)0xFFE01104);
		debugfs_create_x32("ICPLB_ADDR2", 0600, parent, (u32 *)0xFFE01108);
		debugfs_create_x32("ICPLB_ADDR3", 0600, parent, (u32 *)0xFFE0110C);
		debugfs_create_x32("ICPLB_ADDR4", 0600, parent, (u32 *)0xFFE01110);
		debugfs_create_x32("ICPLB_ADDR5", 0600, parent, (u32 *)0xFFE01114);
		debugfs_create_x32("ICPLB_ADDR6", 0600, parent, (u32 *)0xFFE01118);
		debugfs_create_x32("ICPLB_ADDR7", 0600, parent, (u32 *)0xFFE0111C);
		debugfs_create_x32("ICPLB_ADDR8", 0600, parent, (u32 *)0xFFE01120);
		debugfs_create_x32("ICPLB_ADDR9", 0600, parent, (u32 *)0xFFE01124);
		debugfs_create_x32("ICPLB_DATA0", 0600, parent, (u32 *)0xFFE01200);
		debugfs_create_x32("ICPLB_DATA10", 0600, parent, (u32 *)0xFFE01228);
		debugfs_create_x32("ICPLB_DATA11", 0600, parent, (u32 *)0xFFE0122C);
		debugfs_create_x32("ICPLB_DATA12", 0600, parent, (u32 *)0xFFE01230);
		debugfs_create_x32("ICPLB_DATA13", 0600, parent, (u32 *)0xFFE01234);
		debugfs_create_x32("ICPLB_DATA14", 0600, parent, (u32 *)0xFFE01238);
		debugfs_create_x32("ICPLB_DATA15", 0600, parent, (u32 *)0xFFE0123C);
		debugfs_create_x32("ICPLB_DATA1", 0600, parent, (u32 *)0xFFE01204);
		debugfs_create_x32("ICPLB_DATA2", 0600, parent, (u32 *)0xFFE01208);
		debugfs_create_x32("ICPLB_DATA3", 0600, parent, (u32 *)0xFFE0120C);
		debugfs_create_x32("ICPLB_DATA4", 0600, parent, (u32 *)0xFFE01210);
		debugfs_create_x32("ICPLB_DATA5", 0600, parent, (u32 *)0xFFE01214);
		debugfs_create_x32("ICPLB_DATA6", 0600, parent, (u32 *)0xFFE01218);
		debugfs_create_x32("ICPLB_DATA7", 0600, parent, (u32 *)0xFFE0121C);
		debugfs_create_x32("ICPLB_DATA8", 0600, parent, (u32 *)0xFFE01220);
		debugfs_create_x32("ICPLB_DATA9", 0600, parent, (u32 *)0xFFE01224);
		debugfs_create_x32("ICPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0100C);
		debugfs_create_x32("ICPLB_STATUS", 0600, parent, (u32 *)0xFFE01008);
		debugfs_create_x32("IMEM_CONTROL", 0600, parent, (u32 *)0xFFE01004);
		debugfs_create_x32("ITEST_COMMAND", 0600, parent, (u32 *)0xFFE01300);
		debugfs_create_x32("ITEST_DATA0", 0600, parent, (u32 *)0xFFE01400);
		debugfs_create_x32("ITEST_DATA1", 0600, parent, (u32 *)0xFFE01404);

		parent = debugfs_create_dir("L1 Data Memory Registers", top);
		debugfs_create_x32("DCPLB_ADDR0", 0600, parent, (u32 *)0xFFE00100);
		debugfs_create_x32("DCPLB_ADDR10", 0600, parent, (u32 *)0xFFE00128);
		debugfs_create_x32("DCPLB_ADDR11", 0600, parent, (u32 *)0xFFE0012C);
		debugfs_create_x32("DCPLB_ADDR12", 0600, parent, (u32 *)0xFFE00130);
		debugfs_create_x32("DCPLB_ADDR13", 0600, parent, (u32 *)0xFFE00134);
		debugfs_create_x32("DCPLB_ADDR14", 0600, parent, (u32 *)0xFFE00138);
		debugfs_create_x32("DCPLB_ADDR15", 0600, parent, (u32 *)0xFFE0013C);
		debugfs_create_x32("DCPLB_ADDR1", 0600, parent, (u32 *)0xFFE00104);
		debugfs_create_x32("DCPLB_ADDR2", 0600, parent, (u32 *)0xFFE00108);
		debugfs_create_x32("DCPLB_ADDR3", 0600, parent, (u32 *)0xFFE0010C);
		debugfs_create_x32("DCPLB_ADDR4", 0600, parent, (u32 *)0xFFE00110);
		debugfs_create_x32("DCPLB_ADDR5", 0600, parent, (u32 *)0xFFE00114);
		debugfs_create_x32("DCPLB_ADDR6", 0600, parent, (u32 *)0xFFE00118);
		debugfs_create_x32("DCPLB_ADDR7", 0600, parent, (u32 *)0xFFE0011C);
		debugfs_create_x32("DCPLB_ADDR8", 0600, parent, (u32 *)0xFFE00120);
		debugfs_create_x32("DCPLB_ADDR9", 0600, parent, (u32 *)0xFFE00124);
		debugfs_create_x32("DCPLB_DATA0", 0600, parent, (u32 *)0xFFE00200);
		debugfs_create_x32("DCPLB_DATA10", 0600, parent, (u32 *)0xFFE00228);
		debugfs_create_x32("DCPLB_DATA11", 0600, parent, (u32 *)0xFFE0022C);
		debugfs_create_x32("DCPLB_DATA12", 0600, parent, (u32 *)0xFFE00230);
		debugfs_create_x32("DCPLB_DATA13", 0600, parent, (u32 *)0xFFE00234);
		debugfs_create_x32("DCPLB_DATA14", 0600, parent, (u32 *)0xFFE00238);
		debugfs_create_x32("DCPLB_DATA15", 0600, parent, (u32 *)0xFFE0023C);
		debugfs_create_x32("DCPLB_DATA1", 0600, parent, (u32 *)0xFFE00204);
		debugfs_create_x32("DCPLB_DATA2", 0600, parent, (u32 *)0xFFE00208);
		debugfs_create_x32("DCPLB_DATA3", 0600, parent, (u32 *)0xFFE0020C);
		debugfs_create_x32("DCPLB_DATA4", 0600, parent, (u32 *)0xFFE00210);
		debugfs_create_x32("DCPLB_DATA5", 0600, parent, (u32 *)0xFFE00214);
		debugfs_create_x32("DCPLB_DATA6", 0600, parent, (u32 *)0xFFE00218);
		debugfs_create_x32("DCPLB_DATA7", 0600, parent, (u32 *)0xFFE0021C);
		debugfs_create_x32("DCPLB_DATA8", 0600, parent, (u32 *)0xFFE00220);
		debugfs_create_x32("DCPLB_DATA9", 0600, parent, (u32 *)0xFFE00224);
		debugfs_create_x32("DCPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0000C);
		debugfs_create_x32("DCPLB_STATUS", 0600, parent, (u32 *)0xFFE00008);
		debugfs_create_x32("DMEM_CONTROL", 0600, parent, (u32 *)0xFFE00004);
		debugfs_create_x32("DTEST_COMMAND", 0600, parent, (u32 *)0xFFE00300);
		debugfs_create_x32("DTEST_DATA0", 0600, parent, (u32 *)0xFFE00400);
		debugfs_create_x32("DTEST_DATA1", 0600, parent, (u32 *)0xFFE00404);
		debugfs_create_x32("SRAM_BASE_ADDR", 0600, parent, (u32 *)0xFFE00000);

		parent = debugfs_create_dir("MDMA", top);
		debugfs_create_x16("MDMA_D0_CONFIG", 0600, parent, (u16 *)0xFFC00F08);
		debugfs_create_x32("MDMA_D0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F24);
		debugfs_create_x32("MDMA_D0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F20);
		debugfs_create_x16("MDMA_D0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F30);
		debugfs_create_x16("MDMA_D0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F38);
		debugfs_create_x16("MDMA_D0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F28);
		debugfs_create_x32("MDMA_D0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F00);
		debugfs_create_x16("MDMA_D0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F2C);
		debugfs_create_x32("MDMA_D0_START_ADDR", 0600, parent, (u32 *)0xFFC00F04);
		debugfs_create_x16("MDMA_D0_X_COUNT", 0600, parent, (u16 *)0xFFC00F10);
		debugfs_create_x16("MDMA_D0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F14);
		debugfs_create_x16("MDMA_D0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F18);
		debugfs_create_x16("MDMA_D0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F1C);
		debugfs_create_x16("MDMA_D1_CONFIG", 0600, parent, (u16 *)0xFFC00F88);
		debugfs_create_x32("MDMA_D1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FA4);
		debugfs_create_x32("MDMA_D1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FA0);
		debugfs_create_x16("MDMA_D1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FB0);
		debugfs_create_x16("MDMA_D1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FB8);
		debugfs_create_x16("MDMA_D1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FA8);
		debugfs_create_x32("MDMA_D1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F80);
		debugfs_create_x16("MDMA_D1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FAC);
		debugfs_create_x32("MDMA_D1_START_ADDR", 0600, parent, (u32 *)0xFFC00F84);
		debugfs_create_x16("MDMA_D1_X_COUNT", 0600, parent, (u16 *)0xFFC00F90);
		debugfs_create_x16("MDMA_D1_X_MODIFY", 0600, parent, (u16 *)0xFFC00F94);
		debugfs_create_x16("MDMA_D1_Y_COUNT", 0600, parent, (u16 *)0xFFC00F98);
		debugfs_create_x16("MDMA_D1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F9C);
		debugfs_create_x16("MDMA_D2_CONFIG", 0600, parent, (u16 *)0xFFC01F08);
		debugfs_create_x32("MDMA_D2_CURR_ADDR", 0600, parent, (u32 *)0xFFC01F24);
		debugfs_create_x32("MDMA_D2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01F20);
		debugfs_create_x16("MDMA_D2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01F30);
		debugfs_create_x16("MDMA_D2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01F38);
		debugfs_create_x16("MDMA_D2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01F28);
		debugfs_create_x32("MDMA_D2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01F00);
		debugfs_create_x16("MDMA_D2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01F2C);
		debugfs_create_x32("MDMA_D2_START_ADDR", 0600, parent, (u32 *)0xFFC01F04);
		debugfs_create_x16("MDMA_D2_X_COUNT", 0600, parent, (u16 *)0xFFC01F10);
		debugfs_create_x16("MDMA_D2_X_MODIFY", 0600, parent, (u16 *)0xFFC01F14);
		debugfs_create_x16("MDMA_D2_Y_COUNT", 0600, parent, (u16 *)0xFFC01F18);
		debugfs_create_x16("MDMA_D2_Y_MODIFY", 0600, parent, (u16 *)0xFFC01F1C);
		debugfs_create_x16("MDMA_D3_CONFIG", 0600, parent, (u16 *)0xFFC01F88);
		debugfs_create_x32("MDMA_D3_CURR_ADDR", 0600, parent, (u32 *)0xFFC01FA4);
		debugfs_create_x32("MDMA_D3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01FA0);
		debugfs_create_x16("MDMA_D3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01FB0);
		debugfs_create_x16("MDMA_D3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01FB8);
		debugfs_create_x16("MDMA_D3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01FA8);
		debugfs_create_x32("MDMA_D3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01F80);
		debugfs_create_x16("MDMA_D3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01FAC);
		debugfs_create_x32("MDMA_D3_START_ADDR", 0600, parent, (u32 *)0xFFC01F84);
		debugfs_create_x16("MDMA_D3_X_COUNT", 0600, parent, (u16 *)0xFFC01F90);
		debugfs_create_x16("MDMA_D3_X_MODIFY", 0600, parent, (u16 *)0xFFC01F94);
		debugfs_create_x16("MDMA_D3_Y_COUNT", 0600, parent, (u16 *)0xFFC01F98);
		debugfs_create_x16("MDMA_D3_Y_MODIFY", 0600, parent, (u16 *)0xFFC01F9C);
		debugfs_create_x16("MDMA_S0_CONFIG", 0600, parent, (u16 *)0xFFC00F48);
		debugfs_create_x32("MDMA_S0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F64);
		debugfs_create_x32("MDMA_S0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F60);
		debugfs_create_x16("MDMA_S0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F70);
		debugfs_create_x16("MDMA_S0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F78);
		debugfs_create_x16("MDMA_S0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F68);
		debugfs_create_x32("MDMA_S0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F40);
		debugfs_create_x16("MDMA_S0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F6C);
		debugfs_create_x32("MDMA_S0_START_ADDR", 0600, parent, (u32 *)0xFFC00F44);
		debugfs_create_x16("MDMA_S0_X_COUNT", 0600, parent, (u16 *)0xFFC00F50);
		debugfs_create_x16("MDMA_S0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F54);
		debugfs_create_x16("MDMA_S0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F58);
		debugfs_create_x16("MDMA_S0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F5C);
		debugfs_create_x16("MDMA_S1_CONFIG", 0600, parent, (u16 *)0xFFC00FC8);
		debugfs_create_x32("MDMA_S1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FE4);
		debugfs_create_x32("MDMA_S1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FE0);
		debugfs_create_x16("MDMA_S1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FF0);
		debugfs_create_x16("MDMA_S1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FF8);
		debugfs_create_x16("MDMA_S1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FE8);
		debugfs_create_x32("MDMA_S1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00FC0);
		debugfs_create_x16("MDMA_S1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FEC);
		debugfs_create_x32("MDMA_S1_START_ADDR", 0600, parent, (u32 *)0xFFC00FC4);
		debugfs_create_x16("MDMA_S1_X_COUNT", 0600, parent, (u16 *)0xFFC00FD0);
		debugfs_create_x16("MDMA_S1_X_MODIFY", 0600, parent, (u16 *)0xFFC00FD4);
		debugfs_create_x16("MDMA_S1_Y_COUNT", 0600, parent, (u16 *)0xFFC00FD8);
		debugfs_create_x16("MDMA_S1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00FDC);
		debugfs_create_x16("MDMA_S2_CONFIG", 0600, parent, (u16 *)0xFFC01F48);
		debugfs_create_x32("MDMA_S2_CURR_ADDR", 0600, parent, (u32 *)0xFFC01F64);
		debugfs_create_x32("MDMA_S2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01F60);
		debugfs_create_x16("MDMA_S2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01F70);
		debugfs_create_x16("MDMA_S2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01F78);
		debugfs_create_x16("MDMA_S2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01F68);
		debugfs_create_x32("MDMA_S2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01F40);
		debugfs_create_x16("MDMA_S2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01F6C);
		debugfs_create_x32("MDMA_S2_START_ADDR", 0600, parent, (u32 *)0xFFC01F44);
		debugfs_create_x16("MDMA_S2_X_COUNT", 0600, parent, (u16 *)0xFFC01F50);
		debugfs_create_x16("MDMA_S2_X_MODIFY", 0600, parent, (u16 *)0xFFC01F54);
		debugfs_create_x16("MDMA_S2_Y_COUNT", 0600, parent, (u16 *)0xFFC01F58);
		debugfs_create_x16("MDMA_S2_Y_MODIFY", 0600, parent, (u16 *)0xFFC01F5C);
		debugfs_create_x16("MDMA_S3_CONFIG", 0600, parent, (u16 *)0xFFC01FC8);
		debugfs_create_x32("MDMA_S3_CURR_ADDR", 0600, parent, (u32 *)0xFFC01FE4);
		debugfs_create_x32("MDMA_S3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01FE0);
		debugfs_create_x16("MDMA_S3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01FF0);
		debugfs_create_x16("MDMA_S3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01FF8);
		debugfs_create_x16("MDMA_S3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01FE8);
		debugfs_create_x32("MDMA_S3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01FC0);
		debugfs_create_x16("MDMA_S3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01FEC);
		debugfs_create_x32("MDMA_S3_START_ADDR", 0600, parent, (u32 *)0xFFC01FC4);
		debugfs_create_x16("MDMA_S3_X_COUNT", 0600, parent, (u16 *)0xFFC01FD0);
		debugfs_create_x16("MDMA_S3_X_MODIFY", 0600, parent, (u16 *)0xFFC01FD4);
		debugfs_create_x16("MDMA_S3_Y_COUNT", 0600, parent, (u16 *)0xFFC01FD8);
		debugfs_create_x16("MDMA_S3_Y_MODIFY", 0600, parent, (u16 *)0xFFC01FDC);

		parent = debugfs_create_dir("NFC", top);
		debugfs_create_x16("NFC_ADDR", 0600, parent, (u16 *)0xFFC03B40);
		debugfs_create_x16("NFC_CMD", 0600, parent, (u16 *)0xFFC03B44);
		debugfs_create_x16("NFC_COUNT", 0600, parent, (u16 *)0xFFC03B20);
		debugfs_create_x16("NFC_CTL", 0600, parent, (u16 *)0xFFC03B00);
		debugfs_create_x16("NFC_DATA_RD", 0600, parent, (u16 *)0xFFC03B4C);
		debugfs_create_x16("NFC_DATA_WR", 0600, parent, (u16 *)0xFFC03B48);
		debugfs_create_x16("NFC_ECC0", 0600, parent, (u16 *)0xFFC03B10);
		debugfs_create_x16("NFC_ECC1", 0600, parent, (u16 *)0xFFC03B14);
		debugfs_create_x16("NFC_ECC2", 0600, parent, (u16 *)0xFFC03B18);
		debugfs_create_x16("NFC_ECC3", 0600, parent, (u16 *)0xFFC03B1C);
		debugfs_create_x16("NFC_IRQMASK", 0600, parent, (u16 *)0xFFC03B0C);
		debugfs_create_x16("NFC_IRQSTAT", 0600, parent, (u16 *)0xFFC03B08);
		debugfs_create_x16("NFC_PGCTL", 0600, parent, (u16 *)0xFFC03B28);
		debugfs_create_x16("NFC_READ", 0600, parent, (u16 *)0xFFC03B2C);
		debugfs_create_x16("NFC_RST", 0600, parent, (u16 *)0xFFC03B24);
		debugfs_create_x16("NFC_STAT", 0600, parent, (u16 *)0xFFC03B04);

		parent = debugfs_create_dir("OTP", top);
		debugfs_create_x16("OTP_BEN", 0600, parent, (u16 *)0xFFC04304);
		debugfs_create_x16("OTP_CONTROL", 0600, parent, (u16 *)0xFFC04300);
		debugfs_create_x32("OTP_DATA0", 0600, parent, (u32 *)0xFFC04380);
		debugfs_create_x32("OTP_DATA1", 0600, parent, (u32 *)0xFFC04384);
		debugfs_create_x32("OTP_DATA2", 0600, parent, (u32 *)0xFFC04388);
		debugfs_create_x32("OTP_DATA3", 0600, parent, (u32 *)0xFFC0438C);
		debugfs_create_x16("OTP_STATUS", 0600, parent, (u16 *)0xFFC04308);
		debugfs_create_x32("OTP_TIMING", 0600, parent, (u32 *)0xFFC0430C);

		parent = debugfs_create_dir("PINT_0", top);
		debugfs_create_x32("PINT0_ASSIGN", 0600, parent, (u32 *)0xFFC0140C);
		debugfs_create_x32("PINT0_EDGE_CLEAR", 0600, parent, (u32 *)0xFFC01414);
		debugfs_create_x32("PINT0_EDGE_SET", 0600, parent, (u32 *)0xFFC01410);
		debugfs_create_x32("PINT0_INVERT_CLEAR", 0600, parent, (u32 *)0xFFC0141C);
		debugfs_create_x32("PINT0_INVERT_SET", 0600, parent, (u32 *)0xFFC01418);
		debugfs_create_x32("PINT0_IRQ", 0600, parent, (u32 *)0xFFC01408);
		debugfs_create_x32("PINT0_LATCH", 0600, parent, (u32 *)0xFFC01424);
		debugfs_create_x32("PINT0_MASK_CLEAR", 0600, parent, (u32 *)0xFFC01404);
		debugfs_create_x32("PINT0_MASK_SET", 0600, parent, (u32 *)0xFFC01400);
		debugfs_create_x32("PINT0_PINSTATE", 0600, parent, (u32 *)0xFFC01420);

		parent = debugfs_create_dir("PINT_1", top);
		debugfs_create_x32("PINT1_ASSIGN", 0600, parent, (u32 *)0xFFC0143C);
		debugfs_create_x32("PINT1_EDGE_CLEAR", 0600, parent, (u32 *)0xFFC01444);
		debugfs_create_x32("PINT1_EDGE_SET", 0600, parent, (u32 *)0xFFC01440);
		debugfs_create_x32("PINT1_INVERT_CLEAR", 0600, parent, (u32 *)0xFFC0144C);
		debugfs_create_x32("PINT1_INVERT_SET", 0600, parent, (u32 *)0xFFC01448);
		debugfs_create_x32("PINT1_IRQ", 0600, parent, (u32 *)0xFFC01438);
		debugfs_create_x32("PINT1_LATCH", 0600, parent, (u32 *)0xFFC01454);
		debugfs_create_x32("PINT1_MASK_CLEAR", 0600, parent, (u32 *)0xFFC01434);
		debugfs_create_x32("PINT1_MASK_SET", 0600, parent, (u32 *)0xFFC01430);
		debugfs_create_x32("PINT1_PINSTATE", 0600, parent, (u32 *)0xFFC01450);

		parent = debugfs_create_dir("PINT_2", top);
		debugfs_create_x32("PINT2_ASSIGN", 0600, parent, (u32 *)0xFFC0146C);
		debugfs_create_x32("PINT2_EDGE_CLEAR", 0600, parent, (u32 *)0xFFC01474);
		debugfs_create_x32("PINT2_EDGE_SET", 0600, parent, (u32 *)0xFFC01470);
		debugfs_create_x32("PINT2_INVERT_CLEAR", 0600, parent, (u32 *)0xFFC0147C);
		debugfs_create_x32("PINT2_INVERT_SET", 0600, parent, (u32 *)0xFFC01478);
		debugfs_create_x32("PINT2_IRQ", 0600, parent, (u32 *)0xFFC01468);
		debugfs_create_x32("PINT2_LATCH", 0600, parent, (u32 *)0xFFC01484);
		debugfs_create_x32("PINT2_MASK_CLEAR", 0600, parent, (u32 *)0xFFC01464);
		debugfs_create_x32("PINT2_MASK_SET", 0600, parent, (u32 *)0xFFC01460);
		debugfs_create_x32("PINT2_PINSTATE", 0600, parent, (u32 *)0xFFC01480);

		parent = debugfs_create_dir("PINT_3", top);
		debugfs_create_x32("PINT3_ASSIGN", 0600, parent, (u32 *)0xFFC0149C);
		debugfs_create_x32("PINT3_EDGE_CLEAR", 0600, parent, (u32 *)0xFFC014A4);
		debugfs_create_x32("PINT3_EDGE_SET", 0600, parent, (u32 *)0xFFC014A0);
		debugfs_create_x32("PINT3_INVERT_CLEAR", 0600, parent, (u32 *)0xFFC014AC);
		debugfs_create_x32("PINT3_INVERT_SET", 0600, parent, (u32 *)0xFFC014A8);
		debugfs_create_x32("PINT3_IRQ", 0600, parent, (u32 *)0xFFC01498);
		debugfs_create_x32("PINT3_LATCH", 0600, parent, (u32 *)0xFFC014B4);
		debugfs_create_x32("PINT3_MASK_CLEAR", 0600, parent, (u32 *)0xFFC01494);
		debugfs_create_x32("PINT3_MASK_SET", 0600, parent, (u32 *)0xFFC01490);
		debugfs_create_x32("PINT3_PINSTATE", 0600, parent, (u32 *)0xFFC014B0);

		parent = debugfs_create_dir("PIXC", top);
		debugfs_create_x16("PIXC_AHEND", 0600, parent, (u16 *)0xFFC04410);
		debugfs_create_x16("PIXC_AHSTART", 0600, parent, (u16 *)0xFFC0440C);
		debugfs_create_x16("PIXC_ATRANSP", 0600, parent, (u16 *)0xFFC0441C);
		debugfs_create_x16("PIXC_AVEND", 0600, parent, (u16 *)0xFFC04418);
		debugfs_create_x16("PIXC_AVSTART", 0600, parent, (u16 *)0xFFC04414);
		debugfs_create_x16("PIXC_BHEND", 0600, parent, (u16 *)0xFFC04424);
		debugfs_create_x16("PIXC_BHSTART", 0600, parent, (u16 *)0xFFC04420);
		debugfs_create_x16("PIXC_BTRANSP", 0600, parent, (u16 *)0xFFC04430);
		debugfs_create_x32("PIXC_BVCON", 0600, parent, (u32 *)0xFFC04448);
		debugfs_create_x16("PIXC_BVEND", 0600, parent, (u16 *)0xFFC0442C);
		debugfs_create_x16("PIXC_BVSTART", 0600, parent, (u16 *)0xFFC04428);
		debugfs_create_x32("PIXC_CCBIAS", 0600, parent, (u32 *)0xFFC0444C);
		debugfs_create_x16("PIXC_CTL", 0600, parent, (u16 *)0xFFC04400);
		debugfs_create_x32("PIXC_GUCON", 0600, parent, (u32 *)0xFFC04444);
		debugfs_create_x16("PIXC_INTRSTAT", 0600, parent, (u16 *)0xFFC0443C);
		debugfs_create_x16("PIXC_LPF", 0600, parent, (u16 *)0xFFC04408);
		debugfs_create_x16("PIXC_PPL", 0600, parent, (u16 *)0xFFC04404);
		debugfs_create_x32("PIXC_RYCON", 0600, parent, (u32 *)0xFFC04440);
		debugfs_create_x32("PIXC_TC", 0600, parent, (u32 *)0xFFC04450);

		parent = debugfs_create_dir("PLL", top);
		debugfs_create_x16("PLL_CTL", 0600, parent, (u16 *)0xFFC00000);
		debugfs_create_x16("PLL_DIV", 0600, parent, (u16 *)0xFFC00004);
		debugfs_create_x16("PLL_LOCKCNT", 0600, parent, (u16 *)0xFFC00010);
		debugfs_create_x16("PLL_STAT", 0600, parent, (u16 *)0xFFC0000C);
		debugfs_create_x16("VR_CTL", 0600, parent, (u16 *)0xFFC00008);

		parent = debugfs_create_dir("PWM_TMR", top);
		debugfs_create_x16("TIMER0_CONFIG", 0600, parent, (u16 *)0xFFC01600);
		debugfs_create_x32("TIMER0_COUNTER", 0600, parent, (u32 *)0xFFC01604);
		debugfs_create_x32("TIMER0_PERIOD", 0600, parent, (u32 *)0xFFC01608);
		debugfs_create_x32("TIMER0_WIDTH", 0600, parent, (u32 *)0xFFC0160C);
		debugfs_create_x16("TIMER10_CONFIG", 0600, parent, (u16 *)0xFFC00620);
		debugfs_create_x32("TIMER10_COUNTER", 0600, parent, (u32 *)0xFFC00624);
		debugfs_create_x32("TIMER10_PERIOD", 0600, parent, (u32 *)0xFFC00628);
		debugfs_create_x32("TIMER10_WIDTH", 0600, parent, (u32 *)0xFFC0062C);
		debugfs_create_x16("TIMER1_CONFIG", 0600, parent, (u16 *)0xFFC01610);
		debugfs_create_x32("TIMER1_COUNTER", 0600, parent, (u32 *)0xFFC01614);
		debugfs_create_x32("TIMER1_PERIOD", 0600, parent, (u32 *)0xFFC01618);
		debugfs_create_x32("TIMER1_WIDTH", 0600, parent, (u32 *)0xFFC0161C);
		debugfs_create_x16("TIMER2_CONFIG", 0600, parent, (u16 *)0xFFC01620);
		debugfs_create_x32("TIMER2_COUNTER", 0600, parent, (u32 *)0xFFC01624);
		debugfs_create_x32("TIMER2_PERIOD", 0600, parent, (u32 *)0xFFC01628);
		debugfs_create_x32("TIMER2_WIDTH", 0600, parent, (u32 *)0xFFC0162C);
		debugfs_create_x16("TIMER3_CONFIG", 0600, parent, (u16 *)0xFFC01630);
		debugfs_create_x32("TIMER3_COUNTER", 0600, parent, (u32 *)0xFFC01634);
		debugfs_create_x32("TIMER3_PERIOD", 0600, parent, (u32 *)0xFFC01638);
		debugfs_create_x32("TIMER3_WIDTH", 0600, parent, (u32 *)0xFFC0163C);
		debugfs_create_x16("TIMER4_CONFIG", 0600, parent, (u16 *)0xFFC01640);
		debugfs_create_x32("TIMER4_COUNTER", 0600, parent, (u32 *)0xFFC01644);
		debugfs_create_x32("TIMER4_PERIOD", 0600, parent, (u32 *)0xFFC01648);
		debugfs_create_x32("TIMER4_WIDTH", 0600, parent, (u32 *)0xFFC0164C);
		debugfs_create_x16("TIMER5_CONFIG", 0600, parent, (u16 *)0xFFC01650);
		debugfs_create_x32("TIMER5_COUNTER", 0600, parent, (u32 *)0xFFC01654);
		debugfs_create_x32("TIMER5_PERIOD", 0600, parent, (u32 *)0xFFC01658);
		debugfs_create_x32("TIMER5_WIDTH", 0600, parent, (u32 *)0xFFC0165C);
		debugfs_create_x16("TIMER6_CONFIG", 0600, parent, (u16 *)0xFFC01660);
		debugfs_create_x32("TIMER6_COUNTER", 0600, parent, (u32 *)0xFFC01664);
		debugfs_create_x32("TIMER6_PERIOD", 0600, parent, (u32 *)0xFFC01668);
		debugfs_create_x32("TIMER6_WIDTH", 0600, parent, (u32 *)0xFFC0166C);
		debugfs_create_x16("TIMER7_CONFIG", 0600, parent, (u16 *)0xFFC01670);
		debugfs_create_x32("TIMER7_COUNTER", 0600, parent, (u32 *)0xFFC01674);
		debugfs_create_x32("TIMER7_PERIOD", 0600, parent, (u32 *)0xFFC01678);
		debugfs_create_x32("TIMER7_WIDTH", 0600, parent, (u32 *)0xFFC0167C);
		debugfs_create_x16("TIMER8_CONFIG", 0600, parent, (u16 *)0xFFC00600);
		debugfs_create_x32("TIMER8_COUNTER", 0600, parent, (u32 *)0xFFC00604);
		debugfs_create_x32("TIMER8_PERIOD", 0600, parent, (u32 *)0xFFC00608);
		debugfs_create_x32("TIMER8_WIDTH", 0600, parent, (u32 *)0xFFC0060C);
		debugfs_create_x16("TIMER9_CONFIG", 0600, parent, (u16 *)0xFFC00610);
		debugfs_create_x32("TIMER9_COUNTER", 0600, parent, (u32 *)0xFFC00614);
		debugfs_create_x32("TIMER9_PERIOD", 0600, parent, (u32 *)0xFFC00618);
		debugfs_create_x32("TIMER9_WIDTH", 0600, parent, (u32 *)0xFFC0061C);
		debugfs_create_x16("TIMER_DISABLE0", 0600, parent, (u16 *)0xFFC01684);
		debugfs_create_x16("TIMER_DISABLE1", 0600, parent, (u16 *)0xFFC00644);
		debugfs_create_x16("TIMER_ENABLE0", 0600, parent, (u16 *)0xFFC01680);
		debugfs_create_x16("TIMER_ENABLE1", 0600, parent, (u16 *)0xFFC00640);
		debugfs_create_x32("TIMER_STATUS0", 0600, parent, (u32 *)0xFFC01688);
		debugfs_create_x32("TIMER_STATUS1", 0600, parent, (u32 *)0xFFC00648);

		parent = debugfs_create_dir("Port_A", top);
		debugfs_create_x16("PORTA", 0600, parent, (u16 *)0xFFC014C4);
		debugfs_create_x16("PORTA_CLEAR", 0600, parent, (u16 *)0xFFC014CC);
		debugfs_create_x16("PORTA_DIR_CLEAR", 0600, parent, (u16 *)0xFFC014D4);
		debugfs_create_x16("PORTA_DIR_SET", 0600, parent, (u16 *)0xFFC014D0);
		debugfs_create_x16("PORTA_FER", 0600, parent, (u16 *)0xFFC014C0);
		debugfs_create_x16("PORTA_INEN", 0600, parent, (u16 *)0xFFC014D8);
		debugfs_create_x32("PORTA_MUX", 0600, parent, (u32 *)0xFFC014DC);
		debugfs_create_x16("PORTA_SET", 0600, parent, (u16 *)0xFFC014C8);

		parent = debugfs_create_dir("Port_B", top);
		debugfs_create_x16("PORTB", 0600, parent, (u16 *)0xFFC014E4);
		debugfs_create_x16("PORTB_CLEAR", 0600, parent, (u16 *)0xFFC014EC);
		debugfs_create_x16("PORTB_DIR_CLEAR", 0600, parent, (u16 *)0xFFC014F4);
		debugfs_create_x16("PORTB_DIR_SET", 0600, parent, (u16 *)0xFFC014F0);
		debugfs_create_x16("PORTB_FER", 0600, parent, (u16 *)0xFFC014E0);
		debugfs_create_x16("PORTB_INEN", 0600, parent, (u16 *)0xFFC014F8);
		debugfs_create_x32("PORTB_MUX", 0600, parent, (u32 *)0xFFC014FC);
		debugfs_create_x16("PORTB_SET", 0600, parent, (u16 *)0xFFC014E8);

		parent = debugfs_create_dir("Port_C", top);
		debugfs_create_x16("PORTC", 0600, parent, (u16 *)0xFFC01504);
		debugfs_create_x16("PORTC_CLEAR", 0600, parent, (u16 *)0xFFC0150C);
		debugfs_create_x16("PORTC_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01514);
		debugfs_create_x16("PORTC_DIR_SET", 0600, parent, (u16 *)0xFFC01510);
		debugfs_create_x16("PORTC_FER", 0600, parent, (u16 *)0xFFC01500);
		debugfs_create_x16("PORTC_INEN", 0600, parent, (u16 *)0xFFC01518);
		debugfs_create_x32("PORTC_MUX", 0600, parent, (u32 *)0xFFC0151C);
		debugfs_create_x16("PORTC_SET", 0600, parent, (u16 *)0xFFC01508);

		parent = debugfs_create_dir("Port_D", top);
		debugfs_create_x16("PORTD", 0600, parent, (u16 *)0xFFC01524);
		debugfs_create_x16("PORTD_CLEAR", 0600, parent, (u16 *)0xFFC0152C);
		debugfs_create_x16("PORTD_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01534);
		debugfs_create_x16("PORTD_DIR_SET", 0600, parent, (u16 *)0xFFC01530);
		debugfs_create_x16("PORTD_FER", 0600, parent, (u16 *)0xFFC01520);
		debugfs_create_x16("PORTD_INEN", 0600, parent, (u16 *)0xFFC01538);
		debugfs_create_x32("PORTD_MUX", 0600, parent, (u32 *)0xFFC0153C);
		debugfs_create_x16("PORTD_SET", 0600, parent, (u16 *)0xFFC01528);

		parent = debugfs_create_dir("Port_E", top);
		debugfs_create_x16("PORTE", 0600, parent, (u16 *)0xFFC01544);
		debugfs_create_x16("PORTE_CLEAR", 0600, parent, (u16 *)0xFFC0154C);
		debugfs_create_x16("PORTE_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01554);
		debugfs_create_x16("PORTE_DIR_SET", 0600, parent, (u16 *)0xFFC01550);
		debugfs_create_x16("PORTE_FER", 0600, parent, (u16 *)0xFFC01540);
		debugfs_create_x16("PORTE_INEN", 0600, parent, (u16 *)0xFFC01558);
		debugfs_create_x32("PORTE_MUX", 0600, parent, (u32 *)0xFFC0155C);
		debugfs_create_x16("PORTE_SET", 0600, parent, (u16 *)0xFFC01548);

		parent = debugfs_create_dir("Port_F", top);
		debugfs_create_x16("PORTF", 0600, parent, (u16 *)0xFFC01564);
		debugfs_create_x16("PORTF_CLEAR", 0600, parent, (u16 *)0xFFC0156C);
		debugfs_create_x16("PORTF_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01574);
		debugfs_create_x16("PORTF_DIR_SET", 0600, parent, (u16 *)0xFFC01570);
		debugfs_create_x16("PORTF_FER", 0600, parent, (u16 *)0xFFC01560);
		debugfs_create_x16("PORTF_INEN", 0600, parent, (u16 *)0xFFC01578);
		debugfs_create_x32("PORTF_MUX", 0600, parent, (u32 *)0xFFC0157C);
		debugfs_create_x16("PORTF_SET", 0600, parent, (u16 *)0xFFC01568);

		parent = debugfs_create_dir("Port_G", top);
		debugfs_create_x16("PORTG", 0600, parent, (u16 *)0xFFC01584);
		debugfs_create_x16("PORTG_CLEAR", 0600, parent, (u16 *)0xFFC0158C);
		debugfs_create_x16("PORTG_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01594);
		debugfs_create_x16("PORTG_DIR_SET", 0600, parent, (u16 *)0xFFC01590);
		debugfs_create_x16("PORTG_FER", 0600, parent, (u16 *)0xFFC01580);
		debugfs_create_x16("PORTG_INEN", 0600, parent, (u16 *)0xFFC01598);
		debugfs_create_x32("PORTG_MUX", 0600, parent, (u32 *)0xFFC0159C);
		debugfs_create_x16("PORTG_SET", 0600, parent, (u16 *)0xFFC01588);

		parent = debugfs_create_dir("Port_H", top);
		debugfs_create_x16("PORTH", 0600, parent, (u16 *)0xFFC015A4);
		debugfs_create_x16("PORTH_CLEAR", 0600, parent, (u16 *)0xFFC015AC);
		debugfs_create_x16("PORTH_DIR_CLEAR", 0600, parent, (u16 *)0xFFC015B4);
		debugfs_create_x16("PORTH_DIR_SET", 0600, parent, (u16 *)0xFFC015B0);
		debugfs_create_x16("PORTH_FER", 0600, parent, (u16 *)0xFFC015A0);
		debugfs_create_x16("PORTH_INEN", 0600, parent, (u16 *)0xFFC015B8);
		debugfs_create_x32("PORTH_MUX", 0600, parent, (u32 *)0xFFC015BC);
		debugfs_create_x16("PORTH_SET", 0600, parent, (u16 *)0xFFC015A8);

		parent = debugfs_create_dir("Port_I", top);
		debugfs_create_x16("PORTI", 0600, parent, (u16 *)0xFFC015C4);
		debugfs_create_x16("PORTI_CLEAR", 0600, parent, (u16 *)0xFFC015CC);
		debugfs_create_x16("PORTI_DIR_CLEAR", 0600, parent, (u16 *)0xFFC015D4);
		debugfs_create_x16("PORTI_DIR_SET", 0600, parent, (u16 *)0xFFC015D0);
		debugfs_create_x16("PORTI_FER", 0600, parent, (u16 *)0xFFC015C0);
		debugfs_create_x16("PORTI_INEN", 0600, parent, (u16 *)0xFFC015D8);
		debugfs_create_x32("PORTI_MUX", 0600, parent, (u32 *)0xFFC015DC);
		debugfs_create_x16("PORTI_SET", 0600, parent, (u16 *)0xFFC015C8);

		parent = debugfs_create_dir("Port_J", top);
		debugfs_create_x16("PORTJ", 0600, parent, (u16 *)0xFFC015E4);
		debugfs_create_x16("PORTJ_CLEAR", 0600, parent, (u16 *)0xFFC015EC);
		debugfs_create_x16("PORTJ_DIR_CLEAR", 0600, parent, (u16 *)0xFFC015F4);
		debugfs_create_x16("PORTJ_DIR_SET", 0600, parent, (u16 *)0xFFC015F0);
		debugfs_create_x16("PORTJ_FER", 0600, parent, (u16 *)0xFFC015E0);
		debugfs_create_x16("PORTJ_INEN", 0600, parent, (u16 *)0xFFC015F8);
		debugfs_create_x32("PORTJ_MUX", 0600, parent, (u32 *)0xFFC015FC);
		debugfs_create_x16("PORTJ_SET", 0600, parent, (u16 *)0xFFC015E8);

		parent = debugfs_create_dir("RTC", top);
		debugfs_create_x32("RTC_ALARM", 0600, parent, (u32 *)0xFFC00310);
		debugfs_create_x16("RTC_ICTL", 0600, parent, (u16 *)0xFFC00304);
		debugfs_create_x16("RTC_ISTAT", 0600, parent, (u16 *)0xFFC00308);
		debugfs_create_x16("RTC_PREN", 0600, parent, (u16 *)0xFFC00314);
		debugfs_create_x32("RTC_STAT", 0600, parent, (u32 *)0xFFC00300);
		debugfs_create_x16("RTC_SWCNT", 0600, parent, (u16 *)0xFFC0030C);

		parent = debugfs_create_dir("SDH", top);
		debugfs_create_x32("SDH_ARGUMENT", 0600, parent, (u32 *)0xFFC03908);
		debugfs_create_x16("SDH_CFG", 0600, parent, (u16 *)0xFFC039C8);
		debugfs_create_x16("SDH_CLK_CTL", 0600, parent, (u16 *)0xFFC03904);
		debugfs_create_x16("SDH_COMMAND", 0600, parent, (u16 *)0xFFC0390C);
		debugfs_create_x16("SDH_DATA_CNT", 0600, parent, (u16 *)0xFFC03930);
		debugfs_create_x16("SDH_DATA_CTL", 0600, parent, (u16 *)0xFFC0392C);
		debugfs_create_x16("SDH_DATA_LGTH", 0600, parent, (u16 *)0xFFC03928);
		debugfs_create_x32("SDH_DATA_TIMER", 0600, parent, (u32 *)0xFFC03924);
		debugfs_create_x16("SDH_E_MASK", 0600, parent, (u16 *)0xFFC039C4);
		debugfs_create_x16("SDH_E_STATUS", 0600, parent, (u16 *)0xFFC039C0);
		debugfs_create_x32("SDH_FIFO", 0600, parent, (u32 *)0xFFC03980);
		debugfs_create_x16("SDH_FIFO_CNT", 0600, parent, (u16 *)0xFFC03948);
		debugfs_create_x32("SDH_MASK0", 0600, parent, (u32 *)0xFFC0393C);
		debugfs_create_x32("SDH_MASK1", 0600, parent, (u32 *)0xFFC03940);
		debugfs_create_x16("SDH_PID0", 0600, parent, (u16 *)0xFFC039D0);
		debugfs_create_x16("SDH_PID1", 0600, parent, (u16 *)0xFFC039D4);
		debugfs_create_x16("SDH_PID2", 0600, parent, (u16 *)0xFFC039D8);
		debugfs_create_x16("SDH_PID3", 0600, parent, (u16 *)0xFFC039DC);
		debugfs_create_x16("SDH_PID4", 0600, parent, (u16 *)0xFFC039E0);
		debugfs_create_x16("SDH_PID5", 0600, parent, (u16 *)0xFFC039E4);
		debugfs_create_x16("SDH_PID6", 0600, parent, (u16 *)0xFFC039E8);
		debugfs_create_x16("SDH_PID7", 0600, parent, (u16 *)0xFFC039EC);
		debugfs_create_x16("SDH_PWR_CTL", 0600, parent, (u16 *)0xFFC03900);
		debugfs_create_x16("SDH_RD_WAIT_EN", 0600, parent, (u16 *)0xFFC039CC);
		debugfs_create_x32("SDH_RESPONSE0", 0600, parent, (u32 *)0xFFC03914);
		debugfs_create_x32("SDH_RESPONSE1", 0600, parent, (u32 *)0xFFC03918);
		debugfs_create_x32("SDH_RESPONSE2", 0600, parent, (u32 *)0xFFC0391C);
		debugfs_create_x32("SDH_RESPONSE3", 0600, parent, (u32 *)0xFFC03920);
		debugfs_create_x16("SDH_RESP_CMD", 0600, parent, (u16 *)0xFFC03910);
		debugfs_create_x32("SDH_STATUS", 0600, parent, (u32 *)0xFFC03934);
		debugfs_create_x16("SDH_STATUS_CLR", 0600, parent, (u16 *)0xFFC03938);

		parent = debugfs_create_dir("SIC", top);
		debugfs_create_x32("SIC_IAR0", 0600, parent, (u32 *)0xFFC00130);
		debugfs_create_x32("SIC_IAR10", 0600, parent, (u32 *)0xFFC00158);
		debugfs_create_x32("SIC_IAR11", 0600, parent, (u32 *)0xFFC0015C);
		debugfs_create_x32("SIC_IAR1", 0600, parent, (u32 *)0xFFC00134);
		debugfs_create_x32("SIC_IAR2", 0600, parent, (u32 *)0xFFC00138);
		debugfs_create_x32("SIC_IAR3", 0600, parent, (u32 *)0xFFC0013C);
		debugfs_create_x32("SIC_IAR4", 0600, parent, (u32 *)0xFFC00140);
		debugfs_create_x32("SIC_IAR5", 0600, parent, (u32 *)0xFFC00144);
		debugfs_create_x32("SIC_IAR6", 0600, parent, (u32 *)0xFFC00148);
		debugfs_create_x32("SIC_IAR7", 0600, parent, (u32 *)0xFFC0014C);
		debugfs_create_x32("SIC_IAR8", 0600, parent, (u32 *)0xFFC00150);
		debugfs_create_x32("SIC_IAR9", 0600, parent, (u32 *)0xFFC00154);
		debugfs_create_x32("SIC_IMASK0", 0600, parent, (u32 *)0xFFC0010C);
		debugfs_create_x32("SIC_IMASK1", 0600, parent, (u32 *)0xFFC00110);
		debugfs_create_x32("SIC_IMASK2", 0600, parent, (u32 *)0xFFC00114);
		debugfs_create_x32("SIC_ISR0", 0600, parent, (u32 *)0xFFC00118);
		debugfs_create_x32("SIC_ISR1", 0600, parent, (u32 *)0xFFC0011C);
		debugfs_create_x32("SIC_ISR2", 0600, parent, (u32 *)0xFFC00120);
		debugfs_create_x32("SIC_IWR0", 0600, parent, (u32 *)0xFFC00124);
		debugfs_create_x32("SIC_IWR1", 0600, parent, (u32 *)0xFFC00128);
		debugfs_create_x32("SIC_IWR2", 0600, parent, (u32 *)0xFFC0012C);

		parent = debugfs_create_dir("SPI", top);
		debugfs_create_x16("SPI0_BAUD", 0600, parent, (u16 *)0xFFC00514);
		debugfs_create_x16("SPI0_CTL", 0600, parent, (u16 *)0xFFC00500);
		debugfs_create_x16("SPI0_FLG", 0600, parent, (u16 *)0xFFC00504);
		debugfs_create_x16("SPI0_RDBR", 0600, parent, (u16 *)0xFFC00510);
		debugfs_create_x16("SPI0_SHADOW", 0600, parent, (u16 *)0xFFC00518);
		debugfs_create_x16("SPI0_STAT", 0600, parent, (u16 *)0xFFC00508);
		debugfs_create_x16("SPI0_TDBR", 0600, parent, (u16 *)0xFFC0050C);
		debugfs_create_x16("SPI1_BAUD", 0600, parent, (u16 *)0xFFC02314);
		debugfs_create_x16("SPI1_CTL", 0600, parent, (u16 *)0xFFC02300);
		debugfs_create_x16("SPI1_FLG", 0600, parent, (u16 *)0xFFC02304);
		debugfs_create_x16("SPI1_RDBR", 0600, parent, (u16 *)0xFFC02310);
		debugfs_create_x16("SPI1_SHADOW", 0600, parent, (u16 *)0xFFC02318);
		debugfs_create_x16("SPI1_STAT", 0600, parent, (u16 *)0xFFC02308);
		debugfs_create_x16("SPI1_TDBR", 0600, parent, (u16 *)0xFFC0230C);
		debugfs_create_x16("SPI2_BAUD", 0600, parent, (u16 *)0xFFC02414);
		debugfs_create_x16("SPI2_CTL", 0600, parent, (u16 *)0xFFC02400);
		debugfs_create_x16("SPI2_FLG", 0600, parent, (u16 *)0xFFC02404);
		debugfs_create_x16("SPI2_RDBR", 0600, parent, (u16 *)0xFFC02410);
		debugfs_create_x16("SPI2_SHADOW", 0600, parent, (u16 *)0xFFC02418);
		debugfs_create_x16("SPI2_STAT", 0600, parent, (u16 *)0xFFC02408);
		debugfs_create_x16("SPI2_TDBR", 0600, parent, (u16 *)0xFFC0240C);

		parent = debugfs_create_dir("SPORT", top);
		debugfs_create_x16("SPORT0_CHNL", 0600, parent, (u16 *)0xFFC00834);
		debugfs_create_x16("SPORT0_MCMC1", 0600, parent, (u16 *)0xFFC00838);
		debugfs_create_x16("SPORT0_MCMC2", 0600, parent, (u16 *)0xFFC0083C);
		debugfs_create_x32("SPORT0_MRCS0", 0600, parent, (u32 *)0xFFC00850);
		debugfs_create_x32("SPORT0_MRCS1", 0600, parent, (u32 *)0xFFC00854);
		debugfs_create_x32("SPORT0_MRCS2", 0600, parent, (u32 *)0xFFC00858);
		debugfs_create_x32("SPORT0_MRCS3", 0600, parent, (u32 *)0xFFC0085C);
		debugfs_create_x32("SPORT0_MTCS0", 0600, parent, (u32 *)0xFFC00840);
		debugfs_create_x32("SPORT0_MTCS1", 0600, parent, (u32 *)0xFFC00844);
		debugfs_create_x32("SPORT0_MTCS2", 0600, parent, (u32 *)0xFFC00848);
		debugfs_create_x32("SPORT0_MTCS3", 0600, parent, (u32 *)0xFFC0084C);
		debugfs_create_x16("SPORT0_RCLKDIV", 0600, parent, (u16 *)0xFFC00828);
		debugfs_create_x16("SPORT0_RCR1", 0600, parent, (u16 *)0xFFC00820);
		debugfs_create_x16("SPORT0_RCR2", 0600, parent, (u16 *)0xFFC00824);
		debugfs_create_x16("SPORT0_RFSDIV", 0600, parent, (u16 *)0xFFC0082C);
		debugfs_create_x32("SPORT0_RX", 0600, parent, (u32 *)0xFFC00818);
		debugfs_create_x16("SPORT0_STAT", 0600, parent, (u16 *)0xFFC00830);
		debugfs_create_x16("SPORT0_TCLKDIV", 0600, parent, (u16 *)0xFFC00808);
		debugfs_create_x16("SPORT0_TCR1", 0600, parent, (u16 *)0xFFC00800);
		debugfs_create_x16("SPORT0_TCR2", 0600, parent, (u16 *)0xFFC00804);
		debugfs_create_x16("SPORT0_TFSDIV", 0600, parent, (u16 *)0xFFC0080C);
		debugfs_create_x32("SPORT0_TX", 0600, parent, (u32 *)0xFFC00810);
		debugfs_create_x16("SPORT1_CHNL", 0600, parent, (u16 *)0xFFC00934);
		debugfs_create_x16("SPORT1_MCMC1", 0600, parent, (u16 *)0xFFC00938);
		debugfs_create_x16("SPORT1_MCMC2", 0600, parent, (u16 *)0xFFC0093C);
		debugfs_create_x32("SPORT1_MRCS0", 0600, parent, (u32 *)0xFFC00950);
		debugfs_create_x32("SPORT1_MRCS1", 0600, parent, (u32 *)0xFFC00954);
		debugfs_create_x32("SPORT1_MRCS2", 0600, parent, (u32 *)0xFFC00958);
		debugfs_create_x32("SPORT1_MRCS3", 0600, parent, (u32 *)0xFFC0095C);
		debugfs_create_x32("SPORT1_MTCS0", 0600, parent, (u32 *)0xFFC00940);
		debugfs_create_x32("SPORT1_MTCS1", 0600, parent, (u32 *)0xFFC00944);
		debugfs_create_x32("SPORT1_MTCS2", 0600, parent, (u32 *)0xFFC00948);
		debugfs_create_x32("SPORT1_MTCS3", 0600, parent, (u32 *)0xFFC0094C);
		debugfs_create_x16("SPORT1_RCLKDIV", 0600, parent, (u16 *)0xFFC00928);
		debugfs_create_x16("SPORT1_RCR1", 0600, parent, (u16 *)0xFFC00920);
		debugfs_create_x16("SPORT1_RCR2", 0600, parent, (u16 *)0xFFC00924);
		debugfs_create_x16("SPORT1_RFSDIV", 0600, parent, (u16 *)0xFFC0092C);
		debugfs_create_x32("SPORT1_RX", 0600, parent, (u32 *)0xFFC00918);
		debugfs_create_x16("SPORT1_STAT", 0600, parent, (u16 *)0xFFC00930);
		debugfs_create_x16("SPORT1_TCLKDIV", 0600, parent, (u16 *)0xFFC00908);
		debugfs_create_x16("SPORT1_TCR1", 0600, parent, (u16 *)0xFFC00900);
		debugfs_create_x16("SPORT1_TCR2", 0600, parent, (u16 *)0xFFC00904);
		debugfs_create_x16("SPORT1_TFSDIV", 0600, parent, (u16 *)0xFFC0090C);
		debugfs_create_x32("SPORT1_TX", 0600, parent, (u32 *)0xFFC00910);
		debugfs_create_x16("SPORT2_CHNL", 0600, parent, (u16 *)0xFFC02534);
		debugfs_create_x16("SPORT2_MCMC1", 0600, parent, (u16 *)0xFFC02538);
		debugfs_create_x16("SPORT2_MCMC2", 0600, parent, (u16 *)0xFFC0253C);
		debugfs_create_x32("SPORT2_MRCS0", 0600, parent, (u32 *)0xFFC02550);
		debugfs_create_x32("SPORT2_MRCS1", 0600, parent, (u32 *)0xFFC02554);
		debugfs_create_x32("SPORT2_MRCS2", 0600, parent, (u32 *)0xFFC02558);
		debugfs_create_x32("SPORT2_MRCS3", 0600, parent, (u32 *)0xFFC0255C);
		debugfs_create_x32("SPORT2_MTCS0", 0600, parent, (u32 *)0xFFC02540);
		debugfs_create_x32("SPORT2_MTCS1", 0600, parent, (u32 *)0xFFC02544);
		debugfs_create_x32("SPORT2_MTCS2", 0600, parent, (u32 *)0xFFC02548);
		debugfs_create_x32("SPORT2_MTCS3", 0600, parent, (u32 *)0xFFC0254C);
		debugfs_create_x16("SPORT2_RCLKDIV", 0600, parent, (u16 *)0xFFC02528);
		debugfs_create_x16("SPORT2_RCR1", 0600, parent, (u16 *)0xFFC02520);
		debugfs_create_x16("SPORT2_RCR2", 0600, parent, (u16 *)0xFFC02524);
		debugfs_create_x16("SPORT2_RFSDIV", 0600, parent, (u16 *)0xFFC0252C);
		debugfs_create_x32("SPORT2_RX", 0600, parent, (u32 *)0xFFC02518);
		debugfs_create_x16("SPORT2_STAT", 0600, parent, (u16 *)0xFFC02530);
		debugfs_create_x16("SPORT2_TCLKDIV", 0600, parent, (u16 *)0xFFC02508);
		debugfs_create_x16("SPORT2_TCR1", 0600, parent, (u16 *)0xFFC02500);
		debugfs_create_x16("SPORT2_TCR2", 0600, parent, (u16 *)0xFFC02504);
		debugfs_create_x16("SPORT2_TFSDIV", 0600, parent, (u16 *)0xFFC0250C);
		debugfs_create_x32("SPORT2_TX", 0600, parent, (u32 *)0xFFC02510);
		debugfs_create_x16("SPORT3_CHNL", 0600, parent, (u16 *)0xFFC02634);
		debugfs_create_x16("SPORT3_MCMC1", 0600, parent, (u16 *)0xFFC02638);
		debugfs_create_x16("SPORT3_MCMC2", 0600, parent, (u16 *)0xFFC0263C);
		debugfs_create_x32("SPORT3_MRCS0", 0600, parent, (u32 *)0xFFC02650);
		debugfs_create_x32("SPORT3_MRCS1", 0600, parent, (u32 *)0xFFC02654);
		debugfs_create_x32("SPORT3_MRCS2", 0600, parent, (u32 *)0xFFC02658);
		debugfs_create_x32("SPORT3_MRCS3", 0600, parent, (u32 *)0xFFC0265C);
		debugfs_create_x32("SPORT3_MTCS0", 0600, parent, (u32 *)0xFFC02640);
		debugfs_create_x32("SPORT3_MTCS1", 0600, parent, (u32 *)0xFFC02644);
		debugfs_create_x32("SPORT3_MTCS2", 0600, parent, (u32 *)0xFFC02648);
		debugfs_create_x32("SPORT3_MTCS3", 0600, parent, (u32 *)0xFFC0264C);
		debugfs_create_x16("SPORT3_RCLKDIV", 0600, parent, (u16 *)0xFFC02628);
		debugfs_create_x16("SPORT3_RCR1", 0600, parent, (u16 *)0xFFC02620);
		debugfs_create_x16("SPORT3_RCR2", 0600, parent, (u16 *)0xFFC02624);
		debugfs_create_x16("SPORT3_RFSDIV", 0600, parent, (u16 *)0xFFC0262C);
		debugfs_create_x32("SPORT3_RX", 0600, parent, (u32 *)0xFFC02618);
		debugfs_create_x16("SPORT3_STAT", 0600, parent, (u16 *)0xFFC02630);
		debugfs_create_x16("SPORT3_TCLKDIV", 0600, parent, (u16 *)0xFFC02608);
		debugfs_create_x16("SPORT3_TCR1", 0600, parent, (u16 *)0xFFC02600);
		debugfs_create_x16("SPORT3_TCR2", 0600, parent, (u16 *)0xFFC02604);
		debugfs_create_x16("SPORT3_TFSDIV", 0600, parent, (u16 *)0xFFC0260C);
		debugfs_create_x32("SPORT3_TX", 0600, parent, (u32 *)0xFFC02610);

		parent = debugfs_create_dir("Security", top);
		debugfs_create_x16("SECURE_CONTROL", 0600, parent, (u16 *)0xFFC04324);
		debugfs_create_x16("SECURE_STATUS", 0600, parent, (u16 *)0xFFC04328);
		debugfs_create_x32("SECURE_SYSSWT", 0600, parent, (u32 *)0xFFC04320);

		parent = debugfs_create_dir("System Reset and Interrupt Control Registers", top);
		debugfs_create_x16("SWRST", 0600, parent, (u16 *)0xFFC00100);
		debugfs_create_x16("SYSCR", 0600, parent, (u16 *)0xFFC00104);

		parent = debugfs_create_dir("TWI", top);
		debugfs_create_x16("TWI0_CLKDIV", 0600, parent, (u16 *)0xFFC00700);
		debugfs_create_x16("TWI0_CONTROL", 0600, parent, (u16 *)0xFFC00704);
		debugfs_create_x16("TWI0_FIFO_CTL", 0600, parent, (u16 *)0xFFC00728);
		debugfs_create_x16("TWI0_FIFO_STAT", 0600, parent, (u16 *)0xFFC0072C);
		debugfs_create_x16("TWI0_INT_MASK", 0600, parent, (u16 *)0xFFC00724);
		debugfs_create_x16("TWI0_INT_STAT", 0600, parent, (u16 *)0xFFC00720);
		debugfs_create_x16("TWI0_MASTER_ADDR", 0600, parent, (u16 *)0xFFC0071C);
		debugfs_create_x16("TWI0_MASTER_CTL", 0600, parent, (u16 *)0xFFC00714);
		debugfs_create_x16("TWI0_MASTER_STAT", 0600, parent, (u16 *)0xFFC00718);
		debugfs_create_x16("TWI0_RCV_DATA16", 0600, parent, (u16 *)0xFFC0078C);
		debugfs_create_x16("TWI0_RCV_DATA8", 0600, parent, (u16 *)0xFFC00788);
		debugfs_create_x16("TWI0_SLAVE_ADDR", 0600, parent, (u16 *)0xFFC00710);
		debugfs_create_x16("TWI0_SLAVE_CTL", 0600, parent, (u16 *)0xFFC00708);
		debugfs_create_x16("TWI0_SLAVE_STAT", 0600, parent, (u16 *)0xFFC0070C);
		debugfs_create_x16("TWI0_XMT_DATA16", 0600, parent, (u16 *)0xFFC00784);
		debugfs_create_x16("TWI0_XMT_DATA8", 0600, parent, (u16 *)0xFFC00780);
		debugfs_create_x16("TWI1_CLKDIV", 0600, parent, (u16 *)0xFFC02200);
		debugfs_create_x16("TWI1_CONTROL", 0600, parent, (u16 *)0xFFC02204);
		debugfs_create_x16("TWI1_FIFO_CTL", 0600, parent, (u16 *)0xFFC02228);
		debugfs_create_x16("TWI1_FIFO_STAT", 0600, parent, (u16 *)0xFFC0222C);
		debugfs_create_x16("TWI1_INT_MASK", 0600, parent, (u16 *)0xFFC02224);
		debugfs_create_x16("TWI1_INT_STAT", 0600, parent, (u16 *)0xFFC02220);
		debugfs_create_x16("TWI1_MASTER_ADDR", 0600, parent, (u16 *)0xFFC0221C);
		debugfs_create_x16("TWI1_MASTER_CTL", 0600, parent, (u16 *)0xFFC02214);
		debugfs_create_x16("TWI1_MASTER_STAT", 0600, parent, (u16 *)0xFFC02218);
		debugfs_create_x16("TWI1_RCV_DATA16", 0600, parent, (u16 *)0xFFC0228C);
		debugfs_create_x16("TWI1_RCV_DATA8", 0600, parent, (u16 *)0xFFC02288);
		debugfs_create_x16("TWI1_SLAVE_ADDR", 0600, parent, (u16 *)0xFFC02210);
		debugfs_create_x16("TWI1_SLAVE_CTL", 0600, parent, (u16 *)0xFFC02208);
		debugfs_create_x16("TWI1_SLAVE_STAT", 0600, parent, (u16 *)0xFFC0220C);
		debugfs_create_x16("TWI1_XMT_DATA16", 0600, parent, (u16 *)0xFFC02284);
		debugfs_create_x16("TWI1_XMT_DATA8", 0600, parent, (u16 *)0xFFC02280);

		parent = debugfs_create_dir("UART", top);
		debugfs_create_x16("UART0_DLH", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART0_DLL", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART0_GCTL", 0600, parent, (u16 *)0xFFC00408);
		debugfs_create_x16("UART0_IER_CLEAR", 0600, parent, (u16 *)0xFFC00424);
		debugfs_create_x16("UART0_IER_SET", 0600, parent, (u16 *)0xFFC00420);
		debugfs_create_x16("UART0_LCR", 0600, parent, (u16 *)0xFFC0040C);
		debugfs_create_x16("UART0_LSR", 0600, parent, (u16 *)0xFFC00414);
		debugfs_create_x16("UART0_MCR", 0600, parent, (u16 *)0xFFC00410);
		debugfs_create_x16("UART0_MSR", 0600, parent, (u16 *)0xFFC00418);
		debugfs_create_x16("UART0_RBR", 0600, parent, (u16 *)0xFFC0042C);
		debugfs_create_x16("UART0_SCR", 0600, parent, (u16 *)0xFFC0041C);
		debugfs_create_x16("UART0_THR", 0600, parent, (u16 *)0xFFC00428);
		debugfs_create_x16("UART1_DLH", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("UART1_DLL", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART1_GCTL", 0600, parent, (u16 *)0xFFC02008);
		debugfs_create_x16("UART1_IER_CLEAR", 0600, parent, (u16 *)0xFFC02024);
		debugfs_create_x16("UART1_IER_SET", 0600, parent, (u16 *)0xFFC02020);
		debugfs_create_x16("UART1_LCR", 0600, parent, (u16 *)0xFFC0200C);
		debugfs_create_x16("UART1_LSR", 0600, parent, (u16 *)0xFFC02014);
		debugfs_create_x16("UART1_MCR", 0600, parent, (u16 *)0xFFC02010);
		debugfs_create_x16("UART1_MSR", 0600, parent, (u16 *)0xFFC02018);
		debugfs_create_x16("UART1_RBR", 0600, parent, (u16 *)0xFFC0202C);
		debugfs_create_x16("UART1_SCR", 0600, parent, (u16 *)0xFFC0201C);
		debugfs_create_x16("UART1_THR", 0600, parent, (u16 *)0xFFC02028);
		debugfs_create_x16("UART2_DLH", 0600, parent, (u16 *)0xFFC02104);
		debugfs_create_x16("UART2_DLL", 0600, parent, (u16 *)0xFFC02100);
		debugfs_create_x16("UART2_GCTL", 0600, parent, (u16 *)0xFFC02108);
		debugfs_create_x16("UART2_IER_CLEAR", 0600, parent, (u16 *)0xFFC02124);
		debugfs_create_x16("UART2_IER_SET", 0600, parent, (u16 *)0xFFC02120);
		debugfs_create_x16("UART2_LCR", 0600, parent, (u16 *)0xFFC0210C);
		debugfs_create_x16("UART2_LSR", 0600, parent, (u16 *)0xFFC02114);
		debugfs_create_x16("UART2_MCR", 0600, parent, (u16 *)0xFFC02110);
		debugfs_create_x16("UART2_MSR", 0600, parent, (u16 *)0xFFC02118);
		debugfs_create_x16("UART2_RBR", 0600, parent, (u16 *)0xFFC0212C);
		debugfs_create_x16("UART2_SCR", 0600, parent, (u16 *)0xFFC0211C);
		debugfs_create_x16("UART2_THR", 0600, parent, (u16 *)0xFFC02128);
		debugfs_create_x16("UART3_DLH", 0600, parent, (u16 *)0xFFC03104);
		debugfs_create_x16("UART3_DLL", 0600, parent, (u16 *)0xFFC03100);
		debugfs_create_x16("UART3_GCTL", 0600, parent, (u16 *)0xFFC03108);
		debugfs_create_x16("UART3_IER_CLEAR", 0600, parent, (u16 *)0xFFC03124);
		debugfs_create_x16("UART3_IER_SET", 0600, parent, (u16 *)0xFFC03120);
		debugfs_create_x16("UART3_LCR", 0600, parent, (u16 *)0xFFC0310C);
		debugfs_create_x16("UART3_LSR", 0600, parent, (u16 *)0xFFC03114);
		debugfs_create_x16("UART3_MCR", 0600, parent, (u16 *)0xFFC03110);
		debugfs_create_x16("UART3_MSR", 0600, parent, (u16 *)0xFFC03118);
		debugfs_create_x16("UART3_RBR", 0600, parent, (u16 *)0xFFC0312C);
		debugfs_create_x16("UART3_SCR", 0600, parent, (u16 *)0xFFC0311C);
		debugfs_create_x16("UART3_THR", 0600, parent, (u16 *)0xFFC03128);

		parent = debugfs_create_dir("USB", top);
		debugfs_create_x16("USB_APHY_CALIB", 0600, parent, (u16 *)0xFFC03DE4);
		debugfs_create_x16("USB_APHY_CNTRL2", 0600, parent, (u16 *)0xFFC03DE8);
		debugfs_create_x16("USB_APHY_CNTRL", 0600, parent, (u16 *)0xFFC03DE0);
		debugfs_create_x16("USB_COUNT0", 0600, parent, (u16 *)0xFFC03C50);
		debugfs_create_x16("USB_CSR0", 0600, parent, (u16 *)0xFFC03C44);
		debugfs_create_x16("USB_DMA0_ADDRHIGH", 0600, parent, (u16 *)0xFFC0400C);
		debugfs_create_x16("USB_DMA0_ADDRLOW", 0600, parent, (u16 *)0xFFC04008);
		debugfs_create_x16("USB_DMA0_CONTROL", 0600, parent, (u16 *)0xFFC04004);
		debugfs_create_x16("USB_DMA0_COUNTHIGH", 0600, parent, (u16 *)0xFFC04014);
		debugfs_create_x16("USB_DMA0_COUNTLOW", 0600, parent, (u16 *)0xFFC04010);
		debugfs_create_x16("USB_DMA1_ADDRHIGH", 0600, parent, (u16 *)0xFFC0402C);
		debugfs_create_x16("USB_DMA1_ADDRLOW", 0600, parent, (u16 *)0xFFC04028);
		debugfs_create_x16("USB_DMA1_CONTROL", 0600, parent, (u16 *)0xFFC04024);
		debugfs_create_x16("USB_DMA1_COUNTHIGH", 0600, parent, (u16 *)0xFFC04034);
		debugfs_create_x16("USB_DMA1_COUNTLOW", 0600, parent, (u16 *)0xFFC04030);
		debugfs_create_x16("USB_DMA2_ADDRHIGH", 0600, parent, (u16 *)0xFFC0404C);
		debugfs_create_x16("USB_DMA2_ADDRLOW", 0600, parent, (u16 *)0xFFC04048);
		debugfs_create_x16("USB_DMA2_CONTROL", 0600, parent, (u16 *)0xFFC04044);
		debugfs_create_x16("USB_DMA2_COUNTHIGH", 0600, parent, (u16 *)0xFFC04054);
		debugfs_create_x16("USB_DMA2_COUNTLOW", 0600, parent, (u16 *)0xFFC04050);
		debugfs_create_x16("USB_DMA3_ADDRHIGH", 0600, parent, (u16 *)0xFFC0406C);
		debugfs_create_x16("USB_DMA3_ADDRLOW", 0600, parent, (u16 *)0xFFC04068);
		debugfs_create_x16("USB_DMA3_CONTROL", 0600, parent, (u16 *)0xFFC04064);
		debugfs_create_x16("USB_DMA3_COUNTHIGH", 0600, parent, (u16 *)0xFFC04074);
		debugfs_create_x16("USB_DMA3_COUNTLOW", 0600, parent, (u16 *)0xFFC04070);
		debugfs_create_x16("USB_DMA4_ADDRHIGH", 0600, parent, (u16 *)0xFFC0408C);
		debugfs_create_x16("USB_DMA4_ADDRLOW", 0600, parent, (u16 *)0xFFC04088);
		debugfs_create_x16("USB_DMA4_CONTROL", 0600, parent, (u16 *)0xFFC04084);
		debugfs_create_x16("USB_DMA4_COUNTHIGH", 0600, parent, (u16 *)0xFFC04094);
		debugfs_create_x16("USB_DMA4_COUNTLOW", 0600, parent, (u16 *)0xFFC04090);
		debugfs_create_x16("USB_DMA5_ADDRHIGH", 0600, parent, (u16 *)0xFFC040AC);
		debugfs_create_x16("USB_DMA5_ADDRLOW", 0600, parent, (u16 *)0xFFC040A8);
		debugfs_create_x16("USB_DMA5_CONTROL", 0600, parent, (u16 *)0xFFC040A4);
		debugfs_create_x16("USB_DMA5_COUNTHIGH", 0600, parent, (u16 *)0xFFC040B4);
		debugfs_create_x16("USB_DMA5_COUNTLOW", 0600, parent, (u16 *)0xFFC040B0);
		debugfs_create_x16("USB_DMA6_ADDRHIGH", 0600, parent, (u16 *)0xFFC040CC);
		debugfs_create_x16("USB_DMA6_ADDRLOW", 0600, parent, (u16 *)0xFFC040C8);
		debugfs_create_x16("USB_DMA6_CONTROL", 0600, parent, (u16 *)0xFFC040C4);
		debugfs_create_x16("USB_DMA6_COUNTHIGH", 0600, parent, (u16 *)0xFFC040D4);
		debugfs_create_x16("USB_DMA6_COUNTLOW", 0600, parent, (u16 *)0xFFC040D0);
		debugfs_create_x16("USB_DMA7_ADDRHIGH", 0600, parent, (u16 *)0xFFC040EC);
		debugfs_create_x16("USB_DMA7_ADDRLOW", 0600, parent, (u16 *)0xFFC040E8);
		debugfs_create_x16("USB_DMA7_CONTROL", 0600, parent, (u16 *)0xFFC040E4);
		debugfs_create_x16("USB_DMA7_COUNTHIGH", 0600, parent, (u16 *)0xFFC040F4);
		debugfs_create_x16("USB_DMA7_COUNTLOW", 0600, parent, (u16 *)0xFFC040F0);
		debugfs_create_x16("USB_DMA_INTERRUPT", 0600, parent, (u16 *)0xFFC04000);
		debugfs_create_x16("USB_EP0_FIFO", 0600, parent, (u16 *)0xFFC03C80);
		debugfs_create_x16("USB_EP1_FIFO", 0600, parent, (u16 *)0xFFC03C88);
		debugfs_create_x16("USB_EP2_FIFO", 0600, parent, (u16 *)0xFFC03C90);
		debugfs_create_x16("USB_EP3_FIFO", 0600, parent, (u16 *)0xFFC03C98);
		debugfs_create_x16("USB_EP4_FIFO", 0600, parent, (u16 *)0xFFC03CA0);
		debugfs_create_x16("USB_EP5_FIFO", 0600, parent, (u16 *)0xFFC03CA8);
		debugfs_create_x16("USB_EP6_FIFO", 0600, parent, (u16 *)0xFFC03CB0);
		debugfs_create_x16("USB_EP7_FIFO", 0600, parent, (u16 *)0xFFC03CB8);
		debugfs_create_x16("USB_EP_NI0_RXCOUNT", 0600, parent, (u16 *)0xFFC03E10);
		debugfs_create_x16("USB_EP_NI0_RXCSR", 0600, parent, (u16 *)0xFFC03E0C);
		debugfs_create_x16("USB_EP_NI0_RXINTERVAL", 0600, parent, (u16 *)0xFFC03E20);
		debugfs_create_x16("USB_EP_NI0_RXMAXP", 0600, parent, (u16 *)0xFFC03E08);
		debugfs_create_x16("USB_EP_NI0_RXTYPE", 0600, parent, (u16 *)0xFFC03E1C);
		debugfs_create_x16("USB_EP_NI0_TXCOUNT", 0600, parent, (u16 *)0xFFC03E28);
		debugfs_create_x16("USB_EP_NI0_TXCSR", 0600, parent, (u16 *)0xFFC03E04);
		debugfs_create_x16("USB_EP_NI0_TXINTERVAL", 0600, parent, (u16 *)0xFFC03E18);
		debugfs_create_x16("USB_EP_NI0_TXMAXP", 0600, parent, (u16 *)0xFFC03E00);
		debugfs_create_x16("USB_EP_NI0_TXTYPE", 0600, parent, (u16 *)0xFFC03E14);
		debugfs_create_x16("USB_EP_NI1_RXCOUNT", 0600, parent, (u16 *)0xFFC03E50);
		debugfs_create_x16("USB_EP_NI1_RXCSR", 0600, parent, (u16 *)0xFFC03E4C);
		debugfs_create_x16("USB_EP_NI1_RXINTERVAL", 0600, parent, (u16 *)0xFFC03E60);
		debugfs_create_x16("USB_EP_NI1_RXMAXP", 0600, parent, (u16 *)0xFFC03E48);
		debugfs_create_x16("USB_EP_NI1_RXTYPE", 0600, parent, (u16 *)0xFFC03E5C);
		debugfs_create_x16("USB_EP_NI1_TXCOUNT", 0600, parent, (u16 *)0xFFC03E68);
		debugfs_create_x16("USB_EP_NI1_TXCSR", 0600, parent, (u16 *)0xFFC03E44);
		debugfs_create_x16("USB_EP_NI1_TXINTERVAL", 0600, parent, (u16 *)0xFFC03E58);
		debugfs_create_x16("USB_EP_NI1_TXMAXP", 0600, parent, (u16 *)0xFFC03E40);
		debugfs_create_x16("USB_EP_NI1_TXTYPE", 0600, parent, (u16 *)0xFFC03E54);
		debugfs_create_x16("USB_EP_NI2_RXCOUNT", 0600, parent, (u16 *)0xFFC03E90);
		debugfs_create_x16("USB_EP_NI2_RXCSR", 0600, parent, (u16 *)0xFFC03E8C);
		debugfs_create_x16("USB_EP_NI2_RXINTERVAL", 0600, parent, (u16 *)0xFFC03EA0);
		debugfs_create_x16("USB_EP_NI2_RXMAXP", 0600, parent, (u16 *)0xFFC03E88);
		debugfs_create_x16("USB_EP_NI2_RXTYPE", 0600, parent, (u16 *)0xFFC03E9C);
		debugfs_create_x16("USB_EP_NI2_TXCOUNT", 0600, parent, (u16 *)0xFFC03EA8);
		debugfs_create_x16("USB_EP_NI2_TXCSR", 0600, parent, (u16 *)0xFFC03E84);
		debugfs_create_x16("USB_EP_NI2_TXINTERVAL", 0600, parent, (u16 *)0xFFC03E98);
		debugfs_create_x16("USB_EP_NI2_TXMAXP", 0600, parent, (u16 *)0xFFC03E80);
		debugfs_create_x16("USB_EP_NI2_TXTYPE", 0600, parent, (u16 *)0xFFC03E94);
		debugfs_create_x16("USB_EP_NI3_RXCOUNT", 0600, parent, (u16 *)0xFFC03ED0);
		debugfs_create_x16("USB_EP_NI3_RXCSR", 0600, parent, (u16 *)0xFFC03ECC);
		debugfs_create_x16("USB_EP_NI3_RXINTERVAL", 0600, parent, (u16 *)0xFFC03EE0);
		debugfs_create_x16("USB_EP_NI3_RXMAXP", 0600, parent, (u16 *)0xFFC03EC8);
		debugfs_create_x16("USB_EP_NI3_RXTYPE", 0600, parent, (u16 *)0xFFC03EDC);
		debugfs_create_x16("USB_EP_NI3_TXCOUNT", 0600, parent, (u16 *)0xFFC03EE8);
		debugfs_create_x16("USB_EP_NI3_TXCSR", 0600, parent, (u16 *)0xFFC03EC4);
		debugfs_create_x16("USB_EP_NI3_TXINTERVAL", 0600, parent, (u16 *)0xFFC03ED8);
		debugfs_create_x16("USB_EP_NI3_TXMAXP", 0600, parent, (u16 *)0xFFC03EC0);
		debugfs_create_x16("USB_EP_NI3_TXTYPE", 0600, parent, (u16 *)0xFFC03ED4);
		debugfs_create_x16("USB_EP_NI4_RXCOUNT", 0600, parent, (u16 *)0xFFC03F10);
		debugfs_create_x16("USB_EP_NI4_RXCSR", 0600, parent, (u16 *)0xFFC03F0C);
		debugfs_create_x16("USB_EP_NI4_RXINTERVAL", 0600, parent, (u16 *)0xFFC03F20);
		debugfs_create_x16("USB_EP_NI4_RXMAXP", 0600, parent, (u16 *)0xFFC03F08);
		debugfs_create_x16("USB_EP_NI4_RXTYPE", 0600, parent, (u16 *)0xFFC03F1C);
		debugfs_create_x16("USB_EP_NI4_TXCOUNT", 0600, parent, (u16 *)0xFFC03F28);
		debugfs_create_x16("USB_EP_NI4_TXCSR", 0600, parent, (u16 *)0xFFC03F04);
		debugfs_create_x16("USB_EP_NI4_TXINTERVAL", 0600, parent, (u16 *)0xFFC03F18);
		debugfs_create_x16("USB_EP_NI4_TXMAXP", 0600, parent, (u16 *)0xFFC03F00);
		debugfs_create_x16("USB_EP_NI4_TXTYPE", 0600, parent, (u16 *)0xFFC03F14);
		debugfs_create_x16("USB_EP_NI5_RXCOUNT", 0600, parent, (u16 *)0xFFC03F50);
		debugfs_create_x16("USB_EP_NI5_RXCSR", 0600, parent, (u16 *)0xFFC03F4C);
		debugfs_create_x16("USB_EP_NI5_RXINTERVAL", 0600, parent, (u16 *)0xFFC03F60);
		debugfs_create_x16("USB_EP_NI5_RXMAXP", 0600, parent, (u16 *)0xFFC03F48);
		debugfs_create_x16("USB_EP_NI5_RXTYPE", 0600, parent, (u16 *)0xFFC03F5C);
		debugfs_create_x16("USB_EP_NI5_TXCOUNT", 0600, parent, (u16 *)0xFFC03F68);
		debugfs_create_x16("USB_EP_NI5_TXCSR", 0600, parent, (u16 *)0xFFC03F44);
		debugfs_create_x16("USB_EP_NI5_TXINTERVAL", 0600, parent, (u16 *)0xFFC03F58);
		debugfs_create_x16("USB_EP_NI5_TXMAXP", 0600, parent, (u16 *)0xFFC03F40);
		debugfs_create_x16("USB_EP_NI5_TXTYPE", 0600, parent, (u16 *)0xFFC03F54);
		debugfs_create_x16("USB_EP_NI6_RXCOUNT", 0600, parent, (u16 *)0xFFC03F90);
		debugfs_create_x16("USB_EP_NI6_RXCSR", 0600, parent, (u16 *)0xFFC03F8C);
		debugfs_create_x16("USB_EP_NI6_RXINTERVAL", 0600, parent, (u16 *)0xFFC03FA0);
		debugfs_create_x16("USB_EP_NI6_RXMAXP", 0600, parent, (u16 *)0xFFC03F88);
		debugfs_create_x16("USB_EP_NI6_RXTYPE", 0600, parent, (u16 *)0xFFC03F9C);
		debugfs_create_x16("USB_EP_NI6_TXCOUNT", 0600, parent, (u16 *)0xFFC03FA8);
		debugfs_create_x16("USB_EP_NI6_TXCSR", 0600, parent, (u16 *)0xFFC03F84);
		debugfs_create_x16("USB_EP_NI6_TXINTERVAL", 0600, parent, (u16 *)0xFFC03F98);
		debugfs_create_x16("USB_EP_NI6_TXMAXP", 0600, parent, (u16 *)0xFFC03F80);
		debugfs_create_x16("USB_EP_NI6_TXTYPE", 0600, parent, (u16 *)0xFFC03F94);
		debugfs_create_x16("USB_EP_NI7_RXCOUNT", 0600, parent, (u16 *)0xFFC03FD0);
		debugfs_create_x16("USB_EP_NI7_RXCSR", 0600, parent, (u16 *)0xFFC03FCC);
		debugfs_create_x16("USB_EP_NI7_RXINTERVAL", 0600, parent, (u16 *)0xFFC03FF0);
		debugfs_create_x16("USB_EP_NI7_RXMAXP", 0600, parent, (u16 *)0xFFC03FC8);
		debugfs_create_x16("USB_EP_NI7_RXTYPE", 0600, parent, (u16 *)0xFFC03FDC);
		debugfs_create_x16("USB_EP_NI7_TXCOUNT", 0600, parent, (u16 *)0xFFC03FF8);
		debugfs_create_x16("USB_EP_NI7_TXCSR", 0600, parent, (u16 *)0xFFC03FC4);
		debugfs_create_x16("USB_EP_NI7_TXINTERVAL", 0600, parent, (u16 *)0xFFC03FD8);
		debugfs_create_x16("USB_EP_NI7_TXMAXP", 0600, parent, (u16 *)0xFFC03FC0);
		debugfs_create_x16("USB_EP_NI7_TXTYPE", 0600, parent, (u16 *)0xFFC03FD4);
		debugfs_create_x16("USB_FADDR", 0600, parent, (u16 *)0xFFC03C00);
		debugfs_create_x16("USB_FRAME", 0600, parent, (u16 *)0xFFC03C20);
		debugfs_create_x16("USB_FS_EOF1", 0600, parent, (u16 *)0xFFC03D54);
		debugfs_create_x16("USB_GLOBAL_CTL", 0600, parent, (u16 *)0xFFC03C30);
		debugfs_create_x16("USB_GLOBINTR", 0600, parent, (u16 *)0xFFC03C2C);
		debugfs_create_x16("USB_HS_EOF1", 0600, parent, (u16 *)0xFFC03D50);
		debugfs_create_x16("USB_INDEX", 0600, parent, (u16 *)0xFFC03C24);
		debugfs_create_x16("USB_INTRRX", 0600, parent, (u16 *)0xFFC03C0C);
		debugfs_create_x16("USB_INTRRXE", 0600, parent, (u16 *)0xFFC03C14);
		debugfs_create_x16("USB_INTRTX", 0600, parent, (u16 *)0xFFC03C08);
		debugfs_create_x16("USB_INTRTXE", 0600, parent, (u16 *)0xFFC03C10);
		debugfs_create_x16("USB_INTRUSB", 0600, parent, (u16 *)0xFFC03C18);
		debugfs_create_x16("USB_INTRUSBE", 0600, parent, (u16 *)0xFFC03C1C);
		debugfs_create_x16("USB_LINKINFO", 0600, parent, (u16 *)0xFFC03D48);
		debugfs_create_x16("USB_LS_EOF1", 0600, parent, (u16 *)0xFFC03D58);
		debugfs_create_x16("USB_NAKLIMIT0", 0600, parent, (u16 *)0xFFC03C58);
		debugfs_create_x16("USB_OTG_DEV_CTL", 0600, parent, (u16 *)0xFFC03D00);
		debugfs_create_x16("USB_OTG_VBUS_IRQ", 0600, parent, (u16 *)0xFFC03D04);
		debugfs_create_x16("USB_OTG_VBUS_MASK", 0600, parent, (u16 *)0xFFC03D08);
		debugfs_create_x16("USB_PHY_TEST", 0600, parent, (u16 *)0xFFC03DEC);
		debugfs_create_x16("USB_PLLOSC_CTRL", 0600, parent, (u16 *)0xFFC03DF0);
		debugfs_create_x16("USB_POWER", 0600, parent, (u16 *)0xFFC03C04);
		debugfs_create_x16("USB_RXCOUNT", 0600, parent, (u16 *)0xFFC03C50);
		debugfs_create_x16("USB_RXCSR", 0600, parent, (u16 *)0xFFC03C4C);
		debugfs_create_x16("USB_RXINTERVAL", 0600, parent, (u16 *)0xFFC03C60);
		debugfs_create_x16("USB_RXTYPE", 0600, parent, (u16 *)0xFFC03C5C);
		debugfs_create_x16("USB_RX_MAX_PACKET", 0600, parent, (u16 *)0xFFC03C48);
		debugfs_create_x16("USB_SRP_CLKDIV", 0600, parent, (u16 *)0xFFC03DF4);
		debugfs_create_x16("USB_TESTMODE", 0600, parent, (u16 *)0xFFC03C28);
		debugfs_create_x16("USB_TXCOUNT", 0600, parent, (u16 *)0xFFC03C68);
		debugfs_create_x16("USB_TXCSR", 0600, parent, (u16 *)0xFFC03C44);
		debugfs_create_x16("USB_TXINTERVAL", 0600, parent, (u16 *)0xFFC03C58);
		debugfs_create_x16("USB_TXTYPE", 0600, parent, (u16 *)0xFFC03C54);
		debugfs_create_x16("USB_TX_MAX_PACKET", 0600, parent, (u16 *)0xFFC03C40);
		debugfs_create_x16("USB_VPLEN", 0600, parent, (u16 *)0xFFC03D4C);

		parent = debugfs_create_dir("Watchdog", top);
		debugfs_create_x32("WDOG_CNT", 0600, parent, (u32 *)0xFFC00204);
		debugfs_create_x16("WDOG_CTL", 0600, parent, (u16 *)0xFFC00200);
		debugfs_create_x32("WDOG_STAT", 0600, parent, (u32 *)0xFFC00208);

		parent = debugfs_create_dir("Watchpoint and Patch Unit", top);
		debugfs_create_x32("WPDA0", 0600, parent, (u32 *)0xFFE07140);
		debugfs_create_x32("WPDA1", 0600, parent, (u32 *)0xFFE07144);
		debugfs_create_x32("WPDACNT0", 0600, parent, (u32 *)0xFFE07180);
		debugfs_create_x32("WPDACNT1", 0600, parent, (u32 *)0xFFE07184);
		debugfs_create_x32("WPDACTL", 0600, parent, (u32 *)0xFFE07100);
		debugfs_create_x32("WPIA0", 0600, parent, (u32 *)0xFFE07040);
		debugfs_create_x32("WPIA1", 0600, parent, (u32 *)0xFFE07044);
		debugfs_create_x32("WPIA2", 0600, parent, (u32 *)0xFFE07048);
		debugfs_create_x32("WPIA3", 0600, parent, (u32 *)0xFFE0704C);
		debugfs_create_x32("WPIA4", 0600, parent, (u32 *)0xFFE07050);
		debugfs_create_x32("WPIA5", 0600, parent, (u32 *)0xFFE07054);
		debugfs_create_x32("WPIACNT0", 0600, parent, (u32 *)0xFFE07080);
		debugfs_create_x32("WPIACNT1", 0600, parent, (u32 *)0xFFE07084);
		debugfs_create_x32("WPIACNT2", 0600, parent, (u32 *)0xFFE07088);
		debugfs_create_x32("WPIACNT3", 0600, parent, (u32 *)0xFFE0708C);
		debugfs_create_x32("WPIACNT4", 0600, parent, (u32 *)0xFFE07090);
		debugfs_create_x32("WPIACNT5", 0600, parent, (u32 *)0xFFE07094);
		debugfs_create_x32("WPIACTL", 0600, parent, (u32 *)0xFFE07000);
		debugfs_create_x32("WPSTAT", 0600, parent, (u32 *)0xFFE07200);

	}	/* BF548 */

#ifdef __ADSPBF549__
# define USE_BF549 1
#else
# define USE_BF549 0
#endif
	if (USE_BF549) {

		parent = debugfs_create_dir("ATAPI", top);
		debugfs_create_x16("ATAPI_CONTROL", 0600, parent, (u16 *)0xFFC03800);
		debugfs_create_x16("ATAPI_DEV_ADDR", 0600, parent, (u16 *)0xFFC03808);
		debugfs_create_x16("ATAPI_DEV_RXBUF", 0600, parent, (u16 *)0xFFC03810);
		debugfs_create_x16("ATAPI_DEV_TXBUF", 0600, parent, (u16 *)0xFFC0380C);
		debugfs_create_x16("ATAPI_DMA_TFRCNT", 0600, parent, (u16 *)0xFFC03830);
		debugfs_create_x16("ATAPI_INT_MASK", 0600, parent, (u16 *)0xFFC03814);
		debugfs_create_x16("ATAPI_INT_STATUS", 0600, parent, (u16 *)0xFFC03818);
		debugfs_create_x16("ATAPI_LINE_STATUS", 0600, parent, (u16 *)0xFFC03820);
		debugfs_create_x16("ATAPI_MULTI_TIM_0", 0600, parent, (u16 *)0xFFC03850);
		debugfs_create_x16("ATAPI_MULTI_TIM_1", 0600, parent, (u16 *)0xFFC03854);
		debugfs_create_x16("ATAPI_MULTI_TIM_2", 0600, parent, (u16 *)0xFFC03858);
		debugfs_create_x16("ATAPI_PIO_TFRCNT", 0600, parent, (u16 *)0xFFC0382C);
		debugfs_create_x16("ATAPI_PIO_TIM_0", 0600, parent, (u16 *)0xFFC03844);
		debugfs_create_x16("ATAPI_PIO_TIM_1", 0600, parent, (u16 *)0xFFC03848);
		debugfs_create_x16("ATAPI_REG_TIM_0", 0600, parent, (u16 *)0xFFC03840);
		debugfs_create_x16("ATAPI_SM_STATE", 0600, parent, (u16 *)0xFFC03824);
		debugfs_create_x16("ATAPI_STATUS", 0600, parent, (u16 *)0xFFC03804);
		debugfs_create_x16("ATAPI_TERMINATE", 0600, parent, (u16 *)0xFFC03828);
		debugfs_create_x16("ATAPI_UDMAOUT_TFRCNT", 0600, parent, (u16 *)0xFFC03838);
		debugfs_create_x16("ATAPI_ULTRA_TIM_0", 0600, parent, (u16 *)0xFFC03860);
		debugfs_create_x16("ATAPI_ULTRA_TIM_1", 0600, parent, (u16 *)0xFFC03864);
		debugfs_create_x16("ATAPI_ULTRA_TIM_2", 0600, parent, (u16 *)0xFFC03868);
		debugfs_create_x16("ATAPI_ULTRA_TIM_3", 0600, parent, (u16 *)0xFFC0386C);
		debugfs_create_x16("ATAPI_UMAIN_TFRCNT", 0600, parent, (u16 *)0xFFC03834);
		debugfs_create_x16("ATAPI_XFER_LEN", 0600, parent, (u16 *)0xFFC0381C);

		parent = debugfs_create_dir("CAN0 Acceptance Mask RAM", top);
		debugfs_create_x16("CAN0_AM00H", 0600, parent, (u16 *)0xFFC02B04);
		debugfs_create_x16("CAN0_AM00L", 0600, parent, (u16 *)0xFFC02B00);
		debugfs_create_x16("CAN0_AM01H", 0600, parent, (u16 *)0xFFC02B0C);
		debugfs_create_x16("CAN0_AM01L", 0600, parent, (u16 *)0xFFC02B08);
		debugfs_create_x16("CAN0_AM02H", 0600, parent, (u16 *)0xFFC02B14);
		debugfs_create_x16("CAN0_AM02L", 0600, parent, (u16 *)0xFFC02B10);
		debugfs_create_x16("CAN0_AM03H", 0600, parent, (u16 *)0xFFC02B1C);
		debugfs_create_x16("CAN0_AM03L", 0600, parent, (u16 *)0xFFC02B18);
		debugfs_create_x16("CAN0_AM04H", 0600, parent, (u16 *)0xFFC02B24);
		debugfs_create_x16("CAN0_AM04L", 0600, parent, (u16 *)0xFFC02B20);
		debugfs_create_x16("CAN0_AM05H", 0600, parent, (u16 *)0xFFC02B2C);
		debugfs_create_x16("CAN0_AM05L", 0600, parent, (u16 *)0xFFC02B28);
		debugfs_create_x16("CAN0_AM06H", 0600, parent, (u16 *)0xFFC02B34);
		debugfs_create_x16("CAN0_AM06L", 0600, parent, (u16 *)0xFFC02B30);
		debugfs_create_x16("CAN0_AM07H", 0600, parent, (u16 *)0xFFC02B3C);
		debugfs_create_x16("CAN0_AM07L", 0600, parent, (u16 *)0xFFC02B38);
		debugfs_create_x16("CAN0_AM08H", 0600, parent, (u16 *)0xFFC02B44);
		debugfs_create_x16("CAN0_AM08L", 0600, parent, (u16 *)0xFFC02B40);
		debugfs_create_x16("CAN0_AM09H", 0600, parent, (u16 *)0xFFC02B4C);
		debugfs_create_x16("CAN0_AM09L", 0600, parent, (u16 *)0xFFC02B48);
		debugfs_create_x16("CAN0_AM10H", 0600, parent, (u16 *)0xFFC02B54);
		debugfs_create_x16("CAN0_AM10L", 0600, parent, (u16 *)0xFFC02B50);
		debugfs_create_x16("CAN0_AM11H", 0600, parent, (u16 *)0xFFC02B5C);
		debugfs_create_x16("CAN0_AM11L", 0600, parent, (u16 *)0xFFC02B58);
		debugfs_create_x16("CAN0_AM12H", 0600, parent, (u16 *)0xFFC02B64);
		debugfs_create_x16("CAN0_AM12L", 0600, parent, (u16 *)0xFFC02B60);
		debugfs_create_x16("CAN0_AM13H", 0600, parent, (u16 *)0xFFC02B6C);
		debugfs_create_x16("CAN0_AM13L", 0600, parent, (u16 *)0xFFC02B68);
		debugfs_create_x16("CAN0_AM14H", 0600, parent, (u16 *)0xFFC02B74);
		debugfs_create_x16("CAN0_AM14L", 0600, parent, (u16 *)0xFFC02B70);
		debugfs_create_x16("CAN0_AM15H", 0600, parent, (u16 *)0xFFC02B7C);
		debugfs_create_x16("CAN0_AM15L", 0600, parent, (u16 *)0xFFC02B78);
		debugfs_create_x16("CAN0_AM16H", 0600, parent, (u16 *)0xFFC02B84);
		debugfs_create_x16("CAN0_AM16L", 0600, parent, (u16 *)0xFFC02B80);
		debugfs_create_x16("CAN0_AM17H", 0600, parent, (u16 *)0xFFC02B8C);
		debugfs_create_x16("CAN0_AM17L", 0600, parent, (u16 *)0xFFC02B88);
		debugfs_create_x16("CAN0_AM18H", 0600, parent, (u16 *)0xFFC02B94);
		debugfs_create_x16("CAN0_AM18L", 0600, parent, (u16 *)0xFFC02B90);
		debugfs_create_x16("CAN0_AM19H", 0600, parent, (u16 *)0xFFC02B9C);
		debugfs_create_x16("CAN0_AM19L", 0600, parent, (u16 *)0xFFC02B98);
		debugfs_create_x16("CAN0_AM20H", 0600, parent, (u16 *)0xFFC02BA4);
		debugfs_create_x16("CAN0_AM20L", 0600, parent, (u16 *)0xFFC02BA0);
		debugfs_create_x16("CAN0_AM21H", 0600, parent, (u16 *)0xFFC02BAC);
		debugfs_create_x16("CAN0_AM21L", 0600, parent, (u16 *)0xFFC02BA8);
		debugfs_create_x16("CAN0_AM22H", 0600, parent, (u16 *)0xFFC02BB4);
		debugfs_create_x16("CAN0_AM22L", 0600, parent, (u16 *)0xFFC02BB0);
		debugfs_create_x16("CAN0_AM23H", 0600, parent, (u16 *)0xFFC02BBC);
		debugfs_create_x16("CAN0_AM23L", 0600, parent, (u16 *)0xFFC02BB8);
		debugfs_create_x16("CAN0_AM24H", 0600, parent, (u16 *)0xFFC02BC4);
		debugfs_create_x16("CAN0_AM24L", 0600, parent, (u16 *)0xFFC02BC0);
		debugfs_create_x16("CAN0_AM25H", 0600, parent, (u16 *)0xFFC02BCC);
		debugfs_create_x16("CAN0_AM25L", 0600, parent, (u16 *)0xFFC02BC8);
		debugfs_create_x16("CAN0_AM26H", 0600, parent, (u16 *)0xFFC02BD4);
		debugfs_create_x16("CAN0_AM26L", 0600, parent, (u16 *)0xFFC02BD0);
		debugfs_create_x16("CAN0_AM27H", 0600, parent, (u16 *)0xFFC02BDC);
		debugfs_create_x16("CAN0_AM27L", 0600, parent, (u16 *)0xFFC02BD8);
		debugfs_create_x16("CAN0_AM28H", 0600, parent, (u16 *)0xFFC02BE4);
		debugfs_create_x16("CAN0_AM28L", 0600, parent, (u16 *)0xFFC02BE0);
		debugfs_create_x16("CAN0_AM29H", 0600, parent, (u16 *)0xFFC02BEC);
		debugfs_create_x16("CAN0_AM29L", 0600, parent, (u16 *)0xFFC02BE8);
		debugfs_create_x16("CAN0_AM30H", 0600, parent, (u16 *)0xFFC02BF4);
		debugfs_create_x16("CAN0_AM30L", 0600, parent, (u16 *)0xFFC02BF0);
		debugfs_create_x16("CAN0_AM31H", 0600, parent, (u16 *)0xFFC02BFC);
		debugfs_create_x16("CAN0_AM31L", 0600, parent, (u16 *)0xFFC02BF8);

		parent = debugfs_create_dir("CAN0 Control and Status", top);
		debugfs_create_x16("CAN0_AA1", 0600, parent, (u16 *)0xFFC02A14);
		debugfs_create_x16("CAN0_AA2", 0600, parent, (u16 *)0xFFC02A54);
		debugfs_create_x16("CAN0_CEC", 0600, parent, (u16 *)0xFFC02A90);
		debugfs_create_x16("CAN0_CLOCK", 0600, parent, (u16 *)0xFFC02A80);
		debugfs_create_x16("CAN0_CONTROL", 0600, parent, (u16 *)0xFFC02AA0);
		debugfs_create_x16("CAN0_DEBUG", 0600, parent, (u16 *)0xFFC02A88);
		debugfs_create_x16("CAN0_ESR", 0600, parent, (u16 *)0xFFC02AB4);
		debugfs_create_x16("CAN0_EWR", 0600, parent, (u16 *)0xFFC02AB0);
		debugfs_create_x16("CAN0_GIF", 0600, parent, (u16 *)0xFFC02A9C);
		debugfs_create_x16("CAN0_GIM", 0600, parent, (u16 *)0xFFC02A98);
		debugfs_create_x16("CAN0_GIS", 0600, parent, (u16 *)0xFFC02A94);
		debugfs_create_x16("CAN0_INTR", 0600, parent, (u16 *)0xFFC02AA4);
		debugfs_create_x16("CAN0_MBIM1", 0600, parent, (u16 *)0xFFC02A28);
		debugfs_create_x16("CAN0_MBIM2", 0600, parent, (u16 *)0xFFC02A68);
		debugfs_create_x16("CAN0_MBRIF1", 0600, parent, (u16 *)0xFFC02A24);
		debugfs_create_x16("CAN0_MBRIF2", 0600, parent, (u16 *)0xFFC02A64);
		debugfs_create_x16("CAN0_MBTD", 0600, parent, (u16 *)0xFFC02AAC);
		debugfs_create_x16("CAN0_MBTIF1", 0600, parent, (u16 *)0xFFC02A20);
		debugfs_create_x16("CAN0_MBTIF2", 0600, parent, (u16 *)0xFFC02A60);
		debugfs_create_x16("CAN0_MC1", 0600, parent, (u16 *)0xFFC02A00);
		debugfs_create_x16("CAN0_MC2", 0600, parent, (u16 *)0xFFC02A40);
		debugfs_create_x16("CAN0_MD1", 0600, parent, (u16 *)0xFFC02A04);
		debugfs_create_x16("CAN0_MD2", 0600, parent, (u16 *)0xFFC02A44);
		debugfs_create_x16("CAN0_OPSS1", 0600, parent, (u16 *)0xFFC02A30);
		debugfs_create_x16("CAN0_OPSS2", 0600, parent, (u16 *)0xFFC02A70);
		debugfs_create_x16("CAN0_RFH1", 0600, parent, (u16 *)0xFFC02A2C);
		debugfs_create_x16("CAN0_RFH2", 0600, parent, (u16 *)0xFFC02A6C);
		debugfs_create_x16("CAN0_RML1", 0600, parent, (u16 *)0xFFC02A1C);
		debugfs_create_x16("CAN0_RML2", 0600, parent, (u16 *)0xFFC02A5C);
		debugfs_create_x16("CAN0_RMP1", 0600, parent, (u16 *)0xFFC02A18);
		debugfs_create_x16("CAN0_RMP2", 0600, parent, (u16 *)0xFFC02A58);
		debugfs_create_x16("CAN0_STATUS", 0600, parent, (u16 *)0xFFC02A8C);
		debugfs_create_x16("CAN0_TA1", 0600, parent, (u16 *)0xFFC02A10);
		debugfs_create_x16("CAN0_TA2", 0600, parent, (u16 *)0xFFC02A50);
		debugfs_create_x16("CAN0_TIMING", 0600, parent, (u16 *)0xFFC02A84);
		debugfs_create_x16("CAN0_TRR1", 0600, parent, (u16 *)0xFFC02A0C);
		debugfs_create_x16("CAN0_TRR2", 0600, parent, (u16 *)0xFFC02A4C);
		debugfs_create_x16("CAN0_TRS1", 0600, parent, (u16 *)0xFFC02A08);
		debugfs_create_x16("CAN0_TRS2", 0600, parent, (u16 *)0xFFC02A48);
		debugfs_create_x16("CAN0_UCCNF", 0600, parent, (u16 *)0xFFC02ACC);
		debugfs_create_x16("CAN0_UCCNT", 0600, parent, (u16 *)0xFFC02AC4);
		debugfs_create_x16("CAN0_UCRC", 0600, parent, (u16 *)0xFFC02AC8);

		parent = debugfs_create_dir("CAN0 Mailbox RAM", top);
		debugfs_create_x16("CAN0_MB00_DATA0", 0600, parent, (u16 *)0xFFC02C00);
		debugfs_create_x16("CAN0_MB00_DATA1", 0600, parent, (u16 *)0xFFC02C04);
		debugfs_create_x16("CAN0_MB00_DATA2", 0600, parent, (u16 *)0xFFC02C08);
		debugfs_create_x16("CAN0_MB00_DATA3", 0600, parent, (u16 *)0xFFC02C0C);
		debugfs_create_x16("CAN0_MB00_ID0", 0600, parent, (u16 *)0xFFC02C18);
		debugfs_create_x16("CAN0_MB00_ID1", 0600, parent, (u16 *)0xFFC02C1C);
		debugfs_create_x16("CAN0_MB00_LENGTH", 0600, parent, (u16 *)0xFFC02C10);
		debugfs_create_x16("CAN0_MB00_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C14);
		debugfs_create_x16("CAN0_MB01_DATA0", 0600, parent, (u16 *)0xFFC02C20);
		debugfs_create_x16("CAN0_MB01_DATA1", 0600, parent, (u16 *)0xFFC02C24);
		debugfs_create_x16("CAN0_MB01_DATA2", 0600, parent, (u16 *)0xFFC02C28);
		debugfs_create_x16("CAN0_MB01_DATA3", 0600, parent, (u16 *)0xFFC02C2C);
		debugfs_create_x16("CAN0_MB01_ID0", 0600, parent, (u16 *)0xFFC02C38);
		debugfs_create_x16("CAN0_MB01_ID1", 0600, parent, (u16 *)0xFFC02C3C);
		debugfs_create_x16("CAN0_MB01_LENGTH", 0600, parent, (u16 *)0xFFC02C30);
		debugfs_create_x16("CAN0_MB01_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C34);
		debugfs_create_x16("CAN0_MB02_DATA0", 0600, parent, (u16 *)0xFFC02C40);
		debugfs_create_x16("CAN0_MB02_DATA1", 0600, parent, (u16 *)0xFFC02C44);
		debugfs_create_x16("CAN0_MB02_DATA2", 0600, parent, (u16 *)0xFFC02C48);
		debugfs_create_x16("CAN0_MB02_DATA3", 0600, parent, (u16 *)0xFFC02C4C);
		debugfs_create_x16("CAN0_MB02_ID0", 0600, parent, (u16 *)0xFFC02C58);
		debugfs_create_x16("CAN0_MB02_ID1", 0600, parent, (u16 *)0xFFC02C5C);
		debugfs_create_x16("CAN0_MB02_LENGTH", 0600, parent, (u16 *)0xFFC02C50);
		debugfs_create_x16("CAN0_MB02_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C54);
		debugfs_create_x16("CAN0_MB03_DATA0", 0600, parent, (u16 *)0xFFC02C60);
		debugfs_create_x16("CAN0_MB03_DATA1", 0600, parent, (u16 *)0xFFC02C64);
		debugfs_create_x16("CAN0_MB03_DATA2", 0600, parent, (u16 *)0xFFC02C68);
		debugfs_create_x16("CAN0_MB03_DATA3", 0600, parent, (u16 *)0xFFC02C6C);
		debugfs_create_x16("CAN0_MB03_ID0", 0600, parent, (u16 *)0xFFC02C78);
		debugfs_create_x16("CAN0_MB03_ID1", 0600, parent, (u16 *)0xFFC02C7C);
		debugfs_create_x16("CAN0_MB03_LENGTH", 0600, parent, (u16 *)0xFFC02C70);
		debugfs_create_x16("CAN0_MB03_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C74);
		debugfs_create_x16("CAN0_MB04_DATA0", 0600, parent, (u16 *)0xFFC02C80);
		debugfs_create_x16("CAN0_MB04_DATA1", 0600, parent, (u16 *)0xFFC02C84);
		debugfs_create_x16("CAN0_MB04_DATA2", 0600, parent, (u16 *)0xFFC02C88);
		debugfs_create_x16("CAN0_MB04_DATA3", 0600, parent, (u16 *)0xFFC02C8C);
		debugfs_create_x16("CAN0_MB04_ID0", 0600, parent, (u16 *)0xFFC02C98);
		debugfs_create_x16("CAN0_MB04_ID1", 0600, parent, (u16 *)0xFFC02C9C);
		debugfs_create_x16("CAN0_MB04_LENGTH", 0600, parent, (u16 *)0xFFC02C90);
		debugfs_create_x16("CAN0_MB04_TIMESTAMP", 0600, parent, (u16 *)0xFFC02C94);
		debugfs_create_x16("CAN0_MB05_DATA0", 0600, parent, (u16 *)0xFFC02CA0);
		debugfs_create_x16("CAN0_MB05_DATA1", 0600, parent, (u16 *)0xFFC02CA4);
		debugfs_create_x16("CAN0_MB05_DATA2", 0600, parent, (u16 *)0xFFC02CA8);
		debugfs_create_x16("CAN0_MB05_DATA3", 0600, parent, (u16 *)0xFFC02CAC);
		debugfs_create_x16("CAN0_MB05_ID0", 0600, parent, (u16 *)0xFFC02CB8);
		debugfs_create_x16("CAN0_MB05_ID1", 0600, parent, (u16 *)0xFFC02CBC);
		debugfs_create_x16("CAN0_MB05_LENGTH", 0600, parent, (u16 *)0xFFC02CB0);
		debugfs_create_x16("CAN0_MB05_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CB4);
		debugfs_create_x16("CAN0_MB06_DATA0", 0600, parent, (u16 *)0xFFC02CC0);
		debugfs_create_x16("CAN0_MB06_DATA1", 0600, parent, (u16 *)0xFFC02CC4);
		debugfs_create_x16("CAN0_MB06_DATA2", 0600, parent, (u16 *)0xFFC02CC8);
		debugfs_create_x16("CAN0_MB06_DATA3", 0600, parent, (u16 *)0xFFC02CCC);
		debugfs_create_x16("CAN0_MB06_ID0", 0600, parent, (u16 *)0xFFC02CD8);
		debugfs_create_x16("CAN0_MB06_ID1", 0600, parent, (u16 *)0xFFC02CDC);
		debugfs_create_x16("CAN0_MB06_LENGTH", 0600, parent, (u16 *)0xFFC02CD0);
		debugfs_create_x16("CAN0_MB06_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CD4);
		debugfs_create_x16("CAN0_MB07_DATA0", 0600, parent, (u16 *)0xFFC02CE0);
		debugfs_create_x16("CAN0_MB07_DATA1", 0600, parent, (u16 *)0xFFC02CE4);
		debugfs_create_x16("CAN0_MB07_DATA2", 0600, parent, (u16 *)0xFFC02CE8);
		debugfs_create_x16("CAN0_MB07_DATA3", 0600, parent, (u16 *)0xFFC02CEC);
		debugfs_create_x16("CAN0_MB07_ID0", 0600, parent, (u16 *)0xFFC02CF8);
		debugfs_create_x16("CAN0_MB07_ID1", 0600, parent, (u16 *)0xFFC02CFC);
		debugfs_create_x16("CAN0_MB07_LENGTH", 0600, parent, (u16 *)0xFFC02CF0);
		debugfs_create_x16("CAN0_MB07_TIMESTAMP", 0600, parent, (u16 *)0xFFC02CF4);
		debugfs_create_x16("CAN0_MB08_DATA0", 0600, parent, (u16 *)0xFFC02D00);
		debugfs_create_x16("CAN0_MB08_DATA1", 0600, parent, (u16 *)0xFFC02D04);
		debugfs_create_x16("CAN0_MB08_DATA2", 0600, parent, (u16 *)0xFFC02D08);
		debugfs_create_x16("CAN0_MB08_DATA3", 0600, parent, (u16 *)0xFFC02D0C);
		debugfs_create_x16("CAN0_MB08_ID0", 0600, parent, (u16 *)0xFFC02D18);
		debugfs_create_x16("CAN0_MB08_ID1", 0600, parent, (u16 *)0xFFC02D1C);
		debugfs_create_x16("CAN0_MB08_LENGTH", 0600, parent, (u16 *)0xFFC02D10);
		debugfs_create_x16("CAN0_MB08_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D14);
		debugfs_create_x16("CAN0_MB09_DATA0", 0600, parent, (u16 *)0xFFC02D20);
		debugfs_create_x16("CAN0_MB09_DATA1", 0600, parent, (u16 *)0xFFC02D24);
		debugfs_create_x16("CAN0_MB09_DATA2", 0600, parent, (u16 *)0xFFC02D28);
		debugfs_create_x16("CAN0_MB09_DATA3", 0600, parent, (u16 *)0xFFC02D2C);
		debugfs_create_x16("CAN0_MB09_ID0", 0600, parent, (u16 *)0xFFC02D38);
		debugfs_create_x16("CAN0_MB09_ID1", 0600, parent, (u16 *)0xFFC02D3C);
		debugfs_create_x16("CAN0_MB09_LENGTH", 0600, parent, (u16 *)0xFFC02D30);
		debugfs_create_x16("CAN0_MB09_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D34);
		debugfs_create_x16("CAN0_MB10_DATA0", 0600, parent, (u16 *)0xFFC02D40);
		debugfs_create_x16("CAN0_MB10_DATA1", 0600, parent, (u16 *)0xFFC02D44);
		debugfs_create_x16("CAN0_MB10_DATA2", 0600, parent, (u16 *)0xFFC02D48);
		debugfs_create_x16("CAN0_MB10_DATA3", 0600, parent, (u16 *)0xFFC02D4C);
		debugfs_create_x16("CAN0_MB10_ID0", 0600, parent, (u16 *)0xFFC02D58);
		debugfs_create_x16("CAN0_MB10_ID1", 0600, parent, (u16 *)0xFFC02D5C);
		debugfs_create_x16("CAN0_MB10_LENGTH", 0600, parent, (u16 *)0xFFC02D50);
		debugfs_create_x16("CAN0_MB10_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D54);
		debugfs_create_x16("CAN0_MB11_DATA0", 0600, parent, (u16 *)0xFFC02D60);
		debugfs_create_x16("CAN0_MB11_DATA1", 0600, parent, (u16 *)0xFFC02D64);
		debugfs_create_x16("CAN0_MB11_DATA2", 0600, parent, (u16 *)0xFFC02D68);
		debugfs_create_x16("CAN0_MB11_DATA3", 0600, parent, (u16 *)0xFFC02D6C);
		debugfs_create_x16("CAN0_MB11_ID0", 0600, parent, (u16 *)0xFFC02D78);
		debugfs_create_x16("CAN0_MB11_ID1", 0600, parent, (u16 *)0xFFC02D7C);
		debugfs_create_x16("CAN0_MB11_LENGTH", 0600, parent, (u16 *)0xFFC02D70);
		debugfs_create_x16("CAN0_MB11_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D74);
		debugfs_create_x16("CAN0_MB12_DATA0", 0600, parent, (u16 *)0xFFC02D80);
		debugfs_create_x16("CAN0_MB12_DATA1", 0600, parent, (u16 *)0xFFC02D84);
		debugfs_create_x16("CAN0_MB12_DATA2", 0600, parent, (u16 *)0xFFC02D88);
		debugfs_create_x16("CAN0_MB12_DATA3", 0600, parent, (u16 *)0xFFC02D8C);
		debugfs_create_x16("CAN0_MB12_ID0", 0600, parent, (u16 *)0xFFC02D98);
		debugfs_create_x16("CAN0_MB12_ID1", 0600, parent, (u16 *)0xFFC02D9C);
		debugfs_create_x16("CAN0_MB12_LENGTH", 0600, parent, (u16 *)0xFFC02D90);
		debugfs_create_x16("CAN0_MB12_TIMESTAMP", 0600, parent, (u16 *)0xFFC02D94);
		debugfs_create_x16("CAN0_MB13_DATA0", 0600, parent, (u16 *)0xFFC02DA0);
		debugfs_create_x16("CAN0_MB13_DATA1", 0600, parent, (u16 *)0xFFC02DA4);
		debugfs_create_x16("CAN0_MB13_DATA2", 0600, parent, (u16 *)0xFFC02DA8);
		debugfs_create_x16("CAN0_MB13_DATA3", 0600, parent, (u16 *)0xFFC02DAC);
		debugfs_create_x16("CAN0_MB13_ID0", 0600, parent, (u16 *)0xFFC02DB8);
		debugfs_create_x16("CAN0_MB13_ID1", 0600, parent, (u16 *)0xFFC02DBC);
		debugfs_create_x16("CAN0_MB13_LENGTH", 0600, parent, (u16 *)0xFFC02DB0);
		debugfs_create_x16("CAN0_MB13_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DB4);
		debugfs_create_x16("CAN0_MB14_DATA0", 0600, parent, (u16 *)0xFFC02DC0);
		debugfs_create_x16("CAN0_MB14_DATA1", 0600, parent, (u16 *)0xFFC02DC4);
		debugfs_create_x16("CAN0_MB14_DATA2", 0600, parent, (u16 *)0xFFC02DC8);
		debugfs_create_x16("CAN0_MB14_DATA3", 0600, parent, (u16 *)0xFFC02DCC);
		debugfs_create_x16("CAN0_MB14_ID0", 0600, parent, (u16 *)0xFFC02DD8);
		debugfs_create_x16("CAN0_MB14_ID1", 0600, parent, (u16 *)0xFFC02DDC);
		debugfs_create_x16("CAN0_MB14_LENGTH", 0600, parent, (u16 *)0xFFC02DD0);
		debugfs_create_x16("CAN0_MB14_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DD4);
		debugfs_create_x16("CAN0_MB15_DATA0", 0600, parent, (u16 *)0xFFC02DE0);
		debugfs_create_x16("CAN0_MB15_DATA1", 0600, parent, (u16 *)0xFFC02DE4);
		debugfs_create_x16("CAN0_MB15_DATA2", 0600, parent, (u16 *)0xFFC02DE8);
		debugfs_create_x16("CAN0_MB15_DATA3", 0600, parent, (u16 *)0xFFC02DEC);
		debugfs_create_x16("CAN0_MB15_ID0", 0600, parent, (u16 *)0xFFC02DF8);
		debugfs_create_x16("CAN0_MB15_ID1", 0600, parent, (u16 *)0xFFC02DFC);
		debugfs_create_x16("CAN0_MB15_LENGTH", 0600, parent, (u16 *)0xFFC02DF0);
		debugfs_create_x16("CAN0_MB15_TIMESTAMP", 0600, parent, (u16 *)0xFFC02DF4);
		debugfs_create_x16("CAN0_MB16_DATA0", 0600, parent, (u16 *)0xFFC02E00);
		debugfs_create_x16("CAN0_MB16_DATA1", 0600, parent, (u16 *)0xFFC02E04);
		debugfs_create_x16("CAN0_MB16_DATA2", 0600, parent, (u16 *)0xFFC02E08);
		debugfs_create_x16("CAN0_MB16_DATA3", 0600, parent, (u16 *)0xFFC02E0C);
		debugfs_create_x16("CAN0_MB16_ID0", 0600, parent, (u16 *)0xFFC02E18);
		debugfs_create_x16("CAN0_MB16_ID1", 0600, parent, (u16 *)0xFFC02E1C);
		debugfs_create_x16("CAN0_MB16_LENGTH", 0600, parent, (u16 *)0xFFC02E10);
		debugfs_create_x16("CAN0_MB16_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E14);
		debugfs_create_x16("CAN0_MB17_DATA0", 0600, parent, (u16 *)0xFFC02E20);
		debugfs_create_x16("CAN0_MB17_DATA1", 0600, parent, (u16 *)0xFFC02E24);
		debugfs_create_x16("CAN0_MB17_DATA2", 0600, parent, (u16 *)0xFFC02E28);
		debugfs_create_x16("CAN0_MB17_DATA3", 0600, parent, (u16 *)0xFFC02E2C);
		debugfs_create_x16("CAN0_MB17_ID0", 0600, parent, (u16 *)0xFFC02E38);
		debugfs_create_x16("CAN0_MB17_ID1", 0600, parent, (u16 *)0xFFC02E3C);
		debugfs_create_x16("CAN0_MB17_LENGTH", 0600, parent, (u16 *)0xFFC02E30);
		debugfs_create_x16("CAN0_MB17_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E34);
		debugfs_create_x16("CAN0_MB18_DATA0", 0600, parent, (u16 *)0xFFC02E40);
		debugfs_create_x16("CAN0_MB18_DATA1", 0600, parent, (u16 *)0xFFC02E44);
		debugfs_create_x16("CAN0_MB18_DATA2", 0600, parent, (u16 *)0xFFC02E48);
		debugfs_create_x16("CAN0_MB18_DATA3", 0600, parent, (u16 *)0xFFC02E4C);
		debugfs_create_x16("CAN0_MB18_ID0", 0600, parent, (u16 *)0xFFC02E58);
		debugfs_create_x16("CAN0_MB18_ID1", 0600, parent, (u16 *)0xFFC02E5C);
		debugfs_create_x16("CAN0_MB18_LENGTH", 0600, parent, (u16 *)0xFFC02E50);
		debugfs_create_x16("CAN0_MB18_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E54);
		debugfs_create_x16("CAN0_MB19_DATA0", 0600, parent, (u16 *)0xFFC02E60);
		debugfs_create_x16("CAN0_MB19_DATA1", 0600, parent, (u16 *)0xFFC02E64);
		debugfs_create_x16("CAN0_MB19_DATA2", 0600, parent, (u16 *)0xFFC02E68);
		debugfs_create_x16("CAN0_MB19_DATA3", 0600, parent, (u16 *)0xFFC02E6C);
		debugfs_create_x16("CAN0_MB19_ID0", 0600, parent, (u16 *)0xFFC02E78);
		debugfs_create_x16("CAN0_MB19_ID1", 0600, parent, (u16 *)0xFFC02E7C);
		debugfs_create_x16("CAN0_MB19_LENGTH", 0600, parent, (u16 *)0xFFC02E70);
		debugfs_create_x16("CAN0_MB19_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E74);
		debugfs_create_x16("CAN0_MB20_DATA0", 0600, parent, (u16 *)0xFFC02E80);
		debugfs_create_x16("CAN0_MB20_DATA1", 0600, parent, (u16 *)0xFFC02E84);
		debugfs_create_x16("CAN0_MB20_DATA2", 0600, parent, (u16 *)0xFFC02E88);
		debugfs_create_x16("CAN0_MB20_DATA3", 0600, parent, (u16 *)0xFFC02E8C);
		debugfs_create_x16("CAN0_MB20_ID0", 0600, parent, (u16 *)0xFFC02E98);
		debugfs_create_x16("CAN0_MB20_ID1", 0600, parent, (u16 *)0xFFC02E9C);
		debugfs_create_x16("CAN0_MB20_LENGTH", 0600, parent, (u16 *)0xFFC02E90);
		debugfs_create_x16("CAN0_MB20_TIMESTAMP", 0600, parent, (u16 *)0xFFC02E94);
		debugfs_create_x16("CAN0_MB21_DATA0", 0600, parent, (u16 *)0xFFC02EA0);
		debugfs_create_x16("CAN0_MB21_DATA1", 0600, parent, (u16 *)0xFFC02EA4);
		debugfs_create_x16("CAN0_MB21_DATA2", 0600, parent, (u16 *)0xFFC02EA8);
		debugfs_create_x16("CAN0_MB21_DATA3", 0600, parent, (u16 *)0xFFC02EAC);
		debugfs_create_x16("CAN0_MB21_ID0", 0600, parent, (u16 *)0xFFC02EB8);
		debugfs_create_x16("CAN0_MB21_ID1", 0600, parent, (u16 *)0xFFC02EBC);
		debugfs_create_x16("CAN0_MB21_LENGTH", 0600, parent, (u16 *)0xFFC02EB0);
		debugfs_create_x16("CAN0_MB21_TIMESTAMP", 0600, parent, (u16 *)0xFFC02EB4);
		debugfs_create_x16("CAN0_MB22_DATA0", 0600, parent, (u16 *)0xFFC02EC0);
		debugfs_create_x16("CAN0_MB22_DATA1", 0600, parent, (u16 *)0xFFC02EC4);
		debugfs_create_x16("CAN0_MB22_DATA2", 0600, parent, (u16 *)0xFFC02EC8);
		debugfs_create_x16("CAN0_MB22_DATA3", 0600, parent, (u16 *)0xFFC02ECC);
		debugfs_create_x16("CAN0_MB22_ID0", 0600, parent, (u16 *)0xFFC02ED8);
		debugfs_create_x16("CAN0_MB22_ID1", 0600, parent, (u16 *)0xFFC02EDC);
		debugfs_create_x16("CAN0_MB22_LENGTH", 0600, parent, (u16 *)0xFFC02ED0);
		debugfs_create_x16("CAN0_MB22_TIMESTAMP", 0600, parent, (u16 *)0xFFC02ED4);
		debugfs_create_x16("CAN0_MB23_DATA0", 0600, parent, (u16 *)0xFFC02EE0);
		debugfs_create_x16("CAN0_MB23_DATA1", 0600, parent, (u16 *)0xFFC02EE4);
		debugfs_create_x16("CAN0_MB23_DATA2", 0600, parent, (u16 *)0xFFC02EE8);
		debugfs_create_x16("CAN0_MB23_DATA3", 0600, parent, (u16 *)0xFFC02EEC);
		debugfs_create_x16("CAN0_MB23_ID0", 0600, parent, (u16 *)0xFFC02EF8);
		debugfs_create_x16("CAN0_MB23_ID1", 0600, parent, (u16 *)0xFFC02EFC);
		debugfs_create_x16("CAN0_MB23_LENGTH", 0600, parent, (u16 *)0xFFC02EF0);
		debugfs_create_x16("CAN0_MB23_TIMESTAMP", 0600, parent, (u16 *)0xFFC02EF4);
		debugfs_create_x16("CAN0_MB24_DATA0", 0600, parent, (u16 *)0xFFC02F00);
		debugfs_create_x16("CAN0_MB24_DATA1", 0600, parent, (u16 *)0xFFC02F04);
		debugfs_create_x16("CAN0_MB24_DATA2", 0600, parent, (u16 *)0xFFC02F08);
		debugfs_create_x16("CAN0_MB24_DATA3", 0600, parent, (u16 *)0xFFC02F0C);
		debugfs_create_x16("CAN0_MB24_ID0", 0600, parent, (u16 *)0xFFC02F18);
		debugfs_create_x16("CAN0_MB24_ID1", 0600, parent, (u16 *)0xFFC02F1C);
		debugfs_create_x16("CAN0_MB24_LENGTH", 0600, parent, (u16 *)0xFFC02F10);
		debugfs_create_x16("CAN0_MB24_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F14);
		debugfs_create_x16("CAN0_MB25_DATA0", 0600, parent, (u16 *)0xFFC02F20);
		debugfs_create_x16("CAN0_MB25_DATA1", 0600, parent, (u16 *)0xFFC02F24);
		debugfs_create_x16("CAN0_MB25_DATA2", 0600, parent, (u16 *)0xFFC02F28);
		debugfs_create_x16("CAN0_MB25_DATA3", 0600, parent, (u16 *)0xFFC02F2C);
		debugfs_create_x16("CAN0_MB25_ID0", 0600, parent, (u16 *)0xFFC02F38);
		debugfs_create_x16("CAN0_MB25_ID1", 0600, parent, (u16 *)0xFFC02F3C);
		debugfs_create_x16("CAN0_MB25_LENGTH", 0600, parent, (u16 *)0xFFC02F30);
		debugfs_create_x16("CAN0_MB25_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F34);
		debugfs_create_x16("CAN0_MB26_DATA0", 0600, parent, (u16 *)0xFFC02F40);
		debugfs_create_x16("CAN0_MB26_DATA1", 0600, parent, (u16 *)0xFFC02F44);
		debugfs_create_x16("CAN0_MB26_DATA2", 0600, parent, (u16 *)0xFFC02F48);
		debugfs_create_x16("CAN0_MB26_DATA3", 0600, parent, (u16 *)0xFFC02F4C);
		debugfs_create_x16("CAN0_MB26_ID0", 0600, parent, (u16 *)0xFFC02F58);
		debugfs_create_x16("CAN0_MB26_ID1", 0600, parent, (u16 *)0xFFC02F5C);
		debugfs_create_x16("CAN0_MB26_LENGTH", 0600, parent, (u16 *)0xFFC02F50);
		debugfs_create_x16("CAN0_MB26_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F54);
		debugfs_create_x16("CAN0_MB27_DATA0", 0600, parent, (u16 *)0xFFC02F60);
		debugfs_create_x16("CAN0_MB27_DATA1", 0600, parent, (u16 *)0xFFC02F64);
		debugfs_create_x16("CAN0_MB27_DATA2", 0600, parent, (u16 *)0xFFC02F68);
		debugfs_create_x16("CAN0_MB27_DATA3", 0600, parent, (u16 *)0xFFC02F6C);
		debugfs_create_x16("CAN0_MB27_ID0", 0600, parent, (u16 *)0xFFC02F78);
		debugfs_create_x16("CAN0_MB27_ID1", 0600, parent, (u16 *)0xFFC02F7C);
		debugfs_create_x16("CAN0_MB27_LENGTH", 0600, parent, (u16 *)0xFFC02F70);
		debugfs_create_x16("CAN0_MB27_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F74);
		debugfs_create_x16("CAN0_MB28_DATA0", 0600, parent, (u16 *)0xFFC02F80);
		debugfs_create_x16("CAN0_MB28_DATA1", 0600, parent, (u16 *)0xFFC02F84);
		debugfs_create_x16("CAN0_MB28_DATA2", 0600, parent, (u16 *)0xFFC02F88);
		debugfs_create_x16("CAN0_MB28_DATA3", 0600, parent, (u16 *)0xFFC02F8C);
		debugfs_create_x16("CAN0_MB28_ID0", 0600, parent, (u16 *)0xFFC02F98);
		debugfs_create_x16("CAN0_MB28_ID1", 0600, parent, (u16 *)0xFFC02F9C);
		debugfs_create_x16("CAN0_MB28_LENGTH", 0600, parent, (u16 *)0xFFC02F90);
		debugfs_create_x16("CAN0_MB28_TIMESTAMP", 0600, parent, (u16 *)0xFFC02F94);
		debugfs_create_x16("CAN0_MB29_DATA0", 0600, parent, (u16 *)0xFFC02FA0);
		debugfs_create_x16("CAN0_MB29_DATA1", 0600, parent, (u16 *)0xFFC02FA4);
		debugfs_create_x16("CAN0_MB29_DATA2", 0600, parent, (u16 *)0xFFC02FA8);
		debugfs_create_x16("CAN0_MB29_DATA3", 0600, parent, (u16 *)0xFFC02FAC);
		debugfs_create_x16("CAN0_MB29_ID0", 0600, parent, (u16 *)0xFFC02FB8);
		debugfs_create_x16("CAN0_MB29_ID1", 0600, parent, (u16 *)0xFFC02FBC);
		debugfs_create_x16("CAN0_MB29_LENGTH", 0600, parent, (u16 *)0xFFC02FB0);
		debugfs_create_x16("CAN0_MB29_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FB4);
		debugfs_create_x16("CAN0_MB30_DATA0", 0600, parent, (u16 *)0xFFC02FC0);
		debugfs_create_x16("CAN0_MB30_DATA1", 0600, parent, (u16 *)0xFFC02FC4);
		debugfs_create_x16("CAN0_MB30_DATA2", 0600, parent, (u16 *)0xFFC02FC8);
		debugfs_create_x16("CAN0_MB30_DATA3", 0600, parent, (u16 *)0xFFC02FCC);
		debugfs_create_x16("CAN0_MB30_ID0", 0600, parent, (u16 *)0xFFC02FD8);
		debugfs_create_x16("CAN0_MB30_ID1", 0600, parent, (u16 *)0xFFC02FDC);
		debugfs_create_x16("CAN0_MB30_LENGTH", 0600, parent, (u16 *)0xFFC02FD0);
		debugfs_create_x16("CAN0_MB30_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FD4);
		debugfs_create_x16("CAN0_MB31_DATA0", 0600, parent, (u16 *)0xFFC02FE0);
		debugfs_create_x16("CAN0_MB31_DATA1", 0600, parent, (u16 *)0xFFC02FE4);
		debugfs_create_x16("CAN0_MB31_DATA2", 0600, parent, (u16 *)0xFFC02FE8);
		debugfs_create_x16("CAN0_MB31_DATA3", 0600, parent, (u16 *)0xFFC02FEC);
		debugfs_create_x16("CAN0_MB31_ID0", 0600, parent, (u16 *)0xFFC02FF8);
		debugfs_create_x16("CAN0_MB31_ID1", 0600, parent, (u16 *)0xFFC02FFC);
		debugfs_create_x16("CAN0_MB31_LENGTH", 0600, parent, (u16 *)0xFFC02FF0);
		debugfs_create_x16("CAN0_MB31_TIMESTAMP", 0600, parent, (u16 *)0xFFC02FF4);

		parent = debugfs_create_dir("CAN1 Acceptance Mask RAM", top);
		debugfs_create_x16("CAN1_AM00H", 0600, parent, (u16 *)0xFFC03304);
		debugfs_create_x16("CAN1_AM00L", 0600, parent, (u16 *)0xFFC03300);
		debugfs_create_x16("CAN1_AM01H", 0600, parent, (u16 *)0xFFC0330C);
		debugfs_create_x16("CAN1_AM01L", 0600, parent, (u16 *)0xFFC03308);
		debugfs_create_x16("CAN1_AM02H", 0600, parent, (u16 *)0xFFC03314);
		debugfs_create_x16("CAN1_AM02L", 0600, parent, (u16 *)0xFFC03310);
		debugfs_create_x16("CAN1_AM03H", 0600, parent, (u16 *)0xFFC0331C);
		debugfs_create_x16("CAN1_AM03L", 0600, parent, (u16 *)0xFFC03318);
		debugfs_create_x16("CAN1_AM04H", 0600, parent, (u16 *)0xFFC03324);
		debugfs_create_x16("CAN1_AM04L", 0600, parent, (u16 *)0xFFC03320);
		debugfs_create_x16("CAN1_AM05H", 0600, parent, (u16 *)0xFFC0332C);
		debugfs_create_x16("CAN1_AM05L", 0600, parent, (u16 *)0xFFC03328);
		debugfs_create_x16("CAN1_AM06H", 0600, parent, (u16 *)0xFFC03334);
		debugfs_create_x16("CAN1_AM06L", 0600, parent, (u16 *)0xFFC03330);
		debugfs_create_x16("CAN1_AM07H", 0600, parent, (u16 *)0xFFC0333C);
		debugfs_create_x16("CAN1_AM07L", 0600, parent, (u16 *)0xFFC03338);
		debugfs_create_x16("CAN1_AM08H", 0600, parent, (u16 *)0xFFC03344);
		debugfs_create_x16("CAN1_AM08L", 0600, parent, (u16 *)0xFFC03340);
		debugfs_create_x16("CAN1_AM09H", 0600, parent, (u16 *)0xFFC0334C);
		debugfs_create_x16("CAN1_AM09L", 0600, parent, (u16 *)0xFFC03348);
		debugfs_create_x16("CAN1_AM10H", 0600, parent, (u16 *)0xFFC03354);
		debugfs_create_x16("CAN1_AM10L", 0600, parent, (u16 *)0xFFC03350);
		debugfs_create_x16("CAN1_AM11H", 0600, parent, (u16 *)0xFFC0335C);
		debugfs_create_x16("CAN1_AM11L", 0600, parent, (u16 *)0xFFC03358);
		debugfs_create_x16("CAN1_AM12H", 0600, parent, (u16 *)0xFFC03364);
		debugfs_create_x16("CAN1_AM12L", 0600, parent, (u16 *)0xFFC03360);
		debugfs_create_x16("CAN1_AM13H", 0600, parent, (u16 *)0xFFC0336C);
		debugfs_create_x16("CAN1_AM13L", 0600, parent, (u16 *)0xFFC03368);
		debugfs_create_x16("CAN1_AM14H", 0600, parent, (u16 *)0xFFC03374);
		debugfs_create_x16("CAN1_AM14L", 0600, parent, (u16 *)0xFFC03370);
		debugfs_create_x16("CAN1_AM15H", 0600, parent, (u16 *)0xFFC0337C);
		debugfs_create_x16("CAN1_AM15L", 0600, parent, (u16 *)0xFFC03378);
		debugfs_create_x16("CAN1_AM16H", 0600, parent, (u16 *)0xFFC03384);
		debugfs_create_x16("CAN1_AM16L", 0600, parent, (u16 *)0xFFC03380);
		debugfs_create_x16("CAN1_AM17H", 0600, parent, (u16 *)0xFFC0338C);
		debugfs_create_x16("CAN1_AM17L", 0600, parent, (u16 *)0xFFC03388);
		debugfs_create_x16("CAN1_AM18H", 0600, parent, (u16 *)0xFFC03394);
		debugfs_create_x16("CAN1_AM18L", 0600, parent, (u16 *)0xFFC03390);
		debugfs_create_x16("CAN1_AM19H", 0600, parent, (u16 *)0xFFC0339C);
		debugfs_create_x16("CAN1_AM19L", 0600, parent, (u16 *)0xFFC03398);
		debugfs_create_x16("CAN1_AM20H", 0600, parent, (u16 *)0xFFC033A4);
		debugfs_create_x16("CAN1_AM20L", 0600, parent, (u16 *)0xFFC033A0);
		debugfs_create_x16("CAN1_AM21H", 0600, parent, (u16 *)0xFFC033AC);
		debugfs_create_x16("CAN1_AM21L", 0600, parent, (u16 *)0xFFC033A8);
		debugfs_create_x16("CAN1_AM22H", 0600, parent, (u16 *)0xFFC033B4);
		debugfs_create_x16("CAN1_AM22L", 0600, parent, (u16 *)0xFFC033B0);
		debugfs_create_x16("CAN1_AM23H", 0600, parent, (u16 *)0xFFC033BC);
		debugfs_create_x16("CAN1_AM23L", 0600, parent, (u16 *)0xFFC033B8);
		debugfs_create_x16("CAN1_AM24H", 0600, parent, (u16 *)0xFFC033C4);
		debugfs_create_x16("CAN1_AM24L", 0600, parent, (u16 *)0xFFC033C0);
		debugfs_create_x16("CAN1_AM25H", 0600, parent, (u16 *)0xFFC033CC);
		debugfs_create_x16("CAN1_AM25L", 0600, parent, (u16 *)0xFFC033C8);
		debugfs_create_x16("CAN1_AM26H", 0600, parent, (u16 *)0xFFC033D4);
		debugfs_create_x16("CAN1_AM26L", 0600, parent, (u16 *)0xFFC033D0);
		debugfs_create_x16("CAN1_AM27H", 0600, parent, (u16 *)0xFFC033DC);
		debugfs_create_x16("CAN1_AM27L", 0600, parent, (u16 *)0xFFC033D8);
		debugfs_create_x16("CAN1_AM28H", 0600, parent, (u16 *)0xFFC033E4);
		debugfs_create_x16("CAN1_AM28L", 0600, parent, (u16 *)0xFFC033E0);
		debugfs_create_x16("CAN1_AM29H", 0600, parent, (u16 *)0xFFC033EC);
		debugfs_create_x16("CAN1_AM29L", 0600, parent, (u16 *)0xFFC033E8);
		debugfs_create_x16("CAN1_AM30H", 0600, parent, (u16 *)0xFFC033F4);
		debugfs_create_x16("CAN1_AM30L", 0600, parent, (u16 *)0xFFC033F0);
		debugfs_create_x16("CAN1_AM31H", 0600, parent, (u16 *)0xFFC033FC);
		debugfs_create_x16("CAN1_AM31L", 0600, parent, (u16 *)0xFFC033F8);

		parent = debugfs_create_dir("CAN1 Control and Status", top);
		debugfs_create_x16("CAN1_AA1", 0600, parent, (u16 *)0xFFC03214);
		debugfs_create_x16("CAN1_AA2", 0600, parent, (u16 *)0xFFC03254);
		debugfs_create_x16("CAN1_CEC", 0600, parent, (u16 *)0xFFC03290);
		debugfs_create_x16("CAN1_CLOCK", 0600, parent, (u16 *)0xFFC03280);
		debugfs_create_x16("CAN1_CONTROL", 0600, parent, (u16 *)0xFFC032A0);
		debugfs_create_x16("CAN1_DEBUG", 0600, parent, (u16 *)0xFFC03288);
		debugfs_create_x16("CAN1_ESR", 0600, parent, (u16 *)0xFFC032B4);
		debugfs_create_x16("CAN1_EWR", 0600, parent, (u16 *)0xFFC032B0);
		debugfs_create_x16("CAN1_GIF", 0600, parent, (u16 *)0xFFC0329C);
		debugfs_create_x16("CAN1_GIM", 0600, parent, (u16 *)0xFFC03298);
		debugfs_create_x16("CAN1_GIS", 0600, parent, (u16 *)0xFFC03294);
		debugfs_create_x16("CAN1_INTR", 0600, parent, (u16 *)0xFFC032A4);
		debugfs_create_x16("CAN1_MBIM1", 0600, parent, (u16 *)0xFFC03228);
		debugfs_create_x16("CAN1_MBIM2", 0600, parent, (u16 *)0xFFC03268);
		debugfs_create_x16("CAN1_MBRIF1", 0600, parent, (u16 *)0xFFC03224);
		debugfs_create_x16("CAN1_MBRIF2", 0600, parent, (u16 *)0xFFC03264);
		debugfs_create_x16("CAN1_MBTD", 0600, parent, (u16 *)0xFFC032AC);
		debugfs_create_x16("CAN1_MBTIF1", 0600, parent, (u16 *)0xFFC03220);
		debugfs_create_x16("CAN1_MBTIF2", 0600, parent, (u16 *)0xFFC03260);
		debugfs_create_x16("CAN1_MC1", 0600, parent, (u16 *)0xFFC03200);
		debugfs_create_x16("CAN1_MC2", 0600, parent, (u16 *)0xFFC03240);
		debugfs_create_x16("CAN1_MD1", 0600, parent, (u16 *)0xFFC03204);
		debugfs_create_x16("CAN1_MD2", 0600, parent, (u16 *)0xFFC03244);
		debugfs_create_x16("CAN1_OPSS1", 0600, parent, (u16 *)0xFFC03230);
		debugfs_create_x16("CAN1_OPSS2", 0600, parent, (u16 *)0xFFC03270);
		debugfs_create_x16("CAN1_RFH1", 0600, parent, (u16 *)0xFFC0322C);
		debugfs_create_x16("CAN1_RFH2", 0600, parent, (u16 *)0xFFC0326C);
		debugfs_create_x16("CAN1_RML1", 0600, parent, (u16 *)0xFFC0321C);
		debugfs_create_x16("CAN1_RML2", 0600, parent, (u16 *)0xFFC0325C);
		debugfs_create_x16("CAN1_RMP1", 0600, parent, (u16 *)0xFFC03218);
		debugfs_create_x16("CAN1_RMP2", 0600, parent, (u16 *)0xFFC03258);
		debugfs_create_x16("CAN1_STATUS", 0600, parent, (u16 *)0xFFC0328C);
		debugfs_create_x16("CAN1_TA1", 0600, parent, (u16 *)0xFFC03210);
		debugfs_create_x16("CAN1_TA2", 0600, parent, (u16 *)0xFFC03250);
		debugfs_create_x16("CAN1_TIMING", 0600, parent, (u16 *)0xFFC03284);
		debugfs_create_x16("CAN1_TRR1", 0600, parent, (u16 *)0xFFC0320C);
		debugfs_create_x16("CAN1_TRR2", 0600, parent, (u16 *)0xFFC0324C);
		debugfs_create_x16("CAN1_TRS1", 0600, parent, (u16 *)0xFFC03208);
		debugfs_create_x16("CAN1_TRS2", 0600, parent, (u16 *)0xFFC03248);
		debugfs_create_x16("CAN1_UCCNF", 0600, parent, (u16 *)0xFFC032CC);
		debugfs_create_x16("CAN1_UCCNT", 0600, parent, (u16 *)0xFFC032C4);
		debugfs_create_x16("CAN1_UCRC", 0600, parent, (u16 *)0xFFC032C8);

		parent = debugfs_create_dir("CAN1 Mailbox RAM", top);
		debugfs_create_x16("CAN1_MB00_DATA0", 0600, parent, (u16 *)0xFFC03400);
		debugfs_create_x16("CAN1_MB00_DATA1", 0600, parent, (u16 *)0xFFC03404);
		debugfs_create_x16("CAN1_MB00_DATA2", 0600, parent, (u16 *)0xFFC03408);
		debugfs_create_x16("CAN1_MB00_DATA3", 0600, parent, (u16 *)0xFFC0340C);
		debugfs_create_x16("CAN1_MB00_ID0", 0600, parent, (u16 *)0xFFC03418);
		debugfs_create_x16("CAN1_MB00_ID1", 0600, parent, (u16 *)0xFFC0341C);
		debugfs_create_x16("CAN1_MB00_LENGTH", 0600, parent, (u16 *)0xFFC03410);
		debugfs_create_x16("CAN1_MB00_TIMESTAMP", 0600, parent, (u16 *)0xFFC03414);
		debugfs_create_x16("CAN1_MB01_DATA0", 0600, parent, (u16 *)0xFFC03420);
		debugfs_create_x16("CAN1_MB01_DATA1", 0600, parent, (u16 *)0xFFC03424);
		debugfs_create_x16("CAN1_MB01_DATA2", 0600, parent, (u16 *)0xFFC03428);
		debugfs_create_x16("CAN1_MB01_DATA3", 0600, parent, (u16 *)0xFFC0342C);
		debugfs_create_x16("CAN1_MB01_ID0", 0600, parent, (u16 *)0xFFC03438);
		debugfs_create_x16("CAN1_MB01_ID1", 0600, parent, (u16 *)0xFFC0343C);
		debugfs_create_x16("CAN1_MB01_LENGTH", 0600, parent, (u16 *)0xFFC03430);
		debugfs_create_x16("CAN1_MB01_TIMESTAMP", 0600, parent, (u16 *)0xFFC03434);
		debugfs_create_x16("CAN1_MB02_DATA0", 0600, parent, (u16 *)0xFFC03440);
		debugfs_create_x16("CAN1_MB02_DATA1", 0600, parent, (u16 *)0xFFC03444);
		debugfs_create_x16("CAN1_MB02_DATA2", 0600, parent, (u16 *)0xFFC03448);
		debugfs_create_x16("CAN1_MB02_DATA3", 0600, parent, (u16 *)0xFFC0344C);
		debugfs_create_x16("CAN1_MB02_ID0", 0600, parent, (u16 *)0xFFC03458);
		debugfs_create_x16("CAN1_MB02_ID1", 0600, parent, (u16 *)0xFFC0345C);
		debugfs_create_x16("CAN1_MB02_LENGTH", 0600, parent, (u16 *)0xFFC03450);
		debugfs_create_x16("CAN1_MB02_TIMESTAMP", 0600, parent, (u16 *)0xFFC03454);
		debugfs_create_x16("CAN1_MB03_DATA0", 0600, parent, (u16 *)0xFFC03460);
		debugfs_create_x16("CAN1_MB03_DATA1", 0600, parent, (u16 *)0xFFC03464);
		debugfs_create_x16("CAN1_MB03_DATA2", 0600, parent, (u16 *)0xFFC03468);
		debugfs_create_x16("CAN1_MB03_DATA3", 0600, parent, (u16 *)0xFFC0346C);
		debugfs_create_x16("CAN1_MB03_ID0", 0600, parent, (u16 *)0xFFC03478);
		debugfs_create_x16("CAN1_MB03_ID1", 0600, parent, (u16 *)0xFFC0347C);
		debugfs_create_x16("CAN1_MB03_LENGTH", 0600, parent, (u16 *)0xFFC03470);
		debugfs_create_x16("CAN1_MB03_TIMESTAMP", 0600, parent, (u16 *)0xFFC03474);
		debugfs_create_x16("CAN1_MB04_DATA0", 0600, parent, (u16 *)0xFFC03480);
		debugfs_create_x16("CAN1_MB04_DATA1", 0600, parent, (u16 *)0xFFC03484);
		debugfs_create_x16("CAN1_MB04_DATA2", 0600, parent, (u16 *)0xFFC03488);
		debugfs_create_x16("CAN1_MB04_DATA3", 0600, parent, (u16 *)0xFFC0348C);
		debugfs_create_x16("CAN1_MB04_ID0", 0600, parent, (u16 *)0xFFC03498);
		debugfs_create_x16("CAN1_MB04_ID1", 0600, parent, (u16 *)0xFFC0349C);
		debugfs_create_x16("CAN1_MB04_LENGTH", 0600, parent, (u16 *)0xFFC03490);
		debugfs_create_x16("CAN1_MB04_TIMESTAMP", 0600, parent, (u16 *)0xFFC03494);
		debugfs_create_x16("CAN1_MB05_DATA0", 0600, parent, (u16 *)0xFFC034A0);
		debugfs_create_x16("CAN1_MB05_DATA1", 0600, parent, (u16 *)0xFFC034A4);
		debugfs_create_x16("CAN1_MB05_DATA2", 0600, parent, (u16 *)0xFFC034A8);
		debugfs_create_x16("CAN1_MB05_DATA3", 0600, parent, (u16 *)0xFFC034AC);
		debugfs_create_x16("CAN1_MB05_ID0", 0600, parent, (u16 *)0xFFC034B8);
		debugfs_create_x16("CAN1_MB05_ID1", 0600, parent, (u16 *)0xFFC034BC);
		debugfs_create_x16("CAN1_MB05_LENGTH", 0600, parent, (u16 *)0xFFC034B0);
		debugfs_create_x16("CAN1_MB05_TIMESTAMP", 0600, parent, (u16 *)0xFFC034B4);
		debugfs_create_x16("CAN1_MB06_DATA0", 0600, parent, (u16 *)0xFFC034C0);
		debugfs_create_x16("CAN1_MB06_DATA1", 0600, parent, (u16 *)0xFFC034C4);
		debugfs_create_x16("CAN1_MB06_DATA2", 0600, parent, (u16 *)0xFFC034C8);
		debugfs_create_x16("CAN1_MB06_DATA3", 0600, parent, (u16 *)0xFFC034CC);
		debugfs_create_x16("CAN1_MB06_ID0", 0600, parent, (u16 *)0xFFC034D8);
		debugfs_create_x16("CAN1_MB06_ID1", 0600, parent, (u16 *)0xFFC034DC);
		debugfs_create_x16("CAN1_MB06_LENGTH", 0600, parent, (u16 *)0xFFC034D0);
		debugfs_create_x16("CAN1_MB06_TIMESTAMP", 0600, parent, (u16 *)0xFFC034D4);
		debugfs_create_x16("CAN1_MB07_DATA0", 0600, parent, (u16 *)0xFFC034E0);
		debugfs_create_x16("CAN1_MB07_DATA1", 0600, parent, (u16 *)0xFFC034E4);
		debugfs_create_x16("CAN1_MB07_DATA2", 0600, parent, (u16 *)0xFFC034E8);
		debugfs_create_x16("CAN1_MB07_DATA3", 0600, parent, (u16 *)0xFFC034EC);
		debugfs_create_x16("CAN1_MB07_ID0", 0600, parent, (u16 *)0xFFC034F8);
		debugfs_create_x16("CAN1_MB07_ID1", 0600, parent, (u16 *)0xFFC034FC);
		debugfs_create_x16("CAN1_MB07_LENGTH", 0600, parent, (u16 *)0xFFC034F0);
		debugfs_create_x16("CAN1_MB07_TIMESTAMP", 0600, parent, (u16 *)0xFFC034F4);
		debugfs_create_x16("CAN1_MB08_DATA0", 0600, parent, (u16 *)0xFFC03500);
		debugfs_create_x16("CAN1_MB08_DATA1", 0600, parent, (u16 *)0xFFC03504);
		debugfs_create_x16("CAN1_MB08_DATA2", 0600, parent, (u16 *)0xFFC03508);
		debugfs_create_x16("CAN1_MB08_DATA3", 0600, parent, (u16 *)0xFFC0350C);
		debugfs_create_x16("CAN1_MB08_ID0", 0600, parent, (u16 *)0xFFC03518);
		debugfs_create_x16("CAN1_MB08_ID1", 0600, parent, (u16 *)0xFFC0351C);
		debugfs_create_x16("CAN1_MB08_LENGTH", 0600, parent, (u16 *)0xFFC03510);
		debugfs_create_x16("CAN1_MB08_TIMESTAMP", 0600, parent, (u16 *)0xFFC03514);
		debugfs_create_x16("CAN1_MB09_DATA0", 0600, parent, (u16 *)0xFFC03520);
		debugfs_create_x16("CAN1_MB09_DATA1", 0600, parent, (u16 *)0xFFC03524);
		debugfs_create_x16("CAN1_MB09_DATA2", 0600, parent, (u16 *)0xFFC03528);
		debugfs_create_x16("CAN1_MB09_DATA3", 0600, parent, (u16 *)0xFFC0352C);
		debugfs_create_x16("CAN1_MB09_ID0", 0600, parent, (u16 *)0xFFC03538);
		debugfs_create_x16("CAN1_MB09_ID1", 0600, parent, (u16 *)0xFFC0353C);
		debugfs_create_x16("CAN1_MB09_LENGTH", 0600, parent, (u16 *)0xFFC03530);
		debugfs_create_x16("CAN1_MB09_TIMESTAMP", 0600, parent, (u16 *)0xFFC03534);
		debugfs_create_x16("CAN1_MB10_DATA0", 0600, parent, (u16 *)0xFFC03540);
		debugfs_create_x16("CAN1_MB10_DATA1", 0600, parent, (u16 *)0xFFC03544);
		debugfs_create_x16("CAN1_MB10_DATA2", 0600, parent, (u16 *)0xFFC03548);
		debugfs_create_x16("CAN1_MB10_DATA3", 0600, parent, (u16 *)0xFFC0354C);
		debugfs_create_x16("CAN1_MB10_ID0", 0600, parent, (u16 *)0xFFC03558);
		debugfs_create_x16("CAN1_MB10_ID1", 0600, parent, (u16 *)0xFFC0355C);
		debugfs_create_x16("CAN1_MB10_LENGTH", 0600, parent, (u16 *)0xFFC03550);
		debugfs_create_x16("CAN1_MB10_TIMESTAMP", 0600, parent, (u16 *)0xFFC03554);
		debugfs_create_x16("CAN1_MB11_DATA0", 0600, parent, (u16 *)0xFFC03560);
		debugfs_create_x16("CAN1_MB11_DATA1", 0600, parent, (u16 *)0xFFC03564);
		debugfs_create_x16("CAN1_MB11_DATA2", 0600, parent, (u16 *)0xFFC03568);
		debugfs_create_x16("CAN1_MB11_DATA3", 0600, parent, (u16 *)0xFFC0356C);
		debugfs_create_x16("CAN1_MB11_ID0", 0600, parent, (u16 *)0xFFC03578);
		debugfs_create_x16("CAN1_MB11_ID1", 0600, parent, (u16 *)0xFFC0357C);
		debugfs_create_x16("CAN1_MB11_LENGTH", 0600, parent, (u16 *)0xFFC03570);
		debugfs_create_x16("CAN1_MB11_TIMESTAMP", 0600, parent, (u16 *)0xFFC03574);
		debugfs_create_x16("CAN1_MB12_DATA0", 0600, parent, (u16 *)0xFFC03580);
		debugfs_create_x16("CAN1_MB12_DATA1", 0600, parent, (u16 *)0xFFC03584);
		debugfs_create_x16("CAN1_MB12_DATA2", 0600, parent, (u16 *)0xFFC03588);
		debugfs_create_x16("CAN1_MB12_DATA3", 0600, parent, (u16 *)0xFFC0358C);
		debugfs_create_x16("CAN1_MB12_ID0", 0600, parent, (u16 *)0xFFC03598);
		debugfs_create_x16("CAN1_MB12_ID1", 0600, parent, (u16 *)0xFFC0359C);
		debugfs_create_x16("CAN1_MB12_LENGTH", 0600, parent, (u16 *)0xFFC03590);
		debugfs_create_x16("CAN1_MB12_TIMESTAMP", 0600, parent, (u16 *)0xFFC03594);
		debugfs_create_x16("CAN1_MB13_DATA0", 0600, parent, (u16 *)0xFFC035A0);
		debugfs_create_x16("CAN1_MB13_DATA1", 0600, parent, (u16 *)0xFFC035A4);
		debugfs_create_x16("CAN1_MB13_DATA2", 0600, parent, (u16 *)0xFFC035A8);
		debugfs_create_x16("CAN1_MB13_DATA3", 0600, parent, (u16 *)0xFFC035AC);
		debugfs_create_x16("CAN1_MB13_ID0", 0600, parent, (u16 *)0xFFC035B8);
		debugfs_create_x16("CAN1_MB13_ID1", 0600, parent, (u16 *)0xFFC035BC);
		debugfs_create_x16("CAN1_MB13_LENGTH", 0600, parent, (u16 *)0xFFC035B0);
		debugfs_create_x16("CAN1_MB13_TIMESTAMP", 0600, parent, (u16 *)0xFFC035B4);
		debugfs_create_x16("CAN1_MB14_DATA0", 0600, parent, (u16 *)0xFFC035C0);
		debugfs_create_x16("CAN1_MB14_DATA1", 0600, parent, (u16 *)0xFFC035C4);
		debugfs_create_x16("CAN1_MB14_DATA2", 0600, parent, (u16 *)0xFFC035C8);
		debugfs_create_x16("CAN1_MB14_DATA3", 0600, parent, (u16 *)0xFFC035CC);
		debugfs_create_x16("CAN1_MB14_ID0", 0600, parent, (u16 *)0xFFC035D8);
		debugfs_create_x16("CAN1_MB14_ID1", 0600, parent, (u16 *)0xFFC035DC);
		debugfs_create_x16("CAN1_MB14_LENGTH", 0600, parent, (u16 *)0xFFC035D0);
		debugfs_create_x16("CAN1_MB14_TIMESTAMP", 0600, parent, (u16 *)0xFFC035D4);
		debugfs_create_x16("CAN1_MB15_DATA0", 0600, parent, (u16 *)0xFFC035E0);
		debugfs_create_x16("CAN1_MB15_DATA1", 0600, parent, (u16 *)0xFFC035E4);
		debugfs_create_x16("CAN1_MB15_DATA2", 0600, parent, (u16 *)0xFFC035E8);
		debugfs_create_x16("CAN1_MB15_DATA3", 0600, parent, (u16 *)0xFFC035EC);
		debugfs_create_x16("CAN1_MB15_ID0", 0600, parent, (u16 *)0xFFC035F8);
		debugfs_create_x16("CAN1_MB15_ID1", 0600, parent, (u16 *)0xFFC035FC);
		debugfs_create_x16("CAN1_MB15_LENGTH", 0600, parent, (u16 *)0xFFC035F0);
		debugfs_create_x16("CAN1_MB15_TIMESTAMP", 0600, parent, (u16 *)0xFFC035F4);
		debugfs_create_x16("CAN1_MB16_DATA0", 0600, parent, (u16 *)0xFFC03600);
		debugfs_create_x16("CAN1_MB16_DATA1", 0600, parent, (u16 *)0xFFC03604);
		debugfs_create_x16("CAN1_MB16_DATA2", 0600, parent, (u16 *)0xFFC03608);
		debugfs_create_x16("CAN1_MB16_DATA3", 0600, parent, (u16 *)0xFFC0360C);
		debugfs_create_x16("CAN1_MB16_ID0", 0600, parent, (u16 *)0xFFC03618);
		debugfs_create_x16("CAN1_MB16_ID1", 0600, parent, (u16 *)0xFFC0361C);
		debugfs_create_x16("CAN1_MB16_LENGTH", 0600, parent, (u16 *)0xFFC03610);
		debugfs_create_x16("CAN1_MB16_TIMESTAMP", 0600, parent, (u16 *)0xFFC03614);
		debugfs_create_x16("CAN1_MB17_DATA0", 0600, parent, (u16 *)0xFFC03620);
		debugfs_create_x16("CAN1_MB17_DATA1", 0600, parent, (u16 *)0xFFC03624);
		debugfs_create_x16("CAN1_MB17_DATA2", 0600, parent, (u16 *)0xFFC03628);
		debugfs_create_x16("CAN1_MB17_DATA3", 0600, parent, (u16 *)0xFFC0362C);
		debugfs_create_x16("CAN1_MB17_ID0", 0600, parent, (u16 *)0xFFC03638);
		debugfs_create_x16("CAN1_MB17_ID1", 0600, parent, (u16 *)0xFFC0363C);
		debugfs_create_x16("CAN1_MB17_LENGTH", 0600, parent, (u16 *)0xFFC03630);
		debugfs_create_x16("CAN1_MB17_TIMESTAMP", 0600, parent, (u16 *)0xFFC03634);
		debugfs_create_x16("CAN1_MB18_DATA0", 0600, parent, (u16 *)0xFFC03640);
		debugfs_create_x16("CAN1_MB18_DATA1", 0600, parent, (u16 *)0xFFC03644);
		debugfs_create_x16("CAN1_MB18_DATA2", 0600, parent, (u16 *)0xFFC03648);
		debugfs_create_x16("CAN1_MB18_DATA3", 0600, parent, (u16 *)0xFFC0364C);
		debugfs_create_x16("CAN1_MB18_ID0", 0600, parent, (u16 *)0xFFC03658);
		debugfs_create_x16("CAN1_MB18_ID1", 0600, parent, (u16 *)0xFFC0365C);
		debugfs_create_x16("CAN1_MB18_LENGTH", 0600, parent, (u16 *)0xFFC03650);
		debugfs_create_x16("CAN1_MB18_TIMESTAMP", 0600, parent, (u16 *)0xFFC03654);
		debugfs_create_x16("CAN1_MB19_DATA0", 0600, parent, (u16 *)0xFFC03660);
		debugfs_create_x16("CAN1_MB19_DATA1", 0600, parent, (u16 *)0xFFC03664);
		debugfs_create_x16("CAN1_MB19_DATA2", 0600, parent, (u16 *)0xFFC03668);
		debugfs_create_x16("CAN1_MB19_DATA3", 0600, parent, (u16 *)0xFFC0366C);
		debugfs_create_x16("CAN1_MB19_ID0", 0600, parent, (u16 *)0xFFC03678);
		debugfs_create_x16("CAN1_MB19_ID1", 0600, parent, (u16 *)0xFFC0367C);
		debugfs_create_x16("CAN1_MB19_LENGTH", 0600, parent, (u16 *)0xFFC03670);
		debugfs_create_x16("CAN1_MB19_TIMESTAMP", 0600, parent, (u16 *)0xFFC03674);
		debugfs_create_x16("CAN1_MB20_DATA0", 0600, parent, (u16 *)0xFFC03680);
		debugfs_create_x16("CAN1_MB20_DATA1", 0600, parent, (u16 *)0xFFC03684);
		debugfs_create_x16("CAN1_MB20_DATA2", 0600, parent, (u16 *)0xFFC03688);
		debugfs_create_x16("CAN1_MB20_DATA3", 0600, parent, (u16 *)0xFFC0368C);
		debugfs_create_x16("CAN1_MB20_ID0", 0600, parent, (u16 *)0xFFC03698);
		debugfs_create_x16("CAN1_MB20_ID1", 0600, parent, (u16 *)0xFFC0369C);
		debugfs_create_x16("CAN1_MB20_LENGTH", 0600, parent, (u16 *)0xFFC03690);
		debugfs_create_x16("CAN1_MB20_TIMESTAMP", 0600, parent, (u16 *)0xFFC03694);
		debugfs_create_x16("CAN1_MB21_DATA0", 0600, parent, (u16 *)0xFFC036A0);
		debugfs_create_x16("CAN1_MB21_DATA1", 0600, parent, (u16 *)0xFFC036A4);
		debugfs_create_x16("CAN1_MB21_DATA2", 0600, parent, (u16 *)0xFFC036A8);
		debugfs_create_x16("CAN1_MB21_DATA3", 0600, parent, (u16 *)0xFFC036AC);
		debugfs_create_x16("CAN1_MB21_ID0", 0600, parent, (u16 *)0xFFC036B8);
		debugfs_create_x16("CAN1_MB21_ID1", 0600, parent, (u16 *)0xFFC036BC);
		debugfs_create_x16("CAN1_MB21_LENGTH", 0600, parent, (u16 *)0xFFC036B0);
		debugfs_create_x16("CAN1_MB21_TIMESTAMP", 0600, parent, (u16 *)0xFFC036B4);
		debugfs_create_x16("CAN1_MB22_DATA0", 0600, parent, (u16 *)0xFFC036C0);
		debugfs_create_x16("CAN1_MB22_DATA1", 0600, parent, (u16 *)0xFFC036C4);
		debugfs_create_x16("CAN1_MB22_DATA2", 0600, parent, (u16 *)0xFFC036C8);
		debugfs_create_x16("CAN1_MB22_DATA3", 0600, parent, (u16 *)0xFFC036CC);
		debugfs_create_x16("CAN1_MB22_ID0", 0600, parent, (u16 *)0xFFC036D8);
		debugfs_create_x16("CAN1_MB22_ID1", 0600, parent, (u16 *)0xFFC036DC);
		debugfs_create_x16("CAN1_MB22_LENGTH", 0600, parent, (u16 *)0xFFC036D0);
		debugfs_create_x16("CAN1_MB22_TIMESTAMP", 0600, parent, (u16 *)0xFFC036D4);
		debugfs_create_x16("CAN1_MB23_DATA0", 0600, parent, (u16 *)0xFFC036E0);
		debugfs_create_x16("CAN1_MB23_DATA1", 0600, parent, (u16 *)0xFFC036E4);
		debugfs_create_x16("CAN1_MB23_DATA2", 0600, parent, (u16 *)0xFFC036E8);
		debugfs_create_x16("CAN1_MB23_DATA3", 0600, parent, (u16 *)0xFFC036EC);
		debugfs_create_x16("CAN1_MB23_ID0", 0600, parent, (u16 *)0xFFC036F8);
		debugfs_create_x16("CAN1_MB23_ID1", 0600, parent, (u16 *)0xFFC036FC);
		debugfs_create_x16("CAN1_MB23_LENGTH", 0600, parent, (u16 *)0xFFC036F0);
		debugfs_create_x16("CAN1_MB23_TIMESTAMP", 0600, parent, (u16 *)0xFFC036F4);
		debugfs_create_x16("CAN1_MB24_DATA0", 0600, parent, (u16 *)0xFFC03700);
		debugfs_create_x16("CAN1_MB24_DATA1", 0600, parent, (u16 *)0xFFC03704);
		debugfs_create_x16("CAN1_MB24_DATA2", 0600, parent, (u16 *)0xFFC03708);
		debugfs_create_x16("CAN1_MB24_DATA3", 0600, parent, (u16 *)0xFFC0370C);
		debugfs_create_x16("CAN1_MB24_ID0", 0600, parent, (u16 *)0xFFC03718);
		debugfs_create_x16("CAN1_MB24_ID1", 0600, parent, (u16 *)0xFFC0371C);
		debugfs_create_x16("CAN1_MB24_LENGTH", 0600, parent, (u16 *)0xFFC03710);
		debugfs_create_x16("CAN1_MB24_TIMESTAMP", 0600, parent, (u16 *)0xFFC03714);
		debugfs_create_x16("CAN1_MB25_DATA0", 0600, parent, (u16 *)0xFFC03720);
		debugfs_create_x16("CAN1_MB25_DATA1", 0600, parent, (u16 *)0xFFC03724);
		debugfs_create_x16("CAN1_MB25_DATA2", 0600, parent, (u16 *)0xFFC03728);
		debugfs_create_x16("CAN1_MB25_DATA3", 0600, parent, (u16 *)0xFFC0372C);
		debugfs_create_x16("CAN1_MB25_ID0", 0600, parent, (u16 *)0xFFC03738);
		debugfs_create_x16("CAN1_MB25_ID1", 0600, parent, (u16 *)0xFFC0373C);
		debugfs_create_x16("CAN1_MB25_LENGTH", 0600, parent, (u16 *)0xFFC03730);
		debugfs_create_x16("CAN1_MB25_TIMESTAMP", 0600, parent, (u16 *)0xFFC03734);
		debugfs_create_x16("CAN1_MB26_DATA0", 0600, parent, (u16 *)0xFFC03740);
		debugfs_create_x16("CAN1_MB26_DATA1", 0600, parent, (u16 *)0xFFC03744);
		debugfs_create_x16("CAN1_MB26_DATA2", 0600, parent, (u16 *)0xFFC03748);
		debugfs_create_x16("CAN1_MB26_DATA3", 0600, parent, (u16 *)0xFFC0374C);
		debugfs_create_x16("CAN1_MB26_ID0", 0600, parent, (u16 *)0xFFC03758);
		debugfs_create_x16("CAN1_MB26_ID1", 0600, parent, (u16 *)0xFFC0375C);
		debugfs_create_x16("CAN1_MB26_LENGTH", 0600, parent, (u16 *)0xFFC03750);
		debugfs_create_x16("CAN1_MB26_TIMESTAMP", 0600, parent, (u16 *)0xFFC03754);
		debugfs_create_x16("CAN1_MB27_DATA0", 0600, parent, (u16 *)0xFFC03760);
		debugfs_create_x16("CAN1_MB27_DATA1", 0600, parent, (u16 *)0xFFC03764);
		debugfs_create_x16("CAN1_MB27_DATA2", 0600, parent, (u16 *)0xFFC03768);
		debugfs_create_x16("CAN1_MB27_DATA3", 0600, parent, (u16 *)0xFFC0376C);
		debugfs_create_x16("CAN1_MB27_ID0", 0600, parent, (u16 *)0xFFC03778);
		debugfs_create_x16("CAN1_MB27_ID1", 0600, parent, (u16 *)0xFFC0377C);
		debugfs_create_x16("CAN1_MB27_LENGTH", 0600, parent, (u16 *)0xFFC03770);
		debugfs_create_x16("CAN1_MB27_TIMESTAMP", 0600, parent, (u16 *)0xFFC03774);
		debugfs_create_x16("CAN1_MB28_DATA0", 0600, parent, (u16 *)0xFFC03780);
		debugfs_create_x16("CAN1_MB28_DATA1", 0600, parent, (u16 *)0xFFC03784);
		debugfs_create_x16("CAN1_MB28_DATA2", 0600, parent, (u16 *)0xFFC03788);
		debugfs_create_x16("CAN1_MB28_DATA3", 0600, parent, (u16 *)0xFFC0378C);
		debugfs_create_x16("CAN1_MB28_ID0", 0600, parent, (u16 *)0xFFC03798);
		debugfs_create_x16("CAN1_MB28_ID1", 0600, parent, (u16 *)0xFFC0379C);
		debugfs_create_x16("CAN1_MB28_LENGTH", 0600, parent, (u16 *)0xFFC03790);
		debugfs_create_x16("CAN1_MB28_TIMESTAMP", 0600, parent, (u16 *)0xFFC03794);
		debugfs_create_x16("CAN1_MB29_DATA0", 0600, parent, (u16 *)0xFFC037A0);
		debugfs_create_x16("CAN1_MB29_DATA1", 0600, parent, (u16 *)0xFFC037A4);
		debugfs_create_x16("CAN1_MB29_DATA2", 0600, parent, (u16 *)0xFFC037A8);
		debugfs_create_x16("CAN1_MB29_DATA3", 0600, parent, (u16 *)0xFFC037AC);
		debugfs_create_x16("CAN1_MB29_ID0", 0600, parent, (u16 *)0xFFC037B8);
		debugfs_create_x16("CAN1_MB29_ID1", 0600, parent, (u16 *)0xFFC037BC);
		debugfs_create_x16("CAN1_MB29_LENGTH", 0600, parent, (u16 *)0xFFC037B0);
		debugfs_create_x16("CAN1_MB29_TIMESTAMP", 0600, parent, (u16 *)0xFFC037B4);
		debugfs_create_x16("CAN1_MB30_DATA0", 0600, parent, (u16 *)0xFFC037C0);
		debugfs_create_x16("CAN1_MB30_DATA1", 0600, parent, (u16 *)0xFFC037C4);
		debugfs_create_x16("CAN1_MB30_DATA2", 0600, parent, (u16 *)0xFFC037C8);
		debugfs_create_x16("CAN1_MB30_DATA3", 0600, parent, (u16 *)0xFFC037CC);
		debugfs_create_x16("CAN1_MB30_ID0", 0600, parent, (u16 *)0xFFC037D8);
		debugfs_create_x16("CAN1_MB30_ID1", 0600, parent, (u16 *)0xFFC037DC);
		debugfs_create_x16("CAN1_MB30_LENGTH", 0600, parent, (u16 *)0xFFC037D0);
		debugfs_create_x16("CAN1_MB30_TIMESTAMP", 0600, parent, (u16 *)0xFFC037D4);
		debugfs_create_x16("CAN1_MB31_DATA0", 0600, parent, (u16 *)0xFFC037E0);
		debugfs_create_x16("CAN1_MB31_DATA1", 0600, parent, (u16 *)0xFFC037E4);
		debugfs_create_x16("CAN1_MB31_DATA2", 0600, parent, (u16 *)0xFFC037E8);
		debugfs_create_x16("CAN1_MB31_DATA3", 0600, parent, (u16 *)0xFFC037EC);
		debugfs_create_x16("CAN1_MB31_ID0", 0600, parent, (u16 *)0xFFC037F8);
		debugfs_create_x16("CAN1_MB31_ID1", 0600, parent, (u16 *)0xFFC037FC);
		debugfs_create_x16("CAN1_MB31_LENGTH", 0600, parent, (u16 *)0xFFC037F0);
		debugfs_create_x16("CAN1_MB31_TIMESTAMP", 0600, parent, (u16 *)0xFFC037F4);

		parent = debugfs_create_dir("CORE_TMR", top);
		debugfs_create_x32("TCNTL", 0600, parent, (u32 *)0xFFE03000);
		debugfs_create_x32("TCOUNT", 0600, parent, (u32 *)0xFFE0300C);
		debugfs_create_x32("TPERIOD", 0600, parent, (u32 *)0xFFE03004);
		debugfs_create_x32("TSCALE", 0600, parent, (u32 *)0xFFE03008);

		parent = debugfs_create_dir("Counter", top);
		debugfs_create_x16("CNT_COMMAND", 0600, parent, (u16 *)0xFFC0420C);
		debugfs_create_x16("CNT_CONFIG", 0600, parent, (u16 *)0xFFC04200);
		debugfs_create_x32("CNT_COUNTER", 0600, parent, (u32 *)0xFFC04214);
		debugfs_create_x16("CNT_DEBOUNCE", 0600, parent, (u16 *)0xFFC04210);
		debugfs_create_x16("CNT_IMASK", 0600, parent, (u16 *)0xFFC04204);
		debugfs_create_x32("CNT_MAX", 0600, parent, (u32 *)0xFFC04218);
		debugfs_create_x32("CNT_MIN", 0600, parent, (u32 *)0xFFC0421C);
		debugfs_create_x16("CNT_STATUS", 0600, parent, (u16 *)0xFFC04208);

		parent = debugfs_create_dir("DMA", top);
		debugfs_create_x16("DMA0_CONFIG", 0600, parent, (u16 *)0xFFC00C08);
		debugfs_create_x32("DMA0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C24);
		debugfs_create_x32("DMA0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C20);
		debugfs_create_x16("DMA0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C30);
		debugfs_create_x16("DMA0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C38);
		debugfs_create_x16("DMA0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C28);
		debugfs_create_x32("DMA0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C00);
		debugfs_create_x16("DMA0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C2C);
		debugfs_create_x32("DMA0_START_ADDR", 0600, parent, (u32 *)0xFFC00C04);
		debugfs_create_x16("DMA0_X_COUNT", 0600, parent, (u16 *)0xFFC00C10);
		debugfs_create_x16("DMA0_X_MODIFY", 0600, parent, (u16 *)0xFFC00C14);
		debugfs_create_x16("DMA0_Y_COUNT", 0600, parent, (u16 *)0xFFC00C18);
		debugfs_create_x16("DMA0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C1C);
		debugfs_create_x16("DMA10_CONFIG", 0600, parent, (u16 *)0xFFC00E88);
		debugfs_create_x32("DMA10_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EA4);
		debugfs_create_x32("DMA10_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EA0);
		debugfs_create_x16("DMA10_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EB0);
		debugfs_create_x16("DMA10_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EB8);
		debugfs_create_x16("DMA10_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EA8);
		debugfs_create_x32("DMA10_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E80);
		debugfs_create_x16("DMA10_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EAC);
		debugfs_create_x32("DMA10_START_ADDR", 0600, parent, (u32 *)0xFFC00E84);
		debugfs_create_x16("DMA10_X_COUNT", 0600, parent, (u16 *)0xFFC00E90);
		debugfs_create_x16("DMA10_X_MODIFY", 0600, parent, (u16 *)0xFFC00E94);
		debugfs_create_x16("DMA10_Y_COUNT", 0600, parent, (u16 *)0xFFC00E98);
		debugfs_create_x16("DMA10_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E9C);
		debugfs_create_x16("DMA11_CONFIG", 0600, parent, (u16 *)0xFFC00EC8);
		debugfs_create_x32("DMA11_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EE4);
		debugfs_create_x32("DMA11_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EE0);
		debugfs_create_x16("DMA11_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EF0);
		debugfs_create_x16("DMA11_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EF8);
		debugfs_create_x16("DMA11_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EE8);
		debugfs_create_x32("DMA11_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00EC0);
		debugfs_create_x16("DMA11_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EEC);
		debugfs_create_x32("DMA11_START_ADDR", 0600, parent, (u32 *)0xFFC00EC4);
		debugfs_create_x16("DMA11_X_COUNT", 0600, parent, (u16 *)0xFFC00ED0);
		debugfs_create_x16("DMA11_X_MODIFY", 0600, parent, (u16 *)0xFFC00ED4);
		debugfs_create_x16("DMA11_Y_COUNT", 0600, parent, (u16 *)0xFFC00ED8);
		debugfs_create_x16("DMA11_Y_MODIFY", 0600, parent, (u16 *)0xFFC00EDC);
		debugfs_create_x16("DMA12_CONFIG", 0600, parent, (u16 *)0xFFC01C08);
		debugfs_create_x32("DMA12_CURR_ADDR", 0600, parent, (u32 *)0xFFC01C24);
		debugfs_create_x32("DMA12_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01C20);
		debugfs_create_x16("DMA12_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01C30);
		debugfs_create_x16("DMA12_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01C38);
		debugfs_create_x16("DMA12_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01C28);
		debugfs_create_x32("DMA12_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01C00);
		debugfs_create_x16("DMA12_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01C2C);
		debugfs_create_x32("DMA12_START_ADDR", 0600, parent, (u32 *)0xFFC01C04);
		debugfs_create_x16("DMA12_X_COUNT", 0600, parent, (u16 *)0xFFC01C10);
		debugfs_create_x16("DMA12_X_MODIFY", 0600, parent, (u16 *)0xFFC01C14);
		debugfs_create_x16("DMA12_Y_COUNT", 0600, parent, (u16 *)0xFFC01C18);
		debugfs_create_x16("DMA12_Y_MODIFY", 0600, parent, (u16 *)0xFFC01C1C);
		debugfs_create_x16("DMA13_CONFIG", 0600, parent, (u16 *)0xFFC01C48);
		debugfs_create_x32("DMA13_CURR_ADDR", 0600, parent, (u32 *)0xFFC01C64);
		debugfs_create_x32("DMA13_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01C60);
		debugfs_create_x16("DMA13_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01C70);
		debugfs_create_x16("DMA13_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01C78);
		debugfs_create_x16("DMA13_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01C68);
		debugfs_create_x32("DMA13_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01C40);
		debugfs_create_x16("DMA13_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01C6C);
		debugfs_create_x32("DMA13_START_ADDR", 0600, parent, (u32 *)0xFFC01C44);
		debugfs_create_x16("DMA13_X_COUNT", 0600, parent, (u16 *)0xFFC01C50);
		debugfs_create_x16("DMA13_X_MODIFY", 0600, parent, (u16 *)0xFFC01C54);
		debugfs_create_x16("DMA13_Y_COUNT", 0600, parent, (u16 *)0xFFC01C58);
		debugfs_create_x16("DMA13_Y_MODIFY", 0600, parent, (u16 *)0xFFC01C5C);
		debugfs_create_x16("DMA14_CONFIG", 0600, parent, (u16 *)0xFFC01C88);
		debugfs_create_x32("DMA14_CURR_ADDR", 0600, parent, (u32 *)0xFFC01CA4);
		debugfs_create_x32("DMA14_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01CA0);
		debugfs_create_x16("DMA14_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01CB0);
		debugfs_create_x16("DMA14_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01CB8);
		debugfs_create_x16("DMA14_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01CA8);
		debugfs_create_x32("DMA14_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01C80);
		debugfs_create_x16("DMA14_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01CAC);
		debugfs_create_x32("DMA14_START_ADDR", 0600, parent, (u32 *)0xFFC01C84);
		debugfs_create_x16("DMA14_X_COUNT", 0600, parent, (u16 *)0xFFC01C90);
		debugfs_create_x16("DMA14_X_MODIFY", 0600, parent, (u16 *)0xFFC01C94);
		debugfs_create_x16("DMA14_Y_COUNT", 0600, parent, (u16 *)0xFFC01C98);
		debugfs_create_x16("DMA14_Y_MODIFY", 0600, parent, (u16 *)0xFFC01C9C);
		debugfs_create_x16("DMA15_CONFIG", 0600, parent, (u16 *)0xFFC01CC8);
		debugfs_create_x32("DMA15_CURR_ADDR", 0600, parent, (u32 *)0xFFC01CE4);
		debugfs_create_x32("DMA15_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01CE0);
		debugfs_create_x16("DMA15_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01CF0);
		debugfs_create_x16("DMA15_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01CF8);
		debugfs_create_x16("DMA15_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01CE8);
		debugfs_create_x32("DMA15_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01CC0);
		debugfs_create_x16("DMA15_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01CEC);
		debugfs_create_x32("DMA15_START_ADDR", 0600, parent, (u32 *)0xFFC01CC4);
		debugfs_create_x16("DMA15_X_COUNT", 0600, parent, (u16 *)0xFFC01CD0);
		debugfs_create_x16("DMA15_X_MODIFY", 0600, parent, (u16 *)0xFFC01CD4);
		debugfs_create_x16("DMA15_Y_COUNT", 0600, parent, (u16 *)0xFFC01CD8);
		debugfs_create_x16("DMA15_Y_MODIFY", 0600, parent, (u16 *)0xFFC01CDC);
		debugfs_create_x16("DMA16_CONFIG", 0600, parent, (u16 *)0xFFC01D08);
		debugfs_create_x32("DMA16_CURR_ADDR", 0600, parent, (u32 *)0xFFC01D24);
		debugfs_create_x32("DMA16_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01D20);
		debugfs_create_x16("DMA16_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01D30);
		debugfs_create_x16("DMA16_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01D38);
		debugfs_create_x16("DMA16_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01D28);
		debugfs_create_x32("DMA16_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01D00);
		debugfs_create_x16("DMA16_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01D2C);
		debugfs_create_x32("DMA16_START_ADDR", 0600, parent, (u32 *)0xFFC01D04);
		debugfs_create_x16("DMA16_X_COUNT", 0600, parent, (u16 *)0xFFC01D10);
		debugfs_create_x16("DMA16_X_MODIFY", 0600, parent, (u16 *)0xFFC01D14);
		debugfs_create_x16("DMA16_Y_COUNT", 0600, parent, (u16 *)0xFFC01D18);
		debugfs_create_x16("DMA16_Y_MODIFY", 0600, parent, (u16 *)0xFFC01D1C);
		debugfs_create_x16("DMA17_CONFIG", 0600, parent, (u16 *)0xFFC01D48);
		debugfs_create_x32("DMA17_CURR_ADDR", 0600, parent, (u32 *)0xFFC01D64);
		debugfs_create_x32("DMA17_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01D60);
		debugfs_create_x16("DMA17_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01D70);
		debugfs_create_x16("DMA17_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01D78);
		debugfs_create_x16("DMA17_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01D68);
		debugfs_create_x32("DMA17_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01D40);
		debugfs_create_x16("DMA17_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01D6C);
		debugfs_create_x32("DMA17_START_ADDR", 0600, parent, (u32 *)0xFFC01D44);
		debugfs_create_x16("DMA17_X_COUNT", 0600, parent, (u16 *)0xFFC01D50);
		debugfs_create_x16("DMA17_X_MODIFY", 0600, parent, (u16 *)0xFFC01D54);
		debugfs_create_x16("DMA17_Y_COUNT", 0600, parent, (u16 *)0xFFC01D58);
		debugfs_create_x16("DMA17_Y_MODIFY", 0600, parent, (u16 *)0xFFC01D5C);
		debugfs_create_x16("DMA18_CONFIG", 0600, parent, (u16 *)0xFFC01D88);
		debugfs_create_x32("DMA18_CURR_ADDR", 0600, parent, (u32 *)0xFFC01DA4);
		debugfs_create_x32("DMA18_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01DA0);
		debugfs_create_x16("DMA18_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01DB0);
		debugfs_create_x16("DMA18_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01DB8);
		debugfs_create_x16("DMA18_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01DA8);
		debugfs_create_x32("DMA18_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01D80);
		debugfs_create_x16("DMA18_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01DAC);
		debugfs_create_x32("DMA18_START_ADDR", 0600, parent, (u32 *)0xFFC01D84);
		debugfs_create_x16("DMA18_X_COUNT", 0600, parent, (u16 *)0xFFC01D90);
		debugfs_create_x16("DMA18_X_MODIFY", 0600, parent, (u16 *)0xFFC01D94);
		debugfs_create_x16("DMA18_Y_COUNT", 0600, parent, (u16 *)0xFFC01D98);
		debugfs_create_x16("DMA18_Y_MODIFY", 0600, parent, (u16 *)0xFFC01D9C);
		debugfs_create_x16("DMA19_CONFIG", 0600, parent, (u16 *)0xFFC01DC8);
		debugfs_create_x32("DMA19_CURR_ADDR", 0600, parent, (u32 *)0xFFC01DE4);
		debugfs_create_x32("DMA19_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01DE0);
		debugfs_create_x16("DMA19_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01DF0);
		debugfs_create_x16("DMA19_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01DF8);
		debugfs_create_x16("DMA19_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01DE8);
		debugfs_create_x32("DMA19_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01DC0);
		debugfs_create_x16("DMA19_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01DEC);
		debugfs_create_x32("DMA19_START_ADDR", 0600, parent, (u32 *)0xFFC01DC4);
		debugfs_create_x16("DMA19_X_COUNT", 0600, parent, (u16 *)0xFFC01DD0);
		debugfs_create_x16("DMA19_X_MODIFY", 0600, parent, (u16 *)0xFFC01DD4);
		debugfs_create_x16("DMA19_Y_COUNT", 0600, parent, (u16 *)0xFFC01DD8);
		debugfs_create_x16("DMA19_Y_MODIFY", 0600, parent, (u16 *)0xFFC01DDC);
		debugfs_create_x16("DMA1_CONFIG", 0600, parent, (u16 *)0xFFC00C48);
		debugfs_create_x32("DMA1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C64);
		debugfs_create_x32("DMA1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C60);
		debugfs_create_x16("DMA1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C70);
		debugfs_create_x16("DMA1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C78);
		debugfs_create_x16("DMA1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C68);
		debugfs_create_x32("DMA1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C40);
		debugfs_create_x16("DMA1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C6C);
		debugfs_create_x32("DMA1_START_ADDR", 0600, parent, (u32 *)0xFFC00C44);
		debugfs_create_x16("DMA1_X_COUNT", 0600, parent, (u16 *)0xFFC00C50);
		debugfs_create_x16("DMA1_X_MODIFY", 0600, parent, (u16 *)0xFFC00C54);
		debugfs_create_x16("DMA1_Y_COUNT", 0600, parent, (u16 *)0xFFC00C58);
		debugfs_create_x16("DMA1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C5C);
		debugfs_create_x16("DMA20_CONFIG", 0600, parent, (u16 *)0xFFC01E08);
		debugfs_create_x32("DMA20_CURR_ADDR", 0600, parent, (u32 *)0xFFC01E24);
		debugfs_create_x32("DMA20_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01E20);
		debugfs_create_x16("DMA20_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01E30);
		debugfs_create_x16("DMA20_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01E38);
		debugfs_create_x16("DMA20_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01E28);
		debugfs_create_x32("DMA20_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01E00);
		debugfs_create_x16("DMA20_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01E2C);
		debugfs_create_x32("DMA20_START_ADDR", 0600, parent, (u32 *)0xFFC01E04);
		debugfs_create_x16("DMA20_X_COUNT", 0600, parent, (u16 *)0xFFC01E10);
		debugfs_create_x16("DMA20_X_MODIFY", 0600, parent, (u16 *)0xFFC01E14);
		debugfs_create_x16("DMA20_Y_COUNT", 0600, parent, (u16 *)0xFFC01E18);
		debugfs_create_x16("DMA20_Y_MODIFY", 0600, parent, (u16 *)0xFFC01E1C);
		debugfs_create_x16("DMA21_CONFIG", 0600, parent, (u16 *)0xFFC01E48);
		debugfs_create_x32("DMA21_CURR_ADDR", 0600, parent, (u32 *)0xFFC01E64);
		debugfs_create_x32("DMA21_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01E60);
		debugfs_create_x16("DMA21_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01E70);
		debugfs_create_x16("DMA21_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01E78);
		debugfs_create_x16("DMA21_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01E68);
		debugfs_create_x32("DMA21_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01E40);
		debugfs_create_x16("DMA21_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01E6C);
		debugfs_create_x32("DMA21_START_ADDR", 0600, parent, (u32 *)0xFFC01E44);
		debugfs_create_x16("DMA21_X_COUNT", 0600, parent, (u16 *)0xFFC01E50);
		debugfs_create_x16("DMA21_X_MODIFY", 0600, parent, (u16 *)0xFFC01E54);
		debugfs_create_x16("DMA21_Y_COUNT", 0600, parent, (u16 *)0xFFC01E58);
		debugfs_create_x16("DMA21_Y_MODIFY", 0600, parent, (u16 *)0xFFC01E5C);
		debugfs_create_x16("DMA22_CONFIG", 0600, parent, (u16 *)0xFFC01E88);
		debugfs_create_x32("DMA22_CURR_ADDR", 0600, parent, (u32 *)0xFFC01EA4);
		debugfs_create_x32("DMA22_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01EA0);
		debugfs_create_x16("DMA22_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01EB0);
		debugfs_create_x16("DMA22_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01EB8);
		debugfs_create_x16("DMA22_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01EA8);
		debugfs_create_x32("DMA22_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01E80);
		debugfs_create_x16("DMA22_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01EAC);
		debugfs_create_x32("DMA22_START_ADDR", 0600, parent, (u32 *)0xFFC01E84);
		debugfs_create_x16("DMA22_X_COUNT", 0600, parent, (u16 *)0xFFC01E90);
		debugfs_create_x16("DMA22_X_MODIFY", 0600, parent, (u16 *)0xFFC01E94);
		debugfs_create_x16("DMA22_Y_COUNT", 0600, parent, (u16 *)0xFFC01E98);
		debugfs_create_x16("DMA22_Y_MODIFY", 0600, parent, (u16 *)0xFFC01E9C);
		debugfs_create_x16("DMA23_CONFIG", 0600, parent, (u16 *)0xFFC01EC8);
		debugfs_create_x32("DMA23_CURR_ADDR", 0600, parent, (u32 *)0xFFC01EE4);
		debugfs_create_x32("DMA23_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01EE0);
		debugfs_create_x16("DMA23_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01EF0);
		debugfs_create_x16("DMA23_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01EF8);
		debugfs_create_x16("DMA23_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01EE8);
		debugfs_create_x32("DMA23_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01EC0);
		debugfs_create_x16("DMA23_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01EEC);
		debugfs_create_x32("DMA23_START_ADDR", 0600, parent, (u32 *)0xFFC01EC4);
		debugfs_create_x16("DMA23_X_COUNT", 0600, parent, (u16 *)0xFFC01ED0);
		debugfs_create_x16("DMA23_X_MODIFY", 0600, parent, (u16 *)0xFFC01ED4);
		debugfs_create_x16("DMA23_Y_COUNT", 0600, parent, (u16 *)0xFFC01ED8);
		debugfs_create_x16("DMA23_Y_MODIFY", 0600, parent, (u16 *)0xFFC01EDC);
		debugfs_create_x16("DMA2_CONFIG", 0600, parent, (u16 *)0xFFC00C88);
		debugfs_create_x32("DMA2_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CA4);
		debugfs_create_x32("DMA2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CA0);
		debugfs_create_x16("DMA2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CB0);
		debugfs_create_x16("DMA2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CB8);
		debugfs_create_x16("DMA2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CA8);
		debugfs_create_x32("DMA2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C80);
		debugfs_create_x16("DMA2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CAC);
		debugfs_create_x32("DMA2_START_ADDR", 0600, parent, (u32 *)0xFFC00C84);
		debugfs_create_x16("DMA2_X_COUNT", 0600, parent, (u16 *)0xFFC00C90);
		debugfs_create_x16("DMA2_X_MODIFY", 0600, parent, (u16 *)0xFFC00C94);
		debugfs_create_x16("DMA2_Y_COUNT", 0600, parent, (u16 *)0xFFC00C98);
		debugfs_create_x16("DMA2_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C9C);
		debugfs_create_x16("DMA3_CONFIG", 0600, parent, (u16 *)0xFFC00CC8);
		debugfs_create_x32("DMA3_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CE4);
		debugfs_create_x32("DMA3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CE0);
		debugfs_create_x16("DMA3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CF0);
		debugfs_create_x16("DMA3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CF8);
		debugfs_create_x16("DMA3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CE8);
		debugfs_create_x32("DMA3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00CC0);
		debugfs_create_x16("DMA3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CEC);
		debugfs_create_x32("DMA3_START_ADDR", 0600, parent, (u32 *)0xFFC00CC4);
		debugfs_create_x16("DMA3_X_COUNT", 0600, parent, (u16 *)0xFFC00CD0);
		debugfs_create_x16("DMA3_X_MODIFY", 0600, parent, (u16 *)0xFFC00CD4);
		debugfs_create_x16("DMA3_Y_COUNT", 0600, parent, (u16 *)0xFFC00CD8);
		debugfs_create_x16("DMA3_Y_MODIFY", 0600, parent, (u16 *)0xFFC00CDC);
		debugfs_create_x16("DMA4_CONFIG", 0600, parent, (u16 *)0xFFC00D08);
		debugfs_create_x32("DMA4_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D24);
		debugfs_create_x32("DMA4_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D20);
		debugfs_create_x16("DMA4_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D30);
		debugfs_create_x16("DMA4_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D38);
		debugfs_create_x16("DMA4_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D28);
		debugfs_create_x32("DMA4_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D00);
		debugfs_create_x16("DMA4_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D2C);
		debugfs_create_x32("DMA4_START_ADDR", 0600, parent, (u32 *)0xFFC00D04);
		debugfs_create_x16("DMA4_X_COUNT", 0600, parent, (u16 *)0xFFC00D10);
		debugfs_create_x16("DMA4_X_MODIFY", 0600, parent, (u16 *)0xFFC00D14);
		debugfs_create_x16("DMA4_Y_COUNT", 0600, parent, (u16 *)0xFFC00D18);
		debugfs_create_x16("DMA4_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D1C);
		debugfs_create_x16("DMA5_CONFIG", 0600, parent, (u16 *)0xFFC00D48);
		debugfs_create_x32("DMA5_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D64);
		debugfs_create_x32("DMA5_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D60);
		debugfs_create_x16("DMA5_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D70);
		debugfs_create_x16("DMA5_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D78);
		debugfs_create_x16("DMA5_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D68);
		debugfs_create_x32("DMA5_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D40);
		debugfs_create_x16("DMA5_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D6C);
		debugfs_create_x32("DMA5_START_ADDR", 0600, parent, (u32 *)0xFFC00D44);
		debugfs_create_x16("DMA5_X_COUNT", 0600, parent, (u16 *)0xFFC00D50);
		debugfs_create_x16("DMA5_X_MODIFY", 0600, parent, (u16 *)0xFFC00D54);
		debugfs_create_x16("DMA5_Y_COUNT", 0600, parent, (u16 *)0xFFC00D58);
		debugfs_create_x16("DMA5_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D5C);
		debugfs_create_x16("DMA6_CONFIG", 0600, parent, (u16 *)0xFFC00D88);
		debugfs_create_x32("DMA6_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DA4);
		debugfs_create_x32("DMA6_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DA0);
		debugfs_create_x16("DMA6_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DB0);
		debugfs_create_x16("DMA6_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DB8);
		debugfs_create_x16("DMA6_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DA8);
		debugfs_create_x32("DMA6_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D80);
		debugfs_create_x16("DMA6_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DAC);
		debugfs_create_x32("DMA6_START_ADDR", 0600, parent, (u32 *)0xFFC00D84);
		debugfs_create_x16("DMA6_X_COUNT", 0600, parent, (u16 *)0xFFC00D90);
		debugfs_create_x16("DMA6_X_MODIFY", 0600, parent, (u16 *)0xFFC00D94);
		debugfs_create_x16("DMA6_Y_COUNT", 0600, parent, (u16 *)0xFFC00D98);
		debugfs_create_x16("DMA6_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D9C);
		debugfs_create_x16("DMA7_CONFIG", 0600, parent, (u16 *)0xFFC00DC8);
		debugfs_create_x32("DMA7_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DE4);
		debugfs_create_x32("DMA7_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DE0);
		debugfs_create_x16("DMA7_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DF0);
		debugfs_create_x16("DMA7_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DF8);
		debugfs_create_x16("DMA7_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DE8);
		debugfs_create_x32("DMA7_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00DC0);
		debugfs_create_x16("DMA7_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DEC);
		debugfs_create_x32("DMA7_START_ADDR", 0600, parent, (u32 *)0xFFC00DC4);
		debugfs_create_x16("DMA7_X_COUNT", 0600, parent, (u16 *)0xFFC00DD0);
		debugfs_create_x16("DMA7_X_MODIFY", 0600, parent, (u16 *)0xFFC00DD4);
		debugfs_create_x16("DMA7_Y_COUNT", 0600, parent, (u16 *)0xFFC00DD8);
		debugfs_create_x16("DMA7_Y_MODIFY", 0600, parent, (u16 *)0xFFC00DDC);
		debugfs_create_x16("DMA8_CONFIG", 0600, parent, (u16 *)0xFFC00E08);
		debugfs_create_x32("DMA8_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E24);
		debugfs_create_x32("DMA8_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E20);
		debugfs_create_x16("DMA8_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E30);
		debugfs_create_x16("DMA8_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E38);
		debugfs_create_x16("DMA8_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E28);
		debugfs_create_x32("DMA8_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E00);
		debugfs_create_x16("DMA8_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E2C);
		debugfs_create_x32("DMA8_START_ADDR", 0600, parent, (u32 *)0xFFC00E04);
		debugfs_create_x16("DMA8_X_COUNT", 0600, parent, (u16 *)0xFFC00E10);
		debugfs_create_x16("DMA8_X_MODIFY", 0600, parent, (u16 *)0xFFC00E14);
		debugfs_create_x16("DMA8_Y_COUNT", 0600, parent, (u16 *)0xFFC00E18);
		debugfs_create_x16("DMA8_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E1C);
		debugfs_create_x16("DMA9_CONFIG", 0600, parent, (u16 *)0xFFC00E48);
		debugfs_create_x32("DMA9_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E64);
		debugfs_create_x32("DMA9_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E60);
		debugfs_create_x16("DMA9_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E70);
		debugfs_create_x16("DMA9_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E78);
		debugfs_create_x16("DMA9_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E68);
		debugfs_create_x32("DMA9_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E40);
		debugfs_create_x16("DMA9_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E6C);
		debugfs_create_x32("DMA9_START_ADDR", 0600, parent, (u32 *)0xFFC00E44);
		debugfs_create_x16("DMA9_X_COUNT", 0600, parent, (u16 *)0xFFC00E50);
		debugfs_create_x16("DMA9_X_MODIFY", 0600, parent, (u16 *)0xFFC00E54);
		debugfs_create_x16("DMA9_Y_COUNT", 0600, parent, (u16 *)0xFFC00E58);
		debugfs_create_x16("DMA9_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E5C);
		debugfs_create_x16("DMAC0_TCCNT", 0600, parent, (u16 *)0xFFC00B10);
		debugfs_create_x16("DMAC0_TCPER", 0600, parent, (u16 *)0xFFC00B0C);
		debugfs_create_x16("DMAC1_PERIMUX", 0600, parent, (u16 *)0xFFC04340);
		debugfs_create_x16("DMAC1_TCCNT", 0600, parent, (u16 *)0xFFC01B10);
		debugfs_create_x16("DMAC1_TCPER", 0600, parent, (u16 *)0xFFC01B0C);

		parent = debugfs_create_dir("EBIU", top);
		debugfs_create_x32("EBIU_AMBCTL0", 0600, parent, (u32 *)0xFFC00A04);
		debugfs_create_x32("EBIU_AMBCTL1", 0600, parent, (u32 *)0xFFC00A08);
		debugfs_create_x16("EBIU_AMGCTL", 0600, parent, (u16 *)0xFFC00A00);
		debugfs_create_x32("EBIU_ARBSTAT", 0600, parent, (u32 *)0xFFC00A10);
		debugfs_create_x32("EBIU_DDRACCT", 0600, parent, (u32 *)0xFFC00AA0);
		debugfs_create_x32("EBIU_DDRARCT", 0600, parent, (u32 *)0xFFC00AAC);
		debugfs_create_x32("EBIU_DDRBRC0", 0600, parent, (u32 *)0xFFC00A60);
		debugfs_create_x32("EBIU_DDRBRC1", 0600, parent, (u32 *)0xFFC00A64);
		debugfs_create_x32("EBIU_DDRBRC2", 0600, parent, (u32 *)0xFFC00A68);
		debugfs_create_x32("EBIU_DDRBRC3", 0600, parent, (u32 *)0xFFC00A6C);
		debugfs_create_x32("EBIU_DDRBRC4", 0600, parent, (u32 *)0xFFC00A70);
		debugfs_create_x32("EBIU_DDRBRC5", 0600, parent, (u32 *)0xFFC00A74);
		debugfs_create_x32("EBIU_DDRBRC6", 0600, parent, (u32 *)0xFFC00A78);
		debugfs_create_x32("EBIU_DDRBRC7", 0600, parent, (u32 *)0xFFC00A7C);
		debugfs_create_x32("EBIU_DDRBWC0", 0600, parent, (u32 *)0xFFC00A80);
		debugfs_create_x32("EBIU_DDRBWC1", 0600, parent, (u32 *)0xFFC00A84);
		debugfs_create_x32("EBIU_DDRBWC2", 0600, parent, (u32 *)0xFFC00A88);
		debugfs_create_x32("EBIU_DDRBWC3", 0600, parent, (u32 *)0xFFC00A8C);
		debugfs_create_x32("EBIU_DDRBWC4", 0600, parent, (u32 *)0xFFC00A90);
		debugfs_create_x32("EBIU_DDRBWC5", 0600, parent, (u32 *)0xFFC00A94);
		debugfs_create_x32("EBIU_DDRBWC6", 0600, parent, (u32 *)0xFFC00A98);
		debugfs_create_x32("EBIU_DDRBWC7", 0600, parent, (u32 *)0xFFC00A9C);
		debugfs_create_x32("EBIU_DDRCTL0", 0600, parent, (u32 *)0xFFC00A20);
		debugfs_create_x32("EBIU_DDRCTL1", 0600, parent, (u32 *)0xFFC00A24);
		debugfs_create_x32("EBIU_DDRCTL2", 0600, parent, (u32 *)0xFFC00A28);
		debugfs_create_x32("EBIU_DDRCTL3", 0600, parent, (u32 *)0xFFC00A2C);
		debugfs_create_x32("EBIU_DDRGC0", 0600, parent, (u32 *)0xFFC00AB0);
		debugfs_create_x32("EBIU_DDRGC1", 0600, parent, (u32 *)0xFFC00AB4);
		debugfs_create_x32("EBIU_DDRGC2", 0600, parent, (u32 *)0xFFC00AB8);
		debugfs_create_x32("EBIU_DDRGC3", 0600, parent, (u32 *)0xFFC00ABC);
		debugfs_create_x32("EBIU_DDRMCCL", 0600, parent, (u32 *)0xFFC00AC4);
		debugfs_create_x32("EBIU_DDRMCEN", 0600, parent, (u32 *)0xFFC00AC0);
		debugfs_create_x32("EBIU_DDRQUE", 0600, parent, (u32 *)0xFFC00A30);
		debugfs_create_x32("EBIU_DDRTACT", 0600, parent, (u32 *)0xFFC00AA8);
		debugfs_create_x32("EBIU_ERRADD", 0600, parent, (u32 *)0xFFC00A34);
		debugfs_create_x16("EBIU_ERRMST", 0600, parent, (u16 *)0xFFC00A38);
		debugfs_create_x32("EBIU_FCTL", 0600, parent, (u32 *)0xFFC00A18);
		debugfs_create_x32("EBIU_MBSCTL", 0600, parent, (u32 *)0xFFC00A0C);
		debugfs_create_x32("EBIU_MODE", 0600, parent, (u32 *)0xFFC00A14);
		debugfs_create_x16("EBIU_RSTCTL", 0600, parent, (u16 *)0xFFC00A3C);

		parent = debugfs_create_dir("EPPI", top);
		debugfs_create_x32("EPPI0_CLIP", 0600, parent, (u32 *)0xFFC01034);
		debugfs_create_x16("EPPI0_CLKDIV", 0600, parent, (u16 *)0xFFC0101C);
		debugfs_create_x32("EPPI0_CONTROL", 0600, parent, (u32 *)0xFFC01020);
		debugfs_create_x16("EPPI0_FRAME", 0600, parent, (u16 *)0xFFC01014);
		debugfs_create_x32("EPPI0_FS1P_AVPL", 0600, parent, (u32 *)0xFFC01028);
		debugfs_create_x32("EPPI0_FS1W_HBL", 0600, parent, (u32 *)0xFFC01024);
		debugfs_create_x32("EPPI0_FS2P_LAVF", 0600, parent, (u32 *)0xFFC01030);
		debugfs_create_x32("EPPI0_FS2W_LVB", 0600, parent, (u32 *)0xFFC0102C);
		debugfs_create_x16("EPPI0_HCOUNT", 0600, parent, (u16 *)0xFFC01004);
		debugfs_create_x16("EPPI0_HDELAY", 0600, parent, (u16 *)0xFFC01008);
		debugfs_create_x16("EPPI0_LINE", 0600, parent, (u16 *)0xFFC01018);
		debugfs_create_x16("EPPI0_STATUS", 0600, parent, (u16 *)0xFFC01000);
		debugfs_create_x16("EPPI0_VCOUNT", 0600, parent, (u16 *)0xFFC0100C);
		debugfs_create_x16("EPPI0_VDELAY", 0600, parent, (u16 *)0xFFC01010);
		debugfs_create_x32("EPPI1_CLIP", 0600, parent, (u32 *)0xFFC01334);
		debugfs_create_x16("EPPI1_CLKDIV", 0600, parent, (u16 *)0xFFC0131C);
		debugfs_create_x32("EPPI1_CONTROL", 0600, parent, (u32 *)0xFFC01320);
		debugfs_create_x16("EPPI1_FRAME", 0600, parent, (u16 *)0xFFC01314);
		debugfs_create_x32("EPPI1_FS1P_AVPL", 0600, parent, (u32 *)0xFFC01328);
		debugfs_create_x32("EPPI1_FS1W_HBL", 0600, parent, (u32 *)0xFFC01324);
		debugfs_create_x32("EPPI1_FS2P_LAVF", 0600, parent, (u32 *)0xFFC01330);
		debugfs_create_x32("EPPI1_FS2W_LVB", 0600, parent, (u32 *)0xFFC0132C);
		debugfs_create_x16("EPPI1_HCOUNT", 0600, parent, (u16 *)0xFFC01304);
		debugfs_create_x16("EPPI1_HDELAY", 0600, parent, (u16 *)0xFFC01308);
		debugfs_create_x16("EPPI1_LINE", 0600, parent, (u16 *)0xFFC01318);
		debugfs_create_x16("EPPI1_STATUS", 0600, parent, (u16 *)0xFFC01300);
		debugfs_create_x16("EPPI1_VCOUNT", 0600, parent, (u16 *)0xFFC0130C);
		debugfs_create_x16("EPPI1_VDELAY", 0600, parent, (u16 *)0xFFC01310);
		debugfs_create_x32("EPPI2_CLIP", 0600, parent, (u32 *)0xFFC02934);
		debugfs_create_x16("EPPI2_CLKDIV", 0600, parent, (u16 *)0xFFC0291C);
		debugfs_create_x32("EPPI2_CONTROL", 0600, parent, (u32 *)0xFFC02920);
		debugfs_create_x16("EPPI2_FRAME", 0600, parent, (u16 *)0xFFC02914);
		debugfs_create_x32("EPPI2_FS1P_AVPL", 0600, parent, (u32 *)0xFFC02928);
		debugfs_create_x32("EPPI2_FS1W_HBL", 0600, parent, (u32 *)0xFFC02924);
		debugfs_create_x32("EPPI2_FS2P_LAVF", 0600, parent, (u32 *)0xFFC02930);
		debugfs_create_x32("EPPI2_FS2W_LVB", 0600, parent, (u32 *)0xFFC0292C);
		debugfs_create_x16("EPPI2_HCOUNT", 0600, parent, (u16 *)0xFFC02904);
		debugfs_create_x16("EPPI2_HDELAY", 0600, parent, (u16 *)0xFFC02908);
		debugfs_create_x16("EPPI2_LINE", 0600, parent, (u16 *)0xFFC02918);
		debugfs_create_x16("EPPI2_STATUS", 0600, parent, (u16 *)0xFFC02900);
		debugfs_create_x16("EPPI2_VCOUNT", 0600, parent, (u16 *)0xFFC0290C);
		debugfs_create_x16("EPPI2_VDELAY", 0600, parent, (u16 *)0xFFC02910);

		parent = debugfs_create_dir("Event Vectors", top);
		debugfs_create_x32("EVT0", 0600, parent, (u32 *)0xFFE02000);
		debugfs_create_x32("EVT10", 0600, parent, (u32 *)0xFFE02028);
		debugfs_create_x32("EVT11", 0600, parent, (u32 *)0xFFE0202C);
		debugfs_create_x32("EVT12", 0600, parent, (u32 *)0xFFE02030);
		debugfs_create_x32("EVT13", 0600, parent, (u32 *)0xFFE02034);
		debugfs_create_x32("EVT14", 0600, parent, (u32 *)0xFFE02038);
		debugfs_create_x32("EVT15", 0600, parent, (u32 *)0xFFE0203C);
		debugfs_create_x32("EVT1", 0600, parent, (u32 *)0xFFE02004);
		debugfs_create_x32("EVT2", 0600, parent, (u32 *)0xFFE02008);
		debugfs_create_x32("EVT3", 0600, parent, (u32 *)0xFFE0200C);
		debugfs_create_x32("EVT4", 0600, parent, (u32 *)0xFFE02010);
		debugfs_create_x32("EVT5", 0600, parent, (u32 *)0xFFE02014);
		debugfs_create_x32("EVT6", 0600, parent, (u32 *)0xFFE02018);
		debugfs_create_x32("EVT7", 0600, parent, (u32 *)0xFFE0201C);
		debugfs_create_x32("EVT8", 0600, parent, (u32 *)0xFFE02020);
		debugfs_create_x32("EVT9", 0600, parent, (u32 *)0xFFE02024);

		parent = debugfs_create_dir("Extended Registers", top);
		debugfs_create_x32("CHIPID", 0600, parent, (u32 *)0xFFC00014);
		debugfs_create_x32("DSPID", 0600, parent, (u32 *)0xFFE05000);

		parent = debugfs_create_dir("HMDMA", top);
		debugfs_create_x16("HMDMA0_BCINIT", 0600, parent, (u16 *)0xFFC04508);
		debugfs_create_x16("HMDMA0_BCOUNT", 0600, parent, (u16 *)0xFFC04518);
		debugfs_create_x16("HMDMA0_CONTROL", 0600, parent, (u16 *)0xFFC04500);
		debugfs_create_x16("HMDMA0_ECINIT", 0600, parent, (u16 *)0xFFC04504);
		debugfs_create_x16("HMDMA0_ECOUNT", 0600, parent, (u16 *)0xFFC04514);
		debugfs_create_x16("HMDMA0_ECOVERFLOW", 0600, parent, (u16 *)0xFFC04510);
		debugfs_create_x16("HMDMA0_ECURGENT", 0600, parent, (u16 *)0xFFC0450C);
		debugfs_create_x16("HMDMA1_BCINIT", 0600, parent, (u16 *)0xFFC04548);
		debugfs_create_x16("HMDMA1_BCOUNT", 0600, parent, (u16 *)0xFFC04558);
		debugfs_create_x16("HMDMA1_CONTROL", 0600, parent, (u16 *)0xFFC04540);
		debugfs_create_x16("HMDMA1_ECINIT", 0600, parent, (u16 *)0xFFC04544);
		debugfs_create_x16("HMDMA1_ECOUNT", 0600, parent, (u16 *)0xFFC04554);
		debugfs_create_x16("HMDMA1_ECOVERFLOW", 0600, parent, (u16 *)0xFFC04550);
		debugfs_create_x16("HMDMA1_ECURGENT", 0600, parent, (u16 *)0xFFC0454C);

		parent = debugfs_create_dir("HOSTDP", top);
		debugfs_create_x16("HOST_CONTROL", 0600, parent, (u16 *)0xFFC03A00);
		debugfs_create_x16("HOST_STATUS", 0600, parent, (u16 *)0xFFC03A04);
		debugfs_create_x16("HOST_TIMEOUT", 0600, parent, (u16 *)0xFFC03A08);

		parent = debugfs_create_dir("Interrupt Controller", top);
		debugfs_create_x32("ILAT", 0600, parent, (u32 *)0xFFE0210C);
		debugfs_create_x32("IMASK", 0600, parent, (u32 *)0xFFE02104);
		debugfs_create_x32("IPEND", 0600, parent, (u32 *)0xFFE02108);
		debugfs_create_x32("IPRIO", 0600, parent, (u32 *)0xFFE02110);

		parent = debugfs_create_dir("KEYPAD", top);
		debugfs_create_x16("KPAD_CTL", 0600, parent, (u16 *)0xFFC04100);
		debugfs_create_x16("KPAD_MSEL", 0600, parent, (u16 *)0xFFC04108);
		debugfs_create_x16("KPAD_PRESCALE", 0600, parent, (u16 *)0xFFC04104);
		debugfs_create_x16("KPAD_ROWCOL", 0600, parent, (u16 *)0xFFC0410C);
		debugfs_create_x16("KPAD_SOFTEVAL", 0600, parent, (u16 *)0xFFC04114);
		debugfs_create_x16("KPAD_STAT", 0600, parent, (u16 *)0xFFC04110);

		parent = debugfs_create_dir("L1 Code Memory Registers", top);
		debugfs_create_x32("ICPLB_ADDR0", 0600, parent, (u32 *)0xFFE01100);
		debugfs_create_x32("ICPLB_ADDR10", 0600, parent, (u32 *)0xFFE01128);
		debugfs_create_x32("ICPLB_ADDR11", 0600, parent, (u32 *)0xFFE0112C);
		debugfs_create_x32("ICPLB_ADDR12", 0600, parent, (u32 *)0xFFE01130);
		debugfs_create_x32("ICPLB_ADDR13", 0600, parent, (u32 *)0xFFE01134);
		debugfs_create_x32("ICPLB_ADDR14", 0600, parent, (u32 *)0xFFE01138);
		debugfs_create_x32("ICPLB_ADDR15", 0600, parent, (u32 *)0xFFE0113C);
		debugfs_create_x32("ICPLB_ADDR1", 0600, parent, (u32 *)0xFFE01104);
		debugfs_create_x32("ICPLB_ADDR2", 0600, parent, (u32 *)0xFFE01108);
		debugfs_create_x32("ICPLB_ADDR3", 0600, parent, (u32 *)0xFFE0110C);
		debugfs_create_x32("ICPLB_ADDR4", 0600, parent, (u32 *)0xFFE01110);
		debugfs_create_x32("ICPLB_ADDR5", 0600, parent, (u32 *)0xFFE01114);
		debugfs_create_x32("ICPLB_ADDR6", 0600, parent, (u32 *)0xFFE01118);
		debugfs_create_x32("ICPLB_ADDR7", 0600, parent, (u32 *)0xFFE0111C);
		debugfs_create_x32("ICPLB_ADDR8", 0600, parent, (u32 *)0xFFE01120);
		debugfs_create_x32("ICPLB_ADDR9", 0600, parent, (u32 *)0xFFE01124);
		debugfs_create_x32("ICPLB_DATA0", 0600, parent, (u32 *)0xFFE01200);
		debugfs_create_x32("ICPLB_DATA10", 0600, parent, (u32 *)0xFFE01228);
		debugfs_create_x32("ICPLB_DATA11", 0600, parent, (u32 *)0xFFE0122C);
		debugfs_create_x32("ICPLB_DATA12", 0600, parent, (u32 *)0xFFE01230);
		debugfs_create_x32("ICPLB_DATA13", 0600, parent, (u32 *)0xFFE01234);
		debugfs_create_x32("ICPLB_DATA14", 0600, parent, (u32 *)0xFFE01238);
		debugfs_create_x32("ICPLB_DATA15", 0600, parent, (u32 *)0xFFE0123C);
		debugfs_create_x32("ICPLB_DATA1", 0600, parent, (u32 *)0xFFE01204);
		debugfs_create_x32("ICPLB_DATA2", 0600, parent, (u32 *)0xFFE01208);
		debugfs_create_x32("ICPLB_DATA3", 0600, parent, (u32 *)0xFFE0120C);
		debugfs_create_x32("ICPLB_DATA4", 0600, parent, (u32 *)0xFFE01210);
		debugfs_create_x32("ICPLB_DATA5", 0600, parent, (u32 *)0xFFE01214);
		debugfs_create_x32("ICPLB_DATA6", 0600, parent, (u32 *)0xFFE01218);
		debugfs_create_x32("ICPLB_DATA7", 0600, parent, (u32 *)0xFFE0121C);
		debugfs_create_x32("ICPLB_DATA8", 0600, parent, (u32 *)0xFFE01220);
		debugfs_create_x32("ICPLB_DATA9", 0600, parent, (u32 *)0xFFE01224);
		debugfs_create_x32("ICPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0100C);
		debugfs_create_x32("ICPLB_STATUS", 0600, parent, (u32 *)0xFFE01008);
		debugfs_create_x32("IMEM_CONTROL", 0600, parent, (u32 *)0xFFE01004);
		debugfs_create_x32("ITEST_COMMAND", 0600, parent, (u32 *)0xFFE01300);
		debugfs_create_x32("ITEST_DATA0", 0600, parent, (u32 *)0xFFE01400);
		debugfs_create_x32("ITEST_DATA1", 0600, parent, (u32 *)0xFFE01404);

		parent = debugfs_create_dir("L1 Data Memory Registers", top);
		debugfs_create_x32("DCPLB_ADDR0", 0600, parent, (u32 *)0xFFE00100);
		debugfs_create_x32("DCPLB_ADDR10", 0600, parent, (u32 *)0xFFE00128);
		debugfs_create_x32("DCPLB_ADDR11", 0600, parent, (u32 *)0xFFE0012C);
		debugfs_create_x32("DCPLB_ADDR12", 0600, parent, (u32 *)0xFFE00130);
		debugfs_create_x32("DCPLB_ADDR13", 0600, parent, (u32 *)0xFFE00134);
		debugfs_create_x32("DCPLB_ADDR14", 0600, parent, (u32 *)0xFFE00138);
		debugfs_create_x32("DCPLB_ADDR15", 0600, parent, (u32 *)0xFFE0013C);
		debugfs_create_x32("DCPLB_ADDR1", 0600, parent, (u32 *)0xFFE00104);
		debugfs_create_x32("DCPLB_ADDR2", 0600, parent, (u32 *)0xFFE00108);
		debugfs_create_x32("DCPLB_ADDR3", 0600, parent, (u32 *)0xFFE0010C);
		debugfs_create_x32("DCPLB_ADDR4", 0600, parent, (u32 *)0xFFE00110);
		debugfs_create_x32("DCPLB_ADDR5", 0600, parent, (u32 *)0xFFE00114);
		debugfs_create_x32("DCPLB_ADDR6", 0600, parent, (u32 *)0xFFE00118);
		debugfs_create_x32("DCPLB_ADDR7", 0600, parent, (u32 *)0xFFE0011C);
		debugfs_create_x32("DCPLB_ADDR8", 0600, parent, (u32 *)0xFFE00120);
		debugfs_create_x32("DCPLB_ADDR9", 0600, parent, (u32 *)0xFFE00124);
		debugfs_create_x32("DCPLB_DATA0", 0600, parent, (u32 *)0xFFE00200);
		debugfs_create_x32("DCPLB_DATA10", 0600, parent, (u32 *)0xFFE00228);
		debugfs_create_x32("DCPLB_DATA11", 0600, parent, (u32 *)0xFFE0022C);
		debugfs_create_x32("DCPLB_DATA12", 0600, parent, (u32 *)0xFFE00230);
		debugfs_create_x32("DCPLB_DATA13", 0600, parent, (u32 *)0xFFE00234);
		debugfs_create_x32("DCPLB_DATA14", 0600, parent, (u32 *)0xFFE00238);
		debugfs_create_x32("DCPLB_DATA15", 0600, parent, (u32 *)0xFFE0023C);
		debugfs_create_x32("DCPLB_DATA1", 0600, parent, (u32 *)0xFFE00204);
		debugfs_create_x32("DCPLB_DATA2", 0600, parent, (u32 *)0xFFE00208);
		debugfs_create_x32("DCPLB_DATA3", 0600, parent, (u32 *)0xFFE0020C);
		debugfs_create_x32("DCPLB_DATA4", 0600, parent, (u32 *)0xFFE00210);
		debugfs_create_x32("DCPLB_DATA5", 0600, parent, (u32 *)0xFFE00214);
		debugfs_create_x32("DCPLB_DATA6", 0600, parent, (u32 *)0xFFE00218);
		debugfs_create_x32("DCPLB_DATA7", 0600, parent, (u32 *)0xFFE0021C);
		debugfs_create_x32("DCPLB_DATA8", 0600, parent, (u32 *)0xFFE00220);
		debugfs_create_x32("DCPLB_DATA9", 0600, parent, (u32 *)0xFFE00224);
		debugfs_create_x32("DCPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0000C);
		debugfs_create_x32("DCPLB_STATUS", 0600, parent, (u32 *)0xFFE00008);
		debugfs_create_x32("DMEM_CONTROL", 0600, parent, (u32 *)0xFFE00004);
		debugfs_create_x32("DTEST_COMMAND", 0600, parent, (u32 *)0xFFE00300);
		debugfs_create_x32("DTEST_DATA0", 0600, parent, (u32 *)0xFFE00400);
		debugfs_create_x32("DTEST_DATA1", 0600, parent, (u32 *)0xFFE00404);
		debugfs_create_x32("SRAM_BASE_ADDR", 0600, parent, (u32 *)0xFFE00000);

		parent = debugfs_create_dir("MDMA", top);
		debugfs_create_x16("MDMA_D0_CONFIG", 0600, parent, (u16 *)0xFFC00F08);
		debugfs_create_x32("MDMA_D0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F24);
		debugfs_create_x32("MDMA_D0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F20);
		debugfs_create_x16("MDMA_D0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F30);
		debugfs_create_x16("MDMA_D0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F38);
		debugfs_create_x16("MDMA_D0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F28);
		debugfs_create_x32("MDMA_D0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F00);
		debugfs_create_x16("MDMA_D0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F2C);
		debugfs_create_x32("MDMA_D0_START_ADDR", 0600, parent, (u32 *)0xFFC00F04);
		debugfs_create_x16("MDMA_D0_X_COUNT", 0600, parent, (u16 *)0xFFC00F10);
		debugfs_create_x16("MDMA_D0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F14);
		debugfs_create_x16("MDMA_D0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F18);
		debugfs_create_x16("MDMA_D0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F1C);
		debugfs_create_x16("MDMA_D1_CONFIG", 0600, parent, (u16 *)0xFFC00F88);
		debugfs_create_x32("MDMA_D1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FA4);
		debugfs_create_x32("MDMA_D1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FA0);
		debugfs_create_x16("MDMA_D1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FB0);
		debugfs_create_x16("MDMA_D1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FB8);
		debugfs_create_x16("MDMA_D1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FA8);
		debugfs_create_x32("MDMA_D1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F80);
		debugfs_create_x16("MDMA_D1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FAC);
		debugfs_create_x32("MDMA_D1_START_ADDR", 0600, parent, (u32 *)0xFFC00F84);
		debugfs_create_x16("MDMA_D1_X_COUNT", 0600, parent, (u16 *)0xFFC00F90);
		debugfs_create_x16("MDMA_D1_X_MODIFY", 0600, parent, (u16 *)0xFFC00F94);
		debugfs_create_x16("MDMA_D1_Y_COUNT", 0600, parent, (u16 *)0xFFC00F98);
		debugfs_create_x16("MDMA_D1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F9C);
		debugfs_create_x16("MDMA_D2_CONFIG", 0600, parent, (u16 *)0xFFC01F08);
		debugfs_create_x32("MDMA_D2_CURR_ADDR", 0600, parent, (u32 *)0xFFC01F24);
		debugfs_create_x32("MDMA_D2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01F20);
		debugfs_create_x16("MDMA_D2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01F30);
		debugfs_create_x16("MDMA_D2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01F38);
		debugfs_create_x16("MDMA_D2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01F28);
		debugfs_create_x32("MDMA_D2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01F00);
		debugfs_create_x16("MDMA_D2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01F2C);
		debugfs_create_x32("MDMA_D2_START_ADDR", 0600, parent, (u32 *)0xFFC01F04);
		debugfs_create_x16("MDMA_D2_X_COUNT", 0600, parent, (u16 *)0xFFC01F10);
		debugfs_create_x16("MDMA_D2_X_MODIFY", 0600, parent, (u16 *)0xFFC01F14);
		debugfs_create_x16("MDMA_D2_Y_COUNT", 0600, parent, (u16 *)0xFFC01F18);
		debugfs_create_x16("MDMA_D2_Y_MODIFY", 0600, parent, (u16 *)0xFFC01F1C);
		debugfs_create_x16("MDMA_D3_CONFIG", 0600, parent, (u16 *)0xFFC01F88);
		debugfs_create_x32("MDMA_D3_CURR_ADDR", 0600, parent, (u32 *)0xFFC01FA4);
		debugfs_create_x32("MDMA_D3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01FA0);
		debugfs_create_x16("MDMA_D3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01FB0);
		debugfs_create_x16("MDMA_D3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01FB8);
		debugfs_create_x16("MDMA_D3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01FA8);
		debugfs_create_x32("MDMA_D3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01F80);
		debugfs_create_x16("MDMA_D3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01FAC);
		debugfs_create_x32("MDMA_D3_START_ADDR", 0600, parent, (u32 *)0xFFC01F84);
		debugfs_create_x16("MDMA_D3_X_COUNT", 0600, parent, (u16 *)0xFFC01F90);
		debugfs_create_x16("MDMA_D3_X_MODIFY", 0600, parent, (u16 *)0xFFC01F94);
		debugfs_create_x16("MDMA_D3_Y_COUNT", 0600, parent, (u16 *)0xFFC01F98);
		debugfs_create_x16("MDMA_D3_Y_MODIFY", 0600, parent, (u16 *)0xFFC01F9C);
		debugfs_create_x16("MDMA_S0_CONFIG", 0600, parent, (u16 *)0xFFC00F48);
		debugfs_create_x32("MDMA_S0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F64);
		debugfs_create_x32("MDMA_S0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F60);
		debugfs_create_x16("MDMA_S0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F70);
		debugfs_create_x16("MDMA_S0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F78);
		debugfs_create_x16("MDMA_S0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F68);
		debugfs_create_x32("MDMA_S0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F40);
		debugfs_create_x16("MDMA_S0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F6C);
		debugfs_create_x32("MDMA_S0_START_ADDR", 0600, parent, (u32 *)0xFFC00F44);
		debugfs_create_x16("MDMA_S0_X_COUNT", 0600, parent, (u16 *)0xFFC00F50);
		debugfs_create_x16("MDMA_S0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F54);
		debugfs_create_x16("MDMA_S0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F58);
		debugfs_create_x16("MDMA_S0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F5C);
		debugfs_create_x16("MDMA_S1_CONFIG", 0600, parent, (u16 *)0xFFC00FC8);
		debugfs_create_x32("MDMA_S1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FE4);
		debugfs_create_x32("MDMA_S1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FE0);
		debugfs_create_x16("MDMA_S1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FF0);
		debugfs_create_x16("MDMA_S1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FF8);
		debugfs_create_x16("MDMA_S1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FE8);
		debugfs_create_x32("MDMA_S1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00FC0);
		debugfs_create_x16("MDMA_S1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FEC);
		debugfs_create_x32("MDMA_S1_START_ADDR", 0600, parent, (u32 *)0xFFC00FC4);
		debugfs_create_x16("MDMA_S1_X_COUNT", 0600, parent, (u16 *)0xFFC00FD0);
		debugfs_create_x16("MDMA_S1_X_MODIFY", 0600, parent, (u16 *)0xFFC00FD4);
		debugfs_create_x16("MDMA_S1_Y_COUNT", 0600, parent, (u16 *)0xFFC00FD8);
		debugfs_create_x16("MDMA_S1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00FDC);
		debugfs_create_x16("MDMA_S2_CONFIG", 0600, parent, (u16 *)0xFFC01F48);
		debugfs_create_x32("MDMA_S2_CURR_ADDR", 0600, parent, (u32 *)0xFFC01F64);
		debugfs_create_x32("MDMA_S2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01F60);
		debugfs_create_x16("MDMA_S2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01F70);
		debugfs_create_x16("MDMA_S2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01F78);
		debugfs_create_x16("MDMA_S2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01F68);
		debugfs_create_x32("MDMA_S2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01F40);
		debugfs_create_x16("MDMA_S2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01F6C);
		debugfs_create_x32("MDMA_S2_START_ADDR", 0600, parent, (u32 *)0xFFC01F44);
		debugfs_create_x16("MDMA_S2_X_COUNT", 0600, parent, (u16 *)0xFFC01F50);
		debugfs_create_x16("MDMA_S2_X_MODIFY", 0600, parent, (u16 *)0xFFC01F54);
		debugfs_create_x16("MDMA_S2_Y_COUNT", 0600, parent, (u16 *)0xFFC01F58);
		debugfs_create_x16("MDMA_S2_Y_MODIFY", 0600, parent, (u16 *)0xFFC01F5C);
		debugfs_create_x16("MDMA_S3_CONFIG", 0600, parent, (u16 *)0xFFC01FC8);
		debugfs_create_x32("MDMA_S3_CURR_ADDR", 0600, parent, (u32 *)0xFFC01FE4);
		debugfs_create_x32("MDMA_S3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01FE0);
		debugfs_create_x16("MDMA_S3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01FF0);
		debugfs_create_x16("MDMA_S3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01FF8);
		debugfs_create_x16("MDMA_S3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01FE8);
		debugfs_create_x32("MDMA_S3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01FC0);
		debugfs_create_x16("MDMA_S3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01FEC);
		debugfs_create_x32("MDMA_S3_START_ADDR", 0600, parent, (u32 *)0xFFC01FC4);
		debugfs_create_x16("MDMA_S3_X_COUNT", 0600, parent, (u16 *)0xFFC01FD0);
		debugfs_create_x16("MDMA_S3_X_MODIFY", 0600, parent, (u16 *)0xFFC01FD4);
		debugfs_create_x16("MDMA_S3_Y_COUNT", 0600, parent, (u16 *)0xFFC01FD8);
		debugfs_create_x16("MDMA_S3_Y_MODIFY", 0600, parent, (u16 *)0xFFC01FDC);

		parent = debugfs_create_dir("MXVR", top);
		debugfs_create_x32("MXVR_AADDR", 0600, parent, (u32 *)0xFFC02738);
		debugfs_create_x32("MXVR_ALLOC_0", 0600, parent, (u32 *)0xFFC0273C);
		debugfs_create_x32("MXVR_ALLOC_10", 0600, parent, (u32 *)0xFFC02764);
		debugfs_create_x32("MXVR_ALLOC_11", 0600, parent, (u32 *)0xFFC02768);
		debugfs_create_x32("MXVR_ALLOC_12", 0600, parent, (u32 *)0xFFC0276C);
		debugfs_create_x32("MXVR_ALLOC_13", 0600, parent, (u32 *)0xFFC02770);
		debugfs_create_x32("MXVR_ALLOC_14", 0600, parent, (u32 *)0xFFC02774);
		debugfs_create_x32("MXVR_ALLOC_1", 0600, parent, (u32 *)0xFFC02740);
		debugfs_create_x32("MXVR_ALLOC_2", 0600, parent, (u32 *)0xFFC02744);
		debugfs_create_x32("MXVR_ALLOC_3", 0600, parent, (u32 *)0xFFC02748);
		debugfs_create_x32("MXVR_ALLOC_4", 0600, parent, (u32 *)0xFFC0274C);
		debugfs_create_x32("MXVR_ALLOC_5", 0600, parent, (u32 *)0xFFC02750);
		debugfs_create_x32("MXVR_ALLOC_6", 0600, parent, (u32 *)0xFFC02754);
		debugfs_create_x32("MXVR_ALLOC_7", 0600, parent, (u32 *)0xFFC02758);
		debugfs_create_x32("MXVR_ALLOC_8", 0600, parent, (u32 *)0xFFC0275C);
		debugfs_create_x32("MXVR_ALLOC_9", 0600, parent, (u32 *)0xFFC02760);
		debugfs_create_x32("MXVR_APRB_CURR_ADDR", 0600, parent, (u32 *)0xFFC02840);
		debugfs_create_x32("MXVR_APRB_START_ADDR", 0600, parent, (u32 *)0xFFC0283C);
		debugfs_create_x32("MXVR_APTB_CURR_ADDR", 0600, parent, (u32 *)0xFFC02848);
		debugfs_create_x32("MXVR_APTB_START_ADDR", 0600, parent, (u32 *)0xFFC02844);
		debugfs_create_x16("MXVR_AP_CTL", 0600, parent, (u16 *)0xFFC02838);
		debugfs_create_x16("MXVR_BLOCK_CNT", 0600, parent, (u16 *)0xFFC028C0);
		debugfs_create_x32("MXVR_CDRPLL_CTL", 0600, parent, (u32 *)0xFFC028D4);
		debugfs_create_x32("MXVR_CLK_CTL", 0600, parent, (u32 *)0xFFC028D0);
		debugfs_create_x32("MXVR_CMRB_CURR_ADDR", 0600, parent, (u32 *)0xFFC02854);
		debugfs_create_x32("MXVR_CMRB_START_ADDR", 0600, parent, (u32 *)0xFFC02850);
		debugfs_create_x32("MXVR_CMTB_CURR_ADDR", 0600, parent, (u32 *)0xFFC0285C);
		debugfs_create_x32("MXVR_CMTB_START_ADDR", 0600, parent, (u32 *)0xFFC02858);
		debugfs_create_x32("MXVR_CM_CTL", 0600, parent, (u32 *)0xFFC0284C);
		debugfs_create_x16("MXVR_CONFIG", 0600, parent, (u16 *)0xFFC02700);
		debugfs_create_x16("MXVR_DELAY", 0600, parent, (u16 *)0xFFC02728);
		debugfs_create_x32("MXVR_DMA0_CONFIG", 0600, parent, (u32 *)0xFFC02798);
		debugfs_create_x16("MXVR_DMA0_COUNT", 0600, parent, (u16 *)0xFFC027A0);
		debugfs_create_x32("MXVR_DMA0_CURR_ADDR", 0600, parent, (u32 *)0xFFC027A4);
		debugfs_create_x16("MXVR_DMA0_CURR_COUNT", 0600, parent, (u16 *)0xFFC027A8);
		debugfs_create_x32("MXVR_DMA0_START_ADDR", 0600, parent, (u32 *)0xFFC0279C);
		debugfs_create_x32("MXVR_DMA1_CONFIG", 0600, parent, (u32 *)0xFFC027AC);
		debugfs_create_x16("MXVR_DMA1_COUNT", 0600, parent, (u16 *)0xFFC027B4);
		debugfs_create_x32("MXVR_DMA1_CURR_ADDR", 0600, parent, (u32 *)0xFFC027B8);
		debugfs_create_x16("MXVR_DMA1_CURR_COUNT", 0600, parent, (u16 *)0xFFC027BC);
		debugfs_create_x32("MXVR_DMA1_START_ADDR", 0600, parent, (u32 *)0xFFC027B0);
		debugfs_create_x32("MXVR_DMA2_CONFIG", 0600, parent, (u32 *)0xFFC027C0);
		debugfs_create_x16("MXVR_DMA2_COUNT", 0600, parent, (u16 *)0xFFC027C8);
		debugfs_create_x32("MXVR_DMA2_CURR_ADDR", 0600, parent, (u32 *)0xFFC027CC);
		debugfs_create_x16("MXVR_DMA2_CURR_COUNT", 0600, parent, (u16 *)0xFFC027D0);
		debugfs_create_x32("MXVR_DMA2_START_ADDR", 0600, parent, (u32 *)0xFFC027C4);
		debugfs_create_x32("MXVR_DMA3_CONFIG", 0600, parent, (u32 *)0xFFC027D4);
		debugfs_create_x16("MXVR_DMA3_COUNT", 0600, parent, (u16 *)0xFFC027DC);
		debugfs_create_x32("MXVR_DMA3_CURR_ADDR", 0600, parent, (u32 *)0xFFC027E0);
		debugfs_create_x16("MXVR_DMA3_CURR_COUNT", 0600, parent, (u16 *)0xFFC027E4);
		debugfs_create_x32("MXVR_DMA3_START_ADDR", 0600, parent, (u32 *)0xFFC027D8);
		debugfs_create_x32("MXVR_DMA4_CONFIG", 0600, parent, (u32 *)0xFFC027E8);
		debugfs_create_x16("MXVR_DMA4_COUNT", 0600, parent, (u16 *)0xFFC027F0);
		debugfs_create_x32("MXVR_DMA4_CURR_ADDR", 0600, parent, (u32 *)0xFFC027F4);
		debugfs_create_x16("MXVR_DMA4_CURR_COUNT", 0600, parent, (u16 *)0xFFC027F8);
		debugfs_create_x32("MXVR_DMA4_START_ADDR", 0600, parent, (u32 *)0xFFC027EC);
		debugfs_create_x32("MXVR_DMA5_CONFIG", 0600, parent, (u32 *)0xFFC027FC);
		debugfs_create_x16("MXVR_DMA5_COUNT", 0600, parent, (u16 *)0xFFC02804);
		debugfs_create_x32("MXVR_DMA5_CURR_ADDR", 0600, parent, (u32 *)0xFFC02808);
		debugfs_create_x16("MXVR_DMA5_CURR_COUNT", 0600, parent, (u16 *)0xFFC0280C);
		debugfs_create_x32("MXVR_DMA5_START_ADDR", 0600, parent, (u32 *)0xFFC02800);
		debugfs_create_x32("MXVR_DMA6_CONFIG", 0600, parent, (u32 *)0xFFC02810);
		debugfs_create_x16("MXVR_DMA6_COUNT", 0600, parent, (u16 *)0xFFC02818);
		debugfs_create_x32("MXVR_DMA6_CURR_ADDR", 0600, parent, (u32 *)0xFFC0281C);
		debugfs_create_x16("MXVR_DMA6_CURR_COUNT", 0600, parent, (u16 *)0xFFC02820);
		debugfs_create_x32("MXVR_DMA6_START_ADDR", 0600, parent, (u32 *)0xFFC02814);
		debugfs_create_x32("MXVR_DMA7_CONFIG", 0600, parent, (u32 *)0xFFC02824);
		debugfs_create_x16("MXVR_DMA7_COUNT", 0600, parent, (u16 *)0xFFC0282C);
		debugfs_create_x32("MXVR_DMA7_CURR_ADDR", 0600, parent, (u32 *)0xFFC02830);
		debugfs_create_x16("MXVR_DMA7_CURR_COUNT", 0600, parent, (u16 *)0xFFC02834);
		debugfs_create_x32("MXVR_DMA7_START_ADDR", 0600, parent, (u32 *)0xFFC02828);
		debugfs_create_x32("MXVR_FMPLL_CTL", 0600, parent, (u32 *)0xFFC028D8);
		debugfs_create_x16("MXVR_FRAME_CNT_0", 0600, parent, (u16 *)0xFFC02878);
		debugfs_create_x16("MXVR_FRAME_CNT_1", 0600, parent, (u16 *)0xFFC0287C);
		debugfs_create_x16("MXVR_GADDR", 0600, parent, (u16 *)0xFFC02734);
		debugfs_create_x32("MXVR_INT_EN_0", 0600, parent, (u32 *)0xFFC02718);
		debugfs_create_x32("MXVR_INT_EN_1", 0600, parent, (u32 *)0xFFC0271C);
		debugfs_create_x32("MXVR_INT_STAT_0", 0600, parent, (u32 *)0xFFC02710);
		debugfs_create_x32("MXVR_INT_STAT_1", 0600, parent, (u32 *)0xFFC02714);
		debugfs_create_x32("MXVR_LADDR", 0600, parent, (u32 *)0xFFC02730);
		debugfs_create_x16("MXVR_MAX_DELAY", 0600, parent, (u16 *)0xFFC0272C);
		debugfs_create_x16("MXVR_MAX_POSITION", 0600, parent, (u16 *)0xFFC02724);
		debugfs_create_x32("MXVR_PAT_DATA_0", 0600, parent, (u32 *)0xFFC02868);
		debugfs_create_x32("MXVR_PAT_DATA_1", 0600, parent, (u32 *)0xFFC02870);
		debugfs_create_x32("MXVR_PAT_EN_0", 0600, parent, (u32 *)0xFFC0286C);
		debugfs_create_x32("MXVR_PAT_EN_1", 0600, parent, (u32 *)0xFFC02874);
		debugfs_create_x16("MXVR_PIN_CTL", 0600, parent, (u16 *)0xFFC028DC);
		debugfs_create_x16("MXVR_POSITION", 0600, parent, (u16 *)0xFFC02720);
		debugfs_create_x32("MXVR_ROUTING_0", 0600, parent, (u32 *)0xFFC02880);
		debugfs_create_x32("MXVR_ROUTING_10", 0600, parent, (u32 *)0xFFC028A8);
		debugfs_create_x32("MXVR_ROUTING_11", 0600, parent, (u32 *)0xFFC028AC);
		debugfs_create_x32("MXVR_ROUTING_12", 0600, parent, (u32 *)0xFFC028B0);
		debugfs_create_x32("MXVR_ROUTING_13", 0600, parent, (u32 *)0xFFC028B4);
		debugfs_create_x32("MXVR_ROUTING_14", 0600, parent, (u32 *)0xFFC028B8);
		debugfs_create_x32("MXVR_ROUTING_1", 0600, parent, (u32 *)0xFFC02884);
		debugfs_create_x32("MXVR_ROUTING_2", 0600, parent, (u32 *)0xFFC02888);
		debugfs_create_x32("MXVR_ROUTING_3", 0600, parent, (u32 *)0xFFC0288C);
		debugfs_create_x32("MXVR_ROUTING_4", 0600, parent, (u32 *)0xFFC02890);
		debugfs_create_x32("MXVR_ROUTING_5", 0600, parent, (u32 *)0xFFC02894);
		debugfs_create_x32("MXVR_ROUTING_6", 0600, parent, (u32 *)0xFFC02898);
		debugfs_create_x32("MXVR_ROUTING_7", 0600, parent, (u32 *)0xFFC0289C);
		debugfs_create_x32("MXVR_ROUTING_8", 0600, parent, (u32 *)0xFFC028A0);
		debugfs_create_x32("MXVR_ROUTING_9", 0600, parent, (u32 *)0xFFC028A4);
		debugfs_create_x32("MXVR_RRDB_CURR_ADDR", 0600, parent, (u32 *)0xFFC02864);
		debugfs_create_x32("MXVR_RRDB_START_ADDR", 0600, parent, (u32 *)0xFFC02860);
		debugfs_create_x16("MXVR_SCLK_CNT", 0600, parent, (u16 *)0xFFC028E0);
		debugfs_create_x32("MXVR_STATE_0", 0600, parent, (u32 *)0xFFC02708);
		debugfs_create_x32("MXVR_STATE_1", 0600, parent, (u32 *)0xFFC0270C);
		debugfs_create_x32("MXVR_SYNC_LCHAN_0", 0600, parent, (u32 *)0xFFC02778);
		debugfs_create_x32("MXVR_SYNC_LCHAN_1", 0600, parent, (u32 *)0xFFC0277C);
		debugfs_create_x32("MXVR_SYNC_LCHAN_2", 0600, parent, (u32 *)0xFFC02780);
		debugfs_create_x32("MXVR_SYNC_LCHAN_3", 0600, parent, (u32 *)0xFFC02784);
		debugfs_create_x32("MXVR_SYNC_LCHAN_4", 0600, parent, (u32 *)0xFFC02788);
		debugfs_create_x32("MXVR_SYNC_LCHAN_5", 0600, parent, (u32 *)0xFFC0278C);
		debugfs_create_x32("MXVR_SYNC_LCHAN_6", 0600, parent, (u32 *)0xFFC02790);
		debugfs_create_x32("MXVR_SYNC_LCHAN_7", 0600, parent, (u32 *)0xFFC02794);

		parent = debugfs_create_dir("NFC", top);
		debugfs_create_x16("NFC_ADDR", 0600, parent, (u16 *)0xFFC03B40);
		debugfs_create_x16("NFC_CMD", 0600, parent, (u16 *)0xFFC03B44);
		debugfs_create_x16("NFC_COUNT", 0600, parent, (u16 *)0xFFC03B20);
		debugfs_create_x16("NFC_CTL", 0600, parent, (u16 *)0xFFC03B00);
		debugfs_create_x16("NFC_DATA_RD", 0600, parent, (u16 *)0xFFC03B4C);
		debugfs_create_x16("NFC_DATA_WR", 0600, parent, (u16 *)0xFFC03B48);
		debugfs_create_x16("NFC_ECC0", 0600, parent, (u16 *)0xFFC03B10);
		debugfs_create_x16("NFC_ECC1", 0600, parent, (u16 *)0xFFC03B14);
		debugfs_create_x16("NFC_ECC2", 0600, parent, (u16 *)0xFFC03B18);
		debugfs_create_x16("NFC_ECC3", 0600, parent, (u16 *)0xFFC03B1C);
		debugfs_create_x16("NFC_IRQMASK", 0600, parent, (u16 *)0xFFC03B0C);
		debugfs_create_x16("NFC_IRQSTAT", 0600, parent, (u16 *)0xFFC03B08);
		debugfs_create_x16("NFC_PGCTL", 0600, parent, (u16 *)0xFFC03B28);
		debugfs_create_x16("NFC_READ", 0600, parent, (u16 *)0xFFC03B2C);
		debugfs_create_x16("NFC_RST", 0600, parent, (u16 *)0xFFC03B24);
		debugfs_create_x16("NFC_STAT", 0600, parent, (u16 *)0xFFC03B04);

		parent = debugfs_create_dir("OTP", top);
		debugfs_create_x16("OTP_BEN", 0600, parent, (u16 *)0xFFC04304);
		debugfs_create_x16("OTP_CONTROL", 0600, parent, (u16 *)0xFFC04300);
		debugfs_create_x32("OTP_DATA0", 0600, parent, (u32 *)0xFFC04380);
		debugfs_create_x32("OTP_DATA1", 0600, parent, (u32 *)0xFFC04384);
		debugfs_create_x32("OTP_DATA2", 0600, parent, (u32 *)0xFFC04388);
		debugfs_create_x32("OTP_DATA3", 0600, parent, (u32 *)0xFFC0438C);
		debugfs_create_x16("OTP_STATUS", 0600, parent, (u16 *)0xFFC04308);
		debugfs_create_x32("OTP_TIMING", 0600, parent, (u32 *)0xFFC0430C);

		parent = debugfs_create_dir("PINT_0", top);
		debugfs_create_x32("PINT0_ASSIGN", 0600, parent, (u32 *)0xFFC0140C);
		debugfs_create_x32("PINT0_EDGE_CLEAR", 0600, parent, (u32 *)0xFFC01414);
		debugfs_create_x32("PINT0_EDGE_SET", 0600, parent, (u32 *)0xFFC01410);
		debugfs_create_x32("PINT0_INVERT_CLEAR", 0600, parent, (u32 *)0xFFC0141C);
		debugfs_create_x32("PINT0_INVERT_SET", 0600, parent, (u32 *)0xFFC01418);
		debugfs_create_x32("PINT0_IRQ", 0600, parent, (u32 *)0xFFC01408);
		debugfs_create_x32("PINT0_LATCH", 0600, parent, (u32 *)0xFFC01424);
		debugfs_create_x32("PINT0_MASK_CLEAR", 0600, parent, (u32 *)0xFFC01404);
		debugfs_create_x32("PINT0_MASK_SET", 0600, parent, (u32 *)0xFFC01400);
		debugfs_create_x32("PINT0_PINSTATE", 0600, parent, (u32 *)0xFFC01420);

		parent = debugfs_create_dir("PINT_1", top);
		debugfs_create_x32("PINT1_ASSIGN", 0600, parent, (u32 *)0xFFC0143C);
		debugfs_create_x32("PINT1_EDGE_CLEAR", 0600, parent, (u32 *)0xFFC01444);
		debugfs_create_x32("PINT1_EDGE_SET", 0600, parent, (u32 *)0xFFC01440);
		debugfs_create_x32("PINT1_INVERT_CLEAR", 0600, parent, (u32 *)0xFFC0144C);
		debugfs_create_x32("PINT1_INVERT_SET", 0600, parent, (u32 *)0xFFC01448);
		debugfs_create_x32("PINT1_IRQ", 0600, parent, (u32 *)0xFFC01438);
		debugfs_create_x32("PINT1_LATCH", 0600, parent, (u32 *)0xFFC01454);
		debugfs_create_x32("PINT1_MASK_CLEAR", 0600, parent, (u32 *)0xFFC01434);
		debugfs_create_x32("PINT1_MASK_SET", 0600, parent, (u32 *)0xFFC01430);
		debugfs_create_x32("PINT1_PINSTATE", 0600, parent, (u32 *)0xFFC01450);

		parent = debugfs_create_dir("PINT_2", top);
		debugfs_create_x32("PINT2_ASSIGN", 0600, parent, (u32 *)0xFFC0146C);
		debugfs_create_x32("PINT2_EDGE_CLEAR", 0600, parent, (u32 *)0xFFC01474);
		debugfs_create_x32("PINT2_EDGE_SET", 0600, parent, (u32 *)0xFFC01470);
		debugfs_create_x32("PINT2_INVERT_CLEAR", 0600, parent, (u32 *)0xFFC0147C);
		debugfs_create_x32("PINT2_INVERT_SET", 0600, parent, (u32 *)0xFFC01478);
		debugfs_create_x32("PINT2_IRQ", 0600, parent, (u32 *)0xFFC01468);
		debugfs_create_x32("PINT2_LATCH", 0600, parent, (u32 *)0xFFC01484);
		debugfs_create_x32("PINT2_MASK_CLEAR", 0600, parent, (u32 *)0xFFC01464);
		debugfs_create_x32("PINT2_MASK_SET", 0600, parent, (u32 *)0xFFC01460);
		debugfs_create_x32("PINT2_PINSTATE", 0600, parent, (u32 *)0xFFC01480);

		parent = debugfs_create_dir("PINT_3", top);
		debugfs_create_x32("PINT3_ASSIGN", 0600, parent, (u32 *)0xFFC0149C);
		debugfs_create_x32("PINT3_EDGE_CLEAR", 0600, parent, (u32 *)0xFFC014A4);
		debugfs_create_x32("PINT3_EDGE_SET", 0600, parent, (u32 *)0xFFC014A0);
		debugfs_create_x32("PINT3_INVERT_CLEAR", 0600, parent, (u32 *)0xFFC014AC);
		debugfs_create_x32("PINT3_INVERT_SET", 0600, parent, (u32 *)0xFFC014A8);
		debugfs_create_x32("PINT3_IRQ", 0600, parent, (u32 *)0xFFC01498);
		debugfs_create_x32("PINT3_LATCH", 0600, parent, (u32 *)0xFFC014B4);
		debugfs_create_x32("PINT3_MASK_CLEAR", 0600, parent, (u32 *)0xFFC01494);
		debugfs_create_x32("PINT3_MASK_SET", 0600, parent, (u32 *)0xFFC01490);
		debugfs_create_x32("PINT3_PINSTATE", 0600, parent, (u32 *)0xFFC014B0);

		parent = debugfs_create_dir("PIXC", top);
		debugfs_create_x16("PIXC_AHEND", 0600, parent, (u16 *)0xFFC04410);
		debugfs_create_x16("PIXC_AHSTART", 0600, parent, (u16 *)0xFFC0440C);
		debugfs_create_x16("PIXC_ATRANSP", 0600, parent, (u16 *)0xFFC0441C);
		debugfs_create_x16("PIXC_AVEND", 0600, parent, (u16 *)0xFFC04418);
		debugfs_create_x16("PIXC_AVSTART", 0600, parent, (u16 *)0xFFC04414);
		debugfs_create_x16("PIXC_BHEND", 0600, parent, (u16 *)0xFFC04424);
		debugfs_create_x16("PIXC_BHSTART", 0600, parent, (u16 *)0xFFC04420);
		debugfs_create_x16("PIXC_BTRANSP", 0600, parent, (u16 *)0xFFC04430);
		debugfs_create_x32("PIXC_BVCON", 0600, parent, (u32 *)0xFFC04448);
		debugfs_create_x16("PIXC_BVEND", 0600, parent, (u16 *)0xFFC0442C);
		debugfs_create_x16("PIXC_BVSTART", 0600, parent, (u16 *)0xFFC04428);
		debugfs_create_x32("PIXC_CCBIAS", 0600, parent, (u32 *)0xFFC0444C);
		debugfs_create_x16("PIXC_CTL", 0600, parent, (u16 *)0xFFC04400);
		debugfs_create_x32("PIXC_GUCON", 0600, parent, (u32 *)0xFFC04444);
		debugfs_create_x16("PIXC_INTRSTAT", 0600, parent, (u16 *)0xFFC0443C);
		debugfs_create_x16("PIXC_LPF", 0600, parent, (u16 *)0xFFC04408);
		debugfs_create_x16("PIXC_PPL", 0600, parent, (u16 *)0xFFC04404);
		debugfs_create_x32("PIXC_RYCON", 0600, parent, (u32 *)0xFFC04440);
		debugfs_create_x32("PIXC_TC", 0600, parent, (u32 *)0xFFC04450);

		parent = debugfs_create_dir("PLL", top);
		debugfs_create_x16("PLL_CTL", 0600, parent, (u16 *)0xFFC00000);
		debugfs_create_x16("PLL_DIV", 0600, parent, (u16 *)0xFFC00004);
		debugfs_create_x16("PLL_LOCKCNT", 0600, parent, (u16 *)0xFFC00010);
		debugfs_create_x16("PLL_STAT", 0600, parent, (u16 *)0xFFC0000C);
		debugfs_create_x16("VR_CTL", 0600, parent, (u16 *)0xFFC00008);

		parent = debugfs_create_dir("PWM_TMR", top);
		debugfs_create_x16("TIMER0_CONFIG", 0600, parent, (u16 *)0xFFC01600);
		debugfs_create_x32("TIMER0_COUNTER", 0600, parent, (u32 *)0xFFC01604);
		debugfs_create_x32("TIMER0_PERIOD", 0600, parent, (u32 *)0xFFC01608);
		debugfs_create_x32("TIMER0_WIDTH", 0600, parent, (u32 *)0xFFC0160C);
		debugfs_create_x16("TIMER10_CONFIG", 0600, parent, (u16 *)0xFFC00620);
		debugfs_create_x32("TIMER10_COUNTER", 0600, parent, (u32 *)0xFFC00624);
		debugfs_create_x32("TIMER10_PERIOD", 0600, parent, (u32 *)0xFFC00628);
		debugfs_create_x32("TIMER10_WIDTH", 0600, parent, (u32 *)0xFFC0062C);
		debugfs_create_x16("TIMER1_CONFIG", 0600, parent, (u16 *)0xFFC01610);
		debugfs_create_x32("TIMER1_COUNTER", 0600, parent, (u32 *)0xFFC01614);
		debugfs_create_x32("TIMER1_PERIOD", 0600, parent, (u32 *)0xFFC01618);
		debugfs_create_x32("TIMER1_WIDTH", 0600, parent, (u32 *)0xFFC0161C);
		debugfs_create_x16("TIMER2_CONFIG", 0600, parent, (u16 *)0xFFC01620);
		debugfs_create_x32("TIMER2_COUNTER", 0600, parent, (u32 *)0xFFC01624);
		debugfs_create_x32("TIMER2_PERIOD", 0600, parent, (u32 *)0xFFC01628);
		debugfs_create_x32("TIMER2_WIDTH", 0600, parent, (u32 *)0xFFC0162C);
		debugfs_create_x16("TIMER3_CONFIG", 0600, parent, (u16 *)0xFFC01630);
		debugfs_create_x32("TIMER3_COUNTER", 0600, parent, (u32 *)0xFFC01634);
		debugfs_create_x32("TIMER3_PERIOD", 0600, parent, (u32 *)0xFFC01638);
		debugfs_create_x32("TIMER3_WIDTH", 0600, parent, (u32 *)0xFFC0163C);
		debugfs_create_x16("TIMER4_CONFIG", 0600, parent, (u16 *)0xFFC01640);
		debugfs_create_x32("TIMER4_COUNTER", 0600, parent, (u32 *)0xFFC01644);
		debugfs_create_x32("TIMER4_PERIOD", 0600, parent, (u32 *)0xFFC01648);
		debugfs_create_x32("TIMER4_WIDTH", 0600, parent, (u32 *)0xFFC0164C);
		debugfs_create_x16("TIMER5_CONFIG", 0600, parent, (u16 *)0xFFC01650);
		debugfs_create_x32("TIMER5_COUNTER", 0600, parent, (u32 *)0xFFC01654);
		debugfs_create_x32("TIMER5_PERIOD", 0600, parent, (u32 *)0xFFC01658);
		debugfs_create_x32("TIMER5_WIDTH", 0600, parent, (u32 *)0xFFC0165C);
		debugfs_create_x16("TIMER6_CONFIG", 0600, parent, (u16 *)0xFFC01660);
		debugfs_create_x32("TIMER6_COUNTER", 0600, parent, (u32 *)0xFFC01664);
		debugfs_create_x32("TIMER6_PERIOD", 0600, parent, (u32 *)0xFFC01668);
		debugfs_create_x32("TIMER6_WIDTH", 0600, parent, (u32 *)0xFFC0166C);
		debugfs_create_x16("TIMER7_CONFIG", 0600, parent, (u16 *)0xFFC01670);
		debugfs_create_x32("TIMER7_COUNTER", 0600, parent, (u32 *)0xFFC01674);
		debugfs_create_x32("TIMER7_PERIOD", 0600, parent, (u32 *)0xFFC01678);
		debugfs_create_x32("TIMER7_WIDTH", 0600, parent, (u32 *)0xFFC0167C);
		debugfs_create_x16("TIMER8_CONFIG", 0600, parent, (u16 *)0xFFC00600);
		debugfs_create_x32("TIMER8_COUNTER", 0600, parent, (u32 *)0xFFC00604);
		debugfs_create_x32("TIMER8_PERIOD", 0600, parent, (u32 *)0xFFC00608);
		debugfs_create_x32("TIMER8_WIDTH", 0600, parent, (u32 *)0xFFC0060C);
		debugfs_create_x16("TIMER9_CONFIG", 0600, parent, (u16 *)0xFFC00610);
		debugfs_create_x32("TIMER9_COUNTER", 0600, parent, (u32 *)0xFFC00614);
		debugfs_create_x32("TIMER9_PERIOD", 0600, parent, (u32 *)0xFFC00618);
		debugfs_create_x32("TIMER9_WIDTH", 0600, parent, (u32 *)0xFFC0061C);
		debugfs_create_x16("TIMER_DISABLE0", 0600, parent, (u16 *)0xFFC01684);
		debugfs_create_x16("TIMER_DISABLE1", 0600, parent, (u16 *)0xFFC00644);
		debugfs_create_x16("TIMER_ENABLE0", 0600, parent, (u16 *)0xFFC01680);
		debugfs_create_x16("TIMER_ENABLE1", 0600, parent, (u16 *)0xFFC00640);
		debugfs_create_x32("TIMER_STATUS0", 0600, parent, (u32 *)0xFFC01688);
		debugfs_create_x32("TIMER_STATUS1", 0600, parent, (u32 *)0xFFC00648);

		parent = debugfs_create_dir("Port_A", top);
		debugfs_create_x16("PORTA", 0600, parent, (u16 *)0xFFC014C4);
		debugfs_create_x16("PORTA_CLEAR", 0600, parent, (u16 *)0xFFC014CC);
		debugfs_create_x16("PORTA_DIR_CLEAR", 0600, parent, (u16 *)0xFFC014D4);
		debugfs_create_x16("PORTA_DIR_SET", 0600, parent, (u16 *)0xFFC014D0);
		debugfs_create_x16("PORTA_FER", 0600, parent, (u16 *)0xFFC014C0);
		debugfs_create_x16("PORTA_INEN", 0600, parent, (u16 *)0xFFC014D8);
		debugfs_create_x32("PORTA_MUX", 0600, parent, (u32 *)0xFFC014DC);
		debugfs_create_x16("PORTA_SET", 0600, parent, (u16 *)0xFFC014C8);

		parent = debugfs_create_dir("Port_B", top);
		debugfs_create_x16("PORTB", 0600, parent, (u16 *)0xFFC014E4);
		debugfs_create_x16("PORTB_CLEAR", 0600, parent, (u16 *)0xFFC014EC);
		debugfs_create_x16("PORTB_DIR_CLEAR", 0600, parent, (u16 *)0xFFC014F4);
		debugfs_create_x16("PORTB_DIR_SET", 0600, parent, (u16 *)0xFFC014F0);
		debugfs_create_x16("PORTB_FER", 0600, parent, (u16 *)0xFFC014E0);
		debugfs_create_x16("PORTB_INEN", 0600, parent, (u16 *)0xFFC014F8);
		debugfs_create_x32("PORTB_MUX", 0600, parent, (u32 *)0xFFC014FC);
		debugfs_create_x16("PORTB_SET", 0600, parent, (u16 *)0xFFC014E8);

		parent = debugfs_create_dir("Port_C", top);
		debugfs_create_x16("PORTC", 0600, parent, (u16 *)0xFFC01504);
		debugfs_create_x16("PORTC_CLEAR", 0600, parent, (u16 *)0xFFC0150C);
		debugfs_create_x16("PORTC_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01514);
		debugfs_create_x16("PORTC_DIR_SET", 0600, parent, (u16 *)0xFFC01510);
		debugfs_create_x16("PORTC_FER", 0600, parent, (u16 *)0xFFC01500);
		debugfs_create_x16("PORTC_INEN", 0600, parent, (u16 *)0xFFC01518);
		debugfs_create_x32("PORTC_MUX", 0600, parent, (u32 *)0xFFC0151C);
		debugfs_create_x16("PORTC_SET", 0600, parent, (u16 *)0xFFC01508);

		parent = debugfs_create_dir("Port_D", top);
		debugfs_create_x16("PORTD", 0600, parent, (u16 *)0xFFC01524);
		debugfs_create_x16("PORTD_CLEAR", 0600, parent, (u16 *)0xFFC0152C);
		debugfs_create_x16("PORTD_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01534);
		debugfs_create_x16("PORTD_DIR_SET", 0600, parent, (u16 *)0xFFC01530);
		debugfs_create_x16("PORTD_FER", 0600, parent, (u16 *)0xFFC01520);
		debugfs_create_x16("PORTD_INEN", 0600, parent, (u16 *)0xFFC01538);
		debugfs_create_x32("PORTD_MUX", 0600, parent, (u32 *)0xFFC0153C);
		debugfs_create_x16("PORTD_SET", 0600, parent, (u16 *)0xFFC01528);

		parent = debugfs_create_dir("Port_E", top);
		debugfs_create_x16("PORTE", 0600, parent, (u16 *)0xFFC01544);
		debugfs_create_x16("PORTE_CLEAR", 0600, parent, (u16 *)0xFFC0154C);
		debugfs_create_x16("PORTE_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01554);
		debugfs_create_x16("PORTE_DIR_SET", 0600, parent, (u16 *)0xFFC01550);
		debugfs_create_x16("PORTE_FER", 0600, parent, (u16 *)0xFFC01540);
		debugfs_create_x16("PORTE_INEN", 0600, parent, (u16 *)0xFFC01558);
		debugfs_create_x32("PORTE_MUX", 0600, parent, (u32 *)0xFFC0155C);
		debugfs_create_x16("PORTE_SET", 0600, parent, (u16 *)0xFFC01548);

		parent = debugfs_create_dir("Port_F", top);
		debugfs_create_x16("PORTF", 0600, parent, (u16 *)0xFFC01564);
		debugfs_create_x16("PORTF_CLEAR", 0600, parent, (u16 *)0xFFC0156C);
		debugfs_create_x16("PORTF_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01574);
		debugfs_create_x16("PORTF_DIR_SET", 0600, parent, (u16 *)0xFFC01570);
		debugfs_create_x16("PORTF_FER", 0600, parent, (u16 *)0xFFC01560);
		debugfs_create_x16("PORTF_INEN", 0600, parent, (u16 *)0xFFC01578);
		debugfs_create_x32("PORTF_MUX", 0600, parent, (u32 *)0xFFC0157C);
		debugfs_create_x16("PORTF_SET", 0600, parent, (u16 *)0xFFC01568);

		parent = debugfs_create_dir("Port_G", top);
		debugfs_create_x16("PORTG", 0600, parent, (u16 *)0xFFC01584);
		debugfs_create_x16("PORTG_CLEAR", 0600, parent, (u16 *)0xFFC0158C);
		debugfs_create_x16("PORTG_DIR_CLEAR", 0600, parent, (u16 *)0xFFC01594);
		debugfs_create_x16("PORTG_DIR_SET", 0600, parent, (u16 *)0xFFC01590);
		debugfs_create_x16("PORTG_FER", 0600, parent, (u16 *)0xFFC01580);
		debugfs_create_x16("PORTG_INEN", 0600, parent, (u16 *)0xFFC01598);
		debugfs_create_x32("PORTG_MUX", 0600, parent, (u32 *)0xFFC0159C);
		debugfs_create_x16("PORTG_SET", 0600, parent, (u16 *)0xFFC01588);

		parent = debugfs_create_dir("Port_H", top);
		debugfs_create_x16("PORTH", 0600, parent, (u16 *)0xFFC015A4);
		debugfs_create_x16("PORTH_CLEAR", 0600, parent, (u16 *)0xFFC015AC);
		debugfs_create_x16("PORTH_DIR_CLEAR", 0600, parent, (u16 *)0xFFC015B4);
		debugfs_create_x16("PORTH_DIR_SET", 0600, parent, (u16 *)0xFFC015B0);
		debugfs_create_x16("PORTH_FER", 0600, parent, (u16 *)0xFFC015A0);
		debugfs_create_x16("PORTH_INEN", 0600, parent, (u16 *)0xFFC015B8);
		debugfs_create_x32("PORTH_MUX", 0600, parent, (u32 *)0xFFC015BC);
		debugfs_create_x16("PORTH_SET", 0600, parent, (u16 *)0xFFC015A8);

		parent = debugfs_create_dir("Port_I", top);
		debugfs_create_x16("PORTI", 0600, parent, (u16 *)0xFFC015C4);
		debugfs_create_x16("PORTI_CLEAR", 0600, parent, (u16 *)0xFFC015CC);
		debugfs_create_x16("PORTI_DIR_CLEAR", 0600, parent, (u16 *)0xFFC015D4);
		debugfs_create_x16("PORTI_DIR_SET", 0600, parent, (u16 *)0xFFC015D0);
		debugfs_create_x16("PORTI_FER", 0600, parent, (u16 *)0xFFC015C0);
		debugfs_create_x16("PORTI_INEN", 0600, parent, (u16 *)0xFFC015D8);
		debugfs_create_x32("PORTI_MUX", 0600, parent, (u32 *)0xFFC015DC);
		debugfs_create_x16("PORTI_SET", 0600, parent, (u16 *)0xFFC015C8);

		parent = debugfs_create_dir("Port_J", top);
		debugfs_create_x16("PORTJ", 0600, parent, (u16 *)0xFFC015E4);
		debugfs_create_x16("PORTJ_CLEAR", 0600, parent, (u16 *)0xFFC015EC);
		debugfs_create_x16("PORTJ_DIR_CLEAR", 0600, parent, (u16 *)0xFFC015F4);
		debugfs_create_x16("PORTJ_DIR_SET", 0600, parent, (u16 *)0xFFC015F0);
		debugfs_create_x16("PORTJ_FER", 0600, parent, (u16 *)0xFFC015E0);
		debugfs_create_x16("PORTJ_INEN", 0600, parent, (u16 *)0xFFC015F8);
		debugfs_create_x32("PORTJ_MUX", 0600, parent, (u32 *)0xFFC015FC);
		debugfs_create_x16("PORTJ_SET", 0600, parent, (u16 *)0xFFC015E8);

		parent = debugfs_create_dir("RTC", top);
		debugfs_create_x32("RTC_ALARM", 0600, parent, (u32 *)0xFFC00310);
		debugfs_create_x16("RTC_ICTL", 0600, parent, (u16 *)0xFFC00304);
		debugfs_create_x16("RTC_ISTAT", 0600, parent, (u16 *)0xFFC00308);
		debugfs_create_x16("RTC_PREN", 0600, parent, (u16 *)0xFFC00314);
		debugfs_create_x32("RTC_STAT", 0600, parent, (u32 *)0xFFC00300);
		debugfs_create_x16("RTC_SWCNT", 0600, parent, (u16 *)0xFFC0030C);

		parent = debugfs_create_dir("SDH", top);
		debugfs_create_x32("SDH_ARGUMENT", 0600, parent, (u32 *)0xFFC03908);
		debugfs_create_x16("SDH_CFG", 0600, parent, (u16 *)0xFFC039C8);
		debugfs_create_x16("SDH_CLK_CTL", 0600, parent, (u16 *)0xFFC03904);
		debugfs_create_x16("SDH_COMMAND", 0600, parent, (u16 *)0xFFC0390C);
		debugfs_create_x16("SDH_DATA_CNT", 0600, parent, (u16 *)0xFFC03930);
		debugfs_create_x16("SDH_DATA_CTL", 0600, parent, (u16 *)0xFFC0392C);
		debugfs_create_x16("SDH_DATA_LGTH", 0600, parent, (u16 *)0xFFC03928);
		debugfs_create_x32("SDH_DATA_TIMER", 0600, parent, (u32 *)0xFFC03924);
		debugfs_create_x16("SDH_E_MASK", 0600, parent, (u16 *)0xFFC039C4);
		debugfs_create_x16("SDH_E_STATUS", 0600, parent, (u16 *)0xFFC039C0);
		debugfs_create_x32("SDH_FIFO", 0600, parent, (u32 *)0xFFC03980);
		debugfs_create_x16("SDH_FIFO_CNT", 0600, parent, (u16 *)0xFFC03948);
		debugfs_create_x32("SDH_MASK0", 0600, parent, (u32 *)0xFFC0393C);
		debugfs_create_x32("SDH_MASK1", 0600, parent, (u32 *)0xFFC03940);
		debugfs_create_x16("SDH_PID0", 0600, parent, (u16 *)0xFFC039D0);
		debugfs_create_x16("SDH_PID1", 0600, parent, (u16 *)0xFFC039D4);
		debugfs_create_x16("SDH_PID2", 0600, parent, (u16 *)0xFFC039D8);
		debugfs_create_x16("SDH_PID3", 0600, parent, (u16 *)0xFFC039DC);
		debugfs_create_x16("SDH_PID4", 0600, parent, (u16 *)0xFFC039E0);
		debugfs_create_x16("SDH_PID5", 0600, parent, (u16 *)0xFFC039E4);
		debugfs_create_x16("SDH_PID6", 0600, parent, (u16 *)0xFFC039E8);
		debugfs_create_x16("SDH_PID7", 0600, parent, (u16 *)0xFFC039EC);
		debugfs_create_x16("SDH_PWR_CTL", 0600, parent, (u16 *)0xFFC03900);
		debugfs_create_x16("SDH_RD_WAIT_EN", 0600, parent, (u16 *)0xFFC039CC);
		debugfs_create_x32("SDH_RESPONSE0", 0600, parent, (u32 *)0xFFC03914);
		debugfs_create_x32("SDH_RESPONSE1", 0600, parent, (u32 *)0xFFC03918);
		debugfs_create_x32("SDH_RESPONSE2", 0600, parent, (u32 *)0xFFC0391C);
		debugfs_create_x32("SDH_RESPONSE3", 0600, parent, (u32 *)0xFFC03920);
		debugfs_create_x16("SDH_RESP_CMD", 0600, parent, (u16 *)0xFFC03910);
		debugfs_create_x32("SDH_STATUS", 0600, parent, (u32 *)0xFFC03934);
		debugfs_create_x16("SDH_STATUS_CLR", 0600, parent, (u16 *)0xFFC03938);

		parent = debugfs_create_dir("SIC", top);
		debugfs_create_x32("SIC_IAR0", 0600, parent, (u32 *)0xFFC00130);
		debugfs_create_x32("SIC_IAR10", 0600, parent, (u32 *)0xFFC00158);
		debugfs_create_x32("SIC_IAR11", 0600, parent, (u32 *)0xFFC0015C);
		debugfs_create_x32("SIC_IAR1", 0600, parent, (u32 *)0xFFC00134);
		debugfs_create_x32("SIC_IAR2", 0600, parent, (u32 *)0xFFC00138);
		debugfs_create_x32("SIC_IAR3", 0600, parent, (u32 *)0xFFC0013C);
		debugfs_create_x32("SIC_IAR4", 0600, parent, (u32 *)0xFFC00140);
		debugfs_create_x32("SIC_IAR5", 0600, parent, (u32 *)0xFFC00144);
		debugfs_create_x32("SIC_IAR6", 0600, parent, (u32 *)0xFFC00148);
		debugfs_create_x32("SIC_IAR7", 0600, parent, (u32 *)0xFFC0014C);
		debugfs_create_x32("SIC_IAR8", 0600, parent, (u32 *)0xFFC00150);
		debugfs_create_x32("SIC_IAR9", 0600, parent, (u32 *)0xFFC00154);
		debugfs_create_x32("SIC_IMASK0", 0600, parent, (u32 *)0xFFC0010C);
		debugfs_create_x32("SIC_IMASK1", 0600, parent, (u32 *)0xFFC00110);
		debugfs_create_x32("SIC_IMASK2", 0600, parent, (u32 *)0xFFC00114);
		debugfs_create_x32("SIC_ISR0", 0600, parent, (u32 *)0xFFC00118);
		debugfs_create_x32("SIC_ISR1", 0600, parent, (u32 *)0xFFC0011C);
		debugfs_create_x32("SIC_ISR2", 0600, parent, (u32 *)0xFFC00120);
		debugfs_create_x32("SIC_IWR0", 0600, parent, (u32 *)0xFFC00124);
		debugfs_create_x32("SIC_IWR1", 0600, parent, (u32 *)0xFFC00128);
		debugfs_create_x32("SIC_IWR2", 0600, parent, (u32 *)0xFFC0012C);

		parent = debugfs_create_dir("SPI", top);
		debugfs_create_x16("SPI0_BAUD", 0600, parent, (u16 *)0xFFC00514);
		debugfs_create_x16("SPI0_CTL", 0600, parent, (u16 *)0xFFC00500);
		debugfs_create_x16("SPI0_FLG", 0600, parent, (u16 *)0xFFC00504);
		debugfs_create_x16("SPI0_RDBR", 0600, parent, (u16 *)0xFFC00510);
		debugfs_create_x16("SPI0_SHADOW", 0600, parent, (u16 *)0xFFC00518);
		debugfs_create_x16("SPI0_STAT", 0600, parent, (u16 *)0xFFC00508);
		debugfs_create_x16("SPI0_TDBR", 0600, parent, (u16 *)0xFFC0050C);
		debugfs_create_x16("SPI1_BAUD", 0600, parent, (u16 *)0xFFC02314);
		debugfs_create_x16("SPI1_CTL", 0600, parent, (u16 *)0xFFC02300);
		debugfs_create_x16("SPI1_FLG", 0600, parent, (u16 *)0xFFC02304);
		debugfs_create_x16("SPI1_RDBR", 0600, parent, (u16 *)0xFFC02310);
		debugfs_create_x16("SPI1_SHADOW", 0600, parent, (u16 *)0xFFC02318);
		debugfs_create_x16("SPI1_STAT", 0600, parent, (u16 *)0xFFC02308);
		debugfs_create_x16("SPI1_TDBR", 0600, parent, (u16 *)0xFFC0230C);
		debugfs_create_x16("SPI2_BAUD", 0600, parent, (u16 *)0xFFC02414);
		debugfs_create_x16("SPI2_CTL", 0600, parent, (u16 *)0xFFC02400);
		debugfs_create_x16("SPI2_FLG", 0600, parent, (u16 *)0xFFC02404);
		debugfs_create_x16("SPI2_RDBR", 0600, parent, (u16 *)0xFFC02410);
		debugfs_create_x16("SPI2_SHADOW", 0600, parent, (u16 *)0xFFC02418);
		debugfs_create_x16("SPI2_STAT", 0600, parent, (u16 *)0xFFC02408);
		debugfs_create_x16("SPI2_TDBR", 0600, parent, (u16 *)0xFFC0240C);

		parent = debugfs_create_dir("SPORT", top);
		debugfs_create_x16("SPORT0_CHNL", 0600, parent, (u16 *)0xFFC00834);
		debugfs_create_x16("SPORT0_MCMC1", 0600, parent, (u16 *)0xFFC00838);
		debugfs_create_x16("SPORT0_MCMC2", 0600, parent, (u16 *)0xFFC0083C);
		debugfs_create_x32("SPORT0_MRCS0", 0600, parent, (u32 *)0xFFC00850);
		debugfs_create_x32("SPORT0_MRCS1", 0600, parent, (u32 *)0xFFC00854);
		debugfs_create_x32("SPORT0_MRCS2", 0600, parent, (u32 *)0xFFC00858);
		debugfs_create_x32("SPORT0_MRCS3", 0600, parent, (u32 *)0xFFC0085C);
		debugfs_create_x32("SPORT0_MTCS0", 0600, parent, (u32 *)0xFFC00840);
		debugfs_create_x32("SPORT0_MTCS1", 0600, parent, (u32 *)0xFFC00844);
		debugfs_create_x32("SPORT0_MTCS2", 0600, parent, (u32 *)0xFFC00848);
		debugfs_create_x32("SPORT0_MTCS3", 0600, parent, (u32 *)0xFFC0084C);
		debugfs_create_x16("SPORT0_RCLKDIV", 0600, parent, (u16 *)0xFFC00828);
		debugfs_create_x16("SPORT0_RCR1", 0600, parent, (u16 *)0xFFC00820);
		debugfs_create_x16("SPORT0_RCR2", 0600, parent, (u16 *)0xFFC00824);
		debugfs_create_x16("SPORT0_RFSDIV", 0600, parent, (u16 *)0xFFC0082C);
		debugfs_create_x32("SPORT0_RX", 0600, parent, (u32 *)0xFFC00818);
		debugfs_create_x16("SPORT0_STAT", 0600, parent, (u16 *)0xFFC00830);
		debugfs_create_x16("SPORT0_TCLKDIV", 0600, parent, (u16 *)0xFFC00808);
		debugfs_create_x16("SPORT0_TCR1", 0600, parent, (u16 *)0xFFC00800);
		debugfs_create_x16("SPORT0_TCR2", 0600, parent, (u16 *)0xFFC00804);
		debugfs_create_x16("SPORT0_TFSDIV", 0600, parent, (u16 *)0xFFC0080C);
		debugfs_create_x32("SPORT0_TX", 0600, parent, (u32 *)0xFFC00810);
		debugfs_create_x16("SPORT1_CHNL", 0600, parent, (u16 *)0xFFC00934);
		debugfs_create_x16("SPORT1_MCMC1", 0600, parent, (u16 *)0xFFC00938);
		debugfs_create_x16("SPORT1_MCMC2", 0600, parent, (u16 *)0xFFC0093C);
		debugfs_create_x32("SPORT1_MRCS0", 0600, parent, (u32 *)0xFFC00950);
		debugfs_create_x32("SPORT1_MRCS1", 0600, parent, (u32 *)0xFFC00954);
		debugfs_create_x32("SPORT1_MRCS2", 0600, parent, (u32 *)0xFFC00958);
		debugfs_create_x32("SPORT1_MRCS3", 0600, parent, (u32 *)0xFFC0095C);
		debugfs_create_x32("SPORT1_MTCS0", 0600, parent, (u32 *)0xFFC00940);
		debugfs_create_x32("SPORT1_MTCS1", 0600, parent, (u32 *)0xFFC00944);
		debugfs_create_x32("SPORT1_MTCS2", 0600, parent, (u32 *)0xFFC00948);
		debugfs_create_x32("SPORT1_MTCS3", 0600, parent, (u32 *)0xFFC0094C);
		debugfs_create_x16("SPORT1_RCLKDIV", 0600, parent, (u16 *)0xFFC00928);
		debugfs_create_x16("SPORT1_RCR1", 0600, parent, (u16 *)0xFFC00920);
		debugfs_create_x16("SPORT1_RCR2", 0600, parent, (u16 *)0xFFC00924);
		debugfs_create_x16("SPORT1_RFSDIV", 0600, parent, (u16 *)0xFFC0092C);
		debugfs_create_x32("SPORT1_RX", 0600, parent, (u32 *)0xFFC00918);
		debugfs_create_x16("SPORT1_STAT", 0600, parent, (u16 *)0xFFC00930);
		debugfs_create_x16("SPORT1_TCLKDIV", 0600, parent, (u16 *)0xFFC00908);
		debugfs_create_x16("SPORT1_TCR1", 0600, parent, (u16 *)0xFFC00900);
		debugfs_create_x16("SPORT1_TCR2", 0600, parent, (u16 *)0xFFC00904);
		debugfs_create_x16("SPORT1_TFSDIV", 0600, parent, (u16 *)0xFFC0090C);
		debugfs_create_x32("SPORT1_TX", 0600, parent, (u32 *)0xFFC00910);
		debugfs_create_x16("SPORT2_CHNL", 0600, parent, (u16 *)0xFFC02534);
		debugfs_create_x16("SPORT2_MCMC1", 0600, parent, (u16 *)0xFFC02538);
		debugfs_create_x16("SPORT2_MCMC2", 0600, parent, (u16 *)0xFFC0253C);
		debugfs_create_x32("SPORT2_MRCS0", 0600, parent, (u32 *)0xFFC02550);
		debugfs_create_x32("SPORT2_MRCS1", 0600, parent, (u32 *)0xFFC02554);
		debugfs_create_x32("SPORT2_MRCS2", 0600, parent, (u32 *)0xFFC02558);
		debugfs_create_x32("SPORT2_MRCS3", 0600, parent, (u32 *)0xFFC0255C);
		debugfs_create_x32("SPORT2_MTCS0", 0600, parent, (u32 *)0xFFC02540);
		debugfs_create_x32("SPORT2_MTCS1", 0600, parent, (u32 *)0xFFC02544);
		debugfs_create_x32("SPORT2_MTCS2", 0600, parent, (u32 *)0xFFC02548);
		debugfs_create_x32("SPORT2_MTCS3", 0600, parent, (u32 *)0xFFC0254C);
		debugfs_create_x16("SPORT2_RCLKDIV", 0600, parent, (u16 *)0xFFC02528);
		debugfs_create_x16("SPORT2_RCR1", 0600, parent, (u16 *)0xFFC02520);
		debugfs_create_x16("SPORT2_RCR2", 0600, parent, (u16 *)0xFFC02524);
		debugfs_create_x16("SPORT2_RFSDIV", 0600, parent, (u16 *)0xFFC0252C);
		debugfs_create_x32("SPORT2_RX", 0600, parent, (u32 *)0xFFC02518);
		debugfs_create_x16("SPORT2_STAT", 0600, parent, (u16 *)0xFFC02530);
		debugfs_create_x16("SPORT2_TCLKDIV", 0600, parent, (u16 *)0xFFC02508);
		debugfs_create_x16("SPORT2_TCR1", 0600, parent, (u16 *)0xFFC02500);
		debugfs_create_x16("SPORT2_TCR2", 0600, parent, (u16 *)0xFFC02504);
		debugfs_create_x16("SPORT2_TFSDIV", 0600, parent, (u16 *)0xFFC0250C);
		debugfs_create_x32("SPORT2_TX", 0600, parent, (u32 *)0xFFC02510);
		debugfs_create_x16("SPORT3_CHNL", 0600, parent, (u16 *)0xFFC02634);
		debugfs_create_x16("SPORT3_MCMC1", 0600, parent, (u16 *)0xFFC02638);
		debugfs_create_x16("SPORT3_MCMC2", 0600, parent, (u16 *)0xFFC0263C);
		debugfs_create_x32("SPORT3_MRCS0", 0600, parent, (u32 *)0xFFC02650);
		debugfs_create_x32("SPORT3_MRCS1", 0600, parent, (u32 *)0xFFC02654);
		debugfs_create_x32("SPORT3_MRCS2", 0600, parent, (u32 *)0xFFC02658);
		debugfs_create_x32("SPORT3_MRCS3", 0600, parent, (u32 *)0xFFC0265C);
		debugfs_create_x32("SPORT3_MTCS0", 0600, parent, (u32 *)0xFFC02640);
		debugfs_create_x32("SPORT3_MTCS1", 0600, parent, (u32 *)0xFFC02644);
		debugfs_create_x32("SPORT3_MTCS2", 0600, parent, (u32 *)0xFFC02648);
		debugfs_create_x32("SPORT3_MTCS3", 0600, parent, (u32 *)0xFFC0264C);
		debugfs_create_x16("SPORT3_RCLKDIV", 0600, parent, (u16 *)0xFFC02628);
		debugfs_create_x16("SPORT3_RCR1", 0600, parent, (u16 *)0xFFC02620);
		debugfs_create_x16("SPORT3_RCR2", 0600, parent, (u16 *)0xFFC02624);
		debugfs_create_x16("SPORT3_RFSDIV", 0600, parent, (u16 *)0xFFC0262C);
		debugfs_create_x32("SPORT3_RX", 0600, parent, (u32 *)0xFFC02618);
		debugfs_create_x16("SPORT3_STAT", 0600, parent, (u16 *)0xFFC02630);
		debugfs_create_x16("SPORT3_TCLKDIV", 0600, parent, (u16 *)0xFFC02608);
		debugfs_create_x16("SPORT3_TCR1", 0600, parent, (u16 *)0xFFC02600);
		debugfs_create_x16("SPORT3_TCR2", 0600, parent, (u16 *)0xFFC02604);
		debugfs_create_x16("SPORT3_TFSDIV", 0600, parent, (u16 *)0xFFC0260C);
		debugfs_create_x32("SPORT3_TX", 0600, parent, (u32 *)0xFFC02610);

		parent = debugfs_create_dir("Security", top);
		debugfs_create_x16("SECURE_CONTROL", 0600, parent, (u16 *)0xFFC04324);
		debugfs_create_x16("SECURE_STATUS", 0600, parent, (u16 *)0xFFC04328);
		debugfs_create_x32("SECURE_SYSSWT", 0600, parent, (u32 *)0xFFC04320);

		parent = debugfs_create_dir("System Reset and Interrupt Control Registers", top);
		debugfs_create_x16("SWRST", 0600, parent, (u16 *)0xFFC00100);
		debugfs_create_x16("SYSCR", 0600, parent, (u16 *)0xFFC00104);

		parent = debugfs_create_dir("TWI", top);
		debugfs_create_x16("TWI0_CLKDIV", 0600, parent, (u16 *)0xFFC00700);
		debugfs_create_x16("TWI0_CONTROL", 0600, parent, (u16 *)0xFFC00704);
		debugfs_create_x16("TWI0_FIFO_CTL", 0600, parent, (u16 *)0xFFC00728);
		debugfs_create_x16("TWI0_FIFO_STAT", 0600, parent, (u16 *)0xFFC0072C);
		debugfs_create_x16("TWI0_INT_MASK", 0600, parent, (u16 *)0xFFC00724);
		debugfs_create_x16("TWI0_INT_STAT", 0600, parent, (u16 *)0xFFC00720);
		debugfs_create_x16("TWI0_MASTER_ADDR", 0600, parent, (u16 *)0xFFC0071C);
		debugfs_create_x16("TWI0_MASTER_CTL", 0600, parent, (u16 *)0xFFC00714);
		debugfs_create_x16("TWI0_MASTER_STAT", 0600, parent, (u16 *)0xFFC00718);
		debugfs_create_x16("TWI0_RCV_DATA16", 0600, parent, (u16 *)0xFFC0078C);
		debugfs_create_x16("TWI0_RCV_DATA8", 0600, parent, (u16 *)0xFFC00788);
		debugfs_create_x16("TWI0_SLAVE_ADDR", 0600, parent, (u16 *)0xFFC00710);
		debugfs_create_x16("TWI0_SLAVE_CTL", 0600, parent, (u16 *)0xFFC00708);
		debugfs_create_x16("TWI0_SLAVE_STAT", 0600, parent, (u16 *)0xFFC0070C);
		debugfs_create_x16("TWI0_XMT_DATA16", 0600, parent, (u16 *)0xFFC00784);
		debugfs_create_x16("TWI0_XMT_DATA8", 0600, parent, (u16 *)0xFFC00780);
		debugfs_create_x16("TWI1_CLKDIV", 0600, parent, (u16 *)0xFFC02200);
		debugfs_create_x16("TWI1_CONTROL", 0600, parent, (u16 *)0xFFC02204);
		debugfs_create_x16("TWI1_FIFO_CTL", 0600, parent, (u16 *)0xFFC02228);
		debugfs_create_x16("TWI1_FIFO_STAT", 0600, parent, (u16 *)0xFFC0222C);
		debugfs_create_x16("TWI1_INT_MASK", 0600, parent, (u16 *)0xFFC02224);
		debugfs_create_x16("TWI1_INT_STAT", 0600, parent, (u16 *)0xFFC02220);
		debugfs_create_x16("TWI1_MASTER_ADDR", 0600, parent, (u16 *)0xFFC0221C);
		debugfs_create_x16("TWI1_MASTER_CTL", 0600, parent, (u16 *)0xFFC02214);
		debugfs_create_x16("TWI1_MASTER_STAT", 0600, parent, (u16 *)0xFFC02218);
		debugfs_create_x16("TWI1_RCV_DATA16", 0600, parent, (u16 *)0xFFC0228C);
		debugfs_create_x16("TWI1_RCV_DATA8", 0600, parent, (u16 *)0xFFC02288);
		debugfs_create_x16("TWI1_SLAVE_ADDR", 0600, parent, (u16 *)0xFFC02210);
		debugfs_create_x16("TWI1_SLAVE_CTL", 0600, parent, (u16 *)0xFFC02208);
		debugfs_create_x16("TWI1_SLAVE_STAT", 0600, parent, (u16 *)0xFFC0220C);
		debugfs_create_x16("TWI1_XMT_DATA16", 0600, parent, (u16 *)0xFFC02284);
		debugfs_create_x16("TWI1_XMT_DATA8", 0600, parent, (u16 *)0xFFC02280);

		parent = debugfs_create_dir("UART", top);
		debugfs_create_x16("UART0_DLH", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART0_DLL", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART0_GCTL", 0600, parent, (u16 *)0xFFC00408);
		debugfs_create_x16("UART0_IER_CLEAR", 0600, parent, (u16 *)0xFFC00424);
		debugfs_create_x16("UART0_IER_SET", 0600, parent, (u16 *)0xFFC00420);
		debugfs_create_x16("UART0_LCR", 0600, parent, (u16 *)0xFFC0040C);
		debugfs_create_x16("UART0_LSR", 0600, parent, (u16 *)0xFFC00414);
		debugfs_create_x16("UART0_MCR", 0600, parent, (u16 *)0xFFC00410);
		debugfs_create_x16("UART0_MSR", 0600, parent, (u16 *)0xFFC00418);
		debugfs_create_x16("UART0_RBR", 0600, parent, (u16 *)0xFFC0042C);
		debugfs_create_x16("UART0_SCR", 0600, parent, (u16 *)0xFFC0041C);
		debugfs_create_x16("UART0_THR", 0600, parent, (u16 *)0xFFC00428);
		debugfs_create_x16("UART1_DLH", 0600, parent, (u16 *)0xFFC02004);
		debugfs_create_x16("UART1_DLL", 0600, parent, (u16 *)0xFFC02000);
		debugfs_create_x16("UART1_GCTL", 0600, parent, (u16 *)0xFFC02008);
		debugfs_create_x16("UART1_IER_CLEAR", 0600, parent, (u16 *)0xFFC02024);
		debugfs_create_x16("UART1_IER_SET", 0600, parent, (u16 *)0xFFC02020);
		debugfs_create_x16("UART1_LCR", 0600, parent, (u16 *)0xFFC0200C);
		debugfs_create_x16("UART1_LSR", 0600, parent, (u16 *)0xFFC02014);
		debugfs_create_x16("UART1_MCR", 0600, parent, (u16 *)0xFFC02010);
		debugfs_create_x16("UART1_MSR", 0600, parent, (u16 *)0xFFC02018);
		debugfs_create_x16("UART1_RBR", 0600, parent, (u16 *)0xFFC0202C);
		debugfs_create_x16("UART1_SCR", 0600, parent, (u16 *)0xFFC0201C);
		debugfs_create_x16("UART1_THR", 0600, parent, (u16 *)0xFFC02028);
		debugfs_create_x16("UART2_DLH", 0600, parent, (u16 *)0xFFC02104);
		debugfs_create_x16("UART2_DLL", 0600, parent, (u16 *)0xFFC02100);
		debugfs_create_x16("UART2_GCTL", 0600, parent, (u16 *)0xFFC02108);
		debugfs_create_x16("UART2_IER_CLEAR", 0600, parent, (u16 *)0xFFC02124);
		debugfs_create_x16("UART2_IER_SET", 0600, parent, (u16 *)0xFFC02120);
		debugfs_create_x16("UART2_LCR", 0600, parent, (u16 *)0xFFC0210C);
		debugfs_create_x16("UART2_LSR", 0600, parent, (u16 *)0xFFC02114);
		debugfs_create_x16("UART2_MCR", 0600, parent, (u16 *)0xFFC02110);
		debugfs_create_x16("UART2_MSR", 0600, parent, (u16 *)0xFFC02118);
		debugfs_create_x16("UART2_RBR", 0600, parent, (u16 *)0xFFC0212C);
		debugfs_create_x16("UART2_SCR", 0600, parent, (u16 *)0xFFC0211C);
		debugfs_create_x16("UART2_THR", 0600, parent, (u16 *)0xFFC02128);
		debugfs_create_x16("UART3_DLH", 0600, parent, (u16 *)0xFFC03104);
		debugfs_create_x16("UART3_DLL", 0600, parent, (u16 *)0xFFC03100);
		debugfs_create_x16("UART3_GCTL", 0600, parent, (u16 *)0xFFC03108);
		debugfs_create_x16("UART3_IER_CLEAR", 0600, parent, (u16 *)0xFFC03124);
		debugfs_create_x16("UART3_IER_SET", 0600, parent, (u16 *)0xFFC03120);
		debugfs_create_x16("UART3_LCR", 0600, parent, (u16 *)0xFFC0310C);
		debugfs_create_x16("UART3_LSR", 0600, parent, (u16 *)0xFFC03114);
		debugfs_create_x16("UART3_MCR", 0600, parent, (u16 *)0xFFC03110);
		debugfs_create_x16("UART3_MSR", 0600, parent, (u16 *)0xFFC03118);
		debugfs_create_x16("UART3_RBR", 0600, parent, (u16 *)0xFFC0312C);
		debugfs_create_x16("UART3_SCR", 0600, parent, (u16 *)0xFFC0311C);
		debugfs_create_x16("UART3_THR", 0600, parent, (u16 *)0xFFC03128);

		parent = debugfs_create_dir("USB", top);
		debugfs_create_x16("USB_APHY_CALIB", 0600, parent, (u16 *)0xFFC03DE4);
		debugfs_create_x16("USB_APHY_CNTRL2", 0600, parent, (u16 *)0xFFC03DE8);
		debugfs_create_x16("USB_APHY_CNTRL", 0600, parent, (u16 *)0xFFC03DE0);
		debugfs_create_x16("USB_COUNT0", 0600, parent, (u16 *)0xFFC03C50);
		debugfs_create_x16("USB_CSR0", 0600, parent, (u16 *)0xFFC03C44);
		debugfs_create_x16("USB_DMA0_ADDRHIGH", 0600, parent, (u16 *)0xFFC0400C);
		debugfs_create_x16("USB_DMA0_ADDRLOW", 0600, parent, (u16 *)0xFFC04008);
		debugfs_create_x16("USB_DMA0_CONTROL", 0600, parent, (u16 *)0xFFC04004);
		debugfs_create_x16("USB_DMA0_COUNTHIGH", 0600, parent, (u16 *)0xFFC04014);
		debugfs_create_x16("USB_DMA0_COUNTLOW", 0600, parent, (u16 *)0xFFC04010);
		debugfs_create_x16("USB_DMA1_ADDRHIGH", 0600, parent, (u16 *)0xFFC0402C);
		debugfs_create_x16("USB_DMA1_ADDRLOW", 0600, parent, (u16 *)0xFFC04028);
		debugfs_create_x16("USB_DMA1_CONTROL", 0600, parent, (u16 *)0xFFC04024);
		debugfs_create_x16("USB_DMA1_COUNTHIGH", 0600, parent, (u16 *)0xFFC04034);
		debugfs_create_x16("USB_DMA1_COUNTLOW", 0600, parent, (u16 *)0xFFC04030);
		debugfs_create_x16("USB_DMA2_ADDRHIGH", 0600, parent, (u16 *)0xFFC0404C);
		debugfs_create_x16("USB_DMA2_ADDRLOW", 0600, parent, (u16 *)0xFFC04048);
		debugfs_create_x16("USB_DMA2_CONTROL", 0600, parent, (u16 *)0xFFC04044);
		debugfs_create_x16("USB_DMA2_COUNTHIGH", 0600, parent, (u16 *)0xFFC04054);
		debugfs_create_x16("USB_DMA2_COUNTLOW", 0600, parent, (u16 *)0xFFC04050);
		debugfs_create_x16("USB_DMA3_ADDRHIGH", 0600, parent, (u16 *)0xFFC0406C);
		debugfs_create_x16("USB_DMA3_ADDRLOW", 0600, parent, (u16 *)0xFFC04068);
		debugfs_create_x16("USB_DMA3_CONTROL", 0600, parent, (u16 *)0xFFC04064);
		debugfs_create_x16("USB_DMA3_COUNTHIGH", 0600, parent, (u16 *)0xFFC04074);
		debugfs_create_x16("USB_DMA3_COUNTLOW", 0600, parent, (u16 *)0xFFC04070);
		debugfs_create_x16("USB_DMA4_ADDRHIGH", 0600, parent, (u16 *)0xFFC0408C);
		debugfs_create_x16("USB_DMA4_ADDRLOW", 0600, parent, (u16 *)0xFFC04088);
		debugfs_create_x16("USB_DMA4_CONTROL", 0600, parent, (u16 *)0xFFC04084);
		debugfs_create_x16("USB_DMA4_COUNTHIGH", 0600, parent, (u16 *)0xFFC04094);
		debugfs_create_x16("USB_DMA4_COUNTLOW", 0600, parent, (u16 *)0xFFC04090);
		debugfs_create_x16("USB_DMA5_ADDRHIGH", 0600, parent, (u16 *)0xFFC040AC);
		debugfs_create_x16("USB_DMA5_ADDRLOW", 0600, parent, (u16 *)0xFFC040A8);
		debugfs_create_x16("USB_DMA5_CONTROL", 0600, parent, (u16 *)0xFFC040A4);
		debugfs_create_x16("USB_DMA5_COUNTHIGH", 0600, parent, (u16 *)0xFFC040B4);
		debugfs_create_x16("USB_DMA5_COUNTLOW", 0600, parent, (u16 *)0xFFC040B0);
		debugfs_create_x16("USB_DMA6_ADDRHIGH", 0600, parent, (u16 *)0xFFC040CC);
		debugfs_create_x16("USB_DMA6_ADDRLOW", 0600, parent, (u16 *)0xFFC040C8);
		debugfs_create_x16("USB_DMA6_CONTROL", 0600, parent, (u16 *)0xFFC040C4);
		debugfs_create_x16("USB_DMA6_COUNTHIGH", 0600, parent, (u16 *)0xFFC040D4);
		debugfs_create_x16("USB_DMA6_COUNTLOW", 0600, parent, (u16 *)0xFFC040D0);
		debugfs_create_x16("USB_DMA7_ADDRHIGH", 0600, parent, (u16 *)0xFFC040EC);
		debugfs_create_x16("USB_DMA7_ADDRLOW", 0600, parent, (u16 *)0xFFC040E8);
		debugfs_create_x16("USB_DMA7_CONTROL", 0600, parent, (u16 *)0xFFC040E4);
		debugfs_create_x16("USB_DMA7_COUNTHIGH", 0600, parent, (u16 *)0xFFC040F4);
		debugfs_create_x16("USB_DMA7_COUNTLOW", 0600, parent, (u16 *)0xFFC040F0);
		debugfs_create_x16("USB_DMA_INTERRUPT", 0600, parent, (u16 *)0xFFC04000);
		debugfs_create_x16("USB_EP0_FIFO", 0600, parent, (u16 *)0xFFC03C80);
		debugfs_create_x16("USB_EP1_FIFO", 0600, parent, (u16 *)0xFFC03C88);
		debugfs_create_x16("USB_EP2_FIFO", 0600, parent, (u16 *)0xFFC03C90);
		debugfs_create_x16("USB_EP3_FIFO", 0600, parent, (u16 *)0xFFC03C98);
		debugfs_create_x16("USB_EP4_FIFO", 0600, parent, (u16 *)0xFFC03CA0);
		debugfs_create_x16("USB_EP5_FIFO", 0600, parent, (u16 *)0xFFC03CA8);
		debugfs_create_x16("USB_EP6_FIFO", 0600, parent, (u16 *)0xFFC03CB0);
		debugfs_create_x16("USB_EP7_FIFO", 0600, parent, (u16 *)0xFFC03CB8);
		debugfs_create_x16("USB_EP_NI0_RXCOUNT", 0600, parent, (u16 *)0xFFC03E10);
		debugfs_create_x16("USB_EP_NI0_RXCSR", 0600, parent, (u16 *)0xFFC03E0C);
		debugfs_create_x16("USB_EP_NI0_RXINTERVAL", 0600, parent, (u16 *)0xFFC03E20);
		debugfs_create_x16("USB_EP_NI0_RXMAXP", 0600, parent, (u16 *)0xFFC03E08);
		debugfs_create_x16("USB_EP_NI0_RXTYPE", 0600, parent, (u16 *)0xFFC03E1C);
		debugfs_create_x16("USB_EP_NI0_TXCOUNT", 0600, parent, (u16 *)0xFFC03E28);
		debugfs_create_x16("USB_EP_NI0_TXCSR", 0600, parent, (u16 *)0xFFC03E04);
		debugfs_create_x16("USB_EP_NI0_TXINTERVAL", 0600, parent, (u16 *)0xFFC03E18);
		debugfs_create_x16("USB_EP_NI0_TXMAXP", 0600, parent, (u16 *)0xFFC03E00);
		debugfs_create_x16("USB_EP_NI0_TXTYPE", 0600, parent, (u16 *)0xFFC03E14);
		debugfs_create_x16("USB_EP_NI1_RXCOUNT", 0600, parent, (u16 *)0xFFC03E50);
		debugfs_create_x16("USB_EP_NI1_RXCSR", 0600, parent, (u16 *)0xFFC03E4C);
		debugfs_create_x16("USB_EP_NI1_RXINTERVAL", 0600, parent, (u16 *)0xFFC03E60);
		debugfs_create_x16("USB_EP_NI1_RXMAXP", 0600, parent, (u16 *)0xFFC03E48);
		debugfs_create_x16("USB_EP_NI1_RXTYPE", 0600, parent, (u16 *)0xFFC03E5C);
		debugfs_create_x16("USB_EP_NI1_TXCOUNT", 0600, parent, (u16 *)0xFFC03E68);
		debugfs_create_x16("USB_EP_NI1_TXCSR", 0600, parent, (u16 *)0xFFC03E44);
		debugfs_create_x16("USB_EP_NI1_TXINTERVAL", 0600, parent, (u16 *)0xFFC03E58);
		debugfs_create_x16("USB_EP_NI1_TXMAXP", 0600, parent, (u16 *)0xFFC03E40);
		debugfs_create_x16("USB_EP_NI1_TXTYPE", 0600, parent, (u16 *)0xFFC03E54);
		debugfs_create_x16("USB_EP_NI2_RXCOUNT", 0600, parent, (u16 *)0xFFC03E90);
		debugfs_create_x16("USB_EP_NI2_RXCSR", 0600, parent, (u16 *)0xFFC03E8C);
		debugfs_create_x16("USB_EP_NI2_RXINTERVAL", 0600, parent, (u16 *)0xFFC03EA0);
		debugfs_create_x16("USB_EP_NI2_RXMAXP", 0600, parent, (u16 *)0xFFC03E88);
		debugfs_create_x16("USB_EP_NI2_RXTYPE", 0600, parent, (u16 *)0xFFC03E9C);
		debugfs_create_x16("USB_EP_NI2_TXCOUNT", 0600, parent, (u16 *)0xFFC03EA8);
		debugfs_create_x16("USB_EP_NI2_TXCSR", 0600, parent, (u16 *)0xFFC03E84);
		debugfs_create_x16("USB_EP_NI2_TXINTERVAL", 0600, parent, (u16 *)0xFFC03E98);
		debugfs_create_x16("USB_EP_NI2_TXMAXP", 0600, parent, (u16 *)0xFFC03E80);
		debugfs_create_x16("USB_EP_NI2_TXTYPE", 0600, parent, (u16 *)0xFFC03E94);
		debugfs_create_x16("USB_EP_NI3_RXCOUNT", 0600, parent, (u16 *)0xFFC03ED0);
		debugfs_create_x16("USB_EP_NI3_RXCSR", 0600, parent, (u16 *)0xFFC03ECC);
		debugfs_create_x16("USB_EP_NI3_RXINTERVAL", 0600, parent, (u16 *)0xFFC03EE0);
		debugfs_create_x16("USB_EP_NI3_RXMAXP", 0600, parent, (u16 *)0xFFC03EC8);
		debugfs_create_x16("USB_EP_NI3_RXTYPE", 0600, parent, (u16 *)0xFFC03EDC);
		debugfs_create_x16("USB_EP_NI3_TXCOUNT", 0600, parent, (u16 *)0xFFC03EE8);
		debugfs_create_x16("USB_EP_NI3_TXCSR", 0600, parent, (u16 *)0xFFC03EC4);
		debugfs_create_x16("USB_EP_NI3_TXINTERVAL", 0600, parent, (u16 *)0xFFC03ED8);
		debugfs_create_x16("USB_EP_NI3_TXMAXP", 0600, parent, (u16 *)0xFFC03EC0);
		debugfs_create_x16("USB_EP_NI3_TXTYPE", 0600, parent, (u16 *)0xFFC03ED4);
		debugfs_create_x16("USB_EP_NI4_RXCOUNT", 0600, parent, (u16 *)0xFFC03F10);
		debugfs_create_x16("USB_EP_NI4_RXCSR", 0600, parent, (u16 *)0xFFC03F0C);
		debugfs_create_x16("USB_EP_NI4_RXINTERVAL", 0600, parent, (u16 *)0xFFC03F20);
		debugfs_create_x16("USB_EP_NI4_RXMAXP", 0600, parent, (u16 *)0xFFC03F08);
		debugfs_create_x16("USB_EP_NI4_RXTYPE", 0600, parent, (u16 *)0xFFC03F1C);
		debugfs_create_x16("USB_EP_NI4_TXCOUNT", 0600, parent, (u16 *)0xFFC03F28);
		debugfs_create_x16("USB_EP_NI4_TXCSR", 0600, parent, (u16 *)0xFFC03F04);
		debugfs_create_x16("USB_EP_NI4_TXINTERVAL", 0600, parent, (u16 *)0xFFC03F18);
		debugfs_create_x16("USB_EP_NI4_TXMAXP", 0600, parent, (u16 *)0xFFC03F00);
		debugfs_create_x16("USB_EP_NI4_TXTYPE", 0600, parent, (u16 *)0xFFC03F14);
		debugfs_create_x16("USB_EP_NI5_RXCOUNT", 0600, parent, (u16 *)0xFFC03F50);
		debugfs_create_x16("USB_EP_NI5_RXCSR", 0600, parent, (u16 *)0xFFC03F4C);
		debugfs_create_x16("USB_EP_NI5_RXINTERVAL", 0600, parent, (u16 *)0xFFC03F60);
		debugfs_create_x16("USB_EP_NI5_RXMAXP", 0600, parent, (u16 *)0xFFC03F48);
		debugfs_create_x16("USB_EP_NI5_RXTYPE", 0600, parent, (u16 *)0xFFC03F5C);
		debugfs_create_x16("USB_EP_NI5_TXCOUNT", 0600, parent, (u16 *)0xFFC03F68);
		debugfs_create_x16("USB_EP_NI5_TXCSR", 0600, parent, (u16 *)0xFFC03F44);
		debugfs_create_x16("USB_EP_NI5_TXINTERVAL", 0600, parent, (u16 *)0xFFC03F58);
		debugfs_create_x16("USB_EP_NI5_TXMAXP", 0600, parent, (u16 *)0xFFC03F40);
		debugfs_create_x16("USB_EP_NI5_TXTYPE", 0600, parent, (u16 *)0xFFC03F54);
		debugfs_create_x16("USB_EP_NI6_RXCOUNT", 0600, parent, (u16 *)0xFFC03F90);
		debugfs_create_x16("USB_EP_NI6_RXCSR", 0600, parent, (u16 *)0xFFC03F8C);
		debugfs_create_x16("USB_EP_NI6_RXINTERVAL", 0600, parent, (u16 *)0xFFC03FA0);
		debugfs_create_x16("USB_EP_NI6_RXMAXP", 0600, parent, (u16 *)0xFFC03F88);
		debugfs_create_x16("USB_EP_NI6_RXTYPE", 0600, parent, (u16 *)0xFFC03F9C);
		debugfs_create_x16("USB_EP_NI6_TXCOUNT", 0600, parent, (u16 *)0xFFC03FA8);
		debugfs_create_x16("USB_EP_NI6_TXCSR", 0600, parent, (u16 *)0xFFC03F84);
		debugfs_create_x16("USB_EP_NI6_TXINTERVAL", 0600, parent, (u16 *)0xFFC03F98);
		debugfs_create_x16("USB_EP_NI6_TXMAXP", 0600, parent, (u16 *)0xFFC03F80);
		debugfs_create_x16("USB_EP_NI6_TXTYPE", 0600, parent, (u16 *)0xFFC03F94);
		debugfs_create_x16("USB_EP_NI7_RXCOUNT", 0600, parent, (u16 *)0xFFC03FD0);
		debugfs_create_x16("USB_EP_NI7_RXCSR", 0600, parent, (u16 *)0xFFC03FCC);
		debugfs_create_x16("USB_EP_NI7_RXINTERVAL", 0600, parent, (u16 *)0xFFC03FF0);
		debugfs_create_x16("USB_EP_NI7_RXMAXP", 0600, parent, (u16 *)0xFFC03FC8);
		debugfs_create_x16("USB_EP_NI7_RXTYPE", 0600, parent, (u16 *)0xFFC03FDC);
		debugfs_create_x16("USB_EP_NI7_TXCOUNT", 0600, parent, (u16 *)0xFFC03FF8);
		debugfs_create_x16("USB_EP_NI7_TXCSR", 0600, parent, (u16 *)0xFFC03FC4);
		debugfs_create_x16("USB_EP_NI7_TXINTERVAL", 0600, parent, (u16 *)0xFFC03FD8);
		debugfs_create_x16("USB_EP_NI7_TXMAXP", 0600, parent, (u16 *)0xFFC03FC0);
		debugfs_create_x16("USB_EP_NI7_TXTYPE", 0600, parent, (u16 *)0xFFC03FD4);
		debugfs_create_x16("USB_FADDR", 0600, parent, (u16 *)0xFFC03C00);
		debugfs_create_x16("USB_FRAME", 0600, parent, (u16 *)0xFFC03C20);
		debugfs_create_x16("USB_FS_EOF1", 0600, parent, (u16 *)0xFFC03D54);
		debugfs_create_x16("USB_GLOBAL_CTL", 0600, parent, (u16 *)0xFFC03C30);
		debugfs_create_x16("USB_GLOBINTR", 0600, parent, (u16 *)0xFFC03C2C);
		debugfs_create_x16("USB_HS_EOF1", 0600, parent, (u16 *)0xFFC03D50);
		debugfs_create_x16("USB_INDEX", 0600, parent, (u16 *)0xFFC03C24);
		debugfs_create_x16("USB_INTRRX", 0600, parent, (u16 *)0xFFC03C0C);
		debugfs_create_x16("USB_INTRRXE", 0600, parent, (u16 *)0xFFC03C14);
		debugfs_create_x16("USB_INTRTX", 0600, parent, (u16 *)0xFFC03C08);
		debugfs_create_x16("USB_INTRTXE", 0600, parent, (u16 *)0xFFC03C10);
		debugfs_create_x16("USB_INTRUSB", 0600, parent, (u16 *)0xFFC03C18);
		debugfs_create_x16("USB_INTRUSBE", 0600, parent, (u16 *)0xFFC03C1C);
		debugfs_create_x16("USB_LINKINFO", 0600, parent, (u16 *)0xFFC03D48);
		debugfs_create_x16("USB_LS_EOF1", 0600, parent, (u16 *)0xFFC03D58);
		debugfs_create_x16("USB_NAKLIMIT0", 0600, parent, (u16 *)0xFFC03C58);
		debugfs_create_x16("USB_OTG_DEV_CTL", 0600, parent, (u16 *)0xFFC03D00);
		debugfs_create_x16("USB_OTG_VBUS_IRQ", 0600, parent, (u16 *)0xFFC03D04);
		debugfs_create_x16("USB_OTG_VBUS_MASK", 0600, parent, (u16 *)0xFFC03D08);
		debugfs_create_x16("USB_PHY_TEST", 0600, parent, (u16 *)0xFFC03DEC);
		debugfs_create_x16("USB_PLLOSC_CTRL", 0600, parent, (u16 *)0xFFC03DF0);
		debugfs_create_x16("USB_POWER", 0600, parent, (u16 *)0xFFC03C04);
		debugfs_create_x16("USB_RXCOUNT", 0600, parent, (u16 *)0xFFC03C50);
		debugfs_create_x16("USB_RXCSR", 0600, parent, (u16 *)0xFFC03C4C);
		debugfs_create_x16("USB_RXINTERVAL", 0600, parent, (u16 *)0xFFC03C60);
		debugfs_create_x16("USB_RXTYPE", 0600, parent, (u16 *)0xFFC03C5C);
		debugfs_create_x16("USB_RX_MAX_PACKET", 0600, parent, (u16 *)0xFFC03C48);
		debugfs_create_x16("USB_SRP_CLKDIV", 0600, parent, (u16 *)0xFFC03DF4);
		debugfs_create_x16("USB_TESTMODE", 0600, parent, (u16 *)0xFFC03C28);
		debugfs_create_x16("USB_TXCOUNT", 0600, parent, (u16 *)0xFFC03C68);
		debugfs_create_x16("USB_TXCSR", 0600, parent, (u16 *)0xFFC03C44);
		debugfs_create_x16("USB_TXINTERVAL", 0600, parent, (u16 *)0xFFC03C58);
		debugfs_create_x16("USB_TXTYPE", 0600, parent, (u16 *)0xFFC03C54);
		debugfs_create_x16("USB_TX_MAX_PACKET", 0600, parent, (u16 *)0xFFC03C40);
		debugfs_create_x16("USB_VPLEN", 0600, parent, (u16 *)0xFFC03D4C);

		parent = debugfs_create_dir("Watchdog", top);
		debugfs_create_x32("WDOG_CNT", 0600, parent, (u32 *)0xFFC00204);
		debugfs_create_x16("WDOG_CTL", 0600, parent, (u16 *)0xFFC00200);
		debugfs_create_x32("WDOG_STAT", 0600, parent, (u32 *)0xFFC00208);

		parent = debugfs_create_dir("Watchpoint and Patch Unit", top);
		debugfs_create_x32("WPDA0", 0600, parent, (u32 *)0xFFE07140);
		debugfs_create_x32("WPDA1", 0600, parent, (u32 *)0xFFE07144);
		debugfs_create_x32("WPDACNT0", 0600, parent, (u32 *)0xFFE07180);
		debugfs_create_x32("WPDACNT1", 0600, parent, (u32 *)0xFFE07184);
		debugfs_create_x32("WPDACTL", 0600, parent, (u32 *)0xFFE07100);
		debugfs_create_x32("WPIA0", 0600, parent, (u32 *)0xFFE07040);
		debugfs_create_x32("WPIA1", 0600, parent, (u32 *)0xFFE07044);
		debugfs_create_x32("WPIA2", 0600, parent, (u32 *)0xFFE07048);
		debugfs_create_x32("WPIA3", 0600, parent, (u32 *)0xFFE0704C);
		debugfs_create_x32("WPIA4", 0600, parent, (u32 *)0xFFE07050);
		debugfs_create_x32("WPIA5", 0600, parent, (u32 *)0xFFE07054);
		debugfs_create_x32("WPIACNT0", 0600, parent, (u32 *)0xFFE07080);
		debugfs_create_x32("WPIACNT1", 0600, parent, (u32 *)0xFFE07084);
		debugfs_create_x32("WPIACNT2", 0600, parent, (u32 *)0xFFE07088);
		debugfs_create_x32("WPIACNT3", 0600, parent, (u32 *)0xFFE0708C);
		debugfs_create_x32("WPIACNT4", 0600, parent, (u32 *)0xFFE07090);
		debugfs_create_x32("WPIACNT5", 0600, parent, (u32 *)0xFFE07094);
		debugfs_create_x32("WPIACTL", 0600, parent, (u32 *)0xFFE07000);
		debugfs_create_x32("WPSTAT", 0600, parent, (u32 *)0xFFE07200);

	}	/* BF549 */

#ifdef __ADSPBF561__
# define USE_BF561 1
#else
# define USE_BF561 0
#endif
	if (USE_BF561) {

		parent = debugfs_create_dir("Core Timer Register File", top);
		debugfs_create_x32("TCNTL", 0600, parent, (u32 *)0xFFE03000);
		debugfs_create_x32("TCOUNT", 0600, parent, (u32 *)0xFFE0300C);
		debugfs_create_x32("TPERIOD", 0600, parent, (u32 *)0xFFE03004);
		debugfs_create_x32("TSCALE", 0600, parent, (u32 *)0xFFE03008);

		parent = debugfs_create_dir("DMA Traffic Control", top);
		debugfs_create_x16("DMA1_TC_CNT", 0600, parent, (u16 *)0xFFC01B10);
		debugfs_create_x16("DMA1_TC_PER", 0600, parent, (u16 *)0xFFC01B0C);
		debugfs_create_x16("DMA2_TC_CNT", 0600, parent, (u16 *)0xFFC01B10);
		debugfs_create_x16("DMA2_TC_PER", 0600, parent, (u16 *)0xFFC00B0C);

		parent = debugfs_create_dir("DMA1 Channel-0", top);
		debugfs_create_x16("DMA1_0_CONFIG", 0600, parent, (u16 *)0xFFC01C08);
		debugfs_create_x32("DMA1_0_CURR_ADDR", 0600, parent, (u32 *)0xFFC01C24);
		debugfs_create_x32("DMA1_0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01C20);
		debugfs_create_x16("DMA1_0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01C30);
		debugfs_create_x16("DMA1_0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01C38);
		debugfs_create_x16("DMA1_0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01C28);
		debugfs_create_x32("DMA1_0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01C00);
		debugfs_create_x16("DMA1_0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01C2C);
		debugfs_create_x32("DMA1_0_START_ADDR", 0600, parent, (u32 *)0xFFC01C04);
		debugfs_create_x16("DMA1_0_X_COUNT", 0600, parent, (u16 *)0xFFC01C10);
		debugfs_create_x16("DMA1_0_X_MODIFY", 0600, parent, (u16 *)0xFFC01C14);
		debugfs_create_x16("DMA1_0_Y_COUNT", 0600, parent, (u16 *)0xFFC01C18);
		debugfs_create_x16("DMA1_0_Y_MODIFY", 0600, parent, (u16 *)0xFFC01C1C);

		parent = debugfs_create_dir("DMA1 Channel-10", top);
		debugfs_create_x16("DMA1_10_CONFIG", 0600, parent, (u16 *)0xFFC01E88);
		debugfs_create_x32("DMA1_10_CURR_ADDR", 0600, parent, (u32 *)0xFFC01EA4);
		debugfs_create_x32("DMA1_10_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01EA0);
		debugfs_create_x16("DMA1_10_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01EB0);
		debugfs_create_x16("DMA1_10_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01EB8);
		debugfs_create_x16("DMA1_10_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01EA8);
		debugfs_create_x32("DMA1_10_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01E80);
		debugfs_create_x16("DMA1_10_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01EAC);
		debugfs_create_x32("DMA1_10_START_ADDR", 0600, parent, (u32 *)0xFFC01E84);
		debugfs_create_x16("DMA1_10_X_COUNT", 0600, parent, (u16 *)0xFFC01E90);
		debugfs_create_x16("DMA1_10_X_MODIFY", 0600, parent, (u16 *)0xFFC01E94);
		debugfs_create_x16("DMA1_10_Y_COUNT", 0600, parent, (u16 *)0xFFC01E98);
		debugfs_create_x16("DMA1_10_Y_MODIFY", 0600, parent, (u16 *)0xFFC01E9C);

		parent = debugfs_create_dir("DMA1 Channel-11", top);
		debugfs_create_x16("DMA1_11_CONFIG", 0600, parent, (u16 *)0xFFC01EC8);
		debugfs_create_x32("DMA1_11_CURR_ADDR", 0600, parent, (u32 *)0xFFC01EE4);
		debugfs_create_x32("DMA1_11_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01EE0);
		debugfs_create_x16("DMA1_11_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01EF0);
		debugfs_create_x16("DMA1_11_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01EF8);
		debugfs_create_x16("DMA1_11_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01EE8);
		debugfs_create_x32("DMA1_11_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01EC0);
		debugfs_create_x16("DMA1_11_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01EEC);
		debugfs_create_x32("DMA1_11_START_ADDR", 0600, parent, (u32 *)0xFFC01EC4);
		debugfs_create_x16("DMA1_11_X_COUNT", 0600, parent, (u16 *)0xFFC01ED0);
		debugfs_create_x16("DMA1_11_X_MODIFY", 0600, parent, (u16 *)0xFFC01ED4);
		debugfs_create_x16("DMA1_11_Y_COUNT", 0600, parent, (u16 *)0xFFC01ED8);
		debugfs_create_x16("DMA1_11_Y_MODIFY", 0600, parent, (u16 *)0xFFC01EDC);

		parent = debugfs_create_dir("DMA1 Channel-1", top);
		debugfs_create_x16("DMA1_1_CONFIG", 0600, parent, (u16 *)0xFFC01C48);
		debugfs_create_x32("DMA1_1_CURR_ADDR", 0600, parent, (u32 *)0xFFC01C64);
		debugfs_create_x32("DMA1_1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01C60);
		debugfs_create_x16("DMA1_1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01C70);
		debugfs_create_x16("DMA1_1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01C78);
		debugfs_create_x16("DMA1_1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01C68);
		debugfs_create_x32("DMA1_1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01C40);
		debugfs_create_x16("DMA1_1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01C6C);
		debugfs_create_x32("DMA1_1_START_ADDR", 0600, parent, (u32 *)0xFFC01C44);
		debugfs_create_x16("DMA1_1_X_COUNT", 0600, parent, (u16 *)0xFFC01C50);
		debugfs_create_x16("DMA1_1_X_MODIFY", 0600, parent, (u16 *)0xFFC01C54);
		debugfs_create_x16("DMA1_1_Y_COUNT", 0600, parent, (u16 *)0xFFC01C58);
		debugfs_create_x16("DMA1_1_Y_MODIFY", 0600, parent, (u16 *)0xFFC01C5C);

		parent = debugfs_create_dir("DMA1 Channel-2", top);
		debugfs_create_x16("DMA1_2_CONFIG", 0600, parent, (u16 *)0xFFC01C88);
		debugfs_create_x32("DMA1_2_CURR_ADDR", 0600, parent, (u32 *)0xFFC01CA4);
		debugfs_create_x32("DMA1_2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01CA0);
		debugfs_create_x16("DMA1_2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01CB0);
		debugfs_create_x16("DMA1_2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01CB8);
		debugfs_create_x16("DMA1_2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01CA8);
		debugfs_create_x32("DMA1_2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01C80);
		debugfs_create_x16("DMA1_2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01CAC);
		debugfs_create_x32("DMA1_2_START_ADDR", 0600, parent, (u32 *)0xFFC01C84);
		debugfs_create_x16("DMA1_2_X_COUNT", 0600, parent, (u16 *)0xFFC01C90);
		debugfs_create_x16("DMA1_2_X_MODIFY", 0600, parent, (u16 *)0xFFC01C94);
		debugfs_create_x16("DMA1_2_Y_COUNT", 0600, parent, (u16 *)0xFFC01C98);
		debugfs_create_x16("DMA1_2_Y_MODIFY", 0600, parent, (u16 *)0xFFC01C9C);

		parent = debugfs_create_dir("DMA1 Channel-3", top);
		debugfs_create_x16("DMA1_3_CONFIG", 0600, parent, (u16 *)0xFFC01CC8);
		debugfs_create_x32("DMA1_3_CURR_ADDR", 0600, parent, (u32 *)0xFFC01CE4);
		debugfs_create_x32("DMA1_3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01CE0);
		debugfs_create_x16("DMA1_3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01CF0);
		debugfs_create_x16("DMA1_3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01CF8);
		debugfs_create_x16("DMA1_3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01CE8);
		debugfs_create_x32("DMA1_3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01CC0);
		debugfs_create_x16("DMA1_3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01CEC);
		debugfs_create_x32("DMA1_3_START_ADDR", 0600, parent, (u32 *)0xFFC01CC4);
		debugfs_create_x16("DMA1_3_X_COUNT", 0600, parent, (u16 *)0xFFC01CD0);
		debugfs_create_x16("DMA1_3_X_MODIFY", 0600, parent, (u16 *)0xFFC01CD4);
		debugfs_create_x16("DMA1_3_Y_COUNT", 0600, parent, (u16 *)0xFFC01CD8);
		debugfs_create_x16("DMA1_3_Y_MODIFY", 0600, parent, (u16 *)0xFFC01CDC);

		parent = debugfs_create_dir("DMA1 Channel-4", top);
		debugfs_create_x16("DMA1_4_CONFIG", 0600, parent, (u16 *)0xFFC01D08);
		debugfs_create_x32("DMA1_4_CURR_ADDR", 0600, parent, (u32 *)0xFFC01D24);
		debugfs_create_x32("DMA1_4_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01D20);
		debugfs_create_x16("DMA1_4_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01D30);
		debugfs_create_x16("DMA1_4_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01D38);
		debugfs_create_x16("DMA1_4_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01D28);
		debugfs_create_x32("DMA1_4_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01D00);
		debugfs_create_x16("DMA1_4_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01D2C);
		debugfs_create_x32("DMA1_4_START_ADDR", 0600, parent, (u32 *)0xFFC01D04);
		debugfs_create_x16("DMA1_4_X_COUNT", 0600, parent, (u16 *)0xFFC01D10);
		debugfs_create_x16("DMA1_4_X_MODIFY", 0600, parent, (u16 *)0xFFC01D14);
		debugfs_create_x16("DMA1_4_Y_COUNT", 0600, parent, (u16 *)0xFFC01D18);
		debugfs_create_x16("DMA1_4_Y_MODIFY", 0600, parent, (u16 *)0xFFC01D1C);

		parent = debugfs_create_dir("DMA1 Channel-5", top);
		debugfs_create_x16("DMA1_5_CONFIG", 0600, parent, (u16 *)0xFFC01D48);
		debugfs_create_x32("DMA1_5_CURR_ADDR", 0600, parent, (u32 *)0xFFC01D64);
		debugfs_create_x32("DMA1_5_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01D60);
		debugfs_create_x16("DMA1_5_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01D70);
		debugfs_create_x16("DMA1_5_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01D78);
		debugfs_create_x16("DMA1_5_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01D68);
		debugfs_create_x32("DMA1_5_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01D40);
		debugfs_create_x16("DMA1_5_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01D6C);
		debugfs_create_x32("DMA1_5_START_ADDR", 0600, parent, (u32 *)0xFFC01D44);
		debugfs_create_x16("DMA1_5_X_COUNT", 0600, parent, (u16 *)0xFFC01D50);
		debugfs_create_x16("DMA1_5_X_MODIFY", 0600, parent, (u16 *)0xFFC01D54);
		debugfs_create_x16("DMA1_5_Y_COUNT", 0600, parent, (u16 *)0xFFC01D58);
		debugfs_create_x16("DMA1_5_Y_MODIFY", 0600, parent, (u16 *)0xFFC01D5C);

		parent = debugfs_create_dir("DMA1 Channel-6", top);
		debugfs_create_x16("DMA1_6_CONFIG", 0600, parent, (u16 *)0xFFC01D88);
		debugfs_create_x32("DMA1_6_CURR_ADDR", 0600, parent, (u32 *)0xFFC01DA4);
		debugfs_create_x32("DMA1_6_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01DA0);
		debugfs_create_x16("DMA1_6_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01DB0);
		debugfs_create_x16("DMA1_6_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01DB8);
		debugfs_create_x16("DMA1_6_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01DA8);
		debugfs_create_x32("DMA1_6_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01D80);
		debugfs_create_x16("DMA1_6_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01DAC);
		debugfs_create_x32("DMA1_6_START_ADDR", 0600, parent, (u32 *)0xFFC01D84);
		debugfs_create_x16("DMA1_6_X_COUNT", 0600, parent, (u16 *)0xFFC01D90);
		debugfs_create_x16("DMA1_6_X_MODIFY", 0600, parent, (u16 *)0xFFC01D94);
		debugfs_create_x16("DMA1_6_Y_COUNT", 0600, parent, (u16 *)0xFFC01D98);
		debugfs_create_x16("DMA1_6_Y_MODIFY", 0600, parent, (u16 *)0xFFC01D9C);

		parent = debugfs_create_dir("DMA1 Channel-7", top);
		debugfs_create_x16("DMA1_7_CONFIG", 0600, parent, (u16 *)0xFFC01DC8);
		debugfs_create_x32("DMA1_7_CURR_ADDR", 0600, parent, (u32 *)0xFFC01DE4);
		debugfs_create_x32("DMA1_7_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01DE0);
		debugfs_create_x16("DMA1_7_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01DF0);
		debugfs_create_x16("DMA1_7_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01DF8);
		debugfs_create_x16("DMA1_7_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01DE8);
		debugfs_create_x32("DMA1_7_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01DC0);
		debugfs_create_x16("DMA1_7_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01DEC);
		debugfs_create_x32("DMA1_7_START_ADDR", 0600, parent, (u32 *)0xFFC01DC4);
		debugfs_create_x16("DMA1_7_X_COUNT", 0600, parent, (u16 *)0xFFC01DD0);
		debugfs_create_x16("DMA1_7_X_MODIFY", 0600, parent, (u16 *)0xFFC01DD4);
		debugfs_create_x16("DMA1_7_Y_COUNT", 0600, parent, (u16 *)0xFFC01DD8);
		debugfs_create_x16("DMA1_7_Y_MODIFY", 0600, parent, (u16 *)0xFFC01DDC);

		parent = debugfs_create_dir("DMA1 Channel-8", top);
		debugfs_create_x16("DMA1_8_CONFIG", 0600, parent, (u16 *)0xFFC01E08);
		debugfs_create_x32("DMA1_8_CURR_ADDR", 0600, parent, (u32 *)0xFFC01E24);
		debugfs_create_x32("DMA1_8_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01E20);
		debugfs_create_x16("DMA1_8_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01E30);
		debugfs_create_x16("DMA1_8_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01E38);
		debugfs_create_x16("DMA1_8_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01E28);
		debugfs_create_x32("DMA1_8_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01E00);
		debugfs_create_x16("DMA1_8_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01E2C);
		debugfs_create_x32("DMA1_8_START_ADDR", 0600, parent, (u32 *)0xFFC01E04);
		debugfs_create_x16("DMA1_8_X_COUNT", 0600, parent, (u16 *)0xFFC01E10);
		debugfs_create_x16("DMA1_8_X_MODIFY", 0600, parent, (u16 *)0xFFC01E14);
		debugfs_create_x16("DMA1_8_Y_COUNT", 0600, parent, (u16 *)0xFFC01E18);
		debugfs_create_x16("DMA1_8_Y_MODIFY", 0600, parent, (u16 *)0xFFC01E1C);

		parent = debugfs_create_dir("DMA1 Channel-9", top);
		debugfs_create_x16("DMA1_9_CONFIG", 0600, parent, (u16 *)0xFFC01E48);
		debugfs_create_x32("DMA1_9_CURR_ADDR", 0600, parent, (u32 *)0xFFC01E64);
		debugfs_create_x32("DMA1_9_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01E60);
		debugfs_create_x16("DMA1_9_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01E70);
		debugfs_create_x16("DMA1_9_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01E78);
		debugfs_create_x16("DMA1_9_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01E68);
		debugfs_create_x32("DMA1_9_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01E40);
		debugfs_create_x16("DMA1_9_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01E6C);
		debugfs_create_x32("DMA1_9_START_ADDR", 0600, parent, (u32 *)0xFFC01E44);
		debugfs_create_x16("DMA1_9_X_COUNT", 0600, parent, (u16 *)0xFFC01E50);
		debugfs_create_x16("DMA1_9_X_MODIFY", 0600, parent, (u16 *)0xFFC01E54);
		debugfs_create_x16("DMA1_9_Y_COUNT", 0600, parent, (u16 *)0xFFC01E58);
		debugfs_create_x16("DMA1_9_Y_MODIFY", 0600, parent, (u16 *)0xFFC01E5C);

		parent = debugfs_create_dir("DMA2 Channel 0", top);
		debugfs_create_x16("DMA2_0_CONFIG", 0600, parent, (u16 *)0xFFC00C08);
		debugfs_create_x32("DMA2_0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C24);
		debugfs_create_x32("DMA2_0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C20);
		debugfs_create_x16("DMA2_0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C30);
		debugfs_create_x16("DMA2_0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C38);
		debugfs_create_x16("DMA2_0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C28);
		debugfs_create_x32("DMA2_0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C00);
		debugfs_create_x16("DMA2_0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C2C);
		debugfs_create_x32("DMA2_0_START_ADDR", 0600, parent, (u32 *)0xFFC00C04);
		debugfs_create_x16("DMA2_0_X_COUNT", 0600, parent, (u16 *)0xFFC00C10);
		debugfs_create_x16("DMA2_0_X_MODIFY", 0600, parent, (u16 *)0xFFC00C14);
		debugfs_create_x16("DMA2_0_Y_COUNT", 0600, parent, (u16 *)0xFFC00C18);
		debugfs_create_x16("DMA2_0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C1C);

		parent = debugfs_create_dir("DMA2 Channel 10", top);
		debugfs_create_x16("DMA2_10_CONFIG", 0600, parent, (u16 *)0xFFC00E88);
		debugfs_create_x32("DMA2_10_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EA4);
		debugfs_create_x32("DMA2_10_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EA0);
		debugfs_create_x16("DMA2_10_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EB0);
		debugfs_create_x16("DMA2_10_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EB8);
		debugfs_create_x16("DMA2_10_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EA8);
		debugfs_create_x32("DMA2_10_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E80);
		debugfs_create_x16("DMA2_10_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EAC);
		debugfs_create_x32("DMA2_10_START_ADDR", 0600, parent, (u32 *)0xFFC00E84);
		debugfs_create_x16("DMA2_10_X_COUNT", 0600, parent, (u16 *)0xFFC00E90);
		debugfs_create_x16("DMA2_10_X_MODIFY", 0600, parent, (u16 *)0xFFC00E94);
		debugfs_create_x16("DMA2_10_Y_COUNT", 0600, parent, (u16 *)0xFFC00E98);
		debugfs_create_x16("DMA2_10_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E9C);

		parent = debugfs_create_dir("DMA2 Channel 11", top);
		debugfs_create_x16("DMA2_11_CONFIG", 0600, parent, (u16 *)0xFFC00EC8);
		debugfs_create_x32("DMA2_11_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EE4);
		debugfs_create_x32("DMA2_11_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EE0);
		debugfs_create_x16("DMA2_11_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00EF0);
		debugfs_create_x16("DMA2_11_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00EF8);
		debugfs_create_x16("DMA2_11_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00EE8);
		debugfs_create_x32("DMA2_11_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00EC0);
		debugfs_create_x16("DMA2_11_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00EEC);
		debugfs_create_x32("DMA2_11_START_ADDR", 0600, parent, (u32 *)0xFFC00EC4);
		debugfs_create_x16("DMA2_11_X_COUNT", 0600, parent, (u16 *)0xFFC00ED0);
		debugfs_create_x16("DMA2_11_X_MODIFY", 0600, parent, (u16 *)0xFFC00ED4);
		debugfs_create_x16("DMA2_11_Y_COUNT", 0600, parent, (u16 *)0xFFC00ED8);
		debugfs_create_x16("DMA2_11_Y_MODIFY", 0600, parent, (u16 *)0xFFC00EDC);

		parent = debugfs_create_dir("DMA2 Channel 1", top);
		debugfs_create_x16("DMA2_1_CONFIG", 0600, parent, (u16 *)0xFFC00C48);
		debugfs_create_x32("DMA2_1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00C64);
		debugfs_create_x32("DMA2_1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00C60);
		debugfs_create_x16("DMA2_1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00C70);
		debugfs_create_x16("DMA2_1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00C78);
		debugfs_create_x16("DMA2_1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00C68);
		debugfs_create_x32("DMA2_1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C40);
		debugfs_create_x16("DMA2_1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00C6C);
		debugfs_create_x32("DMA2_1_START_ADDR", 0600, parent, (u32 *)0xFFC00C44);
		debugfs_create_x16("DMA2_1_X_COUNT", 0600, parent, (u16 *)0xFFC00C50);
		debugfs_create_x16("DMA2_1_X_MODIFY", 0600, parent, (u16 *)0xFFC00C54);
		debugfs_create_x16("DMA2_1_Y_COUNT", 0600, parent, (u16 *)0xFFC00C58);
		debugfs_create_x16("DMA2_1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C5C);

		parent = debugfs_create_dir("DMA2 Channel 2", top);
		debugfs_create_x16("DMA2_2_CONFIG", 0600, parent, (u16 *)0xFFC00C88);
		debugfs_create_x32("DMA2_2_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CA4);
		debugfs_create_x32("DMA2_2_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CA0);
		debugfs_create_x16("DMA2_2_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CB0);
		debugfs_create_x16("DMA2_2_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CB8);
		debugfs_create_x16("DMA2_2_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CA8);
		debugfs_create_x32("DMA2_2_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00C80);
		debugfs_create_x16("DMA2_2_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CAC);
		debugfs_create_x32("DMA2_2_START_ADDR", 0600, parent, (u32 *)0xFFC00C84);
		debugfs_create_x16("DMA2_2_X_COUNT", 0600, parent, (u16 *)0xFFC00C90);
		debugfs_create_x16("DMA2_2_X_MODIFY", 0600, parent, (u16 *)0xFFC00C94);
		debugfs_create_x16("DMA2_2_Y_COUNT", 0600, parent, (u16 *)0xFFC00C98);
		debugfs_create_x16("DMA2_2_Y_MODIFY", 0600, parent, (u16 *)0xFFC00C9C);

		parent = debugfs_create_dir("DMA2 Channel 3", top);
		debugfs_create_x16("DMA2_3_CONFIG", 0600, parent, (u16 *)0xFFC00CC8);
		debugfs_create_x32("DMA2_3_CURR_ADDR", 0600, parent, (u32 *)0xFFC00CE4);
		debugfs_create_x32("DMA2_3_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00CE0);
		debugfs_create_x16("DMA2_3_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00CF0);
		debugfs_create_x16("DMA2_3_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00CF8);
		debugfs_create_x16("DMA2_3_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00CE8);
		debugfs_create_x32("DMA2_3_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00CC0);
		debugfs_create_x16("DMA2_3_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00CEC);
		debugfs_create_x32("DMA2_3_START_ADDR", 0600, parent, (u32 *)0xFFC00CC4);
		debugfs_create_x16("DMA2_3_X_COUNT", 0600, parent, (u16 *)0xFFC00CD0);
		debugfs_create_x16("DMA2_3_X_MODIFY", 0600, parent, (u16 *)0xFFC00CD4);
		debugfs_create_x16("DMA2_3_Y_COUNT", 0600, parent, (u16 *)0xFFC00CD8);
		debugfs_create_x16("DMA2_3_Y_MODIFY", 0600, parent, (u16 *)0xFFC00CDC);

		parent = debugfs_create_dir("DMA2 Channel 4", top);
		debugfs_create_x16("DMA2_4_CONFIG", 0600, parent, (u16 *)0xFFC00D08);
		debugfs_create_x32("DMA2_4_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D24);
		debugfs_create_x32("DMA2_4_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D20);
		debugfs_create_x16("DMA2_4_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D30);
		debugfs_create_x16("DMA2_4_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D38);
		debugfs_create_x16("DMA2_4_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D28);
		debugfs_create_x32("DMA2_4_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D00);
		debugfs_create_x16("DMA2_4_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D2C);
		debugfs_create_x32("DMA2_4_START_ADDR", 0600, parent, (u32 *)0xFFC00D04);
		debugfs_create_x16("DMA2_4_X_COUNT", 0600, parent, (u16 *)0xFFC00D10);
		debugfs_create_x16("DMA2_4_X_MODIFY", 0600, parent, (u16 *)0xFFC00D14);
		debugfs_create_x16("DMA2_4_Y_COUNT", 0600, parent, (u16 *)0xFFC00D18);
		debugfs_create_x16("DMA2_4_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D1C);

		parent = debugfs_create_dir("DMA2 Channel 5", top);
		debugfs_create_x16("DMA2_5_CONFIG", 0600, parent, (u16 *)0xFFC00D48);
		debugfs_create_x32("DMA2_5_CURR_ADDR", 0600, parent, (u32 *)0xFFC00D64);
		debugfs_create_x32("DMA2_5_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00D60);
		debugfs_create_x16("DMA2_5_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00D70);
		debugfs_create_x16("DMA2_5_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00D78);
		debugfs_create_x16("DMA2_5_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00D68);
		debugfs_create_x32("DMA2_5_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D40);
		debugfs_create_x16("DMA2_5_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00D6C);
		debugfs_create_x32("DMA2_5_START_ADDR", 0600, parent, (u32 *)0xFFC00D44);
		debugfs_create_x16("DMA2_5_X_COUNT", 0600, parent, (u16 *)0xFFC00D50);
		debugfs_create_x16("DMA2_5_X_MODIFY", 0600, parent, (u16 *)0xFFC00D54);
		debugfs_create_x16("DMA2_5_Y_COUNT", 0600, parent, (u16 *)0xFFC00D58);
		debugfs_create_x16("DMA2_5_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D5C);

		parent = debugfs_create_dir("DMA2 Channel 6", top);
		debugfs_create_x16("DMA2_6_CONFIG", 0600, parent, (u16 *)0xFFC00D88);
		debugfs_create_x32("DMA2_6_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DA4);
		debugfs_create_x32("DMA2_6_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DA0);
		debugfs_create_x16("DMA2_6_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DB0);
		debugfs_create_x16("DMA2_6_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DB8);
		debugfs_create_x16("DMA2_6_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DA8);
		debugfs_create_x32("DMA2_6_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00D80);
		debugfs_create_x16("DMA2_6_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DAC);
		debugfs_create_x32("DMA2_6_START_ADDR", 0600, parent, (u32 *)0xFFC00D84);
		debugfs_create_x16("DMA2_6_X_COUNT", 0600, parent, (u16 *)0xFFC00D90);
		debugfs_create_x16("DMA2_6_X_MODIFY", 0600, parent, (u16 *)0xFFC00D94);
		debugfs_create_x16("DMA2_6_Y_COUNT", 0600, parent, (u16 *)0xFFC00D98);
		debugfs_create_x16("DMA2_6_Y_MODIFY", 0600, parent, (u16 *)0xFFC00D9C);

		parent = debugfs_create_dir("DMA2 Channel 7", top);
		debugfs_create_x16("DMA2_7_CONFIG", 0600, parent, (u16 *)0xFFC00DC8);
		debugfs_create_x32("DMA2_7_CURR_ADDR", 0600, parent, (u32 *)0xFFC00DE4);
		debugfs_create_x32("DMA2_7_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00DE0);
		debugfs_create_x16("DMA2_7_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00DF0);
		debugfs_create_x16("DMA2_7_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00DF8);
		debugfs_create_x16("DMA2_7_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00DE8);
		debugfs_create_x32("DMA2_7_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00DC0);
		debugfs_create_x16("DMA2_7_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00DEC);
		debugfs_create_x32("DMA2_7_START_ADDR", 0600, parent, (u32 *)0xFFC00DC4);
		debugfs_create_x16("DMA2_7_X_COUNT", 0600, parent, (u16 *)0xFFC00DD0);
		debugfs_create_x16("DMA2_7_X_MODIFY", 0600, parent, (u16 *)0xFFC00DD4);
		debugfs_create_x16("DMA2_7_Y_COUNT", 0600, parent, (u16 *)0xFFC00DD8);
		debugfs_create_x16("DMA2_7_Y_MODIFY", 0600, parent, (u16 *)0xFFC00DDC);

		parent = debugfs_create_dir("DMA2 Channel 8", top);
		debugfs_create_x16("DMA2_8_CONFIG", 0600, parent, (u16 *)0xFFC00E08);
		debugfs_create_x32("DMA2_8_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E24);
		debugfs_create_x32("DMA2_8_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E20);
		debugfs_create_x16("DMA2_8_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E30);
		debugfs_create_x16("DMA2_8_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E38);
		debugfs_create_x16("DMA2_8_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E28);
		debugfs_create_x32("DMA2_8_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E00);
		debugfs_create_x16("DMA2_8_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E2C);
		debugfs_create_x32("DMA2_8_START_ADDR", 0600, parent, (u32 *)0xFFC00E04);
		debugfs_create_x16("DMA2_8_X_COUNT", 0600, parent, (u16 *)0xFFC00E10);
		debugfs_create_x16("DMA2_8_X_MODIFY", 0600, parent, (u16 *)0xFFC00E14);
		debugfs_create_x16("DMA2_8_Y_COUNT", 0600, parent, (u16 *)0xFFC00E18);
		debugfs_create_x16("DMA2_8_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E1C);

		parent = debugfs_create_dir("DMA2 Channel 9", top);
		debugfs_create_x16("DMA2_9_CONFIG", 0600, parent, (u16 *)0xFFC00E48);
		debugfs_create_x32("DMA2_9_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E64);
		debugfs_create_x32("DMA2_9_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E60);
		debugfs_create_x16("DMA2_9_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00E70);
		debugfs_create_x16("DMA2_9_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00E78);
		debugfs_create_x16("DMA2_9_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00E68);
		debugfs_create_x32("DMA2_9_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E40);
		debugfs_create_x16("DMA2_9_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00E6C);
		debugfs_create_x32("DMA2_9_START_ADDR", 0600, parent, (u32 *)0xFFC00E44);
		debugfs_create_x16("DMA2_9_X_COUNT", 0600, parent, (u16 *)0xFFC00E50);
		debugfs_create_x16("DMA2_9_X_MODIFY", 0600, parent, (u16 *)0xFFC00E54);
		debugfs_create_x16("DMA2_9_Y_COUNT", 0600, parent, (u16 *)0xFFC00E58);
		debugfs_create_x16("DMA2_9_Y_MODIFY", 0600, parent, (u16 *)0xFFC00E5C);

		parent = debugfs_create_dir("EBIU", top);
		debugfs_create_x32("EBIU_AMBCTL0", 0600, parent, (u32 *)0xFFC00A04);
		debugfs_create_x32("EBIU_AMBCTL1", 0600, parent, (u32 *)0xFFC00A08);
		debugfs_create_x16("EBIU_AMGCTL", 0600, parent, (u16 *)0xFFC00A00);
		debugfs_create_x32("EBIU_SDBCTL", 0600, parent, (u32 *)0xFFC00A14);
		debugfs_create_x32("EBIU_SDGCTL", 0600, parent, (u32 *)0xFFC00A10);
		debugfs_create_x16("EBIU_SDRRC", 0600, parent, (u16 *)0xFFC00A18);
		debugfs_create_x16("EBIU_SDSTAT", 0600, parent, (u16 *)0xFFC00A1C);

		parent = debugfs_create_dir("Event Vectors", top);
		debugfs_create_x32("EVT0", 0600, parent, (u32 *)0xFFE02000);
		debugfs_create_x32("EVT10", 0600, parent, (u32 *)0xFFE02028);
		debugfs_create_x32("EVT11", 0600, parent, (u32 *)0xFFE0202C);
		debugfs_create_x32("EVT12", 0600, parent, (u32 *)0xFFE02030);
		debugfs_create_x32("EVT13", 0600, parent, (u32 *)0xFFE02034);
		debugfs_create_x32("EVT14", 0600, parent, (u32 *)0xFFE02038);
		debugfs_create_x32("EVT15", 0600, parent, (u32 *)0xFFE0203C);
		debugfs_create_x32("EVT1", 0600, parent, (u32 *)0xFFE02004);
		debugfs_create_x32("EVT2", 0600, parent, (u32 *)0xFFE02008);
		debugfs_create_x32("EVT3", 0600, parent, (u32 *)0xFFE0200C);
		debugfs_create_x32("EVT4", 0600, parent, (u32 *)0xFFE02010);
		debugfs_create_x32("EVT5", 0600, parent, (u32 *)0xFFE02014);
		debugfs_create_x32("EVT6", 0600, parent, (u32 *)0xFFE02018);
		debugfs_create_x32("EVT7", 0600, parent, (u32 *)0xFFE0201C);
		debugfs_create_x32("EVT8", 0600, parent, (u32 *)0xFFE02020);
		debugfs_create_x32("EVT9", 0600, parent, (u32 *)0xFFE02024);

		parent = debugfs_create_dir("Extended Registers", top);
		debugfs_create_x32("CHIPID", 0600, parent, (u32 *)0xFFC00014);
		debugfs_create_x32("DBGSTAT", 0600, parent, (u32 *)0xFFE05008);
		debugfs_create_x32("DSPID", 0600, parent, (u32 *)0xFFE05000);
		debugfs_create_x32("EVT_OVERRIDE", 0600, parent, (u32 *)0xFFE02100);
		debugfs_create_x32("SRAM_BASE_ADDR_CORE_A", 0600, parent, (u32 *)0xFFE00000);
		debugfs_create_x32("SRAM_BASE_ADDR_CORE_B", 0600, parent, (u32 *)0xFFE00000);

		parent = debugfs_create_dir("Flag 0", top);
		debugfs_create_x16("FIO0_BOTH", 0600, parent, (u16 *)0xFFC0073C);
		debugfs_create_x16("FIO0_DIR", 0600, parent, (u16 *)0xFFC00730);
		debugfs_create_x16("FIO0_EDGE", 0600, parent, (u16 *)0xFFC00738);
		debugfs_create_x16("FIO0_FLAG_C", 0600, parent, (u16 *)0xFFC00704);
		debugfs_create_x16("FIO0_FLAG_D", 0600, parent, (u16 *)0xFFC00700);
		debugfs_create_x16("FIO0_FLAG_S", 0600, parent, (u16 *)0xFFC00708);
		debugfs_create_x16("FIO0_FLAG_T", 0600, parent, (u16 *)0xFFC0070C);
		debugfs_create_x16("FIO0_INEN", 0600, parent, (u16 *)0xFFC00740);
		debugfs_create_x16("FIO0_MASKA_C", 0600, parent, (u16 *)0xFFC00714);
		debugfs_create_x16("FIO0_MASKA_D", 0600, parent, (u16 *)0xFFC00710);
		debugfs_create_x16("FIO0_MASKA_S", 0600, parent, (u16 *)0xFFC00718);
		debugfs_create_x16("FIO0_MASKA_T", 0600, parent, (u16 *)0xFFC0071C);
		debugfs_create_x16("FIO0_MASKB_C", 0600, parent, (u16 *)0xFFC00724);
		debugfs_create_x16("FIO0_MASKB_D", 0600, parent, (u16 *)0xFFC00720);
		debugfs_create_x16("FIO0_MASKB_S", 0600, parent, (u16 *)0xFFC00728);
		debugfs_create_x16("FIO0_MASKB_T", 0600, parent, (u16 *)0xFFC0072C);
		debugfs_create_x16("FIO0_POLAR", 0600, parent, (u16 *)0xFFC00734);

		parent = debugfs_create_dir("Flag 1", top);
		debugfs_create_x16("FIO1_BOTH", 0600, parent, (u16 *)0xFFC0153C);
		debugfs_create_x16("FIO1_DIR", 0600, parent, (u16 *)0xFFC01530);
		debugfs_create_x16("FIO1_EDGE", 0600, parent, (u16 *)0xFFC01538);
		debugfs_create_x16("FIO1_FLAG_C", 0600, parent, (u16 *)0xFFC01504);
		debugfs_create_x16("FIO1_FLAG_D", 0600, parent, (u16 *)0xFFC01500);
		debugfs_create_x16("FIO1_FLAG_S", 0600, parent, (u16 *)0xFFC01508);
		debugfs_create_x16("FIO1_FLAG_T", 0600, parent, (u16 *)0xFFC0150C);
		debugfs_create_x16("FIO1_INEN", 0600, parent, (u16 *)0xFFC01540);
		debugfs_create_x16("FIO1_MASKA_C", 0600, parent, (u16 *)0xFFC01514);
		debugfs_create_x16("FIO1_MASKA_D", 0600, parent, (u16 *)0xFFC01510);
		debugfs_create_x16("FIO1_MASKA_S", 0600, parent, (u16 *)0xFFC01518);
		debugfs_create_x16("FIO1_MASKA_T", 0600, parent, (u16 *)0xFFC0151C);
		debugfs_create_x16("FIO1_MASKB_C", 0600, parent, (u16 *)0xFFC01524);
		debugfs_create_x16("FIO1_MASKB_D", 0600, parent, (u16 *)0xFFC01520);
		debugfs_create_x16("FIO1_MASKB_S", 0600, parent, (u16 *)0xFFC01528);
		debugfs_create_x16("FIO1_MASKB_T", 0600, parent, (u16 *)0xFFC0152C);
		debugfs_create_x16("FIO1_POLAR", 0600, parent, (u16 *)0xFFC01534);

		parent = debugfs_create_dir("Flag 2", top);
		debugfs_create_x16("FIO2_BOTH", 0600, parent, (u16 *)0xFFC0173C);
		debugfs_create_x16("FIO2_DIR", 0600, parent, (u16 *)0xFFC01730);
		debugfs_create_x16("FIO2_EDGE", 0600, parent, (u16 *)0xFFC01738);
		debugfs_create_x16("FIO2_FLAG_C", 0600, parent, (u16 *)0xFFC01704);
		debugfs_create_x16("FIO2_FLAG_D", 0600, parent, (u16 *)0xFFC01700);
		debugfs_create_x16("FIO2_FLAG_S", 0600, parent, (u16 *)0xFFC01708);
		debugfs_create_x16("FIO2_FLAG_T", 0600, parent, (u16 *)0xFFC0170C);
		debugfs_create_x16("FIO2_INEN", 0600, parent, (u16 *)0xFFC01740);
		debugfs_create_x16("FIO2_MASKA_C", 0600, parent, (u16 *)0xFFC01714);
		debugfs_create_x16("FIO2_MASKA_D", 0600, parent, (u16 *)0xFFC01710);
		debugfs_create_x16("FIO2_MASKA_S", 0600, parent, (u16 *)0xFFC01718);
		debugfs_create_x16("FIO2_MASKA_T", 0600, parent, (u16 *)0xFFC0171C);
		debugfs_create_x16("FIO2_MASKB_C", 0600, parent, (u16 *)0xFFC01724);
		debugfs_create_x16("FIO2_MASKB_D", 0600, parent, (u16 *)0xFFC01720);
		debugfs_create_x16("FIO2_MASKB_S", 0600, parent, (u16 *)0xFFC01728);
		debugfs_create_x16("FIO2_MASKB_T", 0600, parent, (u16 *)0xFFC0172C);
		debugfs_create_x16("FIO2_POLAR", 0600, parent, (u16 *)0xFFC01734);

		parent = debugfs_create_dir("IMDMA Destination Channel-0", top);
		debugfs_create_x16("IMDMA_D0_CONFIG", 0600, parent, (u16 *)0xFFC01808);
		debugfs_create_x32("IMDMA_D0_CURR_ADDR", 0600, parent, (u32 *)0xFFC01824);
		debugfs_create_x32("IMDMA_D0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01820);
		debugfs_create_x16("IMDMA_D0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01830);
		debugfs_create_x16("IMDMA_D0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01838);
		debugfs_create_x16("IMDMA_D0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01828);
		debugfs_create_x32("IMDMA_D0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01800);
		debugfs_create_x32("IMDMA_D0_START_ADDR", 0600, parent, (u32 *)0xFFC01804);
		debugfs_create_x16("IMDMA_D0_X_COUNT", 0600, parent, (u16 *)0xFFC01810);
		debugfs_create_x16("IMDMA_D0_X_MODIFY", 0600, parent, (u16 *)0xFFC01814);
		debugfs_create_x16("IMDMA_D0_Y_COUNT", 0600, parent, (u16 *)0xFFC01818);
		debugfs_create_x16("IMDMA_D0_Y_MODIFY", 0600, parent, (u16 *)0xFFC0181C);

		parent = debugfs_create_dir("IMDMA Destination Channel-1", top);
		debugfs_create_x16("IMDMA_D1_CONFIG", 0600, parent, (u16 *)0xFFC01888);
		debugfs_create_x32("IMDMA_D1_CURR_ADDR", 0600, parent, (u32 *)0xFFC018A4);
		debugfs_create_x32("IMDMA_D1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC018A0);
		debugfs_create_x16("IMDMA_D1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC018B0);
		debugfs_create_x16("IMDMA_D1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC018B8);
		debugfs_create_x16("IMDMA_D1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC018A8);
		debugfs_create_x32("IMDMA_D1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01880);
		debugfs_create_x32("IMDMA_D1_START_ADDR", 0600, parent, (u32 *)0xFFC01884);
		debugfs_create_x16("IMDMA_D1_X_COUNT", 0600, parent, (u16 *)0xFFC01890);
		debugfs_create_x16("IMDMA_D1_X_MODIFY", 0600, parent, (u16 *)0xFFC01894);
		debugfs_create_x16("IMDMA_D1_Y_COUNT", 0600, parent, (u16 *)0xFFC01898);
		debugfs_create_x16("IMDMA_D1_Y_MODIFY", 0600, parent, (u16 *)0xFFC0189C);

		parent = debugfs_create_dir("IMDMA Source Channel-0", top);
		debugfs_create_x16("IMDMA_S0_CONFIG", 0600, parent, (u16 *)0xFFC01848);
		debugfs_create_x32("IMDMA_S0_CURR_ADDR", 0600, parent, (u32 *)0xFFC01864);
		debugfs_create_x32("IMDMA_S0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01860);
		debugfs_create_x16("IMDMA_S0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01870);
		debugfs_create_x16("IMDMA_S0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01878);
		debugfs_create_x16("IMDMA_S0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01868);
		debugfs_create_x32("IMDMA_S0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01840);
		debugfs_create_x32("IMDMA_S0_START_ADDR", 0600, parent, (u32 *)0xFFC01844);
		debugfs_create_x16("IMDMA_S0_X_COUNT", 0600, parent, (u16 *)0xFFC01850);
		debugfs_create_x16("IMDMA_S0_X_MODIFY", 0600, parent, (u16 *)0xFFC01854);
		debugfs_create_x16("IMDMA_S0_Y_COUNT", 0600, parent, (u16 *)0xFFC01858);
		debugfs_create_x16("IMDMA_S0_Y_MODIFY", 0600, parent, (u16 *)0xFFC0185C);

		parent = debugfs_create_dir("IMDMA Source Channel-1", top);
		debugfs_create_x16("IMDMA_S1_CONFIG", 0600, parent, (u16 *)0xFFC018C8);
		debugfs_create_x32("IMDMA_S1_CURR_ADDR", 0600, parent, (u32 *)0xFFC018E4);
		debugfs_create_x32("IMDMA_S1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC018E0);
		debugfs_create_x16("IMDMA_S1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC018F0);
		debugfs_create_x16("IMDMA_S1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC018F8);
		debugfs_create_x16("IMDMA_S1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC018E8);
		debugfs_create_x32("IMDMA_S1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC018C0);
		debugfs_create_x32("IMDMA_S1_START_ADDR", 0600, parent, (u32 *)0xFFC018C4);
		debugfs_create_x16("IMDMA_S1_X_COUNT", 0600, parent, (u16 *)0xFFC018D0);
		debugfs_create_x16("IMDMA_S1_X_MODIFY", 0600, parent, (u16 *)0xFFC018D4);
		debugfs_create_x16("IMDMA_S1_Y_COUNT", 0600, parent, (u16 *)0xFFC018D8);
		debugfs_create_x16("IMDMA_S1_Y_MODIFY", 0600, parent, (u16 *)0xFFC018DC);

		parent = debugfs_create_dir("Interrupt Controller", top);
		debugfs_create_x32("ILAT", 0600, parent, (u32 *)0xFFE0210C);
		debugfs_create_x32("IMASK", 0600, parent, (u32 *)0xFFE02104);
		debugfs_create_x32("IPEND", 0600, parent, (u32 *)0xFFE02108);
		debugfs_create_x32("IPRIO", 0600, parent, (u32 *)0xFFE02110);

		parent = debugfs_create_dir("L1 Code Memory Registers", top);
		debugfs_create_x32("ICPLB_ADDR0", 0600, parent, (u32 *)0xFFE01100);
		debugfs_create_x32("ICPLB_ADDR10", 0600, parent, (u32 *)0xFFE01128);
		debugfs_create_x32("ICPLB_ADDR11", 0600, parent, (u32 *)0xFFE0112C);
		debugfs_create_x32("ICPLB_ADDR12", 0600, parent, (u32 *)0xFFE01130);
		debugfs_create_x32("ICPLB_ADDR13", 0600, parent, (u32 *)0xFFE01134);
		debugfs_create_x32("ICPLB_ADDR14", 0600, parent, (u32 *)0xFFE01138);
		debugfs_create_x32("ICPLB_ADDR15", 0600, parent, (u32 *)0xFFE0113C);
		debugfs_create_x32("ICPLB_ADDR1", 0600, parent, (u32 *)0xFFE01104);
		debugfs_create_x32("ICPLB_ADDR2", 0600, parent, (u32 *)0xFFE01108);
		debugfs_create_x32("ICPLB_ADDR3", 0600, parent, (u32 *)0xFFE0110C);
		debugfs_create_x32("ICPLB_ADDR4", 0600, parent, (u32 *)0xFFE01110);
		debugfs_create_x32("ICPLB_ADDR5", 0600, parent, (u32 *)0xFFE01114);
		debugfs_create_x32("ICPLB_ADDR6", 0600, parent, (u32 *)0xFFE01118);
		debugfs_create_x32("ICPLB_ADDR7", 0600, parent, (u32 *)0xFFE0111C);
		debugfs_create_x32("ICPLB_ADDR8", 0600, parent, (u32 *)0xFFE01120);
		debugfs_create_x32("ICPLB_ADDR9", 0600, parent, (u32 *)0xFFE01124);
		debugfs_create_x32("ICPLB_DATA0", 0600, parent, (u32 *)0xFFE01200);
		debugfs_create_x32("ICPLB_DATA10", 0600, parent, (u32 *)0xFFE01228);
		debugfs_create_x32("ICPLB_DATA11", 0600, parent, (u32 *)0xFFE0122C);
		debugfs_create_x32("ICPLB_DATA12", 0600, parent, (u32 *)0xFFE01230);
		debugfs_create_x32("ICPLB_DATA13", 0600, parent, (u32 *)0xFFE01234);
		debugfs_create_x32("ICPLB_DATA14", 0600, parent, (u32 *)0xFFE01238);
		debugfs_create_x32("ICPLB_DATA15", 0600, parent, (u32 *)0xFFE0123C);
		debugfs_create_x32("ICPLB_DATA1", 0600, parent, (u32 *)0xFFE01204);
		debugfs_create_x32("ICPLB_DATA2", 0600, parent, (u32 *)0xFFE01208);
		debugfs_create_x32("ICPLB_DATA3", 0600, parent, (u32 *)0xFFE0120C);
		debugfs_create_x32("ICPLB_DATA4", 0600, parent, (u32 *)0xFFE01210);
		debugfs_create_x32("ICPLB_DATA5", 0600, parent, (u32 *)0xFFE01214);
		debugfs_create_x32("ICPLB_DATA6", 0600, parent, (u32 *)0xFFE01218);
		debugfs_create_x32("ICPLB_DATA7", 0600, parent, (u32 *)0xFFE0121C);
		debugfs_create_x32("ICPLB_DATA8", 0600, parent, (u32 *)0xFFE01220);
		debugfs_create_x32("ICPLB_DATA9", 0600, parent, (u32 *)0xFFE01224);
		debugfs_create_x32("ICPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0100C);
		debugfs_create_x32("ICPLB_STATUS", 0600, parent, (u32 *)0xFFE01008);
		debugfs_create_x32("IMEM_CONTROL", 0600, parent, (u32 *)0xFFE01004);
		debugfs_create_x32("ITEST_COMMAND", 0600, parent, (u32 *)0xFFE01300);
		debugfs_create_x32("ITEST_DATA0", 0600, parent, (u32 *)0xFFE01400);
		debugfs_create_x32("ITEST_DATA1", 0600, parent, (u32 *)0xFFE01404);

		parent = debugfs_create_dir("L1 Data Memory Registers", top);
		debugfs_create_x32("DCPLB_ADDR0", 0600, parent, (u32 *)0xFFE00100);
		debugfs_create_x32("DCPLB_ADDR10", 0600, parent, (u32 *)0xFFE00128);
		debugfs_create_x32("DCPLB_ADDR11", 0600, parent, (u32 *)0xFFE0012C);
		debugfs_create_x32("DCPLB_ADDR12", 0600, parent, (u32 *)0xFFE00130);
		debugfs_create_x32("DCPLB_ADDR13", 0600, parent, (u32 *)0xFFE00134);
		debugfs_create_x32("DCPLB_ADDR14", 0600, parent, (u32 *)0xFFE00138);
		debugfs_create_x32("DCPLB_ADDR15", 0600, parent, (u32 *)0xFFE0013C);
		debugfs_create_x32("DCPLB_ADDR1", 0600, parent, (u32 *)0xFFE00104);
		debugfs_create_x32("DCPLB_ADDR2", 0600, parent, (u32 *)0xFFE00108);
		debugfs_create_x32("DCPLB_ADDR3", 0600, parent, (u32 *)0xFFE0010C);
		debugfs_create_x32("DCPLB_ADDR4", 0600, parent, (u32 *)0xFFE00110);
		debugfs_create_x32("DCPLB_ADDR5", 0600, parent, (u32 *)0xFFE00114);
		debugfs_create_x32("DCPLB_ADDR6", 0600, parent, (u32 *)0xFFE00118);
		debugfs_create_x32("DCPLB_ADDR7", 0600, parent, (u32 *)0xFFE0011C);
		debugfs_create_x32("DCPLB_ADDR8", 0600, parent, (u32 *)0xFFE00120);
		debugfs_create_x32("DCPLB_ADDR9", 0600, parent, (u32 *)0xFFE00124);
		debugfs_create_x32("DCPLB_DATA0", 0600, parent, (u32 *)0xFFE00200);
		debugfs_create_x32("DCPLB_DATA10", 0600, parent, (u32 *)0xFFE00228);
		debugfs_create_x32("DCPLB_DATA11", 0600, parent, (u32 *)0xFFE0022C);
		debugfs_create_x32("DCPLB_DATA12", 0600, parent, (u32 *)0xFFE00230);
		debugfs_create_x32("DCPLB_DATA13", 0600, parent, (u32 *)0xFFE00234);
		debugfs_create_x32("DCPLB_DATA14", 0600, parent, (u32 *)0xFFE00238);
		debugfs_create_x32("DCPLB_DATA15", 0600, parent, (u32 *)0xFFE0023C);
		debugfs_create_x32("DCPLB_DATA1", 0600, parent, (u32 *)0xFFE00204);
		debugfs_create_x32("DCPLB_DATA2", 0600, parent, (u32 *)0xFFE00208);
		debugfs_create_x32("DCPLB_DATA3", 0600, parent, (u32 *)0xFFE0020C);
		debugfs_create_x32("DCPLB_DATA4", 0600, parent, (u32 *)0xFFE00210);
		debugfs_create_x32("DCPLB_DATA5", 0600, parent, (u32 *)0xFFE00214);
		debugfs_create_x32("DCPLB_DATA6", 0600, parent, (u32 *)0xFFE00218);
		debugfs_create_x32("DCPLB_DATA7", 0600, parent, (u32 *)0xFFE0021C);
		debugfs_create_x32("DCPLB_DATA8", 0600, parent, (u32 *)0xFFE00220);
		debugfs_create_x32("DCPLB_DATA9", 0600, parent, (u32 *)0xFFE00224);
		debugfs_create_x32("DCPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0000C);
		debugfs_create_x32("DCPLB_STATUS", 0600, parent, (u32 *)0xFFE00008);
		debugfs_create_x32("DMEM_CONTROL", 0600, parent, (u32 *)0xFFE00004);
		debugfs_create_x32("DTEST_COMMAND", 0600, parent, (u32 *)0xFFE00300);
		debugfs_create_x32("DTEST_DATA0", 0600, parent, (u32 *)0xFFE00400);
		debugfs_create_x32("DTEST_DATA1", 0600, parent, (u32 *)0xFFE00404);
		debugfs_create_x32("SRAM_BASE_ADDR", 0600, parent, (u32 *)0xFFE00000);

		parent = debugfs_create_dir("MDMA1_0 Destination", top);
		debugfs_create_x16("MDMA1_D0_CONFIG", 0600, parent, (u16 *)0xFFC01F08);
		debugfs_create_x32("MDMA1_D0_CURR_ADDR", 0600, parent, (u32 *)0xFFC01F24);
		debugfs_create_x32("MDMA1_D0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01F20);
		debugfs_create_x16("MDMA1_D0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01F30);
		debugfs_create_x16("MDMA1_D0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01F38);
		debugfs_create_x16("MDMA1_D0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01F28);
		debugfs_create_x32("MDMA1_D0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01F00);
		debugfs_create_x16("MDMA1_D0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01F2C);
		debugfs_create_x32("MDMA1_D0_START_ADDR", 0600, parent, (u32 *)0xFFC01F04);
		debugfs_create_x16("MDMA1_D0_X_COUNT", 0600, parent, (u16 *)0xFFC01F10);
		debugfs_create_x16("MDMA1_D0_X_MODIFY", 0600, parent, (u16 *)0xFFC01F14);
		debugfs_create_x16("MDMA1_D0_Y_COUNT", 0600, parent, (u16 *)0xFFC01F18);
		debugfs_create_x16("MDMA1_D0_Y_MODIFY", 0600, parent, (u16 *)0xFFC01F1C);

		parent = debugfs_create_dir("MDMA1_0 Source", top);
		debugfs_create_x16("MDMA1_S0_CONFIG", 0600, parent, (u16 *)0xFFC01F48);
		debugfs_create_x32("MDMA1_S0_CURR_ADDR", 0600, parent, (u32 *)0xFFC01F64);
		debugfs_create_x32("MDMA1_S0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01F60);
		debugfs_create_x16("MDMA1_S0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01F70);
		debugfs_create_x16("MDMA1_S0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01F78);
		debugfs_create_x16("MDMA1_S0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01F68);
		debugfs_create_x32("MDMA1_S0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01F40);
		debugfs_create_x16("MDMA1_S0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01F6C);
		debugfs_create_x32("MDMA1_S0_START_ADDR", 0600, parent, (u32 *)0xFFC01F44);
		debugfs_create_x16("MDMA1_S0_X_COUNT", 0600, parent, (u16 *)0xFFC01F50);
		debugfs_create_x16("MDMA1_S0_X_MODIFY", 0600, parent, (u16 *)0xFFC01F54);
		debugfs_create_x16("MDMA1_S0_Y_COUNT", 0600, parent, (u16 *)0xFFC01F58);
		debugfs_create_x16("MDMA1_S0_Y_MODIFY", 0600, parent, (u16 *)0xFFC01F5C);

		parent = debugfs_create_dir("MDMA1_1 Destination", top);
		debugfs_create_x16("MDMA1_D1_CONFIG", 0600, parent, (u16 *)0xFFC01F88);
		debugfs_create_x32("MDMA1_D1_CURR_ADDR", 0600, parent, (u32 *)0xFFC01FA4);
		debugfs_create_x32("MDMA1_D1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01FA0);
		debugfs_create_x16("MDMA1_D1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01FB0);
		debugfs_create_x16("MDMA1_D1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01FB8);
		debugfs_create_x16("MDMA1_D1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01FA8);
		debugfs_create_x32("MDMA1_D1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01F80);
		debugfs_create_x16("MDMA1_D1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01FAC);
		debugfs_create_x32("MDMA1_D1_START_ADDR", 0600, parent, (u32 *)0xFFC01F84);
		debugfs_create_x16("MDMA1_D1_X_COUNT", 0600, parent, (u16 *)0xFFC01F90);
		debugfs_create_x16("MDMA1_D1_X_MODIFY", 0600, parent, (u16 *)0xFFC01F94);
		debugfs_create_x16("MDMA1_D1_Y_COUNT", 0600, parent, (u16 *)0xFFC01F98);
		debugfs_create_x16("MDMA1_D1_Y_MODIFY", 0600, parent, (u16 *)0xFFC01F9C);

		parent = debugfs_create_dir("MDMA1_1 Source", top);
		debugfs_create_x16("MDMA1_S1_CONFIG", 0600, parent, (u16 *)0xFFC01FC8);
		debugfs_create_x32("MDMA1_S1_CURR_ADDR", 0600, parent, (u32 *)0xFFC01FE4);
		debugfs_create_x32("MDMA1_S1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC01FE0);
		debugfs_create_x16("MDMA1_S1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC01FF0);
		debugfs_create_x16("MDMA1_S1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC01FF8);
		debugfs_create_x16("MDMA1_S1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC01FE8);
		debugfs_create_x32("MDMA1_S1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC01FC0);
		debugfs_create_x16("MDMA1_S1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC01FEC);
		debugfs_create_x32("MDMA1_S1_START_ADDR", 0600, parent, (u32 *)0xFFC01FC4);
		debugfs_create_x16("MDMA1_S1_X_COUNT", 0600, parent, (u16 *)0xFFC01FD0);
		debugfs_create_x16("MDMA1_S1_X_MODIFY", 0600, parent, (u16 *)0xFFC01FD4);
		debugfs_create_x16("MDMA1_S1_Y_COUNT", 0600, parent, (u16 *)0xFFC01FD8);
		debugfs_create_x16("MDMA1_S1_Y_MODIFY", 0600, parent, (u16 *)0xFFC01FDC);

		parent = debugfs_create_dir("MDMA2_0 Destination", top);
		debugfs_create_x16("MDMA2_D0_CONFIG", 0600, parent, (u16 *)0xFFC00F08);
		debugfs_create_x32("MDMA2_D0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F24);
		debugfs_create_x32("MDMA2_D0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F20);
		debugfs_create_x16("MDMA2_D0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F30);
		debugfs_create_x16("MDMA2_D0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F38);
		debugfs_create_x16("MDMA2_D0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F28);
		debugfs_create_x32("MDMA2_D0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F00);
		debugfs_create_x16("MDMA2_D0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F2C);
		debugfs_create_x32("MDMA2_D0_START_ADDR", 0600, parent, (u32 *)0xFFC00F04);
		debugfs_create_x16("MDMA2_D0_X_COUNT", 0600, parent, (u16 *)0xFFC00F10);
		debugfs_create_x16("MDMA2_D0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F14);
		debugfs_create_x16("MDMA2_D0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F18);
		debugfs_create_x16("MDMA2_D0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F1C);

		parent = debugfs_create_dir("MDMA2_0 Source", top);
		debugfs_create_x16("MDMA2_S0_CONFIG", 0600, parent, (u16 *)0xFFC00F48);
		debugfs_create_x32("MDMA2_S0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00F64);
		debugfs_create_x32("MDMA2_S0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00F60);
		debugfs_create_x16("MDMA2_S0_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00F70);
		debugfs_create_x16("MDMA2_S0_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00F78);
		debugfs_create_x16("MDMA2_S0_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00F68);
		debugfs_create_x32("MDMA2_S0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F40);
		debugfs_create_x16("MDMA2_S0_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00F6C);
		debugfs_create_x32("MDMA2_S0_START_ADDR", 0600, parent, (u32 *)0xFFC00F44);
		debugfs_create_x16("MDMA2_S0_X_COUNT", 0600, parent, (u16 *)0xFFC00F50);
		debugfs_create_x16("MDMA2_S0_X_MODIFY", 0600, parent, (u16 *)0xFFC00F54);
		debugfs_create_x16("MDMA2_S0_Y_COUNT", 0600, parent, (u16 *)0xFFC00F58);
		debugfs_create_x16("MDMA2_S0_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F5C);

		parent = debugfs_create_dir("MDMA2_1 Destination", top);
		debugfs_create_x16("MDMA2_D1_CONFIG", 0600, parent, (u16 *)0xFFC00F88);
		debugfs_create_x32("MDMA2_D1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FA4);
		debugfs_create_x32("MDMA2_D1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FA0);
		debugfs_create_x16("MDMA2_D1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FB0);
		debugfs_create_x16("MDMA2_D1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FB8);
		debugfs_create_x16("MDMA2_D1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FA8);
		debugfs_create_x32("MDMA2_D1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00F80);
		debugfs_create_x16("MDMA2_D1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FAC);
		debugfs_create_x32("MDMA2_D1_START_ADDR", 0600, parent, (u32 *)0xFFC00F84);
		debugfs_create_x16("MDMA2_D1_X_COUNT", 0600, parent, (u16 *)0xFFC00F90);
		debugfs_create_x16("MDMA2_D1_X_MODIFY", 0600, parent, (u16 *)0xFFC00F94);
		debugfs_create_x16("MDMA2_D1_Y_COUNT", 0600, parent, (u16 *)0xFFC00F98);
		debugfs_create_x16("MDMA2_D1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00F9C);

		parent = debugfs_create_dir("MDMA2_1 Source", top);
		debugfs_create_x16("MDMA2_S1_CONFIG", 0600, parent, (u16 *)0xFFC00FC8);
		debugfs_create_x32("MDMA2_S1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00FE4);
		debugfs_create_x32("MDMA2_S1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00FE0);
		debugfs_create_x16("MDMA2_S1_CURR_X_COUNT", 0600, parent, (u16 *)0xFFC00FF0);
		debugfs_create_x16("MDMA2_S1_CURR_Y_COUNT", 0600, parent, (u16 *)0xFFC00FF8);
		debugfs_create_x16("MDMA2_S1_IRQ_STATUS", 0600, parent, (u16 *)0xFFC00FE8);
		debugfs_create_x32("MDMA2_S1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00FC0);
		debugfs_create_x16("MDMA2_S1_PERIPHERAL_MAP", 0600, parent, (u16 *)0xFFC00FEC);
		debugfs_create_x32("MDMA2_S1_START_ADDR", 0600, parent, (u32 *)0xFFC00FC4);
		debugfs_create_x16("MDMA2_S1_X_COUNT", 0600, parent, (u16 *)0xFFC00FD0);
		debugfs_create_x16("MDMA2_S1_X_MODIFY", 0600, parent, (u16 *)0xFFC00FD4);
		debugfs_create_x16("MDMA2_S1_Y_COUNT", 0600, parent, (u16 *)0xFFC00FD8);
		debugfs_create_x16("MDMA2_S1_Y_MODIFY", 0600, parent, (u16 *)0xFFC00FDC);

		parent = debugfs_create_dir("PLL", top);
		debugfs_create_x16("PLL_CTL", 0600, parent, (u16 *)0xFFC00000);
		debugfs_create_x16("PLL_DIV", 0600, parent, (u16 *)0xFFC00004);
		debugfs_create_x16("PLL_LOCKCNT", 0600, parent, (u16 *)0xFFC00010);
		debugfs_create_x16("PLL_STAT", 0600, parent, (u16 *)0xFFC0000C);
		debugfs_create_x16("VR_CTL", 0600, parent, (u16 *)0xFFC00008);

		parent = debugfs_create_dir("PPI", top);
		debugfs_create_x16("PPI0_CONTROL", 0600, parent, (u16 *)0xFFC01000);
		debugfs_create_x16("PPI0_COUNT", 0600, parent, (u16 *)0xFFC01008);
		debugfs_create_x16("PPI0_DELAY", 0600, parent, (u16 *)0xFFC0100C);
		debugfs_create_x16("PPI0_FRAME", 0600, parent, (u16 *)0xFFC01010);
		debugfs_create_x16("PPI0_STATUS", 0600, parent, (u16 *)0xFFC01004);
		debugfs_create_x16("PPI1_CONTROL", 0600, parent, (u16 *)0xFFC01300);
		debugfs_create_x16("PPI1_COUNT", 0600, parent, (u16 *)0xFFC01308);
		debugfs_create_x16("PPI1_DELAY", 0600, parent, (u16 *)0xFFC0130C);
		debugfs_create_x16("PPI1_FRAME", 0600, parent, (u16 *)0xFFC01310);
		debugfs_create_x16("PPI1_STATUS", 0600, parent, (u16 *)0xFFC01304);

		parent = debugfs_create_dir("Performance Monitor", top);
		debugfs_create_x32("PFCNTR0", 0600, parent, (u32 *)0xFFE08100);
		debugfs_create_x32("PFCNTR1", 0600, parent, (u32 *)0xFFE08104);
		debugfs_create_x32("PFCTL", 0600, parent, (u32 *)0xFFE08000);

		parent = debugfs_create_dir("SICA Register File", top);
		debugfs_create_x32("SICA_IAR0", 0600, parent, (u32 *)0xFFC00124);
		debugfs_create_x32("SICA_IAR1", 0600, parent, (u32 *)0xFFC00128);
		debugfs_create_x32("SICA_IAR2", 0600, parent, (u32 *)0xFFC0012C);
		debugfs_create_x32("SICA_IAR3", 0600, parent, (u32 *)0xFFC00130);
		debugfs_create_x32("SICA_IAR4", 0600, parent, (u32 *)0xFFC00134);
		debugfs_create_x32("SICA_IAR5", 0600, parent, (u32 *)0xFFC00138);
		debugfs_create_x32("SICA_IAR6", 0600, parent, (u32 *)0xFFC0013C);
		debugfs_create_x32("SICA_IAR7", 0600, parent, (u32 *)0xFFC00140);
		debugfs_create_x32("SICA_IMASK0", 0600, parent, (u32 *)0xFFC0010C);
		debugfs_create_x32("SICA_IMASK1", 0600, parent, (u32 *)0xFFC00110);
		debugfs_create_x32("SICA_ISR0", 0600, parent, (u32 *)0xFFC00114);
		debugfs_create_x32("SICA_ISR1", 0600, parent, (u32 *)0xFFC00118);
		debugfs_create_x32("SICA_IWR0", 0600, parent, (u32 *)0xFFC0011C);
		debugfs_create_x32("SICA_IWR1", 0600, parent, (u32 *)0xFFC00120);
		debugfs_create_x16("SICA_RVECT", 0600, parent, (u16 *)0xFFC00108);
		debugfs_create_x32("SICA_SWRST", 0600, parent, (u32 *)0xFFC00100);
		debugfs_create_x32("SICA_SYSCR", 0600, parent, (u32 *)0xFFC00104);

		parent = debugfs_create_dir("SICB Register File", top);
		debugfs_create_x32("SICB_IAR0", 0600, parent, (u32 *)0xFFC01124);
		debugfs_create_x32("SICB_IAR1", 0600, parent, (u32 *)0xFFC01128);
		debugfs_create_x32("SICB_IAR2", 0600, parent, (u32 *)0xFFC0112C);
		debugfs_create_x32("SICB_IAR3", 0600, parent, (u32 *)0xFFC01130);
		debugfs_create_x32("SICB_IAR4", 0600, parent, (u32 *)0xFFC01134);
		debugfs_create_x32("SICB_IAR5", 0600, parent, (u32 *)0xFFC01138);
		debugfs_create_x32("SICB_IAR6", 0600, parent, (u32 *)0xFFC0113C);
		debugfs_create_x32("SICB_IAR7", 0600, parent, (u32 *)0xFFC01140);
		debugfs_create_x32("SICB_IMASK0", 0600, parent, (u32 *)0xFFC0110C);
		debugfs_create_x32("SICB_IMASK1", 0600, parent, (u32 *)0xFFC01110);
		debugfs_create_x32("SICB_ISR0", 0600, parent, (u32 *)0xFFC01114);
		debugfs_create_x32("SICB_ISR1", 0600, parent, (u32 *)0xFFC01118);
		debugfs_create_x32("SICB_IWR0", 0600, parent, (u32 *)0xFFC0111C);
		debugfs_create_x32("SICB_IWR1", 0600, parent, (u32 *)0xFFC01120);
		debugfs_create_x16("SICB_RVECT", 0600, parent, (u16 *)0xFFC01108);
		debugfs_create_x32("SICB_SWRST", 0600, parent, (u32 *)0xFFC01100);
		debugfs_create_x32("SICB_SYSCR", 0600, parent, (u32 *)0xFFC01104);

		parent = debugfs_create_dir("SPI", top);
		debugfs_create_x16("SPI_BAUD", 0600, parent, (u16 *)0xFFC00514);
		debugfs_create_x16("SPI_CTL", 0600, parent, (u16 *)0xFFC00500);
		debugfs_create_x16("SPI_FLG", 0600, parent, (u16 *)0xFFC00504);
		debugfs_create_x16("SPI_RDBR", 0600, parent, (u16 *)0xFFC00510);
		debugfs_create_x16("SPI_SHADOW", 0600, parent, (u16 *)0xFFC00518);
		debugfs_create_x16("SPI_STAT", 0600, parent, (u16 *)0xFFC00508);
		debugfs_create_x16("SPI_TDBR", 0600, parent, (u16 *)0xFFC0050C);

		parent = debugfs_create_dir("SPORT", top);
		debugfs_create_x16("SPORT0_CHNL", 0600, parent, (u16 *)0xFFC00834);
		debugfs_create_x16("SPORT0_MCMC1", 0600, parent, (u16 *)0xFFC00838);
		debugfs_create_x16("SPORT0_MCMC2", 0600, parent, (u16 *)0xFFC0083C);
		debugfs_create_x32("SPORT0_MRCS0", 0600, parent, (u32 *)0xFFC00850);
		debugfs_create_x32("SPORT0_MRCS1", 0600, parent, (u32 *)0xFFC00854);
		debugfs_create_x32("SPORT0_MRCS2", 0600, parent, (u32 *)0xFFC00858);
		debugfs_create_x32("SPORT0_MRCS3", 0600, parent, (u32 *)0xFFC0085C);
		debugfs_create_x32("SPORT0_MTCS0", 0600, parent, (u32 *)0xFFC00840);
		debugfs_create_x32("SPORT0_MTCS1", 0600, parent, (u32 *)0xFFC00844);
		debugfs_create_x32("SPORT0_MTCS2", 0600, parent, (u32 *)0xFFC00848);
		debugfs_create_x32("SPORT0_MTCS3", 0600, parent, (u32 *)0xFFC0084C);
		debugfs_create_x16("SPORT0_RCLKDIV", 0600, parent, (u16 *)0xFFC00828);
		debugfs_create_x16("SPORT0_RCR1", 0600, parent, (u16 *)0xFFC00820);
		debugfs_create_x16("SPORT0_RCR2", 0600, parent, (u16 *)0xFFC00824);
		debugfs_create_x16("SPORT0_RFSDIV", 0600, parent, (u16 *)0xFFC0082C);
		debugfs_create_x32("SPORT0_RX", 0600, parent, (u32 *)0xFFC00818);
		debugfs_create_x16("SPORT0_STAT", 0600, parent, (u16 *)0xFFC00830);
		debugfs_create_x16("SPORT0_TCLKDIV", 0600, parent, (u16 *)0xFFC00808);
		debugfs_create_x16("SPORT0_TCR1", 0600, parent, (u16 *)0xFFC00800);
		debugfs_create_x16("SPORT0_TCR2", 0600, parent, (u16 *)0xFFC00804);
		debugfs_create_x16("SPORT0_TFSDIV", 0600, parent, (u16 *)0xFFC0080C);
		debugfs_create_x32("SPORT0_TX", 0600, parent, (u32 *)0xFFC00810);
		debugfs_create_x16("SPORT1_CHNL", 0600, parent, (u16 *)0xFFC00934);
		debugfs_create_x16("SPORT1_MCMC1", 0600, parent, (u16 *)0xFFC00938);
		debugfs_create_x16("SPORT1_MCMC2", 0600, parent, (u16 *)0xFFC0093C);
		debugfs_create_x32("SPORT1_MRCS0", 0600, parent, (u32 *)0xFFC00950);
		debugfs_create_x32("SPORT1_MRCS1", 0600, parent, (u32 *)0xFFC00954);
		debugfs_create_x32("SPORT1_MRCS2", 0600, parent, (u32 *)0xFFC00958);
		debugfs_create_x32("SPORT1_MRCS3", 0600, parent, (u32 *)0xFFC0095C);
		debugfs_create_x32("SPORT1_MTCS0", 0600, parent, (u32 *)0xFFC00940);
		debugfs_create_x32("SPORT1_MTCS1", 0600, parent, (u32 *)0xFFC00944);
		debugfs_create_x32("SPORT1_MTCS2", 0600, parent, (u32 *)0xFFC00948);
		debugfs_create_x32("SPORT1_MTCS3", 0600, parent, (u32 *)0xFFC0094C);
		debugfs_create_x16("SPORT1_RCLKDIV", 0600, parent, (u16 *)0xFFC00928);
		debugfs_create_x16("SPORT1_RCR1", 0600, parent, (u16 *)0xFFC00920);
		debugfs_create_x16("SPORT1_RCR2", 0600, parent, (u16 *)0xFFC00924);
		debugfs_create_x16("SPORT1_RFSDIV", 0600, parent, (u16 *)0xFFC0092C);
		debugfs_create_x32("SPORT1_RX", 0600, parent, (u32 *)0xFFC00918);
		debugfs_create_x16("SPORT1_STAT", 0600, parent, (u16 *)0xFFC00930);
		debugfs_create_x16("SPORT1_TCLKDIV", 0600, parent, (u16 *)0xFFC00908);
		debugfs_create_x16("SPORT1_TCR1", 0600, parent, (u16 *)0xFFC00900);
		debugfs_create_x16("SPORT1_TCR2", 0600, parent, (u16 *)0xFFC00904);
		debugfs_create_x16("SPORT1_TFSDIV", 0600, parent, (u16 *)0xFFC0090C);
		debugfs_create_x32("SPORT1_TX", 0600, parent, (u32 *)0xFFC00910);

		parent = debugfs_create_dir("System Timers", top);
		debugfs_create_x16("TIMER0_CONFIG", 0600, parent, (u16 *)0xFFC00600);
		debugfs_create_x32("TIMER0_COUNTER", 0600, parent, (u32 *)0xFFC00604);
		debugfs_create_x32("TIMER0_PERIOD", 0600, parent, (u32 *)0xFFC00608);
		debugfs_create_x32("TIMER0_WIDTH", 0600, parent, (u32 *)0xFFC0060C);
		debugfs_create_x16("TIMER10_CONFIG", 0600, parent, (u16 *)0xFFC01620);
		debugfs_create_x32("TIMER10_COUNTER", 0600, parent, (u32 *)0xFFC01624);
		debugfs_create_x32("TIMER10_PERIOD", 0600, parent, (u32 *)0xFFC01628);
		debugfs_create_x32("TIMER10_WIDTH", 0600, parent, (u32 *)0xFFC0162C);
		debugfs_create_x16("TIMER11_CONFIG", 0600, parent, (u16 *)0xFFC01630);
		debugfs_create_x32("TIMER11_COUNTER", 0600, parent, (u32 *)0xFFC01634);
		debugfs_create_x32("TIMER11_PERIOD", 0600, parent, (u32 *)0xFFC01638);
		debugfs_create_x32("TIMER11_WIDTH", 0600, parent, (u32 *)0xFFC0163C);
		debugfs_create_x16("TIMER1_CONFIG", 0600, parent, (u16 *)0xFFC00610);
		debugfs_create_x32("TIMER1_COUNTER", 0600, parent, (u32 *)0xFFC00614);
		debugfs_create_x32("TIMER1_PERIOD", 0600, parent, (u32 *)0xFFC00618);
		debugfs_create_x32("TIMER1_WIDTH", 0600, parent, (u32 *)0xFFC0061C);
		debugfs_create_x16("TIMER2_CONFIG", 0600, parent, (u16 *)0xFFC00620);
		debugfs_create_x32("TIMER2_COUNTER", 0600, parent, (u32 *)0xFFC00624);
		debugfs_create_x32("TIMER2_PERIOD", 0600, parent, (u32 *)0xFFC00628);
		debugfs_create_x32("TIMER2_WIDTH", 0600, parent, (u32 *)0xFFC0062C);
		debugfs_create_x16("TIMER3_CONFIG", 0600, parent, (u16 *)0xFFC00630);
		debugfs_create_x32("TIMER3_COUNTER", 0600, parent, (u32 *)0xFFC00634);
		debugfs_create_x32("TIMER3_PERIOD", 0600, parent, (u32 *)0xFFC00638);
		debugfs_create_x32("TIMER3_WIDTH", 0600, parent, (u32 *)0xFFC0063C);
		debugfs_create_x16("TIMER4_CONFIG", 0600, parent, (u16 *)0xFFC00640);
		debugfs_create_x32("TIMER4_COUNTER", 0600, parent, (u32 *)0xFFC00644);
		debugfs_create_x32("TIMER4_PERIOD", 0600, parent, (u32 *)0xFFC00648);
		debugfs_create_x32("TIMER4_WIDTH", 0600, parent, (u32 *)0xFFC0064C);
		debugfs_create_x16("TIMER5_CONFIG", 0600, parent, (u16 *)0xFFC00650);
		debugfs_create_x32("TIMER5_COUNTER", 0600, parent, (u32 *)0xFFC00654);
		debugfs_create_x32("TIMER5_PERIOD", 0600, parent, (u32 *)0xFFC00658);
		debugfs_create_x32("TIMER5_WIDTH", 0600, parent, (u32 *)0xFFC0065C);
		debugfs_create_x16("TIMER6_CONFIG", 0600, parent, (u16 *)0xFFC00660);
		debugfs_create_x32("TIMER6_COUNTER", 0600, parent, (u32 *)0xFFC00664);
		debugfs_create_x32("TIMER6_PERIOD", 0600, parent, (u32 *)0xFFC00668);
		debugfs_create_x32("TIMER6_WIDTH", 0600, parent, (u32 *)0xFFC0066C);
		debugfs_create_x16("TIMER7_CONFIG", 0600, parent, (u16 *)0xFFC00670);
		debugfs_create_x32("TIMER7_COUNTER", 0600, parent, (u32 *)0xFFC00674);
		debugfs_create_x32("TIMER7_PERIOD", 0600, parent, (u32 *)0xFFC00678);
		debugfs_create_x32("TIMER7_WIDTH", 0600, parent, (u32 *)0xFFC0067C);
		debugfs_create_x16("TIMER8_CONFIG", 0600, parent, (u16 *)0xFFC01600);
		debugfs_create_x32("TIMER8_COUNTER", 0600, parent, (u32 *)0xFFC01604);
		debugfs_create_x32("TIMER8_PERIOD", 0600, parent, (u32 *)0xFFC01608);
		debugfs_create_x32("TIMER8_WIDTH", 0600, parent, (u32 *)0xFFC0160C);
		debugfs_create_x16("TIMER9_CONFIG", 0600, parent, (u16 *)0xFFC01610);
		debugfs_create_x32("TIMER9_COUNTER", 0600, parent, (u32 *)0xFFC01614);
		debugfs_create_x32("TIMER9_PERIOD", 0600, parent, (u32 *)0xFFC01618);
		debugfs_create_x32("TIMER9_WIDTH", 0600, parent, (u32 *)0xFFC0161C);
		debugfs_create_x32("TMRS4_DISABLE", 0600, parent, (u32 *)0xFFC01644);
		debugfs_create_x32("TMRS4_ENABLE", 0600, parent, (u32 *)0xFFC01640);
		debugfs_create_x32("TMRS4_STATUS", 0600, parent, (u32 *)0xFFC01648);
		debugfs_create_x32("TMRS8_DISABLE", 0600, parent, (u32 *)0xFFC00684);
		debugfs_create_x32("TMRS8_ENABLE", 0600, parent, (u32 *)0xFFC00680);
		debugfs_create_x32("TMRS8_STATUS", 0600, parent, (u32 *)0xFFC00688);

		parent = debugfs_create_dir("Trace Unit", top);
		debugfs_create_x32("TBUF", 0600, parent, (u32 *)0xFFE06100);
		debugfs_create_x32("TBUFCTL", 0600, parent, (u32 *)0xFFE06000);
		debugfs_create_x32("TBUFSTAT", 0600, parent, (u32 *)0xFFE06004);

		parent = debugfs_create_dir("UART", top);
		debugfs_create_x16("UART_DLH", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART_DLL", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART_GBL", 0600, parent, (u16 *)0xFFC00424);
		debugfs_create_x16("UART_GCTL", 0600, parent, (u16 *)0xFFC00424);
		debugfs_create_x16("UART_IER", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART_IIR", 0600, parent, (u16 *)0xFFC00408);
		debugfs_create_x16("UART_LCR", 0600, parent, (u16 *)0xFFC0040C);
		debugfs_create_x16("UART_LSR", 0600, parent, (u16 *)0xFFC00414);
		debugfs_create_x16("UART_MCR", 0600, parent, (u16 *)0xFFC00410);
		debugfs_create_x16("UART_MSR", 0600, parent, (u16 *)0xFFC00418);
		debugfs_create_x16("UART_RBR", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART_SCR", 0600, parent, (u16 *)0xFFC0041C);
		debugfs_create_x16("UART_THR", 0600, parent, (u16 *)0xFFC00400);

		parent = debugfs_create_dir("Watchdog", top);
		debugfs_create_x32("WDOGA_CNT", 0600, parent, (u32 *)0xFFC00204);
		debugfs_create_x16("WDOGA_CTL", 0600, parent, (u16 *)0xFFC00200);
		debugfs_create_x32("WDOGA_STAT", 0600, parent, (u32 *)0xFFC00208);
		debugfs_create_x32("WDOGB_CNT", 0600, parent, (u32 *)0xFFC01204);
		debugfs_create_x16("WDOGB_CTL", 0600, parent, (u16 *)0xFFC01200);
		debugfs_create_x32("WDOGB_STAT", 0600, parent, (u32 *)0xFFC01208);

		parent = debugfs_create_dir("Watchpoint and Patch Unit", top);
		debugfs_create_x32("WPDA0", 0600, parent, (u32 *)0xFFE07140);
		debugfs_create_x32("WPDA1", 0600, parent, (u32 *)0xFFE07144);
		debugfs_create_x32("WPDACNT0", 0600, parent, (u32 *)0xFFE07180);
		debugfs_create_x32("WPDACNT1", 0600, parent, (u32 *)0xFFE07184);
		debugfs_create_x32("WPDACTL", 0600, parent, (u32 *)0xFFE07100);
		debugfs_create_x32("WPIA0", 0600, parent, (u32 *)0xFFE07040);
		debugfs_create_x32("WPIA1", 0600, parent, (u32 *)0xFFE07044);
		debugfs_create_x32("WPIA2", 0600, parent, (u32 *)0xFFE07048);
		debugfs_create_x32("WPIA3", 0600, parent, (u32 *)0xFFE0704C);
		debugfs_create_x32("WPIA4", 0600, parent, (u32 *)0xFFE07050);
		debugfs_create_x32("WPIA5", 0600, parent, (u32 *)0xFFE07054);
		debugfs_create_x32("WPIACNT0", 0600, parent, (u32 *)0xFFE07080);
		debugfs_create_x32("WPIACNT1", 0600, parent, (u32 *)0xFFE07084);
		debugfs_create_x32("WPIACNT2", 0600, parent, (u32 *)0xFFE07088);
		debugfs_create_x32("WPIACNT3", 0600, parent, (u32 *)0xFFE0708C);
		debugfs_create_x32("WPIACNT4", 0600, parent, (u32 *)0xFFE07090);
		debugfs_create_x32("WPIACNT5", 0600, parent, (u32 *)0xFFE07094);
		debugfs_create_x32("WPIACTL", 0600, parent, (u32 *)0xFFE07000);
		debugfs_create_x32("WPSTAT", 0600, parent, (u32 *)0xFFE07200);

	}	/* BF561 */

#ifdef __ADSPBF6xx__
# define USE_BF6xx 1
#else
# define USE_BF6xx 0
#endif
	if (USE_BF6xx) {

		parent = debugfs_create_dir("Core Timer Register File", top);
		debugfs_create_x32("TCNTL", 0600, parent, (u32 *)0xFFF08600);
		debugfs_create_x32("TCOUNT", 0600, parent, (u32 *)0xFFF0860C);
		debugfs_create_x32("TPERIOD", 0600, parent, (u32 *)0xFFF08604);
		debugfs_create_x32("TSCALE", 0600, parent, (u32 *)0xFFF08608);

		parent = debugfs_create_dir("Data Cache Programmable Look-Aside Buffer Fault Address", top);
		debugfs_create_x32("DCPLB_FAULT_STATUS", 0600, parent, (u32 *)0xFFE00008);

		parent = debugfs_create_dir("EBIU", top);
		debugfs_create_x32("EBIU_AMBCTL0", 0600, parent, (u32 *)0xFFC00A04);
		debugfs_create_x32("EBIU_AMBCTL1", 0600, parent, (u32 *)0xFFC00A08);
		debugfs_create_x16("EBIU_AMGCTL", 0600, parent, (u16 *)0xFFC00A00);
		debugfs_create_x16("EBIU_SDBCTL", 0600, parent, (u16 *)0xFFC00A14);
		debugfs_create_x32("EBIU_SDGCTL", 0600, parent, (u32 *)0xFFC00A10);
		debugfs_create_x16("EBIU_SDRRC", 0600, parent, (u16 *)0xFFC00A18);
		debugfs_create_x16("EBIU_SDSTAT", 0600, parent, (u16 *)0xFFC00A1C);

		parent = debugfs_create_dir("Event Vectors", top);
		debugfs_create_x32("EVT0", 0600, parent, (u32 *)0xFFF08100);
		debugfs_create_x32("EVT10", 0600, parent, (u32 *)0xFFF08128);
		debugfs_create_x32("EVT11", 0600, parent, (u32 *)0xFFF0812C);
		debugfs_create_x32("EVT12", 0600, parent, (u32 *)0xFFF08130);
		debugfs_create_x32("EVT13", 0600, parent, (u32 *)0xFFF08134);
		debugfs_create_x32("EVT14", 0600, parent, (u32 *)0xFFF08138);
		debugfs_create_x32("EVT15", 0600, parent, (u32 *)0xFFF0813C);
		debugfs_create_x32("EVT1", 0600, parent, (u32 *)0xFFF08104);
		debugfs_create_x32("EVT2", 0600, parent, (u32 *)0xFFF08108);
		debugfs_create_x32("EVT3", 0600, parent, (u32 *)0xFFF0810C);
		debugfs_create_x32("EVT4", 0600, parent, (u32 *)0xFFF08110);
		debugfs_create_x32("EVT5", 0600, parent, (u32 *)0xFFF08114);
		debugfs_create_x32("EVT6", 0600, parent, (u32 *)0xFFF08118);
		debugfs_create_x32("EVT7", 0600, parent, (u32 *)0xFFF0811C);
		debugfs_create_x32("EVT8", 0600, parent, (u32 *)0xFFF08120);
		debugfs_create_x32("EVT9", 0600, parent, (u32 *)0xFFF08124);
		debugfs_create_x32("IVT", 0600, parent, (u32 *)0xFFF08100);
		debugfs_create_x32("IVbase", 0600, parent, (u32 *)0xFFF08100);

		parent = debugfs_create_dir("Extended Registers", top);
		debugfs_create_x32("DCPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0000C);
		debugfs_create_x32("DCPLB_STATUS", 0600, parent, (u32 *)0xFFE00008);
		debugfs_create_x32("DSPID", 0600, parent, (u32 *)0xFFE05000);
		debugfs_create_x32("EVT_OVERRIDE", 0600, parent, (u32 *)0xFFF08140);
		debugfs_create_x16("FIO_BOTH", 0600, parent, (u16 *)0xFFC0073C);
		debugfs_create_x16("FIO_DIR", 0600, parent, (u16 *)0xFFC00730);
		debugfs_create_x16("FIO_EDGE", 0600, parent, (u16 *)0xFFC00738);
		debugfs_create_x16("FIO_FLAG_C", 0600, parent, (u16 *)0xFFC00704);
		debugfs_create_x16("FIO_FLAG_D", 0600, parent, (u16 *)0xFFC00700);
		debugfs_create_x16("FIO_FLAG_S", 0600, parent, (u16 *)0xFFC00708);
		debugfs_create_x16("FIO_FLAG_T", 0600, parent, (u16 *)0xFFC0070C);
		debugfs_create_x16("FIO_INEN", 0600, parent, (u16 *)0xFFC00740);
		debugfs_create_x16("FIO_MASKA_C", 0600, parent, (u16 *)0xFFC00714);
		debugfs_create_x16("FIO_MASKA_D", 0600, parent, (u16 *)0xFFC00710);
		debugfs_create_x16("FIO_MASKA_S", 0600, parent, (u16 *)0xFFC00718);
		debugfs_create_x16("FIO_MASKA_T", 0600, parent, (u16 *)0xFFC0071C);
		debugfs_create_x16("FIO_MASKB_C", 0600, parent, (u16 *)0xFFC00724);
		debugfs_create_x16("FIO_MASKB_D", 0600, parent, (u16 *)0xFFC00720);
		debugfs_create_x16("FIO_MASKB_S", 0600, parent, (u16 *)0xFFC00728);
		debugfs_create_x16("FIO_MASKB_T", 0600, parent, (u16 *)0xFFC0072C);
		debugfs_create_x32("FIO_POLAR", 0600, parent, (u32 *)0xFFC00734);
		debugfs_create_x32("ICPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0100C);
		debugfs_create_x32("ICPLB_STATUS", 0600, parent, (u32 *)0xFFE01008);

		parent = debugfs_create_dir("Interrupt Controller", top);
		debugfs_create_x32("ILAT", 0600, parent, (u32 *)0xFFF08200);
		debugfs_create_x32("IMASK", 0600, parent, (u32 *)0xFFF08204);
		debugfs_create_x32("IPEND", 0600, parent, (u32 *)0xFFF08208);

		parent = debugfs_create_dir("L1 Code Memory Registers", top);
		debugfs_create_x32("ICPLB_ADDR0", 0600, parent, (u32 *)0xFFE01100);
		debugfs_create_x32("ICPLB_ADDR10", 0600, parent, (u32 *)0xFFE01128);
		debugfs_create_x32("ICPLB_ADDR11", 0600, parent, (u32 *)0xFFE0112C);
		debugfs_create_x32("ICPLB_ADDR12", 0600, parent, (u32 *)0xFFE01130);
		debugfs_create_x32("ICPLB_ADDR13", 0600, parent, (u32 *)0xFFE01134);
		debugfs_create_x32("ICPLB_ADDR14", 0600, parent, (u32 *)0xFFE01138);
		debugfs_create_x32("ICPLB_ADDR15", 0600, parent, (u32 *)0xFFE0113C);
		debugfs_create_x32("ICPLB_ADDR1", 0600, parent, (u32 *)0xFFE01104);
		debugfs_create_x32("ICPLB_ADDR2", 0600, parent, (u32 *)0xFFE01108);
		debugfs_create_x32("ICPLB_ADDR3", 0600, parent, (u32 *)0xFFE0110C);
		debugfs_create_x32("ICPLB_ADDR4", 0600, parent, (u32 *)0xFFE01110);
		debugfs_create_x32("ICPLB_ADDR5", 0600, parent, (u32 *)0xFFE01114);
		debugfs_create_x32("ICPLB_ADDR6", 0600, parent, (u32 *)0xFFE01118);
		debugfs_create_x32("ICPLB_ADDR7", 0600, parent, (u32 *)0xFFE0111C);
		debugfs_create_x32("ICPLB_ADDR8", 0600, parent, (u32 *)0xFFE01120);
		debugfs_create_x32("ICPLB_ADDR9", 0600, parent, (u32 *)0xFFE01124);
		debugfs_create_x32("ICPLB_DATA0", 0600, parent, (u32 *)0xFFE01200);
		debugfs_create_x32("ICPLB_DATA10", 0600, parent, (u32 *)0xFFE01228);
		debugfs_create_x32("ICPLB_DATA11", 0600, parent, (u32 *)0xFFE0122C);
		debugfs_create_x32("ICPLB_DATA12", 0600, parent, (u32 *)0xFFE01230);
		debugfs_create_x32("ICPLB_DATA13", 0600, parent, (u32 *)0xFFE01234);
		debugfs_create_x32("ICPLB_DATA14", 0600, parent, (u32 *)0xFFE01238);
		debugfs_create_x32("ICPLB_DATA15", 0600, parent, (u32 *)0xFFE0123C);
		debugfs_create_x32("ICPLB_DATA1", 0600, parent, (u32 *)0xFFE01204);
		debugfs_create_x32("ICPLB_DATA2", 0600, parent, (u32 *)0xFFE01208);
		debugfs_create_x32("ICPLB_DATA3", 0600, parent, (u32 *)0xFFE0120C);
		debugfs_create_x32("ICPLB_DATA4", 0600, parent, (u32 *)0xFFE01210);
		debugfs_create_x32("ICPLB_DATA5", 0600, parent, (u32 *)0xFFE01214);
		debugfs_create_x32("ICPLB_DATA6", 0600, parent, (u32 *)0xFFE01218);
		debugfs_create_x32("ICPLB_DATA7", 0600, parent, (u32 *)0xFFE0121C);
		debugfs_create_x32("ICPLB_DATA8", 0600, parent, (u32 *)0xFFE01220);
		debugfs_create_x32("ICPLB_DATA9", 0600, parent, (u32 *)0xFFE01224);
		debugfs_create_x32("ICPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0100C);
		debugfs_create_x32("ICPLB_FAULT_STATUS", 0600, parent, (u32 *)0xFFE01008);
		debugfs_create_x32("IMEM_CONTROL", 0600, parent, (u32 *)0xFFE01004);
		debugfs_create_x32("ITEST_COMMAND", 0600, parent, (u32 *)0xFFE01300);
		debugfs_create_x32("ITEST_DATA0", 0600, parent, (u32 *)0xFFE01400);
		debugfs_create_x32("ITEST_DATA1", 0600, parent, (u32 *)0xFFE01404);
		debugfs_create_x32("ITEST_DBGCTL", 0600, parent, (u32 *)0xFFE01C04);

		parent = debugfs_create_dir("L1 Data Memory Registers", top);
		debugfs_create_x32("DCPLB_ADDR0", 0600, parent, (u32 *)0xFFE00100);
		debugfs_create_x32("DCPLB_ADDR10", 0600, parent, (u32 *)0xFFE00128);
		debugfs_create_x32("DCPLB_ADDR11", 0600, parent, (u32 *)0xFFE0012C);
		debugfs_create_x32("DCPLB_ADDR12", 0600, parent, (u32 *)0xFFE00130);
		debugfs_create_x32("DCPLB_ADDR13", 0600, parent, (u32 *)0xFFE00134);
		debugfs_create_x32("DCPLB_ADDR14", 0600, parent, (u32 *)0xFFE00138);
		debugfs_create_x32("DCPLB_ADDR15", 0600, parent, (u32 *)0xFFE0013C);
		debugfs_create_x32("DCPLB_ADDR1", 0600, parent, (u32 *)0xFFE00104);
		debugfs_create_x32("DCPLB_ADDR2", 0600, parent, (u32 *)0xFFE00108);
		debugfs_create_x32("DCPLB_ADDR3", 0600, parent, (u32 *)0xFFE0010C);
		debugfs_create_x32("DCPLB_ADDR4", 0600, parent, (u32 *)0xFFE00110);
		debugfs_create_x32("DCPLB_ADDR5", 0600, parent, (u32 *)0xFFE00114);
		debugfs_create_x32("DCPLB_ADDR6", 0600, parent, (u32 *)0xFFE00118);
		debugfs_create_x32("DCPLB_ADDR7", 0600, parent, (u32 *)0xFFE0011C);
		debugfs_create_x32("DCPLB_ADDR8", 0600, parent, (u32 *)0xFFE00120);
		debugfs_create_x32("DCPLB_ADDR9", 0600, parent, (u32 *)0xFFE00124);
		debugfs_create_x32("DCPLB_DATA0", 0600, parent, (u32 *)0xFFE00200);
		debugfs_create_x32("DCPLB_DATA10", 0600, parent, (u32 *)0xFFE00228);
		debugfs_create_x32("DCPLB_DATA11", 0600, parent, (u32 *)0xFFE0022C);
		debugfs_create_x32("DCPLB_DATA12", 0600, parent, (u32 *)0xFFE00230);
		debugfs_create_x32("DCPLB_DATA13", 0600, parent, (u32 *)0xFFE00234);
		debugfs_create_x32("DCPLB_DATA14", 0600, parent, (u32 *)0xFFE00238);
		debugfs_create_x32("DCPLB_DATA15", 0600, parent, (u32 *)0xFFE0023C);
		debugfs_create_x32("DCPLB_DATA1", 0600, parent, (u32 *)0xFFE00204);
		debugfs_create_x32("DCPLB_DATA2", 0600, parent, (u32 *)0xFFE00208);
		debugfs_create_x32("DCPLB_DATA3", 0600, parent, (u32 *)0xFFE0020C);
		debugfs_create_x32("DCPLB_DATA4", 0600, parent, (u32 *)0xFFE00210);
		debugfs_create_x32("DCPLB_DATA5", 0600, parent, (u32 *)0xFFE00214);
		debugfs_create_x32("DCPLB_DATA6", 0600, parent, (u32 *)0xFFE00218);
		debugfs_create_x32("DCPLB_DATA7", 0600, parent, (u32 *)0xFFE0021C);
		debugfs_create_x32("DCPLB_DATA8", 0600, parent, (u32 *)0xFFE00220);
		debugfs_create_x32("DCPLB_DATA9", 0600, parent, (u32 *)0xFFE00224);
		debugfs_create_x32("DCPLB_FAULT_ADDR", 0600, parent, (u32 *)0xFFE0000C);
		debugfs_create_x32("DMEM_CONTROL", 0600, parent, (u32 *)0xFFE00004);
		debugfs_create_x32("DTEST_COMMAND", 0600, parent, (u32 *)0xFFE00300);
		debugfs_create_x32("DTEST_DATA0", 0600, parent, (u32 *)0xFFE00400);
		debugfs_create_x32("DTEST_DATA1", 0600, parent, (u32 *)0xFFE00404);
		debugfs_create_x32("SRAM_BASE_ADDR", 0600, parent, (u32 *)0xFFE00000);

		parent = debugfs_create_dir("MEMDMA0 Destination Registers", top);
		debugfs_create_x32("MDMAFLX0_CURXCOUNT_D", 0600, parent, (u32 *)0xFFC00E30);
		debugfs_create_x32("MDMAFLX0_CURYCOUNT_D", 0600, parent, (u32 *)0xFFC00E38);
		debugfs_create_x32("MDMAFLX0_DMACNFG_D", 0600, parent, (u32 *)0xFFC00E08);
		debugfs_create_x32("MDMAFLX0_IRQSTAT_D", 0600, parent, (u32 *)0xFFC00E28);
		debugfs_create_x32("MDMAFLX0_XCOUNT_D", 0600, parent, (u32 *)0xFFC00E10);
		debugfs_create_x32("MDMAFLX0_XMODIFY_D", 0600, parent, (u32 *)0xFFC00E14);
		debugfs_create_x32("MDMAFLX0_YCOUNT_D", 0600, parent, (u32 *)0xFFC00E18);
		debugfs_create_x32("MDMAFLX0_YMODIFY_D", 0600, parent, (u32 *)0xFFC00E1C);
		debugfs_create_x32("MDMA_D0_CONFIG", 0600, parent, (u32 *)0xFFC00E08);
		debugfs_create_x32("MDMA_D0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E24);
		debugfs_create_x32("MDMA_D0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E20);
		debugfs_create_x32("MDMA_D0_CURR_X_COUNT", 0600, parent, (u32 *)0xFFC00E30);
		debugfs_create_x32("MDMA_D0_CURR_Y_COUNT", 0600, parent, (u32 *)0xFFC00E38);
		debugfs_create_x32("MDMA_D0_IRQ_STATUS", 0600, parent, (u32 *)0xFFC00E28);
		debugfs_create_x32("MDMA_D0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E00);
		debugfs_create_x32("MDMA_D0_PERIPHERAL_MAP", 0600, parent, (u32 *)0xFFC00E2C);
		debugfs_create_x32("MDMA_D0_START_ADDR", 0600, parent, (u32 *)0xFFC00E04);
		debugfs_create_x32("MDMA_D0_X_COUNT", 0600, parent, (u32 *)0xFFC00E10);
		debugfs_create_x32("MDMA_D0_X_MODIFY", 0600, parent, (u32 *)0xFFC00E14);
		debugfs_create_x32("MDMA_D0_Y_COUNT", 0600, parent, (u32 *)0xFFC00E18);
		debugfs_create_x32("MDMA_D0_Y_MODIFY", 0600, parent, (u32 *)0xFFC00E1C);

		parent = debugfs_create_dir("MEMDMA0 Source Registers", top);
		debugfs_create_x32("MDMAFLX0_CURXCOUNT_S", 0600, parent, (u32 *)0xFFC00E70);
		debugfs_create_x32("MDMAFLX0_CURYCOUNT_S", 0600, parent, (u32 *)0xFFC00E78);
		debugfs_create_x32("MDMAFLX0_DMACNFG_S", 0600, parent, (u32 *)0xFFC00E48);
		debugfs_create_x32("MDMAFLX0_IRQSTAT_S", 0600, parent, (u32 *)0xFFC00E68);
		debugfs_create_x32("MDMAFLX0_XCOUNT_S", 0600, parent, (u32 *)0xFFC00E50);
		debugfs_create_x32("MDMAFLX0_XMODIFY_S", 0600, parent, (u32 *)0xFFC00E54);
		debugfs_create_x32("MDMAFLX0_YCOUNT_S", 0600, parent, (u32 *)0xFFC00E58);
		debugfs_create_x32("MDMAFLX0_YMODIFY_S", 0600, parent, (u32 *)0xFFC00E5C);
		debugfs_create_x32("MDMA_S0_CONFIG", 0600, parent, (u32 *)0xFFC00E48);
		debugfs_create_x32("MDMA_S0_CURR_ADDR", 0600, parent, (u32 *)0xFFC00E64);
		debugfs_create_x32("MDMA_S0_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00E60);
		debugfs_create_x32("MDMA_S0_CURR_X_COUNT", 0600, parent, (u32 *)0xFFC00E70);
		debugfs_create_x32("MDMA_S0_CURR_Y_COUNT", 0600, parent, (u32 *)0xFFC00E78);
		debugfs_create_x32("MDMA_S0_IRQ_STATUS", 0600, parent, (u32 *)0xFFC00E68);
		debugfs_create_x32("MDMA_S0_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E40);
		debugfs_create_x32("MDMA_S0_PERIPHERAL_MAP", 0600, parent, (u32 *)0xFFC00E6C);
		debugfs_create_x32("MDMA_S0_START_ADDR", 0600, parent, (u32 *)0xFFC00E44);
		debugfs_create_x32("MDMA_S0_X_COUNT", 0600, parent, (u32 *)0xFFC00E50);
		debugfs_create_x32("MDMA_S0_X_MODIFY", 0600, parent, (u32 *)0xFFC00E54);
		debugfs_create_x32("MDMA_S0_Y_COUNT", 0600, parent, (u32 *)0xFFC00E58);
		debugfs_create_x32("MDMA_S0_Y_MODIFY", 0600, parent, (u32 *)0xFFC00E5C);

		parent = debugfs_create_dir("MEMDMA1 Destination Registers", top);
		debugfs_create_x32("MDMAFLX1_CURXCOUNT_D", 0600, parent, (u32 *)0xFFC00EB0);
		debugfs_create_x32("MDMAFLX1_CURYCOUNT_D", 0600, parent, (u32 *)0xFFC00EB8);
		debugfs_create_x32("MDMAFLX1_DMACNFG_D", 0600, parent, (u32 *)0xFFC00E88);
		debugfs_create_x32("MDMAFLX1_IRQSTAT_D", 0600, parent, (u32 *)0xFFC00EA8);
		debugfs_create_x32("MDMAFLX1_XCOUNT_D", 0600, parent, (u32 *)0xFFC00E90);
		debugfs_create_x32("MDMAFLX1_XMODIFY_D", 0600, parent, (u32 *)0xFFC00E94);
		debugfs_create_x32("MDMAFLX1_YCOUNT_D", 0600, parent, (u32 *)0xFFC00E98);
		debugfs_create_x32("MDMAFLX1_YMODIFY_D", 0600, parent, (u32 *)0xFFC00E9C);
		debugfs_create_x32("MDMA_D1_CONFIG", 0600, parent, (u32 *)0xFFC00E88);
		debugfs_create_x32("MDMA_D1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EA4);
		debugfs_create_x32("MDMA_D1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EA0);
		debugfs_create_x32("MDMA_D1_CURR_X_COUNT", 0600, parent, (u32 *)0xFFC00EB0);
		debugfs_create_x32("MDMA_D1_CURR_Y_COUNT", 0600, parent, (u32 *)0xFFC00EB8);
		debugfs_create_x32("MDMA_D1_IRQ_STATUS", 0600, parent, (u32 *)0xFFC00EA8);
		debugfs_create_x32("MDMA_D1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00E80);
		debugfs_create_x32("MDMA_D1_START_ADDR", 0600, parent, (u32 *)0xFFC00E84);
		debugfs_create_x32("MDMA_D1_X_COUNT", 0600, parent, (u32 *)0xFFC00E90);
		debugfs_create_x32("MDMA_D1_X_MODIFY", 0600, parent, (u32 *)0xFFC00E94);
		debugfs_create_x32("MDMA_D1_Y_COUNT", 0600, parent, (u32 *)0xFFC00E98);
		debugfs_create_x32("MDMA_D1_Y_MODIFY", 0600, parent, (u32 *)0xFFC00E9C);

		parent = debugfs_create_dir("MEMDMA1 Source Registers", top);
		debugfs_create_x32("MDMAFLX1_CURXCOUNT_S", 0600, parent, (u32 *)0xFFC00EF0);
		debugfs_create_x32("MDMAFLX1_CURYCOUNT_S", 0600, parent, (u32 *)0xFFC00EF8);
		debugfs_create_x32("MDMAFLX1_DMACNFG_S", 0600, parent, (u32 *)0xFFC00EC8);
		debugfs_create_x32("MDMAFLX1_IRQSTAT_S", 0600, parent, (u32 *)0xFFC00EE8);
		debugfs_create_x32("MDMAFLX1_XCOUNT_S", 0600, parent, (u32 *)0xFFC00ED0);
		debugfs_create_x32("MDMAFLX1_XMODIFY_S", 0600, parent, (u32 *)0xFFC00ED4);
		debugfs_create_x32("MDMAFLX1_YCOUNT_S", 0600, parent, (u32 *)0xFFC00ED8);
		debugfs_create_x32("MDMAFLX1_YMODIFY_S", 0600, parent, (u32 *)0xFFC00EDC);
		debugfs_create_x32("MDMA_S1_CONFIG", 0600, parent, (u32 *)0xFFC00EC8);
		debugfs_create_x32("MDMA_S1_CURR_ADDR", 0600, parent, (u32 *)0xFFC00EE4);
		debugfs_create_x32("MDMA_S1_CURR_DESC_PTR", 0600, parent, (u32 *)0xFFC00EE0);
		debugfs_create_x32("MDMA_S1_CURR_X_COUNT", 0600, parent, (u32 *)0xFFC00EF0);
		debugfs_create_x32("MDMA_S1_CURR_Y_COUNT", 0600, parent, (u32 *)0xFFC00EF8);
		debugfs_create_x32("MDMA_S1_IRQ_STATUS", 0600, parent, (u32 *)0xFFC00EE8);
		debugfs_create_x32("MDMA_S1_NEXT_DESC_PTR", 0600, parent, (u32 *)0xFFC00EC0);
		debugfs_create_x32("MDMA_S1_START_ADDR", 0600, parent, (u32 *)0xFFC00EC4);
		debugfs_create_x32("MDMA_S1_X_COUNT", 0600, parent, (u32 *)0xFFC00ED0);
		debugfs_create_x32("MDMA_S1_X_MODIFY", 0600, parent, (u32 *)0xFFC00ED4);
		debugfs_create_x32("MDMA_S1_Y_COUNT", 0600, parent, (u32 *)0xFFC00ED8);
		debugfs_create_x32("MDMA_S1_Y_MODIFY", 0600, parent, (u32 *)0xFFC00EDC);

		parent = debugfs_create_dir("PLL", top);
		debugfs_create_x16("PLL_CTL", 0600, parent, (u16 *)0xFFC00000);
		debugfs_create_x16("PLL_DIV", 0600, parent, (u16 *)0xFFC00004);
		debugfs_create_x16("PLL_LOCKCNT", 0600, parent, (u16 *)0xFFC00010);
		debugfs_create_x16("PLL_STAT", 0600, parent, (u16 *)0xFFC0000C);
		debugfs_create_x32("SWRST", 0600, parent, (u32 *)0xFFC00100);
		debugfs_create_x32("SYSCR", 0600, parent, (u32 *)0xFFC00104);
		debugfs_create_x16("VR_CTL", 0600, parent, (u16 *)0xFFC00008);

		parent = debugfs_create_dir("PPI", top);
		debugfs_create_x16("PPI_CONTROL", 0600, parent, (u16 *)0xFFC01000);
		debugfs_create_x16("PPI_COUNT", 0600, parent, (u16 *)0xFFC01008);
		debugfs_create_x16("PPI_DELAY", 0600, parent, (u16 *)0xFFC0100C);
		debugfs_create_x16("PPI_FRAME", 0600, parent, (u16 *)0xFFC01010);
		debugfs_create_x16("PPI_STATUS", 0600, parent, (u16 *)0xFFC01004);

		parent = debugfs_create_dir("Performance Monitor", top);
		debugfs_create_x32("PFCNTR0", 0600, parent, (u32 *)0xFFF08500);
		debugfs_create_x32("PFCNTR1", 0600, parent, (u32 *)0xFFF08504);
		debugfs_create_x32("PFCTL", 0600, parent, (u32 *)0xFFF08508);

		parent = debugfs_create_dir("RTC", top);
		debugfs_create_x32("RTC_ALARM", 0600, parent, (u32 *)0xFFC00310);
		debugfs_create_x16("RTC_ICTL", 0600, parent, (u16 *)0xFFC00304);
		debugfs_create_x16("RTC_ISTAT", 0600, parent, (u16 *)0xFFC00308);
		debugfs_create_x16("RTC_PREN", 0600, parent, (u16 *)0xFFC00314);
		debugfs_create_x32("RTC_STAT", 0600, parent, (u32 *)0xFFC00300);
		debugfs_create_x16("RTC_SWCNT", 0600, parent, (u16 *)0xFFC0030C);

		parent = debugfs_create_dir("SPI", top);
		debugfs_create_x16("SPI_BAUD", 0600, parent, (u16 *)0xFFC00514);
		debugfs_create_x16("SPI_CTL", 0600, parent, (u16 *)0xFFC00500);
		debugfs_create_x16("SPI_FLG", 0600, parent, (u16 *)0xFFC00504);
		debugfs_create_x16("SPI_RDBR", 0600, parent, (u16 *)0xFFC00510);
		debugfs_create_x16("SPI_SHADOW", 0600, parent, (u16 *)0xFFC00518);
		debugfs_create_x16("SPI_STAT", 0600, parent, (u16 *)0xFFC00508);
		debugfs_create_x16("SPI_TDBR", 0600, parent, (u16 *)0xFFC0050C);

		parent = debugfs_create_dir("SPORT", top);
		debugfs_create_x16("SPORT0_CHNL", 0600, parent, (u16 *)0xFFC00834);
		debugfs_create_x16("SPORT0_MCMC1", 0600, parent, (u16 *)0xFFC00838);
		debugfs_create_x16("SPORT0_MCMC2", 0600, parent, (u16 *)0xFFC0083C);
		debugfs_create_x32("SPORT0_MRCS0", 0600, parent, (u32 *)0xFFC00850);
		debugfs_create_x32("SPORT0_MRCS1", 0600, parent, (u32 *)0xFFC00854);
		debugfs_create_x32("SPORT0_MRCS2", 0600, parent, (u32 *)0xFFC00858);
		debugfs_create_x32("SPORT0_MRCS3", 0600, parent, (u32 *)0xFFC0085C);
		debugfs_create_x32("SPORT0_MTCS0", 0600, parent, (u32 *)0xFFC00840);
		debugfs_create_x32("SPORT0_MTCS1", 0600, parent, (u32 *)0xFFC00844);
		debugfs_create_x32("SPORT0_MTCS2", 0600, parent, (u32 *)0xFFC00848);
		debugfs_create_x32("SPORT0_MTCS3", 0600, parent, (u32 *)0xFFC0084C);
		debugfs_create_x16("SPORT0_RCLKDIV", 0600, parent, (u16 *)0xFFC00828);
		debugfs_create_x16("SPORT0_RCR1", 0600, parent, (u16 *)0xFFC00820);
		debugfs_create_x16("SPORT0_RCR2", 0600, parent, (u16 *)0xFFC00824);
		debugfs_create_x16("SPORT0_RFSDIV", 0600, parent, (u16 *)0xFFC0082C);
		debugfs_create_x32("SPORT0_RX", 0600, parent, (u32 *)0xFFC00818);
		debugfs_create_x16("SPORT0_STAT", 0600, parent, (u16 *)0xFFC00830);
		debugfs_create_x16("SPORT0_TCLKDIV", 0600, parent, (u16 *)0xFFC00808);
		debugfs_create_x16("SPORT0_TCR1", 0600, parent, (u16 *)0xFFC00800);
		debugfs_create_x16("SPORT0_TCR2", 0600, parent, (u16 *)0xFFC00804);
		debugfs_create_x16("SPORT0_TFSDIV", 0600, parent, (u16 *)0xFFC0080C);
		debugfs_create_x32("SPORT0_TX", 0600, parent, (u32 *)0xFFC00810);
		debugfs_create_x16("SPORT1_CHNL", 0600, parent, (u16 *)0xFFC00934);
		debugfs_create_x16("SPORT1_MCMC1", 0600, parent, (u16 *)0xFFC00938);
		debugfs_create_x16("SPORT1_MCMC2", 0600, parent, (u16 *)0xFFC0093C);
		debugfs_create_x32("SPORT1_MRCS0", 0600, parent, (u32 *)0xFFC00950);
		debugfs_create_x32("SPORT1_MRCS1", 0600, parent, (u32 *)0xFFC00954);
		debugfs_create_x32("SPORT1_MRCS2", 0600, parent, (u32 *)0xFFC00958);
		debugfs_create_x32("SPORT1_MRCS3", 0600, parent, (u32 *)0xFFC0095C);
		debugfs_create_x32("SPORT1_MTCS0", 0600, parent, (u32 *)0xFFC00940);
		debugfs_create_x32("SPORT1_MTCS1", 0600, parent, (u32 *)0xFFC00944);
		debugfs_create_x32("SPORT1_MTCS2", 0600, parent, (u32 *)0xFFC00948);
		debugfs_create_x32("SPORT1_MTCS3", 0600, parent, (u32 *)0xFFC0094C);
		debugfs_create_x16("SPORT1_RCLKDIV", 0600, parent, (u16 *)0xFFC00928);
		debugfs_create_x16("SPORT1_RCR1", 0600, parent, (u16 *)0xFFC00920);
		debugfs_create_x16("SPORT1_RCR2", 0600, parent, (u16 *)0xFFC00924);
		debugfs_create_x16("SPORT1_RFSDIV", 0600, parent, (u16 *)0xFFC0092C);
		debugfs_create_x32("SPORT1_RX", 0600, parent, (u32 *)0xFFC00918);
		debugfs_create_x16("SPORT1_STAT", 0600, parent, (u16 *)0xFFC00930);
		debugfs_create_x16("SPORT1_TCLKDIV", 0600, parent, (u16 *)0xFFC00908);
		debugfs_create_x16("SPORT1_TCR1", 0600, parent, (u16 *)0xFFC00900);
		debugfs_create_x16("SPORT1_TCR2", 0600, parent, (u16 *)0xFFC00904);
		debugfs_create_x16("SPORT1_TFSDIV", 0600, parent, (u16 *)0xFFC0090C);
		debugfs_create_x32("SPORT1_TX", 0600, parent, (u32 *)0xFFC00910);

		parent = debugfs_create_dir("SPT0", top);
		debugfs_create_x16("SPT0_CHNL", 0600, parent, (u16 *)0xFFC00834);
		debugfs_create_x16("SPT0_MCMC1", 0600, parent, (u16 *)0xFFC00838);
		debugfs_create_x16("SPT0_MCMC2", 0600, parent, (u16 *)0xFFC0083C);
		debugfs_create_x32("SPT0_MRCS0", 0600, parent, (u32 *)0xFFC00850);
		debugfs_create_x32("SPT0_MRCS1", 0600, parent, (u32 *)0xFFC00854);
		debugfs_create_x32("SPT0_MRCS2", 0600, parent, (u32 *)0xFFC00858);
		debugfs_create_x32("SPT0_MRCS3", 0600, parent, (u32 *)0xFFC0085C);
		debugfs_create_x32("SPT0_MTCS0", 0600, parent, (u32 *)0xFFC00840);
		debugfs_create_x32("SPT0_MTCS1", 0600, parent, (u32 *)0xFFC00844);
		debugfs_create_x32("SPT0_MTCS2", 0600, parent, (u32 *)0xFFC00848);
		debugfs_create_x32("SPT0_MTCS3", 0600, parent, (u32 *)0xFFC0084C);
		debugfs_create_x16("SPT0_RFSDIV", 0600, parent, (u16 *)0xFFC0082C);
		debugfs_create_x16("SPT0_RSCLKDIV", 0600, parent, (u16 *)0xFFC00828);
		debugfs_create_x32("SPT0_RX", 0600, parent, (u32 *)0xFFC00818);
		debugfs_create_x16("SPT0_RX_CONFIG0", 0600, parent, (u16 *)0xFFC00820);
		debugfs_create_x16("SPT0_RX_CONFIG1", 0600, parent, (u16 *)0xFFC00824);
		debugfs_create_x16("SPT0_STAT", 0600, parent, (u16 *)0xFFC00830);
		debugfs_create_x16("SPT0_TFSDIV", 0600, parent, (u16 *)0xFFC0080C);
		debugfs_create_x16("SPT0_TSCLKDIV", 0600, parent, (u16 *)0xFFC00808);
		debugfs_create_x32("SPT0_TX", 0600, parent, (u32 *)0xFFC00810);
		debugfs_create_x16("SPT0_TX_CONFIG0", 0600, parent, (u16 *)0xFFC00800);
		debugfs_create_x16("SPT0_TX_CONFIG1", 0600, parent, (u16 *)0xFFC00804);
		debugfs_create_x16("SPT1_CHNL", 0600, parent, (u16 *)0xFFC00934);

		parent = debugfs_create_dir("SPT1", top);
		debugfs_create_x16("SPT1_MCMC1", 0600, parent, (u16 *)0xFFC00938);
		debugfs_create_x16("SPT1_MCMC2", 0600, parent, (u16 *)0xFFC0093C);
		debugfs_create_x16("SPT1_MRCS0", 0600, parent, (u16 *)0xFFC00950);
		debugfs_create_x16("SPT1_MRCS1", 0600, parent, (u16 *)0xFFC00954);
		debugfs_create_x16("SPT1_MRCS2", 0600, parent, (u16 *)0xFFC00958);
		debugfs_create_x16("SPT1_MRCS3", 0600, parent, (u16 *)0xFFC0095C);
		debugfs_create_x16("SPT1_MTCS0", 0600, parent, (u16 *)0xFFC00940);
		debugfs_create_x16("SPT1_MTCS1", 0600, parent, (u16 *)0xFFC00944);
		debugfs_create_x16("SPT1_MTCS2", 0600, parent, (u16 *)0xFFC00948);
		debugfs_create_x16("SPT1_MTCS3", 0600, parent, (u16 *)0xFFC0094C);
		debugfs_create_x16("SPT1_RFSDIV", 0600, parent, (u16 *)0xFFC0092C);
		debugfs_create_x16("SPT1_RSCLKDIV", 0600, parent, (u16 *)0xFFC00928);
		debugfs_create_x16("SPT1_RX", 0600, parent, (u16 *)0xFFC00918);
		debugfs_create_x16("SPT1_RX_CONFIG0", 0600, parent, (u16 *)0xFFC00920);
		debugfs_create_x16("SPT1_RX_CONFIG1", 0600, parent, (u16 *)0xFFC00924);
		debugfs_create_x16("SPT1_STAT", 0600, parent, (u16 *)0xFFC00930);
		debugfs_create_x16("SPT1_TFSDIV", 0600, parent, (u16 *)0xFFC0090C);
		debugfs_create_x16("SPT1_TSCLKDIV", 0600, parent, (u16 *)0xFFC00908);
		debugfs_create_x16("SPT1_TX", 0600, parent, (u16 *)0xFFC00910);
		debugfs_create_x16("SPT1_TX_CONFIG0", 0600, parent, (u16 *)0xFFC00900);
		debugfs_create_x16("SPT1_TX_CONFIG1", 0600, parent, (u16 *)0xFFC00904);

		parent = debugfs_create_dir("System Interrupt Controller Register File", top);
		debugfs_create_x32("SIC_IAR0", 0600, parent, (u32 *)0xFFC00110);
		debugfs_create_x32("SIC_IAR1", 0600, parent, (u32 *)0xFFC00114);
		debugfs_create_x32("SIC_IAR2", 0600, parent, (u32 *)0xFFC00118);
		debugfs_create_x32("SIC_IAR3", 0600, parent, (u32 *)0xFFC0011C);
		debugfs_create_x32("SIC_IMASK", 0600, parent, (u32 *)0xFFC0010C);
		debugfs_create_x32("SIC_ISR", 0600, parent, (u32 *)0xFFC00120);
		debugfs_create_x32("SIC_IWR", 0600, parent, (u32 *)0xFFC00124);
		debugfs_create_x16("SIC_RVECT", 0600, parent, (u16 *)0xFFC00108);

		parent = debugfs_create_dir("Timer Registers", top);
		debugfs_create_x16("TIMER0_CONFIG", 0600, parent, (u16 *)0xFFC00600);
		debugfs_create_x32("TIMER0_COUNTER", 0600, parent, (u32 *)0xFFC00604);
		debugfs_create_x32("TIMER0_PERIOD", 0600, parent, (u32 *)0xFFC00608);
		debugfs_create_x32("TIMER0_WIDTH", 0600, parent, (u32 *)0xFFC0060C);
		debugfs_create_x16("TIMER1_CONFIG", 0600, parent, (u16 *)0xFFC00610);
		debugfs_create_x32("TIMER1_COUNTER", 0600, parent, (u32 *)0xFFC00614);
		debugfs_create_x32("TIMER1_PERIOD", 0600, parent, (u32 *)0xFFC00618);
		debugfs_create_x32("TIMER1_WIDTH", 0600, parent, (u32 *)0xFFC0061C);
		debugfs_create_x16("TIMER2_CONFIG", 0600, parent, (u16 *)0xFFC00620);
		debugfs_create_x32("TIMER2_COUNTER", 0600, parent, (u32 *)0xFFC00624);
		debugfs_create_x32("TIMER2_PERIOD", 0600, parent, (u32 *)0xFFC00628);
		debugfs_create_x32("TIMER2_WIDTH", 0600, parent, (u32 *)0xFFC0062C);
		debugfs_create_x16("TIMER_DISABLE", 0600, parent, (u16 *)0xFFC00644);
		debugfs_create_x16("TIMER_ENABLE", 0600, parent, (u16 *)0xFFC00640);
		debugfs_create_x16("TIMER_STATUS", 0600, parent, (u16 *)0xFFC00648);

		parent = debugfs_create_dir("Trace Unit", top);
		debugfs_create_x32("TBUF", 0600, parent, (u32 *)0xFFE06100);
		debugfs_create_x32("TBUFCTL", 0600, parent, (u32 *)0xFFF08400);
		debugfs_create_x32("TBUFSTAT", 0600, parent, (u32 *)0xFFE06004);

		parent = debugfs_create_dir("UART", top);
		debugfs_create_x16("UART_DLH", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART_DLL", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART_GCTL", 0600, parent, (u16 *)0xFFC00424);
		debugfs_create_x16("UART_IER", 0600, parent, (u16 *)0xFFC00404);
		debugfs_create_x16("UART_IIR", 0600, parent, (u16 *)0xFFC00408);
		debugfs_create_x16("UART_LCR", 0600, parent, (u16 *)0xFFC0040C);
		debugfs_create_x16("UART_LSR", 0600, parent, (u16 *)0xFFC00414);
		debugfs_create_x16("UART_MCR", 0600, parent, (u16 *)0xFFC00410);
		debugfs_create_x16("UART_RBR", 0600, parent, (u16 *)0xFFC00400);
		debugfs_create_x16("UART_SCR", 0600, parent, (u16 *)0xFFC0041C);
		debugfs_create_x16("UART_THR", 0600, parent, (u16 *)0xFFC00400);

		parent = debugfs_create_dir("Watchdog", top);
		debugfs_create_x32("WDOG_CNT", 0600, parent, (u32 *)0xFFC00204);
		debugfs_create_x16("WDOG_CTL", 0600, parent, (u16 *)0xFFC00200);
		debugfs_create_x32("WDOG_STAT", 0600, parent, (u32 *)0xFFC00208);

		parent = debugfs_create_dir("Watchpoint and Patch Unit", top);
		debugfs_create_x32("OSPID", 0600, parent, (u32 *)0xFFF08720);
		debugfs_create_x32("WPDA0", 0600, parent, (u32 *)0xFFF08758);
		debugfs_create_x32("WPDA1", 0600, parent, (u32 *)0xFFF0875C);
		debugfs_create_x32("WPDACNT0", 0600, parent, (u32 *)0xFFF08798);
		debugfs_create_x32("WPDACNT1", 0600, parent, (u32 *)0xFFF0879C);
		debugfs_create_x32("WPDACTL", 0600, parent, (u32 *)0xFFF0870C);
		debugfs_create_x32("WPIA0", 0600, parent, (u32 *)0xFFF08740);
		debugfs_create_x32("WPIA1", 0600, parent, (u32 *)0xFFF08744);
		debugfs_create_x32("WPIA2", 0600, parent, (u32 *)0xFFF08748);
		debugfs_create_x32("WPIA3", 0600, parent, (u32 *)0xFFF0874C);
		debugfs_create_x32("WPIA4", 0600, parent, (u32 *)0xFFF08750);
		debugfs_create_x32("WPIA5", 0600, parent, (u32 *)0xFFF08754);
		debugfs_create_x32("WPIACNT0", 0600, parent, (u32 *)0xFFF08780);
		debugfs_create_x32("WPIACNT1", 0600, parent, (u32 *)0xFFF08784);
		debugfs_create_x32("WPIACNT2", 0600, parent, (u32 *)0xFFF08788);
		debugfs_create_x32("WPIACNT3", 0600, parent, (u32 *)0xFFF0878C);
		debugfs_create_x32("WPIACNT4", 0600, parent, (u32 *)0xFFF08790);
		debugfs_create_x32("WPIACNT5", 0600, parent, (u32 *)0xFFF08794);
		debugfs_create_x32("WPIACTL01", 0600, parent, (u32 *)0xFFF08700);
		debugfs_create_x32("WPIACTL23", 0600, parent, (u32 *)0xFFF08704);
		debugfs_create_x32("WPIACTL45", 0600, parent, (u32 *)0xFFF08708);
		debugfs_create_x32("WPPID", 0600, parent, (u32 *)0xFFF087A0);
		debugfs_create_x32("WPSTAT", 0600, parent, (u32 *)0xFFF08760);

	}	/* BF6xx */

	return 0;
}

late_initcall(bfin_init_mmr_debugfs);
